#include "benchmarkTime.h"

/* Global Variables: */
#include "dhry.h"

extern Rec_Pointer     Ptr_Glob,
                Next_Ptr_Glob;
extern int             Int_Glob;
extern Boolean         Bool_Glob;
extern char            Ch_1_Glob,
                Ch_2_Glob;
extern int             Arr_1_Glob [50];
extern int             Arr_2_Glob [50] [50];

extern char Reg_Define[];

extern Enumeration     Func_1 ();
  /* 
  forward declaration necessary since Enumeration may not simply be int
  */

#ifndef ROPT
#define REG
        /* REG becomes defined as empty */
        /* i.e. no register variables   */
#else
#define REG register
#endif

/* Marked out by Edward 2005/5/19 */
#if 0
/* variables for time measurement: */

#define Too_Small_Time 2
                /* Measurements should last at least 2 seconds */

extern double          Begin_Time,
                End_Time,
                User_Time;

extern double          Microseconds,
                Dhrystones_Per_Second,
                Vax_Mips;
#endif
/* end of variables for time measurement */


void dhrystone21(int Number_Of_Runs)
/*****/

  /* main program, corresponds to procedures        */
  /* Main and Proc_0 in the Ada version             */
{
__DRAM static One_Fifty       Int_1_Loc;
__DRAM static   REG   One_Fifty       Int_2_Loc;
__DRAM static  One_Fifty       Int_3_Loc;
__DRAM static  REG   char            Ch_Index;
__DRAM static  Enumeration     Enum_Loc;
__DRAM static  Str_30          Str_1_Loc;
__DRAM static  Str_30          Str_2_Loc;
__DRAM static  REG   int             Run_Index;
	/* Added by Edward 2005/5/18 to calcuate time */
__DRAM static unsigned int jifPassed, testRound;
__DRAM static unsigned int cp3CtrlReg[4] = {0x1a121110, 0x1b131710, 0x19181710, 0x16151410};
__DRAM static uint64 cp3Cntr[16];
/* Using local veriable to replace malloc by Edward 2005/5/19 */
__DRAM static Rec_Type  Record1, Record2;  
  Next_Ptr_Glob = &Record1;  
  Ptr_Glob = &Record2;
  /* Marked out by Edward 2005/5/19 
  Next_Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));
  Ptr_Glob = (Rec_Pointer) malloc (sizeof (Rec_Type));
	*/
  Ptr_Glob->Ptr_Comp                    = Next_Ptr_Glob;
  Ptr_Glob->Discr                       = Ident_1;
  Ptr_Glob->variant.var_1.Enum_Comp     = Ident_3;
  Ptr_Glob->variant.var_1.Int_Comp      = 40;
  strcpy (Ptr_Glob->variant.var_1.Str_Comp, 
          "DHRYSTONE PROGRAM, SOME STRING");
  strcpy (Str_1_Loc, "DHRYSTONE PROGRAM, 1'ST STRING");

  Arr_2_Glob [8][7] = 10;
        /* Was missing in published program. Without this statement,    */
        /* Arr_2_Glob [8][7] would have an undefined value.             */
        /* Warning: With 16-Bit processors and Number_Of_Runs > 32000,  */
        /* overflow may occur for this array element.                   */

  printk("\n");
  printk("Dhrystone Benchmark, Version 2.1 (Language: C)\n");
  printk("\n");
  printk("Execution starts, %d runs through Dhrystone\n",Number_Of_Runs);

 for(testRound = 0; testRound < 4; testRound++) {
  /***************/
  /* Start timer */
  /***************/
 benchmarkTime_start(cp3CtrlReg[testRound]);
  
  for (Run_Index = 1; Run_Index <= Number_Of_Runs; ++Run_Index)
  {
    Proc_5();
    Proc_4();
      /* Ch_1_Glob == 'A', Ch_2_Glob == 'B', Bool_Glob == true */
    Int_1_Loc = 2;
    Int_2_Loc = 3;
    strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 2'ND STRING");
    Enum_Loc = Ident_2;
    Bool_Glob = ! Func_2 (Str_1_Loc, Str_2_Loc);
      /* Bool_Glob == 1 */
    while (Int_1_Loc < Int_2_Loc)  /* loop body executed once */
    {
      Int_3_Loc = 5 * Int_1_Loc - Int_2_Loc;
        /* Int_3_Loc == 7 */
      Proc_7 (Int_1_Loc, Int_2_Loc, &Int_3_Loc);
        /* Int_3_Loc == 7 */
      Int_1_Loc += 1;
    } /* while */
      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
    Proc_8 (Arr_1_Glob, Arr_2_Glob, Int_1_Loc, Int_3_Loc);
      /* Int_Glob == 5 */
    Proc_1 (Ptr_Glob);
    for (Ch_Index = 'A'; Ch_Index <= Ch_2_Glob; ++Ch_Index)
                             /* loop body executed twice */
    {
      if (Enum_Loc == Func_1 (Ch_Index, 'C'))
          /* then, not executed */
        {
        Proc_6 (Ident_1, &Enum_Loc);
        strcpy (Str_2_Loc, "DHRYSTONE PROGRAM, 3'RD STRING");
        Int_2_Loc = Run_Index;
        Int_Glob = Run_Index;
        }
    }
      /* Int_1_Loc == 3, Int_2_Loc == 3, Int_3_Loc == 7 */
    Int_2_Loc = Int_2_Loc * Int_1_Loc;
    Int_1_Loc = Int_2_Loc / Int_3_Loc;
    Int_2_Loc = 7 * (Int_2_Loc - Int_3_Loc) - Int_1_Loc;
      /* Int_1_Loc == 1, Int_2_Loc == 13, Int_3_Loc == 7 */
    Proc_2 (&Int_1_Loc);
      /* Int_1_Loc == 5 */
  } /* loop "for Run_Index" */

  /**************/
  /* Stop timer */
  /**************/

	jifPassed = benchmarkTime_end(&cp3Cntr[testRound<<2]);  
 }

for(testRound = 0; testRound<4; testRound++)
 benchmarkTime_display(cp3CtrlReg[testRound], &cp3Cntr[testRound<<2]);

	if(jifPassed == 0)
		printk("Please run more rounds to make jiffies become non-zero\n");
	else {
		  printk("Execution ends\n");
		  printk("\n");
		  printk("Final values of the variables used in the benchmark:\n");
		  printk("\n");
		  printk("Int_Glob:            %d\n", Int_Glob);
		  printk("        should be:   %d\n", 5);
		  printk("Bool_Glob:           %d\n", Bool_Glob);
		  printk("        should be:   %d\n", 1);
		  printk("Ch_1_Glob:           %c\n", Ch_1_Glob);
		  printk("        should be:   %c\n", 'A');
		  printk("Ch_2_Glob:           %c\n", Ch_2_Glob);
		  printk("        should be:   %c\n", 'B');
		  printk("Arr_1_Glob[8]:       %d\n", Arr_1_Glob[8]);
		  printk("        should be:   %d\n", 7);
		  printk("Arr_2_Glob[8][7]:    %d\n", Arr_2_Glob[8][7]);
		  printk("        should be:   Number_Of_Runs + 10\n");
		  printk("Ptr_Glob->\n");
		  printk("  Ptr_Comp:          %d\n", (int) Ptr_Glob->Ptr_Comp);
		  printk("        should be:   (implementation-dependent)\n");
		  printk("  Discr:             %d\n", Ptr_Glob->Discr);
		  printk("        should be:   %d\n", 0);
		  printk("  Enum_Comp:         %d\n", Ptr_Glob->variant.var_1.Enum_Comp);
		  printk("        should be:   %d\n", 2);
		  printk("  Int_Comp:          %d\n", Ptr_Glob->variant.var_1.Int_Comp);
		  printk("        should be:   %d\n", 17);
		  printk("  Str_Comp:          %s\n", Ptr_Glob->variant.var_1.Str_Comp);
		  printk("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
		  printk("Next_Ptr_Glob->\n");
		  printk("  Ptr_Comp:          %d\n", (int) Next_Ptr_Glob->Ptr_Comp);
		  printk("        should be:   (implementation-dependent), same as above\n");
		  printk("  Discr:             %d\n", Next_Ptr_Glob->Discr);
		  printk("        should be:   %d\n", 0);
		  printk("  Enum_Comp:         %d\n", Next_Ptr_Glob->variant.var_1.Enum_Comp);
		  printk("        should be:   %d\n", 1);
		  printk("  Int_Comp:          %d\n", Next_Ptr_Glob->variant.var_1.Int_Comp);
		  printk("        should be:   %d\n", 18);
		  printk("  Str_Comp:          %s\n", Next_Ptr_Glob->variant.var_1.Str_Comp);
		  printk("        should be:   DHRYSTONE PROGRAM, SOME STRING\n");
		  printk("Int_1_Loc:           %d\n", Int_1_Loc);
		  printk("        should be:   %d\n", 5);
		  printk("Int_2_Loc:           %d\n", Int_2_Loc);
		  printk("        should be:   %d\n", 13);
		  printk("Int_3_Loc:           %d\n", Int_3_Loc);
		  printk("        should be:   %d\n", 7);
		  printk("Enum_Loc:            %d\n", Enum_Loc);
		  printk("        should be:   %d\n", 1);
		  printk("Str_1_Loc:           %s\n", Str_1_Loc);
		  printk("        should be:   DHRYSTONE PROGRAM, 1'ST STRING\n");
		  printk("Str_2_Loc:           %s\n", Str_2_Loc);
		  printk("        should be:   DHRYSTONE PROGRAM, 2'ND STRING\n");
		  printk("\n");

		printk("Run %d dhrystone2.1/sec (Jiffies %u) %d DMIPS\n", Number_Of_Runs/jifPassed*100, jifPassed, Number_Of_Runs/jifPassed*100/1757);
	}
}

