	/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Source File for Layer3/4 Model Code
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: aclModel.c,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#include <rtl_glue.h>
#include "assert.h"
#include "hsModel.h"
#include "asicRegs.h"
#include "icModel.h"
#include "modelTrace.h"
#include "l2Model.h"
#include "aclModel.h"
#include "rtl865xC_tblAsicDrv.h"
#define RTL8651_TBLDRV_LOCAL_H
#include "rtl8651_aclLocal.h"
extern int32 rtl8651_getAsicAclRule(uint32 index, _rtl8651_tblDrvAclRule_t *rule);
static enum MODEL_BOOLEAN_VALUE modelaclmatch(hsb_t*hsb,_rtl8651_tblDrvAclRule_t *rule)
{
	ether_addr_t srcMac, dstMac;
	switch (rule->ruleType_)
	{
		case RTL8651_ACL_MAC:			
			 srcMac.octet[0] =rule->srcMacMask_.octet[0] &hsb->sa0;
 			 srcMac.octet[1] =rule->srcMacMask_.octet[1] &hsb->sa1;
 			 srcMac.octet[2] =rule->srcMacMask_.octet[2] &hsb->sa2;			 
 			 srcMac.octet[3] =rule->srcMacMask_.octet[3] &hsb->sa3;
 			 srcMac.octet[4] =rule->srcMacMask_.octet[4] &hsb->sa4;			 
  			 srcMac.octet[5] =rule->srcMacMask_.octet[5]&hsb->sa5;			 
			 dstMac.octet[0]=rule->dstMacMask_.octet[0]&hsb->da0;
 			 dstMac.octet[1]=rule->dstMacMask_.octet[1]&hsb->da1;
 			 dstMac.octet[2]=rule->dstMacMask_.octet[2]&hsb->da2;
 			 dstMac.octet[3]=rule->dstMacMask_.octet[3]&hsb->da3;
 			 dstMac.octet[4]=rule->dstMacMask_.octet[4]&hsb->da4;			 
 			 dstMac.octet[5]=rule->dstMacMask_.octet[5]&hsb->da5;	
			 if (((hsb->ethtype& rule->typeLenMask_) == (rule->typeLen_ & rule->typeLenMask_)) &&
			 	(memcmp(dstMac.octet, rule->dstMac_.octet, 6) == 0) &&
			 	(memcmp(srcMac.octet, rule->srcMac_.octet, 6) == 0) )
			 		return MMATCH;
			 
			break;			
		case RTL8651_ACL_IP:			
			if ( 	(rule->srcIpAddr_ &rule->srcIpAddrMask_) ==(hsb->sip & rule->srcIpAddrMask_) &&
				(rule->dstIpAddr_ &rule->dstIpAddrMask_) ==(hsb->dip & rule->dstIpAddrMask_) &&
				(rule->ipHttpFilter_ ==hsb->urlmch)
				)
				{		
					return MMATCH;
					
				}
			break;
		case RTL8651_ACL_TCP:			
			if ( 	(rule->srcIpAddr_ &rule->srcIpAddrMask_) ==(hsb->sip & rule->srcIpAddrMask_) &&
			(rule->dstIpAddr_ &rule->dstIpAddrMask_) ==(hsb->dip & rule->dstIpAddrMask_) &&
				((hsb->tcpfg & rule->tcpFlagMask_) == (rule->tcpFlag_ & rule->tcpFlagMask_)) &&
				( hsb->sprt >=rule->tcpSrcPortLB_ ) &&
				(hsb->sprt  <= rule->tcpSrcPortUB_)&&
				(hsb->dprt  >= rule->tcpDstPortLB_)&&
				(hsb->dprt <=  rule->tcpDstPortUB_) 				
				)
				{		
					return MMATCH;
					
				}
			
			break;
		case RTL8651_ACL_UDP:			
			if ( 	(rule->srcIpAddr_ &rule->srcIpAddrMask_) ==(hsb->sip & rule->srcIpAddrMask_) &&
				(rule->dstIpAddr_ &rule->dstIpAddrMask_) ==(hsb->dip & rule->dstIpAddrMask_) &&
				(hsb->sprt>=rule->udpSrcPortLB_)&&
				(hsb->sprt<= rule->udpSrcPortUB_) &&
				(hsb->dprt >=rule->udpDstPortLB_)&&
				(hsb->dprt <= rule->udpDstPortUB_) 				
			)
			{		
					return MMATCH;
				
			}
			break;
		case RTL8651_ACL_ICMP:			
			if ( 	((rule->srcIpAddr_ &rule->srcIpAddrMask_) ==(hsb->sip & rule->srcIpAddrMask_) )&&
				((rule->dstIpAddr_ &rule->dstIpAddrMask_) ==(hsb->dip & rule->dstIpAddrMask_) )&&
			       ((hsb->iptos &rule->tosMask_) == (rule->tos_ & rule->tosMask_))  &&
				((hsb->ipptl & rule->icmpTypeMask_)== (rule->icmpType_&rule->icmpTypeMask_)) &&
				((hsb->sprt & rule->icmpCodeMask_) == (rule->icmpCode_ & rule->icmpCodeMask_))
				)
				{
					return MMATCH;
				}
			break;
		case RTL8651_ACL_IGMP:			
			if ( 	((rule->srcIpAddr_ &rule->srcIpAddrMask_) ==(hsb->sip & rule->srcIpAddrMask_) )&&
				((rule->dstIpAddr_ &rule->dstIpAddrMask_) ==(hsb->dip & rule->dstIpAddrMask_) )&&
				 ((hsb->iptos &rule->tosMask_) == (rule->tos_ & rule->tosMask_))  &&
			 	((hsb->ipptl & rule->igmpTypeMask_)== (rule->igmpType_&rule->igmpTypeMask_)) 
				)
			 	{
			 		return MMATCH;
			 	}
			
			break;
		case RTL8651_ACL_SRCFILTER:
			 srcMac.octet[0] =rule->srcFilterMacMask_.octet[0] &hsb->sa0;
 			 srcMac.octet[1] =rule->srcFilterMacMask_.octet[1] &hsb->sa1;
 			 srcMac.octet[2] =rule->srcFilterMacMask_.octet[2] &hsb->sa2;			 
 			 srcMac.octet[3] =rule->srcFilterMacMask_.octet[3] &hsb->sa3;
 			 srcMac.octet[4] =rule->srcFilterMacMask_.octet[4] &hsb->sa4;			 
  			 srcMac.octet[5] =rule->srcFilterMacMask_.octet[5]&hsb->sa5;			 

			switch (rule->srcFilterIgnoreL3L4_)
			{
				case 0:
				 	if ( (memcmp(srcMac.octet, rule->srcMac_.octet, 6) == 0) &&
						(((1<<hsb->spa) & rule->srcFilterPortMask_) == ( rule->srcFilterPort_ & rule->srcFilterPortMask_)) &&
						((hsb->vid & rule->srcFilterVlanIdxMask_) == (rule->srcFilterVlanIdx_ &rule->srcFilterVlanIdxMask_))&&
						((hsb->sip & rule->srcFilterIpAddrMask_) == (rule->srcFilterIpAddr_ & rule->srcFilterIpAddrMask_)) &&
						( hsb->sprt>=rule->srcFilterPortLowerBound_ ) &&
						(hsb->sprt<=  rule->srcFilterPortUpperBound_ )
					)
			 		{
			 			return MMATCH;
			 		}
				case 1:
				 	if ( (memcmp(srcMac.octet, rule->srcMac_.octet, 6) == 0) &&
						(((1<<hsb->spa) & rule->srcFilterPortMask_) == ( rule->srcFilterPort_ & rule->srcFilterPortMask_)) &&
						((hsb->vid & rule->srcFilterVlanIdxMask_) == (rule->srcFilterVlanIdx_ &rule->srcFilterVlanIdxMask_))
					)
			 		{
			 			return MMATCH;
			 		}
						
					
			}
			
		
			break;
		case RTL8651_ACL_DSTFILTER:
			 dstMac.octet[0]=rule->dstMacMask_.octet[0]&hsb->da0;
 			 dstMac.octet[1]=rule->dstMacMask_.octet[1]&hsb->da1;
 			 dstMac.octet[2]=rule->dstMacMask_.octet[2]&hsb->da2;
 			 dstMac.octet[3]=rule->dstMacMask_.octet[3]&hsb->da3;
 			 dstMac.octet[4]=rule->dstMacMask_.octet[4]&hsb->da4;			 
 			 dstMac.octet[5]=rule->dstMacMask_.octet[5]&hsb->da5;			 
			switch (rule->dstFilterIgnoreL3L4_)
			{
				case 0:
				 	if ( (memcmp(dstMac.octet, rule->dstMac_.octet, 6) == 0) &&
						((hsb->vid & rule->dstFilterVlanIdxMask_) == (rule->dstFilterVlanIdx_ &rule->dstFilterVlanIdxMask_))&&
						((hsb->dip & rule->dstFilterIpAddrMask_) == (rule->dstFilterIpAddr_ & rule->dstFilterIpAddrMask_)) &&
						( hsb->dprt>=rule->dstFilterPortLowerBound_ ) &&
						(hsb->dprt<=  rule->dstFilterPortUpperBound_ )
					)
			 		{
			 			return MMATCH;
			 		}
				case 1:
				 	if ( (memcmp(dstMac.octet, rule->dstMac_.octet, 6) == 0) &&
						((hsb->vid & rule->dstFilterVlanIdxMask_) == (rule->srcFilterVlanIdx_ &rule->dstFilterVlanIdxMask_))
					)
			 		{
			 			return MMATCH;
			 		}
						
					
			}			
			 
			 break;
			
		default:
			break;
			
	}
	return MNOTMATCH;
}
/*
@func enum MODEL_RETURN_VALUE | modelIngressACLCheck	| model code for ingress check
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue enum MODEL_RETURN_VALUE |
@comm 
*/

enum MODEL_RETURN_VALUE modelIngressACLCheck( hsb_t* hsb, hsa_t* hsa )
{

	_rtl8651_tblDrvAclRule_t rule;
	uint32 i;
	rtl865x_tblAsicDrv_vlanParam_t  *netif;
	uint32 spa;
	spa = hsb->spa;	

	/* We check VLAN ingress filtering only when enabled. */
	modelGetNetIf((void*)&netif);	
	/* Verify the member port of VLAN. Drop this packet if the packet is coming from the non-existed member port. */
	for (i=netif->inAclStart;i<=netif->inAclEnd;i++)
	{
			rtl8651_getAsicAclRule(i,&rule);
			switch  (rule.actionType_)
			{
				case RTL8651_ACL_PERMIT:
					if (modelaclmatch(hsb,&rule)==MMATCH)
						return MRET_OK;
					break;
				case RTL8651_ACL_DROP:					
					if (modelaclmatch(hsb,&rule)==MMATCH)
					{
						return MRET_DROP;
					}
					break;
				case RTL8651_ACL_CPU:						
					if (modelaclmatch(hsb,&rule)==MMATCH)
					{
						return MRET_TOCPU;
					}
					break;
			}
				
	}	
	hsa->dp=0;
	return MRET_OK;
}



/*
@func enum MODEL_RETURN_VALUE | modelIngressACLCheck	| model code for ingress check
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue enum MODEL_RETURN_VALUE |
@comm 
*/

enum MODEL_RETURN_VALUE modelEgressACLCheck( hsb_t* hsb, hsa_t* hsa )
{
	_rtl8651_tblDrvAclRule_t rule;
	uint32 i;
	rtl865x_tblAsicDrv_vlanParam_t  *netif;

	/* We check VLAN ingress filtering only when enabled. */	
	modelGetNetIf((void*)&netif);	
	/* Verify the member port of VLAN. Drop this packet if the packet is coming from the non-existed member port. */
	for (i=netif->outAclStart;i<=netif->outAclEnd;i++)
	{
			rtl8651_getAsicAclRule(i,&rule);
			switch  (rule.actionType_)
			{
				case RTL8651_ACL_PERMIT:
					if (modelaclmatch(hsb,&rule)==MMATCH)
						return MRET_OK;
					break;
				case RTL8651_ACL_DROP:					
					if (modelaclmatch(hsb,&rule)==MMATCH)
					{
						return MRET_DROP;
					}
					break;
				case RTL8651_ACL_CPU:						
					if (modelaclmatch(hsb,&rule)==MMATCH)
					{
						return MRET_TOCPU;
					}
					break;
			}
				
	}	
	hsa->dp = 0;
	return MRET_OK;
}

