/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Header File for IC Export Function
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: icExport.h,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/
#include "rtl_types.h"
#include "virtualMac.h"

enum EXPORT_REGISTER_FORMAT
{
	EXPORT_RTK_SIM,			/* Export registers for designer to simulate IC operation, said 'memw' commands. */
	EXPORT_RTK_EXPECT,		/* Export registers for designer to compare results, said 'memw' commands. */
	EXPORT_CLESHELL,		/* Export registers to import from CLE Shell command. */
};

char* modelExportPointerRegister( uint32 addr );
char* modelExportRegister( uint32 addr );
char* modelExportMemory( uint32 addr, uint32 len );
char* modelExportComment( char* pszComment );
int32 modelExportGdmaRegisters( void );
int32 modelExportAllRegisters( void );

#ifdef CONFIG_RTL865XB_EXP_CRYPTOENGINE
int32 modelExportCryptoRegisters( void );
#endif

/*===========================================================================*
 *   VIRTUAL ADDRESS TO PHYSICAL ADDRESS                                     *
 *===========================================================================*/
uint32 queryModelToPhysical( uint32 virtual );
int32 addModelToPhysical( uint32 virtualStart, uint32 virtualEnd, uint32 physicalStart );
int32 delModelToPhysical( uint32 virtualStart );

int32 modelExportSetOutputForm( enum EXPORT_REGISTER_FORMAT newFormat );
int32 modelExportGetOutputForm( enum EXPORT_REGISTER_FORMAT *oldFormat );
int32 modelExportSetIcType( enum IC_TYPE newType );
int32 modelExportGetIcType( enum IC_TYPE *oldType );
int32 modelExportOpenFile( char* pszFilename );
int32 modelExportCloseFile( void );
int32 runModelExport(uint32 userId,  int32 argc,int8 **saved);

