/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Source File for IC-specific Function
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: icModel.c,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#include "rtl_types.h"
#include "asicRegs.h"
#include "assert.h"
#include "rtl_glue.h"
#include "virtualMac.h"
#include "icModel.h"
#include "hsModel.h"
#include "l2Model.h"
#include "l34Model.h"
#include "aclModel.h"
#include "modelTrace.h"
#include "gdmaModel.h"
#include "swNic2.h"

#include "rtl_utils.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "icExport.h"
#define CHECK_RETVAL(A) if ((retval=A)==MRET_DROP) \
								goto drop;\
							else if (retval==MRET_TOCPU)\
								goto tocpu;

#ifdef CONFIG_RTL865XC 
uint32 FIRST_CPUTPDCR0=0, FIRST_CPUTPDCR1=1;
uint32 FIRST_CPURPDCR0=0,FIRST_CPURPDCR1=0,FIRST_CPURPDCR2=0,FIRST_CPURPDCR3=0,FIRST_CPURPDCR4=0,FIRST_CPURPDCR5=0;
uint32 FIRST_CPURMDCR0=0;

#define MAX_QUEUE_ENTRY 16
uint32 QueuePriority[MAX_QUEUE_ENTRY]={0};
uint8   QueuePriorityIndex=0;
#else
uint32 FIRST_CPUTPDCR=0;
uint32 FIRST_CPURPDCR=0;
uint32 FIRST_CPURMDCR=0;
#endif


void modelSwcoreFullReset( void )
{
}


void modelSwcoreSemiReset( void )
{
}


void dumpHSB(void)
{
	hsb_t hsb;	
	modelGetHsb(&hsb);	
	rtlglue_printf("hsb.spa=0x%x;\n",hsb.spa);  
	rtlglue_printf("hsb.vid=0x%x;\n",hsb.vid);
	rtlglue_printf("hsb.len=%d;\n",hsb.len);
	rtlglue_printf("hsb.tagif=0x%x;\n",hsb.tagif);
	rtlglue_printf("hsb.pppoeif=0x%x;\n",hsb.pppoeif);
	rtlglue_printf("hsb.sip=0x%x;\n",hsb.sip);
	rtlglue_printf("hsb.sprt=0x%x;\n",hsb.sprt);
	rtlglue_printf("hsb.dprt=0x%x;\n",hsb.dprt);
	rtlglue_printf("hsb.dip=0x%x;\n",hsb.dip);
	rtlglue_printf("hsb.ipptl=0x%x;\n",hsb.ipptl);
	rtlglue_printf("hsb.ipfg=0x%x;\n",hsb.ipfg);
	rtlglue_printf("hsb.iptos=0x%x;\n",hsb.iptos);
	rtlglue_printf("hsb.tcpfg=0x%x;\n",hsb.tcpfg);
	rtlglue_printf("hsb.type=0x%x;\n",hsb.type);
	rtlglue_printf("hsb.patmatch=0x%x;\n",hsb.patmatch);
	rtlglue_printf("hsb.ethtype=0x%x;\n",hsb.ethtype);
	rtlglue_printf("hsb.da0=0x%x; ",hsb.da0);
	rtlglue_printf("hsb.da1=0x%x; ",hsb.da1);	
	rtlglue_printf("hsb.da2=0x%x; ",hsb.da2);	
	rtlglue_printf("hsb.da3=0x%x; ",hsb.da3);	
	rtlglue_printf("hsb.da4=0x%x; ",hsb.da4);	
	rtlglue_printf("hsb.da5=0x%x;\n",hsb.da5);	
	rtlglue_printf("hsb.sa0=0x%x; ",hsb.sa0);
	rtlglue_printf("hsb.sa1=0x%x; ",hsb.sa1);	
	rtlglue_printf("hsb.sa2=0x%x; ",hsb.sa2);	
	rtlglue_printf("hsb.sa3=0x%x; ",hsb.sa3);	
	rtlglue_printf("hsb.sa4=0x%x; ",hsb.sa4);	
	rtlglue_printf("hsb.sa5=0x%x;\n",hsb.sa5);	
	rtlglue_printf("hsb.hiprior=0x%x;\n",hsb.hiprior);		
	rtlglue_printf("hsb.snap=0x%x;\n",hsb.snap);
	rtlglue_printf("hsb.llcothr=0x%x;\n",hsb.llcothr);
	rtlglue_printf("hsb.udpnocs=0x%x;\n",hsb.udpnocs);
	rtlglue_printf("hsb.ttlst=0x%x;\n",hsb.ttlst);
	rtlglue_printf("hsb.dirtx=0x%x;\n",hsb.dirtx);
	rtlglue_printf("hsb.l3csok=0x%x;\n",hsb.l3csok);	
	rtlglue_printf("hsb.l4csok=0x%x;\n",hsb.l4csok);	
	rtlglue_printf("hsb.ipfg=0x%x;\n",hsb.ipfg);	
	rtlglue_printf("hsb.ipfo0_n=0x%x;\n",hsb.ipfo0_n);		
	rtlglue_printf("hsb.urlmch=0x%x;\n",hsb.urlmch);		
	rtlglue_printf("hsb.extspa=0x%x;\n",hsb.extspa);		
	rtlglue_printf("hsb.extl2=0x%x;\n",hsb.extl2);	
}


struct grehdr					   /* Enhanced GRE header. */
{
	uint16    gh_flags;			   /* Flags. */
	uint16    gh_protocol;			   /* Protocol type. */
	uint16    gh_length;			   /* Payload length. */
	uint16    gh_call_id;			   /* Call ID. */
	uint32    gh_seq_no;			   /* Sequence number (optional). */
	uint32    gh_ack_no;			   /* Acknowledgment number (optional). */
};

#if defined(RTL865X_MODEL_USER) || defined(RTL865X_MODEL_KERNEL)
/*********************************************************************************
* Routine Name :  _rtl8651_ipChecksum                                   
* Description : 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
uint16 
_rtl8651_ipChecksum(struct ip * pip)
{


	uint32     sum=0,oddbyte=0;
	uint16 *ptr = (uint16 *)pip;
	uint32 nbytes = ((pip->ip_vhl & 0xf) << 2);	

	while (nbytes > 1)
	{
		
		sum += (*ptr++);
		nbytes -= 2;
	}
	if (nbytes == 1)
	{
#if 0
		//oddbyte = 0;
		//((uint8 *) & oddbyte)[0] = *(uint8 *) ptr;
		//((uint8 *) & oddbyte)[1] = 0;
#endif
		oddbyte = (*ptr & 0xff00);
		sum += oddbyte;
	}
	
	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);
	
	return (~sum);


}


/*********************************************************************************
* Routine Name :  _rtl8651_tcpChecksum                                   
* Description : 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/

uint16 _rtl8651_tcpChecksum(struct ip *pip)
{
	int32 sum, nbytes, nhdr, i;
	uint16 *sip, *dip, *ptr;

	nhdr =  ((pip->ip_vhl & 0xf) << 2);
	nbytes = ntohs(pip->ip_len) - nhdr;
	ptr = (uint16 *) ((char *) pip + nhdr);
	sum = 0;

	/* Note: We always padding zero to the tail of the packet!! */
	*(((uint8 *)pip) + nhdr + nbytes) = (uint8)0;
	for (i=0; i<nbytes ;i=i+2){
/*		sum += (unsigned long)*ptr++;*/
		sum += (unsigned long)ntohs(*ptr);
		ptr++;
	}

	/* "Pseudo-header" data */
	dip=(uint16 *)&pip->ip_dst;
	sum += ntohs(*dip); dip++;
	sum += ntohs(*dip);
	sip=(uint16 *)&pip->ip_src;
	sum += ntohs(*sip); sip++;
	sum += ntohs(*sip);	

	sum +=  nbytes;
	sum += ((uint16) pip->ip_p);

	/* Roll over carry bits */
	while (sum>>16)
		sum = (sum & 0xFFFF)+(sum >> 16);
	
	/* Take the one's complement of sum */
	sum = ~sum;
	return htons((uint16)sum);
	
}
#endif


/*
func void		| modelPktParser	| Parse packet, and output to HSB.
parm enum PORT_MASK | fromPort | The port number of packet from
parm uint8* | data | Packet content
parm uint8 | srcPortNum | source port number, 7: from CPU
parm uint8 | srcExtPortNum | source extersion port number, 0:CPU, 1:Ext0, 2:Ext1, 3:Ext2
parm uint16 | length | Length of packet
rvalue int |0:Drop, 1:Mirror to CPU, 2:forward to CPU, 3: to Mirror Port, 4:forward
comm 
This function will model the packet parser of ASIC.
It will generate HSB according to the input packet content.
*/
int modelPktParser(uint8 *data,uint8 srcPortNum,uint8 srcExtPortNum,uint16 length,struct rtl_pktHdr *pPkt)
{

	hsb_t hsb;	
	struct ip *ip=NULL;
	struct tcphdr *tc=NULL;
	struct udphdr *ud=NULL;	
	struct icmp *icmp=NULL;
	struct igmp *igmp=NULL;
	struct grehdr *gre=NULL;
	int32 ip_offset;
	uint32 ethTypePos;
	int8 isDirectTX=FALSE,isSNAP=FALSE,isLLC=FALSE;
	int8 isIP=FALSE;
	uint16 vlanId=0;
	int8 retval=4; /* 0:Drop, 1:Mirror to CPU, 2:forward to CPU, 3: to Mirror Port, 4:forward */

	ip_offset = 14;
	ethTypePos = 12;
	memset(&hsb,0,sizeof(hsb));

	if((srcExtPortNum==0)&&(srcPortNum==7))
	{
		isDirectTX=TRUE;
	}

	if((data[ethTypePos]==0x81)&&(data[ethTypePos+1]==0x00))  /* VLAN-Tag */
	{	

		vlanId=((data[ethTypePos+2]<<8)|data[ethTypePos+3])&0xfff;	
		ip_offset+=4;
		ethTypePos+=4;
		if(isDirectTX==FALSE) hsb.tagif=1;
	}	
	else if(data[ethTypePos]<=0x5) /*  LLC/SNAP (LLC-Tag) */
	{

		if((data[ethTypePos+2]==0xaa)&&(data[ethTypePos+3]==0xaa)&&(data[ethTypePos+4]==0x03))
		{
			isSNAP=TRUE;
			ip_offset+=8; /*for SNAP*/
			ethTypePos+=8; /*for SNAP*/
		}
		else
		{
			isLLC=TRUE;
		}
	}

	if((data[ethTypePos]==0x88)&&((data[ethTypePos+1]==0x63)||(data[ethTypePos+1]==0x64))) /*PPPoE-Tag*/
	{

		ip_offset+=8;
		if(isDirectTX==FALSE) hsb.pppoeif=1;
	}
	


	ip=(struct ip *)(&data[ip_offset]);

	if((ip->ip_vhl&0x40)==0x40)
		isIP=TRUE;

	if(isIP)
	{
		switch(ip->ip_p)
		{
			case IPPROTO_TCP:
				tc = (struct tcphdr *) ((int8 *)ip + ((ip->ip_vhl &0xf) << 2));
				break;

			case IPPROTO_UDP:
				ud = (struct udphdr *) ((int8 *)ip + ((ip->ip_vhl &0xf) << 2));
				break;

			case IPPROTO_ICMP:
				icmp = (struct icmp *) ((int8 *)ip + ((ip->ip_vhl &0xf) << 2));	
				break;

			case IPPROTO_IGMP:
				igmp = (struct igmp *) ((int8 *)ip + ((ip->ip_vhl &0xf) << 2));	
				break;			

			case IPPROTO_GRE:
				gre = (struct grehdr *) ((int8 *)ip + ((ip->ip_vhl &0xf) << 2));
				break;
		}
	}


	
	if(isDirectTX==TRUE)
	{
		hsb.spa=7;
		hsb.vid=pPkt->ph_vlanID;

		hsb.sprt=ntohs(ip->ip_sum);

		if(isIP)
		{
			if(ip->ip_p==IPPROTO_TCP)
			{
				hsb.dprt=ntohs(tc->th_sum);
			}
			else if(ip->ip_p==IPPROTO_UDP)
			{
				hsb.dprt=ntohs(ud->uh_sum);
			}
			else
			{
				hsb.dprt=0;
			}
		}

		if(pPkt->ph_LLCTagged)
		{
			hsb.snap=1; 
		}

		hsb.llcothr=0;  
		hsb.dirtx=1; 
		hsb.extspa=0;	

		if(pPkt->ph_pppeTagged)
		{
			hsb.pppoeif=1;
		}

		if(pPkt->ph_vlanTagged)
		{
			hsb.tagif=1;
		}		
		
	}
	else
	{
		hsb.spa=srcPortNum; /* RX: Src Port Number*/
		hsb.vid= vlanId;


		if(isIP)
		{
			switch(ip->ip_p)
			{
				case IPPROTO_TCP:
					hsb.sprt=ntohs(tc->th_sport);
					hsb.dprt=ntohs(tc->th_dport);
					break;
					
				case IPPROTO_UDP:
					hsb.sprt=ntohs(ud->uh_sport);
					hsb.dprt=ntohs(ud->uh_dport);
					break;
					
				case IPPROTO_ICMP:
					hsb.sprt=ntohs(icmp->icmp_id);
					break;
					
				case IPPROTO_GRE:
					hsb.sprt=ntohs(gre->gh_call_id);
					break;
			}
		}
		
		hsb.snap=isSNAP;
		hsb.llcothr=isLLC;
		hsb.dirtx=0;
		hsb.extspa=srcExtPortNum;
		
	}

	hsb.len=length;
	
	if(isIP)
	{
		/*hsb.len=ntohs(ip->ip_len)+ip_offset;*/
		hsb.sip=ntohl(ip->ip_src.s_addr);
		hsb.dip=ntohl(ip->ip_dst.s_addr);	

		if(ip->ip_p==IPPROTO_ICMP)
		{
			hsb.ipptl=icmp->icmp_type;
		}
		else if(ip->ip_p==IPPROTO_IGMP)
		{
			hsb.ipptl=igmp->igmp_type;
		}
		else
		{
			hsb.ipptl=ip->ip_p; 
		}
		hsb.ipfg=(ntohs(ip->ip_off)>>15)&0x7;
		hsb.iptos=ip->ip_tos;

		if(ip->ip_p==IPPROTO_TCP)
		{
			hsb.tcpfg=tc->th_flags; 
		}
		else if(ip->ip_p==IPPROTO_ICMP)
		{
			hsb.tcpfg=icmp->icmp_code; /*ICMP Code*/
		}


		switch(ip->ip_p)
		{
			case IPPROTO_GRE:
				hsb.type=1;
				break;
			case IPPROTO_IP:
				hsb.type=2;
				break;
			case IPPROTO_ICMP:
				hsb.type=3;
				break;
			case IPPROTO_IGMP:
				hsb.type=4;
				break;
			case IPPROTO_TCP:
				hsb.type=5;
				break;
			case IPPROTO_UDP:
				hsb.type=6;
				break;
			default:			
				hsb.type=0;
				break;
		}
	}

	if(srcPortNum==7) /* DirectTX or ExtPort*/
	{
#ifdef CONFIG_RTL865XC 
		hsb.hiprior=((pPkt->ph_flags&PKTHDR_QUEUE_ID)==0x0800)?1:0;	
#else
		hsb.hiprior=(pPkt->ph_flags&PKTHDR_HPRIORITY)?1:0;	
#endif
	}

	if(isDirectTX==TRUE)
	{	
		hsb.ethtype=(pPkt->ph_portlist<<5)|(pPkt->ph_vlanTagged<<4)|(pPkt->ph_pppeTagged<<3)|(pPkt->ph_pppoeIdx); /* for Direct TX, this field is { Reserved(12), DoPPPoETAG, PPPoEID }				*/

	}
	else
	{
		hsb.ethtype=(data[ethTypePos]<<8)|(data[ethTypePos+1]);
		if((READ_MEM32(PPMAR)&0x2000)!=0) /*enable Pattern Match*/
		{
			if(srcPortNum<6)
			{
				if((READ_MEM32(PPMAR)&(1<<(srcPortNum+26)))!=0) /*enable Per-Port Pattern Match*/
				{				
					uint32 search,mask,value;
					int i;
					search=ntohl(READ_MEM32(PATP0+srcPortNum*4));
					mask=ntohl(READ_MEM32(MASKP0+srcPortNum*4));
					for(i=0;i<length-4;i++)
					{
						value=(data[i]<<24)|(data[i+1]<<16)|(data[i+2]<<8)|(data[i+3]);
						if((value&mask)==search) 
						{
							hsb.patmatch=1;
							retval=(READ_MEM32(PPMAR)>>24)&0x3; /*save return Action*/
							break;
						}
					}
				}

			}

		}


/*		hsb.hiprior=hiprior; not be used in TX/RX??*/
	}
	
	hsb.da0=data[0];
	hsb.da1=data[1];
	hsb.da2=data[2];
	hsb.da3=data[3];
	hsb.da4=data[4];
	hsb.da5=data[5];	
	hsb.sa0=data[6];	
	hsb.sa1=data[7];	
	hsb.sa2=data[8];	
	hsb.sa3=data[9];	
	hsb.sa4=data[10];	
	hsb.sa5=data[11];	


	if(isIP)
	{
		/*  UDP and checksum = 0*/
		if(ip->ip_p==IPPROTO_UDP)
		{
			if(ntohs(ud->uh_sum)==0) hsb.udpnocs=1;
		}

		/*set IP TTL value*/
		if(ip->ip_ttl==0)
			hsb.ttlst=0;
		else if(ip->ip_ttl==1)
			hsb.ttlst=1;
		else
			hsb.ttlst=2;
		
		/* IP fragmentation offset status , 0:offset =0 , 1:not 0*/
		if((ntohs(ip->ip_off)&IP_OFFMASK)==0) 
			hsb.ipfo0_n=0;
		else
			hsb.ipfo0_n=1;


		if(isDirectTX==FALSE)	
		{
			uint16 l3sum,l4sum;
			l3sum=ip->ip_sum;
			l4sum = 0; /* compiler complains un-initialized. */
			ip->ip_sum=0;

			if((hsb.ipfo0_n==0)&&(hsb.udpnocs==0)) /*don't care UDP no-checksum or fragment packets.*/
			{
				if(ip->ip_p==IPPROTO_TCP)
				{
					l4sum=(tc->th_sum);
					tc->th_sum=0;
					tc->th_sum = _rtl8651_tcpChecksum(ip);
					if(tc->th_sum==l4sum) hsb.l4csok=1;
					else { hsb.l4csok=0; retval=0; }
				
				}
				else if(ip->ip_p==IPPROTO_UDP)
				{
					l4sum=(ud->uh_sum);
					ud->uh_sum=0;
					ud->uh_sum = _rtl8651_tcpChecksum(ip);
					if(ud->uh_sum==l4sum) hsb.l4csok=1;
					else { hsb.l4csok=0; retval=0; } 
				}
			}

			ip->ip_sum = _rtl8651_ipChecksum(ip);	

			if(l3sum==ip->ip_sum) hsb.l3csok=1;
			else { hsb.l3csok=0; retval=0; }
			ip->ip_sum=l3sum;

			if(hsb.ipfo0_n==0) 
			{
				if(ip->ip_p==IPPROTO_TCP)
					tc->th_sum=l4sum;			
				else if(ip->ip_p==IPPROTO_UDP)
					ud->uh_sum=l4sum;
			}		
		}
	}

#if 0	
//	hsb.urlmch=urlmch;
//	hsb.extl2=
#endif

	modelSetHsb(&hsb);
/*	dumpHSB();	*/
	return retval;

}


#if defined(RTL865X_MODEL_USER)||defined(RTL865X_MODEL_KERNEL)
/*
 * For IC hardware, it is different between READ and WRITE.
 * To emulate the hardware, we provide two functions.
 * Therefore, we can emulate some hardware-specific function, such as "write 1 to clear interrupt pending bit".
 */
void WRITE_MEM32(uint32 reg, uint32 val)
{
	enum IC_TYPE ictype;

	model_getTestTarget( &ictype );

	switch( ictype )
	{

		case IC_TYPE_MODEL:
	
			if ( 0 ) { /* to make program pretty */ }
			/* CPU Interface Control Register */
			else if ( reg==CPUICR )
			{
				/*rtlglue_printf("CPUICR %x TXFD=%x TXCMD=%x\n",val,TXFD,TXCMD);*/
				if(val&TXFD)
				{
					int i;

					if(val&TXCMD)
					{

#ifdef CONFIG_RTL865XC 


						for(i=0;i<totalTxPkthdr1;i++)
						{
							if(*(uint32 *)(FIRST_CPUTPDCR1+i*4)&DESC_SWCORE_OWNED)
							{
								struct rtl_pktHdr *pPkt;
								int retval;

								WRITE_VIR32(CPUTPDCR1,FIRST_CPUTPDCR1+i*4);
								pPkt=(struct rtl_pktHdr *)((*((uint32*) (READ_MEM32(CPUTPDCR1)))) &(~(DESC_OWNED_BIT|DESC_WRAP)));


								if(QueuePriorityIndex<MAX_QUEUE_ENTRY)
								{
									QueuePriority[QueuePriorityIndex++]=(uint32)pPkt;
								}

								retval=modelPktParser(pPkt->ph_mbuf->m_data,7,pPkt->ph_srcExtPortNum,pPkt->ph_len,pPkt);							

								*(uint32 *)(FIRST_CPUTPDCR1+i*4)&=(~DESC_SWCORE_OWNED); /* to CPU own */


								if(READ_MEM32(CPUIIMR)&TX_DONE_IE1)
								{
									WRITE_VIR32(CPUIISR, READ_VIR32(CPUIISR)|TX_DONE_IP1);
								}							
							}
						}

						if(READ_MEM32(CPUIIMR)&TX_ALL_DONE_IE1)
						{	
							WRITE_VIR32(CPUIISR, READ_VIR32(CPUIISR)|TX_ALL_DONE_IP1);
						}

						for(i=0;i<totalTxPkthdr0;i++)
						{
							if(*(uint32 *)(FIRST_CPUTPDCR0+i*4)&DESC_SWCORE_OWNED)
							{
								struct rtl_pktHdr *pPkt;
								int retval;

								WRITE_VIR32(CPUTPDCR0,FIRST_CPUTPDCR0+i*4);
								pPkt=(struct rtl_pktHdr *)((*((uint32*) (READ_MEM32(CPUTPDCR0)))) &(~(DESC_OWNED_BIT|DESC_WRAP)));


								if(QueuePriorityIndex<MAX_QUEUE_ENTRY)
								{
									QueuePriority[QueuePriorityIndex++]=(uint32)pPkt;
								}
								
								retval=modelPktParser(pPkt->ph_mbuf->m_data,7,pPkt->ph_srcExtPortNum,pPkt->ph_len,pPkt);							

								*(uint32 *)(FIRST_CPUTPDCR0+i*4)&=(~DESC_SWCORE_OWNED); /* to CPU own */


								if(READ_MEM32(CPUIIMR)&TX_DONE_IE0)
								{
									WRITE_VIR32(CPUIISR, READ_VIR32(CPUIISR)|TX_DONE_IP0);
								}							
							}
						}

						if(READ_MEM32(CPUIIMR)&TX_ALL_DONE_IE1)
						{	
							WRITE_VIR32(CPUIISR, READ_VIR32(CPUIISR)|TX_ALL_DONE_IP1);
						}
						

#else

						for(i=0;i<totalTxPkthdr;i++)
						{
							if(*(uint32 *)(FIRST_CPUTPDCR+i*4)&DESC_SWCORE_OWNED)
							{
								struct rtl_pktHdr *pPkt;
								int retval;
								/*rtlglue_printf("send a packet in idx=%d\n",i);*/
								WRITE_VIR32(CPUTPDCR,FIRST_CPUTPDCR+i*4);
								pPkt=(struct rtl_pktHdr *)((*((uint32*) (READ_MEM32(CPUTPDCR)))) &(~(DESC_OWNED_BIT|DESC_WRAP)));
/*								rtlglue_printf("pPkt in mem32=%x %x\n",(uint32)pPkt,(uint32)pPkt->ph_mbuf);*/
								
								retval=modelPktParser(pPkt->ph_mbuf->m_data,7,pPkt->ph_srcExtPortNum,pPkt->ph_len,pPkt);							
/*								rtlglue_printf("retval=%d\n",retval);*/
								*(uint32 *)(FIRST_CPUTPDCR+i*4)&=(~DESC_SWCORE_OWNED);
/*								rtlglue_printf("desc i=%d ptr=%x\n",i,*(uint32 *)(FIRST_CPUTPDCR+i*4));*/

								if(READ_MEM32(CPUIIMR)&TX_DONE_IE)
								{
									WRITE_VIR32(CPUIISR, READ_VIR32(CPUIISR)|TX_DONE_IP);
								}							
							}
						}

						if(READ_MEM32(CPUIIMR)&TX_ALL_DONE_IE)
						{	
							WRITE_VIR32(CPUIISR, READ_VIR32(CPUIISR)|TX_ALL_DONE_IP);
						}
#endif						

					}
					
					val&=(~TXFD); /*clear TxFN*/
				}


				if(val&STOPTX)
				{
					val&=(~TXFD);
					val&=(~STOPTX);
				}

				if(val&SWINTSET)
				{
					val&=(~SWINTSET);
				}
				
				if(val&SOFTRST) /*must end of all CPUICR flags*/
				{
					val=0;
					WRITE_VIR32(CPUIIMR,0);
					WRITE_VIR32(CPUIISR,0); /*?*/
				}	

				val&=0xd7ff00ff; /* clear Reserved */
				WRITE_VIR32( reg, val );

			}
#ifdef CONFIG_RTL865XC 
			else if ( reg==CPURPDCR0 )
			{
				FIRST_CPURPDCR0=val;

				WRITE_VIR32( reg, val );
			}
			else if ( reg==CPURPDCR1 )
			{
				FIRST_CPURPDCR1=val;

				WRITE_VIR32( reg, val );
			}
			else if ( reg==CPURPDCR2 )
			{
				FIRST_CPURPDCR2=val;

				WRITE_VIR32( reg, val );
			}
			else if ( reg==CPURPDCR3 )
			{
				FIRST_CPURPDCR3=val;

				WRITE_VIR32( reg, val );
			}			
			else if ( reg==CPURPDCR4 )
			{
				FIRST_CPURPDCR4=val;

				WRITE_VIR32( reg, val );
				/* FIXME: The Rx Pkt Header First Descriptor Pointer Address */
			}
			else if ( reg==CPURPDCR5 )
			{
				FIRST_CPURPDCR5=val;

				WRITE_VIR32( reg, val );
				/* FIXME: The Rx Pkt Header First Descriptor Pointer Address */
			}

			else if ( reg==CPURMDCR0 )
			{
				FIRST_CPURMDCR0=val;

				WRITE_VIR32( reg, val );
				/* FIXME: The Rx mbuf First Descriptor Pointer Address */
			}
			
			else if ( reg==CPUTPDCR0 )
			{
				FIRST_CPUTPDCR0=val;

				WRITE_VIR32( reg, val );
			}			
			else if ( reg==CPUTPDCR1 )
			{
				FIRST_CPUTPDCR1=val;

				WRITE_VIR32( reg, val );
			}			
			
#else
			else if ( reg==CPURPDCR )
			{
				FIRST_CPURPDCR=val;
				/*rtlglue_printf("CPURPDCR\n");*/
				WRITE_VIR32( reg, val );
				/* FIXME: The Rx Pkt Header First Descriptor Pointer Address */
			}
			else if ( reg==CPURMDCR )
			{
				FIRST_CPURMDCR=val;
				/*rtlglue_printf("CPURMDCR\n");*/
				WRITE_VIR32( reg, val );
				/* FIXME: The Rx mbuf First Descriptor Pointer Address */
			}
			else if ( reg==CPUTPDCR )
			{
				FIRST_CPUTPDCR=val;
				/*rtlglue_printf("CPUTPDCR\n");*/
				WRITE_VIR32( reg, val );
				/* FIXME: The Tx Pkt Header First Descriptor Pointer Address */
			}			
#endif			

			else if ( reg==CPUIIMR )
			{

#ifdef CONFIG_RTL865XC 
				val&=0xffff07fe; 
#else
				val&=0xf8f80000;
#endif				
				
				WRITE_VIR32( reg, val );
			}
			else if( reg ==CPUIISR) 
			{

#ifdef CONFIG_RTL865XC 
				val&=0xffff07fe; 
#else
				val&=0xf8f80000;
#endif	
				WRITE_VIR32(CPUIISR,READ_VIR32(CPUIISR)&(~val));  /* write one to clear */

			}
			
			
			/* System control registers */
			else if ( reg==MACCR )
			{
				if ( val & FULL_RST )
					modelSwcoreFullReset();
				if ( val & SEMI_RST )
					modelSwcoreSemiReset();	
			}
			else if ( reg==SWTACR )
			{
				WRITE_VIR32(reg, val);
				if ( val & ACTION_START )
				{
					/*
					case CMD_ADD:
					case CMD_MODIFY:
					case CMD_FORCE:
					*/
					WRITE_VIR32( SWTACR, READ_VIR32(SWTACR) & ~ACTION_MASK );
					WRITE_VIR32( SWTASR, 0 );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x00, READ_VIR32( TCR0 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x04, READ_VIR32( TCR1 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x08, READ_VIR32( TCR2 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x0C, READ_VIR32( TCR3 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x10, READ_VIR32( TCR4 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x14, READ_VIR32( TCR5 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x18, READ_VIR32( TCR6 ) );
					WRITE_VIR32( READ_VIR32(SWTAA)+0x1C, READ_VIR32( TCR7 ) );
				}
			}
			else if ( reg==GDMACNR )
			{
				if ( ( (READ_VIR32(reg)&GDMA_ENABLE) == 0 ) && ( val & GDMA_ENABLE ) )
				{
					/* write 0, and 1 to reset GDMA */
					WRITE_VIR32( GDMAISR, 0 );
				}
				
				WRITE_VIR32( reg, val );
				if ( val & GDMA_POLL )
				{
					modelGdma();
				}
				else
				{
					/* Set to output 'memw ...' */
					if ( (READ_VIR32(reg)&GDMA_ENABLE) == 0 )
						modelExportComment( "Disable GDMA, enable it to reset." );
					modelExportSetOutputForm(EXPORT_RTK_SIM);
					modelExportRegister( GDMACNR );
				}
			}
			else if ( reg==GDMAISR )
			{
				/* write 1 to clear */
				WRITE_VIR32( reg, READ_VIR32(reg) & ~val );
			}			
			else
			{	/* Default */
				/*Pattern Match: PPMAR,PATP0,PATP1,PATP2,PATP3,PATP4,PATP5,MASKP0,MASKP1,MASKP2,MASKP3,MASKP4,MASKP5...*/
				WRITE_VIR32( reg, val );
			}
			break;
			
		case IC_TYPE_REAL:
			REG32(reg) = big_endian(val);			
			break;
			
		default:
			assert( 0 );
			break;
	}
}


uint32 READ_MEM32(uint32 reg)
{
	uint32 ret = 0;
	enum IC_TYPE ictype;

	model_getTestTarget( &ictype );
		
	switch( ictype )
	{
		case IC_TYPE_MODEL:
			if ( 0 ) { /* to make program pretty */ }
			/* CPU Interface Control Register */
			else if ( reg==CPUICR )
			{
				ret = READ_VIR32(reg);
			}
#ifdef CONFIG_RTL865XC 	
			else if ( reg==CPURPDCR0 )
			{
				ret = READ_VIR32(reg);			
			}
			else if ( reg==CPURPDCR1 )
			{
				ret = READ_VIR32(reg);			
			}
			else if ( reg==CPURPDCR2 )
			{
				ret = READ_VIR32(reg);			
			}
			else if ( reg==CPURPDCR3 )
			{
				ret = READ_VIR32(reg);			
			}
			else if ( reg==CPURPDCR4 )
			{
				ret = READ_VIR32(reg);			
			}
			else if ( reg==CPURPDCR5 )
			{
				ret = READ_VIR32(reg);			
			}

			
			else if ( reg==CPURMDCR0 )
			{
				ret = READ_VIR32(reg);			
			}

			
			else if ( reg==CPUTPDCR0 )
			{
				ret = READ_VIR32(reg);			
			}
			else if ( reg==CPUTPDCR1 )
			{
				ret = READ_VIR32(reg);			
			}

#else
			else if ( reg==CPURPDCR )
			{
				ret = READ_VIR32(reg);			
				/* FIXME: The Rx Pkthdr Current Descriptor Address */
			}
			else if ( reg==CPURMDCR )
			{
				ret = READ_VIR32(reg);			
				/* FIXME: The Rx mbuf Current Descriptor Address */
			}
			else if ( reg==CPUTPDCR )
			{
				ret = READ_VIR32(reg);			
				/* FIXME: The Tx Pkthdr Current Descriptor Address */
			}
#endif
			else if ( reg==CPUIIMR )			
			{
				ret = READ_VIR32(reg);
			}
			else if ( reg==CPUIISR )
			{
				ret = READ_VIR32(reg);			
			}
			/* System control registers */
			else if ( reg==MACCR )
			{
				ret = READ_VIR32(reg) & ~(FULL_RST|SEMI_RST);
			}
			else if ( reg==SWTASR )
			{
				/* do nothing */
			}
			else
			{	/* Default */
				/* Pattern Match: PPMAR,PATP0,PATP1,PATP2,PATP3,PATP4,PATP5,MASKP0,MASKP1,MASKP2,MASKP3,MASKP4,MASKP5... */
				ret = READ_VIR32(reg);
			}
			break;

		case IC_TYPE_REAL:
			ret = big_endian( REG32(reg) );
			break;

		default:
			assert( 0 );
			break;
	}
	return ret;
}


/*
 *	For Model Code to write into virtual register space.
 *	If you want to monitor which model code touch the specified register, add your code here.
 */
void WRITE_VIR32(uint32 reg, uint32 val)
{
	enum IC_TYPE ictype;

	if ( ( reg & 3 ) != 0 )
	{
		rtlglue_printf( "\x1b[31;42m%s():%d unaligned 32-bit access to 0x%08x.\x1b[m\n", __FUNCTION__, __LINE__, reg );
	}
	
	model_getTestTarget( &ictype );
	switch( ictype )
	{
		case IC_TYPE_MODEL:
			REG32( reg ) = big_endian( val );
			break;
			
		case IC_TYPE_REAL:
			rtlglue_printf( "\x1b[31;42m%s(0x%08x):%d In real mode, model code should be inactive.\x1b[m\n", __FUNCTION__, reg, __LINE__ );
			assert( 0 );
			break;

		default:
			rtlglue_printf( "\x1b[31;42m%s(0x%08x):%d Unknown IC type: 0x%x.\x1b[m\n", __FUNCTION__, reg, __LINE__, ictype );
			assert( 0 );
			break;
	}
}

void WRITE_VIR16(uint32 reg, uint32 val)
{
	uint32 _val;
	
	if ( ( reg & 1 ) != 0 )
	{
		rtlglue_printf( "\x1b[31;42m%s():%d unaligned 16-bit access to 0x%08x.\x1b[m\n", __FUNCTION__, __LINE__, reg );
	}

	_val = READ_VIR32( reg & 0xfffffffc );
	_val = _val & ~(0xffff<<((2-(reg&2))*8));
	_val = _val | (val<<((2-(reg&2))*8));
	WRITE_VIR32( reg & 0xfffffffc, _val );
}

void WRITE_VIR8(uint32 reg, uint32 val)
{
	uint32 _val;
	
	_val = READ_VIR32( reg & 0xfffffffc );
	_val = _val & ~(0xff<<((3-(reg&3))*8));
	_val = _val | (val<<((3-(reg&3))*8));
	WRITE_VIR32( reg & 0xfffffffc, _val );
}


/*
 *	For Model Code to read from virtual register space.
 *	If you want to monitor which model code touch the specified register, add your code here.
 */
uint32 READ_VIR32(uint32 reg)
{
	enum IC_TYPE ictype;

	if ( ( reg & 3 ) != 0 )
	{
		rtlglue_printf( "\x1b[31;42m%s():%d unaligned 32-bit access to 0x%08x.\x1b[m\n", __FUNCTION__, __LINE__, reg );
	}
	
	model_getTestTarget( &ictype );

	switch( ictype )
	{
		case IC_TYPE_MODEL:
			return big_endian( REG32( reg ) );
			
		case IC_TYPE_REAL:
			return big_endian( REG32( reg ) );
			break;

		default:
			assert( 0 );
			break;
	}
	return 0xDeadC0de; /* Exception !!! */
}

uint32 READ_VIR16(uint32 reg)
{
	if ( ( reg & 1 ) != 0 )
	{
		rtlglue_printf( "\x1b[31;42m%s():%d unaligned 16-bit access to 0x%08x.\x1b[m\n", __FUNCTION__, __LINE__, reg );
	}
	
	return ( READ_VIR32( reg & 0xfffffffc ) >> ((2-(reg&0x2))*8) ) & 0xffff;
}

uint32 READ_VIR8(uint32 reg)
{
	return ( READ_VIR32( reg & 0xfffffffc ) >> ((3-(reg&0x3))*8) ) & 0xff;
}

#endif

/*
func int32		| modelIcSetDefaultValue	| Set default value of IC registers after booted up.
parm void | |
rvalue void |
comm 
Set the default value of all rgisters in IC. Please key-in these default according the 865xC specification.
This function must be called after pVirtualSWReg/pVirtualSysReg/pVirtualSWTable had been allocated and 
  before ROME driver sets its default value.
*/
void modelIcSetDefaultValue( void )
{
#if 0 /* Enable it when SWCORE is ready. */
	WRITE_MEM32( CHIPID, 0x8651b000 );
	WRITE_MEM32( CRMR, 0x05015788 );
#endif
}


/*
func void		| startModel	| Starting model ( HSB --> HSA )
parm void | |
rvalue void |
comm 
This function has no parameter and return value.
Because this function will input parameter from global HSB, and generate return value into global HSA.
The decision flow is described according to Alpha's note.
*/
void modelStart( void )
{
	hsb_t hsb;
	hsa_t hsa;
	int32 retval;
	memset((void*)&hsa,0,sizeof(hsa));
	retval = modelGetHsb( &hsb );
	assert( retval == SUCCESS );
	/* TODO: Monitor Rx Port for Port Mirror */
	
	/* DONE: DMac==IEEE 802.1D Protocol Reserved Group Address */
	MT_WATCH( "before model802_1dAddress()..." );

	if ( model802_1dAddress( &hsb, &hsa ) == MRET_TOCPU )
	{
		goto tocpu;
	}
	
	/* TODO: VLAN Ingress Check */
	MT_WATCH( "before modelIngressCheck()..." );
	CHECK_RETVAL(modelIngressCheck( &hsb, &hsa ));
	/* TODO: (G-2)Trap to CPU if VLAN is configured as promiscuous mode. */
	if ( 0 == MRET_TOCPU )
	{
		/* TODO: Trap to CPU */
		goto tocpu;
	}

	/* TODO: Check Spanning Tree State */
	if ( 0 == MRET_DROP )
		goto drop;

	/* TODO: (N)SA Blocking */
	if ( 0 == MRET_DROP )
		goto drop;
	CHECK_RETVAL(modelIngress802_1X(&hsb,&hsa));
	/* Source MAC Learning */
	modelLayer2Switching( &hsb, &hsa );
	/* TODO: (F)To CPU, plz ask Alpha for details */
	/* TODO: (I)Realtek private protocol frame */
	/* TODO: (B-1)Ingress ACL */
	retval=modelIngressACLCheck(&hsb, &hsa);
	switch (retval)
		{
			case MRET_DROP:
					goto drop;
					break;
			case MRET_TOCPU:
					goto tocpu;
					break;
			default:
					break;
		}
		
		
	if ( 0 == MRET_DROP )
		goto drop;
	else if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: (D)Pattern Match */
	if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: (C)Protocol trap */
	if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: (J)Broadcast/Multicast check */
	CHECK_RETVAL(modelLayer3Switching(&hsb,&hsa));
	if (retval==MRET_TOCPU)
		goto tocpu;
	/* TODO: (H)DA=gateway MAC && ((!IPv4)||(!route_allow)) */
	if ( 0 == MRET_DROP )
		goto drop;
	else if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: (A)L2/L3/L4 */
	if ( 0 == MRET_DROP )
		goto drop;
	else if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: (G-1)VLan table's non-unicast frame to CPU. */
	if ( 0 == MRET_DROP )
		goto drop;
	else if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: (K)Trunk processing */
	/* TODO: Spanning Tree State */
	if ( 0 == MRET_DROP )
		goto drop;

	/* TODO: VLAN Egress Check */
		
	/* TODO: VLAN Ingress Check */
	MT_WATCH( "before modelIngressCheck()..." );
	CHECK_RETVAL(modelEgressCheck( &hsb, &hsa ));
	/* TODO: (B-2)Egress ACL */
	CHECK_RETVAL(modelEgressACLCheck(&hsb, &hsa));
	
	if ( 0 == MRET_DROP )
		goto drop;
	else if ( 0 == MRET_TOCPU )
		goto tocpu;

	/* TODO: Monitor Tx port for mirror port */
	/* TODO: (M)Mirror Function Process */
	/* TODO: (L)CPU direct Tx */
	goto drop;

tocpu:
	/* rtlglue_printf( "* Packet trapped to CPU.\n" ); */
	
	/* TODO: Queue packet to CPU NIC. */
	goto out;

drop:

out:
	/* Write-back HSA */
	retval = modelSetHsa( &hsa );
	assert( retval == SUCCESS );
	
}


/*
func int32		| modelPktTranslator	| Get
parm enum PORT_MASK* | toPort | The port number of packet from
parm uint8** | packet | Packet content
parm int32* | len | Input: the max length of packet content; Output: length of packet returned
rvalue SUCCESS | Returned a packet
rvalue FAILED | No packet stored in output queue
comm 
This function will model the packet parser of ASIC.
It will generate HSB according to the input packet content.
*/
int32 modelPktTranslator( enum PORT_MASK *toPort, uint8* packet, int32 *len )
{
	return SUCCESS;
}

