/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Header File for IC-specific Function
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: icModel.h,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#ifndef _IC_MODEL_
#define NUMBER_OF_L2_SWITCH_TABLE_ENTRY         1024
#define _IC_MODEL_
#define BIT1MASK        0x00000001
#define BIT2MASK        0x00000003
#define BIT3MASK        0x00000007
#define BIT4MASK        0x0000000F
#define BIT5MASK        0x0000001F
#define BIT6MASK        0x0000003F
#define BIT7MASK        0x0000007F
#define BIT8MASK        0x000000FF
#define BIT9MASK        0x000001FF
#define BIT10MASK       0x000003FF
#define BIT11MASK       0x000007FF
#define BIT12MASK       0x00000FFF
#define BIT13MASK       0x00001FFF
#define BIT14MASK       0x00003FFF
#define BIT15MASK       0x00007FFF
#define BIT16MASK       0x0000FFFF
#define BIT17MASK       0x0001FFFF
#define BIT18MASK       0x0003FFFF
#define BIT19MASK       0x0007FFFF
#define BIT20MASK       0x000FFFFF
#define BIT21MASK       0x001FFFFF
#define BIT22MASK       0x003FFFFF
#define BIT23MASK       0x007FFFFF
#define BIT24MASK       0x00FFFFFF
#define BIT25MASK       0x01FFFFFF
#define BIT26MASK       0x03FFFFFF
#define BIT27MASK       0x07FFFFFF
#define BIT28MASK       0x0FFFFFFF
#define BIT29MASK       0x1FFFFFFF
#define BIT30MASK       0x3FFFFFFF
#define BIT31MASK       0x7FFFFFFF
#define BIT32MASK       0xFFFFFFFF

enum PORT_NUM
{
	PN_PORT0 = 0,
	PN_PORT1 = 1,
	PN_PORT2 = 2,
	PN_PORT3 = 3,
	PN_PORT4 = 4,
	PN_PORT5 = 5,
	PN_PORT_EXT0 = 7,
	PN_PORT_EXT1 = 8,
	PN_PORT_EXT2 = 9,
	PN_PORT_CPU = 10,
};

enum PORT_MASK
{
	PM_PORT_0 = (1<<PN_PORT0),
	PM_PORT_1 = (1<<PN_PORT1),
	PM_PORT_2 = (1<<PN_PORT2),
	PM_PORT_3 = (1<<PN_PORT3),
	PM_PORT_4 = (1<<PN_PORT4),
	PM_PORT_5 = (1<<PN_PORT5),
	PM_PORT_EXT0 = (1<<PN_PORT_EXT0),
	PM_PORT_EXT1 = (1<<PN_PORT_EXT1),
	PM_PORT_EXT2 = (1<<PN_PORT_EXT2),
	PM_PORT_CPU = (1<<PN_PORT_CPU),
};

#define MODEL_CPU_PORT_MASK	(1<<6)
enum MODEL_RETURN_VALUE
{
	/* 0*/	MRET_OK = 0,
	/* 1*/	MRET_DROP,
	/* 2*/	MRET_TOCPU,
};
enum MODEL_BOOLEAN_VALUE
{
	/* 0*/	MNOTMATCH = 0,
	/* 1*/	MMATCH,
};

void modelIcSetDefaultValue( void );
int modelPktParser(uint8 *data,uint8 srcPortNum,uint8 srcExtPortNum,uint16 length,struct rtl_pktHdr *pPkt);
int32 modelPktTranslator( enum PORT_MASK *toPort, uint8* packet, int32 *len );
void modelStart( void );
void dumpHSB(void);

#endif
