/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Model Code for 865xC
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: icTest.c,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/
#include <rtl_types.h>
#include <rtl_glue.h>
#if defined(RTL865X_TEST)||defined(RTL865X_MODEL_USER)
#define  CONFIG_RTL865XB
#include "utility.h"
#include <cle_userglue.h>
#else
#include "utility.h"
#endif
#include <cle_struct.h>
#include "pktGen.h"
#include "asicRegs.h"
#include "icTest.h"
#include "hsModel.h"
#ifdef CONFIG_RTL865XC
#include "rtl865xC_tblAsicDrv.h"
#else
#include "rtl8651_tblAsicDrv.h"
#endif
#define RTL8651_TBLDRV_LOCAL_H
#include "rtl8651_aclLocal.h"
#include "rtl8651_layer2local.h"
#include "drvTest.h"
#include "fwdTest.h"
#include "rtl8651_tblDrvFwd.h"
#include "virtualMac.h"
#include "gdmaTest.h"
#include "nicTest.h"
#include "parserTest.h"

struct MODEL_TEST_CASE_S
{	
	int32 no;
	char* name;
	int32 (*fp)(uint32);
	uint32 group;
};
typedef struct MODEL_TEST_CASE_S MODEL_TEST_CASE_T;

#define MODEL_TEST_CASE( case_no, func, group_mask ) \
	{ \
		no: case_no, \
		name: #func, \
		fp: func, \
		group: group_mask, \
	}

/*
 * To make source code more clear, we define this macro.
 * This is for modelCompHsb() and modelCompHsa() functions.
 */
#define CHECK_EQUAL( p1, p2, field, retvar, retval ) \
	do { \
		if ( p1->field != p2->field ) \
		{ \
			rtlglue_printf( "%s(): '%s' NOT equal( %d , %d ).\n", __FUNCTION__, #field, p1->field, p2->field ); \
			retvar = retval; \
		} \
	} while(0);


int32 compHsb( hsb_t* hsb1, hsb_t* hsb2 )
{
	int32 retval = SUCCESS;

	CHECK_EQUAL( hsb1, hsb2, spa, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, len, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, vid, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, tagif, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, pppoeif, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sip, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sprt, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, dip, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, dprt, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, ipptl, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, ipfg, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, iptos, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, tcpfg, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, type, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, patmatch, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, ethtype, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, da0, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, da1, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, da2, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, da3, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, da4, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, da5, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sa0, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sa1, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sa2, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sa3, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sa4, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, sa5, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, hiprior, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, snap, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, udpnocs, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, ttlst, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, dirtx, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, l3csok, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, l4csok, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, ipfo0_n, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, llcothr, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, urlmch, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, extspa, retval, FAILED );
	CHECK_EQUAL( hsb1, hsb2, extl2, retval, FAILED );

	return retval;
}


int32 compHsa( hsa_t* hsa1, hsa_t* hsa2 )
{
	int32 retval = SUCCESS;
	
	CHECK_EQUAL( hsa1, hsa2, nhmac0, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, nhmac1, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, nhmac2, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, nhmac3, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, nhmac4, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, nhmac5, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, trip, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, port, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, l3csdt, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, l4csdt, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, egif, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, l2tr, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, l34tr, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, dirtxo, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, typeo, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, llc, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, vlanproc, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, dvidx, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, pppoeifo, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, pppidx, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, leno, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, l3csoko, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, l4csoko, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, frag, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, lastfrag, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, ipmcastr, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, svidx, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, fragpkt, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, ttl_1if, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, dpc, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, spao, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, ttl_1if2, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, dpext, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, spaext, retval, FAILED );
	CHECK_EQUAL( hsa1, hsa2, why2cpu, retval, FAILED );

	return retval;
}


/*
 *  Test the READ_VIR32()/READ_VIR16()/READ_VIR8() functions.
 *  READ_VIR*() functions are availiable only in MODEL mode.
 */
static uint8 forTestVir[4];
int32 testModel_readvir(uint32 caseNo)
{
	int32 retval = FAILED;
	uint8 *cp;
	uint32 var32;
	uint16 var16;
	uint8 var8;
	int i;

	for( i = IC_TYPE_MODEL; i < IC_TYPE_MODEL; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

		/* We first insert a known value */
		cp = (char*)forTestVir;
		cp[0] = 0x01;
		cp[1] = 0x23;
		cp[2] = 0x45;
		cp[3] = 0x67;
	
		/* Then, read with 32 bits */
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "READ_VIR32() error", var32, 0x01234567, __FUNCTION__, __LINE__ );
		
		/* Second, read 16 bits */
		var16 = READ_VIR16( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "READ_VIR16() error", var16, 0x0123, __FUNCTION__, __LINE__ );
		var16 = READ_VIR16( (uint32)forTestVir+2 );
		IS_EQUAL_INT( "READ_VIR16() error", var16, 0x4567, __FUNCTION__, __LINE__ );

		/* Third, read 8-bits */
		var8 = READ_VIR8( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "READ_VIR8() error", var8, 0x01, __FUNCTION__, __LINE__ );
		var8 = READ_VIR8( (uint32)forTestVir+1 );
		IS_EQUAL_INT( "READ_VIR8() error", var8, 0x23, __FUNCTION__, __LINE__ );
		var8 = READ_VIR8( (uint32)forTestVir+2 );
		IS_EQUAL_INT( "READ_VIR8() error", var8, 0x45, __FUNCTION__, __LINE__ );
		var8 = READ_VIR8( (uint32)forTestVir+3 );
		IS_EQUAL_INT( "READ_VIR8() error", var8, 0x67, __FUNCTION__, __LINE__ );
		
	}

	return SUCCESS;
}


/*
 *  Test the WRITE_VIR32()/WRITE_VIR16()/WRITE_VIR8() functions.
 *  WRITE_VIR*() functions are availiable only in MODEL mode.
 */
int32 testModel_writevir(uint32 caseNo)
{
	int32 retval = FAILED;
	uint8 *cp;
	uint32 var32;
	int i;

	for( i = IC_TYPE_MODEL; i < IC_TYPE_MODEL; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

		/* We first insert a known value */
		cp = (char*)forTestVir;
	
		/* Then, write with 32 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR32( (uint32)forTestVir+0, 0x01234567 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "READ_VIR32() error", var32, 0x01234567, __FUNCTION__, __LINE__ );
		
		/* Second, write high 16 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR16( (uint32)forTestVir+0, 0x0123 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "WRITE_VIR16() error", var32, 0x0123FFFF, __FUNCTION__, __LINE__ );

		/* write low 16 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR16( (uint32)forTestVir+2, 0x4567 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "WRITE_VIR16() error", var32, 0xFFFF4567, __FUNCTION__, __LINE__ );

		/* write highest 8 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR8( (uint32)forTestVir+0, 0x01 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "WRITE_VIR16() error", var32, 0x01FFFFFF, __FUNCTION__, __LINE__ );

		/* write 2nd highest 8 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR8( (uint32)forTestVir+1, 0x23 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "WRITE_VIR16() error", var32, 0xFF23FFFF, __FUNCTION__, __LINE__ );

		/* write 2nd lowest 8 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR8( (uint32)forTestVir+2, 0x45 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "WRITE_VIR16() error", var32, 0xFFFF45FF, __FUNCTION__, __LINE__ );

		/* write lowest 8 bits */
		cp[0] = 0xFF; cp[1] = 0xFF; cp[2] = 0xFF; cp[3] = 0xFF;
		WRITE_VIR8( (uint32)forTestVir+3, 0x67 );
		var32 = READ_VIR32( (uint32)forTestVir+0 );
		IS_EQUAL_INT( "WRITE_VIR16() error", var32, 0xFFFFFF67, __FUNCTION__, __LINE__ );

		
	}

	return SUCCESS;
}

/*
*  Test the 802.1d Reserved Address
*
*  We expect these packet with DMAC=01:80:C2:00:00:0x will be trapped to CPU.
*/
int32 testModel_802_1dAdress(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 0,
		len: 64,
		vid: 0x1234,
		tagif: 1,
		pppoeif: 1,
		sip: 0x11223344,
		sprt: 0x5566,
		dip: 0x778899aa,
		dprt: 0xbbcc,
		ipptl: 0xdd,
		ipfg: 0x0,
		iptos: 0x65,
		tcpfg: 0x00,
		type: 0,
		patmatch: 1,
		ethtype: 0x7788,
		da0: 0x01,
		da1: 0x80,
		da2: 0xC2,
		da3: 0x00,
		da4: 0x00,
		da5: 0x00,
		sa0: 0x77,
		sa1: 0x88,
		sa2: 0x99,
		sa3: 0xaa,
		sa4: 0xbb,
		sa5: 0xcc,
		hiprior: 0,
		snap: 1,
		udpnocs: 0,
		ttlst: 2,
		dirtx: 0,
		l3csok: 1,
		l4csok: 1,
		ipfo0_n: 1,
		llcothr: 0,
		urlmch: 1,
		extspa: 0,
		extl2: 0,
	};
	hsa_t hsa;
	int i, da5;

	for( da5 = 0; da5 <= 0xf; da5++ )
	{
		hsb.da5 = da5;

		/* Compare the HSA of expected, model, FPGA, and real IC. */
		for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
		{
			retval = model_setTestTarget( i );
			if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );

			/* Start model code */
			modelStart();
			
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet should be trapped to CPU.", hsa.dp, MODEL_CPU_PORT_MASK, __FUNCTION__, __LINE__ );
		}
	}
	
	retval = SUCCESS;
	return retval;
}


/*
*  Test the vlan ingress check model code
*
*  We expect these packet with DMAC=01:80:C2:00:00:0x will be trapped to CPU.
*/
int32 testModel_vlanIngressCheck(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 0,
		len: 64,
		vid: 0x1234,
		tagif: 0,
		pppoeif: 1,
		sip: 0x11223344,
		sprt: 0x5566,
		dip: 0x778899aa,
		dprt: 0xbbcc,
		ipptl: 0xdd,
		ipfg: 0x0,
		iptos: 0x65,
		tcpfg: 0x00,
		type: 0,
		patmatch: 1,
		ethtype: 0x7788,
		da0: 0x11,
		da1: 0x22,
		da2: 0x33,
		da3: 0x44,
		da4: 0x55,
		da5: 0x66,
		sa0: 0x77,
		sa1: 0x88,
		sa2: 0x99,
		sa3: 0xaa,
		sa4: 0xbb,
		sa5: 0xcc,
		hiprior: 0,
		snap: 1,
		udpnocs: 0,
		ttlst: 2,
		dirtx: 0,
		l3csok: 1,
		l4csok: 1,
		ipfo0_n: 1,
		llcothr: 0,
		urlmch: 1,
		extspa: 0,
		extl2: 0,
	};

	hsa_t hsa;
	int i, port;
	_rtl8651_tblDrvAclRule_t rule;
	rtl865x_tblAsicDrv_vlanParam_t vlan;

	/* Enable ingress filtering. */
	WRITE_MEM32( SWTMCR, EN_VLAN_INGRESS_FILTER );	
	/* Set PVID of all port to VLAN 8. */
	WRITE_MEM32(( PVCR0+0*4), ((0x8<<0)|(0x8<<16)|(0x4<<12)) );
	WRITE_MEM32(( PVCR0+1*4), ((0x8<<0)|(0x8<<16)) );
	WRITE_MEM32(( PVCR0+2*4), ((0x8<<0)|(0x8<<16)) );
	/* Set permit rule. */
	bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
	rule.actionType_ = RTL8651_ACL_PERMIT;
	rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
	rule.ruleType_ = RTL8651_ACL_MAC;
	rtl8651_setAsicAclRule( 0, &rule);
	/* Config VLAN 8 (vidx:0) */
	vlan.vid = 8;
	vlan.valid = 1;
	vlan.broadcastToCpu = FALSE;
	vlan.DMZFlag = 0;
	vlan.enableRoute = FALSE;
	vlan.inAclEnd = 0;
	vlan.inAclStart = 0;
	vlan.outAclEnd = 0;
	vlan.outAclStart = 0;
	vlan.internal = 1;
	memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
	vlan.macAddrNumber = 1;
	vlan.memberPortMask = 0;
	vlan.mtu = 1500;
	vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
	vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
	vlan.promiscuous = 0;
	vlan.untagPortMask = 0;
	rtl8651_setAsicVlan( &vlan );

	for( port = PN_PORT0; port <= PN_PORT5; port++ )
	{
		hsb.spa = port;
		vlan.memberPortMask = 0x1f & (~( 1 << port ));
		rtl8651_setAsicVlan( &vlan );
		
		/* Compare the HSA of expected, model, FPGA, and real IC. */
		for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
		{
			retval = model_setTestTarget( i );
			if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		
			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );

			/* Start model code */
			modelStart();			
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet shouldn't  be forwarded, however forward", hsa.dp, 0, __FUNCTION__, __LINE__ );
		}

		/* let VLAN has no member port, all packets should be dropped. */
		hsb.spa = port;
		vlan.memberPortMask = 0;
		rtl8651_setAsicVlan( &vlan );
		
		/* Compare the HSA of expected, model, FPGA, and real IC. */
		for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
		{
			retval = model_setTestTarget( i );
			if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
			
			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );

			/* Start model code */
			modelStart();
			
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet shoulde be dropped !", hsa.dp, 0, __FUNCTION__, __LINE__ );
		}

	}

	retval = SUCCESS;	
	return retval;
}




/****************************************************************************
 ****__*****__*************                                                ** 
 ***|  |***|  |****__******                                                ** 
 ***|  |***|  |***|  |*****                                                ** 
 ***|  |***|  |***|__|*****                                                ** 
 ***|  |***|  |************      Add Your Model Test Cases HERE !!!        ** 
 ***|   ___   |****__******                                                ** 
 ***|  |***|  |***|  |*****                                                ** 
 ***|  |***|  |***|  |*****                                                ** 
 ***|  |***|  |***|  |*****                                                ** 
 ***|  |***|  |***|  |*****                                                ** 
 ***|__|***|__|***|__|*****                                                **
 ****************************************************************************/
MODEL_TEST_CASE_T modelTestCase[] =
{
	MODEL_TEST_CASE( AUTO_CASE_NO, testModel_readvir, GRP_ALL | GRP_PKT_PARSER ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testModel_writevir, GRP_ALL | GRP_PKT_PARSER ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testModel_802_1dAdress, GRP_ALL | GRP_PRE_CORE ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testModel_vlanIngressCheck, GRP_ALL | GRP_PRE_CORE ),

	/* GDMA */
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaPatternMatch1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaPatternMatch2, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaPatternMatch3, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaPatternMatch4, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaPatternMatch5, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaPatternMatch6, GRP_ALL | GRP_GDMA ),


	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaMemory1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaChecksum1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaSequentialTCAM, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaWirelessMIC, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaBase64Encode1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaBase64Decode1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaQuotedPrintableEncode1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaQuotedPrintableDecode1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaByteSwap1, GRP_ALL | GRP_GDMA ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testGdmaByteSwap2, GRP_ALL | GRP_GDMA ),

	/* NIC */
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicTx, GRP_ALL | GRP_NIC ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicTxQueuePriority, GRP_ALL | GRP_NIC ),	
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicRx, GRP_ALL | GRP_NIC ),	
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicRxRunout, GRP_ALL | GRP_NIC ),	
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicRxPriority, GRP_ALL | GRP_NIC ),	
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicRegs, GRP_ALL | GRP_NIC ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testNicRxQueueidDescringMapping, GRP_ALL | GRP_NIC ),

	/* Parser */
	MODEL_TEST_CASE( AUTO_CASE_NO, parserTagForDirectTX, GRP_ALL | GRP_PKT_PARSER ),
	MODEL_TEST_CASE( AUTO_CASE_NO, parserPatternMatch, GRP_ALL | GRP_PKT_PARSER ),	
	MODEL_TEST_CASE( AUTO_CASE_NO, parserChecksumCheck, GRP_ALL | GRP_PKT_PARSER ),
	MODEL_TEST_CASE( AUTO_CASE_NO, parserUrlTrap, GRP_ALL | GRP_PKT_PARSER ),

	/* Layer 2*/
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2UniLearning, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2UniLRULearning, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2FIDLearning, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2UnwareVlan, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2VlanNoExist, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2UnkonwUniCast, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer2UnKnownMulticast, GRP_ALL | GRP_L2 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer28021XPortBase, GRP_ALL | GRP_L2 ),
	
	/* Layer 3*/
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer3MTU, GRP_ALL | GRP_L34 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLayer3Routing, GRP_ALL | GRP_L34 ),
	/*Layer 4*/
	MODEL_TEST_CASE( AUTO_CASE_NO, testServerPort, GRP_ALL | GRP_L34 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testALG, GRP_ALL | GRP_L34 ),
	MODEL_TEST_CASE( AUTO_CASE_NO, testLocalPublicIP, GRP_ALL | GRP_L34 ),

	
};


int32 runModelTest(uint32 userId,  int32 argc,int8 **saved)
{
	int8 *nextToken;
	int32 size;
	int32 lower, upper;
	int i;
	int32 retval;
	int32 totalCase = 0;
	int32 okCase = 0;
	int32 failCase = 0;
	int32 failCaseIdx[sizeof(modelTestCase)/sizeof(modelTestCase[0])];
	int32 caseNoSeq = 1; /* to generate auto-increased case number. */
	uint32 groupmask = 0xffffffff;

	lower = 0;
	upper = sizeof(modelTestCase)/sizeof(modelTestCase[0]); /* MAX */
	
	cle_getNextCmdToken(&nextToken,&size,saved);
	if ( !strcmp( nextToken, "all" ) )
		groupmask = GRP_ALL;
	else if ( !strcmp( nextToken, "parser" ) )
		groupmask = GRP_PKT_PARSER;
	else if ( !strcmp( nextToken, "translator" ) )
		groupmask = GRP_PKT_TRANSLATOR;
	else if ( !strcmp( nextToken, "pre_core" ) )
		groupmask = GRP_PRE_CORE;
	else if ( !strcmp( nextToken, "l2" ) )
		groupmask = GRP_L2;
	else if ( !strcmp( nextToken, "l34" ) )
		groupmask = GRP_L34;
	else if ( !strcmp( nextToken, "post_core" ) )
		groupmask = GRP_POST_CORE;
	else if ( !strcmp( nextToken, "gdma" ) )
		groupmask = GRP_GDMA;
	else if ( !strcmp( nextToken, "nic" ) )
		groupmask = GRP_NIC;	
	else
		lower = upper = U32_value(nextToken);

	if ( cle_getNextCmdToken(&nextToken,&size,saved) == SUCCESS )
		upper = U32_value(nextToken);

	/* generate auto-increased pCase->no */
	for( i = 0; i < sizeof(modelTestCase)/sizeof(modelTestCase[0]); i++ )
	{
		MODEL_TEST_CASE_T *pCase = &modelTestCase[i];
		
		if  ( pCase->no == AUTO_CASE_NO )
			pCase->no = (caseNoSeq++);
	}

	rtlglue_printf( "Running from %d to %d with group mask 0x%08x:\n\n", lower, upper, groupmask );
		
	for( i = 0; i < sizeof(modelTestCase)/sizeof(modelTestCase[0]); i++ )
	{
		MODEL_TEST_CASE_T *pCase = &modelTestCase[i];

		if ( pCase->no < lower || pCase->no > upper ) continue;
		if ( ( pCase->group & groupmask ) == 0 ) continue;

		totalCase++;
		
		modelIcSetDefaultValue();
		
		rtlglue_printf( "Running Model Test Case %d: %s() ...\n", pCase->no, pCase->name );
		
		retval = pCase->fp( pCase->no );

		if ( retval == SUCCESS )
		{
			rtlglue_printf( " ok!\n\n" );
			okCase++;
		}
		else
		{
			rtlglue_printf( "\033[31;43m fail!! \033[m\n\n" );
			failCaseIdx[failCase] = i;
			failCase++;
		}
	}

	rtlglue_printf( ">>Total Case: %d,  Pass: %d,  Fail: %d\n\n", totalCase, okCase, failCase );
	if ( failCase > 0 )
	{
		/* list fail cases */
		int i;
		
		rtlglue_printf("  +-- Failed Cases ----------------------------------------------------------+\n");
		for( i = 0; i < failCase; i++ )
		{
			rtlglue_printf("  | case %-5d  %-60s |\n", modelTestCase[failCaseIdx[i]].no,
			                                           modelTestCase[failCaseIdx[i]].name );
		}
		rtlglue_printf("  +--------------------------------------------------------------------------+\n\n");
	}

	/* Finally, we had finished all test cases. We must recover the registers to real address. */
	model_setTestTarget( IC_TYPE_REAL );

	return SUCCESS;
}


