
#include <rtl_types.h>
#include <rtl_glue.h>
#if defined(RTL865X_TEST)||defined(RTL865X_MODEL_USER)
#define  CONFIG_RTL865XB
#include "utility.h"
#include <cle_userglue.h>
#else
#include "utility.h"
#endif
#include <cle_struct.h>
#include "pktGen.h"
#include "asicRegs.h"
#include "icTest.h"
#include "hsModel.h"
#ifdef CONFIG_RTL865XC
#include "rtl865xC_tblAsicDrv.h"
#else
#include "rtl8651_tblAsicDrv.h"
#endif
#define RTL8651_TBLDRV_LOCAL_H
#include "rtl8651_aclLocal.h"
#include "rtl8651_layer2local.h"
#include "drvTest.h"
#include "fwdTest.h"
#include "rtl8651_tblDrvFwd.h"
#include "virtualMac.h"


int32 testLayer2UniLearning(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 0,
		len: 64,
		vid: 0x0234,
		tagif: 0,
		pppoeif: 0,
		sip: 0x11223344,
		sprt: 0x5566,
		dip: 0x778899aa,
		dprt: 0xbbcc,
		ipptl: 0xdd,
		ipfg: 0x0,
		iptos: 0x65,
		tcpfg: 0x00,
		type: 0,
		patmatch: 1,
		ethtype: 0x7788,
		da0: 0xff,
		da1: 0xff,
		da2: 0xff,
		da3: 0xff,
		da4: 0xff,
		da5: 0xff,
		sa0: 0x00,
		sa1: 0x80,
		sa2: 0xc0,
		sa3: 0x00,
		sa4: 0x00,
		sa5: 0x00,
		hiprior: 0,
		snap: 1,
		udpnocs: 0,
		ttlst: 2,
		dirtx: 0,
		l3csok: 1,
		l4csok: 1,
		ipfo0_n: 1,
		llcothr: 0,
		urlmch: 1,
		extspa: 0,
		extl2: 0,
	};
	hsa_t hsa;
	int i;
	_rtl8651_tblDrvAclRule_t rule;
	rtl865x_tblAsicDrv_vlanParam_t vlan;
	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);	
		/* Set PVID of all port to VLAN 8. */
		for (i=0;i<3;i++)	WRITE_MEM32(( PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );

		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);

		/* Config VLAN 8 (vidx:0) */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 0;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 0;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3f;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;
		vlan.fid=2;
		rtl8651_setAsicVlan( &vlan );
		hsb.spa = 0x1;

		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		
		hsb.spa=0x2;
		hsb.sa0=0;		hsb.sa1=0x80;
		hsb.sa2=0xc0;	hsb.sa3=0x10;
		hsb.sa4=0x10;	hsb.sa5=0;

		hsb.da0=0;		hsb.da1=0x80;
		hsb.da2=0xc0;	hsb.da3=0x0;
		hsb.da4=0x0;		hsb.da5=0;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );          
		IS_EQUAL_INT("Pakcet should be learned ", hsa.dp,2, __FUNCTION__, __LINE__ );
	}


	retval = SUCCESS;	
	return retval;
}
int32 testLayer2FIDLearning(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 0,
		len: 64,
		vid: 0x0234,
		tagif: 0,
		pppoeif: 0,
		sip: 0x11223344,
		sprt: 0x5566,
		dip: 0x778899aa,
		dprt: 0xbbcc,
		ipptl: 0xdd,
		ipfg: 0x0,
		iptos: 0x65,
		tcpfg: 0x00,
		type: 0,
		patmatch: 1,
		ethtype: 0x7788,
		da0: 0xff,
		da1: 0xff,
		da2: 0xff,
		da3: 0xff,
		da4: 0xff,
		da5: 0xff,
		sa0: 0x00,
		sa1: 0x80,
		sa2: 0xc0,
		sa3: 0x00,
		sa4: 0x00,
		sa5: 0x00,
		hiprior: 0,
		snap: 1,
		udpnocs: 0,
		ttlst: 2,
		dirtx: 0,
		l3csok: 1,
		l4csok: 1,
		ipfo0_n: 1,
		llcothr: 0,
		urlmch: 1,
		extspa: 0,
		extl2: 0,
	};
	hsa_t hsa;
	int i,vlanid;
	_rtl8651_tblDrvAclRule_t rule;
	rtl865x_tblAsicDrv_vlanParam_t vlan;
	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
	
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);  
		rtl8651_clearAsicPvid();
		rtl8651_setAsicPvid(0, 8);
		rtl8651_setAsicPvid(1, 8);
		rtl8651_setAsicPvid(2, 8);
		rtl8651_setAsicPvid(3, 9);
		rtl8651_setAsicPvid(4, 9);
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);

		/* Config VLAN 8 (vidx:0) */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 3;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 4;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		vlan.fid=0;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3;
		vlan.mtu = 1500;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;

		rtl8651_getAsicPvid(3,&vlanid);
		rtl8651_setAsicVlan( &vlan );   
		/* Config VLAN 9  */
		vlan.vid = 9;
		vlan.inAclEnd = 3;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 8;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x1c;
		vlan.fid=1;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;
		rtl8651_setAsicVlan( &vlan );   
  	        
		hsb.spa=0x1;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x10;	
		hsb.sa4=0x10;		hsb.sa5=0;	
		hsb.da0=0xff;		hsb.da1=0xff;
		hsb.da2=0xff;		hsb.da3=0xff;
		hsb.da4=0xff;		hsb.da5=0xff;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		hsb.spa=0x3;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x10;
		hsb.sa4=0x10;		hsb.sa5=0;
		retval = virtualMacSetHsb( &hsb );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		assert( retval == SUCCESS );			
		hsb.spa=0x4;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x11;
		hsb.sa4=0x10;		hsb.sa5=0;			
		hsb.da0=0;			hsb.da1=0x80;
		hsb.da2=0xc0;		hsb.da3=0x10;
		hsb.da4=0x10;		hsb.da5=0;
		retval = virtualMacSetHsb( &hsb );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		assert( retval == SUCCESS );			
		IS_EQUAL_INT("Pakcet should be forward to port 3 ", hsa.dp,(1<<3), __FUNCTION__, __LINE__ );
		hsb.spa=0x0;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc1;		hsb.sa3=0x11;
		hsb.sa4=0x10;		hsb.sa5=0;			
		hsb.da0=0;			hsb.da1=0x80;
		hsb.da2=0xc0;		hsb.da3=0x10;
		hsb.da4=0x10;		hsb.da5=0;
		retval = virtualMacSetHsb( &hsb );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		assert( retval == SUCCESS );			
		IS_EQUAL_INT("Pakcet should be forward to port 1 ", hsa.dp,(2), __FUNCTION__, __LINE__ );


			
	}
	
	retval = SUCCESS;	
	return retval;
}
int32 testLayer2UniLRULearning(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 0,			len: 64,
		vid: 0x0234,		tagif: 0,
		pppoeif: 0,		sip: 0x11223344,
		sprt: 0x5566,		dip: 0x778899aa,
		dprt: 0xbbcc,		ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: 0,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0xff,		da1: 0xff,
		da2: 0xff,		da3: 0xff,
		da4: 0xff,		da5: 0xff,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 1,
		udpnocs: 0,		ttlst: 2,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0,
	};
	hsa_t hsa;
	int i;
	_rtl8651_tblDrvAclRule_t rule;
	rtl865x_tblAsicDrv_vlanParam_t vlan;

	
	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);	
		WRITE_MEM32(FFCR,READ_MEM32(FFCR)&~EN_UNUNICAST_TOCPU);
			WRITE_MEM32( TEACR,READ_MEM32(TEACR)&~EN_L2LRUHASH);		
		WRITE_MEM32( TEACR,READ_MEM32(TEACR));		
		/* Set PVID of all port to VLAN 8. */
		for (i=0;i<3;i++)	WRITE_MEM32((PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);
		/* Config VLAN 8 */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 0;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 0;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3f;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		rtl8651_setAsicVlan( &vlan );	


	
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		
		hsb.spa=0x1;			
		hsb.sa0=0;			hsb.sa1=0x80;		
		hsb.sa2=0xc0;		hsb.sa3=0x10;		
		hsb.sa4=0x10;		hsb.sa5=0;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );			

		hsb.spa=0x1;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x11;
		hsb.sa4=0x11;		hsb.sa5=0;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );			
		
		hsb.spa=0x1;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x14;
		hsb.sa4=0x14;		hsb.sa5=0;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );			
		
		hsb.spa=0x2;
		hsb.sa0=0x00;		hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x18;
		hsb.sa4=0x18;		hsb.sa5=0x00;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );						

		hsb.spa=0x1;
		hsb.sa0=0x02;		hsb.sa1=0x80;
		hsb.da0=0x00;		hsb.da1=0x80;
		hsb.da2=0xc0;		hsb.da3=0x18;
		hsb.da4=0x18;	       hsb.da5=0x00;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );						
		IS_EQUAL_INT("Pakcet should be broadcast,but ....", hsa.dp,0x3d, __FUNCTION__, __LINE__ );


		WRITE_MEM32( TEACR,READ_MEM32(TEACR)|EN_L2LRUHASH);		
		hsb.spa=0x2;
		hsb.sa0=0x00;		hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x18;
		hsb.sa4=0x18;		hsb.sa5=0x00;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );						

		hsb.spa=0x1;
		hsb.sa0=0x02;		hsb.sa1=0x80;
		hsb.da0=0x00;		hsb.da1=0x80;
		hsb.da2=0xc0;		hsb.da3=0x18;
		hsb.da4=0x18;	       hsb.da5=0x00;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );						
		IS_EQUAL_INT("Pakcet should be learn,but ....", hsa.dp,0x4, __FUNCTION__, __LINE__ );

		
	}
	retval = SUCCESS;	
	return retval;
}
int32 testLayer2UnwareVlan(uint32 caseNo)
{
	int32 retval;	
	hsb_t hsb =
	{
		spa: 0,			len: 64,
		vid: 0x09,		tagif: 1,
		pppoeif: 0,		sip: 0x11223344,
		sprt: 0x5566,		dip: 0x778899aa,
		dprt: 0xbbcc,		ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: 0,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0xff,		da1: 0xff,
		da2: 0xff,		da3: 0xff,
		da4: 0xff,		da5: 0xff,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 1,
		udpnocs: 0,		ttlst: 2,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0
	};
	hsa_t hsa;
	int i;
	rtl865x_tblAsicDrv_vlanParam_t vlan;
	_rtl8651_tblDrvAclRule_t rule;

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
			rtl8651_clearAsicAllTable();
		/* Enable ingress filtering.  1q unware*/
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER|EN_1QUNWARE);	
		WRITE_MEM32( TEACR,READ_MEM32(TEACR)|EN_L2LRUHASH);		
		/* Set PVID of all port to VLAN 8. */
		for (i=0;i<3;i++)	WRITE_MEM32(( PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);
		rtl8651_setAsicOperationLayer(2);
		/* Config VLAN 8 */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 0;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 0;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3f;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;
		rtl8651_setAsicVlan( &vlan );	

		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );

		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );			
		IS_NOT_EQUAL_INT("Pakcet should be forward, but dropped", hsa.dp,0, __FUNCTION__, __LINE__ );
		hsb.spa=0x2;
		hsb.sa0=0;			hsb.sa1=0x80;
		hsb.sa2=0xc0;		hsb.sa3=0x18;
		hsb.sa4=0x18;		hsb.sa5=0;
		hsb.da0=0;			hsb.da1=0x80;
		hsb.da2=0xc0;		hsb.da3=0x0;
		hsb.da4=0x0;			hsb.da5=0;
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );				
		IS_EQUAL_INT("Pakcet should be forward,but broadcast or dropped", hsa.dp,1, __FUNCTION__, __LINE__ );
			
	}	
	retval=SUCCESS;
	return retval;
}
int32 testLayer2VlanNoExist(uint32 caseNo)
{
	int32 retval;
	hsb_t hsb =
	{
		spa: 0,			len: 64,
		vid: 0x09,		tagif: 0,
		pppoeif: 0,		sip: 0x11223344,
		sprt: 0x5566,		dip: 0x778899aa,
		dprt: 0xbbcc,		ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: 0,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0xff,		da1: 0xff,
		da2: 0xff,		da3: 0xff,
		da4: 0xff,		da5: 0xff,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 0,
		udpnocs: 0,		ttlst: 2,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0
	};
	hsa_t hsa;
	int i;
	_rtl8651_tblDrvAclRule_t rule;	

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);	
		WRITE_MEM32( TEACR,READ_MEM32(TEACR));		
		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0)|EN_UKNOWNVID_TO_CPU);
		/* Set PVID of all port to VLAN 8. */
		for (i=0;i<3;i++)	WRITE_MEM32(( PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);
		
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );			
		IS_EQUAL_INT("Pakcet should be to cpu, but ...", hsa.dp,1<<6, __FUNCTION__, __LINE__ );
	}	
	retval=SUCCESS;
	return retval;

}
int32 testLayer2UnkonwUniCast(uint32 caseNo)
{
	int32 retval;
	hsb_t hsb =
	{
		spa: 0,			len: 64,
		vid: 0x08,		tagif: 0,
		pppoeif: 0,		sip: 0x11223344,
		sprt: 0x5566,		dip: 0x778899aa,
		dprt: 0xbbcc,		ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: 0,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x00,		da1: 0xff,
		da2: 0xff,		da3: 0xff,
		da4: 0xff,		da5: 0xff,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 0,
		udpnocs: 0,		ttlst: 2,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0
	};
	hsa_t hsa;
	int i;
	_rtl8651_tblDrvAclRule_t rule;	
	rtl865x_tblAsicDrv_vlanParam_t vlan;

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);	
		WRITE_MEM32( TEACR,READ_MEM32(TEACR));		
		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0));
		WRITE_MEM32(FFCR,READ_MEM32(FFCR)|EN_UNUNICAST_TOCPU);
				/* Set PVID of all port to VLAN 8. */
		for (i=0;i<3;i++)	WRITE_MEM32(( PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);
		/* Config VLAN 8 */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 0;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 0;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3f;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;
		rtl8651_setAsicVlan( &vlan );	


		
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		if ((hsa.dp&0x40)!=0x40)
		{
				rtlglue_printf ("%s %d Pakcet should be to cpu, but hsa.dp %x expect 0x40 dp = 0x40   ...",  __FUNCTION__, __LINE__,hsa.dp );
				return FAILED;
		}

	}	
	retval=SUCCESS;
	return retval;	
}
int32 testLayer2UnKnownMulticast(uint32 caseNo)
{
	int32 retval;
	hsb_t hsb =
	{
		spa: 0,			len: 64,
		vid: 0x08,		tagif: 0,
		pppoeif: 0,		sip: 0x11223344,
		sprt: 0x5566,		dip: 0x778899aa,
		dprt: 0xbbcc,		ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: 0,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x01,		da1: 0xff,
		da2: 0xff,		da3: 0xff,
		da4: 0xff,		da5: 0xff,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 0,
		udpnocs: 0,		ttlst: 2,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0
	};
	hsa_t hsa;
	int i;
	_rtl8651_tblDrvAclRule_t rule;	
	rtl865x_tblAsicDrv_vlanParam_t vlan;

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);	
		WRITE_MEM32( TEACR,READ_MEM32(TEACR));		
		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0));
		WRITE_MEM32(FFCR,READ_MEM32(FFCR)|EN_UNMCAST_TOCPU);
				/* Set PVID of all port to VLAN 8. */
		for (i=0;i<3;i++)	WRITE_MEM32(( PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);
		/* Config VLAN 8 */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 0;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 0;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3f;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;
		rtl8651_setAsicVlan( &vlan );	


		
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );			
		IS_EQUAL_INT("Pakcet should be to cpu, but ...", hsa.dp,0x7e, __FUNCTION__, __LINE__ );

	}	
	retval=SUCCESS;
	
	return retval;
}
int32 testLayer28021XPortBase(uint32 caseNo)
{
	int32 retval;

	hsb_t hsb =
	{
		spa: 0,			len: 64,
		vid: 0x08,		tagif: 0,
		pppoeif: 0,		sip: 0x11223344,
		sprt: 0x5566,		dip: 0x778899aa,
		dprt: 0xbbcc,		ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: 0,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x01,		da1: 0xff,
		da2: 0xff,		da3: 0xff,
		da4: 0xff,		da5: 0xff,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 0,
		udpnocs: 0,		ttlst: 2,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0
	};
	hsa_t hsa;
	int i;
	_rtl8651_tblDrvAclRule_t rule;	
	rtl865x_tblAsicDrv_vlanParam_t vlan;

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		rtl8651_clearAsicAllTable();
		/* Enable ingress filtering. */
		WRITE_MEM32( VCR, EN_VLAN_INGRESS_FILTER);	
		WRITE_MEM32( TEACR,READ_MEM32(TEACR));		
		WRITE_MEM32(SWTCR0,READ_MEM32(SWTCR0));
		WRITE_MEM32(FFCR,READ_MEM32(FFCR)&(~EN_UNMCAST_TOCPU));
				/* Set PVID of all port to VLAN 8. */
		WRITE_MEM32(DOT1XPORTCR,0x1);
		for (i=0;i<3;i++)	WRITE_MEM32(( PVCR0+i*4), ((0x8<<0)|(0x8<<16)) );
		/* Set permit rule. */
		bzero(&rule, sizeof(_rtl8651_tblDrvAclRule_t));
		rule.actionType_ = RTL8651_ACL_PERMIT;
		rule.pktOpApp = RTL8651_ACLTBL_ONLY_L2;
		rule.ruleType_ = RTL8651_ACL_MAC;
		rtl8651_setAsicAclRule( 0, &rule);
		/* Config VLAN 8 */
		bzero(&vlan, sizeof(vlan));
		vlan.vid = 8;
		vlan.valid = 1;
		vlan.broadcastToCpu = FALSE;
		vlan.DMZFlag = 0;
		vlan.enableRoute = FALSE;
		vlan.inAclEnd = 0;
		vlan.inAclStart = 0;
		vlan.outAclEnd = 0;
		vlan.outAclStart = 0;
		vlan.internal = 1;
		memset( &vlan.macAddr, 0xa5, sizeof(vlan.macAddr) );
		vlan.macAddrNumber = 1;
		vlan.memberPortMask = 0x3f;
		vlan.mtu = 1500;
		vlan.portState[0] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[1] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[2] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[3] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[4] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[5] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[6] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[7] = RTL8651_PORTSTA_FORWARDING;
		vlan.portState[8] = RTL8651_PORTSTA_FORWARDING;
		vlan.promiscuous = 0;
		vlan.untagPortMask = 0;
		rtl8651_setAsicVlan( &vlan );			
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );	
		if (hsa.dp&0x3f) 
		{
			rtlglue_printf("line %d Packet should be drop , but forward to portmask %x\n", __LINE__,hsa.dp);			
			return FAILED;
		}
		WRITE_MEM32(DOT1XPORTCR,0x3);
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );	
		if ((hsa.dp&0x3f)==0) 
		{
			rtlglue_printf("Packet should be forward , but drop %x\n", hsa.dp);			
			return FAILED;
		}
	}		
	retval=SUCCESS;
	return retval;
}
