/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Source File for Layer3/4 Model Code
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: l34Model.c,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#include <rtl_glue.h>
#include "assert.h"
#include "hsModel.h"
#include "asicRegs.h"
#include "icModel.h"
#include "l2Model.h"
#include "l34Model.h"
#include "modelTrace.h"
#include "rtl865xC_tblAsicDrv.h"
#include "rtl8651_tblDrvLocal.h"

#define RTL8651_TBLDRV_LOCAL_H
#include "rtl8651_aclLocal.h"
const int8 str[][12] = { "PPPoE", "L2", "ARP", "Invalid ", "CPU", "NxtHop", "DROP", " Invalid" };
static rtl865xc_tblAsic_l3RouteTable_t asic_l3[RTL8651_ROUTINGTBL_SIZE];			
static rtl8651_tblAsic_extIpTable_t asic_ipt[RTL8651_IPTABLE_SIZE];
static rtl8651_tblAsic_srvPortTable_t   asic_serverp[RTL8651_SERVERPORTTBL_SIZE];
static uint16 routingSipIdx,routingDipIdx;
/*
@func enum MODEL_RETURN_VALUE | modelAlgCheck	| model code for Alg Check
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue enum MODEL_RETURN_VALUE |
@comm 
*/
enum MODEL_RETURN_VALUE modelAlgCheck( hsb_t* hsb, hsa_t* hsa,int LanToWan )
{
	rtl865x_tblAsicDrv_algParam_t AlgEntry;
	uint16 algport,dport,sport,type;
	int i;
	for (i=0;i<RTL865XC_ALGTBL_SIZE;i++)
	{
		if (rtl8651_getAsicAlg(i, &AlgEntry)!=SUCCESS)
			continue;
		algport = AlgEntry.port;
		dport=hsb->dprt;
		sport=hsb->sprt;
		type=hsb->type;
		if ((algport != dport) && (algport!=sport))
			continue;		
		if (AlgEntry.direction==ALG_DIRECTION_BOTH)
		{
			if ( (type==HSB_TYPE_TCP) && (AlgEntry.protocol==ALG_PROTOCOL_TCP1||AlgEntry.protocol==ALG_PROTOCOL_TCP2||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
			{
				if ((algport==dport)  || (algport==sport)) 
					return MRET_TOCPU;
			}
			if ( (type==HSB_TYPE_UDP) && (AlgEntry.protocol==ALG_PROTOCOL_UDP||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
			{
					if ((algport==dport)  || (algport==sport)) 
					return MRET_TOCPU;
			}
		}
		if (LanToWan)
		{
			if (AlgEntry.direction==ALG_DIRECTION_LANTOWAN)
			{
				if ( (type==HSB_TYPE_TCP) && (AlgEntry.protocol==ALG_PROTOCOL_TCP1||AlgEntry.protocol==ALG_PROTOCOL_TCP2||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (dport==algport)
						return MRET_TOCPU;
				}
				if ( (type==HSB_TYPE_UDP) && (AlgEntry.protocol==ALG_PROTOCOL_UDP ||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (dport==algport) 
						return MRET_TOCPU;
				}
				

			}
			if (AlgEntry.direction==ALG_DIRECTION_WANTOLAN)		
			{
				if ( (type==HSB_TYPE_TCP) && (AlgEntry.protocol==ALG_PROTOCOL_TCP1||AlgEntry.protocol==ALG_PROTOCOL_TCP2||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (sport==algport) 
						return MRET_TOCPU;
				}
				if ( (type==HSB_TYPE_UDP) && (AlgEntry.protocol==ALG_PROTOCOL_UDP||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (sport==algport) 
						return MRET_TOCPU;
				}
			}
		}
		else
		{
			if (AlgEntry.direction==ALG_DIRECTION_LANTOWAN)
			{
				if ( (type==HSB_TYPE_TCP) && (AlgEntry.protocol==ALG_PROTOCOL_TCP1||AlgEntry.protocol==ALG_PROTOCOL_TCP2||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (sport==algport) 
						return MRET_TOCPU;
				}
				if ( (type==HSB_TYPE_UDP) && (AlgEntry.protocol==ALG_PROTOCOL_UDP||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (sport==algport) 
						return MRET_TOCPU;
				}

			}
			if (AlgEntry.direction==ALG_DIRECTION_WANTOLAN)		
			{
				if ( (type==HSB_TYPE_TCP) && (AlgEntry.protocol==ALG_PROTOCOL_TCP1||AlgEntry.protocol==ALG_PROTOCOL_TCP2||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (dport==algport) 
						return MRET_TOCPU;
				}
				if ( (type==HSB_TYPE_UDP) && (AlgEntry.protocol==ALG_PROTOCOL_UDP||AlgEntry.protocol==ALG_PROTOCOL_BOTH))
				{
					if (dport==algport) 
						return MRET_TOCPU;
				}
			}
		
		}

	}
	return MRET_OK;
}

/*
@func uint8 | modelIPRouting	| IP routing
@parm uint32  | ipaddr | ip address for routing
@rvalue uint8 |
@comm 
*/

uint8 modelIPRouting(uint32 ipaddr)
{

	uint32 mask;
	uint8 index,maxIndx,i; 
	for (index=0,maxIndx=RTL8651_ROUTINGTBL_SIZE-1; index < RTL8651_ROUTINGTBL_SIZE;index++)			
	{
		if(asic_l3[index].linkTo.ARPEntry.valid == 0)
			continue;

		for(i=0, mask = 0; i<=asic_l3[index].linkTo.ARPEntry.IPMask; i++)
		{
			mask |= 1<<(31-i);
			if (index==RTL8651_ROUTINGTBL_SIZE-1) mask=0;
				if( (ipaddr & mask ) == (asic_l3[index].IPAddr & mask))
				{				
					if (mask > asic_l3[maxIndx].linkTo.ARPEntry.IPMask)
						maxIndx=index;
				}
			
		}	

	}
	
	return maxIndx;
}	

/*
@func uint8 | modelDIPmatchNATIP	| IP whether Local Public
@@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue uint32 | 1 : true 0:false
@comm 
*/
uint32  modelDIPmatchNAPTIP(hsb_t* hsb, hsa_t* hsa)
{	
	uint16 i; 
	uint32 ipaddr=hsb->dip;
	for (i =0;i< RTL8651_IPTABLE_SIZE;i++)			
	{
		if (asic_ipt[i].valid==0)
			continue;		
		if ( (asic_ipt[i].externalIP==ipaddr) &&  (asic_ipt[i].isLocalPublic==0 )&&(asic_ipt[i].isOne2One==0))
		{
			return 1;	
		}
	}
	return 0;
}	


/*
@func uint8 | modelDIPmatchLP	| IP whether Local Public
@@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue uint32 | 1 : true 0:false
@comm 
*/
uint32  modelDIPmatchLP(hsb_t* hsb, hsa_t* hsa)
{	
	uint16 i; 
	uint32 ipaddr=hsb->dip;
	for (i =0;i< RTL8651_IPTABLE_SIZE;i++)			
	{
		if (asic_ipt[i].valid==0)
			continue;		
		if ( (asic_ipt[i].externalIP==ipaddr) &&  asic_ipt[i].isLocalPublic)
		{
			hsa->trip=asic_ipt[i].externalIP;	
			hsa->port=hsb->dprt;
			return 1;	
		}
	}
	return 0;
}	

/*
@func uint8 | modelSIPmatchLP	| IP whether Local Public
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)

@rvalue uint32 | 1 : true 0:false
@comm 
*/
uint32  modelSIPmatchLP(hsb_t* hsb, hsa_t* hsa)
{	
	uint16 i; 
	uint32 ipaddr=hsb->sip;
	for (i =0;i< RTL8651_IPTABLE_SIZE;i++)			
	{
		if (asic_ipt[i].valid==0)
			continue;		
		if ((asic_ipt[i].internalIP==ipaddr) &&  asic_ipt[i].isLocalPublic)
		{
			hsa->trip=asic_ipt[i].externalIP;	
			hsa->port=hsb->dprt;
			return 1;	
		}
	}
	return 0;
}	

/*
@func enum MODEL_RETURN_VALUE | modelLayer3Switching	| model code for L3 switching
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue enum MODEL_RETURN_VALUE |
@comm 
*/

enum MODEL_RETURN_VALUE modelLayer3Switching( hsb_t* hsb, hsa_t* hsa )
{		
	uint16 i;
	uint16 arpIndex;
	rtl865xc_tblAsic_l2Table_t   asic_l2;
	rtl8651_tblAsic_arpTable_t  asic_arp;
       rtl865xc_tblAsic_nextHopTable_t  asic_nexthop;
	rtl865x_tblAsicDrv_vlanParam_t  *netif;	   
	uint8 SIPInternal,DIPInternal,fid;
	int nhStart;
	rtl865xc_tblAsic_l3RouteTable_t *l3_entry;
	rtl865x_tblAsicDrv_vlanParam_t  vlan;
	uint32 retval;
	
	netif=0;
	if (modelMatchGatewayMAC()!=MMATCH) 
	{	
		MT_DROP("DA is not  MAC of  GateWay!!!!")
		return MRET_OK;
	}
	hsa->l2tr=1;	
	if (READ_MEM32(ALECR) &(EN_TTL1))
	{
		hsa->ttl_1if = hsa->dp;		
		hsa->l34tr=1;
	}	

	for (i=0; i < RTL8651_ROUTINGTBL_SIZE;i++)		
		_rtl8651_readAsicEntry(TYPE_L3_ROUTING_TABLE, i, &asic_l3[i]);
	asic_l3[i].linkTo.ARPEntry.IPMask = 0;/* default routing*/
	
	for (i=0; i < RTL8651_IPTABLE_SIZE;i++)		
		_rtl8651_readAsicEntry(TYPE_EXT_INT_IP_TABLE, i, &asic_ipt[i]);

	/* source route*/		
	routingSipIdx=modelIPRouting(hsb->sip);
	l3_entry=&asic_l3[routingSipIdx]; 
	SIPInternal=l3_entry->linkTo.ARPEntry.internal;
	/* destination route*/
	routingDipIdx=modelIPRouting(hsb->dip);
	l3_entry=&asic_l3[routingDipIdx]; 
	DIPInternal=l3_entry->linkTo.ARPEntry.internal; 
	
	if  (modelDIPmatchLP(hsb,hsa))
		goto layer3_routing;
	if (modelSIPmatchLP(hsb,hsa))
		goto layer3_routing;


	for (i=0;i<RTL8651_SERVERPORTTBL_SIZE;i++)
		_rtl8651_readAsicEntry(TYPE_SERVER_PORT_TABLE, i, &asic_serverp[i]);		
	
	if ((SIPInternal ^DIPInternal))		
	{

		if (modelAlgCheck(hsb,hsa,SIPInternal)==MRET_TOCPU)
		{
			hsa->dp=1<<(6);
			return MRET_TOCPU;
		}
		
	}	
	if ( SIPInternal && (retval=modelMatchInternalServerPort(hsb,hsa)  ) ) 
	{
		if (retval==MACT_TOCPU)
			return MRET_TOCPU;			
		if (retval==MACT_L3ROUTING)
			goto layer3_routing;

	}				

	if ((SIPInternal==0) && (modelMatchExternalServerPort(hsb,hsa)))
	{
		routingDipIdx=modelIPRouting(hsa->trip);
		goto layer3_routing;
	}
	
	if (SIPInternal )
	{
		if (DIPInternal)
			goto layer3_routing;
		retval = modelLayer4Switching( hsb, hsa, 1);
		if (retval==MACT_L3ROUTING)
		{
			routingDipIdx=modelIPRouting(hsa->trip);
			goto layer3_routing;
		}
			
	}
	else
	{
		retval=modelLayer4Switching( hsb, hsa, 0);
		if (retval==MACT_L3ROUTING)
		{
			goto layer3_routing;
		}
		
	}
	if (modelDIPmatchNAPTIP(hsb,hsa))
	{						
			modelCPUport( hsb, hsa);
			return MACT_TOCPU;/* port bouncing*/
	}
	l3_entry=&asic_l3[routingDipIdx]; 	

layer3_routing:	
	modelGetNetIf(&netif);/* Get netif  and   change pointer for Egress ACL... .*/
	switch(l3_entry->linkTo.ARPEntry.process)
	{
		case 0:/*PPPoE*/
			break;
		case 1:/*Direct*/
			break;
		case 2:/*Indirect*/
			rtl865xc_getAsicNetInterface(l3_entry->linkTo.ARPEntry.netif,&vlan);		
			if (vlan.mtu<hsb->len)
			{						
				modelCPUport( hsb, hsa);
				return MACT_TOCPU;/* packet length exceed MTU*/
			}			
				
		    	hsa->dvidx = vlan.vid;	
			memcpy((void*)netif,(void*)&vlan,sizeof(*netif));			
			arpIndex = (hsb->dip &0xff) + l3_entry->linkTo.ARPEntry.ARPStart*8;
			_rtl8651_readAsicEntry(TYPE_ARP_TABLE, arpIndex, &asic_arp);						
			if (asic_arp.valid) 
			{
				_rtl8651_readAsicEntry(TYPE_L2_SWITCH_TABLE,asic_arp.nextHop, &asic_l2);							
				hsa->nhmac0=asic_l2.mac47_40;
				hsa->nhmac1=asic_l2.mac39_24>>8;
				hsa->nhmac2=asic_l2.mac39_24&0xff;
				hsa->nhmac3=asic_l2.mac23_8>>8;
				hsa->nhmac4=asic_l2.mac23_8&0xff;
				fid =asic_l2.fid;
				hsa->nhmac5=hsa->nhmac4 ^hsa->nhmac3^hsa->nhmac2^hsa->nhmac1^hsa->nhmac0 ^ (asic_arp.nextHop>>2) ^fid;				
				hsa->dp=asic_l2.memberPort;
				hsa->dpext=asic_l2.extMemberPort;
			}				
			else	
			{
					return MRET_TOCPU;
			}				
			break;
		case 4: /* CPU */
			return MRET_TOCPU;
		case 6: /* Drop */	
			return MRET_DROP;
		case 5:/* NextHop*/
			nhStart = (l3_entry->linkTo.NxtHopEntry.nhStart) << 1;
	     		if(nhStart>=RTL8651_NEXTHOPTBL_SIZE)
		       	return MRET_TOCPU;				
		    	_rtl8651_readAsicEntry(TYPE_NEXT_HOP_TABLE, nhStart,&asic_nexthop);
		    	_rtl8651_readAsicEntry(TYPE_L2_SWITCH_TABLE,asic_nexthop.nextHop, &asic_l2);			
			rtl865xc_getAsicNetInterface(asic_nexthop.dstnetif,&vlan);		
		    	hsa->dvidx = vlan.vid;	
			if (vlan.mtu<hsb->len)
			{						
				modelCPUport( hsb, hsa);
				return MACT_TOCPU;/* packet exceed MTU*/
			}
			memcpy((void*)netif,(void*)&vlan,sizeof(*netif));			
			hsa->nhmac0=asic_l2.mac47_40;
			hsa->nhmac1=asic_l2.mac39_24>>8;
			hsa->nhmac2=asic_l2.mac39_24&0xff;
			hsa->nhmac3=asic_l2.mac23_8>>8;
			hsa->nhmac4=asic_l2.mac23_8&0xff;
			fid = asic_l2.fid;			
			hsa->nhmac5=hsa->nhmac4^hsa->nhmac3^hsa->nhmac2^hsa->nhmac1 ^hsa->nhmac0 ^ (asic_nexthop.nextHop>>2) ^fid;		
			hsa->dp=asic_l2.memberPort;
			hsa->dpext=asic_l2.extMemberPort;
			break;
		default:
			return MRET_TOCPU;				
	}	
	return MRET_OK;
}

/*
@func
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue int32 |	 
@comm 
*/
enum MODEL_ACTION_VALUE modelMatchExternalServerPort( hsb_t* hsb, hsa_t* hsa)
{
	uint16 i,port;
	uint32 ip;
	rtl8651_tblAsic_srvPortTable_t   *entry;

	port = hsb->dprt;
	ip = hsb->dip;

	for (i=0;i<RTL8651_SERVERPORTTBL_SIZE;i++)
	{	
		entry = &asic_serverp[i];
		if(entry->valid == 0)
			continue;

		if ((port==entry->externalPort)&& (ip==entry->externalIP))
		{
			hsa->trip=entry->internalIP;
			hsa->port=entry->internalPort;
			return MACT_L3ROUTING;
		}		
			
	}
	return MACT_FORWARD;
}

/*
@func
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue int32 |	 
@comm 
*/

enum MODEL_ACTION_VALUE modelMatchInternalServerPort( hsb_t* hsb, hsa_t* hsa)
{
	uint16 i,port;
	uint32 ip;
	rtl8651_tblAsic_srvPortTable_t   *entry;

	port = hsb->sprt;
	ip = hsb->sip;

	for (i=0;i<RTL8651_SERVERPORTTBL_SIZE;i++)
	{	
		entry = &asic_serverp[i];
		if(entry->valid == 0)
			continue;
		if ((port==entry->internalPort)&& (ip==entry->internalIP))
		{
			if (hsb->dip==entry->externalIP && hsb->dprt==entry->externalPort)
			{
				modelCPUport( hsb, hsa);
				return MACT_TOCPU;//* port bouncing*/
			}
			if (modelDIPmatchNAPTIP(hsb,hsa))
			{						
				modelCPUport( hsb, hsa);
				return MACT_TOCPU;//* port bouncing*/
			}				
			hsa->trip=entry->externalIP;
			hsa->port=entry->externalPort;
			return MACT_L3ROUTING;
		}
	}
	return MACT_FORWARD;

}
/*
@func
@parm hsb_t* | hsb | Header Stamp of Before (for input)
@parm hsa_t* | hsa | Header Stamp of After (for output)
@rvalue int32 |	 
@comm 
*/
enum MODEL_ACTION_VALUE modelLayer4Switching( hsb_t* hsb, hsa_t* hsa,uint8 LanToWan)
{

	if (LanToWan)
	{
			/**** To Do....*/
	}
	else
	{
	
	
			/**** To Do....*/
	}
	return MRET_OK;
}

