
#include <rtl_types.h>
#include <rtl_glue.h>
#if defined(RTL865X_TEST)||defined(RTL865X_MODEL_USER)
#define  CONFIG_RTL865XB
#include "utility.h"
#include <cle_userglue.h>
#else
#include "utility.h"
#endif
#include <cle_struct.h>
#include "pktGen.h"
#include "asicRegs.h"
#include "icTest.h"
#include "hsModel.h"
#ifdef CONFIG_RTL865XC
#include "rtl865xC_tblAsicDrv.h"
#else
#include "rtl8651_tblAsicDrv.h"
#endif
#define RTL8651_TBLDRV_LOCAL_H
#include "rtl8651_aclLocal.h"
#include "rtl8651_layer2local.h"
#include "drvTest.h"
#include "fwdTest.h"
#include "rtl8651_tblDrvFwd.h"
#include "virtualMac.h"

#define WAN0_VID 8
#define GW_WAN0_MAC "00-00-00-00-88-88"
#define WAN1_VID 9
#define GW_WAN1_MAC "00-00-00-00-88-89"
#define GW_WAN1_SUBNET_MASK "255.255.255.248"
#define LAN0_VID 10
#define GW_LAN0_MAC "00-00-00-00-88-8a"
#define GW_LAN0_IP "192.168.2.1"
#define GW_LAN0_SUBNET_MASK "255.255.255.248"
#define LAN1_VID 11
#define GW_LAN1_MAC "00-00-00-00-88-8b"
#define GW_LAN1_IP "192.168.1.1"
#define GW_LAN1_SUBNET_MASK "255.255.255.248"
/* isp 0 */
#define WAN0_ISP_MAC "00-00-00-00-99-9c"
#define WAN0_ISP_PPPOE_SID 0x55
#define WAN0_ISP_PUBLIC_IP "192.168.4.1"
#define WAN3_ISP_PUBLIC_IP "192.168.4.3"
/* isp 1 */
#define WAN1_ISP_PUBLIC_IP "192.168.3.1"
#define GW_WAN1_IP "192.168.3.1"
#define GW_WAN1_SUBNET_MASK "255.255.255.248"

/* wan 0 hosts */
#define HOST5_MAC "00-00-00-00-00-10"
#define HOST5_IP "192.168.4.5"
/* wan 1 hosts */
#define HOST4_MAC "00-00-00-00-00-20"
#define HOST4_IP "192.168.3.2"
/* lan 0 hosts */
#define HOST3_MAC "00-00-00-00-00-30"
#define HOST3_IP "192.168.2.2"
/* lan 1 hosts */
#define HOST1_MAC "00-00-00-00-00-40"
#define HOST1_IP "192.168.1.2"
#define HOST2_MAC "00-00-00-00-00-50"
#define HOST2_IP "192.168.1.3"
#define HOST6_MAC "00-00-00-00-00-60"
#define HOST6_IP "192.168.1.4"

void strtomac(ether_addr_t *mac, uint8 *str)
{
    int32 t1, t2, t3, t4, t5, t6;
    sscanf(str, "%x-%x-%x-%x-%x-%x", &t1, &t2, &t3, &t4, &t5, &t6);
    mac->octet[0]=t1; mac->octet[1]=t2; mac->octet[2]=t3; mac->octet[3]=t4; mac->octet[4]=t5; mac->octet[5]=t6;
}

void strtoip(ipaddr_t *ip, uint8 *str)
{
    int32 t1, t2, t3, t4;
    sscanf(str, "%d.%d.%d.%d", &t1, &t2, &t3, &t4);
    *ip = (t1<<24)|(t2<<16)|(t3<<8)|t4;
}

uint32 getL2TableRowFromMacStr(uint8 *str)
{
    int32 t1, t2, t3, t4, t5, t6;
    ether_addr_t mac;
    sscanf(str, "%x-%x-%x-%x-%x-%x", &t1, &t2, &t3, &t4, &t5, &t6);
    mac.octet[0]=t1; mac.octet[1]=t2; mac.octet[2]=t3; mac.octet[3]=t4; mac.octet[4]=t5; mac.octet[5]=t6;
    return rtl8651_filterDbIndex(&mac);
}
int32   rtl865xc_netIfIndex(int vid)  
{
	uint16 i;
	rtl865xc_tblAsic_netifTable_t	 netif;
	for (i=0;i<RTL865XC_NETINTERFACE_NUMBER;i++)
	{
		_rtl8651_readAsicEntry(TYPE_NETINTERFACE_TABLE, i, &netif);
		if (netif.vid==vid)
			return i;
	}
	rtlglue_printf("error not  foud network interface..... %s %d\n",__FILE__,__LINE__);
	return RTL865XC_NETINTERFACE_NUMBER;
}
uint8 port_number_of_host[3][MAX_PORT_NUMBER] = {{0,1,2,3,4,5},{4,3,2,1,0,5},{1,0,3,2,4,5}};
static uint8 *hp;


int32  layer3Config( void )
{
	rtl865x_tblAsicDrv_vlanParam_t vlant;
	_rtl8651_tblDrvAclRule_t aclt;
	rtl865x_tblAsicDrv_l2Param_t l2t;
	rtl865x_tblAsicDrv_pppoeParam_t pppoet;
	rtl865x_tblAsicDrv_arpParam_t arpt;
	rtl865x_tblAsicDrv_routingParam_t routet;
	rtl865x_tblAsicDrv_nextHopParam_t nxthpt;
	ipaddr_t ip32;
	uint32 i;
	hp = port_number_of_host[0];
	rtl8651_clearAsicAllTable();
	rtl8651_clearAsicPvid();
	rtl8651_setAsicPvid(hp[5],8);  /*host 5 pvid 0*/
	rtl8651_setAsicPvid(hp[4],9);   /*host 4 pvid 1*/
	rtl8651_setAsicPvid(hp[3],10);  /*host 3 pvid 2*/
	rtl8651_setAsicPvid(hp[2],11);  /*host 2 pvid 3*/
	rtl8651_setAsicPvid(hp[1],11);  /*host 1 pvid 3*/
	rtl8651_setAsicPvid(hp[6],11);  /*host 6 pvid 3*/
	/* module switch control reg: enable L2/L3/L4/STP, trap 802.1D/GARP to CPU */
	rtl8651_setAsicOperationLayer(3);
	/* TTL control reg: enable TTL-1 operation */
	WRITE_MEM32(ALECR,READ_MEM32(ALECR)|(uint32)EN_TTL1);	
	/* VLAN tagging control reg: accept untagged */
	WRITE_MEM32(VLANTCR, 0);
	/* l4 table aging control reg */
	WRITE_MEM32(TEATCR, 0xffffffff);
	/* l4 table offset control reg: start = 20, end = 20 */
	WRITE_MEM32(OCR, (20<<OCR_START_OFFSET)|(20<<OCR_END_OFFSET));
	/* switch table misc control reg: enable napt auto learn/delete, enable VLAN ingress filtering, 
	trap non-TCP/UDP/ICMP NAPT packets to CPU, enable multicast table, accept broadcast packets, 
	enable PPPoE auto-encapsulation and auto-decapsulation */
	WRITE_MEM32(SWTMCR, 0x7600001e);
	/* gidx mapping control */
	WRITE_MEM32(GIDXMCR, 0);
	/* disable 50b mode */
	WRITE_MEM32(SWTECR, 0);

	 /* config vlan table */
	 bzero((void*) &vlant, sizeof(vlant));
	 bzero((void*) &aclt, sizeof(aclt));
	/* wan 0 */
	strtomac(&vlant.macAddr, GW_WAN0_MAC);
	vlant.memberPortMask = vlant.untagPortMask = (1<<hp[5]);
	vlant.macAddrNumber = 1;
	vlant.vid = WAN0_VID;
	for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum;i++)
		vlant.portState[i] = RTL8651_PORTSTA_FORWARDING;
	vlant.mtu = 1500;
	vlant.inAclStart = 0;
	vlant.inAclEnd = 0;
	vlant.outAclStart = vlant.outAclEnd = 0;
	vlant.internal = 1;
	vlant.enableRoute = 1;
	vlant.valid = 1;
	rtl8651_setAsicVlan(&vlant);
	 /* ingress filter gateway mac */
	 memset((void*)&aclt, 0, sizeof(aclt));
	aclt.ruleType_ = RTL8651_ACL_MAC;
	aclt.actionType_ = RTL8651_ACL_PERMIT;
	rtl8651_setAsicAclRule(0, &aclt);
	 /* wan 1 */
	strtomac(&vlant.macAddr, GW_WAN1_MAC);
	vlant.memberPortMask = vlant.untagPortMask = (1<<hp[4]);
	vlant.vid = WAN1_VID;
    	vlant.inAclStart = 0;
    	vlant.inAclEnd = 0;
    	vlant.outAclStart = vlant.outAclEnd = 0;
    	vlant.internal = 1;
	rtl8651_setAsicVlan(&vlant);
	/* ingress filter gateway mac */
	aclt.ruleType_ = RTL8651_ACL_MAC;
	memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
	aclt.actionType_ = RTL8651_ACL_CPU;
	rtl8651_setAsicAclRule(4, &aclt);
	/* lan 0 */
	strtomac(&vlant.macAddr, GW_LAN0_MAC);
	vlant.memberPortMask = (1<<hp[3]);
	vlant.untagPortMask = 0; //tagged
	vlant.vid = LAN0_VID;
	vlant.inAclStart = 0;
	vlant.inAclEnd = 0;
	vlant.outAclStart = vlant.outAclEnd = 0;
	vlant.internal = 1;
	rtl8651_setAsicVlan(&vlant);
	/* ingress filter gateway mac */
	aclt.ruleType_ = RTL8651_ACL_MAC;
	memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
	aclt.actionType_ = RTL8651_ACL_CPU;
	rtl8651_setAsicAclRule(8, &aclt);
	/* lan 1 */
	strtomac(&vlant.macAddr, GW_LAN1_MAC);
	vlant.memberPortMask = vlant.untagPortMask = (1<<hp[2])|(1<<hp[1])|(1<<hp[6]);
	vlant.vid = LAN1_VID;
	vlant.inAclStart = 0;
	vlant.inAclEnd = 0;
	vlant.outAclStart = vlant.outAclEnd = 0;
	vlant.internal = 1;
	rtl8651_setAsicVlan(&vlant);
	 /* ingress filter gateway mac */
	aclt.ruleType_ = RTL8651_ACL_MAC;
	memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
	aclt.actionType_ = RTL8651_ACL_CPU;
	rtl8651_setAsicAclRule(12, &aclt);    
	/* config l2 table */
	bzero((void*) &l2t, sizeof(l2t));
	/* wan 0 isp modem */
	strtomac(&l2t.macAddr, WAN0_ISP_MAC);
	l2t.memberPortMask = (1<<hp[5]);
	l2t.isStatic = 1;
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(WAN0_ISP_MAC), 0, &l2t);
	/* wan 1 host */
	strtomac(&l2t.macAddr, HOST4_MAC);
	l2t.memberPortMask = (1<<hp[4]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST4_MAC), 0, &l2t);
	/* lan 0 host */
	strtomac(&l2t.macAddr, HOST3_MAC);
	l2t.memberPortMask = (1<<hp[3]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST3_MAC), 0, &l2t);
	/* lan 1 host 1 */
	strtomac(&l2t.macAddr, HOST2_MAC);
	l2t.memberPortMask = (1<<hp[2]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST2_MAC), 0, &l2t);
	/* lan 1 host 0 */
	strtomac(&l2t.macAddr, HOST1_MAC);
	l2t.memberPortMask = (1<<hp[1]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST1_MAC), 0, &l2t);
	/* lan 1 host 5 */
	strtomac(&l2t.macAddr, HOST6_MAC);
	l2t.memberPortMask = (1<<hp[6]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST6_MAC), 0, &l2t);
	    
	/* config pppoe table */
	bzero((void*) &pppoet, sizeof(pppoet));
	pppoet.sessionId = WAN0_ISP_PPPOE_SID;
	rtl8651_setAsicPppoe(0, &pppoet);
	/* config arp table */
	bzero((void*) &arpt, sizeof(arpt));
	/* wan 1 host */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST4_MAC);
	strtoip(&ip32, HOST4_IP);
	rtl8651_setAsicArp(ip32 & 0x7, &arpt);
	/* lan 0 host */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST3_MAC);
	strtoip(&ip32, HOST3_IP);
	rtl8651_setAsicArp(8 + (ip32 & 0x7), &arpt);
    
	/* lan 1 host 1 */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST2_MAC);
	strtoip(&ip32, HOST2_IP);
	rtl8651_setAsicArp(16 + (ip32 & 0xff), &arpt);	
	rtl8651_setAsicArp(ip32 & 0xff, &arpt);
	/* lan 1 host 0 */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST1_MAC);
	strtoip(&ip32, HOST1_IP);
	rtl8651_setAsicArp(16 + (ip32 & 0xff), &arpt);
	 /* lan 1 host 5 */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST6_MAC);
	strtoip(&ip32, HOST6_IP);
	rtl8651_setAsicArp(16 + (ip32 & 0xff), &arpt);
	/* config routing table */
	bzero((void*) &routet, sizeof(routet));
	/* route to wan 1: use arp table [0:7] */
	strtoip(&routet.ipAddr, GW_WAN1_IP);
	strtoip(&routet.ipMask, GW_WAN1_SUBNET_MASK);
	routet.process = PROCESS_INDIRECT;
	routet.vidx = rtl865xc_netIfIndex(WAN1_VID);
	routet.arpStart = 0;
	routet.arpEnd = 0;
	routet.internal=1;
 	rtl8651_setAsicRouting(0, &routet);
	
	/* route to lan 0: use arp table [8:15] */
	strtoip(&routet.ipAddr, GW_LAN0_IP);
	strtoip(&routet.ipMask, GW_LAN0_SUBNET_MASK);
	routet.process = PROCESS_INDIRECT;
	routet.vidx = rtl865xc_netIfIndex(LAN0_VID);
	routet.arpStart = 1;
	routet.arpEnd = 1;
	routet.internal=1;
	rtl8651_setAsicRouting(1, &routet);
	 /* route to lan 1: use arp table [16:23] */
	 strtoip(&routet.ipAddr, GW_LAN1_IP);
	strtoip(&routet.ipMask, GW_LAN1_SUBNET_MASK);
	routet.process = PROCESS_INDIRECT;
	routet.vidx = rtl865xc_netIfIndex(LAN1_VID);
	routet.arpStart = 2;
	routet.arpEnd = 2;
	routet.internal=1;
	rtl8651_setAsicRouting(2, &routet);
	/* default route to wan 0: direct to modem */
	 bzero((void*) &routet, sizeof(routet));
	 strtoip(&routet.ipAddr, "0.0.0.0");
	strtoip(&routet.ipMask, "0.0.0.0");
	routet.process = PROCESS_NXT_HOP;
	routet.vidx = rtl865xc_netIfIndex(WAN0_VID);
	routet.nextHopRow = getL2TableRowFromMacStr(WAN0_ISP_MAC);
	routet.nhStart = 4;
	routet.nhNum = 2; //index 4~5
	routet.nhNxt = 0;
	routet.nhAlgo = 2; //per-source
	routet.ipDomain = 1;
	routet.internal=1;
	rtl8651_setAsicRouting(7, &routet);
	 /* config next hop table */
	 bzero((void*) &nxthpt, sizeof(nxthpt));
	 /* wan 0: load balance traffic through isp0 & isp1 as 3:1 */
	/* isp 0 occupies 3 entries */
	nxthpt.nextHopRow = getL2TableRowFromMacStr(WAN0_ISP_MAC);
	nxthpt.pppoeIdx = 0; //WAN0_ISP0_PPPOE_SID
	nxthpt.dvid = rtl865xc_netIfIndex(WAN0_VID);
	nxthpt.extIntIpIdx = 0; //WAN0_ISP0_NPE_IP
	nxthpt.isPppoe = 0;
	rtl8651_setAsicNextHopTable(4, &nxthpt);       
	return 0;
	
}
int32  layer4Config( void )
{
	
	 rtl865x_tblAsicDrv_extIntIpParam_t ipt;	
	rtl865x_tblAsicDrv_vlanParam_t vlant;
	_rtl8651_tblDrvAclRule_t aclt;
	rtl865x_tblAsicDrv_l2Param_t l2t;
	rtl865x_tblAsicDrv_pppoeParam_t pppoet;
	rtl865x_tblAsicDrv_arpParam_t arpt;
	rtl865x_tblAsicDrv_routingParam_t routet;
	rtl865x_tblAsicDrv_nextHopParam_t nxthpt;
	ipaddr_t ip32;
	uint32 i;
	hp = port_number_of_host[0];
	rtl8651_clearAsicAllTable();
	rtl8651_clearAsicPvid();
	rtl8651_setAsicPvid(hp[5],8);  /*host 5 pvid 0*/
	rtl8651_setAsicPvid(hp[4],9);   /*host 4 pvid 1*/
	rtl8651_setAsicPvid(hp[3],10);  /*host 3 pvid 2*/
	rtl8651_setAsicPvid(hp[2],11);  /*host 2 pvid 3*/
	rtl8651_setAsicPvid(hp[1],11);  /*host 1 pvid 3*/
	rtl8651_setAsicPvid(hp[6],11);  /*host 6 pvid 3*/
	/* module switch control reg: enable L2/L3/L4/STP, trap 802.1D/GARP to CPU */
	rtl8651_setAsicOperationLayer(3);
	/* TTL control reg: enable TTL-1 operation */
	WRITE_MEM32(ALECR,READ_MEM32(ALECR)|(uint32)EN_TTL1);	
	/* VLAN tagging control reg: accept untagged */
	WRITE_MEM32(VLANTCR, 0);
	/* l4 table aging control reg */
	WRITE_MEM32(TEATCR, 0xffffffff);
	/* l4 table offset control reg: start = 20, end = 20 */
	WRITE_MEM32(OCR, (20<<OCR_START_OFFSET)|(20<<OCR_END_OFFSET));
	/* switch table misc control reg: enable napt auto learn/delete, enable VLAN ingress filtering, 
	trap non-TCP/UDP/ICMP NAPT packets to CPU, enable multicast table, accept broadcast packets, 
	enable PPPoE auto-encapsulation and auto-decapsulation */
	WRITE_MEM32(SWTMCR, 0x7600001e);
	/* gidx mapping control */
	WRITE_MEM32(GIDXMCR, 0);
	/* disable 50b mode */
	WRITE_MEM32(SWTECR, 0);

	 /* config vlan table */
	 bzero((void*) &vlant, sizeof(vlant));
	 bzero((void*) &aclt, sizeof(aclt));
	/* wan 0 */
	strtomac(&vlant.macAddr, GW_WAN0_MAC);
	vlant.memberPortMask = vlant.untagPortMask = (1<<hp[5]);
	vlant.macAddrNumber = 1;
	vlant.vid = WAN0_VID;
	for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum;i++)
		vlant.portState[i] = RTL8651_PORTSTA_FORWARDING;
	vlant.mtu = 1500;
	vlant.inAclStart = 0;
	vlant.inAclEnd = 0;
	vlant.outAclStart = vlant.outAclEnd = 0;
	vlant.internal = 0;
	vlant.enableRoute = 1;
	vlant.valid = 1;
	rtl8651_setAsicVlan(&vlant);
	 /* ingress filter gateway mac */
	 memset((void*)&aclt, 0, sizeof(aclt));
	aclt.ruleType_ = RTL8651_ACL_MAC;
	aclt.actionType_ = RTL8651_ACL_PERMIT;
	rtl8651_setAsicAclRule(0, &aclt);
	 /* wan 1 */
	strtomac(&vlant.macAddr, GW_WAN1_MAC);
	vlant.memberPortMask = vlant.untagPortMask = (1<<hp[4]);
	vlant.vid = WAN1_VID;
    	vlant.inAclStart = 0;
    	vlant.inAclEnd = 0;
    	vlant.outAclStart = vlant.outAclEnd = 0;
    	vlant.internal = 0;
	rtl8651_setAsicVlan(&vlant);
	/* ingress filter gateway mac */
	aclt.ruleType_ = RTL8651_ACL_MAC;
	memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
	aclt.actionType_ = RTL8651_ACL_CPU;
	rtl8651_setAsicAclRule(4, &aclt);
	/* lan 0 */
	strtomac(&vlant.macAddr, GW_LAN0_MAC);
	vlant.memberPortMask = (1<<hp[3]);
	vlant.untagPortMask = 0; //tagged
	vlant.vid = LAN0_VID;
	vlant.inAclStart = 0;
	vlant.inAclEnd = 0;
	vlant.outAclStart = vlant.outAclEnd = 0;
	vlant.internal = 1;
	rtl8651_setAsicVlan(&vlant);
	/* ingress filter gateway mac */
	aclt.ruleType_ = RTL8651_ACL_MAC;
	memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
	aclt.actionType_ = RTL8651_ACL_CPU;
	rtl8651_setAsicAclRule(8, &aclt);
	/* lan 1 */
	strtomac(&vlant.macAddr, GW_LAN1_MAC);
	vlant.memberPortMask = vlant.untagPortMask = (1<<hp[2])|(1<<hp[1])|(1<<hp[6]);
	vlant.vid = LAN1_VID;
	vlant.inAclStart = 0;
	vlant.inAclEnd = 0;
	vlant.outAclStart = vlant.outAclEnd = 0;
	vlant.internal = 1;
	rtl8651_setAsicVlan(&vlant);
	 /* ingress filter gateway mac */
	aclt.ruleType_ = RTL8651_ACL_MAC;
	memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
	aclt.actionType_ = RTL8651_ACL_CPU;
	rtl8651_setAsicAclRule(12, &aclt);    
	/* config l2 table */
	bzero((void*) &l2t, sizeof(l2t));
	/* wan 0 isp modem */
	strtomac(&l2t.macAddr, WAN0_ISP_MAC);
	l2t.memberPortMask = (1<<hp[5]);
	l2t.isStatic = 1;
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(WAN0_ISP_MAC), 0, &l2t);
	/* wan 1 host */
	strtomac(&l2t.macAddr, HOST4_MAC);
	l2t.memberPortMask = (1<<hp[4]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST4_MAC), 0, &l2t);
	/* lan 0 host */
	strtomac(&l2t.macAddr, HOST3_MAC);
	l2t.memberPortMask = (1<<hp[3]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST3_MAC), 0, &l2t);
	/* lan 1 host 1 */
	strtomac(&l2t.macAddr, HOST2_MAC);
	l2t.memberPortMask = (1<<hp[2]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST2_MAC), 0, &l2t);
	/* lan 1 host 0 */
	strtomac(&l2t.macAddr, HOST1_MAC);
	l2t.memberPortMask = (1<<hp[1]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST1_MAC), 0, &l2t);
	/* lan 1 host 5 */
	strtomac(&l2t.macAddr, HOST6_MAC);
	l2t.memberPortMask = (1<<hp[6]);
	rtl8651_setAsicL2Table(getL2TableRowFromMacStr(HOST6_MAC), 0, &l2t);
	    
	/* config pppoe table */
	bzero((void*) &pppoet, sizeof(pppoet));
	pppoet.sessionId = WAN0_ISP_PPPOE_SID;
	rtl8651_setAsicPppoe(0, &pppoet);
	/* config arp table */
	bzero((void*) &arpt, sizeof(arpt));
	/* wan 1 host */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST4_MAC);
	strtoip(&ip32, HOST4_IP);
	rtl8651_setAsicArp(ip32 & 0x7, &arpt);
	/* lan 0 host */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST3_MAC);
	strtoip(&ip32, HOST3_IP);
	rtl8651_setAsicArp(8 + (ip32 & 0x7), &arpt);
    
	/* lan 1 host 1 */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST2_MAC);
	strtoip(&ip32, HOST2_IP);
	rtl8651_setAsicArp(16 + (ip32 & 0xff), &arpt);	
	rtl8651_setAsicArp(ip32 & 0xff, &arpt);
	/* lan 1 host 0 */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST1_MAC);
	strtoip(&ip32, HOST1_IP);
	rtl8651_setAsicArp(16 + (ip32 & 0xff), &arpt);
	 /* lan 1 host 5 */
	arpt.nextHopRow = getL2TableRowFromMacStr(HOST6_MAC);
	strtoip(&ip32, HOST6_IP);
	rtl8651_setAsicArp(16 + (ip32 & 0xff), &arpt);
	/* config routing table */
	bzero((void*) &routet, sizeof(routet));
	/* route to wan 1: use arp table [0:7] */
	strtoip(&routet.ipAddr, GW_WAN1_IP);
	strtoip(&routet.ipMask, GW_WAN1_SUBNET_MASK);
	routet.process = PROCESS_INDIRECT;
	routet.vidx = rtl865xc_netIfIndex(WAN1_VID);
	routet.arpStart = 0;
	routet.arpEnd = 0;
	routet.internal=0;
 	rtl8651_setAsicRouting(0, &routet);
	
	/* route to lan 0: use arp table [8:15] */
	strtoip(&routet.ipAddr, GW_LAN0_IP);
	strtoip(&routet.ipMask, GW_LAN0_SUBNET_MASK);
	routet.process = PROCESS_INDIRECT;
	routet.vidx = rtl865xc_netIfIndex(LAN0_VID);
	routet.arpStart = 1;
	routet.arpEnd = 1;
	routet.internal=1;
	rtl8651_setAsicRouting(1, &routet);
	 /* route to lan 1: use arp table [16:23] */
	 strtoip(&routet.ipAddr, GW_LAN1_IP);
	strtoip(&routet.ipMask, GW_LAN1_SUBNET_MASK);
	routet.process = PROCESS_INDIRECT;
	routet.vidx = rtl865xc_netIfIndex(LAN1_VID);
	routet.arpStart = 2;
	routet.arpEnd = 2;
	routet.internal=1;
	rtl8651_setAsicRouting(2, &routet);
	/* default route to wan 0: direct to modem */
	 bzero((void*) &routet, sizeof(routet));
	 strtoip(&routet.ipAddr, "0.0.0.0");
	strtoip(&routet.ipMask, "0.0.0.0");
	routet.process = PROCESS_NXT_HOP;
	routet.vidx = rtl865xc_netIfIndex(WAN0_VID);
	routet.nextHopRow = getL2TableRowFromMacStr(WAN0_ISP_MAC);
	routet.nhStart = 4;
	routet.nhNum = 2; //index 4~5
	routet.nhNxt = 0;
	routet.nhAlgo = 2; //per-source
	routet.ipDomain = 1;
	routet.internal=0;
	rtl8651_setAsicRouting(7, &routet);
	 /* config next hop table */
	 bzero((void*) &nxthpt, sizeof(nxthpt));
	 /* wan 0: load balance traffic through isp0 & isp1 as 3:1 */
	/* isp 0 occupies 3 entries */
	nxthpt.nextHopRow = getL2TableRowFromMacStr(WAN0_ISP_MAC);
	nxthpt.pppoeIdx = 0; //WAN0_ISP0_PPPOE_SID
	nxthpt.dvid = rtl865xc_netIfIndex(WAN0_VID);
	nxthpt.extIntIpIdx = 0; //WAN0_ISP0_NPE_IP
	nxthpt.isPppoe = 0;
	rtl8651_setAsicNextHopTable(4, &nxthpt);       
	
	/* config ip table */
	bzero((void*) &ipt, sizeof(ipt));
	/* wan 0 napt */
	strtoip(&ipt.intIpAddr, "0.0.0.0");
	strtoip(&ipt.extIpAddr, WAN0_ISP_PUBLIC_IP);
	rtl8651_setAsicExtIntIpTable(0, &ipt);
	/* wan 1 nat */
	strtoip(&ipt.intIpAddr, HOST1_IP);
	strtoip(&ipt.extIpAddr, WAN1_ISP_PUBLIC_IP);
	ipt.nat = 1;
	rtl8651_setAsicExtIntIpTable(1, &ipt);



	return 0;
	
}

extern int dumpAsicIP(void);
extern int dumpAsicServerP(void);
int32 testLayer3Routing(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 3,
		len: 64,
		vid: 0x0234,
		tagif: 0,
		pppoeif: 1,
		sip: ntohl(inet_addr("192.168.1.2")),
		sprt: 1020,
		dip:ntohl(inet_addr("120.168.1.3")),
		dprt: 80,
		ipptl: 0xdd,
		ipfg: 0x0,
		iptos: 0x65,
		tcpfg: 0x00,
		type: HSB_TYPE_UDP,
		patmatch: 1,
		ethtype: 0x7788,
		da0: 0x00,
		da1: 0x00,
		da2: 0x00,
		da3: 0x00,
		da4: 0x88,
		da5: 0x8a,
		sa0: 0x00,
		sa1: 0x80,
		sa2: 0xc0,
		sa3: 0x00,
		sa4: 0x00,
		sa5: 0x00,
		hiprior: 0,
		snap: 1,
		udpnocs: 0,
		ttlst: 64,
		dirtx: 0,
		l3csok: 1,
		l4csok: 1,
		ipfo0_n: 1,
		llcothr: 0,
		urlmch: 1,
		extspa: 0,
		extl2: 0,
	};
	hsa_t hsa;
	int i;

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		
			layer3Config();	
			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );
			/* Start model code */
			modelStart();
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet should be broadcast,but ....", hsa.dp,0x20, __FUNCTION__, __LINE__ );
			assert( retval == SUCCESS );
			

	}
	retval = SUCCESS;	
	return retval;
}

int32 testLayer3MTU(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 3,			len: 1323,		
		vid: 0x0234,		tagif: 0,
		pppoeif: 1,		sip: ntohl(inet_addr("192.168.1.2")),
		sprt: 1020,		dip:ntohl(inet_addr("120.168.1.3")),
		dprt: 80,			ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: HSB_TYPE_UDP,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x00,		da1: 0x00,
		da2: 0x00,		da3: 0x00,
		da4: 0x88,		da5: 0x8a,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 1,
		udpnocs: 0,		ttlst: 64,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0,
	};
	hsa_t hsa;
	int i;
	rtl865x_tblAsicDrv_vlanParam_t vlant;
	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		
			layer3Config();	
			strtomac(&vlant.macAddr, GW_WAN0_MAC);
			vlant.memberPortMask = vlant.untagPortMask = (1<<hp[5]);
			vlant.macAddrNumber = 1;
			vlant.vid = WAN0_VID;
			for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum;i++)
				vlant.portState[i] = RTL8651_PORTSTA_FORWARDING;
			vlant.mtu = 1200;
			vlant.inAclStart = 0;
			vlant.inAclEnd = 0;
			vlant.outAclStart = vlant.outAclEnd = 0;
			vlant.internal = 1;
			vlant.enableRoute = 1;
			vlant.valid = 1;
			rtl8651_setAsicVlan(&vlant);
			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );
			/* Start model code */
			modelStart();
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet should be to CPU,but ....", hsa.dp,MODEL_CPU_PORT_MASK, __FUNCTION__, __LINE__ );
			assert( retval == SUCCESS );
			

	}
	retval = SUCCESS;	
	return retval;
}

int32 testServerPort(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 3,			len: 64,
		vid: 0x0234,		tagif: 0,
		pppoeif: 1,		sip: ntohl(inet_addr("192.168.1.3")),
		sprt: 1020,		dip:ntohl(inet_addr("120.168.1.3")),
		dprt: 80,			ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: HSB_TYPE_UDP,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x00,		da1: 0x00,
		da2: 0x00,		da3: 0x00,
		da4: 0x88,		da5: 0x8a,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 1,
		udpnocs: 0,		ttlst: 64,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0, 		urlmch: 1,
		extspa: 0,		extl2: 0,
	};
	hsa_t hsa;
	int i;
	rtl865x_tblAsicDrv_serverPortParam_t	 srvt;
	

	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

	
			layer4Config();	
			/* config server port table */
			bzero((void*) &srvt, sizeof(srvt));
			/* server port 1020 translated to wan 0 isp port 20 */
			strtoip(&srvt.intIpAddr, HOST2_IP);
			strtoip(&srvt.extIpAddr, WAN0_ISP_PUBLIC_IP);
			srvt.extPort = 20;
			srvt.intPort = 1020;
			srvt.valid = 1;
			rtl8651_setAsicServerPortTable(0, &srvt);

			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );
			/* Start model code */
			modelStart();
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet should be to ....", hsa.port,20, __FUNCTION__, __LINE__ );
			assert( retval == SUCCESS );	

			hsb.dip=ntohl(inet_addr("192.168.4.1"));
			retval = virtualMacSetHsb( &hsb );
			modelStart();
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet should be to cpu ,but ....", 0x40,hsa.dp, __FUNCTION__, __LINE__ );
			assert( retval == SUCCESS );	

	}
	retval = SUCCESS;	
	return retval;
}
int32 testALG(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 3,			len: 64,
		vid: 0x0234,		tagif: 0,
		pppoeif: 1,		sip: ntohl(inet_addr("192.168.1.3")),
		sprt: 1020,		dip:ntohl(inet_addr("120.168.1.3")),
		dprt: 80,			ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: HSB_TYPE_UDP,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x00,		da1: 0x00,
		da2: 0x00,		da3: 0x00,
		da4: 0x88,		da5: 0x8a,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 1,
		udpnocs: 0,		ttlst: 64,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0,
	};
	hsa_t hsa;
	int i;
	rtl865x_tblAsicDrv_algParam_t algt;
	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

		layer4Config();	
		/* config alg table */
		bzero((void*) &algt, sizeof(algt));
		algt.port = 80; //trap http
		algt.protocol=ALG_PROTOCOL_BOTH;
		algt.direction=ALG_DIRECTION_LANTOWAN;
		rtl8651_setAsicAlg(0, &algt);
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		IS_EQUAL_INT("Pakcet should be to CPU but ....", hsa.dp,MODEL_CPU_PORT_MASK, __FUNCTION__, __LINE__ );

		bzero((void*) &algt, sizeof(algt));
		algt.port = 80; //trap http
		algt.protocol=ALG_PROTOCOL_UDP;
		algt.direction=ALG_DIRECTION_LANTOWAN;
		rtl8651_setAsicAlg(0, &algt);
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		IS_EQUAL_INT("Pakcet should be to CPU but ....", hsa.dp,MODEL_CPU_PORT_MASK, __FUNCTION__, __LINE__ );
		assert( retval == SUCCESS );	

		
		bzero((void*) &algt, sizeof(algt));
		algt.port = 80; //trap http
		algt.protocol=ALG_PROTOCOL_BOTH;
		algt.direction=ALG_DIRECTION_WANTOLAN;
		rtl8651_setAsicAlg(0, &algt);
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		IS_NOT_EQUAL_INT("Pakcet should be to forward but ....", hsa.dp,MODEL_CPU_PORT_MASK, __FUNCTION__, __LINE__ );
		assert( retval == SUCCESS );	


		bzero((void*) &algt, sizeof(algt));
		algt.port = 80; //trap http
		algt.protocol=ALG_PROTOCOL_TCP1;
		algt.direction=ALG_DIRECTION_LANTOWAN;
		rtl8651_setAsicAlg(0, &algt);
		retval = virtualMacSetHsb( &hsb );
		assert( retval == SUCCESS );
		/* Start model code */
		modelStart();
		retval = virtualMacGetHsa( &hsa );
		IS_NOT_EQUAL_INT("Pakcet should be to forward but ....", hsa.dp,MODEL_CPU_PORT_MASK, __FUNCTION__, __LINE__ );
		assert( retval == SUCCESS );	

	}
	retval = SUCCESS;	
	return retval;
}
int testLocalPublicIP(uint32 caseNo)
{
	int32 retval = SUCCESS;
	hsb_t hsb =
	{
		spa: 3,			len: 64,
		vid: 0x0234,		tagif: 0,
		pppoeif: 0,		sip: ntohl(inet_addr(WAN3_ISP_PUBLIC_IP)),
		sprt: 1020,		dip:ntohl(inet_addr("120.168.1.3")),
		dprt: 80,			ipptl: 0xdd,
		ipfg: 0x0,			iptos: 0x65,
		tcpfg: 0x00,		type: HSB_TYPE_UDP,
		patmatch: 1,		ethtype: 0x7788,
		da0: 0x00,		da1: 0x00,
		da2: 0x00,		da3: 0x00,
		da4: 0x88,		da5: 0x8a,
		sa0: 0x00,		sa1: 0x80,
		sa2: 0xc0,		sa3: 0x00,
		sa4: 0x00,		sa5: 0x00,
		hiprior: 0,		snap: 1,
		udpnocs: 0,		ttlst: 64,
		dirtx: 0,			l3csok: 1,
		l4csok: 1,		ipfo0_n: 1,
		llcothr: 0,			urlmch: 1,
		extspa: 0,		extl2: 0,
	};
	hsa_t hsa;
	int i;
	rtl865x_tblAsicDrv_extIntIpParam_t ipt;
	
	/* Compare the HSA of expected, model, FPGA, and real IC. */
	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{
		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */
		
			layer4Config();	
			bzero((void*)&ipt, sizeof(rtl865x_tblAsicDrv_extIntIpParam_t));
			strtoip(&ipt.extIpAddr, WAN3_ISP_PUBLIC_IP);
			strtoip(&ipt.intIpAddr,WAN3_ISP_PUBLIC_IP);
			ipt.localPublic	= TRUE;
			ipt.nat			= FALSE;
			ipt.nhIndex		= 0;
			rtl8651_setAsicExtIntIpTable(2, &ipt);

			retval = virtualMacSetHsb( &hsb );
			assert( retval == SUCCESS );
			/* Start model code */
			modelStart();
			retval = virtualMacGetHsa( &hsa );
			IS_EQUAL_INT("Pakcet should be to ....",hsa.trip,ntohl(inet_addr(WAN3_ISP_PUBLIC_IP)), __FUNCTION__, __LINE__ );
			IS_EQUAL_INT("Pakcet should be to ....", hsa.port,80, __FUNCTION__, __LINE__ );

	}
	retval = SUCCESS;	
	return retval;


}

