/*
* Copyright c                  Realtek Semiconductor Corporation, 2005
* All rights reserved.
* 
* Program : Model code for NIC
* Abstract : 
* Author : Tony Tzong-yn Su (tysu@realtek.com.tw)               
* $Id: nicTest.c,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#include "rtl_types.h"
#include "asicRegs.h"
#ifdef CONFIG_RTL865XC
#include "rtl865xC_tblAsicDrv.h"
#else
#include "rtl8651_tblAsicDrv.h"
#endif
#include "gdma.h"
#include "kmp.h"
#include "gdmaModel.h"
#include "virtualMac.h"
#include "rtl_glue.h"
#include "rtl_utils.h"
#include "drvTest.h"

#include "swNic2.h"
#include "nicTest.h"

static int countRX=0;
static int PriorityChecksum=0;
#define MAX_QUEUE_ENTRY 16
extern uint32 QueuePriority[MAX_QUEUE_ENTRY];
extern uint8   QueuePriorityIndex;
__IRAM int32 swNic_isrReclaim(uint32 rxDescIdx,uint32 rxMbufIdx, struct rtl_pktHdr*pPkthdr,struct rtl_mBuf *pMbuf);
long  rtl865x_fastRx(struct rtl_pktHdr* pPkt) {
     
	struct rtl_mBuf *mbuf;
	int QueueID=(pPkt->ph_flags & PKTHDR_QUEUE_ID)>>11;
	int descriptRing=0;
	int to;

	mbuf=pPkt->ph_mbuf;
	countRX++;

	to=pPkt->ph_srcExtPortNum;

	if(to==0) //to CPU
		descriptRing=(READ_VIR16(CPUQDM0+QueueID*2)>>12)&0x7;
	else if(to==1) //to Ext1
		descriptRing=(READ_VIR16(CPUQDM0+QueueID*2)>>8)&0x7;
	else if(to==2) //to Ext2
		descriptRing=(READ_VIR16(CPUQDM0+QueueID*2)>>4)&0x7;
	else if(to==3) //to Ext3
		descriptRing=READ_VIR16(CPUQDM0+QueueID*2)&0x7;

	PriorityChecksum+=countRX*(descriptRing+1);

	switch(descriptRing)
	{
		case 0:
			swNic_isrReclaim(rxPhdrIndex0,rxMbufIndex0,pPkt,mbuf);
			break;
		case 1:
			swNic_isrReclaim(rxPhdrIndex1,rxMbufIndex0,pPkt,mbuf);
			break;
		case 2:
			swNic_isrReclaim(rxPhdrIndex2,rxMbufIndex0,pPkt,mbuf);
			break;
		case 3:
			swNic_isrReclaim(rxPhdrIndex3,rxMbufIndex0,pPkt,mbuf);
			break;
		case 4:
			swNic_isrReclaim(rxPhdrIndex4,rxMbufIndex0,pPkt,mbuf);
			break;
		case 5:
			swNic_isrReclaim(rxPhdrIndex5,rxMbufIndex0,pPkt,mbuf);
			break;
	}

	return 0;
}

struct rtl_pktHdr*  simulateRX(int QueueID,int to)
{

	struct rtl_pktHdr* pPkt=NULL;
	struct rtl_mBuf* pMbuf;
	char data[32]={0};	
	int descriptRing=0;

	if(to==0) //to CPU
		descriptRing=(READ_VIR16(CPUQDM0+QueueID*2)>>12)&0x7;
	else if(to==1) //to Ext1
		descriptRing=(READ_VIR16(CPUQDM0+QueueID*2)>>8)&0x7;
	else if(to==2) //to Ext2
		descriptRing=(READ_VIR16(CPUQDM0+QueueID*2)>>4)&0x7;
	else if(to==3) //to Ext3
		descriptRing=READ_VIR16(CPUQDM0+QueueID*2)&0x7;
			
	WRITE_VIR32(CPUIIMR,READ_MEM32(CPUIIMR)|RX_DONE_IE_ALL);

	
	switch(descriptRing)
	{
	case 0: 			
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|RX_DONE_IE0);
		
		if((*(uint32*)(READ_MEM32(CPURPDCR0))&DESC_SWCORE_OWNED)==0)
		{
			WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|PKTHDR_DESC_RUNOUT_IE0);
			return NULL;
		}

		*(uint32*)READ_MEM32(CPURPDCR0) &=(~DESC_SWCORE_OWNED);
		pPkt=(struct rtl_pktHdr *)((*(uint32*)READ_MEM32(CPURPDCR0))&(~(DESC_OWNED_BIT|DESC_WRAP)));	


		if((*(uint32*)(READ_MEM32(CPURPDCR0))&DESC_WRAP)!=0) 
		{
			WRITE_VIR32(CPURPDCR0,(uint32)&RxPkthdrRing0[0]);	
		}
		else
		{
			WRITE_VIR32(CPURPDCR0,READ_MEM32(CPURPDCR0)+4);										
		}			
		break;	
	case 1: 			
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|RX_DONE_IE1);
		
		if((*(uint32*)(READ_MEM32(CPURPDCR1))&DESC_SWCORE_OWNED)==0)
		{
			WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|PKTHDR_DESC_RUNOUT_IE1);
			return NULL;
		}

		*(uint32*)READ_MEM32(CPURPDCR1) &=(~DESC_SWCORE_OWNED);
		pPkt=(struct rtl_pktHdr *)((*(uint32*)READ_MEM32(CPURPDCR1))&(~(DESC_OWNED_BIT|DESC_WRAP)));	


		if((*(uint32*)(READ_MEM32(CPURPDCR1))&DESC_WRAP)!=0) 
		{
			WRITE_VIR32(CPURPDCR1,(uint32)&RxPkthdrRing1[0]);	
		}
		else
		{
			WRITE_VIR32(CPURPDCR1,READ_MEM32(CPURPDCR1)+4);										
		}			
		break;
	case 2: 			
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|RX_DONE_IE2);
		
		if((*(uint32*)(READ_MEM32(CPURPDCR2))&DESC_SWCORE_OWNED)==0)
		{
			WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|PKTHDR_DESC_RUNOUT_IE2);
			return NULL;
		}

		*(uint32*)READ_MEM32(CPURPDCR2) &=(~DESC_SWCORE_OWNED);
		pPkt=(struct rtl_pktHdr *)((*(uint32*)READ_MEM32(CPURPDCR2))&(~(DESC_OWNED_BIT|DESC_WRAP)));	


		if((*(uint32*)(READ_MEM32(CPURPDCR2))&DESC_WRAP)!=0) 
		{
			WRITE_VIR32(CPURPDCR2,(uint32)&RxPkthdrRing2[0]);	
		}
		else
		{
			WRITE_VIR32(CPURPDCR2,READ_MEM32(CPURPDCR2)+4);										
		}			
		break;
	case 3: 			
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|RX_DONE_IE3);
		
		if((*(uint32*)(READ_MEM32(CPURPDCR3))&DESC_SWCORE_OWNED)==0)
		{
			WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|PKTHDR_DESC_RUNOUT_IE3);
			return NULL;
		}

		*(uint32*)READ_MEM32(CPURPDCR3) &=(~DESC_SWCORE_OWNED);
		pPkt=(struct rtl_pktHdr *)((*(uint32*)READ_MEM32(CPURPDCR3))&(~(DESC_OWNED_BIT|DESC_WRAP)));	


		if((*(uint32*)(READ_MEM32(CPURPDCR3))&DESC_WRAP)!=0) 
		{
			WRITE_VIR32(CPURPDCR3,(uint32)&RxPkthdrRing3[0]);	
		}
		else
		{
			WRITE_VIR32(CPURPDCR3,READ_MEM32(CPURPDCR3)+4);										
		}			
		break;
	case 4: 			
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|RX_DONE_IE4);
		
		if((*(uint32*)(READ_MEM32(CPURPDCR4))&DESC_SWCORE_OWNED)==0)
		{
			WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|PKTHDR_DESC_RUNOUT_IE4);
			return NULL;
		}

		*(uint32*)READ_MEM32(CPURPDCR4) &=(~DESC_SWCORE_OWNED);
		pPkt=(struct rtl_pktHdr *)((*(uint32*)READ_MEM32(CPURPDCR4))&(~(DESC_OWNED_BIT|DESC_WRAP)));	


		if((*(uint32*)(READ_MEM32(CPURPDCR4))&DESC_WRAP)!=0) 
		{
			WRITE_VIR32(CPURPDCR4,(uint32)&RxPkthdrRing4[0]);	
		}
		else
		{
			WRITE_VIR32(CPURPDCR4,READ_MEM32(CPURPDCR4)+4);										
		}			
		break;	
	case 5: 			
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|RX_DONE_IE5);
		
		if((*(uint32*)(READ_MEM32(CPURPDCR5))&DESC_SWCORE_OWNED)==0)
		{
			WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|PKTHDR_DESC_RUNOUT_IE5);
			return NULL;
		}

		*(uint32*)READ_MEM32(CPURPDCR5) &=(~DESC_SWCORE_OWNED);
		pPkt=(struct rtl_pktHdr *)((*(uint32*)READ_MEM32(CPURPDCR5))&(~(DESC_OWNED_BIT|DESC_WRAP)));	

		if((*(uint32*)(READ_MEM32(CPURPDCR5))&DESC_WRAP)!=0) 
		{
			WRITE_VIR32(CPURPDCR5,(uint32)&RxPkthdrRing5[0]);	
		}
		else
		{
			WRITE_VIR32(CPURPDCR5,READ_MEM32(CPURPDCR5)+4);										
		}			
		break;		
	}


	/*  handle Mbuf */
	if((*(uint32*)(READ_MEM32(CPURMDCR0))&DESC_SWCORE_OWNED)==0)
	{
		WRITE_VIR32(CPUIISR,READ_MEM32(CPUIISR)|MBUF_DESC_RUNOUT_IE0);
		return NULL;
	}

	*(uint32*)READ_MEM32(CPURMDCR0) &=(~DESC_SWCORE_OWNED);
	
	pMbuf=(struct rtl_mBuf *)((*(uint32*)READ_MEM32(CPURMDCR0))&(~(DESC_OWNED_BIT|DESC_WRAP)));

	if((*(uint32*)(READ_MEM32(CPURMDCR0))&DESC_WRAP)!=0) 
	{
		WRITE_VIR32(CPURMDCR0,(uint32)&RxMbufRing0[0]);				
	}
	else
	{
		WRITE_VIR32(CPURMDCR0,READ_MEM32(CPURMDCR0)+4);								
	}



	/*  DMA data	*/
	pPkt->ph_mbuf=pMbuf;
	pPkt->ph_len=10;
	pPkt->ph_flags=0x8000; /* if flags have PKTHDR_DRIVERHOLD , will become rx runout. */


	pPkt->ph_portlist=0x1;
	pPkt->ph_proto=0;	
	pPkt->ph_flags |= (QueueID<<11);

	
	pMbuf->m_pkthdr=pPkt;
	pMbuf->m_next=NULL;
	pMbuf->m_data=pMbuf->m_extbuf=data;
	pMbuf->m_len=10;


	return pPkt;

}


int32 testNicRegs(uint32 caseNo)
{
	int i;
	int retval;

	for( i = IC_TYPE_MIN; i < IC_TYPE_MAX; i++ )
	{

		retval = model_setTestTarget( i );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

		
#ifdef CONFIG_RTL865XC 	
		WRITE_MEM32(CPUICR,0xffffffff);
		if(READ_MEM32(CPUICR)!=0) return FAILED;
		
		WRITE_MEM32(CPUICR,0xff00ffff);
		if(READ_MEM32(CPUICR)!=0xd70000ff) return FAILED;

		WRITE_MEM32(CPUICR,0xffa0ffff);
		if(READ_MEM32(CPUICR)!=0xd70000ff) return FAILED;		

		WRITE_MEM32(CPUICR,0xff10ffff);
		if(READ_MEM32(CPUICR)!=0xd70000ff) return FAILED;

		WRITE_MEM32(CPUIIMR,0xffffffff);
		if(READ_MEM32(CPUIIMR)!=0xffff07fe) return FAILED;		

		WRITE_VIR32(CPUIISR,0xffff07fe);
		WRITE_MEM32(CPUIISR,0x80800000);
		if(READ_MEM32(CPUIISR)!=0x7f7f07fe) return FAILED;	

		WRITE_VIR32(CPUIISR,0xffff07fe);
		WRITE_MEM32(CPUIISR,0xffffffff);
		if(READ_MEM32(CPUIISR)!=0) return FAILED;	
		
#else
		WRITE_MEM32(CPUICR,0xffffffff);
		if(READ_MEM32(CPUICR)!=0) return FAILED;
		
		WRITE_MEM32(CPUICR,0xff00ffff);
		if(READ_MEM32(CPUICR)!=0xd70000ff) return FAILED;

		WRITE_MEM32(CPUICR,0xffa0ffff);
		if(READ_MEM32(CPUICR)!=0xd70000ff) return FAILED;		

		WRITE_MEM32(CPUICR,0xff10ffff);
		if(READ_MEM32(CPUICR)!=0xd70000ff) return FAILED;

		WRITE_MEM32(CPUIIMR,0xffffffff);
		if(READ_MEM32(CPUIIMR)!=0xf8f80000) return FAILED;		

		WRITE_VIR32(CPUIISR,0xf8f80000);
		WRITE_MEM32(CPUIISR,0x80800000);
		if(READ_MEM32(CPUIISR)!=0x78780000) return FAILED;	

		WRITE_VIR32(CPUIISR,0xf8f80000);
		WRITE_MEM32(CPUIISR,0xffffffff);
		if(READ_MEM32(CPUIISR)!=0) return FAILED;	
#endif		

	}

	return SUCCESS;
	
}
int32 swNic_txRxSwitch(uint32 tx, uint32 rx);
int32 testNicRx(uint32 caseNo)
{

	int i,j;

	int retval;
	countRX=0;
	for( j = IC_TYPE_MIN;j < IC_TYPE_MAX; j++ )
	{
		retval = model_setTestTarget( j );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */


		swNic_txRxSwitch(txEnable,rxEnable);

		for(i=0;i<6;i++)
			WRITE_VIR16(CPUQDM0+i*2,(i<<12));

		for(i=0;i<1024;i++)
		{
			

			/* Switch Core Operation */
			/* simulate an interrupt (turn  CPUIISR RX_DONE_IE on) */
			simulateRX(0,TO_CPU);

			/* Swich Core interrupt to notify the RISC that a packet is ready	*/

			retval=swNic_intHandler(&i);
			if(retval!=1) return FAILED;

			swNic_rxThread(i);


			if(countRX!=(i+1)) 
			{
				rtlglue_printf("Failed when %dth packet RX!\n",countRX);
				return FAILED;
			}

			/* mBuf_freeMbufChain(pMbuf); */

			
		}
	}

	return SUCCESS;
}

int firstTime=TRUE;

int32 testNicTx(uint32 caseNo)
{

	struct rtl_pktHdr	*pktHdr;
	struct rtl_mBuf	*Mblk;

/*

The following packet is a HTTP Request;
===================================================================================
GET / HTTP/1.1
Accept: * / *
Accept-Language: zh-tw
Accept-Encoding: gzip, deflate
User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.0; .NET CLR 1.1.4322)
Host: www.google.com.tw
Connection: Keep-Alive
Cookie: PREF=ID=0c6c50c80799b799:TB=2:LD=zh-TW:TM=1116899852:LM=1119873714:GM=1:S=lPKPB0qpAAJvXssT
===================================================================================

*/

	char org_data[] = {


	0x00, 0x00, 0xe8, 0x66, 0x46, 0x85,   /* DMAC */
	0x00, 0x0c, 0x6e, 0x3a, 0x5d, 0x66,   /* SMAC */

/*	0x05,0xff,0xaa,0xaa,0x03,0,0,0,  */ /* for SNAP */

	
	0x08, 0x00,   /* Ether Type */

	/* IP header */

	0x45, 0x00, 0x01, 0x67, 0xa4, 0xd2, 0x40, 0x00, 
	0x80, 0x06, 0xaf, 0xde, 0xc0, 0xa8, 0x9a, 0x6e, 
	0x42, 0x66, 0x07, 0x63, 


	/* TCP header */

	0x10, 0x46, 0x00, 0x50, 0x92, 0x11, 
	0xa2, 0xdf, 0x4c, 0xa5, 0x5c, 0xdd, 0x50, 0x18,
	0x44, 0x70, 0xbc, 0x2c, 0x00, 0x00,


	/*  Payload */

	0x47, 0x45, 0x54, 0x20, 0x2f, 0x20, 0x48, 0x54, 	0x54, 0x50, 0x2f, 0x31, 0x2e, 0x31, 0x0d, 0x0a, 
	0x41, 0x63, 0x63, 0x65, 0x70, 0x74, 0x3a, 0x20, 	0x2a, 0x2f, 0x2a, 0x0d, 0x0a, 0x41, 0x63, 0x63, 
	0x65, 0x70, 0x74, 0x2d, 0x4c, 0x61, 0x6e, 0x67, 	0x75, 0x61, 0x67, 0x65, 0x3a, 0x20, 0x7a, 0x68, 
	0x2d, 0x74, 0x77, 0x0d, 0x0a, 0x41, 0x63, 0x63, 	0x65, 0x70, 0x74, 0x2d, 0x45, 0x6e, 0x63, 0x6f, 
	0x64, 0x69, 0x6e, 0x67, 0x3a, 0x20, 0x67, 0x7a, 	0x69, 0x70, 0x2c, 0x20, 0x64, 0x65, 0x66, 0x6c, 
	0x61, 0x74, 0x65, 0x0d, 0x0a, 0x55, 0x73, 0x65, 	0x72, 0x2d, 0x41, 0x67, 0x65, 0x6e, 0x74, 0x3a, 
	0x20, 0x4d, 0x6f, 0x7a, 0x69, 0x6c, 0x6c, 0x61, 	0x2f, 0x34, 0x2e, 0x30, 0x20, 0x28, 0x63, 0x6f, 
	0x6d, 0x70, 0x61, 0x74, 0x69, 0x62, 0x6c, 0x65, 	0x3b, 0x20, 0x4d, 0x53, 0x49, 0x45, 0x20, 0x36, 
	0x2e, 0x30, 0x3b, 0x20, 0x57, 0x69, 0x6e, 0x64, 	0x6f, 0x77, 0x73, 0x20, 0x4e, 0x54, 0x20, 0x35, 
	0x2e, 0x30, 0x3b, 0x20, 0x2e, 0x4e, 0x45, 0x54, 	0x20, 0x43, 0x4c, 0x52, 0x20, 0x31, 0x2e, 0x31, 
	0x2e, 0x34, 0x33, 0x32, 0x32, 0x29, 0x0d, 0x0a, 	0x48, 0x6f, 0x73, 0x74, 0x3a, 0x20, 0x77, 0x77, 
	0x77, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 	0x2e, 0x63, 0x6f, 0x6d, 0x2e, 0x74, 0x77, 0x0d, 
	0x0a, 0x43, 0x6f, 0x6e, 0x6e, 0x65, 0x63, 0x74, 	0x69, 0x6f, 0x6e, 0x3a, 0x20, 0x4b, 0x65, 0x65, 
	0x70, 0x2d, 0x41, 0x6c, 0x69, 0x76, 0x65, 0x0d, 	0x0a, 0x43, 0x6f, 0x6f, 0x6b, 0x69, 0x65, 0x3a, 
	0x20, 0x50, 0x52, 0x45, 0x46, 0x3d, 0x49, 0x44, 	0x3d, 0x30, 0x63, 0x36, 0x63, 0x35, 0x30, 0x63, 
	0x38, 0x30, 0x37, 0x39, 0x39, 0x62, 0x37, 0x39, 	0x39, 0x3a, 0x54, 0x42, 0x3d, 0x32, 0x3a, 0x4c, 
	0x44, 0x3d, 0x7a, 0x68, 0x2d, 0x54, 0x57, 0x3a, 	0x54, 0x4d, 0x3d, 0x31, 0x31, 0x31, 0x36, 0x38, 
	0x39, 0x39, 0x38, 0x35, 0x32, 0x3a, 0x4c, 0x4d, 	0x3d, 0x31, 0x31, 0x31, 0x39, 0x38, 0x37, 0x33, 
	0x37, 0x31, 0x34, 0x3a, 0x47, 0x4d, 0x3d, 0x31, 	0x3a, 0x53, 0x3d, 0x6c, 0x50, 0x4b, 0x50, 0x42, 
	0x30, 0x71, 0x70, 0x41, 0x41, 0x4a, 0x76, 0x58, 	0x73, 0x73, 0x54, 0x0d, 0x0a, 0x0d, 0x0a };


	int i,j;

	int retval;

	for( j = IC_TYPE_MIN;j < IC_TYPE_MAX; j++ )
	{
		retval = model_setTestTarget( j );		
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

		if(firstTime==TRUE)
		{
			firstTime=FALSE;
				
#ifdef CONFIG_RTL865XC 
				retval=mBuf_init(1536,  0/* use external cluster pool */, 1536, 2048, 0);
				if(retval!=SUCCESS) { rtlglue_printf("mBuf_init failed...\n"); return FAILED; }
				if(0!=swNic_init(128,128,128,128,128,128,1024,16,16,2048,(proc_input_pkt_funcptr_t) rtl865x_fastRx ,NULL)){
#else
				mBuf_init(256,  0/* use external cluster pool */, 256, 2048, 0);
				if(0!=swNic_init(128,128,16,2048,(proc_input_pkt_funcptr_t) rtl865x_fastRx ,NULL)){
#endif					
					rtlglue_printf("swNic_init failed........\n");
					return FAILED;
				}
		}




		for(i=0;i<256;i++)
		{
			int ret;
			char *data;
			data=rtlglue_malloc(sizeof(org_data));
			if(data==NULL) { rtlglue_printf("Out of memory!\n"); return FAILED; }
			memcpy(data,org_data,sizeof(data));
			
			Mblk=mBuf_attachHeader((void*)data,(uint32)0,2048, sizeof(data),0);
			pktHdr=Mblk->m_pkthdr;
			pktHdr->ph_flags |= 0x0800; /*  Set High Priority */


			ret=swNic_write(pktHdr);		

			WRITE_MEM32(CPUICR , READ_MEM32(CPUICR) | TXFD );
			/* mBuf_freeMbufChain(Mblk); */
			if(ret!=SUCCESS) return FAILED;
		}
	}

	return SUCCESS;

}


int32 testNicTxQueuePriority(uint32 caseNo)
{

	uint32 QueuePrioritySample[4]={0};
	uint8 QueuePrioritySampleIndex=0;
	char org_data[] = {

	0x00, 0x00, 0xe8, 0x66, 0x46, 0x85,   /* DMAC */
	0x00, 0x0c, 0x6e, 0x3a, 0x5d, 0x66,   /* SMAC */

/*	0x05,0xff,0xaa,0xaa,0x03,0,0,0, */ /* for SNAP  */
	
	0x08, 0x00,  /* Ether Type */


	/* IP header */
	0x45, 0x00, 0x01, 0x67, 0xa4, 0xd2, 0x40, 0x00, 
	0x80, 0x06, 0xaf, 0xde, 0xc0, 0xa8, 0x9a, 0x6e, 
	0x42, 0x66, 0x07, 0x63, 

	/* TCP header */
	0x10, 0x46, 0x00, 0x50, 0x92, 0x11, 
	0xa2, 0xdf, 0x4c, 0xa5, 0x5c, 0xdd, 0x50, 0x18,
	0x44, 0x70, 0xbc, 0x2c, 0x00, 0x00,

	/* Payload */
	0x47, 0x45, 0x54, 0x20, 0x2f, 0x20, 0x48, 0x54, 	0x54, 0x50, 0x2f, 0x31, 0x2e, 0x31, 0x0d, 0x0a, 
	0x41, 0x63, 0x63, 0x65, 0x70, 0x74, 0x3a, 0x20, 	0x2a, 0x2f, 0x2a, 0x0d, 0x0a, 0x41, 0x63, 0x63, 
	0x65, 0x70, 0x74, 0x2d, 0x4c, 0x61, 0x6e, 0x67, 	0x75, 0x61, 0x67, 0x65, 0x3a, 0x20, 0x7a, 0x68, 
	0x2d, 0x74, 0x77, 0x0d, 0x0a, 0x41, 0x63, 0x63, 	0x65, 0x70, 0x74, 0x2d, 0x45, 0x6e, 0x63, 0x6f, 
	0x64, 0x69, 0x6e, 0x67, 0x3a, 0x20, 0x67, 0x7a, 	0x69, 0x70, 0x2c, 0x20, 0x64, 0x65, 0x66, 0x6c, 
	0x61, 0x74, 0x65, 0x0d, 0x0a, 0x55, 0x73, 0x65, 	0x72, 0x2d, 0x41, 0x67, 0x65, 0x6e, 0x74, 0x3a, 
	0x20, 0x4d, 0x6f, 0x7a, 0x69, 0x6c, 0x6c, 0x61, 	0x2f, 0x34, 0x2e, 0x30, 0x20, 0x28, 0x63, 0x6f, 
	0x6d, 0x70, 0x61, 0x74, 0x69, 0x62, 0x6c, 0x65, 	0x3b, 0x20, 0x4d, 0x53, 0x49, 0x45, 0x20, 0x36, 
	0x2e, 0x30, 0x3b, 0x20, 0x57, 0x69, 0x6e, 0x64, 	0x6f, 0x77, 0x73, 0x20, 0x4e, 0x54, 0x20, 0x35, 
	0x2e, 0x30, 0x3b, 0x20, 0x2e, 0x4e, 0x45, 0x54, 	0x20, 0x43, 0x4c, 0x52, 0x20, 0x31, 0x2e, 0x31, 
	0x2e, 0x34, 0x33, 0x32, 0x32, 0x29, 0x0d, 0x0a, 	0x48, 0x6f, 0x73, 0x74, 0x3a, 0x20, 0x77, 0x77, 
	0x77, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 	0x2e, 0x63, 0x6f, 0x6d, 0x2e, 0x74, 0x77, 0x0d, 
	0x0a, 0x43, 0x6f, 0x6e, 0x6e, 0x65, 0x63, 0x74, 	0x69, 0x6f, 0x6e, 0x3a, 0x20, 0x4b, 0x65, 0x65, 
	0x70, 0x2d, 0x41, 0x6c, 0x69, 0x76, 0x65, 0x0d, 	0x0a, 0x43, 0x6f, 0x6f, 0x6b, 0x69, 0x65, 0x3a, 
	0x20, 0x50, 0x52, 0x45, 0x46, 0x3d, 0x49, 0x44, 	0x3d, 0x30, 0x63, 0x36, 0x63, 0x35, 0x30, 0x63, 
	0x38, 0x30, 0x37, 0x39, 0x39, 0x62, 0x37, 0x39, 	0x39, 0x3a, 0x54, 0x42, 0x3d, 0x32, 0x3a, 0x4c, 
	0x44, 0x3d, 0x7a, 0x68, 0x2d, 0x54, 0x57, 0x3a, 	0x54, 0x4d, 0x3d, 0x31, 0x31, 0x31, 0x36, 0x38, 
	0x39, 0x39, 0x38, 0x35, 0x32, 0x3a, 0x4c, 0x4d, 	0x3d, 0x31, 0x31, 0x31, 0x39, 0x38, 0x37, 0x33, 
	0x37, 0x31, 0x34, 0x3a, 0x47, 0x4d, 0x3d, 0x31, 	0x3a, 0x53, 0x3d, 0x6c, 0x50, 0x4b, 0x50, 0x42, 
	0x30, 0x71, 0x70, 0x41, 0x41, 0x4a, 0x76, 0x58, 	0x73, 0x73, 0x54, 0x0d, 0x0a, 0x0d, 0x0a };


	int i,j;

	int retval;

	for( j = IC_TYPE_MIN;j < IC_TYPE_MAX; j++ )
	{

		retval = model_setTestTarget( j );		
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

/*		for(i=0;i<256;i++) */


		QueuePriorityIndex=0;

		for(i=0;i<4;i++)
		{
			int ret;
			char *data;
			struct rtl_pktHdr	*pktHdr;
			struct rtl_mBuf	*Mblk;			
			data=rtlglue_malloc(sizeof(org_data));
			if(data==NULL) { rtlglue_printf("Out of memory!\n"); while(1); }			
			memcpy(data,org_data,sizeof(data));			
			Mblk=mBuf_attachHeader((void*)data,(uint32)0,2048, sizeof(data),0);
			pktHdr=Mblk->m_pkthdr;
			if(i%2==1) pktHdr->ph_flags |= 0x0800; /* Set High Priority */

			QueuePrioritySample[QueuePrioritySampleIndex++]=(uint32)pktHdr;
			ret=swNic_write(pktHdr);			
			/* mBuf_freeMbufChain(Mblk); */

			if(ret!=SUCCESS) return FAILED;
		}

		WRITE_MEM32(CPUICR , READ_MEM32(CPUICR) | TXFD );
	}

	if(QueuePriority[0]!=QueuePrioritySample[1]) return FAILED;
	if(QueuePriority[1]!=QueuePrioritySample[3]) return FAILED;
	if(QueuePriority[2]!=QueuePrioritySample[0]) return FAILED;
	if(QueuePriority[3]!=QueuePrioritySample[2]) return FAILED;	

	return SUCCESS;

}



int32 testNicRxRunout(uint32 caseNo)
{

	int i,j;

	int retval;
	countRX=0;
	for( j = IC_TYPE_MIN;j < IC_TYPE_MAX; j++ )
	{
		retval = model_setTestTarget( j );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */

		swNic_txRxSwitch(txEnable,rxEnable);


		for(i=0;i<6;i++)
			WRITE_VIR16(CPUQDM0+i*2,(i<<12));
		

		for(j=0;j<150;j++)
			simulateRX(0,TO_CPU); /* after 128th runout */

		simulateRX(5,TO_CPU);	/* 129th */
		simulateRX(3,TO_CPU);	 /* 130th */
		simulateRX(4,TO_CPU);	 /* 131th */
		simulateRX(2,TO_CPU);	 /* 132th */
		simulateRX(5,TO_CPU);	 /* 133th */


		/* Swich Core interrupt to notify the RISC that packets is ready	 */
		retval=swNic_intHandler(&i);
		if(retval!=1) return FAILED;
		swNic_rxThread(i);


		if(countRX!=133) 
		{
			rtlglue_printf("Failed when %dth packet RX!\n",countRX);
			return FAILED;
		}

		/* mBuf_freeMbufChain(pMbuf); */
		
	}

	return SUCCESS;
}


int32 testNicRxPriority(uint32 caseNo)
{

	int i,j;

	int retval;
	countRX=0;
	PriorityChecksum=0;
	for( j = IC_TYPE_MIN;j < IC_TYPE_MAX; j++ )
	{
		retval = model_setTestTarget( j );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */


		swNic_txRxSwitch(txEnable,rxEnable);


		for(i=0;i<6;i++)
			WRITE_VIR16(CPUQDM0+i*2,(i<<12));
		

		simulateRX(0,TO_CPU);			
		simulateRX(5,TO_CPU);	
		simulateRX(3,TO_CPU);	
		simulateRX(4,TO_CPU);	
		simulateRX(2,TO_CPU);	
		simulateRX(5,TO_CPU);	
		simulateRX(1,TO_CPU);			

		/* Swich Core interrupt to notify the RISC that packets is ready	 */
		retval=swNic_intHandler(&i);
		if(retval!=1) return FAILED;
		swNic_rxThread(i);


		if(PriorityChecksum!=83)
		{
			rtlglue_printf("pkt receive priority failed!\n");
			return FAILED;
		}


		if(countRX!=7) 
		{
			rtlglue_printf("Failed when %dth packet RX!\n",countRX);
			return FAILED;
		}


		/* mBuf_freeMbufChain(pMbuf); */
		
	}

	return SUCCESS;
}


int32 testNicRxQueueidDescringMapping(uint32 caseNo)
{

	int i,j;

	int retval;
	countRX=0;
	PriorityChecksum=0;
	for( j = IC_TYPE_MIN;j < IC_TYPE_MAX; j++ )
	{
		retval = model_setTestTarget( j );
		if ( retval == VMAC_ERROR_NON_AVAILABLE ) continue; /* Not support, we don't compare. */


		swNic_txRxSwitch(txEnable,rxEnable);


		for(i=0;i<6;i++)
			WRITE_VIR16(CPUQDM0+i*2,((i/2)<<12));
		

		simulateRX(0,TO_CPU);	// to Desc0
		simulateRX(5,TO_CPU);	// to Desc2
		simulateRX(3,TO_CPU);	// to Desc1
		simulateRX(4,TO_CPU);	// to Desc2
		simulateRX(2,TO_CPU);	// to Desc1
		simulateRX(5,TO_CPU);	// to Desc2		
		simulateRX(1,TO_CPU);  // to Desc0

		/* Swich Core interrupt to notify the RISC that packets is ready	 */
		retval=swNic_intHandler(&i);
		if(retval!=1) return FAILED;
		swNic_rxThread(i);

		if(PriorityChecksum!=49)
		{
			rtlglue_printf("pkt receive priority failed!\n");
			return FAILED;
		}


		if(countRX!=7) 
		{
			rtlglue_printf("Failed when %dth packet RX!\n",countRX);
			return FAILED;
		}


		/* mBuf_freeMbufChain(pMbuf); */
		
	}

	return SUCCESS;
}


