/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : CLE command for Model Code
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: model_cmd.c,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#include <rtl_types.h>
#include <rtl_cle.h>
#include <rtl_glue.h>
#include "icTest.h"
#include "icExport.h"
#include "asicRegs.h"
#include "modelTrace.h"
#include "model_cmd.h"



cle_exec_t model_cmds[] = 
{
	{	"run",
		"Run model test code",
		" { "
		"   all | "
		"   parser | "
		"   translator | "
		"   pre_core | "
		"   l2 | "
		"   l34 | "
		"   post_core | "
		"   gdma | "
		"   nic | "
		"   { %d'lower test case number' [ %d'upper test case number' ] } "
		" } ",
		runModelTest,
		CLE_USECISCOCMDPARSER,
		0,
		NULL
	},	
	{	"trace",
		"Set debug trace level",
		" { "
		"   all { on | off } | "
		"   watch { on | off } | "
		"   drop { on | off } | "
		"   tocpu { on | off } "
		" } ",
		runModelTrace,
		CLE_USECISCOCMDPARSER,
		0,
		NULL
	},	
	{	"export",
		"Export registers for debug or verification.",
		" { "
		"   map'Dump Virtual Address to Physical Address Mapping Table' | "
		"   open'open a logfile to export' { stdout'export to stdout' | %s'export to file' } | "
		"   close'close log file' | "
		"   snapshot'Export current register(not supported)' "
		" } ",
		runModelExport,
		CLE_USECISCOCMDPARSER,
		0,
		NULL
	},	

};

cle_grp_t model_cmdGrpList[] = 
{
#if 0 /* for example */
	{
		"spi",			    				//cmdStr
		"Serial Peripheral Interface",		//cmdDesc
		NULL,								//cmdPrompt
		spi_cmds,	  			 			//exec array
		NULL,		        				//group array
		CMD_SPI_CMD_NUM,					//exec number
		0,		            				//group number
		0,		            				//access level
	},	
#endif
};


