/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Header File for Virtual MAC
* Abstract : 
* Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
* $Id: virtualMac.h,v 1.1.1.1 2006/07/26 05:38:22 blue Exp $
*/

#ifndef _VIRTUAL_MAC_
#define _VIRTUAL_MAC_

#include "icModel.h"
#include "hsModel.h"

enum IC_TYPE
{
	IC_TYPE_MIN = 0,
	IC_TYPE_REAL = 0,
	IC_TYPE_MODEL,
	IC_TYPE_MAX /* to enumerate all IC_TYPE */ 
};

#define VMAC_ERROR_NON_AVAILABLE	(-2) /* In this test environment, this IC type is not available. Please ignore it. */
#define VMAC_ERROR_NO_PACKET_OUT	(-3) /* No packet arrived from IC */


int32 model_setTestTarget( enum IC_TYPE ic_type );
int32 model_getTestTarget( enum IC_TYPE *pic_type );

int32 virtualMacInput( enum PORT_NUM fromPort, uint8* packet, int32 len );
int32 virtualMacOutput( enum PORT_MASK *toPort, uint8* packet, int32 *len );

int32 virtualMacGetHsb( hsb_t* hsb );
int32 virtualMacSetHsb( hsb_t* hsb );
int32 virtualMacGetHsa( hsa_t* hsa );
int32 virtualMacSetHsa( hsa_t* hsa );


#endif
