/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : Blizzard Battlenet ( for Star Craft , Diablo II )
* Abstract : 
* Creator : 
* Author : $
* $Id: rtl8651_alg_battlenet.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_battlenet.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.8  2005/07/11 05:53:31  tony
* *: bug fixed: for addNaptConnection not be assigned.
*
* Revision 1.7  2005/06/01 13:56:18  tony
* *: support alg reinit.
*
* Revision 1.6  2005/04/11 08:59:17  tony
* *: bug fixed: StarCraft support multi-user. (advanced port bouncing)
*
* Revision 1.5  2004/12/01 13:08:16  tony
* *: support StarCraft for WAN-to-LAN case.
*
* Revision 1.4  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.3  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/18 09:22:26  tony
* add alg reinit function, it will be called when fwdEng ReInit.
*
* Revision 1.1  2004/03/12 07:32:22  tony
* add new ALG for Blizzard Battlenet ( for Star Craft , Diablo II )
*
*
*/
#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvFwd.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_battlenet.h"


#define MAX_SC_CLIENT 8
static uint32 clientIpList[MAX_SC_CLIENT]={0};

void  rtl8651_l4AliasHandleBattlenetReInit(void)
{
	int i;
	for(i=0;i<MAX_SC_CLIENT;i++) clientIpList[i]=0;
}


int32 rtl8651_l4AliasHandleBattlenetClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
		if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_BATTLENET)==0) return SUCCESS;

		if(pip->ip_p==IPPROTO_TCP)
		{
			struct tcphdr *th = NULL;
			uint8 *data;
			uint32   hlen, tlen, dlen;
	
			th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
			hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
			tlen = ntohs(pip->ip_len);
			dlen = tlen - hlen;	
			data = (uint8 *)(th + 1);
			if(data[0]==0xff)
			{
				if((dlen>23)&&(data[1]==0x09)) //SID_GETADVLISTEX
				{
					uint16 result_port;
					int i;
					//serverip=PKTGET_UINT32_UNALIGNED(&data[20]);
					//serverport=(data[18]<<8)+data[19];				
					for(i=0;i<MAX_SC_CLIENT;i++)
					{
						if(clientIpList[i]== tb->insideLocalIpAddr)  
						{
							break;
						}
						else if(clientIpList[i]==0)
						{
							clientIpList[i]= tb->insideLocalIpAddr;
							_rtl8651_removeNaptConnectionByIntIPandPort(FALSE,tb->insideLocalIpAddr,6112);
							_rtl8651_addNaptConnection(TRUE, TRUE,UDP_FLOW, tb->insideLocalIpAddr, 6112, &tb->insideGlobalIpAddr, &result_port,0,0);
							break;
						}					
					}				
				}
/*				
				else if(data[1]==0x1c) //SID_STARTADVEX3 
				{

					uint16 result_port=6112;
					_rtl8651_removeNaptConnectionByIntIPandPort(TRUE,tb->insideLocalIpAddr,6112);
					_rtl8651_addNaptConnection(TRUE, TRUE,TCP_LISTEN_FLOW, tb->insideLocalIpAddr, 6112, &tb->insideGlobalIpAddr, &result_port,0,0);
					_rtl8651_removeNaptConnectionByIntIPandPort(FALSE,tb->insideLocalIpAddr,6112);
					_rtl8651_addNaptConnection(TRUE, TRUE,UDP_FLOW, tb->insideLocalIpAddr, 6112, &tb->insideGlobalIpAddr, &result_port,0,0);
					printk("add server: %x\n",tb->insideLocalIpAddr);
				}
*/				
			}
		}

	return SUCCESS;
}


