/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : Counter-Strike / Half life
* Abstract : 
* Creator : 
* Author : $
* $Id: rtl8651_alg_cs.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_cs.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.4  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.3  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/18 09:22:26  tony
* add alg reinit function, it will be called when fwdEng ReInit.
*
* Revision 1.1  2004/03/12 07:34:07  tony
* add new ALG for Counter-Strike / Half life
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_cs.h"

static ipaddr_t localip=0;

void rtl8651_l4AliasHandleCsReInit(void)
{
	localip=0;
}

int32 rtl8651_l4AliasHandleCSClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_CS)==0) return FWDENG_USER_DROP;

	if(localip!=tb->insideLocalIpAddr)
	{
		localip=tb->insideLocalIpAddr;
		
#ifdef _RTL_UPNP
	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 6003,
		tb->insideLocalIpAddr, 6003);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 7002,
		tb->insideLocalIpAddr, 7002);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27005,
		tb->insideLocalIpAddr, 27005);
	
	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27010,
		tb->insideLocalIpAddr, 27010);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27011,
		tb->insideLocalIpAddr, 27011);

	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27012,
		tb->insideLocalIpAddr, 27012);
	
	rtl8651_addUpnpMap(UPNP_ONESHOT ,0 , 0, 
		tb->insideGlobalIpAddr, 27015,
		tb->insideLocalIpAddr, 27015);

#endif // _RTL_UPNP 
	}
	
	return SUCCESS;
}

