/*
* Copyright c                  Realtek Semiconductor Corporation, 2004  
* All rights reserved.
* 
* Program : CUseeMe
* Abstract : 
* Creator : 
* Author : $
* $Id: rtl8651_alg_cuseeme.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_cuseeme.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.5  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.4  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.3  2004/03/16 07:53:50  tony
* support endian free for test module.
*
* Revision 1.2  2004/03/16 03:52:18  tony
* fix bug: CUseeMe ALG support endian free for test module
*
* Revision 1.1  2004/03/12 07:34:44  tony
* add new ALG for CUseeMe
*
*
*/
#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_cuseeme.h"

int32 rtl8651_l4AliasHandleCUseeMeClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct udphdr *udp;
	int32 tlen,hlen,dlen;
	uint8 *data;
	struct cu_header *chdr;
	
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_CUSEEME)==0) return FWDENG_USER_DROP;

	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	
	data = (uint8 *)(udp+1);

	tlen = ntohs(pip->ip_len);
	hlen =(pip->ip_vhl & 0xf) + sizeof(struct udphdr);
	dlen = tlen - hlen;

	if(dlen>=sizeof(struct cu_header))
	{	
		chdr=(struct cu_header *)data;

		if(chdr->addr) 
		{
			{
				uint8 *srcip,*srcport;
				srcip=(uint8*)&chdr->addr;
				srcport=(uint8*)&chdr->port;
				*srcip=(tb->insideGlobalIpAddr>>24)&0xff;
				*(srcip+1)=(tb->insideGlobalIpAddr>>16)&0xff;
				*(srcip+2)=(tb->insideGlobalIpAddr>>8)&0xff;
				*(srcip+3)=tb->insideGlobalIpAddr&0xff;
				*srcport=(tb->insideGlobalPort>>8)&0xff;
				*(srcport+1)=tb->insideGlobalPort&0xff;				
			}			
		}
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleCUseeMeClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct udphdr *udp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	struct cu_header *chdr;
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_CUSEEME)==0) return SUCCESS;

	udp = (struct udphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = (uint8 *)(udp+1);	
		
	tlen = ntohs(pip->ip_len);
	hlen =(pip->ip_vhl & 0xf) + sizeof(struct udphdr);
	dlen = tlen - hlen;


	if(dlen>=sizeof(struct cu_header))
	{
		chdr=(struct cu_header *)data;
		if(chdr->dest_addr)
		{
			uint8 *addr,*port;	               
                     addr=(uint8*)&chdr->dest_addr;
                     port=(uint8*)&chdr->dest_port;
                     addr[0]=(tb->insideLocalIpAddr>>24)&0xff;
			addr[1]=(tb->insideLocalIpAddr>>16)&0xff;
			addr[2]=(tb->insideLocalIpAddr>>8)&0xff;
			addr[3]=tb->insideLocalIpAddr&0xff;
			port[0]=(tb->insideLocalPort>>8)&0xff;
			port[1]=tb->insideLocalPort&0xff;
		}

		if(ntohs(chdr->data_type)==101 && dlen > sizeof(struct oc_header))
		{
			struct oc_header *oc;
			struct client_info *ci;
			uint16 off,i;
			oc = (struct oc_header * ) data;

		       off=sizeof(struct oc_header);
		       
			for(i=0;(i < ntohs(oc->client_count) && off+sizeof(struct client_info) <= dlen); i++)
			{
				uint8 *addr;				
                            ci=(struct client_info *)(data+off);
                            addr=(uint8*)&ci->address;                              
                            
				if(addr[0]==((tb->insideGlobalIpAddr>>24)&0xff)&&
					addr[1]==((tb->insideGlobalIpAddr>>16)&0xff)&&				
					addr[2]==((tb->insideGlobalIpAddr>>8)&0xff)&&					
					addr[3]==(tb->insideGlobalIpAddr&0xff))
				{					
					addr[0]=((tb->insideLocalIpAddr>>24)&0xff);
					addr[1]=((tb->insideLocalIpAddr>>16)&0xff);
					addr[2]=((tb->insideLocalIpAddr>>8)&0xff);
					addr[3]=(tb->insideLocalIpAddr&0xff);
					break;
				}
			        else
				   off+=sizeof(struct client_info);
			}
			
		}
	}

	return SUCCESS;	
}


