/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_alg_dx7play.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_dx7play.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.12  2005/06/01 13:56:18  tony
* *: support alg reinit.
*
* Revision 1.11  2004/12/03 05:44:28  tony
* *: remove debug message
*
* Revision 1.10  2004/12/03 05:40:46  tony
* *: fix alg bug
*
* Revision 1.9  2004/12/01 13:08:16  tony
* *: support StarCraft for WAN-to-LAN case.
*
* Revision 1.8  2004/11/30 07:09:53  tony
* *: support ALG:DirectX for game AOE II
*
* Revision 1.7  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.6  2004/07/27 10:42:01  cfliu
* *: Fix a possible bug which uses uninitialized variable.
*
* Revision 1.5  2004/07/26 02:03:54  tony
* *: bug fixed for uninitialized data pointer will crash.
*
* Revision 1.4  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.3  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/08 02:48:44  tony
* fix bug: when add a incoming connection, allow any src port can connect in.
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.11  2004/01/29 01:39:47  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.10  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.9  2004/01/09 08:57:43  tony
* change define MULTIPLE_SESSION_UI to RTL8651_DSID_SUPPORT.
*
* Revision 1.8  2004/01/09 08:03:21  tony
* make the code architecture of ALG is able to support multiple dial session.
*
* Revision 1.7  2003/12/16 12:07:22  tony
* fix bug: make DirectX ALG support game AOE2.
*
* Revision 1.6  2003/11/28 11:07:19  tony
* make DirectX 7 ALG is able to work correctly.
* (only for Client in LAN case)
*
* Revision 1.5  2003/10/23 07:09:41  hiwu
* arrange include file sequence
*
* Revision 1.4  2003/10/17 08:45:51  hiwu
* merge new function type
*
* Revision 1.3  2003/10/17 06:15:07  hiwu
* ADD nat support
*
* Revision 1.2  2003/10/02 10:39:52  hiwu
* fix header conflict problem
*
* Revision 1.1  2003/10/02 10:01:49  hiwu
* initial version
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_dx7play.h" 
static uint32 session=0;
static uint16 alg_port=0;

void rtl8651_l4AliasHandleDx7playReInit(void)
{
	session=0;
	alg_port=0;
}

int32
rtl8651_l4AliasHandleDx7playClientOutbound (struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	
						struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct tcphdr *th = NULL;
	uint8 *data=NULL;
	uint16 port;
	uint32   hlen, tlen, dlen=0;


	//printk("alg support pkt->ph_dsid=%d a[d]=%d dx7=%d\n",pkthdrPtr->dsid,alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7,RTL8651_ALG_DX7);

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;

 	if(pip->ip_p==6)
	{
		th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
		hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
		tlen = ntohs(pip->ip_len);
		dlen = tlen - hlen;	
		data = (uint8 *)(th + 1);
 	}
 	else
 	{
 		return SUCCESS;
 	}



	//  All the packets we have to monitor are bofa (B0FA) packets
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;
	 
	port=(*(data+6)<<8)|(*(data+7));
	if(port>2400||port<2300) return SUCCESS;

	//printk("dx7 TCP control port=%d\n",port);

#ifdef _RTL_UPNP
//	printk("client out alg port=%d\n",port);	
	rtl8651_addUpnpMap(UPNP_TCP|UPNP_PERSIST , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);
#endif // _RTL_UPNP 
	session++;
	

	return SUCCESS;
}


int32
rtl8651_l4AliasHandleDx7playServerInbound (struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	
						struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct tcphdr *th = NULL;
	uint8 *data=NULL;
	uint16 port;
	uint32   hlen, tlen, dlen=0;


	//printk("alg support pkt->ph_dsid=%d a[d]=%d dx7=%d\n",pkthdrPtr->dsid,alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7,RTL8651_ALG_DX7);

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;

 	if(pip->ip_p==6)
	{
		th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
		hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
		tlen = ntohs(pip->ip_len);
		dlen = tlen - hlen;	
		data = (uint8 *)(th + 1);
 	}
 	else
 	{
 		return SUCCESS;
 	}



	//  All the packets we have to monitor are bofa (B0FA) packets
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;
	 
	port=(*(data+6)<<8)|(*(data+7));
	if(port>2400||port<2300) return SUCCESS;

	if(alg_port==0)
	{

//		printk("server in alg port=%d\n",port);
		rtl8651_fwdEngineRegisterAlgModule(port, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, //for client out
		NULL, 
		NULL,
		NULL); //for server in
		alg_port=port;
	}

	

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleDx7playClientOutbound2(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
 {
	struct tcphdr *th = NULL;
	uint8 *data;
	uint16 port=0;
	uint32   hlen, tlen, dlen;


 	if(pip->ip_p!=6)
		return FAILED; //only supports TCP
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;	


	link->alg_client_out=rtl8651_l4AliasHandleDx7playClientOutbound2;

 
	th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;	
	data = (uint8 *)(th + 1);

	//  All the packets we have to monitor are bofa (B0FA) packets
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;

	
	if((dlen>=300)&&(data[dlen-16]==2)&&(data[dlen-15]==0))
	{
		port=(*(data+dlen-14)<<8)|(*(data+dlen-13));
//		printk("client out 3=%d\n",port);		
		
	}
	else if((dlen>=134)&&(data[112]==2)&&(data[113]==0))
	{
		port=(*(data+114)<<8)|(*(data+115));
//		printk("client out 2=%d\n",port);		
		
	}
	else if((dlen>=128)&&(data[4]==2)&&(data[5]==0))
	{
		port=(*(data+6)<<8)|(*(data+7));
	//	printk("client out 1=%d\n",port);
		
	}
	
	if((port>2400)||(port<2300)) return SUCCESS;
	//printk("UDP Port=%d\n",port);


#ifdef _RTL_UPNP

	// for udp channel
	rtl8651_addUpnpMap(UPNP_ONESHOT , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);

#endif // _RTL_UPNP 

	if(alg_port!=0)
	{

		rtl8651_fwdEngineRemoveAlgModule(alg_port, TRUE);
		alg_port=0;
		rtl8651_addUpnpMap(UPNP_PERSIST|UPNP_TCP , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);		
	}

	return SUCCESS;
 }


int32 rtl8651_l4AliasHandleDx7playServerInbound2(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
 {
	struct tcphdr *th = NULL;
	uint8 *data;
	uint16 port=0;
	uint32   hlen, tlen, dlen;

 	if(pip->ip_p!=6)
		return FAILED; //only supports TCP
	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_DX7)==0) return SUCCESS;	


	link->alg_client_out=rtl8651_l4AliasHandleDx7playClientOutbound2;

 
	th = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( th->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;	
	data = (uint8 *)(th + 1);

	//  All the packets we have to monitor are bofa (B0FA) packets
	if((dlen!=(data[0]|(data[1]<<8))) || (data[2]!=0xB0) || (data[3]!=0xFA)) 
  		return SUCCESS;

	if((dlen>=300)&&(data[dlen-16]==2)&&(data[dlen-15]==0))
	{
		port=(*(data+dlen-14)<<8)|(*(data+dlen-13));
//		printk("server in 3=%d\n",port);		
		
	}
	else if((dlen>=134)&&(data[112]==2)&&(data[113]==0))
	{
		port=(*(data+114)<<8)|(*(data+115));		
//		printk("server in 2=%d\n",port);				
		
	}
	else if((dlen>=128)&&(data[4]==2)&&(data[5]==0))					
	{
		port=(*(data+6)<<8)|(*(data+7));
//		printk("server in 1=%d\n",port);				
		
	}
	
	if((port>2400)||(port<2300)) return SUCCESS;
	//printk("UDP Port=%d\n",port);


	if(alg_port==0)
	{
		rtl8651_fwdEngineRegisterAlgModule(port, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, //for client out
		NULL, 
		NULL,
		NULL); //for server in
		alg_port=port;
	}


#ifdef _RTL_UPNP

	rtl8651_addUpnpMap(UPNP_ONESHOT , link->dstIpAddr, 0, 
		link->insideGlobalIpAddr, port,
		link->insideLocalIpAddr, port);

#endif // _RTL_UPNP 


	return SUCCESS;
 }

