/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_alg_ftp.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_ftp.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.2  2005/11/22 04:19:22  shliu
* *: specify case-sensitive when calling mBuf_getBMjmpTable() and
*    mBuf_getBMjmpTable().
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.19  2005/08/25 04:01:35  chenyl
* *: rearrange code, add MUTEX lock/unlock for external functions, add `inline' property to some critical functions
*
* Revision 1.18  2005/06/01 13:56:18  tony
* *: support alg reinit.
*
* Revision 1.17  2004/12/22 05:19:15  tony
* +: support new features: make ALG(FTP,SIP,NetMeeting) support MNQueue.
*
* Revision 1.16  2004/09/03 07:55:21  chhuang
* *: remove debug message
*
* Revision 1.15  2004/09/03 03:00:09  chhuang
* +: add new feature: pseudo VLAN
*
* Revision 1.14  2004/08/12 08:57:30  danwu
* * bug fix: A public is always allocated when translating the PORT command.
* 	Considering re-transmission, it should first search if there exists
* 	an translation.
*
* Revision 1.13  2004/08/06 15:16:00  yjlou
* +: add 'interfaceRoute' bit to tell if this NAPT connection is interface route ?
*    If it is interface route, and it is NEVER ASIC-accelerated.
*
* Revision 1.12  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.11  2004/06/15 05:55:25  chhuang
* +: try to add Policy-Based pacth, but not complete. Because this is low priority
*
* Revision 1.10  2004/06/03 13:57:13  tony
* patch ftp for ftp server in our gateway problem.
*
* Revision 1.9  2004/05/24 11:34:27  orlando
* fix portablility bug: don't declare after statement
*
* Revision 1.8  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.7  2004/03/19 12:16:09  cfliu
* Rename all osk_malloc, printk, printf, printfByPolling as rtlglue_printf
*
* Revision 1.6  2004/03/18 09:22:26  tony
* add alg reinit function, it will be called when fwdEng ReInit.
*
* Revision 1.5  2004/03/03 09:16:18  tony
* update to endian free version for test module.
*
* Revision 1.4  2004/03/03 03:20:51  chenyl
* *: Policy route by SIP
* *: modify _rtl8651_drvIcmp, bounce packet back to ingress interface
* +: FwdEngineReinit() for reset fwdeng's variable and data structures
*
* Revision 1.3  2004/03/02 12:08:47  tony
* fix ftp alg module, make it support alg server test module.
*
* Revision 1.2  2004/03/02 08:36:29  tony
* make it support ftp client test modules
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.12  2004/01/29 01:39:47  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.11  2004/01/13 09:31:41  tony
* *** empty log message ***
*
* Revision 1.10  2004/01/13 06:27:23  tony
* fix crash problem when server in lan and use pasv mode.
*
* Revision 1.9  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.8  2003/12/19 11:40:01  tony
* change memcpy to rtl8651_memcpy
*
* Revision 1.7  2003/12/17 10:36:51  hiwu
* add checksum function
*
* Revision 1.6  2003/11/07 06:17:58  rupert
* modify for multiple ppppoe
*
* Revision 1.5  2003/11/03 08:30:30  tony
* add ALG:Yahoo Messenger v5.6 (Peer-to-Peer File transfer)
*
* Revision 1.4  2003/10/02 10:39:52  hiwu
* fix header conflict problem
*
* Revision 1.3  2003/10/02 07:05:01  hiwu
* merge with new table driver
*
* Revision 1.2  2003/09/23 04:34:28  hiwu
* change include file
*
* Revision 1.1  2003/09/17 06:45:57  hiwu
* initial version
*
*
*
*/




#include "rtl8651_alg_ftp.h"


#define _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE 576

static uint8 *_rtl8651_l4_ftp_alias_buf[2]; 


/*Ported from socket.c, Structure used for SO_RCVDELIMITER option. recv buffer pattern matching. */
 struct rcvdelimit {
 	#define RCVDELIMITER_LENGTH	8
 	uint32 length;
	uint8  delimiter[RCVDELIMITER_LENGTH];
	uint16 jump_table[256]; //Used by Boyer-Moore pattern matching algorithm
 } PASVpattern;

enum _rtl8651_l4FtpMessageType
{
	_RTL8651L4_FTP_PORT_COMMAND,
	_RTL8651_L4_FTP_EPRT_COMMAND,
	_RTL8651_L4_FTP_227_REPLY,
	_RTL8651_L4_FTP_229_REPLY,
	_RTL8651_L4_FTP_UNKNOWN_MESSAGE
};


static ipaddr_t _rtl8651_true_addr;	   /* in host byte order. */
static uint16 _rtl8651_true_port;			   /* in host byte order. */


/*********************************************************************************
* Routine Name : _rtl8651_l4ParseFtpPortCommand                                    
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static int32 _rtl8651_l4ParseFtpPortCommand(int8 * sptr, int32 dlen)
{
	int8      ch;
	int32     i, state;
	uint32    addr;
	uint16    port;
	uint8     octet;

	/*
	   Format: "PORT A,D,D,R,PO,RT". 
	 */

	/*
	   Return if data length is too short. 
	 */
	if (dlen < 18)
		return 0;

	addr = port = octet = 0;
	state = -4;
	for (i = 0; i < dlen; i++)
	{
		ch = sptr[i];
		switch (state)
		{
			case -4:
				if (ch == 'P')
					state++;
				else
					return 0;
				break;
			case -3:
				if (ch == 'O')
					state++;
				else
					return 0;
				break;
			case -2:
				if (ch == 'R')
					state++;
				else
					return 0;
				break;
			case -1:
				if (ch == 'T')
					state++;
				else
					return 0;
				break;

			case 0:
				if (_rtl8651_isspace(ch))
					break;
				else
					state++;
			case 1:
			case 3:
			case 5:
			case 7:
			case 9:
			case 11:
				if (_rtl8651_isdigit(ch))
				{
					octet = ch - '0';
					state++;
				}
				else
					return 0;
				break;
			case 2:
			case 4:
			case 6:
			case 8:
				if (_rtl8651_isdigit(ch))
					octet = 10 * octet + ch - '0';
				else if (ch == ',')
				{
					addr = (addr << 8) + octet;
					state++;
				}
				else
					return 0;
				break;
			case 10:
			case 12:
				if (_rtl8651_isdigit(ch))
					octet = 10 * octet + ch - '0';
				else if (ch == ',' || state == 12)
				{
					port = (port << 8) + octet;
					state++;
				}
				else
					return 0;
				break;
		}
	}

	if (state == 13)
	{
		_rtl8651_true_addr = addr;
		_rtl8651_true_port = port;
		return 1;
	}
	else
		return 0;
}


/*********************************************************************************
* Routine Name :  _rtl8651_l4ParseFtpEprtCommand                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static int32 _rtl8651_l4ParseFtpEprtCommand(int8 * sptr, int32 dlen)
{
	int8      ch, delim;
	int32     i, state;
	uint32    addr;
	uint16    port;
	uint8     octet;

	/*
	   Format: "EPRT |1|A.D.D.R|PORT|". 
	 */

	/*
	   Return if data length is too short. 
	 */
	if (dlen < 18)
		return 0;

	addr = port = octet = 0;
	delim = '|';					   /* XXX gcc -Wuninitialized */
	state = -4;
	for (i = 0; i < dlen; i++)
	{
		ch = sptr[i];
		switch (state)
		{
			case -4:
				if (ch == 'E')
					state++;
				else
					return 0;
				break;
			case -3:
				if (ch == 'P')
					state++;
				else
					return 0;
				break;
			case -2:
				if (ch == 'R')
					state++;
				else
					return 0;
				break;
			case -1:
				if (ch == 'T')
					state++;
				else
					return 0;
				break;

			case 0:
				if (!_rtl8651_isspace(ch))
				{
					delim = ch;
					state++;
				}
				break;
			case 1:
				if (ch == '1')		   /* IPv4 address */
					state++;
				else
					return 0;
				break;
			case 2:
				if (ch == delim)
					state++;
				else
					return 0;
				break;
			case 3:
			case 5:
			case 7:
			case 9:
				if (_rtl8651_isdigit(ch))
				{
					octet = ch - '0';
					state++;
				}
				else
					return 0;
				break;
			case 4:
			case 6:
			case 8:
			case 10:
				if (_rtl8651_isdigit(ch))
					octet = 10 * octet + ch - '0';
				else if (ch == '.' || state == 10)
				{
					addr = (addr << 8) + octet;
					state++;
				}
				else
					return 0;
				break;
			case 11:
				if (_rtl8651_isdigit(ch))
				{
					port = ch - '0';
					state++;
				}
				else
					return 0;
				break;
			case 12:
				if (_rtl8651_isdigit(ch))
					port = 10 * port + ch - '0';
				else if (ch == delim)
					state++;
				else
					return 0;
				break;
		}
	}

	if (state == 13)
	{
		_rtl8651_true_addr  = addr;
		_rtl8651_true_port = port;
		return 1;
	}
	else
		return 0;
}


/*********************************************************************************
* Routine Name :  _rtl8651_l4ParseFtp227Reply                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static int32 _rtl8651_l4ParseFtp227Reply(int8 * sptr, int32 dlen)
{
	int8      ch;
	int32     i, state;
	uint32    addr;
	uint16    port;
	uint8     octet;

	/*
	   Format: "227 Entering Passive Mode (A,D,D,R,PO,RT)" 
	 */

	/*
	   Return if data length is too short. 
	 */
	if (dlen < 17)
		return 0;

	addr = port = octet = 0;

	state = -3;
	for (i = 0; i < dlen; i++)
	{
		ch = sptr[i];
		switch (state)
		{
			case -3:
				if (ch == '2')
					state++;
				else
					return 0;
				break;
			case -2:
				if (ch == '2')
					state++;
				else
					return 0;
				break;
			case -1:
				if (ch == '7')
					state++;
				else
					return 0;
				break;

			case 0:
				if (ch == '(')
					state++;
				break;
			case 1:
			case 3:
			case 5:
			case 7:
			case 9:
			case 11:
				if (_rtl8651_isdigit(ch))
				{
					octet = ch - '0';
					state++;
				}
				else
					return 0;
				break;
			case 2:
			case 4:
			case 6:
			case 8:
				if (_rtl8651_isdigit(ch))
					octet = 10 * octet + ch - '0';
				else if (ch == ',')
				{
					addr = (addr << 8) + octet;
					state++;
				}
				else
					return 0;
				break;
			case 10:
			case 12:
				if (_rtl8651_isdigit(ch))
					octet = 10 * octet + ch - '0';
				else if (ch == ',' || (state == 12 && ch == ')'))
				{
					port = (port << 8) + octet;
					state++;
				}
				else
					return 0;
				break;
		}
	}

	if (state == 13)
	{		
		_rtl8651_true_port = port;
		_rtl8651_true_addr = addr;
		return 1;
	}
	else
		return 0;
}


/*********************************************************************************
* Routine Name :  _rtl8651_l4ParseFtp229Reply                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static int32 _rtl8651_l4ParseFtp229Reply(int8 * sptr, int32 dlen)
{
	int8      ch, delim;
	int32     i, state;
	uint16    port;

	/*
	   Format: "229 Entering Extended Passive Mode (|||PORT|)" 
	 */

	/*
	   Return if data length is too short. 
	 */
	if (dlen < 11)
		return 0;

	port = 0;
	delim = '|';					   /* XXX gcc -Wuninitialized */

	state = -3;
	for (i = 0; i < dlen; i++)
	{
		ch = sptr[i];
		switch (state)
		{
			case -3:
				if (ch == '2')
					state++;
				else
					return 0;
				break;
			case -2:
				if (ch == '2')
					state++;
				else
					return 0;
				break;
			case -1:
				if (ch == '9')
					state++;
				else
					return 0;
				break;

			case 0:
				if (ch == '(')
					state++;
				break;
			case 1:
				delim = ch;
				state++;
				break;
			case 2:
			case 3:
				if (ch == delim)
					state++;
				else
					return 0;
				break;
			case 4:
				if (_rtl8651_isdigit(ch))
				{
					port = ch - '0';
					state++;
				}
				else
					return 0;
				break;
			case 5:
				if (_rtl8651_isdigit(ch))
					port = 10 * port + ch - '0';
				else if (ch == delim)
					state++;
				else
					return 0;
				break;
			case 6:
				if (ch == ')')
					state++;
				else
					return 0;
				break;
		}
	}

	if (state == 7)
	{
		_rtl8651_true_port = port;
		return 1;
	}
	else
		return 0;
}


/*********************************************************************************
* Routine Name :   _rtl8651_l4NewFtpClientMessage                                  
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/

static    int32
_rtl8651_l4NewFtpClientMessage(struct ip *pip,
			  rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb,
			  int32 _rtl8651_l4FtpMessageType)
{
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *ftp_tb=&entry;	
	int32     diff_len = 0;	
	struct tcphdr *tc;
	ipaddr_t ip_s, ip_d, ip_alias = 0;
	uint16 ip_dp, ip_aliasp = 0;		

	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
		
	ip_s = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
	ip_d = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
	ip_dp =  tc->th_dport;
	
	/* Security checks. */
	if (_rtl8651_true_port < IPPORT_RESERVED){
		return 0;
	}

	/* port does not change; assume from nat */
	if(tb->natlink){
		ftp_tb = tb;
		ip_alias = tb->insideGlobalIpAddr;
		ip_aliasp = _rtl8651_true_port;
		goto nat_proc;
	}

	
	ftp_tb=&entry;
	if(_rtl8651_getOutboundNaptFlow(TRUE,_rtl8651_true_addr,_rtl8651_true_port,ip_d,ip_dp-1,  &ftp_tb)==SUCCESS){
		ip_alias = ftp_tb->insideGlobalIpAddr;
		ip_aliasp = ftp_tb->insideGlobalPort;
	}
	else
	{
		int r;

		_rtl8651_softNaptPolicyRoute(0, ip_s,ip_d,ip_dp,&ip_alias,&ip_aliasp);
		if (!ip_alias)
		{
		/* Establish link to address and port found in FTP control message. */
			if( _rtl8651_getUsableExtIpAndPort(TRUE,
				_rtl8651_true_addr,_rtl8651_true_port,ip_d,ip_dp-1,&ip_alias,&ip_aliasp) != SUCCESS ){
				return 0;
			}
		}
		assert(ip_aliasp);


#ifdef _RTL_UPNP
		/* add PNP port map */		
		_rtl8651_addAlgQosUpnpMap(UPNP_TCP|UPNP_ONESHOT|UPNP_ALG_QOS, ip_d, 0, 
				ip_alias, ip_aliasp,_rtl8651_true_addr,_rtl8651_true_port, RTL8651_ALG_FTP_IDX );		
#endif /* _RTL_UPNP */

		r=_rtl8651_addAlgQosNaptConnection(TRUE, TRUE|ALG_QOS,TCP_LISTEN_FLOW, _rtl8651_true_addr, _rtl8651_true_port, &ip_alias, &ip_aliasp, ip_d, ip_dp-1,RTL8651_ALG_FTP_IDX);
		//r=_rtl8651_addNaptConnection(TRUE, TRUE,TCP_LISTEN_FLOW, _rtl8651_true_addr, _rtl8651_true_port, &ip_alias, &ip_aliasp, ip_d, ip_dp-1);
		ftp_tb=&entry;

		_rtl8651_getOutboundNaptFlow(TRUE,_rtl8651_true_addr,_rtl8651_true_port,ip_d,ip_dp-1,  &ftp_tb);		
		if (ftp_tb != NULL){
			ftp_tb->tcpAckModified = 0;
			ftp_tb->tcpFtpLastLineCRLFTermed = 0;
			ftp_tb->tcpStateINdex = 0;	
			//chhuang added, but Louis commented
			//ftp_tb->acl_flag = 1;
//printk("napt: src port: %d, dport: %d\n", _rtl8651_true_port, ip_dp-1);
		}

	}
	
nat_proc:

	if (ftp_tb != NULL)
	{
		int32     slen, hlen, tlen, dlen;
		struct tcphdr *tc;

		
		/* Calculate data length of TCP packet */
		tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
		hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
		tlen = ntohs(pip->ip_len);
		dlen = tlen - hlen;

		/* Create new FTP message. */
		{
			int8 *stemp;
			int8     *sptr;

			int32     a1, a2, a3, a4, p1, p2;

			/* assign stemp buffer */
			stemp = (int8*)_rtl8651_l4_ftp_alias_buf[0];
			/* Decompose alias address into quad format */
#if 0			
			ip_alias = ntohl(ip_alias);			
			ptr = (uint8 *) &ip_alias;			
			a1 = *ptr++;
			a2 = *ptr++;
			a3 = *ptr++;
			a4 = *ptr;
#else
			a1 = (ip_alias >> 24)&0xff;
			a2 = (ip_alias >> 16)&0xff;
			a3 = (ip_alias >> 8)&0xff;
			a4 = ip_alias & 0xff;				
#endif

			switch (_rtl8651_l4FtpMessageType)
			{
				case _RTL8651L4_FTP_PORT_COMMAND:
					/* Decompose alias port into pair format. */
#if 0					
					ptr = (uint8 *) & ip_aliasp;
					p1 = *ptr++;
					p2 = *ptr;
#else
					p1 = (ip_aliasp >> 8) & 0xff;
					p2 = ip_aliasp & 0xff;
#endif

					if (_rtl8651_l4FtpMessageType == _RTL8651L4_FTP_PORT_COMMAND)
					{
						/*Generate PORT command string. */
						sprintf(stemp, "PORT %d,%d,%d,%d,%d,%d\r\n",
								a1, a2, a3, a4, p1, p2);						
					}
					break;
				case _RTL8651_L4_FTP_EPRT_COMMAND:
					/* Generate EPRT command string.  */
					sprintf(stemp, "EPRT |1|%d.%d.%d.%d|%d|\r\n",
							a1, a2, a3, a4, ip_aliasp);
					break;
			}

			/* Save string length for IP header modification */
			slen = strlen(stemp);

			/* Copy modified buffer into IP packet. */
			sptr = (int8 *) pip;
			sptr += hlen;

			_strncpy(sptr, stemp, _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE - hlen);
			
		}

		/* Save information regarding modified seq and ack numbers */
		{
			int32     delta;

			tb->tcpAckModified = 1;
			delta = _rtl8651_l4GetDeltaSeqOut(pip, tc, tb);
			_rtl8651_l4AddSeq(pip, tb, delta + slen - dlen);
			diff_len = slen - dlen;
		}

		/* Revise IP header */
		{
			uint16    new_len;

			new_len = htons(hlen + slen);
			pip->ip_len = new_len;
			
		}		
		
	}
	else{
		assert(0);
	}

	return diff_len;				   /* return the data length change */
}


/*********************************************************************************
* Routine Name :   _rtl8651_l4NewFtpServerMessage                                  
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/

static    int32
_rtl8651_l4NewFtpServerMessage(struct ip *pip,
			  rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb,
			  int32 _rtl8651_l4FtpMessageType)
{
	int32     diff_len = 0;	
	ipaddr_t ip_s,ip_d = 0;	
	struct tcphdr *tc;		
		
	ip_s = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
	ip_d = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);
	
	{
		int32     slen, hlen, tlen, dlen;
		
		/* Calculate data length of TCP packet */
		tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
		hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
		tlen = ntohs(pip->ip_len);
		dlen = tlen - hlen;
		
		/* port does not change; assume from nat */
		if(tb->natlink){
			goto nat_proc;
		}

#ifdef _RTL_UPNP
		/* add PNP port map */
		_rtl8651_addAlgQosUpnpMap(UPNP_TCP|UPNP_ONESHOT|UPNP_ALG_QOS, ip_d, 0, 
				tb->insideGlobalIpAddr, _rtl8651_true_port,
				ip_s, _rtl8651_true_port,RTL8651_ALG_FTP_IDX);		
#endif /* _RTL_UPNP */

nat_proc:
		/* Create new FTP message. */
		{
			int8 *stemp;
			int8     *sptr;

			int32     a1, a2, a3, a4, p1, p2;

			/* assign stemp buffer */
			stemp = (int8*)_rtl8651_l4_ftp_alias_buf[0];
			/* Decompose alias address into quad format */
#if 0			
			ptr = (uint8 *) &(tb->insideGlobalIpAddr);
			a1 = *ptr++;
			a2 = *ptr++;
			a3 = *ptr++;
			a4 = *ptr;
#else
			a1 = (tb->insideGlobalIpAddr >> 24) & 0xff;
			a2 = (tb->insideGlobalIpAddr >> 16) & 0xff;
			a3 = (tb->insideGlobalIpAddr >> 8) & 0xff;
			a4 = (tb->insideGlobalIpAddr) & 0xff;			
#endif

			switch (_rtl8651_l4FtpMessageType)
			{
				case _RTL8651_L4_FTP_227_REPLY:
					/* Decompose alias port into pair format. */
#if 0					
					ptr = (uint8 *) & _rtl8651_true_port;
					p1 = *ptr++;
					p2 = *ptr;
#else
					p1 = (_rtl8651_true_port>>8)&0xff;
					p2 = (_rtl8651_true_port)&0xff;				
#endif

					/* Generate 227 reply string. */
					sprintf(stemp,
							"227 Entering Passive Mode (%d,%d,%d,%d,%d,%d)\r\n",
							a1, a2, a3, a4, p1, p2);					
					break;
				case _RTL8651_L4_FTP_EPRT_COMMAND:
					/* Generate EPRT command string.  */
					sprintf(stemp, "EPRT |1|%d.%d.%d.%d|%d|\r\n",
							a1, a2, a3, a4, _rtl8651_true_port);
					break;
				case _RTL8651_L4_FTP_229_REPLY:
					/* Generate 229 reply string.  */
					sprintf(stemp,
							"229 Entering Extended Passive Mode (|||%d|)\r\n",
							_rtl8651_true_port);
					break;
			}

			/* Save string length for IP header modification */
			slen = strlen(stemp);

			/* Copy modified buffer into IP packet. */
			sptr = (int8 *) pip;
			sptr += hlen;
			_strncpy(sptr, stemp, _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE - hlen);

		}

		/* Save information regarding modified seq and ack numbers */
		{
			int32     delta;

			tb->tcpAckModified = 1;
			delta = _rtl8651_l4GetDeltaSeqOut(pip, tc, tb);
			_rtl8651_l4AddSeq(pip, tb, delta + slen - dlen);
			diff_len = slen - dlen;
		}

		/* Revise IP header */
		{
			uint16    new_len;

			new_len = htons(hlen + slen);
			pip->ip_len = new_len;
		}		
	}

	/* Compute TCP/IP checksum for revised packet */
	tc->th_sum = 0;
	pip->ip_sum = 0;				
	tc->th_sum = _rtl8651_tcpChecksum(pip);
	pip->ip_sum = _rtl8651_ipChecksum(pip);	
		
	return diff_len;				   /* return the data length change */
}



static int32 init_ftp = 0;
int32 rtl8651_l4AliasFtpInit(void *arg){
	/*initialize Boyer-Moore pattern match reference table for filtering PASV command inside 
	inbound server FTP messages */
	
	int8 pasvCmdStr[]="PASV\r\n";
	
	if(init_ftp)
		return SUCCESS;

	init_ftp = 1;		
	/* malloc global variable */
	_rtl8651_l4_ftp_alias_buf[0] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE+64);
	_rtl8651_l4_ftp_alias_buf[1] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE+64);
	assert(_rtl8651_l4_ftp_alias_buf[0]);
	assert(_rtl8651_l4_ftp_alias_buf[1]);
	
	//strcpy((int8*)&PASVpattern.delimiter[0], pasvCmdStr);
	rtl8651_memcpy((void*)&PASVpattern.delimiter[0], pasvCmdStr, sizeof(pasvCmdStr)+1);
	PASVpattern.length=strlen(pasvCmdStr);
	mBuf_getBMjmpTable((uint8 *)pasvCmdStr, (uint16 *)&PASVpattern.jump_table[0], PASVpattern.length, TRUE);
	return SUCCESS;
}


void rtl8651_l4AliasFtpReInit(void){
	/*initialize Boyer-Moore pattern match reference table for filtering PASV command inside 
	inbound server FTP messages */
	_rtl8651_true_addr=0;
	_rtl8651_true_port=0;
	memset(&PASVpattern,0,sizeof(PASVpattern));
}



/*********************************************************************************
* Routine Name :   rtl8651_l4AliasHandleFtpCleintOutbound                                  
* Description :     
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
int32 rtl8651_l4AliasHandleFtpCleintOutbound(
	struct rtl_pktHdr *indat, 
	struct ip *inhdr,
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link	
)
{
	struct rtl_pktHdr * pkthdrPtr ;
	struct rtl_mBuf *m ;	
	int32     hlen, tlen, dlen;
	int8     *sptr;
	struct tcphdr *tc;
	int32     _rtl8651_l4FtpMessageType;
	int8     *newpacket;	
	struct ip *pip;	
	int32 off_set;
	struct ip *inip = (struct ip*)(inhdr);
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb;

	if((alg_supports[indat->ph_dsid]&RTL8651_ALG_FTP)==0) return SUCCESS;	

	tb = (rtl8651_tblDrv_naptTcpUdpFlowEntry_t *)link;

		
	pkthdrPtr  = (struct rtl_pktHdr * )indat;
	m  = pkthdrPtr->ph_mbuf;

	off_set = ((uint8 *)inip) - m->m_data;
	
	if(off_set < 0 || off_set > 40 || tb == NULL){
		return FAILED;
	}

	/* test the packet length */
	if (m->m_pkthdr->ph_len > _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE)
	{
		return FAILED;
	}	

	/* assigned new packet buffer ; use the latter part of _rtl8651_l4_ftp_alias_buf */
	
	newpacket =  (int8 *)_rtl8651_l4_ftp_alias_buf[1];
	/* copy out the mbuf data */
	mBuf_copyToUserBuffer(m, off_set, m->m_pkthdr->ph_len - off_set, newpacket);	

	assert(m->m_len == m->m_pkthdr->ph_len);
	pip = (struct ip *) newpacket;
	/* Calculate data length of TCP packet */
	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;

	/* Place string pointer and beginning of data */
	sptr = (int8 *) pip;
	sptr += hlen;


	/*
	 * Check that data length is not too long and previous message was
	 * properly terminated with CRLF.
	 */
	
	if (dlen <= _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE && (tb->tcpFtpLastLineCRLFTermed))
	{
		_rtl8651_l4FtpMessageType = _RTL8651_L4_FTP_UNKNOWN_MESSAGE;

		/* When aliasing a client, check for the PORT/EPRT command. */
		if (_rtl8651_l4ParseFtpPortCommand(sptr, dlen))
			_rtl8651_l4FtpMessageType = _RTL8651L4_FTP_PORT_COMMAND;
		else if (_rtl8651_l4ParseFtpEprtCommand(sptr, dlen))
			_rtl8651_l4FtpMessageType = _RTL8651_L4_FTP_EPRT_COMMAND;
		
		if (_rtl8651_l4FtpMessageType != _RTL8651_L4_FTP_UNKNOWN_MESSAGE)		
			_rtl8651_l4NewFtpClientMessage(pip, tb, _rtl8651_l4FtpMessageType);
	}


	/* Track the msgs which are CRLF term'd for PORT/PASV FW breach */

	if (dlen)
	{	
		/* only if there's data */  
		/* start over at beginning */
		/* recalc tlen, pkt may have grown */					  	
		
		sptr = (int8 *) pip;		
		tlen = ntohs(pip->ip_len);	
		if((sptr[tlen - 2] == '\r') && (sptr[tlen - 1] == '\n'))
			link->tcpFtpLastLineCRLFTermed = 1;
		else
			link->tcpFtpLastLineCRLFTermed = 0;

		/* Compute TCP/IP checksum for revised packet */
		tc->th_sum = 0;
		pip->ip_sum = 0;				
		tc->th_sum = _rtl8651_tcpChecksum(pip);
		pip->ip_sum = _rtl8651_ipChecksum(pip);		

		mBuf_copyToMbuf(m, off_set, tlen, newpacket);
		assert(m->m_len == m->m_pkthdr->ph_len);
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleFtpCleintInbound(
	struct rtl_pktHdr *indat, 
	struct ip *inhdr,
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link	
)
{

//chhuang
//printk("**********************************************\n");

	return SUCCESS;
}




 
/*********************************************************************************
* Routine Name :   rtl8651_l4AliasFilterFtpServerInboundPasvCmd                                  
* Description :   Filter incoming FTP message and intercept PASV command. Force FTP client to backoff and use
* 	de-facto active mode (ie. the PORT command) so as to use ASIC acceleration feature in 8651.
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
int32 rtl8651_l4AliasFilterFtpServerInboundPasvCmd(
	struct rtl_pktHdr *indat, 
	struct ip *inhdr,
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link	
)
{
	struct rtl_pktHdr * pkthdrPtr ;
	struct rtl_mBuf *m ;	
	int32     hlen, tlen, dlen;
	int8     *sptr;
	struct tcphdr *tc;
	struct ip *pip;	
	int32 off_set, pos=-1;
	struct ip *inip = (struct ip*)(inhdr);
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb;

	if((alg_supports[indat->ph_dsid]&RTL8651_ALG_FTP)==0) return SUCCESS;	

	tb = (rtl8651_tblDrv_naptTcpUdpFlowEntry_t *)link;

		
	pkthdrPtr  = (struct rtl_pktHdr * )indat;
	m  = pkthdrPtr->ph_mbuf;

	off_set = ((uint8 *)inip) - m->m_data;
	
	if(off_set < 0 || off_set > 40 || tb == NULL){
		return FAILED;
	}
	 
	/* test the packet length */
	if (m->m_pkthdr->ph_len > _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE)
	{
		return FAILED;
	}	

	pip = (struct ip *) m->m_data;

	/* Calculate data length of TCP packet */
	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;

	/* Place string pointer and beginning of data */
	sptr = (int8 *) pip;
	sptr += hlen;

	if(dlen)
		pos=mBuf_BMpatternMatch(m, m->m_len, (uint8*)&PASVpattern.delimiter,PASVpattern.length, (uint16 *)&PASVpattern.jump_table, TRUE);

	if(pos>0){
		//PASV command found, change it....:)
		m->m_data[pos]='N';
		m->m_data[pos+1]='U';
		m->m_data[pos+2]='L';
		m->m_data[pos+3]='L';
	}

	if (dlen)
	{	
		/* only if there's data */  
		if((sptr[tlen - 2] == '\r') && (sptr[tlen - 1] == '\n'))
			link->tcpFtpLastLineCRLFTermed = 1;
		else
			link->tcpFtpLastLineCRLFTermed = 0;
	}
	
	/* Compute TCP/IP checksum for revised packet */
	tc->th_sum = 0;
	pip->ip_sum = 0;				
	tc->th_sum = _rtl8651_tcpChecksum(pip);
	pip->ip_sum = _rtl8651_ipChecksum(pip);		
			
	return SUCCESS;
}


/*********************************************************************************
* Routine Name :   rtl8651_l4AliasHandleFtpServerOutbound                                  
* Description :     
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
int32 rtl8651_l4AliasHandleFtpServerOutbound(
	struct rtl_pktHdr *indat, 
	struct ip *inhdr,
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link	
)
{
	struct rtl_pktHdr * pkthdrPtr ;
	struct rtl_mBuf *m ;	
	int32     hlen, tlen, dlen;
	int8     *sptr;
	struct tcphdr *tc;
	int32     _rtl8651_l4FtpMessageType;
	int8     *newpacket;	
	struct ip *pip;	
	int32 off_set;
	struct ip *inip = (struct ip*)(inhdr);
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb;

	
	if((alg_supports[indat->ph_dsid]&RTL8651_ALG_FTP)==0) return SUCCESS;	

	tb = (rtl8651_tblDrv_naptTcpUdpFlowEntry_t *)link;

		
	pkthdrPtr  = (struct rtl_pktHdr * )indat;
	m  = pkthdrPtr->ph_mbuf;

	off_set = ((uint8 *)inip) - m->m_data;
	
	if(off_set < 0 || off_set > 40 || tb == NULL){
		return FAILED;
	}
	 
	/* test the packet length */
	if (m->m_pkthdr->ph_len > _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE)
	{
		return FAILED;
	}	

	/* assigned new packet buffer ; use the latter part of _rtl8651_l4_ftp_alias_buf */
	newpacket =  (int8 *)_rtl8651_l4_ftp_alias_buf[1];

	/* copy out the mbuf data */
	mBuf_copyToUserBuffer(m, off_set, m->m_pkthdr->ph_len - off_set, newpacket);	

	assert(m->m_len == m->m_pkthdr->ph_len);
	pip = (struct ip *) newpacket;

	/* Calculate data length of TCP packet */
	tc = (struct tcphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tc->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;

	/* Place string pointer and beginning of data */
	sptr = (int8 *) pip;
	sptr += hlen;

	/*
	 * Check that data length is not too long and previous message was
	 * properly terminated with CRLF.
	 */
		
	if (dlen <= _RTL8651_L4_MAX_FTP_ALIAS_BUF_SIZE && (tb->tcpFtpLastLineCRLFTermed) )
	{
		_rtl8651_l4FtpMessageType = _RTL8651_L4_FTP_UNKNOWN_MESSAGE;

		/* When aliasing a server, check for the 227/229 reply. */
		if (_rtl8651_l4ParseFtp227Reply(sptr, dlen))
			_rtl8651_l4FtpMessageType = _RTL8651_L4_FTP_227_REPLY;
		else if (_rtl8651_l4ParseFtp229Reply(sptr, dlen))
			_rtl8651_l4FtpMessageType = _RTL8651_L4_FTP_229_REPLY;

		if (_rtl8651_l4FtpMessageType != _RTL8651_L4_FTP_UNKNOWN_MESSAGE)		
			_rtl8651_l4NewFtpServerMessage(pip, tb, _rtl8651_l4FtpMessageType);
	}
	
	/* Track the msgs which are CRLF term'd for PORT/PASV FW breach */

	if (dlen)
	{	
		/* only if there's data */  
		/* start over at beginning */
		/* recalc tlen, pkt may have grown */					  	
		
		sptr = (int8 *) pip;		
		tlen = ntohs(pip->ip_len);	   
		if((sptr[tlen - 2] == '\r') && (sptr[tlen - 1] == '\n'))
			link->tcpFtpLastLineCRLFTermed = 1;
		else
			link->tcpFtpLastLineCRLFTermed = 0;

		/* Compute TCP/IP checksum for revised packet */
		tc->th_sum = 0;
		pip->ip_sum = 0;				
		tc->th_sum = _rtl8651_tcpChecksum(pip);
		pip->ip_sum = _rtl8651_ipChecksum(pip);		
		
		mBuf_copyToMbuf(m, off_set, tlen, newpacket);
		assert(m->m_len == m->m_pkthdr->ph_len);
	}
	
	return SUCCESS;
}



