/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_alg_h323.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_h323.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.26  2005/07/21 07:45:31  chenyl
* *: print message only when DEBUG is turned on.
*
* Revision 1.25  2005/07/19 07:58:35  chenyl
* +: H.323 some RAS support (tested by OpenH323 Gatekeeper)
*
* Revision 1.24  2005/07/08 02:38:01  chenyl
* *: modify ip when doning RSVP NAPT in/out H.323 related process.
* *: Let RSVP callback function returning value to indicate RSVP process was been ignored if it don't do anything.
*
* Revision 1.23  2005/06/30 13:57:11  tony
* *: support for Vizufon VoIP Phone(H323).
*
* Revision 1.22  2005/06/01 13:56:18  tony
* *: support alg reinit.
*
* Revision 1.21  2004/12/22 05:19:15  tony
* +: support new features: make ALG(FTP,SIP,NetMeeting) support MNQueue.
*
* Revision 1.20  2004/12/06 09:02:14  tony
* *: disable server port entry PURE_SW check in ALG, move it to check in addNaptConnection
*
* Revision 1.19  2004/12/03 10:34:51  tony
* *: fix bug for hash2  napt server port entry can't assign correct nexthop.
*    put this napt entry to software.
*
* Revision 1.18  2004/10/12 11:51:36  tony
* *: fix h323 bug for video steam.
*
* Revision 1.17  2004/10/08 14:32:02  tony
* *: fix h245 bug.
*
* Revision 1.16  2004/10/08 03:23:48  tony
* *: support for CDRouter test case.
*
* Revision 1.15  2004/10/06 14:05:02  tony
* *: fix h323 bug for test case.
*
* Revision 1.14  2004/10/04 05:08:54  tony
* *: fix bug for NetMeeting Video in/out.
*
* Revision 1.13  2004/09/22 10:54:38  tony
* *: disable debug message
*
* Revision 1.12  2004/09/21 05:43:42  tony
* *: fix h323 bug for CDRouter test case.
*
* Revision 1.11  2004/09/14 10:37:14  yjlou
* *: fixed for CD-Router 2.2 test case FAIL: case 114 and 115.
*    114: sourceCallSignalAddress should be modified to ExtIP, too.
*    115: rtl8651_l4AliasHandleClientH245Out() should always modify to ExtIp if find_port() successes.
*
* Revision 1.10  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.9  2004/09/02 06:15:37  chenyl
* *: multicast :
* 	- when turning-on ip-multicast, periodic query will be sent immediately
* +: tbldrv
* 	- add options when run addNaptConnection
* 		- PURE_SW: pure software entry
* 		- DONT_CHECK_INTIP: ignore internal IP checking
* 		- TO_PROTOCOL_STACK: this napt packet must be trapped to protocol stack
* +: forwarding engine:
* 	- protocol stack TCP/UDP flow cache
* 	- napt redirect register/unregister/query
*
* Revision 1.8  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.7  2004/07/22 08:53:12  orlando
* fix a 'declare after statement' bug for easy porting, in rtl8651_l4AliasHandleClientH225In().
*
* Revision 1.6  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.5  2004/03/19 12:17:21  cfliu
* Rename all osk_malloc, printk, printf, printfByPolling as rtlglue_printf
*
* Revision 1.4  2004/03/16 12:58:56  tony
* make netmeeting alg support test module.
*
* Revision 1.3  2004/03/16 09:22:27  tony
* make netMeeting client is able to run with test module(endian free).
*
* Revision 1.2  2004/03/12 07:37:37  tony
* fix bug
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.19  2004/01/29 01:39:47  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.18  2004/01/15 13:35:33  tony
* make port 1503 is able to connect from many clients at the same time.
*
* Revision 1.17  2004/01/15 07:18:19  tony
* support incoming call for H323 ALG.
*
* Revision 1.16  2004/01/14 03:35:05  tony
* fix offset shift bug.
*
* Revision 1.15  2004/01/13 09:31:41  tony
* *** empty log message ***
*
* Revision 1.14  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.13  2003/12/31 05:50:41  tony
* small change
*
* Revision 1.12  2003/12/22 11:59:14  tony
* fix bug: unalignment issue.
*
* Revision 1.11  2003/12/19 11:40:01  tony
* change memcpy to rtl8651_memcpy
*
* Revision 1.10  2003/12/17 10:35:16  hiwu
* add checksum function
*
* Revision 1.9  2003/10/23 07:09:41  hiwu
* arrange include file sequence
*
* Revision 1.8  2003/10/21 08:07:02  tony
* add DoS attack log routine
*
* Revision 1.7  2003/10/20 07:27:43  tony
* fix H.323 ALG routine
*
* Revision 1.6  2003/10/20 05:12:06  hiwu
* add new h245 alg support
*
* Revision 1.5  2003/10/17 08:40:28  hiwu
* merge new function type
*
* Revision 1.4  2003/10/17 06:15:07  hiwu
* ADD nat support
*
* Revision 1.3  2003/10/02 10:39:52  hiwu
* fix header conflict problem
*
* Revision 1.2  2003/10/02 10:01:16  hiwu
* fix h323 tcp parser bug
*
* Revision 1.1  2003/10/02 07:08:11  hiwu
* initial version
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_h323.h"

#define H225_TUNNEL_SUPPORT 1

#define _RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE 576

#undef RTL_H323_RASDEBUG

static uint8 *_rtl8651_l4_h323_alias_buf[2]; 

static int32 init_h323 = FALSE;
static uint16 tempPort = 0;

static uint16 lastPort[4]={0};
static uint32 RsvpLocalIp = 0;
static uint32 RsvpGlobalIp = 0;


static int32 find_h245_id(uint8 *data, int32 datlen);
static int32 find_port (int32, uint8 *, int32 , int32 *, uint16 *);
//static int32 find_h245_id (uint8 *, int32 );

#if 0
/* ============================================================== 
		Data structures used by H.323 ALG
    ============================================================== */
#define H323_TPKT_VERSION		0x03
struct h323_tpktHdr {
	uint8	tpkt_ver;
	uint8	tpkt_reserv;
	uint16	tpkt_len;
};

#define H323_DISCRIMINATOR_Q931	0x08

#define H225_MSGTYPE_ALERTING					0x01
#define H225_MSGTYPE_CALLPROCEEDING			0x02
#define H225_MSGTYPE_CONNECT					0x07
#define H225_MSGTYPE_CONNECTACK				0x0f
#define H225_MSGTYPE_PROGRESS					0x03
#define H225_MSGTYPE_SETUP					0x05
#define H225_MSGTYPE_SETUPACK					0x0d

#define H225_IEI_UUIE							0x7e

/*
	rem:	remain total length of data
	ptr:		current pointer
	shift:	shift length
	exit:		if current length is not enough to shift, then jump to 'exit'
*/
#define PTR_SHIFT_EXIT(rem, ptr, shift, exit) \
	do { \
		if ((rem) <= (shift)) \
		{ \
			goto exit; \
		} \
		(rem) -= (shift); \
		(uint32)(ptr) += (uint32)(shift); \
	} while (0);

/* ============================================================== 
		Utility
    ============================================================== */

/* Function to parse H.225 CS Connect message to get Peer IP */

static void * _rtl8651_H225_getConnectPeerAddr(uint8 *data)
{
	void *ret = NULL;
	uint32 totalLen;
	uint8 *ptr = data;
	struct h323_tpktHdr *tpkt_p;

	/* H.225 Message: First of it would be TPKT header */
	tpkt_p = (struct h323_tpktHdr*)ptr;

	if (	(tpkt_p->tpkt_ver != H323_TPKT_VERSION) ||
		(tpkt_p->tpkt_reserv != 0) ||
		(htons(tpkt_p->tpkt_len) <= sizeof(struct h323_tpktHdr)))
	{
		goto out;
	}
	totalLen = htons(tpkt_p->tpkt_len);

	PTR_SHIFT_EXIT(totalLen, ptr, sizeof(struct h323_tpktHdr), out);

	/* "Protocol Discriminator " */
	{
		uint8 protoDiscriminator = *((uint8*)ptr);

		switch (protoDiscriminator)
		{
			case H323_DISCRIMINATOR_Q931:	/* Q.931 */
				PTR_SHIFT_EXIT(totalLen, ptr, sizeof(uint8), out);	/* size of "Protocol Discriminator ": 8 bits */
				break;
			default:
				goto out;
		}
	}
	/* "Length of call reference bits" */
	{
		uint8 ref_len = (*((uint8 *)ptr)) & 0x0f;	/* this field only has 4 bits */

		PTR_SHIFT_EXIT(totalLen, ptr, sizeof(uint8), out);	/* size of "Length of call reference bits": 8 bits */
		PTR_SHIFT_EXIT(totalLen, ptr, (sizeof(uint8)*ref_len), out);	/* skip Call reference information */
	}

	/* "Call message type" */
	{
		uint8 callMsgType = (*((uint8*)ptr)) & 0x7f;	/* this field has 7 bits (MSB is reserved) */

		switch (callMsgType)
		{
			case H225_MSGTYPE_CONNECT:
				PTR_SHIFT_EXIT(totalLen, ptr, sizeof(uint8), out);
				break;
			default:
				goto out;
		}
	}

	/* "Information elements" */
	{
		uint8 IEI = *((uint8*)ptr);

		switch (IEI)
		{
			case H225_IEI_UUIE:
				PTR_SHIFT_EXIT(totalLen, ptr, sizeof(uint8), out);
				/* get length of content for this IE */
				{
					uint16 ie_len = ntohs(*((uint16*)ptr));

					if (ie_len > totalLen)
					{
						goto out;
					}
				}
				
			default:
				goto out;
		}
	}

	/* Find magic number "0x0008914a": It's the protocol Identifier of H.225 */
	{
		uint8 h225Magic[] = {0x00, 0x08, 0x91, 0x4a};
		uint32 idx;

		for (idx = 3 ; idx < (totalLen - sizeof(h225Magic)) ; idx ++)
		{
			if (memcmp((&(ptr[idx])), h225Magic, sizeof(h225Magic)) == 0)
			{
				break;
			}
		}
		if (idx >= (totalLen - sizeof(h225Magic)))
			goto out;

		if (*(uint8*)(&ptr[idx - 3]) == 0x02)
		{
			PTR_SHIFT_EXIT(totalLen, ptr, (idx + sizeof(h225Magic)), out);
			if (*ptr == 0)
			{
				PTR_SHIFT_EXIT(totalLen, ptr, 1, out);
				if (totalLen >= 6)
				{
					ret = ptr;
					goto out;
				}
			}
		}
	}

out:
	return ret;
}
#endif

static int32 find_port(ipaddr, data, datlen, off, port)
int32 ipaddr;
uint8 *data;
int32 datlen, *off;
uint16 *port;
{
	uint32 addr;
	uint8 *dp;
	int32 offset;

	if (datlen < 6 || data == NULL)
		return -1;
	
	*port = 0;
	offset = *off;
	dp = (uint8 *)data;	

	for (offset = 0; offset <= datlen - 6; offset++, dp++) {
		addr = (dp[0] << 24) | (dp[1] << 16) | (dp[2] << 8) | dp[3];
		if (ipaddr == addr)
		{			
			*port = (uint16)((*(dp + 4) << 8) | *(dp + 5));
			//printk("netaddr=%u.%u.%u.%u datalen=%d port=%d\n",NIPQUAD(addr),datlen,*port);
			break;
		}
	}
	*off = offset;
  	return (offset > datlen - 6) ? -1 : 0;
}


#ifdef H225_TUNNEL_SUPPORT
/* if h245 id is in h22, it maybe a inband h245 signaling (huristic) */
static int32 find_h245_id(uint8 *data, int32 datlen)
{
	uint8 h245_id[] = { 0x08, 0x81, 0x75, 0x00  };

	uint32 id1, id2;
	uint8 *dp;
	int32 offset;

	if (datlen < 5 || data == NULL)
		return 0;
	
	offset = 0;
	dp = (uint8 *)data;
	id1 = (h245_id[0] << 24) | (h245_id[1] << 16) | (h245_id[2] << 8) | h245_id[3];

	for (offset = 0; offset <= datlen - 5; offset++, dp++) {
		id2 = (dp[0] << 24) | (dp[1] << 16) | (dp[2] << 8) | dp[3];
		if (id1 == id2 )
		{
			return 1;
		}
	}
	
  	return 0;
  }
#endif /* H225_TUNNEL_SUPPORT */

/* =======================================================================

		H.225 Process:

			There are several H.225 signalings we need to support:

				1. Gate keeper Discovery Port signal:				UDP/1718
					- To Known Address
					- To multicast Address
				2. RAS (Registration and Status Port) signal:		UDP/1719
				3. Call-Signaling:								TCP/1720

     ======================================================================= */

#define RTL865X_ALG_H323_H225

#define RTL865X_ALG_H323_H225_RAS

/* ==========================================
	H.225 Call signaling Message (UDP/1719)
    ========================================== */
int32 rtl8651_l4AliasHandleClientH225RASIn (
					struct rtl_pktHdr* pkthdrPtr,
					struct ip *iphdr,
					rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link)
{
	struct rtl_mBuf *mbuf = pkthdrPtr->ph_mbuf;
	struct udphdr *ud = NULL;
	struct ip *pip = NULL;
	uint8 *cp = NULL, *cp_end = NULL, *data = NULL;
	uint32 mins = mbuf->m_len, copied = 0, datalen = 0, hlen = 0, chksum_flag = FALSE;
	int32 offset = 0;
	uint16 port = 0;
	/* -------------------------------------------------------------------------------- 
			check if this packet can be process by callback function
	    -------------------------------------------------------------------------------- */

	if ( (alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING) == 0 )
	{
		goto out;
	}

	if (IS_FRAGMENT(iphdr->ip_off))
	{
		goto out;
	}

	if (iphdr->ip_p != IPPROTO_UDP)
	{
		assert(0);
		goto out;
	}

	ud = (struct udphdr *)L4HDR_ADDR(iphdr);

	/* -------------------------------------------------------------------------------- 
			copy packet content to ALIAS buffer
	    -------------------------------------------------------------------------------- */

	/* end of search */
	if (mins > _RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE)
	{
		mins = _RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	}

	cp = _rtl8651_l4_h323_alias_buf[0];

	copied = (int32)mBuf_copyToUserBuffer(	mbuf,
											0,
											mins,
											(int8 *)(_rtl8651_l4_h323_alias_buf[0]));
	cp_end = cp + copied;

	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset]);

	switch (pip->ip_p)
	{
		case IPPROTO_UDP:
			ud = (struct udphdr *)L4HDR_ADDR(pip);
			hlen = ((pip->ip_vhl & 0xf) + sizeof(struct udphdr));				/* IP + UDP header length */
			break;
		default:
			assert(0);
			return SUCCESS;
	}

	/* -------------------------------------------------------------------------------- 
			Start to process H.225 RAS signaling
	    -------------------------------------------------------------------------------- */

	data = &_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset + hlen];
	datalen = copied - hlen;

	while (find_port(link->insideGlobalIpAddr, data, datalen, &offset, &port) == 0 )
	{
		/* change tcp check sum */
		chksum_flag = TRUE;
#ifdef RTL_H323_RASDEBUG
		rtlglue_printf("[DATA IN] %u.%u.%u.%u(%d) -- connect back to LAN-endpoint.\n\t=>We modify IP to %u.%u.%u.%u.\n",
						NIPQUAD(link->insideGlobalIpAddr), port,
						NIPQUAD(link->insideLocalIpAddr));
#endif
		/* modify IP */
		PKTSET_UINT32_UNALIGNED(link->insideLocalIpAddr, (uint8*)&(data[offset]));

		/* find NEXT */
		if (datalen < (offset + 6))
		{
			break;
		}
		data += (6+offset);
		datalen -= (6+offset);
		offset = 0;
	}

	/* -------------------------------------------------------------------------------- 
			End of Proc:
				1. recalculate checksum
				2. write back
	    -------------------------------------------------------------------------------- */

	if (chksum_flag)
	{
		/* Compute TCP/UDP/IP checksum for revised packet */
		if (!IPHDRLEN_IS_TWENTY(pip))
		{
			pip->ip_sum = 0;
			if (ud->uh_sum)
			{
				ud->uh_sum = 0;
				ud->uh_sum = _rtl8651_tcpChecksum(pip);
			}
			pip->ip_sum = _rtl8651_ipChecksum(pip);
		}
	}

	mBuf_copyToMbuf(mbuf, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[0]);

out:
	return SUCCESS;
}

int32 rtl8651_l4AliasHandleClientH225RASOut (
					struct rtl_pktHdr* pkthdrPtr,
					struct ip *iphdr,
					rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link)
{
	struct rtl_mBuf *mbuf = pkthdrPtr->ph_mbuf;
	struct udphdr *ud = NULL;
	struct ip *pip = NULL;
	uint8 *cp = NULL, *cp_end = NULL, *data = NULL;
	uint32 mins = mbuf->m_len, copied = 0, datalen = 0, hlen = 0, chksum_flag = FALSE;
	int32 offset = 0;
	uint16 port = 0;

	/* -------------------------------------------------------------------------------- 
			check if this packet can be process by callback function
	    -------------------------------------------------------------------------------- */
	if ( (alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING) == 0 )
	{
		goto out;
	}
	if (IS_FRAGMENT(iphdr->ip_off))
	{
		goto out;
	}
	if (iphdr->ip_p != IPPROTO_UDP)
	{
		assert(0);
		goto out;
	}

	/* -------------------------------------------------------------------------------- 
			copy packet content to ALIAS buffer
	    -------------------------------------------------------------------------------- */

	/* end of search */
	if (mins > _RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE)
	{
		mins = _RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	}

	cp = _rtl8651_l4_h323_alias_buf[0];

	copied = (int32)mBuf_copyToUserBuffer(	mbuf,
											0,
											mins,
											(int8 *)(_rtl8651_l4_h323_alias_buf[0]));
	cp_end = cp + copied;

	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset]);

	switch (pip->ip_p)
	{
		case IPPROTO_UDP:
			ud = (struct udphdr *)L4HDR_ADDR(pip);
			hlen = ((pip->ip_vhl & 0xf) + sizeof(struct udphdr));				/* IP + UDP header length */
			break;
		default:
			assert(0);
			return SUCCESS;
	}

	/* -------------------------------------------------------------------------------- 
			Start to process H.225 RAS signaling
	    -------------------------------------------------------------------------------- */

	/* Find information to modify IP/Port */
	data = &_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset + hlen];
	datalen = copied - hlen;

	while (find_port (link->insideLocalIpAddr, data, datalen, &offset, &port) == 0)
	{
		chksum_flag = TRUE;

		if (port == link->insideGlobalPort)
		{
			/*
				We only modify IP to public one. No any napt/upnp entry need to be added.
			*/
#ifdef RTL_H323_RASDEBUG
			rtlglue_printf("[DATA OUT] %u.%u.%u.%u(%d)\n\t=>We modify IP to %u.%u.%u.%u.\n",
							NIPQUAD(link->insideLocalIpAddr), port,
							NIPQUAD(link->insideGlobalIpAddr));
#endif
		} else if (port == link->insideLocalPort)
		{
			/*
				We modify both IP and Port to public one, IP would be modified at below, so we change Port here.
			*/
#ifdef RTL_H323_RASDEBUG
			rtlglue_printf("[DATA OUT] %u.%u.%u.%u(%d)\n\t=>We modify IP/Port to %u.%u.%u.%u(%d).\n",
							NIPQUAD(link->insideLocalIpAddr), port,
							NIPQUAD(link->insideGlobalIpAddr), link->insideGlobalPort);
#endif
			data[offset + sizeof(ipaddr_t)] = (htons(link->insideGlobalPort)) >> 8;
			data[offset + sizeof(ipaddr_t) + 1] = (htons(link->insideGlobalPort)) & 0xff;
		} else
		{
			/*
				We need to modify IP to public and must add a new napt entry for incoming traffic.
			*/

			uint32 retval;
#ifdef RTL_H323_RASDEBUG
			rtlglue_printf("[ALLOW IN] %u.%u.%u.%u(%d) -- allow other H.323 endpoints to connect back.\n\t=>We modify IP to %u.%u.%u.%u and add NAPT for new calls\n",
							NIPQUAD(link->insideLocalIpAddr), port,
							NIPQUAD(link->insideGlobalIpAddr));
#endif
#if 0
			rtl8651_addUpnpMap(	UPNP_TCP,
									0,
									0,
									link->insideGlobalIpAddr, port,
									link->insideLocalIpAddr, port);
#else
			if ((retval = _rtl8651_addNaptConnection(	TRUE, (TRUE|PURE_SW),
													TCP_LISTEN_FLOW,
													link->insideLocalIpAddr, port,
													&link->insideGlobalIpAddr,&port,
													0, 0)) != SUCCESS)
			{
				if (retval != TBLDRV_EDRVNAPTEXIST)
				{
					goto out;
				}
#ifdef RTL_H323_RASDEBUG
				rtlglue_printf("[INFO] Napt connection INT %u.%u.%u.%u(%d) : GLB %u.%u.%u.%u(%d) exists\n",
							NIPQUAD(link->insideLocalIpAddr), port,
							NIPQUAD(link->insideGlobalIpAddr), port);
#endif
			}
#endif
		}

		/* modify IP */
		PKTSET_UINT32_UNALIGNED(link->insideGlobalIpAddr, ((uint8*)&(data[offset])));

		/* find NEXT */
		if (datalen < (offset + 6))
		{
			break;
		}
		data += (6+offset);
		datalen -= (6+offset);
		offset = 0;
	}

	/* -------------------------------------------------------------------------------- 
			End of Proc:
				1. recalculate checksum
				2. write back
	    -------------------------------------------------------------------------------- */

	if (chksum_flag)
	{
		/* Compute TCP/UDP/IP checksum for revised packet */
		if (!IPHDRLEN_IS_TWENTY(pip))
		{
			pip->ip_sum = 0;
			if (ud->uh_sum)
			{
				ud->uh_sum = 0;
				ud->uh_sum = _rtl8651_tcpChecksum(pip);
			}
			pip->ip_sum = _rtl8651_ipChecksum(pip);
		}
	}

	mBuf_copyToMbuf(mbuf, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[0]);

out:
	return SUCCESS;
}

int32 rtl8651_l4AliasHandleClientH225CSIn(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct in_addr ipaddr;
	int32 off;
	uint16 port;
	uint8 *data;
	struct tcphdr *tcp;
	int32     tlen;
	uint8 *cp;
	uint8 *cp_end;
	int32 copied = 0;
	struct rtl_mBuf *m=NULL;
	uint8 chksum_flag=0;
	uint32 mins;
	int32     hlen,datalen;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	

	m = (struct rtl_mBuf *)pkthdrPtr->ph_mbuf;
	mins=m->m_len;

	//tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));

	ipaddr.s_addr = PKTGET_UINT32_UNALIGNED(&pip->ip_src);

	//data = (uint8 *)tcp + ((tcp->th_off_x & 0xf0)>>2) ;
	tlen = ntohs(pip->ip_len);
	
	/* end of search */

	if(mins>_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE) mins=_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	cp = _rtl8651_l4_h323_alias_buf[0];
	copied = (int32)mBuf_copyToUserBuffer((struct rtl_mBuf *)m, (uint32)0, mins, (int8 *)(_rtl8651_l4_h323_alias_buf[0]));
	cp_end = cp + copied;		

	
	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset]);
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));

	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;	

	
	data = ((uint8 *)pip)+hlen;
	
	datalen = copied - hlen;

	

#ifdef H225_TUNNEL_SUPPORT	


//	if (tlen < 50 )/* packet len should more than 50 bytes (huristic) */
//		return SUCCESS;

	/* now test if h245 is inband or outband (huristic) */	
	if( link->h245tunnel || 		
		(find_h245_id(data,datalen)) ){
		/* inband process */
		link->h245tunnel = 1;
		return SUCCESS;
	}
#endif /* H225_TUNNEL_SUPPORT */
		
	/*trap and hook outband h245 process */	
	off = cp - data;

	/* replace ip address and port in H.225  Setup-UUIE */

	if (find_port(ipaddr.s_addr, data, datalen, &off, &port) == 0) {

	{
		uint32 addr_1;
		uint16 port_1;
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;
		int32 r;
		
		addr_1 = link->insideGlobalIpAddr;
		port_1 = link->insideLocalPort+1;
		
		//printk("findport  addnapt=Global:%x:%d Local:%x link->dstIpAddr=%x:%d\n",addr_1,port_1,link->insideLocalIpAddr,link->dstIpAddr,port);
		
			/* Establish link to address and port found in H245 control message. */
			//// _rtl8651_addAlgCtrlConnection
				

			r = _rtl8651_addNaptConnection(TRUE,(TRUE|PURE_SW), TCP_LISTEN_FLOW,
				link->insideLocalIpAddr,link->insideLocalPort+1,
				&addr_1,&port_1,
				link->dstIpAddr,port);	
				
			/* h245 entry cannot establish */
			if(r){
				goto end_proc;
			}

		if(_rtl8651_getOutboundNaptFlow(TRUE,link->insideLocalIpAddr,link->insideLocalPort+1, 
				link->dstIpAddr,port,&tb)!=SUCCESS) 
			{			
				/* 245 entry cannot establish */
				goto end_proc;
			}					
			//printk("lport=%x gport=%x rpport=%x\n",tb->insideLocalPort,tb->insideGlobalPort,tb->dstPort);
			tb->alg_client_out = rtl8651_l4AliasHandleClientH245Out;
			tb->alg_client_in = rtl8651_l4AliasHandleClientH245In;

	}

}
end_proc:


	while( find_port(link->insideGlobalIpAddr, data, datalen, &off, &port) ==0 ) {
		

		/* change tcp check sum */
		
		chksum_flag = 1;
		data[off]=(link->insideLocalIpAddr>>24)&0xff;
		data[off+1]=(link->insideLocalIpAddr>>16)&0xff;
		data[off+2]=(link->insideLocalIpAddr>>8)&0xff;
		data[off+3]=(link->insideLocalIpAddr)&0xff;		
//		printk("h225 in port=%d\n",port);
		
		//port = 0;		
		data+=(off+6);
		datalen-=(off+6);		
		off = 0;
	}	

	if(chksum_flag){
		/* Compute TCP checksum for revised packet */
		/* Compute TCP/IP checksum for revised packet */
		if((pip->ip_vhl & 0xf)!=5)
		{
			tcp->th_sum = 0;
			pip->ip_sum = 0;				
			tcp->th_sum = _rtl8651_tcpChecksum(pip);
			pip->ip_sum = _rtl8651_ipChecksum(pip);		
		}
	}

	mBuf_copyToMbuf(m, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[0]);


	return SUCCESS;
}


int32 rtl8651_l4AliasHandleClientH225CSOut(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{

	uint8 *data;
	struct tcphdr *tcp;
	int32  tlen;
	uint8 *cp;
	uint8 *cp_end;
	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;
	int32     hlen,datalen;
	int32 copied = 0;
	int32 off=0;
	uint16 result_port=0;
	uint8 chksum_flag=0;
	uint32 mins=m->m_len;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	

	
	tcp = (struct tcphdr *)(struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));

	data = (uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2);
	tlen = ntohs(pip->ip_len);
	
	/* end of search */
//	cp_end = m->m_data + m->m_len;
//	cp = data;

	if(mins>_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE) mins=_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	//printk("   tlen > m->m_len _rtl8651_l4_h323_alias_buf[0]=%x\n",_rtl8651_l4_h323_alias_buf[0]);
	cp = _rtl8651_l4_h323_alias_buf[0];
	copied = (int32)mBuf_copyToUserBuffer((struct rtl_mBuf *)m, (uint32)0, mins, (int8 *)(_rtl8651_l4_h323_alias_buf[0]));
	cp_end = cp + copied;		


	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset]);
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));

	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;	
	
	data = &_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset+hlen];
	datalen = copied - hlen;

	//printk("ip=%x datalen=%d\n",link->insideLocalIpAddr,datalen);
	while( find_port(link->insideLocalIpAddr, data, datalen, &off, &result_port) ==0 ) {
	
		/* change tcp check sum */
		//printk("change ip......\n");
		chksum_flag = 1;
		data[off]=(link->insideGlobalIpAddr>>24)&0xff;
		data[off+1]=(link->insideGlobalIpAddr>>16)&0xff;
		data[off+2]=(link->insideGlobalIpAddr>>8)&0xff;
		data[off+3]=(link->insideGlobalIpAddr)&0xff;		
		//result_port = 0;
		data+=(6+off);
		datalen-=(6+off);		
		off=0;
	}	

	data = &_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset+hlen];
	datalen = copied - hlen;
	while( find_port(link->insideGlobalIpAddr, data, datalen, &off, &result_port) ==0 ) {
	
//		printk("h225 %x port=%d\n",link->insideGlobalIpAddr,result_port);
		_rtl8651_addAlgQosNaptConnection(TRUE, TRUE|ALG_QOS|DO_REDUNDANCY_CHECK,UDP_FLOW, link->insideLocalIpAddr, result_port, &link->insideGlobalIpAddr, &result_port,0,0,RTL8651_ALG_NETMEETING_IDX);
		
		data+=(6+off);
		datalen-=(6+off);		
		off=0;
	}


#ifdef H225_TUNNEL_SUPPORT
	/* now test if h245 is inband or outband */
	/* h225 packet with h245 id; so it is inband control  (huristic) */
	if( link->h245tunnel || 
		find_h245_id(cp,cp_end-cp) ){
		/* inband process */
		//printk("   find_h245_id(cp,cp_end-cp)=%d\n",find_h245_id(cp,cp_end-cp) );
		link->h245tunnel = 1;
		//printk("  call rtl8651_l4AliasHandleClientH245Out\n");
		rtl8651_l4AliasHandleClientH245Out(pkthdrPtr,pip,link);
	}
#endif	/* H225_TUNNEL_SUPPORT */


	if(chksum_flag){
		/* Compute TCP checksum for revised packet */
		/* Compute TCP/IP checksum for revised packet */
		if((pip->ip_vhl & 0xf)!=5)
		{
			tcp->th_sum = 0;
			pip->ip_sum = 0;				
			tcp->th_sum = _rtl8651_tcpChecksum(pip);
			pip->ip_sum = _rtl8651_ipChecksum(pip);		
		}	
	}

	mBuf_copyToMbuf(m, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[0]);

	/* store RSVP ip information when processing H.225 signaling */
	RsvpLocalIp = link->insideLocalIpAddr;
	RsvpGlobalIp = link->insideGlobalIpAddr;

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleClientH245In(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
				struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
#if 0
	int32 off=0, datlen;
	uint16 result_port;
	uint8 *data = NULL;
	struct tcphdr *tcp = NULL;
	int32     hlen;
	int portIdx=0;
	

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	

	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;		
	data = (uint8*)pip+hlen;
	datlen =ntohs(pip->ip_len)  - hlen;

	memset(lastPort,0,sizeof(uint16)*4);
	
	while( find_port(link->dstIpAddr, data, datlen, &off, &result_port) ==0 ) {

		if(ntohs(result_port)==1503)
		goto ClientH245In_break;
					

		lastPort[portIdx]=result_port;
		portIdx++;
		
		//printk("client h245 in %x:%d\n",link->insideGlobalIpAddr,result_port);


ClientH245In_break:
		data+=(off+6);
		datlen-=(off+6);
		result_port = 0;
		off = 0;
	}
	
#endif
	return SUCCESS;

}

/* a relax verion; hardware accelerate will be disable */
int32 rtl8651_l4AliasHandleClientH245Out(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
				struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct in_addr ipaddr_org;
	int32 off=0, datlen;
	uint16 result_port;
	uint8 *data = NULL;
	struct tcphdr *tcp = NULL;
	int32     hlen;
	int32 chksum_flag = 0;
	int32 copied = 0;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;

	uint32 mins;
	int portIdx=0;
	struct rtl_mBuf *m;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	


	m  = pkthdrPtr->ph_mbuf;
	mins=m->m_len;
	if(mins>_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE) mins=_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	copied = (int32)mBuf_copyToUserBuffer((struct rtl_mBuf *)m, (uint32)0, mins, (int8 *)(_rtl8651_l4_h323_alias_buf[0]));
	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset]);
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;	
	
	data = &_rtl8651_l4_h323_alias_buf[0][pkthdrPtr->ph_iphdrOffset+hlen];
	datlen = copied - hlen;
	
	ipaddr_org.s_addr  = link->insideLocalIpAddr;
			
	while( find_port(ipaddr_org.s_addr, data, datlen, &off, &result_port) ==0 ) {

		/* change tcp check sum */
		chksum_flag = 1;
		data[off]=(link->insideGlobalIpAddr>>24)&0xff;
		data[off+1]=(link->insideGlobalIpAddr>>16)&0xff;
		data[off+2]=(link->insideGlobalIpAddr>>8)&0xff;
		data[off+3]=(link->insideGlobalIpAddr)&0xff;	

		if ( result_port == 1503 )  goto end_aliash245Out;
	
		if(link->natlink == 0){

			if(_rtl8651_getOutboundNaptFlow(FALSE,link->insideLocalIpAddr,result_port,link->dstIpAddr,lastPort[portIdx],  &tb)==SUCCESS){
				_rtl8651_delNaptConnection(tb);							
			}

#if 0
			if( lastPort[portIdx])
				_rtl8651_addNaptConnection(TRUE, TRUE,UDP_FLOW, link->insideLocalIpAddr,result_port,  &link->insideGlobalIpAddr, &result_port,link->dstIpAddr, lastPort[portIdx]);
			else
#else
				//delete existed hash 1 entry.
				_rtl8651_removeNaptConnectionByIntIPandPort(FALSE,link->insideLocalIpAddr,result_port);
#endif
				_rtl8651_addAlgQosNaptConnection(TRUE, TRUE|ALG_QOS,UDP_FLOW, link->insideLocalIpAddr, result_port, &link->insideGlobalIpAddr, &result_port,0,0,RTL8651_ALG_NETMEETING_IDX);
				
/*
				rtl8651_addUpnpMap(UPNP_ONESHOT , link->dstIpAddr, 0, 
					link->insideGlobalIpAddr, result_port,
					link->insideLocalIpAddr, result_port);
*/
			
			//printk("client h245 out %x:%d %d\n",link->insideGlobalIpAddr,result_port,lastPort[portIdx]);
			portIdx++;
		}			
				
		
end_aliash245Out:		
		data+=(off+6);
		datlen-=(off+6);
		result_port = 0;
		off = 0;
	}


	if(chksum_flag){
		/* Compute TCP checksum for revised packet */
		/* Compute TCP/IP checksum for revised packet */
		tcp->th_sum = 0;
		pip->ip_sum = 0;				
		tcp->th_sum = _rtl8651_tcpChecksum(pip);
		pip->ip_sum = _rtl8651_ipChecksum(pip);		
	}

	mBuf_copyToMbuf(m, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[0]);
	
	return SUCCESS;

}

static int32 _rtl8651_l4RsvpNaptAliasIn(struct rtl_pktHdr *pkthdrPtr,struct ip * pip)
{
	int32 retval = FWDENG_RSVP_IGNORE;
	uint8 *data=NULL,*dp;
	uint32 dip,addr,offset;
	uint16 datlen,port;

	
	if ((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING) == 0 )
	{
		goto out;
	}

	if (RsvpLocalIp == 0)
	{
		goto out;
	}

	dip = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);

	data = (uint8*)((uint8 *) pip + ((pip->ip_vhl &0xf) << 2));
	datlen = (uint32)data-(uint32)pip;
	dp = data;

	for (offset = 0; offset < datlen - 8; offset++, dp++)
	{
		addr = (dp[0] << 24) | (dp[1] << 16) | (dp[2] << 8) | dp[3];
		if (dip == addr)
		{
			port = (uint16)((*(dp + 6) << 8) | *(dp + 7));
			if (	_rtl8651_addAlgQosNaptConnection(	TRUE, 
													TRUE|ALG_QOS|DO_REDUNDANCY_CHECK,
													UDP_FLOW,
													RsvpLocalIp, port,
													&addr, &port,
													0,0,
													RTL8651_ALG_NETMEETING_IDX) == SUCCESS)
			{
				PKTSET_UINT32_UNALIGNED(RsvpLocalIp, &(pip->ip_dst));
				retval = SUCCESS;
				/* continue and call 'goto out;' */
			}
			goto out;
		}
	}	

out:
	return retval;
}


static int32 _rtl8651_l4RsvpNaptAliasOut(struct rtl_pktHdr *phdr,struct ip * pip)
{

	if ((alg_supports[phdr->ph_dsid]&RTL8651_ALG_NETMEETING) == 0 )
	{
		return FWDENG_RSVP_IGNORE;
	}

	if (RsvpGlobalIp != 0)
	{
		PKTSET_UINT32_UNALIGNED(RsvpGlobalIp, &pip->ip_src);
		return SUCCESS;
	}

	return FWDENG_RSVP_IGNORE;	
}

void rtl8651_l4AliasH323ReInit(void)
{
	/* reset all variables */
	tempPort = 0;
	RsvpLocalIp = 0;
	RsvpGlobalIp = 0;

	rtl8651_l4RsvpNaptAliasIn = _rtl8651_l4RsvpNaptAliasIn;
	rtl8651_l4RsvpNaptAliasOut = _rtl8651_l4RsvpNaptAliasOut;

}

int32 rtl8651_l4AliasH323Init(void *arg)
{
	
	
	/* malloc global variable */
	if (init_h323 == TRUE)
	{
		goto init_para;
		return SUCCESS;
	}
		
	init_h323 = TRUE;
	_rtl8651_l4_h323_alias_buf[0] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE+64);
	_rtl8651_l4_h323_alias_buf[1] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE+64);
	assert(_rtl8651_l4_h323_alias_buf[0]);
	assert(_rtl8651_l4_h323_alias_buf[1]);

	memset(_rtl8651_l4_h323_alias_buf[0], 0, sizeof(_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE+64));
	memset(_rtl8651_l4_h323_alias_buf[1], 0, sizeof(_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE+64));


init_para:

	rtl8651_l4AliasH323ReInit();	/* parameters initialization */

	return SUCCESS;
}

int32 rtl8651_l4AliasHandleServerH225RASIn (
					struct rtl_pktHdr* pkthdrPtr,
					struct ip *pip,
					rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link)
{
	if ( (alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING) == 0 )
	{
		goto out;
	}

	/* do NOTHING */

out:
	return SUCCESS;
}

int32 rtl8651_l4AliasHandleServerH225RASOut (
					struct rtl_pktHdr* pkthdrPtr,
					struct ip *pip,
					rtl8651_tblDrv_naptTcpUdpFlowEntry_t *link)
{
	if ( (alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING) == 0 )
	{
		goto out;
	}

	/* do NOTHING */

out:
	return SUCCESS;
}


//for ALG incoming call
int32 rtl8651_l4AliasHandleServerH225CSOut(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	//uint8 *data;
	struct tcphdr *tcp;
	int32  tlen,hlen,dlen;
	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;
	int32 copied = 0;
	int  off;
	uint16 result_port;
	uint32 mins;
	uint8 *data=NULL;
	uint32 datalen=0;
	uint8 chksum_flag=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	
	
	tcp = (struct tcphdr *)(struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;		

//	printk("h225 server out \n");
	mins=m->m_len;
	if(mins>_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE) mins=_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	
	copied = mBuf_copyToUserBuffer(m, 0,
		mins, 
		(int8 *)_rtl8651_l4_h323_alias_buf[1]);


	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[1][pkthdrPtr->ph_iphdrOffset]);
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;	
		
	data = &_rtl8651_l4_h323_alias_buf[1][pkthdrPtr->ph_iphdrOffset+hlen];
	datalen = copied - hlen;

	while(find_port(link->insideLocalIpAddr, data, datalen, &off, &result_port) ==0)
	{
		data[off]=(link->insideGlobalIpAddr>>24)&0xff;
		data[off+1]=(link->insideGlobalIpAddr>>16)&0xff;
		data[off+2]=(link->insideGlobalIpAddr>>8)&0xff;
		data[off+3]=(link->insideGlobalIpAddr)&0xff;				
//		printk("packet modify 225out port=%d!\n",result_port);
		tempPort=result_port;				

#ifdef _RTL_UPNP
		rtl8651_addUpnpMap(UPNP_ONESHOT|UPNP_TCP , link->dstIpAddr, 0, 
			link->insideGlobalIpAddr, 17200,
			link->insideLocalIpAddr, result_port);
#endif // _RTL_UPNP

		
		result_port=17200;
		data[off+4]=(result_port>>8)&0xff;
		data[off+5]=(result_port)&0xff;
		chksum_flag=1;		
		data+=(off+6);
		datalen-=(off+6);
		off = 0;
	}		


	data = &_rtl8651_l4_h323_alias_buf[1][pkthdrPtr->ph_iphdrOffset+hlen];
	datalen = copied - hlen;

	while(find_port(link->insideGlobalIpAddr, data, datalen, &off, &result_port) ==0)
	{
//		printk("225 server out port=%u!\n",result_port);
		_rtl8651_addAlgQosNaptConnection(TRUE, TRUE|ALG_QOS|DO_REDUNDANCY_CHECK,UDP_FLOW, link->insideLocalIpAddr, result_port, &link->insideGlobalIpAddr, &result_port,0,0,RTL8651_ALG_NETMEETING_IDX);
		data+=(off+6);
		datalen-=(off+6);
		off = 0;
	}


	if(chksum_flag){
		/* Compute TCP checksum for revised packet */
		/* Compute TCP/IP checksum for revised packet */
		if((pip->ip_vhl & 0xf)!=5)
		{
			tcp->th_sum = 0;
			pip->ip_sum = 0;				
			tcp->th_sum = _rtl8651_tcpChecksum(pip);
			pip->ip_sum = _rtl8651_ipChecksum(pip);		
		}		
	}

	mBuf_copyToMbuf(m, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[1]);
	
	return SUCCESS;

}

int32 rtl8651_l4AliasHandleServerH225CSIn(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{

	//uint8 *data;
	struct tcphdr *tcp;
	int32  tlen,hlen,dlen;
	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;
	int32 copied = 0;
	int  off;
	uint16 result_port;
	uint32 mins;
	uint8 chksum_flag=0;
	uint8 *data;
	uint32 datalen=0;


	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	
	
	tcp = (struct tcphdr *)(struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;		
	//data = (uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2);
//	printk("h225 server in \n");
	mins=m->m_len;
	if(mins>_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE) mins=_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;

	copied = mBuf_copyToUserBuffer(m, 0,
		mins, 
		(int8 *)_rtl8651_l4_h323_alias_buf[1]);

	pip = (struct ip *)(&_rtl8651_l4_h323_alias_buf[1][pkthdrPtr->ph_iphdrOffset]);
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;	
	
	data = &_rtl8651_l4_h323_alias_buf[1][pkthdrPtr->ph_iphdrOffset+hlen];
	datalen = copied - hlen;
	

	while(find_port(link->insideGlobalIpAddr, data, datalen, &off, &result_port) ==0)
	{
		data[off]=(link->insideLocalIpAddr>>24)&0xff;
		data[off+1]=(link->insideLocalIpAddr>>16)&0xff;
		data[off+2]=(link->insideLocalIpAddr>>8)&0xff;
		data[off+3]=(link->insideLocalIpAddr)&0xff;	

//		printk("h225 in.................find port=%u\n",result_port);
		//printk("packet modify 225in!\n");
		chksum_flag=1;
		data+=(6+off);
		datalen-=(6+off);			
		off=0;
	}


	if(chksum_flag){
		/* Compute TCP checksum for revised packet */
		/* Compute TCP/IP checksum for revised packet */
		if((pip->ip_vhl & 0xf)!=5)
		{
			tcp->th_sum = 0;
			pip->ip_sum = 0;				
			tcp->th_sum = _rtl8651_tcpChecksum(pip);
			pip->ip_sum = _rtl8651_ipChecksum(pip);		
		}
	}

	mBuf_copyToMbuf(m, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[1]);

	
	return SUCCESS;
}


int32 rtl8651_l4AliasHandleServerH245Out(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
				struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{

	//uint8 *data;
	struct tcphdr *tcp;
	int32  tlen,hlen,dlen;
	struct rtl_mBuf *m = pkthdrPtr->ph_mbuf;
	int32 copied = 0;
	int  off;
	uint16 result_port;
	int offset=0;
	int mins;
	uint8 *data;
	int portIdx=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	

	tcp = (struct tcphdr *)(struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen =((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;
	tlen = ntohs(pip->ip_len);
	dlen = tlen - hlen;		

//	printk("h245 server out \n");
	mins=m->m_len;
	if(mins>_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE) mins=_RTL8651_L4_MAX_H323_ALIAS_BUF_SIZE;
	
	copied = mBuf_copyToUserBuffer(m, 0,
		mins, 
		(int8 *)_rtl8651_l4_h323_alias_buf[1]);

	data = &_rtl8651_l4_h323_alias_buf[1][pkthdrPtr->ph_iphdrOffset+hlen];

	while(find_port(link->insideLocalIpAddr, &data[offset], mins-pkthdrPtr->ph_iphdrOffset-hlen-offset, &off, &result_port) ==0)
	{
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s entry, *tb = &entry;
		data[off+offset]=(link->insideGlobalIpAddr>>24)&0xff;
		data[1+off+offset]=(link->insideGlobalIpAddr>>16)&0xff;
		data[2+off+offset]=(link->insideGlobalIpAddr>>8)&0xff;
		data[3+off+offset]=(link->insideGlobalIpAddr)&0xff;

//		printk("found port ...........%u\n",result_port);

		if(result_port==1503) goto H245Out_break;

		if(_rtl8651_getOutboundNaptFlow(FALSE,link->insideLocalIpAddr,result_port,link->dstIpAddr,lastPort[portIdx],  &tb)==SUCCESS){
			_rtl8651_delNaptConnection(tb);							
		}

#if 0
		if(lastPort[portIdx])
			_rtl8651_addNaptConnection(TRUE, TRUE,UDP_FLOW, link->insideLocalIpAddr, result_port, &link->insideGlobalIpAddr, &result_port,link->dstIpAddr, lastPort[portIdx]);
		else
#else
			//delete existed hash 1 entry.
			_rtl8651_removeNaptConnectionByIntIPandPort(FALSE,link->insideLocalIpAddr,result_port);			
			//printk("r=%d localip %x:%d\n",r,link->insideLocalIpAddr,result_port);
			
#endif
			_rtl8651_addAlgQosNaptConnection(TRUE, TRUE|ALG_QOS|DO_REDUNDANCY_CHECK,UDP_FLOW, link->insideLocalIpAddr, result_port, &link->insideGlobalIpAddr, &result_port,0,0,RTL8651_ALG_NETMEETING_IDX);

/*
			rtl8651_addUpnpMap(UPNP_ONESHOT , link->dstIpAddr, 0, 
				link->insideGlobalIpAddr, result_port,
				link->insideLocalIpAddr, result_port);
*/				

		//printk("server h245 out %x:%d last:%d\n",link->insideGlobalIpAddr,result_port,lastPort[portIdx]);
		portIdx++;

H245Out_break:

		mBuf_copyToMbuf(m, 0,copied,(int8 *)_rtl8651_l4_h323_alias_buf[1]);
		offset+=(6+off);
	}			
	return SUCCESS;


}


int32 rtl8651_l4AliasHandleServerH245In(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
				struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
#if 0
	int32 off=0, datlen;
	uint16 result_port;
	uint8 *data = NULL;
	struct tcphdr *tcp = NULL;
	int32     hlen;
	int portIdx=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_NETMEETING)==0) return SUCCESS;	

	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2 ;		
	data = (uint8*)pip+hlen;
	datlen =ntohs(pip->ip_len)  - hlen;

	memset(lastPort,0,sizeof(uint16)*4);
			
	while( find_port(link->dstIpAddr, data, datlen, &off, &result_port) ==0 ) {

		if(ntohs(result_port)==1503)
		goto ServerH245In_break;
					
#ifdef _RTL_UPNP

		/* add PNP port map */
		if(link->natlink == 0){
			//uint16 gport=result_port-70;
			lastPort[portIdx]=result_port;
			portIdx++;
			//_rtl8651_addNaptConnection(TRUE, TRUE,UDP_FLOW, link->insideLocalIpAddr, gport, &link->insideGlobalIpAddr, &gport,link->dstIpAddr, result_port);			
			//printk("server h245 in %x:%d\n",link->insideGlobalIpAddr,result_port);					
		}
#endif /* _RTL_UPNP */

ServerH245In_break:
		data+=(off+6);
		datlen-=(off+6);
		result_port = 0;
		off = 0;
	}

#endif	
	return SUCCESS;

}



