/*
* Copyright c                  Realtek Semiconductor Corporation, 2003  
* All rights reserved.
* 
* Program :  ICQ ALG (support  for ICQ Protocol Ver 8)
* Abstract : 
* Creator : 
* Author :
* $Id: rtl8651_alg_icq.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_icq.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.7  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.6  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.5  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.4  2004/03/18 09:22:26  tony
* add alg reinit function, it will be called when fwdEng ReInit.
*
* Revision 1.3  2004/03/12 07:39:07  tony
* fix ICQ ALG bugs, and open a port for AIM Protocol
*
* Revision 1.2  2004/03/04 10:31:25  tony
* fix ICQ ALG bug and make it support module test.
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.6  2004/02/11 10:01:54  tony
* change memcpy to rtl8651_memcpy
*
* Revision 1.5  2004/01/29 01:39:47  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.4  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.3  2003/12/22 07:21:53  tony
* fix bug: unalignment issue appears in ICQ ALG.
*
* Revision 1.2  2003/11/27 12:14:30  tony
* update ICQ ALG: support for ICQ 2003b
*
* Revision 1.1  2003/11/13 12:28:53  tony
* add ALG ICQ (for version 2000b~2003b)
*
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_icq.h"
static int client_session=0;
static ipaddr_t localip=0;

int32 rtl8651_l4AliasHandleIcqClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	struct icq_command *icq;
	struct icq_command2 *icq2;	
	int32 hlen, tlen, dlen, idx=0;
	uint8 *payload;
	char buf[1500];	

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_ICQ)==0) return SUCCESS;	

	//for AIM
#ifdef _RTL_UPNP
	if(localip!=tb->insideLocalIpAddr)
	{
		localip=tb->insideLocalIpAddr;
		/* add PNP port map */
		rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
			tb->insideGlobalIpAddr, 5190,
			tb->insideLocalIpAddr, 5190);
	}
#endif /* _RTL_UPNP */
	
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	payload = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));	
	
	tlen = ntohs(pip->ip_len); //total_length
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2; // IP+TCP header length
	dlen = tlen - hlen; //data_length

	while(idx+sizeof(struct icq_command)<dlen)
	{
		rtl8651_memcpy(buf,payload+idx,dlen-idx);
		icq = (struct icq_command *)buf;

		if((icq->id==0x2a)&&(icq->channel==0x02)&&(ntohs(icq->snac1)==0x01)&&(ntohs(icq->snac2)==0x1e))
		{
			if((ntohl(icq->tlv6)==0x00060004)&&(ntohl(icq->tlv8)==0x00080002)&&(ntohs(icq->tlv12)==0x000c))
				{				
					//uint32 ip=ntohl(((uint16)(icq->ip[0])<<16)|((uint16)(icq->ip[1])&0xffff));
					//printk("ICQ CLIENT INFO %u.%u.%u.%u:%u session=%d\n",NIPQUAD(ip),ntohs(icq->port),client_session);

					#ifdef _RTL_UPNP
					/* add PNP port map */
					rtl8651_addUpnpMap(UPNP_TCP|UPNP_PERSIST, 0, 0, 
							tb->insideGlobalIpAddr, 24500+client_session,
							tb->insideLocalIpAddr, ntohs(icq->port));
					#endif /* _RTL_UPNP */
						
					//icq->port=htons(24500+client_session);
					//2004/3/4 modify ICQ transfer port
					{
						uint16 *icqport=(uint16*)(payload+idx+40);
						*icqport=htons(24500+client_session);						
					}
					++client_session;					
					client_session%=_RTL8651_ALG_ICQ_MAX_CLIENT;
					return SUCCESS;
				}
		}
		idx+=(ntohs(icq->length)+6);
	}

	//suport for ICQ 2003b
	if(sizeof(struct icq_command2)+4>dlen) return SUCCESS;

	rtl8651_memcpy(buf,payload,dlen);
	icq2 = (struct icq_command2 *)buf;

	if((icq2->id==0x2a)&&(icq2->channel==0x02)&&(ntohs(icq2->snac1)==0x04)&&(ntohs(icq2->snac2)==0x06))
	{
		uint16 port;
		port=(*(payload+dlen-4)&0xff)|((*(payload+dlen-3)&0xff)<<8);

#ifdef _RTL_UPNP
		/* add PNP port map */
		if(port>1024)
		{
			rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
				tb->insideGlobalIpAddr, port,
				tb->insideLocalIpAddr, port);
		}
#endif /* _RTL_UPNP */

		port=(*(payload+dlen-8)&0xff)|((*(payload+dlen-7)&0xff)<<8);

#ifdef _RTL_UPNP
		/* add PNP port map */
		if(port>1024)
		{
			rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
				tb->insideGlobalIpAddr, port,
				tb->insideLocalIpAddr, port);
		}		
#endif

		//printk("ICQ FILE TRANSFER to %u.%u.%u.%u:%d for ICQ2003b\n",NIPQUAD(tb->insideLocalIpAddr),port);
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleIcqServerOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint16 port;
	uint8 *payload;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_ICQ)==0) return SUCCESS;
	
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	tlen = ntohs(pip->ip_len); //total_length
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2; // IP+TCP header length
	dlen = tlen - hlen; //data_length
	if(dlen<5) return SUCCESS; 
	payload = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));
	if((*payload)!=2) return SUCCESS;	
	port=(*(payload+dlen-4)&0xff)|((*(payload+dlen-3)&0xff)<<8);	
	
#ifdef _RTL_UPNP
	/* add PNP port map */
	rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
		tb->insideGlobalIpAddr, port,
		tb->insideLocalIpAddr, port);
#endif /* _RTL_UPNP */

	//printk("ICQ FILE TRANSFER to %u.%u.%u.%u:%d\n",NIPQUAD(tb->insideLocalIpAddr),port);
	return SUCCESS;
}


void  rtl8651_l4AliasIcqReInit(void)
 {
	client_session=0;
	localip=0;
 }


