/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_alg_init.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_init.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:42  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.2  2005/11/22 15:50:54  chenyl
* *: Add mutex lock/unlock in log r/w
* *: new idle-timeout mechanism for VLAN / PPPOE / PPTP / L2TP wan types
* *: bug fix: PPTP passthrough
* *: bug fix: sip / ymsg typo error
* *: for ARP-reply module in RomeDrv, use newly allocated mbuf/pkt instead of original one ( To prevent from treated as packet forwarding instead of reply).
* *: minor coding style, sync with main trunk
*
* +: ioctl case for Mutex Lock/Unlock called by user level
* +: add 2 APIs to enable / disable
* 	1. Error messages from protocol stack to WAN : TCP RST, ICMP ICMP_UNREACH/ICMP_SOURCEQUENCH/ICMP_TIMXCEED/ICMP_PARAMPROB
* 	2. All packet from protocol stack to WAN
*    filtering to disable / enable idle-timer update triggered by these kinds of packets.
* +: TFTP ALG
* +: rtl8651_debug.h for debugging usage
* +: merge code about rtl_glue.c / re_core.c with Sercomm's version ( Airgo modification ?)
* +:
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.28  2005/07/19 07:58:35  chenyl
* +: H.323 some RAS support (tested by OpenH323 Gatekeeper)
*
* Revision 1.27  2005/06/01 13:56:18  tony
* *: support alg reinit.
*
* Revision 1.26  2005/04/11 08:59:17  tony
* *: bug fixed: StarCraft support multi-user. (advanced port bouncing)
*
* Revision 1.25  2005/03/28 08:26:22  tony
* *:bug fixed: Netmeeting WAN->LAN can't use chat and white-board.
*
* Revision 1.24  2005/03/01 12:50:15  tony
* *: fix bug for PPTP/IPSec ALG can't set server only mode.
*
* Revision 1.23  2005/03/01 08:20:34  tony
* *: support PPTP/IPSec ALG config dividedly.
*
* Revision 1.22  2005/02/16 12:51:59  tony
* +: add IPSec pass-through NAT traversal, WAN->LAN mode.
*
* Revision 1.21  2004/12/22 05:19:15  tony
* +: support new features: make ALG(FTP,SIP,NetMeeting) support MNQueue.
*
* Revision 1.20  2004/12/03 05:40:46  tony
* *: fix alg bug
*
* Revision 1.19  2004/12/01 13:08:16  tony
* *: support StarCraft for WAN-to-LAN case.
*
* Revision 1.18  2004/11/30 07:09:53  tony
* *: support ALG:DirectX for game AOE II
*
* Revision 1.17  2004/10/04 05:08:54  tony
* *: fix bug for NetMeeting Video in/out.
*
* Revision 1.16  2004/09/30 10:31:53  chhuang
* +: add RTSP alg
*
* Revision 1.15  2004/09/16 11:50:20  tony
* +: add PPTP pass-throught software (not change call ID) case.
*
* Revision 1.14  2004/09/13 13:34:42  tony
* *: fix bug for closing PPTP Server-in pass-throught is not clear his server-in port.
*
* Revision 1.13  2004/09/08 08:26:20  tony
* *: make VPN passthrough support 32 sessions.
*
* Revision 1.12  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.11  2004/09/03 02:55:09  chhuang
* *: bug fixed: rtl8651a_setAlgConfig(): memory pollution
*
* Revision 1.10  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.9  2004/07/21 12:45:51  tony
* +: add new features: PPTP Pass-through support server in.
*
* Revision 1.8  2004/06/15 05:56:58  chhuang
* +: add rtl8651_l4AliasHandleFtpCleintInbound to handle Policy-based QoS. Not complete due to its low priority
*
* Revision 1.7  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.6  2004/03/19 08:40:52  tony
* set rtl8651_algMaxSession default value.
*
* Revision 1.5  2004/03/19 08:12:53  tony
* make IPSec, PPTP, L2TP are able to set session numbers dynamically by user.
*
* Revision 1.4  2004/03/18 09:22:26  tony
* add alg reinit function, it will be called when fwdEng ReInit.
*
* Revision 1.3  2004/03/16 03:52:18  tony
* fix bug: CUseeMe ALG support endian free for test module
*
* Revision 1.2  2004/03/12 07:38:21  tony
* support for new ALGs
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.43  2004/02/12 06:25:17  rupert
* Rename pppoeId to SessionID
* Fixed  rtl8651_flushPolicyRoute about dynamic route
*
* Revision 1.42  2004/02/11 05:55:42  tony
* add rtl8651a_flushAlgServerIn(dsid) and  rtl8651_flushAlgServerIn()
* :It can disable all the server ports of ALG server incoming call.
*
* Revision 1.41  2004/02/11 03:00:17  tony
* disable server port 20.
*
* Revision 1.40  2004/02/09 03:00:28  tony
* rename _rtl8651_getPppoeIpAddrByDsid to _rtl8651_getExtIpAddrByDsid
*
* Revision 1.39  2004/01/29 09:40:13  tony
* add return value in  rtl8651a_setAlgStatus(when the session isn't up, return NOT_OK).
*
* Revision 1.38  2004/01/28 07:58:25  tony
* make DirectX7 ALG support Server-In function.
*
* Revision 1.37  2004/01/27 08:34:55  tony
* make SIP ALG support incoming call.
*
* Revision 1.36  2004/01/16 12:19:18  tony
* add rtl8651_getAlgStatus() and rtl8651a_getAlgStatus(),
* make setAlgStatus() support server in by server port.
*
* Revision 1.35  2004/01/15 13:48:42  tony
* small change
*
* Revision 1.34  2004/01/15 13:38:22  tony
* add function rtl8651a_getAlgStatus(), rtl8651_getAlgStatus()
* make rtl8651a_setAlgStatus() is able to support incoming call
* by _rtl8651_addNaptServerPort() pure software entry.
*
* Revision 1.33  2004/01/15 07:18:19  tony
* support incoming call for H323 ALG.
*
* Revision 1.32  2004/01/14 03:44:26  tony
* small change
*
* Revision 1.31  2004/01/14 03:38:53  tony
* support single session in rtl8651a_setAlgStatus(for old users)
*
* Revision 1.30  2004/01/14 03:37:18  tony
* Support single session in rtl8651_setAlgStatus (for old user)
*
* Revision 1.29  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.28  2004/01/09 08:03:21  tony
* make the code architecture of ALG is able to support multiple dial session.
*
* Revision 1.27  2003/12/31 04:59:26  tony
* fix bug: turn L2TP ALG on/off dynamically.
*
* Revision 1.26  2003/12/16 12:07:22  tony
* fix bug: make DirectX ALG support game AOE2.
*
* Revision 1.25  2003/12/12 11:33:24  tony
* modify SIP ALG, make it support CISCO IP Phone 7960 dial from LAN.
*
* Revision 1.24  2003/12/08 13:56:51  tony
* add new ALG: support SIP protocol (for single session)
*
* Revision 1.23  2003/12/08 03:37:26  tony
* add new ALG: L2TP v2 multiple-session
*
* Revision 1.22  2003/12/02 12:30:45  tony
* the common.h is replace by rtl8651_dos.h and rtl8651_alg_init.h
*
* Revision 1.21  2003/12/02 09:29:15  tony
* rename alg.h to common.h(used for RomeDrvier and Turnkey)
*
* Revision 1.20  2003/12/01 12:35:52  tony
* make ALG is able to be configured by users(Web GUI).
*
* Revision 1.19  2003/12/01 06:20:20  tony
* support dynamic load alg.
*
* Revision 1.18  2003/12/01 06:14:00  tony
* remove old irc alg
*
* Revision 1.17  2003/11/28 11:07:19  tony
* make DirectX 7 ALG is able to work correctly.
* (only for Client in LAN case)
*
* Revision 1.16  2003/11/28 02:53:17  tony
* remove unused irc_init function
*
* Revision 1.15  2003/11/27 03:26:20  tony
* Support ALG for mIRC DCC (Direct Client Connect: SEND and CHAT)
*
* Revision 1.14  2003/11/13 12:30:04  tony
* add ALG ICQ
*
* Revision 1.13  2003/11/07 05:34:36  tony
* modify YMSG ALG, it'll not have to cooperate with trigger port.
*
* Revision 1.12  2003/11/05 09:33:56  hiwu
* change 0 to FALSE
*
* Revision 1.11  2003/11/04 03:01:44  tony
* small change
*
* Revision 1.10  2003/11/03 08:30:30  tony
* add ALG:Yahoo Messenger v5.6 (Peer-to-Peer File transfer)
*
* Revision 1.9  2003/10/27 08:10:16  hiwu
* add isakmp pass through
*
* Revision 1.8  2003/10/24 04:21:40  hiwu
* add RTSP alg support
*
* Revision 1.7  2003/10/23 07:10:18  hiwu
* add pptp alg support
*
* Revision 1.6  2003/10/20 05:12:06  hiwu
* add new h245 alg support
*
* Revision 1.5  2003/10/17 06:15:30  hiwu
* add IRC alg
*
* Revision 1.4  2003/10/02 10:39:52  hiwu
* fix header conflict problem
*
* Revision 1.3  2003/10/02 10:03:09  hiwu
* disable un-tested alg
*
* Revision 1.2  2003/10/02 07:05:41  hiwu
* merge with new table driver
*
* Revision 1.1  2003/09/17 06:45:57  hiwu
* initial version
*
*
*
*/

//#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"

#include "rtl8651_alg_init.h"
#include "rtl8651_alg_ftp.h"
#include "rtl8651_alg_h323.h"
//#include "rtl8651_alg_mms.h"
//#include "rtl8651_alg_nbt.h"
#include "rtl8651_alg_dx7play.h"
#include "rtl8651_alg_pptp.h"
//#include "rtl8651_alg_smedia.h"
#include "rtl8651_alg_ipsec.h"
#include "rtl8651_alg_ymsg.h"
#include "rtl8651_alg_icq.h"
#include "rtl8651_alg_irc_dcc.h"
#include "rtl8651_alg_l2tp.h"
#include "rtl8651_alg_sip.h"
#include "rtl8651_alg_vdolive.h"
#include "rtl8651_alg_cs.h"
#include "rtl8651_alg_quake.h"
#include "rtl8651_alg_battlenet.h"
#include "rtl8651_alg_realaudio.h"
#include "rtl8651_alg_rtsp.h"
#include "rtl8651_alg_cuseeme.h"
#include "rtl8651_alg_tftp.h"
#include "rtl8651_tblDrvLocal.h"

uint32 alg_supports[RTL8651_MAX_DIALSESSION]={0};
uint32 alg_serverips[RTL8651_MAX_DIALSESSION][32]={{0}};
uint32 alg_qosqid[RTL8651_MAX_DIALSESSION][32]={{0}};
uint32 alg_qoshl[RTL8651_MAX_DIALSESSION][32]={{0}};
struct rtl8651_algMaxSession algMaxSession={32,32,32};

uint32 rtl8651_getAlgStatus(void)
{
	return alg_supports[0];
}

uint32 rtl8651a_getAlgStatus(uint32 SessionID)
{
	uint32 dsid=_rtl8651_SessionIDToDSID(SessionID);
	if(dsid>=RTL8651_MAX_DIALSESSION)
		return 0;
	else
		return alg_supports[dsid];
}


uint32 rtl8651_flushAlgServerIn(void)
{
	rtl8651a_flushAlgServerIn(0);
	return SUCCESS;
}
	
uint32 rtl8651a_flushAlgServerIn(uint32 SessionID)
{
	uint32 dsid=_rtl8651_SessionIDToDSID(SessionID);
	ipaddr_t gip=_rtl8651_getExtIpAddrByDsid(dsid);
	

	//FTP
	rtl8651a_delNaptServerPortMapping(dsid,1,gip, 21,alg_serverips[dsid][RTL8651_ALG_FTP_IDX], 21);

	//NetMeeting
	rtl8651a_delNaptServerPortMapping(dsid,1,gip, 1720,alg_serverips[dsid][RTL8651_ALG_NETMEETING_IDX], 1720);
	rtl8651a_delNaptServerPortMapping(dsid,1,gip, 1503,alg_serverips[dsid][RTL8651_ALG_NETMEETING_IDX], 1503);	

	//SIP
	rtl8651a_delNaptServerPortMapping(dsid,0,gip, 5060,alg_serverips[dsid][RTL8651_ALG_SIP_IDX], 5060);

	//IPSec
	rtl8651a_delNaptServerPortMapping(dsid,0,gip, 500,alg_serverips[dsid][RTL8651_ALG_IPSEC_IDX], 500);

	//DX7
	rtl8651a_delNaptServerPortMapping(dsid,1,gip, 47624,alg_serverips[dsid][RTL8651_ALG_DX7_IDX], 47624);

	//ICUII
	rtl8651a_delNaptServerPortRange(dsid,1,gip, 2000,alg_serverips[dsid][RTL8651_ALG_ICUII_IDX], 2000,2);
	rtl8651a_delNaptServerPortMapping(dsid,0,gip, 2002,alg_serverips[dsid][RTL8651_ALG_ICUII_IDX], 2002);

	//PPTP
	rtl8651a_delNaptServerPortMapping(dsid,1,gip, 1723,alg_serverips[dsid][RTL8651_ALG_PPTP_IDX], 1723);

	//Battlenet
	rtl8651a_delNaptServerPortMapping(dsid,TRUE,gip, 6112,alg_serverips[dsid][RTL8651_ALG_BATTLENET_IDX], 6112);
	rtl8651a_delNaptServerPortMapping(dsid,FALSE,gip, 6112,alg_serverips[dsid][RTL8651_ALG_BATTLENET_IDX], 6112);	

	//TFTP
	rtl8651a_delNaptServerPortMapping(dsid, FALSE, gip, TFTP_UDP_DPORT, alg_serverips[dsid][RTL8651_ALG_TFTP_IDX], TFTP_UDP_DPORT);

	return SUCCESS;	
}
	

void rtl8651_setAlgStatus(uint32 alg_support,ipaddr_t *alg_serverip)
{
	 rtl8651a_setAlgStatus(0,alg_support,alg_serverip);
}

void rtl8651_setAlgConfig(uint32 alg_support,ipaddr_t *alg_serverip,struct rtl8651_algMaxSession maxSession)
{
	 rtl8651a_setAlgConfig(0,alg_support,alg_serverip,maxSession);
}


int32 rtl8651a_setAlgQosQueueId(uint32 SessionID,uint32 alg_idx,uint32 queueID,uint32 isHigh)
{
	if(alg_idx>=32) return FAILED;
	alg_qosqid[SessionID][alg_idx]=queueID;
	alg_qoshl[SessionID][alg_idx]=isHigh;	
	return SUCCESS;
}

int32 rtl8651_setAlgQosQueueId(uint32 alg_idx,uint32 queueID,uint32 isHigh)
{
	return rtl8651a_setAlgQosQueueId(0,alg_idx,queueID,isHigh);
}

int32 _rtl8651_addAlgQosNaptConnection(int8 fromDrv, int16 assigned, int8 flowType, ipaddr_t insideLocalIpAddr, uint16 insideLocalPort, 
			ipaddr_t *insideGlobalIpAddr, uint16 *insideGlobalPort, ipaddr_t dstIpAddr, uint16 dstPort,uint32 AlgIdx) 
{
	/* add to QoS High/Low Queue */

if((assigned&ALG_QOS)&&(assigned&EXTIPPORT_ASSIGNED)&&(alg_qosqid[0][AlgIdx]!=0))
{
	rtl8651_tblDrvAclRule_t rule;

	memset(&rule, 0, sizeof(rtl8651_tblDrvAclRule_t));
	rule.actionType_ = RTL8651_ACL_DROP;

	switch(flowType) {

	case UDP_FLOW: /* UDP */
		rule.ruleType_	= RTL8651_ACL_UDP;
		rule.udpSrcPortUB_	= insideLocalPort;
		rule.udpSrcPortLB_		= insideLocalPort;
//		printk("insideLocalPort=%d\n",insideLocalPort);

#if 0		
		if(dstPort)
		{
			rule.udpDstPortUB_	= dstPort;
			rule.udpDstPortLB_		= dstPort;
		}
		else			
#endif					
		{
			rule.udpDstPortUB_	= 65535;
			rule.udpDstPortLB_		= 0;
		}
		break;

	default: /* TCP */
		rule.ruleType_	= RTL8651_ACL_TCP;
		rule.tcpSrcPortUB_		= insideLocalPort;
		rule.tcpSrcPortLB_		= insideLocalPort;

#if 0
		if(dstPort)
		{
			rule.tcpDstPortUB_	= dstPort;
			rule.tcpDstPortLB_	= dstPort;
		}
		else	
#endif					
		{		
			rule.tcpDstPortUB_	= 65535;
			rule.tcpDstPortLB_	= 0;
		}
		break;		
	}
	
	rule.srcIpAddr_		= insideLocalIpAddr;
	rule.srcIpAddrMask_	= 0xffffffff;

#if 0
	if(dstIpAddr)
	{
		rule.dstIpAddr_		= dstIpAddr;
		rule.dstIpAddrMask_	= 0xffffffff;	
	}
#endif	

	{
		int r=0;
		if(alg_qoshl[0][AlgIdx])  
			r=rtl8651_addFlowToUnlimitedQueue("eth1", &rule, 1, alg_qosqid[0][AlgIdx]);
		else
			r=rtl8651_addFlowToLimitedQueue("eth1", &rule, 1, alg_qosqid[0][AlgIdx]);
		if(r) printk("addFlowToUn/LimiteQueue Failed , lport=%d r=%d ishigh=%d qid=%d\n",insideLocalPort,r,alg_qoshl[0][AlgIdx],alg_qosqid[0][AlgIdx]);
	}

}

return _rtl8651_addNaptConnection(fromDrv, assigned, flowType,  insideLocalIpAddr,insideLocalPort, 
			insideGlobalIpAddr, insideGlobalPort, dstIpAddr,  dstPort) ;


}


uint32 rtl8651a_setAlgStatus(uint32 SessionID,uint32 alg_support,ipaddr_t *alg_serverip)
{
	struct rtl8651_algMaxSession maxSession;	
	maxSession.ipsecMaxSession=32;
	maxSession.l2tpMaxSession=32;
	maxSession.pptpMaxSession=32;	
	rtl8651a_setAlgConfig(SessionID,alg_support,alg_serverip,maxSession);
	return SUCCESS;
}

uint32 rtl8651a_setAlgConfig(uint32 SessionID,uint32 alg_support,ipaddr_t *alg_serverip,struct rtl8651_algMaxSession maxSession)
{
	int i;
	uint32 dsid=_rtl8651_SessionIDToDSID(SessionID);
	ipaddr_t gip=_rtl8651_getExtIpAddrByDsid(dsid);
	
	if(gip==0) return NOT_OK;

	rtl8651_memcpy(&algMaxSession,&maxSession,sizeof(maxSession));
	
	alg_supports[dsid]=alg_support;

	rtl8651a_flushAlgServerIn(dsid);


	/* if defined, FTP passive mode works when server is inside LAN, however,
	 * performance is pure software forwarding. 
	 * Not as good as using active mode only(ASIC wirespeed).
	 * orlando memo: use FTPALG_INSIDE_SERVER_PASSIVE_MODE for passing
	 * customer's evaluation testing.... 2003/10/01
	 */
	#define FTPALG_INSIDE_SERVER_PASSIVE_MODE

	if((alg_support&RTL8651_ALG_FTP)&&(alg_serverip[RTL8651_ALG_FTP_IDX]))
	{		
		rtl8651a_addNaptServerPortMapping(dsid,(1|2),gip, 21,alg_serverip[RTL8651_ALG_FTP_IDX], 21);	
	}

	#ifdef FTPALG_INSIDE_SERVER_PASSIVE_MODE
		rtl8651_fwdEngineRegisterAlgModule(21, TRUE,
			rtl8651_l4AliasFtpInit,
			(alg_funcptr)rtl8651_l4AliasHandleFtpCleintOutbound,
			(alg_funcptr)rtl8651_l4AliasHandleFtpCleintInbound,
			(alg_funcptr)rtl8651_l4AliasHandleFtpServerOutbound,
			NULL);
	#else
		rtl8651_fwdEngineRegisterAlgModule(21, TRUE,
			rtl8651_l4AliasFtpInit,
			(alg_funcptr)rtl8651_l4AliasHandleFtpCleintOutbound,
			NULL,
			(alg_funcptr)rtl8651_l4AliasHandleFtpServerOutbound,
			(alg_funcptr)rtl8651_l4AliasFilterFtpServerInboundPasvCmd);
	#endif	/* FTPALG_INSIDE_SERVER_PASSIVE_MODE */


	/* Microsoft Netmeeting */
	//printk("del gip=%u.%u.%u.%u serverip=%u.%u.%u.%u\n",NIPQUAD(gip),NIPQUAD(alg_serverips[dsid][RTL8651_ALG_NETMEETING_IDX]));
	if((alg_support&RTL8651_ALG_NETMEETING)&&(alg_serverip[RTL8651_ALG_NETMEETING_IDX]))
	{		
		//printk("add gip=%u.%u.%u.%u serverip=%u.%u.%u.%u\n",NIPQUAD(gip),NIPQUAD(alg_serverip[RTL8651_ALG_NETMEETING_IDX]));
		rtl8651a_addNaptServerPortMapping(dsid,(1|2),gip, 1720,alg_serverip[RTL8651_ALG_NETMEETING_IDX], 1720);
		rtl8651a_addNaptServerPortMapping(dsid,(1),gip, 1503,alg_serverip[RTL8651_ALG_NETMEETING_IDX], 1503);
	}
	
	rtl8651_fwdEngineRegisterAlgModule(1719, FALSE,
		rtl8651_l4AliasH323Init,
		(alg_funcptr)rtl8651_l4AliasHandleClientH225RASOut,
		(alg_funcptr)rtl8651_l4AliasHandleClientH225RASIn,
		(alg_funcptr)rtl8651_l4AliasHandleServerH225RASOut,
		(alg_funcptr)rtl8651_l4AliasHandleServerH225RASIn);

	rtl8651_fwdEngineRegisterAlgModule(1720, TRUE,
		rtl8651_l4AliasH323Init,
		(alg_funcptr)rtl8651_l4AliasHandleClientH225CSOut,
		(alg_funcptr)rtl8651_l4AliasHandleClientH225CSIn,
		(alg_funcptr)rtl8651_l4AliasHandleServerH225CSOut,
		(alg_funcptr)rtl8651_l4AliasHandleServerH225CSIn);
	

       rtl8651_fwdEngineRegisterAlgModule(17200, TRUE,
		NULL,
		NULL, //rtl8651_l4AliasHandleClientH245Out,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleServerH245Out,
		(alg_funcptr)rtl8651_l4AliasHandleServerH245In);

	/* PPTP */	
	rtl8651_fwdEngineRegisterAlgModule(1723, TRUE,
		rtl8651_l4AliasPptpInit,
		(alg_funcptr)rtl8651_l4AliasHandlePptpClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandlePptpClientInbound,
		(alg_funcptr)rtl8651_l4AliasHandlePptpServerOutbound,
		(alg_funcptr)rtl8651_l4AliasHandlePptpServerInbound);

	/* PPTP Server In */	
	if((alg_support&RTL8651_ALG_PPTP_SERVER)&&(alg_serverip[RTL8651_ALG_PPTP_IDX]))
	{		
		//printk("add gip=%u.%u.%u.%u serverip=%u.%u.%u.%u\n",NIPQUAD(gip),NIPQUAD(alg_serverip[RTL8651_ALG_PPTP_IDX]));
		rtl8651a_addNaptServerPortMapping(dsid,(1|2),gip, 1723,alg_serverip[RTL8651_ALG_PPTP_IDX], 1723);
	}

	/* IPSec */
	rtl8651_fwdEngineRegisterAlgModule(500, FALSE,
		rtl8651_l4AliasIpsecInit,
		(alg_funcptr)rtl8651_l4AliasHandleIpsecClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleIpsecClientInbound,
		NULL,
		NULL);

	/* IPSec Server In */	
	if((alg_support&RTL8651_ALG_IPSEC_SERVER)&&(alg_serverip[RTL8651_ALG_IPSEC_IDX]))
	{		
		rtl8651a_addNaptServerPortMapping(dsid,(2),gip, 500,alg_serverip[RTL8651_ALG_IPSEC_IDX], 500);
	}

	/* L2TP */
	//rtl8651_fwdEngineRemoveAlgModule(1701, FALSE);
	rtl8651_fwdEngineRegisterAlgModule(1701, FALSE,
		rtl8651_l4AliasL2tpInit,
		(alg_funcptr)rtl8651_l4AliasHandleL2tpClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleL2tpClientInbound,
		NULL,
		NULL);

	/* SIP */
	if((alg_support&RTL8651_ALG_SIP)&&(alg_serverip[RTL8651_ALG_SIP_IDX]))
	{		
		rtl8651a_addNaptServerPortMapping(dsid,(0|2),gip, 5060,alg_serverip[RTL8651_ALG_SIP_IDX], 5060);
	}

	rtl8651_fwdEngineRegisterAlgModule(5060, FALSE,
		rtl8651_l4AliasSipInit,
		(alg_funcptr)rtl8651_l4AliasHandleSipClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleSipClientInbound,
		(alg_funcptr)rtl8651_l4AliasHandleSipClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleSipClientInbound);	

	/* Microsoft DirectX7 */


	//for server in
	if((alg_support&RTL8651_ALG_DX7)&&(alg_serverip[RTL8651_ALG_DX7_IDX]))
	{		
		rtl8651a_addNaptServerPortMapping(dsid,(1|2),gip, 47624,alg_serverip[RTL8651_ALG_DX7_IDX], 47624);
	}

	//for client out
	rtl8651_fwdEngineRegisterAlgModule(47624, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound, //for client out
		NULL,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleDx7playServerInbound); //for server in

//	for(i=0;i<_RTL8651_ALG_DX7PLAY_MAX_CLIENT;i++)
		rtl8651_fwdEngineRegisterAlgModule(2300, TRUE,
			NULL,
			(alg_funcptr)rtl8651_l4AliasHandleDx7playClientOutbound2, //for client out
			NULL, 
			NULL,
			(alg_funcptr)rtl8651_l4AliasHandleDx7playServerInbound2); //for server in


	/* ICUII */	
	if((alg_support&RTL8651_ALG_ICUII)&&(alg_serverip[RTL8651_ALG_ICUII_IDX]))
	{		
		rtl8651a_addNaptServerPortRange(dsid,1,gip, 2000,alg_serverip[RTL8651_ALG_ICUII_IDX], 2000,2);
		rtl8651a_addNaptServerPortMapping(dsid,(0|2),gip, 2002,alg_serverip[RTL8651_ALG_ICUII_IDX], 2002);
	}	

	/* ICQ */
	rtl8651_fwdEngineRegisterAlgModule(5190, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleIcqClientOutbound,
		NULL,
		NULL,
		NULL);


	for(i=0;i<_RTL8651_ALG_ICQ_MAX_CLIENT;i++)		
		rtl8651_fwdEngineRegisterAlgModule(24500+i, TRUE,
			NULL,
			NULL,
			NULL,
			(alg_funcptr)rtl8651_l4AliasHandleIcqServerOutbound,
			NULL);

	/* Yahoo Messenger */			
	rtl8651_fwdEngineRegisterAlgModule(5050, TRUE,
		rtl8651_l4AliasYmsgInit,
		(alg_funcptr)rtl8651_l4AliasHandleYmsgClientOutbound,
		NULL,
		NULL,
		NULL);

	/* IRC_DCC */	
	rtl8651_fwdEngineRegisterAlgModule(6667, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleIrcDccClientOutbound,
		NULL,
		NULL,
		NULL);

	rtl8651_fwdEngineRegisterAlgModule(6668, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleIrcDccClientOutbound,
		NULL,
		NULL,
		NULL);

	/* VDOlive */
	rtl8651_fwdEngineRegisterAlgModule(7000, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleVDOliveClientOutbound,
		NULL,
		NULL,
		NULL);

	/* Quake I */
	rtl8651_fwdEngineRegisterAlgModule(27910, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleQuakeClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleQuakeClientInbound,
		NULL,
		NULL);	

	/* Quake III */
	rtl8651_fwdEngineRegisterAlgModule(27960, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleQuakeClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleQuakeClientInbound,
		NULL,
		NULL);

	/* Blizzard Battlenet */
	rtl8651_fwdEngineRegisterAlgModule(6112, TRUE,
		NULL,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleBattlenetClientInbound,
		NULL,
		NULL);

	/* Blizzard Battlenet */
	if((alg_support&RTL8651_ALG_BATTLENET)&&(alg_serverip[RTL8651_ALG_BATTLENET_IDX]))
	{		
		rtl8651a_addNaptServerPortMapping(dsid,(FALSE|PURE_SW),gip, 6112,alg_serverip[RTL8651_ALG_BATTLENET_IDX], 6112);
		rtl8651a_addNaptServerPortMapping(dsid,(TRUE|PURE_SW),gip, 6112,alg_serverip[RTL8651_ALG_BATTLENET_IDX], 6112);		
	}	
	
	/* RealAudio */
	rtl8651_fwdEngineRegisterAlgModule(7070, TRUE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleRealAudioClientOutbound,
		NULL,
		NULL,
		NULL);

	/* RTSP */
	rtl8651_fwdEngineRegisterAlgModule(554, TRUE,
		rtl8651_l4AliasRTSPInit,
		(alg_funcptr)rtl8651_l4AliasHandleRTSPClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleRTSPClientInbound,
		NULL,
		NULL);

	/* CUseeMe */
	rtl8651_fwdEngineRegisterAlgModule(7648, FALSE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleCUseeMeClientOutbound,
		(alg_funcptr)rtl8651_l4AliasHandleCUseeMeClientInbound,
		NULL,
		NULL);		

	/* Counter-Strike / Half Life  */
	rtl8651_fwdEngineRegisterAlgModule(27015, FALSE,
		NULL,
		(alg_funcptr)rtl8651_l4AliasHandleCSClientOutbound,
		NULL,
		NULL,
		NULL);
	
	/* TFTP */
	if((alg_support&RTL8651_ALG_TFTP)&&(alg_serverip[RTL8651_ALG_TFTP_IDX]))
	{		
		rtl8651a_addNaptServerPortMapping(	dsid,
											FALSE,
											gip,
											TFTP_UDP_DPORT,
											alg_serverip[RTL8651_ALG_TFTP_IDX],
											TFTP_UDP_DPORT);
	}	
	rtl8651_fwdEngineRegisterAlgModule(	TFTP_UDP_DPORT,
										FALSE,
										NULL,
										(alg_funcptr)rtl8651_l4AliasHandleTftpClientOutbound,
										NULL,
										NULL,
										NULL);

#if 0 /* disable temp */
	/* Microsoft Message Server */
	rtl8651_fwdEngineRegisterAlgModule(1863, TRUE,
		rtl8651_l4AliasMmsInit,
		rtl8651_l4AliasHandleMmsCleintOutbound,
		NULL,
		NULL,
		NULL);
		
	/* Netbios over UDP */	
	rtl8651_fwdEngineRegisterAlgModule(137, FALSE,
		NULL,
		rtl8651_l4AliasHandleClientUdpNbtNSOut,
		rtl8651_l4AliasHandleClientUdpNbtNSIn,
		NULL,
		NULL);		
	rtl8651_fwdEngineRegisterAlgModule(138, FALSE,
		NULL,
		rtl8651_l4AliasHandleClientUdpNbtOut,
		rtl8651_l4AliasHandleClientUdpNbtIn,
		NULL,
		NULL);	
		
	/* RTSP */	
	rtl8651_fwdEngineRegisterAlgModule(RTSP_CONTROL_PORT_NUMBER_1, TRUE,
		rtl8651_l4AliasSmediaInit,
		rtl8651_l4AliasHandleSmediaCleintOutbound,
		NULL,
		NULL,
		NULL);		
	rtl8651_fwdEngineRegisterAlgModule(RTSP_CONTROL_PORT_NUMBER_2, TRUE,
		NULL,
		rtl8651_l4AliasHandleSmediaCleintOutbound,
		NULL,
		NULL,
		NULL);	
				
#endif /* hiwu: disable temp */

	rtl8651_memcpy(alg_serverips[dsid],alg_serverip,32*sizeof(uint32));
	return OK;

}

/*  a one second periodic timer ; 
	this function will be called every one second */
int32 rtl8651_algOneSecondTimer(void){
	rtl8651_l4AliasPptpHouseKeeping();
	rtl8651_l4AliasIpsecHouseKeeping();
	rtl8651_l4AliasRtspHouseKeeping();
	return SUCCESS;
}

void rtl8651_algReInit(void)
{
	rtl8651_l4AliasHandleBattlenetReInit();
	rtl8651_l4AliasHandleCsReInit();
	rtl8651_l4AliasHandleDx7playReInit();
	rtl8651_l4AliasFtpReInit();
	rtl8651_l4AliasH323ReInit();
	rtl8651_l4AliasIcqReInit();	
	rtl8651_l4AliasIpsecReInit();	
	rtl8651_l4AliasPptpReInit();	
	rtl8651_l4AliasSipReInit();
	rtl8651_l4AliasYmsgReInit();
}



