/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_alg_ipsec.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_ipsec.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.21  2005/09/08 05:53:36  tony
* *: bug fixed: check the IPSec enable/disable flag.
*
* Revision 1.20  2005/08/09 07:28:01  tony
* *: support IPSec Pass-through traversal mode.
*
* Revision 1.19  2005/06/24 02:25:16  tony
* *: support ipsec with local source port not 500.
*
* Revision 1.18  2005/03/01 08:20:34  tony
* *: support PPTP/IPSec ALG config dividedly.
*
* Revision 1.17  2005/02/25 07:35:22  chenyl
* *: if Internal server IP is not set, we ignore inbound ipsec passthrough
*
* Revision 1.16  2005/02/16 13:27:33  tony
* *: bug fix: when IPSec-pt disable, drop the IPSec packet.
*
* Revision 1.15  2005/02/16 12:51:59  tony
* +: add IPSec pass-through NAT traversal, WAN->LAN mode.
*
* Revision 1.14  2004/10/07 08:22:08  tony
* *: fix bug for CDRouter test case.
*
* Revision 1.15  2004/10/06 14:08:24  chhuang
* *:bug fixed by tony: icookie & rcookie checking error
*
* Revision 1.14  2004/10/01 15:00:03  chhuang
* *: for cdrouter
*
* Revision 1.13  2004/09/22 13:47:50  tony
* *: disabled data channel (ESP) when disable ALG.
*
* Revision 1.12  2004/09/10 03:26:52  tony
* *: patch for CDRouter test case.
*
* Revision 1.11  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.10  2004/09/02 06:41:37  tony
* *: fix bug - ipsec passthrough's ISAKMP timeout will cause udp src port change.
*
* Revision 1.9  2004/07/27 07:31:42  chenyl
* *: pptp/ipSec pass-through, GRE/ESP fragment packets process.
* *: if DoS Ignore Type is matched, we check whether system can sent fragment packet
*    regardless of the TearDrop Setting.
*
* Revision 1.8  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.7  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.6  2004/03/19 12:19:26  cfliu
* Rename all osk_malloc, printk, printf, printfByPolling as rtlglue_printf
*
* Revision 1.5  2004/03/19 08:12:53  tony
* make IPSec, PPTP, L2TP are able to set session numbers dynamically by user.
*
* Revision 1.4  2004/03/18 09:22:26  tony
* add alg reinit function, it will be called when fwdEng ReInit.
*
* Revision 1.3  2004/03/18 05:40:31  tony
* fix bug: ESP path for endian free.
*
* Revision 1.2  2004/03/18 02:02:54  tony
* fix small bug
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.11  2004/02/11 06:29:40  tony
* fix bug: turn IPSec ALG on/off dynamically.
*
* Revision 1.10  2004/01/29 01:39:47  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.9  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.8  2004/01/07 08:23:25  hiwu
* fix alignment  problem in dptr = (uint64 *) (ud+1);
*
* Revision 1.7  2004/01/07 06:49:19  hiwu
* FIX VPN passthrough support
*
* Revision 1.6  2003/12/19 11:40:01  tony
* change memcpy to rtl8651_memcpy
*
* Revision 1.5  2003/12/17 10:34:31  hiwu
* add checksum function
*
* Revision 1.4  2003/11/26 07:36:06  hiwu
* update ipsec pass-throgh
* multiple session is support only when isakmp cookie is different
*
* Revision 1.3  2003/11/05 09:34:27  hiwu
* FIX ipsec pass through
*
* Revision 1.2  2003/11/03 08:14:05  hiwu
* update isakmp check function
*
* Revision 1.1  2003/10/27 08:07:59  hiwu
* initial version
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_ipsec.h"


#define IPSEC_IDLE_TIME 600 /* 10 minutes */

#define  IPSEC_FREE 0
#define  IPSEC_USED 1

struct isakmp_data_s {
	uint64	icookie;	/* initiator cookie */
	uint64	rcookie;	/* responder cookie */
	
	uint32 peer_ip;
	uint32 local_ip;
	uint32 alias_ip;

	uint32	ospi;
	uint32	ispi;

	uint16 state;
	uint16 idle_timer;

	uint32 dsid;
};

static struct isakmp_data_s *_rtl8651_isakmpDb=NULL;


/*********************************************************************************
* Routine Name :  _rtl8651_findIsakmpIn                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static struct isakmp_data_s* 
_rtl8651_findIsakmpIn(uint32 peer_ip,uint32 alias_ip,uint64 icookie,uint64 rcookie){ 
	int i;
	struct isakmp_data_s *tp;
	tp = _rtl8651_isakmpDb;
	
	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		if(tp->peer_ip == peer_ip &&
		   tp->alias_ip == alias_ip &&
		   ((tp->icookie == icookie )||(tp->icookie==0)||(icookie==0)) &&
		   ((tp->rcookie == rcookie)||(tp->rcookie==0)||(rcookie==0)) && 
		   tp->state == IPSEC_USED){	
		   	tp->idle_timer = 0;	 
		   	tp->rcookie = rcookie;  	
		   	tp->icookie = icookie;  
		   	return tp;
		}
		tp++;
	}
	
	return NULL;
}


/*********************************************************************************
* Routine Name :  _rtl8651_findIsakmpOut                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static struct isakmp_data_s* 
_rtl8651_findIsakmpOut(uint32 local_ip,uint32 peer_ip,uint64 icookie,uint64 rcookie){ 
	int i;
	struct isakmp_data_s *tp;
	tp = _rtl8651_isakmpDb;
	
	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		if(tp->peer_ip == peer_ip &&
		   tp->local_ip == local_ip &&
		   ((tp->icookie== icookie)||(icookie==0) ||(tp->icookie==0)) &&
		   ((tp->rcookie== rcookie)||(rcookie==0) ||(tp->rcookie==0)) &&

		   tp->state == IPSEC_USED){	
		   	tp->idle_timer = 0;	   
		   	tp->rcookie = rcookie;  	
		   	tp->icookie = icookie;  		   		
		   	return tp;
		}
		tp++;
	}
	
	return NULL;
}



/*********************************************************************************
* Routine Name :  _rtl8651_addIsakmp                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static struct isakmp_data_s* 
_rtl8651_addIsakmp(uint32 local_ip,uint32 peer_ip,uint32 alias_ip, 
		uint64 icookie,uint64 rcookie,uint32 dsid){ 
	int i;
	struct isakmp_data_s *tp;
	tp = _rtl8651_isakmpDb;
	
	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		if(tp->state == IPSEC_FREE){
		    memset(tp,0,sizeof(struct isakmp_data_s));
		    tp->idle_timer = 0;
		    tp->peer_ip = peer_ip;
		    tp->local_ip = local_ip;
		    tp->alias_ip = alias_ip;
		    tp->icookie = icookie;
		    tp->rcookie = rcookie;
		    tp->state = IPSEC_USED;
		    tp->dsid = dsid;
		   	return tp;
		}
		tp++;
	}
	return NULL;
}

/*********************************************************************************
* Routine Name :  _rtl8651_findEspIn                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static struct isakmp_data_s* 
_rtl8651_findEspIn(uint32 peer_ip,uint32 alias_ip,uint32 ispi){ 
	int i;
	struct isakmp_data_s *tp;
	tp = _rtl8651_isakmpDb;
	
	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		if(tp->peer_ip == peer_ip &&
		   tp->alias_ip == alias_ip &&
		   tp->state == IPSEC_USED &&
		   ((tp->ispi == ispi) || (tp->ispi == 0 ) || (ispi==0)) ){	
		   	tp->idle_timer = 0;	   	
		   	tp->ispi = ispi;  
		   	return tp;
		}
		tp++;
	}
	
	return NULL;
}


/*********************************************************************************
* Routine Name :  _rtl8651_findEspOut                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static struct isakmp_data_s* 
_rtl8651_findEspOut(uint32 local_ip,uint32 peer_ip, uint32 ospi){ 
	int i;
	struct isakmp_data_s *tp;
	tp = _rtl8651_isakmpDb;
	
	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		if(tp->peer_ip == peer_ip &&
		   tp->local_ip == local_ip &&
		   ((tp->ospi ==  ospi )||(ospi==0)||(tp->ospi==0)) &&
		   tp->state == IPSEC_USED ){	
		   	tp->idle_timer = 0;	  
		   	tp->ospi = ospi;   	
		   	return tp;
		}
		tp++;
	}

	return NULL;
}



/*********************************************************************************
* Routine Name :  _rtl8651_addEsp                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static struct isakmp_data_s* 
_rtl8651_addEsp(uint32 local_ip,uint32 peer_ip,uint32 ospi,uint32 ispi){ 

	struct isakmp_data_s *tp;	
	int i;


	tp = _rtl8651_isakmpDb;

	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		if(tp->state == IPSEC_USED && tp->peer_ip == peer_ip
		   && tp->local_ip == local_ip){
			tp->idle_timer = 0;
		    tp->ospi = ospi;
		    tp->ispi = ispi;
		   	return tp;
		}
		tp++;
	}

	// patch for CDRouter test case
	{
		ipaddr_t extip;
		extip=_rtl8651_getExtIpAddrByDsid(0);
		if(extip)
		{
			tp = _rtl8651_addIsakmp(local_ip,peer_ip,extip,0,0,0);
			return tp;
		}
	}	
	return NULL;
}


/*********************************************************************************
* Routine Name : _rtl8651_l4EspNaptAliasIn                                 
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static int32 _rtl8651_l4EspNaptAliasIn(struct rtl_pktHdr *phdr,struct ip * pip)
{
	uint32	i_spi;
	struct isakmp_data_s *link;
	if((alg_supports[phdr->ph_dsid]&(RTL8651_ALG_IPSEC|RTL8651_ALG_IPSEC_SERVER))==0) return SUCCESS;

	i_spi = PKTGET_UINT32_UNALIGNED((uint32 *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2)));

	link = _rtl8651_findEspIn(PKTGET_UINT32_UNALIGNED(&pip->ip_src), PKTGET_UINT32_UNALIGNED(&pip->ip_dst), i_spi);

	if(link == NULL){
		if (alg_serverips[0][RTL8651_ALG_IPSEC_IDX] == 0)	/* not be assigned yet */
		{
			return FWDENG_ESP_IGNORE;
		}
		/* server-in IP addess has be assigned, we add new esp entry dynamically */
		link = _rtl8651_addEsp(alg_serverips[0][RTL8651_ALG_IPSEC_IDX], PKTGET_UINT32_UNALIGNED(&pip->ip_src),0, i_spi);
	}
	
	if (link != NULL)
	{	/* Restore original IP address. */		
		uint8 *dst;
		dst=(uint8 *)&pip->ip_dst;
		dst[0]=(link->local_ip>>24)&0xff;
		dst[1]=(link->local_ip>>16)&0xff;
		dst[2]=(link->local_ip>>8)&0xff;
		dst[3]=link->local_ip&0xff;		
		phdr->ph_dip = link->local_ip;

		/* Compute IP checksum for revised packet */
//		pip->ip_sum = 0;
//		pip->ip_sum = _rtl8651_ipChecksum(pip);	
		return SUCCESS;		
	}
	
	return FWDENG_ESP_IGNORE;
}


/*********************************************************************************
* Routine Name : _rtl8651_l4EspNaptAliasOut                                    
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
static int32 _rtl8651_l4EspNaptAliasOut(struct rtl_pktHdr *phdr,struct ip *pip)
{
	
	uint32	o_spi;
	struct isakmp_data_s *link;
	if((alg_supports[phdr->ph_dsid]&(RTL8651_ALG_IPSEC|RTL8651_ALG_IPSEC_SERVER))==0) return SUCCESS;
	o_spi = PKTGET_UINT32_UNALIGNED((uint32 *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2)));

	link = _rtl8651_findEspOut(PKTGET_UINT32_UNALIGNED(&pip->ip_src), PKTGET_UINT32_UNALIGNED(&pip->ip_dst), o_spi);

	if(link == NULL){
		link = _rtl8651_addEsp(PKTGET_UINT32_UNALIGNED(&pip->ip_src), PKTGET_UINT32_UNALIGNED(&pip->ip_dst), o_spi,0);
	}
	
	if (link != NULL)
	{
		uint8 *ptr;
		/* Change source IP address.  */		 
	
		ptr=(uint8 *)&pip->ip_src;
		ptr[0]=(link->alias_ip>>24)&0xff;
		ptr[1]=(link->alias_ip>>16)&0xff;
		ptr[2]=(link->alias_ip>>8)&0xff;
		ptr[3]=(link->alias_ip)&0xff;
		phdr->ph_sip = link->alias_ip;
	
//		rtl8651_memcpy(&pip->ip_src , &link->alias_ip,4);
		/* Compute IP checksum for revised packet */
//		pip->ip_sum = 0;				
//		pip->ip_sum = _rtl8651_ipChecksum(pip);		
		return SUCCESS;	
	}	
	return FWDENG_ESP_IGNORE;
}

/*********************************************************************************
* Routine Name :  rtl8651_l4AliasHandleIpsecClientInbound                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
int32 rtl8651_l4AliasHandleIpsecClientInbound(struct rtl_pktHdr *pkt, struct ip *pip, 
					   struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s * link)	
{
	struct isakmp_data_s *tb;	
	struct 	udphdr *ud;
	uint64	*dptr, icookie, rcookie;	
	char compstr[12]={0};

	if((alg_supports[pkt->ph_dsid]&(RTL8651_ALG_IPSEC|RTL8651_ALG_IPSEC_SERVER))==0) return SUCCESS;
		
	ud = (struct udphdr *)((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	/* If it's not long enough to contain cookies, give up */
	if (ud->uh_ulen < 16) {
		return SUCCESS;
	}
	dptr = (uint64 *) (ud+1);
	rtl8651_memcpy(&icookie,dptr,8);
	dptr++;
	rtl8651_memcpy(&rcookie,dptr,8);

	if(memcmp((uint8*)dptr,compstr,12)!=0)
	{
	
		tb = _rtl8651_findIsakmpIn(link->dstIpAddr,link->insideGlobalIpAddr,icookie,rcookie);
		
		if(tb == NULL){

			if((alg_supports[pkt->ph_dsid]&RTL8651_ALG_IPSEC_SERVER)==0) return FWDENG_USER_DROP;
			
#ifdef _RTL_UPNP
			/* add UPNP port map */
			rtl8651_addUpnpMap(UPNP_PERSIST, 0, 0, 
					link->insideGlobalIpAddr, 4500,
					link->insideLocalIpAddr, 4500);	
#endif /* _RTL_UPNP */

			tb = _rtl8651_addIsakmp(alg_serverips[pkt->ph_dsid][RTL8651_ALG_IPSEC_IDX],link->dstIpAddr,
									link->insideGlobalIpAddr,icookie,rcookie,pkt->ph_dsid);
			if(tb == NULL){			
				return SUCCESS;
			}		
	       }
		
		link->insideLocalIpAddr = tb->local_ip;	
	}

	return SUCCESS;
}



/*********************************************************************************
* Routine Name :  rtl8651_aliasHandleIsakmpClientOutbound                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
int32 rtl8651_l4AliasHandleIpsecClientOutbound(
		struct rtl_pktHdr *pkt,
		struct ip *pip,
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *link)
{
	struct isakmp_data_s *tb;	
	struct 	udphdr *ud;
	uint64	*dptr, icookie, rcookie;	
	char compstr[12]={0};

	if((alg_supports[pkt->ph_dsid]&(RTL8651_ALG_IPSEC|RTL8651_ALG_IPSEC_SERVER))==0) return SUCCESS;
	
	ud = (struct udphdr *) ((int8 *) pip + ((*(uint8*)pip&0xf) << 2));

	/* If it's not long enough to contain cookies, give up */	
	if ( ud->uh_ulen < 16) {	
		return SUCCESS;
	}

	dptr = (uint64 *) (ud+1);
	rtl8651_memcpy(&icookie,dptr,8);
	dptr++;
	rtl8651_memcpy(&rcookie,dptr,8);

	if(memcmp((uint8*)dptr,compstr,12)!=0)
	{
	
		tb = _rtl8651_findIsakmpOut(link->insideLocalIpAddr,link->dstIpAddr,icookie,rcookie);
		if(tb == NULL){
			
			if((alg_supports[pkt->ph_dsid]&RTL8651_ALG_IPSEC)==0) return FWDENG_USER_DROP;
			
			tb = _rtl8651_addIsakmp(link->insideLocalIpAddr,link->dstIpAddr,
									link->insideGlobalIpAddr,icookie,rcookie,pkt->ph_dsid);
			if(tb == NULL){	
				return SUCCESS;
			}		
	       }

		if(link->insideLocalPort==500)
		{
			
			if(link->insideGlobalPort!=500)
			{
#ifdef _RTL_UPNP			
		    	rtl8651_addUpnpMap(UPNP_ONESHOT, link->dstIpAddr, 500, 
					link->insideGlobalIpAddr, 500,link->insideLocalIpAddr, 500);		
#endif /* _RTL_UPNP */	
				link->insideGlobalPort = 500;
			}
		}		
	}
	return SUCCESS;
}


/*********************************************************************************
* Routine Name :  rtl8651_l4AliasIpsecInit                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/


int32 rtl8651_l4AliasIpsecInit(void *arg){
	
	
	/* malloc global variable */
	if(_rtl8651_isakmpDb) rtlglue_free(_rtl8651_isakmpDb);
	_rtl8651_isakmpDb = (struct isakmp_data_s *)rtlglue_malloc(algMaxSession.ipsecMaxSession*(sizeof(struct isakmp_data_s)));
	memset(_rtl8651_isakmpDb,0,algMaxSession.ipsecMaxSession*(sizeof(struct isakmp_data_s)));	
	rtl8651_l4EspNaptAliasIn = _rtl8651_l4EspNaptAliasIn;
	rtl8651_l4EspNaptAliasOut = _rtl8651_l4EspNaptAliasOut;
	return SUCCESS;
}


void rtl8651_l4AliasIpsecReInit(void){
	
	if(_rtl8651_isakmpDb) memset(_rtl8651_isakmpDb,0,algMaxSession.ipsecMaxSession*(sizeof(struct isakmp_data_s)));	
	rtl8651_l4EspNaptAliasIn = _rtl8651_l4EspNaptAliasIn;
	rtl8651_l4EspNaptAliasOut = _rtl8651_l4EspNaptAliasOut;	
}


/*********************************************************************************
* Routine Name :  rtl8651_l4AliasIpsecHouseKeeping                                   
* Description :                                                 
* Input :                                                               
* Output :                                                             
* Return :                                                             
* Note :   
*        ThreadSafe: n
**********************************************************************************/
void 
rtl8651_l4AliasIpsecHouseKeeping(void){ 
	int i,j;
	struct isakmp_data_s *tp;
	tp = _rtl8651_isakmpDb;
	
	/* isakmp db */
	for(i = 0 ; i < algMaxSession.ipsecMaxSession ; i++){
		
		if(tp == NULL || _rtl8651_isakmpDb == NULL)
				return;
		if(tp->state == IPSEC_FREE)
			continue;

		// clear disable entry
		for(j=0;j<RTL8651_MAX_DIALSESSION;j++)
			if((alg_supports[j]&RTL8651_ALG_IPSEC)==0)
			{
				if(tp->dsid==j) tp->state = IPSEC_FREE;
			}
			
		tp->idle_timer++;
		if(tp->idle_timer > IPSEC_IDLE_TIME ){	
			tp->state = IPSEC_FREE;
		}
		tp++;
	}	
}



