/*
* Copyright c                  Realtek Semiconductor Corporation, 2003  
* All rights reserved.
* 
* Program : Support ALG for mIRC v6.12 DCC(Direct Client Connection,SEND & CHAT)
* Abstract : 
* Creator : 
* Author :
* $Id: rtl8651_alg_irc_dcc.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_irc_dcc.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.5  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.4  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.3  2004/04/20 03:44:02  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/03 06:37:05  tony
* remove printk message
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.5  2004/01/29 01:39:47  orlando
* checkin acl's dsid support, not the final version
*
* Revision 1.4  2004/01/12 11:59:34  tony
* make ALG is able to enable/disable for multiple dial session.
*
* Revision 1.3  2003/12/19 11:40:01  tony
* change memcpy to rtl8651_memcpy
*
* Revision 1.2  2003/11/28 02:53:17  tony
* remove unused irc_init function
*
* Revision 1.1  2003/11/27 03:26:20  tony
* Support ALG for mIRC DCC (Direct Client Connect: SEND and CHAT)
*
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_irc_dcc.h"

int32 rtl8651_l4AliasHandleIrcDccClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint32 i,j,k,endport_idx=0;

	uint32 dcc_type=0;
	uint8 *dcc;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_IRC)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	dcc = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	dlen = tlen - hlen;

	//PRIVMSG ((target) :^ADCC SEND ((filename) ((longip) ((port) ((filesize)^A 
	if(dlen<8) return SUCCESS;
	if(memcmp(dcc,"PRIVMSG",7))  return SUCCESS;

	for(i=7;i<dlen;i++)
	{
		if(dcc[i]==1)
		{			
			if(i+10>dlen) return SUCCESS;
			if(memcmp(&dcc[i+1],"DCC SEND ",9)==0) dcc_type=IRC_DCC_SEND;
			else if(memcmp(&dcc[i+1],"DCC CHAT ",9)==0) dcc_type=IRC_DCC_CHAT;				
			else return SUCCESS;
			i+=10;
			break;
		}
	}
	if(dcc_type==0) return SUCCESS;
	

	for(j=dlen-1;j>=i;j--)
		{
			if(((dcc[j]&0xff)==1)&&(dcc_type==IRC_DCC_CHAT)) endport_idx=j;
			if(dcc[j]==' ')
			{				
				
				if(endport_idx!=0)				
				{
					uint16 port=0;
					char port_str[6]={0};
					if(endport_idx-j-1>5) return SUCCESS;
					rtl8651_memcpy(port_str,&dcc[j+1],endport_idx-j-1);
					for(k=0;k<5;k++)
						{
							if(port_str[k]==0) break;
							port=port*10+(port_str[k]-'0');							
						}					
					//printk("dcc type=%s port=%d\n",(dcc_type==IRC_DCC_SEND)?"SEND":"CHAT",port);
#ifdef _RTL_UPNP
					/* add PNP port map */
					rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, 0, 0, 
						tb->insideGlobalIpAddr, port,
						tb->insideLocalIpAddr, port);	
					//printk("addupnp ip:%u.%u.%u.%u:%d",NIPQUAD(tb->insideGlobalIpAddr),port);
#endif /* _RTL_UPNP */					
					break;
				}

				if((endport_idx==0) &&(dcc_type==IRC_DCC_SEND)) endport_idx=j;
			}
		}

	return SUCCESS;
}

