/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_alg_mms.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_mms.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.6  2005/08/25 04:01:35  chenyl
* *: rearrange code, add MUTEX lock/unlock for external functions, add `inline' property to some critical functions
*
* Revision 1.5  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.4  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.3  2004/04/20 03:44:03  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/19 12:17:21  cfliu
* Rename all osk_malloc, printk, printf, printfByPolling as rtlglue_printf
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.2  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.7  2004/02/18 13:54:37  chhuang
* *** empty log message ***
*
* Revision 1.6  2003/12/19 11:40:01  tony
* change memcpy to rtl8651_memcpy
*
* Revision 1.5  2003/12/17 10:33:56  hiwu
* add checksum function
*
* Revision 1.4  2003/10/02 10:40:05  hiwu
* fix header conflict problem
*
* Revision 1.3  2003/10/02 10:03:25  hiwu
* fix mms tcp parser bug
*
* Revision 1.2  2003/10/02 07:05:32  hiwu
* merge with new table driver
*
* Revision 1.1  2003/09/23 04:36:00  hiwu
* initial version
*
*/


#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_mms.h"

#define _RTL8651_L4_MAX_MMS_ALIAS_BUF_SIZE 576

static uint8 *_rtl8651_l4_mms_alias_buf[2]; 

#define IS_DIGIT(c)    (c >= '0' && c <= '9')
#define IS_DIGITDOT(c) ((c >= '0' && c <= '9') || c == '.')
#define IS_ALPHA(c)    ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z'))
#define IS_WSPACE(c)   (c == ' ' || c == '\t' || c == '\r' || c == '\n')
#define SKIP_WSPACE(p,n) while( n > 0 && IS_WSPACE(*p) ) { n--; p++; }


/*** helpers ***/

static int32
str_to_u16( int8* pbuf, uint16* pval )
{
    int32 n = 0;

    *pval = 0;
    while( pbuf[n] >= '0' && pbuf[n] <= '9' )
    {
        *pval = (*pval * 10) + (pbuf[n] - '0');
        n++;
    }

    return n;
}

static int32
str_to_u32( int8* pbuf, uint32* pval )
{
    int32 n = 0;

    *pval = 0;
    while( pbuf[n] >= '0' && pbuf[n] <= '9' )
    {
        *pval = (*pval * 10) + (pbuf[n] - '0');
        n++;
    }

    return n;
}

static int32
next_line( int8** ppbuf, uint32* pbuflen, int8** ppline, uint32* plinelen )
{
    int8* pbuf = *ppbuf;
    uint32 buflen = *pbuflen;
    uint32 linelen = 0;

    do
    {
        while( *pbuf != '\r' && *pbuf != '\n' )
        {
            if( buflen <= 1 )
            {
                return 0;
            }

            pbuf++;
            linelen++;
            buflen--;
        }

        if( buflen > 1 && *pbuf == '\r' && *(pbuf+1) == '\n' )
        {
            pbuf++;
            buflen--;
        }

        pbuf++;
        buflen--;
    }
    while( buflen > 0 && (*pbuf == ' ' || *pbuf == '\t') );

    *ppline = *ppbuf;
    *plinelen = linelen;
    *ppbuf = pbuf;
    *pbuflen = buflen;

    return linelen;
}


static  struct tcphdr*
get_mbuf_data( struct ip *iph, struct rtl_mBuf** ppm, int8** ppdata, uint32* plen )
{
    struct tcphdr*  th;
    struct rtl_mBuf *pm;
    int8* pbuf;
    int8* pend;
    
    pm = *ppm;
    mBuf_copyToUserBuffer(pm,0,mBuf_getPktlen(pm),(int8 *)_rtl8651_l4_mms_alias_buf[0]);
    
    th = (struct tcphdr*)&(_rtl8651_l4_mms_alias_buf[0][(iph->ip_vhl & 0x0f)<<2]);

    pbuf = (int8*)th + (((th->th_off_x>>4) & 0xf) << 2);
    pend = (int8 *)(pm->m_data) + pm->m_len;    
    *ppdata = pbuf;
    *plen = pend - pbuf;
    return th;
}


/*
 * Handle outgoing (C->S) packet
 */
int32 rtl8651_l4AliasHandleMmsCleintOutbound(
	struct rtl_pktHdr *indat, 
	struct ip *pip,
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *tb	
)
{


    int32   diff     = 0;
    int8* mbuf_data_p  = NULL;
    uint32 mbuf_len   = 0;

    int8* pdata    = NULL;
    uint32   datalen  = 0;

    int8* pline;
    uint32 linelen;
    int8  buf[32];
    int32   buflen;

    uint32 entitylen = 0;
    int32 isinvite = 0;
    int32 accepted = 0;
    int32 addrpos = 0;
    int32 addrlen = 0;
    int32 portpos = 0;
    int32 portlen = 0;
    uint16 s_port;
 
    struct in_addr t_in_addr ;
    struct tcphdr *tc;
    struct rtl_mBuf *m;
    
    ipaddr_t ip_s,ip_d = 0;	
		
    ip_s = PKTGET_UINT32_UNALIGNED(&pip->ip_src);
    ip_d = PKTGET_UINT32_UNALIGNED(&pip->ip_dst);    
        
    m = indat->ph_mbuf;
    
  
/* Calculate data length of TCP packet */

   /* alias_buf is init here */
    tc = get_mbuf_data(pip, &m, &mbuf_data_p, &mbuf_len );
    pip = (struct ip*)_rtl8651_l4_mms_alias_buf[0];
    pdata = mbuf_data_p;
    datalen = mbuf_len;

    if( !next_line( &pdata, &datalen, &pline, &linelen ) )
    {
        return FAILED;
    }

    /* Look for "MSG <seqno> <v> <mimelen>" */
    if( strncmp( pline, "MSG ", 4 ) != 0 ) 
    	return FAILED;
    
    pline += 4;
    
    if( ! IS_DIGIT(*pline) ) 
    	return FAILED;
    
    while( IS_DIGIT(*pline) ) 
    	pline++;
    
    if( *pline != ' ' ) 
    	return FAILED;
    
    pline++;
    
    if( ! IS_ALPHA(*pline) ) 
    	return FAILED;
    
    pline++;
    
    if( *pline != ' ' ) 
    	return FAILED;
    
    pline++;
    
    if( ! IS_DIGIT(*pline) ) 
    	return FAILED;
    
    pline += str_to_u32( pline, &entitylen );

    /* Parse mime headers */
    while( next_line( &pdata, &datalen, &pline, &linelen ) )
    {
        if( linelen == 0 )
        {
            break;
        }
        if( memcmp( pline, "Content-Type:", 13 ) == 0 )
        {
            pline += 13;
            while( *pline == ' ' ) 
            	pline++;
            
            if( memcmp( pline, "text/x-msmsgsinvite;", 20 ) == 0 )
                isinvite = 1;
        }
    }
    
    if( !isinvite ) 
    	return FAILED;

    /* Parse entity for accept, ipaddr, port */
    while( next_line( &pdata, &datalen, &pline, &linelen ) )
    {
        if( memcmp( pline, "Invitation-Command:", 19 ) == 0 )
        {
            pline += 19;
            while( *pline == ' ' ) pline++;
            if( memcmp( pline, "ACCEPT", 6 ) == 0 )
                accepted = 1;
        }
        if( memcmp( pline, "IP-Address:", 11 ) == 0 )
        {
            pline += 11;
            while( *pline == ' ' ) pline++;
            addrpos = pline - mbuf_data_p;
            addrlen = 0;
            while( IS_DIGITDOT(pline[addrlen]) ) addrlen++;
        }
        if( memcmp( pline, "Port:", 5 ) == 0 )
        {
            pline += 5;
            while( *pline == ' ' ) pline++;
            portpos = pline - mbuf_data_p;
            portlen = 0;
            while( IS_DIGIT(pline[portlen]) ) portlen++;
        }
    }

    if( !accepted || !addrpos || !portpos ) 
    	return FAILED;

    str_to_u16( mbuf_data_p+portpos, &s_port );


#ifdef _RTL_UPNP
		/* add PNP port map */
    if(tb->natlink == 0){
    	rtl8651_addUpnpMap(UPNP_TCP|UPNP_ONESHOT, ip_d, 0, 
			tb->insideGlobalIpAddr, s_port,
			ip_s, s_port);		
    }
#endif /* _RTL_UPNP */    
    
    
    /* Replace the data */
    /* replace ip address */
    {    	
    	uint8 *cp ;
    	t_in_addr.s_addr = tb->insideGlobalIpAddr ;
    	NTOHL(t_in_addr.s_addr);
   		cp = (uint8 *)(&t_in_addr);
    	
	    buflen = sprintf( buf, "%d.%d.%d.%d", cp[0],cp[1],cp[2],cp[3]);
    }
    
    if( buflen == addrlen )
    {
        rtl8651_memcpy( mbuf_data_p+addrpos, buf, buflen );
    }
    else
    {
        get_mbuf_data( pip, &m, &mbuf_data_p, &mbuf_len );
        diff += buflen - addrlen;
        if( portpos > addrpos )
        {
            portpos += buflen - addrlen;
        }
    }

    /* replace port */
    /* hiwu: in fact I did not replace the port */
    buflen = sprintf( buf, "%hu", ntohs(s_port) );
    
    if( buflen == portlen )
    {
        rtl8651_memcpy( mbuf_data_p+portpos, buf, buflen );
    }
    else
    {
		/* Save information regarding modified seq and ack numbers */
		
			int32     delta;

            /*
			SetAckModified(link);
			delta = GetDeltaSeqOut(pip, link);
    	    diff += buflen - portlen;
			AddSeq(pip, link, delta + diff);		    
            */
            
			tb->tcpAckModified = 1;
			delta = _rtl8651_l4GetDeltaSeqOut(pip, tc, tb);
			diff += buflen - portlen;
			_rtl8651_l4AddSeq(pip, tb, delta + diff);
                        
    }

    	/* Revise IP header */
	{
		uint16    new_len;
		
		new_len = ntohs(pip->ip_len)+ diff;
		HTONS(new_len);
		pip->ip_len = new_len;
		
		/* Compute TCP/IP checksum for revised packet */
		tc->th_sum = 0;
		pip->ip_sum = 0;				
		tc->th_sum = _rtl8651_tcpChecksum(pip);
		pip->ip_sum = _rtl8651_ipChecksum(pip);			

		mBuf_copyToMbuf(m, 0, new_len, (int8 *)_rtl8651_l4_mms_alias_buf[0]);
	}

    return SUCCESS;
}


static int32 init_mms = 0;
int32 rtl8651_l4AliasMmsInit(void *arg){
	
	if(init_mms)
		return SUCCESS;
		
	init_mms = 1;	
	/* malloc global variable */
	_rtl8651_l4_mms_alias_buf[0] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_MMS_ALIAS_BUF_SIZE+64);
	_rtl8651_l4_mms_alias_buf[1] = (uint8 *)rtlglue_malloc(_RTL8651_L4_MAX_MMS_ALIAS_BUF_SIZE+64);
	assert(_rtl8651_l4_mms_alias_buf[0]);
	assert(_rtl8651_l4_mms_alias_buf[1]);

	return SUCCESS;
}

