/*
* Copyright c                  Realtek Semiconductor Corporation, 2003  
* All rights reserved.
* 
* Program : Quake
* Abstract : 
* Creator : 
* Author : $
* $Id: rtl8651_alg_quake.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_quake.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.3  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.2  2004/04/20 03:44:03  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.1  2004/03/12 07:35:39  tony
* add new ALG for Quake I, Quake II, Quake III
*
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_quake.h"

static uint16 udpport=0;

int32 rtl8651_l4AliasHandleQuakeClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	uint8 *message;


	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_QUAKE)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	dlen = tlen - hlen;

	if(dlen<5) return SUCCESS;

	//type
	if(data[0]!=0x00||data[1]!=0x80) return SUCCESS;

	//pointer to message
	message=data+4;

	switch(*message)
	{
		case 0x81:
			{
				uint16 length=((data[2]<<8)&0xff00)|(data[3]&0xff);
				uint16 udpport_local=0;
				if(length<9) return SUCCESS;
				message++;
				udpport_local=((message[0]<<8)&0xff00)|(message[1]&0xff);
#ifdef _RTL_UPNP
				/* add PNP port map */
				rtl8651_addUpnpMap(UPNP_ONESHOT, 0, udpport, 
					tb->insideGlobalIpAddr, udpport_local,
					tb->insideLocalIpAddr, udpport_local);	
#endif /* _RTL_UPNP */						
				
			}
			break;	
	}

	return SUCCESS;
}


int32 rtl8651_l4AliasHandleQuakeClientInbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	uint8 *message;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_QUAKE)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	dlen = tlen - hlen;

	if(dlen<5) return SUCCESS;

	//type
	if(data[0]!=0x00||data[1]!=0x80) return SUCCESS;

	//pointer to message
	message=data+4;

	switch(*message)
	{
		case 0x81:
			{
				uint16 length=((data[2]<<8)&0xff00)|(data[3]&0xff);
				if(length<9) return SUCCESS;
				message++;
				udpport=((message[0]<<8)&0xff00)|(message[1]&0xff);
			}
			break;	
	}

	return SUCCESS;	
}
