/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : RealAudio UDP data channel
* Abstract : 
* Creator : 
* Author : $
* $Id: rtl8651_alg_realaudio.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_realaudio.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:05  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.4  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.3  2004/04/20 03:44:03  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.2  2004/03/15 11:33:02  tony
* remove debug message
*
* Revision 1.1  2004/03/12 07:36:34  tony
* add new ALG for RealAudio
*
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_realaudio.h"

int32 rtl8651_l4AliasHandleRealAudioClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen,idx,port_idx;
	uint8 *data;
	uint16 version=0;
	uint16 msg_id=0;
	uint16 msg_len=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_REALAUDIO)==0) return SUCCESS;

		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	dlen = tlen - hlen;

	if(dlen<9) return SUCCESS; 

	if(memcmp(data,"PNA",3)!=0) return SUCCESS;

	version=((data[3]<<8)&0xff00)|(data[4]&0xff);

	if(version>=256) return SUCCESS;

	idx=5;

	while(idx+4<dlen)
	{
		msg_id=((data[idx]<<8)&0xff00)|(data[idx+1]&0xff);
		msg_len=((data[idx+2]<<8)&0xff00)|(data[idx+3]&0xff);
		idx+=4;
		if(msg_id==0) return SUCCESS; //end tag seen
		port_idx=idx;
		idx+=msg_len;
		if(idx>dlen) return SUCCESS; // packet to short
		if((msg_id==1)||(msg_id==7)) 
		{
			uint16 udp_port;
			udp_port=((data[port_idx]<<8)&0xff00)|(data[port_idx+1]&0xff);
#ifdef _RTL_UPNP
			/* add PNP port map */
			if(udp_port!=0)
			{
				rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
					tb->insideGlobalIpAddr, udp_port,
					tb->insideLocalIpAddr, udp_port);
					//printk("open a udp port:%d for RealAudio!\n",udp_port);
			}
#endif /* _RTL_UPNP */
		}
	}
	return SUCCESS;
}




