/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : VDOlive
* Abstract : 
* Creator : 
* Author : $
* $Id: rtl8651_alg_vdolive.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_alg_vdolive.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:06  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.3  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.2  2004/04/20 03:44:03  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.1  2004/03/12 07:36:11  tony
* add new ALG for VDOlive
*
*
*/

#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_alg_init.h"
#include "rtl8651_alg_vdolive.h"

int32 rtl8651_l4AliasHandleVDOliveClientOutbound(struct rtl_pktHdr *pkthdrPtr, struct ip *pip,
			struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *tb)
{
	struct tcphdr *tcp;
	int32 hlen, tlen, dlen;
	uint8 *data;
	uint32 targval=0;
	uint16 port=0;

	if((alg_supports[pkthdrPtr->ph_dsid]&RTL8651_ALG_VDOLIVE)==0) return SUCCESS;
		
	tcp = (struct tcphdr *) ((int8 *) pip + ((pip->ip_vhl &0xf) << 2));	
	data = ((uint8 *)tcp + ((tcp->th_off_x & 0xf0) >> 2));

	tlen = ntohs(pip->ip_len);
	hlen = ((pip->ip_vhl & 0xf) + (( tcp->th_off_x >>4)&0xf)) << 2;//Edward: Fix for alignment issue
	dlen = tlen - hlen;

	if(dlen<=8) return SUCCESS;

	targval=((data[4]<<24)&0xff000000)|((data[5]<<16)&0xff0000)|((data[6]<<24)&0xff00)|(data[7]&0xff);

	if((targval!=6)&&(targval!=1)) return SUCCESS;

	if((targval==6)&&(dlen<=36)) return 0;
	else if((targval==1)&&(dlen<=20)) return 0;

	if(targval==6) data+=24;
	else data+=8;

	if(memcmp(data,"VDO Live",8)!=0) return 0;

	data+=10;
	
	port=(data[0]<<8&0xff00)|(data[1]&0xff);

#ifdef _RTL_UPNP
	/* add PNP port map */
	rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, 
		tb->insideGlobalIpAddr, port,
		tb->insideLocalIpAddr, port);	
#endif /* _RTL_UPNP */		

	return SUCCESS;
}




