/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : 
* Abstract : 
* Creator : 
* Author :  
* $Id: rtl8651_dos.c,v 1.1.1.1 2006/07/26 05:38:23 blue Exp $
* $Log: rtl8651_dos.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:23  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:06  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:43  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.2  2005/11/22 15:50:54  chenyl
* *: Add mutex lock/unlock in log r/w
* *: new idle-timeout mechanism for VLAN / PPPOE / PPTP / L2TP wan types
* *: bug fix: PPTP passthrough
* *: bug fix: sip / ymsg typo error
* *: for ARP-reply module in RomeDrv, use newly allocated mbuf/pkt instead of original one ( To prevent from treated as packet forwarding instead of reply).
* *: minor coding style, sync with main trunk
*
* +: ioctl case for Mutex Lock/Unlock called by user level
* +: add 2 APIs to enable / disable
* 	1. Error messages from protocol stack to WAN : TCP RST, ICMP ICMP_UNREACH/ICMP_SOURCEQUENCH/ICMP_TIMXCEED/ICMP_PARAMPROB
* 	2. All packet from protocol stack to WAN
*    filtering to disable / enable idle-timer update triggered by these kinds of packets.
* +: TFTP ALG
* +: rtl8651_debug.h for debugging usage
* +: merge code about rtl_glue.c / re_core.c with Sercomm's version ( Airgo modification ?)
* +:
*
* Revision 1.1.1.1  2005/11/21 05:20:03  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.32  2005/07/07 07:31:58  shliu
* *: Modify ip spoof judgement in pptp/l2tp wan type.
*
* Revision 1.31  2005/02/16 02:02:15  chenyl
* *: fix module test's bug: reset napt-connection-control system's threshold when doing system-reinit.
*
* Revision 1.30  2004/12/15 06:05:15  chenyl
* *: modify "enable switch"'s checking position
*
* Revision 1.29  2004/12/15 05:45:43  chenyl
* *: re-write connection control system's code about "Per-Source Tracking Entry Update"
*
* Revision 1.28  2004/12/14 09:48:09  chenyl
* +: NAPT-Connection Control system
* *: add "NAPT-AddFail" error messages into ignore case.
*
* Revision 1.27  2004/12/07 02:29:43  chenyl
* +: Connection tracking/counting system prototype
*
* Revision 1.26  2004/11/19 06:59:39  chenyl
* *: fix unalignment bug
*
* Revision 1.25  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.24  2004/07/27 07:31:42  chenyl
* *: pptp/ipSec pass-through, GRE/ESP fragment packets process.
* *: if DoS Ignore Type is matched, we check whether system can sent fragment packet
*    regardless of the TearDrop Setting.
*
* Revision 1.23  2004/07/26 14:45:43  chenyl
* +: new logging model
* +: dos Ignore Case
* 	- ignore packets from LAN
* 	- ignore packets from WAN
*
* Revision 1.22  2004/07/23 13:19:57  tony
* *: remove all warning messages.
*
* Revision 1.21  2004/07/12 12:43:02  chenyl
* *: bug fix: typing error of Port Scan System
*
* Revision 1.20  2004/07/12 12:02:51  chenyl
* *: bug fix : debugging legacy
*
* Revision 1.19  2004/07/12 05:50:04  chenyl
* *: bug fix: sip blocking will cause crash when port scan detected
*
* Revision 1.18  2004/07/12 05:32:03  chenyl
* *: bug fix: proc DOS type error of dos_proc "_SCAN" -> "_PORTSCAN"
*
* Revision 1.17  2004/07/12 04:25:36  chenyl
* *: extend existing port scan mechanism
*
* Revision 1.16  2004/07/02 10:30:08  chenyl
* *: bug fix: per-source Flooding check bug (counter error)
* *: bug fix: ip-spoofing ACL add function error
* *: bug fix: ICMP ping-of-death : threshold from 65500 to 65535 (follows cisco)
* *: bug fix: item name change of DOS check: UDP Bomb -> UDP EchoChargen (follows cisco)
* +: new feature: New DoS check item, UDP Bomb
* 		- Triggered if (Length of UDP header) < (Length of IP header)
* 		- allow (Length of UDP header) > (Length of IP header)
* 		- follows cisco
*
* Revision 1.15  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.14  2004/06/18 08:11:15  tony
* +: add new features: SYN,FIN,ACK Port Scan.
*
* Revision 1.13  2004/06/03 06:46:10  chenyl
* *: queue-all fragment packet only when tear-drop check enabled
* *: modify module test for auto zero bit padding
*
* Revision 1.12  2004/05/25 11:14:24  chenyl
* *: bug fix for icmp fragment packet check
*
* Revision 1.11  2004/05/21 12:08:50  chenyl
* *: TCP/UDP/ICMP spoof -> check for (sip) == (dip)
* *: modify DOS prevention webpage
*
* Revision 1.10  2004/05/20 12:28:35  chenyl
* *: for fast path packets, only check SYN/FIN/UDP/ICMP flooding DOS
* *: fast path packets don't run Egress ACL
* *: BUG FIX: refresh age-time of UDP flows in forwarding engine
*
* Revision 1.9  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.8  2004/05/12 07:20:14  chenyl
* +: source ip blocking
* *: modify dos mechanism
*
* Revision 1.7  2004/04/20 03:44:03  tony
* if disable define "RTL865X_OVER_KERNEL" and "RTL865X_OVER_LINUX", __KERNEL__ and __linux__ will be undefined.
*
* Revision 1.6  2004/03/25 08:56:29  chenyl
* *: tcp syn-with-data : SYN packet with IP_MF set need to be caught
*
* Revision 1.5  2004/03/24 09:50:37  chenyl
* +: Queued pkts to CPU
*
* Revision 1.4  2004/03/16 13:01:55  jzchen
* Add assert to avoid dsid error
*
* Revision 1.3  2004/03/16 06:46:27  chenyl
* *: dos check modification for pure-L3 dos check in TCP/UDP/ICMP dos check
*
* Revision 1.2  2004/03/05 08:19:25  chenyl
* *: change SYN,ICMP,UDP,FIN Flood check mechanism
* *: change fwdeng check flow, check dos one time in whole data path
*
* Revision 1.1  2004/02/25 14:26:33  chhuang
* *** empty log message ***
*
* Revision 1.3  2004/02/25 14:24:52  chhuang
* *** empty log message ***
*
* Revision 1.25  2004/02/18 07:05:32  chhuang
* remove compiler warning
*
* Revision 1.24  2004/01/13 09:02:29  orlando
* fix bug in rtl8651_dosOneSecondTimer()
*
* Revision 1.23  2004/01/08 13:30:40  orlando
* api change
*
* Revision 1.22  2004/01/07 05:37:14  orlando
* logging feature sercomm phase 2 spec 1st milestone checkin
*
* Revision 1.21  2004/01/07 03:42:08  orlando
* checkin sercomm phase2 spec change 1st milestone api
*
* Revision 1.20  2004/01/06 03:22:34  orlando
* move counter update to be after dos penalty clear loop and set loop
* so that 0 packet/second will be equivalent to drop all
*
* Revision 1.19  2004/01/06 03:00:16  orlando
* tune dosPenaltyClear loop to be executed only when dosPenaltySetFlag
* has been set
*
* Revision 1.18  2004/01/06 02:23:30  orlando
* tune dosPenaltyFlag variables
*
* Revision 1.17  2004/01/06 02:03:09  orlando
* add _rtl8651_dosPenaltySet(Clear)Flag variables to gurantee the set/clear
* dosPenalty loop will be done once only per second
*
* Revision 1.16  2004/01/05 13:27:22  orlando
* dos spec change (drop existing flow data, allow new flow data)
*
* Revision 1.15  2003/12/31 05:42:10  orlando
* modify macros to deal with unalignment access issues.
*
* Revision 1.14  2003/12/08 13:50:20  orlando
* enhance logging function
*
* Revision 1.13  2003/12/03 01:47:16  tony
* move rtl8651_setDosStatus() to rtl8651_dos.c
*
* Revision 1.12  2003/12/02 12:30:45  tony
* the common.h is replace by rtl8651_dos.h and rtl8651_alg_init.h
*
* Revision 1.11  2003/12/02 10:24:47  tony
* Add Routine: support DoS is able to set threshold by user(Webs GUI).
*
* Revision 1.10  2003/12/02 09:29:15  tony
* rename alg.h to common.h(used for RomeDrvier and Turnkey)
*
* Revision 1.9  2003/10/30 10:14:32  orlando
* add _rtl8651_enableDos() code, but leave them marked
*
* Revision 1.8  2003/10/28 08:28:24  orlando
* tune logging function parameters
*
* Revision 1.7  2003/10/24 10:25:57  tony
* add DoS attack interactive webpage,
* FwdEngine is able to get WAN status by rtl8651_wanStatus(0:disconnect,1:connect)
*
* Revision 1.6  2003/10/23 12:11:17  tony
* add DoS test message.
*
* Revision 1.5  2003/10/23 08:54:15  tony
* add direction info in DoS functions, fix ipSpoof DoS function.
*
* Revision 1.4  2003/10/23 02:10:35  tony
* fix DoS function routine
*
* Revision 1.3  2003/10/21 08:07:02  tony
* add DoS attack log routine
*
* Revision 1.2  2003/10/17 04:32:47  hiwu
* merge into forwarding engine
*
* Revision 1.1  2003/09/18 03:36:05  hiwu
* initial version
*
*
*/


#include "rtl_types.h"
#include "assert.h"
#include "types.h"
#include "rtl_queue.h"
#include "rtl_errno.h"
#include "rtl_glue.h"
#include "mbuf.h"

#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvStatistic.h"
#include "rtl8651_tblDrv.h"
#include "rtl8651_dos.h"
#include "rtl8651_dos_local.h"

/* hash function */
#include "rtl8651_jhash.h"

#ifdef RTL865X_TEST
#define printk	printf
#endif /* RTL865X_TEST */
#define MAX(a,b) ((a>b)?a:b)
#define MIN(a,b) ((a>b)?b:a)

/*********************************************************************************
							Ignore Type Function declaration
*********************************************************************************/
void _rtl8651_dosTurnOn(uint32 dsid, uint32 enableItem);
void _rtl8651_dosTurnOff(uint32 dsid);
void _rtl8651_dosIgnoreTypeFlush(void);
uint32 _rtl8651_dosIgnoreTypeAdd(uint32);
uint32 _rtl8651_dosIgnoreTypeDel(uint32);
/*********************************************************************************
							Internal Function declaration
*********************************************************************************/
static int32 _rtl8651_dosSynFlood(uint32 dsid,struct ip*,struct tcphdr *,uint32*);//tool,CHECK(2 ways ok)
static int32 _rtl8651_dosStealthFin(uint32 dsid,struct ip *,struct tcphdr *,uint32*);//tool,CHECK(2 ways ok)
static int32 _rtl8651_dosScan(struct ip*,struct tcphdr *);//tool,ok,CHECK(XMAS scan,NULL scan)(2 ways ok)
static int32 _rtl8651_dosTcpLand(struct ip *,struct tcphdr *);//tool,ok,CHECK(lan to wan error)
static int32 _rtl8651_dosSynWithData(struct ip *,struct tcphdr *);//tool,ok,CHECK(2 ways ok)
static int32 _rtl8651_dosUdpBomb(struct ip *,struct udphdr *);//tool,ok,CHECK(2 ways ok)
static int32 _rtl8651_dosUdpEchoChargen(struct ip *, struct udphdr *);//tool,ok,CHECK(2 ways ok)
static int32 _rtl8651_dosUdpLand(struct ip *,struct udphdr *);//no tool,implement ok
static int32 _rtl8651_dosUdpFlood(uint32 dsid,struct ip *,struct udphdr *,uint32*);//tool,CHECK(2 ways ok)
static int32 _rtl8651_dosPingOfDeath(struct ip *,struct icmp *); //tool,fwd not support icmp defragment
static int32 _rtl8651_dosIcmpFlood(uint32 dsid,struct ip *,struct icmp *, uint32*);//tool,check(2 ways ok)
static int32 _rtl8651_dosIcmpLand(struct ip *,struct icmp *);//no tool,implement ok
static int32 _rtl8651_dosSmurf(struct ip *,struct icmp *, uint16);//tool,hw block DMAC is BCAST && sip==gw && dip=subnet bcast, CPU get nothing, code not able to verify
static int32 _rtl8651_dosIpSpoof(struct ip *, uint16, uint8);//tool,ok,CHECK(lan to wan test ok!) wan to lan not be tested
static void _rtl8651_dosPreProcess(uint32, uint32, uint32); // pre-process when turn-on some dos detection, the orld and new switch are both known and the corresponding process can be done.
static void _rtl8651_dosSwitch(void);
static void _rtl8651_dosACLSet(void);
/*********************************************************************************
							DOS Sytem global variables
*********************************************************************************/
/* for tcp Dos Scan */
static int8 _tcpDosScanBitmap[64];
/*********************************************************************************
							DOS check Switches and Counters
*********************************************************************************/
/* switch */
uint32		_rtl8651_dos_enable = FALSE;
uint32		_rtl8651_dos_sw[RTL8651_MAX_DIALSESSION] = {0};
static uint32	_rtl8651_dos_ignoreType;	/* determine what kind of packets need to be checked and what kinds of packets need to be ingore */
/* counter */
static int32 _rtl8651_local_syn_counter[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_fin_counter[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_icmp_counter[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_udp_counter[RTL8651_MAX_DIALSESSION];
/* threshold */
static int32 _rtl8651_local_syn_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_fin_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_icmp_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_local_udp_threshold[RTL8651_MAX_DIALSESSION];
/*-- Connection Control System --*/
/* threshold */
static int32 _rtl8651_local_tcpConn_threshold;
static int32 _rtl8651_local_udpConn_threshold;
static int32 _rtl8651_local_tcpudpConn_threshold;
/*********************************************************************************
		per-sip pkt count tracking system switches, threshold and data structures
*********************************************************************************/
#define DOS_PERSRC_PKT_TRACK_SYSTEM
// per-sip packet count tracking data structure
typedef struct _rtl8651_dos_PktCnt_s {
	/*-----------------Data------------------*/
	uint8	item;
	uint32	recordTime;
	ipaddr_t	ip;
	uint32	count;
	/*---------------Linked List---------------*/
	// free list
	struct _rtl8651_dos_PktCnt_s	**hdr;
	struct _rtl8651_dos_PktCnt_s	*prev;
	struct _rtl8651_dos_PktCnt_s	*next;
	// Last-Recently-Used list
	struct _rtl8651_dos_PktCnt_s	*lru_prev;
	struct _rtl8651_dos_PktCnt_s	*lru_next;
	// Linked List
	struct _rtl8651_dos_PktCnt_s	*list_prev;
	struct _rtl8651_dos_PktCnt_s	*list_next;
} _rtl8651_dos_PktCnt_t;
// system enable ?
static uint32	_rtl8651_SrcTracking_enable = TRUE;
// hash table
#define RTL8651_DOS_HASHTBL_SIZE		32
#define RTL8651_DOS_HASH_RAND			31

/**********************************************************
	Usage 1: trace Packet count per-second
**********************************************************/
// hash table header
static _rtl8651_dos_PktCnt_t	*synHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t	*finHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t	*udpHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t	*icmpHash[RTL8651_DOS_HASHTBL_SIZE];

// hash table size
static uint32 synLimit	= 0;
static uint32 finLimit	= 0;
static uint32 udpLimit	= 0;
static uint32 icmpLimit	= 0;
static uint32 synCnt	= 0;
static uint32 finCnt		= 0;
static uint32 udpCnt	= 0;
static uint32 icmpCnt	= 0;

// lru list header
static _rtl8651_dos_PktCnt_t	*lru_hdr = NULL;
static _rtl8651_dos_PktCnt_t *lru_tail = NULL;

#define RTL8651_DOS_SRCTRACK_NONE	0
#define RTL8651_DOS_SRCTRACK_SYN		1
#define RTL8651_DOS_SRCTRACK_FIN		2
#define RTL8651_DOS_SRCTRACK_UDP		3
#define RTL8651_DOS_SRCTRACK_ICMP		4

// threshold
static int32 _rtl8651_perSrc_syn_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_perSrc_fin_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_perSrc_udp_threshold[RTL8651_MAX_DIALSESSION];
static int32 _rtl8651_perSrc_icmp_threshold[RTL8651_MAX_DIALSESSION];


/**********************************************************
	Usage 2: trace Total Connection Count
**********************************************************/
// hash table header
static _rtl8651_dos_PktCnt_t	*tcpConnHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t *udpConnHash[RTL8651_DOS_HASHTBL_SIZE];
static _rtl8651_dos_PktCnt_t *tcpudpConnHash[RTL8651_DOS_HASHTBL_SIZE];

// hash table size
static uint32 tcpConnLimit		= 0;
static uint32 udpConnLimit		= 0;
static uint32 tcpudpConnLimit	= 0;
static uint32 tcpConnCnt		= 0;
static uint32 udpConnCnt		= 0;
static uint32 tcpudpConnCnt	= 0;

// linked-list header
static _rtl8651_dos_PktCnt_t *connInuseList = NULL;
static _rtl8651_dos_PktCnt_t *connFreeList = NULL;

#define RTL8651_DOS_CONNTRACK_NONE		0
#define RTL8651_DOS_CONNTRACK_TCP		1
#define RTL8651_DOS_CONNTRACK_UDP		2
#define RTL8651_DOS_CONNTRACK_TCPUDP		3
#define RTL8651_DOS_CONNTRACK_MAXTYPE	4	/* Note : All type definition MUST less than this entry */

// threshold
static int32 _rtl8651_perSrc_tcpConn_threshold;
static int32 _rtl8651_perSrc_udpConn_threshold;
static int32 _rtl8651_perSrc_tcpudpConn_threshold;
/*********************************************************************************
				per-sip pkt count tracking system functions declaration
*********************************************************************************/
/*-------Init-------*/
static int32 _rtl8651_dosSrcTracking_init(rtl8651_fwdEngineInitPara_t *);
static int32 _rtl8651_dosSrcTracking_reinit(void);
/*-------Hash Table management-------*/
static __inline__ uint32 _rtl8651_dosHash(ipaddr_t);
static __inline__ void _rtl8651_dosSrcTrackingLink(_rtl8651_dos_PktCnt_t **, _rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingUnlink(_rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingLruUnlink(_rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToTail(_rtl8651_dos_PktCnt_t *);
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToHead(_rtl8651_dos_PktCnt_t *);
static __inline__ int32 _rtl8651_dosSrcTrackingListRemoveFromList(_rtl8651_dos_PktCnt_t **list, _rtl8651_dos_PktCnt_t *entry);
static __inline__ void _rtl8651_dosSrcTrackingListAddToHead(_rtl8651_dos_PktCnt_t **, _rtl8651_dos_PktCnt_t *);

/*-------Usage 1-------*/
static uint32 _rtl8651_dosSrcTrackingCount(uint32, ipaddr_t);
//static void _rtl8651_dosSrcTrackingRemove(uint32, ipaddr_t);
/*-------Dos Check-------*/
static int32 _rtl8651_dosSrcSynFlood(uint32,struct ip*,struct tcphdr *, uint32 *);
static int32 _rtl8651_dosSrcStealthFin(uint32,struct ip*,struct tcphdr *, uint32 *);
static int32 _rtl8651_dosSrcUdpFlood(uint32,struct ip *, uint32 *);
static int32 _rtl8651_dosSrcIcmpFlood(uint32,struct ip *,struct icmp *, uint32 *);

/*-------Usage 2-------*/
static inline int32 _rtl8651_connSrcTracking_FindEntry(uint8, ipaddr_t, _rtl8651_dos_PktCnt_t ***, _rtl8651_dos_PktCnt_t **, uint32 **, uint32 **);
static inline uint32 _rtl8651_connSrcTracking_getConnCount(uint8, ipaddr_t);
static inline void _rtl8651_connSrcTrackingRemove(uint32 *, _rtl8651_dos_PktCnt_t *);
static inline void _rtl8651_connSrcTrackingUpdate(uint8, ipaddr_t, uint32);
static void _rtl8651_connSrcTrackingFlush(uint8);
/*-------Dos Check-------*/
static inline int32 _rtl8651_dosSrcConnCtrl(uint8, ipaddr_t);
static inline int32 _rtl8651_dosConnCtrl(uint8);
/*********************************************************************************
		syn/fin/ack/udp scan pkt flow cache system switches, threshold and data structures

		* run in slow path
*********************************************************************************/
#define DOS_PERSRC_SUSPECTFLOW_CACHE_SYSTEM
/* per-sip packet flow cache data structure */
typedef struct _rtl8651_dos_SuspectFlowCache_s {
	/*-----------------Data------------------*/
	uint32	expire;
	ipaddr_t	sip;
	uint8	direction;	/* 0:LAN_to_WAN 1:WAN_to_LAN */
	uint32	dsid;
	rtl8651_tblDrv_vlanTable_t *vlan;
	/* syn */
	uint32	SynDstIpMask;
	uint32	SynSrcPortMask;
	uint32	SynDstPortMask;
	uint16	SynComplainCnt;
	/* fin */
	uint32	FinDstIpMask;
	uint32	FinSrcPortMask;
	uint32	FinDstPortMask;
	uint16	FinComplainCnt;
	/* ack */
	uint32	AckDstIpMask;
	uint32	AckSrcPortMask;
	uint32	AckDstPortMask;
	uint16	AckComplainCnt;
	/* udp */
	uint32	UdpDstIpMask;
	uint32	UdpSrcPortMask;
	uint32	UdpDstPortMask;
	uint16	UdpComplainCnt;
	/* total */
	uint16	TotalComplainCnt;

	/*---------------Linked List---------------*/
	/* hash table */
	struct _rtl8651_dos_SuspectFlowCache_s	**hdr;
	struct _rtl8651_dos_SuspectFlowCache_s	*prev;
	struct _rtl8651_dos_SuspectFlowCache_s	*next;
	/* Last-Recently-Used list */
	struct _rtl8651_dos_SuspectFlowCache_s	*lru_prev;
	struct _rtl8651_dos_SuspectFlowCache_s	*lru_next;
} _rtl8651_dos_SuspectFlowCache_t;

/* system enable ? */
static uint32	_rtl8651_ScanTrackingSystem_enable = FALSE;	/* system initiate and enable system ? */
static uint32	_rtl8651_ScanTrackingSystem_turnON = FALSE;	/* user turn ON scan tracking system ? */

/* hash table header */
static _rtl8651_dos_SuspectFlowCache_t	*SuspectFlowCacheHash[RTL8651_DOS_HASHTBL_SIZE] = {NULL};
/* lru list header */
static _rtl8651_dos_SuspectFlowCache_t *lru_SuspectFlowCache_hdr = NULL;
static _rtl8651_dos_SuspectFlowCache_t *lru_SuspectFlowCache_tail = NULL;
/* structure pointer and counter */
static _rtl8651_dos_SuspectFlowCache_t *SuspectFlowCache_ptr = NULL;
static uint32 SuspectFlowCache_Cnt = 0;
/* threshold and timeout */
static uint32 _rtl8651_scan_monitor_window = RTL8651_DOS_SCAN_MOINTOR_WIN_DEFAULT;
static uint32 _rtl8651_scan_threshold[RTL8651_MAX_DIALSESSION] = {0};
/*********************************************************************************
				syn/fin/ack/udp scan pkt flow cache system functions declaration
*********************************************************************************/
/*-------Init-------*/
static int32 _rtl8651_dosScanTracking_init(rtl8651_fwdEngineInitPara_t *);
static int32 _rtl8651_dosScanTracking_reinit(void);
static __inline__ void _rtl8651_dosScanTrackingLink(_rtl8651_dos_SuspectFlowCache_t**, _rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingUnlink(_rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingLruUnlink(_rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingLruMoveToTail(_rtl8651_dos_SuspectFlowCache_t *);
static __inline__ void _rtl8651_dosScanTrackingLruMoveToHead(_rtl8651_dos_SuspectFlowCache_t *);
static _rtl8651_dos_SuspectFlowCache_t *_rtl8651_dosScanTrackingFindEntry(ipaddr_t);
static int32 _rtl8651_dosTcpUdpScan(_rtl8651_dos_SuspectFlowCache_t *, uint16, uint8);


/*********************************************************************************
				macro
*********************************************************************************/
#ifdef _RTL_NEW_LOGGING_MODEL
#define DOS_LOG(logType,dsid,sip,dip,l4proto,direction,sport,dport,icmpType,icmpId,logAction) \
	do { \
		if ( (_loggingModule[(dsid)] & RTL8651_LOGMODULE_DOS) && _pUserLoggingFunc ) \
		{ \
			rtl8651_logInfo_t info;\
			info.infoType = RTL8651_LOG_INFO_PKT; \
			info.pkt_dsid = (dsid); \
			info.pkt_sip = (sip); \
			info.pkt_dip = (dip); \
			info.pkt_proto = (l4proto); \
			info.pkt_direction = (direction); \
			info.pkt_sport = ((sport)?(sport):(0xffff)); \
			info.pkt_dport = ((dport)?(dport):(0xffff)); \
			info.pkt_icmpType	= (icmpType); \
			info.pkt_icmpId = ((icmpId)?(icmpId):(0xffff)); \
			info.action = (logAction); \
			(*_pUserLoggingFunc) (RTL8651_LOGMODULE_DOS, (logType), &info); \
		} \
	} while (0);
#else
#define DOS_LOG(dsid,sip,dip,l4proto,direction,sport,dport,icmpType,logAction,msg) \
	do { \
		if ( (_loggingModule[(dsid)] & RTL8651_LOGMODULE_DOS) && _pUserLoggingFunc ) \
		{ \
			(*_pUserLoggingFunc) ( \
			(dsid), \
			RTL8651_LOGMODULE_DOS, \
			(unsigned char)(l4proto), \
			(unsigned char)(direction), \
			(unsigned long)(sip), \
			(unsigned long)(dip), \
			(unsigned short)((sport)?(sport):0xffff), \
			(unsigned short)((dport)?(dport):0xffff), \
			(unsigned short)(icmpType), \
			(logAction), \
			(msg));\
		} \
	} while (0);
#endif


/*********************************************************************************
							DOS Sytem control functions
*********************************************************************************/
/* DOS initial function */
void _rtl8651_dos_init(rtl8651_fwdEngineInitPara_t *para){
	uint32 i;
	memset(&_tcpDosScanBitmap[0], 0, sizeof(_tcpDosScanBitmap));
	//0: - NULL scan
	// 3: SYN,FIN - SYN/FIN scan
	// 8: PUSH	-Vecna
	// 9: PUSH, FIN -Vecna
	// 32: URG	-Vecna
	// 33: URG, FIN -Vecna	
	// 40: URG,PUSH -Vecna
	// 41: URG,PUSH,FIN: - nmap xmas scan
	// 58: SYN,ACK,URG,PUSH - full Sapu scan
	// 63: SYN,RST,FIN,URG,PUSH,ACK - full Xmas scan
	_tcpDosScanBitmap[0]=_tcpDosScanBitmap[3]=_tcpDosScanBitmap[8]=_tcpDosScanBitmap[9]=
	_tcpDosScanBitmap[32]=_tcpDosScanBitmap[33]=_tcpDosScanBitmap[40]=_tcpDosScanBitmap[41]=
	_tcpDosScanBitmap[58]=_tcpDosScanBitmap[63]=1;
	for (i=0;i<RTL8651_MAX_DIALSESSION;i++){
		_rtl8651_local_syn_threshold[i]		= RTL8651_DOS_SYN_THRESHOLD_DEFAULT;
		_rtl8651_local_fin_threshold[i]		= RTL8651_DOS_FIN_THRESHOLD_DEFAULT;
		_rtl8651_local_icmp_threshold[i]		= RTL8651_DOS_ICMP_THRESHOLD_DEFAULT;
		_rtl8651_local_udp_threshold[i]		= RTL8651_DOS_UDP_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_syn_threshold[i]		= RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_fin_threshold[i]		= RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udp_threshold[i]		= RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_icmp_threshold[i]	= RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT;

		_rtl8651_local_tcpConn_threshold		= RTL8651_DOS_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_udpConn_threshold	= RTL8651_DOS_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_tcpudpConn_threshold	= RTL8651_DOS_TCPUDPCONN_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_tcpConn_threshold	= RTL8651_DOS_PERSRC_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udpConn_threshold	= RTL8651_DOS_PERSRC_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_tcpudpConn_threshold= RTL8651_DOS_PERSRC_TCPUDPCONN_THRESHOLD_DEFAULT;
		
		_rtl8651_dosTurnOff(i);
	}
	_rtl8651_dosSrcTracking_init(para);
	_rtl8651_dosScanTracking_init(para);
	_rtl8651_procDoSPkt_init(para);
	_rtl8651_dosIgnoreTypeFlush();
}

void _rtl8651_dos_Reinit()
{
	uint32 i;
	memset(&_tcpDosScanBitmap[0], 0, sizeof(_tcpDosScanBitmap));
	//0: - NULL scan
	// 3: SYN,FIN - SYN/FIN scan
	// 8: PUSH	-Vecna
	// 9: PUSH, FIN -Vecna
	// 32: URG	-Vecna
	// 33: URG, FIN -Vecna	
	// 40: URG,PUSH -Vecna
	// 41: URG,PUSH,FIN: - nmap xmas scan
	// 58: SYN,ACK,URG,PUSH - full Sapu scan
	// 63: SYN,RST,FIN,URG,PUSH,ACK - full Xmas scan
	_tcpDosScanBitmap[0]=_tcpDosScanBitmap[3]=_tcpDosScanBitmap[8]=_tcpDosScanBitmap[9]=
	_tcpDosScanBitmap[32]=_tcpDosScanBitmap[33]=_tcpDosScanBitmap[40]=_tcpDosScanBitmap[41]=
	_tcpDosScanBitmap[58]=_tcpDosScanBitmap[63]=1;
	for (i=0;i<RTL8651_MAX_DIALSESSION;i++){
		_rtl8651_local_syn_threshold[i]		= RTL8651_DOS_SYN_THRESHOLD_DEFAULT;
		_rtl8651_local_fin_threshold[i]		= RTL8651_DOS_FIN_THRESHOLD_DEFAULT;
		_rtl8651_local_icmp_threshold[i]		= RTL8651_DOS_ICMP_THRESHOLD_DEFAULT;
		_rtl8651_local_udp_threshold[i]		= RTL8651_DOS_UDP_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_syn_threshold[i]		= RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_fin_threshold[i]		= RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udp_threshold[i]		= RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_icmp_threshold[i]	= RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT;

		_rtl8651_local_tcpConn_threshold		= RTL8651_DOS_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_udpConn_threshold	= RTL8651_DOS_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_local_tcpudpConn_threshold	= RTL8651_DOS_TCPUDPCONN_THRESHOLD_DEFAULT;

		_rtl8651_perSrc_tcpConn_threshold	= RTL8651_DOS_PERSRC_TCPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_udpConn_threshold	= RTL8651_DOS_PERSRC_UDPCONN_THRESHOLD_DEFAULT;
		_rtl8651_perSrc_tcpudpConn_threshold= RTL8651_DOS_PERSRC_TCPUDPCONN_THRESHOLD_DEFAULT;

		_rtl8651_dosTurnOff(i);
	}
	_rtl8651_dosSrcTracking_reinit();
	_rtl8651_dosScanTracking_reinit();
	_rtl8651_procDosPkt_reinit();
	_rtl8651_dosIgnoreTypeFlush();
}

void rtl8651a_setDosStatus(uint32 dsid,uint32 enableItem)
{
	//if(dsid!=0) return FAILED;
	if(enableItem)
		_rtl8651_dosTurnOn(dsid, enableItem);
	else
		_rtl8651_dosTurnOff(dsid);
}

void rtl8651a_setDosThreshold(uint32 dsid,uint32 type,uint32 threshold)
{
	assert(dsid < rtl8651_tblDrvPara.dialSessionNumber);
	switch(type)
	{
		case RTL8651_DOS_SYN_THRESHOLD:
			_rtl8651_local_syn_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_FIN_THRESHOLD:
			_rtl8651_local_fin_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_UDP_THRESHOLD:
			_rtl8651_local_udp_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_ICMP_THRESHOLD:
			_rtl8651_local_icmp_threshold[dsid]=threshold;
			break;
		case RTL8651_DOS_TCPCONN_THRESHOLD:
			_rtl8651_local_tcpConn_threshold = threshold;
			break;
		case RTL8651_DOS_UDPCONN_THRESHOLD:
			_rtl8651_local_udpConn_threshold = threshold;
			break;
		case RTL8651_DOS_TCPUDPCONN_THRESHOLD:
			_rtl8651_local_tcpudpConn_threshold = threshold;
			break;
	}
}

void rtl8651a_setPerSrcDosThreshold(uint32 dsid, uint32 type, uint32 threshold)
{
	assert(dsid < rtl8651_tblDrvPara.dialSessionNumber);
	switch(type)
	{
		case RTL8651_DOS_SYN_THRESHOLD:
			_rtl8651_perSrc_syn_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_FIN_THRESHOLD:
			_rtl8651_perSrc_fin_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_UDP_THRESHOLD:
			_rtl8651_perSrc_udp_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_ICMP_THRESHOLD:
			_rtl8651_perSrc_icmp_threshold[dsid] = threshold;
			break;
		case RTL8651_DOS_TCPCONN_THRESHOLD:
			_rtl8651_perSrc_tcpConn_threshold = threshold;
			break;
		case RTL8651_DOS_UDPCONN_THRESHOLD:
			_rtl8651_perSrc_udpConn_threshold = threshold;
			break;
		case RTL8651_DOS_TCPUDPCONN_THRESHOLD:
			_rtl8651_perSrc_tcpudpConn_threshold = threshold;
			break;
	}
}

/*
	Pre-Process before actual setting the new switch to DOS system
*/
static void _rtl8651_dosPreProcess(uint32 dsid, uint32 oldSW, uint32 newSW)
{
	/* <------ We must reinit connection tracking system before use it ------> */
	if ( (oldSW & RTL8651_DOS_SRC_TCPCONNOVERFLOW) != (newSW & RTL8651_DOS_SRC_TCPCONNOVERFLOW) )
	{
		_rtl8651_connSrcTrackingFlush(RTL8651_DOS_CONNTRACK_TCP);
	}
	if ( (oldSW & RTL8651_DOS_SRC_UDPCONNOVERFLOW) != (newSW & RTL8651_DOS_SRC_UDPCONNOVERFLOW) )
	{
		_rtl8651_connSrcTrackingFlush(RTL8651_DOS_CONNTRACK_UDP);
	}
	if ( (oldSW & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW) != (newSW & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW) )
	{
		_rtl8651_connSrcTrackingFlush(RTL8651_DOS_CONNTRACK_TCPUDP);
	}
}

static void _rtl8651_dosSwitch(void)
{
	uint32 idx;
	uint32 enable;

	/* check dos system */
	enable = FALSE;
	for (idx = 0 ; idx < RTL8651_MAX_DIALSESSION ; idx ++)
	{
		if (_rtl8651_dos_sw[idx])
			enable = TRUE;
	}
	_rtl8651_dos_enable = enable;

	/* check scan tracking system */
	enable = FALSE;
	for (idx = 0 ; idx < RTL8651_MAX_DIALSESSION ; idx ++)
	{
		if (_rtl8651_dos_sw[idx] & RTL8651_DOS_PORTSCAN)
			enable = TRUE;
	}
	_rtl8651_ScanTrackingSystem_turnON = enable;
}
void _rtl8651_dosACLSet(void)
{
	uint32 i;
	uint32 addVlanMask;
	uint32 delVlanMask;

	/********** According to dos Filter, some vlans don't need to add acl **********/
	addVlanMask = 0xffffffff;		/* by default, we add acl to all vlans */ 
	delVlanMask = 0xffffffff;		/* if we want to delete one dos itme, we delete acl from all vlans */

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_LAN)
	{	/* don't process ALL PACKET FROM LAN, so we filter ALL INTERNAL VLANs */
		rtl8651_tblDrv_vlanTable_t *vlanp;
		for (i = 0 ; i < RTL8651_VLAN_NUMBER ; i ++)
		{
			vlanp = &DrvTbl.vlan[i];
			if (vlanp->internal)
			{	/* filter it */
				addVlanMask &= ~(1<<i);
			}
		}
	}

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_WAN)
	{	/* don't process ALL PACKET FROM WAN, so we filter ALL EXTERNAL VLANs */
		rtl8651_tblDrv_vlanTable_t *vlanp;
		for (i = 0 ; i < RTL8651_VLAN_NUMBER ; i ++)
		{
			vlanp = &DrvTbl.vlan[i];
			if (!(vlanp->internal))
			{	/* filter it */
				addVlanMask &= ~(1<<i);
			}
		}
	}
	/********************************************************************/
	/* trap all packets which "syn" flag set */
	/*
		SYN Flood, SynWithData, TCP Land Attack
	*/
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_SYNWITHDATA|RTL8651_DOS_TCPLAND|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_TCP_SYNFLOOD, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_TCP_SYNFLOOD, FALSE, delVlanMask);
	}
	/* trap all packets which "fin" flag set */
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_TCP_STEALTHFIN, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_TCP_STEALTHFIN, FALSE, delVlanMask);
	}
	/* TCP scans */
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_SCAN))
		{
			_rtl8651_enableDoS(RTL8651_TCP_FULLXMASSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_FULLSAPUSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_FINSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_SYNFINSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_NULLSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_NMAPXMASSCAN, TRUE, addVlanMask);
			_rtl8651_enableDoS(RTL8651_TCP_VECNASCAN, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_TCP_FULLXMASSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_FULLSAPUSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_FINSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_SYNFINSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_NULLSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_NMAPXMASSCAN, FALSE, delVlanMask);
		_rtl8651_enableDoS(RTL8651_TCP_VECNASCAN, FALSE, delVlanMask);
	}

	/* IP spoofing */
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_IPSPOOF))
		{
			_rtl8651_enableDoS(RTL8651_IP_SPOOFING, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_IP_SPOOFING, FALSE, delVlanMask);
	}

	/* UDP EchoChargen */
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_ECHOCHARGEN))
		{
			_rtl8651_enableDoS(RTL8651_UDP_ECHOCHARGENBOMB, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_UDP_ECHOCHARGENBOMB, FALSE, delVlanMask);
	}

	/* UDP Flood, Bomb, LAND */
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD|RTL8651_DOS_UDPBOMB|RTL8651_DOS_UDPLAND|RTL8651_DOS_UDPCONNOVERFLOW|RTL8651_DOS_SRC_UDPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_UDP_FLOOD, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_UDP_FLOOD, FALSE, delVlanMask);
	}
	
	/* TCP/UDP port scan */
	for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i++)
	{
		if (_rtl8651_dos_sw[i] & (RTL8651_DOS_PORTSCAN|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW))
		{
			_rtl8651_enableDoS(RTL8651_TCPUDP_PORTSCAN, TRUE, addVlanMask);
			break;
		}
		/* disable */
		_rtl8651_enableDoS(RTL8651_TCPUDP_PORTSCAN, FALSE, delVlanMask);
	}
	return;
}

void _rtl8651_dosTurnOn(uint32 dsid, uint32 enableItem)
{
	/* do related processes */
	_rtl8651_dosPreProcess(dsid, _rtl8651_dos_sw[dsid], enableItem);
	/* dos process switch */
	_rtl8651_dos_sw[dsid] = enableItem;
	/* re-check switch */
	_rtl8651_dosSwitch();
	/* disable napt auto add if we need */
	if (_rtl8651_dos_enable == TRUE)
		rtl8651_enableNaptAutoAdd(FALSE);
	_rtl8651_dosACLSet();
}

void _rtl8651_dosTurnOff(uint32 dsid)
{
	/* do related processes */
	_rtl8651_dosPreProcess(dsid, _rtl8651_dos_sw[dsid], 0);
	/* set new switch */
	_rtl8651_dos_sw[dsid] = 0;
	/* re-check switch */
	_rtl8651_dosSwitch();
	/* re-Arrange ACL */
	_rtl8651_dosACLSet();
}
/*
	Flush dos ignore items to zero, it means DOS system will process ALL packets
*/
void _rtl8651_dosIgnoreTypeFlush(void)
{
	_rtl8651_dos_ignoreType = 0;
	_rtl8651_dosACLSet();	/* ignore policy is modified, re-Arrange ACL again */
}
/*
	Add dos ignore items, return the New check item mask
*/
uint32 _rtl8651_dosIgnoreTypeAdd(uint32 add)
{
	_rtl8651_dos_ignoreType |= add;
	_rtl8651_dosACLSet();	/* ignore policy is modified, re-Arrange ACL again */
	return _rtl8651_dos_ignoreType;
}
/*
	Delete dos ignore items, return the New check item mask
*/
uint32 _rtl8651_dosIgnoreTypeDel(uint32 del)
{
	_rtl8651_dos_ignoreType &= ~(del);
	_rtl8651_dosACLSet();	/* ignore policy is modified, re-Arrange ACL again */
	return _rtl8651_dos_ignoreType;
}

/*
	If return value is TRUE, it means this packet is ignored and we don't process it.
	If return value is FALSE, it means this packet is normal packet, so we still process it.
*/
uint8 _rtl8651_dosIgnoreTypeCheck(uint8 direction)
{
	/* direction filter check */
	if ((1 << direction) & _rtl8651_dos_ignoreType)
		return TRUE;

	/* pass the filter, return FALSE */
	return FALSE;
}

/*  a one second periodic timer ; 
	this function will be called every one second */
int32 rtl8651_dosOneSecondTimer(){
	uint32 i;
//	if(lastPortScanInfo.age>0) lastPortScanInfo.age--;
	for (i=0;i<RTL8651_MAX_DIALSESSION;i++){
		_rtl8651_local_syn_counter[i]		= 0;
		_rtl8651_local_fin_counter[i]		= 0;
		_rtl8651_local_icmp_counter[i]	= 0;
		_rtl8651_local_udp_counter[i]		= 0;
	}
	return SUCCESS;
}
/*********************************************************************************
						per-sip pkt count tracking system functions implementation
*********************************************************************************/
#define DOS_PERSRC_PKT_TRACK_SYSTEM_FUNCTIONS
static int32 _rtl8651_dosSrcTracking_init(rtl8651_fwdEngineInitPara_t *para)
{
	_rtl8651_dos_PktCnt_t *ptr;
	int32 idx;
	int32 tblsize;						// table size of tracking system

	assert(para);

	if (!para)
		goto err;

	/*---------------------- Usage 1 ----------------------*/

	/* We can't determine total table size if (one of syn/fin/udp/icmp tables is no limit) and (total entry count is no limit) */
	if ((!para->dos_total_trackCnt) &&
		((!para->dos_SynFlood_trackCnt) || (!para->dos_StealthFin_trackCnt) || (!para->dos_UdpFlood_trackCnt) || (!para->dos_IcmpFlood_trackCnt)))
		goto err;

	/* determine table size */
	if (para->dos_total_trackCnt)
	{
		if (para->dos_SynFlood_trackCnt && para->dos_StealthFin_trackCnt && para->dos_UdpFlood_trackCnt && para->dos_IcmpFlood_trackCnt)
		{
			tblsize = MIN(para->dos_total_trackCnt, (para->dos_SynFlood_trackCnt + para->dos_StealthFin_trackCnt + para->dos_UdpFlood_trackCnt + para->dos_IcmpFlood_trackCnt));
		}else
		{
			tblsize = para->dos_total_trackCnt;
		}
	}else
	{
		tblsize = (para->dos_SynFlood_trackCnt + para->dos_StealthFin_trackCnt + para->dos_UdpFlood_trackCnt + para->dos_IcmpFlood_trackCnt);
	}

	/* store the limit of each table */
	synLimit		= (para->dos_SynFlood_trackCnt)?para->dos_SynFlood_trackCnt:tblsize;
	finLimit		= (para->dos_StealthFin_trackCnt)?para->dos_StealthFin_trackCnt:tblsize;
	udpLimit		= (para->dos_UdpFlood_trackCnt)?para->dos_UdpFlood_trackCnt:tblsize;
	icmpLimit	= (para->dos_IcmpFlood_trackCnt)?para->dos_IcmpFlood_trackCnt:tblsize;

	/* clear counter */
	synCnt		= 0;
	finCnt		= 0;
	udpCnt		= 0;
	icmpCnt		= 0;

	/* allocate memory for source tracking */
	lru_hdr = rtlglue_malloc(tblsize*sizeof(_rtl8651_dos_PktCnt_t));
	if (!lru_hdr)
		goto err;

	memset(lru_hdr, 0, tblsize*sizeof(_rtl8651_dos_PktCnt_t));

	/* set tail of lru list */
	lru_tail = lru_hdr + (tblsize - 1);

	/* initial linked list */
	ptr = lru_hdr;
	for (idx = 0 ; idx < tblsize ; idx ++, ptr ++)
	{
		if (idx != 0)
		{
			ptr->lru_prev = ptr - 1;
		}
		if (idx != (tblsize - 1))
		{
			ptr->lru_next = ptr + 1;
		}
	}

	/* hash table */
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		synHash[idx]			= NULL;
		finHash[idx]			= NULL;
		udpHash[idx]			= NULL;
		icmpHash[idx]		= NULL;
	}

	/*---------------------- Usage 2 ----------------------*/
	/* We can't determine total table size if (one of TCP/UDP/ALL-connection tables is no limit) and (total entry count is no limit) */
	if ((!para->dos_totalConn_trackCnt) &&
		((!para->dos_TcpConn_trackCnt) || (!para->dos_UdpConn_trackCnt) || (!para->dos_TcpUdpConn_trackCnt)))
		goto err;

	/* determine table size */
	if (para->dos_totalConn_trackCnt)
	{
		if (para->dos_TcpConn_trackCnt && para->dos_UdpConn_trackCnt && para->dos_TcpUdpConn_trackCnt)
		{
			tblsize = MIN(para->dos_total_trackCnt, (para->dos_TcpConn_trackCnt + para->dos_UdpConn_trackCnt + para->dos_TcpUdpConn_trackCnt));
		}else
		{
			tblsize = para->dos_totalConn_trackCnt;
		}
	}else
	{
		tblsize = (para->dos_TcpConn_trackCnt + para->dos_UdpConn_trackCnt + para->dos_TcpUdpConn_trackCnt);
	}

	/* store the limit of each table */
	tcpConnLimit		= (para->dos_TcpConn_trackCnt)?para->dos_TcpConn_trackCnt:tblsize;
	udpConnLimit	= (para->dos_UdpConn_trackCnt)?para->dos_UdpConn_trackCnt:tblsize;
	tcpudpConnLimit	= (para->dos_TcpUdpConn_trackCnt)?para->dos_TcpUdpConn_trackCnt:tblsize;

	/* clear counter */
	tcpConnCnt		= 0;
	udpConnCnt		= 0;
	tcpudpConnCnt	= 0;

	/* allocate memory for source tracking */
	connInuseList = NULL;
	connFreeList = rtlglue_malloc(tblsize*sizeof(_rtl8651_dos_PktCnt_t));
	if (!connFreeList)
		goto err;

	memset(connFreeList, 0, tblsize*sizeof(_rtl8651_dos_PktCnt_t));

	/* initial linked list : use the "lru" pointer as Free/Inuse list */
	ptr = connFreeList;
	for (idx = 0 ; idx < tblsize ; idx ++, ptr ++)
	{
		if (idx != 0)
		{
			ptr->list_prev = ptr - 1;
		}
		if (idx != (tblsize - 1))
		{
			ptr->list_next = ptr + 1;
		}
	}

	/* hash table */
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		tcpConnHash[idx]			= NULL;
		udpConnHash[idx]		= NULL;
		tcpudpConnHash[idx]		= NULL;
	}

	/* All source tracking system OK */
	_rtl8651_SrcTracking_enable = TRUE;
	return SUCCESS;
err:
	_rtl8651_SrcTracking_enable = FALSE;
	return FAILED;
}
static int32 _rtl8651_dosSrcTracking_reinit(void)
{
	uint32 idx;
	_rtl8651_dos_PktCnt_t	*ptr;

	if (_rtl8651_SrcTracking_enable == FALSE)
		return FAILED;

	/*---------------------- Usage 1 ----------------------*/

	/* hash table */
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		synHash[idx]			= NULL;
		finHash[idx]			= NULL;
		udpHash[idx]			= NULL;
		icmpHash[idx]		= NULL;
	}

	/* trace lru_list and clear all entries */
	ptr = lru_hdr;
	if (!ptr)
		goto err;
	while (ptr)
	{
		ptr->recordTime	= 0;
		ptr->ip			= 0;
		ptr->count		= 0;
		ptr->item		= RTL8651_DOS_SRCTRACK_NONE;
		ptr->hdr			= NULL;
		ptr->prev		= NULL;
		ptr->next		= NULL;

		ptr = ptr->lru_next;
	}

	/* reset counter */
	synCnt		= 0;
	finCnt		= 0;
	udpCnt		= 0;
	icmpCnt		= 0;

	/*---------------------- Usage 2 ----------------------*/

	/* hash table */
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx++)
	{
		tcpConnHash[idx]		= NULL;
		udpConnHash[idx]	= NULL;
		tcpudpConnHash[idx]	= NULL;
	}

	/* trace lru_list and clear all entries */
	ptr = connInuseList;
	while (ptr)
	{
		_rtl8651_dosSrcTrackingListRemoveFromList(&connInuseList, ptr);
		_rtl8651_dosSrcTrackingListAddToHead(&connFreeList, ptr);
		ptr = connInuseList;
	}

	/* reset counter */
	tcpConnCnt		= 0;
	udpConnCnt		= 0;
	tcpudpConnCnt	= 0;
	
	return SUCCESS;
err:
	_rtl8651_SrcTracking_enable = FALSE;
	return FAILED;
}
static __inline__ uint32 _rtl8651_dosHash(ipaddr_t ip)
{
	return (ip % RTL8651_DOS_HASHTBL_SIZE);
//	return (jhash_1word(ip, RTL8651_DOS_HASH_RAND) & (RTL8651_DOS_HASHTBL_SIZE-1));
}
static __inline__ void _rtl8651_dosSrcTrackingLink(_rtl8651_dos_PktCnt_t **hdr, _rtl8651_dos_PktCnt_t *entry)
{	// put entry to head of list
	entry->hdr = hdr;		// entry point at header
	entry->next = (*hdr);		// entry point at next entry
	if (*hdr)	{
		(*hdr)->prev = entry;	// next entry point at entry
	}

	(*hdr) = entry;			// header point at entry
}
static __inline__ void _rtl8651_dosSrcTrackingUnlink(_rtl8651_dos_PktCnt_t *entry)
{	// remove entry from list
	_rtl8651_dos_PktCnt_t **hdr = entry->hdr;
	if (!hdr) {	// this entry isn't in any linked list
		goto clearLink;
	}
	if (entry->prev)
		entry->prev->next = entry->next;
	if (entry->next)
		entry->next->prev = entry->prev;

	if ((*hdr) == entry)
		(*hdr) = entry->next;
clearLink:
	entry->hdr	= NULL;
	entry->prev	= NULL;
	entry->next	= NULL;
}
static __inline__ void _rtl8651_dosSrcTrackingLruUnlink(_rtl8651_dos_PktCnt_t *entry)
{
	if (entry->lru_prev)
		entry->lru_prev->lru_next = entry->lru_next;
	if (entry->lru_next)
		entry->lru_next->lru_prev = entry->lru_prev;
	if (lru_hdr == entry)
		lru_hdr = entry->lru_next;
	if (lru_tail == entry)
		lru_tail = entry->lru_prev;
	entry->lru_next = NULL;
	entry->lru_prev = NULL;
}
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToTail(_rtl8651_dos_PktCnt_t *entry)
{	// move entry to tail of list
	if (lru_tail == entry)
		return;

	assert(lru_hdr != lru_tail);	// If hdr=tail, LruUnlink will let lru_hdr and lru_tail become NULL both
	_rtl8651_dosSrcTrackingLruUnlink(entry);
	entry->lru_prev = lru_tail;
	if (lru_tail)
		lru_tail->lru_next = entry;
	lru_tail = entry;
}
static __inline__ void _rtl8651_dosSrcTrackingLruMoveToHead(_rtl8651_dos_PktCnt_t *entry)
{	// move entry to tail of list
	if (lru_hdr == entry)
		return;

	assert(lru_hdr != lru_tail);	// If hdr=tail, LruUnlink will let lru_hdr and lru_tail become NULL both
	_rtl8651_dosSrcTrackingLruUnlink(entry);
	entry->lru_next = lru_hdr;
	if (lru_hdr)
		lru_hdr->lru_prev = entry;
	lru_hdr = entry;
}
static __inline__ int32 _rtl8651_dosSrcTrackingListRemoveFromList(_rtl8651_dos_PktCnt_t **list, _rtl8651_dos_PktCnt_t *entry)
{
	if ( (list == NULL) ||(*list == NULL) ||(entry == NULL) )
		return FAILED;

	if (entry->list_prev)
		entry->list_prev->list_next = entry->list_next;
	if (entry->list_next)
		entry->list_next->list_prev = entry->list_prev;

	if (*list == entry)
		*list = entry->list_next;

	entry->list_prev = NULL;
	entry->list_next = NULL;

	return SUCCESS;
}
static __inline__ void _rtl8651_dosSrcTrackingListAddToHead(_rtl8651_dos_PktCnt_t **list, _rtl8651_dos_PktCnt_t *entry)
{
	if ( (list == NULL) ||(entry == NULL) )
		return;

	entry->list_prev = NULL;
	entry->list_next = *list;
	if (*list)
		(*list)->list_prev = entry;
	*list = entry;

	return;
}
#define DOS_PERSRC_PKT_TRACK_SYSTEM_FOR_FLOODCHECK
/*--------------------- Usage 1 ---------------------*/
static uint32 _rtl8651_dosSrcTrackingCount(uint32 item, ipaddr_t sip)
{
	_rtl8651_dos_PktCnt_t **hdr = NULL, *ptr = NULL;
	uint32 hash = _rtl8651_dosHash(sip);
	uint32 *cntPtr, *limitPtr;
	int32 pktCnt = 0;

	if (_rtl8651_SrcTracking_enable == FALSE)
		goto noentry_out;
	switch (item)
	{
		case RTL8651_DOS_SRCTRACK_SYN:
			hdr = &synHash[hash];
			cntPtr = &synCnt;
			limitPtr = &synLimit;
			break;
		case RTL8651_DOS_SRCTRACK_FIN:
			hdr = &finHash[hash];
			cntPtr = &finCnt;
			limitPtr = &finLimit;
			break;
		case RTL8651_DOS_SRCTRACK_UDP:
			hdr = &udpHash[hash];
			cntPtr = &udpCnt;
			limitPtr = &udpLimit;
			break;
		case RTL8651_DOS_SRCTRACK_ICMP:
			hdr = &icmpHash[hash];
			cntPtr = &icmpCnt;
			limitPtr = &icmpLimit;
			break;
		default:
			goto noentry_out;
	}
	ptr = (*hdr);
	while (ptr)
	{
		if (ptr->ip == sip)
		{	// entry found
			if (ptr->recordTime < _sysUpSeconds)	// expired entry, reset it
			{
				ptr->recordTime = _sysUpSeconds;
				ptr->count = 1;	// reset counter
				pktCnt = 1;
			}else
			{
				pktCnt = ++(ptr->count);
			}
			_rtl8651_dosSrcTrackingLruMoveToTail(ptr);
			goto out;
		}
		ptr = ptr->next;
	}
	// cannot find entry for this sip, try to allocate new entry from lru_list
	ptr = lru_hdr;
	if ((*limitPtr) && ((*cntPtr) >= (*limitPtr)))
	{	// Limit Arrived: only find expired entry whose "item" is same as this new entry
		while (ptr)
		{
			if (ptr->recordTime >= _sysUpSeconds)
				goto noentry_out;	// lru-list has no any expired entry: allocation failed

			if (ptr->item == item)
			{
				goto recycle_entry;
			}
			ptr = ptr->lru_next;	// next entry
		}
		goto noentry_out;	// cannot find entry
	}else
	{	// use the first expired entry
		if ((ptr) && (ptr->recordTime < _sysUpSeconds))	// (ptr == lru_hdr) now
		{	// this entry can be allocated
			// update counter
			switch (ptr->item)
			{
				case RTL8651_DOS_SRCTRACK_SYN:
					synCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_FIN:
					finCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_UDP:
					udpCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_ICMP:
					icmpCnt --;
					break;
				case RTL8651_DOS_SRCTRACK_NONE:
					break;	// do nothing
			}
			// update counter for new entry
			*cntPtr = *cntPtr + 1;
recycle_entry:
			// remove this entry from old linked-list
			_rtl8651_dosSrcTrackingUnlink(ptr);
			// set new entry
			ptr->item			= item;
			ptr->ip				= sip;
			ptr->recordTime		= _sysUpSeconds;
			ptr->count			= 1;
			// add this entry to new linked-list
			_rtl8651_dosSrcTrackingLink(hdr, ptr);
			// move this entry to the tail of lru list
			_rtl8651_dosSrcTrackingLruMoveToTail(ptr);
			pktCnt = 1;	// new entry: count "1"
			goto out;
		}
		goto noentry_out;	// there is no expired entry: we cannot create new entry
	}
out:
	return pktCnt;
noentry_out:
	return 1;	// if we cannot set up new entry for this source ip, system return pkt count 1 for this packet
}

#if 0
static void _rtl8651_dosSrcTrackingRemove(uint32 item, ipaddr_t sip)
{
	_rtl8651_dos_PktCnt_t *ptr;
	uint32 *cntPtr;
	uint32 hash = _rtl8651_dosHash(sip);

	if (_rtl8651_SrcTracking_enable == FALSE)
		return;

	switch (item)
	{
		case RTL8651_DOS_SRCTRACK_SYN:
			ptr = synHash[hash];
			cntPtr = &synCnt;
			break;
		case RTL8651_DOS_SRCTRACK_FIN:
			ptr = finHash[hash];
			cntPtr = &finCnt;
			break;
		case RTL8651_DOS_SRCTRACK_UDP:
			ptr = udpHash[hash];
			cntPtr = &udpCnt;
			break;
		case RTL8651_DOS_SRCTRACK_ICMP:
			ptr = icmpHash[hash];
			cntPtr = &icmpCnt;
			break;
		default:
			return;
	}

	while (ptr)
	{
		if (ptr->ip == sip)
		{	// entry found
			// remove from hash table
			_rtl8651_dosSrcTrackingUnlink(ptr);
			// add to the head of lru list for new ip allocation
			ptr->recordTime = 0;							// flush record time
			ptr->item = RTL8651_DOS_SRCTRACK_NONE;		// flush item type
			_rtl8651_dosSrcTrackingLruMoveToHead(ptr);
			// update counter
			*cntPtr = *cntPtr - 1;
			return;
		}
		ptr = ptr->next;
	}
	return;
}
#endif
/*********************************************************************************
			External Functions
*********************************************************************************/
static int32 _rtl8651_dosSrcSynFlood(uint32 dsid,struct ip*ip,struct tcphdr *tc, uint32* NeedLog)
{
	ipaddr_t	sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 	pktCnt;

	*NeedLog = FALSE;
	if (tc->th_flags & TH_SYN)
	{
		pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_SYN, sip);
		if ( pktCnt >= _rtl8651_perSrc_syn_threshold[dsid])
		{	// this host send too many SYN packet
			//_rtl8651_dosSrcTrackingRemove(RTL8651_DOS_SRCTRACK_SYN, sip);
			if (pktCnt == _rtl8651_perSrc_syn_threshold[dsid])
			{
				*NeedLog = TRUE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}
static int32 _rtl8651_dosSrcStealthFin(uint32 dsid,struct ip*ip,struct tcphdr *tc, uint32* NeedLog)
{
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 pktCnt;
	
	*NeedLog = FALSE;
	if (tc->th_flags & TH_FIN)
	{
		pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_FIN, sip);
		if (pktCnt >= _rtl8651_perSrc_fin_threshold[dsid])
		{	// this host send too many FIN packet
			//_rtl8651_dosSrcTrackingRemove(RTL8651_DOS_SRCTRACK_FIN, sip);
			if (pktCnt == _rtl8651_perSrc_fin_threshold[dsid])
			{
				*NeedLog = TRUE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}
static int32 _rtl8651_dosSrcUdpFlood(uint32 dsid,struct ip *ip, uint32* NeedLog)
{
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 pktCnt;
	
	*NeedLog = FALSE;
	pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_UDP, sip);
	if (pktCnt >= _rtl8651_perSrc_udp_threshold[dsid])
	{	// this host send too many UDP packet
		//_rtl8651_dosSrcTrackingRemove(RTL8651_DOS_SRCTRACK_UDP, sip);
		if (pktCnt == _rtl8651_perSrc_udp_threshold[dsid])
		{
			*NeedLog = TRUE;
		}
		return SUCCESS;
	}
	return FAILED;
}
static int32 _rtl8651_dosSrcIcmpFlood(uint32 dsid,struct ip *ip,struct icmp *ic, uint32* NeedLog)
{
	ipaddr_t sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	uint32 pktCnt;

	*NeedLog = FALSE;
//	if (ic->icmp_type == ICMP_ECHO || ic->icmp_type == ICMP_ECHOREPLY)
//	{
		pktCnt = _rtl8651_dosSrcTrackingCount(RTL8651_DOS_SRCTRACK_ICMP, sip);
		if (pktCnt >= _rtl8651_perSrc_icmp_threshold[dsid])
		{	// this host send too many ICMP packet
			//_rtl8651_dosSrcTrackingRemove(RTL8651_DOS_SRCTRACK_ICMP, sip);
			if (pktCnt == _rtl8651_perSrc_icmp_threshold[dsid])
			{
				*NeedLog = TRUE;
			}
			return SUCCESS;
		}
//	}
	return FAILED;
}
#define DOS_PERSRC_PKT_TRACK_SYSTEM_FOR_CONNECTIONCONTROL

#define GET_COUNT_FROM_NAPT_SYSTEM(ip,tcpCntp,udpCntp) \
	do { \
		_rtl8651_countNaptConnectionByIP( (ip), (tcpCntp), (udpCntp)); \
	} while ( 0 );

/*--------------------- Usage 2 ---------------------*/
/*
	find the source tracking entry in connection count control system
*/
static inline int32 _rtl8651_connSrcTracking_FindEntry(uint8 flowType, ipaddr_t ip, _rtl8651_dos_PktCnt_t ***phdr, _rtl8651_dos_PktCnt_t **ppe, uint32 **ppcnt, uint32 **pplimit)
{
	_rtl8651_dos_PktCnt_t **hdr = NULL, *ptr = NULL;
	uint32 *pcnt = NULL, *plimit = NULL;
	uint32 hash = _rtl8651_dosHash(ip);

	switch (flowType)
	{
		case RTL8651_DOS_CONNTRACK_TCP:
			hdr = &tcpConnHash[hash];
			pcnt = &tcpConnCnt;
			plimit = &tcpConnLimit;
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			hdr = &udpConnHash[hash];
			pcnt = &udpConnCnt;
			plimit = &udpConnLimit;
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			hdr = &tcpudpConnHash[hash];
			pcnt = &tcpudpConnCnt;
			plimit = &tcpudpConnLimit;
			break;
		default:
			return FAILED;
	}
	ptr = (*hdr);
	while (ptr)
	{
		if (ptr->ip == ip)
		{
			goto out;
		}
		ptr = ptr->next;
	}
	ptr = NULL;

out:
	if (phdr)
	{
		*phdr = hdr;
	}
	if (ppe)
	{
		*ppe = ptr;
	}
	if (ppcnt)
	{
		*ppcnt = pcnt;
	}
	if (pplimit)
	{
		*pplimit = plimit;
	}
	return SUCCESS;
}

/*
	get the connection count for the specified "ip"
*/
static inline uint32 _rtl8651_connSrcTracking_getConnCount(uint8 flowType, ipaddr_t ip)
{
	_rtl8651_dos_PktCnt_t **hdr = NULL, *ptr = NULL;
	uint32 *cntPtr, *limitPtr;
	uint32 connCnt = 0;

	if (_rtl8651_SrcTracking_enable == FALSE)
	{
		goto out;
	}

	if (_rtl8651_connSrcTracking_FindEntry(flowType, ip, &hdr, &ptr, &cntPtr, &limitPtr) != SUCCESS)
	{
		goto out;
	}

	/* entry found */
	if ( ptr )
	{
		connCnt = ptr->count;
		goto out;
	}

	/************** Try to allocate new entry **************/
	{
		uint32 tmpTcp;
		uint32 tmpUdp;

		GET_COUNT_FROM_NAPT_SYSTEM(ip, &tmpTcp, &tmpUdp);

		switch (flowType)
		{
			case RTL8651_DOS_CONNTRACK_TCP:
				connCnt = tmpTcp;
				break;
			case RTL8651_DOS_CONNTRACK_UDP:
				connCnt = tmpUdp;
				break;
			case RTL8651_DOS_CONNTRACK_TCPUDP:
				connCnt = tmpTcp + tmpUdp;
				break;
		}

		/* find free entry */
		if ( (*cntPtr) < (*limitPtr) )
		{
			/* 1. From Free List */
			if ( connFreeList )
			{
				ptr = connFreeList;
				_rtl8651_dosSrcTrackingListRemoveFromList(&connFreeList, ptr);
				_rtl8651_dosSrcTrackingListAddToHead(&connInuseList, ptr);
				_rtl8651_dosSrcTrackingLink(hdr, ptr);

				ptr->ip = ip;
				ptr->count = connCnt;
				ptr->item = flowType;

				(*cntPtr) ++;
			}
		}
		/*	Can NOT Allocate new entry:
			use the data gotten from NAPT system. (have been stored in connCnt) */
	}

out:
	return connCnt;
}

static inline void _rtl8651_connSrcTrackingUpdate(uint8 flowType, ipaddr_t ip, uint32 isDecrease)
{
	_rtl8651_dos_PktCnt_t *ptr;
	uint32 *cntPtr;

	if (_rtl8651_SrcTracking_enable == FALSE)
	{
		return;
	}

	if ( (_rtl8651_connSrcTracking_FindEntry(flowType, ip, NULL, &ptr, &cntPtr, NULL) == SUCCESS) &&
		(ptr) )
	{
		if (isDecrease)
		{	/* Decrease */
			ptr->count --;

			if (ptr->count == 0)
			{
				_rtl8651_connSrcTrackingRemove(cntPtr, ptr);
			}

		} else
		{	/* Increase */
			ptr->count ++;
		}
	}
}

/*
	Flush and reinit tracking entries according to the flowType given by caller

	if flowtype = "RTL8651_DOS_CONNTRACK_NONE", flush all entries.
*/
static void _rtl8651_connSrcTrackingFlush(uint8 flowType)
{
	_rtl8651_dos_PktCnt_t *ptr, *next;
	uint32 *cntPtr = NULL;

	switch (flowType)
	{
		case RTL8651_DOS_CONNTRACK_NONE:
			cntPtr = NULL;
			tcpConnCnt = 0;
			udpConnCnt = 0;
			tcpudpConnCnt = 0;
			break;
		case RTL8651_DOS_CONNTRACK_TCP:
			cntPtr = &tcpConnCnt;
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			cntPtr = &udpConnCnt;
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			cntPtr = &tcpudpConnCnt;
			break;
		default:
			return;
	}

	ptr = connInuseList;
	while ( ptr )
	{
		next = ptr->list_next;
		if ( (flowType == RTL8651_DOS_CONNTRACK_NONE)||(ptr->item == flowType) )
		{
			_rtl8651_connSrcTrackingRemove(cntPtr, ptr);
		}
		ptr = next;
	}

	assert( (!cntPtr)||((*cntPtr) == 0) );
}

static inline void _rtl8651_connSrcTrackingRemove(uint32 *cntPtr, _rtl8651_dos_PktCnt_t *ptr)
{
	_rtl8651_dosSrcTrackingListRemoveFromList(&connInuseList, ptr);
	_rtl8651_dosSrcTrackingListAddToHead(&connFreeList, ptr);
	_rtl8651_dosSrcTrackingUnlink(ptr);
	if (cntPtr)
	{
		(*cntPtr) --;
	}
}

/*
	Flush and reinit tracking entries according to the flowType and ip given by caller

	- return the del count of source tracking entries

		Note: "RTL8651_DOS_CONNTRACK_NONE" is ILLEGAL
*/
inline int32 _rtl8651_connSrcTrackingRemoveByFlowtypeIp(uint8 flowType, ipaddr_t ip)
{
	_rtl8651_dos_PktCnt_t *ptr = NULL;
	uint32 *cntPtr = NULL;
	int32 retval = 0;

	if (_rtl8651_SrcTracking_enable == FALSE)
	{
		return 0;
	}

	while ((_rtl8651_connSrcTracking_FindEntry(flowType, ip, NULL, &ptr, &cntPtr, NULL) == SUCCESS) &&
		(ptr))
	{	/* entry found */ 
		_rtl8651_connSrcTrackingRemove(cntPtr, ptr);
		retval ++;
	}
	return retval;
}

/*
	Remove tracking entries according to the ip given by caller

	- return the del count of source tracking entries
*/
inline int32 _rtl8651_connSrcTrackingRemoveByIp(ipaddr_t ip)
{
	int32 idx;
	int32 delCnt = 0;

	for ( idx = 0 ; idx < RTL8651_DOS_CONNTRACK_MAXTYPE ; idx ++)
	{
		delCnt += _rtl8651_connSrcTrackingRemoveByFlowtypeIp(idx, ip);
	}
	
	return delCnt;
}

/*********************************************************************************
			External Functions
*********************************************************************************/
/* For Other Rome Driver Modules or forwarding engine */
/*
	Dump the information of connection count control system:
		- threshold
		- per-source connection count tracking cache
*/
void rtl8651_dumpConnCtrl(void)
{
	int connType;
	int idx;

	rtlglue_drvMutexLock();

	rtlglue_printf("Connection Counting Control System:\n");
	/* whole system */
	rtlglue_printf("\tConfiguration (whole system constraint):\n");
	/* threshold */
	rtlglue_printf("\t\t\t\tTCP\tUDP\tBOTH\n");
	rtlglue_printf("\t\tThreshold\t%d\t%d\t%d\n",
			_rtl8651_local_tcpConn_threshold,
			_rtl8651_local_udpConn_threshold,
			_rtl8651_local_tcpudpConn_threshold);
	rtlglue_printf("\t\tFlowCnt\t\t%d\t%d\t%d\n",
			rtl8651_tblDrvNaptCounter.dosCountedTcpCnt,
			rtl8651_tblDrvNaptCounter.dosCountedUdpCnt,
			(rtl8651_tblDrvNaptCounter.dosCountedTcpCnt+rtl8651_tblDrvNaptCounter.dosCountedUdpCnt));
	rtlglue_printf("\t\tInternalFlow\t%d\t%d\t%d\n",
			rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt,
			rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt,
			(rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt+rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt));
	/* per-source */
	rtlglue_printf("\tConfiguration (per-source constraint):\n");
	/* threshold */
	rtlglue_printf("\t\tThreshold\tTCP\tUDP\tBOTH\n");
	rtlglue_printf("\t\t\t\t%d\t%d\t%d\n",
			_rtl8651_perSrc_tcpConn_threshold,
			_rtl8651_perSrc_udpConn_threshold,
			_rtl8651_perSrc_tcpudpConn_threshold);
	/* cache */
	rtlglue_printf("\n\t=====================================================\n");
	/* TCP */
	for (connType = 0 ; connType < RTL8651_DOS_CONNTRACK_MAXTYPE ; connType ++)
	{
		/* Note that the definition of tracking system is TCP->UDP->TCPUDP */
		_rtl8651_dos_PktCnt_t **hdr[RTL8651_DOS_CONNTRACK_MAXTYPE] =
							{NULL, tcpConnHash, udpConnHash, tcpudpConnHash};
		uint32 connCnt[RTL8651_DOS_CONNTRACK_MAXTYPE] =
							{0, tcpConnCnt, udpConnCnt, tcpudpConnCnt};
		char* connStr[RTL8651_DOS_CONNTRACK_MAXTYPE] =
							{"", "TCP", "UDP", "Both"};
		_rtl8651_dos_PktCnt_t *ptr = NULL;

		if ( hdr[connType] == NULL )
		{
			continue;
		}
		for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx ++)
		{
			ptr = (hdr[connType])[idx];
			while (ptr)
			{
				rtlglue_printf("\t[%s] %u.%u.%u.%u\t-- %d\n", connStr[connType],
						NIPQUAD(ptr->ip), ptr->count);

				assert(ptr->item == connType);
				ptr = ptr->next;
			}
		}
		if ( connCnt[connType] == 0 )
		{
			rtlglue_printf("\t\t === <Empty> ===\n");
		}

		rtlglue_printf("\t\t\t\t\t%s -- TrackCnt: %d\n", connStr[connType], connCnt[connType]);
	}
	rtlglue_printf("\t=====================================================\n");

	rtlglue_drvMutexUnlock();

}

/*
	- Update the TCP/UDP Connection count for Connection Control System.
	- Input:
			1. isDecrease: Decrease count: TRUE, Increase count: FALSE
			2. isTcp: TCP-True, UDP-False
			3. ip: ip as an index to decrease connection count
	Called by NAPT system.
*/
inline void _rtl8651_dosSrcConnCtrlUpdateConnection(uint8 isDecrease, uint8 isTcp, ipaddr_t ip)
{

	if (_rtl8651_dos_enable == FALSE)
	{
		return;
	}

	if ( isTcp )
	{	/* TCP */
		if (_rtl8651_dos_sw[0] & RTL8651_DOS_SRC_TCPCONNOVERFLOW)
		{
			_rtl8651_connSrcTrackingUpdate(RTL8651_DOS_CONNTRACK_TCP, ip, isDecrease);
		}
	} else
	{	/* UDP */
		if (_rtl8651_dos_sw[0] & RTL8651_DOS_SRC_UDPCONNOVERFLOW)
		{
			_rtl8651_connSrcTrackingUpdate(RTL8651_DOS_CONNTRACK_UDP, ip, isDecrease);
		}
	}

	/* Both TCP/UDP */
	if (_rtl8651_dos_sw[0] & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW)
	{
		_rtl8651_connSrcTrackingUpdate(RTL8651_DOS_CONNTRACK_TCPUDP, ip, isDecrease);
	}
}

/*
	-  Check if the total connection count for the specific "ip" is arrive system's threshold or not.
*/
static inline int32 _rtl8651_dosSrcConnCtrl(uint8 flowType, ipaddr_t ip)
{
	switch (flowType)
	{
		case RTL8651_DOS_CONNTRACK_TCP:
			if ( _rtl8651_connSrcTracking_getConnCount(flowType, ip) >= _rtl8651_perSrc_tcpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			if ( _rtl8651_connSrcTracking_getConnCount(flowType, ip) >= _rtl8651_perSrc_udpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			if ( _rtl8651_connSrcTracking_getConnCount(flowType, ip) >= _rtl8651_perSrc_tcpudpConn_threshold )
			{
				goto success;
			}
			break;
	}
	return FAILED;
success:
	return SUCCESS;
}

/*********************************************************************************
				Whole system connection control system
*********************************************************************************/

/*
	-  Check if the total connection count in whole system is arrive system's threshold or not.
*/
static inline int32 _rtl8651_dosConnCtrl(uint8 flowType)
{
	int32 tcpCnt, udpCnt, totalCnt;

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_LAN)
	{
		tcpCnt = rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt;
		udpCnt = rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt;
	}else
	{
		tcpCnt = rtl8651_tblDrvNaptCounter.dosCountedTcpCnt;
		udpCnt = rtl8651_tblDrvNaptCounter.dosCountedUdpCnt;
	}

	if (_rtl8651_dos_ignoreType & RTL8651_DOS_IGNORETYPE_FROM_WAN)
	{
		tcpCnt -= (rtl8651_tblDrvNaptCounter.dosCountedTcpCnt -
					rtl8651_tblDrvNaptCounter.dosCountedFromInternalTcpCnt);
		udpCnt -= (rtl8651_tblDrvNaptCounter.dosCountedUdpCnt -
					rtl8651_tblDrvNaptCounter.dosCountedFromInternalUdpCnt); 
	}

	assert( tcpCnt >= 0 && udpCnt >= 0 );
	totalCnt = tcpCnt + udpCnt;

	switch ( flowType )
	{
		case RTL8651_DOS_CONNTRACK_TCP:
			if ( tcpCnt >= _rtl8651_local_tcpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_UDP:
			if ( udpCnt >= _rtl8651_local_udpConn_threshold )
			{
				goto success;
			}
			break;
		case RTL8651_DOS_CONNTRACK_TCPUDP:
			if ( totalCnt >= _rtl8651_local_tcpudpConn_threshold )
			{
				goto success;
			}
			break;
	}

	return FAILED;
success:
	return SUCCESS;
}

/*********************************************************************************
				syn/fin/ack/udp scan pkt flow cache system functions implement
*********************************************************************************/
#define DOS_PERSRC_SUSPECTFLOW_CACHE_SYSTEM_FUNCTIONS
/*<----------------------------- Init ----------------------------->*/
static int32 _rtl8651_dosScanTracking_init(rtl8651_fwdEngineInitPara_t *para)
{
	uint32 idx;

	/* before init cache, disable system */
	_rtl8651_ScanTrackingSystem_enable = FALSE;

	SuspectFlowCache_Cnt = para->dos_total_portScan_trackCnt;

	if (SuspectFlowCache_Cnt == 0)
		goto out;	/* disable scan tracking */

	/* initiate window size */
	_rtl8651_scan_monitor_window = RTL8651_DOS_SCAN_MOINTOR_WIN_DEFAULT;
	/* initiate threshold */
	for (idx = 0 ; idx < RTL8651_MAX_DIALSESSION ; idx ++)
		_rtl8651_scan_threshold[idx] = RTL8651_DOS_SCAN_THRESHOLD_DEFAULT;

	/* allocate entries */
	SuspectFlowCache_ptr = (_rtl8651_dos_SuspectFlowCache_t*) rtlglue_malloc(SuspectFlowCache_Cnt*sizeof(_rtl8651_dos_SuspectFlowCache_t));
	if (!SuspectFlowCache_ptr)
		goto out;	/* allocate fail, disable scan tracking */

	/* memory is allocated , we enable system now */
	_rtl8651_ScanTrackingSystem_enable = TRUE;

	/* initiate pointers and data structures */
	_rtl8651_dosScanTracking_reinit();

out:
	return SUCCESS;
}
static int32 _rtl8651_dosScanTracking_reinit(void)
{
	_rtl8651_dos_SuspectFlowCache_t *ptr;
	int32 idx;

	if (_rtl8651_ScanTrackingSystem_enable != TRUE)
		return FAILED;

	/* temporarily disable system for reinit */
	_rtl8651_ScanTrackingSystem_enable = FALSE;

	/* clear all entries */
	memset(SuspectFlowCache_ptr, 0, SuspectFlowCache_Cnt * sizeof(_rtl8651_dos_SuspectFlowCache_t));
	/* clear lru list */
	lru_SuspectFlowCache_hdr = SuspectFlowCache_ptr;
	lru_SuspectFlowCache_tail = SuspectFlowCache_ptr + (SuspectFlowCache_Cnt - 1);
	/* clear hash table */
	for (idx = 0 ; idx < RTL8651_DOS_HASHTBL_SIZE ; idx ++)
		SuspectFlowCacheHash[idx] = NULL;

	/* re-link lru list */
	ptr = SuspectFlowCache_ptr;
	for (idx = 0 ; idx < SuspectFlowCache_Cnt ; idx ++, ptr ++)
	{
		if (idx > 0)
			ptr->lru_prev = ptr - 1;
		if (idx < (SuspectFlowCache_Cnt - 1))
			ptr->lru_next = ptr + 1;
	}

	/* enable system after reinit */
	_rtl8651_ScanTrackingSystem_enable = TRUE;

	return SUCCESS;
}

/*<----------------------------- Linked List management ----------------------------->*/

static __inline__ void _rtl8651_dosScanTrackingLink(_rtl8651_dos_SuspectFlowCache_t**hdr, _rtl8651_dos_SuspectFlowCache_t *entry)
{	/* put entry to head of list */
	entry->hdr = hdr;		/* entry point at header */
	entry->next = (*hdr);		/* entry point at next entry */
	if (*hdr)	{
		(*hdr)->prev = entry;	/* next entry point at entry */
	}

	(*hdr) = entry;			/* header point at entry */
}
static __inline__ void _rtl8651_dosScanTrackingUnlink(_rtl8651_dos_SuspectFlowCache_t *entry)
{	/* remove entry from list */
	_rtl8651_dos_SuspectFlowCache_t **hdr = entry->hdr;
	if (!hdr) {	/* this entry isn't in any linked list */
		goto clearLink;
	}
	if (entry->prev)
		entry->prev->next = entry->next;
	if (entry->next)
		entry->next->prev = entry->prev;

	if ((*hdr) == entry)
		(*hdr) = entry->next;
clearLink:
	entry->hdr	= NULL;
	entry->prev	= NULL;
	entry->next	= NULL;
}
static __inline__ void _rtl8651_dosScanTrackingLruUnlink(_rtl8651_dos_SuspectFlowCache_t *entry)
{	/* unlink entry from lru list */
	if (entry->lru_prev)
		entry->lru_prev->lru_next = entry->lru_next;
	if (entry->lru_next)
		entry->lru_next->lru_prev = entry->lru_prev;
	if (lru_SuspectFlowCache_hdr == entry)
		lru_SuspectFlowCache_hdr = entry->lru_next;
	if (lru_SuspectFlowCache_tail == entry)
		lru_SuspectFlowCache_tail = entry->lru_prev;
	entry->lru_next = NULL;
	entry->lru_prev = NULL;
}
static __inline__ void _rtl8651_dosScanTrackingLruMoveToTail(_rtl8651_dos_SuspectFlowCache_t *entry)
{	/* move entry to tail of lru list */
	if (lru_SuspectFlowCache_tail == entry)
		return;

	assert(lru_SuspectFlowCache_hdr != lru_SuspectFlowCache_tail);	/* If hdr=tail, LruUnlink will let lru_SuspectFlowCache_hdr and lru_SuspectFlowCache_tail become NULL both */
	_rtl8651_dosScanTrackingLruUnlink(entry);
	entry->lru_prev = lru_SuspectFlowCache_tail;
	if (lru_SuspectFlowCache_tail)
		lru_SuspectFlowCache_tail->lru_next = entry;
	lru_SuspectFlowCache_tail = entry;
}
static __inline__ void _rtl8651_dosScanTrackingLruMoveToHead(_rtl8651_dos_SuspectFlowCache_t *entry)
{	/* move entry to head of lru list */
	if (lru_SuspectFlowCache_hdr == entry)
		return;

	assert(lru_SuspectFlowCache_hdr != lru_SuspectFlowCache_tail);	/* If hdr=tail, LruUnlink will let lru_SuspectFlowCache_hdr and lru_SuspectFlowCache_tail become NULL both */
	_rtl8651_dosScanTrackingLruUnlink(entry);
	entry->lru_next = lru_SuspectFlowCache_hdr;
	if (lru_SuspectFlowCache_hdr)
		lru_SuspectFlowCache_hdr->lru_prev = entry;
	lru_SuspectFlowCache_hdr = entry;
}

static _rtl8651_dos_SuspectFlowCache_t *_rtl8651_dosScanTrackingFindEntry(ipaddr_t sip)
{
	uint32 hash;
	_rtl8651_dos_SuspectFlowCache_t *ptr;

	hash = _rtl8651_dosHash(sip);

	ptr = SuspectFlowCacheHash[hash];
	while (ptr && (ptr->sip != sip))
		ptr = ptr->next;
	if (!ptr)
	{	/* no entry? we get a new one */
//		getNew:
			ptr = lru_SuspectFlowCache_hdr;
			if (ptr && ptr->expire <= _sysUpSeconds)
			{	/* expired entry, use it ! */
				_rtl8651_dosScanTrackingUnlink(ptr);
				_rtl8651_dosScanTrackingLink(&(SuspectFlowCacheHash[hash]), ptr);
				_rtl8651_dosScanTrackingLruMoveToTail(ptr);
			}else
				return NULL;	/* cannot allocate new entry, we return NULL */
			assert(ptr);
			/* set ip information */
			ptr->sip = sip;
			/* initiate tracking information */
			ptr->direction = 0;
			ptr->vlan = 0;
			ptr->dsid = 0;
			/* clear flow expire time/tracking information */
		resetEntryInfo:
			ptr->expire = _sysUpSeconds + _rtl8651_scan_monitor_window;
			ptr->SynDstIpMask = 0;
			ptr->SynSrcPortMask = 0;
			ptr->SynDstPortMask = 0;
			ptr->SynComplainCnt = 0;
			ptr->FinDstIpMask = 0;
			ptr->FinSrcPortMask = 0;
			ptr->FinDstPortMask = 0;
			ptr->FinComplainCnt = 0;
			ptr->AckDstIpMask = 0;
			ptr->AckSrcPortMask = 0;
			ptr->AckDstPortMask = 0;
			ptr->AckComplainCnt = 0;
			ptr->UdpDstIpMask = 0;
			ptr->UdpSrcPortMask = 0;
			ptr->UdpDstPortMask = 0;
			ptr->UdpComplainCnt = 0;
			ptr->TotalComplainCnt = 0;
	} else if (ptr->expire <= _sysUpSeconds)
	{	/* if the entry is expired, refresh it */
		_rtl8651_dosScanTrackingLruMoveToTail(ptr);
		goto resetEntryInfo;
	}
	assert(ptr);
	return ptr;
}

static int32 _rtl8651_dosTcpUdpScan(_rtl8651_dos_SuspectFlowCache_t *ptr, uint16 dsid, uint8 l4Type)
{
	if (ptr->TotalComplainCnt == _rtl8651_scan_threshold[dsid])
	{	/* we suppose this is attack */
		if (!ptr->vlan)
		{
			/* no flow tracked but attack record? print error and exit */
			#ifdef RTL865X_DEBUG
			rtlglue_printf("[%s:%d] Warning: Tracking Count is zero, but the complain count has exceed threshold [%d]\n", __FUNCTION__, __LINE__, _rtl8651_scan_threshold[dsid]);
			#endif
			return FAILED;
		}
		/* generate log */
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{	/* generate msg */
			uint32 totalComplainWeight;
#ifdef _RTL_NEW_LOGGING_MODEL
			rtl8651_logInfo_t info;
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= ptr->dsid;
			info.pkt_sip		= ptr->sip;
			info.pkt_dip		= 0;
			info.pkt_proto		= l4Type;
			info.pkt_direction	= ptr->direction;
			info.pkt_sport		= 0xffff;
			info.pkt_dport		= 0xffff;
			info.pkt_icmpType	= 0xff;
			info.pkt_icmpId	= 0xffff;
			info.action		= RTL8651_LOGACTION_NONE;

			totalComplainWeight = (ptr->TotalComplainCnt - 1) * RTL8651_DOS_SCAN_DECIDE_WEIGHT_NUMERATOR;
			
			/* determine attack type */

			if ((ptr->SynComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* SYN Scan */
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_SYN, &info);
			}else if ((ptr->FinComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* FIN Scan */
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_FIN, &info);
			}else if ((ptr->AckComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* ACK Scan */
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_ACK, &info);
			}else if ((ptr->UdpComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* UDP Scan */
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_UDP, &info);
			}else
			{	/* hybrid Scan */
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpUdpScan_HYBRID, &info);
			}
#else
			char *synScan = "SYN Scan";
			char *finScan = "FIN Scan";
			char *ackScan = "ACK Scan";
			char *udpScan = "UDP Scan";
			char *hybridScan = "Hybrid Scan";
			char *msg = NULL;

			totalComplainWeight = (ptr->TotalComplainCnt - 1) * RTL8651_DOS_SCAN_DECIDE_WEIGHT_NUMERATOR;

			/* determine attack type */
			if ((ptr->SynComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* SYN Scan */
				msg = synScan;
				goto WRITE_LOG;
			}
			if ((ptr->FinComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* FIN Scan */
				msg = finScan;
				goto WRITE_LOG;
			}
			if ((ptr->AckComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* ACK Scan */
				msg = ackScan;
				goto WRITE_LOG;
			}
			if ((ptr->UdpComplainCnt * RTL8651_DOS_SCAN_DECIDE_WEIGHT_DENOMINATOR) >=
				totalComplainWeight)
			{	/* UDP Scan */
				msg = udpScan;
				goto WRITE_LOG;
			}
			msg = hybridScan;

			WRITE_LOG:
			(*_pUserLoggingFunc)(
				ptr->dsid,
				RTL8651_LOGMODULE_DOS,
				(unsigned char)l4Type,				/* reference protocol */
				(unsigned char)ptr->direction,		/* reference direction */
				(unsigned long)ptr->sip,			/* attacking host */
				(unsigned long)0,					/* dip: don't care */
				(unsigned short)0,					/* sport: don't care */
				(unsigned short)0,					/* dport: don't care */
				0,								/* type: don't care */
				RTL8651_LOGACTION_FORWARD,	/* action: we don't drop RST or ICMP error msg */
				msg );							/* msg */
#endif
		}
		/* proc sip and return SUCCESS */
		if (ptr && ptr->vlan)
		{
			assert(ptr->dsid < RTL8651_MAX_DIALSESSION);
			assert(ptr->sip);
			_rtl8651_procDoSIP(RTL8651_DOS_PORTSCAN, ptr->dsid, ptr->vlan->vid, ptr->sip);
		}
		return SUCCESS;
	}
	return FAILED;
}
/*<----------------------------- APIs for DOS system ----------------------------->*/
/*
	For All TCP slow path traffic, we check if this packet in suspected list (this sip was been reported with rst),
	For All UDP slow path traffic, we check if this packet in suspected list (this sip was been reported with icmp-host-unreachable)
	
	if the answer is YES, we trace it, we record the dip/sport/dport of this flow.
	if the answer is NO, we don't record it.
*/
void _rtl8651_dosScanTracking(struct rtl_pktHdr*pkt, struct ip *ip, uint8 l4Type, void*l4hdr)
{
	uint32 hash;
	ipaddr_t sip;
	_rtl8651_dos_SuspectFlowCache_t* ptr;

	if ((_rtl8651_ScanTrackingSystem_enable != TRUE)||(_rtl8651_ScanTrackingSystem_turnON != TRUE))
		goto out;

	if (ntohs(ip->ip_off) & (IP_OFFMASK))
		goto out;

	if ((l4Type != IPPROTO_TCP) && (l4Type != IPPROTO_UDP))
		goto out;

	/* get source ip */
	sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	if (!sip)
		goto out;

	/* find entry */
	hash = _rtl8651_dosHash(sip);
	ptr = SuspectFlowCacheHash[hash];
	while (ptr && (ptr->sip != sip))
		ptr = ptr->next;
	if (!ptr)
		goto out;	/* no entry for this sip */
	/* check if the entry is out of date or not */
	if (ptr->expire <= _sysUpSeconds)
	{	/* expire it: unlink it and put it to the head of lru list */
		_rtl8651_dosScanTrackingUnlink(ptr);
		_rtl8651_dosScanTrackingLruMoveToHead(ptr);
		goto out;
	}
	/*<----- Now, ptr points to the entry with {sip == source ip}, and this entry is not expired ----->*/
	/* now, we record the dip/sport/dport info according to this sip */
	/* get flag/dip/sport/dport to record */
	{
		uint8 th_flags;
		struct tcphdr *tc;
		struct udphdr *ud;
		ipaddr_t dip;
		uint16 sport, dport;
		uint32 dipMask, sportMask, dportMask;

		/* update direction */
		ptr->vlan = &DrvTbl.vlan[pkt->ph_vlanIdx & (RTL8651_VLAN_NUMBER - 1)];
		ptr->direction = ((ptr->vlan)->internal?0:1);
		ptr->dsid = pkt->ph_dsid;

		if (l4Type == IPPROTO_TCP)
		{	/* TCP */
			tc = (struct tcphdr*)l4hdr;
			th_flags = tc->th_flags;
			/* get information */
			dip		= PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
			sport	= ntohs(tc->th_sport);
			dport	= ntohs(tc->th_dport);
			/* calculate mask */
			dipMask		= 1 << (dip & 0x0000001f);
			sportMask	= 1 << (sport & 0x0000001f);
			dportMask	= 1 << (dport & 0x0000001f);
			/* set the corresponding bits */
			if (th_flags & TH_SYN)
			{
				ptr->SynDstIpMask	|= dipMask;
				ptr->SynSrcPortMask	|= sportMask;
				ptr->SynDstPortMask	|= dportMask;
			}
			if (th_flags & TH_FIN)
			{
				ptr->FinDstIpMask		|= dipMask;
				ptr->FinSrcPortMask	|= sportMask;
				ptr->FinDstPortMask	|= dportMask;
			}
			if (th_flags & TH_ACK)
			{
				ptr->AckDstIpMask	|= dipMask;
				ptr->AckSrcPortMask	|= sportMask;
				ptr->AckDstPortMask	|= dportMask;
			}
		}else
		{	/* UDP */
			ud = (struct udphdr*)l4hdr;
			/* get information */
			dip		= PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
			sport	= ntohs(ud->uh_sport);
			dport	= ntohs(ud->uh_dport);
			/* set the corresponding bits */
			ptr->UdpDstIpMask	|= (1 << (dip & 0x0000001f));
			ptr->UdpSrcPortMask	|= (1 << (sport & 0x0000001f));
			ptr->UdpDstPortMask	|= (1 << (dport & 0x0000001f));
		}
	}
out:
	return;
}
int32 _rtl8651_dosScanCheckComplain(uint16 dsid, struct ip *ip)
{
	ipaddr_t dip;
	_rtl8651_dos_SuspectFlowCache_t *ptr = NULL;
	struct tcphdr *tc = NULL;
	struct icmp *ic = NULL;
	uint8 l4Type;

	if ((_rtl8651_ScanTrackingSystem_enable != TRUE)||(_rtl8651_ScanTrackingSystem_turnON != TRUE))
		goto NoAttackOut;

	if (ntohs(ip->ip_off) & (IP_OFFMASK))
		goto NoAttackOut;

	l4Type = ip->ip_p;
	switch(l4Type)
	{
		case IPPROTO_TCP:	/* only accept RST */
			tc = (struct tcphdr*)((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
			if (!(tc->th_flags & TH_RST))
				goto NoAttackOut;
			break;
		case IPPROTO_ICMP:	/* only accept ICMP Port unreach Now */
			ic = (struct icmp*)((int8 *) ip + ( (ip->ip_vhl & 0x0f) << 2));
#if 1
			/*
				chenyl: this coding style is so stupid! To prevent from unalignment-access:
					For some compilers (eg. gcc 3.3.3), the original code might be compiled to "lw" (load word)
					and the unalignment access problem arises.
					Two solutions is ok for this problem:
						1. set "volatile" to pointer "ic"	- performance problem.
						2. change coding layout.
			*/
			if (ic->icmp_type != ICMP_UNREACH)
				goto NoAttackOut;
			else if (ic->icmp_code != ICMP_UNREACH_PORT)
				goto NoAttackOut;
#else
			if ((ic->icmp_type != ICMP_UNREACH) || (ic->icmp_code != ICMP_UNREACH_PORT))
				goto NoAttackOut;
#endif
			break;
		default:
			goto NoAttackOut;
	}

	/* <-------- For TCP packets with RST or ICMP unreach, we start to trace the dip of this packet --------> */
	dip = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	if ((ptr = _rtl8651_dosScanTrackingFindEntry(dip)) == NULL)
		goto NoAttackOut;
	/* <----------- Now, We get the entry, we update entry data for this complain -----------> */
	assert(ptr);
	{
		ipaddr_t sip;
		uint16 sport, dport;
		uint32 dipMask, sportMask, dportMask;

		/* get sip/sport/dport of this packet, they are dip/dport/sport of the original packet */
		sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		if (l4Type == IPPROTO_TCP)
		{	/* TCP complain */
			sport = ntohs(tc->th_sport);
			dport = ntohs(tc->th_dport);
		}else
		{	/* ICMP complain */
			struct ip*eip;
			struct udphdr *eud;
			eip = &ic->icmp_ip;
			if (eip->ip_p != IPPROTO_UDP)
				goto NoAttackOut;
			eud = (struct udphdr *)((int8 *) eip + ( (eip->ip_vhl & 0x0f) << 2));
			/* when we calculating mask, we swap sport and dport, so in the original udp packet, we swap it here */
			sport = ntohs(eud->uh_dport);
			dport = ntohs(eud->uh_sport);
		}

		/* calculate mask */
		dipMask		= 1 << (sip & 0x0000001f);
		sportMask	= 1 << (dport & 0x0000001f);
		dportMask	= 1 << (sport & 0x0000001f);

		if (l4Type == IPPROTO_TCP)
		{	/* TCP complain */
			uint8 newComplain = FALSE;
			/* process SYN */
			if ((ptr->SynDstIpMask & dipMask) &&
				(ptr->SynSrcPortMask & sportMask) &&
				(ptr->SynDstPortMask & dportMask))
			{
				ptr->SynComplainCnt ++;		/* tracking flow match */
				newComplain = TRUE;
			}
			/* process FIN */
			if ((ptr->FinDstIpMask & dipMask) &&
				(ptr->FinSrcPortMask & sportMask) &&
				(ptr->FinDstPortMask & dportMask))
			{
				ptr->FinComplainCnt ++;		/* tracking flow match */
				newComplain = TRUE;
			}
			/* process ACK */
			if ((ptr->AckDstIpMask & dipMask) &&
				(ptr->AckSrcPortMask & sportMask) &&
				(ptr->AckDstPortMask & dportMask))
			{
				ptr->AckComplainCnt ++;		/* tracking flow match */
				newComplain = TRUE;
			}
			if (newComplain == TRUE)
				ptr->TotalComplainCnt ++;
		}else
		{	/* ICMP complain */
			/* process UDP */
			if ((ptr->UdpDstIpMask & dipMask) &&
				(ptr->UdpSrcPortMask & sportMask) &&
				(ptr->UdpDstPortMask & dportMask))
			{
				ptr->UdpComplainCnt ++;		/* tracking flow match */
				ptr->TotalComplainCnt ++;
			}
		}
		/* check if this sip is attack or not, including TCP and UDP */
		return _rtl8651_dosTcpUdpScan(ptr, dsid, (l4Type == IPPROTO_TCP?IPPROTO_TCP:IPPROTO_UDP));
	}
	/* goto No AttackOut */
NoAttackOut:
	return FAILED;
}
/*
	For Outbound TCP packets, in FIN/ACK attack, gateway will NOT do NAPT/NAPT-R and don't forward these packets,
	so we must record them as attack.
	For Inbound TCP packets, they will be trapped to Protocol Stack, if they are attack, protocol stack will return RST/ICMP
	and we can record them.
*/
int32 _rtl8651_dosScanCheckTcpOutboundFailUnusual(uint16 dsid, struct ip *ip, struct tcphdr *tc)
{
	uint8 tcpFlag;
	ipaddr_t sip;
	_rtl8651_dos_SuspectFlowCache_t *ptr;

	if ((_rtl8651_ScanTrackingSystem_enable != TRUE)||(_rtl8651_ScanTrackingSystem_turnON != TRUE))
		goto NoAttackOut;

	if (ntohs(ip->ip_off) & IP_OFFMASK)
		goto NoAttackOut;

	tcpFlag = tc->th_flags;

	if (tcpFlag & TH_RST)
		goto NoAttackOut;	/* attacker don't use RST packet to Scan target, so we ignore it */

	sip = PKTGET_UINT32_UNALIGNED(&ip->ip_src);

	/* This is suspect attack record get the scan tracking entry */
	if ((ptr = _rtl8651_dosScanTrackingFindEntry(sip)) == NULL)
		goto NoAttackOut;	/* system can not get any new entry, so we ignore this record */

	/* <----------- Now, We get the entry, we update entry data for this complain -----------> */
	assert(ptr);
	{
		if (tcpFlag & (TH_FIN|TH_ACK))
			ptr->TotalComplainCnt ++;
		if (tcpFlag & TH_FIN)
			ptr->FinComplainCnt ++;
		if (tcpFlag & TH_ACK)
			ptr->AckComplainCnt ++;
		
	}
	
	/* check if this sip is attack or not, including TCP and UDP */
	return _rtl8651_dosTcpUdpScan(ptr, dsid, IPPROTO_TCP);

NoAttackOut:
	return FAILED;
}
/*<----------------------------- APIs for External Setting ----------------------------->*/
int32 rtl8651_dosScanTrackingSetPara(uint32 dsid, uint32 windowSize, uint32 threshold)
{
	uint32 wSize, tHold;

	if (_rtl8651_ScanTrackingSystem_enable != TRUE)
		return FAILED;
	/* check parameter */
	if (dsid >= RTL8651_MAX_DIALSESSION)
		return FAILED;
	wSize = windowSize;
	tHold = threshold;
	if (wSize < RTL8651_DOS_SCAN_MIN_MONITOR_WIN)
		wSize = RTL8651_DOS_SCAN_MIN_MONITOR_WIN;
	if (tHold < RTL8651_DOS_SCAN_MIN_THRESHOLD)
		tHold = RTL8651_DOS_SCAN_MIN_THRESHOLD;

	rtlglue_drvMutexLock();	/* Lock resource */
	/* threshold */
	_rtl8651_scan_threshold[dsid] = tHold;
	/* window size */
	_rtl8651_scan_monitor_window = wSize;
	/* flush all entries */
	_rtl8651_dosScanTracking_reinit();	/* clear all entries */

	rtlglue_drvMutexUnlock();	/* Release resource */
	return SUCCESS;
}
/*********************************************************************************
							Other DOS check
*********************************************************************************/
#define DOS_NORMAL_ATTACK_ITEM_FUNCTIONS
/* example DOS detector*/
static int32 _rtl8651_dosPingOfDeath(struct ip *ip,struct icmp *ic){
	uint16 ip_off = ntohs(ip->ip_off);
	uint32 val;

	if((ip_off & IP_MF) == 0 && (ip_off & IP_OFFMASK))
	{
		ip_off &= IP_OFFMASK;
		val = (ip_off << 3) + ntohs(ip->ip_len) -((ip->ip_vhl & 0x0f) << 2);
		if(val > 65535)
			return SUCCESS;	
	}
	return FAILED;
}

static int32 _rtl8651_dosSynFlood(uint32 dsid,struct ip *ip,struct tcphdr *tc,uint32* NeedLog){

	if (tc->th_flags & TH_SYN)
	{
		_rtl8651_local_syn_counter[dsid]++;

		if (_rtl8651_local_syn_counter[dsid] > _rtl8651_local_syn_threshold[dsid])
		{
			if (_rtl8651_local_syn_counter[dsid] == (_rtl8651_local_syn_threshold[dsid]+1))
			{
				*NeedLog = TRUE;
			}
			else
			{
				*NeedLog = FALSE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}

static int32 _rtl8651_dosStealthFin(uint32 dsid,struct ip *ip,struct tcphdr *tc,uint32 *NeedLog){

	if (tc->th_flags & TH_FIN)
	{
		_rtl8651_local_fin_counter[dsid] ++;

		if (_rtl8651_local_fin_counter[dsid] > _rtl8651_local_fin_threshold[dsid])
		{
			if (_rtl8651_local_fin_counter[dsid] == (_rtl8651_local_fin_threshold[dsid]+1))
			{
				*NeedLog = TRUE;
			}
			else
			{
				*NeedLog = FALSE;
			}
			return SUCCESS;
		}
	}
	return FAILED;
}

static int32 _rtl8651_dosIcmpFlood(uint32 dsid,struct ip *ip,struct icmp *ic, uint32* NeedLog){
	
//	if  (ic->icmp_type == ICMP_ECHO || ic->icmp_type == ICMP_ECHOREPLY)
//	{
		_rtl8651_local_icmp_counter[dsid]++;
		if(_rtl8651_local_icmp_counter[dsid] > _rtl8651_local_icmp_threshold[dsid])
		{
			if (_rtl8651_local_icmp_counter[dsid] == (_rtl8651_local_icmp_threshold[dsid] + 1))
			{
				*NeedLog = TRUE;
			}
			else
			{
				*NeedLog = FALSE;
			}
			return SUCCESS;		
		}
//	}
	return FAILED;
}

static int32 _rtl8651_dosTcpLand(struct ip *ip,struct tcphdr *tc){
	
//	if(ntohs(tc->th_sport) == ntohs(tc->th_dport)){
		uint32 ip_s, ip_d;
		ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
		if(ip_s == ip_d){
			return SUCCESS;
		}
//	}
	return FAILED;
}

static int32 _rtl8651_dosUdpLand(struct ip *ip,struct udphdr *ud){
	
//	if(ntohs(ud->uh_sport) == ntohs(ud->uh_dport)){
		uint32 ip_s, ip_d;
		ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
		if(ip_s == ip_d){
			return SUCCESS;
		}
//	}
	return FAILED;
}

static int32 _rtl8651_dosIcmpLand(struct ip *ip,struct icmp *ic){
	uint32 ip_s, ip_d;
	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
	ip_d = PKTGET_UINT32_UNALIGNED(&ip->ip_dst);
	if(ip_s == ip_d) return SUCCESS;
	return FAILED;
}

static int32 _rtl8651_dosSmurf(struct ip *ip,struct icmp *ic, uint16 vid){
	
	if(ic->icmp_type == ICMP_ECHO){
		//printk("icmp type=%d dip=%u.%u.%u.%u\n",ic->icmp_type,NIPQUAD(ip->ip_dst.s_addr));
		
		rtl8651_tblDrv_routeTable_t *tb;
		uint32 ip_s;
		ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);
		//route lookup by source IP			
		tb = _rtl8651_getRoutingEntry(ip_s);			
		//If route not found or routing result interface is not incoming interface and sip is not one of IP unnumbered IP,
		//then source IP may be forged. Block it.
		if(!tb || (tb->dvid != vid &&FALSE==_rtl8651_isLanSideIpUnnumberedIpAddr(ip_s))){
			return SUCCESS;
		}		
	}
	return FAILED;
}


static int32 _rtl8651_dosIpSpoof(struct ip *ip, uint16 vid,uint8 direction){
			
	rtl8651_tblDrv_routeTable_t *tb;
	uint32 ip_s;

	ip_s = PKTGET_UINT32_UNALIGNED(&ip->ip_src);			
	tb = _rtl8651_getRoutingEntry(ip_s);

	/* WAN_to_LAN Spoof, ip src ip in internal network. */
	if(direction==1)
	{
		if (tb)	/* tb == NULL, it means whole IPs are Remote-Public IP, and no IP Spoofing attack would be found. */
		{
			if (tb->dvid == vid)
			{
				/* legal packet, not IP Spoofing */
			} else
			{
				if (	(tb->nextHopType == RTL8651_LL_PPTP) ||
					(tb->nextHopType == RTL8651_LL_L2TP)	)
				{	/* for PPTP/L2TP wan types, both 'real WAN VLAN' and 'loopback VLAN' are legal for WAN-to-LAN packet */
					if (	(tunnel.valid) &&
						((tb->dvid == tunnel.wanVid) ||(tb->dvid == tunnel.loopBackVid)) &&
						((vid == tunnel.wanVid)||(vid == tunnel.loopBackVid)))
					{
						goto legal;
					}
				}
				/* Other cases, IP Spoof found!! Song la */
				return SUCCESS;
			}
		}
	
		if((tb!=NULL)&&(tb->dvid!=vid)) return SUCCESS;
	}
	else /* LAN_to_WAN Spoof, ip src ip != internal network */
	{
		if((tb==NULL)||(tb->dvid!=vid)) return SUCCESS;
	}	
legal:
	return FAILED;
}


static int32 _rtl8651_dosScan(struct ip *ip,struct tcphdr *tc){

	if(_tcpDosScanBitmap[tc->th_flags&0x3f])
		return SUCCESS;
	return FAILED;
}

static int32 _rtl8651_dosUdpFlood(uint32 dsid,struct ip *ip,struct udphdr *ud,uint32 *NeedLog){

	_rtl8651_local_udp_counter[dsid]++;

	if (_rtl8651_local_udp_counter[dsid] > _rtl8651_local_udp_threshold[dsid])
	{
		if (_rtl8651_local_udp_counter[dsid] == (_rtl8651_local_udp_threshold[dsid]+1))
		{
			*NeedLog = TRUE;
		}
		else
		{
			*NeedLog = FALSE;
		}
		return SUCCESS;
	}
	return FAILED;
}

static int32 _rtl8651_dosUdpBomb(struct ip *ip,struct udphdr *ud){
	uint32 ipPayLoadLength;

	// This function is for UdpBomb check
	if (!(ip->ip_off & (IP_OFFMASK|IP_MF)))
	{	// L3 claimed payload Length
		ipPayLoadLength = ntohs(ip->ip_len) - ((ip->ip_vhl & 0x0f) << 2);
		// udp payload Length
		if (ipPayLoadLength > ntohs(ud->uh_ulen))
			return SUCCESS;
	}

	return FAILED;
}			

static int32 _rtl8651_dosUdpEchoChargen(struct ip *ip, struct udphdr *ud) {
	if(	(ud->uh_dport==htons(7)||ud->uh_dport==htons(17)||ud->uh_dport==htons(19))||
		(ud->uh_sport==htons(7)||ud->uh_sport==htons(17)||ud->uh_sport==htons(19))){
		return SUCCESS;
	}
	return FAILED;
}

static int32 _rtl8651_dosSynWithData(struct ip *ip,struct tcphdr *tc)
{
	if(tc->th_flags == TH_SYN )
	{
		uint32 datalen= ntohs(ip->ip_len)-((ip->ip_vhl & 0xf)<<2)- ((( tc->th_off_x>>4)&0xf)<<2);		
		if(datalen>0)
		{
			return SUCCESS;
		}
		if (htons(ip->ip_off) & IP_MF)
		{
			return SUCCESS;
		}
	}
	return FAILED;
}

#define DOS_FRAGMENT_ATTACK_DETECTION_FUNCTIONS
/* Fragment Packet related DOS hooking */
/* add fragment packet related DOS checking and logging here */
/* return SUCCESS Forwarding Engine will drop the packet */
/* return FAILED Forwarding Engine will forward the packet */
int32 rtl8651a_dosFragmentCheck(uint32 dsid, struct ip* ip, struct rtl_pktHdr* pktHdr){
	uint8 *l4hdr = NULL;
	uint32 Attack = 0;
	rtl8651_tblDrv_vlanTable_t *vlanp;
	uint8 direction;
	uint16 vid;
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;
#endif

	if (_rtl8651_dos_enable == FALSE) return FAILED;

	/*********************** Get the vlan/direction info ***********************/
	vlanp = &DrvTbl.vlan[pktHdr->ph_vlanIdx & (RTL8651_VLAN_NUMBER - 1)];
	vid = vlanp->vid;
	// make sure packet direction  0:LAN_to_WAN 1:WAN_to_LAN
	if(vlanp->internal)
		direction = 0;
	else
		direction = 1;
	/*********************************************************************/
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	l4hdr = (uint8 *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
	/*
		ICMP Ping Of Death
	*/
	if((_rtl8651_dos_sw[dsid]&RTL8651_DOS_PINGOFDEATH) && _rtl8651_dosPingOfDeath(ip,(struct icmp*)l4hdr) == SUCCESS){	
		Attack |= RTL8651_DOS_PINGOFDEATH;
	}

//fragment_dos_out:
	if (Attack)
	{
		/*********************************************************************************/
		// Log
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
			if (Attack & RTL8651_DOS_PINGOFDEATH)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_ICMP;
				info.pkt_direction	= direction;
				info.pkt_icmpType	= ((ntohs(ip->ip_off)&IP_OFFMASK)?(0xff):(((struct icmp*)l4hdr)->icmp_type));
				info.pkt_icmpId	= ((ntohs(ip->ip_off)&IP_OFFMASK)?(0xffff):(ntohs(((struct icmp*)l4hdr)->icmp_type)));
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpPingOfDeath, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)0xffffffff, /* don't care */
					(unsigned short)0xffffffff, /* don't care */
					((ip->ip_off&IP_OFFMASK)?(0xff):(((struct icmp*)l4hdr)->icmp_type)), /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"ICMP Ping Of Death" /* msg */);
#endif
			}
		}
		// attack found : further process attack packet and return SUCCESS
		_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;
}

/* for Fragment UDP packet, we check the total ip payload length and the claimed UDP length */
/* If the total ip payload length > UDP length(from CISCO IDS signature List), we note that with UDP bomb */
/* return SUCCESS Forwarding Engine will drop the packet */
/* return FAILED Forwarding Engine will forward the packet */
int32 rtl8651a_dosFragUdpBombCheck(uint32 dsid, uint16 vid, struct ip* ip, struct udphdr*ud, uint8 direction, uint32 IpTotalLen, struct rtl_pktHdr* pktHdr)
{
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	/* for log */
#endif
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	if((_rtl8651_dos_sw[dsid] & RTL8651_DOS_UDPBOMB) &&
		(IpTotalLen > ntohs(ud->uh_ulen))){
		//printk("DoS Attack: TCP UdpBomb -- Direction: %s, Src: %u.%u.%u.%u:%u, Dest: %u.%u.%u.%u:%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),tc->th_sport,NIPQUAD(ip->ip_dst.s_addr),tc->th_dport);
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= direction;
			info.pkt_sport		= ntohs(ud->uh_sport);
			info.pkt_dport		= ntohs(ud->uh_dport);
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpBomb, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    	(unsigned char)ip->ip_p, /* protocol */
			    	(unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)(ntohs(ud->uh_sport)),
				(unsigned short)(ntohs(ud->uh_dport)),
				0xff,
				RTL8651_LOGACTION_DROP, /* action */
				"UDP Bomb" /* msg */);
#endif
		}
			// attack found : further process attack packet and return SUCCESS
			_rtl8651_procDoSPkt(RTL8651_DOS_UDPBOMB, dsid, vid, ip, direction, pktHdr);
			return SUCCESS;
	}
	return FAILED;
}


/* TCP TearDrop logging */
/* log TCP TearDrop event here */
/* return SUCCESS TearDrop event has been logged */
/* return FAILED TearDrop event has NOT been logged */
int32 rtl8651a_dosTearDropLogging(uint32 dsid, uint16 vid, struct ip* ip, uint8 direction, struct rtl_pktHdr* pktHdr)
{
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	if(_rtl8651_dos_sw[dsid] & RTL8651_DOS_TEARDROP)
	{
		struct udphdr *ud;
		struct tcphdr *tc;
		struct icmp *ic;
		uint32 sport = 0xffffffff;
		uint32 dport = 0xffffffff;
		uint8 type = 0xff;
		uint16 id = 0xffff;
#ifdef _RTL_NEW_LOGGING_MODEL
		rtl8651_logInfo_t info;
#endif
		if (!(ntohs(ip->ip_off) & IP_OFFMASK))
		{
			switch (ip->ip_p)
			{
				case IPPROTO_TCP:
					tc = (struct tcphdr *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					sport = ntohs(tc->th_sport);
					dport = ntohs(tc->th_dport);
					break;
				case IPPROTO_UDP:
					ud = (struct udphdr *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					sport = ntohs(ud->uh_sport);
					dport = ntohs(ud->uh_dport);
					break;
				case IPPROTO_ICMP:
					ic = (struct icmp *)((int8 *) ip + ((*(uint8*)ip&0xf) << 2));
					type = ic->icmp_type;
					id = ntohs(ic->icmp_id);
					break;
			}
		}

		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= ip->ip_p;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.pkt_icmpType	= type;
			info.pkt_icmpId	= id;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TearDrop, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    	(unsigned char)ip->ip_p, /* protocol */
			    	(unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				type,
				RTL8651_LOGACTION_DROP, /* action */
				"IP TearDrop" /* msg */);
#endif
		}
			// attack found : further process attack packet and return SUCCESS
			_rtl8651_procDoSPkt(RTL8651_DOS_TEARDROP, dsid, vid, ip, direction, pktHdr);
			return SUCCESS;
	}
	return FAILED;
}

#define DOS_NORMAL_ATTACK_DETECTION_FUNCTIONS
int32 _rtl8651_dosNaptConnCheck(uint8 isTcp, ipaddr_t ip, uint8 direction)
{
#define DOS_CONNCTRL_TCP_CHECKLIST	(RTL8651_DOS_SRC_TCPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW|RTL8651_DOS_TCPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW)
#define DOS_CONNCTRL_UDP_CHECKLIST	(RTL8651_DOS_SRC_UDPCONNOVERFLOW|RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW|RTL8651_DOS_UDPCONNOVERFLOW|RTL8651_DOS_TCPUDPCONNOVERFLOW)

	uint32 dos_checkList = _rtl8651_dos_sw[0];
	uint32 Attack = 0;

	if (_rtl8651_dos_enable == FALSE) return SUCCESS;

	/*                                                      Decide DoS Checking Items                                                */
	/***********************************************************************************/
	if ( isTcp )
	{
		dos_checkList &= DOS_CONNCTRL_TCP_CHECKLIST;
	} else
	{
		dos_checkList &= DOS_CONNCTRL_UDP_CHECKLIST;
	}
	/*                                                      Start DoS Checking                                                            */
	/***********************************************************************************/
	/* TCP Per-Source Connection overflow */
	if ( (dos_checkList & RTL8651_DOS_SRC_TCPCONNOVERFLOW) &&
		(_rtl8651_dosSrcConnCtrl(RTL8651_DOS_CONNTRACK_TCP, ip) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_SRC_TCPCONNOVERFLOW;
	}

	/* UDP Per-Source Connection overflow */
	if ( (dos_checkList & RTL8651_DOS_SRC_UDPCONNOVERFLOW) &&
		(_rtl8651_dosSrcConnCtrl(RTL8651_DOS_CONNTRACK_UDP, ip) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_SRC_UDPCONNOVERFLOW;
	}

	/* TCP/UDP Per-Source Connection overflow */
	if ( (dos_checkList & RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW) &&
		(_rtl8651_dosSrcConnCtrl(RTL8651_DOS_CONNTRACK_TCPUDP, ip) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW;
	}

	/* TCP Whole-System Connection overflow */
	if ( (dos_checkList & RTL8651_DOS_TCPCONNOVERFLOW) &&
		(_rtl8651_dosConnCtrl(RTL8651_DOS_CONNTRACK_TCP) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_TCPCONNOVERFLOW;
	}
	/* UDP Whole-System Connection overflow */
	if ( (dos_checkList & RTL8651_DOS_UDPCONNOVERFLOW) &&
		(_rtl8651_dosConnCtrl(RTL8651_DOS_CONNTRACK_UDP) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_UDPCONNOVERFLOW;
	}
	/* TCP/UDP Whole-System Connection overflow */
	if ( (dos_checkList & RTL8651_DOS_TCPUDPCONNOVERFLOW) &&
		(_rtl8651_dosConnCtrl(RTL8651_DOS_CONNTRACK_TCPUDP) == SUCCESS) )
	{
		Attack |= RTL8651_DOS_TCPUDPCONNOVERFLOW;
	}

	/*
		For the correctness of connection count cache,
		We MUST always count flows no matter it match the ignore type or not.
	*/
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return SUCCESS;
	
	if (Attack)
	{
		rtl8651_tblDrv_routeTable_t *tb;
		tb = _rtl8651_getRoutingEntry(ip);

		/* DOS Proc */
		if ( tb && tb->valid )
		{
			_rtl8651_procDoSIP(Attack, RTL8651_DSID_ALL, tb->dvid, ip);	/* allow all dsid */
		}

		/* We always DONT log these events */

		/***********************************************************/
		return FAILED;
	}
	return SUCCESS;
}
/* TCP DOS hooking */
/* add TCP DOS checking and logging here */
/* return SUCCESS Forwarding Engine will drop the packet */
/* return FAILED Forwarding Engine will forward the packet */
/* input parameter ip is 2-bytes boundary, but 4-bytes boundary */
int32 rtl8651a_dosTcpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction,uint32 wanStatus, struct rtl_pktHdr *pktHdr, uint8 checkType){
	struct tcphdr *tc = NULL;
	uint32 sport, dport;
	uint32 NeedLog;
	uint32 Attack = 0;
	uint32 l3Only = (ntohs(ip->ip_off) & (IP_OFFMASK));	// for fragment packet, check L3 only
	uint32 dos_checkList = _rtl8651_dos_sw[dsid];
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	/* for log */
#endif
	//if(dsid!=0) return FAILED;
	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);

	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	assert(ip);
	tc = (struct tcphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));

	#define DOS_TCP_L3_CHECKLIST		(RTL8651_DOS_IPSPOOF|RTL8651_DOS_TCPLAND|RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN)
	#define DOS_TCP_FAST_CHECKLIST	(RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN)

	if (checkType == RTL8651_DOS_FAST_CHECK)
		dos_checkList &= DOS_TCP_FAST_CHECKLIST;
	else
		dos_checkList &= ~DOS_TCP_FAST_CHECKLIST;

	if (l3Only)
	{
		dos_checkList &= DOS_TCP_L3_CHECKLIST;
		sport = 0xffffffff;
		dport = 0xffffffff;
	}else
	{
		sport = (uint32)ntohs(tc->th_sport);
		dport = (uint32)ntohs(tc->th_dport);
	}

//TCP_DOS_L3:

	if((dos_checkList&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"IP Spoofing" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}

	//Syn flood attack DoS check is not in fast path since both attacks
	//apply only for initial SYN pkt when creating new connection
	if((dos_checkList&RTL8651_DOS_SYNFLOOD) && _rtl8651_dosSynFlood(dsid,ip,tc,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		//printk("DoS Attack: TCP SYN Flood -- Direction: %s, Src: %u.%u.%u.%u:%u, Dest: %u.%u.%u.%u:%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),tc->th_sport,NIPQUAD(ip->ip_dst.s_addr),tc->th_dport);
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_TCP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_SynFlood, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"TCP SYN Flood" /* msg */);
#endif
			}
		}
		Attack |= RTL8651_DOS_SYNFLOOD;
 	}	

	// per-sip flooding dos check
	if ((dos_checkList&RTL8651_DOS_SRC_SYNFLOOD) && _rtl8651_dosSrcSynFlood(dsid,ip,tc, &NeedLog) == SUCCESS) {
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostSynFlood, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"HOST Attack: TCP SYN Flood" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SRC_SYNFLOOD;
	}

	if((dos_checkList&RTL8651_DOS_STEALTHFIN) && _rtl8651_dosStealthFin(dsid,ip,tc,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_TCP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_StealthFin, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"TCP Stealth FIN Port Scan" /* msg */);
#endif
			}
		}
		Attack |= RTL8651_DOS_STEALTHFIN;
	}

	if((dos_checkList&RTL8651_DOS_SRC_STEALTHFIN) && _rtl8651_dosSrcStealthFin(dsid,ip,tc,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostStealthFin, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"HOST Attack: TCP Stealth FIN Port Scan" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SRC_STEALTHFIN;
	}

//TCP_DOS_L4:

	if((dos_checkList&RTL8651_DOS_TCPLAND)  && _rtl8651_dosTcpLand(ip,tc) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpLand, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"Land" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_TCPLAND;
	}		
	
	if((dos_checkList&RTL8651_DOS_SCAN) && _rtl8651_dosScan(ip,tc) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;	
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpScan, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"TCP Scan" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SCAN;
	}

	if((dos_checkList&RTL8651_DOS_SYNWITHDATA) && _rtl8651_dosSynWithData(ip,tc) == SUCCESS){		
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		//printk("DoS Attack: TCP SYN with data -- Direction: %s, Src: %u.%u.%u.%u:%u, Dest: %u.%u.%u.%u:%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),tc->th_sport,NIPQUAD(ip->ip_dst.s_addr),tc->th_dport);
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_TCP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_TcpSynWithData, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"TCP SYN with Data" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SYNWITHDATA;
	}

// tcp_dos_out:
	if (Attack)
	{	// attack found : further process attack packet and return SUCCESS
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;	
}

/* IP DOS hooking */
/* add IP DOS checking and logging here */
/* return SUCCESS Forwarding Engine will drop the packet */
/* return FAILED Forwarding Engine will forward the packet */
/* input parameter ip is 2-bytes boundary, but 4-bytes boundary */
int32 rtl8651a_dosIpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction ,uint32 wanStatus, struct rtl_pktHdr* pktHdr){
	uint32 Attack = 0;
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	/* for log */
#endif

	//if(dsid!=0) return FAILED;
	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;
	
	//Land attack DoS check is not in fast path since both attacks
	//apply only for initial SYN pkt when creating new connection
	assert(ip);
	if((_rtl8651_dos_sw[dsid]&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= ip->ip_p;
			info.pkt_direction	= direction;
			info.pkt_sport		= 0xffff;
			info.pkt_dport		= 0xffff;
			info.pkt_icmpType	= 0xff;
			info.pkt_icmpId	= 0xffff;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, /* don't care */
				(unsigned short)0xffffffff, /* don't care */
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"IP Spoofing" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}
//ip_dos_out:
	if (Attack)
	{	// attack found : further process attack packet and return SUCCESS
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;	

}

/* ICMP DOS hooking */
/* add IP DOS checking and logging here */
/* return SUCCESS Forwarding Engine will drop the packet */
/* return FAILED Forwarding Engine will forward the packet */
/* input parameter ip is 2-bytes boundary, but 4-bytes boundary */
int32 rtl8651a_dosIcmpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction,uint32 wanStatus, struct rtl_pktHdr* pktHdr){
	struct icmp *ic = NULL;
	uint8 icmpType;
	uint16 icmpId;
	uint32 Attack = 0;
	uint32 NeedLog;
	uint32 l3Only = (ntohs(ip->ip_off) & (IP_OFFMASK));	// for fragment packet, check L3 only
	uint32 dos_checkList = _rtl8651_dos_sw[dsid];
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	/* for log */
#endif

	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);
	//if(dsid!=0) return FAILED;
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;
	assert(ip);

	ic = (struct icmp *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));

	#define DOS_ICMP_L3_CHECKLIST (RTL8651_DOS_IPSPOOF|RTL8651_DOS_ICMPLAND|RTL8651_DOS_PINGOFDEATH|RTL8651_DOS_ICMPFLOOD|RTL8651_DOS_SRC_ICMPFLOOD)

	if (l3Only)
	{
		dos_checkList &= DOS_ICMP_L3_CHECKLIST;
		icmpType = 0xff;
		icmpId = 0xffff;
	}else
	{
		icmpType = ic->icmp_type;
		icmpId = ntohs(ic->icmp_id);
	}

//ICMP_DOS_L3:

	if((dos_checkList&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, /* don't care */
				(unsigned short)0xffffffff, /* don't care */
				icmpType, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"IP Spoofing" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}

	//printk("icmpcheck dip=%u.%u.%u.%u\n",NIPQUAD(ip->ip_dst.s_addr));
	if((dos_checkList&RTL8651_DOS_ICMPLAND) && _rtl8651_dosIcmpLand(ip,ic) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		//printk("DoS Attack: ICMP Land --  Direction: %s, Src: %u.%u.%u.%u, Dest: %u.%u.%u.%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),NIPQUAD(ip->ip_dst.s_addr));
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL		
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpLand, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, /* don't care */
				(unsigned short)0xffffffff, /* don't care */
				icmpType, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"ICMP Land" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_ICMPLAND;
	}

	if((dos_checkList&RTL8651_DOS_PINGOFDEATH) && _rtl8651_dosPingOfDeath(ip,ic) == SUCCESS){	
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		//printk("DoS Attack: ICMP Ping Of Death --  Direction: %s, Src: %u.%u.%u.%u, Dest: %u.%u.%u.%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),NIPQUAD(ip->ip_dst.s_addr));
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpPingOfDeath, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, /* don't care */
				(unsigned short)0xffffffff, /* don't care */
				icmpType, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"ICMP Ping Of Death" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_PINGOFDEATH;
	}

	if((dos_checkList&RTL8651_DOS_ICMPFLOOD) && _rtl8651_dosIcmpFlood(dsid,ip,ic, &NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		//printk("DoS Attack: ICMP Flood -- Direction: %s, Src: %u.%u.%u.%u, Dest: %u.%u.%u.%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),NIPQUAD(ip->ip_dst.s_addr));
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_ICMP;
				info.pkt_direction	= direction;
				info.pkt_icmpType	= icmpType;
				info.pkt_icmpId	= icmpId;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpFlood, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)0xffffffff, /* don't care */
					(unsigned short)0xffffffff, /* don't care */
					icmpType, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"ICMP Flood" /* msg */);
#endif
			}
		}
		Attack |= RTL8651_DOS_ICMPFLOOD;
	}

	if((dos_checkList&RTL8651_DOS_SRC_ICMPFLOOD)&&_rtl8651_dosSrcIcmpFlood(dsid,ip,ic,&NeedLog) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostIcmpFlood, &info); 
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, /* don't care */
				(unsigned short)0xffffffff, /* don't care */
				icmpType, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"HOST Attack: ICMP Flood" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SRC_ICMPFLOOD;
	}

//ICMP_DOS_L4:

	if((dos_checkList&RTL8651_DOS_SMURF) && _rtl8651_dosSmurf(ip,ic,vid) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		//printk("DoS Attack: ICMP Smurf -- Direction: %s, Src: %u.%u.%u.%u, Dest: %u.%u.%u.%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),NIPQUAD(ip->ip_dst.s_addr));
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_ICMP;
			info.pkt_direction	= direction;
			info.pkt_icmpType	= icmpType;
			info.pkt_icmpId	= icmpId;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IcmpSmurf, &info); 
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)0xffffffff, /* don't care */
				(unsigned short)0xffffffff, /* don't care */
				icmpType, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"ICMP Smurf" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SMURF;
	}	

//icmp_dos_out:
	if (Attack)
	{	// attack found : further process attack packet and return SUCCESS
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;	
}


/* UDP DOS hooking */
/* add UDP DOS checking and logging here */
/* return SUCCESS Forwarding Engine will drop the packet */
/* return FAILED Forwarding Engine will forward the packet */
/* input parameter ip is 2-bytes boundary, but 4-bytes boundary */
int32 rtl8651a_dosUdpCheck(uint32 dsid,uint16 vid, struct ip* ip, int32 *local_val,uint8 direction,uint32 wanStatus, struct rtl_pktHdr* pktHdr, uint8 checkType){
	struct udphdr *ud = NULL;
	uint32 sport, dport;
	uint32 Attack = 0;
	uint32 NeedLog;
	uint32 l3Only = (ntohs(ip->ip_off) & (IP_OFFMASK));	// for fragment packet, check L3 only
	uint32 dos_checkList = _rtl8651_dos_sw[dsid];
#ifdef _RTL_NEW_LOGGING_MODEL
	rtl8651_logInfo_t info;	/* for log */
#endif
	//if(dsid!=0) return FAILED;
	assert(dsid<rtl8651_tblDrvPara.dialSessionNumber);
	if (_rtl8651_dos_enable == FALSE) return FAILED;
	if(wanStatus==FAILED) return FAILED;
	if (_rtl8651_dosIgnoreTypeCheck(direction) == TRUE) return FAILED;

	ud = (struct udphdr *) ((int8 *) ip + ((*(uint8*)ip&0xf) << 2));

	#define DOS_UDP_L3_CHECKLIST		(RTL8651_DOS_IPSPOOF|RTL8651_DOS_UDPLAND|RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD)
	#define DOS_UDP_FAST_CHECKLIST	(RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD|RTL8651_DOS_UDPBOMB)

	if (checkType == RTL8651_DOS_FAST_CHECK)
		dos_checkList &= DOS_UDP_FAST_CHECKLIST;
	else
		dos_checkList &= ~DOS_UDP_FAST_CHECKLIST;

	// set different sport/dport
	if (l3Only)
	{
		dos_checkList &= DOS_UDP_L3_CHECKLIST;
		sport = 0xffffffff;
		dport = 0xffffffff;
	}else
	{
		sport = (uint32)ntohs(ud->uh_sport);
		dport = (uint32)ntohs(ud->uh_dport);
	}

//UDP_DOS_L3:

	if((dos_checkList&RTL8651_DOS_IPSPOOF) && _rtl8651_dosIpSpoof(ip,vid,direction) == SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_IpSpoof, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport, /* don't care */
				(unsigned short)dport, /* don't care */
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"IP Spoofing" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_IPSPOOF;
	}


	if((dos_checkList&RTL8651_DOS_UDPFLOOD) && _rtl8651_dosUdpFlood(dsid,ip,ud,&NeedLog)==SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if (NeedLog == TRUE)
		{
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpFlood, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"UDP Flood" /* msg */);
#endif
			}
		}
		Attack |= RTL8651_DOS_UDPFLOOD;
	}

	if((dos_checkList&RTL8651_DOS_SRC_UDPFLOOD) && _rtl8651_dosSrcUdpFlood(dsid,ip,&NeedLog)==SUCCESS){
		*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
		if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc&&NeedLog)
		{
#ifdef _RTL_NEW_LOGGING_MODEL
			info.infoType		= RTL8651_LOG_INFO_PKT;
			info.pkt_dsid		= dsid;
			info.pkt_sip		= pktHdr->ph_sip;
			info.pkt_dip		= pktHdr->ph_dip;
			info.pkt_proto		= IPPROTO_UDP;
			info.pkt_direction	= direction;
			info.pkt_sport		= sport;
			info.pkt_dport		= dport;
			info.action		= RTL8651_LOGACTION_DROP;
			(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_HostUdpFlood, &info);
#else
			(*_pUserLoggingFunc)(
				dsid,
				RTL8651_LOGMODULE_DOS,
			    (unsigned char)ip->ip_p, /* protocol */
			    (unsigned char)direction, /* direction */
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
				(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
				(unsigned short)sport,
				(unsigned short)dport,
				0, /* type: only meaningful for ICMP */
				RTL8651_LOGACTION_DROP, /* action */
				"HOST Attack: UDP Flood" /* msg */);
#endif
		}
		Attack |= RTL8651_DOS_SRC_UDPFLOOD;
	}

//UDP_DOS_L4:

		if((dos_checkList&RTL8651_DOS_UDPLAND) && _rtl8651_dosUdpLand(ip,ud) == SUCCESS){
			*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;
			//printk("DoS Attack: UDP Land -- Direction: %s, Src: %u.%u.%u.%u:%u, Dest: %u.%u.%u.%u:%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),ud->uh_sport,NIPQUAD(ip->ip_dst.s_addr),ud->uh_dport);
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpLand, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"UDP Land" /* msg */);
#endif
			}
			Attack |= RTL8651_DOS_UDPLAND;
		}		
	
		if((dos_checkList&RTL8651_DOS_UDPBOMB) && _rtl8651_dosUdpBomb(ip,ud)==SUCCESS){
			*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;//just disable these ports...
			//printk("DoS Attack: UDP Bomb -- Direction: %s, Src: %u.%u.%u.%u:%u, Dest: %u.%u.%u.%u:%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),ud->uh_sport,NIPQUAD(ip->ip_dst.s_addr),ud->uh_dport);
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpBomb, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
					(unsigned char)ip->ip_p, /* protocol */
					(unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"UDP Bomb" /* msg */);
#endif
			}
			Attack |= RTL8651_DOS_UDPBOMB;
		}

		if((dos_checkList&RTL8651_DOS_ECHOCHARGEN) && _rtl8651_dosUdpEchoChargen(ip,ud)==SUCCESS){
			*local_val=FWDENG_USER_IDSCHECKDROP|FWDENG_DROP;//just disable these ports...
			//printk("DoS Attack: UDP Echo Chargen -- Direction: %s, Src: %u.%u.%u.%u:%u, Dest: %u.%u.%u.%u:%u\n",dir[direction],NIPQUAD(ip->ip_src.s_addr),ud->uh_sport,NIPQUAD(ip->ip_dst.s_addr),ud->uh_dport);
			if ((_loggingModule[dsid]&RTL8651_LOGMODULE_DOS)&&_pUserLoggingFunc)
			{
#ifdef _RTL_NEW_LOGGING_MODEL
				info.infoType		= RTL8651_LOG_INFO_PKT;
				info.pkt_dsid		= dsid;
				info.pkt_sip		= pktHdr->ph_sip;
				info.pkt_dip		= pktHdr->ph_dip;
				info.pkt_proto		= IPPROTO_UDP;
				info.pkt_direction	= direction;
				info.pkt_sport		= sport;
				info.pkt_dport		= dport;
				info.action		= RTL8651_LOGACTION_DROP;
				(* _pUserLoggingFunc)(RTL8651_LOGMODULE_DOS, RTL8651_LOG_DOS_UdpEchoChargen, &info);
#else
				(*_pUserLoggingFunc)(
					dsid,
					RTL8651_LOGMODULE_DOS,
				    (unsigned char)ip->ip_p, /* protocol */
				    (unsigned char)direction, /* direction */
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_src.s_addr),
					(unsigned long)PKTGET_UINT32_UNALIGNED(&ip->ip_dst.s_addr),
					(unsigned short)sport,
					(unsigned short)dport,
					0, /* type: only meaningful for ICMP */
					RTL8651_LOGACTION_DROP, /* action */
					"UDP Echo Chargen" /* msg */);
#endif
			}
			Attack |= RTL8651_DOS_ECHOCHARGEN;
		}


//udp_dos_out:
	if (Attack)
	{	// attack found : further process attack packet and return SUCCESS
			_rtl8651_procDoSPkt(Attack, dsid, vid, ip, direction, pktHdr);
		return SUCCESS;
	}
	return FAILED;
}

