#include "rtl_types.h"
#include "types.h"
#include "rtl_cle.h" 
#include "rtl8651_tblDrvFwdLocal.h"

static int32	_fwdEngineFeatures(uint32 userId,  int32 argc,int8 **saved){
	int8 *nextToken;
	int32 size, Switch=FALSE;
	cle_getNextCmdToken(&nextToken,&size,saved); 
	if(strcmp(nextToken, "enable") == 0)
		Switch=TRUE;
	while(cle_getNextCmdToken(&nextToken,&size,saved) != FAILED) {		
		if((strcmp(nextToken, "arp-reply") == 0)&&rtl8651_fwdEngineArp(Switch))
			return FAILED;
		else if((strcmp(nextToken, "arp-proxy") == 0)&& rtl8651_fwdEngineArpProxy(Switch))
			return FAILED;
		else if((strcmp(nextToken, "icmp-reply") == 0)&& rtl8651_fwdEngineIcmp(Switch))
			return FAILED;
		else if((strcmp(nextToken, "icmp-rt-msg") == 0)&& rtl8651_fwdEngineIcmpRoutingMsg(Switch))
			return FAILED;
		else if((strcmp(nextToken, "uncond-icmpReply") == 0)&& rtl8651_fwdEngineAlwaysReplyICMPErrForFragment(Switch))
			return FAILED;
		else if((strcmp(nextToken, "icmp-dmz-fwd") == 0) && rtl8651_fwdEngineDMZHostIcmpPassThrough(Switch))
			return FAILED;
		else if((strcmp(nextToken, "other-dmz-fwd") == 0) && rtl8651_fwdEngineFwdGeneralL4ToDMZ(Switch))
			return FAILED;
		else if((strcmp(nextToken, "unicast-igmp-fwd") == 0) && rtl8651_fwdEngineFwdUnicastIGMPPkt(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "ip-fragment") == 0)&&rtl8651_fwdEngineProcessIPFragment(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "ip-multicast") == 0)&&rtl8651_fwdEngineProcessIPMulticast(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "port-bouncing") == 0)&&rtl8651_fwdEngineProcessPortBouncing(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "inexactUdp") == 0)&&rtl8651_fwdEngineInexactUdpFlow(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "port-keeping") == 0) && (rtl8651_fwdEngineUdpStaticNaptPortTranslation(Switch)||rtl8651_fwdEngineTcpStaticNaptPortTranslation(Switch)))
			return FAILED;
#ifdef _RTL_WEAK_NAPT_CTRL
		else if ((strcmp(nextToken, "weak-napt") == 0) && (rtl8651_fwdEngineWeakTcpNaptProcess(Switch)))
			return FAILED;
#else
		else if (strcmp(nextToken, "weak-napt") == 0)
			return FAILED;
#endif /* _RTL_WEAK_NAPT_CTRL */
		else if((strcmp(nextToken, "layer34") == 0)&&rtl8651_fwdEngineProcessL34(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "ps2wanDTout") == 0)&&rtl8651_fwdEnginePsDontTimeout(Switch))
			return FAILED;
		else if ((strcmp(nextToken, "psErr2wanDTout") == 0)&&rtl8651_fwdEnginePsToWanErrMsgDontTimeout(Switch))
			return FAILED;
		else if(strcmp(nextToken, "pppoe") == 0){
#if 0
			if(rtl8651_fwdEnginePPPoE(Switch, rtl_pppoe_input))
				return FAILED;
#endif
		}
	}
	return SUCCESS;
}

static int32	_fwdEngineTxMirror(uint32 userId,  int32 argc,int8 **saved){
	int8 *nextToken;
	int32 size, add=FALSE, retval;
	cle_getNextCmdToken(&nextToken, &size, saved);
	if(!strcmp(nextToken, "add"))
		add=TRUE;
	else
		add=FALSE;

	while(cle_getNextCmdToken(&nextToken,&size,saved) != FAILED) {		
		uint16 vid=U16_value(nextToken);
		if((retval=rtl8651_setVlanFwdTxMirror(vid, add)) != SUCCESS)
			return retval;
	}
	return SUCCESS;
}


static int32	_fwdEngineDoSscan(uint32 userId,  int32 argc,int8 **saved){
	printk("_fwdEngineDoSscan().............\n");
	return SUCCESS;
}


static int32	_fwdEngineDump(uint32 userId,  int32 argc,int8 **saved){
	int8 *nextToken;
	int32 size, i;
	uint32 start=0, end=0, total=0, total2=0, lines=0;	

	//Dump Alg ctrl connections...
	cle_getNextCmdToken(&nextToken, &size, saved);

	//Get start, end position		
	if(size>0){
		start=end=*((uint32 *)nextToken);
	}else if(!strcmp("from", (int8 *)nextToken)){
		cle_getNextCmdToken((int8 **)&nextToken,&size,saved); //starting index
		start = *((uint32 *)nextToken);
		cle_getNextCmdToken((int8 **)&nextToken,&size,saved);
		if(!strcmp("all", (int8 *)nextToken))
			end = 1023;
		else if(!strcmp("until", (int8 *)nextToken)){
			cle_getNextCmdToken((int8 **)&nextToken,&size,saved);
			end = *((uint32 *)nextToken);
			if(end>1023)
				end=1023;
		}
	}else if(!strcmp("until", (int8 *)nextToken)){
			cle_getNextCmdToken((int8 **)&nextToken,&size,saved);
			end = *((uint32 *)nextToken);
			if(end>1023)
				end=1023;
			start = 0;
	}else if(!strcmp("all", (int8 *)nextToken)){
			end = 1023;
			start = 0;
	}

	printk(">>ALG control connection list:\n\t");
	printk("f)orwarding engine created.\n\t"
			"I)nbound flow.\n\t"
			"L)iberal hashing flow.\n\t"
			"T)CP\n\t"
			"U)DP\n\t"
			);
	printk("\n");
	
	for(i=start; i<=end; i++) {
		int32 count=0;
		count=_rtl8651_dumpAlgCtrlConnections(i);
		if(count)
			lines++;
		total2+=count;
	}
	printk("%d ASIC entries listed.\n", total);
	printk("%d flows listed, on %d lines.\n", total2, lines);
	
	return SUCCESS;
}




cle_exec_t rtl8651_tblDrvFwd_cmds[] = {
	{	"alg-conns",
		"Dump ALG ctrl connections created by forwarding engine.",
		"{ %d'entry index' | { all'List all'  | until'Specify end index'  %d'End index' | from'Specify starting index'  %d'Starting  index'   { all'List all'  | until'Specify end index'  %d'End index' } } }  ",
		_fwdEngineDump,
		CLE_USECISCOCMDPARSER,	
		0,
		NULL
	},	
	{	"dosscan",
		"Config built-in DoS and SCAN detect feature.",
		"{ { { enable'enable DoS/Scan detect features' | disable'Disable DoS/Scan detect features' }  {  ip { [ teardrop ] [ spoofing ] } | "
		" tcp { [ synflood %d'threshold' ] [ synwithdata ] [ landattack ] [ fullxmas ] [ fullsapuscan ] [ finscan ] [ synfinscan ] [ nullscan ] [ nmapxmasscan ] [ vecnascan ] } | "
		" udp { [ flood %d'threshold' ] [ echochargenbomb ] } | "
		" icmp { [ pingofdeath ] [ smurf ] [ flood %d'threshold' ] } } } | status'List all DoS/scan detect item status' }",
		_fwdEngineDoSscan,
		CLE_USECISCOCMDPARSER,	
		0,
		NULL
	},	
	{	"features",
		"Config forwarding engine built-in software features",
		"{ enable'Enable driver built-in protocol features' { [ arp-reply'Let driver reply ARP queries to gateway'  ] [ arp-proxy'Let driver reply ARP query if it need arp proxy'  ] [ icmp-reply'Let driver response ICMP requests' ] [ icmp-rt-msg'Let driver handle routing related ICMP messages' ] [ uncond-icmpReply'Let drv always reply ICMP message for all packets need fragment.' ] [ other-dmz-fwd'Forward other L4 packets to/from dmz host' ] [ unicast-igmp-fwd'Forward unicast IGMP packet insteads of trap/run IGMP proxy function' ] [ icmp-dmz-fwd'Forward ICMP requests to dmz host' ] [ ip-fragment'Process IP fragment packet' ] [ ip-multicast'Process IP multicast/IGMP packet' ] [ port-bouncing'Process Port Bouncing' ] [ inexactUdp'Enable Inexact UDP NAPT connection creation' ] [ port-keeping'Enable UDP/TCP NAPT connection without translating source port' ] [ weak-napt'Enable TCP weak NAPT connection, ignore SPI check (Dangerous!)' ] [ layer34'Enable driver built-in Routing/NAT/NAPT/server port features' ] [ ps2wanDTout'Disable idleTimer update for all PS2WAN packets' ] [ psErr2wanDTout'Disable idleTimer update for PS2WAN err-msg' ] [ pppoe'Enable driver built-in PPPoE/PPP protocol module' ] } | "
		" disable'Disable driver built-in protocol features' { [ arp-reply'Pass ARP queries(to gateway) to host protocol stack.'  ] [ arp-proxy'Pass all ARP queries(not to gateway) to host protocol stack.'  ] [ icmp-reply'Pass all ICMP requests to host protocol stack.' ] [ icmp-rt-msg'Host protocol stack handle/send routing related ICMP messages.' ] [ uncond-icmpReply'Only reply ICMP message for fragment-packet with Dont Frag bit set.' ] [ other-dmz-fwd'Trap other L4 packets from dmz host/remote host to proctocol stack' ] [ unicast-igmp-fwd'Trap or run IGMP proxy function for IGMP unicast packet' ] [ icmp-dmz-fwd'Reply ICMP requests by gateway instead of dmz host' ] [ ip-fragment'Trap all fragment packets to protocol stack' ] [ ip-multicast'L2 broadcast IP multicast/IGMP packets and trap them' ] [ port-bouncing'trap Port Bouncing packets' ] [ inexactUdp'Only allow full-associated NAPT UDP connection creation' ] [ port-keeping'UDP/TCP NAPT flow sport is assigned by driver' ] [ weak-napt'TCP napt connection must pass SPI check' ] [ layer34'Pass all L3/L4 packets to host protocol stack' ] [ ps2wanDTout'Dont disable idleTimer update for PS2WAN packets' ] [ psErr2wanDTout'Dont disable idleTimer update for PS2WAN err-msg' ] [ pppoe'Disable driver built-in PPPoE/PPP protocol module' ] } } ",
		_fwdEngineFeatures,
		CLE_USECISCOCMDPARSER,	
		0,
		NULL
	},
	{	"tx-mirror",
		"Add/Remove Tx mirror member VLANs.",
		"{ add'Add VLAN(s) to receive forwarding engine transmitted packets'  | remove'remove VLANs from receiveing forwarding engine Tx packets' } (1~8)%d'VLAN id' ",
		_fwdEngineTxMirror,
		CLE_USECISCOCMDPARSER,	
		0,
		NULL
	},
};

