#include "rtl_types.h"
#include "rtl8651_timer.h"
#define u8 unsigned char
#define u16 unsigned short
#define u32 unsigned int



/* static LIST_HEAD(_rtl8651_tv1_vec); */
static struct list_head _rtl8651_tv1_vec = LIST_HEAD_INIT(_rtl8651_tv1_vec);

void _rtl8651_init_timer(struct rtl8651_timer_list * timer)
{

timer->list.next=timer->list.prev=0;
}

static inline int timer_pending (const struct rtl8651_timer_list * timer)
{
	return timer->list.next != 0;
}

static inline int _rtl8651_detach_timer (struct rtl8651_timer_list *timer)
{	
	if (!timer_pending(timer))
		return 0;
	list_del(&timer->list);
	return 1;
}

int _rtl8651_del_timer(struct rtl8651_timer_list * timer)
{
	int ret;
	ret = _rtl8651_detach_timer(timer);
	timer->list.next = timer->list.prev = 0;
	return ret;
}


/* Creation primitives. */


static inline void _rtl8651_internal_add_timer(struct rtl8651_timer_list *timer)
{
	list_add_tail(&timer->list,&_rtl8651_tv1_vec);
}

int _rtl8651_mod_timer(struct rtl8651_timer_list *timer, uint32 expires)
{
	int ret;
	timer->expires = expires;
	ret = _rtl8651_detach_timer(timer);
	_rtl8651_internal_add_timer(timer);
	return ret;
}



void _rtl8651_run_timer_list(void)
{
	struct list_head *head, *curr;
	
	if (list_empty(&_rtl8651_tv1_vec)) 
	{
		return;
	}		
	head = &_rtl8651_tv1_vec;	
	curr=head->next;
	while(curr!=head)
	{
		struct rtl8651_timer_list *timer;
		void (*fn)(uint32);
		unsigned long data;
		/* ptr, type,member*/
		timer = list_entry(curr, struct rtl8651_timer_list, list);
		if (timer && (timer->expires <=_sysUpSeconds))
		{

	 		fn = timer->function;
	 		data= timer->data;
			_rtl8651_detach_timer(timer);
			timer->list.next = timer->list.prev = 0; 
			if (fn)
			{
				fn(data);
				curr = head->next;
			}else
				curr = curr->next;
		}else
		{
			curr = curr->next;
		}
	}

}

