#include <stdio.h>
#include <string.h>
#include "utility.h"
#include "pktDump.h"
#include "pktGen.h"

int main(){
	rtl8651_PktConf_t	*ptr;
	uint32			pktLen;
	int8			pktBuff[2048], content[2048];
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//				Test Cases
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	#define TEST_N		100
	rtl8651_PktConf_t	TestCase[TEST_N];
	int32			caseN = 0;
	bzero(TestCase, (sizeof(struct rtl8651_PktConf_s)*TEST_N));

	// test case 0
	TestCase[caseN].pktType             	= _PKT_TYPE_ARP;                                /* arp packet */
	TestCase[caseN].l2Flag              	= 0;                                            /* no VLAN/PPPoE/SNAP */
	set_mac (TestCase[caseN].conf_smac, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06);
	set_mac (TestCase[caseN].conf_dmac, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff);
	TestCase[caseN].arp.ip_src		= ntohl(inet_addr("192.168.1.1"));
	TestCase[caseN].arp.ip_dst  	        = ntohl(inet_addr("140.113.1.1"));
	TestCase[caseN].arp.op          	= ARPOP_REQUEST;

	// test case 1  
	caseN++; if (caseN == (TEST_N-1)) goto finalCase; // Add case number, Don't modify!
	TestCase[caseN].pktType             = _PKT_TYPE_TCP;                                /* tcp packet */
	TestCase[caseN].l2Flag              = 0;                                            /* no VLAN/PPPoE/SNAP */
	set_mac (TestCase[caseN].conf_smac, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06);
	set_mac (TestCase[caseN].conf_dmac, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
	TestCase[caseN].conf_sip			= ntohl(inet_addr("192.168.1.1"));
	TestCase[caseN].conf_dip			= ntohl(inet_addr("140.113.1.1"));
	TestCase[caseN].ip.version		= 4;
	TestCase[caseN].ip.headerLen		= 20;					// bytes
	TestCase[caseN].ip.tos			= 0;
	TestCase[caseN].ip.id			= 0xa;
	TestCase[caseN].ip.diffserv		= 0;
	TestCase[caseN].ip.mf			= 1;
	TestCase[caseN].ip.offset		= 0;
	TestCase[caseN].ip.ttl			= 255;
	TestCase[caseN].conf_sport			= 123;
	TestCase[caseN].conf_dport			= 456;
	TestCase[caseN].conf_tcp_seq			= 0xb;
	TestCase[caseN].conf_tcp_ack			= 0xc;
	TestCase[caseN].conf_tcp_flag		= 0;
	TestCase[caseN].conf_tcp_win			= 0xfffe;
	TestCase[caseN].payload.content		= content;		// system default content (< 2048)
	TestCase[caseN].payload.length		= 10;			// must < 2048

	// test case 1  
	caseN++; if (caseN == (TEST_N-1)) goto finalCase; // Add case number, Don't modify!
	TestCase[caseN].pktType             = _PKT_TYPE_UDP;                                /* tcp packet */
	TestCase[caseN].l2Flag              = 0;                                            /* no VLAN/PPPoE/SNAP */
	set_mac (TestCase[caseN].conf_smac, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06);
	set_mac (TestCase[caseN].conf_dmac, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f);
	TestCase[caseN].conf_sip			= ntohl(inet_addr("192.168.1.1"));
	TestCase[caseN].conf_dip			= ntohl(inet_addr("140.113.1.1"));
	TestCase[caseN].ip.version		= 4;
	TestCase[caseN].ip.headerLen		= 20;					// bytes
	TestCase[caseN].ip.tos			= 0;
	TestCase[caseN].ip.id			= 0xa;
	TestCase[caseN].ip.diffserv		= 0;
	TestCase[caseN].ip.mf			= 1;
	TestCase[caseN].ip.offset		= 0;
	TestCase[caseN].ip.ttl			= 255;
	TestCase[caseN].conf_sport			= 123;
	TestCase[caseN].conf_dport			= 456;
	TestCase[caseN].payload.content		= content;		// system default content (< 2048)
	TestCase[caseN].payload.length		= 10;			// must < 2048


////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
finalCase:
	TestCase[TEST_N-1].pktType      = _PKT_STOP;
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	memset(content, 'X', 2048);

	ptr = TestCase;// initial
	printf("@Pkt Gen Start...\n\n");

	while (1){

		pktLen = pktGen(ptr, pktBuff);
		if (pktLen == 0){	//	last packet, exit
			break;
		}
		printf("\n\n");
		dumpInfo(pktBuff, pktLen);
		printf("\n\n");
		ptr ++;		// next test case
	}
	printf("\n\n@Pkt Gen success...\n\n");
	return 0;
}
