#ifndef PKTPARSE_H
#define PKTPARSE_H

#include "types.h"
#include "flagDef.h"
#include "l2pkt.h"
#include "l3pkt.h"
#include "l4pkt.h"

typedef struct pktParse_s {
	uint32		pktFlag;
	_etherHdr_t	*ether2;
	_vlanHdr_t	*vlan;
	_llcHdr_t	*llc;
	_pppoeHdr_t	*pppoe;
	//Following are mutual exclusive
	ipxHdr_t	*ipx;
	arpHdr_t	*arp;
	ipHdr_t		*ip;
	uint32		l3Flag;
	uint16		l3Cksum;
	//Following are mutual exclusive
	greHdr_t	*pptp;
	icmpHdr_t	*icmp;
	igmpHdr_t	*igmp;
	udpHdr_t	*udp;
	tcpHdr_t	*tcp;
	uint32		l4Flag;
	uint16		l4Cksum;
	// payload
	uint8		*payload;
	// Total Length
	uint32		totalLen;
	// Data Length
	uint32		dataLen;
} pktParse_t;

void pktParse(int8 * pkt, pktParse_t * result, uint32 totalLen);

#endif

