/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : Forwarding Engine test module
* Abstract : 
* Creator : Edward Jin-Ru Chen (jzchen@realtek.com.tw)
* Author :  
*
* $Id: drvTest.c,v 1.1.1.1 2006/07/26 05:38:28 blue Exp $
*
* $Log: drvTest.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:28  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:21  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:57  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.2  2005/11/23 05:17:00  chenyl
* *: module test for WPNT834 case.
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.193  2005/09/21 04:22:56  shliu
* *: add remote management test case
*
* Revision 1.192  2005/09/20 14:39:47  shliu
* *: add remote management test cases
*
* Revision 1.191  2005/09/15 16:03:41  chenyl
* +: ARP testing code
*
* Revision 1.190  2005/08/15 10:53:28  chenyl
* +: new TRIGGER PORT mechanism
* 	- sip check when activate Trigger Port.
* 	- age timer for Triggered Port Mapping.
*
* Revision 1.189  2005/08/04 05:27:56  shliu
* *: add a testing case for ip range ACL.
*
* Revision 1.188  2005/08/01 13:28:53  yjlou
* +: add Hash2_Outbound_Ambigious() and Hash2_2pairs().
*
* Revision 1.187  2005/07/19 05:05:01  chenyl
* *: for Protocol-Stack TX, unknown unicast and multicast DMAC would be L2-broadcasted to all member-ports of destination vlan.
* *: In l3fastActRouting(), system would check arp cache's integrity before using it.
* *: bug fix, NAPTed UDP fragmentation forwarding typing error.
*
* Revision 1.186  2005/07/08 13:30:09  yjlou
* +: support _rtl8651_changeNaptIpAndPort().
* +: add testChangeNaptIpAndPort().
*
* Revision 1.185  2005/07/04 06:35:55  yjlou
* *: remove Generic Model code (to move to model code).
*
* Revision 1.184  2005/06/28 05:16:20  shliu
* *: add TBLDRV testing case for software vlan.
*
* Revision 1.183  2005/06/07 08:34:50  yjlou
* *: fixed the bug of IP Interface cannot be deleted.
*   *: fixed the bug of changeNaptFlowListType(): Symmetric Hash2 connection should not call setNaptEntry() twice. Just call once, and setNaptEntry() will call addHash2ToNexthop() twice.
*   *: fixed the bug of delNaptConnection(): derefHash2NexthopCount() should be called twice (for inbound entry and outbound entry).
*
* Revision 1.182  2005/05/27 13:23:01  yjlou
* +: add NaptTestMoreThan4096Connections() function.
*
* Revision 1.181  2005/05/23 12:53:42  yjlou
* *: rename rtl8651_timeUpdate() to rtl8651_realtimeSchedule().
* +: ROME driver supports realtime PCM and tick interrupt for VoIP.
*
* Revision 1.180  2005/05/17 13:39:49  yjlou
* +: add test case to evaluate the performance of KMP algorithm.
*
* Revision 1.179  2005/05/06 12:23:16  chenyl
* *: for outbound packet which match upnp mapping, ROME Drvier would use the mapped external ip/port
* 	to contribute this connection.
*
* *: tony: fix tcp upnp qos support problem.
*
* Revision 1.178  2005/04/30 07:32:41  yjlou
* +: add VoIP supporting of ROME driver
*
* Revision 1.177  2005/04/30 04:19:49  chenyl
* +: support (L2-Packet-filling + L3-Forwarding) offload Engine
*
* Revision 1.176  2005/04/20 03:31:51  shliu
* *: add url_Filter_test8
*
* Revision 1.175  2005/04/14 12:56:55  shliu
* *: Add new acl matchType testing case.
*
* Revision 1.174  2005/04/02 08:47:32  chenyl
* *: bug fix: server port overlapping check without regardless of TCP/UDP
*
* Revision 1.173  2005/03/31 16:34:19  yjlou
* +: merge GDMA model and driver code to test module system.
*
* Revision 1.172  2005/03/29 15:08:25  chenyl
* +: URL filter with SMAC checking
*
* Revision 1.171  2005/03/28 12:17:17  chenyl
* +: Exception List for NAPT-Redirect system
*
* Revision 1.170  2005/03/28 06:01:51  chenyl
* *: NAPT redirect without DIp/Dport modification
*
* Revision 1.169  2005/03/25 13:04:43  shliu
* *: Add testing case 918.
*
* Revision 1.168  2005/03/24 16:03:26  chenyl
* *: modify IP unnumber patch mechanism
* 	- patch IP unnumber with ASIC local public entry, ACL entry, or ToCPU-interface route entry
*
* +: Rate Limit Counter
* 	- use Rate Limit table and egress ACL rule to counter the amount of packets forwarded by ASIC
* 	- used by IP unnumbered ASIC local public entry patch now.
*
* Revision 1.167  2005/03/24 04:40:31  shliu
* *: Add misc_test4 for testing _rtl8651_getOneVidx() API.
*
* Revision 1.166  2005/03/17 06:28:24  shliu
* +: Add "src Mac & dst Port" ACL rule testing case.
*
* Revision 1.165  2005/03/14 14:39:27  chenyl
* *: URL filter exactly match
*
* Revision 1.164  2005/03/02 08:48:04  shliu
* * : Add test case 503: testing the correctness of adding/removing IP table
*     entry by rtl8651_addNaptMappingExt() & rtl8651_delNaptMapping().
* * : Modify test case 4102: When the linkLayerType is PPTP,
*     the PROCESS of the interface routing entry is always to CPU.
*     This is for "pptp dial demand (when pinging  pptp server IP)" spec.
*
* Revision 1.163  2005/02/16 02:15:12  chenyl
* +: Forwarding Engine Trapping Dispatch system:
* 	When one packet must to be trapped to upper-layer protocol stack,
* 	User can decide how to dispatch this packet into different "categories"
* 	according to its 'l4protocol/source IP/destination IP/source Port (TCP/UDP)/
* 	destination Port (TCP/UDP)' with wide-card allowed. The category
* 	number is decided by user and will be set into ph_category in packet header.
* 	Fragment packet's test is passed.
*
* +: Forwarding Engine QoS Send:
* 	Protocol stack packet send with high TX queue used.
*
* Revision 1.162  2005/01/27 05:51:29  chhuang
* *: l2 learning always trusts new information
*
* Revision 1.161  2005/01/20 02:46:10  jzchen
* +: Change rate limit data structure name
*
* Revision 1.160  2005/01/11 07:41:06  yjlou
* +: add ipsecTestFrag()
*
* Revision 1.159  2004/12/17 13:15:48  yjlou
* +: add ipsecTestBasic1();
*        ipsecTestBasic2();
*        ipsecTestBasic3();
*        ipsecTestBasic4();
*        ipsecTestError();
*
* Revision 1.158  2004/12/15 02:46:24  yjlou
* +: add NaptTestAddNaptConnectiondBug()
* +: add DONT_BIRD_CDROUTER
*
* Revision 1.157  2004/12/14 09:48:10  chenyl
* +: NAPT-Connection Control system
* *: add "NAPT-AddFail" error messages into ignore case.
*
* Revision 1.156  2004/12/07 02:15:41  chenyl
* *: bug fix : Protocol Stack Flow cache
* +: hooking code for ACL-process dispatch
* +: add testing cases for Policy Route and Remote Management
*
* Revision 1.155  2004/12/02 06:17:12  chenyl
* +: add testing cases about Mutli-session fragment packet forwarding.
* *: activate New _rtl8651_l34PacketProcess and rewrite _rtl8651_l34ActExec
*
* Revision 1.154  2004/11/29 07:35:44  chenyl
* *: fix bug : multiple-PPPoE MTU setting bug
* *: fix bug : Never add second session's ip into ASIC in multiple-PPPoE WAN type.
* *: fix bug : Tunekey abnormal behavior when multiple-PPPoE Dial-on-demand Dynamically turn ON/OFF
* *: in forwarding engine Init function, the parameter == 0xffffffff means user want to set as default value
* *: add Mutex-Lock/Unlock checking in testing code
*
* Revision 1.153  2004/11/26 07:40:05  shliu
* Change L3 table arrangement
*
* Revision 1.152  2004/11/18 14:42:09  chhuang
* +: add new testing case for pptp/l2tp
*
* Revision 1.151  2004/11/15 06:09:45  chenyl
* *: bug fix : multicast flow-cache update bugs
* 		- flow-cache might cause age-counting error in some cases
* 		- must filter source vlan/port when add multicast member to flow-cache
* 		- don't remove node as multicast upstream when that node send LEAVE
*
* Revision 1.150  2004/11/05 05:28:26  chenyl
* +: add test case for fragment-multicast packet forwarding test
*
* Revision 1.149  2004/10/21 03:01:54  yjlou
* *: fixed for PPPOE_PASSTHRU_NEW_MODEL
*
* Revision 1.148  2004/10/20 09:44:13  yjlou
* *: fixed for SERVERPORT_PARK_TCPUDP and ADD_FINITE_HASH2_SP.
*
* Revision 1.147  2004/10/15 11:49:39  yjlou
* +: add testAgeOfHash2PortReused()
*
* Revision 1.146  2004/10/15 03:13:54  yjlou
* +: add testNapt4WayHash()
*
* Revision 1.145  2004/10/14 02:43:30  chhuang
* *: add new testing code
*
* Revision 1.144  2004/10/13 07:06:59  yjlou
* +: add NaptInterfaceRoute2() to check interface route in ASIC accelerated.
*
* Revision 1.143  2004/10/12 11:39:13  yjlou
* +: ServerPortAndNewHash1()
* *: fixed for ALLOW_SP
*
* Revision 1.142  2004/10/12 08:53:52  yjlou
* *: fixed for CDRouter: HASH1 UDP will not write to ASIC when add.
*
* Revision 1.141  2004/10/08 06:21:54  chhuang
* *: add new testing code for pptp/l2tp: setPptpProperty & setL2tpProperty need add l2 entry again
*
* Revision 1.140  2004/10/08 03:15:04  yjlou
* +: add pkt_pppoe_passthru_without_vlan1()
*
* Revision 1.139  2004/10/07 13:16:40  chenyl
* +: uPnP entry checking for Port Bouncing
*
* Revision 1.138  2004/10/04 14:41:16  yjlou
* +: add AddConnPerSec_Hash1() and AddConnPerSec_Hash2()
*
* Revision 1.137  2004/10/04 04:30:25  yjlou
* *: give colorful "fail!!" message
*
* Revision 1.136  2004/10/04 03:29:43  yjlou
* +: add testGetOutboundNaptFlow()
*
* Revision 1.135  2004/09/24 07:20:37  yjlou
* +: add testNewlyAddedHash2Udp() function
* *: fixed SelEIdx field
*
* Revision 1.134  2004/09/22 14:18:12  yjlou
* +: add pkt_pppoe_passthru_vlan_index() function
*
* Revision 1.133  2004/09/22 13:25:25  yjlou
* +: add pkt_pppoe_passthru_drop_unknown()
*
* Revision 1.132  2004/09/20 07:35:18  chenyl
* *: non-TCP/UDP/ICMP DMZ forward
* *: unicast IGMP forward
*
* Revision 1.131  2004/09/20 06:04:02  yjlou
* *: commit for test case 356 and 359.
*    *: fixed for NaptTest4096Connections and NaptInterfaceRoute.
*
* Revision 1.130  2004/09/16 11:50:20  tony
* +: add PPTP pass-throught software (not change call ID) case.
*
* Revision 1.129  2004/09/15 16:14:28  chenyl
* +: enable multicast forward cache
*
* Revision 1.128  2004/09/08 01:57:20  chhuang
* +: add new testing case
*
* Revision 1.127  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.126  2004/09/03 03:00:09  chhuang
* +: add new feature: pseudo VLAN
*
* Revision 1.125  2004/09/02 09:04:59  chenyl
* *: napt-redirect: fragment packet support
*
* Revision 1.124  2004/09/02 06:15:38  chenyl
* *: multicast :
* 	- when turning-on ip-multicast, periodic query will be sent immediately
* +: tbldrv
* 	- add options when run addNaptConnection
* 		- PURE_SW: pure software entry
* 		- DONT_CHECK_INTIP: ignore internal IP checking
* 		- TO_PROTOCOL_STACK: this napt packet must be trapped to protocol stack
* +: forwarding engine:
* 	- protocol stack TCP/UDP flow cache
* 	- napt redirect register/unregister/query
*
* Revision 1.123  2004/08/31 03:16:43  chhuang
* +: new testing code for nexthop
*
* Revision 1.122  2004/08/30 05:19:47  tony
* *: fix bug - the path of PPTP server to protocol stack is failed.
*
* Revision 1.121  2004/08/24 07:24:59  chenyl
* *: re_core. modify COMPILE_FLAG
* *: forwarding engine: bug fix, URL Filter match bug
* *: testing code for PPTP header compression
* *: PPTP testing cases re-numbering
*
* Revision 1.120  2004/08/19 11:19:05  chenyl
* +: port bouncing: add the garbage collection mechanism to port bouncing entry
* 	- recycle the TCP port bouncing flow entry for new flow if it in CLOSE state
* +: testing cases for bug fix
*
* Revision 1.119  2004/08/18 14:17:31  chenyl
* *: forwarding engine : let some code be endian free/modify some return value
* +: testing cases for bug fix
*
* Revision 1.118  2004/08/17 12:30:00  chenyl
* *: add port config to multicast default upstream setting API
*
* Revision 1.117  2004/08/17 05:49:46  yjlou
* +: add code to list failed cases at final
*
* Revision 1.116  2004/08/17 02:38:43  chhuang
* *: remove partial MNQueue testing code. Because it is not a stable algorithm
*
* Revision 1.115  2004/08/16 12:31:28  chenyl
* +: test case for udp blocking
*
* Revision 1.114  2004/08/12 13:20:11  chenyl
* +: testing case for remote management fragment packet support
*
* Revision 1.113  2004/08/12 12:59:21  yjlou
* +: add NaptInterfaceRoute()
* +: tcpudp_entry_cmp() supports to compare selExtIPIdx,selEIdx,isCollision2,isDedicated.
*
* Revision 1.112  2004/08/11 05:19:06  chenyl
* +: weak TCP napt checking
* *: modify: for TCP napt outbound packet, if packet is (SYN+ACK) and no any entry found,
* 		forwarding engine will trap this packet and return FWDENG_TCP_NAPT_OUT_NOTFOUND
* 		insteads of dropping it silently.
*
* Revision 1.111  2004/08/06 09:40:50  chenyl
* *: enable TCP/UDP NAPT static-port-translation
* *: rename from looseUDP to InexactUDP
*
* Revision 1.110  2004/08/03 10:44:41  chenyl
* +: looseUDP (re-commit previous commit is failed due to DISK space's full)
*
* Revision 1.109  2004/08/03 10:21:56  chenyl
* +: loose UDP
*
* Revision 1.108  2004/07/28 14:09:17  yjlou
* +: BIG BANG! ROME Driver supports HASH2 ASIC-accelerated now!
*
* Revision 1.107  2004/07/26 14:45:43  chenyl
* +: new logging model
* +: dos Ignore Case
* 	- ignore packets from LAN
* 	- ignore packets from WAN
*
* Revision 1.106  2004/07/26 08:49:36  tony
* +: add PPTP Server in LAN test module.
*
* Revision 1.105  2004/07/19 12:54:43  chenyl
* *: bug fix: process udp packets withc zero-checksum
* *: bug fix: process L3/L4 packets whose ip-header length is not 20 byte
* +: add testing functions to compare/clear checksum field of mbuf/pkthdr
*
* Revision 1.104  2004/07/18 12:13:50  chhuang
* +: M-N-1 Queue
*
* Revision 1.103  2004/07/16 03:05:58  tony
* +: add test module for pptp_idle_timeout and l2tp_idle_timeout case.
*
* Revision 1.102  2004/07/14 11:42:52  chhuang
* +: add M-N Queue
*
* Revision 1.101  2004/07/14 06:55:55  tony
* +: add remote management test case.(web port fowrad and icmp disable)
*
* Revision 1.100  2004/07/14 06:52:45  yjlou
* +: add pkt_ras_dialondemand() function to ensure RAS Dial-on-Demand is OK
*
* Revision 1.99  2004/07/13 13:52:06  yjlou
* +: ROME driver supports IPv6 passthru forwarding even when protocol-based VLAN is created.
*
* Revision 1.98  2004/07/13 09:46:49  yjlou
* +: support RAS idle timeout
*
* Revision 1.97  2004/07/12 07:25:52  chhuang
* +: add new testing code for M-N Queue
*
* Revision 1.96  2004/07/12 04:25:36  chenyl
* *: extend existing port scan mechanism
*
* Revision 1.95  2004/07/08 04:11:05  yjlou
* +: ROME driver supports PPPoE passthru forwarding even when protocol-based VLAN is created.
* -: PPPoE passthru no more monitor the control messages.
*
* Revision 1.94  2004/07/06 06:23:14  chhuang
* +: add rate limit testing code
*
* Revision 1.93  2004/07/05 09:04:58  jzchen
* +: Port bandwidth control testing
*
* Revision 1.92  2004/07/02 10:30:08  chenyl
* *: bug fix: per-source Flooding check bug (counter error)
* *: bug fix: ip-spoofing ACL add function error
* *: bug fix: ICMP ping-of-death : threshold from 65500 to 65535 (follows cisco)
* *: bug fix: item name change of DOS check: UDP Bomb -> UDP EchoChargen (follows cisco)
* +: new feature: New DoS check item, UDP Bomb
* 		- Triggered if (Length of UDP header) < (Length of IP header)
* 		- allow (Length of UDP header) > (Length of IP header)
* 		- follows cisco
*
* Revision 1.91  2004/06/30 02:53:57  chhuang
* +: add new testing case for MTU
*
* Revision 1.90  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.89  2004/06/25 13:53:11  chhuang
* +: add new testing case for MTU fragment
*
* Revision 1.88  2004/06/23 14:42:28  chhuang
* add new testing case for IGMP v3
*
* Revision 1.87  2004/06/15 05:53:22  chhuang
* +: add new testing code
*
* Revision 1.86  2004/06/14 11:04:23  yjlou
* *: replace CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU and CONFIG_RTL865XB_EXP_IPV6_PASSTHRU with CONFIG_RTL865XB_EXP_IPV6_PASSTHRU
*
* Revision 1.85  2004/06/11 14:00:03  jzchen
* +: Add PPPoE session not existed termination feature
*
* Revision 1.84  2004/06/10 03:28:14  jzchen
* +: Display PPPoE session counter in pdddoe command
*
* Revision 1.83  2004/06/08 14:34:33  jzchen
* +: Active PPPoE session tracking testing code
* +: Add dump PPPoE active session ID dump command
*
* Revision 1.82  2004/06/07 13:07:03  yjlou
* +: Supporting IPv6 Passthru
* *: ACL testing code is modified with sequence template.
*
* Revision 1.81  2004/06/01 09:37:37  chhuang
* add new testing csae for ip range acl
*
* Revision 1.80  2004/05/31 14:37:08  jzchen
* Add counter dump command and testing item
*
* Revision 1.79  2004/05/27 05:04:07  chhuang
* use new PPPoE data structure and the data structure merges PPTP/L2TP and PPPoE to a
* single data structure
*
* Revision 1.78  2004/05/25 13:31:04  yjlou
* -: remove CONFIG_RTL865XB_EXP_PROTOCOL_BASED_NAT compile flag
*
* Revision 1.77  2004/05/25 10:05:30  yjlou
* +: CLE supports dynamically enable and disable PPPoE Passthru
*    'drv pppoepassthru enable' and 'drv pppoepassthru disable'
*    + _rtl8651_setExternalInterfaceforPPPoEPassthru()
* +: support dump protocol-based VLAN table
*
* Revision 1.76  2004/05/25 02:44:54  yjlou
* *: I forgot to delete testing code in dump_pppoepassthru()
*
* Revision 1.75  2004/05/24 12:07:21  yjlou
* +: support dump pppoe passthru and dump protocol based vlan
*
* Revision 1.74  2004/05/20 14:06:12  chhuang
* change assumption of Class A/B for testing code
*
* Revision 1.73  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.72  2004/05/19 14:01:26  yjlou
* +: support Protocol-Based NAT
*
* Revision 1.71  2004/05/19 07:44:09  chhuang
* add new testing case for bug fix
*
* Revision 1.70  2004/05/12 07:20:15  chenyl
* +: source ip blocking
* *: modify dos mechanism
*
* Revision 1.69  2004/05/10 08:02:24  chhuang
* add new testing code for url-filtering extension
*
* Revision 1.68  2004/05/06 08:04:17  chhuang
* add testing code for MAC filtering
*
* Revision 1.67  2004/05/05 08:24:39  chhuang
* add new testing code
*
* Revision 1.66  2004/05/05 07:30:07  chenyl
* +: arp-proxy testing case
* *: bug fix in tblDrv addArp function
*
* Revision 1.65  2004/05/05 03:08:35  chhuang
* add new testing code
*
* Revision 1.64  2004/05/04 12:46:27  chenyl
* *: modify ipQueue/multicast system
*         +:  ipQueue:   can constraint total queued packet only
*         +:  multicast: can constraint total member only
*         *:  allocate table when ipQueue/Multicast init()
*         *:  if table size == 0 , ipQueue/Multicast system become disable
*         *:  switch to turn on/off Multicast system dynamically
*
* *: add CLE command to turn on/off ipQueue/ Multicast system
*
* *: change the init method: init ipQueue/multicast system in rtl8651_fwdEngineInit(configPara)
*    and set initial value using "configPara"
*
* Revision 1.63  2004/05/03 14:57:50  cfliu
* add "chip" command
*
* Revision 1.62  2004/04/30 08:58:08  chenyl
* +: ip multicast/igmp proxy
*
* Revision 1.61  2004/04/23 06:55:25  chhuang
* add new testing code for multicast
*
* Revision 1.60  2004/04/21 11:56:58  yjlou
* *: 50B supports protocol-based VLAN PPPoE passthru.
*
* Revision 1.59  2004/04/20 14:31:28  yjlou
* +: add CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU compile flag.
*    (Warning: 5XB Protocol-Based VLAN PPPoE Passthru is still empty)
*
* Revision 1.58  2004/04/19 09:01:16  yjlou
* +: add test code for PPPoE Passthru:
*    pkt_pppoe_passthru()
*
* Revision 1.57  2004/04/19 03:28:15  chhuang
* add new testing code
*
* Revision 1.56  2004/04/15 10:38:24  tony
* add PPTP/L2TP test module.
*
* Revision 1.55  2004/04/09 09:28:02  chhuang
* add new testing case
*
* Revision 1.54  2004/04/09 05:30:28  chhuang
* add new testing case
*
* Revision 1.53  2004/04/09 02:38:35  chhuang
* add new testing case
*
* Revision 1.52  2004/04/08 02:11:24  chhuang
* add new testing case
*
* Revision 1.51  2004/04/07 11:29:33  chenyl
* *: bug fix in fwd-engine : remove "isToEthBcast"
* +: rtl8651_fwdEngineProcessIPFragment(enable) to enable/disable ipQueue system
* 	enable : fragment packets are processed by fwdeng
* 	disable: fragment packets are trapped to protocol stack
*
* Revision 1.50  2004/04/06 01:53:52  chenyl
* +: new testing cases
*
* Revision 1.49  2004/04/01 12:41:04  chhuang
* add new testing case for l2tp
*
* Revision 1.48  2004/04/01 07:01:29  chhuang
* add new testing case for pptp/l2tp
*
* Revision 1.47  2004/03/25 08:58:22  chenyl
* *: new testing cases for fragment packet to protocol stack
*
* Revision 1.46  2004/03/24 09:50:37  chenyl
* +: Queued pkts to CPU
*
* Revision 1.45  2004/03/24 09:12:54  chhuang
* add new testing case
*
* Revision 1.44  2004/03/22 12:30:35  chenyl
* *: new testing cases
*
* Revision 1.43  2004/03/18 11:55:35  chhuang
* regular update
*
* Revision 1.42  2004/03/18 09:17:13  tony
* fix bug: ALG not reinit when test module start.
*
* Revision 1.41  2004/03/18 08:36:42  chhuang
* regular update
*
* Revision 1.40  2004/03/18 07:25:01  chenyl
* +: new testing cases for portbouncing
*
* Revision 1.39  2004/03/18 03:09:20  tony
* add IPSec Client ALG test module(ISAKMP path).
*
* Revision 1.38  2004/03/18 01:59:09  tony
* add PPTP Client ALG test module.
*
* Revision 1.37  2004/03/17 06:21:49  yjlou
* +: NaptPortRangeBug()
*
* Revision 1.36  2004/03/16 15:11:46  chenyl
* +: new testing cases for IP-Unnumbered -> DMZ Host port bouncing
* *: fix default mac bug (default mac is set to multicast mac addr)
*
* Revision 1.35  2004/03/16 12:58:16  tony
* add NetMeeting Server ALG test module.
*
* Revision 1.34  2004/03/16 09:21:24  tony
* add NetMeeting Client ALG test module.
*
* Revision 1.33  2004/03/16 07:52:12  tony
* add L2TP Client ALG test module.
*
* Revision 1.32  2004/03/16 03:51:19  tony
* add CUseeMe Client ALG test module.
*
* Revision 1.31  2004/03/15 13:23:52  chenyl
* +: new testing cases for fragment packet
*
* Revision 1.30  2004/03/15 13:03:34  tony
* add Counter-Strike client ALG test module.
*
* Revision 1.29  2004/03/15 12:48:07  tony
* add Battlenet ALG test module.
*
* Revision 1.28  2004/03/15 12:08:03  tony
* add Quake Client ALG test module.
*
* Revision 1.27  2004/03/15 11:32:38  tony
* add VDOlive Client ALG test module.
* add RealAudio Client ALG test module.
*
* Revision 1.26  2004/03/15 10:03:14  tony
* add SIP Server ALG test module.
*
* Revision 1.25  2004/03/15 09:09:41  tony
* add SIP Client ALG test module.
*
* Revision 1.24  2004/03/12 01:42:03  chenyl
* +: new testing cases for ICMP TIMEXCEED reply
* *: eliminate error packet's L3/4 checksum in mbuf-compare function
*
* Revision 1.23  2004/03/09 05:16:41  chenyl
* *: new testing cases
*
* Revision 1.22  2004/03/08 10:45:59  chenyl
* +: rtl8651_fwdEngineIcmpToDMZHost()
* 	set if fwdeng need to forward ICMP echo/tstamp request to DMZ host or not
*
* Revision 1.21  2004/03/08 05:34:40  tony
* add DirectX7 Server ALG test module.
*
* Revision 1.20  2004/03/08 02:46:19  tony
* add DirectX 7 Client ALG test module.
*
* Revision 1.19  2004/03/05 08:16:17  chenyl
* +: new cases dip = multicast ip, dmac = gw mac
* *: modify policy route config, only 2 session allowed
*
* Revision 1.18  2004/03/05 02:57:23  tony
* add ICUII ALG test module.
*
* Revision 1.17  2004/03/05 01:54:49  chhuang
* modify dump_l3
*
* Revision 1.16  2004/03/04 10:30:37  tony
* add ICQ ALG test module.(support version 2000b~2003a)
*
* Revision 1.15  2004/03/04 06:45:51  chhuang
* add new testing code for large IP class
*
* Revision 1.14  2004/03/04 02:35:07  chenyl
* *: testing cases
*
* Revision 1.13  2004/03/03 09:17:00  tony
* add Yahoo Messenger ALG test module.
*
* Revision 1.12  2004/03/03 06:22:55  tony
* add IRC ALG test module.
*
* Revision 1.11  2004/03/03 03:31:02  chenyl
* *: testing cases for fwdeng
* *: reinit fwdeng and mbuf system
*
* Revision 1.10  2004/03/02 12:08:12  tony
* add ALG Server test module.
*
* Revision 1.9  2004/03/02 08:20:46  tony
* add ALG Client test module
*
*
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "assert.h"
#include "types.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblDrv.h"
#include "drvTest.h"
#include "tblTest.h"
#include "naptTest.h"
#include "fwdTest.h"

rtl8651_tblDrvInitPara_t configPara;
	
/*=======================================
  * ASIC Table Comparation
  *=======================================*/
#define ASIC_TABLE_COMPARATION

int32 mcast_entry_cmp(rtl865x_tblAsicDrv_multiCastParam_t *entry1, rtl865x_tblAsicDrv_multiCastParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_IP("sip:", entry1->sip, entry2->sip, _fun_, _line_);
	IS_EQUAL_IP("dip:", entry1->dip, entry2->dip, _fun_, _line_);
	IS_EQUAL_INT("svid:", entry1->svid, entry2->svid, _fun_, _line_);
	IS_EQUAL_INT("sport:", entry1->port, entry2->port, _fun_, _line_);
	IS_EQUAL_INT("mbr:", entry1->mbr, entry2->mbr, _fun_, _line_);
	IS_EQUAL_INT("cpu:", entry1->cpu, entry2->cpu, _fun_, _line_);
	IS_EQUAL_INT("age:", entry1->age, entry2->age, _fun_, _line_);
	IS_EQUAL_INT("extIdx:", entry1->extIdx, entry2->extIdx, _fun_, _line_);
	return SUCCESS;
}


int32 l2_entry_cmp(rtl865x_tblAsicDrv_l2Param_t *entry1, rtl865x_tblAsicDrv_l2Param_t *entry2, int8 *_fun_, uint32 _line_)
{
	uint32 age;
	IS_EQUAL_MAC("mac", entry1->macAddr, entry2->macAddr, _fun_, _line_);
	IS_EQUAL_BOOL("cpu", entry1->cpu, entry2->cpu, _fun_, _line_);
	IS_EQUAL_BOOL("static", entry1->isStatic, entry2->isStatic, _fun_, _line_);
	IS_EQUAL_BOOL("srcBlk", entry1->srcBlk, entry2->srcBlk, _fun_, _line_);
	IS_EQUAL_BOOL("nhFlag", entry1->nhFlag, entry2->nhFlag, _fun_, _line_);
	IS_EQUAL_INT("memberPortMask", entry1->memberPortMask, entry2->memberPortMask, _fun_, _line_);
	/* specially handle */
	age = (entry1->ageSec>200)? 0x02: (entry1->ageSec<=200 && entry1->ageSec>100)? 0x03: (entry1->ageSec<=100 && entry1->ageSec>0)? 0x01: 0x00;
	IS_EQUAL_INT("ageSec", age*100, entry2->ageSec, _fun_, _line_);
	return SUCCESS;
}

int32 vlan_entry_cmp(rtl865x_tblAsicDrv_vlanParam_t *entry1, rtl865x_tblAsicDrv_vlanParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	int32 i;
	IS_EQUAL_MAC("mac", entry1->macAddr, entry2->macAddr, _fun_, _line_);
	IS_EQUAL_INT("memberPortMask", entry1->memberPortMask, entry2->memberPortMask, _fun_, _line_);
	IS_EQUAL_INT("untagPortMask", entry1->untagPortMask, entry2->untagPortMask, _fun_, _line_);
	IS_EQUAL_INT("macAddrNumber", entry1->macAddrNumber, entry2->macAddrNumber, _fun_, _line_);
	IS_EQUAL_INT("vid", entry1->vid, entry2->vid, _fun_, _line_);
	IS_EQUAL_INT("inAclStart", entry1->inAclStart, entry2->inAclStart, _fun_, _line_);
	IS_EQUAL_INT("inAclEnd", entry1->inAclEnd, entry2->inAclEnd, _fun_, _line_);
	IS_EQUAL_INT("outAclStart", entry1->outAclStart, entry2->outAclStart, _fun_, _line_);
	IS_EQUAL_INT("outAclEnd", entry1->outAclEnd, entry2->outAclEnd, _fun_, _line_);
	IS_EQUAL_INT("mtu", entry1->mtu, entry2->mtu, _fun_, _line_);
	IS_EQUAL_BOOL("internal", entry1->internal, entry2->internal, _fun_, _line_);
	IS_EQUAL_BOOL("enableRoute", entry1->enableRoute, entry2->enableRoute, _fun_, _line_);
	IS_EQUAL_BOOL("broadcastToCpu", entry1->broadcastToCpu, entry2->broadcastToCpu, _fun_, _line_);
	IS_EQUAL_BOOL("promiscuous", entry1->promiscuous, entry2->promiscuous, _fun_, _line_);
#ifdef RTL8650B
	IS_EQUAL_BOOL("DMZFlag", entry1->DMZFlag, entry2->DMZFlag, _fun_, _line_);
	IS_EQUAL_BOOL("macNotExist", entry1->macNotExist, entry2->macNotExist, _fun_, _line_);
#endif /* RTL8650B */
	IS_EQUAL_BOOL("valid", entry1->valid, entry2->valid, _fun_, _line_);
#ifdef RTL8650B
	for(i=0; i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; i++) {
		if (entry1->portState[i] != entry2->portState[i]) {
			printf("\t%s(%u): portState: port%d:%d, port%d:%d\n", _fun_, _line_, i, entry1->portState[i], i, entry2->portState[i]);
			return FAILED;
		} 
	}
#else
	for(i=0; i<RTL8651_PORT_NUMBER; i++) {
		if (entry1->portState[i] != entry2->portState[i]) {
			printf("\t%s(%u): portState: port%d:%d, port%d:%d\n", _fun_, _line_, i, entry1->portState[i], i, entry2->portState[i]);
			return FAILED;
		} 
	}
#endif
	return SUCCESS;
}

int32 l3_entry_cmp(rtl865x_tblAsicDrv_routingParam_t *entry1, rtl865x_tblAsicDrv_routingParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_IP("ipAddr", entry1->ipAddr, entry2->ipAddr, _fun_, _line_);
	if (entry1->ipAddr) /* If default route, msak is meaningless */
	IS_EQUAL_IP("ipMask", entry1->ipMask, entry2->ipMask, _fun_, _line_);
	IS_EQUAL_INT("process", entry1->process, entry2->process, _fun_, _line_);
	switch(entry1->process) 
	{
	case 0x00: /* PPPoE */
		IS_EQUAL_INT("pppoeIdx", entry1->pppoeIdx, entry2->pppoeIdx, _fun_, _line_);
		IS_EQUAL_INT("vidx", entry1->vidx, entry2->vidx, _fun_, _line_);
		IS_EQUAL_INT("nextHopRow", entry1->nextHopRow, entry2->nextHopRow, _fun_, _line_);
		IS_EQUAL_INT("nextHopColumn", entry1->nextHopColumn, entry2->nextHopColumn, _fun_, _line_);
		break;		
		
	case 0x01: /* L2 */
		IS_EQUAL_INT("nextHopRow", entry1->nextHopRow, entry2->nextHopRow, _fun_, _line_);
		IS_EQUAL_INT("nextHopColumn", entry1->nextHopColumn, entry2->nextHopColumn, _fun_, _line_);
		IS_EQUAL_INT("vidx", entry1->vidx, entry2->vidx, _fun_, _line_);
		break;
		
	case 0x02: /* ARP */
		IS_EQUAL_INT("vidx", entry1->vidx, entry2->vidx, _fun_, _line_);
		IS_EQUAL_INT("arpStart", entry1->arpStart, entry2->arpStart, _fun_, _line_);
		IS_EQUAL_INT("arpEnd", entry1->arpEnd, entry2->arpEnd, _fun_, _line_);
		break;

	case 0x04: /* CPU */
		break;

	case 0x05: /* NAPT Next Hop */
		IS_EQUAL_INT("nhStart", entry1->nhStart, entry2->nhStart, _fun_, _line_);
		IS_EQUAL_INT("nhNum", entry1->nhNum, entry2->nhNum, _fun_, _line_);
		IS_EQUAL_INT("nhNxt", entry1->nhNxt, entry2->nhNxt, _fun_, _line_);
		IS_EQUAL_INT("nhAlgo", entry1->nhAlgo, entry2->nhAlgo, _fun_, _line_);
		IS_EQUAL_INT("ipDomain", entry1->ipDomain, entry2->ipDomain, _fun_, _line_);
		break;
	
	case 0x06: /* Drop */
		break;
		
	default:
		printf("\t%s(%u): Unknown PROCESS type!!\n", _fun_, _line_);
		return FAILED;	
	}
	return SUCCESS;
}

int32 ip_entry_cmp(rtl865x_tblAsicDrv_extIntIpParam_t *entry1, rtl865x_tblAsicDrv_extIntIpParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_IP("extIpAddr", entry1->extIpAddr, entry2->extIpAddr, _fun_, _line_);
	IS_EQUAL_IP("intIpAddr", entry1->intIpAddr, entry2->intIpAddr, _fun_, _line_);
	IS_EQUAL_INT("nhIndex", entry1->nhIndex, entry2->nhIndex, _fun_, _line_);
	IS_EQUAL_BOOL("localPublic", entry1->localPublic, entry2->localPublic, _fun_, _line_);
	IS_EQUAL_BOOL("nat", entry1->nat, entry2->nat, _fun_, _line_);
	return SUCCESS;
}

int32 sp_entry_cmp(rtl865x_tblAsicDrv_serverPortParam_t *entry1, rtl865x_tblAsicDrv_serverPortParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_IP("extIpAddr", entry1->extIpAddr, entry2->extIpAddr, _fun_, _line_);
	IS_EQUAL_IP("intIpAddr", entry1->intIpAddr, entry2->intIpAddr, _fun_, _line_);
	IS_EQUAL_INT("extPort", entry1->extPort, entry2->extPort, _fun_, _line_);
	IS_EQUAL_INT("intPort", entry1->intPort, entry2->intPort, _fun_, _line_);
#ifdef RTL8650B
	IS_EQUAL_INT("nhIndex", entry1->nhIndex, entry2->nhIndex, _fun_, _line_);
	IS_EQUAL_BOOL("portRange", entry1->portRange, entry2->portRange, _fun_, _line_);
#endif /* RTL8650B */
	return SUCCESS;
}

int32 pppoe_entry_cmp(rtl865x_tblAsicDrv_pppoeParam_t *entry1, rtl865x_tblAsicDrv_pppoeParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_INT("sessionId", entry1->sessionId, entry2->sessionId, _fun_, _line_);
	return SUCCESS;
}

int32 nxthop_entry_cmp(rtl865x_tblAsicDrv_nextHopParam_t *entry1, rtl865x_tblAsicDrv_nextHopParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_INT("nextHopRow", entry1->nextHopRow, entry2->nextHopRow, _fun_, _line_);
	IS_EQUAL_INT("nextHopColumn", entry1->nextHopColumn, entry2->nextHopColumn, _fun_, _line_);
	IS_EQUAL_INT("pppoeIdx", entry1->pppoeIdx, entry2->pppoeIdx, _fun_, _line_);
	IS_EQUAL_INT("dvid", entry1->dvid, entry2->dvid, _fun_, _line_);
	IS_EQUAL_INT("extIntIpIdx", entry1->extIntIpIdx, entry2->extIntIpIdx, _fun_, _line_);
	IS_EQUAL_BOOL("isPppoe", entry1->isPppoe, entry2->isPppoe, _fun_, _line_);
	return SUCCESS;
}

int32 arp_entry_cmp(rtl865x_tblAsicDrv_arpParam_t *entry1, rtl865x_tblAsicDrv_arpParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_INT("nextHopRow", entry1->nextHopRow, entry2->nextHopRow, _fun_, _line_);
	IS_EQUAL_INT("nextHopColumn", entry1->nextHopColumn, entry2->nextHopColumn, _fun_, _line_);
	return SUCCESS;
}

int32 tcpudp_entry_cmp(rtl865x_tblAsicDrv_naptTcpUdpParam_t *entry1, rtl865x_tblAsicDrv_naptTcpUdpParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_IP("insideLocalIpAddr", entry1->insideLocalIpAddr, entry2->insideLocalIpAddr, _fun_, _line_);
	IS_EQUAL_INT("insideLocalPort", entry1->insideLocalPort, entry2->insideLocalPort, _fun_, _line_);
	IS_EQUAL_INT("tcpFlag", entry1->tcpFlag, entry2->tcpFlag, _fun_, _line_);
	IS_EQUAL_INT("offset", entry1->offset, entry2->offset, _fun_, _line_);
	IS_EQUAL_INT("selExtIPIdx", entry1->selExtIPIdx, entry2->selExtIPIdx, _fun_, _line_);
	IS_EQUAL_INT("selEIdx", entry1->selEIdx, entry2->selEIdx, _fun_, _line_);
	IS_EQUAL_BOOL("isTcp", entry1->isTcp, entry2->isTcp, _fun_, _line_);
	IS_EQUAL_BOOL("isCollision", entry1->isCollision, entry2->isCollision, _fun_, _line_);
	IS_EQUAL_BOOL("isCollision2", entry1->isCollision2, entry2->isCollision2, _fun_, _line_);
	IS_EQUAL_BOOL("isStatic", entry1->isStatic, entry2->isStatic, _fun_, _line_);
	IS_EQUAL_BOOL("isValid", entry1->isValid, entry2->isValid, _fun_, _line_);
	IS_EQUAL_BOOL("isDedicated", entry1->isDedicated, entry2->isDedicated, _fun_, _line_);
	IS_EQUAL_INT("ageSec",
				_rtl8651_NaptAgingToSec(_rtl8651_NaptAgingToUnit(entry1->ageSec)),
				entry2->ageSec, _fun_, _line_
	);
	return SUCCESS;
}

int32 icmp_entry_cmp(rtl865x_tblAsicDrv_naptIcmpParam_t *entry1, rtl865x_tblAsicDrv_naptIcmpParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_IP("insideLocalIpAddr", entry1->insideLocalIpAddr, entry2->insideLocalIpAddr, _fun_, _line_);
	IS_EQUAL_INT("insideLocalId", entry1->insideLocalId, entry2->insideLocalId, _fun_, _line_);
	IS_EQUAL_INT("offset", entry1->offset, entry2->offset, _fun_, _line_);
#ifdef RTL8650B
	IS_EQUAL_BOOL("isSpi", entry1->isSpi, entry2->isSpi, _fun_, _line_);
	IS_EQUAL_BOOL("isPptp", entry1->isPptp, entry2->isPptp, _fun_, _line_);
#endif /* RTL8650B */
	IS_EQUAL_BOOL("isCollision", entry1->isCollision, entry2->isCollision, _fun_, _line_);
	IS_EQUAL_BOOL("isStatic", entry1->isStatic, entry2->isStatic, _fun_, _line_);
	IS_EQUAL_INT("ageSec",
				_rtl8651_NaptAgingToSec(_rtl8651_NaptAgingToUnit(entry1->ageSec)),
				entry2->ageSec, _fun_, _line_
	);
	return SUCCESS;
}

int32 alg_entry_cmp(rtl865x_tblAsicDrv_algParam_t *entry1, rtl865x_tblAsicDrv_algParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_INT("port", entry1->port, entry2->port, _fun_, _line_);
	return SUCCESS;
}

int32 acl_entry_cmp(_rtl8651_tblDrvAclRule_t *entry1, _rtl8651_tblDrvAclRule_t *entry2, int8 *_fun_, uint32 _line_)
{
	switch(entry1->ruleType_)
	{
	case RTL8651_ACL_MAC:
		IS_EQUAL_MAC("dstMac_", entry1->dstMac_, entry2->dstMac_, _fun_, _line_);
		IS_EQUAL_MAC("dstMacMask_", entry1->dstMacMask_, entry2->dstMacMask_, _fun_, _line_);
		IS_EQUAL_MAC("srcMac_", entry1->srcMac_, entry2->srcMac_, _fun_, _line_);
		IS_EQUAL_MAC("srcMacMask_", entry1->srcMacMask_, entry2->srcMacMask_, _fun_, _line_);
		IS_EQUAL_INT("typeLen_", entry1->typeLen_, entry2->typeLen_, _fun_, _line_);
		IS_EQUAL_INT("typeLenMask_", entry1->typeLenMask_, entry2->typeLenMask_, _fun_, _line_);
		break;
		
	case RTL8651_ACL_IFSEL:
		break;

	case RTL8651_ACL_IP:
		IS_EQUAL_INT("ipProto_", entry1->ipProto_, entry2->ipProto_, _fun_, _line_);
		IS_EQUAL_INT("ipProtoMask_", entry1->ipProtoMask_, entry2->ipProtoMask_, _fun_, _line_);
		IS_EQUAL_INT("ipFlagMask_", entry1->ipFlagMask_, entry2->ipFlagMask_, _fun_, _line_);
		IS_EQUAL_INT("ipFlag_", entry1->ipFlag_, entry2->ipFlag_, _fun_, _line_);
		IS_EQUAL_BOOL("ipFOP_", entry1->ipFOP_, entry2->ipFOP_, _fun_, _line_);
		IS_EQUAL_BOOL("ipFOM_", entry1->ipFOM_, entry2->ipFOM_, _fun_, _line_);
		IS_EQUAL_BOOL("ipHttpFilter_", entry1->ipHttpFilter_, entry2->ipHttpFilter_, _fun_, _line_);
		IS_EQUAL_BOOL("ipHttpFilterM_", entry1->ipHttpFilterM_, entry2->ipHttpFilterM_, _fun_, _line_);
		IS_EQUAL_BOOL("ipIdentSrcDstIp_", entry1->ipIdentSrcDstIp_, entry2->ipIdentSrcDstIp_, _fun_, _line_);
		IS_EQUAL_BOOL("ipIdentSrcDstIpM_", entry1->ipIdentSrcDstIpM_, entry2->ipIdentSrcDstIpM_, _fun_, _line_);
		goto shared;
		
	case RTL8651_ACL_ICMP:
		IS_EQUAL_INT("icmpType_", entry1->icmpType_, entry2->icmpType_, _fun_, _line_);
		IS_EQUAL_INT("icmpTypeMask_", entry1->icmpTypeMask_, entry2->icmpTypeMask_, _fun_, _line_);
		IS_EQUAL_INT("icmpCode_", entry1->icmpCode_, entry2->icmpCode_, _fun_, _line_);
		IS_EQUAL_INT("icmpCodeMask_", entry1->icmpCodeMask_, entry2->icmpCodeMask_, _fun_, _line_);
		goto shared;

	case RTL8651_ACL_IGMP:
		IS_EQUAL_INT("igmpType_", entry1->igmpType_, entry2->igmpType_, _fun_, _line_);
		IS_EQUAL_INT("igmpTypeMask_", entry1->igmpTypeMask_, entry2->igmpTypeMask_, _fun_, _line_);
		goto shared;

	case RTL8651_ACL_TCP:
		IS_EQUAL_INT("tcpSrcPortUB_", entry1->tcpSrcPortUB_, entry2->tcpSrcPortUB_, _fun_, _line_);
		IS_EQUAL_INT("tcpSrcPortLB_", entry1->tcpSrcPortLB_, entry2->tcpSrcPortLB_, _fun_, _line_);
		IS_EQUAL_INT("tcpDstPortUB_", entry1->tcpDstPortUB_, entry2->tcpDstPortUB_, _fun_, _line_);
		IS_EQUAL_INT("tcpDstPortLB_", entry1->tcpDstPortLB_, entry2->tcpDstPortLB_, _fun_, _line_);
		IS_EQUAL_INT("tcpFlagMask_", entry1->tcpFlagMask_, entry2->tcpFlagMask_, _fun_, _line_);
		IS_EQUAL_INT("tcpFlag_", entry1->tcpFlag_, entry2->tcpFlag_, _fun_, _line_);
		goto shared;

	case RTL8651_ACL_UDP:
		IS_EQUAL_INT("udpSrcPortUB_", entry1->udpSrcPortUB_, entry2->udpSrcPortUB_, _fun_, _line_);
		IS_EQUAL_INT("udpSrcPortLB_", entry1->udpSrcPortLB_, entry2->udpSrcPortLB_, _fun_, _line_);
		IS_EQUAL_INT("udpDstPortUB_", entry1->udpDstPortUB_, entry2->udpDstPortUB_, _fun_, _line_);
		IS_EQUAL_INT("udpDstPortLB_", entry1->udpDstPortLB_, entry2->udpDstPortLB_, _fun_, _line_);
		
shared:
		IS_EQUAL_IP("srcIpAddr_", entry1->srcIpAddr_, entry2->srcIpAddr_, _fun_, _line_);
		IS_EQUAL_IP("srcIpAddrMask_", entry1->srcIpAddrMask_, entry2->srcIpAddrMask_, _fun_, _line_);
		IS_EQUAL_IP("dstIpAddr_", entry1->dstIpAddr_, entry2->dstIpAddr_, _fun_, _line_);
		IS_EQUAL_IP("dstIpAddrMask_", entry1->dstIpAddrMask_, entry2->dstIpAddrMask_, _fun_, _line_);
		IS_EQUAL_INT("tos_", entry1->tos_, entry2->tos_, _fun_, _line_);
		IS_EQUAL_INT("tosMask_", entry1->tosMask_, entry2->tosMask_, _fun_, _line_);
		break;

	case RTL8651_ACL_SRCFILTER:
		IS_EQUAL_MAC("srcFilterMac_", entry1->srcFilterMac_, entry2->srcFilterMac_, _fun_, _line_);
		IS_EQUAL_MAC("srcFilterMacMask_", entry1->srcFilterMacMask_, entry2->srcFilterMacMask_, _fun_, _line_);
		IS_EQUAL_INT("srcFilterPort_", entry1->srcFilterPort_, entry2->srcFilterPort_, _fun_, _line_);
		IS_EQUAL_INT("srcFilterPortMask_", entry2->srcFilterPortMask_, entry2->srcFilterPortMask_, _fun_, _line_);
		IS_EQUAL_INT("srcFilterVlanIdx_", entry1->srcFilterVlanIdx_, entry2->srcFilterVlanIdx_, _fun_, _line_);
		IS_EQUAL_INT("srcFilterVlanIdxMask_", entry1->srcFilterVlanIdxMask_, entry2->srcFilterVlanIdxMask_, _fun_, _line_);
		IS_EQUAL_IP("srcFilterIpAddr_", entry1->srcFilterIpAddr_, entry2->srcFilterIpAddr_, _fun_, _line_);
		IS_EQUAL_IP("srcFilterIpAddrMask_", entry1->srcFilterIpAddrMask_, entry2->srcFilterIpAddrMask_, _fun_, _line_);
		IS_EQUAL_INT("srcFilterPortUpperBound_", entry1->srcFilterPortUpperBound_, entry2->srcFilterPortUpperBound_, _fun_, _line_);
		IS_EQUAL_INT("srcFilterPortLowerBound_", entry1->srcFilterPortLowerBound_, entry2->srcFilterPortLowerBound_, _fun_, _line_);
		IS_EQUAL_BOOL("srcFilterIgnoreL3L4_", entry1->srcFilterIgnoreL3L4_, entry2->srcFilterIgnoreL3L4_, _fun_, _line_);
		IS_EQUAL_BOOL("srcFilterIgnoreL4_", entry1->srcFilterIgnoreL4_, entry2->srcFilterIgnoreL4_, _fun_, _line_);
		break;
		
	case RTL8651_ACL_DSTFILTER:
		IS_EQUAL_MAC("dstFilterMac_", entry1->dstFilterMac_, entry2->dstFilterMac_, _fun_, _line_);
		IS_EQUAL_MAC("dstFilterMacMask_", entry1->dstFilterMacMask_, entry2->dstFilterMacMask_, _fun_, _line_);
		IS_EQUAL_INT("dstFilterVlanIdx_", entry1->dstFilterVlanIdx_, entry2->dstFilterVlanIdx_, _fun_, _line_);
		IS_EQUAL_INT("dstFilterVlanIdxMask_", entry1->dstFilterVlanIdxMask_, entry2->dstFilterVlanIdxMask_, _fun_, _line_);
		IS_EQUAL_IP("dstFilterIpAddr_", entry1->dstFilterIpAddr_, entry2->dstFilterIpAddr_, _fun_, _line_);
		IS_EQUAL_IP("dstFilterIpAddrMask_v", entry1->dstFilterIpAddrMask_, entry2->dstFilterIpAddrMask_, _fun_, _line_);
		IS_EQUAL_INT("dstFilterPortUpperBound_", entry1->dstFilterPortUpperBound_, entry2->dstFilterPortUpperBound_, _fun_, _line_);
		IS_EQUAL_INT("dstFilterPortLowerBound_", entry1->dstFilterPortLowerBound_, entry2->dstFilterPortLowerBound_, _fun_, _line_);
		IS_EQUAL_BOOL("dstFilterIgnoreL3L4_", entry1->dstFilterIgnoreL3L4_, entry2->dstFilterIgnoreL3L4_, _fun_, _line_);
		IS_EQUAL_BOOL("dstFilterIgnoreL4_", entry1->dstFilterIgnoreL4_, entry2->dstFilterIgnoreL4_, _fun_, _line_);
		break;
		
	default: 
		printf("\t%s(%u): Unknown acl rule type!!\n", _fun_, _line_);
		return FAILED;		
	}
	IS_EQUAL_INT("actionType_", entry1->actionType_, entry2->actionType_, _fun_, _line_);


	switch(entry1->actionType_)
	{


	case RTL8651_ACL_PERMIT: /* 0x00 */
	case RTL8651_ACL_REDIRECT: /* 0x01 */
	case RTL8651_ACL_CPU: /* 0x03 */
	case RTL8651_ACL_DROP: /* 0x02, 0x04 */
	case RTL8651_ACL_DROP_LOG: /* 0x05 */
	case RTL8651_ACL_MIRROR: /* 0x06 */
	case RTL8651_ACL_REDIRECT_PPPOE: /* 0x07 */
	case RTL8651_ACL_MIRROR_KEEP_MATCH: /* 0x09 */
		IS_EQUAL_INT("nextHop_", entry1->nextHop_, entry2->nextHop_, _fun_, _line_);
		IS_EQUAL_INT("dvid_", entry1->dvid_, entry2->dvid_, _fun_, _line_);
		IS_EQUAL_BOOL("priority_", entry1->priority_, entry2->priority_, _fun_, _line_);
		IS_EQUAL_INT("pppoeIdx_", entry1->pppoeIdx_, entry2->pppoeIdx_, _fun_, _line_);
		break;
			
	case RTL8651_ACL_POLICY: /* 0x08 */
		IS_EQUAL_INT("nhIndex", entry1->nhIndex, entry2->nhIndex, _fun_, _line_);
		IS_EQUAL_INT("priority_", entry1->priority_, entry2->priority_, _fun_, _line_);
		break;

	case RTL8651_ACL_DROP_RATE_EXCEED_PPS: /* 0x0a */
	case RTL8651_ACL_LOG_RATE_EXCEED_PPS: /* 0x0b */
	case RTL8651_ACL_DROP_RATE_EXCEED_BPS: /* 0x0c */
	case RTL8651_ACL_LOG_RATE_EXCEED_BPS: /* 0x0d */
		IS_EQUAL_INT("rlIndex", entry1->rlIndex, entry2->rlIndex, _fun_, _line_);
		break;

	default:
		printf("\t%s(%u): Unknown acl action type!!\n", _fun_, _line_);
		return FAILED;	
	}
	IS_EQUAL_INT("pktOpApp", entry1->pktOpApp, entry2->pktOpApp, _fun_, _line_);
	return SUCCESS;
}


	


int32 ratelimit_entry_cmp(rtl865x_tblAsicDrv_rateLimitParam_t *entry1, rtl865x_tblAsicDrv_rateLimitParam_t *entry2, int8 *_fun_, uint32 _line_)
{
	IS_EQUAL_INT("Token: ", entry1->token, entry2->token, _fun_, _line_);
	IS_EQUAL_INT("Time Remain: ", entry1->t_remainUnit, entry2->t_remainUnit, _fun_, _line_);
	IS_EQUAL_INT("Max Token: ", entry1->maxToken, entry2->maxToken, _fun_, _line_);
	IS_EQUAL_INT("Refill Time: ", entry1->t_intervalUnit, entry2->t_intervalUnit, _fun_, _line_);
	IS_EQUAL_INT("Refill Token: ", entry1->refill_number, entry2->refill_number, _fun_, _line_);
	return SUCCESS;
}



int32 acl_default_tocpu(uint32 index, int8 *_fun_, uint32 _line_)
{
	_rtl8651_tblDrvAclRule_t asic_acl_1, asic_acl_2;
	
	bzero(&asic_acl_1, sizeof(_rtl8651_tblDrvAclRule_t));
	bzero(&asic_acl_2, sizeof(_rtl8651_tblDrvAclRule_t));
	asic_acl_1.actionType_	= RTL8651_ACL_CPU;
	asic_acl_1.dvid_		= 0;
	asic_acl_1.nextHop_	= 0;
#ifdef RTL8650B
	asic_acl_1.nhIndex		= 0;
#endif /* RTL8650B */
	asic_acl_1.pppoeIdx_	= 0;
	asic_acl_1.priority_		= 0;
	asic_acl_1.ruleType_	= RTL8651_ACL_MAC;
	asic_acl_1.typeLen_	= 0;
	asic_acl_1.typeLenMask_= 0;
	if (rtl8651_getAsicAclRule(0, &asic_acl_2) != SUCCESS) {
		printf("\t%s(%u): Fail!\n", _fun_, _line_); 
		return FAILED;
	}
	if (acl_entry_cmp(&asic_acl_1, &asic_acl_2, _fun_, _line_)==FAILED) 
		return FAILED;
	return SUCCESS;
}

int32 acl_default_drop(uint32 index, int8 *_fun_, uint32 _line_)
{
	_rtl8651_tblDrvAclRule_t asic_acl_1, asic_acl_2;
	
	bzero(&asic_acl_1, sizeof(_rtl8651_tblDrvAclRule_t));
	bzero(&asic_acl_2, sizeof(_rtl8651_tblDrvAclRule_t));
	asic_acl_1.actionType_	= RTL8651_ACL_DROP;
	asic_acl_1.dvid_		= 0;
	asic_acl_1.nextHop_	= 0;
#ifdef RTL8650B
	asic_acl_1.nhIndex		= 0;
#endif /* RTL8650B */
	asic_acl_1.pppoeIdx_	= 0;
	asic_acl_1.priority_		= 0;
	asic_acl_1.ruleType_	= RTL8651_ACL_MAC;
	asic_acl_1.typeLen_	= 0;
	asic_acl_1.typeLenMask_= 0;
	if (rtl8651_getAsicAclRule(0, &asic_acl_2) != SUCCESS) {
		printf("\t%s(%u): Fail!\n", _fun_, _line_); 
		return FAILED;
	}
	if (acl_entry_cmp(&asic_acl_1, &asic_acl_2, _fun_, _line_)==FAILED) 
		return FAILED;
	return SUCCESS;

}

int32 acl_default_permit(uint32 index, int8 *_fun_, uint32 _line_)
{
	_rtl8651_tblDrvAclRule_t asic_acl_1, asic_acl_2;
	
	bzero(&asic_acl_1, sizeof(_rtl8651_tblDrvAclRule_t));
	bzero(&asic_acl_2, sizeof(_rtl8651_tblDrvAclRule_t));
	asic_acl_1.actionType_	= RTL8651_ACL_PERMIT;
	asic_acl_1.dvid_		= 0;
	asic_acl_1.nextHop_	= 0;
#ifdef RTL8650B
	asic_acl_1.nhIndex		= 0;
#endif /* RTL8650B */
	asic_acl_1.pppoeIdx_	= 0;
	asic_acl_1.priority_		= 0;
	asic_acl_1.ruleType_	= RTL8651_ACL_MAC;
	asic_acl_1.typeLen_	= 0;
	asic_acl_1.typeLenMask_= 0;
	if (rtl8651_getAsicAclRule(index, &asic_acl_2) != SUCCESS) {
		printf("\t%s(%u): Fail!\n", _fun_, _line_); 
		return FAILED;
	}
	if (acl_entry_cmp(&asic_acl_1, &asic_acl_2, _fun_, _line_)==FAILED) 
		return FAILED;
	return SUCCESS;

}







/*
  * Data Structure for Testing Case:
  *
  */

typedef struct emuCase_s {
	uint32 caseID;			/* Testing Case ID */
	uint32 groupID;		/* Group ID */
	int32 (*fun_t)(uint32);	/* Function pointer to Testing Case */
} emuCase_t;

typedef struct runCase_group_s {
	int8	  *name;
	uint32 groupID;
} runCase_group_t;

/* Constant Definition for Group ID */
#define GROUP_ASIC_INTERFACE			0x00000001
#define GROUP_TBL_L2					0x00000002
#define GROUP_TBL_ARP					0x00000004
#define GROUP_TBL_L3					0x00000008
#define GROUP_TBL_TCPUDP				0x00000010
#define GROUP_TBL_ICMP				0x00000020
#define GROUP_TBL_IP					0x00000040
#define GROUP_TBL_SERVPORT			0x00000080
#define GROUP_TBL_VLAN				0x00000100
#define GROUP_TBL_ALG					0x00000200
#define GROUP_TBL_ACL					0x00000400
#define GROUP_TBL_PROTOTRAP			0x00000800
#define GROUP_TBL_PPPOE				0x00001000
#define GROUP_TBL_NEXTHOP			0x00002000
#define GROUP_TBL_RATELIMIT			0x00004000
#define GROUP_FWDENGINE				0x00008000
#define GROUP_URLFILTER				0x00010000
#define GROUP_DMZHOST				0x00020000
#define GROUP_IP_INTERFACE			0x00040000
#define GROUP_ALG					0x00080000
#define GROUP_LARGE_IPCLASS			0x00100000
#define GROUP_QOS					0x00200000
#define GROUP_POLICYROUTE			0x00400000
#define GROUP_PPTP					0x00800000
#define GROUP_L2TP					0x01000000
#define GROUP_PPPOE_PASSTHRU		0x02000000
#define GROUP_IPV6_PASSTHRU			0x04000000
#define GROUP_TBL_MCAST				0x08000000
#define GROUP_MISC					0x40000000
#define GROUP_ALL						0x80000000


static emuCase_t emuCase_array[] =
{
	/* Test L2 Table Case ID:            	1 - 100 */
	{ 1, GROUP_TBL_L2|GROUP_ALL, l2_test1 },
	{ 2, GROUP_TBL_L2|GROUP_ALL, l2_test2 },
	

	/* Test ARP Table Case ID:		101 -  200 */
	{ 101, GROUP_TBL_ARP|GROUP_ALL,	arp_test1	},
	{ 102, GROUP_TBL_ARP|GROUP_ALL,	arp_test2	},
	{ 103, GROUP_TBL_ARP|GROUP_ALL,	arp_test3	},
	{ 104, GROUP_TBL_ARP|GROUP_ALL,	arp_test4	},
	{ 105, GROUP_TBL_ARP|GROUP_ALL,	arp_test5	},
	{ 106, GROUP_TBL_ARP|GROUP_ALL,	arp_test6	},
	{ 107, GROUP_TBL_ARP|GROUP_ALL,	arp_test7	},
	{ 108, GROUP_TBL_ARP|GROUP_ALL,	arp_test8	},




	

	/* Test L3 Table Case ID:		201 -  300 */
	{ 201, GROUP_TBL_L3|GROUP_ALL, 	l3_test1	},
	{ 202, GROUP_TBL_L3|GROUP_ALL, 	l3_test2	},
	{ 203, GROUP_TBL_L3|GROUP_ALL, 	l3_test3	},
	{ 204, GROUP_TBL_L3|GROUP_ALL, 	l3_test4	},
	{ 205, GROUP_TBL_L3|GROUP_ALL, 	l3_test5	},
	{ 206, GROUP_TBL_L3|GROUP_ALL, 	l3_test6	},
	{ 207, GROUP_TBL_L3|GROUP_ALL, 	l3_test7	},
	{ 208, GROUP_TBL_L3|GROUP_ALL, 	l3_test8	},
	{ 209, GROUP_TBL_L3|GROUP_ALL, 	l3_test9	},
	{ 210, GROUP_TBL_L3|GROUP_ALL, 	l3_test10	},
	{ 211, GROUP_TBL_L3|GROUP_ALL, 	l3_test11 },
	{ 212, GROUP_TBL_L3|GROUP_ALL, 	l3_test12 },
	{ 213, GROUP_TBL_L3|GROUP_ALL, 	l3_test13 },
	{ 214, GROUP_TBL_L3|GROUP_ALL, 	l3_test14 },
	{ 215, GROUP_TBL_L3|GROUP_ALL, 	l3_test15 },
	{ 216, GROUP_TBL_L3|GROUP_ALL, 	l3_test16 },
	{ 217, GROUP_TBL_L3|GROUP_ALL, 	l3_test17 },

	{ 220, GROUP_TBL_L3|GROUP_ALL, 	l3_test20 },
	{ 221, GROUP_TBL_L3|GROUP_ALL, 	l3_test21 },
	{ 222, GROUP_TBL_L3|GROUP_ALL, 	l3_test22 },
	{ 223, GROUP_TBL_L3|GROUP_ALL, 	l3_test23 },
	{ 224, GROUP_TBL_L3|GROUP_ALL, 	l3_test24 },
	{ 225, GROUP_TBL_L3|GROUP_ALL, 	l3_test25 },
	{ 226, GROUP_TBL_L3|GROUP_ALL, 	l3_test26 },
	{ 227, GROUP_TBL_L3|GROUP_ALL, 	l3_test27 },
	{ 228, GROUP_TBL_L3|GROUP_ALL, 	l3_test28 },
	{ 229, GROUP_TBL_L3|GROUP_ALL, 	l3_test29 },
	{ 230, GROUP_TBL_L3|GROUP_ALL, 	l3_test30 },
	{ 231, GROUP_TBL_L3|GROUP_ALL, 	l3_test31 },
	{ 232, GROUP_TBL_L3|GROUP_ALL, 	l3_test32 },
	{ 233, GROUP_TBL_L3|GROUP_ALL, 	l3_test33 },
	{ 234, GROUP_TBL_L3|GROUP_ALL, 	l3_test34 },
	{ 235, GROUP_TBL_L3|GROUP_ALL, 	l3_test35 },
	{ 236, GROUP_TBL_L3|GROUP_ALL,	l3_test36 },
	
	
	/* Test TCPUDP Table Case ID:    	301 -  400 */
#ifdef CONFIG_RTL865XB_EXP_HASH2
	{  399, GROUP_TBL_TCPUDP|GROUP_ALL, AddNaptConnectionErrors },
	{  351, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTypicalCase },
	{  352, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTypicalCaseButHash2Accelerated },
	{  353, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTypicalCaseButHalfAccelerated },
	{  354, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTypicalCaseWith4Way },
	{  355, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTestL04 },
	{  356, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTestL04UdpForCDRouter },
	{  357, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTest4096Connections },
	{  358, GROUP_TBL_TCPUDP|GROUP_ALL, NaptInterfaceRoute2 },
/*	{  359, GROUP_TBL_TCPUDP|GROUP_ALL, NaptInterfaceRoute }, */
	{  360, GROUP_TBL_TCPUDP|GROUP_ALL, testNapt4WayHash },
	{  361, GROUP_TBL_TCPUDP|GROUP_ALL, DMZHostUsingHash1 },
	{  362, GROUP_TBL_TCPUDP|GROUP_ALL, DMZHostUsingHash2 },
#ifdef LEGACY_AGING_CODE
#else/*LEGACY_AGING_CODE*/
	{  366, GROUP_TBL_TCPUDP|GROUP_ALL, testAgeOfHash2PortReused },
#endif/*LEGACY_AGING_CODE*/
	{  371, GROUP_TBL_TCPUDP|GROUP_ALL, Hash2BestCase },
	{  372, GROUP_TBL_TCPUDP|GROUP_ALL, Hash2WorstCase },
	{  381, GROUP_TBL_TCPUDP|GROUP_ALL, ServerPortUsingOneHash2Entry },
	{  382, GROUP_TBL_TCPUDP|GROUP_ALL, ServerPortUsingTwoHash2Entries },
	{  383,	GROUP_TBL_TCPUDP|GROUP_ALL,	ServerPortAndNewHash1 },
	{  391, GROUP_TBL_TCPUDP|GROUP_ALL, TestNaptAlgConnection },
	{  394, GROUP_TBL_TCPUDP|GROUP_ALL, TestUpdateNaptConnection1Way },
	{  395, GROUP_TBL_TCPUDP|GROUP_ALL, TestUpdateNaptConnection4Way },
	{  396, GROUP_TBL_TCPUDP|GROUP_ALL, TestUpdateNaptConnectionHybrid1 },
	{  397, GROUP_TBL_TCPUDP|GROUP_ALL, TestUpdateNaptConnectionHybrid2 },
#else//CONFIG_RTL865XB_EXP_HASH2
	{  309,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptAddConnectionError },
	{  301,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptTypicalCase },
	{  302,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptTypicalCaseRandomTest },
	{  303,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptHash1Hash2RandomTest },
	{  304,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptPortRangeBug },
	{  319,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptAddAlgCtrlConnectionError },
	{  311,	GROUP_TBL_TCPUDP|GROUP_ALL,	NaptAddAlgCtrlConnectionRandomTest },
#endif//CONFIG_RTL865XB_EXP_HASH2
	{  321,	GROUP_TBL_TCPUDP|GROUP_ALL,	testNewlyAddedHash2Udp },
	{  322,	GROUP_TBL_TCPUDP|GROUP_ALL,	testGetOutboundNaptFlow },
	{  333,	0, AddConnPerSec_Hash1 },
	{  334,	0, AddConnPerSec_Hash2 },
	{  335, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTestAddNaptConnectiondBug },
#ifdef FLUSH_NAPT_CONNECTION_WHEN_MORE_THAN_LIMIT
	{  336, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTestMoreThan4096Connections },
#endif
	{  337, GROUP_TBL_TCPUDP|GROUP_ALL, NaptTestIpEntryReferenceCount },
	{  338, GROUP_TBL_TCPUDP|GROUP_ALL, testChangeNaptIpAndPort },
	{  339, GROUP_TBL_TCPUDP|GROUP_ALL, Hash2_2pairs },
	{  340, GROUP_TBL_TCPUDP|GROUP_ALL, Hash2_Outbound_Ambigious },

	/* Test ICMP Table Case ID:          	401 -  500 */
	{  499,	GROUP_TBL_ICMP|GROUP_ALL,	AddDelIcmpError },
	{  401,	GROUP_TBL_ICMP|GROUP_ALL,	AddDelIcmpRandomTest },
	
	/* Test IP Table Case ID:            	501 -  600 */
	{  501, GROUP_TBL_IP|GROUP_ALL, iptbl_test1 },
	{  502, GROUP_TBL_IP|GROUP_ALL, iptbl_test2 },
	{  503, GROUP_TBL_IP|GROUP_ALL, iptbl_test3 },
	
	
	/* Test Server Port Table Case ID: 	601 -  700 */
	{  699,	GROUP_TBL_SERVPORT|GROUP_ALL, NaptAddServerPortError },
	{  601,	GROUP_TBL_SERVPORT|GROUP_ALL, NaptAddDelServerPort },
	{  602,	GROUP_TBL_SERVPORT|GROUP_ALL, NaptAddDelServerPortRandomTest },
	{  603,	GROUP_TBL_SERVPORT|GROUP_ALL, NaptAddDelServerPortRandomTest2 },
	{  604,	GROUP_TBL_SERVPORT|GROUP_ALL, NaptFlushNaptServerPortbyExtIpRandomTest },
	{  605,	GROUP_TBL_SERVPORT|GROUP_ALL, testServerPortParkTcpUdp },

	/* Test VLAN Table Case ID:          	701 -  800 */
	
	/* Test ALG Table Case ID:           	801 -  900 */
	{  801,	GROUP_TBL_ALG|GROUP_ALL, AddDelALGError },
	{  898,	GROUP_TBL_ALG|GROUP_ALL, AddDelALGBug },
	{  802,	GROUP_TBL_ALG|GROUP_ALL, AddDelALGRandomTest },


	/* Test ACL Table Case ID:          	901 -  1000 */
	{ 901, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test1 },
	{ 911, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test11 },
	{ 912, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test12 },
	{ 913, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test13 },
	{ 914, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test14 },
	{ 915, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test15 },
	{ 916, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test16 },
	{ 917, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test17 },
	{ 918, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test18 },
	{ 919, 	GROUP_ALL|GROUP_TBL_ACL, 	acl_test19 },
	
	
	/* Test Proto Trap Table Case ID: 	1001 - 1100 */

	/* Test PPPoE Table Case ID:        	1101 - 1200 */
	{ 1101, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test1	},
	{ 1102, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test2	},
	{ 1103, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test3	},
	{ 1110, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test10	},
	{ 1111, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test11	},
	{ 1112, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test12	},
	{ 1113, 	GROUP_TBL_PPPOE|GROUP_ALL,	pppoe_test13	},


	
	
	/* Test NextHop Table Case ID:    	1201 - 1300 */



	
	/* Test URL Filtering  Case ID:   	1301 - 1400 */
	{ 1301, GROUP_URLFILTER|GROUP_ALL, url_Filter_test1 },
	{ 1302, GROUP_URLFILTER|GROUP_ALL, url_Filter_test2 },
	{ 1303, GROUP_URLFILTER|GROUP_ALL, url_Filter_test3 },
	{ 1304, GROUP_URLFILTER|GROUP_ALL, url_Filter_test4 },
	{ 1305, GROUP_URLFILTER|GROUP_ALL, url_Filter_test5 },
	{ 1306, GROUP_URLFILTER|GROUP_ALL, url_Filter_test6 },
	{ 1307, GROUP_URLFILTER|GROUP_ALL, url_Filter_test7 },
	{ 1308, GROUP_URLFILTER|GROUP_ALL, url_Filter_test8 },
	{ 1309, GROUP_URLFILTER|GROUP_ALL, url_Filter_test9 },	

	/* Test Policy Route ID: 1401 -  1500 */
	{ 1401, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_1 },
	{ 1402, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_2 },
	{ 1403, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_3 },
	{ 1404, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_4 },
	{ 1405, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_5 },
	{ 1406, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_6 },
	{ 1407, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_7 },
	{ 1408, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_8 },

	{ 1410, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_10 },
	{ 1411, GROUP_POLICYROUTE|GROUP_ALL, policyRoute_11 },




	
	
	/* Misc: 1501 - 1600 */
	{ 1501, GROUP_MISC|GROUP_ALL,		misc_test1	},
	{ 1502, GROUP_MISC|GROUP_ALL,		misc_test2	},
	{ 1503, GROUP_MISC|GROUP_ALL,		misc_test3	},
	{ 1504, GROUP_MISC|GROUP_ALL,		misc_test4	},

	{ 1511, GROUP_MISC|GROUP_ALL, 	macAccessControl_test1 },
	{ 1512, GROUP_MISC|GROUP_ALL, 	macAccessControl_test2 },
	{ 1513, GROUP_MISC|GROUP_ALL, 	macAccessControl_test3 },
	{ 1514, GROUP_MISC|GROUP_ALL, 	macAccessControl_test4 },
	{ 1515, GROUP_MISC|GROUP_ALL, 	macAccessControl_test5 },
	{ 1516, GROUP_MISC|GROUP_ALL, 	macAccessControl_test6 },
	{ 1517, GROUP_MISC|GROUP_ALL, 	macAccessControl_test7 },
	{ 1518, GROUP_MISC|GROUP_ALL, 	macAccessControl_test8 },
	{ 1519, GROUP_MISC|GROUP_ALL, 	macAccessControl_test9 },
	{ 1520, GROUP_MISC|GROUP_ALL, 	macAccessControl_test10 },
	{ 1521, GROUP_MISC|GROUP_ALL, 	macAccessControl_test11 },
	{ 1522, GROUP_MISC|GROUP_ALL, 	macAccessControl_test12 },
	{ 1523, GROUP_MISC|GROUP_ALL, 	macAccessControl_test13 },
	{ 1524, GROUP_MISC|GROUP_ALL, 	macAccessControl_test14 },
	{ 1525, GROUP_MISC|GROUP_ALL, 	macAccessControl_test15 },
	{ 1526, GROUP_MISC|GROUP_ALL, 	macAccessControl_test16 },

	{ 1531, GROUP_MISC|GROUP_ALL, 	mtu_test1 },
	{ 1532, GROUP_MISC|GROUP_ALL, 	mtu_test2 },
	{ 1533, GROUP_MISC|GROUP_ALL, 	mtu_test3 },
	{ 1534, GROUP_MISC|GROUP_ALL, 	mtu_test4 },

	{ 1541, GROUP_MISC|GROUP_ALL, 	pkt_ras_idletimeout },
	{ 1542, GROUP_MISC|GROUP_ALL, 	pkt_ras_dialondemand },

	
	/* Test: Server Port & nexthop: 1601 - 1700 */


		
	/* Test: DMZ Host: 1701 - 1800 */
	{ 1701, GROUP_DMZHOST|GROUP_ALL, NaptDMZHostError },
	{ 1702, GROUP_DMZHOST|GROUP_ALL, NaptAddDMZHost },
	{ 1703, GROUP_DMZHOST|GROUP_ALL, NaptAddDMZHost2 },
	{ 1703, GROUP_DMZHOST|GROUP_ALL, NaptAddDMZHostRandomTest },


	/* Test: IP interface: 1801 - 1900 */
	{ 1801,	GROUP_IP_INTERFACE|GROUP_ALL, ip_interface_test_1	},
	{ 1802,	GROUP_IP_INTERFACE|GROUP_ALL, ip_interface_test_2	},
	{ 1803,	GROUP_IP_INTERFACE|GROUP_ALL, ip_interface_test_3	},
	{ 1804,	GROUP_IP_INTERFACE|GROUP_ALL, ip_interface_test_4	},
	{ 1805,	GROUP_IP_INTERFACE|GROUP_ALL, ip_interface_test_5	},


	/* Test: Large IP Class: 1901 - 1999 */
	{ 1901, GROUP_LARGE_IPCLASS|GROUP_ALL, large_ipClass_1 },
	{ 1902, GROUP_LARGE_IPCLASS|GROUP_ALL, large_ipClass_2 },
	{ 1903, GROUP_LARGE_IPCLASS|GROUP_ALL, large_ipClass_3 },
	



	/* Test Forwarding Engine Case ID:	2000 - 2999 */
	// basic function
	{ 2000,	GROUP_FWDENGINE|GROUP_ALL,	mbuf_test1},
	{ 2001,	GROUP_FWDENGINE|GROUP_ALL,	pkt_route_normal1},
	{ 2002,	GROUP_FWDENGINE|GROUP_ALL,	pkt_route_frag1},
	{ 2003,	GROUP_FWDENGINE|GROUP_ALL,	pkt_route_frag2},
	{ 2004,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal1},
	{ 2005,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal2},
	{ 2006,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal3},
	{ 2007,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal4},
	{ 2008,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal5},
	{ 2009,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal6},
	{ 2010,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal7},
	{ 2011,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_normal8},
	{ 2012,	GROUP_FWDENGINE|GROUP_ALL,	Napt_UdpStaticPortTranslation1},
	{ 2013,	GROUP_FWDENGINE|GROUP_ALL,	Napt_TcpStaticPortTranslation1},
	{ 2015,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_frag1},

	{ 2021,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_tcp_1},
	{ 2022,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_tcp_2},
	{ 2023,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_tcp_3},
	{ 2024,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_tcp_4},
	{ 2025,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_udp_1},
	{ 2026,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_udp_2},
	{ 2027,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_hybrid_1},
	{ 2028,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_serverport_hybrid_2},

	{ 2030,	GROUP_FWDENGINE|GROUP_ALL,	pkt_nat_tcp_1},
	{ 2031,	GROUP_FWDENGINE|GROUP_ALL,	pkt_nat_tcp_2},
	{ 2032,	GROUP_FWDENGINE|GROUP_ALL,	pkt_nat_udp_1},
	{ 2033,	GROUP_FWDENGINE|GROUP_ALL,	pkt_nat_icmp_1},
	{ 2034,	GROUP_FWDENGINE|GROUP_ALL,	pkt_nat_icmp_2},

	{ 2037,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_dmzHost_tcp_1},
	{ 2038,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_dmzHost_udp_1},
	{ 2039,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_dmzHost_icmp_1},
	{ 2040,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_dmzHost_UnicastIgmp_1},
	{ 2041,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_dmzHost_GeneralPktForward_1},

	{ 2042,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_uPnP_tcp_1},
	{ 2043,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_uPnP_tcp_2},
	{ 2044,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_uPnP_udp_1},
	{ 2045,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_uPnP_udp_2},

	{ 2050,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_tcp_1},
	{ 2051,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_tcp_2},
	{ 2052,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_tcp_3},
	{ 2053,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_tcp_4},
	{ 2054,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_tcp_5},
	{ 2055,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_tcp_6},
	{ 2056,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_udp_1},
	{ 2057,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_udp_2},
	{ 2058,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_udp_3},
	{ 2059,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_udp_4},
	{ 2060,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_udp_5},
	{ 2061,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_1},
	{ 2062,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_2},
	{ 2063,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_3},
	{ 2064,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_4},
	{ 2065,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_5},
	{ 2066,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_6},
	{ 2067,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_7},
	{ 2068,	GROUP_FWDENGINE|GROUP_ALL,	pkt_portBouncing_icmp_8},
	// fwdengine futures
	{ 2070,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_icmpReply_1},
	{ 2071,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_icmpReply_2},
	{ 2072,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_icmpTexceedReply_1},
	{ 2073,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_logNewFlow_1},
	{ 2074,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_arp_1},
	{ 2075,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_arp_proxy_1},
	{ 2076,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_InexactUDPNapt_1},
#ifdef RTL_WEAK_NAPT_CTRL_TEST
	{ 2077,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_weakTcpNaptCheck_1},
	{ 2078,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_weakTcpNaptCheck_2},
/*	{ 2079,	GROUP_FWDENGINE|GROUP_ALL,	pkt_feature_weakTcpNaptCheckRandomTest_1}, */
#endif /* RTL_WEAK_NAPT_CTRL_TEST */
	// black list
	{ 2080,	GROUP_FWDENGINE|GROUP_ALL,	pkt_BlackList_sip1},
	// to CPU
	{ 2086,	GROUP_FWDENGINE|GROUP_ALL,	pkt_acl_2cpu1},
	{ 2087,	GROUP_FWDENGINE|GROUP_ALL,	pkt_frag_2cpu1},
	{ 2088,	GROUP_FWDENGINE|GROUP_ALL,	pkt_frag_2cpu2},
	// Stress
	{ 2091,	GROUP_FWDENGINE|GROUP_ALL,	ipFrag_stress_1},
	{ 2092,	GROUP_FWDENGINE|GROUP_ALL,	ipFrag_stress_2},
	// udp blocking
	{ 2093,	GROUP_FWDENGINE|GROUP_ALL,	pkt_udp_blocking1},
	{ 2094,	GROUP_FWDENGINE|GROUP_ALL,	pkt_udp_blocking2},
	// bug fix
	{ 2096,	GROUP_FWDENGINE|GROUP_ALL,	pkt_udp_zeroCksum},
	{ 2097,	GROUP_FWDENGINE|GROUP_ALL,	pkt_udp_cksum},
	{ 2098,	GROUP_FWDENGINE|GROUP_ALL,	pkt_dos_IcmpFragment1},
	{ 2099,	GROUP_FWDENGINE|GROUP_ALL,	pkt_PacketBouncing_1},
	{ 2100,	GROUP_FWDENGINE|GROUP_ALL,	pkt_SPI_1},
	{ 2101,	GROUP_FWDENGINE|GROUP_ALL,	pkt_SPI_2},
	{ 2102,	GROUP_FWDENGINE|GROUP_ALL,	pkt_ttlCheck1},
	{ 2103,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl1},
	{ 2104,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl2},
	{ 2105,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl3},
	{ 2106,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl4},
	// note: number 2107 is used by some test case.
	{ 2108,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl5},
	{ 2109,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl6},
	{ 2110,	GROUP_FWDENGINE|GROUP_ALL,	pkt_newflow_acl7},

	// protocol stack TX flow QoS
	{ 2121,	GROUP_FWDENGINE|GROUP_ALL,	pkt_protocolStackFlow_QosSend_1},
	{ 2122,	GROUP_FWDENGINE|GROUP_ALL,	pkt_protocolStackFlow_portListDetermination_1},
	{ 2123,	GROUP_FWDENGINE|GROUP_ALL,	pkt_protocolStackFlow_portListDetermination_2},

	// policy route
#ifdef RTL_FWDENG_POLICYRT_TEST 
	{ 2131,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy1},
	{ 2132,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy2},
	{ 2133,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy3},
	{ 2134,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy4},
	{ 2135,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy5},
	{ 2136,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy6},
	{ 2137,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_policy7},

#if 0
	{ 2106,	GROUP_FWDENGINE|GROUP_ALL,	pkt_unnumbered_1},
#endif
	{ 2107,	GROUP_FWDENGINE|GROUP_ALL,	pkt_future_icmpReply_policy1},
#endif /* RTL_FWDENG_POLICYRT_TEST  */ 
#ifdef CONFIG_RTL865X_MULTICAST
	{ 2150,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp1},
	{ 2151,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp2},
	{ 2152,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp3},
	{ 2153,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp4},
	{ 2154,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp5},
	{ 2155,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp6},
	{ 2156,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_igmp_Filter1},
	{ 2158,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_flowCache1},
//#ifdef RTL_FWDENG_POLICYRT_TEST
//	{ 2190,	GROUP_FWDENGINE|GROUP_ALL,	pkt_multicast_multi_session1},
//#endif /* RTL_FWDENG_POLICYRT_TEST */
#endif /* CONFIG_RTL865X_MULTICAST */ 


	{ 2161, 	GROUP_FWDENGINE|GROUP_ALL, pkt_mac_filtering_test1 },
	{ 2162, 	GROUP_FWDENGINE|GROUP_ALL, pkt_mac_filtering_test2 },
	{ 2163, 	GROUP_FWDENGINE|GROUP_ALL, pkt_mac_filtering_test3 },
	{ 2164, 	GROUP_FWDENGINE|GROUP_ALL, pkt_mac_filtering_test4 },

	{ 2171, 	GROUP_FWDENGINE|GROUP_ALL, pkt_serverPort_syn_ack_drop },

	{ 2181,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_tcp_1},
	{ 2182,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_tcp_2},
	{ 2183,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_tcp_3},
	{ 2184,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_tcp_4},

	{ 2186,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_udp_1},
	{ 2187,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_udp_2},
	{ 2188,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_udp_3},
	{ 2189,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_triggerport_udp_4},

	/* Dos test Case ID:	 2200 - 2399 */

#ifdef RTL_FWDENG_DOS_TEST
	{ 2200,	GROUP_FWDENGINE|GROUP_ALL,	dosSynFlood_1},
	{ 2201,	GROUP_FWDENGINE|GROUP_ALL,	dosSynFlood_2},
	{ 2202,	GROUP_FWDENGINE|GROUP_ALL,	dosSynFlood_3},
	{ 2203,	GROUP_FWDENGINE|GROUP_ALL,	dosSynFlood_4},
	{ 2204,	GROUP_FWDENGINE|GROUP_ALL,	dosStealthFin_1},
	{ 2205,	GROUP_FWDENGINE|GROUP_ALL,	dosStealthFin_2},
	{ 2206,	GROUP_FWDENGINE|GROUP_ALL,	dosStealthFin_3},
	{ 2207,	GROUP_FWDENGINE|GROUP_ALL,	dosStealthFin_4},
	{ 2208,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpFlood_1},
	{ 2209,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpFlood_2},
	{ 2210,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpFlood_3},
	{ 2211,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpFlood_4},
	{ 2212,	GROUP_FWDENGINE|GROUP_ALL,	dosIcmpFlood_1},
	{ 2213,	GROUP_FWDENGINE|GROUP_ALL,	dosIcmpFlood_2},
	{ 2214,	GROUP_FWDENGINE|GROUP_ALL,	dosIcmpFlood_3},
	{ 2215,	GROUP_FWDENGINE|GROUP_ALL,	dosIcmpFlood_4},

	{ 2216,	GROUP_FWDENGINE|GROUP_ALL,	dosTcpLand_1},
	{ 2217,	GROUP_FWDENGINE|GROUP_ALL,	dosTcpLand_2},
	{ 2218,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpLand_1},
	{ 2219,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpLand_2},
	{ 2220,	GROUP_FWDENGINE|GROUP_ALL,	dosIcmpLand_1},
	{ 2221,	GROUP_FWDENGINE|GROUP_ALL,	dosIcmpLand_2},
	{ 2222,	GROUP_FWDENGINE|GROUP_ALL,	dosSmurf_1},
	{ 2223,	GROUP_FWDENGINE|GROUP_ALL,	dosSynWithData_1},
	{ 2224,	GROUP_FWDENGINE|GROUP_ALL,	dosSynWithData_2},
	{ 2225,	GROUP_FWDENGINE|GROUP_ALL,	dosTearDrop_1},
	{ 2226,	GROUP_FWDENGINE|GROUP_ALL,	dosTearDrop_2},
 	{ 2227,	GROUP_FWDENGINE|GROUP_ALL,	dosIpSpoof_1},
	{ 2228,	GROUP_FWDENGINE|GROUP_ALL,	dosIpSpoof_2},
	// for ip-queue syste, PingOfDeath will never occur
	{ 2229,	GROUP_FWDENGINE|GROUP_ALL,	dosPingOfDeath_1},
	{ 2230,	GROUP_FWDENGINE|GROUP_ALL,	dosPingOfDeath_2},

	{ 2231,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpEchoChargen_1},
	{ 2232,	GROUP_FWDENGINE|GROUP_ALL,	dosTcpScan_1},
	{ 2233,	GROUP_FWDENGINE|GROUP_ALL,	SipBlocking_1},

	{ 2234,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpBomb_1},
	{ 2235,	GROUP_FWDENGINE|GROUP_ALL,	dosUdpBomb_2},
	{ 2236,	GROUP_FWDENGINE|GROUP_ALL,	dosTcpUdpPortScan_1},
	{ 2237,	GROUP_FWDENGINE|GROUP_ALL,	dosTcpUdpPortScan_2},
	{ 2238,	GROUP_FWDENGINE|GROUP_ALL,	dosIgnoreCase_1},
	{ 2239,	GROUP_FWDENGINE|GROUP_ALL,	dosIgnoreCase_2},

	{ 2251,	GROUP_FWDENGINE|GROUP_ALL,	pkt_connectionControl_wholeSystem_1},
	{ 2252,	GROUP_FWDENGINE|GROUP_ALL,	pkt_connectionControl_perSrc_1},

#endif /* RTL_FWDENG_DOS_TEST */

	/* Napt-Redirect Case ID:	 2400 - 2419 */
#ifdef RTL_NAPT_REDIRECT_TEST
	{ 2400,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_1},
	{ 2401,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_2},
	{ 2402,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_3},
	{ 2403,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_4},
	{ 2404,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_5},
	{ 2405,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_6},
	{ 2406,	GROUP_FWDENGINE|GROUP_ALL,	pkt_naptRedirect_7},
#endif /* RTL_NAPT_REDIRECT_TEST */

	/* Trapping Dispatch Case ID:	 2420 - 2429 */
#ifdef RTL_TRAPPING_DISPATCH_TEST
	{ 2420,	GROUP_FWDENGINE|GROUP_ALL,	pkt_trapping_dispatch_1},
	{ 2421,	GROUP_FWDENGINE|GROUP_ALL,	pkt_trapping_dispatch_2},
#endif /* RTL_TRAPPING_DISPATCH_TEST */

/* Offload Engine Case ID:	 2430 - 2449 */
#ifdef RTL_OFFLOAD_ENGINE_TEST
	{ 2430,	GROUP_FWDENGINE|GROUP_ALL,	pkt_L3_offload_engine_1},
#endif /* RTL_OFFLOAD_ENGINE_TEST */

	/* Protocol stack flow cache Case ID:	2450 - 2459 */
#ifdef RTL_PROTOCOLSTACK_FLOWCACHE_TEST
	{ 2450,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_ProtocolStackFlow_trap_1},
	{ 2451,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_ProtocolStackFlow_trap_2},
	{ 2452,	GROUP_FWDENGINE|GROUP_ALL,	pkt_napt_ProtocolStackFlow_trap_3},
#endif /* RTL_PROTOCOLSTACK_FLOWCACHE_TEST */

	/* Forwarding engine and ACL co-operate Case ID:	 2900 - 2999 */
	{ 2900,	GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL,	acl_Syn2CpuForExternalVlan},
	{ 2901,	GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL,	acl_DoS2Cpu},
 
	/* Test ALG with Forwarding Engine Case ID:	3000 - 3999 */
	{ 3000,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algFtpClient},	
	{ 3001,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algFtpServer},		
	{ 3002,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algIrcClient},
	{ 3003,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algYmsgClient},	
	{ 3004,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algIcqClient},
	{ 3005,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algIcuiiServer},	
	{ 3006,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algDx7Client},
	{ 3007,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algDx7Server},	
	{ 3008,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algSipClient},
	{ 3009,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algSipServer},
	{ 3010,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algRealAudioClient},
	{ 3011,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algVDOliveClient},
	{ 3012,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algQuakeClient},
	{ 3013,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algBattlenetClient},
	{ 3014,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algCsClient},
	{ 3015,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algCUseeMeClient},
	{ 3016,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algPptpClient},
	{ 3017,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algL2tpClient},
	{ 3018,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algIpsecClient},
	{ 3019,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algNetMeetingClient},
	{ 3020,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algNetMeetingServer},
	{ 3021,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algPptpServer},	
	{ 3022,	GROUP_FWDENGINE|GROUP_TBL_ALG|GROUP_ALL,	algPptpSoftwareClient},	

	/* QoS: 4001 - 4100 */
	{ 4001, 	GROUP_QOS|GROUP_ALL,		qos_test1	},
	{ 4002, 	GROUP_QOS|GROUP_ALL,		qos_test2	},
	{ 4003, 	GROUP_QOS|GROUP_ALL,		qos_test3	},
	{ 4004, 	GROUP_QOS|GROUP_ALL,		qos_test4	},
	{ 4005, 	GROUP_QOS|GROUP_ALL,		qos_test5	},

	/* PPTP: 4101 - 4200 */
	{ 4101,	GROUP_PPTP|GROUP_ALL,		pptp_test1	},
	{ 4102,	GROUP_PPTP|GROUP_ALL,		pptp_test2	},
	{ 4103,	GROUP_PPTP|GROUP_ALL,		pptp_test3	},
	{ 4104,	GROUP_PPTP|GROUP_ALL,		pptp_test4	},
	{ 4105,	GROUP_PPTP|GROUP_ALL,		pptp_test5	},
	{ 4106,	GROUP_PPTP|GROUP_ALL,		pptp_test6	},
	{ 4107,	GROUP_PPTP|GROUP_ALL,		pptp_test7	},
	{ 4108,	GROUP_PPTP|GROUP_ALL,		pptp_test8	},
	{ 4109,	GROUP_PPTP|GROUP_ALL,		pptp_test9	},
	{ 4110,	GROUP_PPTP|GROUP_ALL,		pptp_test10	},
	{ 4111,	GROUP_PPTP|GROUP_ALL,		pptp_test11	},
	{ 4112,	GROUP_PPTP|GROUP_ALL,		pptp_test12	},	
	{ 4113,	GROUP_PPTP|GROUP_ALL,		pptp_test_idletimeout },
	{ 4114,	GROUP_PPTP|GROUP_ALL,		pptp_test14	},	
	{ 4115,	GROUP_PPTP|GROUP_ALL,		pptp_test15	},
	{ 4116,	GROUP_PPTP|GROUP_ALL,		pptp_test16	},
	{ 4117,	GROUP_PPTP|GROUP_ALL,		pptp_test17	},



	/* L2TP: 4201 - 4300 */
	{ 4201,	GROUP_L2TP|GROUP_ALL,		l2tp_test1	},
	{ 4202,	GROUP_L2TP|GROUP_ALL,		l2tp_test2	},
	{ 4203,	GROUP_L2TP|GROUP_ALL,		l2tp_test3	},
	{ 4204,	GROUP_L2TP|GROUP_ALL,		l2tp_test4	},
	{ 4205,	GROUP_L2TP|GROUP_ALL,		l2tp_test5	},
	{ 4206,	GROUP_L2TP|GROUP_ALL,		l2tp_test6	},
	{ 4207,	GROUP_L2TP|GROUP_ALL,		l2tp_test7	},
	{ 4208,	GROUP_L2TP|GROUP_ALL,		l2tp_test8	},
	{ 4209,	GROUP_L2TP|GROUP_ALL,		l2tp_test9	},
	{ 4210,	GROUP_L2TP|GROUP_ALL,		l2tp_test_idletimeout },
	{ 4214,	GROUP_L2TP|GROUP_ALL,		l2tp_test14	},
	

	/* PPPoE Passthru: 4301 - 4400 */
#if 1//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
	{ 4301,	GROUP_PPPOE_PASSTHRU|GROUP_ALL,		pkt_pppoe_passthru_PBV	},
#else//CONFIG_RTL865XB
#endif//CONFIG_RTL865XB
	{ 4302,	GROUP_PPPOE_PASSTHRU|GROUP_ALL,		pkt_pppoe_passthru	},
	{ 4303,	GROUP_PPPOE_PASSTHRU|GROUP_ALL,		pkt_pppoe_passthru_drop_unknown	},
	{ 4304,	GROUP_PPPOE_PASSTHRU|GROUP_ALL,		pkt_pppoe_passthru_vlan_index	},
	{ 4305,	GROUP_PPPOE_PASSTHRU|GROUP_ALL,		pkt_pppoe_passthru_without_vlan1	},

	/* Multicast: 4401 - 4500 */
	{ 4401,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test1	},
	{ 4402,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test2	},
	{ 4403,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test3	},
	{ 4404,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test4	},
	{ 4405,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test5	},
	{ 4406,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test6	},
	{ 4407,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test7	},
	{ 4408,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test8	},
	{ 4409,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test9	},
	{ 4410,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test10	},
	{ 4411,	GROUP_TBL_MCAST|GROUP_ALL,		muticast_test11	},
	

	/* Protocol-Base NAT: 4501 - 4600 */
	{ 4501,	GROUP_MISC|GROUP_ALL,		ProtocolBasedNATError	},
	{ 4502,	GROUP_MISC|GROUP_ALL,		ProtocolBasedNATRandomTest	},
	{ 4511,	GROUP_MISC|GROUP_ALL,		pkt_protocol_based_nat	},

	/* Misc test: 4601 - 4700 */
	{ 4601, GROUP_ASIC_INTERFACE|GROUP_ALL, counter_test1},
	{ 4602, GROUP_MISC|GROUP_ALL, portBandwidthControl_test1},

	/* PPPoE Passthru: 4701 - 4800 */
#if 1//CONFIG_RTL865XB_EXP_IPV6_PASSTHRU
	{ 4701,	GROUP_IPV6_PASSTHRU|GROUP_ALL,		pkt_ipv6_passthru_PBV	},
#else//CONFIG_RTL865XB
#endif//CONFIG_RTL865XB
	{ 4702,	GROUP_IPV6_PASSTHRU|GROUP_ALL,		pkt_ipv6_passthru	},
	/* PPPoE Not existed session termination test: 4801 - 4900 */
	{4801, GROUP_FWDENGINE|GROUP_ALL,	pppoeSessionNotExistedTermination_test1},
	{4802, GROUP_FWDENGINE|GROUP_ALL,	pkt_pppoeNotExistedSessionTermination_test2},


	/* MTU Fragment: 4901 - 5000 */
	{ 4901, GROUP_FWDENGINE|GROUP_ALL, pkt_mtu_fragment_static_ip },
	{ 4902, GROUP_FWDENGINE|GROUP_ALL, pkt_mtu_fragment_pppoe },
	//{ 4903, GROUP_FWDENGINE|GROUP_ALL, pkt_mtu_fragment_static_ip_fragment }, 
	

	/* Rate Limit: 5001 - 5050 */
	{ 5001, GROUP_MISC|GROUP_ALL, rateLimit_test1 },
	{ 5002, GROUP_MISC|GROUP_ALL, rateLimit_test2 },
	{ 5003, GROUP_MISC|GROUP_ALL, rateLimit_test3 },
	{ 5004, GROUP_MISC|GROUP_ALL, rateLimit_test4 },
	{ 5005, GROUP_MISC|GROUP_ALL, rateLimit_test5 },

	/* Rate Limit Counter: 5051 - 5100 */
	{ 5051, GROUP_MISC|GROUP_ALL, rateLimitCounter_test1 },
	{ 5052, GROUP_MISC|GROUP_ALL, rateLimitCounter_test2 },
	{ 5053, GROUP_MISC|GROUP_ALL, rateLimitCounter_test3 },
	{ 5054, GROUP_MISC|GROUP_ALL, rateLimitCounter_test4 },
	{ 5055, GROUP_MISC|GROUP_ALL, rateLimitCounter_test5 },
	{ 5056, GROUP_MISC|GROUP_ALL, rateLimitCounter_test6 },

	/* M-N Queue: 5101 - 5200 */
	{ 5101, GROUP_MISC|GROUP_ALL, qos_MNQueue_test1	},
	{ 5102, GROUP_MISC|GROUP_ALL, qos_MNQueue_test2	},
	//{ 5103, GROUP_MISC|GROUP_ALL, qos_MNQueue_test3	},
	//{ 5104, GROUP_MISC|GROUP_ALL, qos_MNQueue_test4	},
	//{ 5105, GROUP_MISC|GROUP_ALL,  qos_MNQueue_test5	},
	//{ 5106, GROUP_MISC|GROUP_ALL,  qos_MNQueue_test6	},

	/* Pseudo VLAN: 5151 - 5160 */
	{ 5151, GROUP_MISC|GROUP_ALL, pseudo_vlan_test1 },
	{ 5152, GROUP_MISC|GROUP_ALL, pseudo_vlan_test2 },
	{ 5153, GROUP_MISC|GROUP_ALL, pseudo_vlan_test3 },
	{ 5154, GROUP_MISC|GROUP_ALL, pseudo_vlan_test4 },
	{ 5155, GROUP_MISC|GROUP_ALL, pseudo_vlan_test5 },
	{ 5156, GROUP_MISC|GROUP_ALL, pseudo_vlan_test6 },
	{ 5157, GROUP_MISC|GROUP_ALL, pseudo_vlan_test7 },
#ifdef RTL865XB_DCUT_SWVLAN
	{ 5158, GROUP_MISC|GROUP_ALL, swVlan_test1 },
	{ 5159, GROUP_MISC|GROUP_ALL, swVlan_test2 },
#endif
	


	/* Remote Management 5201 - 5210 */
	{ 5201, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management1 },
	{ 5202, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management2 },
	{ 5203, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management3 },
	{ 5204, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management4 },
	{ 5205, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management5 },
	{ 5206, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management6 },
	{ 5207, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management7 },
	{ 5208, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management8 },
	{ 5209, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management9 },
	{ 5210, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management10 },
	{ 5211, GROUP_FWDENGINE|GROUP_MISC|GROUP_ALL, pkt_remote_management11 },


	/* Nexthop Table: 5301 - 5400 */
	{ 5301, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test1 },
	{ 5302, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test2 },
	{ 5303, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test3 },
	{ 5304, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test4 },
	{ 5305, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test5 },
	{ 5306, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test6 },
	{ 5307, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test7 },
	{ 5308, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test8 },

	{ 5310, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test10 },
	{ 5311, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test11 },
	{ 5312, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test12 },
	{ 5313, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test13 },
	{ 5314, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test14 },
	{ 5315, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test15 },
	{ 5316, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test16 },
	{ 5317, GROUP_TBL_NEXTHOP|GROUP_ALL, nexthop_test17 },

	/* IPSEC Table: 5401 - 5500 */
	{ 5499, GROUP_FWDENGINE|GROUP_ALL, ipsecTestError },
	{ 5401, GROUP_FWDENGINE|GROUP_ALL, ipsecTestBasic1 },
	{ 5402, GROUP_FWDENGINE|GROUP_ALL, ipsecTestBasic2 },
	{ 5403, GROUP_FWDENGINE|GROUP_ALL, ipsecTestBasic3 },
	{ 5404, GROUP_FWDENGINE|GROUP_ALL, ipsecTestBasic4 },
	{ 5405, GROUP_FWDENGINE|GROUP_ALL, ipsecTestFrag },

#ifdef CONFIG_RTL865X_VOIP
	/* VoIP Supporintg: 5601 - 5699 */
	{ 5601, GROUP_FWDENGINE|GROUP_ALL, rtpTest1 },
	{ 5602, GROUP_FWDENGINE|GROUP_ALL, rtpTest2 },
	{ 5603, GROUP_FWDENGINE|GROUP_ALL, rtpTest3 },
	{ 5604, GROUP_FWDENGINE|GROUP_ALL, rtpTest4 },
#endif

	/* The end of Testing Case */
	{ 0xffffffff, 0, NULL },
};

static runCase_group_t groupArray[] =
{
	{ "asic", 		GROUP_ASIC_INTERFACE 	}, 
	{ "l2", 		GROUP_TBL_L2 			}, 
	{ "arp", 		GROUP_TBL_ARP 			},
	{ "l3", 		GROUP_TBL_L3 			}, 
	{"tcpudp",  	GROUP_TBL_TCPUDP 		}, 
	{ "icmp", 	GROUP_TBL_ICMP 				},
	{ "ip", 		GROUP_TBL_IP 			}, 
	{ "sp", 		GROUP_TBL_SERVPORT 		}, 
	{ "vlan", 		GROUP_TBL_VLAN 			},
	{ "alg", 		GROUP_TBL_ALG 			}, 
	{ "acl", 		GROUP_TBL_ACL 			}, 
	{ "ptrap", 	GROUP_TBL_PROTOTRAP 		},
	{ "pppoe", 	GROUP_TBL_PPPOE 			},
	{ "nxthop", 	GROUP_TBL_NEXTHOP 		}, 
	{ "ratelimit", 	GROUP_TBL_RATELIMIT 	},
	{ "fwd",		GROUP_FWDENGINE			},
	{ "dmz",		GROUP_DMZHOST			},
    { "ipinterface", GROUP_IP_INTERFACE		},
    { "ipclass",	GROUP_LARGE_IPCLASS		},     
	{ "qos",		GROUP_QOS				},
	{ "policy",		GROUP_POLICYROUTE		},
	{ "pptp",		GROUP_PPTP				},
	{ "l2tp",		GROUP_L2TP				},
	{ "mcast",	GROUP_TBL_MCAST				},
	{ "misc",		GROUP_MISC				},
	{ "all", 		GROUP_ALL				},

	{ NULL, 0 }, /* End of Group */
};


typedef struct cmdIntr_s {
	int8		*cmd;		/* command name */
	uint32	acType;		/* command action type */
	int8		*comment;	/* comment */
} cmdIntr_t;

/* Constatnt Definition for Command */
#define CMD_RUN				0x0001		/* Run Testing Case */
#define CMD_DL2				0x0002		/* Dump L2 Table */
#define CMD_DL3				0x0003		/* Dump L3 Table */
#define CMD_DARP				0x0004		/* Dump Arp Table */
#define CMD_DACL				0x0005		/* Dump ACL Table */
#define CMD_DALG				0x0006		/* Dump ALG Table */
#define CMD_DTCPUDP			0x0007		/* Dump TCP/UDP Table */
#define CMD_DICMP			0x0008		/* Dump ICMP Table */
#define CMD_DIP				0x0009		/* Dump IP Table */
#define CMD_DSP				0x000a		/* Dump Server Port Table */
#define CMD_DPTRAP			0x000b		/* Dump Protocol Trap Table */
#define CMD_DPPPOE			0x000c		/* Dump PPPoE Table */
#define CMD_DVLAN			0x000d		/* Dump Vlan Table */
#define CMD_DPVID			0x000e		/* Dump PVID Register */
#define CMD_DTRUNK			0x000f		/* Dump Trunking Register */
#define CMD_DGIDX			0x0010		/* Dump GIDX Register */
#define CMD_DNH				0x0011		/* Dump Next Hop Table */
#define CMD_DRL				0x0012		/* Dump Rate Limit Table */
#define CMD_DMBUF			0x0013		/* Dump mbuf Table */
#define CMD_DMCAST			0x0014		/* Dump multicast Table */
#define CMD_CHIP			0x0015		/* Set chip ID */
#define CMD_DPBNAT			0x0016		/* Dump Protocol-Based NAT */
#define CMD_DPPPOEPASSTHUR	0x0017		/* Dump PPPoE Passthru */
#define CMD_DPBVLAN			0x0018		/* Dump Protocol-Based VLAN */
#define CMD_COUNTER			0x0019		/* Dump counter information */
#define CMD_DCONNCNT			0x001a		/* Dump connection counting system */
#ifdef RTL865XB_DCUT_SWVLAN
#define CMD_DSWVLAN			0x001b		/* Dump software VLAN table */
#endif
#define CMD_EXIT				0xffff			/* exit */



static cmdIntr_t cmdTable[] =
{
	{ "exit",				CMD_EXIT,		"Exit the program" },
	{ "run",				CMD_RUN,		"Run testing case" },
	{ "dl2",				CMD_DL2, 		"Dump L2 Table" },
	{ "dl3",				CMD_DL3,		"Dump L3 Table" },
	{ "darp", 				CMD_DARP,		"Dump Arp Table" },
	{ "dacl",				CMD_DACL,		"Dump ACL Table" },
	{ "dalg",				CMD_DALG,		"Dump ALG Table" },
	{ "dtcpudp",			CMD_DTCPUDP,	"Dump TCP/UDP Table" },
	{ "dicmp",			CMD_DICMP,		"Dump ICMP Table" },
	{ "dip",				CMD_DIP,			"Dump IP Table " },
	{ "dsp",				CMD_DSP,		"Dump Server Port Table" },
	{ "dptrap",			CMD_DPTRAP,		"Dump Protocol Trap Table " },
	{ "dpppoe",			CMD_DPPPOE,		"Dump PPPoE Table" },
	{ "dvlan",				CMD_DVLAN,		"Dump VLAN Table" },
	{ "dpvid",				CMD_DPVID,		"Dump PVID Reg." },
	{ "dtrunk",			CMD_DTRUNK,		"Dump Aggregate Reg." },
	{ "dgidx",				CMD_DGIDX,		"Dump GIDX Reg." },
	{ "dnh",				CMD_DNH,		"Dump Next Hop Table" },
	{ "drl", 				CMD_DRL,		"Dump Rate Limit Table" },
	{ "mbuf", 				CMD_DMBUF,		"Dump Mbuf Status" },
	{ "chip", 				CMD_CHIP,		"Set chip ID for testing." },
	{ "dmcast", 			CMD_DMCAST,		"Dump Multicast Table" },
	{ "dpppoepassthru",		CMD_DPPPOEPASSTHUR,		"Dump PPPoE Passthru" },
	{ "dpbnat",				CMD_DPBNAT,		"Dump Protocol-Based NAT" },
	{ "dpbvlan",			CMD_DPBVLAN,		"Dump Protocol-Based VLAN" },
	{ "dcounter", 		CMD_COUNTER, 		"Dump counter related information"},
	{ "dconncnt", 		CMD_DCONNCNT, 		"Dump NAPT connection count"},
#ifdef RTL865XB_DCUT_SWVLAN
	{ "dswvlan", 		CMD_DSWVLAN, 		"Dump Software VLAN Table"},
#endif

	{ NULL, 0 }, /* End of Command */
};


static void Usage(void)
{
	uint32 i;
	for(i=0; cmdTable[i].cmd != NULL; i++)
		printf("%s\t\t%s\n", cmdTable[i].cmd, cmdTable[i].comment);
	printf("\n");
}

static void Usage_run(void)
{
	

}

static uint32 ACTION_TYPE(int8 *cmd)
{
	uint32 i;
	for(i=0; cmdTable[i].cmd != NULL; i++)
		if (!strcmp(cmdTable[i].cmd, cmd))
			return cmdTable[i].acType;
	return 0;
}

static uint32 RUN_CASETYPE(int8 *cmd)
{
	uint32 i;
	for(i=0; groupArray[i].name != NULL; i++)
		if (!strcmp(groupArray[i].name, cmd))
			return groupArray[i].groupID;
	return 0;
}

#ifdef RTL865XB_DCUT_SWVLAN
void dump_swVlan(void)
{
	rtl8651_tblDrv_swVlanTable_t *swVlanPtr;
	uint32 vid, entry = 0;

	printf(">>Software VLAN Table:\n");
	for(vid = 0; vid < 4096; vid++) {
		swVlanPtr = &DrvTbl.swVlan[rtl8651_swVlanTableIndex(vid)];
		if (swVlanPtr->valid == 0)
			printf(" vid(%d)  not exist\n", vid);
		else {
			printf(" vid(%d)  MBR(%x) MBRstats(%x) untagMBR(%x) fid(%d)\n", 
				vid, swVlanPtr->memberPortMask, swVlanPtr->memberPortUpStatus, swVlanPtr->untagPortMask, swVlanPtr->fid);
			entry++;
		}
	}
	printf("Total entry: %d\n", entry);
}
#endif

static void dump_l2(void)
{
	rtl865x_tblAsicDrv_l2Param_t asic_l2;
	uint32 row, col, entry=0;
	
	printf(">>ASIC L2 Table:\n");
	for(row=0; row<RTL8651_L2TBL_ROW; row++)
		for(col=0; col<RTL8651_L2TBL_COLUMN; col++) {
			if (rtl8651_getAsicL2Table(row, col, &asic_l2) == FAILED)
				continue;
			entry++;
			printf("  [%d,%d] %x:%x:%x:%x:%x:%x mbr(%d) cpu(%d) sta(%d) srcBlk(%d) age(%u) nhFlag(%d)\n",
					row, col, asic_l2.macAddr.octet[0], asic_l2.macAddr.octet[1], asic_l2.macAddr.octet[2], 
					asic_l2.macAddr.octet[3], asic_l2.macAddr.octet[4], asic_l2.macAddr.octet[5],
					asic_l2.memberPortMask, asic_l2.cpu, asic_l2.isStatic, asic_l2.srcBlk, asic_l2.ageSec, asic_l2.nhFlag);
		}
	printf("Total entry: %d\n", entry);
}

void dump_l3(void)
{
	rtl865x_tblAsicDrv_routingParam_t asic_l3;
	int8 *str[] = { "PPPoE", "L2", "ARP", " ", "CPU", "NxtHop", "DROP", " " };
	uint32 idx, mask;

	printf(">>L3 Routing Table:\n");
	for(idx=0; idx<RTL8651_ROUTINGTBL_SIZE; idx++) {
		if (rtl8651_getAsicRouting(idx, &asic_l3) == FAILED) {
			printf("\t[%d]  (Invalid)\n", idx);
			continue;
		}
		if (idx == RTL8651_ROUTINGTBL_SIZE-1)
			mask = 0;
		else for(mask=32; !(asic_l3.ipMask&0x01); asic_l3.ipMask=asic_l3.ipMask>>1)
				mask--;
		printf("\t[%d]  %d.%d.%d.%d/%d process(%s)\n", idx, (asic_l3.ipAddr>>24),
			((asic_l3.ipAddr&0x00ff0000)>>16), ((asic_l3.ipAddr&0x0000ff00)>>8), (asic_l3.ipAddr&0xff), 
			mask, str[asic_l3.process]
		);
		switch(asic_l3.process) 
		{
		case 0x00:	/* PPPoE */
			printf("\t           dvidx(%d)  pppidx(%d) nxthop(%d)\n", asic_l3.vidx, asic_l3.pppoeIdx, (asic_l3.nextHopRow<<2)+asic_l3.nextHopColumn);
			break;
			
		case 0x01:	/* L2 */
			printf("              dvidx(%d) nexthop(%d)\n", asic_l3.vidx, (asic_l3.nextHopRow<<2)+asic_l3.nextHopColumn);
			break;

		case 0x02:	/* ARP */
			printf("             dvidx(%d) ARPSTA(%d) ARPEND(%d)\n", asic_l3.vidx, asic_l3.arpStart, asic_l3.arpEnd);
			break;

		case 0x03:	/* Reserved */
			assert(0);

		case 0x04:	/* CPU */
			break;

		case 0x05:	/* NAPT Next Hop */
			printf("              NHSTA(%d) NHNUM(%d) NHNXT(%d) NHALGO(%d) IPDOMAIN(%d)\n", asic_l3.nhStart,
				asic_l3.nhNum, asic_l3.nhNxt, asic_l3.nhAlgo, asic_l3.ipDomain);
			break;

		case 0x06:	/* DROP */
			printf("\n");
			break;

		case 0x07:	/* Reserved */
			/* pass through */
		default: assert(0);
		}
	}
}

static void dump_arp(void)
{
	rtl865x_tblAsicDrv_arpParam_t asic_arp;
	uint32  idx, entry=0;

	printf(">>ASIC ARP Table:\n");
	for(idx=0; idx<RTL8651_ARPTBL_SIZE; idx++) {
		if (rtl8651_getAsicArp(idx, &asic_arp) == FAILED)
			continue;
		printf("\t[%d]   %d/[%d,%d]\n", idx, ((asic_arp.nextHopRow<<2)+asic_arp.nextHopColumn),
			asic_arp.nextHopRow, asic_arp.nextHopColumn);
		entry++;
	}
	printf("Total entry: %d\n", entry);
}

void dump_acl(void)
{
	//int8 *actionT[] = { "permit", "redirect to ethernet", "drop", "trap to cpu", "drop", "drop to cpu for logging", 
	//			      "mirror to mirror port", "redirect to PPPoE", "default redirect to if permitted", "default mirror to mirror port",
	//			      "drop if rate exceeded(pps)", "log to cpu if rate exceeded(pps)",
	//			      "drop if rate exceeded(bps)", "log to cpu if rate exceeded(bps)" };
	int8 *actionT[] = { "", "permit", "drop", "cpu", "drop log", "drop notify", "redirect to ethernet", "redirect to pppoe", "mirror", "mirro keep match", "drop rate exceed pps", "log rate exceed pps", "drop rate exceed bps", "log rate exceed bps", "policy Route" };
	_rtl8651_tblDrvAclRule_t asic_acl;
	rtl865x_tblAsicDrv_vlanParam_t asic_vlan;
	uint32 start, end;
	uint16 vid;
	int8 outRule;


	printf(">>ACL Table:\n\n");
	for(vid=0; vid<4095; vid++ ) {
		/* Read VLAN Table */
		if (rtl8651_getAsicVlan(vid, &asic_vlan) == FAILED)
			continue;

		outRule = FALSE;
		start = asic_vlan.inAclStart; end = asic_vlan.inAclEnd;
again:
		if (outRule == FALSE)
			printf("\n<<Ingress Rule for Vlan %d:>>\n", vid);
		else printf("\n<<Egress Rule for Vlan %d>>:\n", vid);
		for( ; start<=end; start++) {
			if (rtl8651_getAsicAclRule(start, &asic_acl) == FAILED)
				assert(0);
			switch(asic_acl.ruleType_)
			{
			case RTL8651_ACL_MAC:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "Ethernet", actionT[asic_acl.actionType_]);
				printf("\tether type: %x   ether type mask: %x\n", asic_acl.typeLen_, asic_acl.typeLenMask_);
				printf("\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n",
					asic_acl.dstMac_.octet[0], asic_acl.dstMac_.octet[1], asic_acl.dstMac_.octet[2],
					asic_acl.dstMac_.octet[3], asic_acl.dstMac_.octet[4], asic_acl.dstMac_.octet[5],
					asic_acl.dstMacMask_.octet[0], asic_acl.dstMacMask_.octet[1], asic_acl.dstMacMask_.octet[2],
					asic_acl.dstMacMask_.octet[3], asic_acl.dstMacMask_.octet[4], asic_acl.dstMacMask_.octet[5]
				);
				printf("\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n",
					asic_acl.srcMac_.octet[0], asic_acl.srcMac_.octet[1], asic_acl.srcMac_.octet[2],
					asic_acl.srcMac_.octet[3], asic_acl.srcMac_.octet[4], asic_acl.srcMac_.octet[5],
					asic_acl.srcMacMask_.octet[0], asic_acl.srcMacMask_.octet[1], asic_acl.srcMacMask_.octet[2],
					asic_acl.srcMacMask_.octet[3], asic_acl.srcMacMask_.octet[4], asic_acl.srcMacMask_.octet[5]
				);
				break;

			case RTL8651_ACL_IP:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "IP", actionT[asic_acl.actionType_]);
				printf("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (asic_acl.dstIpAddr_>>24),
					((asic_acl.dstIpAddr_&0x00ff0000)>>16), ((asic_acl.dstIpAddr_&0x0000ff00)>>8),
					(asic_acl.dstIpAddr_&0xff), (asic_acl.dstIpAddrMask_>>24), ((asic_acl.dstIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.dstIpAddrMask_&0x0000ff00)>>8), (asic_acl.dstIpAddrMask_&0xff)
				);
				printf("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (asic_acl.srcIpAddr_>>24),
					((asic_acl.srcIpAddr_&0x00ff0000)>>16), ((asic_acl.srcIpAddr_&0x0000ff00)>>8),
					(asic_acl.srcIpAddr_&0xff), (asic_acl.srcIpAddrMask_>>24), ((asic_acl.srcIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.srcIpAddrMask_&0x0000ff00)>>8), (asic_acl.srcIpAddrMask_&0xff)
				);
				printf("\tTos: %x   TosM: %x   ipProto: %x   ipProtoM: %x   ipFlag: %x   ipFlagM: %x\n",
					asic_acl.tos_, asic_acl.tosMask_, asic_acl.ipProto_, asic_acl.ipProtoMask_, asic_acl.ipFlag_, asic_acl.ipFlagMask_
				);
#ifdef RTL8650B
				printf("\t<FOP:%x> <FOM:%x> <http:%x> <httpM:%x> <IdentSdip:%x> <IdentSdipM:%x> <DF:%x> <MF:%x>\n",
					asic_acl.ipFOP_, asic_acl.ipFOM_, asic_acl.ipHttpFilter_, asic_acl.ipHttpFilterM_, asic_acl.ipIdentSrcDstIp_,
					asic_acl.ipIdentSrcDstIpM_, asic_acl.ipDF_, asic_acl.ipMF_
				);
#endif /* RTL8650B */
				break;			

			case RTL8651_ACL_ICMP:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "ICMP", actionT[asic_acl.actionType_]);
				printf("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (asic_acl.dstIpAddr_>>24),
					((asic_acl.dstIpAddr_&0x00ff0000)>>16), ((asic_acl.dstIpAddr_&0x0000ff00)>>8),
					(asic_acl.dstIpAddr_&0xff), (asic_acl.dstIpAddrMask_>>24), ((asic_acl.dstIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.dstIpAddrMask_&0x0000ff00)>>8), (asic_acl.dstIpAddrMask_&0xff)
				);
				printf("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (asic_acl.srcIpAddr_>>24),
					((asic_acl.srcIpAddr_&0x00ff0000)>>16), ((asic_acl.srcIpAddr_&0x0000ff00)>>8),
					(asic_acl.srcIpAddr_&0xff), (asic_acl.srcIpAddrMask_>>24), ((asic_acl.srcIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.srcIpAddrMask_&0x0000ff00)>>8), (asic_acl.srcIpAddrMask_&0xff)
				);
				printf("\tTos: %x   TosM: %x   type: %x   typeM: %x   code: %x   codeM: %x\n",
					asic_acl.tos_, asic_acl.tosMask_, asic_acl.icmpType_, asic_acl.icmpTypeMask_, 
					asic_acl.icmpCode_, asic_acl.icmpCodeMask_);
				break;

			case RTL8651_ACL_IGMP:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "IGMP", actionT[asic_acl.actionType_]);
				printf("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (asic_acl.dstIpAddr_>>24),
					((asic_acl.dstIpAddr_&0x00ff0000)>>16), ((asic_acl.dstIpAddr_&0x0000ff00)>>8),
					(asic_acl.dstIpAddr_&0xff), (asic_acl.dstIpAddrMask_>>24), ((asic_acl.dstIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.dstIpAddrMask_&0x0000ff00)>>8), (asic_acl.dstIpAddrMask_&0xff)
				);
				printf("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (asic_acl.srcIpAddr_>>24),
					((asic_acl.srcIpAddr_&0x00ff0000)>>16), ((asic_acl.srcIpAddr_&0x0000ff00)>>8),
					(asic_acl.srcIpAddr_&0xff), (asic_acl.srcIpAddrMask_>>24), ((asic_acl.srcIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.srcIpAddrMask_&0x0000ff00)>>8), (asic_acl.srcIpAddrMask_&0xff)
				);
				printf("\tTos: %x   TosM: %x   type: %x   typeM: %x\n", asic_acl.tos_, asic_acl.tosMask_,
					asic_acl.igmpType_, asic_acl.igmpTypeMask_
				);
				break;

			case RTL8651_ACL_TCP:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "TCP", actionT[asic_acl.actionType_]);
				printf("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (asic_acl.dstIpAddr_>>24),
					((asic_acl.dstIpAddr_&0x00ff0000)>>16), ((asic_acl.dstIpAddr_&0x0000ff00)>>8),
					(asic_acl.dstIpAddr_&0xff), (asic_acl.dstIpAddrMask_>>24), ((asic_acl.dstIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.dstIpAddrMask_&0x0000ff00)>>8), (asic_acl.dstIpAddrMask_&0xff)
				);
				printf("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (asic_acl.srcIpAddr_>>24),
					((asic_acl.srcIpAddr_&0x00ff0000)>>16), ((asic_acl.srcIpAddr_&0x0000ff00)>>8),
					(asic_acl.srcIpAddr_&0xff), (asic_acl.srcIpAddrMask_>>24), ((asic_acl.srcIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.srcIpAddrMask_&0x0000ff00)>>8), (asic_acl.srcIpAddrMask_&0xff)
				);
				printf("\tTos:%x  TosM:%x  sportL:%d  sportU:%d  dportL:%d  dportU:%d\n",
					asic_acl.tos_, asic_acl.tosMask_, asic_acl.tcpSrcPortLB_, asic_acl.tcpSrcPortUB_,
					asic_acl.tcpDstPortLB_, asic_acl.tcpDstPortUB_
				);
				printf("\tflag: %x  flagM: %x  <URG:%x> <ACK:%x> <PSH:%x> <RST:%x> <SYN:%x> <FIN:%x>\n",
					asic_acl.tcpFlag_, asic_acl.tcpFlagMask_, asic_acl.tcpURG_, asic_acl.tcpACK_,
					asic_acl.tcpPSH_, asic_acl.tcpRST_, asic_acl.tcpSYN_, asic_acl.tcpFIN_
				);
				break;

			case RTL8651_ACL_UDP:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "UDP", actionT[asic_acl.actionType_]);
				printf("\tdip: %d.%d.%d.%d dipM: %d.%d.%d.%d\n", (asic_acl.dstIpAddr_>>24),
					((asic_acl.dstIpAddr_&0x00ff0000)>>16), ((asic_acl.dstIpAddr_&0x0000ff00)>>8),
					(asic_acl.dstIpAddr_&0xff), (asic_acl.dstIpAddrMask_>>24), ((asic_acl.dstIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.dstIpAddrMask_&0x0000ff00)>>8), (asic_acl.dstIpAddrMask_&0xff)
				);
				printf("\tsip: %d.%d.%d.%d sipM: %d.%d.%d.%d\n", (asic_acl.srcIpAddr_>>24),
					((asic_acl.srcIpAddr_&0x00ff0000)>>16), ((asic_acl.srcIpAddr_&0x0000ff00)>>8),
					(asic_acl.srcIpAddr_&0xff), (asic_acl.srcIpAddrMask_>>24), ((asic_acl.srcIpAddrMask_&0x00ff0000)>>16),
					((asic_acl.srcIpAddrMask_&0x0000ff00)>>8), (asic_acl.srcIpAddrMask_&0xff)
				);
				printf("\tTos:%x  TosM:%x  sportL:%d  sportU:%x  dportL:%d  dportU:%d\n",
					asic_acl.tos_, asic_acl.tosMask_, asic_acl.udpSrcPortLB_, asic_acl.udpSrcPortUB_,
					asic_acl.udpDstPortLB_, asic_acl.udpDstPortUB_
				);
				break;				

			case RTL8651_ACL_IFSEL:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "UDP", actionT[asic_acl.actionType_]);
				printf("\tgidxSel: %x\n", asic_acl.gidxSel_);
				break;

			case RTL8651_ACL_SRCFILTER:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "Source Filter", actionT[asic_acl.actionType_]);
				printf("\tSMAC: %x:%x:%x:%x:%x:%x  SMACM: %x:%x:%x:%x:%x:%x\n", 
					asic_acl.srcFilterMac_.octet[0], asic_acl.srcFilterMac_.octet[1], asic_acl.srcFilterMac_.octet[2], 
					asic_acl.srcFilterMac_.octet[3], asic_acl.srcFilterMac_.octet[4], asic_acl.srcFilterMac_.octet[5],
					asic_acl.srcFilterMacMask_.octet[0], asic_acl.srcFilterMacMask_.octet[1], asic_acl.srcFilterMacMask_.octet[2],
					asic_acl.srcFilterMacMask_.octet[3], asic_acl.srcFilterMacMask_.octet[4], asic_acl.srcFilterMacMask_.octet[5]
				);
				printf("\tsvidx: %d   svidxM: %x   sport: %d   sportM: %x   ProtoType: %x\n",
					asic_acl.srcFilterVlanIdx_, asic_acl.srcFilterVlanIdxMask_, asic_acl.srcFilterPort_, asic_acl.srcFilterPortMask_,
					(asic_acl.srcFilterIgnoreL3L4_==TRUE? 2: (asic_acl.srcFilterIgnoreL4_ == 1? 1: 0))
				);
				printf("\tsip: %d.%d.%d.%d   sipM: %d.%d.%d.%d\n", (asic_acl.srcFilterIpAddr_>>24),
					((asic_acl.srcFilterIpAddr_&0x00ff0000)>>16), ((asic_acl.srcFilterIpAddr_&0x0000ff00)>>8),
					(asic_acl.srcFilterIpAddr_&0xff), (asic_acl.srcFilterIpAddrMask_>>24),
					((asic_acl.srcFilterIpAddrMask_&0x00ff0000)>>16), ((asic_acl.srcFilterIpAddrMask_&0x0000ff00)>>8),
					(asic_acl.srcFilterIpAddrMask_&0xff)
				);
				printf("\tsportL: %d   sportU: %d\n", asic_acl.srcFilterPortLowerBound_, asic_acl.srcFilterPortUpperBound_);
				break;

			case RTL8651_ACL_DSTFILTER:
				printf(" [%d] rule type: %s   rule action: %s\n", start, "Deatination Filter", actionT[asic_acl.actionType_]);
				printf("\tDMAC: %x:%x:%x:%x:%x:%x  DMACM: %x:%x:%x:%x:%x:%x\n", 
					asic_acl.dstFilterMac_.octet[0], asic_acl.dstFilterMac_.octet[1], asic_acl.dstFilterMac_.octet[2], 
					asic_acl.dstFilterMac_.octet[3], asic_acl.dstFilterMac_.octet[4], asic_acl.dstFilterMac_.octet[5],
					asic_acl.dstFilterMacMask_.octet[0], asic_acl.dstFilterMacMask_.octet[1], asic_acl.dstFilterMacMask_.octet[2],
					asic_acl.dstFilterMacMask_.octet[3], asic_acl.dstFilterMacMask_.octet[4], asic_acl.dstFilterMacMask_.octet[5]
				);
				printf("\tdvidx: %d   dvidxM: %x  ProtoType: %x   dportL: %d   dportU: %d\n",
					asic_acl.dstFilterVlanIdx_, asic_acl.dstFilterVlanIdxMask_, 
					(asic_acl.dstFilterIgnoreL3L4_==TRUE? 2: (asic_acl.dstFilterIgnoreL4_ == 1? 1: 0)), 
					asic_acl.dstFilterPortLowerBound_, asic_acl.dstFilterPortUpperBound_
				);
				printf("\tdip: %d.%d.%d.%d   dipM: %d.%d.%d.%d\n", (asic_acl.dstFilterIpAddr_>>24),
					((asic_acl.dstFilterIpAddr_&0x00ff0000)>>16), ((asic_acl.dstFilterIpAddr_&0x0000ff00)>>8),
					(asic_acl.dstFilterIpAddr_&0xff), (asic_acl.dstFilterIpAddrMask_>>24),
					((asic_acl.dstFilterIpAddrMask_&0x00ff0000)>>16), ((asic_acl.dstFilterIpAddrMask_&0x0000ff00)>>8),
					(asic_acl.dstFilterIpAddrMask_&0xff)
				);
				break;

			default: assert(0);

			}

			/* Action type */
			switch (asic_acl.actionType_) {

			case RTL8651_ACL_PERMIT: /* 0x00 */
			case RTL8651_ACL_REDIRECT: /* 0x01 */
			case RTL8651_ACL_CPU: /* 0x03 */
			case RTL8651_ACL_DROP: /* 0x02, 0x04 */
			case RTL8651_ACL_DROP_LOG: /* 0x05 */
			case RTL8651_ACL_MIRROR: /* 0x06 */
			case RTL8651_ACL_REDIRECT_PPPOE: /* 0x07 */
			case RTL8651_ACL_MIRROR_KEEP_MATCH: /* 0x09 */
				printf("\tdvidx: %d   hp: %d   pppoeIdx: %d   nxtHop:%d  ", asic_acl.dvid_, asic_acl.priority_,
						asic_acl.pppoeIdx_, asic_acl.nextHop_);
				break;

			case RTL8651_ACL_POLICY: /* 0x08 */
				printf("\thp: %d   nxtHopIdx: %d  ", asic_acl.priority_, asic_acl.nhIndex);
				break;

			case RTL8651_ACL_DROP_RATE_EXCEED_PPS: /* 0x0a */
			case RTL8651_ACL_LOG_RATE_EXCEED_PPS: /* 0x0b */
			case RTL8651_ACL_DROP_RATE_EXCEED_BPS: /* 0x0c */
			case RTL8651_ACL_LOG_RATE_EXCEED_BPS: /* 0x0d */
				printf("\trlIdx: %d  ", asic_acl.rlIndex);
				break;
			default: assert(0);
			
			}
			printf("pktOpApp: %d\n", asic_acl.pktOpApp);
			
			


#if 0

#ifdef RTL8650B
			printf("\tpkgopt: %x\n", asic_acl.pktOpApp);
#endif /* RTL8650B */
			if (asic_acl.actionType_ < 8 || asic_acl.actionType_ == 9) {
				printf("\tdvidx: %d   hp: %d   pppoeIdx: %d   nxtHop:%d\n", asic_acl.dvid_, asic_acl.priority_,
					asic_acl.pppoeIdx_, asic_acl.nextHop_
				);
#ifdef RTL8650B				
			} else if (asic_acl.actionType_ == 8) {
				printf("\thp: %d   nxtHopIdx: %d\n", asic_acl.priority_, asic_acl.nhIndex);
			} else {
				printf("\trlIdx: %d\n", asic_acl.rlIndex);
#endif /* RTL8650B */
			}
#endif



			
		}

		if (outRule == FALSE) {
			start = asic_vlan.outAclStart; end = asic_vlan.outAclEnd;
			outRule = TRUE;
			goto again;
		}
	}

}

static void dump_alg(void) {
	rtl865x_tblAsicDrv_algParam_t asic_alg;
	uint32 idx, entry=0;

	printf(">>ASIC ALG Table:\n");
	for(idx=0; idx<RTL8651_ALGTBL_SIZE; idx++) {
		if (rtl8651_getAsicAlg(idx, &asic_alg) == FAILED)
			continue;
		printf("\t[%d]   port(%d)\n", idx, asic_alg.port);
		entry++;
	}
	printf("Total entry: %d\n", entry);
}

void dump_tcpudp(void)
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t asic_tcpudp;
	uint32 idx, entry=0;

	printf(">>ASIC NAPT TCP/UDP Table:\n");

	for(idx=0; idx<RTL8651_TCPUDPTBL_SIZE; idx++) {
		if (rtl8651_getAsicNaptTcpUdpTable(idx, &asic_tcpudp) == FAILED)
			continue;
#ifdef CONFIG_RTL865XB_EXP_HASH2
		if (asic_tcpudp.isValid == 1 || asic_tcpudp.isDedicated == 1 ) {
#else
		if (asic_tcpudp.isValid == 1 ) {
#endif /* CONFIG_RTL865XB_EXP_HASH2 */
#ifdef  CONFIG_RTL865XB_EXP_HASH2
			printf("[%4d] %d.%d.%d.%d:%d {V,D}={%d,%d} col1(%d) col2(%d) static(%d) tcp(%d)\n",
			       idx,
			       asic_tcpudp.insideLocalIpAddr>>24, (asic_tcpudp.insideLocalIpAddr&0x00ff0000) >> 16,
			       (asic_tcpudp.insideLocalIpAddr&0x0000ff00)>>8, asic_tcpudp.insideLocalIpAddr&0x000000ff,
			       asic_tcpudp.insideLocalPort, 
			       asic_tcpudp.isValid, asic_tcpudp.isDedicated,
			       asic_tcpudp.isCollision, asic_tcpudp.isCollision2, asic_tcpudp.isStatic, asic_tcpudp.isTcp );

			printf("         age(%d) offset(%d) tcpflag(%d) SelEIdx(%d) SelIPIdx(%d)\n",
			        asic_tcpudp.ageSec, asic_tcpudp.offset<<10, asic_tcpudp.tcpFlag, 
			        asic_tcpudp.selEIdx, asic_tcpudp.selExtIPIdx );
#else
			printf("[%4d] %d.%d.%d.%d:%d {V}={%d} col1(%d) static(%d) tcp(%d)\n",
			       idx,
			       asic_tcpudp.insideLocalIpAddr>>24, (asic_tcpudp.insideLocalIpAddr&0x00ff0000) >> 16,
			       (asic_tcpudp.insideLocalIpAddr&0x0000ff00)>>8, asic_tcpudp.insideLocalIpAddr&0x000000ff,
			       asic_tcpudp.insideLocalPort, 
			       asic_tcpudp.isValid, asic_tcpudp.isCollision, asic_tcpudp.isStatic, asic_tcpudp.isTcp );

			printf("         age(%d) offset(%d) tcpflag(%d) \n",
			        asic_tcpudp.ageSec, asic_tcpudp.offset<<10, asic_tcpudp.tcpFlag );

#endif /* CONFIG_RTL865XB_EXP_HASH2 */
			entry++;
		}
	}
	printf("Total entry: %d\n", entry);
}

static void dump_icmp(void)
{
	rtl865x_tblAsicDrv_naptIcmpParam_t asic_icmp;
	uint32 idx;

	printf(">>ASIC NAPT ICMP Table:\n");
	for(idx=0; idx<RTL8651_ICMPTBL_SIZE; idx++) {
		if (rtl8651_getAsicNaptIcmpTable(idx, &asic_icmp) == FAILED)
			continue;
		

	}

}

void dump_ip(void)
{
	rtl865x_tblAsicDrv_extIntIpParam_t asic_ip;
	uint32 idx;

	printf(">>ASIC IP Table:\n");
	for(idx=0; idx<RTL8651_IPTABLE_SIZE; idx++) {
		if (rtl8651_getAsicExtIntIpTable(idx, &asic_ip) == FAILED) {
			printf("\t[%d]  (Invalid)\n", idx);
			continue;
		}
#if 1
		printf("\t[%d]  intip(%d.%d.%d.%d) extip(%d.%d.%d.%d) type(%s) nhIdx(%d)\n", idx, 
			(asic_ip.intIpAddr>>24), ((asic_ip.intIpAddr&0x00ff0000)>>16), ((asic_ip.intIpAddr&0x0000ff00)>>8), (asic_ip.intIpAddr&0xff),
			(asic_ip.extIpAddr>>24), ((asic_ip.extIpAddr&0x00ff0000)>>16), ((asic_ip.extIpAddr&0x0000ff00)>>8), (asic_ip.extIpAddr&0xff),
			(asic_ip.localPublic==TRUE? "lp": (asic_ip.nat==TRUE? "nat": "napt")), asic_ip.nhIndex);
#else
		printf("\t[%d]  intip(%d.%d.%d.%d) extip(%d.%d.%d.%d) type(%s)\n", idx, 
			(asic_ip.intIpAddr>>24), ((asic_ip.intIpAddr&0x00ff0000)>>16), ((asic_ip.intIpAddr&0x0000ff00)>>8), (asic_ip.intIpAddr&0xff),
			(asic_ip.extIpAddr>>24), ((asic_ip.extIpAddr&0x00ff0000)>>16), ((asic_ip.extIpAddr&0x0000ff00)>>8), (asic_ip.extIpAddr&0xff),
			(asic_ip.localPublic==TRUE? "lp": (asic_ip.nat==TRUE? "nat": "napt")));

#endif /* RTL8650B */
	}
}

static void dump_sp(void)
{
	rtl865x_tblAsicDrv_serverPortParam_t asic_sp;
	uint32 idx;

	printf(">>ASIC Server Port Table:\n");
	for(idx=0; idx<RTL8651_SERVERPORTTBL_SIZE; idx++) {
		if (rtl8651_getAsicServerPortTable(idx, &asic_sp) == FAILED) {
			printf("\t[%d]  (Invalid)\n", idx);
			continue;
		}
#ifdef RTL8650B
		printf("\t[%d]  extIP(%d.%d.%d.%d) extPort(%d) intIP(%d.%d.%d.%d) intPort(%d) nhIndex(%d) isRange(%d)\n",
			idx, (asic_sp.extIpAddr>>24), ((asic_sp.extIpAddr&0x00ff0000)>>16), ((asic_sp.extIpAddr&0x0000ff00)>>8), (asic_sp.extIpAddr&0xff),
			asic_sp.extPort,
			 (asic_sp.intIpAddr>>24), ((asic_sp.intIpAddr&0x00ff0000)>>16), ((asic_sp.intIpAddr&0x0000ff00)>>8), (asic_sp.intIpAddr&0xff),
			asic_sp.intPort, asic_sp.nhIndex, asic_sp.portRange);
#else
		printf("\t[%d]  extIP(%d.%d.%d.%d) extPort(%d) intIP(%d.%d.%d.%d) intPort(%d)\n",
			idx, (asic_sp.extIpAddr>>24), ((asic_sp.extIpAddr&0x00ff0000)>>16), ((asic_sp.extIpAddr&0x0000ff00)>>8), (asic_sp.extIpAddr&0xff),
			asic_sp.extPort,
			 (asic_sp.intIpAddr>>24), ((asic_sp.intIpAddr&0x00ff0000)>>16), ((asic_sp.intIpAddr&0x0000ff00)>>8), (asic_sp.intIpAddr&0xff),
			asic_sp.intPort);

#endif /* RTL8650B */
	}
}

static void dump_ptrap(void)
{
	rtl865x_tblAsicDrv_protoTrapParam_t asic_ptrap;
	uint32 idx;
	int8 isEnable;
	
	printf(">> Protocol Trap Table:\n");
	for(idx=0; idx<RTL8651_PROTOCOLTRAP_SIZE; idx++)
		if (rtl8651_getAsicProtoTrap(idx, &asic_ptrap) == FAILED)
			printf("\t[%d]  Invalid\n", idx);
		else printf("\t[%d]  type(%x) content(%x)\n", idx, asic_ptrap.type, asic_ptrap.content);
	printf("\n");
	rtl8651_getHardwiredProtoTrap(0x00, 0x0806, &isEnable); 
	printf("\t[0]  ARP %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x00, 0x8035, &isEnable); 
	printf("\t[1]  RARP %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x00, 0x8863, &isEnable); 
	printf("\t[2]  PPPoE %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x01, 0x0002, &isEnable); 
	printf("\t[3]  IGMP, DVMRP and PIMv1 %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x01, 0x0043, &isEnable); 
	printf("\t[4]  BOOTPs/DHCP %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x01, 0x0044, &isEnable); 
	printf("\t[5]  BOOTPc/DHCP %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x01, 0x0059, &isEnable); 
	printf("\t[6]  OSPF %s\n", isEnable==TRUE? "on": "off");
	rtl8651_getHardwiredProtoTrap(0x03, 0x0208, &isEnable); 
	printf("\t[7]  RIP %s\n", isEnable==TRUE? "on": "off");
}

static void dump_pppoe(void)
{
	uint32 curSessionId, nextSessionId, * sessionIdPtr;
	rtl865x_tblDrv_basicCounterParam_t pppoeCntr;
	rtl865x_tblAsicDrv_pppoeParam_t asic_pppoe;
	uint32 idx, entry=0;
	uint16 sessionId, *retSessionIdPtr;

	printf(">>ASIC PPPoE Table:\n");
	for(idx=0; idx<RTL8651_PPPOETBL_SIZE; idx++) {
		if (rtl8651_getAsicPppoe(idx, &asic_pppoe) == FAILED)
			continue;
#ifdef RTL8650B
		printf("\t[%d]  %d age(%d)\n", idx, asic_pppoe.sessionId, asic_pppoe.age);		
#else
		printf("\t[%d]  %d\n", idx, asic_pppoe.sessionId);
#endif /* RTL8650B */
		entry++;
	}
	printf("Total entry: %d\n", entry);

	retSessionIdPtr = _rtl8651_getNextPppoeActiveSession(NULL, &sessionId);
	idx = 0;
	if(retSessionIdPtr == NULL)
		printf("No active session ID exist\n");
	else {
		while(retSessionIdPtr) {
			printf("<%02d> Active session ID %x \n", idx++, *retSessionIdPtr);
			retSessionIdPtr = _rtl8651_getNextPppoeActiveSession(retSessionIdPtr, &sessionId);
		}
	}
	
	sessionIdPtr = rtl8651_getNextPppoeSession(NULL, &nextSessionId);
	do {
		if(rtl8651_getPppoeCounter(*sessionIdPtr, &pppoeCntr)==SUCCESS) {
			printk("PPPoE session ID %u\n", *sessionIdPtr);
			printk("\tReceive %u packets %u Bytes %u Errors\n", pppoeCntr.rxPackets, pppoeCntr.rxBytes, pppoeCntr.rxErrors);
			printk("\tTransmit %u Packets %u Bytes Drop %u packets\n", pppoeCntr.txPackets, pppoeCntr.txBytes, pppoeCntr.drops);
		}
		curSessionId = *sessionIdPtr;
	} while(sessionIdPtr = rtl8651_getNextPppoeSession(&curSessionId, &nextSessionId));
	
}

void dump_vlan(void)
{
	uint8	*pst[] = { "Disable", "Blk/Lst", "Learn", "Fwd" };
	rtl865x_tblAsicDrv_vlanParam_t asic_vlan;
	uint16 vid, j;

	printf(">>ASIC Vlan Table:\n");
	for(vid=1; vid<4095; vid++) {
		if (rtl8651_getAsicVlan(vid, &asic_vlan) == FAILED)
			continue;
		printf("  VID[%d] %x:%x:%x:%x:%x:%x mbr(0x%-x) inAclStart(%d) inAclEnd(%d)\n", 
			vid, asic_vlan.macAddr.octet[0], asic_vlan.macAddr.octet[1], asic_vlan.macAddr.octet[2],
			asic_vlan.macAddr.octet[3], asic_vlan.macAddr.octet[4], asic_vlan.macAddr.octet[5],
			asic_vlan.memberPortMask&0x3f, asic_vlan.inAclStart, asic_vlan.inAclEnd
		);
#ifdef RTL8650B
		printf("      outAclStart(%d) outAclEnd(%d) int(%d) enrtr(%d) bc2cpu(%d) prom(%d), dmz(%d)\n",
			asic_vlan.outAclStart, asic_vlan.outAclEnd, asic_vlan.internal, asic_vlan.enableRoute,
			asic_vlan.broadcastToCpu, asic_vlan.promiscuous, asic_vlan.DMZFlag
		);
#else
		printf("      outAclStart(%d) outAclEnd(%d) int(%d) enrtr(%d) bc2cpu(%d) prom(%d)\n",
			asic_vlan.outAclStart, asic_vlan.outAclEnd, asic_vlan.internal, asic_vlan.enableRoute,
			asic_vlan.broadcastToCpu, asic_vlan.promiscuous
		);
#endif /* RTL8650B */
		printf("      vlanuntag(0x%-x) macMask(%d) mtu(%d)\n",
			asic_vlan.untagPortMask&0x3f, asic_vlan.macAddrNumber, asic_vlan.mtu
		);

		printf("      pst(");
		for(j=0; j<RTL8651_PORT_NUMBER; j++) {
			if (asic_vlan.memberPortMask & ((0x1)<<j))
				printf("<%d>%s ", j, pst[(int32)asic_vlan.portState[j]]);
			else printf("<%d>no ", j);
		}					
//#ifdef RTL8650B
		printf("\n      ExtMBR(0x%-x), ExtVlanUntag(0x%-x)\n",
			(asic_vlan.memberPortMask>>RTL8651_PORT_NUMBER),
			(asic_vlan.untagPortMask>>RTL8651_PORT_NUMBER)
		);
		printf("      Extpst(");
		for(j=RTL8651_PORT_NUMBER; j<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; j++) {
			if (asic_vlan.memberPortMask & ((0x1)<<j))
				printf("<%d>%s ", j, pst[(int32)asic_vlan.portState[j]]);
			else printf("<%d>no ", j);
		}
//#endif /* RTL8650B */

		printf("\n");
	}
	printf("\n");
}

static void dump_pvid(void)
{
	uint32 vidp[6];
	uint32  port;

	for(port=0; port<RTL8651_PORT_NUMBER; port++)
		assert(rtl8651_getAsicPvid(port, &vidp[port]) == SUCCESS);
	printf(">> PVID Reg:\n");
	printf("   vidp0: %d, vidp1: %d, vidp2: %d, vidp3: %d, vidp4: %d, vidp5: %d\n",
		vidp[0], vidp[1], vidp[2], vidp[3], vidp[4], vidp[5]);
}

static void dump_trunk(void)
{
	int32	i;
	uint32	portMask, mapping;
	
	assert(rtl8651_getAsicLinkAggregator(&portMask, &mapping) == SUCCESS);
	printf(">> Trunk Reg:\n");
	printf("   ");
	for(i=0; i<8; i++)
		printf("LMPR%-1d:%d  ", i, ((0x07<<(i*3))& mapping)>>(i*3));
	printf("\n   Trunk1PortMask: %x\n", portMask);
}

static void dump_gidx(void)
{
	uint32 i, gidxReg;
	
	assert(rtl8651_getAsicGidxRegister(&gidxReg) == SUCCESS);
	printf(">> GIDXReg:\n");
	for(i=0; i<8; i++)
		printf("   gidx%d: %d", i, (gidxReg>>(i*3))&0x7);
	printf("\n");
}


static void dump_nexthop(void) 
{
	rtl865x_tblAsicDrv_nextHopParam_t asic_nxthop;
	uint32 idx;

	printf(">>ASIC Next Hop Table:\n");
	for(idx=0; idx<RTL8651_NEXTHOPTBL_SIZE; idx++) {
		if (rtl8651_getAsicNextHopTable(idx, &asic_nxthop) == FAILED)
			continue;
		printf("\t[%d]  type(%s) IPIdx(%d) dstVid(%d) pppoeIdx(%d) nextHop(%d)\n", idx,
			(asic_nxthop.isPppoe==TRUE? "pppoe": "ethernet"), asic_nxthop.extIntIpIdx, 
			asic_nxthop.dvid, asic_nxthop.pppoeIdx, (asic_nxthop.nextHopRow<<2)+asic_nxthop.nextHopColumn);
	}
}


static void dump_mcast(void)
{
	rtl865x_tblAsicDrv_multiCastParam_t asic;
	uint32 entry;
	
	printf(">>ASIC Multicast Table:\n");
	for(entry=0; entry<RTL8651_MULTICASTTBL_SIZE; entry++) {
		if (rtl8651_getAsicIpMulticastTable(entry, &asic) != SUCCESS) {
			printf("\t[%d]  (Invalid Entry)\n", entry);
			continue;
		}
		printf("\t[%d]  Mip(%d.%d.%d.%d) sip(%d.%d.%d.%d) MBR(%x)\n", entry,
			asic.dip>>24, (asic.dip&0x00ff0000)>>16, (asic.dip&0x0000ff00)>>8, (asic.dip&0xff), 
			asic.sip>>24, (asic.sip&0x00ff0000)>>16, (asic.sip&0x0000ff00)>>8, (asic.sip&0xff),
			asic.mbr);
		printf("\t       svid:%d, spa:%d, EXtIP:%d, age:%d, cpu:%d\n", asic.svid, asic.port, asic.extIdx,
			asic.age, asic.cpu);
	}
}





static void dump_ratelimit(void)
{
	rtl865x_tblAsicDrv_rateLimitParam_t asic_rl;
	uint32 entry;
	
	printf("\n<<Rate Limit Table>>\n");
	for(entry=0; entry<RTL8651_RATELIMITTBL_SIZE; entry++) {
		if (rtl8651_getAsicRateLimitTable(entry, &asic_rl) == SUCCESS) {
			printf(" [%d]  Token(%d)  MaxToken(%d)  remain(%d)  refillTime(%d)  refillToken(%d)\n",
				entry, asic_rl.token, asic_rl.maxToken, asic_rl.t_remainUnit, asic_rl.t_remainUnit, asic_rl.refill_number);
		}
		else printf(" [%d]  Invalid entry\n", entry);
	}
	printf("\n");
}


int32 dump_pppoepassthru()
{
	printk("\n<<PPPoe Passthru>>\n");

#if 1//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU

	if ( rtl8651_gPPPoEExternalVlanIndex == RTL8651_VLAN_NUMBER )
		printk("External VLAN Index:  (INVALID)\n" );
	else
		printk("External VLAN Index:  %d\n", rtl8651_gPPPoEExternalVlanIndex );
		
	printk("         Gateway MAC: %02x:%02x:%02x:%02x:%02x:%02x\n", 
	       rtl8651_gPPPoEExternalGatewayMAC.octet[0], rtl8651_gPPPoEExternalGatewayMAC.octet[1], 
	       rtl8651_gPPPoEExternalGatewayMAC.octet[2], rtl8651_gPPPoEExternalGatewayMAC.octet[3], 
	       rtl8651_gPPPoEExternalGatewayMAC.octet[4], rtl8651_gPPPoEExternalGatewayMAC.octet[5] );

	if ( rtl8651_gPPPoEPassthruVlanID == RTL8651_PPPOEPASSTHRU_VLANID_IS_NOT_SET )
		printk("PPPoE Passthru VLAN Index: (INVALID)\n" );
	else
		printk("PPPoE Passthru VLAN Index: %d\n", rtl8651_gPPPoEPassthruVlanID );

	printk("\n");

#else//CONFIG_RTL865XB

	printk("\n");

#endif//CONFIG_RTL865XB

	return SUCCESS;
}


/*
	Dump Protocol-Based NAT
*/
int32 dump_pbnat()
{
	rtl8651_tblDrv_protocolBasedNat_t *pbNat;

	printk("<<Protocol-Based NAT>>\n");
	printk("Protocol    ExtIp            IntIp\n");
	
	for( pbNat = SLIST_FIRST(&DrvTbl.inuseList.protocolBasedNat);
	     pbNat != NULL;
	     pbNat = SLIST_NEXT(pbNat,next) )
	{
		printk( "%03d         %3d.%3d.%3d.%3d  %3d.%3d.%3d.%3d\n",
		        pbNat->protocol,
		        pbNat->ExtIp>>24, (pbNat->ExtIp>>16)&0xff, (pbNat->ExtIp>>8)&0xff, pbNat->ExtIp&0xff,
		        pbNat->IntIp>>24, (pbNat->IntIp>>16)&0xff, (pbNat->IntIp>>8)&0xff, pbNat->IntIp&0xff );
	}
	printk("\n");

	return SUCCESS;
}



/*
	Dump Protocol-Based VLAN
*/
int32 dump_pbvlan()
{
	int32 ruleNo, port;

	printk("<<Protocol-Based VLAN>>\n");
	printk("Protocol      P0 P1 P2 P3 P4 P5 E0 E1 E2\n");
	
	for( ruleNo = 1; ruleNo <= 6; ruleNo++  )
	{
		switch( ruleNo )
		{
			case 1: printk("%-12s  ", "IPX"); break;
			case 2: printk("%-12s  ", "NetBIOS"); break;
			case 3: printk("%-12s  ", "PPPoEControl"); break;
			case 4: printk("%-12s  ", "PPPoESession"); break;
			case 5: printk("%-12s  ", "Rule 5"); break;
			case 6: printk("%-12s  ", "Rule 6"); break;
		}

		for( port = 0; port < RTL8651_PORT_NUMBER + 3; port++ )
		{
			uint8 valid, vlanIdx;
			rtl8651_getProtocolBasedVLAN( ruleNo, port, &valid, &vlanIdx );

			if ( valid )
				printk( " %1d ", vlanIdx );
			else
				printk( " - " );
		}
		printk("\n");
	}
	printk("\n");

	return SUCCESS;
}

int32 dump_counter()
{
	int32 counterIdx, port;
	uint32 regValue;
	rtl865x_tblAsicDrv_basicCounterParam_t basicCounter;
	
	printk("<<Counter Information>>\n");
	
	for( counterIdx = 0; counterIdx < 3; counterIdx++  )
	{
		if(rtl8651_getAsicCounter(counterIdx, &basicCounter) == FAILED)
			printk("Unable to get counter %d\n", counterIdx);
		else
			printk("Counter %d: ", counterIdx);
		for( port = 0; port < RTL8651_PORT_NUMBER + 3; port++ )
		{
			if ( basicCounter.mbr & (1<<port))
				printk( " %1d ", port);
		}
		printk("\nRx %u Bytes, Rx %u Pkts, Drop %u pkts, Error %u pkts\n", basicCounter.rxBytes, basicCounter.rxPackets, basicCounter.drops, basicCounter.rxErrors);
		printk("Tx %u Bytes, Tx %u Pkts, , CPU %u pkts,\n", basicCounter.txBytes, basicCounter.txPackets, basicCounter.cpus);
		
	}
	printk("\n");

	return SUCCESS;
}



static uint32 cmd_Interpreter(int32 cmdArgc, int8 *cmdArgv[]) {
	uint32 runGroup, caseId, idx;
	uint32 totalCase=0, failCase = 0;
	int32 retval;
	int32 failCaseIdx[sizeof(emuCase_array)/sizeof(emuCase_t)];
 
	switch(ACTION_TYPE(cmdArgv[0]))
	{
	case CMD_RUN:
		if (cmdArgc == 0) {
			Usage_run();
			return 1;
		}

		if (rtl8651_tblDrvReinit() != SUCCESS) {
			printf("drvTest: rtl8651_tblDrvReinit() error!!\n");
			return 1;
		}
		#if 0
		if (mBuf_Reinit() != SUCCESS) {
			printf("drvTest: mBuf_Reinit() error!!\n");
			return 1;
		}
		#endif
		if (rtl8651_fwdEngineReinit() != SUCCESS) {
			printf("drvTest: rtl8651_fwdEngineReinit() error!!\n");
			return 1;
		}
		if (rtl8651_reinitDrvMutex() != SUCCESS) {
			printf("drvTest: rtl8651_reinitDrvMutex() error!!\n");
			return 1;
		}
		if (rtl8651_reinitMbufMutex() != SUCCESS) {
			printf("drvTest: rtl8651_reinitMbufMutex() error!!\n");
			return 1;
		}
		if ((runGroup=RUN_CASETYPE(cmdArgv[1])) == 0) {
			if (cmdArgc == 2)
			{
				uint32 caseStart, caseStop;
				caseStart = atoi(cmdArgv[1]);
				caseStop = atoi(cmdArgv[2]);

				for (idx = 0 ; emuCase_array[idx].fun_t ; idx++)
					if (((caseId = emuCase_array[idx].caseID) >= caseStart) &&
						(emuCase_array[idx].caseID <= caseStop)){
							if (rtl8651_tblDrvReinit() != SUCCESS) {
								printf("drvTest: rtl8651_tblDrvReinit() error!!\n");
								return 1;
							}
							#if 0
							if (mBuf_Reinit() != SUCCESS) {
								printf("drvTest: mBuf_Reinit() error!!\n");
								return 1;
							}
							#endif
							if (rtl8651_fwdEngineReinit() != SUCCESS) {
								printf("drvTest: rtl8651_fwdEngineReinit() error!!\n");
								return 1;
							}
							if (rtl8651_reinitDrvMutex() != SUCCESS) {
								printf("drvTest: rtl8651_reinitDrvMutex() error!!\n");
								return 1;
							}
							if (rtl8651_reinitMbufMutex() != SUCCESS) {
								printf("drvTest: rtl8651_reinitMbufMutex() error!!\n");
								return 1;
							}
							totalCase ++;
							if (((retval = emuCase_array[idx].fun_t(caseId)) == SUCCESS)
								&& (rtl8651_getDrvMutex()==0)
								&& (rtl8651_getMbufMutex()==0) )
								printf("ok!\n\n");
							else 
							{
								/* Record the fail case */
								failCaseIdx[failCase] =idx;
								failCase++; 
								if (retval != SUCCESS)
									printf("\033[31;43m fail!! \033[m\n\n"); 
								else if ( rtl8651_getDrvMutex() || rtl8651_getMbufMutex())
								{
									if (rtl8651_getDrvMutex())
										printf("\033[31;43m [DrvMutex] is not be fully freed -- [%d]!! \033[m\n\n", rtl8651_getDrvMutex()); 
									if (rtl8651_getMbufMutex())
										printf("\033[31;43m [MbufMutex] is not be fully freed -- [%d]!! \033[m\n\n", rtl8651_getMbufMutex()); 
								}
							}
						}
			}else
			{
				caseId = atoi(cmdArgv[1]);
				for(idx=0; emuCase_array[idx].fun_t; idx++) {
					if (caseId == emuCase_array[idx].caseID) {
						totalCase ++;
						if (((retval = emuCase_array[idx].fun_t(caseId)) == SUCCESS)
							&& (rtl8651_getDrvMutex()==0)
							&& (rtl8651_getMbufMutex()==0) )
							printf(" ok!\n\n");
						else 
						{ 
							/* Record the fail case */
							failCaseIdx[failCase] = idx;
							failCase++;
							if (retval != SUCCESS)
								printf("\033[31;43m fail!! \033[m\n\n"); 
							else if ( rtl8651_getDrvMutex() || rtl8651_getMbufMutex())
							{
								if (rtl8651_getDrvMutex())
									printf("\033[31;43m [DrvMutex] is not be fully freed -- [%d]!! \033[m\n\n", rtl8651_getDrvMutex()); 
								if (rtl8651_getMbufMutex())
									printf("\033[31;43m [MbufMutex] is not be fully freed -- [%d]!! \033[m\n\n", rtl8651_getMbufMutex()); 
							}
						}
					}
				}
			}
		} else {
			for(idx=0; emuCase_array[idx].fun_t; idx++) {
				if (!(runGroup & emuCase_array[idx].groupID))
					continue;
				if (rtl8651_tblDrvReinit() != SUCCESS) {
					printf("drvTest: rtl8651_tblDrvReinit() error!!\n");
					return 1;
				}
				#if 0
				if (mBuf_Reinit() != SUCCESS) {
					printf("drvTest: mBuf_Reinit() error!!\n");
					return 1;
				}
				#endif
				if (rtl8651_fwdEngineReinit() != SUCCESS) {
					printf("drvTest: rtl8651_fwdEngineReinit() error!!\n");
					return 1;
				}
				if (rtl8651_reinitDrvMutex() != SUCCESS) {
					printf("drvTest: rtl8651_reinitDrvMutex() error!!\n");
					return 1;
				}
				if (rtl8651_reinitMbufMutex() != SUCCESS) {
					printf("drvTest: rtl8651_reinitMbufMutex() error!!\n");
					return 1;
				}
				totalCase ++;
				if (((retval = emuCase_array[idx].fun_t(emuCase_array[idx].caseID)) == SUCCESS)
						&& (rtl8651_getDrvMutex()==0)
						&& (rtl8651_getMbufMutex()==0) )
					printf(" ok!\n\n"); 
				else
				{
					/* Record the fail case */
					failCaseIdx[failCase] = idx;
					failCase++; 
					if (retval != SUCCESS)
						printf("\033[31;43m fail!! \033[m\n\n"); 
					else if ( rtl8651_getDrvMutex() || rtl8651_getMbufMutex())
					{
						if (rtl8651_getDrvMutex())
							printf("\033[31;43m [DrvMutex] is not be fully freed -- [%d]!! \033[m\n\n", rtl8651_getDrvMutex()); 
						if (rtl8651_getMbufMutex())
							printf("\033[31;43m [MbufMutex] is not be fully freed -- [%d]!! \033[m\n\n", rtl8651_getMbufMutex()); 
					}
				}
			}
		}
		printf(">>Total Case: %d,  Pass: %d,  Fail: %d\n\n", totalCase, totalCase-failCase, failCase);
		if ( failCase > 0 )
		{
			/* list fail cases */
			int i;
			
			printf("  +-- Failed Cases -----+\n");
			for( i = 0; i < failCase; i++ )
			{
				printf("  | case %5d ...      |\n", emuCase_array[failCaseIdx[i]].caseID );
			}
			printf("  +---------------------+\n\n");
		}
		break;
		
	case CMD_DL2:		dump_l2(); 		break;
	case CMD_DL3:		dump_l3(); 		break;
	case CMD_DARP:		dump_arp();		break;
	case CMD_DACL:		dump_acl();		break;
	case CMD_DALG:		dump_alg();		break;
	case CMD_DTCPUDP:	dump_tcpudp();	break;
	case CMD_DICMP:		dump_icmp();		break;
	case CMD_DIP:		dump_ip();		break;
	case CMD_DSP:		dump_sp();		break;
	case CMD_DPTRAP:		dump_ptrap();		break;
	case CMD_DPPPOE:		dump_pppoe();	break;
	case CMD_DVLAN:		dump_vlan();		break;
	case CMD_DPVID:		dump_pvid();		break;
	case CMD_DTRUNK:		dump_trunk();		break;
	case CMD_DGIDX:		dump_gidx();		break;
	case CMD_DNH:		dump_nexthop();	break;
	case CMD_DRL:		dump_ratelimit();	break;
	case CMD_DMCAST:		dump_mcast();		break;
	case CMD_DMBUF:		dump_mBuf();		break;
#ifdef RTL865XB_DCUT_SWVLAN
	case CMD_DSWVLAN:		dump_swVlan();		break;
#endif
	case CMD_EXIT:		return CMD_EXIT;
	case CMD_CHIP:{
		char chipVersion[16];
		int rev;
		if (cmdArgc == 0) {
			printf("Synopsis: chip { get | 8650 | 8651 | 8650B | 8651B } \n");
			return 1;
		}		
		if(strcmp(cmdArgv[1],"get")==0){
			rtl8651_getChipVersion(chipVersion, sizeof(chipVersion), &rev);
			printf("Testing %s chip, revision %d\n", chipVersion, rev);
		}else
			rtl8651_setChipVersion(cmdArgv[1],NULL);
		break;
		}

	case CMD_DPPPOEPASSTHUR: dump_pppoepassthru(); break;

	case CMD_DPBNAT:	dump_pbnat();	break;

	case CMD_DPBVLAN:	dump_pbvlan();	break;

	case CMD_COUNTER:	dump_counter(); break;

	case CMD_DCONNCNT:rtl8651_dumpConnCtrl(); break;

	default: 				Usage();
	}
	return 0;
}


static int8	*cmdArgv[] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };

uint32 cmd_Parser(int8 *cmd) {

	uint32	cmdArgc;
	int8	*cmdPtr;
	
	for(cmdPtr=cmd; *cmdPtr==' '; cmdPtr++);
		for(cmdArgc=0, cmdArgv[cmdArgc]=cmdPtr; *cmdPtr!='\0'; cmdPtr++)
			if (*cmdPtr == ' ') {
				cmdArgc++;
				*cmdPtr = '\0';
				cmdArgv[cmdArgc] = cmdPtr+1;
			}
	return(cmdArgc);
}


int main(int argc, char *argv[]) {
	int8	cmdString[200];
	// mbuf
	uint32 nmbufs, nmbclusters, nmpkthdrs, clusterSize;

	/* Always set to RTL8650B */
	rtl8651_initAsic();
	rtl8651_setChipVersion("8650B", NULL);

	/* Setting initial parameters */
	memset(&configPara, 0, sizeof(rtl8651_tblDrvInitPara_t));
	configPara.macAddressDbSize = 8;
	configPara.filterDbSize = 1024;
	configPara.networkIntfTableSize= 32;
	configPara.ipIntfEntryNumber= 64;
	configPara.ipIntfIpAddrNumber= 128;
	configPara.arpTableSize = 512;
	configPara.routingTableSize = 64;
	configPara.natSize = 8;
	configPara.natCtlSize = 32;
	configPara.naptTcpUdpFlowSize = 4096;
	configPara.naptIcmpFlowSize = 128;
	configPara.aclSize = 256;//128;
	configPara.algSize = 256;//128;
	configPara.naptServerPortEntryNumber = 64;
	configPara.dynamicPolicy = 32;
	configPara.dialSessionNumber = 8;
#ifdef RTL8650B
	configPara.policyRules = 32;
#endif /* RTL8650B */

	// mbuf
	nmbufs = 128;
	nmbclusters = 256;
	nmpkthdrs = 128;
	clusterSize = 2048;

	/* Initialize Table Driver and Asic Driver */
	printf("Table Driver Initialization......\t");
	if (rtl8651_tblDrvInit(&configPara) == FAILED) {
		printf("failure!!!!\n");
		return 1;
	} else printf("ok!\n");
	
	/* Initialize mbuf system */
	printf("Mbuf Initialization......\t\t");
	if (mBuf_init(nmbufs, nmbclusters, nmpkthdrs, clusterSize, 0) != SUCCESS){
		printf("failure!!!!\n");
		return 1;
	} else printf("ok!\n");

	/* Initialize forwarding engine */
	printf("Forward Engine Initialization......\t");
	if (rtl8651_fwdEngineInit(NULL) != SUCCESS){
		printf("failure!!!!\n");
		return 1;
	} else{
		mbufList_init();
		printf("ok!\n");
	}
	printf("\n");

	/* Begin Command Line */
	while(1) {
		char chipVersion[16];
		rtl8651_getChipVersion(chipVersion, sizeof(chipVersion),NULL);
		printf("Test%s> ",chipVersion); 
		cmdString[0] = '\0'; 
		//gets(cmdString);
		fgets(cmdString, (sizeof(cmdString)-1), stdin);
		strtok( cmdString, "\r\n" );
		if (cmdString[0] == '\0')
			continue;
		if (cmd_Interpreter(cmd_Parser(cmdString), cmdArgv) == CMD_EXIT)
			break;
	}
	return 0;
}

