/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : Forwarding Engine test module
* Abstract : 
* Creator : Edward Jin-Ru Chen (jzchen@realtek.com.tw)
* Author :  
*
* $Id: drvTest.h,v 1.1.1.1 2006/07/26 05:38:28 blue Exp $
*
* $Log: drvTest.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:28  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:21  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:39:57  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.8  2005/09/27 01:44:21  yjlou
* +: show heximal value for IS_EQUAL_INT() and IS_NOT_EQUAL_INT() for debug.
*
* Revision 1.7  2005/07/20 15:29:38  yjlou
* +: porting Model Code to Linux Kernel: check RTL865X_MODEL_KERNEL.
*
* Revision 1.6  2004/07/06 06:23:14  chhuang
* +: add rate limit testing code
*
* Revision 1.5  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.4  2004/04/23 06:55:25  chhuang
* add new testing code for multicast
*
* Revision 1.3  2004/03/04 09:45:40  chenyl
* *: move some MACROs from fwdTest.c to drvTest.h
*
* Revision 1.2  2004/03/02 08:20:46  tony
* add ALG Client test module
*
*
*/

#if defined(RTL865X_TEST)||defined(RTL865X_MODEL_USER)
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#endif
#include "assert.h"
#include "types.h"
#include "rtl8651_tblDrv.h"





/*=======================================
  * Macro definition: Basic Unit comparation
  *=======================================*/
  
#define ASSERT(value)\
do {\
	if (!((int32)(value))) {\
		rtlglue_printf("\t%s(%d): errno=%d, fail, so abort!\n", __FUNCTION__, __LINE__, 0);\
		return FAILED; \
	}\
}while (0)
#define START_TEST_CASE()	rtlglue_printf("@Running testing case %d(%s)......\n", caseNo, __FUNCTION__);

#define IS_EQUAL_BOOL(str, v1, v2, _f_, _l_) \
	if ( (v1) != (v2) ) { \
		rtlglue_printf("\t%s(%u): %s: %s, %s\n", _f_, _l_, str, (v1==1? "TRUE": "FALSE"), (v2==1? "TRUE": "FALSE")); \
		return FAILED; \
	}
#define IS_EQUAL_MAC(str, v1, v2, _f_, _l_) \
	if (memcmp((int8 *)&(v1), (int8 *)&(v2), 6)) { \
		rtlglue_printf("\t%s(%u): %s: %x:%x:%x:%x:%x:%x, %x:%x:%x:%x:%x:%x\n", _f_, _l_, str, v1.octet[0], v1.octet[1], v1.octet[2], v1.octet[3], v1.octet[4], v1.octet[5], v2.octet[0], v2.octet[1], v2.octet[2], v2.octet[3], v2.octet[4], v2.octet[5]); \
		return FAILED; \
	}
#define IS_EQUAL_IP(str, v1, v2, _f_, _l_) \
	if ((v1) != (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %d.%d.%d.%d, %d.%d.%d.%d\n", _f_, _l_, str, (v1>>24), (v1&0x00ff0000)>>16, (v1&0x0000ff00)>>8, (v1&0xff), (v2>>24), (v2&0x00ff0000)>>16, (v2&0x0000ff00)>>8, (v2&0xff)); \
		return FAILED; \
	}

// less or equal
#define IS_LE_INT(str, v1, v2, _f_, _l_) \
	if ((v1) > (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %d, %d\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}

// greater or equal
#define IS_GE_INT(str, v1, v2, _f_, _l_) \
	if ((v1) < (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %d, %d\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}

#define IS_EQUAL_INT(str, v1, v2, _f_, _l_) \
	if ((v1) != (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %d(0x%08x), %d(0x%08x)\n", _f_, _l_, str, v1, v1, v2, v2); \
		return FAILED; \
	}

 #define IS_NOT_EQUAL_INT(str, v1, v2, _f_, _l_) \
	if ((v1) == (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %d(0x%08x), %d(0x%08x)\n", _f_, _l_, str, v1, v1, v2, v2); \
		return FAILED; \
	}

#define IS_EQUAL_POINTER(str, v1, v2, _f_, _l_) \
	if ((v1) != (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %p, %p\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}
	
#define IS_NOT_EQUAL_POINTER(str, v1, v2, _f_, _l_) \
	if ((v1) == (v2)) { \
		rtlglue_printf("\t%s(%u): %s: %p, %p\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}
 
#define IS_EQUAL_STR(str, s1, s2, _f_, _l_) \
	if (strcmp(s1,s2)) {\
		rtlglue_printf("\t%s(%u): %s:\n\t%s\n\t%s\n", _f_, _l_, str, s1, s2); \
		return FAILED; \
	}


/*=======================================
  * Macro definition: ASIC Table comparation
  *=======================================*/
#define MCAST_ENTRY_CMP(entry1, entry2)		if (mcast_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define L2_ENTRY_CMP(entry1, entry2) 			if (l2_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define VLAN_ENTRY_CMP(entry1, entry2)		if (vlan_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define L3_ENTRY_CMP(entry1, entry2)			if (l3_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define IP_ENTRY_CMP(entry1, entry2)			if (ip_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define SP_ENTRY_CMP(entry1, entry2)			if (sp_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define PPPOE_ENTRY_CMP(entry1, entry2)		if (pppoe_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define NXTHOP_ENTRY_CMP(entry1, entry2) 	if (nxthop_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ARP_ENTRY_CMP(entry1, entry2)		if (arp_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define TCPUDP_ENTRY_CMP(entry1, entry2)		if (tcpudp_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ICMP_ENTRY_CMP(entry1, entry2)		if (icmp_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ALG_ENTRY_CMP(entry1, entry2)		if (alg_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ACL_ENTRY_CMP(entry1, entry2)		if (acl_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ACL_DEFAULT_TOCPU(index)			if (acl_default_tocpu(index, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ACL_DEFAULT_DROP(index)			if (acl_default_drop(index, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define ACL_DEFAULT_PERMIT(index)			if (acl_default_permit(index, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define RATELIMIT_ENTRY_CMP(entry1, entry2)	if (ratelimit_entry_cmp(entry1, entry2, __FUNCTION__, __LINE__)==FAILED) return FAILED;



/*=======================================
  * Global Variable:
  *=======================================*/
extern rtl8651_tblDrvInitPara_t configPara;


