/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : Forwarding Engine test module
* Abstract : 
* Creator : Edward Jin-Ru Chen (jzchen@realtek.com.tw)
* Author :  
*
* $Id: fwdTest.h,v 1.1.1.1 2006/07/26 05:38:29 blue Exp $
*
* $Log: fwdTest.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:29  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:24  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:00  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.99  2005/09/21 04:24:05  shliu
* *: add a remote management test case
*
* Revision 1.98  2005/09/20 14:41:09  shliu
* *: add remote management test cases
*
* Revision 1.97  2005/09/15 16:03:42  chenyl
* +: ARP testing code
*
* Revision 1.96  2005/08/15 10:53:28  chenyl
* +: new TRIGGER PORT mechanism
* 	- sip check when activate Trigger Port.
* 	- age timer for Triggered Port Mapping.
*
* Revision 1.95  2005/07/19 05:05:01  chenyl
* *: for Protocol-Stack TX, unknown unicast and multicast DMAC would be L2-broadcasted to all member-ports of destination vlan.
* *: In l3fastActRouting(), system would check arp cache's integrity before using it.
* *: bug fix, NAPTed UDP fragmentation forwarding typing error.
*
* Revision 1.94  2005/06/20 13:51:20  yjlou
* *: moves common macro from 'fwdTest.c' to 'fwdTest.h' for model code to include.
*
* Revision 1.93  2005/05/23 12:53:42  yjlou
* *: rename rtl8651_timeUpdate() to rtl8651_realtimeSchedule().
* +: ROME driver supports realtime PCM and tick interrupt for VoIP.
*
* Revision 1.92  2005/05/06 12:23:16  chenyl
* *: for outbound packet which match upnp mapping, ROME Drvier would use the mapped external ip/port
* 	to contribute this connection.
*
* *: tony: fix tcp upnp qos support problem.
*
* Revision 1.91  2005/04/30 07:32:41  yjlou
* +: add VoIP supporting of ROME driver
*
* Revision 1.90  2005/04/30 04:19:49  chenyl
* +: support (L2-Packet-filling + L3-Forwarding) offload Engine
*
* Revision 1.89  2005/04/14 12:58:33  shliu
* *: Add new acl matchType testing case.
*
* Revision 1.88  2005/04/02 08:47:32  chenyl
* *: bug fix: server port overlapping check without regardless of TCP/UDP
*
* Revision 1.87  2005/03/28 12:17:17  chenyl
* +: Exception List for NAPT-Redirect system
*
* Revision 1.86  2005/03/28 06:01:52  chenyl
* *: NAPT redirect without DIp/Dport modification
*
* Revision 1.85  2005/03/14 14:40:15  chenyl
* *: bug fix: protocol-stack flow cache, fragment packet forwarding
*
* Revision 1.84  2005/02/16 02:15:12  chenyl
* +: Forwarding Engine Trapping Dispatch system:
* 	When one packet must to be trapped to upper-layer protocol stack,
* 	User can decide how to dispatch this packet into different "categories"
* 	according to its 'l4protocol/source IP/destination IP/source Port (TCP/UDP)/
* 	destination Port (TCP/UDP)' with wide-card allowed. The category
* 	number is decided by user and will be set into ph_category in packet header.
* 	Fragment packet's test is passed.
*
* +: Forwarding Engine QoS Send:
* 	Protocol stack packet send with high TX queue used.
*
* Revision 1.83  2005/01/11 07:41:06  yjlou
* +: add ipsecTestFrag()
*
* Revision 1.82  2004/12/17 13:15:48  yjlou
* +: add ipsecTestBasic1();
*        ipsecTestBasic2();
*        ipsecTestBasic3();
*        ipsecTestBasic4();
*        ipsecTestError();
*
* Revision 1.81  2004/12/14 09:48:10  chenyl
* +: NAPT-Connection Control system
* *: add "NAPT-AddFail" error messages into ignore case.
*
* Revision 1.80  2004/12/07 02:15:41  chenyl
* *: bug fix : Protocol Stack Flow cache
* +: hooking code for ACL-process dispatch
* +: add testing cases for Policy Route and Remote Management
*
* Revision 1.79  2004/12/02 06:17:12  chenyl
* +: add testing cases about Mutli-session fragment packet forwarding.
* *: activate New _rtl8651_l34PacketProcess and rewrite _rtl8651_l34ActExec
*
* Revision 1.78  2004/11/05 05:28:26  chenyl
* +: add test case for fragment-multicast packet forwarding test
*
* Revision 1.77  2004/10/21 03:01:55  yjlou
* *: fixed for PPPOE_PASSTHRU_NEW_MODEL
*
* Revision 1.76  2004/10/08 03:15:05  yjlou
* +: add pkt_pppoe_passthru_without_vlan1()
*
* Revision 1.75  2004/10/07 13:16:41  chenyl
* +: uPnP entry checking for Port Bouncing
*
* Revision 1.74  2004/09/22 14:18:13  yjlou
* +: add pkt_pppoe_passthru_vlan_index() function
*
* Revision 1.73  2004/09/22 13:25:26  yjlou
* +: add pkt_pppoe_passthru_drop_unknown()
*
* Revision 1.72  2004/09/20 07:35:20  chenyl
* *: non-TCP/UDP/ICMP DMZ forward
* *: unicast IGMP forward
*
* Revision 1.71  2004/09/16 11:50:21  tony
* +: add PPTP pass-throught software (not change call ID) case.
*
* Revision 1.70  2004/09/15 16:14:28  chenyl
* +: enable multicast forward cache
*
* Revision 1.69  2004/09/02 09:05:00  chenyl
* *: napt-redirect: fragment packet support
*
* Revision 1.68  2004/09/02 06:15:38  chenyl
* *: multicast :
* 	- when turning-on ip-multicast, periodic query will be sent immediately
* +: tbldrv
* 	- add options when run addNaptConnection
* 		- PURE_SW: pure software entry
* 		- DONT_CHECK_INTIP: ignore internal IP checking
* 		- TO_PROTOCOL_STACK: this napt packet must be trapped to protocol stack
* +: forwarding engine:
* 	- protocol stack TCP/UDP flow cache
* 	- napt redirect register/unregister/query
*
* Revision 1.67  2004/08/31 03:16:43  chhuang
* +: new testing code for nexthop
*
* Revision 1.66  2004/08/30 05:19:48  tony
* *: fix bug - the path of PPTP server to protocol stack is failed.
*
* Revision 1.65  2004/08/24 07:25:00  chenyl
* *: re_core. modify COMPILE_FLAG
* *: forwarding engine: bug fix, URL Filter match bug
* *: testing code for PPTP header compression
* *: PPTP testing cases re-numbering
*
* Revision 1.64  2004/08/19 11:19:05  chenyl
* +: port bouncing: add the garbage collection mechanism to port bouncing entry
* 	- recycle the TCP port bouncing flow entry for new flow if it in CLOSE state
* +: testing cases for bug fix
*
* Revision 1.63  2004/08/18 14:17:32  chenyl
* *: forwarding engine : let some code be endian free/modify some return value
* +: testing cases for bug fix
*
* Revision 1.62  2004/08/17 12:30:01  chenyl
* *: add port config to multicast default upstream setting API
*
* Revision 1.61  2004/08/16 12:31:28  chenyl
* +: test case for udp blocking
*
* Revision 1.60  2004/08/12 13:20:12  chenyl
* +: testing case for remote management fragment packet support
*
* Revision 1.59  2004/08/11 05:19:06  chenyl
* +: weak TCP napt checking
* *: modify: for TCP napt outbound packet, if packet is (SYN+ACK) and no any entry found,
* 		forwarding engine will trap this packet and return FWDENG_TCP_NAPT_OUT_NOTFOUND
* 		insteads of dropping it silently.
*
* Revision 1.58  2004/08/06 09:40:50  chenyl
* *: enable TCP/UDP NAPT static-port-translation
* *: rename from looseUDP to InexactUDP
*
* Revision 1.57  2004/08/03 10:44:41  chenyl
* +: looseUDP (re-commit previous commit is failed due to DISK space's full)
*
* Revision 1.56  2004/08/03 10:21:56  chenyl
* +: loose UDP
*
* Revision 1.55  2004/07/26 14:45:44  chenyl
* +: new logging model
* +: dos Ignore Case
* 	- ignore packets from LAN
* 	- ignore packets from WAN
*
* Revision 1.54  2004/07/26 08:49:36  tony
* +: add PPTP Server in LAN test module.
*
* Revision 1.53  2004/07/19 12:54:43  chenyl
* *: bug fix: process udp packets withc zero-checksum
* *: bug fix: process L3/L4 packets whose ip-header length is not 20 byte
* +: add testing functions to compare/clear checksum field of mbuf/pkthdr
*
* Revision 1.52  2004/07/16 03:05:58  tony
* +: add test module for pptp_idle_timeout and l2tp_idle_timeout case.
*
* Revision 1.51  2004/07/14 06:55:55  tony
* +: add remote management test case.(web port fowrad and icmp disable)
*
* Revision 1.50  2004/07/14 06:52:45  yjlou
* +: add pkt_ras_dialondemand() function to ensure RAS Dial-on-Demand is OK
*
* Revision 1.49  2004/07/13 13:52:06  yjlou
* +: ROME driver supports IPv6 passthru forwarding even when protocol-based VLAN is created.
*
* Revision 1.48  2004/07/13 09:46:49  yjlou
* +: support RAS idle timeout
*
* Revision 1.47  2004/07/12 04:25:36  chenyl
* *: extend existing port scan mechanism
*
* Revision 1.46  2004/07/08 04:11:05  yjlou
* +: ROME driver supports PPPoE passthru forwarding even when protocol-based VLAN is created.
* -: PPPoE passthru no more monitor the control messages.
*
* Revision 1.45  2004/07/02 10:30:08  chenyl
* *: bug fix: per-source Flooding check bug (counter error)
* *: bug fix: ip-spoofing ACL add function error
* *: bug fix: ICMP ping-of-death : threshold from 65500 to 65535 (follows cisco)
* *: bug fix: item name change of DOS check: UDP Bomb -> UDP EchoChargen (follows cisco)
* +: new feature: New DoS check item, UDP Bomb
* 		- Triggered if (Length of UDP header) < (Length of IP header)
* 		- allow (Length of UDP header) > (Length of IP header)
* 		- follows cisco
*
* Revision 1.44  2004/06/30 02:53:57  chhuang
* +: add new testing case for MTU
*
* Revision 1.43  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.42  2004/06/25 13:53:12  chhuang
* +: add new testing case for MTU fragment
*
* Revision 1.41  2004/06/15 05:53:22  chhuang
* +: add new testing code
*
* Revision 1.40  2004/06/14 11:04:23  yjlou
* *: replace CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU and CONFIG_RTL865XB_EXP_IPV6_PASSTHRU with CONFIG_RTL865XB_EXP_IPV6_PASSTHRU
*
* Revision 1.39  2004/06/11 14:01:20  jzchen
* +: Define forwarding engine part PPPoE session not existed termination testing function
*
* Revision 1.38  2004/06/07 13:07:03  yjlou
* +: Supporting IPv6 Passthru
* *: ACL testing code is modified with sequence template.
*
* Revision 1.37  2004/05/12 07:20:15  chenyl
* +: source ip blocking
* *: modify dos mechanism
*
* Revision 1.36  2004/05/06 08:03:59  chhuang
* add testing code for MAC filtering
*
* Revision 1.35  2004/05/05 07:30:07  chenyl
* +: arp-proxy testing case
* *: bug fix in tblDrv addArp function
*
* Revision 1.34  2004/05/04 12:46:27  chenyl
* *: modify ipQueue/multicast system
*         +:  ipQueue:   can constraint total queued packet only
*         +:  multicast: can constraint total member only
*         *:  allocate table when ipQueue/Multicast init()
*         *:  if table size == 0 , ipQueue/Multicast system become disable
*         *:  switch to turn on/off Multicast system dynamically
*
* *: add CLE command to turn on/off ipQueue/ Multicast system
*
* *: change the init method: init ipQueue/multicast system in rtl8651_fwdEngineInit(configPara)
*    and set initial value using "configPara"
*
* Revision 1.33  2004/04/30 08:58:08  chenyl
* +: ip multicast/igmp proxy
*
* Revision 1.32  2004/04/21 11:56:58  yjlou
* *: 50B supports protocol-based VLAN PPPoE passthru.
*
* Revision 1.31  2004/04/19 09:01:16  yjlou
* +: add test code for PPPoE Passthru:
*    pkt_pppoe_passthru()
*
* Revision 1.30  2004/04/15 10:38:24  tony
* add PPTP/L2TP test module.
*
* Revision 1.29  2004/04/07 11:29:34  chenyl
* *: bug fix in fwd-engine : remove "isToEthBcast"
* +: rtl8651_fwdEngineProcessIPFragment(enable) to enable/disable ipQueue system
* 	enable : fragment packets are processed by fwdeng
* 	disable: fragment packets are trapped to protocol stack
*
* Revision 1.28  2004/04/06 01:53:52  chenyl
* +: new testing cases
*
* Revision 1.27  2004/03/25 08:58:22  chenyl
* *: new testing cases for fragment packet to protocol stack
*
* Revision 1.26  2004/03/24 09:50:37  chenyl
* +: Queued pkts to CPU
*
* Revision 1.25  2004/03/22 12:30:35  chenyl
* *: new testing cases
*
* Revision 1.24  2004/03/18 07:25:01  chenyl
* +: new testing cases for portbouncing
*
* Revision 1.23  2004/03/16 15:11:46  chenyl
* +: new testing cases for IP-Unnumbered -> DMZ Host port bouncing
* *: fix default mac bug (default mac is set to multicast mac addr)
*
* Revision 1.22  2004/03/15 13:23:52  chenyl
* +: new testing cases for fragment packet
*
* Revision 1.21  2004/03/15 11:32:39  tony
* add VDOlive Client ALG test module.
* add RealAudio Client ALG test module.
*
* Revision 1.20  2004/03/15 09:09:41  tony
* add SIP Client ALG test module.
*
* Revision 1.19  2004/03/12 01:42:03  chenyl
* +: new testing cases for ICMP TIMEXCEED reply
* *: eliminate error packet's L3/4 checksum in mbuf-compare function
*
* Revision 1.18  2004/03/09 05:16:41  chenyl
* *: new testing cases
*
* Revision 1.17  2004/03/08 10:45:59  chenyl
* +: rtl8651_fwdEngineIcmpToDMZHost()
* 	set if fwdeng need to forward ICMP echo/tstamp request to DMZ host or not
*
* Revision 1.16  2004/03/08 05:34:40  tony
* add DirectX7 Server ALG test module.
*
* Revision 1.15  2004/03/08 02:46:19  tony
* add DirectX 7 Client ALG test module.
*
* Revision 1.14  2004/03/05 08:16:17  chenyl
* +: new cases dip = multicast ip, dmac = gw mac
* *: modify policy route config, only 2 session allowed
*
* Revision 1.13  2004/03/05 02:57:24  tony
* add ICUII ALG test module.
*
* Revision 1.12  2004/03/04 10:30:37  tony
* add ICQ ALG test module.(support version 2000b~2003a)
*
* Revision 1.11  2004/03/04 02:35:07  chenyl
* *: testing cases
*
* Revision 1.10  2004/03/03 09:17:00  tony
* add Yahoo Messenger ALG test module.
*
* Revision 1.9  2004/03/03 06:22:55  tony
* add IRC ALG test module.
*
* Revision 1.8  2004/03/03 03:29:54  chenyl
* *: new testing case, fix icmp-pkt-generating-function's bug
*
* Revision 1.7  2004/03/02 12:08:12  tony
* add ALG Server test module.
*
* Revision 1.6  2004/03/02 08:20:46  tony
* add ALG Client test module
*
*
*/

#ifndef FWDTEST_H
#define FWDTEST_H

#define RTL_FWDENG_POLICYRT_TEST
#define RTL_FWDENG_DOS_TEST
#define RTL_FWDENG_ALG_TEST

#ifdef _RTL_WEAK_NAPT_CTRL
#define RTL_WEAK_NAPT_CTRL_TEST
#endif

#ifdef _RTL_PS_FLOWCACHE
#define RTL_PROTOCOLSTACK_FLOWCACHE_TEST
#endif

#ifdef _RTL_NAPT_REDIRECT
#define RTL_NAPT_REDIRECT_TEST
#endif

#ifdef _RTL_TRAPPING_DISPATCH
#define RTL_TRAPPING_DISPATCH_TEST
#endif /* _RTL_UDP_TRAPPING_DISPATCH */


/********************************/
#define IP_DEFAULT_TTL 128
#define defaultNaptLongTimeout 100000
/*********************************/

#define MAX(a,b) ((a>b)?a:b)
#define MIN(a,b) ((a>b)?b:a)

#define MASK_INCREASE(ip, addend, mask)	\
	do {	\
		ipaddr_t	net; \
		net = ((ip) & (mask)); \
		(ip) = ((ip) & ~(mask)) + (addend); \
		if ((ip) == 0) \
		{ \
			(ip) ++; \
		} \
		(ip) |= net; \
	}while(0);

#define LOWERBOUND_INCREASE(number, addend, lowerBound) \
	do {\
		(number) += (addend); \
		if ((number) < (lowerBound)) \
			(number) = (lowerBound); \
	}while(0);

#define UPPERBOUND_INCREASE(number, addend, upperBound) \
	do {\
		(number) += (addend); \
		if ((number) > (upperBound)) \
			(number) = 0; \
	}while(0);

#define BOUND_INCREASE(number, addend, lowerBound, upperBound) \
	do {\
		(number) += (addend); \
		if (((number) > (upperBound)) || ((number) < (lowerBound))) \
			(number) = (lowerBound); \
	}while(0);


#define DICING(base)	(random() % (base))

 #define RESET_CONF(conf) \
	do { \
		memset(conf, 0, sizeof(rtl8651_PktConf_t)); \
	}while(0)

#define CP_MAC(sm, dm)	\
	do{ \
		memcpy(dm, sm.octet, 6); \
	}while(0)

#define SET_RX_PORT(portlist, p) \
	do{ \
		portlist = p; \
	}while(0)

#define ADD_TX_PORT(portlist, p) \
	do{ \
		portlist |= (1<<p); \
	}while(0)



#define RTL_OFFLOAD_ENGINE_TEST

// Basic function
int32 mbuf_test1(uint32 caseNo);
int32 pkt_route_normal1(uint32 caseNo);
int32 pkt_route_frag1(uint32 caseNo);
int32 pkt_route_frag2(uint32 caseNo);
int32 pkt_napt_normal1(uint32 caseNo);
int32 pkt_napt_normal2(uint32 caseNo);
int32 pkt_napt_normal3(uint32 caseNo);
int32 pkt_napt_normal4(uint32 caseNo);
int32 pkt_napt_normal5(uint32 caseNo);
int32 pkt_napt_normal6(uint32 caseNo);
int32 pkt_napt_normal7(uint32 caseNo);
int32 pkt_napt_normal8(uint32 caseNo);
int32 pkt_newflow_acl1(uint32 caseNo);
int32 pkt_newflow_acl2(uint32 caseNo);
int32 pkt_newflow_acl3(uint32 caseNo);
int32 pkt_newflow_acl4(uint32 caseNo);
int32 pkt_newflow_acl5(uint32 caseNo);
int32 pkt_newflow_acl6(uint32 caseNo);
int32 pkt_newflow_acl7(uint32 caseNo);
int32 Napt_UdpStaticPortTranslation1(uint32 caseNo);
int32 Napt_TcpStaticPortTranslation1(uint32 caseNo);
int32 pkt_napt_frag1(uint32 caseNo);

int32 pkt_napt_serverport_tcp_1(uint32 caseNo);
int32 pkt_napt_serverport_tcp_2(uint32 caseNo);
int32 pkt_napt_serverport_tcp_3(uint32 caseNo);
int32 pkt_napt_serverport_tcp_4(uint32 caseNo);
int32 pkt_napt_serverport_udp_1(uint32 caseNo);
int32 pkt_napt_serverport_udp_2(uint32 caseNo);
int32 pkt_napt_serverport_hybrid_1(uint32 caseNo);
int32 pkt_napt_serverport_hybrid_2(uint32 caseNo);

int32 pkt_nat_tcp_1(uint32 caseNo);
int32 pkt_nat_tcp_2(uint32 caseNo);
int32 pkt_nat_udp_1(uint32 caseNo);
int32 pkt_nat_icmp_1(uint32 caseNo);
int32 pkt_nat_icmp_2(uint32 caseNo);
int32 pkt_napt_dmzHost_tcp_1(uint32 caseNo);
int32 pkt_napt_dmzHost_udp_1(uint32 caseNo);
int32 pkt_napt_dmzHost_icmp_1(uint32 caseNo);
int32 pkt_napt_dmzHost_UnicastIgmp_1(uint32 caseNo);
int32 pkt_napt_dmzHost_GeneralPktForward_1(uint32 caseNo);

int32 pkt_napt_uPnP_tcp_1(uint32 caseNo);
int32 pkt_napt_uPnP_tcp_2(uint32 caseNo);
int32 pkt_napt_uPnP_udp_1(uint32 caseNo);
int32 pkt_napt_uPnP_udp_2(uint32 caseNo);

int32 pkt_napt_triggerport_tcp_1(uint32 caseNo);
int32 pkt_napt_triggerport_tcp_2(uint32 caseNo);
int32 pkt_napt_triggerport_tcp_3(uint32 caseNo);
int32 pkt_napt_triggerport_tcp_4(uint32 caseNo);

int32 pkt_napt_triggerport_udp_1(uint32 caseNo);
int32 pkt_napt_triggerport_udp_2(uint32 caseNo);
int32 pkt_napt_triggerport_udp_3(uint32 caseNo);
int32 pkt_napt_triggerport_udp_4(uint32 caseNo);


int32 pkt_portBouncing_tcp_1(uint32 caseNo);
int32 pkt_portBouncing_tcp_2(uint32 caseNo);
int32 pkt_portBouncing_tcp_3(uint32 caseNo);
int32 pkt_portBouncing_tcp_4(uint32 caseNo);
int32 pkt_portBouncing_tcp_5(uint32 caseNo);
int32 pkt_portBouncing_tcp_6(uint32 caseNo);
int32 pkt_portBouncing_udp_1(uint32 caseNo);
int32 pkt_portBouncing_udp_2(uint32 caseNo);
int32 pkt_portBouncing_udp_3(uint32 caseNo);
int32 pkt_portBouncing_udp_4(uint32 caseNo);
int32 pkt_portBouncing_udp_5(uint32 caseNo);
int32 pkt_portBouncing_icmp_1(uint32 caseNo);
int32 pkt_portBouncing_icmp_2(uint32 caseNo);
int32 pkt_portBouncing_icmp_3(uint32 caseNo);
int32 pkt_portBouncing_icmp_4(uint32 caseNo);
int32 pkt_portBouncing_icmp_5(uint32 caseNo);
int32 pkt_portBouncing_icmp_6(uint32 caseNo);
int32 pkt_portBouncing_icmp_7(uint32 caseNo);
int32 pkt_portBouncing_icmp_8(uint32 caseNo);
int32 pkt_mac_filtering_test1(uint32 caseNo);
int32 pkt_mac_filtering_test2(uint32 caseNo);
int32 pkt_mac_filtering_test3(uint32 caseNo);
int32 pkt_mac_filtering_test4(uint32 caseNo);



#if 0
int32 pkt_unnumbered_1(uint32 caseNo);
#endif
// FwdEngine Feature
int32 pkt_feature_icmpReply_1(uint32 caseNo);
int32 pkt_feature_icmpReply_2(uint32 caseNo);
int32 pkt_feature_icmpTexceedReply_1(uint32 caseNo);
int32 pkt_feature_logNewFlow_1(uint32 caseNo);
int32 pkt_feature_arp_1(uint32 caseNo);
int32 pkt_feature_arp_proxy_1(uint32 caseNo);
int32 pkt_feature_InexactUDPNapt_1(uint32 caseNo);
#ifdef RTL_WEAK_NAPT_CTRL_TEST
int32 pkt_feature_weakTcpNaptCheck_1(uint32 caseNo);
int32 pkt_feature_weakTcpNaptCheck_2(uint32 caseNo);
int32 pkt_feature_weakTcpNaptCheckRandomTest_1(uint32 caseNo);
#endif /* RTL_WEAK_NAPT_CTRL_TEST */
// Black List
int32 pkt_BlackList_sip1(uint32 caseNo);
// to CPU
int32 pkt_acl_2cpu1(uint32 caseNo);
int32 pkt_frag_2cpu1(uint32 caseNo);
int32 pkt_frag_2cpu2(uint32 caseNo);

// Stress test
int32 ipFrag_stress_1(uint32 caseNo);
int32 ipFrag_stress_2(uint32 caseNo);

// udp blocking
int32 pkt_udp_blocking1(uint32 caseNo);
int32 pkt_udp_blocking2(uint32 caseNo);

// bug fix
int32 pkt_udp_zeroCksum(uint32 caseNo);
int32 pkt_udp_cksum(uint32 caseNo);
int32 pkt_dos_IcmpFragment1(uint32 caseNo);
int32 pkt_PacketBouncing_1(uint32 caseNo);
int32 pkt_SPI_1(uint32 caseNo);
int32 pkt_SPI_2(uint32 caseNo);
int32 pkt_ttlCheck1(uint32 caseNo);

/* protocol stack TX QoS */
int32 pkt_protocolStackFlow_QosSend_1(uint32 caseNo);

int32 pkt_protocolStackFlow_portListDetermination_1(uint32 caseNo);
int32 pkt_protocolStackFlow_portListDetermination_2(uint32 caseNo);


#ifdef RTL_FWDENG_POLICYRT_TEST
int32 pkt_napt_policy1(uint32 caseNo);
int32 pkt_napt_policy2(uint32 caseNo);
int32 pkt_napt_policy3(uint32 caseNo);
int32 pkt_napt_policy4(uint32 caseNo);
int32 pkt_napt_policy5(uint32 caseNo);
int32 pkt_napt_policy6(uint32 caseNo);
int32 pkt_napt_policy7(uint32 caseNo);
int32 pkt_future_icmpReply_policy1(uint32 caseNo);
#endif /* RTL_FWDENG_POLICYRT_TEST */

#ifdef CONFIG_RTL865X_MULTICAST
int32 pkt_multicast_igmp1(uint32 caseNo);
int32 pkt_multicast_igmp2(uint32 caseNo);
int32 pkt_multicast_igmp3(uint32 caseNo);
int32 pkt_multicast_igmp4(uint32 caseNo);
int32 pkt_multicast_igmp5(uint32 caseNo);
int32 pkt_multicast_igmp6(uint32 caseNo);
int32 pkt_multicast_igmp_Filter1(uint32 caseNo);
int32 pkt_multicast_flowCache1(uint32 caseNo);
//#ifdef RTL_FWDENG_POLICYRT_TEST
//int32 pkt_multicast_multi_session1(uint32 caseNo);
//#endif /* RTL_FWDENG_POLICYRT_TEST */
#endif /* CONFIG_RTL865X_MULTICAST */
#ifdef RTL_FWDENG_DOS_TEST
int32 dosSynFlood_1(uint32 caseNo);
int32 dosSynFlood_2(uint32 caseNo);
int32 dosSynFlood_3(uint32 caseNo);
int32 dosSynFlood_4(uint32 caseNo);
int32 dosStealthFin_1(uint32 caseNo);
int32 dosStealthFin_2(uint32 caseNo);
int32 dosStealthFin_3(uint32 caseNo);
int32 dosStealthFin_4(uint32 caseNo);
int32 dosUdpFlood_1(uint32 caseNo);
int32 dosUdpFlood_2(uint32 caseNo);
int32 dosUdpFlood_3(uint32 caseNo);
int32 dosUdpFlood_4(uint32 caseNo);
int32 dosIcmpFlood_1(uint32 caseNo);
int32 dosIcmpFlood_2(uint32 caseNo);
int32 dosIcmpFlood_3(uint32 caseNo);
int32 dosIcmpFlood_4(uint32 caseNo);
int32 dosSynWithData_1(uint32 caseNo);
int32 dosSynWithData_2(uint32 caseNo);
int32 dosTearDrop_1(uint32 caseNo);
int32 dosTearDrop_2(uint32 caseNo);
int32 dosTcpLand_1(uint32 caseNo);
int32 dosTcpLand_2(uint32 caseNo);
int32 dosUdpLand_1(uint32 caseNo);
int32 dosUdpLand_2(uint32 caseNo);
int32 dosIcmpLand_1(uint32 caseNo);
int32 dosIcmpLand_2(uint32 caseNo);
int32 dosSmurf_1(uint32 caseNo);

int32 dosIpSpoof_1(uint32 caseNo);
int32 dosIpSpoof_2(uint32 caseNo);

int32 dosUdpEchoChargen_1(uint32 caseNo);
int32 dosTcpScan_1(uint32 caseNo);
int32 dosPingOfDeath_1(uint32 caseNo);
int32 dosPingOfDeath_2(uint32 caseNo);
int32 dosUdpBomb_1(uint32 caseNo);
int32 dosUdpBomb_2(uint32 caseNo);
int32 dosTcpUdpPortScan_1(uint32 caseNo);
int32 dosTcpUdpPortScan_2(uint32 caseNo);
int32 dosIgnoreCase_1(uint32 caseNo);
int32 dosIgnoreCase_2(uint32 caseNo);
int32 SipBlocking_1(uint32 caseNo);

int32 pkt_connectionControl_wholeSystem_1(uint32 caseNo);
int32 pkt_connectionControl_perSrc_1(uint32 caseNo);
#endif /* RTL_FWDENG_DOS_TEST */

#ifdef RTL_NAPT_REDIRECT_TEST
int32 pkt_naptRedirect_1(uint32 caseNo);
int32 pkt_naptRedirect_2(uint32 caseNo);
int32 pkt_naptRedirect_3(uint32 caseNo);
int32 pkt_naptRedirect_4(uint32 caseNo);
int32 pkt_naptRedirect_5(uint32 caseNo);
int32 pkt_naptRedirect_6(uint32 caseNo);
int32 pkt_naptRedirect_7(uint32 caseNo);


#endif

#ifdef RTL_TRAPPING_DISPATCH_TEST
int32 pkt_trapping_dispatch_1(uint32 caseNo);
int32 pkt_trapping_dispatch_2(uint32 caseNo);
#endif /* RTL_TRAPPING_DISPATCH_TEST */

#ifdef RTL_OFFLOAD_ENGINE_TEST
int32 pkt_L3_offload_engine_1(uint32 caseNo);
#endif /* RTL_OFFLOAD_ENGINE_TEST */

#ifdef RTL_PROTOCOLSTACK_FLOWCACHE_TEST
int32 pkt_napt_ProtocolStackFlow_trap_1(uint32 caseNo);
int32 pkt_napt_ProtocolStackFlow_trap_2(uint32 caseNo);
int32 pkt_napt_ProtocolStackFlow_trap_3(uint32 caseNo);
#endif

#ifdef RTL_FWDENG_ALG_TEST
int32 algFtpClient(uint32 caseNo);
int32 algFtpServer(uint32 caseNo);
int32 algIrcClient(uint32 caseNo);
int32 algYmsgClient(uint32 caseNo);
int32 algIcqClient(uint32 caseNo);
int32 algIcuiiServer(uint32 caseNo);
int32 algDx7Client(uint32 caseNo);
int32 algDx7Server(uint32 caseNo);
int32 algSipClient(uint32 caseNo);
int32 algSipServer(uint32 caseNo);
int32 algRealAudioClient(uint32 caseNo);
int32 algVDOliveClient(uint32 caseNo);
int32 algQuakeClient(uint32 caseNo);
int32 algBattlenetClient(uint32 caseNo);
int32 algCsClient(uint32 caseNo);
int32 algCUseeMeClient(uint32 caseNo);
int32 algPptpClient(uint32 caseNo);
int32 algPptpSoftwareClient(uint32 caseNo);
int32 algL2tpClient(uint32 caseNo);
int32 algIpsecClient(uint32 caseNo);
int32 algNetMeetingClient(uint32 caseNo);
int32 algNetMeetingServer(uint32 caseNo);
int32 pptp_test10(uint32 caseNo);
int32 pptp_test11(uint32 caseNo);
int32 pptp_test12(uint32 caseNo);
int32 l2tp_test8(uint32 caseNo);
int32 pkt_mtu_fragment_static_ip(uint32 caseNo);
int32 pkt_mtu_fragment_pppoe(uint32 caseNo);
int32 pkt_mtu_fragment_static_ip_fragment(uint32 caseNo);

int32 algPptpServer(uint32 caseNo);
#endif /* RTL_FWDENG_ALG_TEST */



#if 1//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
int32 pkt_pppoe_passthru_PBV(uint32 caseNo);
#else //CONFIG_RTL865XB
#endif//CONFIG_RTL865XB
int32 pkt_pppoe_passthru(uint32 caseNo);
int32 pkt_pppoe_passthru_drop_unknown(uint32 caseNo );
int32 pkt_pppoe_passthru_vlan_index(uint32 caseNo );
int32 pkt_pppoe_passthru_without_vlan1(uint32 caseNo );

#if 1//CONFIG_RTL865XB_EXP_IPV6_PASSTHRU
int32 pkt_ipv6_passthru_PBV(uint32 caseNo);
#else //CONFIG_RTL865XB
#endif//CONFIG_RTL865XB
int32 pkt_ipv6_passthru(uint32 caseNo);

int32 pkt_serverPort_syn_ack_drop(uint32 caseNo);
int32 pkt_pppoeNotExistedSessionTermination_test2(uint32 caseNo);

int32 pkt_ras_idletimeout(uint32 caseNo);

int32 pkt_remote_management1(uint32 caseNo);
int32 pkt_remote_management2(uint32 caseNo);
int32 pkt_remote_management3(uint32 caseNo);
int32 pkt_remote_management4(uint32 caseNo);
int32 pkt_remote_management5(uint32 caseNo);
int32 pkt_remote_management6(uint32 caseNo);
int32 pkt_remote_management7(uint32 caseNo);
int32 pkt_remote_management8(uint32 caseNo);
int32 pkt_remote_management9(uint32 caseNo);
int32 pkt_remote_management10(uint32 caseNo);
int32 pkt_remote_management11(uint32 caseNo);


int32 pkt_ras_dialondemand(uint32 caseNo);

int32 pptp_test_idletimeout(uint32 caseNo);
int32 l2tp_test_idletimeout(uint32 caseNo);



//////////// forwarding engine ACL setting /////////////////
int32 acl_Syn2CpuForExternalVlan(uint32 caseNo);
int32 acl_DoS2Cpu(uint32 caseNo); 

int32 ipsecTestBasic1(uint32 caseNo);
int32 ipsecTestBasic2(uint32 caseNo);
int32 ipsecTestBasic3(uint32 caseNo);
int32 ipsecTestBasic4(uint32 caseNo);
int32 ipsecTestFrag(uint32 caseNo);
int32 ipsecTestError(uint32 caseNo);

/* VoIP Supporting */
int32 rtpTest1(uint32 caseNo);
int32 rtpTest2(uint32 caseNo);
int32 rtpTest3(uint32 caseNo);
int32 rtpTest4(uint32 caseNo);

#endif
