#ifndef MBUF_GEN
#define MBUF_GEN

#include "mbuf.h"
#include "PktProc/pktGen.h"

#ifndef DATA_CMP
#define DATA_CMP

#define ABSOLUTE(v) (v>=0?(v):(-v))
#define IS_EQUAL_BOOL(str, v1, v2, _f_, _l_) \
	if ( (v1) != (v2) ) { \
		printf("\t%s(%u): %s: %s, %s\n", _f_, _l_, str, (v1==1? "TRUE": "FALSE"), (v2==1? "TRUE": "FALSE")); \
		return FAILED; \
	}
#define IS_EQUAL_MAC(str, v1, v2, _f_, _l_) \
	if (memcmp((int8 *)&(v1), (int8 *)&(v2), 6)) { \
		printf("\t%s(%u): %s: %x:%x:%x:%x:%x:%x, %x:%x:%x:%x:%x:%x\n", _f_, _l_, str, v1.octet[0], v1.octet[1], v1.octet[2], v1.octet[3], v1.octet[4], v1.octet[5], v2.octet[0], v2.octet[1], v2.octet[2], v2.octet[3], v2.octet[4], v2.octet[5]); \
		return FAILED; \
	}
#define IS_EQUAL_IP(str, v1, v2, _f_, _l_) \
	if ((v1) != (v2)) { \
		printf("\t%s(%u): %s: %d.%d.%d.%d, %d.%d.%d.%d\n", _f_, _l_, str, (v1>>24), (v1&0x00ff0000)>>16, (v1&0x0000ff00)>>8, (v1&0xff), (v2>>24), (v2&0x00ff0000)>>16, (v2&0x0000ff00)>>8, (v2&0xff)); \
		return FAILED; \
	}
#define IS_EQUAL_INT(str, v1, v2, _f_, _l_) \
	if ((v1) != (v2)) { \
		printf("\t%s(%u): %s: %d, %d\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}

#define IS_EQUAL_POINTER(str, v1, v2, _f_, _l_) \
	if ((v1) != (v2)) { \
		printf("\t%s(%u): %s: %p, %p\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}
	
#define IS_NOT_EQUAL_POINTER(str, v1, v2, _f_, _l_) \
	if ((v1) == (v2)) { \
		printf("\t%s(%u): %s: %p, %p\n", _f_, _l_, str, v1, v2); \
		return FAILED; \
	}
#endif

#define total_nmbufList	50
struct rtl_mBuf* mbufList[total_nmbufList];
struct rtl_mBuf** mbufListCur;
uint32 nmbufList;

/*
	Checksum related constant
*/
#define TEST_CSUM_IP				0x00000001
#define TEST_CSUM_L4				0x00000002
#define TEST_CSUM_ICMPERR			0x00000004
#define TEST_CSUM_1SCMODE			0x10000000	/* because checksum is 1's complement, 0xffff == 0x0 */
#define TEST_CSUM_IGNOREUDP0		0x10000000


#define MBUFGEN_INTERNAL_FUNC
int8 *_mBuf2pkt(struct rtl_mBuf *mbuf, uint32* pktLen);
struct rtl_mBuf *pkt2mBuf(int8 *buf, uint32 pktLen);
int32 _setPktHdr(struct rtl_mBuf* mbuf, rtl8651_PktConf_t* conf);
int32 _dumpPktHdr(struct rtl_mBuf* mbuf);

#define MBUFGEN_EXTERNAL_FUNC
int32 freeMbuf(struct rtl_mBuf* mbuf);
struct rtl_mBuf* genMbufPkt(rtl8651_PktConf_t* conf);
struct rtl_mBuf* genIcmpErrMbufPkt(rtl8651_PktConf_t* err_pkt, rtl8651_PktConf_t* icmp_pkt);

int32 dumpMbufPkt(struct rtl_mBuf* mbuf);
int32 dump_mBuf( void );

int32 get_mbuf_IpId(struct rtl_mBuf* mbuf, ipaddr_t *sip, ipaddr_t *dip, uint16 *id);
int32 get_mbuf_IpPort(struct rtl_mBuf* mbuf, ipaddr_t *sip, uint16 *sport, ipaddr_t *dip, uint16 *dport);
int32 mbuf_cmp(struct rtl_mBuf* m1, struct rtl_mBuf* m2, int8* _fun_, uint32 _line_);
int32 icmpErrPkt_cmp(struct rtl_mBuf* m1, struct rtl_mBuf* m2, int8* _fun_, uint32 _line_);
int32 checksum_cmp(struct rtl_mBuf* m1, struct rtl_mBuf* m2, uint32 flag, int8* _fun_, uint32 _line_);
int32 clr_checksum(struct rtl_mBuf* m, uint32 flag);

void mbufList_init(void);
void mbufList_Reinit(void);
int32 mbufList_enqueue(struct rtl_mBuf* mbuf);
struct rtl_mBuf* mbufList_dequeue(void);
int32 mbufList_nmbuf(void);
#endif
