

#include <stdio.h>
#include "types.h"
#include "asicRegs.h"
#include "asicTabs.h"
#include "rtl8651_tblDrvLocal.h"
#ifdef CONFIG_RTL865XC
#include "rtl865xC_tblAsicDrv.h"
#else
#include "rtl8651_tblAsicDrv.h"
#endif




static void _rtl8651_asicTableAccessForward(uint32 tableType, uint32 eidx, void *entryContent_P) {
	uint32 *p_data = (uint32 *)(rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);

	ASSERT_CSP(entryContent_P);
	p_data[0] = big_endian(*((uint32 *)entryContent_P + 0));
	p_data[1] = big_endian(*((uint32 *)entryContent_P + 1));
	p_data[2] = big_endian(*((uint32 *)entryContent_P + 2));
	p_data[3] = big_endian(*((uint32 *)entryContent_P + 3));
	p_data[4] = big_endian(*((uint32 *)entryContent_P + 4));
	p_data[5] = big_endian(*((uint32 *)entryContent_P + 5));
	p_data[6] = big_endian(*((uint32 *)entryContent_P + 6));
	p_data[7] = big_endian(*((uint32 *)entryContent_P + 7));
}

int32 _rtl8651_addAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P) {
	_rtl8651_asicTableAccessForward(tableType, eidx, entryContent_P);
	return SUCCESS;
}


int32 _rtl8651_forceAddAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P) {
	_rtl8651_asicTableAccessForward(tableType, eidx, entryContent_P);
	return SUCCESS;
}

int32 _rtl8651_readAsicEntry(uint32 tableType, uint32 eidx, void *entryContent_P) {
	uint32 *    entryAddr;
    
	ASSERT_CSP(entryContent_P);
	entryAddr = (uint32 *) (
		(uint32) rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);

	*((uint32 *)entryContent_P + 0) = big_endian(*(entryAddr + 0));
	*((uint32 *)entryContent_P + 1) = big_endian(*(entryAddr + 1));
	*((uint32 *)entryContent_P + 2) = big_endian(*(entryAddr + 2));
	*((uint32 *)entryContent_P + 3) = big_endian(*(entryAddr + 3));
	*((uint32 *)entryContent_P + 4) = big_endian(*(entryAddr + 4));
	*((uint32 *)entryContent_P + 5) = big_endian(*(entryAddr + 5));
	*((uint32 *)entryContent_P + 6) = big_endian(*(entryAddr + 6));
	*((uint32 *)entryContent_P + 7) = big_endian(*(entryAddr + 7));
	
	return SUCCESS;
}

int32 _rtl8651_delAsicEntry(uint32 tableType, uint32 startEidx, uint32 endEidx) {
  	uint32 *p_data, eidx = startEidx;
	
	while (eidx <= endEidx) {
		p_data = (uint32 *) (rtl8651_asicTableAccessAddrBase(tableType) + eidx * RTL8651_ASICTABLE_ENTRY_LENGTH);
		p_data[0] = 0;        
		p_data[1] = 0;     
		p_data[2] = 0;     
		p_data[3] = 0;     
		p_data[4] = 0;     
		p_data[5] = 0;     
		p_data[6] = 0;     
		p_data[7] = 0;     		
		++eidx;
	}
	return SUCCESS;
}
