/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/mii.c,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract: This file provides mii access routines.
*
* $Author: blue $
*
* $Log: mii.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:11  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:30:51  danwu
* init
*
* Revision 1.14  2003/10/07 06:55:15  jzchen
* Avoid debugging message display during MII write and make gap longer
*
* Revision 1.13  2003/09/26 07:08:22  danwu
* supports reading from all ports
*
* Revision 1.12  2003/09/03 08:51:17  danwu
* return if mii does not receive any packet
*
* Revision 1.11  2003/08/11 07:21:07  danwu
* exit miir right away when no packet is received
*
* Revision 1.10  2003/06/16 03:29:05  danwu
* remove directory of asicregs.h and let makefile decides the path according to
* chip
*
* Revision 1.9  2003/04/30 15:25:08  cfliu
* remove rtl_debug.h
*
* Revision 1.8  2002/11/07 12:04:33  henryCho
* no message
*
* Revision 1.7  2002/10/03 05:56:26  henryCho
* sync board running code with server.
*
* Revision 1.5  2002/09/10 07:08:23  danwu
* Allow mr command to escape by pressing 'x'.
*
* Revision 1.4  2002/08/28 14:12:36  henryCho
* Add writing 8 trailing zeros in mii_readFrMii().
*
* Revision 1.3  2002/08/28 07:26:18  orlando
* Correct a bug:
* shiftOfst = (2<<port); --> shiftOfst = (port << 2);
*
* Revision 1.2  2002/08/28 03:51:16  orlando
* Add #include <sys/rtl_debug.h>.
*
* Revision 1.1  2002/08/28 03:32:18  orlando
* MII access routine.
*
*-------------------------------------------------------------------------
*/
#include "../types.h"
//#include <board.h>
#include "../asicRegs.h"
#include "../hsRegs.h"
//#include "pg_pktParse.h" // for pktParseMain()
#define DEBUGMSG(a)

//static int8   tmtmrBuf[6][2048]; // port0 - port5

/*
 *
 */
void mii_writeToMii(uint32 port, int8 * pktBuf, uint32 pktLen)
{
	uint32 i=0;
	uint32 PxRxDV=0;
	uint32 nib1;
	uint32 nib2;
	uint32 shiftOfst=0;
	uint32 nibMask=0;
	
	// enable mii rx
	// REG32(TMCR) = 0x00ff0000;
	
	if (port > 5 || pktBuf == NULL || pktLen > 2048)
	{
		DEBUGMSG(("writeToMii parameter error!\n"));
		return;
	}

	PxRxDV = (1 << (25+port));
	
	shiftOfst = (port<<2); // shift offset = port * 4
	
	nibMask = ~(PxRxDV | (0xf << shiftOfst)); // specific to one port only
	
	// write preamble: 0000 aaaa aaaa aaaa aaad (each symbol is a nibble)
	
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;

	
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	
	/*
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV); //1
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV); //5
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV); //9
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) = REG32(TMRMR) & nibMask | (0x5<<shiftOfst) | (PxRxDV);
	*/
	
	REG32(TMRMR) =  (0x5<<shiftOfst) | (PxRxDV); //13
	REG32(TMRMR) =  (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) =  (0x5<<shiftOfst) | (PxRxDV);
	REG32(TMRMR) =  (0xd<<shiftOfst) | (PxRxDV); //15
	
	for (i=0; i < pktLen; i++)
	{
		nib2 = (pktBuf[i] & 0x0f) << shiftOfst;
		REG32(TMRMR) = (PxRxDV | nib2);
		//DEBUGMSG(("pkt#%d nib2 0x08x\n", i, nib2));
		
		nib1 = ((pktBuf[i] & 0xf0) >> 4) << shiftOfst;
		REG32(TMRMR) = (PxRxDV | nib1);
		//DEBUGMSG(("pkt#%d nib1 0x08x\n", i, nib1));
	}
	
	// write trailing 8 zero
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;

	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;

	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	REG32(TMRMR) = 0x00000000;
	
	// disable mii rx
	//REG32(TMCR) = 0x00000000; 
	
	DEBUGMSG(("\nwriteToMii done!\n"));
	
} /* end mii_writeToMii */


/*
 *
 */
int32 mii_readFrMii(uint32 port, int8 * pktBuf, uint32 * pPktLen)
{
	//uint32    i = 0;
	uint32    nib;
	uint32    regVal = 0;
	uint32    PxNibMask = 0;
	uint32    PxTxEnMask=0;
	//uint32  port=0;
	//uint32  ofst[6];   // tmtmrBuf[] offset
	//uint32  toggle[6]; // 0: high nibble, 1: low nibble
	//uint32  pktLen[6];
	uint32    ofst = 0;
	uint32    toggle = 0;
	int32     retry=30;
	
	//memset((void *)ofst,   0, MUL(sizeof(uint32),4));
	//memset((void *)toggle, 0, MUL(sizeof(uint32),4));
	//memset((void *)pktLen, 0, MUL(sizeof(uint32),4));

	PxTxEnMask = (1<<(25+port));
	
 	while (((regVal=REG32(TMTMR)) & PxTxEnMask) == 0)
 	{
 	    if ( --retry < 0 )
        return FAILED;
 	}

	
	#if 0
	switch (regVal & 0x7e000000)
	{
		case 0x02000000:
			port = 0;
			break;
		case 0x04000000:
			port = 1;
			break;
		case 0x08000000:
			port = 2;
			break;
		case 0x10000000:
			port = 3;
			break;
		case 0x20000000:
			port = 4;
			break;
		case 0x40000000:
			port = 5;
			break;
		default:
			DEBUGMSG(("hs_readFrMii error !\n"));
			return FAILED;
	}
	#endif
	
	//PxTxEnMask = (1<<(25+port));
	
	PxNibMask = (uint32)(0x0000000f << (port<<2));
	
	// loop till PxTxD==0xd
	while ( (((regVal=REG32(TMTMR)) & PxNibMask)>>(port<<2)) != 0xd );
	
	// read one specific port
	while ((regVal = REG32(TMTMR)) & PxTxEnMask)
	{
		nib = (regVal & PxNibMask) >> (port<<2);
		//tmtmrBuf[port][ofst[port]] |= (nib << (toggle[port] ? 0 : 4));
		pktBuf[ofst] |= (nib << (toggle ? 4 : 0));
		if (toggle == 1)
			ofst += 1;
		toggle ^= 1; // alternate toggle value
	} /* end while */
	
	
	DEBUGMSG(("readFrMii done.\n"));
	#if 0 
	for (i=0; i<6; i++)
	{
		i = port;
		DEBUGMSG(("port[%d]: pktlen %d(0x%x)\n",i,(int)ofst[i],(int)ofst[i]));
		DEBUGMSG(("analyze port[%d] pkt ...\n",i));
		hs_dumpPkt();
		pktParseMain(tmtmrBuf[i], ofst[i]); // notice that "tmtmrBuf[]" is a pointer
		DEBUGMSG(("--------------------\n"));
	}
	#endif

	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);

	*pPktLen = ofst;

	return SUCCESS;
	
} /* end mii_readFrMii */


/*
 *
 */
int32 mii_readAllPorts(int8** bufArray, uint32* lenArray)
{
	uint32    nib;
	uint32    regVal;
	uint32    PxTxEnMask;
	uint32    msb[6];
	int32     retry=30;
	uint32    PxTxDataMask;
	uint32    port;

#ifndef FPGA_BOARD
	PxTxEnMask=0x3f<<25;
#else
	PxTxEnMask=0;
	printf("Only read from 2 ports for this FPGA version!\n");
	for (port=0; port<2; port++)
	{
		if (bufArray[port])
			PxTxEnMask|=(1<<port)<<25;
	}
#endif /*FPGA_BOARD*/
	
 	while (((regVal=REG32(TMTMR)) & PxTxEnMask) == 0)
 	{
 	    if (--retry < 0)
        return FAILED;
 	}
 	
 	for (port=0; port<6; port++)
 	{
    lenArray[port]=0;
    msb[port]=0;
  }
  PxTxDataMask=0;
	
	while ((regVal=REG32(TMTMR)) & PxTxEnMask)
	{
		for (port=0; port<6; port++)
		{
			if (bufArray[port] && ((1<<port) & PxTxDataMask))
			{
				nib = (regVal>>(port<<2)) & 0xf;
				bufArray[port][lenArray[port]]|=nib<<(msb[port]?4:0);
				if (msb[port])
					lenArray[port]++;
				msb[port]^=1;
			}
			else
			{
				if (((1<<(port+25)) & regVal) && 
						(((regVal>>(port<<2))&0x0f) == 0x0d))
					PxTxDataMask|=(1<<port);
			}
		}
	}

	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);
	regVal = REG32(TMTMR);

	return SUCCESS;
}


#if 0
// scan thru each port to retrieve data			
for (i=0; i<6; i++)
{
	if (regVal & (1<<(i+25)))
	{
		/* port i has data */
		nib = regVal & (0xf << (i<<2));
		tmtmrBuf[i][ofst[i]] |= nib << (toggle[i] ? 0 : 4);
		if (toggle[i] == 1)
			ofst[i] += 1;
		toggle[i] ^= 1; // alternate toggle value					
	}
}
#endif

/* end of mii.c */
