/*
* ----------------------------------------------------------------
* Copyright c              Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_pktGen.c,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract: packet generation entry program.
*
* $Author: blue $
*
* $Log: pg_pktGen.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:11  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:34  danwu
* init
*
* Revision 1.5  2003/12/30 10:34:42  waynelee
* add pptp, ipx support and provide more flexible packet format
*
* Revision 1.4  2003/12/19 02:24:06  danwu
* no message
*
* Revision 1.3  2003/04/30 15:46:09  cfliu
* remove macro.h, use macros defined in types.h instead
*
* Revision 1.2  2002/08/29 03:36:03  orlando
* Treat 'd' as 'n' flag in l2Flag of pg_pktGen(). 'd' flag will be used in
* the caller of pg_pktGen().
*
* Revision 1.1  2002/08/28 03:44:03  orlando
* packet generation module initial check-in.
*
* ---------------------------------------------------------------
*/

//#include <csp/rtl8650/asic/asicRegs.h>
#include "../../types.h"
#include "pg_protoForm.h"
#include "pktgen.h" // exported prototype declaration

/* local data */
#define MAX_PAYLOAD_LENGTH 1500
//static int8 pktBuf[2048]; // moved to mii_test.c
//static int8 macAddr[6];
//static int8 sa[6];
//static int8 da[6];
static int8 content[2048];
static uint32 len;

/* local prototypes */

void pg_pktGen
(
int8   * ptype,
int8   * l2FlagStr,
uint32   payloadLen,
int8   * pktBuf,
uint32 * pLen,
int8   * srcIp,
int8   * dstIp,
int8   * sa,
int8   * da
)
{
	uint32 l2Flag=0;
	uint32 i=0;
	//vlan_param_t p;
	//acl_param_t aclp;

	//#define srcIp "192.168.1.1"
	//#define dstIp "140.113.1.1"
	
	#if 0
	da[0] = 0x00; da[1] = 0x01; da[2] = 0x02;
	da[3] = 0x03; da[4] = 0x04; da[5] = 0x05;
	sa[0] = 0x06; sa[1] = 0x07; sa[2] = 0x08;
	sa[3] = 0x09; sa[4] = 0x0a; sa[5] = 0x0b;
	#endif
	
	if (payloadLen > MAX_PAYLOAD_LENGTH)
	{
		printf("payload length %d exceeds max: %d\n", payloadLen, MAX_PAYLOAD_LENGTH);
		return;
	}
	len = payloadLen;
	
	//len = 50;
	memset(content, 0x5a, len);

	for (i=0; i<strlen(l2FlagStr); i++)
	{
		switch (l2FlagStr[i])
		{
			case 'v':
			case 'V':
				l2Flag |= L2_VLAN;
				break;
			case 's':
			case 'S':
				l2Flag |= L2_SNAP;
				break;
			case 'p':
			case 'P':
				l2Flag |= L2_PPPoE;
				break;
			case 'n':
			case 'N':
			case 'd':
			case 'D':
				break;
			default:
				printf("unknown l2flag!\n");
				return;
		}
	}

	switch (ptype[0])
	{
	case 'a':
		protoForm_vs_arp(pktBuf, l2Flag, 
			da, sa, 36, 0, 0,
			sa, ntohl(inet_addr(srcIp)),
			da, ntohl(inet_addr(dstIp)),
			ARPOP_REPLY, &len);
		break;
	case 'i':
		protoForm_vsp_ip(pktBuf, l2Flag, da, sa, 24, 0, 0, 0x8864, 5, 4, 20, 0, 0, 0, 0, 0, 16,
			ntohl(inet_addr(srcIp)), ntohl(inet_addr(dstIp)), 89,
			content, 0, &len);
		break;
	case 'c':
		protoForm_vsp_icmp(pktBuf, l2Flag, da, sa, 24, 0, 0, 0x8864, 5, 4, 20, 0, 0, 0, 0, 0, 16,
			ntohl(inet_addr(srcIp)), ntohl(inet_addr(dstIp)),
			ICMP_ECHO, 0, 12, 1, content, 0, &len);
		break;
	case 'g':
		protoForm_vsp_igmp(pktBuf, l2Flag, da, sa, 24, 0, 1, 0x8864, 5, 4, 20, 0, 0, 0, 0, 0, 16,
			ntohl(inet_addr(srcIp)), ntohl(inet_addr("224.0.0.1")),
			IGMP_MEMBERSHIP_QUERY, 0, ntohl(inet_addr("224.1.1.1")), 0, &len);
		break;
	case 't':
		protoForm_vsp_tcp(pktBuf, l2Flag, da, sa, 24, 0, 0, 0x8864, 5, 4, 20, 0, 0, 0, 0, 0, 16,
			ntohl(inet_addr(srcIp)), ntohl(inet_addr(dstIp)),
			19, 58, 2, 1, 1?0x10:0, 4096, //sport, dport, seq, ack, win
			content, 0, &len);
		break;
	case 'u':		
		protoForm_vsp_udp(pktBuf, l2Flag,
			da, sa, 24, 0, 0, 0x8864, 5, 4, 20, 0, 0, 0, 0, 0, 16,
			ntohl(inet_addr(srcIp)), ntohl(inet_addr(dstIp)),
			19, 58,	content, 0, &len);//sport, dport
		break;
	default:
		printf("unknown packet type!\n");
		return;
	} /* end switch ptype */

	*pLen = len;
	
	return;	
} /* end pg_pktGen */

/* end of pg_pktFormParseMain.c */
