/*
* ----------------------------------------------------------------
* Copyright c              Realtek Semiconductor Corporation, 2002 
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_protoForm.c,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract: packet genration module. protocol form.
*
* $Author: blue $
*
* $Log: pg_protoForm.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:12  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:34  danwu
* init
*
* Revision 1.4  2004/01/08 14:58:18  waynelee
* update
*
* Revision 1.3  2003/12/30 10:34:42  waynelee
* add pptp, ipx support and provide more flexible packet format
*
* Revision 1.2  2003/12/19 02:23:15  danwu
* input complete tcp flag (ack) into routine l4FormTcpFlow
*
* Revision 1.1  2002/08/28 03:44:16  orlando
* packet generation module initial check-in.
*
*
* * modify to generate a complete ethernet frame
*   (1) if (ether-header + ether-payload < 60)
*           ether-header+ether-payload = 60.
*       # the ether payload part will be '0x00', as pktBuf[] has been
*         cleared to zero at very beginning
*       # if 'payloadLen' has been given, 0x5a will be added in the
*         content[] buffer to form the packet (copied from content[]
*         to pktBuf[]. after that, if ether-head + ether-payload
*         still < 60, the '0x00' will be used in the pktBuf[].
*   (2) add CRC
*   (3) length count-in CRC length (4 bytes)
* -----------------------------------------------------------------
*/

#include "pg_protoForm.h"
#include "pg_pktForm.h"
#include "pg_l3pkt.h"
#include "pg_l4pkt.h"

void protoForm_vsp_ether(int8 * pktBuf, uint32 l2Flag,
						int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority, 
						uint8 dsap, uint8 ssap,
						uint16 pppoeType,
						uint16 pppoeSession,
						uint16 etherType,
						int8 * content,
						uint32 * len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) ;
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, dsap, ssap, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l2FormOtherEtherType(pktFmt, pktBuf, etherType, content, *len);

	*len = formedFrameLen(pktFmt, pktBuf, *len);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}


void protoForm_vsp_ipx(int8 * pktBuf, uint32 l2Flag,
					   int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority, 
	//					uint8 dsap, uint8 ssap,
						uint16 pppoeType,
						uint16 pppoeSession,
						uint8 type,
						uint32 dnet, uint8 dnode[6], uint16 dsock,
						uint32 snet, uint8 snode[6], uint16 ssock,
						int8 * content, uint32 * len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IPX ;
	memset(pktBuf, 0, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xe0, 0xe0, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	// printf("before ipxb address: %02x%02x\n",pktBuf[20],pktBuf[21]);
	l3FormIpxBasic(pktFmt, type, pktBuf);
	// printf("before ipxd address: %02x%02x\n",pktBuf[20],pktBuf[21]);
	l3FormIpxDnet(pktFmt, dnet, dnode, dsock, pktBuf);
	// printf("before ipxs address: %02x%02x\n",pktBuf[20],pktBuf[21]);
	l3FormIpxSnet(pktFmt, snet, snode, ssock, pktBuf);
	// printf("after ipx address: %02x%02x\n",pktBuf[20],pktBuf[21]);

	l3FormIpxContent(pktFmt,pktBuf,content,*len);
	// printf("after ipxc address: %02x%02x\n",pktBuf[20],pktBuf[21]);

	*len = formedFrameLen(pktFmt, pktBuf, *len);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}


void protoForm_vs_arp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority, 
						int8 * sha, uint32 spa,
						int8 * tha, uint32 tpa,
						uint16 op, uint32 * len) {
	uint32 pktFmt;
	int8	zero[6]={0};

	pktFmt = (l2Flag & L2_MASK) | L3_ARP; //pppoe is ignored automatically
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l3FormArpBasic(pktFmt, op, pktBuf);

	// if users set "sha", use "sha"; if not, use "sa" as "sha"
	if(memcmp(sha,zero,6)==0)
		l3FormArpSelfInfo(pktFmt, pktBuf, spa, sa);
	else
		l3FormArpSelfInfo(pktFmt, pktBuf, spa, sha);

	// ARP: if users set "tha", use "tha" ; if not, use "da" as "tha"
	// RARP: if users set "tha", use "tha" ; if not, use "sa" as "tha" 
	if(memcmp(tha,zero,6)==0)
		if(op == ARPOP_REVREQUEST)
			l3FormArpPeerInfo(pktFmt, pktBuf, op, tpa, sa);
		else
			l3FormArpPeerInfo(pktFmt, pktBuf, op, tpa, da);
	else
		l3FormArpPeerInfo(pktFmt, pktBuf, op, tpa, tha);


	*len = formedFrameLen(pktFmt, pktBuf, *len);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

void protoForm_vsp_ip(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority,
						uint16 pppoeType,
						uint16 pppoeSession,
						uint8 ipv, uint8 iphl,
						uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
						uint8 ttl,uint32 sip, uint32 dip, int8 proto,
						int8 * content,
						uint32 errorFlag, uint32 * len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IP | L4_ICMP | (errorFlag&CTL_MASK);
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l3FormIpBasic(pktFmt, pktBuf, ipv, iphl); //Version 4, header length 20
	l3FormIpIdFrag(pktFmt, pktBuf, ipid, df, mf, ipoff/8);
	// l3FormIpIdFlag(uint32 flag, int8 * pktBuf, uint16 id, uint8 df, uint8 mf, uint16 offset)
	l3FormIpFlow(pktFmt, pktBuf, tos, ttl); //TOS 0, TTL 16
	l3FormIpAddr(pktFmt, pktBuf, sip, dip);
	l3FormIpProtocol(pktFmt, pktBuf, proto);
	l3FormIpContent(pktFmt, pktBuf, content, *len);

	*len = formedPktLen(pktFmt, pktBuf);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

void protoForm_vsp_pptp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority,
						uint16 pppoeType,
						uint16 pppoeSession, 
						uint8 ipv, uint8 iphl,
						uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
						uint8 ttl, uint32 sip, uint32 dip,
						uint16 callid, uint32 seqno, uint32 ackno,
						int8 * content, 
						uint32 errorFlag, uint32 * len) {

	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IP | L4_PPTP | (errorFlag&CTL_MASK);
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l3FormIpBasic(pktFmt, pktBuf, ipv, iphl); //Version 4, header length 20
	l3FormIpIdFrag(pktFmt, pktBuf, ipid, df, mf, ipoff/8);
	l3FormIpFlow(pktFmt, pktBuf, tos, ttl); //TOS 0, TTL 16
	l3FormIpAddr(pktFmt, pktBuf, sip, dip);

	l4FormPptpBasic(pktFmt, pktBuf, 0, 0, 1, 1, 0, 1, 1, 0, 1);
	l4FormPptpKey(pktFmt, pktBuf, callid, seqno, ackno);
	l4FormPptpOther(pktFmt, pktBuf, content, *len);

	*len = formedPktLen(pktFmt, pktBuf);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

void protoForm_vsp_icmp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority,
						uint16 pppoeType,
						uint16 pppoeSession, 
						uint8 ipv, uint8 iphl,
						uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
						uint8 ttl, uint32 sip, uint32 dip,
						uint8 type, uint8 code, uint16 id, uint16 seq,
						int8 * content,
						uint32 errorFlag, uint32 * len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IP | L4_ICMP | (errorFlag&CTL_MASK);
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l3FormIpBasic(pktFmt, pktBuf, ipv, iphl); //Version 4, header length 20
	l3FormIpIdFrag(pktFmt, pktBuf, ipid, df, mf, ipoff/8);
	l3FormIpFlow(pktFmt, pktBuf, tos, ttl); //TOS 0, TTL 16
	l3FormIpAddr(pktFmt, pktBuf, sip, dip);


	l4FormIcmpBasic(pktFmt, pktBuf, type, code);
	l4FormIcmpEcho(pktFmt, pktBuf, id, seq);

	l4FormIcmpData(pktFmt, pktBuf, content, *len);

	*len = formedPktLen(pktFmt, pktBuf);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

void protoForm_vsp_igmp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
					uint16 vid, uint8 vlanCfi, uint16 priority, 
					uint16 pppoeType,
					uint16 pppoeSession, 
					uint8 ipv, uint8 iphl,
					uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
					uint8 ttl, uint32 sip, uint32 dip,
					uint8 type, uint8 respTime, uint32 gaddr, 
					uint32 errorFlag, uint32 *len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IP | L4_IGMP | (errorFlag&CTL_MASK);
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l3FormIpBasic(pktFmt, pktBuf, ipv, iphl); //Version 4, header length 20
	l3FormIpIdFrag(pktFmt, pktBuf, ipid, df, mf, ipoff/8);
	l3FormIpFlow(pktFmt, pktBuf, tos, ttl); //TOS 0, TTL 16
	l3FormIpAddr(pktFmt, pktBuf, sip, dip);

	l4FormIgmpBasic(pktFmt, pktBuf, type, respTime, gaddr);

	*len = formedPktLen(pktFmt, pktBuf);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

void protoForm_vsp_tcp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
					uint16 vid, uint8 vlanCfi, uint16 priority,
					uint16 pppoeType,
					uint16 pppoeSession, 
					uint8 ipv, uint8 iphl,
					uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
					uint8 ttl, uint32 sip, uint32 dip,
					uint16 sport, uint16 dport,
					uint32 seq, uint32 ack, uint8 tcpFlag, uint16 win, 
					int8 * content, uint32 errorFlag, uint32 * len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IP | L4_TCP | (errorFlag&CTL_MASK);
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l3FormIpBasic(pktFmt, pktBuf, ipv, iphl); //Version 4, header length 20
	l3FormIpIdFrag(pktFmt, pktBuf, ipid, df, mf, ipoff/8);
	l3FormIpFlow(pktFmt, pktBuf, tos, ttl); //TOS 0, TTL 16
	l3FormIpAddr(pktFmt, pktBuf, sip, dip);

	l4FormTcpBasic(pktFmt, pktBuf, sport, dport, 20);
	l4FormTcpFlow(pktFmt, pktBuf, seq, ack, win, tcpFlag, 0);
//	l4FormTcpFlow(pktFmt, pktBuf, seq, ack, win, ack?TH_ACK:0, 0);
	l4FormTcpContent(pktFmt, pktBuf, content, *len);

	*len = formedPktLen(pktFmt, pktBuf);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

void protoForm_vsp_udp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
					uint16 vid, uint8 vlanCfi, uint16 priority,
					uint16 pppoeType,
					uint16 pppoeSession,
					uint8 ipv, uint8 iphl,
					uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
					uint8 ttl, uint32 sip, uint32 dip,
					uint16 sport, uint16 dport,
					int8 * content, uint32 errorFlag, uint32 * len) {
	uint32 pktFmt;

	pktFmt = (l2Flag & L2_MASK) | L3_IP | L4_UDP | (errorFlag&CTL_MASK);
	memset(pktBuf, 0x00, 2048);
	l2FormEtherAddress(pktBuf, da, sa);
	l2FormVlanTag(pktFmt, pktBuf, vid, vlanCfi, priority);
	l2FormLlc(pktFmt, 0xAA, 0xAA, pktBuf);
	l2FormPppoeSession(pktFmt, pktBuf, pppoeType, pppoeSession);
	l3FormIpBasic(pktFmt, pktBuf, ipv, iphl); //Version 4, header length 20
	l3FormIpIdFrag(pktFmt, pktBuf, ipid, df, mf, ipoff/8);
	l3FormIpFlow(pktFmt, pktBuf, tos, ttl); //TOS 0, TTL 16
	l3FormIpAddr(pktFmt, pktBuf, sip, dip);

	l4FormUdpBasic(pktFmt, pktBuf, sport, dport);
	l4FormUdpContent(pktFmt, pktBuf, content, *len);

	*len = formedPktLen(pktFmt, pktBuf);
	if (*len < 60)
		*len = 60;
	l2FormCrc(pktFmt, pktBuf, *len);
	*len+=4;
}

/* end of pg_protoForm.c */
