/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_protoForm.h,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract:
*
* $Log: pg_protoForm.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:12  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:43  danwu
* init
*
* Revision 1.2  2003/12/30 10:34:41  waynelee
* add pptp, ipx support and provide more flexible packet format
*
* Revision 1.1  2002/08/28 03:44:21  orlando
* packet generation module initial check-in.
*
*-------------------------------------------------------------------------
*/

#ifndef _PG_PROTOFORM_H_
#define _PG_PROTOFORM_H_

#include "../../rtl_types.h"


/* 
 * general ethernet frames; we can indicate the ethertype of this frame
 */

void protoForm_vsp_ether(int8 * pktBuf, uint32 l2Flag,
						int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority, 
						uint8 dsap, uint8 ssap,
						uint16 pppoeType,
						uint16 pppoeSession,
						uint16 etherType,
						int8 * content,
						uint32 * len);

/*
 * IPX packets; only support general IPX/SAP
 * Note: if using l2Flag, only vlan works.
 */

void protoForm_vsp_ipx(int8 * pktBuf, uint32 l2Flag,
					   int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority, 
	//					uint8 dsap, uint8 ssap,
						uint16 pppoeType,
						uint16 pppoeSession,
						uint8 type,
						uint32 dnet, uint8 dnode[6], uint16 dsock,
						uint32 snet, uint8 snode[6], uint16 ssock,
						int8 * content, uint32 * len);

/*
 * ARP packets; including ARP, RARP
 */

void protoForm_vs_arp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority, 
						int8 * sha, uint32 spa,
						int8 * tha, uint32 tpa,
						uint16 op, uint32 * len);
/*
 * IP packets; len is the length of IP payload
 */

void protoForm_vsp_ip(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority,
						uint16 pppoeType,
						uint16 pppoeSession, 
						uint8 ipv, uint8 iphl,
						uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
						uint8 ttl,uint32 sip, uint32 dip, int8 proto,
						int8 * content,
						uint32 errorFlag, uint32 * len);

void protoForm_vsp_pptp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority,
						uint16 pppoeType,
						uint16 pppoeSession, 
						uint8 ipv, uint8 iphl,
						uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
						uint8 ttl, uint32 sip, uint32 dip,
						uint16 callid, uint32 seqno, uint32 ackno,
						int8 * content, 
						uint32 errorFlag, uint32 * len);
/*
 * ICMP packets; len is the length of ICMP payload
 */

void protoForm_vsp_icmp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
						uint16 vid, uint8 vlanCfi, uint16 priority,
						uint16 pppoeType,
						uint16 pppoeSession, 
						uint8 ipv, uint8 iphl,
						uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
						uint8 ttl, uint32 sip, uint32 dip,
						uint8 type, uint8 code, uint16 id, uint16 seq,
						int8 * content,
						uint32 errorFlag, uint32 * len);
/*
 * IGMP packets; len doesn't work now.
 */

void protoForm_vsp_igmp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
					uint16 vid, uint8 vlanCfi, uint16 priority,
					uint16 pppoeType,
					uint16 pppoeSession, 
					uint8 ipv, uint8 iphl,
					uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
					uint8 ttl, uint32 sip, uint32 dip,
					uint8 type, uint8 respTime, uint32 gaddr, 
					uint32 errorFlag, uint32 *len);
/*
 * TCP packets; len is the length of TCP payload
 */

void protoForm_vsp_tcp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
					uint16 vid, uint8 vlanCfi, uint16 priority,
					uint16 pppoeType,
					uint16 pppoeSession, 
					uint8 ipv, uint8 iphl,
					uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
					uint8 ttl, uint32 sip, uint32 dip,
					uint16 sport, uint16 dport,
					uint32 seq, uint32 ack, uint8 tcpFlag, uint16 win, 
					int8 * content, uint32 errorFlag, uint32 * len);
/*
 * UDP packets; len is the length of UDP payload
 */

void protoForm_vsp_udp(int8 * pktBuf, uint32 l2Flag, int8 * da, int8 * sa, 
					uint16 vid, uint8 vlanCfi, uint16 priority,
					uint16 pppoeType,
					uint16 pppoeSession,
					uint8 ipv, uint8 iphl,
					uint8 tos, uint16 ipid, uint8 df, uint8 mf, uint16 ipoff,
					uint8 ttl, uint32 sip, uint32 dip,
					uint16 sport, uint16 dport,
					int8 * content, uint32 errorFlag, uint32 * len);

#endif /* _PG_PROTOFORM_H_ */

/* end of pg_protoForm.h */
