/*
* ----------------------------------------------------------------
* Copyright c              Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pg_utility.c,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract: packet generation module. utility routines.
*
* $Author: blue $
*
* $Log: pg_utility.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:12  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:34  danwu
* init
*
* Revision 1.4  2003/05/02 09:57:40  cfliu
* remove DIV, MOD, MUL
*
* Revision 1.3  2003/04/30 15:46:08  cfliu
* remove macro.h, use macros defined in types.h instead
*
* Revision 1.2  2003/02/27 02:44:20  jzchen
* Remove some multiple definition function
*
* Revision 1.1  2002/08/28 03:44:25  orlando
* packet generation module initial check-in.
*
* ---------------------------------------------------------------
*/

#include "../../types.h"
#include "pg_utility.h"

#if 0
int
isxdigit( int c )
{
    return (isdigit(c) || (c >= 'a' && c <= 'f') || (c >= 'A' && c <= 'F'));
}

int
isspace( int c )
{
    return (c == ' ' || c == '\f' || c == '\n' || c == '\r' ||
	    c == '\t' || c == '\v');
}

int
islower( int c )
{
    return (c >=  'a' && c <= 'z');
}


int
isascii( int c )
{
    return (c > 0 && c <= 0x7f);
}

int isdigit( int c )
{
    return (c >= '0' && c <= '9');
}

void memDump(void *start, uint32 size, int8 * strHeader)
{

	int32     row, column, index, index2, max;
	uint8    *buf, ascii[17];
	char      empty = ' ';

	assert(start && (size > 0));
	buf = (uint8 *) start;

	/*
	   16 bytes per line
	 */
	if (strHeader)
		printf("%s", strHeader);
	column = size % 16;
	//column = MOD(size , 16);
	row = (size / 16) + 1;
	//row = DIV(size , 16) + 1;
	for (index = 0; index < row; index++, buf += 16)
	{
		memset(ascii, 0, 17);
		printf("\n%08x ", (memaddr) buf);

		max = (index == row - 1) ? column : 16;

		//Hex
		for (index2 = 0; index2 < max; index2++)
		{
			if (index2 == 8)
				printf("  ");
			printf("%02x ", (uint8) buf[index2]);
			ascii[index2] = ((uint8) buf[index2] < 32) ? empty : buf[index2];
		}

		if (max != 16)
		{
			if (max < 8)
				printf("  ");
			for (index2 = 16 - max; index2 > 0; index2--)
				printf("   ");
		}

		//ASCII
		printf("  %s", ascii);
	}
	printf("\n");
	return;
}
#endif

uint16 ipcsum(uint16 *ptr, uint32 len, uint16 resid) {
	uint32 csum = resid;
	uint32 odd = 0;

	if(len & 1) odd = 1;
	len = len >> 1;
	
	for(;len > 0 ; len--,ptr++) 
		csum += ntohs(*ptr);

	if(odd)
		csum += (*((uint8 *)ptr) <<8) & 0xff00;

	/* take care of 1's complement */
	while(csum >> 16)
		csum = (csum & 0xffff) + (csum >> 16);

	if(csum == 0xffff)	csum = 0;

	return((uint16)csum);
}

uint16 ipadjcsum(uint16 old, uint32 diff) {
	uint32 csum = old + diff;

	csum = (csum & 0xffff) + (csum >> 16);
	if(!csum)	csum = 0xffff;
	return((uint16)csum);
}

/* 
 * Check whether "cp" is a valid ascii representation
 * of an Internet address and convert to a binary address.
 * Returns 1 if the address is valid, 0 if not.
 * This replaces inet_addr, the return value from which
 * cannot distinguish between failure and a local broadcast address.
 * returns in network order
 */
int32 inet_aton(const int8 *cp, struct in_addr *addr){
	uint32 val;
	int32 base, n;
	int8 c;
	uint32 parts[4];
	uint32 *pp = parts;

	c = *cp;
	for (;;) {
		/*
		 * Collect number up to ``.''.
		 * Values are specified as for C:
		 * 0x=hex, 0=octal, isdigit=decimal.
		 */
		if (!isdigit(c))
			return (0);
		val = 0; base = 10;

		//determine the base
		if (c == '0') {
			c = *++cp;
			if (c == 'x' || c == 'X')
				base = 16, c = *++cp;
			else
				base = 8;
		}

		for (;;) {
			if (isascii(c) && isdigit(c)) {
				//val = (val * base) + (c - '0');
				val = val*base + (c - '0');
				c = *++cp;
			} else if (base == 16 && isascii(c) && isxdigit(c)) {
				val = (val << 4) |
					(c + 10 - (islower(c) ? 'a' : 'A'));
				c = *++cp;
			} else
				break;
		}

		if (c == '.') {
			/*
			 * Internet format:
			 *	a.b.c.d
			 *	a.b.c	(with c treated as 16 bits)
			 *	a.b	(with b treated as 24 bits)
			 */
			if (pp >= parts + 3)
				return (0);
			*pp++ = val;
			c = *++cp;
		} else
			break;
	}
	/*
	 * Check for trailing characters.
	 */
	if (c != '\0' && (!isascii(c) || !isspace(c)))
		return (0);
	/*
	 * Concoct the address according to
	 * the number of parts specified.
	 */
	n = pp - parts + 1;
	switch (n) {

	case 0:
		return (0);		/* initial nondigit */

	case 1:				/* a -- 32 bits */
		break;

	case 2:				/* a.b -- 8.24 bits */
		if ((val > 0xffffff) || (parts[0] > 0xff))
			return (0);
		val |= parts[0] << 24;
		break;

	case 3:				/* a.b.c -- 8.8.16 bits */
		if ((val > 0xffff) || (parts[0] > 0xff) || (parts[1] > 0xff))
			return (0);
		val |= (parts[0] << 24) | (parts[1] << 16);
		break;

	case 4:				/* a.b.c.d -- 8.8.8.8 bits */
		if ((val > 0xff) || (parts[0] > 0xff) || (parts[1] > 0xff) || (parts[2] > 0xff))
			return (0);
		val |= (parts[0] << 24) | (parts[1] << 16) | (parts[2] << 8);
		break;
	}
	if (addr)
		addr->s_addr = htonl(val);
	return (1);
}

/*deprecated.*/
uint32 inet_addr(const int8 *cp){
	struct in_addr val;

	if (inet_aton(cp, &val))
		return (val.s_addr);
	return (INADDR_NONE); //typically -1, but that is equivalent to 255.255.255.255!!! 
}

static int8 *ui8tod( uint8 n, int8 *p )
{
	//if( n > 99 ) *p++ = (n/100) + '0';
	if( n > 99 ) *p++ = (n/100) + '0';
	//if( n >  9 ) *p++ = ((n/10)%10) + '0';
	if( n >  9 ) *p++ = ((n/10)%10) + '0';
	//*p++ = (n%10) + '0';
	*p++ = (n%10) + '0';
	return p;
}

int8 *inet_ntoa(struct in_addr ina)
{
	static int8 buf[4*sizeof "123"];
	int8 *p = buf;
	uint8 *ucp = (unsigned char *)&ina;

	p = ui8tod( ucp[0] & 0xFF, p);
	*p++ = '.';
	p = ui8tod( ucp[1] & 0xFF, p);
	*p++ = '.';
	p = ui8tod( ucp[2] & 0xFF, p);
	*p++ = '.';
	p = ui8tod( ucp[3] & 0xFF, p);
	*p++ = '\0';

	return (buf);
}
