/*
*-------------------------------------------------------------------------
* Copyright c                  Realtek Semiconductor Corporation, 2002
* All rights reserved.
* 
* $Header: /home/cvsroot/SBU_III_2/wpnt834/ntg/src_from_v1036/uClinux-dist/linux-2.4.x/drivers/net/re865x/rtl865x/veri/pktgen/pktgen.h,v 1.1.1.1 2006/07/26 05:38:30 blue Exp $
*
* Abstract: packet generation/parsing module header file.
*
* $Log: pktgen.h,v $
* Revision 1.1.1.1  2006/07/26 05:38:30  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:26  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:12  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.1  2004/03/26 06:31:43  danwu
* init
*
* Revision 1.5  2003/12/30 10:36:31  waynelee
* add pptp, ipx support and provide more flexible packet format
*
* Revision 1.4  2003/12/19 02:24:40  danwu
* no message
*
* Revision 1.3  2003/04/30 15:35:25  cfliu
* remove rtl_Debug.h
*
* Revision 1.2  2002/08/28 08:43:01  orlando
* Add pg_pktDump().
*
* Revision 1.1  2002/08/28 03:50:42  orlando
* Packet gen module exported header file.
*
*-------------------------------------------------------------------------
*/

#ifndef _PKTGEN_H_
#define _PKTGEN_H_

#include "../../rtl_types.h"
#include "pg_utility.h"
#include "pg_dumpPkt.h"

#include "pg_flagDef.h"
#include "pg_l2pkt.h"
#include "pg_l3pkt.h"
#include "pg_l4pkt.h"

#ifdef __linux__
#define printf printk
#endif

// prototype declaration

void pg_pktGen
(
int8   * pType,     // <(a)rp/(i)p/(t)cp/(u)dp/i(c)mp/i(g)mp>
int8   * l2FlagStr, // [v|s|p|n]
uint32   payloadLen, // highest level protocol payload length
int8   * pktBuf, // packet buffer pointer, preallocated at least 2048 bytes
uint32 * pLen,
int8   * srcIp, // src ip: 4 byte array pointer
int8   * dstIp, // dest ip: 4 byte array pointer
int8   * sa, // src mac: 6 byte array pointer
int8   * da  // dest mac: 6 byte array pointer
); // in pg_pktGen.c

// data type declaration
typedef struct pktParse_s {
	uint32		pktFlag;
	// L2
	etherHdr_t	*ether2;
	vlanHdr_t	*vlan;
	llcHdr_t	*llc;
	pppoeHdr_t	*pppoe;
	//Following are mutual exclusive
		// IPX
		ipxHdr_t	*ipx;
		// ARP
		arpHdr_t	*arp;
		// IP	
		ipHdr_t		*ip;
		uint32		l3Flag;
		uint16		l3Cksum;
		uint32		ipDataLen;
		uint8		*ipPayload;
	//Following are mutual exclusive
	greHdr_t	*pptp;
	icmpHdr_t	*icmp;
	igmpHdr_t	*igmp;
	udpHdr_t	*udp;
	tcpHdr_t	*tcp;
	uint32		l4Flag;
	uint16		l4Cksum;
	// payload
	uint8		*payload;
	// Total Length
	uint32		totalLen;
	// Data Length
	uint32		dataLen;
} pktParse_t;




void pg_pktParse(int8 * pktBuf, uint32 pktLen); // in pg_pktParse.c

void pg_pktDump(int8 * pktBuf, uint32 pktLen); // in pg_dumpPkt.c

void pktParse(int8 * pkt, pktParse_t * result, uint32 totalLen);


#endif /* _PKTGEN_H_ */
