#include <linux/config.h>
#include "../../rtl_types.h"
#include "../../asicRegs.h"
#include "../../hsRegs.h"
#include "../../rtl8651_tblAsicDrv.h"
#include "../veri.h"

/* LOCAL DEFINITIONS 
*/
/* gateway */
#define WAN0_VID 8
#define WAN0_PORT 0
#define GW_WAN0_MAC "00-00-00-00-88-88"
#define WAN1_VID 9
#define WAN1_PORT 1
#define GW_WAN1_MAC "00-00-00-00-88-89"
#define GW_WAN1_IP "172.20.1.11"
#define GW_WAN1_SUBNET_MASK "255.255.255.0"
#define LAN_VID 11
#define LAN_PORT 2
#define GW_LAN_MAC "00-00-00-00-88-8b"
#define GW_LAN_IP "192.168.1.254"
#define GW_LAN_SUBNET_MASK "255.255.255.0"
/* wan 0 isp 0 */
#define WAN0_ISP0_MAC "00-00-00-00-99-9c"
#define WAN0_ISP0_PPPOE_SID 0x55
#define WAN0_ISP0_NPE_IP "203.49.1.11"
#define WAN0_ISP0_NE1_IP "203.49.1.12"
#define WAN0_ISP0_NE2_IP "203.49.1.13"
/* wan 0 isp 1 */
#define WAN0_ISP1_MAC "00-00-00-00-99-9d"
#define WAN0_ISP1_PPPOE_SID 0xcc
#define WAN0_ISP1_NPE_IP "109.1.1.20"
#define WAN0_ISP1_NE3_IP "109.1.1.21"
/* wan 1 */
#define WAN1_ISP_MAC "00-00-00-00-99-9e"
#define WAN1_ISP_NPE_IP "172.20.1.11"
#define WAN1_ISP_NE1_IP "172.20.1.12"
#define WAN1_ISP_NE2_IP "172.20.1.13"
#define WAN1_ISP_NE3_IP "172.20.1.14"
/* lan hosts */
#define LAN_NI_HOST1_MAC "00-00-00-00-00-10"
#define LAN_NI_HOST1_IP "192.168.1.1"
#define LAN_NI_HOST2_MAC "00-00-00-00-00-20"
#define LAN_NI_HOST2_IP "192.168.1.2"
#define LAN_NI_HOST3_MAC "00-00-00-00-00-30"
#define LAN_NI_HOST3_IP "192.168.1.3"
#define LAN_NPI_HOST1_MAC "00-00-00-00-00-40"
#define LAN_NPI_HOST1_IP "192.168.1.161"
#define LAN_NPI_HOST2_MAC "00-00-00-00-00-50"
#define LAN_NPI_HOST2_IP "192.168.1.214"
#define LAN_SRV_HOST_MAC "00-00-00-00-00-60"
#define LAN_SRV_HOST_IP "192.168.1.150"
/* lan public hosts */
#define LAN_LP_HOST_MAC "00-00-00-00-00-90"
#define LAN_LP_HOST_IP "211.72.6.6"
/* rp */
#define RP_IP "211.72.254.7"
/* wan 1 rp */
#define RP2_IP "172.20.1.6"


void routCentric_tplg()
{
extern rtl865x_tblAsicDrv_vlanParam_t vlant;
extern _rtl8651_tblDrvAclRule_t aclt;
extern rtl865x_tblAsicDrv_l2Param_t l2t;
extern rtl865x_tblAsicDrv_pppoeParam_t pppoet;
extern rtl865x_tblAsicDrv_nextHopParam_t nxthpt;
extern rtl865x_tblAsicDrv_arpParam_t arpt;
extern rtl865x_tblAsicDrv_routingParam_t routet;
extern rtl865x_tblAsicDrv_extIntIpParam_t ipt;
extern rtl865x_tblAsicDrv_serverPortParam_t srvt;
    ipaddr_t ip32;
    uint32 i;
    
    /* switch core misc control reg: enable L4 hash, multicast MTU = 0x6ff */
    WRITE_MEM32(MISCCR, 0x16ff);
    /* module switch control reg: enable L2/L3/L4/ingress ACL/STP, trap 802.1D/GARP to CPU */
    rtl8651_setAsicOperationLayer(4);
    /* TTL control reg: enable TTL-1 operation */
    WRITE_MEM32(TTLCR, EN_TTL1);
    /* VLAN tagging control reg: accept untagged */
    WRITE_MEM32(VLANTCR, 0);
    /* l4 table aging control reg */
    WRITE_MEM32(TEATCR, 0xffffffff);
    /* l4 table offset control reg: start = 20, end = 20 */
    WRITE_MEM32(OCR, (20<<OCR_START_OFFSET)|(20<<OCR_END_OFFSET));
    /* switch table misc control reg: enable napt auto learn/delete, enable VLAN ingress filtering, 
      trap non-TCP/UDP/ICMP NAPT packets to CPU, enable multicast table, accept broadcast packets, 
      enable PPPoE auto-encapsulation and auto-decapsulation */
    WRITE_MEM32(SWTMCR, 0x7600001e);
    /* gidx mapping control */
    WRITE_MEM32(GIDXMCR, 0);
    
    /* enable 51b mode */
    WRITE_MEM32(SWTECR, EN_RTL8650B | EN_51B_CPU_REASON);
    
    /* port based vlan config reg */
    WRITE_MEM32(PVCR, (rtl8651_vlanTableIndex(LAN_VID)<<(LAN_PORT*3) | (rtl8651_vlanTableIndex(WAN0_VID)<<(WAN0_PORT*3)) | (rtl8651_vlanTableIndex(WAN1_VID)<<(WAN1_PORT*3))));

    rtl8651_clearAsicAllTable();
    
    /* config vlan table */
    bzero((void*) &vlant, sizeof(vlant));
    /* wan 0 */
    strtomac(&vlant.macAddr, GW_WAN0_MAC);
    vlant.memberPortMask = vlant.untagPortMask = 1 << WAN0_PORT;
    vlant.macAddrNumber = 1;
    vlant.vid = WAN0_VID;
    for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum;i++)
        vlant.portState[i] = RTL8651_PORTSTA_FORWARDING;
    vlant.mtu = 1522;
    vlant.inAclStart = 0;
    vlant.inAclEnd = 3;
    vlant.outAclStart = 4;
    vlant.outAclEnd = 7;
    vlant.internal = 0;
    vlant.enableRoute = 1;
    vlant.valid = 1;
    rtl8651_setAsicVlan(&vlant);
    /* ingress filter gateway mac */
    aclt.ruleType_ = RTL8651_ACL_MAC;
    memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
    memset(aclt.srcMacMask_.octet, 0xff, 6);
    aclt.actionType_ = RTL8651_ACL_CPU;
    rtl8651_setAsicAclRule(0, &aclt);
    /* wan 1 */
    strtomac(&vlant.macAddr, GW_WAN1_MAC);
    vlant.memberPortMask = vlant.untagPortMask = 1 << WAN1_PORT;
    vlant.vid = WAN1_VID;
    vlant.inAclStart = 8;
    vlant.inAclEnd = 11;
    vlant.outAclStart = 12;
    vlant.outAclEnd = 15;
    vlant.internal = 0;
    rtl8651_setAsicVlan(&vlant);
    /* ingress filter gateway mac */
    aclt.ruleType_ = RTL8651_ACL_MAC;
    memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
    aclt.actionType_ = RTL8651_ACL_CPU;
    rtl8651_setAsicAclRule(8, &aclt);
    /* lan */
    strtomac(&vlant.macAddr, GW_LAN_MAC);
    vlant.memberPortMask = vlant.untagPortMask = 1 << LAN_PORT;
    vlant.vid = LAN_VID;
    vlant.inAclStart = 16;
    vlant.inAclEnd = 19;
    vlant.outAclStart = 20;
    vlant.outAclEnd = 23;
    vlant.internal = 1;
    rtl8651_setAsicVlan(&vlant);
    /* ingress filter gateway mac */
    aclt.ruleType_ = RTL8651_ACL_MAC;
    memcpy(aclt.srcMac_.octet, vlant.macAddr.octet, 6);
    aclt.actionType_ = RTL8651_ACL_CPU;
    rtl8651_setAsicAclRule(16, &aclt);
    
    /* config l2 table */
    bzero((void*) &l2t, sizeof(l2t));
    /* wan 0 isp 0 modem */
    strtomac(&l2t.macAddr, WAN0_ISP0_MAC);
    l2t.memberPortMask = 1 << WAN0_PORT;
    l2t.isStatic = 1;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(WAN0_ISP0_MAC), 0, &l2t);
    /* wan 0 isp 0 modem */
    strtomac(&l2t.macAddr, WAN0_ISP1_MAC);
    l2t.memberPortMask = 1 << WAN0_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(WAN0_ISP1_MAC), 0, &l2t);
    /* wan 1 isp modem */
    strtomac(&l2t.macAddr, WAN1_ISP_MAC);
    l2t.memberPortMask = 1 << WAN1_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(WAN1_ISP_MAC), 0, &l2t);
    /* lan ni host 1 */
    strtomac(&l2t.macAddr, LAN_NI_HOST1_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_NI_HOST1_MAC), 0, &l2t);
    /* lan ni host 2 */
    strtomac(&l2t.macAddr, LAN_NI_HOST2_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_NI_HOST2_MAC), 0, &l2t);
    /* lan ni host 3 */
    strtomac(&l2t.macAddr, LAN_NI_HOST3_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_NI_HOST3_MAC), 0, &l2t);
    /* lan npi host 1 */
    strtomac(&l2t.macAddr, LAN_NPI_HOST1_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_NPI_HOST1_MAC), 0, &l2t);
    /* lan npi host 2 */
    strtomac(&l2t.macAddr, LAN_NPI_HOST2_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_NPI_HOST2_MAC), 0, &l2t);
    /* lan server host */
    strtomac(&l2t.macAddr, LAN_SRV_HOST_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_SRV_HOST_MAC), 0, &l2t);
    /* lan local public host */
    strtomac(&l2t.macAddr, LAN_LP_HOST_MAC);
    l2t.memberPortMask = 1 << LAN_PORT;
    rtl8651_setAsicL2Table(getL2TableRowFromMacStr(LAN_LP_HOST_MAC), 0, &l2t);
    
    /* config pppoe table */
    bzero((void*) &pppoet, sizeof(pppoet));
    /* wan 0 isp 0 modem */
    pppoet.sessionId = WAN0_ISP0_PPPOE_SID;
    rtl8651_setAsicPppoe(0, &pppoet);
    /* wan 0 isp 1 modem */
    pppoet.sessionId = WAN0_ISP1_PPPOE_SID;
    rtl8651_setAsicPppoe(1, &pppoet);
    
    /* config next hop table */
    bzero((void*) &nxthpt, sizeof(nxthpt));
    /* wan 0: load balance traffic through isp0 & isp1 as 3:1 */
    /* isp 0 occupies 3 entries */
    nxthpt.nextHopRow = getL2TableRowFromMacStr(WAN0_ISP0_MAC);
    nxthpt.pppoeIdx = 0; //WAN0_ISP0_PPPOE_SID
    nxthpt.dvid = rtl8651_vlanTableIndex(WAN0_VID);
    nxthpt.extIntIpIdx = 0; //WAN0_ISP0_NPE_IP
    nxthpt.isPppoe = 1;
    rtl8651_setAsicNextHopTable(0, &nxthpt);
    rtl8651_setAsicNextHopTable(1, &nxthpt);
    rtl8651_setAsicNextHopTable(2, &nxthpt);
    /* isp 1 */
    nxthpt.nextHopRow = getL2TableRowFromMacStr(WAN0_ISP1_MAC);
    nxthpt.pppoeIdx = 1; //WAN0_ISP1_PPPOE_SID
    nxthpt.dvid = rtl8651_vlanTableIndex(WAN0_VID);
    nxthpt.extIntIpIdx = 1; //WAN0_ISP1_NPE_IP
    nxthpt.isPppoe = 1;
    rtl8651_setAsicNextHopTable(3, &nxthpt);
    /* wan 1 */
    nxthpt.nextHopRow = getL2TableRowFromMacStr(WAN1_ISP_MAC);
    nxthpt.dvid = rtl8651_vlanTableIndex(WAN1_VID);
    nxthpt.extIntIpIdx = 4; //WAN1_ISP_NPE_IP
    nxthpt.isPppoe = 0;
    rtl8651_setAsicNextHopTable(4, &nxthpt);
    rtl8651_setAsicNextHopTable(5, &nxthpt);
    
    /* config arp table */
    bzero((void*) &arpt, sizeof(arpt));
    /* lan ni host 1 */
    arpt.nextHopRow = getL2TableRowFromMacStr(LAN_NI_HOST1_MAC);
    strtoip(&ip32, LAN_NI_HOST1_IP);
    rtl8651_setAsicArp(ip32 & 0xff, &arpt);
    /* lan ni host 2 */
    arpt.nextHopRow = getL2TableRowFromMacStr(LAN_NI_HOST2_MAC);
    strtoip(&ip32, LAN_NI_HOST2_IP);
    rtl8651_setAsicArp(ip32 & 0xff, &arpt);
    /* lan ni host 3 */
    arpt.nextHopRow = getL2TableRowFromMacStr(LAN_NI_HOST3_MAC);
    strtoip(&ip32, LAN_NI_HOST3_IP);
    rtl8651_setAsicArp(ip32 & 0xff, &arpt);
    /* lan npi host 1 */
    arpt.nextHopRow = getL2TableRowFromMacStr(LAN_NPI_HOST1_MAC);
    strtoip(&ip32, LAN_NPI_HOST1_IP);
    rtl8651_setAsicArp(ip32 & 0xff, &arpt);
    /* lan npi host 2 */
    bzero((void*) &arpt, sizeof(arpt));
    arpt.nextHopRow = getL2TableRowFromMacStr(LAN_NPI_HOST2_MAC);
    strtoip(&ip32, LAN_NPI_HOST2_IP);
    rtl8651_setAsicArp(ip32 & 0xff, &arpt);
    /* lan server host */
    arpt.nextHopRow = getL2TableRowFromMacStr(LAN_SRV_HOST_MAC);
    strtoip(&ip32, LAN_SRV_HOST_IP);
    rtl8651_setAsicArp(ip32 & 0xff, &arpt);
    
    /* config routing table */
    bzero((void*) &routet, sizeof(routet));
    /* route to lan: use arp table [0:255] */
    strtoip(&routet.ipAddr, GW_LAN_IP);
    strtoip(&routet.ipMask, GW_LAN_SUBNET_MASK);
    routet.process = PROCESS_INDIRECT;
    routet.vidx = rtl8651_vlanTableIndex(LAN_VID);
    routet.arpStart = 0;
    routet.arpEnd = 31;
    rtl8651_setAsicRouting(0, &routet);
    /* route to wan 1: use next hop table [4:5] and ip/server port table domain 1 */
    strtoip(&routet.ipAddr, GW_WAN1_IP);
    strtoip(&routet.ipMask, GW_WAN1_SUBNET_MASK);
    routet.process = PROCESS_NXT_HOP;
    routet.vidx = rtl8651_vlanTableIndex(WAN1_VID);
    routet.nhStart = 4;
    routet.nhNum = 2; //index 4~5
    routet.nhNxt = 0;
    routet.nhAlgo = 2; //per-source
    routet.ipDomain = 1;
    rtl8651_setAsicRouting(2, &routet);
    /* default route to wan 0: use next hop table [0:3] and ip/server port table domain 0 */
    bzero((void*) &routet, sizeof(routet));
    strtoip(&routet.ipAddr, "0.0.0.0");
    strtoip(&routet.ipMask, "0.0.0.0");
    routet.process = PROCESS_NXT_HOP;
    routet.vidx = rtl8651_vlanTableIndex(WAN0_VID);
    routet.nhStart = 0;
    routet.nhNum = 4; //index 0~3
    routet.nhNxt = 0;
    routet.nhAlgo = 2; //per-source
    routet.ipDomain = 0;
    rtl8651_setAsicRouting(7, &routet);
    
    /* config ip table */
    bzero((void*) &ipt, sizeof(ipt));
    /* wan 0 isp 0 npe */
    strtoip(&ipt.extIpAddr, WAN0_ISP0_NPE_IP);
    ipt.nhIndex = 0;
    rtl8651_setAsicExtIntIpTable(0, &ipt);
    /* wan 0 isp 1 npe */
    strtoip(&ipt.extIpAddr, WAN0_ISP1_NPE_IP);
    ipt.nhIndex = 3;
    rtl8651_setAsicExtIntIpTable(1, &ipt);
    /* wan 0 isp 0 ne1 */
    strtoip(&ipt.intIpAddr, LAN_NI_HOST1_IP);
    strtoip(&ipt.extIpAddr, WAN0_ISP0_NE1_IP);
    ipt.nhIndex = 0;
    ipt.nat = 1;
    rtl8651_setAsicExtIntIpTable(2, &ipt);
    /* wan 0 isp 1 ne3 */
    strtoip(&ipt.intIpAddr, LAN_NI_HOST3_IP);
    strtoip(&ipt.extIpAddr, WAN0_ISP1_NE3_IP);
    ipt.nhIndex = 3;
    ipt.nat = 1;
    rtl8651_setAsicExtIntIpTable(3, &ipt);
    /* wan 1 isp npe */
    strtoip(&ipt.intIpAddr, "0.0.0.0");
    strtoip(&ipt.extIpAddr, WAN1_ISP_NPE_IP);
    ipt.nhIndex = 4;
    ipt.nat = 0;
    rtl8651_setAsicExtIntIpTable(6, &ipt);
    /* wan 1 isp ne1 */
    strtoip(&ipt.intIpAddr, LAN_NI_HOST1_IP);
    strtoip(&ipt.extIpAddr, WAN1_ISP_NE1_IP);
    ipt.nhIndex = 4;
    ipt.nat = 1;
    rtl8651_setAsicExtIntIpTable(7, &ipt);
    
    /* config server port table */
    bzero((void*) &srvt, sizeof(srvt));
    /* server port 1020 translated to wan 0 isp 0 npe with port 20 */
    strtoip(&srvt.intIpAddr, LAN_SRV_HOST_IP);
    strtoip(&srvt.extIpAddr, WAN0_ISP0_NPE_IP);
    srvt.extPort = 20;
    srvt.intPort = 1020;
    srvt.nhIndex = 0;
    srvt.valid = 1;
    rtl8651_setAsicServerPortTable(0, &srvt);
    /* server port 1080 translated to wan 0 isp 1 npe with port 80 */
    strtoip(&srvt.intIpAddr, LAN_SRV_HOST_IP);
    strtoip(&srvt.extIpAddr, WAN0_ISP1_NPE_IP);
    srvt.extPort = 80;
    srvt.intPort = 1080;
    srvt.nhIndex = 3;
    srvt.valid = 1;
    rtl8651_setAsicServerPortTable(1, &srvt);
    /* server port 1020 translated to wan 1 isp npe with port 20 */
    strtoip(&srvt.intIpAddr, LAN_SRV_HOST_IP);
    strtoip(&srvt.extIpAddr, WAN1_ISP_NPE_IP);
    srvt.extPort = 20;
    srvt.intPort = 1020;
    srvt.nhIndex = 4;
    srvt.valid = 1;
    rtl8651_setAsicServerPortTable(7, &srvt);
    
    VERI_MSG(("*****\n* Route-centric mechanism test topology ready!\n*****\n"));
    return;
}


/* NAT Next Hop Selection */
#define ROUTCENTRIC_TESTNATNEXTHOP_TARGET1 \
"Verify that the ipidx field of next hop table is neglected.\n"
#define ROUTCENTRIC_TESTNATNEXTHOP_TARGET2 \
"One internal IP address may appear at different entries in the ext/internal IP table. Verify that domain settings of L3 routing and ext/internal IP tables correctly select the corresponding external IP address.\n"
#define ROUTCENTRIC_TESTNATNEXTHOP_TARGET3 \
"One route (WAN) may contain multiple next hops (ISPs). Verify that selection of external IP address matches that of next hop.\n"
uint32 routCentric_testNatNextHop()
{
    uint32 errCount = 0;
    uint8 pktBuf[2048];
    uint32 pktLen;
    pktGenTcpFormat_t tcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNATNEXTHOP_TARGET1));
    
    /* lan ni host 1 to wan 0: NAT translation through isp 0 */
    VERI_MSG(("Outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NE1_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
    /* backward */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    tcpt.pppoeTag = 1;
    tcpt.sid = WAN0_ISP0_PPPOE_SID;
    strtomac(&tcpt.dmac, GW_WAN0_MAC);
    strtomac(&tcpt.smac, WAN0_ISP0_MAC);
    strtoip(&tcpt.dip, WAN0_ISP0_NE1_IP);
    strtoip(&tcpt.sip, RP_IP);
    tcpt.dport = 100;
    tcpt.sport = 200;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(WAN0_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;;
        }
        CHK_PKT_MAC(tcpt.dmac, LAN_NI_HOST1_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_NI_HOST1_IP, errCount);
        CHK_PKT_IP(tcpt.sip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 200, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNATNEXTHOP_TARGET2));
    
    /* lan ni host 1 to wan 1: NAT translation */
    VERI_MSG(("Outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NI_HOST1_MAC);
    strtoip(&tcpt.dip, RP2_IP);
    strtoip(&tcpt.sip, LAN_NI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN1_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN1_ISP_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN1_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, RP2_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN1_ISP_NE1_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
    /* backward */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_WAN1_MAC);
    strtomac(&tcpt.smac, WAN1_ISP_MAC);
    strtoip(&tcpt.dip, WAN1_ISP_NE1_IP);
    strtoip(&tcpt.sip, RP2_IP);
    tcpt.dport = 100;
    tcpt.sport = 200;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(WAN1_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;;
        }
        CHK_PKT_MAC(tcpt.dmac, LAN_NI_HOST1_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_NI_HOST1_IP, errCount);
        CHK_PKT_IP(tcpt.sip, RP2_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 200, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNATNEXTHOP_TARGET3));
    
    /* lan ni host 3 to wan 0: NAT translation through isp 1 */
    VERI_MSG(("Outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NI_HOST3_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NI_HOST3_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NE3_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
    /* backward */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    tcpt.pppoeTag = 1;
    tcpt.sid = WAN0_ISP1_PPPOE_SID;
    strtomac(&tcpt.dmac, GW_WAN0_MAC);
    strtomac(&tcpt.smac, WAN0_ISP1_MAC);
    strtoip(&tcpt.dip, WAN0_ISP1_NE3_IP);
    strtoip(&tcpt.sip, RP_IP);
    tcpt.dport = 100;
    tcpt.sport = 200;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(WAN0_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;;
        }
        CHK_PKT_MAC(tcpt.dmac, LAN_NI_HOST3_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_NI_HOST3_IP, errCount);
        CHK_PKT_IP(tcpt.sip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 200, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
_EXIT:
    return errCount;
}


/* Server Port Next Hop Selection */
#define ROUTCENTRIC_TESTSRVPRTNEXTHOP_TARGET1 \
"Verify that the ipidx field of next hop table is neglected.\n"
#define ROUTCENTRIC_TESTSRVPRTNEXTHOP_TARGET2 \
"One pair of internal IP address and port may appear at different entries in the server port table. Verify that domain settings of L3 routing and server port tables correctly select the corresponding external IP address and port.\n"
#define ROUTCENTRIC_TESTSRVPRTNEXTHOP_TARGET3 \
"One route (WAN) may contain multiple next hops (ISPs). Verify that selection of external IP address and port matches that of next hop.\n"
uint32 routCentric_testSrvPrtNextHop()
{
    uint32 errCount = 0;
    uint8 pktBuf[2048];
    uint32 pktLen;
    pktGenTcpFormat_t tcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTSRVPRTNEXTHOP_TARGET1));
    
    /* wan 0 rp to server port 20: NAPT server port translation */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    tcpt.pppoeTag = 1;
    tcpt.sid = WAN0_ISP0_PPPOE_SID;
    strtomac(&tcpt.dmac, GW_WAN0_MAC);
    strtomac(&tcpt.smac, WAN0_ISP0_MAC);
    strtoip(&tcpt.dip, WAN0_ISP0_NPE_IP);
    strtoip(&tcpt.sip, RP_IP);
    tcpt.dport = 20;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(WAN0_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;;
        }
        CHK_PKT_MAC(tcpt.dmac, LAN_SRV_HOST_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_SRV_HOST_IP, errCount);
        CHK_PKT_IP(tcpt.sip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 1020, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
    /* backward */
    VERI_MSG(("Outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_SRV_HOST_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_SRV_HOST_IP);
    tcpt.dport = 100;
    tcpt.sport = 1020;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 20, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTSRVPRTNEXTHOP_TARGET2));
    
    /* wan 1 rp to server port 20: NAPT server port translation */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_WAN1_MAC);
    strtomac(&tcpt.smac, WAN1_ISP_MAC);
    strtoip(&tcpt.dip, WAN1_ISP_NPE_IP);
    strtoip(&tcpt.sip, RP2_IP);
    tcpt.dport = 20;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(WAN1_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;;
        }
        CHK_PKT_MAC(tcpt.dmac, LAN_SRV_HOST_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_SRV_HOST_IP, errCount);
        CHK_PKT_IP(tcpt.sip, RP2_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 1020, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
    /* backward */
    VERI_MSG(("Outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_SRV_HOST_MAC);
    strtoip(&tcpt.dip, RP2_IP);
    strtoip(&tcpt.sip, LAN_SRV_HOST_IP);
    tcpt.dport = 100;
    tcpt.sport = 1020;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN1_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN1_ISP_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN1_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, RP2_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN1_ISP_NPE_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 20, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTSRVPRTNEXTHOP_TARGET3));
    
    /* wan 0 rp to server port 80: NAPT server port translation */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    tcpt.pppoeTag = 1;
    tcpt.sid = WAN0_ISP1_PPPOE_SID;
    strtomac(&tcpt.dmac, GW_WAN0_MAC);
    strtomac(&tcpt.smac, WAN0_ISP1_MAC);
    strtoip(&tcpt.dip, WAN0_ISP1_NPE_IP);
    strtoip(&tcpt.sip, RP_IP);
    tcpt.dport = 80;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(WAN0_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;;
        }
        CHK_PKT_MAC(tcpt.dmac, LAN_SRV_HOST_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_SRV_HOST_IP, errCount);
        CHK_PKT_IP(tcpt.sip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 1080, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
    /* backward */
    VERI_MSG(("Outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_SRV_HOST_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_SRV_HOST_IP);
    tcpt.dport = 100;
    tcpt.sport = 1080;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 80, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
_EXIT:
    return errCount;
}


/* NAPT Load Balance */
#define ROUTCENTRIC_TESTNAPTLOADBALANCE_TARGET1 \
"Verify per-packet load balance.\n"
#define ROUTCENTRIC_TESTNAPTLOADBALANCE_TARGET2 \
"Verify per-session load balance.\n"
#define ROUTCENTRIC_TESTNAPTLOADBALANCE_TARGET3 \
"Verify per-source-IP load balance.\n"
uint32 routCentric_testNaptLoadBalance()
{
    uint32 errCount = 0;
extern rtl865x_tblAsicDrv_routingParam_t routet;
    uint32 i;
    uint16 extPort;
    uint8 txPktBuf[2048], rxPktBuf[2048];
    uint32 txPktLen, rxPktLen;
    pktGenTcpFormat_t tcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTLOADBALANCE_TARGET1));
    
    /* per-packet load balance */
    rtl8651_getAsicRouting(7, &routet);
    routet.nhAlgo = 0;
    rtl8651_setAsicRouting(7, &routet);
    
    /* lan npi host 1 to wan 0: 3 packets through isp 0, 1 packet through isp 1 */
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = TCPFLAG_SYN;
    tcpt.padLen = 100;
    txPktLen = pktGenTcp(txPktBuf, &tcpt);
    extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
    for (i=1; i<=6; i++)
    {
        VERI_MSG(("Outbound packet through ISP %d ...\n", (i%4==0)));
        miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
        /* check received packet */
        rxPktLen=2048;
        miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
        else
        {
            if (pktParseTcp(rxPktBuf, &tcpt, rxPktLen) != SUCCESS)
            {
                VERI_MSG(("Error! received packet is not TCP\n"));
                ++errCount;
                goto _EXIT;
            }
            CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
            CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
            CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
            CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
            CHK_PKT_DEC(tcpt.dport, 200, errCount);
            CHK_PKT_DEC(tcpt.sport, extPort, errCount);
            if (i%4)
            {
                /* isp 0 */
                CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
                CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
                CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
            }
            else
            {
                /* isp 1 */
                CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
                CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
                CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
            }
        }
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTLOADBALANCE_TARGET2));
    
    /* per-session load balance */
    routet.nhAlgo = 1;
    rtl8651_setAsicRouting(7, &routet);
    
    /* lan npi host 1 to wan 0 */
    for (i=9; i<=14; i++)
    {
        bzero((void*) &tcpt, sizeof(tcpt));
        strtomac(&tcpt.dmac, GW_LAN_MAC);
        strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
        strtoip(&tcpt.dip, RP_IP);
        strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
        tcpt.sip &= 0xffffff00;
        tcpt.sip |= i;
        tcpt.dport = 200;
        tcpt.sport = 100;
        tcpt.flag = TCPFLAG_SYN;
        tcpt.padLen = 100;
        txPktLen = pktGenTcp(txPktBuf, &tcpt);
        extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
        VERI_MSG(("Outbound packet through ISP %d ...\n", ((extPort%4)==3)));
        miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
        /* check received packet */
        rxPktLen=2048;
        miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
        else
        {
            if (pktParseTcp(rxPktBuf, &tcpt, rxPktLen) != SUCCESS)
            {
                VERI_MSG(("Error! received packet is not TCP\n"));
                ++errCount;
                goto _EXIT;
            }
            CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
            CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
            CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
            CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
            CHK_PKT_DEC(tcpt.dport, 200, errCount);
            CHK_PKT_DEC(tcpt.sport, extPort, errCount);
            if ((extPort%4)!=3)
            {
                /* isp 0 */
                CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
                CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
                CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
            }
            else
            {
                /* isp 1 */
                CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
                CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
                CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
            }
        }
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));

    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTLOADBALANCE_TARGET3));
    
    /* per-source load balance */
    routet.nhAlgo = 2;
    rtl8651_setAsicRouting(7, &routet);
    
    /* lan npi host 1 to wan 0 */
    for (i=22; i<=27; i++)
    {
        bzero((void*) &tcpt, sizeof(tcpt));
        strtomac(&tcpt.dmac, GW_LAN_MAC);
        strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
        strtoip(&tcpt.dip, RP_IP);
        strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
        tcpt.sip &= 0xffffff00;
        tcpt.sip |= i;
        tcpt.dport = 200;
        tcpt.sport = 100;
        tcpt.flag = TCPFLAG_SYN;
        tcpt.padLen = 100;
        txPktLen = pktGenTcp(txPktBuf, &tcpt);
        extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
        VERI_MSG(("Outbound packet through ISP %d ...\n", (i%4==3)));
        miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
        /* check received packet */
        rxPktLen=2048;
        miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
        else
        {
            if (pktParseTcp(rxPktBuf, &tcpt, rxPktLen) != SUCCESS)
            {
                VERI_MSG(("Error! received packet is not TCP\n"));
                ++errCount;
                goto _EXIT;
            }
            CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
            CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
            CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
            CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
            CHK_PKT_DEC(tcpt.dport, 200, errCount);
            CHK_PKT_DEC(tcpt.sport, extPort, errCount);
            if (i%4!=3)
            {
                /* isp 0 */
                CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
                CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
                CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
            }
            else
            {
                /* isp 1 */
                CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
                CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
                CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
            }
        }
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));

_EXIT:
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    
    return errCount;
}


/* Server Port Next Hop Range */
#define ROUTCENTRIC_TESTSRVPRTRANGE_TARGET1 \
"Verify that server port range functionality.\n"
uint32 routCentric_testSrvPrtRange()
{
    uint32 errCount = 0;
extern rtl865x_tblAsicDrv_serverPortParam_t srvt;
    uint32 prt;
    uint8 pktBuf[2048];
    uint32 pktLen;
    pktGenTcpFormat_t tcpt;
    uint16 extPort;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    /* server port range 20~24 */
    bzero((void*) &srvt, sizeof(srvt));
    strtoip(&srvt.intIpAddr, LAN_SRV_HOST_IP);
    strtoip(&srvt.extIpAddr, WAN0_ISP0_NPE_IP);
    srvt.extPort = 24;
    srvt.intPort = 21;
    srvt.nhIndex = 0;
    srvt.portRange = 1;
    srvt.valid = 1;
    rtl8651_setAsicServerPortTable(0, &srvt);
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTSRVPRTRANGE_TARGET1));
    
    /* wan 0 rp to server ports: NAPT server port translation */
    for (prt=20; prt<=25; prt++)
    {
        if ((prt>=21) && (prt<=24))
        {
            VERI_MSG(("Inbound packet to server port %d ...\n", prt));
        }
        else
        {
            VERI_MSG(("Inbound packet to non-server port %d ...\n", prt));
        }
        bzero((void*) &tcpt, sizeof(tcpt));
        tcpt.pppoeTag = 1;
        tcpt.sid = WAN0_ISP0_PPPOE_SID;
        strtomac(&tcpt.dmac, GW_WAN0_MAC);
        strtomac(&tcpt.smac, WAN0_ISP0_MAC);
        strtoip(&tcpt.dip, WAN0_ISP0_NPE_IP);
        strtoip(&tcpt.sip, RP_IP);
        tcpt.dport = prt;
        tcpt.sport = 100;
        tcpt.flag = 0;
        tcpt.padLen = 100;
        pktLen = pktGenTcp(pktBuf, &tcpt);
        miiLikeTestSend(WAN0_PORT, pktBuf, pktLen);
        if ((prt>=21) && (prt<=24))
        {
            /* check received packet */
            pktLen=2048;
            miiLikeTestReceive(LAN_PORT, pktBuf, &pktLen);
            if (pktLen == 0)
            {
                VERI_MSG(("Error! no packet received\n"));
                ++errCount;
                goto _EXIT;;
            }
            else
            {
                if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
                {
                    VERI_MSG(("Error! received packet is not TCP\n"));
                    ++errCount;
                    goto _EXIT;;
                }
                CHK_PKT_MAC(tcpt.dmac, LAN_SRV_HOST_MAC, errCount);
                CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
                CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
                CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
                CHK_PKT_IP(tcpt.dip, LAN_SRV_HOST_IP, errCount);
                CHK_PKT_IP(tcpt.sip, RP_IP, errCount);
                CHK_PKT_DEC(tcpt.dport, prt, errCount);
                CHK_PKT_DEC(tcpt.sport, 100, errCount);
            }
        }
        else
        {
            miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen); //directly trapped
            if (pktLen == 0)
            {
                VERI_MSG(("Error! no packet received\n"));
                ++errCount;
                goto _EXIT;;
            }
        }
    }
    
    /* lan server ports to wan 0: NAPT server port translation */
    for (prt=20; prt<=25; prt++)
    {
        if ((prt>=21) && (prt<=24))
        {
            VERI_MSG(("Outbound packet from server port %d ...\n", prt));
        }
        else
        {
            VERI_MSG(("Outbound packet from non-server port %d ...\n", prt));
        }
        bzero((void*) &tcpt, sizeof(tcpt));
        strtomac(&tcpt.dmac, GW_LAN_MAC);
        strtomac(&tcpt.smac, LAN_SRV_HOST_MAC);
        strtoip(&tcpt.dip, RP_IP);
        strtoip(&tcpt.sip, LAN_SRV_HOST_IP);
        tcpt.dport = 100;
        tcpt.sport = prt;
        tcpt.flag = TCPFLAG_SYN;
        tcpt.padLen = 100;
        extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
        pktLen = pktGenTcp(pktBuf, &tcpt);
        miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
        /* check received packet */
        pktLen=2048;
        miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
        if (pktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
        else
        {
            if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
            {
                VERI_MSG(("Error! received packet is not TCP\n"));
                ++errCount;
                goto _EXIT;
            }
            CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
            CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
            CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
            CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
            CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
            CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
            CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
            CHK_PKT_DEC(tcpt.dport, 100, errCount);
            if ((prt>=21) && (prt<=24))
            {
                CHK_PKT_DEC(tcpt.sport, prt, errCount);
            }
            else
            {
                CHK_PKT_DEC(tcpt.sport, extPort, errCount);
            }
        }
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
_EXIT:
    /* recover server port table */
    bzero((void*) &srvt, sizeof(srvt));
    strtoip(&srvt.intIpAddr, LAN_SRV_HOST_IP);
    strtoip(&srvt.extIpAddr, WAN0_ISP0_NPE_IP);
    srvt.extPort = 20;
    srvt.intPort = 1020;
    srvt.nhIndex = 0;
    srvt.valid = 1;
    rtl8651_setAsicServerPortTable(0, &srvt);
    
    return errCount;
}


/* NAPT TCP/UDP Table Static Hash-1 with Next Hop */
#define ROUTCENTRIC_TESTNAPTSTATICHASH1_TARGET1 \
"Verify static Hash-1 entry with next hop table setting.\n"
uint32 routCentric_testNaptStaticHash1()
{
    uint32 errCount = 0;
    rtl865x_tblAsicDrv_naptTcpUdpParam_t tut;
    uint16 extPort;
    uint8 txPktBuf[2048], rxPktBuf[2048];
    uint32 txPktLen, rxPktLen;
    pktGenTcpFormat_t tcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTSTATICHASH1_TARGET1));
    
    /* comparison: lan npi host 1 to wan 0 through isp 0 */
    VERI_MSG(("Comparison: Outbound packet through ISP 0 ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = TCPFLAG_SYN;
    tcpt.padLen = 100;
    txPktLen = pktGenTcp(txPktBuf, &tcpt);
    extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &tcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, extPort, errCount);
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
    }
    
    /* set static entry through isp 1 */
    bzero((void*) &tut, sizeof(tut));
    strtoip(&tut.insideLocalIpAddr, LAN_NPI_HOST1_IP);
    tut.insideLocalPort = 100;
    tut.offset = 20;
    tut.selEIdx = 1|(3<<1); //select next hop index 3
    tut.isTcp = 1;
    tut.isStatic = 1;
    tut.isValid = 1;
    rtl8651_setAsicNaptTcpUdpTable(1, extPort & 0x3ff, &tut);
    
    /* lan npi host 1 to wan 0 through isp 1 */
    VERI_MSG(("Outbound packet through ISP 1 ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = TCPFLAG_SYN;
    tcpt.padLen = 100;
    txPktLen = pktGenTcp(txPktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &tcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, extPort, errCount);
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
    }
    
    /* wan 0 to lan npi host 1 */
    VERI_MSG(("Inbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_WAN0_MAC);
    strtomac(&tcpt.smac, WAN0_ISP1_MAC);
    tcpt.pppoeTag = 1;
    tcpt.sid = WAN0_ISP1_PPPOE_SID;
    strtoip(&tcpt.dip, WAN0_ISP1_NPE_IP);
    strtoip(&tcpt.sip, RP_IP);
    tcpt.dport = extPort;
    tcpt.sport = 200;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    txPktLen = pktGenTcp(txPktBuf, &tcpt);
    miiLikeTestSend(WAN0_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(LAN_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &tcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_LAN_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 0, errCount);
        CHK_PKT_IP(tcpt.dip, LAN_NPI_HOST1_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 200, errCount);
        CHK_PKT_MAC(tcpt.dmac, LAN_NPI_HOST1_MAC, errCount);
        CHK_PKT_IP(tcpt.sip, RP_IP, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
_EXIT:
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    
    return errCount;
}


/* NAPT TCP/UDP Table Hash-2 */
#define ROUTCENTRIC_TESTNAPTHASH2_TARGET1 \
"Verify Hash-2 entry with extern-interup-IP table offset setting (selIPIdx/selEIdx).\n"
#define ROUTCENTRIC_TESTNAPTHASH2_TARGET2 \
"Verify non-quiet mode (trap all SYN/FIN/RST to CPU).\n"
#define ROUTCENTRIC_TESTNAPTHASH2_TARGET3 \
"Verify collision-2.\n"
uint32 routCentric_testNaptHash2()
{
    uint32 errCount = 0;
    rtl865x_tblAsicDrv_naptTcpUdpParam_t tut;
    uint32 selExtIPIdx[2] = {0,1}, selEIdx[2] = {165,90}, i, j;
    uint32 hash2Idx;
    uint8 txPktBuf[2048], rxPktBuf[2048];
    uint32 txPktLen, rxPktLen;
    pktGenTcpFormat_t txOTcpt, txITcpt, rxTcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    /* prepare hash2 parameters */
    bzero((void*) &tut, sizeof(tut));
    strtoip(&tut.insideLocalIpAddr, LAN_NPI_HOST1_IP);
    tut.insideLocalPort = 100;
    tut.offset = 20;
    tut.isTcp = 1;
    tut.isStatic = 1;
    tut.isValid = 1;
    tut.isDedicated = 1;
    
    /* prepare lan npi host 1 to wan 0 through isp 0 */
    bzero((void*) &txOTcpt, sizeof(txOTcpt));
    strtomac(&txOTcpt.dmac, GW_LAN_MAC);
    strtomac(&txOTcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&txOTcpt.dip, RP_IP);
    strtoip(&txOTcpt.sip, LAN_NPI_HOST1_IP);
    txOTcpt.dport = 200;
    txOTcpt.sport = 100;
    txOTcpt.flag = 0;
    txOTcpt.padLen = 100;
    
    /* prepare wan 0 to lan npi host 1 through isp 0 */
    bzero((void*) &txITcpt, sizeof(txITcpt));
    strtomac(&txITcpt.dmac, GW_WAN0_MAC);
    txITcpt.pppoeTag = 1;
    strtoip(&txITcpt.sip, RP_IP);
    txITcpt.sport = 200;
    txITcpt.flag = 0;
    txITcpt.padLen = 100;
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH2_TARGET1));
    
    for (i=0; i<=1; i++)
        for (j=0; j<=1; j++)
        {
            /* clear napt tcp/udp table */
            rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
            /* set hash2 entries */
            tut.selExtIPIdx = selExtIPIdx[i];
            tut.selEIdx = selEIdx[j];
            tut.tcpFlag = (1<<2)|(1<<1)|(1<<0); //quiet,outbound
            hash2Idx = rtl8651_naptTcpUdpTableIndex(1, tut.insideLocalIpAddr, tut.insideLocalPort, 0, 0);
            rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut);
            tut.tcpFlag = (1<<2)|(1<<1)|(0<<0); //quiet,inbound
            rtl8651_setAsicNaptTcpUdpTable(1, tut.selEIdx, &tut);
            
            VERI_MSG(("Outbound packet with selIPIdx=%d, selEIdx=%d ...\n", selExtIPIdx[i], selEIdx[j]));
            txPktLen = pktGenTcp(txPktBuf, &txOTcpt);
            miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
            /* check received packet */
            rxPktLen=2048;
            miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
            if (rxPktLen == 0)
            {
                VERI_MSG(("Error! no packet received\n"));
                ++errCount;
                goto _EXIT;
            }
            else
            {
                if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
                {
                    VERI_MSG(("Error! received packet is not TCP\n"));
                    ++errCount;
                    goto _EXIT;
                }
                CHK_PKT_MAC(rxTcpt.smac, GW_WAN0_MAC, errCount);
                CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
                CHK_PKT_DEC(rxTcpt.pppoeTag, 1, errCount);
                CHK_PKT_IP(rxTcpt.dip, RP_IP, errCount);
                CHK_PKT_DEC(rxTcpt.dport, 200, errCount);
                CHK_PKT_DEC(rxTcpt.sport, (20<<10)|tut.selEIdx, errCount);
                if (tut.selExtIPIdx==0)
                {
                    CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP0_MAC, errCount);
                    CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
                    CHK_PKT_IP(rxTcpt.sip, WAN0_ISP0_NPE_IP, errCount);
                }
                else
                {
                    CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP1_MAC, errCount);
                    CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
                    CHK_PKT_IP(rxTcpt.sip, WAN0_ISP1_NPE_IP, errCount);
                }
            }
            
            VERI_MSG(("Inbound packet ...\n"));
            if (tut.selExtIPIdx==0)
            {
                strtomac(&txITcpt.smac, WAN0_ISP0_MAC);
                txITcpt.sid = WAN0_ISP0_PPPOE_SID;
                strtoip(&txITcpt.dip, WAN0_ISP0_NPE_IP);
            }
            else
            {
                strtomac(&txITcpt.smac, WAN0_ISP1_MAC);
                txITcpt.sid = WAN0_ISP1_PPPOE_SID;
                strtoip(&txITcpt.dip, WAN0_ISP1_NPE_IP);
            }
            txITcpt.dport = (20<<10)|tut.selEIdx;
            txPktLen = pktGenTcp(txPktBuf, &txITcpt);
            miiLikeTestSend(WAN0_PORT, txPktBuf, txPktLen);
            /* check received packet */
            rxPktLen=2048;
            miiLikeTestReceive(LAN_PORT, rxPktBuf, &rxPktLen);
            if (rxPktLen == 0)
            {
                VERI_MSG(("Error! no packet received\n"));
                ++errCount;
                goto _EXIT;
            }
            else
            {
                if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
                {
                    VERI_MSG(("Error! received packet is not TCP\n"));
                    ++errCount;
                    goto _EXIT;
                }
                CHK_PKT_MAC(rxTcpt.smac, GW_LAN_MAC, errCount);
                CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
                CHK_PKT_DEC(rxTcpt.pppoeTag, 0, errCount);
                CHK_PKT_IP(rxTcpt.sip, RP_IP, errCount);
                CHK_PKT_DEC(rxTcpt.sport, 200, errCount);
                CHK_PKT_DEC(rxTcpt.dport, 100, errCount);
                CHK_PKT_MAC(rxTcpt.dmac, LAN_NPI_HOST1_MAC, errCount);
                CHK_PKT_IP(rxTcpt.dip, LAN_NPI_HOST1_IP, errCount);
            }
        }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH2_TARGET2));
    
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    /* set hash entries */
    tut.selExtIPIdx = selExtIPIdx[1];
    tut.selEIdx = selEIdx[1];
    tut.tcpFlag = (0<<2)|(1<<1)|(1<<0); //non-quiet,outbound
    rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut);
    tut.tcpFlag = (0<<2)|(1<<1)|(0<<0); //non-quiet,inbound
    rtl8651_setAsicNaptTcpUdpTable(1, tut.selEIdx, &tut);
    for (i=0; i<=3; i++)
    {
        VERI_MSG(("Outbound packet with "));
        switch (i)
        {
            case 0: txOTcpt.flag = TCPFLAG_SYN; VERI_MSG(("SYN")); break;
            case 1: txOTcpt.flag = TCPFLAG_SYN|TCPFLAG_ACK; VERI_MSG(("SYN,ACK")); break;
            case 2: txOTcpt.flag = TCPFLAG_FIN; VERI_MSG(("FIN")); break;
            case 3: txOTcpt.flag = TCPFLAG_RST; VERI_MSG(("RST")); break;
        }
        VERI_MSG((" ...\n"));
        txPktLen = pktGenTcp(txPktBuf, &txOTcpt);
        miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
        /* check trapped packet */
        rxPktLen=2048;
        miiLikeTestReceive(LAN_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
            
        VERI_MSG(("Inbound packet with "));
        switch (i)
        {
            case 0: txITcpt.flag = TCPFLAG_SYN; VERI_MSG(("SYN")); break;
            case 1: txITcpt.flag = TCPFLAG_SYN|TCPFLAG_ACK; VERI_MSG(("SYN,ACK")); break;
            case 2: txITcpt.flag = TCPFLAG_FIN; VERI_MSG(("FIN")); break;
            case 3: txITcpt.flag = TCPFLAG_RST; VERI_MSG(("RST")); break;
        }
        VERI_MSG((" ...\n"));
        strtomac(&txITcpt.smac, WAN0_ISP1_MAC);
        txITcpt.sid = WAN0_ISP1_PPPOE_SID;
        strtoip(&txITcpt.dip, WAN0_ISP1_NPE_IP);
        txITcpt.dport = (20<<10)|tut.selEIdx;
        txPktLen = pktGenTcp(txPktBuf, &txITcpt);
        miiLikeTestSend(WAN0_PORT, txPktBuf, txPktLen);
        /* check trapped packet */
        rxPktLen=2048;
        miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH2_TARGET3));
    
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    /* set collision-2 parameters */
    bzero((void*) &tut, sizeof(tut));
    strtoip(&tut.insideLocalIpAddr, LAN_NPI_HOST1_IP);
    tut.insideLocalPort = 100;
    tut.offset = 30; //different offset
    tut.isTcp = 1;
    tut.isStatic = 1;
    tut.isCollision2 = 1;
    
    /* prepare packets */
    txOTcpt.flag = 0;
    txITcpt.flag = 0;
    strtomac(&txITcpt.smac, WAN0_ISP0_MAC);
    txITcpt.sid = WAN0_ISP0_PPPOE_SID;
    strtoip(&txITcpt.dip, WAN0_ISP0_NPE_IP);
    txITcpt.dport = (20<<10)|hash2Idx;
    
    for (i=0; i<=3; i++)
    {
        switch (i)
        {
            case 0:
                tut.isValid = 1;
                tut.isDedicated = 0;
                rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut);
                VERI_MSG(("Hash-1 entry with collision-2. "));
                break;
            case 1:
                tut.isValid = 0;
                tut.isDedicated = 1;
                rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut);
                VERI_MSG(("SPI entry with collision-2. "));
                break;
            case 2:
                tut.insideLocalPort = 300;
                tut.isValid = 1;
                tut.isDedicated = 1;
                rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut);
                VERI_MSG(("Hash-2 entry with collision-2. "));
                break;
            case 3:
                bzero((void*) &tut, sizeof(tut));
                tut.isCollision2 = 1;
                rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut);
                VERI_MSG(("Empty entry with collision-2. "));
                break;
        }
        VERI_MSG(("Outbound packet ...\n"));
        txPktLen = pktGenTcp(txPktBuf, &txOTcpt);
        miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
        /* check trapped packet */
        rxPktLen=2048;
        miiLikeTestReceive(LAN_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
            
        VERI_MSG(("Inbound packet ...\n"));
        txPktLen = pktGenTcp(txPktBuf, &txITcpt);
        miiLikeTestSend(WAN0_PORT, txPktBuf, txPktLen);
        /* check trapped packet */
        rxPktLen=2048;
        miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
        if (rxPktLen == 0)
        {
            VERI_MSG(("Error! no packet received\n"));
            ++errCount;
            goto _EXIT;
        }
    }
    
_EXIT:
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    return errCount;
}


/* Hash-1 v.s Hash-2 Priority */
#define ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET1 \
"Verify Forward 1 > Forward 2.\n"
#define ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET2 \
"Verify Forward 1 Trap > Forward 2.\n"
#define ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET3 \
"Verify Forward 1 > Forward 2 Trap.\n"
#define ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET4 \
"Verify Forward 2 > Hash 1 Trap.\n"
#define ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET5 \
"Verify Forward 1 > Hash 2 Trap.\n"
#define ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET6 \
"Verify Forward 2 > Autolearn Trap.\n"
uint32 routCentric_testNaptHash1Vs2()
{
    uint32 errCount = 0;
    rtl865x_tblAsicDrv_naptTcpUdpParam_t tut1, tut2;
    uint8 txPktBuf[2048], rxPktBuf[2048];
    uint32 txPktLen, rxPktLen;
    uint16 hash1Idx, hash2Idx;
    pktGenTcpFormat_t txTcpt, rxTcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    
    /* prepare lan npi host 1 to wan 0 through isp 0 */
    bzero((void*) &txTcpt, sizeof(txTcpt));
    strtomac(&txTcpt.dmac, GW_LAN_MAC);
    strtomac(&txTcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&txTcpt.dip, RP_IP);
    strtoip(&txTcpt.sip, LAN_NPI_HOST1_IP);
    txTcpt.dport = 200;
    txTcpt.sport = 100;
    txTcpt.flag = 0;
    txTcpt.padLen = 100;
    txPktLen = pktGenTcp(txPktBuf, &txTcpt);
    
    /* setup hash1 entry */
    bzero((void*) &tut1, sizeof(tut1));
    strtoip(&tut1.insideLocalIpAddr, LAN_NPI_HOST1_IP);
    tut1.insideLocalPort = 100;
    tut1.offset = 20;
    tut1.isTcp = 1;
    tut1.isStatic = 1;
    tut1.isValid = 1;
    tut1.isDedicated = 0;
    hash1Idx = rtl8651_naptTcpUdpTableIndex(1, tut1.insideLocalIpAddr, tut1.insideLocalPort, txTcpt.dip, txTcpt.dport);
    rtl8651_setAsicNaptTcpUdpTable(1, hash1Idx, &tut1);
    
    /* setup hash2 entry */
    bzero((void*) &tut2, sizeof(tut2));
    strtoip(&tut2.insideLocalIpAddr, LAN_NPI_HOST1_IP);
    tut2.insideLocalPort = 100;
    tut2.offset = 20;
    tut2.isTcp = 1;
    tut2.isStatic = 1;
    tut2.isValid = 1;
    tut2.isDedicated = 1;
    tut2.selExtIPIdx = 1;
    tut2.selEIdx = 90;
    tut2.tcpFlag = (1<<2)|(1<<1)|(1<<0); //quiet,outbound
    hash2Idx = rtl8651_naptTcpUdpTableIndex(1, tut2.insideLocalIpAddr, tut2.insideLocalPort, 0, 0);
    rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut2);
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET1));
    
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(rxTcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(rxTcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(rxTcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(rxTcpt.dport, 200, errCount);
        CHK_PKT_DEC(rxTcpt.sport, (20<<10)|hash1Idx, errCount);
        CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(rxTcpt.sip, WAN0_ISP0_NPE_IP, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET2));
    
    /* disable auto-delete */
    WRITE_MEM32(SWTMCR, READ_MEM32(SWTMCR) & ~EN_NAPT_AUTO_DELETE);
    
    /* FIN -> forward 1 trap, forward 2 */
    txTcpt.flag = TCPFLAG_FIN;
    txPktLen = pktGenTcp(txPktBuf, &txTcpt);
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(LAN_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }

    /* enable auto-delete */
    WRITE_MEM32(SWTMCR, READ_MEM32(SWTMCR) | EN_NAPT_AUTO_DELETE);
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET3));
    
    /* set hash2 entry to non-quiet */
    tut2.tcpFlag = (0<<2)|(1<<1)|(1<<0); //non-quiet,outbound
    rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut2);
    
    /* FIN -> forward 1, forward 2 trap */
    txTcpt.flag = TCPFLAG_FIN;
    txPktLen = pktGenTcp(txPktBuf, &txTcpt);
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(rxTcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(rxTcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(rxTcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(rxTcpt.dport, 200, errCount);
        CHK_PKT_DEC(rxTcpt.sport, (20<<10)|hash1Idx, errCount);
        CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(rxTcpt.sip, WAN0_ISP0_NPE_IP, errCount);
    }
    
    /* recover hash2 entry */
    tut2.tcpFlag = (1<<2)|(1<<1)|(1<<0); //quiet,outbound
    rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut2);
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET4));
    
    /* setup hash1 entry to collision */
    tut1.insideLocalPort = 300;
    tut1.isCollision = 1;
    rtl8651_setAsicNaptTcpUdpTable(1, hash1Idx, &tut1);
    
    /* hash 1 trap, forward 2 */
    txTcpt.flag = 0;
    txPktLen = pktGenTcp(txPktBuf, &txTcpt);
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(rxTcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(rxTcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(rxTcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(rxTcpt.dport, 200, errCount);
        CHK_PKT_DEC(rxTcpt.sport, (20<<10)|tut2.selEIdx, errCount);
        CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(rxTcpt.sip, WAN0_ISP1_NPE_IP, errCount);
    }
    
    /* recover hash1 entry */
    tut1.insideLocalPort = 100;
    tut1.isCollision = 0;
    rtl8651_setAsicNaptTcpUdpTable(1, hash1Idx, &tut1);
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET5));
    
    /* set hash2 entry to collision-2 */
    tut2.insideLocalPort = 300;
    tut2.isCollision2 = 1;
    rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut2);
    
    /* forward 1, hash 2 trap */
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(rxTcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(rxTcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(rxTcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(rxTcpt.dport, 200, errCount);
        CHK_PKT_DEC(rxTcpt.sport, (20<<10)|hash1Idx, errCount);
        CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(rxTcpt.sip, WAN0_ISP0_NPE_IP, errCount);
    }
    
    /* recover hash2 entry */
    tut2.insideLocalPort = 100;
    tut2.isCollision2 = 0;
    rtl8651_setAsicNaptTcpUdpTable(1, hash2Idx, &tut2);
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTNAPTHASH1VS2_TARGET6));
    
    /* set empty hash1 entry with collision */
    bzero((void*) &tut1, sizeof(tut1));
    tut1.isCollision = 1;
    rtl8651_setAsicNaptTcpUdpTable(1, hash1Idx, &tut1);
    
    /* hash 1 auto-learn trap, forward 2 */
    txTcpt.flag = TCPFLAG_SYN;
    txPktLen = pktGenTcp(txPktBuf, &txTcpt);
    miiLikeTestSend(LAN_PORT, txPktBuf, txPktLen);
    /* check received packet */
    rxPktLen=2048;
    miiLikeTestReceive(WAN0_PORT, rxPktBuf, &rxPktLen);
    if (rxPktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(rxPktBuf, &rxTcpt, rxPktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(rxTcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(rxTcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(rxTcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(rxTcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(rxTcpt.dport, 200, errCount);
        CHK_PKT_DEC(rxTcpt.sport, (20<<10)|tut2.selEIdx, errCount);
        CHK_PKT_MAC(rxTcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_HEX(rxTcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(rxTcpt.sip, WAN0_ISP1_NPE_IP, errCount);
    }
    
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
_EXIT:
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    return errCount;
}


/* Default Redirect Next Hop Selection */
#define ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET1 \
"Verify that default redirect rule changes PPPoE, DMAC decision of NAT, but not external IP.\n"
#define ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET2 \
"Verify that default redirect rule changes PPPoE, DMAC decision of server port, but not external IP.\n"
#define ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET3 \
"Verify that default redirect rule changes PPPoE, DMAC, external IP decision of NAPT static entry.\n"
#define ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET4 \
"Verify that default redirect rule changes PPPoE, DMAC, external IP decision of NAPT load balance.\n"
uint32 routCentric_testDefaultRedirectNextHop()
{
    uint32 errCount = 0;
    rtl865x_tblAsicDrv_naptTcpUdpParam_t tut;
extern _rtl8651_tblDrvAclRule_t aclt;
    uint16 extPort, hash1Idx;
    uint8 pktBuf[2048];
    uint32 pktLen;
    pktGenTcpFormat_t tcpt;
    
    VERI_MSG(("* %s\n", __FUNCTION__));
    
    /* set NAPT static entry through isp 0 */
    bzero((void*) &tut, sizeof(tut));
    strtoip(&tut.insideLocalIpAddr, LAN_NPI_HOST1_IP);
    tut.insideLocalPort = 100;
    tut.offset = 35;
    tut.selEIdx = 0;
    tut.isTcp = 1;
    tut.isStatic = 1;
    tut.isValid = 1;
    strtoip(&tcpt.dip, RP_IP); //for calculating index
    strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    rtl8651_setAsicNaptTcpUdpTable(1, rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport), &tut);
    
    /* lan ni host 1 to wan 0: NAT translation through isp 0 */
    VERI_MSG(("Comparison: NAT outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NE1_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }

    /* lan server host to wan 0: NAPT translation through isp 0 */
    VERI_MSG(("Comparison: NAPT server port outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_SRV_HOST_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_SRV_HOST_IP);
    tcpt.dport = 100;
    tcpt.sport = 1020;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 20, errCount);
    }
    
    VERI_MSG(("Comparison: NAPT static entry outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    extPort = (35<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, extPort, errCount);
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
    }
    
    VERI_MSG(("Comparison: NAPT load balance outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST2_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST2_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = TCPFLAG_SYN;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, extPort, errCount);
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP0_MAC, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP0_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
    }
    
    /* set ACL ingress default redirect rule through isp 1 */
    bzero((void*) &aclt, sizeof(aclt));
    aclt.ruleType_ = RTL8651_ACL_IP;
    strtoip(&aclt.dstIpAddr_, RP_IP);
    strtoip(&aclt.dstIpAddrMask_, "255.255.255.255");
    aclt.actionType_ = RTL8651_ACL_POLICY;
    aclt.nhIndex = 3;
    rtl8651_setAsicAclRule(17, &aclt);
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET1));
    
    /* lan ni host 1 to wan 0: NAT translation through isp 0 */
    VERI_MSG(("Outbound NAT packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NE1_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, 100, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET2));
    
    /* lan server host to wan 0: NAPT translation through isp 0 */
    VERI_MSG(("NAPT server port outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_SRV_HOST_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_SRV_HOST_IP);
    tcpt.dport = 100;
    tcpt.sport = 1020;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP0_NPE_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 100, errCount);
        CHK_PKT_DEC(tcpt.sport, 20, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET3));
    
    VERI_MSG(("NAPT static entry outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST1_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST1_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = 0;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    extPort = (35<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
        else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, extPort, errCount);
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
    VERI_MSG(("*****\n"));
    VERI_MSG((ROUTCENTRIC_TESTDEFAULTREDIRECTNEXTHOP_TARGET4));
    
    VERI_MSG(("NAPT load balance outbound packet ...\n"));
    bzero((void*) &tcpt, sizeof(tcpt));
    strtomac(&tcpt.dmac, GW_LAN_MAC);
    strtomac(&tcpt.smac, LAN_NPI_HOST2_MAC);
    strtoip(&tcpt.dip, RP_IP);
    strtoip(&tcpt.sip, LAN_NPI_HOST2_IP);
    tcpt.dport = 200;
    tcpt.sport = 100;
    tcpt.flag = TCPFLAG_SYN;
    tcpt.padLen = 100;
    pktLen = pktGenTcp(pktBuf, &tcpt);
    extPort = (20<<10) | rtl8651_naptTcpUdpTableIndex(1, tcpt.sip, tcpt.sport, tcpt.dip, tcpt.dport);
    miiLikeTestSend(LAN_PORT, pktBuf, pktLen);
    /* check received packet */
    pktLen=2048;
    miiLikeTestReceive(WAN0_PORT, pktBuf, &pktLen);
    if (pktLen == 0)
    {
        VERI_MSG(("Error! no packet received\n"));
        ++errCount;
        goto _EXIT;
    }
    else
    {
        if (pktParseTcp(pktBuf, &tcpt, pktLen) != SUCCESS)
        {
            VERI_MSG(("Error! received packet is not TCP\n"));
            ++errCount;
            goto _EXIT;
        }
        CHK_PKT_MAC(tcpt.smac, GW_WAN0_MAC, errCount);
        CHK_PKT_DEC(tcpt.vlanTag, 0, errCount);
        CHK_PKT_DEC(tcpt.pppoeTag, 1, errCount);
        CHK_PKT_IP(tcpt.dip, RP_IP, errCount);
        CHK_PKT_DEC(tcpt.dport, 200, errCount);
        CHK_PKT_DEC(tcpt.sport, extPort, errCount);
        CHK_PKT_MAC(tcpt.dmac, WAN0_ISP1_MAC, errCount);
        CHK_PKT_HEX(tcpt.sid, WAN0_ISP1_PPPOE_SID, errCount);
        CHK_PKT_IP(tcpt.sip, WAN0_ISP1_NPE_IP, errCount);
    }
        
    VERI_MSG(("Test Done\n"));
    VERI_MSG(("*****\n"));
    
_EXIT:
    /* clear napt tcp/udp table */
    rtl8651_delAsicNaptTcpUdpTable(0, RTL8651_TCPUDPTBL_SIZE - 1);
    /* set rule 1 to permit */
    bzero((void*) &aclt, sizeof(aclt));
    rtl8651_setAsicAclRule(17, &aclt);
    
    return errCount;
}
