#include "mips.h"
#include "radiax.h"

#define MAX_32	0x7fffffff
#define MIN_32	0x80000000
#define MAX_16	0x00007fff
#define MIN_16	0x00008000

/**************
 set_mmd(char a)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	set_mmd
	.ent	set_mmd
set_mmd:
	mtru	a0, mmd
	nop
	jr		ra
	nop
	.end	set_mmd

/*
Word16 add(Word16 var1, Word16 var2)
*/	
	.text
	.set	noat
	.set	noreorder	
	.globl	add
	.ent	add
add:
	addr2.s	v0, a0, a1
	sll		v0, v0, 16
	jr		ra
	sra		v0, v0, 16
	.end	add

/*
Word16 sub(Word16 var1,Word16 var2)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	sub
	.ent	sub
sub:	
	subr2.s	v0, a0, a1
	sll		v0, v0, 16
	jr		ra
	sra		v0, v0, 16
	.end	sub

/*
Word16 abs_s(Word16 var1)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	abs_s
	.ent	abs_s
abs_s:	
	absr2.s v0, a0
	sll		v0, v0, 16
	jr		ra
	sra		v0, v0, 16
	.end	abs_s

/*
Word16 shl(Word16 var1, var2)
assume: var2 >= 0
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	shl
	.ent	shl
shl:
#if 1
	beqz	a1, 2f
	sll		v0, a0, 16	//v0=[var1 z]
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, a1, 1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
1:
	addr2.s v0, v0, v0
	nop	
	nop	
2:		
	jr		ra
	sra		v0, v0, 16
#else
	beqz	a1, lp0_e
	//move	v0, a0
	sll		v0, a0, 16
	
	la		t0, lp0_s
	la		t1, lp0_e-4
	sub		t2, a1, 1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	
	sll		a0, a0, 16
	mta2	a0, m0l

lp0_s:

	addma.s	m0l, m0l, m0l
	mfa		v0, m0l	

lp0_e:	

	jr		ra
	sra		v0, v0, 16	
#endif
	.end	shl
	
#--- danwu 20050315 add start
/*
Word16 shl_OVF(Word16 var1, var2)
assume: var2 >= 0
*/
	.text
#	.set	noat
	.set	noreorder	
	.globl	shl_OVF
	.ent	shl_OVF
shl_OVF:
	beqz	a1, 2f
	sll		v0, a0, 16	//v0=[var1 z]
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, a1, 1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
1:
	addr2.s v0, v0, v0
	nop	
	nop	
2:		
	li		t0, MAX_16
	beq		v0, t0, 3f
	li		t0, MIN_16
	bne		v0, t0, 4f
	nop
3:
	li		t0, 1
	sh		t0, Overflow
4:
	jr		ra
	sra		v0, v0, 16
	.end	shl_OVF
#--- danwu 20050315 add end
	
/*
Word16 shr(Word16 var1,Word16 var2)
assume:
	var2 >= 0
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	shr
	.ent	shr
shr:
	li		t4, 15
	min		a1, a1, t4
	jr		ra
	sra		v0, a0, a1
	.end	shr

/*
Word16 mult(Word16 var1, Word16 var2)
*/

	.text
	.set	noat
	.set	noreorder	
	.globl	mult
	.ent	mult
mult:
	multa2	m0l, a0, a1		// incur 2 pipeline stall, but efficient code size
	mfa		v0, m0l
	jr		ra
	sra		v0, v0, 15		
	.end	mult

/*
Word32 L_mult(Word16 var1,Word16 var2)
*/

	.text
	.set	noat
	.set	noreorder	
	.globl	L_mult
	.ent	L_mult
L_mult:
	multa2	m0l, a0, a1		
	addma.s	m0l, m0l, m0l	// multa2 and addma can issue back-to-back with no stall
	mfa		v0, m0l			// mfa issue delay 2 stall from addma
	jr		ra
	nop
	.end	L_mult

#--- danwu 20050315 add start
/*
Word32 L_mult_OVF(Word16 var1,Word16 var2)
*/

	.text
#	.set	noat
	.set	noreorder	
	.globl	L_mult_OVF
	.ent	L_mult_OVF
L_mult_OVF:
	multa2	m0l, a0, a1	
	mfa		t0, m0l
	la		t1, 0x40000000
	bne		t0, t1, 1f
	li		t0, 1
	sh		t0, Overflow
	lui		t1, %hi(MAX_32)
	jr		ra
	addiu	v0, t1, %lo(MAX_32)
1:	
	addma.s	m0l, m0l, m0l	// multa2 and addma can issue back-to-back with no stall
	mfa		v0, m0l			// mfa issue delay 2 stall from addma
	jr		ra
	nop
	.end	L_mult_OVF
#--- danwu 20050315 add end

/*
Word16 negate(Word16 var1)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	negate
	.ent	negate
negate:
	#--- danwu 20050314 add start
	li		t0, MIN_16
	bne		a0, t0, 1f
	nop
	jr		ra
	li		v0, MAX_16
1:
	#--- danwu 20050314 add end
	subr2.s	v0, zero, a0
	sll		v0, v0, 16
	jr		ra
	sra		v0, v0, 16
	.end 	negate

/*
Word16 extract_h(Word32 L_var1)	
*/
/*
	.set	noat
	.set	noreorder
	.text
	.globl	extract_h
	.ent	extrach_h
extract_h:
	jr		ra
	sra		v0, a0, 16		
	.end	extract_h
*/	
/*
Word16 extract_l(Word32 L_var1)
*/
/*
	.set	noat
	.set	noreorder
	.text
	.globl	extract_l
	.ent	extract_l
extract_l:
	sll		v0, a0, 16
	jr		ra
	sra		v0, v0, 16

	.end	extract_l
*/	


/*
Word16 round(Word32 L_var1)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	round
	.ent	round
round:
	li		t4, 0x00008000
	addr.s	v0, a0, t4
	jr		ra
	sra		v0, v0, 16

	.end	round


#--- danwu 20050315 add start
/*
Word16 round_OVF(Word32 L_var1)
*/
	.text
#	.set	noat
	.set	noreorder	
	.globl	round_OVF
	.ent	round_OVF
round_OVF:
	li		t4, 0x00008000
	addr.s	v0, a0, t4
	li		t0, MIN_16
	beq		v0, t0, 1f
	li		t0, MAX_16
	bne		v0, t0, 2f
	nop
1:
	li		t0, 1
	sh		t0, Overflow
2:
	jr		ra
	sra		v0, v0, 16

	.end	round_OVF
#--- danwu 20050315 add end

/*
Word32 L_mac(Word32 L_var3, Word16 var1, Word16 var2)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	L_mac
	.ent	L_mac
L_mac:
	mta2	a0, m0h					// no stall
	multa2	m0l, a1, a2				// no stall
	addma.s	m0l, m0l, m0l			// no stall
	addma.s	m0l, m0l, m0h			// no stall
	mfa		v0, m0l					// 2 pipe stall from last addma.s	
	jr		ra
	nop
	.end	L_mac

#--- danwu 20050315 add start
/*
Word32 L_mac_OVF(Word32 L_var3, Word16 var1, Word16 var2)
*/
	.text
#	.set	noat
	.set	noreorder	
	.globl	L_mac_OVF
	.ent	L_mac_OVF
L_mac_OVF:
	mta2	a0, m0h					// no stall
	multa2	m0l, a1, a2				// no stall
	mfa		t0, m0l
	la		t1, 0x40000000
	bne		t0, t1, 1f
	li		t0, 1
	sh		t0, Overflow
	lui		t1, %hi(MAX_32)
	addiu	t1, t1, %lo(MAX_32)
	b		2f
	mta2	t1, m0l
1:
	addma.s	m0l, m0l, m0l			// no stall
2:	
	addma.s	m0l, m0l, m0h			// no stall
	mfa		v0, m0l	
	li		t0, MAX_32
	beq		v0, t0, 1f
	li		t0, MIN_32
	bne		v0, t0, 2f
	nop
1:
	li		t0, 1
	sh		t0, Overflow
2:
	jr		ra
	nop
	.end	L_mac_OVF
#--- danwu 20050315 add end


/*
Word32 L_msu(Word32 L_var3, Word16 var1, Word16 var2)
*/

	.text
	.set	noat
	.set	noreorder	
	.globl	L_msu
	.ent	L_msu
L_msu:
	mta2	a0, m0h
	multa2	m0l, a1, a2
	addma.s	m0l, m0l, m0l
	subma.s m0l, m0h, m0l
	mfa		v0, m0l
	jr		ra
	nop
	.end	L_msu


#--- danwu 20050315 add start
/*
Word32 L_msu_OVF(Word32 L_var3, Word16 var1, Word16 var2)
*/

	.text
#	.set	noat
	.set	noreorder	
	.globl	L_msu_OVF
	.ent	L_msu_OVF
L_msu_OVF:
	mta2	a0, m0h
	multa2	m0l, a1, a2
	mfa		t0, m0l
	la		t1, 0x40000000
	bne		t0, t1, 1f
	li		t0, 1
	sh		t0, Overflow
	lui		t1, %hi(MAX_32)
	addiu	t1, t1, %lo(MAX_32)
	b		2f
	mta2	t1, m0l
1:	
	addma.s	m0l, m0l, m0l
2:
	subma.s m0l, m0h, m0l
	mfa		v0, m0l	
	li		t0, MAX_32
	beq		v0, t0, 1f
	li		t0, MIN_32
	bne		v0, t0, 2f
	nop
1:
	li		t0, 1
	sh		t0, Overflow
2:
	jr		ra
	nop
	.end	L_msu_OVF
#--- danwu 20050315 add end

/*
Word32 L_add(Word32 L_var1, Word32 L_var2)
*/
	.text
#	.set	noat
	.set	noreorder	
	.globl	L_add
	.ent	L_add
L_add:
	jr		ra
	addr.s	v0, a0, a1
	.end	L_add

#--- danwu 20050315 add start
/*
Word32 L_add_OVF(Word32 L_var1, Word32 L_var2)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	L_add_OVF
	.ent	L_add_OVF
L_add_OVF:
	addr.s	v0, a0, a1
	li		t0, MAX_32
	beq		v0, t0, 1f
	li		t0, MIN_32
	bne		v0, t0, 2f
	nop
1:
	li		t0, 1
	sh		t0, Overflow
2:
	jr		ra
	nop
	.end	L_add_OVF
#--- danwu 20050315 add end

/*
Word32 L_sub(Word32 L_var1, Word32 L_var2)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	L_sub
	.ent	L_sub
L_sub:
	jr		ra
	subr.s	v0, a0, a1
	.end	L_sub

#--- danwu 20050315 add start
/*
Word32 L_sub_OVF(Word32 L_var1, Word32 L_var2)
*/
	.text
#	.set	noat
	.set	noreorder	
	.globl	L_sub_OVF
	.ent	L_sub_OVF
L_sub_OVF:
	subr.s	v0, a0, a1
	li		t0, MAX_32
	beq		v0, t0, 1f
	li		t0, MIN_32
	bne		v0, t0, 2f
	nop
1:
	li		t0, 1
	sh		t0, Overflow
2:
	jr		ra
	nop
	.end	L_sub_OVF
#--- danwu 20050315 add end

/*
Word32 L_negate(Word32 L_var1)
*/

	.text
	.set	noat
	.set	noreorder	
	.globl	L_negate
	.ent	L_negate
L_negate:
	#--- danwu 20050314 add start
	li		t0, MIN_32
	bne		a0, t0, 1f
	nop
	lui		v0, %hi(MAX_32)
	jr		ra
	addiu	v0, %lo(MAX_32)
1:
	#--- danwu 20050314 add end
	jr		ra
	subr.s	v0, zero, a0
	.end	L_negate

/*
Word16 mult_r(Word16 var1, Word16 var2)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	mult_r
	.ent	mult_r
mult_r:
	multa2	m0l, a0, a1;li	t4, 0x00004000
	mfa		v0, m0l
	addr.s	v0, v0, t4
	jr		ra
	sra		v0, v0, 15
	.end	mult_r

/****************************************************

Word32 L_shl(Word32 L_var1, Word16 var2)

input:
	a0 -> L_var1
	a1 -> var2
output:
	v0
*/

	.text
	.set	noat
	.set 	noreorder	
	.globl 	L_shl
	.ent	L_shl
L_shl:
#if 1
	beqz	a1, 2f
	move	v0, a0
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, a1, 1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
1:
	addr.s	v0, v0, v0
	nop
	nop
2:
	jr		ra
	nop
#else
	beqz	a1, lp1_e
	move	v0, a0
		
	la		t0, lp1_s
	la		t1, lp1_e-4
	sub		t2, a1, 1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	mta2	a0, m0l			// m0l = L_var1		
	
lp1_s:

	addma.s	m0l, m0l, m0l	// L_var1 * 2
	mfa		v0, m0l	
	
lp1_e:	

	jr		ra
	nop
#endif
	.end	L_shl

#--- danwu 20050315 add start
/****************************************************

Word32 L_shl_OVF(Word32 L_var1, Word16 var2)

input:
	a0 -> L_var1
	a1 -> var2
output:
	v0
*/

	.text
#	.set	noat
	.set 	noreorder	
	.globl 	L_shl_OVF
	.ent	L_shl_OVF
L_shl_OVF:
	beqz	a1, 2f
	move	v0, a0
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, a1, 1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
1:
	addr.s	v0, v0, v0
	nop
	nop
2:
	li		t0, MAX_32
	beq		v0, t0, 3f
	li		t0, MIN_32
	bne		v0, t0, 4f
	nop
3:
	li		t0, 1
	sh		t0, Overflow
4:
	jr		ra
	nop
	.end	L_shl_OVF
#--- danwu 20050315 add end

/*
Word32 L_shr(Word32 L_var1, Word16 var2)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	L_shr
	.ent	L_shr
L_shr:
	li		t4, 31
	min		t4, a1, t4
	jr		ra
	srav	v0, a0, t4
	.end	L_shr

/*
Word32 L_deposit_h(Word16 var1)
*/
/*
	.set	noat
	.set	noreorder
	.text
	.globl	L_deposit_h
	.ent	L_deposit_h
L_deposit_h:
	jr		ra
	sll		v0, a0, 16
	.end	L_deposit_h
*/	
/*
Word32 L_deposit_l(Word16 var1)
*/
/*
	.set	noat
	.set	noreorder
	.text
	.globl	L_deposit_l
	.ent	L_deposit_l
L_deposit_l:
	sll		v0, a0, 16
	jr		ra
	sra		v0, v0, 16
	.end	L_deposit_l
*/
/*
Word32 L_abs(Word32 L_var1)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	L_abs
	.ent	L_abs
L_abs:
	jr		ra
	absr.s	v0, a0
	.end	L_abs

	
/*
Word16 norm_s(Word16 var1)
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	norm_s
	.ent	norm_s
norm_s:    
#if 1
	#--- danwu 20050314 add start
	li		t0, 0xffff
	bne		a0, t0, 1f
	nop
	jr		ra
	li		v0, 15
1:
	absr2.s v0, a0
	sll		v0, v0, 16
	sra		a0, v0, 16
	#--- danwu 20050314 add end
	cls		v0, a0
	sub		v0, v0, 16
	jr		ra
	cmveqz	v0, zero, a0
#else
	beqz	a0, lp3_e			// if var1==0
	ori		v0, zero, 0			// var_out = 0
	la		t4, lp3_s
	la		t5, lp3_e-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t4, 15
	mtru	t4, lpc0
	li		t5, 0x00004000
lp3_s:
	sub		t6, a0, t5
	bgez	t6, lp3_e	
	sll		a0, a0, 1
	addiu	v0, v0, 1
lp3_e:	    
	jr		ra
	nop	
#endif
	.end	norm_s

/*********************************************************
 
 Word16 div_s(Word16 var1, Word16 var2)
 
 input:	
 	a0 -> var1
 	a1 -> var2
 output:
 	v0
*/

	.set	noat
	.set 	noreorder
	.text
	.globl	div_s
	.ent	div_s
div_s:

	bltz	a0, div_exit
	li		v0, 0
	bltz	a1, div_exit
	li		v0, 0
	sub		t4, a0, a1
	bgtz	t4, div_exit
	li		v0, 0
	beqz	a1, div_exit		// if (var2 == 0)
	li		v0, 0
	
	beqz	a0, div_exit
	li		v0, 0				// if (var1 == 0)
	//	if (var1 == var2)
	sub		t4, a0, a1
	beqz	t4, div_exit
	li		v0, MAX_16
	// else
	la		t4, lp2_s
	la		t5, lp2_e-4
	li		t6, 14
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	li		v0, 0
lp2_s:	
	sll		a0, a0, 1		// L_num << 1
	sub		t4, a0, a1
	bltz	t4, lp2_e-4
	nop
	subr.s	a0, a0, a1
	addi	v0, v0, 1
	sll		v0, v0, 1		// var_out << 1
lp2_e:
	sra		v0, v0, 1
	
div_exit:
	jr		ra
	nop		
	
	.end	div_s


/*
Word16 norm_l(Word32 L_var1)
used:
	t4, t5, t6
can't used:
	t9, a2, a3
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	norm_l
	.ent	norm_l
norm_l:
#if 1
#--- danwu 20050315
# The following patch makes this match C code. However, G.723.1
# test crashes, so I comment it out.
#	#--- danwu 20050314 add start
#	li		t0, 0xffffffff
#	bne		a0, t0, 1f
#	nop
#	jr		ra
#	li		v0, 31
#1:
#	absr.s  a0, a0
#	#--- danwu 20050314 add end
	cls		v0, a0
	jr		ra
	cmveqz	v0, zero, a0
#else
	beqz	a0, lp4_e		// if L_var1 == 0
	li		v0, 0
	li		t4, 0xffffffff
	sub		t5, t4, a0
	beqz	t5, lp4_e		// if L_var1 == 0xffffffff
	li		v0, 31			
	bltz	a0, 1f			// if L_var1 < 0
	li		v0, 0			//var_out = 0
	j		2f
	nop
1:	
	not		a0, a0			// ~L_var1
2:
	li		t6, 31
	li		t4, 0x40000000
lp4_s:
	sub		t5, a0, t4		
	bgez	t5, lp4_e		// L_var1 >= 0x40000000
	sll		a0, a0, 1
	sub		t6, t6, 1	
	bgtz	t6, lp4_s
	addiu	v0, v0, 1		// var_out++
lp4_e:
	jr		ra
	nop	
#endif
	.end	norm_l

/*
Word32   L_mls( Word32 Lv, Word16 v )
*/
	.text
	.set	noat
	.set	noreorder	
	.globl	L_mls
	.ent	L_mls
	.align	3
L_mls:
	and		t4, a0, 0x0000ffff//t4=Lv[l]	
	mux2.ll	a2, a1, a1	//a1=[v v]
	multa	m0, t4, a1	//v*Lv[l]
	multa2	m1h, a0, a2	//v*Lv[h]
	addma.s	m1h, m1h, m1h
	mfa		t5, m0l
	mfa		t6, m1h
	sra		t5, t5, 15
	jr		ra
	addr.s	v0, t5, t6

	.end	L_mls

/*
Word16 div_l( Word32  L_num, Word16 den )
used:
	t4, t5, t6, t7				(15+15*
can't used:
	t9
*/

	.set	noat
	.set	noreorder
	.text
	.globl	div_l
	.ent	div_l
div_l:	
	sll		t4, a1, 16	// t4 = L_den
	sub		t5, a0, t4
	bgez	t5, lp5_e	// if (L_num >= L_den)
	li		v0, MAX_16
	li		v0, 0		// var_out=0
	la		t5, lp5_s	
	la		t6, lp5_e-4	
	mtru	t5, lps0
	sra		a0, a0, 1	// L_num = L_shr(L_num,1)
	mtru	t6, lpe0
	sra		t4, t4, 1	// L-den = L_shr(L_den,1)
	li		t7, 15-1
	mtru	t7, lpc0
	.align	3
lp5_s:	
	sll		v0, v0, 1	// var_out << 1
	sll		a0, a0, 1	// L_num << 1
	sub		t5, a0, t4		
	bltz	t5, lp5_e-4	// if (L_num < L_den)
	nop
	sub		a0, a0, t4	// L_num = L_num-L_den
	addiu	v0, v0, 1	// var_out++
	nop
lp5_e:
	jr		ra
	nop
	.end	div_l

