#ifndef __FIXEDPT_BASIC_OP_H__
#define __FIXEDPT_BASIC_OP_H__
#include "typedef.h"
extern Flag Overflow;
extern Flag Carry;
#define MAX_32 (Word32)0x7fffffffL
#define MIN_32 (Word32)0x80000000L
#define MAX_16 (Word16)0x7fff
#define MIN_16 (Word16)0x8000

/*-------------------------------*/
/*Absolute value, Shift, negation*/
/*-------------------------------*/
Word16 abs_s(Word16 var1);              /* Short abs,           1 */
Word32 L_abs(Word32 L_var1);            /* Long abs,            3 */

Word16 shr(Word16 var1, Word16 var2);           /* Short shift right,      1 */
Word16 shr_r(Word16 var1, Word16 var2);         /* Shift right with round, 2 */
Word32 L_shr(Word32 L_var1, Word16 var2);       /* Long shift right,       2 */
Word32 L_shr_r(Word32 L_var1, Word16 var2);     /* Long shift right with round,  3*/
Word32 L_shr_r_plus(Word32 L_var1, Word16 var2);/* Long shift right with round,  3*/

Word16 shl    (Word16 var1, Word16 var2);     /* Short shift left,    1 */
Word16 shl_OVF(Word16 var1, Word16 var2);
Word32 L_shl  (Word32 L_var1, Word16 var2);   /* Long shift left,     2 */
Word32 L_shl_OVF(Word32 L_var1, Word16 var2);
Word32 L_shlOv  (Word32 L_var1, Word16 var2); /* Long shift left,     2 */

Word16 negate(Word16 var1);               /* Short negate,        1 */
Word32 L_negate(Word32 L_var1);           /* Long negate,         2 */

#ifdef VC6
Word16 extract_h(Word32 L_var1);          /* Extract high,        1 */
Word16 extract_l(Word32 L_var1);          /* Extract low,         1 */
#else
#define extract_h(a)	(Word16)(a>>16)
#define extract_l(a)	(Word16)(a)
#endif

#ifdef VC6
Word32 L_deposit_h(Word16 var1);       /* 16 bit var1 -> MSB,     2 */
Word32 L_deposit_l(Word16 var1);       /* 16 bit var1 -> LSB,     2 */
#else
#define L_deposit_h(a)	(Word32)(((Word32)a)<<16)
#define L_deposit_l(a)	(Word32)(a)
#endif
Word16 norm_l(Word32 L_var1);           /* Long norm,            30 */
Word16 norm_s(Word16 var1);             /* Short norm,           15 */

Word16 round    (Word32 L_var1);        /* Round,               1 */
Word16 round_OVF(Word32 L_var1);
Word16 roundOv  (Word32 L_var1);        /* Round,               1 */

//Word32 L_sat(Word32 L_var1);            /* Long saturation,       4 */
Word16 sature(Word32 L_var1);             /* Limit to 16 bits,    1 */
Word16 satureOv(Word32 L_var1);             /* Limit to 16 bits,    1 */



/*-------------------------------*/
/*Addition operation             */
/*-------------------------------*/
Word16 add      (Word16 var1, Word16 var2);     /* Short add,           1 */
Word16 addOv    (Word16 var1, Word16 var2);     /* Short add,           1 */
Word32 L_add    (Word32 L_var1, Word32 L_var2); /* Long add,        2 */
Word32 L_add_OVF(Word32 L_var1, Word32 L_var2);
Word32 L_addOv(Word32 L_var1, Word32 L_var2);   /* Long add,        2 */
//Word32 L_add_c(Word32 L_var1, Word32 L_var2); /*Long add with c,  2 */

/*Substraction operation*/
Word16 sub(Word16 var1, Word16 var2);     /* Short sub,           1 */
Word16 sub(Word16 var1, Word16 var2);     /* Short sub,           1 */
Word16 subOv(Word16 var1, Word16 var2);     /* Short sub,           1 */
Word32 L_sub(Word32 L_var1, Word32 L_var2);   /* Long sub,        2 */
Word32 L_sub_OVF(Word32 L_var1, Word32 L_var2);
Word32 L_subOv(Word32 L_var1, Word32 L_var2);   /* Long sub,        2 */
//Word32 L_sub_c(Word32 L_var1, Word32 L_var2); /*Long sub with c,  2 */

/*Multplication operation*/
Word16 mult(Word16 var1, Word16 var2);    /* Short mult,          1 */
Word16 mult_r(Word16 var1, Word16 var2);  /* Mult with round,     2 */
Word32 L_mult(Word16 var1, Word16 var2);  /* Long mult,           1 */
Word32 L_mult_OVF(Word16 var1,Word16 var2);
Word32 L_multOv(Word16 var1, Word16 var2);  /* Long mult,           1 */

/*Multiplication with addition or substraction*/
Word32 L_mac(Word32 L_var3, Word16 var1, Word16 var2); /* Mac,    1 */
Word32 L_mac_OVF(Word32 L_var3, Word16 var1, Word16 var2);
Word32 L_macOv(Word32 L_var3, Word16 var1, Word16 var2); /* Mac,    1 */

Word32 L_msu(Word32 L_var3, Word16 var1, Word16 var2); /* Msu,    1 */
Word32 L_msu_OVF(Word32 L_var3, Word16 var1, Word16 var2);
Word32 L_msuOv(Word32 L_var3, Word16 var1, Word16 var2); /* Msu,    1 */

//Word16 mac_r(Word32 L_var3, Word16 var1, Word16 var2);/* Mac with rounding, 2*/
//Word16 msu_r(Word32 L_var3, Word16 var1, Word16 var2);/* Msu with rounding, 2*/
//Word32 L_macNs(Word32 L_var3, Word16 var1, Word16 var2);/*[Mac without sat, 1*/
//Word32 L_msuNs(Word32 L_var3, Word16 var1, Word16 var2);/* Msu without sat, 1*/

/*division*/
Word16 div_s(Word16 var1, Word16 var2); /* Short division,       18 */

/*  Additional operators  */
Word32 L_mls( Word32 Lv, Word16 v );	    /* Wght ?? */
Word16 div_l( Word32, Word16 ) ;
#define i_mult(a,b)		(Word16)(a*b)

#endif
