#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define		Frame		240
#define 	SubFrames	4
#define 	SubFrLen	60
#define 	LpcOrder	10
#define  	PreCoef     0xc000            /* -0.25*2 */
#define		PitchMax	145
#define  	RidgeFact   10
#define		LpcFrame	180
#define		LpcOrderP1	(LpcOrder+1)
#define  	ClPitchOrd  5

/******************** 
 Data section
*/
	.bss
	.align	14
	.globl	FirCoef
FirCoef:			//Spfs()
	.space	10*2
	
	.globl	IirCoef
IirCoef:			//Spfs()
	.space	10*2	
	
	.globl	g7231_TmpVct	
	.globl	OccPos
g7231_TmpVct:				//Comp_Irs() Sub_Rings() Synts2() Spfs() Lsp_Svqs()
OccPos:				//Find_Bests() 
	.space	2*(SubFrLen+LpcOrder)
	
	.align	3
	.globl	PastX
	.globl	Imr
	.globl	RezBuf2	
PastX:				//AtoLsps() Comp_Vads() Comp_Lpcs() Error_Wghts() Comp_Irs() Sub_Rings() UpdRings() Spfs()
Imr:				//Find_Bests() 
RezBuf2:			//Find_Acbks()
	.space	2*(SubFrLen+LpcOrder)
	
	.align	3
	.globl	PastY
	.globl	ImrCorr
	.globl	Imrv	
	.globl	Acf_sf	
PastY:				//Error_Wghts() Comp_Irs() Sub_Rings() Upd_Rings() Spfs()
ImrCorr:			//Find_Bests()
Imrv:				//Find_Acbks()
Acf_sf:				//Comp_Lpcs() 
	.space	2*(SubFrLen+LpcOrder)

	.align	3
	.globl	Temp2
	.globl	FltBuf	
	.globl	Dpnt	
Temp2:				//Estim_Pitchs() Find_Bs2() 
FltBuf:				//Find_Acbks()
Dpnt:				//Comp_Lpcs()
	.space	2*(PitchMax+Frame+1)

	.align	3
	.globl	Temp3
	.globl	ConvEn
	.globl	Vect_Norm	
Temp3:				//Estim_Pitchs() 
ConvEn:				//Find_Acbks() 
Vect_Norm:			//Comp_Lpcs()
	.space	2*(PitchMax+Frame+1)

	
	.align	3
	.globl	Temp
Temp:				//C functions: Coder() Decod()
	.space  2*(PitchMax+Frame+1)
	
	.align	3
	.globl	Temp1
Temp1:				//C functions: Coder() Decod()
	.space  2*(PitchMax+Frame+1)

/*	.align	3
	.globl	DataBuff
DataBuff:			//C function: lbccoder()
	.space	2*(PitchMax+Frame+1)
*/
	.align	3
	.globl	src
	.globl	ErrBlk
	.globl	CorVct	
src:				// Estim_Pitchs()
ErrBlk:				//Find_Bests() 
CorVct:				//Find_Acbks() 
	.space	2*(2*SubFrLen)
	
	.align	3
	.globl	tar
	.globl	WrkBlk
	.globl	CorBuf
tar:				//Estim_Pitchs()
WrkBlk:				//Find_Bests()
CorBuf:				//Find_Acbks() 
	.space	2*(2*SubFrLen+PitchMax)	

	.align	3
	.globl	QntLpc
QntLpc:				//C functions: Coder() Decod()
	.space	2*(SubFrames*LpcOrder)

    .align 3
    .globl  ImpResp
ImpResp:
    .space  2*SubFrLen

	.align	3
	.globl	RezBuf
	.globl	best
RezBuf:				//Decod_Acbks()
best:				//Find_Bests()
	.space	(SubFrLen+ClPitchOrd-1)*2	
	
	.align	14
	.globl	blank
blank:
	.space	4096


/*************************************************
void Fir(Word32 *Acc0, Word32 *Acc2, Word16 *pCoe, Word16 *pDat)
	note1. assume 32 bit and fractional mode
	note2. assume pCoe and pDat are align 4 boundary
 Instr: 23 clk + (40/4)*icache_miss_penalty(30)={23, 323}
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Firs
	.ent	Firs	
Firs:			
	.align	3	
	// t0:[c0 c1]t1:[c8 c9]t4:[c4 c5]t5:[c6 c7]
	// t2:[d0 d1]t3:[d8 d9]t6:[d4 d5]t7:[d6 d7]
	// t8:[d7 d8] t9:[d5 d6]
	lh		t8, -2(a3)	;	multa2	m0, zero, zero//46/15
	lwp		t0, (a2)+4
	lwp		t1, (a2)+4
	lwp		t2, (a3)+4	;	multa2	m2, zero, zero	
	lwp		t3, (a3)+4
	lwp		t6, (a3)+4
	msuba2.s m0, t0, t2	;	mux2.lh	t8, t8, t2
	msuba2.s m2, t0, t8	;	lwp		t4, (a2)+4
	msuba2.s m0, t1, t3	;	mux2.lh	t9, t2, t3
	msuba2.s m2, t1, t9	;	lwp		t7, (a3)+4
	msuba2.s m0, t4, t6	;	mux2.lh	t8, t3, t6
	msuba2.s m2, t4, t8	;	lwp		t5, (a2)+4
	mux2.lh	t9, t6, t7	;	lwp		t3, (a3)+4
	msuba2.s m0, t5, t7	;	lwp		t1, (a2)+4
	msuba2.s m2, t5, t9	;	mux2.lh	t8, t7, t3
	msuba2.s m0, t1, t3	;	lw		v0, 0(a0)//v0=Acc0
	msuba2.s m2, t1, t8	;	lw		v1, 0(a1)//v1=Acc1
	addma.s	m0l, m0l, m0h;	addma.s	m2l, m2l, m2h	
	mfa		t0, m0l
	mfa		t1, m2l
	addr.s	v0, v0, t0	;	addr.s	v1, v1, t1
	sw		v0, 0(a0)	
	sw		v1, 0(a1)		
	jr		ra
	nop
	.end	Firs

/******************************************************
void Iir(Word32 *Acc0, Word32 *Acc2, Word16 *pCoe, Word16 *pDat)
	note1. assume 32 bit sature and fractional mode
	note2. assume pCoe and pDat are align on 4 boundary
 Instr: 31 + (52/4)*icache_miss_pemalty(30)={31,421}
*/
	
	.text
	.set	noat
	.set	noreorder
	.globl	g7231_Iirs
	.ent	g7231_Iirs
	.align	3
g7231_Iirs:			
	// t0:[c8 c9]t1:[c2 c3]t2:[c4 c5]t3:[c6 c7]
	// t4:[d8 d9]t5:[d2 d3]t6:[d4 d5]t7:[d6 d7]
	// t8:[d7 d8]t9:[d5 d6]
	lwp		t0, (a2)+4
	lwp		t1, (a2)+4
	lwp		t2, (a2)+4	
	lwp		t4, (a3)+4
	lwp		t5, (a3)+4	;	multa2	m0,zero,zero
	lwp		t6, (a3)+4	;	multa2	m2,zero,zero
	madda2.s m0, t0, t4	;	mux2.lh	t8, zero, t4
	madda2.s m2, t0, t8	;	lwp		t3, (a2)+4
	madda2.s m0, t1, t5	;	mux2.lh	t9, t4, t5
	madda2.s m2, t1, t9	;	lwp		t7, (a3)+4	
	madda2.s m0, t2, t6	;	mux2.lh	t8, t5, t6
	madda2.s m2, t2, t8	;	lwp		t4, (a3)+4
	madda2.s m0, t3, t7	;	mux2.lh	t9, t6, t7
	madda2.s m2, t3, t9	;	lwp		t0, (a2)+4
	subu	a3, a3, 20	;	mux2.lh	t8, t7, t4
	madda2.s m0, t0, t4	;	subu	a2, a2, 20
	madda2.s m2, t0, t8	;	addma.s m0l, m0l, m0h
	addma.s  m2h, m2h,m2l;	lw		v0, 0(a0)
	nop					;	mfa		t0, m0l
	lw		v1, 0(a1)	;	addr.s	v0, v0, t0
	lh		t3, 0(a2)	;	li		t5, 0x00008000		//v0=*Acc0 //pCoe[0]
	sw		v0, 0(a0)	;	addr.s	t1, v0, v0	
	mta2	v1, m3l		;	addr.s	t1, t1, t1			// L_shl(Acc0, 2)
	addma.s m2h,m2h,m3l	;	addr.s	t1, t1, t5
	sra		t1, t1, 16	;	nop
	sh		t1, -2(a3)	;	multa2	m2l, t3, t1	
	addma.s	m2h, m2h, m2l
	mfa		t2, m2h
	sw		t2, 0(a1)	/*;	sll		t3, t2, 2	*/
	addr.s	t3, t2, t2	//L_shl(Acc1, 2)
	addr.s	t3, t3, t3
	addr.s	t3, t3, t5
	sra		t3, t3, 16
	sh		t3, -4(a3)
	jr		ra
	nop	
	.end	g7231_Iirs

/*
 void crossconv180(Word16 *Tv, Word16 *Imr, Word32 *CrossEn, Word16 *Len)
	a0->Tv
	a1->Imr
	a2->CrossEn
	a3->Len
Usage.
	1.assume "integer" mpy mode and 32 bit sature
	2.process 4 output each outer loop
	3.Tv[] has to pad 4 "zero" in the tail
clks: 14+Len[0]/4*(5+14)+8*(Len[1]/4+..+1)+6
*/
	.text
	.set	noat
	.set	noreorder
	.globl	crossconv180s
	.ent	crossconv180s
crossconv180s:
	subu	sp, sp, 40	
	sw		s0, 20(sp)	//Tv offset stride
	sw		s1, 24(sp)	//Imr[0]
	sw		at, 28(sp)
	sw		s3, 32(sp);	li	s0, 8	//offset pointer
	lw		a3, 0(a3)	//a3=Len[0:1]
	nop
	mux2.lh	t4, zero, a3	//t4=Len[0]
	mux2.hl	t5, zero, a3	//t5=Len[1]
	move	at, t5	;	move	s1, a1//at=inner loop length
	/////////////////////	
	sll		at, at, 1
	add		at, at, 8	//at=Len[1]*2+8
	la		t0, 1f		
	la		t1, 2f-4
	mtru	t0, lps0;sra a3, t4, 2	//outer loop cnter (a3=Len[0]/4)
	mtru	t1, lpe0;sra s3, t5, 2	
	sub		s3, s3, 1				//inner loop cnter (s3=Len[1]/4-1)
	.align	3			
3:	
	// set inner loop times
	mtru	s3, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a1)+8	;multa2	m1,zero,zero
	ltp		t4, (a0)+8	;multa2	m2,zero,zero
	lt		t6, 0(a0)	;multa2 m3,zero,zero
	move	t0,t2		;nop
1:	// inner loop start
	// Imr ->t0:[4 5]t1:[2 3]t2:[4 5]t3:[6 7]
	// Tv->	 t4:[4 5]t5:[6 7]t6:[8 9]t7:[10 11] 
	//		 t8:[5 6]t9:[3 4]
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (a1)+8
	madda2.s m2, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m2, t1, t6	;mux2.lh t9, t5, t6
	madda2.s m1, t0, t8	;ltp	t4, (a0)+8
	madda2.s m1, t1, t9	;mux2.lh t8, t6, t7
	madda2.s m3, t0, t9	;lt		t6, 0(a0)
	madda2.s m3, t1, t8	;move	t0, t2	
2:	// inner loop end
	addma.s m0l, m0l, m0h;addma.s m1l, m1l, m1h
	addma.s m2l, m2l, m2h;addma.s m3l, m3l, m3h
	mfa		t0, m0l
	mfa		t1, m1l
	mfa		t2, m2l
	mfa		t3, m3l
	// store 4 CrossEn[]
	// adjust Tv[] and Imr[] pointer	
	// dec inner loop cnter
	swp		t0, (a2)+4;subu	a0, a0, at	//Tv=Tv-(Len[1]*2+8)
	swp		t1, (a2)+4;move	a1, s1
	swp		t2, (a2)+4;addu	a0, a0, s0	//Tv=Tv+offset(offset 4 samples)	
	swp		t3, (a2)+4;sub	s3, s3, 1
	addu	s0, s0, 8
	//dec outer loop cnter
	sub		a3, a3, 1
	bgtz	a3, 3b
	nop	
4:	
	////////////////////	
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		at, 28(sp)
	lw		s3, 32(sp)	
	jr		ra
	addu	sp, sp, 40
	.end	crossconv180s
	

/*
void  Comp_Lpc( Word16 *UnqLpc, Word16 *PrevDat, Word16 *DataBuff )
	s0->UnqLpc (align 4)
	a1->PrevDat	(align 8)
	a2->DataBuff (align 8)
local:
	Dpnt->Dpnt[]
	Vect_Norm->Vect_Norm[]
	Acf_sf->Acf_sf[]
	CrossEn->PastX[]	
	32(sp)->ShAcf_sf[0]
	38(sp)->ShAcf_sf[3]	
	40(sp)->Len[0:1]
	44(sp)->Pk2
	56(sp)->mmd
	
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Comp_Lpcs
	.ent	Comp_Lpcs
Comp_Lpcs:
	subu	sp, sp, 128
	sw		s0, 80(sp)
	sw		s1, 84(sp)
	sw		s2, 88(sp)
	sw		s3, 92(sp)	
	sw		s4, 96(sp)	
	sw		s5, 100(sp)	
	sw		s6, 104(sp)
	sw		s7, 108(sp)	
	sw		ra, 60(sp)
	move	s0, a0
	mfru	t4, mmd	
	sw		t4, 56(sp)	
	//////////////////
	/* Generate a buffer of 360 samples */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (LpcFrame-SubFrLen)/8-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	la		s1, Dpnt	//s1=Vect=&Dpnt[0]
	move	a0, s1	
1:
	ltp		t4, (a1)+8
	ltp		t6, (a1)+8
	stp		t4, (a0)+8
	stp		t6, (a0)+8
2:
	la		t0, 1f
	la		t1, 2f-4
	li		t2, Frame/8-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
1:
	ltp		t4, (a2)+8
	ltp		t6, (a2)+8
	stp		t4, (a0)+8
	stp		t6, (a0)+8
2:
	/* Repeat for all subframes */
	la		s2, Acf_sf	//s2->curAcf=&Acf_sf[0]
	li		s3, 0		//s3=k
	la		s4, Vect_Norm//s4->Vect_Norm
	
3:	//for(k=0; k<SubFrames; k++) {
	/* Do windowing */
	move	a0, s1	//a0->Vect
	/*Normalize*/
	move	a1, s4
	jal		Vec_Norms
	//jal		Vec_Norm
	li		a2, LpcFrame
	sll		t4, s3, 1
	addu	t4, t4, sp
	sh		v0, 32(t4)		//ShAcf_sf[k]=Vec_Norm()
	/*Apply the Hamming window */
	la		a1, HammingWindowTable
	move	a0, s4			//a0->Vect_Norm
	la		t0, 1f
	la		t1, 2f-4
	li		t2, LpcFrame/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	ltp		t0, (a0)+8		//t0:[V0 V1]t1:[V2 V3]
	ltp		t4, (a1)+8		//t4:[H0 H1]t5:[H2 H3]	
	li		t6, 0x6		//32 bit sature and fractional mode
	mtru	t6, mmd
	.align	3
1:
	multa2	m0, t0, t4
	multa2	m1, t1, t5	
	mfa		t2, m0h		;li		t8, 0x00008000
	mfa		t3, m0l		;addr.s	t2, t2, t8
	mfa		t6, m1h		;addr.s	t3, t3, t8
	mfa		t7, m1l		;addr.s	t6, t6, t8
	ltp		t0, (a0)+8	;addr.s	t7, t7, t8
	ltp		t4, (a1)+8	;mux2.hh t2, t2, t3
	mux2.hh	t3, t6, t7	;nop
	st		t2, -16(a0)
2:
	// pad 4 zero in the tail of Vect_Norm[]
	sw		zero, -8(a0)
	sw		zero, -4(a0)
	/* compute the 0-order coefficient(energy) */
	move	a0, s4	//a0->Vect_Norm
	multa2	m0, zero,zero	
	la		t4, 1f
	la		t5, 2f-4
	la		t6, (LpcFrame+4)/8-1	//+4 for align 8
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
1:
	ltp		t0, (a0)+8
	ltp		t2, (a0)+8
	madda2.s m0, t0, t0
	madda2.s m0, t1, t1
	madda2.s m0, t2, t2
	madda2.s m0, t3, t3
2:	
	addma.s m0l,m0l,m0h
	mfa		v1, m0l, 1
	/* Apply a white noise correction factor of (1025/1024) */
	sra		v0, v1, RidgeFact
	addr.s	v1, v1, v0		//v1=Acc1
	/* Normalize the energy */
	jal		norm_l
	move	a0, v1			//v0=Exp
	sll		v1, v1, v0		//Acc1=Acc1 << Exp
	//sub		s5, v0, 1		//s5=Exp-1
	move	s5, v0		//s5=Exp
	li		t4, 0x00008000
	addr.s	t4, v1, t4
	sra		t4, t4, 16
	shp		t4, (s2)+2		//curAcf0]=round(Acc1)
	
	bnez	t4, 1f
	nop
	// if(curAcf[0] == 0)
	shp		zero, (s2)+2
	shp		zero, (s2)+2
	shp		zero, (s2)+2
	shp		zero, (s2)+2
	shp		zero, (s2)+2
	shp		zero, (s2)+2
	shp		zero, (s2)+2	;sll	t4, s3, 1
	shp		zero, (s2)+2	;addu	t4, t4, sp
	shp		zero, (s2)+2	;li		t5, 40
	shp		zero, (s2)+2	
	sh		v0, 32(t4)		//ShAcf_sf[k]=40
	j		4f
	nop
1:	// else
	/* compute the reset of the autocorrelation */
	li		t4, 12		;li		t5, LpcFrame
	mux2.ll	t4, t4, t5	;move	a0, s4
	sw		t4, 40(sp)	;move	a1, s4
	la		s6, PastX	//s6=CrossEn=PastX
	move	a2, s6		
	li		t4, 0x2		//integer mode
	mtru	t4, mmd
	addu	a3, sp, 40
	jal		crossconv180s
	nop
		
	la		t0, 1f
	la		t1, 2f-4
	li		t2, LpcOrder-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	addu	s6, s6, 4	//s6->CrossEn[1]
	la		s7, BinomialWindowTable		
1:
	lwp		t0, (s6)+4	
	lhp		a1, (s7)+2
	jal		L_mls
	sllv	a0, t0, s5		//CrossEn[i]<<Exp
	li		t4, 0x00008000
	addr.s	v0, v0, t4
	sra		v0, v0, 16
	shp		v0, (s2)+2
2:		
	li		t1, 0x6		//fractional mode
	mtru	t1, mmd
	sll		t0, s3, 1
	addu	t0, t0, sp
	lh		t1, 32(t0)
	//add		t2, s5, 1	//Exp	
	nop
	addu	t2, s5, t1
	addu	t2, t2, t1
	sh		t2, 32(t0)	
4:	// Apply the Levinson-Durbin algorithm */	
	li		t4, LpcOrder
	multa2	m0l, t4, s3
	subu	a1, s2, 2*LpcOrder;lh	a2, (-2*LpcOrderP1)(s2)
	addu	a3, sp, 44	;mfa	t5, m0l
	li		t4, 0x2	//integer mpy
	mtru	t4, mmd	
	jal		Durbin
	addu	a0, s0, t5
	.extern pCoderMem	
	//lw		t4, pCodStat
	lw		t4, pCoderMem	
	li		t6, 0x0000799a
	addu	t4, t4, 784	//t4->pCoderMem->CodStat
	lh		t5, 14(t4)	//14(t4)->CodStat.SinDet
	lh		t3, 44(sp)	//t3=Pk2
	sll		t5, t5, 1	//t5=SinDet<<1
	add		t7, t5, 1	//t7=SinDet<<1+1
	sgt		t2, t3, t6
	cmvnez	t5, t7, t2	//t5=pCodStat.SinDet
	sh		t5, 14(t4)	//save pCodStat.SinDet
	
	addu	s1, s1, 2*SubFrLen	//Vect=Dpnt[k*SubFrLen]
	//} end k
	addu	s3, s3, 1
	sge		t0, s3, SubFrames
	beqz	t0, 3b
	nop
	/* Update sine detector */
	and		t5, t5, 0x7fff
	//sh		t5, 14(t4)		//t5=j=SinDet
	la		t0, 1f
	la		t1, 2f-4
	li		t2, 15-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	li		v0, 0	//v0=k
	move	t6, t5	//t6=SinDet
1:
	and		t0, t5, 0x1
	add		v0, v0, t0
	srl		t5, t5, 1
2:		
	ori		t7, t6, 0x8000
	li		t0, 14
	sge		t1, v0, t0	
	cmvnez	t6, t7, t1
	sh		t6, 14(t4)
	/* Update CNG Acf memories */
	subu	a0, s2, 4*LpcOrderP1*2	
	jal		Update_Acf
	addu	a1, sp, 32
	
	//////////////////
	lw		ra, 60(sp)
	lw		t4, 56(sp)	
	lw		s0, 80(sp)
	lw		s1, 84(sp)
	lw		s2, 88(sp)
	lw		s3, 92(sp)
	lw		s4, 96(sp)
	lw		s5, 100(sp)
	lw		s6, 104(sp)
	lw		s7, 108(sp)	
	mtru	t4, mmd
	addu	sp, sp, 128
	jr		ra
	nop

	.end	Comp_Lpcs	

	
/*************************************************
void  Wght_Lpc( Word16 *PerLpc, Word16 *UnqLpc )
	a0->PerLpc
	a1->UnqLpc
Instruction: 376 instructions
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Wght_Lpcs
	.ent	Wght_Lpcs
Wght_Lpcs:
	la		t0, PerFiltZeroTable
	la		t1, PerFiltPoleTable
	la		t4, 1f
	la		t5, 2f-4
	li		t8, LpcOrder/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t9, SubFrames
4:	// for(i=0; i<SubFrames; i++) {		
	mtru	t8, lpc0
	.align	3		
1:
	lwp		t2, (a1)+4	// UnqLpc[j,j+1]
	lwp		t3, (t0)+4	// PerFiltZeroTable[j,j+1]
	lwp		t4, (t1)+4	// PerFiltPoleTable[j,j+1]
	li		t5, 0x00004000
	multa2	m0, t2, t3
	multa2	m1, t2, t4
	mfa		v0, m0h
	mfa		v1, m0l
	mfa		t6, m1h	;	addr.s	v0, v0, t5
	mfa		t7, m1l	;	addr.s	v1, v1, t5
	addr.s	t6, t6, t5;	addr.s	t7, t7, t5
	sra		v0, v0, 15;	sra		v1, v1, 15
	sra		t6, t6, 15;	sra		t7, t7, 15
	sh		v0, 0(a0)
	sh		v1, 2(a0)
	sh		t6, (LpcOrder*2)(a0)
	sh		t7, (LpcOrder*2+2)(a0)
	addu	a0, a0, 4
2:	
	addu	a0, a0, LpcOrder*2	
	subu	t0, t0, 20	;	subu	t1, t1, 20
	sub		t9, t9, 1
	bgtz	t9, 4b
	nop
	// }
	
	jr		ra
	nop
	
	.end	Wght_Lpcs
	
/**************************************************
void  Error_Wght( Word16 *Dpnt, Word16 *PerLpc )
	s0->Dpnt
	s1->PerLpc
local:
	FirDl->PastX=s2
	IirDl->PastY=s3
	s4->SubFrames
	s5->pCodStat
	Acc0=20(sp)
	Acc2=24(sp)
Instruction: 33+4(2+30(9+23+31+6)+14)+25=8672	33+4(2+30(18+44+60+6)+18)+22 = 
*/	
	.text
	.set	noat
	.set	noreorder
	.globl	Error_Wghts
	.ent	Error_Wghts
	.align	3
Error_Wghts:
	subu	sp, sp, 64
	mfru	t9, mmd
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	
	sw		s3, 40(sp)	;	move	s0, a0
	sw		s4, 44(sp)	;	move	s1, a1
	sw		s5, 48(sp)
	sw		t9, 52(sp)	// mmd
	sw		ra, 60(sp)
	/////////////////////
	/* Do for all subframes */
	li		s4, SubFrames
	la		s2, PastX
	la		s3, PastY
	//.extern pCodStat
	//lw		s5, pCodStat
	.extern pCoderMem
	lw		s5, pCoderMem	
	addu	s2, s2, SubFrLen*2	//s2=ptrF
	addu	s3, s3, SubFrLen*2	//s3=ptrI
	addu	s5, s5, 784	//s5=pCoderMem->CodStat
	la		t4, 1f
	la		t5, 2f-4
	mtru	t4, lps0
	mtru	t5, lpe0
	li		t6, 0x6		//fractional mpy and 32 bits sature
	mtru	t6, mmd	
	
	lt		t4, (1168)(s5)	
	lt		t6, (1192)(s5)
	st		t4, 0(s2)
	st		t6, 0(s3)
	lt		t4, (1168+8)(s5)
	lt		t6, (1192+8)(s5)
	st		t4, 8(s2)
	st		t6, 8(s3)
	lw		t4, (1168+16)(s5)
	lw		t6, (1192+16)(s5)
	sw		t4, 16(s2)
	sw		t6, 16(s3)
	// for(k=0;k<SubFrames;k++) {
4:		
	li		t5, SubFrLen/2-1
	mtru	t5, lpc0	
		// for (i=0; i<SubFrLen; i+=2) {
	.align	3
1:
	/* FIR part */
	lh		t4, 0(s0)
	lh		t5, 2(s0)
	li		t6, 0x00002000	;	sh	t4, -2(s2)
	multa2	m0l, t4, t6		;	sh	t5, -4(s2)
	multa2	m2l, t5, t6		;	addu	a0, sp, 20
	mfa		v0, m0l			;	addu	a1, sp, 24
	mfa		v1, m2l			;	move	a2, s1
	move	a3, s2			;	sw		v0, 20(sp)
	sw		v1, 24(sp)		;	nop
	jal		Firs
	nop	
	/* IIR part */
	addu	a2, s1, LpcOrder*2;	move	a3, s3
	jal		g7231_Iirs
	nop
	
	lh		t4, -2(s3)
	lh		t5, -4(s3)
	shp		t4, (s0)+2	;	subu	s2, s2, 4
	shp		t5, (s0)+2	;	subu	s3, s3, 4	
2:
		// }		
	/* restore memory */
	lw		t4, 0(s2)
	lw		t5, 4(s2)
	lw		t6, 0(s3)
	lw		t7, 4(s3)
	//lt		t4, 0(s2)
	//lt		t6, 0(s3)
	st		t4, (SubFrLen*2)(s2)
	st		t6, (SubFrLen*2)(s3)
	//lt		t4, 8(s2)
	//lt		t6, 8(s3)
	lw		t4, 8(s2)
	lw		t5, 12(s2)
	lw		t6, 8(s3)
	lw		t7, 12(s3)
	st		t4, (SubFrLen*2+8)(s2)
	st		t6, (SubFrLen*2+8)(s3)
	lw		t4, 16(s2)
	lw		t6, 16(s3)
	sw		t4, (SubFrLen*2+16)(s2)
	sw		t6, (SubFrLen*2+16)(s3)
	
	addu	s1, s1, 2*2*LpcOrder
	addu	s2, s2, SubFrLen*2;	addu	s3, s3, SubFrLen*2
	
	// }
	sub		s4, s4, 1
	bgtz	s4, 4b
	nop
	
	// update memory
	//lt		t4, 0(s2)
	//lt		t6, 0(s3)
	lw		t4, 0(s2)
	lw		t5, 4(s2)
	lw		t6, 0(s3)
	lw		t7, 4(s3)
	st		t4, (1168)(s5)
	st		t6, (1192)(s5)
	//lt		t4, 8(s2)
	//lt		t6, 8(s3)
	lw		t4, 8(s2)
	lw		t5, 12(s2)
	lw		t6, 8(s3)
	lw		t7, 12(s3)
	st		t4, (1168+8)(s5)
	st		t6, (1192+8)(s5)
	lw		t4, 16(s2)
	lw		t6, 16(s3)
	sw		t4, (1168+16)(s5)
	sw		t6, (1192+16)(s5)
	/////////////////////
	lw		t9, 52(sp)		//mmd
	lw		ra, 60(sp)
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	mtru	t9, mmd
	jr		ra
	addu	sp, sp, 64
	.end	Error_Wghts

/*************************************************
void  Comp_Ir( Word16 *ImpResp, Word16 *QntLpc, Word16 *PerLpc, PWDEF *Pw )
	a0 -> ImpResp
	a1 -> QntLpc
	a2 -> PerLpc
	a3 -> Pw
local:
	FirDl[]: share PastX with Spfs()
	IirDl[]: share PastY with Spfs()
	Temp[]: share g7231_TmpVct with Synts() and Spfs()
	Acc0 -> 24(sp)
	Acc2 -> 20(sp)	
	t9 -> mmd
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Comp_Irs
	.ent	Comp_Irs	
Comp_Irs:		
	subu	sp, sp, 128
	mfru	t9, mmd
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)
	sw		s3, 40(sp)	
	sw		s4, 44(sp)				// s4 -> ptrF
	sw		s5, 48(sp)				// s5 -> ptrI
	sw		s6, 52(sp)				// s6 -> g7231_TmpVct
	sw		s7, 56(sp)				// s7->thr0
	sw		ra, 60(sp)
	sw		t9, 64(sp)	//mmd
	li		t4, 0x6		//fractional mpy ans 32 sature
	mtru	t4, mmd
	/* clear all memory */
	la		t0, PastX
	addiu	s4, t0, SubFrLen*2		// s4 -> PastX[SubFrLen] = ptrF
	la		t1, PastY
	addiu	s5, t1, SubFrLen*2		// s5 -> PastY[SubFrLen] = ptrI
	li		t2, 0			;		li		t3, 0
	st		t2, 0(s4)
	st		t2, 0(s5)
	st		t2, 8(s4)
	st		t2, 8(s5)
	sw		t2, 16(s4)
	sw		t2, 16(s5)
	/* Input a single impulse */		
	lh		t5, 0(a3)		// Pw->Indx
	li		t4, 0x04000000			
	sub		s7, zero, t5		// s7 = thr0
	sw		zero, 20(sp)		// Acc2 = 0
	sw		t4, 24(sp)			// Acc0 = 0	

	/* Do for all elements in a subframe */
	la		t2, 1f
	la		t3, 2f-4
	la		s6, g7231_TmpVct
	li		t4, SubFrLen/2-1
	mtru	t2, lps0
	mtru	t3, lpe0
	mtru	t4, lpc0		
	.align 	3
	move	s0, a0		;	move	s1, a1
	move	s2, a2		;	move	s3, a3
	// for (i=0; i<SubFrLen; i+=2) {	
1:		
	/* Synthesis filter */
	addu	a0, sp, 24	;	addu	a1, sp, 20
	move	a2, s1		;	move	a3, s4
	jal		g7231_Iirs
	nop	
	/* Perceptual weighting filter */
	 /* FIR part */
	move	a2, s2		;	move	a3, s4
	jal		Firs
	nop
	lw		t4, 24(sp)
	lw		t5, 20(sp)
	addr.s	t4, t4, t4	// L_shl(Acc0, 1)
	addr.s	t5, t5, t5	// L_shl(Acc2, 1)
	sw		t4, 24(sp)
	sw		t5, 20(sp)
	 /* IIR part */
	addu	a2, s2, 10*2; 	move	a3, s5
	jal		g7231_Iirs
	nop
	lh		t0, -2(s5)		// ptrI[-1]
	lh		t1, -4(s5)		// ptrI[-2]
	shp		t0, (s6)+2		//Temp[i]=ptrI[-1]
	shp		t1, (s6)+2		//Temp[i+1]=ptrI[-2]
	/* Harmonic noise shaping filter */	
	bgez	s7, 3f
	li		t4, 0		// t4=tmp0
	j		4f
	nop
3:
	sll		t6, s7, 1
	la		t7, g7231_TmpVct
	addu	t7, t7, t6	//Temp[thr0]
	lh		t4, 0(t7)
4:	
	addi	s7, s7, 1	// thr0++
	
	bgez	s7, 3f
	li		t5, 0
	j		4f
	nop
3:
	sll		t6, s7, 1
	la		t7, g7231_TmpVct
	addu	t7, t7, t6
	lh		t5, 0(t7)	// t5=tmp2
4:
	addi	s7, s7, 1

	lh		t2, 2(s3)	// Pw.Gain	
	sll		v0, t0, 16		//;	multa2	m0, zero, zero
	sll		v1, t1, 16		//;	multa2	m2, zero, zero
	multa2 /*msuba2.s*/ m0l, t2, t4	;	li		t6, 0x00008000
	multa2 /*msuba2.s*/ m2l, t2, t5
	mfa		t4, m0l
	mfa		t5, m2l			;	subr.s/*addr.s*/	v0, v0, t4
	subr.s/*addr.s*/	v1, v1, t5		;	addr.s	v0, v0, t6
	addr.s	v1, v1, t6		;	sra		v0, v0, 16
	sra		v1, v1, 16		;	shp		v0, (s0)+2
	shp		v1, (s0)+2		;	subu	s4, s4, 4	// ptrF -= 2
	sw		zero, 24(sp)	// Acc0 = 0
	sw		zero, 20(sp)		// Acc2 = 0
	subu	s5, s5, 4		// ptrI -= 2
2:	
	// } end for loop
	lw		t9, 64(sp)
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)	
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)	
	lw		ra, 60(sp)
	mtru	t9, mmd
	jr		ra
	addu	sp, sp, 128
	.end	Comp_Irs

/************************************************************
void  Sub_Ring( Word16 *Dpnt, Word16 *QntLpc, Word16 *PerLpc, Word16 *PrevErr, PWDEF *Pw )
	a0 -> Dpnt
	a1 -> QntLpc
	a2 -> PerLpc
	a3 -> PrevErr
	//t0 -> Pw	(for GHS)
	16(sp)->Pw
local:
	FirDl[]: share PastX with Spfs()
	IirDl[]: share PastY with Spfs()
	Temp[]: share g7231_TmpVct with Synts() and Spfs() and Comp_Irs()
	at -> ind
	Acc0 -> 28(sp)
	Acc2 -> 32(sp)	
	40(sp) -> &Temp[0]
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Sub_Rings
	.ent	Sub_Rings
	.align	3
Sub_Rings:	
	lw		t0, 16(sp)		//NOTE. for GNU, get Pw from stack
	nop
	subu	sp, sp, 128
	mfru	t9, mmd
	sw		ra, 76(sp)	
	sw		s0, 20(sp)
	sw		s1, 24(sp)		
	sw		s2, 44(sp)		;	move	s0, a0
	sw		s3, 48(sp)		;	move	s1, a1
	sw		s4, 52(sp)		;	move	s2, a2
	sw		s5, 56(sp)		;	move	s3, a3		// s5->ptrF
	sw		s6, 60(sp)		;	move	s4, t0		// s6->ptrI
	sw		s7, 64(sp)								// s7->Temp		
	sw		at, 68(sp)
	sw		t9, 72(sp)	//mmd
	////////////////
	/* Initialize the memory */
	la		t4, PastX
	li		t2, 0x6			//32 fractional mode
	mtru	t2, mmd
	la		t5, PastY
	addu	s5, t4, SubFrLen*2	;	addu	s6, t5, SubFrLen*2
	//lw		t1, pCodStat
	//nop
	.extern pCoderMem
	lw		t1, pCoderMem
	nop	
	addu	t1, t1, 784		//t1=pCoderMem->CodStat
	lt		t2, (1216+0)(t1)		// t2=CodStat.RingFirDl[0]
	lt		t4, (1216+8)(t1)	
	lw		t6, (1216+16)(t1)		
	st		t2, 0(s5)
	st		t4, 8(s5)
	sw		t6, 16(s5)
	lt		t2, (1240+0)(t1)		// t2=CodStat.RingIirDl[0]
	lt		t4, (1240+8)(t1)
	lw		t6, (1240+16)(t1)
	st		t2, 0(s6)
	st		t4, 8(s6)
	sw		t6, 16(s6)
	
	li		t2, PitchMax	;	lh		t5, 0(s4)		// Pw->Indx
	nop						;	sub		at, t2, t5				// at=ind=PitchMax-Pw->Indx
	
	/* Do for all elements in a subframe */
	la		t4, 1f
	la		t5, 2f-4
	li		t6, SubFrLen/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	la		s7, g7231_TmpVct			// s7 -> g7231_TmpVct
	sw		s7, 40(sp)			// 40(sp) -> &Temp[0]
	// for (i=0; i<SubFrLen; i+=2)
	.align	3
1:	
	/* input zero */
	sw		zero, 28(sp)		// Acc0=0
	sw		zero, 32(sp)		// Acc2=0
	/* Synthesis filter */
	addu	a0, sp, 28		;	addu	a1, sp, 32	
	move	a2, s1			;	move	a3, s5
	jal		g7231_Iirs
	nop
	/* Perceptual weighting filter */
		/* Fir part */
	move 	a2, s2			;	move	a3, s5
	jal		Firs
	nop
		/*Iir part*/
	addu	a2, s2, 20		;	move	a3, s6
	jal		g7231_Iirs
	nop

	lh		t4, -2(s6)
	lh		t5, -4(s6)
	shp		t4, (s7)+2		// Temp[i] = ptrI[-1]
	shp		t5, (s7)+2		// Temp[i+1]=ptrI[-2]
	/* Do the harmonic noise sharping filter 
	   and subtract the result from the harmonic
	   noise weighted vector */
	lh		t2, 0(s0)		// Dpnt[i]
	lh		t3, 2(s0)		// Dpnt[i+1]
	subr.s	t2, t2, t4	
	subr.s	t3, t3, t5
	sll		t2, t2, 16		// t2=Acc0
	sll		t3, t3, 16		// t3=Acc2
	
	lw		t1, 40(sp)		// t1=&Temp[0]
	sub		t0, at, PitchMax// t0=ind-PitchMax
	bgez	t0, 3f
	nop
	sll		t0, at, 1
	j		4f
	addu	t0, t0, s3	
3:
	sll		t0, t0, 1
	addu	t0, t0, t1
4:	
	lh		t4, 0(t0)		//t4=sam1
		
	add		at, at, 1		// ind++
	
	sub		t0, at, PitchMax
	bgez	t0, 3f
	nop
	sll		t0, at, 1
	j		4f
	addu	t0, t0, s3
3:
	sll		t0, t0, 1
	addu	t0, t0, t1
4:
	lh		t5, 0(t0)		//t5=sam2
	add		at, at, 1

	lh		t6, 2(s4)	;	li		t7, 0x00008000
	multa2	m0l, t6, t4
	multa2	m2l, t6, t5
	mfa		v0, m0l
	mfa		v1, m2l
	addr.s	v0, v0, t2	;	addr.s	v1, v1, t3
	addr.s	v0, v0, t7	;	addr.s	v1, v1, t7
	sra		v0, v0, 16	;	sra		v1, v1, 16
	shp		v0, (s0)+2	;	subu	s5, s5, 4
	shp		v1, (s0)+2	;	subu	s6, s6, 4
2:	
	////////////////
	lw		t9, 72(sp)
	lw		ra, 76(sp)	
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 44(sp)
	lw		s3, 48(sp)
	lw		s4, 52(sp)
	lw		s5, 56(sp)
	lw		s6, 60(sp)
	lw		s7, 64(sp)
	lw		at, 68(sp)
	mtru	t9, mmd
	jr		ra
	addu	sp, sp, 128
	.end	Sub_Rings

/********************************************
void  Upd_Ring( Word16 *Dpnt, Word16 *QntLpc, Word16 *PerLpc, Word16 *PrevErr )
	s0->Dpnt
	s1->QntLpc
	s2->PerLpc
	s3->PrevErr[PitchMax]
local:
	FirDl->PastX=s4
	IirDl->PastY=s5
	Acc0 ->36(sp)
	Acc2 ->40(sp)		
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Upd_Rings
	.ent	Upd_Rings
Upd_Rings:
	subu	sp, sp, 128
	mfru	t9, mmd
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;	move	s0, a0
	sw		s4, 44(sp)	;	move	s1, a1
	sw		s5, 48(sp)	;	move	s2, a2
	sw		s6, 52(sp)	;	addu	s3, a3, PitchMax*2
	sw		s7, 56(sp)
	sw		ra, 60(sp)
	sw		t9, 64(sp)//mmd
	li		t4, 0x6
	mtru	t4, mmd
	///////////////////
	/* Initial FirDl, IirDl */	
	//.extern	pCodStat
	//lw		t8, pCodStat
	.extern pCoderMem
	lw		t8, pCoderMem	
	la		s4, PastX		// s4=ptrF
	addu	t8, t8, 784		//t8->pCoderMem->CodStat
	la		s5, PastY		// s5=ptrI		
	addu	s4, s4,SubFrLen*2	;	addu	s5, s5,SubFrLen*2	
	lt		t4, (1216)(t8)	// CodStat.RingFirDl[]
	lt		t6, (1240)(t8)	// CodStat.RingIirDl[]
	st		t4, 0(s4)
	st		t6, 0(s5)
	lt		t4, (1216+8)(t8)
	lt		t6, (1240+8)(t8)
	st		t4, 8(s4)
	st		t6, 8(s5)
	lw		t4, (1216+16)(t8)	
	lw		t6, (1240+16)(t8)
	sw		t4, 16(s4)
	sw		t6, 16(s5)
	/* Do for all elements in the subframe */	
	la		t4, 1f
	la		t5, 2f-4
	li		t6, SubFrLen/2-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0		
1:
	/* input the current subframe's excitation */
	lh		t4, 0(s0)	// Dpnt[i]
	lh		t5, 2(s0)	// Dpnt[i+1]
	sll		t4, t4, 16
	sll		t5, t5, 16
	sra		t4, t4, 3
	sra		t5, t5, 3	
	sw		t4, 36(sp)	// Acc0		
	sw		t5, 40(sp)	// Acc2
	/* Synthesis filter */
	addu	a0, sp, 36	;	addu	a1, sp, 40
	move	a2, s1		;	move	a3, s4
	jal		g7231_Iirs
	nop
	lh		t4, -2(s4)
	lh		t5, -4(s4)
	addr2.s	t4, t4, t4	;	addr2.s t5, t5, t5
	shp		t4, (s0)+2
	shp		t5, (s0)+2
	/* Perceptual weighting filter */
		/* Fir part */
	move	a2, s2		;	move	a3, s4
	jal		Firs
	nop
		/* Iir part */
	addu	a2, s2, 10*2;	move	a3, s5
	jal		g7231_Iirs
	nop
	
	/* Update harmonic noise sharping memory */
	lh		t4, -2(s5)
	lh		t5, -4(s5)
	shp		t4, (s3)+2	;	subu	s4, s4, 4// PrevErr[PitchMax+i]=ptrI[-1]
	shp		t5, (s3)+2	;	subu	s5, s5, 4		
2:
	//lw		t8, pCodStat	
	.extern pCoderMem
	lw		t8, pCoderMem	
	lwp		t4, (s4)+4
	lwp		t5, (s4)+4
	addu	t8, t8, 784	//t8->pCoderMem->CodStat
	lwp		t6, (s5)+4
	lwp		t7, (s5)+4
	st		t4, (1216)(t8)
	st		t6, (1240)(t8)
	lwp		t4, (s4)+4
	lwp		t5, (s4)+4
	lwp		t6, (s5)+4
	lwp		t7, (s5)+4
	st		t4, (1216+8)(t8)
	st		t6, (1240+8)(t8)
	lwp		t4, (s4)+4
	lwp		t5, (s5)+4
	sw		t4, (1216+16)(t8)
	sw		t5, (1240+16)(t8)	
	///////////////////
	lw		t9, 64(sp)
	lw		ra, 60(sp)
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)	
	mtru	t9, mmd	
	jr		ra
	addu	sp, sp, 128

	.end	Upd_Rings

/********************************************
void Synts(Word16 *Dpnt, Word16 *Lpc)
	a0 -> Dpnt (align 4)
	a1 -> Lpc (align 4)
local:
	t9 = mmd
	s2->pVct
	s3->pDecStat->SynIirDl
	20(sp)->Acc0
	24(sp)->Acc1
Instruction: 1353 clks
*/
#if 0
	.text
	.set	noat
	.set	noreorder
	.globl	Synts
	.ent	Synts
Synts:	
	mfru	t9, mmd
	////////////////////////////		// (~33)
	.extern pDecStat
	lw		t8, pDecStat
	nop	
	addiu	t8, t8, 32				// t8 = &(pDecStat->SyntIirDl[0])	
	la		t7, g7231_TmpVct
	addiu	t7, t7, SubFrLen*2		// t7 = pVct = &g7231_TmpVct[SubFrLen]
	ltp		t0, (t8)+8
	ltp		t2, (t8)+8
	lwp		t4, (t8)+4
	stp		t0, (t7)+8
	stp		t2, (t7)+8
	swp		t4, (t7)+4
	li		t0, 0x6
	sub		t7, t7, 20				// t7 = pVct
	mtru	t0, mmd					// fractional and 32 bit sature		
	sub		t8, t8, 20				// t8 = &(pDecStat->SyntIirDl[0])
	
	/* do for all elements in the subframe */
													// m0 = a(0)V(0)+a(1)V(1)+a(2)V(2)+a(3)V(3)
	la		t4, lp0s								// a(4)V(4)+a(5)v(5)+a(6)V(6)+a(7)V(7)+a(8)V(8)+a(9)V(9)
	la		t5, lp0e-4
	li		t6, SubFrLen/2-1						// m1 = a(0)z   +a(1)V(0)+a(2)V(1)+a(3)V(2)
	mtru	t4, lps0								// a(4)V(3)+a(5)V(4)+a(6)V(5)+a(7)V(6)+a(8)V(7)+a(9)V(8)
	mtru	t5, lpe0
	mtru	t6, lpc0
	.align	3
lp0s:								// (~ 30*44=1320)
	lh		t0, (a0)				// Dpnt[0]
	lh		t1, 2(a0)				// Dpnt[1]
	sll		t0, t0, 16		;	lwp		t2, (a1)+4//ltp		t2, (a1)+8		// t2:lpc[8:9], t3:lpc[6:7]
	sll		t1, t1, 16		; 	lwp		t3, (a1)+4//ltp		t4, (t7)+8		// t4:pVct[8:9], t5:pVct[6:7]
	sra		t0, t0, 3		;	lwp		t4, (t7)+4		// t0 = Acc0
	sra		t1, t1, 3		;	lwp		t5, (t7)+4		// t1 = Acc1	
	
	// synthesis
	multa2	m0, t2, t4		;	mux2.lh	t6, zero, t4	// t6: [z pVct[0]]
	multa2	m1, t2, t6		; 	lwp		t2, (a1)+4		
	madda2.s m0, t3, t5		;	mux2.lh	t6, t4, t5		// t6: pVct[1:2]
	madda2.s m1, t3, t6		;	lwp		t4, (t7)+4
	lwp		t3, (a1)+4		;	nop
	madda2.s m0, t2, t4		;	mux2.lh	t6, t5, t4		// t6: pVct[3:4]
	madda2.s m1, t2, t6		;	lwp		t5, (t7)+4
	lwp		t2, (a1)+4		;	nop
	madda2.s m0, t3, t5		; 	mux2.lh	t6, t4, t5		// t6: pVct[5:6]
	madda2.s m1, t3, t6		;	lwp		t4, (t7)+4
	sub		a1, a1, 20		;	nop						// reset Lpc pointer
	madda2.s m0, t2, t4		;	mux2.lh	t6, t5, t4		// t6: pVct[7:8]
	madda2.s m1, t2, t6		;	addma.s	m0l, m0l, m0h	
	sub		t7, t7, 20		;	li		t4, 0x00008000	// reset pVct pointer
	mfa		v0, m0l			;	lh		t2, (a1)		// t2 = Lpc[0]
	addr.s	v0, v0, t0		
	addr.s	v0, v0, v0									// L_shl(Acc0, 2)
	addr.s	v0, v0, v0
	addr.s	v0, v0, t4		
	sra		v0, v0, 16
	madda2.s m1, t2, v0		
	sh		v0, -2(t7)		;	addma.s m0h, m1l, m1h	// pVct[-1] = round(Acc0)		
	mfa		v1, m0h
	addr.s	v1, v1, t1
	addr.s	v1, v1, v1
	addr.s	v1, v1, v1									// L_shl(Acc1,2)
	addr.s	v1, v1, t4
	sra		v1, v1, 16
	sh		v1, -4(t7)									//pVct[-2] = round(Acc1)
	
	/* scale output if postfilter is off. (Otherwise output
	is scaled by the gain scaling unit */
	.extern	UsePf
	lh		t4, UsePf
	nop
	bnez	t4, 1f
	nop
	addr2.s	v0, v0, v0	
	addr2.s v1, v1, v1	
1:	// Use Pf
	shp		v0, (a0)+2
	shp		v1, (a0)+2

	subu	t7, t7, 4									// pVct -= 4
lp0e:	

	ltp		t0, (t7)+8
	ltp		t2, (t7)+8
	lw		t4, (t7)
	stp		t0, (t8)+8	
	stp		t2, (t8)+8	
	sw		t4, (t8)

	////////////////////////////
	mtru	t9, mmd	
	jr		ra
    nop
	.end 	Synts

#endif

	.text
	.set	noat
	.set	noreorder
	.globl	Synts2
	.ent	Synts2
Synts2:	
	subu	sp, sp, 64
	mfru	t9, mmd	
	sw		ra, 28(sp)
	sw		s0, 32(sp)
	sw		s1, 36(sp)
	sw		s2, 40(sp)	;	move s0, a0
	sw		s3, 44(sp)	;	move s1, a1
	//mfru	at, mmd
	sw		t9, 48(sp)//mmd
	////////////////////////////		// (~33)
	//.extern pDecStat
	//lw		t8, pDecStat
	.extern pDecodMem
	lw		t8, pDecodMem		//t8->pDecodMem->DecStat
	la		t7, g7231_TmpVct
	addiu	t7, t7, SubFrLen*2		// t7 = pVct = &g7231_TmpVct[SubFrLen]
	addiu	t8, t8, 32				// t8 = &(DecStat.SyntIirDl[0])
	ltp		t0, (t8)+8
	ltp		t2, (t8)+8
	lwp		t4, (t8)+4
	stp		t0, (t7)+8
	stp		t2, (t7)+8
	swp		t4, (t7)+4
	li		t0, 0x6
	mtru	t0, mmd					// fractional and 32 bit sature	
	sub		s2, t7, 20				// s2 = pVct
	sub		s3, t8, 20				// s3 = &(DecStat.SyntIirDl[0])
	
	/* do for all elements in the subframe */
													// m0 = a(0)V(0)+a(1)V(1)+a(2)V(2)+a(3)V(3)
	la		t4, 1f								// a(4)V(4)+a(5)v(5)+a(6)V(6)+a(7)V(7)+a(8)V(8)+a(9)V(9)
	la		t5, 2f-4
	li		t6, SubFrLen/2-1						// m1 = a(0)z   +a(1)V(0)+a(2)V(1)+a(3)V(2)
	mtru	t4, lps0								// a(4)V(3)+a(5)V(4)+a(6)V(5)+a(7)V(6)+a(8)V(7)+a(9)V(8)
	mtru	t5, lpe0
	mtru	t6, lpc0
	.align	3
1:								// (~ 30*44=1320)
	lh		t0, 0(s0)				// Dpnt[0]
	lh		t1, 2(s0)				// Dpnt[1]
	sll		t0, t0, 16		;	sll		t1, t1, 16
	sra		t0, t0, 3		;	sra		t1, t1, 3
	sw		t0, 20(sp)		;	addu	a0, sp, 20
	sw		t1, 24(sp)		;	addu	a1, sp, 24
	move	a2, s1			;	move	a3, s2
	jal		g7231_Iirs
	nop

	/* scale output if postfilter is off. (Otherwise output
	is scaled by the gain scaling unit */
	lh		v0, -2(s2)	//v0=pVct[-1]
	lh		v1, -4(s2)	//v1=pVct[-2]
	.extern	UsePf
	lh		t4, UsePf
	nop
	bnez	t4, 3f
	nop
	addr2.s	v0, v0, v0	
	addr2.s v1, v1, v1		
3:	// Use Pf
	shp		v0, (s0)+2
	shp		v1, (s0)+2

	subu	s2, s2, 4		//pVct -= 2							// pVct -= 4
2:	

	ltp		t0, (s2)+8
	ltp		t2, (s2)+8
	lw		t4, (s2)
	stp		t0, (s3)+8	
	stp		t2, (s3)+8	
	sw		t4, (s3)

	////////////////////////////	
	//nop
	//mtru	at, mmd	
	//nop
	lw		t9, 48(sp)
	lw		ra, 28(sp)	
	lw		s0, 32(sp)
	lw		s1, 36(sp)
	lw		s2, 40(sp)
	lw		s3, 44(sp)
	mtru	t9, mmd	
	jr		ra
	addu	sp, sp, 64
	.end	Synts2

	
/********************************************
Word32 Spf(Word16 *Tv, Word16 *Lpc)
	Tv: align 4
	Lpc: align 4
	s0:Tv
	s1:Lpc
	s2:Exp,Sen
	s3:mmd
	s4:Acc1,Tmp
	s5:pX
	s6:pY
	32(sp):Acc0 in Firs() and g7231_Iirs()
	36(sp):Acc1
Instruction: 2360 clks
*/

	.text
	.set	noat
	.set	noreorder
	.globl	Spfs
	.ent	Spfs
Spfs:
	subu	sp, sp, 64
	sw		s0, 20(sp)		// s0=Tv
	sw		s1, 24(sp)		// s1=Lpc
	sw		s2, 28(sp)		// s2=Exp,Sen
	sw		s3, 40(sp)		// s3=mmd
	sw		s4, 44(sp)		// s4=Acc1,Tmp	
	sw		s5, 48(sp)	;	move	s0, a0//s5=pX
	sw		s6, 52(sp)	;	move	s1, a1//s6=pY
	sw		ra,	56(sp)	;	mfru	s3, mmd
			
	/* Compute ARMA coeff. (20+12*5=80) */
	la		a2, FirCoef
	la		a3, IirCoef
	.extern PostFiltZeroTable
	.extern	PostFiltPoleTable	
	la		t0, PostFiltZeroTable
	la		t1, PostFiltPoleTable		
	la		t2, lp0_s
	la		t3, lp0_e-4
	mtru	t2, lps0
	mtru	t3, lpe0
	li		t4, LpcOrder/2-1		
	mtru	t4, lpc0
	lwp		t2, (a1)+4
	lwp		t3, (t0)+4
	lwp		t4, (t1)+4		
	ori		t9, zero, 0x00004000
	.align	3	
lp0_s:									
	multa2	m0, t2, t3	;	lwp		t3, (t0)+4		// load zero[]
	multa2	m1, t2, t4	;	lwp		t4, (t1)+4		// load pole[]
	lwp		t2, (a1)+4	;	nop						// load lpc[]
	mfa		t5, m0h		;	nop
	mfa		t6, m0l		;	addr.s	t5, t5, t9	
	mfa		t7, m1h		;	addr.s	t6, t6, t9
	mfa		t8, m1l		;	addr.s	t7, t7, t9		
	addr.s	t8, t8, t9	;	sra		t5, t5, 15
	sra		t6, t6, 15	;	shp		t5, (a2)+2
	sra		t7, t7, 15	;	shp		t6, (a2)+2	
	sra		t8, t8, 15	; 	shp		t7, (a3)+2	
	shp		t8, (a3)+2	;	nop
lp0_e:

	/* Normalize the speech vector.(~200) */
	ori		a0, s0, 0
	la		a1, g7231_TmpVct		
	li		a2, SubFrLen
	jal		Vec_Norms
	nop	
	ori		s2, v0, 0		// s2 = Exp
	
	/* Compute the first 2 autocorrelation 	(~ 14+15*5+3=92)
	   coeff R[0] and R[1]  */		
	ori		t5, zero, 0x6	// frac mpy and 32 sature
	mtru	t5, mmd		
	la		t4, lp1_s
	la		t5, lp1_e-4			
	li		t6, SubFrLen/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0		;	ori		t2, zero, 0	// t2:[z 3]
	la		a2, g7231_TmpVct			// a2 = g7231_TmpVct
	multa2	m0, zero, zero	;	lwp		t0, (a2)+4	// t0:g7231_TmpVct[4 5]
	multa2	m1, zero, zero	;	lwp		t1, (a2)+4	// t1:g7231_TmpVct[6 7]	
	.align 	3
lp1_s:
	madda2.s m1, t0, t0		;	mux2.lh	t3, t2, t0	// t3:g7231_TmpVct[1 2]
	madda2.s m0, t0, t3		;	mux2.lh	t4, t0, t1
	madda2.s m1, t1, t1		;	lwp		t0, (a2)+4
	madda2.s m0, t1, t4		;	mux2.hl	t2, zero, t1
	lwp		t1, (a2)+4		;	nop
lp1_e:
	addma.s	m0l, m0l, m0h	;	addma.s m1l, m1l, m1h
	mfa		v1, m1l
	mfa		v0, m0l

	/* scale the energy for the later use (~ 6)*/
	sll		s2, s2, 1	
	add		s2, s2, 4
	bltz	s2, 1f
	nop
	sra		s2, v1, s2		// Sen = L_shr(Acc1, fac)		
	j		2f
	nop
1:		
	sub		t4, zero, s2
	sll		s2, v1, t4		// Sen = L_shl(Acc1, -fac)
2:
	/* compute the first order partial correlation coeff of (75+8=83)
	   the input speech vector. */		
	sra		a1, v1, 16		// a1=Tmp
	li		t9, 0			// t9=Tmp=0
	beqz	a1, 3f
	nop
		/* compute first parkor */
	sra		v0, v0, 1	
	ori		s4, v0, 0		// s4=Acc1
	absr.s	a0, v0	
	jal		div_l
	nop	
    ori     t9, v0, 0
	bgez	s4, 3f
	nop	
	sub		t9, zero, v0	// t9=Tmp
3:		
	/* compute the compensation filter parameter and update (~20)
	   the memory */
	//lw		t0, (pDecStat)
	//nop
	.extern pDecodMem
	lw		t0, pDecodMem	//t0->pDecodmem->DecStat
	ori		t5, zero, 0x00002000
	lh		t4, 8(t0)		//t4=DecStat.Park	
	multa2	m0l, t5, t9		// L_mult(Tmp, 0x2000)
	multa2	m1l, t4, t5		// L_mult(Park, 0x2000)
	subma.s	m0l, m0l, m1l	
	mfa		t5, m0l
	sll		t4, t4, 16
	addr.s	t5, t5, t4		// Acc0 = Park+(Tmp*0x2000)-(Park*0x2000)
	ori		t6, zero, 0x00008000
	addr.s	t5, t5, t6
	sra		t5, t5, 16
	sh		t5, 8(t0)		//Park = round(Acc0)
	//li		t4, PreCoef
	ori		t4, zero, PreCoef
	multa2	m0l, t5, t4
	mfa		t6, m0l
	sra		t9, t6, 16
	andi	s4, t9, 0xfffc	// s4 = Tmp &= 0xfffc
	
	/* copy past memory to buffer */		//(~23)
	//lw		t0, pDecStat
	//nop
	.extern pDecodMem
	lw		t0, pDecodMem	//t0=pDecodMem->DecStat
	la		t3, PastX
	addiu	s5, t3, SubFrLen*2		// s5 = pX
	addiu	t1, t0, 52				// t1 = pDecStat.PostFirDl
	addiu	t2, t0, 72				// t2 = pDecStat.PostIirDl	
	la		t4, PastY
	addiu	s6, t4, SubFrLen*2		// s6 = pY
	lwp		t6, (t1)+4
	lwp		t7, (t1)+4
	lwp		t8, (t2)+4
	lwp		t9, (t2)+4
	stp		t6, (s5)+8
	stp		t8, (s6)+8
	swp		t8, (s6)+4
	swp		t9, (s6)+4
	lwp		t6, (t1)+4
	lwp		t7, (t1)+4
	lwp		t8, (t2)+4
	lwp		t9, (t2)+4
	stp		t6, (s5)+8
	stp		t8, (s6)+8
	lw		t6, 0(t1)
	lw		t8, 0(t2)
	sw		t6, 0(s5)
	sw		t8, 0(s6)	
	subu	s5, s5, 16	//s5=pX
	subu	s6, s6, 16	//s6=pY
	
	/* Do for all elements in the subframe  */		// (14+30*60=1814)
	la		t0, lp2_s
	la		t1, lp2_e-4
	li		t2, SubFrLen/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align 	3
lp2_s:
	lh		t0, 0(s0)//t0=Tv[i]	
	lh		t1, 2(s0)//t1=Tv[i+1]	
	la		t4, FirCoef
	sll		t2, t0, 16	;	sll	t3, t1, 16
	sra		t2, t2, 2	;	sra	t3, t3, 2
	/* Formant postfilter */
	sw		t2, 32(sp)	;	addu	a0, sp, 32
	sw		t3, 36(sp)	;	addu	a1, sp, 36
	sh		t0, -2(s5)	;	move	a2, t4
	sh		t1, -4(s5)	;	move	a3, s5
	jal		Firs
	nop
	la		t5, IirCoef
	move	a2, t5		;	move	a3, s6
	jal		g7231_Iirs
	nop
	lw		v0, 32(sp)//load Acc0
	lw		v1, 36(sp)//load Acc1
	addr.s	t7, v0, v0	;	addr.s	t8, v1, v1//Lshl(Acc0,2)
	addr.s	t7, t7, t7	;	addr.s	t8, t8, t8//Lshl(Acc1,2)
	
	/* compensation filter */
	lh		t5, 0(s6)	;	li		t4, 0x00008000
	lh		t6, -2(s6)	;	nop
	multa2	m0l, t5, s4	;	nop
	multa2	m1l, t6, s4	;	nop
	mfa		v0, m0l
	mfa		v1, m1l
	addr.s	v0, v0, t7	;	addr.s	v1, v1, t8	
	addr.s	v0, v0, t4	;	addr.s	v1, v1, t4	
	sra		v0, v0, 16	;	sra		v1, v1, 16	
	shp		v0, (s0)+2		// Tv[i] = round(L_tmp)
	shp		v1, (s0)+2			// Tv[i+1] = round(L_tmp2), point to next Tv[]	
	subu	s5, s5, 4		;	subu	s6, s6, 4			
lp2_e:

	/* write back past memory */		// (~28)
	//lw		t4, pDecStat
	//nop
	.extern pDecodMem
	lw		t4, pDecodMem		//t4->pDecodMem.DecStat
	nop
	addiu	t4, t4, 52				// t4 -> pDecStat.PostFirDl[0]
	addiu	t5, t4, 20				// t5 -> pDecStat.PostIirDl[0]
	lwp		t0, (s5)+4
	lwp		t1, (s5)+4
	lwp		t2, (s6)+4
	lwp		t3, (s6)+4
	swp		t0, (t4)+4
	swp		t1, (t4)+4
	swp		t2, (t5)+4
	swp		t3, (t5)+4
	lwp		t0, (s5)+4
	lwp		t1, (s5)+4
	lwp		t2, (s6)+4
	lwp		t3, (s6)+4
	swp		t0, (t4)+4
	swp		t1, (t4)+4
	swp		t2, (t5)+4
	swp		t3, (t5)+4
	lw		t0, (s5)
	lw		t2, (s6)
	sw		t0, (t4)
	sw		t2, (t5)
	
	ori		v0, s2, 0				// return Sen

	mtru	s3, mmd
	lw		ra, 56(sp)
	lw		s6, 52(sp)
	lw		s5, 48(sp)
	lw		s4, 44(sp)
	lw		s3, 40(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	jr		ra
	addiu	sp, sp, 64

	.end Spfs



