#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define  LspQntBands       3
#define  LspCbSize         256
#define  LspCbBits         8
#define  LpcOrder		   10
#define	 CosineTableSize   512

/*
Word32 EvalPoly(Word16 *pq, Word16 *CosTab, Word16 tabind, Word16 flag)
	NOTE.
	1.assume fractional mpy
*/
	.text
	.set	noat
	.set	noreorder
	.globl	EvalPolys
	.ent	EvalPolys
EvalPolys:
	
	add		v0, a3, LpcOrder	//v0=ind1
	li		v1, 0				//v1=ind2
	multa2	m0,zero,zero
	sll		v0, v0, 1	
	add		a0, a0, v0	;lh		t3, 0(a1) //a0->Spq[ind1]	
	la		t4, 1f
	la		t5, 2f-4
	li		t6, 3-1		;lhp	t2, (a0)-4
	mtru	t4, lps0	;sll	t0, a2, 1	//tabind*2
	mtru	t5, lpe0	;addu	t7, a1, t0
	mtru	t6, lpc0	;add	v1, v1, a2
	lhp		t4, (a0)-4	
	lh		t5, 0(t7)
	.align	3
1:
	madda2.s m0l, t2, t3;li		t8, CosineTableSize-1
	madda2.s m0l, t4, t5;lhp	t2, (a0)-4
	lhp		t4, (a0)-4	;addu	t0, v1, s6		
	and		v1, t0, t8	;addu	t1, t0, s6
	and		t1, t1, t8	;sll	t0, v1, 1
	sll		t6, t1, 1	;addu	t7, a1, t0
	lh		t3, 0(t7)	;addu	t8, a1, t6
	lh		t5, 0(t8)	;move	v1, t1 
2:	
	mfa		v0, m0l
	jr		ra
	nop

	.end	EvalPolys

/*
void AtoLsp( Word16 *LspVect, Word16 *Lpc, Word16 *PrevLsp )
	s0->LspVect	(align 4)
	a1->Lpc		(align 4)
	s2->PrevLsp	(align 8)
local:	
	LspCnt->s1
	PrevVal->s3
	Lpq[]->PastX[0:47]->s4
	Spq[]->PastX[48:71]
	CosineTable->s5
	k->t9
	i->s6
*/
	.text
	.set	noat
	.set	noreorder
	.globl	AtoLsps
	.ent	AtoLsps
AtoLsps:
	mfru	t4, mmd
	subu	sp,sp,64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	
	sw		s4, 36(sp)	
	sw		s5, 40(sp)	
	sw		s6, 44(sp)	;move	s0, a0
	sw		t4, 48(sp)	;move	s2, a2
	sw		ra, 52(sp)	
	/////////////////////
	/* Perform a bandwidth expansion on the LPC coeffs. */
	la		a3, BandExpTable
	lwp		t0, (a1)+4
	lwp		t5, (a3)+4		;li		t9, 0x6//fractional mpy
	la		t1, 1f
	la		t2, 2f-4
	li		t3, LpcOrder/2-1;mtru	t9, mmd
	mtru	t1, lps0
	mtru	t2, lpe0
	mtru	t3, lpc0
	.align	3
1:	
	multa2	m0, t0, t5	;lwp	t1, (a1)+4
	lwp		t6, (a3)+4	;li		t9, 0x00008000
	mfa		v0, m0h		;move	t0, t1
	mfa		v1, m0l		;move	t5, t6
	addr.s	v0, v0, t9	;addr.s	v1, v1, t9	
	mux2.hh	v0, v0, v1
	swp		v0, (a0)+4
2:	
	/* p_0 = q_0 = 1 */
	la		s4, PastX	//s4->Lpq[0]
	li		t4, 0x02000000
	sw		t4, 0(s4)
	sw		t4, 4(s4)
		
	/* This loop compute the coeffs of P(z) and Q(z) */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, LpcOrder/2-1
	mtru	t0, lps0
	mtru	t1, lpe0;move	a0, s4	//a0->Lpq[0]
	mtru	t2, lpc0;move	a1, s0	//a1->LspVect[0]	
	addu	a2, a1, (LpcOrder-1)*2	//a2->LspVect[9]
	addu	a3, s4, 8				//a3->Lpq[2]
	.align	3
1:
	ltp		t0, (a0)+8	//t0:Lpq[0]t1:Lpq[1]
	lhp		t2, (a1)+2	//t2:Lsp[0]
	
	lhp		t3, (a2)-2	//t3:Lsp[9]
	subr.s	t4, zero, t0//t4=Acc1=L_negate(Lpq[0])
	
	sll		t2, t2, 16	//t2=Acc0=L_deposit_h(Lsp[0])
	sll		t3, t3, 16	//t3=L_deposit_h(Lsp[9])
	
	sra		t2, t2, 4
	sra		t3, t3, 4
	
	subr.s	t4, t4, t2
	subr.s	t1, t1, t2
	
	subr.s	t4, t4, t3
	addr.s	t5, t1, t3
	
	stp		t4, (a3)+8	//store Lpq[2:3]
2:		
	/* Divide p_5 and q_5 by 2 for proper weighting */
	sra		t4, t4, 1	;sra		t5, t5, 1
	st		t4, -8(a3)
	
	/* Normalize the plynomial coeffs. and convert to short */
		/* Find the maximum */
	move	a0, s4	//a0->Lpq[0]
	ltp		t0, (a0)+8
	ltp		t2, (a0)+8
	la		t4, 1f
	la		t5, 2f-4
	li		t6, (LpcOrder+2)/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	li		t5, 0	//Acc1=0
	.align	3	
1:	
	absr.s	t0, t0		;absr.s		t1, t1
	absr.s	t2, t2		;absr.s		t3, t3
	max		v0, t0, t1	;max		v1, t2, t3
	ltp		t0, (a0)+8	;max		v0, v0, v1
	ltp		t2, (a0)+8	;max		t5, v0, t5
2:
	jal		norm_l	
	move	a0, t5
	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (LpcOrder+2)/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	move	a0, s4		//a0->Lpq[0]
	addu	a1, s4, 48	//a1->Spq[0]
	li		t9, 0x00008000
	.align	3
1:
	ltp		t4, (a0)+8
	ltp		t6, (a0)+8
	sllv	t4, t4, v0	;sllv	t5, t5, v0
	addr.s	t4, t4, t9	;addr.s	t5, t5, t9
	sllv	t6, t6, v0	;sllv	t7, t7, v0
	addr.s	t6, t6, t9	;addr.s	t7, t7, t9
	mux2.hh	t0, t4, t5	;mux2.hh t1, t6, t7
	stp		t0, (a1)+8
2:
	/* 
	 Initialize the search loop 
	*/
	li		t9, 0			//t9=k
	
	/* Evaluate the sum polynomial at freq zero */
	li		s3, 0			//s3=PrevVal	
	la		s5, CosineTable	//s5=CosineTable
	lw		t5, 0(s5)		//t5:[C0 C1]
	addu	a0, s4, 48		//a0->Spq[0]
	lwp		t0, (a0)+4		//t0:[S0 S1]
	lwp		t1, (a0)+4	
	multa2	m0h, t0, t5		;lwp	t2, (a0)+4
	madda2.s m0h, t1, t5	;lwp	t3, (a0)+4
	madda2.s m0h, t2, t5	;lwp	t4, (a0)+4
	madda2.s m0h, t3, t5	;lwp	t0, (a0)+4
	madda2.s m0h, t4, t5	
	madda2.s m0h, t0, t5	
	mfa		s3, m0h			//s3=PrevVal
	
	/* Search loop. */
	li		s1, 0	//s1=LspCnt
	li		s6, 1	//s6=i=1
3:	// for (i=1; i<CosineTableSize/2; i++)	
		/* Evaluate the selected polynomial */
	addu	a0, s4, 48	;move	a1, s5
	move	a2, s6		;move	a3, t9
	jal		EvalPolys
	nop

	/* Check for a sign change, indicate zero crossing point */	
	xor		t0, v0, s3	//v0=CurrVal
	bgez	t0, 4f
	nop
		/* Interpolate to find the bottom 7 bits of zero-crossing freq. */
	absr.s	a2, v0	;absr.s	a3, s3	//a2=Acc0
	addr.s	a2, a2, a3				//a3=Acc1
	jal		norm_l					
	move	a0, a2
	sll		a2, a2, v0;sll	a3, a3, v0
	
	sra		a0, a3, 8;sra	a1, a2, 16
	jal		div_l
	nop					//v0=LspVect[LspCnt]
		/* Add the upper part of zero-crossing freq, */
	sub		t0, s6, 1
	sll		t0, t0, 7	
	add		v0, v0, t0	//v0=LspVect[]+Exp	
	shp		v0, (s0)+2	//LspVect[LspCnt] += Exp
	addi	s1, s1, 1	//LspCnt++
		/* Check if all zeros have been found */
	sub		t0, s1, LpcOrder
	beqz	t0, 5f
	nop
	
	xor		t9, t9, 1	//k ^= 1
		
	addu	a0, s4, 48	;move	a1, s5
	move	a2, s6
	jal		EvalPolys	//v0=CurrVal
	move	a3, t9
	
4:	/* Update the previous value */
	move	s3, v0	
	
	// end i
	addu	s6, s6, 1	//i++
	sub		t0, s6, CosineTableSize/2
	bltz	t0, 3b
	nop

5:	/* Check if all 10 zeros were found */
	sub		t0, s1, LpcOrder
	beqz	t0, 6f
	nop
	la		t2, 1f
	la		t3, 2f-4
	li		t4, LpcOrder/2-1
	mtru	t2, lps0
	mtru	t3, lpe0
	mtru	t4, lpc0
1:
	lwp		t2, (s2)+4
	lwp		t3, (s2)+4
	swp		t2, (s0)+4
	swp		t3, (s0)+4
2:

6:	////////////////////
	lw		ra, 52(sp)
	lw		t4, 48(sp)	//mmd
	lw		s6, 44(sp)
	lw		s5, 40(sp)
	lw		s4, 36(sp)
	lw		s3, 32(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64

	.end	AtoLsps

/*
Word32   Lsp_Svq( Word16 *Tv, Word16 *Wvect )
	a0->Tv (should align 4)
	a1->Wvect (should align 4)	
local:
	Tmp[]->g7231_TmpVct[0:19]
	//Rez->g7231_TmpVct[20:23]
	Rez->s8
	Indx->g7231_TmpVct[24:27]
	LspQntPnt->g7231_TmpVct[28:31]
*/
	.text
	.set	noat
	.set	noreorder
	.globl	Lsp_Svqs
	.ent	Lsp_Svqs
Lsp_Svqs:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;move	s0, a0
	mfru	t4, mmd		;move	s1, a1		
	sw		t4, 36(sp)	//36(sp)->mmd
	sw		s4, 40(sp)
	sw		s5, 44(sp)
	sw		s6, 48(sp)
	sw		s7, 52(sp)	
	sw		at, 56(sp)
	sw		s8, 60(sp)
	///////////////////
	/* Initialize the return value */
	la		s2, g7231_TmpVct	//s2->g7231_TmpVct
	//sw		zero, 20(s2)//Rez=0
	li		s8, 0	//s8->Rez
	
	/* Quantize each bans separately */
	li		t9, 0		//t9->k
	la		a3, BandInfoTable//a3->&BandInfoTable[0][0]
	la		s3, BandQntTable	//s3->&BandQntTable	
	li		t4, 0x6
	mtru	t4, mmd
3:	//for (k=0; k<LspQntBands; k++) {
	
	/*Search over the entire VQ table to 
	  find the index minimizes the error */
	
	/* Initialize the search */
	lhp		t4, (a3)+4	//t4=BandInfoTable[0][0]
	li		v1, -1		//Acc1=-1	
	lwp		a0, (s3)+4	//a0->LspQntPnt
	li		t8, 0		//t8=Indx=0	
	sll		t4, t4, 1
	addu	a1, s1, t4	//a1->pWvect
	addu	a2, s0, t4	//a2->pTv
	sub		t4, t9, 2
	bgez	t4, 9f
	nop	
	// if (k < 2 )
	lhp		t0, (a2)+2	//pTv[0]
	lhp		t1, (a2)+2	//pTv[1]
	lhp		t2, (a2)+2	//pTv[2]
	lhp		t4, (a1)+2	//pWvect[0]
	mux2.ll	s6, t0, t1	//s6:[t0 t1]	
	lhp		t5, (a1)+2	//pWvect[1]
	mux2.ll	s7, t2, t2	//s7:[t2 t2]
	lhp		t6, (a1)+2	//pWvect[2]		
	la		t0, 1f
	la		t1, 2f-4
	li		t2, LspCbSize/2-1
	mtru	t0, lps0
	li		at, 1
	sllv2	s6, s6, at	//s6:[t0*2 t1*2]	
	mtru	t1, lpe0	
	sllv2	s7, s7, at	//s7:[t2*2 t2*2]
	mtru	t2, lpc0	
	lwp		t0, (a0)+4	//t0:[L0 L1]
	li		at, 0		//at=i
	lwp		t1, (a0)+4	//t1:[L2 L3]
	lwp		t2, (a0)+4	//t2:[L4 L5]
	mux2.ll	s4, t4, t5	//s4:[w0 w1]
	mux2.ll	s5, t6, t6	//s5:[w2 w2]
	.align	3
1:
	multa2	m0, s4, t0	;mux2.lh	t7, t1, t2
	multa2	m1, s4, t7	;mux2.hl	t6, t1, t2
	multa2	m2, s5, t6	;subr2.s	t4, s6, t0//t4=Tv[0:1]-L[0:1]
	mfa		t0, m0h		;subr2.s	t5, s6, t7//t5=Tv[0:1]-L[3:4] 
	mfa		t1, m0l		;subr2.s	t6, s7, t6//t6=Tv[2:2]-L[2,5]
	mfa		t2, m2h		;li			t7, 0x00008000
	addr.s	t0, t0, t7	;addr.s		t1, t1, t7
	addr.s	t2, t2, t7	;mux2.hh	t0, t0, t1//t0=Tmp[0:1]
	mfa		t3, m1h		;mux2.hl	t1, t2, zero//t1=Tmp[2 z]
	mfa		t2, m1l		;multa2		m0, t4, t0
	mfa		t4, m2l		;madda2.s 	m0h, t6, t1
	addr.s	t3, t3, t7	;addr.s		t2, t2, t7
	addr.s	t4, t4, t7	;mux2.hh	t3, t3, t2	
	mux2.hh	t4, t4, t4	;lwp		t0, (a0)+4
	multa2	m1, t5, t3	;lwp		t1, (a0)+4//t3=Tmp[0:1]
	madda2.s m1l, t6, t4;lwp		t2, (a0)+4//t4=Tmp[2:2] 
	addma.s m0l,m0l,m0h	;addma.s 	m1l,m1l,m1h
	mfa		t3, m0l
	mfa		t4, m1l
	/*compare previous maximum */
	sgt		t5, t4, t3	;addu		t6, at, 1//t6=i+1	
	move	v0, t3		;move		t7, at
	cmvnez	v0, t4, t5	;addu		at, at, 2
	cmvnez	t7, t6, t5	
	sgt		t5, v0, v1
	cmvnez	v1, v0, t5	//v1=Acc1
	cmvnez	t8, t7, t5	//t8=Indx
2:		
	j		4f
	nop
9:	// else (k >= 2)	
	lwp		s6, (a2)+4		//s6:[t0 t1]
	lwp		s7, (a2)+4		//s7:[t2 t3]
	lwp		s4, (a1)+4		//s4:[w0 w1]
	lwp		s5, (a1)+4		//s5:[w2 w3]
	la		t0, 1f
	la		t1, 2f-4
	li		t2, LspCbSize/2-1
	mtru	t0, lps0
	li		at, 1
	sllv2	s6, s6, at	//s6:[t0*2 t1*2]	
	mtru	t1, lpe0	
	sllv2	s7, s7, at	//s7:[t2*2 t2*2]
	mtru	t2, lpc0	
	lwp		t0, (a0)+4	//t0:[L0 L1]
	li		at, 0		//at=i
	lwp		t1, (a0)+4	//t1:[L2 L3]
	lwp		t2, (a0)+4	//t2:[L4 L5]
	lwp		t3, (a0)+4	//t3:[L6 L7]	
	.align	3
1:
	multa2	m0, s4, t0	;subr2.s	t4, s6, t0
	multa2	m1, s5, t1	;subr2.s	t5, s7, t1
	multa2	m2, s4, t2	;subr2.s	t6, s6, t2
	multa2	m3, s5, t3	;subr2.s	t7, s7, t3
	mfa		t0, m0h		;li			s0, 0x00008000	
	mfa		t1, m0l		;addr.s		t0, t0, s0
	mfa		t2, m1h		;addr.s		t1, t1, s0
	mfa		t3, m1l		;addr.s		t2, t2, s0
	mux2.hh	t0, t0, t1	;addr.s		t3, t3, s0
	mux2.hh	t1, t2, t3	;multa2		m0, t4, t0
	madda2.s m0, t5, t1	;mfa		t0, m2h		
	mfa		t1, m2l		;addr.s		t0, t0, s0
	mfa		t2, m3h		;addr.s		t1, t1, s0
	mfa		t3, m3l		;addr.s		t2, t2, s0
	mux2.hh	t0, t0, t1	;addr.s		t3, t3, s0
	mux2.hh	t1, t2, t3	;multa2		m2, t6, t0	
	madda2.s m2, t7, t1	;lwp		t0, (a0)+4
	addma.s	m0l, m0l,m0h;lwp		t1, (a0)+4
	addma.s	m2l,m2l,m2h	;lwp		t2, (a0)+4
	lwp		t3, (a0)+4	;nop
	mfa		t4, m0l
	mfa		t5, m2l
	/*compare previous maximum */
	sgt		t6, t5, t4	;addu		s1, at, 1//s1=i+1	
	move	v0, t4		;move		t7, at
	cmvnez	v0, t5, t6	;addu		at, at, 2
	cmvnez	t7, s1, t6	
	sgt		t6, v0, v1
	cmvnez	v1, v0, t6	//v1=Acc1
	cmvnez	t8, t7, t6	//t8=Indx
2:	
	
4:	/* pack the result with optimum index */	
	sll		s8, s8, LspCbBits
	addr.s	s8, s8, t8			
	
	// } end k
	addu	t9, t9, 1
	sge		t4, t9, LspQntBands
	beqz	t4, 3b
	nop
	
	move	v0, s8		//return Rez
	
	///////////////////
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)
	lw		t4, 36(sp)//mmd
	lw		s4, 40(sp)
	lw		s5, 44(sp)
	lw		s6, 48(sp)
	lw		s7, 52(sp)
	lw		at, 56(sp)
	lw		s8, 60(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64

	.end	Lsp_Svqs

	
