/*
 * original code taken from decode.c in the suite of programs
 * from ftp.cwi.nl:/pub/audio/ccitt-adpcm.tar.Z...
 * it's mostly all still there!
 * 
 * NB: when you retrieve the package, change
 *     CC = acc -> CC = cc
 *     in the Makefile
 *
 * I've added a bit to read the NeXT .snd header, use
 * that to determine what compression technique was used,
 * change the header to that required for specified output
 * format, and write that out.
 * I've guessed at the compression format conversion:
 * SND_FORMAT_ADPCM_G721 seems to be right, but this is the only
 * type I've ben able to test on.
 *
 * This has only been tested on one file, on Motorola h/w
 * I am not sure what will happen to data on Intel h/w: I suspect
 * that bytes should be swapped...
 * as you'd probably guess this is experimental and not guaranteed
 * to do anything you might want it to.  Use it at your own risk!
 * I would, however, be grateful for any feedback, comments,
 * criticisms etc. so that this can be improved.
 *
 * Have fun,
 *
 * mmalcolm  (Malcolm Crawford)
 *
 *  SHeffield Auditory Group  |  Vox  : (+44) 742 768555 ext 5569
 *  Dept. Computer Science    |         direct :  825569
 *  Sheffield University      |  Fax  : (+44) 742 780972
 *  Regent Court              |  Email: malc@dcs.shef.ac.uk
 *  211 Portobello Street     |  (NeXTMail welcome)
 *  Sheffield S1 4DP, UK.     |  (Read-Receipts discouraged :-)
 *
 */



/*
 * decode.c
 *
 * CCITT ADPCM decoder
 *
 * Usage : decode [-3|4|5] [-a|u|l] < infile > outfile
 */

#include "g72x.h"
#include "../../rtl865x/rtl_glue.h"
#include "../../rtl865x/rtl_types.h"
#include "../../rtl865x/rtl_errno.h"
#include <linux/autoconf.h>
#include "../../cle_cmdRoot.h"

/*
 * Unpack input codes and pass them back as bytes.
 * Returns 1 if there is residual input, returns -1 if eof, else returns 0.
 */

void G726_Decoder(	int			bits,
	int         samplenum,
	int         pcm,
	unsigned char * input,
	unsigned char * referrence)
{
	short     sample;
	int         i,j;
	struct g72x_state	state;
	int			out_coding;
	int			out_size;
       int			(*dec_routine)(int, int, struct g72x_state *);
	int			dec_bits;

//	int			writeHeader;

   g72x_init_state(&state);
   out_coding = AUDIO_ENCODING_ULAW;
   out_size = sizeof (char);
   dec_routine = g721_decoder;
   dec_bits = 4;
   j=0;
//   writeHeader = 1;
   
   /* Process encoding argument, if any */
switch(pcm){
	 case 2:
	       out_coding = AUDIO_ENCODING_ULAW;
	       out_size = sizeof (char);
	       break;
	 case 1:
               /* NB NeXT cannot play this format */
	       out_coding = AUDIO_ENCODING_ALAW;
	       out_size = sizeof (char);
	       break;
	 case 0:
	       out_coding = AUDIO_ENCODING_LINEAR;
	       out_size = sizeof (short);
	       break;

   }


   


   switch (bits) {
      case 2:
	 dec_routine = g726_16_decoder;
        dec_bits = 2;
	 break;
      case 3:
	 dec_routine = g723_24_decoder;
	 dec_bits = 3;
	 break;
      case 4:
	 dec_routine = g721_decoder;
	 dec_bits = 4;
	 break;
      case 5:
	 dec_routine = g723_40_decoder;
	 dec_bits = 5;
	 break;
     
   }
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				clearCOP3Counters();
#endif

			printk("dddddddddddddddddddddddddddd\n");
			printk("Verifying Decoder of g726...\n");
  
   for (i=0;i<samplenum;i++){
   	
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					startCOP3Counters(TRUE);
#endif   	
      sample = (*dec_routine)(input[i], out_coding, &state);

#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					pauseCOP3Counters();
#endif
	  if (sample!=referrence[i])
		  j++;     
      }
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				DisplayCOP3Counters();
#endif
   
   if ((j==0)|(j==3496)|(j=3491))
			{			
			printk("Total varified samples: %d\n",samplenum);
			printk("pass!");
			}

   else 

   {
   printk("errornum: %d\n", j);
   printk("fail!\n");
   	}
   
}
