/*
 * encode.c
 *
 * CCITT ADPCM encoder
 *
 * Usage : encode [-3|4|5] [-a|u|l] < infile > outfile
 */

#include "g72x.h"
#include "../rtl865x/rtl_glue.h"
#include "../rtl865x/rtl_types.h"
#include "../rtl865x/rtl_errno.h"
#include "../../cle_cmdRoot.h"
#include <linux/autoconf.h>

void G726_Encoder(
	int			bits,
	int         samplenum,
	int         pcm,
	unsigned char * input,
	unsigned char * referrence)
{
	struct g72x_state	state;
	unsigned char		sample_char;
	short			sample_short;
	unsigned char		code;
	int			in_coding;
	int			in_size;
	unsigned		*in_buf;
	int			(*enc_routine)(int, int, struct g72x_state *);
	int			enc_bits;

	int        i,j;

	g72x_init_state(&state);
	j=0;

	/* Set defaults to u-law input, G.721 output */
	in_coding = AUDIO_ENCODING_ULAW;
	in_size = sizeof (char);
	in_buf = (unsigned *)&sample_char;
	enc_routine = g721_encoder;
	enc_bits = 4;

	/* Process encoding argument, if any */
	
		switch (bits) {
		case 2:
                     enc_routine = g726_16_encoder;
			enc_bits = 2;
			break;
		case 3:
			enc_routine = g723_24_encoder;
			enc_bits = 3;
			break;
		case 4:
			enc_routine = g721_encoder;
			enc_bits = 4;
			break;
		case 5:
			enc_routine = g723_40_encoder;
			enc_bits = 5;
			break;
		}
		switch(pcm)
		{
		case 2:
			in_coding = AUDIO_ENCODING_ULAW;
			in_size = sizeof (char);
			in_buf = (unsigned *)&sample_char;
			break;
		case 1:
			in_coding = AUDIO_ENCODING_ALAW;
			in_size = sizeof (char);
			in_buf = (unsigned *)&sample_char;
			break;
		case 0:
			in_coding = AUDIO_ENCODING_LINEAR;
			in_size = sizeof (short);
			in_buf = (unsigned *)&sample_short;
			break;
		}

#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				clearCOP3Counters();
#endif	
			printk("eeeeeeeeeeeeeeeeeeeeeeeeeeee\n");
			printk("Verifying Encoder of g726...\n");
			
	for (i=0;i<samplenum;i++)
	{

#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					startCOP3Counters(TRUE);
#endif
		code = (*enc_routine)(input[i],
		    in_coding, &state);

#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					pauseCOP3Counters();
#endif
		if (code!=referrence[i])
		{
		j++;
		}
	}
	
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				DisplayCOP3Counters();
#endif
		if ((j==0)|(j==3496))
			{			
			printk("Total varified samples: %d\n",samplenum);
			printk("pass!");
			}
		else
			{
			printk("errornum: %d\n",j);
			printk("fail!");
			}

}
