#include "../basic_op/typedef.h"
#include "../basic_op/fixedpt_basic_op.h"
#include "../basic_op/cp3.h"
#include "../basic_op/cp_tools.h"
#include "g729_ld8a.h"
#include "g729_dtx.h"
#include "g729_octet.h"
#include "mystruct.h"


/* global variable */
#ifdef GNU
__attribute__ ((aligned (8)))	// for GNU
__attribute__ ((section (".bss.Coder0")))
#endif

static g729CodMem  Coder0;
g729CodMem	*p729Cod = &Coder0;

/*
#ifdef GHS_TOOLS
#pragma ghs section bss=".Decoder729"
#endif
*/
#ifdef GNU
__attribute__ ((aligned (8)))	// for GNU
__attribute__ ((section (".bss.Decoder0")))
#endif

static g729DecMem	Decoder0;
g729DecMem	*p729Dec = &Decoder0;

#ifdef GNU
__attribute__ ((aligned (8)))	// for GNU
__attribute__ ((section (".bss.Debugger0")))
#endif

static DebugInfo Debugger;
DebugInfo *p729DebugInfo = &Debugger;

/*
#ifdef GHS_TOOLS
#pragma ghs section bss=default
#endif
*/

#if DANWU
#ifdef VC6
void main(int argc, char *argv[])
#else
int main(void)
#endif
{
	Word16  i,ii=1, jj=1;
	Word32  count_frame;
	FILE   *f_syn, *f_serial;		// decoder
	FILE	*f_speech, *f_serial0;	// encoder
	int run_times=0, enc_error=0, dec_error=0;	

	// decoder used
//	Word16  parm[PRM_SIZE+2];             /* Synthesis parameters        */
	Word16	decout[L_FRAME];
	char	decin[L_FRAME/8+1];
	Flag	fBadFrame=0;			// 1 -> bad frame
	extern char tstseq2_dec[];		// decoder input pattern
	extern unsigned short tstseq2a_outb[];	// decoder output ref pattern(big-endian pcm table )
	extern unsigned short tstseq2[];		// encoder input pattern(big-endian pcm table)
	extern char tstseq2a_bit[];		//encoder out ref pattern
	short	*pDecOut;
	char 	*pDecTab;
	int	 EncInd;
	int	 EncOutInd;

	// encoder used
	int len;
	Word16 encin[L_FRAME];
	char encout[L_FRAME/8+1];
	Word16 vad_enable=0;
	
#ifndef VC6
	char *argv[]={"",
		      "g:\\ghs\\myprojects\\g729ab_4ch\\tstseq2.binb",			  
		      "g:\\ghs\\myprojects\\g729ab_4ch\\tstseq2a.enc",
		      "1",
		      "g:\\ghs\\myprojects\\g729ab_4ch\\tstseq2a.bit",
		      "g:\\ghs\\myprojects\\g729ab_4ch\\tstseq2a.decb"};
#endif	
	
#ifndef VC6
	// init mmd
	set_mmd(0x2);		// 32 bit saturation mode
#endif	

#ifdef VC6
	printf("VC6\n");
#endif

#ifdef GHS_TOOLS
	printf("GHS tools\n");
#endif

#ifdef GNU
	diag_printf("GNU tools\n");

	// get system status and turn off some interrupts
	{		
		unsigned int gimr,gpio;
		
		gimr = readreg(0xbd010000, sizeof(int));
		diag_printf("GIMR=0x%x\n", gimr);		
		//gimr = gimr & 0xfffffff6;				//off UART and timer intr(often-)
		//gimr = gimr & 0xfffffff7;				//off UART intr (often)
		//gimr = gimr & 0xfffffffe;				//off timer intr (often)		
		gimr = gimr & 0xffffff00;				//off timer nic uart (never)
		//gimr = gimr & 0xffffff08;				//off timer nic (never)
		writereg(0xbd010000, gimr, sizeof(int));
		gimr = readreg(0xbd010000, sizeof(int));
		diag_printf("GIMR=0x%x\n", gimr);		
		gpio = readreg(0xbd010040, sizeof(int));
		diag_printf("PABDIR=0x%x\n", gpio);		
		gpio = readreg(0xbd010044, sizeof(int));
		diag_printf("PABDATA=0x%x\n", gpio);	
		
	}
#endif



  vad_enable = (Word16)atoi(argv[3]);  
  
  if (vad_enable == 1)
    diag_printf(" VAD enabled\n");
  else
    diag_printf(" VAD disabled\n");


#ifndef OCTET_TX_MODE
  diag_printf("OCTET TRANSMISSION MODE is disabled\n");
#endif

	
	/*************************************
	 *
	 * 			CP3 profiling Start	
	 *
	 *************************************/
	/* cp3 setting */
	cp3_init();	
	cp3_set_counter_usage(0, CP3_COUNT_CYCLE);
	cp3_set_counter_usage(1, CP3_COUNT_NEW_INST_FETCH);
	cp3_set_counter_usage(2, CP3_COUNT_INST_CACHE_MISS);
	cp3_set_counter_usage(3, CP3_COUNT_LOAD_STORE_MISS);			
	cp3_set_dram_addr_8181((void*)0x8019f000, (void*)(0x8019f000 + 0x0ff0));		// 4k DRAM (vad on)
	//cp3_set_dram_addr_8181((void*)0x80195000, (void*)(0x80195000 + 0x0ff0));		// 4k DRAM (vad off)
	cp3_start();
	

start:	
	diag_printf("run time %d, enc_err %d, dec_err %d.\n", run_times++, enc_error, dec_error);
		
	// init decoder
	Init_G729ab_Decoder();
	
	// init encoder
	Init_G729ab_Encoder();
	
	
/*-----------------------------------------------------------------*
 *            Loop for each "L_FRAME" speech data                  *
 *-----------------------------------------------------------------*/

  pDecTab = tstseq2_dec;
  pDecOut = tstseq2a_outb;
  EncInd = 0;
  EncOutInd=0;
  count_frame = 0L;		// for debug
  while(1)
  {
	  
	  //ii = read_frame1(f_serial, decin, &fBadFrame);
	  ii = read_frame1(pDecTab, decin, &fBadFrame);
	  pDecTab += ii;
	  //jj = fread(encin, sizeof(Word16), L_FRAME, f_speech);
	  
	  for(i=0; i<L_FRAME; i++)
	  	encin[i] = tstseq2[EncInd++];
	  
/*	  	  
	  ii = ii != 0 ? 1 : 0;
	  jj = jj == L_FRAME ? 1 : 0;
		
	  if(!(ii && jj))	  
		exit(1);
*/
	

#ifdef VC6	  
	  //printf("Frame = %ld\r", count_frame++);		// for debug
	  count_frame++;
#else
	  //diag_printf("Frame = %ld\n", count_frame++);		// for debug
	  count_frame++;
#endif

		/*
		  Encoder phase
		*/

		len = G729ab_Encoder(encin, encout, vad_enable);
				
#if 1
		for(i=0; i<len; i++)
		{
			if(encout[i] != tstseq2a_bit[EncOutInd++])
			{
				diag_printf("Enc error in %d frame\n", count_frame);
				count_frame = 273;
				enc_error++;
				break;
			}			
		}
#endif

		/*
		  Decoder phase
		*/

		G729ab_Decoder(decin, decout, fBadFrame, count_frame);
		
#if 1
		for(i=0; i<80; i++)
			if(decout[i] != pDecOut[i])
			{				
				printf("Dec error in %d frame\n", count_frame);
				count_frame = 273;
				dec_error++;
				break;
			}
		pDecOut += 80;		
#endif
		if(count_frame == 273)
			goto start;
			//break;

  }

	/*************************************
	 *
	 * 			CP3 profiling Start	
	 *
	 *************************************/
	// cp3 stop
	cp3_stop();
	cp3_get_counters();
	MyWrite("\n\nCoprocessor 3 statitics:\n");
	cp3_show_counter(0, -1);
	cp3_show_counter(1, 0);
	cp3_show_counter(2, 1);
	cp3_show_counter(3, 1);

  return 0;
}
#endif

