/*
   ITU-T G.729A Speech Coder with Annex B    ANSI-C Source Code
   Version 1.3    Last modified: August 1997

   Copyright (c) 1996,
   AT&T, France Telecom, NTT, Universite de Sherbrooke, Lucent Technologies,
   Rockwell International
   All rights reserved.
*/

/*G729_coder.c*/
/*-------------------------------------------------------------------*
 * Main program of the ITU-T G.729A  8 kbit/s encoder.               *
 *                                                                   *
 *    Usage : coder speech_file  bitstream_file                      *
 *-------------------------------------------------------------------*/

#include "../basic_op/typedef.h"
#include "../basic_op/fixedpt_basic_op.h"
#include "g729_ld8a.h"
#include "g729_dtx.h"
#include "g729_octet.h"
#include "mystruct.h"

//extern Word16 *new_speech;     /* Pointer to new speech data            */
//extern Word16 noise_fg[MODE][MA_NP][M];
//Word16 frame=0;                  /* frame counter */
/*
void StoreGlobalVar(GlobalVar *ptr)
{	
	int i,j,k;

	ptr->new_speech = new_speech;
	for (i=0; i<MODE; i++)
		for (j=0; j<MA_NP; j++)
			for (k=0; k<M; k++)
				ptr->noise_fg[i][j][k] = noise_fg[i][j][k];
	ptr->frame = frame;
}

void LoadGlobalVar(GlobalVar *ptr)
{
	int i,j,k;

	new_speech = ptr->new_speech;
	for (i=0; i<MODE; i++)
		for (j=0; j<MA_NP; j++)
			for (k=0; k<M; k++)
				noise_fg[i][j][k] = ptr->noise_fg[i][j][k];
	frame = ptr->frame;
}
*/
void pack2bit(Word16 *serial, Word16 enc_bytes, char *pEncOutBuff)
{
	short i;
//	short bl;	//bitstream length

	switch(enc_bytes)
	{
	case 80:	// active	
		//g729_enc_out[0] ^= (serial[0] << 1) + serial[1];
		//pEncOutBuff[0] ^= (serial[0] << 1) + serial[1];
		pEncOutBuff[0] = 0x1;
		serial += 2;
		//bl = 80;
		for (i=0; i<enc_bytes; i++)
		   //g729_enc_out[1 + (i>>3)] ^= (*serial++ << ( 7 - (i & 0x0007)));
		   pEncOutBuff[1 + (i>>3)] ^= (*serial++ << ( 7 - (i & 0x0007)));
		break;
	case 0:	// not transmitted
		//bl = 2;
		//g729_enc_out[0] = 0x0;
		pEncOutBuff[0] = 0x00;
		//g729_enc_out[1] = 0x0;
		pEncOutBuff[1] = 0;
		break;
	case 16:	// sid
		//g729_enc_out[0] ^= (serial[0] << 1) + serial[1];
		//pEncOutBuff[0] ^= (serial[0] << 1) + serial[1];
		pEncOutBuff[0] = 0x2;
		serial += 2;		
		//bl = 16;
		for (i=0;i<enc_bytes;i++)
	  	   //g729_enc_out[1 + (i>>3)] ^= (*serial++ << ( 7 - (i & 0x0007)));				
		   pEncOutBuff[1 + (i>>3)] ^= (*serial++ << ( 7 - (i & 0x0007)));				
		break;
	}	
}	


/*--------------------------------------------------------------------------*
 * Initialization of the coder.                                             *
 *--------------------------------------------------------------------------*/
void Init_G729ab_Encoder(void)
{
	Init_Pre_Process();
	Init_Coder_ld8a();
	/* for G.729B */
	Init_Cod_cng();
	p729Cod->GloVar.frame = 0;
}

/* DMEM */
Word16 prm[PRM_SIZE+1];        /* Analysis parameters + frame type      */
Word16 serial[SERIAL_SIZE];    /* Output bitstream buffer               */

int G729ab_Encoder(Word16 *EncInBuf ,char *outbits, Word16 vad_enable)
{
	Word16 i;

	/* For G.729B */
	Word16 nb_words=0;

    if (p729Cod->GloVar.frame == 32767) 
		p729Cod->GloVar.frame = 256;
    else 
		p729Cod->GloVar.frame++;
  /*----------------------------------------------------------------------*
  *      Initialize pointers to speech vector.                            *
  *   |--------------------|-------------|-------------|------------|     *
  *     previous speech(120)      sf1(40)      sf2(40)      L_NEXT(40)    *
  *                                                                       *
  *   <----------------  Total speech vector(L_TOTAL 240)----------->     *
  *   <----------------  LPC analysis window (L_WINDOW)  ----------->     *
  *   |                   <-- present frame (L_FRAME) -->                 *
  * old_speech            |              <-- new speech (L_FRAME) -->     *
  * p_window              |              |                                *
  *                     speech           |                                *
  *                             new_speech                                *
  *-----------------------------------------------------------------------*/
	Copy(EncInBuf, p729Cod->GloVar.new_speech, L_FRAME);

#ifdef VC6
    Pre_Process(p729Cod->GloVar.new_speech, L_FRAME);
#else
	Pre_Processs(p729Cod->GloVar.new_speech, L_FRAME);
#endif
    Coder_ld8a(prm, p729Cod->GloVar.frame, vad_enable);
	/* serial is the standard output of ITU-T src code */
    prm2bits_ld8k( prm, serial);
	nb_words = serial[1];
	for (i=0; i<L_FRAME/8+1; i++)
		outbits[i] = 0;
	pack2bit(serial, nb_words, outbits);
	return nb_words/8+1;
}


