/*
   ITU-T G.729A Speech Coder    ANSI-C Source Code
   Version 1.1    Last modified: September 1996

   Copyright (c) 1996,
   AT&T, France Telecom, NTT, Universite de Sherbrooke, Lucent Technologies
   All rights reserved.
*/

/*-----------------------------------------------------------*
 *  Function  Decod_ACELP()                                  *
 *  ~~~~~~~~~~~~~~~~~~~~~~~                                  *
 *   Algebraic codebook decoder.                             *
 *----------------------------------------------------------*/

#include "../basic_op/typedef.h"
#include "../basic_op/fixedpt_basic_op.h"
#include "g729_ld8a.h"

void Decod_ACELP(
  Word16 sign, /* (i)     : signs of 4 pulses.                       */
  Word16 index,/* (i)     : Positions of the 4 pulses.               */
  Word16 cod[] /* (o) Q13 : algebraic (fixed) codebook excitation    */
)
{
	Word16 i, j;
	Word16 pos[4];
	/* Decode the positions index: 0,1,...39*/
	i      = index & (Word16)7;
	pos[0] = i + ( i << 2 );

	index  = shr(index, 3);  
	i      = index & (Word16)7;
	i      = i + ( i << 2 );
	pos[1] = i + 1;

	index  = shr(index, 3);
	i      = index & (Word16)7;
	i      = i + ( i << 2 );
	pos[2] = i + 2;

	index  = shr(index, 3);
	j      = index & (Word16)1;
	index  = shr(index, 1);
	i      = index & (Word16)7;
	i      = i + ( i << 2 );
	i      = i + 3;
	pos[3] = i + j;
	
	for ( i = 0 ; i < L_SUBFR ; i++) {//L_SUBFR = 40
		cod[i] = 0;
	}
	/* decode the signs  and build the codeword */
	for ( j = 0 ; j < 4 ; ++j )
	{
		i = sign & (Word16)1;
		sign = shr(sign, 1);
		if (i != 0) {
			cod[pos[j]] =  8191;     /* Q13 +1.0 */
		}
		else {
			cod[pos[j]] = -8192;     /* Q13 -1.0 */
		}
	}
	return;
}

