#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

/*
Word32 Pow2(Word16 exponent, Word16 fraction)
	a0->exponent
	a1->fraction
*/
	.text
    //.section ".text.Pow2"
	.set	noreorder
	.globl	Pow2
	.ent	Pow2
Pow2:	
	sll		t0, a1, 6	
	sra		t1, t0, 16		;sra	t2, t0, 1//t1=i t2=L_x
	and		t3, t2, 0x7fff	;sll	t1, t1, 1//t3=a
	.extern tabpow
	la		t9, tabpow
	addu	t9, t9, t1//t9->tabpow[i]
	lh		t4, 0(t9)	//t4=tabpow[i]	
	lh		t5, 2(t9)	//t5=tabpow[i+1]	
	sll		t6, t4, 16	//t6=L_x
	sub		t7, t4, t5	//t7=tmp
	multa2	m0l, t3, t7	
	addma.s	m0l,m0l,m0l	;li		t0, 30
	mfa		v0, m0l		;sub	t0, t0, a0//t0=exp
	subr.s	t6, t6, v0	//t6=L_x
	//L_shr_r_plus
	li		t4, 1
	max		t0, t0, t4	//var2=max(var2, 1)
	sub		v1, t0, 1
	sll		t4, t4, v1	//t4=1<<(var2-1)
	addr.s	v0, t6, t4
	jr		ra	
	sra		v0, v0, t0		
	.set	reorder
	.end	Pow2

/*
void Log2(Word32 L_x, Word16 *exponent, Word16 *fraction)
	a0->L_x
	a1->*exponent
	a2->*fraction
*/
	.text
    //.section ".text.Log2"
	.set	noreorder
	.globl	Log2
	.ent	Log2
Log2:
	subu	sp, sp, 64
	sw		ra, 20(sp)
	sw		s0, 24(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)
	move	s0, a0		;move	s1, a1
	move	s2, a2
	////////////////
	bgtz	a0, 3f
	nop
	sh		zero, 0(a1)	
	j		7f
	sh		zero, 0(a2)	
3:	
	//jal		norm_l
	//nop
	cls		v0, a0
	cmveqz	v0, zero, a0
	.extern tablog
	la		t9, tablog
	sll		s0, s0, v0	;li		t4, 30//s0=L_x
	sub		t4, t4, v0	;sra	s0, s0, 9//t4=*exponent
	sh		t4, 0(s1)	;sra	t0, s0, 16//t0=i
	sra		s0, s0, 1	;sub	t0, t0, 32//t0=i
	and		t1,s0,0x7fff;sll	t0, t0, 1//t1=a
	addu	t9, t9, t0	//t9->tablog[i]
	lh		t4, 0(t9)
	lh		t5, 2(t9)
	sll		t6, t4, 16//t6=L_y
	sub		t3, t4, t5//t3=tmp
	multa2	m0l,t3, t1
	addma.s m0l,m0l,m0l
	mfa		v0, m0l
	subr.s	t6, t6, v0
	sra		t6, t6, 16
	sh		t6, 0(s2)	
	
7:	////////////////
	lw		ra, 20(sp)
	lw		s0, 24(sp)
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	jr		ra
	addu	sp, sp, 64

	.set	reorder
	.end	Log2

/*
Word32 Inv_sqrt(Word32 L_x)
	a0->L_x
*/
	.text
    //.section ".text.Inv_sqrt"
	.set	noreorder
	.globl	Inv_sqrt
	.ent	Inv_sqrt
Inv_sqrt:
	subu	sp, sp, 64
	sw		s0, 24(sp)
	sw		ra, 20(sp)	
	//////////////////
	bgtz	a0, 3f
	move	s0, a0	//s0=L_x
	lui		v0, 0x3fff
	j		7f
	addiu	v0, 0xffff
3:
	//jal		norm_l
	//nop					//v0=exp
	cls		v0, a0
	cmveqz	v0, zero, a0
	
	sll		s0, s0, v0	;li	t4, 30//s0=L_x
	sub		v0, t4, v0	;nop//v0=exp
	and		t0, v0, 1	;sra	v1, s0, 1
	cmveqz	s0, v1, t0	;sra	v0, v0, 1
	add		v0, v0, 1	;sra	s0, s0, 9//v0=exp
	sra		t0, s0, 16	;nop//t0=i
	sra		s0, s0, 1	;sub	t0, t0, 16
	and		t4,s0,0x7fff;sll	t0, t0, 1//t4=a
	.extern tabsqr
	la		t9, tabsqr
	addu	t9, t9, t0	//t9+tabsqr[i]
	lh		t0, 0(t9)
	lh		t1, 2(t9)	
	sll		t3, t0, 16//t3=L_y
	sub		t2, t0, t1//t2=tmp
	multa2	m0l, t2, t4
	addma.s m0l,m0l,m0l
	mfa		v1, m0l
	subr.s	t0, t3, v1	//t0=L_y
	bltz	v0, 3f
	absr	a1, v0	
	j		7f
	sra		v0, t0, v0	//v0=L_y
3:	
	jal		L_shl
	move	a0, t0

7:	//////////////////
	lw		ra, 20(sp)
	lw		s0, 24(sp)
	jr		ra
	addu	sp, sp, 64

	.set	reorder
	.end	Inv_sqrt


