#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define	M		10
#define L_SUBFR	40
#define L_FRAME	80
#define PIT_MAX	143

/************
 Data section
*/
	.bss
	//.section ".bss.g729_TmpVct"
	.align	3
	.globl	g729_TmpVct	//Syn_filts() Residus() agcs()
g729_TmpVct:
	.space 	2*(7*L_SUBFR)
		
	//.section ".bss.ssig"
	//.section ".dram"
	.align	3	
	.globl	ssig
ssig:
	.space 2*(L_FRAME+PIT_MAX+1)
	.space 0x800
	

/******************************************************
void Iir(Word32 *Acc0, Word32 *Acc2, Word16 *pCoe, Word16 *pDat)
	note1. assume 32 bit sature and fractional mode
	note2. assume pCoe and pDat are align on 4 boundary
 Instr: 31 + (52/4)*icache_miss_pemalty(30)={31,421}
*/
	.text	
	//.section ".text.g729_Iirs"
	.set	noreorder
	.globl	g729_Iirs
	.ent	g729_Iirs
	.align	3
g729_Iirs:			
	// t0:[c8 c9]t1:[c2 c3]t2:[c4 c5]t3:[c6 c7]
	// t4:[d8 d9]t5:[d2 d3]t6:[d4 d5]t7:[d6 d7]
	// t8:[d7 d8]t9:[d5 d6]
	lwp		t0, (a2)+4
	lwp		t1, (a2)+4
	lwp		t2, (a2)+4	
	lwp		t4, (a3)+4
	lwp		t5, (a3)+4	;	multa2	m0,zero,zero
	lwp		t6, (a3)+4	;	multa2	m2,zero,zero
	madda2.s m0, t0, t4	;	mux2.lh	t8, zero, t4
	madda2.s m2, t0, t8	;	lwp		t3, (a2)+4
	madda2.s m0, t1, t5	;	mux2.lh	t9, t4, t5
	madda2.s m2, t1, t9	;	lwp		t7, (a3)+4	
	madda2.s m0, t2, t6	;	mux2.lh	t8, t5, t6
	madda2.s m2, t2, t8	;	lwp		t4, (a3)+4
	madda2.s m0, t3, t7	;	mux2.lh	t9, t6, t7
	madda2.s m2, t3, t9	;	lwp		t0, (a2)+4
	subu	a3, a3, 20	;	mux2.lh	t8, t7, t4
	madda2.s m0, t0, t4	;	subu	a2, a2, 20
	madda2.s m2, t0, t8	;	addma.s m0l, m0l, m0h
	addma.s  m2h, m2h,m2l;	lw		v0, 0(a0)
	nop					;	mfa		t0, m0l
	lw		v1, 0(a1)	;	subr.s	v0, v0, t0
	lh		t3, 0(a2)	;	li		t5, 0x00008000		//v0=*Acc0 //pCoe[0]
	sw		v0, 0(a0)	;	addr.s	t1, v0, v0
	mta2	v1, m3l		;	addr.s	t1, t1, t1			// L_shl(Acc0, 3)
	addr.s	t1, t1, t1	;	subma.s m2h,m3l,m2h
	addr.s	t1, t1, t5
	sra		t1, t1, 16
	sh		t1, -2(a3)	;	multa2	m2l, t3, t1	
	subma.s	m2h, m2h, m2l
	mfa		t2, m2h
	sw		t2, 0(a1)	/*;	sll		t3, t2, 2	*/
	addr.s	t3, t2, t2	//L_shl(Acc1, 3)
	addr.s	t3, t3, t3
	addr.s	t3, t3, t3
	addr.s	t3, t3, t5
	sra		t3, t3, 16
	sh		t3, -4(a3)
	jr		ra
	nop	
	.set	reorder
	.end	g729_Iirs


/*
void Syn_filt(
  Word16 a[],     // (i) Q12 : a[m] prediction coefficients   (m=10)  
  Word16 x[],     // (i)     : input signal                             
  Word16 y[],     // (o)     : output signal                            
  Word16 lg,      // (i)     : size of filtering(40 or 22)              
  Word16 mem[],   // (i/o)   : memory associated with this filtering.   
  Word16 update   // (i)     : 0=no update, 1=update of memory.         

	s0->a[]		//must align 4
	s1->x[]		//must align 4
	s2->y[]		//must align 4
	s3->lg
	s4->mem[]		//for GHS
	s5->update		//for GHS
local:
	g729_TmpVct[0]->tmp
	s->sp(52)
	s2->sp(56)
*/
	.text
	//.section ".text.Syn_filts"
	.set	noreorder	
	.globl	Syn_filts
	.ent	Syn_filts	
Syn_filts:
	lw		t0, 16(sp)		//for GNU, get mem[] from stack
	lw		t1, 20(sp)		//for GNU, get update from stack
	nop
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	.align	3
	sw		s3, 32(sp)	;move	s0, a0
	sw		s4, 36(sp)	;move	s1, a1
	sw		s5, 40(sp)	;move	s2, a2
	sw		ra, 44(sp)	;move	s3, a3
	mfru	t4, mmd		;move	s4, t0	//for GHS (mem[])
	sw		t4, 48(sp)	;li		t5, 0x6	//fractional mpy and 32 bits	 
	mtru	t5, mmd		;move	s5, t1	//for GHS (update)
	/////////////////////
	/* Copy mem to yy */
	.extern g729_TmpVct
	la		a0, g729_TmpVct	
	addu	t8, a0, 2*L_SUBFR	//t8=yy->tmp[L_SUBFR]
	addu	t9, s4, 2*(M-2)		//t9->mem[8]
	move	v0, t8				//v0=yy
	lwp		t2, (t9)-4		//t2:[m8 m9]
	lwp		t3, (t9)-4	;nop//t3:[m6 m7]
	lwp		t4, (t9)-4	;mux2.lh	t2, t2, t2
	lwp		t5, (t9)-4	;mux2.lh	t3, t3, t3
	lwp		t6, (t9)-4	;mux2.lh	t4, t4, t4
	stp		t2, (t8)+8	;mux2.lh	t5, t5, t5
	stp		t4, (t8)+8	;mux2.lh	t6, t6, t6
	swp		t6, (t8)+4

	/* Do the filtering */
	la		t0, 1f
	la		t1, 2f-4
	lwp		t4, (s1)+4	//t4=x[0 1]
	sra		t2, s3, 1
	sub		t2, t2, 1
	move	s3, v0		//s3->yy
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0		
	.align 	3
1:
	addu	a0, sp, 52	;li	t5, 0x10001000
	multa2	m0, t4, t5	;addu	a1, sp, 56			
	move	a2, s0		;mfa	t4, m0h	//s
	move	a3, s3		;mfa	t5, m0l	//s2
	sw		t4, 52(sp)	
	jal		g729_Iirs
	sw		t5, 56(sp)
	
	lw		t6, -4(s3)	//t4=yy[-2] yy[-1]
	lwp		t4, (s1)+4	;mux2.lh t6, t6, t6
	swp		t6, (s2)+4	;subu	s3, s3, 4	//yy -= 2	
2:
	/* Update of memory if update==1 */
	beqz	s5, 3f
	subu	s2, s2, 2*M		//s2->y[lg-M]
	lwp		t4, (s2)+4
	lwp		t5, (s2)+4
	lwp		t6, (s2)+4
	lwp		t7, (s2)+4
	lwp		t8, (s2)+4
	swp		t4, (s4)+4
	swp		t5, (s4)+4
	swp		t6, (s4)+4
	swp		t7, (s4)+4
	swp		t8, (s4)+4
3:
	////////////////////
	lw		t4, 48(sp)
	lw		ra, 44(sp)
	lw		s5, 40(sp)
	lw		s4, 36(sp)
	lw		s3, 32(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	addu	sp, sp, 64
	jr		ra
	mtru	t4, mmd

	.set	reorder
	.end	Syn_filts

/*
void Residu(Word16 a[], Word16 x[], Word16 y[], Word16 lg)
	a0->a[]		//align 4
	a1->x[]		//align 4
	a2->y[]		//align 2
	a3->lg
local:
	g729_TmpVct[0]->invx[0]		//align 8
	g729_TmpVct[64]->coef[0]		//align 8
*/
	.text
	//.section ".text.Residus"
	.set	noreorder
	.globl	Residus
	.ent	Residus
Residus:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)
	mfru	t4, mmd
	sw		t4, 36(sp)
	/////////////////
	li		t0, 0x6		//frac mpy and 32 bits
	mtru	t0, mmd
	/* copy a[] to coef[] */
	.extern g729_TmpVct
	la		s0, g729_TmpVct		//s0->invx[0]
	addu	t9, a0, 2*(M-2)	//t9->a[M-2]	
	addu	s1, s0, 2*(64)	//s1->coef[0]
	lwp		t2, (t9)-4	;nop
	lwp		t3, (t9)-4	;li			t7, 0x10000000
	lwp		t4, (t9)-4	;mux2.lh	t2, t2, t2
	lwp		t5, (t9)-4	;mux2.lh	t3, t3, t3
	lwp		t6, (t9)-4	;mux2.lh	t4, t4, t4
	st		t2, 0(s1)	;mux2.lh	t5, t5, t5
	st		t4, 8(s1)	;mux2.lh	t6, t6, t6	
	st		t6, 16(s1)	;nop	
	/* copy x mem */
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (L_SUBFR+M+2)/4-1
	mtru	t0, lps0	;subu	t8, a1, 2*M//t8->x[-M]
	mtru	t1, lpe0
	mtru	t2, lpc0	;move	t9, s0	//t9->invx[0]
1:
	lwp		t4, (t8)+4
	lwp		t5, (t8)+4
	swp		t4, (t9)+4
	swp		t5, (t9)+4
2:
	/* processing */
	la		t0, 1f
	la		t1, 2f-4
	li		s2, L_SUBFR/4
	mtru	t0, lps0
	mtru	t1, lpe0
	li		s3, (M+2)/4-1		//s3=2
	//s0->invx[0] s1->coef[0]
	.align	3
	//t0:[x4 x5]t1:[x6 x7]t2:[x4 x5]t3:[x6 x7]
	//t8:[x1 x2]t9:[x3 x4]t7:[x5 x6]
	//t4:[a4 a5]t5:[a6 a7]
3:	
	ltp		t2, (s0)+8	;multa2	m0,zero,zero
	ltp		t4, (s1)+8	;multa2	m1,zero,zero
	move	t0, t2		;multa2	m2,zero,zero
	mtru	s3, lpc0	;multa2	m3,zero,zero
1:	
	madda2.s m0, t4, t0	;move	t1, t3
	madda2.s m0, t5, t1	;ltp	t2, (s0)+8
	madda2.s m2, t4, t1	;mux2.lh t8, t0, t1
	madda2.s m2, t5, t2	;mux2.lh t9, t1, t2
	madda2.s m1, t4, t8	;mux2.lh t7, t2, t3
	madda2.s m1, t5, t9	;move	t0, t2
	madda2.s m3, t4, t9	;move	t6, t5
	madda2.s m3, t6, t7	;ltp	t4, (s1)+8
	li	t8, 0x00008000	;nop
2:	
	addma.s	m0l,m0l,m0h	;addma.s m1l,m1l,m1h
	addma.s	m2l,m2l,m2h	;addma.s m3l,m3l,m3h
	addma.s	m0l,m0l,m0l	;addma.s m1l,m1l,m1l
	addma.s	m2l,m2l,m2l	;addma.s m3l,m3l,m3l
	addma.s	m0l,m0l,m0l	;addma.s m1l,m1l,m1l
	addma.s	m2l,m2l,m2l	;addma.s m3l,m3l,m3l
	addma.s	m0l,m0l,m0l	;addma.s m1l,m1l,m1l
	addma.s	m2l,m2l,m2l	;addma.s m3l,m3l,m3l
	
	mfa		t0, m0l
	mfa		t1, m1l
	mfa		t2, m2l		;addr.s	t0, t0, t8
	mfa		t3, m3l		;addr.s	t1, t1, t8
	addr.s	t2, t2, t8	;addr.s	t3, t3, t8
	sra		t0, t0, 16	;nop
	shp		t0, (a2)+2	;sra	t1, t1, 16
	shp		t1, (a2)+2	;sra	t2, t2, 16
	shp		t2, (a2)+2	;sra	t3, t3, 16
	shp		t3, (a2)+2	;subu	s0, s0, (32-8)
	sub		s2, s2, 1
	bgtz	s2, 3b
	subu	s1, 32
	
	////////////////
	lw		t4, 36(sp)
	lw		s3, 32(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64

	.set	reorder
	.end	Residus



