#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define L_WINDOW	240
#define NP			12
#define NC			5
#define M			10

/* void Crossconv(Word16 *Tv, Word16 *Imr, Word32 *CrossEn, Word16 *Len)
	a0->Tv
	a1->Imr
	a2->CrossEn
	a3->Len 1.Len[0]: number of output
			2.Len[1]: inner loop length
NOTE.
	1.Len[0] must be multiple of 4 (process 4 output each time)
	2.Tv[] has to pad 4 "zero" in the tail	
	3.asume fractional mpy
*/
	.text
	//.section ".text.g729_crossconvs"
	.set	noreorder
	.globl	g729_crossconvs
	.ent	g729_crossconvs
g729_crossconvs:
	subu	sp, sp, 40	
	sw		s0, 20(sp)	//Tv offset stride
	sw		s1, 24(sp)	//Imr[0]
	sw		s2, 28(sp)
	sw		s3, 32(sp);	li	s0, 8	//offset pointer
	lw		a3, 0(a3)	//a3=Len[0:1]
	nop
	mux2.lh	t4, zero, a3	//t4=Len[0]
	mux2.hl	t5, zero, a3	//t5=Len[1]
	move	s2, t5	;	move	s1, a1//s2=inner loop length
	/////////////////////	
	sll		s2, s2, 1
	add		s2, s2, 8	//s2=Len[1]*2+8
	la		t0, 1f		
	la		t1, 2f-4
	mtru	t0, lps0;sra a3, t4, 2	//outer loop cnter (a3=Len[0]/4)
	mtru	t1, lpe0;sra s3, t5, 2	
	sub		s3, s3, 1				//inner loop cnter (s3=Len[1]/4-1)
	.align	3
3:	
	// set inner loop times
	mtru	s3, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a1)+8	;multa2	m1,zero,zero
	ltp		t4, (a0)+8	;multa2	m2,zero,zero
	lt		t6, 0(a0)	;multa2 m3,zero,zero
	move	t0,t2		;nop
1:	// inner loop start
	// Imr ->t0:[4 5]t1:[2 3]t2:[4 5]t3:[6 7]
	// Tv->	 t4:[4 5]t5:[6 7]t6:[8 9]t7:[10 11] 
	//		 t8:[5 6]t9:[3 4]
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (a1)+8
	madda2.s m2, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m2, t1, t6	;mux2.lh t9, t5, t6
	madda2.s m1, t0, t8	;ltp	t4, (a0)+8
	madda2.s m1, t1, t9	;mux2.lh t8, t6, t7
	madda2.s m3, t0, t9	;lt		t6, 0(a0)
	madda2.s m3, t1, t8	;move	t0, t2	
2:	// inner loop end
	addma.s m0l, m0l, m0h;addma.s m1l, m1l, m1h
	addma.s m2l, m2l, m2h;addma.s m3l, m3l, m3h
	mfa		t0, m0l
	mfa		t1, m1l
	mfa		t2, m2l
	mfa		t3, m3l
	// store 4 CrossEn[]
	// adjust Tv[] and Imr[] pointer	
	// dec inner loop cnter
	swp		t0, (a2)+4;subu	a0, a0, s2	//Tv=Tv-(Len[1]*2+8)
	swp		t1, (a2)+4;move	a1, s1
	swp		t2, (a2)+4;addu	a0, a0, s0	//Tv=Tv+offset(offset 4 samples)	
	swp		t3, (a2)+4;sub	s3, s3, 1
	addu	s0, s0, 8
	//dec outer loop cnter
	sub		a3, a3, 1
	bgtz	a3, 3b
	nop	
4:	
	////////////////////	
	lw		s0, 20(sp)
	lw		s1, 24(sp)
	lw		s2, 28(sp)
	lw		s3, 32(sp)	
	jr		ra
	addu	sp, sp, 40
	
	.set	reorder
	.end	g729_crossconvs

/*
void Autocorr(Word16 x[], Word16 r_h[], Word16 r_l[], Word16 *exp_R0)
	a0->x[] align 8
	a1->r_h[]
	a2->r_l[]
	a3->*exp_R0
local:
	g729_TmpVct[0]->y[0]
	g729_TmpVct[244]->Len[0]
	g729_TmpVct[246]->CrossEn[0]
*/
	.text
	//.section ".text.Autocorrs"
	.set	noreorder
	.globl	Autocorrs
	.ent	Autocorrs
Autocorrs:
	subu	sp, sp, 64
	sw		ra, 20(sp)	
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0
	sw		s3, 40(sp)	;move	s1, a1
	sw		s4, 44(sp)	;move	s2, a2	//s4=y[0]
	sw		s5, 48(sp)	;move	s3, a3	//s5=exp_R0
	////////////////
	.extern g729_TmpVct		  // align 8
	.extern hamwindow 	      // align 8
	/* Windowing of signal */
	la		s4, g729_TmpVct	  // s4->y[0]
	la		t9, hamwindow	  // t9 = hamwindow
	ltp		t4, (a0)+8
	ltp		t6, (t9)+8
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_WINDOW/4-1
	mtru	t0, lps0	
	mtru	t1, lpe0	;move	t8, s4	//t8=y[0]
	mtru	t2, lpc0	;li		t0, 0x00004000
	mta2	t0, m2l
	.align	3
1:
	multa2	m0, t4, t6	;nop
	multa2	m1, t5, t7	;addma.s m0h, m0h, m2l
	addma.s m0l,m0l,m2l	;ltp	t4, (a0)+8
	addma.s m1h,m1h,m2l	;ltp	t6, (t9)+8
	addma.s m1l,m1l,m2l	;mfa	t0, m0h
	sra		t0, t0, 15	;mfa	t1, m0l
	sra		t1, t1, 15	;mfa	t2, m1h
	sra		t2, t2, 15	;mfa	t3, m1l
	sra		t3, t3, 15	;mux2.ll t0, t0, t1
	mux2.ll	t1, t2, t3
	stp		t0, (t8)+8
2:
	li		t5, 0x6		//fractional mpy
	mfru	t4, mmd		
	sw		t4, 24(sp)
	mtru	t5, mmd	
	/* Compute r[0] and test for overflow */
	li		s5, 1		//s5= *exp_R0	
	la		t8, 1f
	la		t7, 2f-4
	li		t6, L_WINDOW/8-1
	la		a0, 5f
	la		a1, 6f-4
	li		a2, L_WINDOW/8-1
	.align	3
3:	
	ltp		t0, (s4)+8	;li		t9, 0	//t9=Overflow
	ltp		t2, (s4)+8
	mtru	t8, lps0
	mtru	t7, lpe0
	mtru	t6, lpc0	;multa2	m0,zero,zero
1:
	madda2.s m0, t0, t0	;ltp	t4, (s4)+8
	madda2.s m0, t1, t1	;ltp	v0, (s4)+8
	madda2.s m0, t2, t2	;move	t0, t4
	madda2.s m0, t3, t3	;move	t1, t5
	move	t2, v0		;move	t3, v1
2:
	addma.s m0l,m0l,m0h	;subu	s4, s4, 496
	mfa		v0, m0l		;li		t0, 1
	addr.s	v0, v0, t0	;li		t1, 0x7fffffff//v0=sum
	seq		t2, v0, t1
	cmvnez	t9, t0, t2
	/* If overflow divied y[] by 4 */
	beqz	t9, 4f
	nop		
	mtru	a0, lps0
	mtru	a1, lpe0
	mtru	a2, lpc0
	.align	3
5:
	ltp		t0, (s4)+8	;li		t4, 2
	ltp		t2, (s4)+8	;srav2	t0, t0, t4
	srav2	t1, t1, t4	;srav2	t2, t2, t4	
	st		t0, -16(s4)	;srav2	t3, t3, t4	
	st		t2, -8(s4)	;nop
6:	
	add		s5, s5, 4	//exp_R0+=4
	j		3b
	subu	s4, s4, 480
	// pad 4 zero
4:	
	move	t0, zero	;move	t1, zero
	st		t0, 480(s4)	
	
	/* calculate r[0] to r[NP] */	
	//jal		norm_l
	//move	a0, v0
	cls		a0, v0
	cmveqz	a0, zero, v0
	move	v0, a0
	
	sub		s5, s5, v0	;li		t0, 0x001000f0	//16, 240
	sw		t0, 488(s4)	;addu	a3, s4, 488
	move	a0, s4		;move	a1, s4
	move	s0, v0		//s0=norm
	jal		g729_crossconvs
	addu	a2, s4, 492
	
	addu	t9, s4, 492	//t9->CrossEn[0]
	lw		t4, 0(t9)
	li		t5, 1
	la		t0, 1f	
	la		t1, 2f-4
	addr.s	t4, t4, t5
	li		t2, NP
	swp		t4, (t9)+4
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	.align	3
1:
	sllv	a0, t4, s0	;move	a1, s1	
	lwp		t4, (t9)+4	;move	a2, s2
	jal		L_Extract	;addu	s1, s1, 2
	addu	s2, s2, 2
2:
	//store *exp_R0
	sh		s5, 0(s3)
	////////////////
	lw		ra, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	Autocorrs
	
/* 
Word16 Levinson(Word16 Rh[], Word16 Rl[], Word16 A[], Word16 rc[])
	a0->Rh[]	//align 4
	a1->Rl[]	//align 4
	a2->A[]		//align 4	
	a3->rc[]	//align 4
	
local:
	Ah->g729_TmpVct[0]
	Al->g729_TmpVct[12]
	Anh->g729_TmpVct[24]
	Anl->g729_TmpVct[36]
	alp_exp->g729_TmpVct[48]
	alp_h->g729_TmpVct[52]
	alp_l->g729_TmpVct[53]
	
	64(sp)->t2
*/
	.text
	//.section ".text.Levinsons"
	.set	noreorder
	.globl	Levinsons
	.ent	Levinsons
Levinsons:
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)	
	sw		s2, 36(sp)	;move	s0, a0//s0->Rh[]
	sw		s3, 40(sp)	;move	s1, a1//s1->Rl[]
	sw		s4, 44(sp)	;move	s2, a2//s2->A[]
	sw		s5, 48(sp)	;move	s3, a3//s3->rc[]
	sw		s6, 52(sp)	
	sw		s7, 56(sp)
	////////////////////
	//sw		t0, 60(sp)	//store Err to 60(sp)
	//li		t4, 0x6 //frac mpy and 32 bit sature
	//mfru	t5, mmd	
	//mtru	t4, mmd
	//sw		t5, 24(sp)
	/* K=A[1]=-R[1]/R[0] */
	lw		t0, 0(a0)	//t0=Rh[0:1]	
	lh		t1, 2(a1)	//t1=Rl[1]
	lh		a2, 0(a1)	;sll	t3, t0, 16//a2=Rl[0]	
	sll		t1, t1, 1
	addr.s	t1, t3, t1	//t1
	absr.s	t2, t1		//t2
	move	a0, t2
	jal		Div_32
	sra		a1, t0, 16
	move	t0, v0		;subr.s	t3, zero,t0
	sgt		t2, t1, zero
	cmvnez	t0, t3, t2	//t0
	//L_Extract(t0, &kh, &kl)
	sra		v0, t0, 16	;sra	v1, t0, 1//v0=Kh
	sll		a3, v0, 14+1
	subr.s	v1, v1, a3	//v1=Kl
	sh		v0, 0(s3)	//rc[0]=Kh
	sra		t0, t0, 4	//t0
	.extern g729_TmpVct
	la		s4, g729_TmpVct	//s4->g729_TmpVct
	move	a0, t0		;addu	a1, s4, 2//a1->Ah[1]
	move	t4, v0		;move	t5, v1
	jal		L_Extract
	addu	a2, s4, 24+2				//a2->Al[1]
	/* Alpha = R[0] * (1-K**2) */
	move	a0, t4		;move	a1, t5
	move	a2, t4		;move	a3, t5
	jal		Mpy_32
	nop
	absr.s	t0, v0	//t0
	li		t1, 0x7fffffff
	subr.s	t0, t1, t0
	sra		a2, t0, 16	;sra	a3, t0, 1//v0=hi
	lh		a0, 0(s0)	;sll	t5, a2, 14+1
	lh		a1, 0(s1)	;subr.s	a3, a3, t5//v1=lo
	jal		Mpy_32
	nop
	/* Normalize Alpha */	
	move	s6, v0		//s6=t0
	//jal		norm_l
	//move	a0, v0
	cls		a0, v0
	cmveqz	a0, zero, v0
	move	v0, a0
	
	sw		v0, (48*2)(s4)//alp_exp	
	sll		a0, s6, v0	//t0
	addu	a1, s4, 52*2
	jal		L_Extract
	addu	a2, s4, 53*2
			
	/*-----------------------
	 iterations i=2 to M 
	 *-----------------------*/
	li		s5, 2			//s5=i
7:	//for(i=2; i<=M; i++)		
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, s5, 2
	mtru	t0, lps0	;li		s6, 0	//s6=t0=0
	mtru	t1, lpe0	;sub	t3, s5, 1
	mtru	t2, lpc0	;sll	t9, t3, 1	//t9=k<<1
	addu	t4, s0, t9	;addu	t8, s4, 2	//t4=Rh[k] t8=Ah[1]
	addu	t5, s1, t9	;addu	t7, t8, 24	//t5=Rl[k] t7=Al[1]
1:
	lhp		a0, (t4)-2	
	lhp		a1, (t5)-2
	lhp		a2, (t8)+2	
	jal		Mpy_32
	lhp		a3, (t7)+2
	addr.s	s6, s6, v0
2:
	sll		s6, s6, 4	;sll	t0, s5, 1
	addu	t1, s0, t0	//t1=Rh[i]
	addu	t2, s1, t0	//t2=Rl[i]
	lh		t1, 0(t1)
	lh		t2, 0(t2)
	lh		a1, (52*2)(s4)	//a1=alp_h
	lh		a2, (53*2)(s4)	//a2=alp_l
	sll		t1, t1, 16
	sll		t2, t2, 1
	addr.s	t1, t1, t2
	addr.s	s6, s6, t1	//s6=t0
	/* K=-t0/Alpha */
	jal		Div_32
	absr.s	a0, s6	
	
	lw	t5, (48*2)(s4)	;sgt t4, s6, zero//t3=-t2 t5=alp_exp
	subr.s	t3,zero,v0
	cmvnez	v0, t3, t4	//v0=t2 	
	sll		t2, v0, t5	//t2=t2<<alp_exp
	
	sra		a2, t2, 16
	sll		t5, a2, 14+1;sra	a3, t2, 1//a2=Kh
	sub		t4, s5, 1	;subr.s	a3, a3, t5//t4=i-1
	sll		t4, t4, 1					//a3=Kl
	addu	t6, s3, t4	//t6=rc[i-1]
	sh		a2, 0(t6)
	sw		t2, 64(sp)		//store t2 to 64(sp)
	/* test for unstable filter */
	absr.s	t0, a2
	li		t1, 32750
	sub		t1, t0, t1
	.extern p729Cod
	blez	t1, 3f	
	nop
	lw		t9, p729Cod	//t9=p729Cod
	nop
	addu	t8, t9, 1544//t8->p729Cod->LpcStat.Old_A[0]
	addu	t7, t9, 1544+24//t7->old_rc[0]	
	lwp		t0, (t8)+4
	lwp		t1, (t8)+4
	lwp		t2, (t8)+4
	lwp		t3, (t8)+4
	lwp		t4, (t8)+4
	lhp		t5, (t8)+2
	lwp		t6, (t7)+4	//t6=old_rc[]
	swp		t0, (s2)+4
	swp		t1, (s2)+4
	swp		t2, (s2)+4
	swp		t3, (s2)+4
	swp		t4, (s2)+4
	shp		t5, (s2)+2
	swp		t6, (s3)+4
	j		8f		//return;
	li		v0, 1	//ener = 1
	
3:	/*--------------------------------
	 compute new lpc coeff. -. An[i] 
	 An[j] = A[j] + K*A[i-j]
	 An[i] = K
	 *--------------------------------*/
	sub		t9, s5, 1//t9=k
	li		t8, 1	 //t8=l
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, t9, 1
	mtru	t0, lps0
	mtru	t1, lpe0	;move	s6, a2//s6=Kh
	mtru	t2, lpc0	;move	s7, a3//s7=Kl
	sll		t0, t9, 1	;sll	t1, t8, 1
	addu	t8, s4, t0	;addu	t6, s4, t1//t8->Ah[k] t6=Ah[l]
	add		t9, t8, 24	;add	t7, t6, 24//t9->Al[k] t7=Al[l]
1:
	lhp		a2, (t8)-2
	lhp		a3, (t9)-2
	lhp		t4, (t6)+2	;move	a0, s6
	lhp		t5, (t7)+2	;move	a1, s7
	jal		Mpy_32
	nop
	sll		t4, t4, 16	;sll	t5, t5, 1	
	addr.s	t4, t4, t5	;addu	a1, t6, (48-2)
	addr.s	a0, v0, t4	;addu	a2, t7, (48-2)
	jal		L_Extract	;nop
	nop					;nop
2:
	lw		t2, 64(sp)	;add	a1, s4, 48//t2
	sll		t4, s5, 1	;add	a2, s4, 72
	addu	a1, a1, t4	;addu	a2, a2, t4
	jal		L_Extract
	sra		a0, t2, 4
	/* Alpha = Alpha * (1-K**2) */
	move	a0, s6	;move	a1, s7
	move	a2, s6	;move	a3, s7
	jal		Mpy_32
	nop
	li		t1, 0x7fffffff
	absr.s	t0, v0
	subr.s	t0, t1, t0
	//L_Extract
	sra		a2, t0, 16	;sra	a3, t0, 1//a2=hi
	sll		t3, a2, 14+1;lh		a0, (52*2)(s4)
	subr.s	a3, a3, t3	;lh		a1, (53*2)(s4)//a3=lo
	jal		Mpy_32
	nop
	
	/* Normalize Alpha */
	lw		t8, (48*2)(s4)//t8=alp_exp
	move	s6, v0	//s6=t0
	//jal		norm_l
	//move	a0, v0
	cls		a0, v0
	cmveqz	a0, zero, v0
	move	v0, a0
	
	add		t8, t8, v0	//alp_exp += j
	sll		a0, s6, v0
	sw		t8, (48*2)(s4)	
	addu	a1, s4, (52*2)//a1=alp_h
	jal		L_Extract
	addu	a2, s4, (53*2)//a2=alp_l
	/* A[j] = An[j] */
	la		t0, 1f
	la		t1, 2f-4
	sub		t2, s5, 1
	mtru	t0, lps0
	mtru	t1, lpe0	;addu	t8, s4, 25*2
	mtru	t2, lpc0	;addu	t9, s4, 37*2
	addu	t6, s4, 1*2	;addu	t7, s4, 13*2	
1:
	lhp		t0, (t8)+2	//Anh[j]
	lhp		t1, (t9)+2	//Anl[j]
	shp		t0, (t6)+2	//Ah[j]
	shp		t1, (t7)+2	//Al[j]
2:		
	// end i
	addi	s5, s5, 1	
	sub		t9, s5, M
	blez	t9, 7b	
	
	lw		t4, (48*2)(s4)	//t4=alp_exp
	lh		t1, (52*2)(s4)	//t1=alp_h	
	blez	t4, 3f
	//lw		t6, 60(sp)		//t6->Err
	nop
	j		4f
	sra		v0, t1, t4
3:
	sub		a1, zero, t4	
	jal		shl	
	move	a0, t1
4:	//sh		v0, 0(t6)		//*Err
	move	s7, v0		//s7=ener
	.align	3
	/* Truncate A[i] in Q27 to Q12 with rounding */
	li		t0, 4096	;lw		t9, p729Cod
	shp		t0, (s2)+2	;nop	//A[0]=4096
	la		t4, 1f
	la		t5, 2f-4
	li		t6, M-1		;addu	t8, t9, 1544+2//t8->old_A[1]
	mtru	t4, lps0	;addu	t7, t9, 1544+24//t7->old_rc[0]
	mtru	t5, lpe0	;addu	a0, s4, 1*2 //a0->Ah[1]
	mtru	t6, lpc0	;addu	a1, s4, 13*2//a1->Al[1]
	lhp		t0, (a0)+2	;li		t4, 0x00008000
	lhp		t1, (a1)+2	;nop
1:	
	sll		t0, t0, 16	;nop
	sll		t1, t1, 1	;lhp	t2, (a0)+2
	addr.s	v0, t0, t1	;lhp	t3, (a1)+2
	addr.s	v0, v0, v0	;move	t0, t2
	addr.s	v0, v0, t4	;move	t1, t3
	sra		v0, v0, 16	
	shp		v0, (s2)+2
	shp		v0, (t8)+2
2:
	lw		t4, 0(s3)
	nop	
	sw		t4, 0(t7)	//LpcStat.old_rc[]
	
	move	v0, s7		//v0=ener
	
8:	///////////////////
	lw		ra, 20(sp)
	//lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	//mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128

	.set	reorder
	.end	Levinsons

/*
Word16 Chebps_1x(Word16 x, Word16 f[], Flag mode)
	s0->x
	s1->f[]		align4
	a2->mode
local:
	
*/
	.text
	//.section ".text.Chebps_1xs"
	.set	noreorder
	.globl	Chebps_1xs
	.ent	Chebps_1xs
Chebps_1xs:
	subu	sp, sp, 64
	sw		ra, 20(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move 	s0, a0//s0->x
	sw		s3, 40(sp)	;move	s1, a1//s1->f[]
	sw		s4, 44(sp)
	.align	3
	///////////////////
	li		s2, 128		;li		t4, 256
	li		s3, 256		;li		t5, 512
	li		s4, 7		;li		t6, 6
	cmvnez	s2, t4, a2	;cmvnez	s3, t5, a2
	cmvnez	s4, t6, a2	//s2=t0, s3=t1, s4=t2
	/* NOTE. all computation are done in Q24 */
	move	t9, s2		//t9=b2_h	
	lw		t0, 0(s1)	;li		t1, 4096
	multa2	m0l, s0, s3	;li		t8, 0//t8=b2_l	
	madda2.s m0l, t0, t1
	addma.s m0l,m0l,m0l
	mfa		a0, m0l	
	//L_Extract()
	sra		t7, a0, 16	;sra	v1, a0, 1//t7=b1_h
	sll		a3, t7, 14+1	
	subr.s	t6, v1, a3					//t6=b1_l
	la		t0, 1f
	la		t1, 2f-4
	li		t2, NC-2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	addu	s1, s1, 4	//s1->f[2]
	.align	3
1:
	move	a0, t7	;move	a1, t6
	jal		Mpy_32_16
	move	a2, s0
	addr.s	v0, v0, v0	;li		t0, -32768
	multa2	m0l, t9, t0	;lh		t2, 0(s1)
	addma.s m0l, m0l,m0l;li		t3, 2			
	msuba2.s m0l, t8, t3;li		t1, 4096*2
	madda2.s m0l, t2, t1;addu	s1, s1, 2
	mfa		v1, m0l
	addr.s	v0, v0, v1
	
	//L_Extract()
	sra		t5, v0, 16	;sra	v1, v0, 1//t5=b0_h
	sll		a3, t5, 14+1
	subr.s	t4, v1, a3
	
	move	t9, t7		;move	t8, t6
	move	t7, t5		;move	t6, t4
2:	
	move	a0, t7		;move	a1, t6
	jal		Mpy_32_16
	move	a2, s0
	multa2	m0l, t9, t0	;lh		t2, 0(s1)
	addma.s m0l,m0l,m0l	;li		t1, 2048*2
	msuba2.s m0l, t8, t3
	madda2.s m0l, t2, t1
	mfa		a0, m0l
	addr.s	a0, a0, v0
	jal		L_shl
	move	a1, s4
	sra		v0, v0, 16	//cheb
			
	///////////////////
	lw		ra, 20(sp)
	//lw		t4, 24(sp)
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	//mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	
	.set	reorder	
	.end	Chebps_1xs


