/*
   ITU-T G.729A Speech Coder with Annex B    ANSI-C Source Code
   Version 1.3    Last modified: August 1997

   Copyright (c) 1996,
   AT&T, France Telecom, NTT, Universite de Sherbrooke, Lucent Technologies,
   Rockwell International
   All rights reserved.
*/

#include "../basic_op/typedef.h"
#include "../basic_op/fixedpt_basic_op.h"
#include "g729_ld8a.h"
#include "g729_tab_ld8a.h"
#include "mystruct.h"

/* static memory */
//static Word16 freq_prev[MA_NP][M];   /* Q13 */

/* static memory for frame erase operation */
//static Word16 prev_ma;                  /* previous MA prediction coef.*/
//static Word16 prev_lsp[M];              /* previous LSP vector         */
/*
void StoreLspDecStaticVar(LspDecStaticVar *ptr)
{
	int i,j;
	for (i=0; i<MA_NP; i++)
		for (j=0; j<M; j++)
			ptr->freq_prev[i][j] = freq_prev[i][j];
	ptr->prev_ma = prev_ma;
	for (i=0; i<M; i++)
		ptr->prev_lsp[i] = prev_lsp[i];
}

void LoadLspDecStaticVar(LspDecStaticVar *ptr)
{
	int i,j;
	for (i=0; i<MA_NP; i++)
		for (j=0; j<M; j++)
			freq_prev[i][j] = ptr->freq_prev[i][j];
	prev_ma = ptr->prev_ma;
	for (i=0; i<M; i++)
		prev_lsp[i] = ptr->prev_lsp[i];
}
*/
/*----------------------------------------------------------------------------
 * Lsp_decw_reset -   set the previous LSP vectors
 *----------------------------------------------------------------------------
 */
void Lsp_decw_reset( void)
{
  Word16 i;

  for(i=0; i<MA_NP; i++)
    Copy( &freq_prev_reset[0], &p729Dec->DLspStat.freq_prev[i][0], M );

  p729Dec->DLspStat.prev_ma = 0;

  Copy( freq_prev_reset, p729Dec->DLspStat.prev_lsp, M);
}



/*----------------------------------------------------------------------------
 * Lsp_iqua_cs -  LSP main quantization routine
 *----------------------------------------------------------------------------
 */
void Lsp_iqua_cs(
 Word16 prm[],          /* (i)     : indexes of the selected LSP */
 Word16 lsp_q[],        /* (o) Q13 : Quantized LSP parameters    */
 Word16 erase           /* (i)     : frame erase information     */
)
{
  Word16 mode_index;
  Word16 code0;
  Word16 code1;
  Word16 code2;
  Word16 buf[M];     /* Q13 */

  if( erase==0 ) {  /* Not frame erasure */
    mode_index = shr(prm[0] ,NC0_B/*7*/) & (Word16)1;
    code0 = prm[0] & (Word16)(NC0 - 1);
    code1 = shr(prm[1] ,NC1_B/*5*/) & (Word16)(NC1/*32*/ - 1);
    code2 = prm[1] & (Word16)(NC1 - 1);
    /* compose quantized LSP (lsp_q) from indexes */

    Lsp_get_quant(lspcb1, lspcb2, code0, code1, code2,
      fg[mode_index], p729Dec->DLspStat.freq_prev, lsp_q, fg_sum[mode_index]);

    /* save parameters to use in case of the frame erased situation */

    Copy(lsp_q, p729Dec->DLspStat.prev_lsp, M);
    p729Dec->DLspStat.prev_ma = mode_index;
  }
  else {           /* Frame erased */

    /* use revious LSP */
    Copy(p729Dec->DLspStat.prev_lsp, lsp_q, M);

    /* update freq_prev */
#ifdef VC6
    Lsp_prev_extract(p729Dec->DLspStat.prev_lsp, buf,
      fg[p729Dec->DLspStat.prev_ma], p729Dec->DLspStat.freq_prev, fg_sum_inv[p729Dec->DLspStat.prev_ma]);
#else
	Lsp_prev_extracts(p729Dec->DLspStat.prev_lsp, buf,
      fg[p729Dec->DLspStat.prev_ma], p729Dec->DLspStat.freq_prev, fg_sum_inv[p729Dec->DLspStat.prev_ma]);
#endif

    Lsp_prev_update(buf, p729Dec->DLspStat.freq_prev);
  }

  return;
}



/*-------------------------------------------------------------------*
 * Function  D_lsp: Decode Lsp                                       *
 *           ~~~~~~                                                  *
 *-------------------------------------------------------------------*/

void D_lsp(
  Word16 prm[],          /* (i)     : indexes of the selected LSP */
  Word16 lsp_q[],        /* (o) Q15 : Quantized LSP parameters    */
  Word16 erase           /* (i)     : frame erase information     */
)
{
	/* domain 0.0 <= lsf_q < pi in Q13 */
	Word16 lsf_q[M];       
	Lsp_iqua_cs(prm, lsf_q, erase);
	/* Convert LSFs to LSPs */
	Lsf_lsp2(lsf_q, lsp_q, M);
	return;
}


void Get_decfreq_prev(Word16 x[MA_NP][M])/* arg is lsfp_mem[MA_NP][M]*/
{
	Word16 i;
	for (i=0; i<MA_NP; ++i) {/* MA_NP=4; Copy 2-D "MA_NP x M" */
		Copy(&p729Dec->DLspStat.freq_prev[i][0], &x[i][0], M);
	}
}
  
void Update_decfreq_prev(Word16 x[MA_NP][M])
{
  Word16 i;

  for (i=0; i<MA_NP; i++)
    Copy(&x[i][0], &p729Dec->DLspStat.freq_prev[i][0], M);
}



