#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

/*
void L_Extract(Word32 L_32, Word16 *hi, Word16 *lo)
	NOTE.
	can't use t0~t9
*/
	.text
	//.section ".text.L_Extract"
	.set	noreorder
	.ent	L_Extract
	.globl	L_Extract
L_Extract:
	.align	3
	sra		v0, a0, 16	;sra	v1, a0, 1//v0=t4 v1=t6
	sh		v0, 0(a1)	;sll	a3, v0, 14+1	//a3=t5
	subr.s	v1, v1, a3
	jr		ra
	sh		v1, 0(a2)
	/*sra		t4, a0, 16	;sra	t6, a0, 1
	sh		t4, 0(a1)	;sll	t5, t4, 14+1 
	subr.s	t6, t6, t5
	jr		ra
	sh		t6, 0(a2)*/
	.set	reorder
	.end	L_Extract		

/*
Word32 L_Comp(Word16 hi, Word16 lo)
*/
	.text
	//.section ".text.L_Comp"
	.set	noreorder
	.ent	L_Comp
	.globl	L_Comp
L_Comp:
	sll		a0, a0, 16
	sll		a1, a1, 1
	jr		ra
	addr.s	v0, a0, a1	
	.set	reorder
	.end	L_Comp


/*
Word32 Mpy_32(Word16 hi1, Word16 lo1, Word16 hi2, Word16 lo2)
	NOTE.
	can't use t0~t9
*/
	.text
	//.section ".text.Mpy_32"
	.set	noreorder
	.ent	Mpy_32
	.globl	Mpy_32
Mpy_32:
	multa2	m0l, a0, a2
	addma.s m0l,m0l,m0l	//m0l=L_32
	multa2	m1l, a0, a3
	multa2	m2l, a1, a2
	mfa		a3, m0l
	mfa		v1, m1l
	mfa		v0, m2l		;sra	v1, v1, 15
	sra		v0, v0, 15	;sll	v1, v1, 1
	sll		v0, v0, 1	;addr.s	a3, a3, v1
	jr		ra
	addr.s	v0, a3, v0
	.set	reorder	
	.end	Mpy_32

/*
Word32 Mpy_32_16(Word16 hi, Word16 lo, Word16 n)
NOTE.
	can't use t0~t9, m2, m3
*/
	.text
	//.section ".text.Mpy_32_16"
	.set	noreorder
	.ent	Mpy_32_16
	.globl	Mpy_32_16
Mpy_32_16:
	multa2	m0l, a0, a2
	addma.s	m0l,m0l,m0l	//shift left 1
	multa2	m1l, a1, a2
	mfa		v0, m0l
	mfa		a3, m1l
	sra		a3, a3, 15
	sll		a3, a3, 1	
	jr		ra
	addr.s	v0, v0, a3
	.set	reorder
	.end	Mpy_32_16

/*
Word32 Div_32(Word32 L_num, Word16 denom_hi, Word16 denom_lo)
	a0->L_num
	a1->denom_hi
	a2->denom_lo
local:
	s3: approx	
	hi: sp(36)
	lo: sp(38)
	n_hi: sp(40)
	n_lo: sp(42)
*/	
	.text
	//.section ".text.Div_32"
	.set	noreorder
	.ent	Div_32
	.globl	Div_32
Div_32:
	subu	sp, sp, 64
	sw		s0, 16(sp)
	sw		s1, 20(sp)
	sw		s2, 24(sp)	;move	s0, a0
	sw		s3, 28(sp)	;move	s1, a1	
	sw		ra, 32(sp)	;move	s2, a2	
	//////////////////
	/* First approximation: 1 / L_denom = 1/denom_hi */
	li		a0, 0x3fff
	jal		div_s
	move	a1, s1
	move	s3, v0	//s3=approx
	/* 1/L_denom=approx * (2-L_denom * approx) */
	move	a0, s1		;move	a1, s2
	jal		Mpy_32_16
	move	a2, s3
	
	li		t4, 0x7fffffff
	subr.s	a0, t4, v0	//a0=L_32
	//move	s4, a0		//s4=L_32
	
	addu	a1, sp, 36	
	jal		L_Extract
	addu	a2, sp, 38
	
	lh		a0, 36(sp)
	lh		a1, 38(sp)
	jal		Mpy_32_16
	move	a2, s3
	/* L_num * (1/L_denom) */
	move	a0, v0
	addu	a1, sp, 36
	jal		L_Extract
	addu	a2, sp, 38
	move	a0, s0
	addu	a1, sp, 40
	jal		L_Extract
	addu	a2, sp, 42
	
	lh		a0, 40(sp)
	lh		a1, 42(sp)
	lh		a2, 36(sp)	
	jal		Mpy_32
	lh		a3, 38(sp)
	
	addr.s	v0, v0, v0
	addr.s	v0, v0, v0
		
	//////////////////
	lw		ra, 32(sp)
	lw		s0, 16(sp)
	lw		s1, 20(sp)
	lw		s2, 24(sp)
	lw		s3, 28(sp)
	jr		ra
	addu	sp, sp, 64	
	.set	reorder
	.end	Div_32

