#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define L_FRAME	80
#define L_SUBFR	40
#define PIT_MAX	143
#define MAX_32	0x7fffffff
#define MIN_32	0x80000000


/* 
Word16 cal_pit_en(Word16 *p, Word32 CrossEn)
local:
	sp(32)->max_h, max_l, ener_h, ener_l
*/	
	.text
	//.section ".text.cal_pit_ens"
	.set	noreorder
	.globl	cal_pit_ens
	.ent	cal_pit_ens
cal_pit_ens:
	subu	sp, sp, 64		#unsigned sub
	sw		s1, 28(sp)		#store word s1 in sp+28
	sw		ra, 20(sp)		#store word ra in sp+28
	sw		s0, 24(sp)
	mfru	s1, mmd	
	li		t0, 0x6
	mtru	t0, mmd	
	move	s0, a1	//s0=CrossEn
	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_FRAME/(2*2)-1
	mtru	t0, lps0	;li		t3, 1
	mtru	t1, lpe0	;multa2	m0,zero,zero
	mtru	t2, lpc0	;mta2	t3, m0l
1:
	lhp		t4, (a0)+4
	lhp		t5, (a0)+4
	madda2.s m0l, t4, t4
	madda2.s m0l, t5, t5
2:		
	mfa		a0, m0l
	li		t0, 0x2	//int mpy
	mtru	t0, mmd	
	jal		Inv_sqrt
	nop
	move	t8, v0		//t8=sum
	
	sra		t0, s0, 16	;sra	t1, s0, 1//t0=max_h
	sll		a3, t0, 14+1	//a3=t5
	subr.s	t1, t1, a3				//t1=max_l
	
	//move	a0, s0
	//addu	a1, sp, 32
	//jal		L_Extract
	//addu	a2, sp, 34
	sra		t2, t8, 16	;sra	t3, t8, 1//t2=ener_h
	sll		a3, t2, 14+1	//a3=t5
	subr.s	t3, t3, a3					//t3=ener_l		
	
	mux2.ll	t0, t0, t1
	mux2.ll	t1, t2, t3
	//move	a0, t8
	//addu	a1, sp, 36
	//jal		L_Extract
	//addu	a2, sp, 38
	
	//addu	t1, sp, 32
	//lt		t0, 0(t1)
	//lt		t0, 32(sp)
	//li		t3, 0x6	//frac mpy
	//mtru	t3, mmd
	// Mpy_32()	
	multa2	m0h, t0, t1	;mux2.lh	t2, t1, t1		
	multa2	m1h, t0, t2	;addma.s 	m0h, m0h, m0h
	multa2	m2l, t0, t2
	mfa		t4, m0h
	mfa		t5, m1h
	mfa		t6, m2l		;sra	t5, t5, 15
	sra		t6, t6, 15	;sll	t5, t5, 1
	sll		t6, t6, 1	;addr.s	t4, t4, t5	
	addr.s	v0, t4, t6
	sll		v0, v0, 16
	sra		v0, v0, 16	
	
	mtru	s1, mmd	
	lw		ra, 20(sp)
	lw		s0, 24(sp)		
	lw		s1, 28(sp)
	jr		ra
	addu	sp, sp, 64
	
	.set	reorder
	.end	cal_pit_ens
	

/*
Word16 Pitch_ol_fasts(Word16 signal[])
	s0->signal[]	//align 8
local:
	  g729_TmpVct[0]->CrossEn[0]
	         ssig[0]->scaled_signal[0]
	g729_TmpVct[132]->max_h,max_l,ener_h,ener_l
*/
	.text
#	.section ".text.Pitch_ol_fasts"
	.set	noreorder
	.globl	Pitch_ol_fasts
	.ent	Pitch_ol_fasts
Pitch_ol_fasts:
	subu	sp, sp, 64		# sp = sp - 64 (Do not generate Overflow trap)
	sw		ra, 20(sp)		# save a word value of ra in sp + 20
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)
	sw		s3, 40(sp)
	sw		s4, 44(sp)
	sw		s5, 48(sp)
	sw		s6, 52(sp)
	sw		s7, 56(sp)
	move	s0, a0			# s0 = a0 s0->signal, move a0 to s0
	//////////////////
	// C-code:
	//  scal_sig = &scaled_signal[PIT_MAX+1];	  /* scal_sig align 8 => Init_coder_ld8a */
	//  scal_sig[-144] = 0;
	.extern ssig			# ssig := scaled signal
	la		s1, ssig		# load address
	addu	s1, s1, 2*(PIT_MAX+1)# s1->scal_sig , s1 = s1 + 2*(PIT_MAX+1) (Do not generate Overflow trap)
	sw		zero, (-288)(s1)# assign zero to mem s1-288(i.e. 144 sp samples)
	li		t4, 0x6			# frac mpy and 32 sature , load 6 to t4
	mfru	t5, mmd			# move from mmd to t5
	mtru	t4, mmd			# move from t4 to mmd
	sw		t5, 24(sp)		# save content of mmd on stack
	
	//
	// verifying for risk of overflow 
	//
	la		t4, 1f
	la		t5, 2f-4
	li		t6, (L_FRAME+PIT_MAX+1)/(4*2)-1
	subu	a0, a0, 144*2

	ltp		t0, (a0)+8
	ltp		t2, (a0)+8
	mtru	t4, lps0
	mtru	t5, lpe0		;li		t9, 0	//t9=Overflow
	mtru	t6, lpc0		;multa2	m0,zero,zero
    .align	3								// aligned to 2^3=8 bytes boundaries
1:
	madda2.s m0l, t0, t0	;ltp	t4, (a0)+8
	madda2.s m0l, t1, t1	;ltp	t6, (a0)+8
	madda2.s m0l, t2, t2	;move	t0, t4
	madda2.s m0l, t3, t3	;move	t1, t5
	move	t2, t6			;move	t3, t7
2:
	li		t4, MAX_32		;mfa	v0, m0l
	subr.s	t4, v0, t4		;li		t8, 1
	/* scaling of input signal */
	li		t9, 3
	subu	a1, s1, 144*2	//a1->scal_sig[-144]
	bnez	t4, 3f
	subu	a0, s0, 144*2	//a0->signal[-144]
	// if(Overflow==1)
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (L_FRAME+PIT_MAX+1)/8-1
	ltp		t4, (a0)+8
	ltp		t6, (a0)+8
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	.align	3
1:
	srav2	t4, t4, t9	;srav2	t5, t5, t9
	srav2	t6, t6, t9	;srav2	t7, t7, t9
	stp		t4, (a1)+8
	stp		t6, (a1)+8
	ltp		t4, (a0)+8
	ltp		t6, (a0)+8
/*
	srav2	t4, t4, t9	;ltp	t0, (a0)+8
	srav2	t5, t5, t9	;ltp	t2, (a0)+8
	srav2	t6, t6, t9	;stp	t4, (a1)+8
	srav2	t7, t7, t9	;nop
	move	t4, t0		;move	t5, t1		
	stp		t6, (a1)+8	;nop
	nop	;nop
	move	t6, t2		;move	t7, t3
*/	
2:
	j		5f
	nop
3:	//else	
	li		t4, 1048576
	subr.s	v0, v0, t4
	bgez	v0, 4f
	nop
	// if(L-temp < 0)
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (L_FRAME+PIT_MAX+1)/8-1
	ltp		t4, (a0)+8
	ltp		t6, (a0)+8
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	
	.align	3
1:
	sllv2	t4, t4, t9	;ltp	t0, (a0)+8
	sllv2	t5, t5, t9	;ltp	t2, (a0)+8
	sllv2	t6, t6, t9	;stp	t4, (a1)+8
	sllv2	t7, t7, t9	;move	t4, t0
	move	t5, t1		;stp	t6, (a1)+8
	move	t6, t2		;move	t7, t3
2:
	j		5f
	nop
4:	// else
	move	s1, s0	//s1=scal_sig=signal

5:	/* The pitch lag search is divided in 3 sections */
	.extern g729_TmpVct
	la		s2, g729_TmpVct	//s2->CrossEn[]
	li		v1, 64/4
	move	a0, s1		 //a0->scal_sig[0]
	addu	a1, a0, -80*2//a1->scal_sig[-80]
	addu	a2, s2, 62*4 //a2->CrossEn[62]
	la		t4, 1f
	la		t5, 2f-4
	li		v0, L_FRAME/(2*2)-1
	mtru	t4, lps0
	mtru	t5, lpe0
	.align	3
3:	
	//t0:[p0 p1]t1:[p2 p3]t2:[p4 p5]t3:[p6 p7]
	//t4:[q4 q5]t5:[q6 q7]t6:[q8 q9]t7:[q10 q11]	
	//t8:[q5 q6]t9:[q3 q4]
	mtru	v0, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a0)+8	;multa2	m1,zero,zero
	ltp		t4, (a1)+8	;multa2	m2,zero,zero
	lt		t6, 0(a1)	;multa2	m3,zero,zero
	move	t0, t2		;nop
	.align	3
1:	
	madda2.s m0h,t0,t4	;move	t1, t3
	madda2.s m0h,t1,t5	;mux2.lh t8,t4,t5
	madda2.s m2h,t0,t5	;mux2.lh t9,t5,t6
	madda2.s m2h,t1,t6	;ltp	t4, (a1)+8
	madda2.s m1h,t0,t8	;ltp	t2, (a0)+8
	madda2.s m1h,t1,t9	;mux2.lh t8,t6,t7
	madda2.s m3h,t0,t9	;lt		t6, 0(a1)
	madda2.s m3h,t1,t8	;move	t0, t2
2:
	mfa		t1, m0h		;subu	a0, a0, 168
	mfa		t0, m1h		;subu	a1, a1, 160
	mfa		t3, m2h		;sub	v1, v1, 1	//dec counter
	mfa		t2, m3h
	stp		t0, (a2)-8	
	bgtz	v1, 3b
	stp		t2, (a2)-8
	
	/* find T1 */
	la		t4, 1f
	la		t5, 2f-4
	li		t6, 20-1	;mtru	t4, lps0
	mtru	t5, lpe0	;addu	a0, s2, 3*4
	mtru	t6, lpc0	;li		v0, MIN_32	
	lwp		t0, (a0)+4	;li		t9, 20	//v0=max t9=i	
	li		s3, 20		;nop	//s3=T1
1:	
	subr.s	t1, t0, v0	;lwp	t2, (a0)+4
	sgt		t1, t1, zero;nop
	cmvnez	v0, t0, t1	;cmvnez	s3, t9, t1
	move	t0, t2		;addi	t9, t9, 1	
2:	
	/* find T2 */
	la		t4, 1f
	la		t5, 2f-4
	li		t6, 40-1	;mtru	t4, lps0
	mtru	t5, lpe0	;li		v0, MIN_32//v0=max
	mtru	t6, lpc0	;li		t9, 40	//t9=i
	li		s4, 40		;nop	//s4=T2
1:
	subr.s	t1, t0, v0	;lwp	t2, (a0)+4
	sgt		t1, t1, zero;nop
	cmvnez	v0, t0, t1	;cmvnez	s4, t9, t1
	move	t0, t2		;addi	t9, t9, 1
2:	
	/* compute energy of maximum sect 1*/
	subu	a0, s1, s3	;sub	t0, s3, (20-3)
	subu	a0, a0, s3	;sll	t0, t0, 2//a0->scal_sig[-T1]
	addu	t0, t0, s2	//t0->CrossEn[T1-20+3]
	lw		a1, 0(t0)
	jal		cal_pit_ens
	nop
	move	s5, v0		//s5=max1
	/* compute energy of maximum sect 2 */
	subu	a0, s1, s4	;sub	t0, s4, (20-3)
	subu	a0, a0, s4	;sll	t0, t0, 2//a0->scal_sig[-T2]
	addu	t0, t0, s2	//t0->CrossEn[T2-20+3]
	lw		a1, 0(t0)
	jal		cal_pit_ens
	nop
	move	s6, v0		//s6=max2
	/* Thrid section */
	
	.extern g729_TmpVct	
	li		v1, 64/(2*2)
	move	a0, s1		 //a0->scal_sig[0]
	addu	a1, a0, -142*2//a1->scal_sig[-142]
	addu	a2, s2, 30*4 //a2->CrossEn[30]
	la		t4, 1f
	la		t5, 2f-4
	li		v0, L_FRAME/(2*2)-1
	mtru	t4, lps0
	mtru	t5, lpe0
	.align	3
3:	
	//t0:[p0 p1]t1:[p2 p3]t2:[p0 p1]t3:[p2 p3]
	//t4:[q0 q1]t5:[q2 q3]t6:[q4 q5]t7:[q6 q7]	
	//t8:[q5 q6]t9:[q3 q4]
	mtru	v0, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a0)+8	
	lwp		t4, (a1)+4
	lwp		t5, (a1)+4	;multa2	m2,zero,zero	
	lwp		t6, (a1)+4	;nop
	lwp		t7, (a1)+4	;move	t0, t2		
1:	
	madda2.s m0h,t0,t4	;move	t1, t3
	madda2.s m0h,t1,t5	;ltp	t2, (a0)+8
	madda2.s m2h,t0,t5	;move	t4, t6
	madda2.s m2h,t1,t6	;move	t5, t7
	lwp		t6, (a1)+4	;move	t0, t2
	lwp		t7, (a1)+4	;nop
2:
	mfa		t1, m0h		;subu	a0, a0, 168
	mfa		t0, m2h		;subu	a1, a1, 168
	sub		v1, v1, 1	//dec counter		
	bgtz	v1, 3b
	stp		t0, (a2)-8	
	
	/* find T3 */
	la		t4, 1f
	la		t5, 2f-4
	li		t6, 32-1	;mtru	t4, lps0
	mtru	t5, lpe0	;move	a0, s2
	mtru	t6, lpc0	;li		v0, MIN_32//v0=max	
	lwp		t0, (a0)+4	;li		t9, 80	// t9=i	
	li		s2, 80		;nop	//s2=T3
1:	
	subr.s	t1, t0, v0	;lwp	t2, (a0)+4
	sgt		t1, t1,zero	;nop
	cmvnez	v0, t0, t1	;cmvnez	s2, t9, t1
	move	t0, t2		;addi	t9, t9, 2
2:	
	/* Test around max3 */
	move	t9, s2	//t9=i
	move	a0, s1	//a0->scal_sig[0]	
	add		t4, t9, 1	;ltp	t0, (a0)+8		
	sll		t4, t4, 1	
	subu	a1, s1, t4//a1->scal_sig[-(i+1)]	
	lhp		t2, (a1)+4	
	lhp		t3, (a1)+4
	la		t4, 1f
	la		t5, 2f-4
	li		t6, L_FRAME/(2*2)-1
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	multa2	m0,zero,zero
	.align	3
1:	
	mux2.lh	t2, t2, t2	;lhp	t4, (a1)+4
	madda2.s m0h,t0,t2	;lhp	t5, (a1)+4
	move	t2, t4		;mux2.lh t3, t3, t3
	madda2.s m0h,t1,t3	;nop
	ltp		t0, (a0)+8	;move	t3, t5
2:	
	mfa		t0, m0h		;addi	t8, t9, 1
	subr.s	t1, t0, v0
	sgt		t1, t1, zero
	cmvnez	v0, t0, t1	;cmvnez	s2, t8, t1//v0=max
	
	move	a0, s1	//s0->scal_sig[0]
	sub		t8, t9, 1
	sll		t8, t8, 1	;ltp	t0, (a0)+8
	subu	a1, s1, t8	//a1->scal_sig[-(i-1)]
	li		t6, L_FRAME/(2*2)-1
	la		t4, 1f
	la		t5, 2f-4	
	mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	lhp		t2, (a1)+4
	lhp		t3, (a1)+4
	multa2	m0,zero,zero
	.align	3
1:
	mux2.lh	t2, t2, t2	;lhp	t4, (a1)+4
	madda2.s m0h,t0,t2	;lhp	t5, (a1)+4
	move	t2, t4		;mux2.lh t3, t3, t3
	madda2.s m0h,t1,t3	;nop
	ltp		t0, (a0)+8	;move	t3, t5
2:
	mfa		t0, m0h		;sub	t8, t9, 1
	subr.s	t1, t0, v0
	sgt		t1, t1, zero
	cmvnez	v0, t0, t1	;cmvnez	s2, t8, t1//v0=max,s2=T3
	
	/* compute energy of maximum */
	sll		t0, s2, 1
	subu	a0, s1, t0
	jal		cal_pit_ens
	move	a1, v0
	move	s7, v0	//s7=max3
	// s3=T1 s4=T2 s5=max1 s6=max2 s2=T3 s7=max3	
	/* Test for multiple */
	
	/* if(abs(T2*2-T3) < 5) */
	/* max2 += max3*0.25 */
	//sll		t0, s4, 1
	addr.s	t0, s4, s4
	//sub		t9, t0, s2	//t9=i
	subr.s	t9, t0, s2	//t9=i
	//absr2.s	t0, t9
	absr.s	t0, t9
	sub		t0, t0, 5
	bgez	t0, 1f	
	sra		t1, s7, 2
	//addr2.s	s6, s6, t1//max2=add(max2,shr(max3,2))	
	addr.s	s6, s6, t1
1:
	/* if(abs(T2*3-T3) < 7) */
	/* max2 += max3*0.25 */
	add		t9, t9, s4	//t9=i
	//absr2.s	t0, t9
	absr.s	t0, t9
	sub		t0, t0, 7
	bgez	t0, 1f
	sra		t1, s7, 2
	//addr2.s	s6, s6, t1//max2=add(max2,shr(max3,2))	
	addr.s	s6, s6, t1
1:	
	/* if(abs(T1*2-T2) < 5)
	max1 += max2 8 0.2 */
	sll		t0, s3, 1
	sub		t0, t0, s4	//t0=i
	//absr2.s t1, t0
	absr.s	t1, t0
	sub		t1, t1, 5	//t1=j
	bgez	t1, 1f
	li		t2, 6554
	multa2	m0l, s6, t2
	mfa		v0, m0l
	sra		v0, v0, 16
	//addr2.s	s5, s5, v0	
	addr.s	s5, s5, v0
1:	
	/* if(abs(T1*3-T2) < 7)
	max1 += max2 * 0.2 */
	add		t0, t0, s3
	//absr2.s	t1, t0
	absr.s	t1, t0
	sub		t1, t1, 7
	bgez	t1, 1f
	li		t2, 6554
	multa2	m0l, s6, t2
	mfa		v0, m0l
	sra		v0, v0, 16
	//addr2.s s5, s5, v0
	addr.s	s5, s5, v0
1:	/* compare the 3 sections maxima */
	//subr2.s t0, s5, s6
	subr.s	t0, s5, s6
	slt		t0, t0, zero
	cmvnez	s5, s6, t0
	cmvnez	s3, s4, t0
	//subr2.s t1, s5, s7
	subr.s	t1, s5, s7
	slt		t1, t1, zero
	cmvnez	s3, s2, t1
	
	move	v0, s3	//return T1		

	//////////////////
	lw		ra, 20(sp)
	lw		t4, 24(sp)	//mmd
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	Pitch_ol_fasts


/*
Word32 Dot_Product(Word16 x[], Word16 y[], Word16 lg)
	a0->x[]		//align 4
	a1->y[]		//align 4
	a2->lg		//lg=40
*/
	.text
	//.section ".text.Dot_Products"
	.set	noreorder
	.globl	Dot_Products
	.ent	Dot_Products
Dot_Products:
	lwp		t0, (a0)+4	
	lwp		t2, (a1)+4	
	lwp		t1, (a0)+4	
	la		t4, 1f
	la		t5, 2f-4
	li		t6, L_SUBFR/4-1	;mtru	t4, lps0
	mtru	t5, lpe0
	mtru	t6, lpc0
	multa2	m0,zero,zero	;lwp	t3, (a1)+4
	.align	3
1:
	madda2.s m0, t0, t2	;lwp	t4, (a0)+4
	madda2.s m0, t1, t3	;lwp	t6, (a1)+4
	lwp		t5, (a0)+4	;move	t0, t4
	lwp		t7, (a1)+4	;move	t2, t6
	move	t1, t5		;nop
	move	t3, t7		;nop
2:
	addma.s m0l,m0l,m0h
	addma.s m0l,m0l,m0l	//shift left 1
	jr		ra
	mfa		v0, m0l
	
	.set	reorder
	.end	Dot_Products

/*
Word16 G_pitch(Word16 xn[], Word16 y1[], Word16 g_coeff[], Word16 L_subfr)
	a0->xn[]		align 8
	a1->y1[]		align 4
	a2->g_coeff[]	align 4
	a3->L_subfr
local:
	g729_TmpVct[0]->scaled_y1[]
*/
	.text
	//.section ".text.G_pitchs"
	.set	noreorder
	.globl	G_pitchs
	.ent	G_pitchs
G_pitchs:
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 24(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)
	sw		s3, 36(sp)	;move	s0, a0//s0->xn[]
	sw		s4, 40(sp)	;move	s1, a1//s1->y1[]
	sw		s5, 44(sp)	;move	s2, a2//s2->g_coeff[]
	sw		s6, 48(sp)
	sw		s7, 52(sp)
	////////////////	
	/* divide y1[] by 4 to avoid overflow */
	/* compute scalar product <y1,y1> */
	.extern g729_TmpVct
	.align	3
	la		s3, g729_TmpVct	//s3->g729_TmpVct
	lwp		t4, (a1)+4	;move	a0, s3//a0->scaled_y1
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	;multa2	m0,zero,zero
	mtru	t2, lpc0	;li		t6, 2	
1:
	madda2.s m0, t4, t4	;lwp	t5, (a1)+4
	srav2	t0, t4, t6	;lwp	t7, (a1)+4
	madda2.s m0, t5, t5	;srav2	t1, t5, t6
	stp		t0, (a0)+8	;move	t4, t7	
2:
	addma.s m0l,m0l,m0h	;li		t4, 1	//s=1
	addma.s m0l,m0l,m0l	;mta2	t4, m1l
	addma.s m0l,m0l,m1l	;li		t9, 0	//t9=overflow
	mfa		s4, m0l		;li		t0, MAX_32//s4=s
	subr.s	t1, s4, t0
	cmveqz	t9, t4, t1
	
	// if(overflow==0)
	bnez	t9, 3f
	li		t8, 0x00008000
	//jal		norm_l
	//move	a0, s4
	cls		v0, s4
	cmveqz	v0, zero, s4
	sll		t0, s4, v0	;move	s5, v0//s5=exp_yy
	addr.s	t0, t0, t8	
	j		4f
	sra		s4, t0, 16	//s4=yy
3:	//else
	la		t0, 1f
	move	a0, s3//a0->scaled_y1
	ltp		t4, (a0)+8
	la		t1, 2f-4
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0	
	mtru	t2, lpc0	;multa2	m0,zero,zero
	.align	3
1:
	madda2.s m0, t4, t4	;ltp	t6, (a0)+8
	madda2.s m0, t5, t5	;nop
	move	t4, t6		;move	t5, t7
2:
	addma.s m0l,m0l,m0h	;li		t4, 1
	addma.s m0l,m0l,m0l	;mta2	t4, m1l
	addma.s m0l,m0l,m1l
	mfa		s4, m0l		//s4=s
//	jal		norm_l
//	move	a0, s4
	cls		v0, s4
	cmveqz	v0, zero, s4
	sll		t0, s4, v0	;sub	s5, v0, 4//s5=exp_yy
	addr.s	t0, t0, t8
	sra		s4, t0, 16	//s4=yy
4:
	/* compute scalar product <xn,y1> */	
	la		t0, 1f
	ltp		t4, (s0)+8	//t4=xn[0 1]t5=xn[2 3]
	lwp		t6, (s1)+4
	lwp		t7, (s1)+4
	la		t1, 2f-4	
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	;multa2	m0,zero,zero
	.align	3
1:
	madda2.s m0, t4, t6	;lwp	t0, (s1)+4
	madda2.s m0, t5, t7	;lwp	t1, (s1)+4
	move	t6, t0		;ltp	t4, (s0)+8
	move	t7, t1		;li		t8, MAX_32
2:
	addma.s m0l,m0l,m0h	;li		t9, 0//t9=overflow
	addma.s m0l,m0l,m0l	;li		t7, 1
	mfa		s6, m0l	//s6=s
	subr.s	t0, s6, t8
	cmveqz	t9, t7, t0	//t9=overflow
	
	// if(overflow == 0)
	bnez	t9, 3f
	li		t8, 0x00008000
	//jal		norm_l
	//move	a0, s6
	cls		v0, s6
	cmveqz	v0, zero, s6
	sll		t0, s6, v0	;move	s7, v0//s7=exp_xy
	addr.s	t0, t0, t8
	j		4f
	sra		s6, t0, 16	//s6=xy
3:	//else	
	la		t0, 1f
	ltp		t4, (s0)+8
	ltp		t6, (s3)+8
	la		t1, 2f-4
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	;multa2	m0, zero, zero
	.align	3
1:
	madda2.s m0, t4, t6	;ltp	t0, (s0)+8
	madda2.s m0, t5, t7	;ltp	t2, (s3)+8
	move	t4, t0		;move	t5, t1
	move	t6, t2		;move	t7, t3
2:	
	addma.s m0l,m0l,m0h	;li		t8, 0x00008000
	addma.s m0l,m0l,m0l
	mfa		s6, m0l		//s6=s
	//jal		norm_l
	//move	a0, s6
	cls		v0, s6
	cmveqz	v0, zero, s6
	sll		t0, s6, v0	;sub	s7, v0, 2//s7=exp_xy
	addr.s	t0, t0, t8
	sra		s6, t0, 16	//s6=xy
4:
	// g_coeff
	li		t4, 15
	sub		t0, t4, s5
	sub		t1, t4, s7	;mux2.ll t0, s4, t0
	mux2.ll	t1, s6, t1	;sw		t0, 0(s2)
	sw		t1, 4(s2)	;li		t2, -15
	
	/* if (xy <=0) gain = 0 */
	bgtz	s6,3f	
	mux2.ll t1, s6, t2
	sw		t1, 4(s2)	;li		v0, 0
	j		G_pitch_end		//return (0)
	nop
3:
	/*compute gain=xy/yy */
	sra		a0, s6, 1	;sub	s0, s7, s5//s0=i
	jal		div_s
	move	a1, s4	//v0=gain
	// if(i>0)
	blez	s0, 1f
	li		t4, 15
	min		s0, s0, t4
	j		2f
	sra		v0, v0, s0		//v0=gain
1:	//else
	abs		a1, s0
	jal		shl
	move	a0, v0			//v0=gain	
2:	
	/* if(gain>1.2) gain=1.2 in Q14 */
	li		t4, 19661
	min		v0, v0, t4	
	
G_pitch_end:	
	////////////////
	lw		ra, 20(sp)
	lw		s0, 24(sp)
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	lw		s3, 36(sp)
	lw		s4, 40(sp)
	lw		s5, 44(sp)
	lw		s6, 48(sp)
	lw		s7, 52(sp)
	jr		ra
	addu	sp, sp, 128
	.set	reorder
	.end	G_pitchs

