#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"


#define M		10
#define MIN_32	 0x80000000
#define L_SUBFR	 40
#define L_FRAME	80
#define GAMMAP   16384   /* 0.5               (Q15) */
#define INV_GAMMAP  21845   /* 1/(1+GAMMAP)      (Q15) */
#define GAMMAP_2 10923   /* GAMMAP/(1+GAMMAP) (Q15) */
#define AGC_FAC  29491   /* Factor for automatic gain control     0.9  Q15 */
#define AGC_FAC1 (32767 - AGC_FAC)    /* 1-AGC_FAC in Q15          */
#define L_H		22
#define PIT_MAX	143
#define  GAMMA2_PST 18022 /* Formant postfilt factor (numerator)   0.55 Q15 */
#define  GAMMA1_PST 22938 /* Formant postfilt factor (denominator) 0.70 Q15 */
#define  MU       26214   /* Factor for tilt compensation filter   0.8  Q15 */

/*
void Post_Filter(Word16 *syn, Word16 *Az_4, Word16 *T, Word16 Vad)
	a0->syn
	a1->Az_4
	a2->T
	a3->Vad
local:
	res2_pst->ssig[0]
	syn_pst->ssig[40]
	Ap3->ssig[120]
	Ap4->ssig[132]
	h->ssig[144]
	t0_min, t0_max->ssig[172~175] 32 bits
*/
	.text
	//.section ".text.Post_Filters"
	.set	noreorder
	.globl	Post_Filters
	.ent	Post_Filters
Post_Filters:
	subu	sp, sp, 128
	sw		ra, 24(sp)
	sw		s0, 28(sp)
	sw		s1, 32(sp)
	sw		s2, 36(sp)	;move	s0, a0//s0->syn
	sw		s3, 40(sp)	;move	s1, a1//s1->Az_4
	sw		s4, 44(sp)	;move	s2, a2//s2->T
	sw		s5, 48(sp)	;move	s3, a3//s3->Vad
	sw		s6, 52(sp)
	sw		s7, 56(sp)
	//////////////////
	li		s4, 0		//s4=i_subfr
	.extern ssig
	la		s5, ssig	//s5->ssig
	.extern p729Dec
	lw		s6, p729Dec	//s6=p729Dec
9:	// for(i_subfr=0; i_subfr<L_FRAME; i_subfr+=L_SUBFR)
	
	/*Find pitch range t0_min - t0_max */
	lhp		t0, (s2)+2	//t0=T
	li		t2, PIT_MAX
	li		t4, PIT_MAX-6
	sub		t0, t0, 3	//t0=t0_min
	add		t1, t0, 6	//t1=t0_max
	//sub		t3, t1, PIT_MAX
	sgt		t3, t1, PIT_MAX
	cmvnez	t1, t2, t3
	cmvnez	t0, t4, t3
	st		t0, (172*2)(s5)// store t0_min & t0_max
	
	/* Find weighted filter coefficients Ap3[] and Ap4[] */
	move	a0, s1		;li		a1, GAMMA2_PST
	li		a2, M		;addu	a3, s5, 2*120//a3->Ap3
	jal		Weight_Azs	
	nop
	move	a0, s1		;li		a1, GAMMA1_PST
	li		a2, M		;addu	a3, s5, 2*132//a3->Ap4
	jal		Weight_Azs	
	nop
	
	/* filtering of synthesis speech by A(z/GAMMA2_PST */
	addu	a0, s5, 2*120;sll	t0, s4, 1
	addu	a1, s0, t0	;lw		a2, (664+368)(s6)//a2->p729Dec->PfStat.res2
	jal		Residus
	li		a3, L_SUBFR
	
	/* scaling of "res2[]" to avoid energy overflow */
	addu	a0, s6, 664+368	
	addu	a1, s6, 664+744
	lw		a0, 0(a0)		//a0->PfStat.res2 	//align 2
	lw		a1, 0(a1)		//a1->PfStat.scal_res2//align 2
	lhp		t4, (a0)+2		//t4=res2[0]
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (L_SUBFR-4)/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0	;sra	t4, t4, 2	
	shp		t4, (a1)+2	//a0 & a1 align 4 now
	li		v0, 2
	.align	3
1:
	lwp		t0, (a0)+4
	lwp		t1, (a0)+4
	srav2	t0, t0, v0	;nop
	swp		t0, (a1)+4	;srav2	t1, t1, v0
	swp		t1, (a1)+4	;nop	
2:	
	lwp		t0, (a0)+4
	lhp		t1, (a0)+2
	srav2	t0, t0, v0
	swp		t0, (a1)+4	;sra	t1, t1, v0
	shp		t1, (a1)+2
	/* pitch postfiltering */
	beqz	s3, 1f
	subu	a0, a0, 80	//a0->p729Dec->PfStat.res2[]
	addu	a0, s6, 664	;lw		a1, (2*172)(s5)
	lw		a2, (2*174)(s5);move a3, s5
	jal		pit_pst_filts	
	nop
	j		3f
	nop
1:
	lhp		t4, (a0)+2
	lwp		t5, (a0)+4	;move	a1, s5	//a1->res2_pst	
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	.align	3
1:
	mux2.lh	t0, t4, t5	;lwp	t6, (a0)+4
	swp		t0, (a1)+4	;move	t4, t5
	move	t5, t6		;nop
2:
	
3:	/* tilt compensation filter */	
	//addu	a0, s5, 2*120
	//addu	a1, s5, 2*144
	lt		t0, (2*120)(s5)	;li		t4, 0x1000
	lt		t2, (2*124)(s5)	;nop
	lw		t6, (2*128)(s5)	;mux2.lh t4, t4, t0
	mux2.lh t5, t0, t1		;mux2.lh t8, t1, t2
	mux2.lh t9, t2, t3		;st		t4, (2*144)(s5)
	st		t8, (2*148)(s5)	;mux2.lh t0, t3, t6
	sw		t0, (2*152)(s5)	;mux2.ll t1, t6, zero
	sw		t1, (2*154)(s5)	//store h[M] h[M+1]
	//Set_zero
	sw		zero, (2*156)(s5)
	sw		zero, (2*158)(s5);addu	a0, s5, (2*132)
	sw		zero, (2*160)(s5);addu	a1, s5, (2*144)
	sw		zero, (2*162)(s5);move	a2, a1
	sw		zero, (2*164)(s5);li	a3, L_H
	sw		zero, (2*166)(s5);addu	t0, a1, 2*(M+2)//NOTE. for GHS
	li		t1, 0	//NOTE. for GHS
	sw		t0, 16(sp)	//NOTE. for GNU, pass via stack
	sw		t1, 20(sp)	//NOTE. for GNU, pass via stack
	jal		Syn_filts
	nop	
	
	/* 1st correlation of h[] */
	.align	3
	la		t4, 1f
	la		t5, 2f-4
	li		t6, (L_H+2)/8-1
	mtru	t4, lps0
	mtru	t5, lpe0	;addu	a0, s5, 2*144	//a0->h[0]		
	ltp		t0, (a0)+8	;multa2		m0,zero,zero
	ltp		t2, (a0)+8	;multa2		m1,zero,zero
	mtru	t6, lpc0	;nop	
	//t0:[h8 h9] t1:[h10 h11] t2:[h20 h21] t3:[h22 h23]
	//t8:[h5 h6] t9:[h7 h8]
	.align	3
1:
	madda2.s m0, t0, t0	;mux2.lh	t8, t0, t1	
	madda2.s m1, t0, t8	;mux2.lh	t9, t1, t2
	madda2.s m0, t1, t1	;lwp		t0, (a0)+4
	madda2.s m1, t1, t9	;mux2.lh	t8, t2, t3
	madda2.s m0, t2, t2	;lwp		t1, (a0)+4
	madda2.s m1, t2, t8	;mux2.lh	t9, t3, t0
	madda2.s m0, t3, t3	;lwp		t2, (a0)+4
	madda2.s m1, t3, t9	
	lwp		t3, (a0)+4	
2:
	addma.s	m0l,m0l,m0h	;addma.s m1l,m1l,m1h
	addma.s m0l,m0l,m0l	;addma.s m1l,m1l,m1l
	mfa		v0, m0l		//v0=L_tmp
	mfa		v1, m1l		//v1=L_tmp2
	sra		v0, v0, 16	//v0=temp1
	sra		v1, v1, 16	//v1=temp2
	move	t0, v1		//t0=temp2
	
	max		v1, v1, zero//v1=max[temp2, zero]		
	blez	t0, 1f	
	li		t1, MU
	multa2	m0l, v1, t1
	mfa		v1, m0l
	sra		a0, v1, 15	//a0=temp2
	jal		div_s
	move	a1, v0		
	
1:	/* preemphasis() */	
	move	a0, s5
	move	a1, v0
	jal		preemphasiss	
	li		a2, L_SUBFR
	
	.align	3
	/* filtering through 1/A(z/GAMMA1_PST) */
	addu	a0, s5, 2*132	;sll	t0, s4, 1
	move	a1, s5			;addu	a2, s5, t0
	addu	a2, a2, 2*40	;li		a3, L_SUBFR
	addu	t0, s6, 664+748	;li		t1, 1//NOTE. for GHS
	sw		t0, 16(sp)	//NOTE. for GNU
	sw		t1, 20(sp)	//NOTE. for GNU
	jal		Syn_filts
	nop
	/* scale output to input */
	sll		t0, s4, 1		;addu	a1, s5, 2*40
	addu	a0, s0, t0		;addu	a1, a1, t0
	jal		agcs	
	li		a2, L_SUBFR
	
	/* update res2[] buffer; shift by L_SUBFR */
	lw		v0, (664+368)(s6);li	t0, 2*(L_SUBFR-PIT_MAX)		
	nop						;li		t1, 2*(-PIT_MAX)
	addu	a0, v0, t0		;addu	a1, v0, t1	
	jal		Copy_a8_m8
	li		a2, PIT_MAX+1
		
	lw		v0, (664+744)(s6);li	t0, 2*(L_SUBFR-PIT_MAX)
	nop						;li		t1, 2*(-PIT_MAX)
	addu	a0, v0, t0		;addu	a1, v0, t1
	jal		Copy_a8_m8
	li		a2, PIT_MAX+1
		
	addu	s4, s4, L_SUBFR
	sub		t0, s4, L_FRAME
	bltz	t0, 9b
	addu	s1, s1, 2*M		//Az += M
	// } end i_subfr
	
	/* update syn[] buffer */
	li		t0, 2*(L_FRAME-M);li	t1, 2*(-M)
	addu	a0, s0, t0		;addu	a1, s0, t1
	jal		Copy
	li		a2, M	
	
	/* overwrite synthesis speech by postfiltered synthesis speech */
	addu	a0, s5, 2*40	;move	a1, s0
	jal		Copy_a8_m8
	li		a2, L_FRAME	
	
	//////////////////
	lw		ra, 24(sp)
	lw		s0, 28(sp)
	lw		s1, 32(sp)
	lw		s2, 36(sp)
	lw		s3, 40(sp)
	lw		s4, 44(sp)
	lw		s5, 48(sp)
	lw		s6, 52(sp)
	lw		s7, 56(sp)
	jr		ra
	addu	sp, sp, 128
	.set	reorder
	.end	Post_Filters


/*
void crosscorr(Word16 *src, Word16 *tar, Word32 *out, Word16 len)	
	note.
	1. src and tar should align 8 boundary
	2. len: must divided by 4
	3. assume fractional mpy and 32 bits saturation
*/
	.text
	//.section ".text.g729_crosscorrs"
	.set	noreorder
	.globl	g729_crosscorrs
	.ent	g729_crosscorrs
g729_crosscorrs:
	subu	sp, sp, 64
	sw		s0, 20(sp)	
	/////////////////
	la		t4, 1f
	la		t5, 2f-4
	li		s0, L_SUBFR/4-1
	mtru	t4, lps0
	mtru	t5, lpe0
	sra		a3, a3, 2		//len/4 iteration
	.align	3
3:
	// t0:[s4 s5]t1:[s6 s7]t2:[s4 s5]t3:[s6 s7]
	// t4:[t4 t5]t5:[t6 t7]t6:[t8 t9]t7:[t10 t11]
	// t8:[t5 t6]t9:[t3 t4]
	mtru	s0, lpc0	;multa2	m0,zero,zero
	ltp		t2, (a0)+8	;multa2	m1,zero,zero
	ltp		t4, (a1)+8	;multa2	m2,zero,zero
	lt		t6, 0(a1)	;multa2	m3,zero,zero
	move	t0, t2		;nop	
1:
	madda2.s m0, t0, t4	;move	t1, t3
	madda2.s m0, t1, t5	;ltp	t2, (a0)+8
	madda2.s m2, t0, t5	;mux2.lh t8, t4, t5
	madda2.s m2, t1, t6	;mux2.lh t9, t5, t6
	madda2.s m1, t0, t8	;ltp	t4, (a1)+8
	madda2.s m1, t1, t9	;mux2.lh t8, t6, t7
	madda2.s m3, t0, t9	;lt		t6, 0(a1)
	madda2.s m3, t1, t8	;move	t0, t2
2:
	addma.s m0l,m0l,m0h	;addma.s m1l,m1l,m1h	
	addma.s m2l,m2l,m2h	;addma.s m3l,m3l,m3h
	mfa		t0, m0l		;subu	a0, a0, 88//back src[0]
	mfa		t1, m1l		;subu	a1, a1, 80//back tar[4]
	mfa		t2, m2l		
	mfa		t3, m3l
	swp		t0, (a2)-4
	swp		t1, (a2)-4
	swp		t2, (a2)-4
	swp		t3, (a2)-4	
	
	sub		a3, a3, 1
	bgtz	a3, 3b
	nop	
	
	/////////////////
	lw		s0, 20(sp)	
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	g729_crosscorrs

/*
void pit_pst_filt(PostfiltStaticVar *PfStat, Word16 t0_min,
		Word16 t0_max, Word16 *signal_pst)
	a0->PfStat
	a1->t0_min
	a2->t0_max
	a3->signal_pst	
local:
	g729_TmpVct[0]->tar
	g729_TmpVct[60]->xcorr	
	g729_TmpVct[80]->src
	g729_TmpVct[132]->sig
	56(sp)->mmd
	60(sp)->t0	
*/
	.text
	//.section ".text.pit_pst_filts"
	.set	noreorder
	.globl	pit_pst_filts
	.ent	pit_pst_filts
pit_pst_filts:
	subu	sp, sp, 128
	sw		s0, 20(sp)	//signal
	sw		s1, 24(sp)	//scal_sig
	sw		s2, 28(sp)	//tar
	sw		s3, 32(sp)	//t0_min, cor_max, cmax
	sw		s4, 36(sp)	//signal_pst
	sw		s5, 40(sp)	//ener, en
	sw		s6, 44(sp)	//ener0, en0, g0
	sw		s7, 48(sp)	//src, gain
	sw		ra, 52(sp)
	///////////////////
	lw		s0, 368(a0)	//s0=signal=PfStat->res2
	move	s3, a1		//s3->t0_min
	lw		s1, 744(a0)	//s1=scal_sig=PfStat->scal_res2
	move	s4, a3		//s4->signal_pst
	/* compute the correlations for all delays */
	sll		a2, a2, 1	;mfru	t4, mmd
	subu	t0, s1, a2	;li		t5, 0x6//t0->deb_sig
	mtru	t5, mmd		;move	t9, s1	//t9->p
	sw		t4, 56(sp)	;move	t8, s0	//t8->signal
	.extern g729_TmpVct
	la		s2, g729_TmpVct	//s2->tar
	addu	t7, s2, 2*80//t7=src	
	la		t1, 1f
	la		t2, 2f-4
	li		t3, (L_SUBFR+8)/2-1	
	move	t6, s2		//t6=tar	
	mtru	t1, lps0
	mtru	t2, lpe0	;move	s7, t7//s7=src
	mtru	t3, lpc0	;addu	v0, s2, 2*132//v0->sig
	.align	3
1:
	lhp		a0, (t8)+2
	lhp		a1, (t8)+2
	lhp		t1, (t9)+2
	lhp		t2, (t9)+2	
	lhp		t3, (t0)+2	;mux2.ll a0, a0, a1
	lhp		t4, (t0)+2	;mux2.ll t1, t1, t2
	swp		a0, (v0)+4	;mux2.ll t3, t3, t4
	swp		t1, (t7)+4
	swp		t3, (t6)+4
2:	
	addu	a0, s2, 2*80;move	a1, s2
	addu	a2, s2, (2*60+7*4)	//a2->xcorr[7]	
	jal		g729_crosscorrs
	li		a3, 8
	
	li		v1, MIN_32	//v1=cor_max
	move	t0, s3		//t0=t0_min
	la		t1, 1f
	la		t2, 2f-4
	li		t3, 7-1
	addu	a0, s2, (2*60+1*4)//a0->xcorr[1]
	lwp		t4, (a0)+4
	move	t9, s3		//t9=t0_min
	mtru	t1, lps0	
	mtru	t2, lpe0
	mtru	t3, lpc0	
1:
	subr.s	t1, t4, v1
	sgt		t1, t1, zero
	cmvnez	v1, t4, t1
	cmvnez	t0, t9, t1
	lwp		t4, (a0)+4
	addi	t9, t9, 1
2:	
	sw		t0, 60(sp)//save t0
	/* compute energy of delayed by t0 */
	/* compute energy in the present subframe */
	li		t4, 1		;multa2	m0,zero,zero
	mta2	t4, m0l		;multa2	m1,zero,zero	
	mta2	t4, m1l		;subu	a0,s1,t0
	la		t1, 1f
	la		t2, 2f-4
	li		t3, L_SUBFR/2-1;subu	a0, a0, t0//a0->p
	mtru	t1, lps0	;move	a1, s7//a1->p1
	lhp		t4, (a0)+2
	lhp		t5, (a0)+2
	mtru	t2, lpe0
	mtru	t3, lpc0
	.align	3
1:
	mux2.ll	t6, t4, t5	;lwp	t7, (a1)+4
	madda2.s m0, t6, t6	;lhp	t4, (a0)+2
	madda2.s m1, t7, t7	;lhp	t5, (a0)+2
	nop					;nop
2:
	addma.s m0l,m0l,m0h	;addma.s m1l,m1l,m1h
	mfa		s5, m0l		//s5->ener
	mfa		s6, m1l		//s6->ener0
	
	slt		t0, v1, zero
	cmvnez	v1, zero, t0
	
	/* scale "cor_max" "ener" and "ener0" on 16 bits */
	move	a0, v1		//v0=temp
	max		a0, a0, s5
	max		a0, a0, s6
	//jal		norm_l
	//move	s3, v1		//s3=cor_max
	cls		v0, a0		;move	s3, v1//s3=cor_max
	cmveqz	v0, zero, a0
	
	sll		t0, s3, v0	;li		t5, 0x00008000
	sll		t1, s5, v0	;addr.s	t0, t0, t5
	sll		t2, s6, v0	;addr.s	t1, t1, t5
	sra		s3, t0, 16	;addr.s	t2, t2, t5
	sra		s5, t1, 16	;sra	s6, t2, 16
	//s3=cmax //s5=en //s6=en0
	/* prediction gain (dB) */
	multa2	m0l, s3, s3
	multa2	m1l, s5, s6
	mfa		v0, m0l
	mfa		v1, m1l, 1
	subr.s	v0, v0, v1
	
	//if(temp < 0)
	bgez	v0, 3f
	nop
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/4-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	addu	s0, s2, 2*132//s0->sig
1:
	lwp		t0, (s0)+4
	lwp		t1, (s0)+4
	swp		t0, (s4)+4
	swp		t1, (s4)+4
2:
	j		7f
	nop
3:	//if(sub(cmax, en) > 0)
	li		t1, INV_GAMMAP
	li		t2, GAMMAP_2
	sgt		t0, s3, s5
	cmvnez	s6, t1, t0	//s6=g0	
	bnez	t0, 3f
	cmvnez	s7, t2, t0	//s7=gain
	// else {
	li		t0, GAMMAP
	multa2	m0l, s3, t0
	//mfa		s3, m0l, 2	//s3=cmax
	mfa		s3, m0l
	sra		s3, s3, 16+1	
	sra		s5, s5, 1	//s5=en
	add		t1, s3, s5
	// if(i>0)
	bltz	t1, 1f
	move	a0, s3	
	jal		div_s
	move	a1, t1
	move	s7, v0	
	li		t2, 32767
	j		3f	
	subr.s	s6, t2, s7
1:	// else	
	li		s6, 32767
	li		s7, 0		
3:	// }
	
	/* final process */
	lw		t9, 60(sp)	//t9=t0
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR/2-1
	mtru	t0, lps0	;subu	a0, s0, t9
	mtru	t1, lpe0	;subu	a0, a0, t9//a0->signal[-t0]
	mtru	t2, lpc0	;mux2.ll t8, s6, s6//t8=[g0 g0]
	lhp		t1, (a0)+2	;mux2.ll t9, s7, s7//t9=[gain gain]
	lhp		t2, (a0)+2	;addu	s0, s2, 2*132//s0->sig
	lwp		t0, (s0)+4	//sig[i]
	.align	3
	//t1:signal[-t0] t2:signal[-t0+1]
	//t0:[sig[0] sig[1]]
1:
	// ver(1): better resolution, but diff with tstseq2a.outb
	//mux2.ll t1, t1, t2;lhp	t3, (a0)+2	
	//multa2 m0, t8, t0	;lhp	t4, (a0)+2
	//madda2.s m0, t9, t1	;lwp	t0, (s0)+4	
	//mfa	v0, m0h
	//mfa	v1, m0l
	//mux2.hh v0, v0, v1
	//swp	v0, (s4)+4
	// ver(2): same as tstseq2a.outb
	mux2.ll	t1, t1, t2	;lhp	t3, (a0)+2
	multa2	m0, t8, t0	;lhp	t4, (a0)+2
	multa2	m1, t9, t1	;lwp	t0, (s0)+4	
	mfa		v0, m0h		;move	t1, t3
	mfa		v1, m0l		;move	t2, t4
	mfa		t5, m1h		;sra	v0, v0, 16
	mfa		t6, m1l		;sra	v1, v1, 16
	sra		t5, t5, 16	;sra	t6, t6, 16
	addr2.s	v0, v0, t5	;addr2.s v1, v1, t6	
	mux2.ll	v0, v0, v1
	swp		v0, (s4)+4
2:	

7:	///////////////////
	lw		t4, 56(sp)	//mmd
	lw		ra, 52(sp)
	lw		s7, 48(sp)
	lw		s6, 44(sp)
	lw		s5, 40(sp)
	lw		s4, 36(sp)
	lw		s3, 32(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 128
	
	.set	reorder
	.end	pit_pst_filts
	
/* 
void preemphasis(Word16 *signal, Word16 g, Word16 L)
	a0->signal
	a1->g
	a2->L
*/	
	.text
	//.section ".text.preemphasiss"
	.set	noreorder
	.globl	preemphasiss
	.ent	preemphasiss
preemphasiss:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)	
	/////////////////
	addu	s0, a0, 2*(L_SUBFR-2)//s0->signal[38]
	lh		s1, 2(s0)	//s1=temp
	la		t0, 1f
	la		t1, 2f-4
	li		t2, (L_SUBFR-2)/2-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	//t4:[s38 s39]t5:[s36 s37]
	lwp		t4, (s0)-4	;mux2.ll	a1, a1, a1//a1=[g g]
	lwp		t5, (s0)-4
	.align	3
1:
	multa2	m0h, a1, t4	;sll	t0, t4, 16 //g*s38
	multa2	m0l, a1, t5	;sra	t1, t4, 16 //g*s37
	mfa		v0, m0h		;sra	t0, t0, 16 //t0=s39
	mfa		v1, m0l		;move	t4, t5	   //t1=s38
	lwp		t5, (s0)-4	;sra	v0, v0, 15
	subr2.s	v0, t0, v0	;sra	v1, v1, 15 //v0=s39
	subr2.s	v1, t1, v1	//v1=s38
	mux2.ll	v0, v1, v0
	sw		v0, 12(s0)	
2:
	.extern p729Dec
	lw		t2, p729Dec	;multa2	m0h, a1, t4	//g*s0	
	sll		t0, t4, 16	;mfa	v0, m0h	
	addu	t2, t2, 664+768//t2=PfStat.mem_pre
	lh		t3, 0(t2)	;sra	t1, t4, 16	//t1=s0
	sra		t0, t0, 16	;sra	v0, v0, 15
	multa2	m0l, a1, t3	;subr2.s v0, t0, v0	//v0=s1-g*s0	
	mfa		v1, m0l	
	sra		v1, v1, 15	
	subr2.s v1, t1, v1	//v1=s0-g*mem_pre	
	mux2.ll	v0, v1, v0
	sw		v0, 8(s0)	
	sh		s1, 0(t2)

	/////////////////
	lw		s0, 20(sp)
	lw		s1, 24(sp)	
	jr		ra
	addu	sp, sp, 64
	.set	reorder
	.end	preemphasiss
/* 
void agc(Word16 *sig_in, Word16 *sig_out, Word16 l_trm)
	a0->sig_in[]		align 4
	a1->sig_out[]		align 4
	a2->l_trm
local:
	g729_TmpVct[0]->signal[0]
	s2->signal[]
	s3->exp
	s4->gain_in
	s5->gain_out
	s6->g0
	s7->gain
*/
	.text
	//.section ".text.agcs"
	.set	noreorder
	.globl	agcs
	.ent	agcs
agcs:
	subu	sp, sp, 64
	sw		s0, 20(sp)
	sw		s1, 24(sp)
	sw		s2, 28(sp)
	sw		s3, 32(sp)	;move	s0, a0
	sw		s4, 36(sp)	;move	s1, a1
	sw		s5, 40(sp)	
	sw		s6, 44(sp)
	sw		s7, 48(sp)
	sw		ra, 52(sp)	
	mfru	t4, mmd
	li		t5, 0x6		//frac mpy and 32 bit sature
	mtru	t5, mmd	
	sw		t4, 56(sp)
	//////////////////
	/* calculate gain_out with exponent */
	.extern g729_TmpVct
	la		s2, g729_TmpVct	//s2->signal=g729_TmpVct
	la		t4, 1f
	la		t5, 2f-4
	li		t6, L_SUBFR/4-1	;lwp	t0, (a1)+4
	move	a2, s2			;lwp	t1, (a1)+4
	mtru	t4, lps0		;li		t3, 2	//a2->signal
	mtru	t5, lpe0	;srav2	t0, t0, t3
	mtru	t6, lpc0	;multa2	m0,zero,zero
	.align	3
1:		
	lwp		t4, (a1)+4	;madda2.s m0, t0, t0
	lwp		t5, (a1)+4	;srav2	t1, t1, t3
	move	t0, t4		;madda2.s m0, t1, t1
	move	t1, t5		;srav2	t0, t0, t3
2:
	addma.s m0l,m0l,m0h
	mfa		a0, m0l			//a0 = s
	
	// if(s==0) {
	bnez	a0, 3f
	nop
	.extern p729Dec
	lw		t4, p729Dec
	nop
	addu	t4, t4, 664	//t4->p729Dec->PfStat
	addu	t4, t4, 770	//past_gain		
	j		7f			//return
	sh		zero, 0(t4)
	// }
3:	/* exp */
	//jal		norm_l
	//move	s5, a0		//s5=s
	cls		v0, a0		;move	s5, a0	//s5=s
	cmveqz	v0, zero, a0
	sub		s3, v0, 1	//s3=exp
	bltz	s3, 3f
	li		s4, 0x00008000
	// if(exp >= 0)
	j		4f
	sll		t4, s5, s3
3:	//else
	sub		t5, zero, s3//t5=-exp
	sra		t4, s5, t5
4:	
	addr.s	t4, t4, s4	
	sra		s5, t4, 16	//s5=gain_out	
	
	/* calculate gain_in with exponent */	
	la		t4, 1f
	la		t5, 2f-4
	move	a1, s0		//a1->sig_in[]
	li		t6, L_SUBFR/4-1	;lwp	t0, (a1)+4
	move	a2, s2			;lwp	t1, (a1)+4
	mtru	t4, lps0		;li		t3, 2	//a2->signal
	mtru	t5, lpe0	;srav2	t0, t0, t3
	mtru	t6, lpc0	;multa2	m0,zero,zero
	.align	3
1:	
	lwp		t4, (a1)+4	;madda2.s m0, t0, t0
	lwp		t5, (a1)+4	;srav2	t1, t1, t3
	move	t0, t4		;madda2.s m0, t1, t1
	move	t1, t5		;srav2	t0, t0, t3
2:
	addma.s m0l,m0l,m0h
	mfa		a0, m0l			//a0 = s	
	//if (s==0) {
	bnez	a0, 3f
	li		s6, 0			//s6=g0
	j		4f
	nop	
3:	//else {
	//jal		norm_l
	//move	s4, a0		//s4=s
	cls		v0, a0		;move	s4, a0	//s4=s
	cmveqz	v0, zero, a0
	sll		s4, s4, v0
	li		t4, 0x00008000
	addr.s	s4, s4, t4
	sra		s4, s4, 16	//s4=gain_in
	sub		s3, s3, v0	//s3=exp=exp-i
	
	/* g0=(1-AGC_FAC)*sqrt(gain_in/gain_out) */
	move	a0, s5
	jal		div_s
	move	a1, s4	
	sll		v0, v0, 7	//v0=s

	sra		t5, v0, s3	//t5=L_shr(s,exp)
	sub		t4, zero, s3
	sll		t6, v0, t4	//t6=L_shl(s,-exp)
	sle		t3, s3, zero
	cmvnez	t5, t6, t3	//t5=s
	
	/* i=s=1/sqrt(s) */
	li		t4, 0x2
	mtru	t4, mmd
	jal		Inv_sqrt
	move	a0, t5
	li		t4, 0x6		;sll	v0, v0, 9
	mtru	t4, mmd		;li		t5, 0x00008000
	addr.s	v0, v0, t5
	sra		v0, v0, 16	//v0=i
	/* g0=i * (1-AGC_FAC) */
	li		t4, AGC_FAC1
	multa2	m0l, v0, t4
	mfa		v0, m0l
	sra		s6, v0, 16		//s6=g0
	// }
	
	/* compute gain(n) */
	/* sig_out(n) = gain(n) sig_out(n) */
4:	.extern p729Dec
	lw		t8, p729Dec
	nop
	addu	t8, t8, 664	//t8->p729Dec->PfStat
	addu	t8, t8, 770	//past_gain
	lh		s7, 0(t8)	//s7=gain
	la		t0, 1f
	la		t1, 2f-4
	li		t2, L_SUBFR-1
	mtru	t0, lps0
	mtru	t1, lpe0
	mtru	t2, lpc0
	li		t9, AGC_FAC	
1:
	multa2	m0l, s7, t9	
	mfa		v0, m0l
	sra		v0, v0, 16
	lh		t4, 0(s1)	
	add		s7, v0, s6	
	multa2	m0l, t4, s7
	mfa		v0, m0l
	sll		v0, v0, 3
	sra		v0, v0, 16
	shp		v0, (s1)+2
2:
	sh		s7, 0(t8)	//past_gain = gain

7:	//////////////////
	lw		t4, 56(sp)
	lw		ra, 52(sp)
	lw		s7, 48(sp)
	lw		s6, 44(sp)
	lw		s5, 40(sp)
	lw		s4, 36(sp)
	lw		s3, 32(sp)
	lw		s2, 28(sp)
	lw		s1, 24(sp)
	lw		s0, 20(sp)
	mtru	t4, mmd
	jr		ra
	addu	sp, sp, 64
	
	.set	reorder
	.end	agcs


