#include "../basic_op/mips.h"
#include "../basic_op/radiax.h"

#define GP0999	16383
#define NCAN1     4                /* Pre-selecting order for #1 */
#define NCAN2     8                /* Pre-selecting order for #2 */
#define GPCLIP2     481        /* Maximum pitch gain if taming is needed Q9 */
#define MAX_32	0x7fffffff


/*
Word16 Qua_gain(Word16 code[], Word16 g_coeff[], Word16 exp_coeff[], Word16 *gain_pit, Word16 *gain_cod, Word16 tameflag)
	a0->code[]
	a1->g_coeff[]		//align 4
	a2->exp_coeff[]		//align 4
	a3->*gain_pit
	t0->gain_cod
	t1->tameflag
local:
	g729_TmpVct[0]->coeff[]
	g729_TmpVct[8]->coeff_lsf[]
	g729_TmpVct[16]->exp_min[]
	g729_TmpVct[24]->gcode0
	g729_TmpVct[25]->exp_gcode0
	g729_TmpVct[26]->best_gain[]
	g729_TmpVct[28]->cand1
	g729_TmpVct[29]->cand2
	
*/
	.text
	//.section ".text.Qua_gains"
	.set	noreorder
	.globl	Qua_gains
	.ent	Qua_gains
Qua_gains:
    lw      t0, 16(sp)    //get gain_cod for GNU
    lw      t1, 20(sp)    //get tameflag for GNU
	subu	sp, sp, 128
	sw		ra, 20(sp)
	sw		s0, 24(sp)
	sw		s1, 28(sp)
	sw		s2, 32(sp)	;move	s0, a1//s0->g_coeff[]
	sw		s3, 36(sp)	;move	s1, a2//s1->exp_coeff[]
	sw		s4, 40(sp)	
	sw		s5, 44(sp)
	sw		s6, 48(sp)
	sw		s7, 52(sp)
	sw		a3, 56(sp)	//56(sp)->gain_pit
	sw		t0, 60(sp)	//60(sp)->gain_cod //for GHS & GNU
	sw		t1, 64(sp)	//64(sp)->tameflag //for GHS & GNU
	///////////////////
	.extern g729_TmpVct
	la		s2, g729_TmpVct	//s2->g729_TmpVct
	/* energy due to innovation */
	.align	3
	.extern p729Cod	
	lw		t4, p729Cod	;move	a1, a0
	addu	a2, s2, 2*24;addu	a3, s2, 2*25
	jal		Gain_predicts
	addu	a0, t4, 1592
  /*-----------------------------------------------------------------*
   *  tmp = -1./(4.*coeff[0]*coeff[2]-coeff[4]*coeff[4]) ;           *
   *-----------------------------------------------------------------*/
  	lw		s3, 0(s0)	;nop//s3=g_coeff[0 1]
  	lw		s4, 4(s0)	;li		t5, 0x00010001//s4=g_coeff[2 3]
  	lw		t9, 8(s0)	;li		t4, 0xffffffff//t9=g_coeff[4 x]  	
  	lw		s5, 0(s1)	;multa2	m0h, s3, s4//s5=exp_coeff[0 1]
  	lw		s6, 4(s1)	;addma.s m0h,m0h,m0h//s6=exp_coeff[2 3]
  	lw		t8, 8(s1)	;multa2	m1h, t9, t9//t8=exp_coeff[4 x]
  	addma.s m1h,m1h,m1h	;addr2.s t0, s5, s6//m1h=L_tmp2
  	addr2.s	t0, t0, t4	;addr2.s t1, t8, t8//t0[hi]=exp1
  	addr2.s t1, t1, t5	;mfa	v0, m0h	//t1[hi]=exp2
  	subr2.s	t2, t0, t1	;mfa	v1, m1h
  	sra		t2, t2, 16
  	sgt		t3, t2, zero
  	absr.s	t2, t2		;move	s2, t1	//t2=abs(exp1-exp2)  	  	
  	li		t6, 31
  	min		t2, t2, t6
  	sra		t4, v0, t2	;sra	t5, v1, t2
  	subr.s	s7, t4, v1	;subr.s	t5, v0, t5
  	cmveqz	s7, t5, t3	//s7=L_tmp
  	cmveqz	s2, t0, t3	
  	sra		s2, s2, 16	//s2=exp
  	
  	//jal		norm_l		//v0=sft
  	//move	a0, s7	
  	cls		v0, s7
	cmveqz	v0, zero, s7
  	
  	.align	3
  	sll		t0, s7, v0	;add	t1, s2, v0
  	sra		a1, t0, 16	;li		t2, 14+15//a1=denom  	
  	sub		s7, t1, 16	;mux2.lh s3, s3, s3//s7=exp_denom s3=g_coeff[1 0]
  	sub		s2, t2, s7	;mux2.lh s5, s5, s5//s2=exp_inv_denom s5=exp_coeff[1 0]
  	jal		div_s		
  	li		a0, 16384
  	sub		s7, zero, v0;lw		t9, 8(s0)//s7=inv_denom t9=g_coeff[4 x]
  /*-----------------------------------------------------------------*
   *  best_gain[0] = (2.*coeff[2]*coeff[1]-coeff[3]*coeff[4])*tmp ;  *
   *-----------------------------------------------------------------*/
   	multa2	m0h, s3, s4	;addr2.s t0, s5, s6//t0[hi]=exp1
   	addma.s m0h,m0h,m0h	;mux2.lh t9, t9, t9//t9=g_coeff[x 4]
   	multa2	m0l, s4, t9	;lh		t8, 8(s1)
   	addma.s m0l,m0l,m0l	;mfa	v0, m0h	//v0=L_temp1
   	addr2.s t1, s6, t8	;mfa	v1, m0l	//v1=L_temp2
   	add		t1, t1, 1	;sra	t0, t0, 16// t0=exp1
   	sll		t1, t1, 16
   	sra		t1, t1, 16	//t1=exp2
   	sgt		t3, t0, t1	;sub	t2, t0, t1
   	absr.s	t2, t2		;sra	t8, v1, 1//t2=abs(exp1-exp2)
   	add		t2, t2, 1	;sra	t9, v0, 1
   	li		t6, 31
   	min		t2, t2, t6
   	sra		t4, v0, t2	;sra	t5, v1, t2
   	subr.s	s3, t4, t8	;sub	s4, t1, 1
   	subr.s	t5, t9 ,t5	;sub	t7, t0, 1   	
   	cmveqz	s3, t5, t3	;cmveqz	s4, t7, t3//s3=L_tmp s4=exp
   	//jal		norm_l
   	//move	a0, s3//v0=sft
   	cls		v0, s3
	cmveqz	v0, zero, s3
   	
   	sll		t0, s3, v0
   	sra		t0, t0, 16	//t0=nume
   	add		t1, s4, v0	;multa2	m0l, s7, t0
   	sub		t1, t1, 16	;addma.s m0l,m0l,m0l//t1=exp_nume
   	add		t2, s2, t1
   	sub		v0, t2, (9+16-1)//v0=sft
   	mfa		t4, m0l	//t4=L_mult(nume, inv_denom)
   	.extern	g729_TmpVct
   	la		s4, g729_TmpVct	//s4=g729_TmpVct
   	lw		s3, 64(sp)	//s3=tameflag   
   	blez	v0, 1f
  	nop
  	j		2f
  	sra		v0, t4, v0	//v0=L_acc   	  	
1:   	
  	move	a0, t4	;absr	a1, v0 	
   	jal		L_shl
   	nop   	
2:  
	beqz	s3, 1f
	sra		v0, v0, 16
	li		t2, GPCLIP2
	min		v0, v0, t2
	
1: 	sh		v0, (2*26)(s4)	//store best_gain[0] 	
		
  /*-----------------------------------------------------------------*
   *  best_gain[1] = (2.*coeff[0]*coeff[3]-coeff[1]*coeff[4])*tmp ;  *
   *-----------------------------------------------------------------*/
   .align	3
   	lw		s3, 0(s0)	//s3=g_coeff[0 1]
   	lw		s4, 4(s0)	//s4=gcoeff[2 3]
   	lw		s5, 0(s1)	//s5=exp_g[0 1]
   	lw		s6, 4(s1)	;mux2.lh s4, s4, s4//s6=exp_g[2 3]
   	lw		t9, 8(s0)	//t9=g_coeff[4 x]
   	lw		t8, 8(s1)	;mux2.lh s6, s6, s6//t8=exp_g[4 x]
   	multa2	m0h, s3, s4	;mux2.lh t9, t9, t9
   	multa2	m0l, s3, t9	;addr2.s t4, s5, s6//t4[hi]=exp1
   	addma.s m0h,m0h,m0h	;addma.s m0l,m0l,m0l
   	mux2.lh	t8, t8, t8	;li		t6, 0x00010001
   	addr2.s t5, s5, t8	;mfa	v0, m0h	//v0=L_tmp1
   	addr2.s t5, t5, t6	;mfa	v1, m0l //t5[lo]=exp2 v1=L_tmp2
   	sll		t0, t5, 16	;sra	s3, t4, 16//s3=exp1
   	subr2.s t0, t4, t0	;sll	t5, t5, 16//t0[hi]=(exp1-exp2)
   	sra		t0, t0, 16	;sra	t5, t5, 16//t0=exp1-exp2 t5=exp2
   	sgt		t3, t0, zero;sub	s3, s3, 1//s3=exp(1)
   	absr	t1, t0		;sub	s4, t5, 1//t1=abs(exp1-exp2)
   	add		t1, t1, 1	;sra	t5, v1, 1//s4=exp(0)
   	sra		t4, v0, t1	;li		t2, 31
   	subr.s	s5, t4, t5	;min	t1, t1, t2//clip t1 t0 31 to prevent shift larger than 30
   	sra		t7, v0, 1	;sra	t6, v1, t1//s5=L_tmp(0)
   	subr.s	t5, t7, t6	//t5=L_tmp(1)
   	cmveqz	s5, t5, t3	//s5=L_tmp
   	cmveqz	s4, s3, t3	//s4=exp
   	
   	//jal		norm_l
   	//move	a0, s5	//v0=sft
   	cls		v0, s5
	cmveqz	v0, zero, s5
   	
   	sll		t0, s5, v0
   	sra		t0, t0, 16	//t0=nume
   	add		t1, s4, v0
   	sub		t1, t1, 16	//t1=exp_nume
   	
   	.extern g729_TmpVct
   	la		s4, g729_TmpVct	//s4->g729_TmpVct
   	add		t2, s2, t1	;multa2	m0l, t0, s7
   	sub		t2, t2, (2+16-1);addma.s m0l,m0l,m0l//t2=sft
   	blez	t2, 1f   	   	
   	mfa		a0, m0l
   	j		2f
  	sra		v0, a0, t2 	//v0=L_acc
1:   	
	jal		L_shl
  	absr	a1, t2
2:  
	sra		v0, v0, 16
	sh		v0, (2*27)(s4)	//store best_gain[1]
	
	/* change Q-format of gcode0 */
	lh		s5, (2*25)(s4)	//s5=exp_gcode0
	lh		t1, (2*24)(s4)	//t1=gcode0
	sub		t2, s5, 4
	bltz	t2, 1f
	nop
	j		2f
	sra		a3, t1, t2		//a3=gcode0_org
1:	
  	li		t3, (4+16)
  	sub		t3, t3, s5
  	sll		t1, t1, t3
  	sra		a3, t1, 16		//a3=gcode0_org
2:  	
  /*----------------------------------------------*
   *   - presearch for gain codebook -            *
   *----------------------------------------------*/
  	addu	a0, s4, (2*26)	;addu	a1, s4, (2*28)
  	jal		Gbk_presel
  	addu	a2, s4, (2*29)
  	
  /* 
   find best quantizer
  */
  	.align	3
  	lw		t0, 0(s1);sll	t2, s5, 1
  	lw		t1, 4(s1);li	t3, 0x000d000e
  	addr2.s t0, t0, t3;sub	t2, t2, 21//t3=13,14  	
  	sw		t0, (2*16)(s4);sub	t3, s5, 3//t0=exp_min[0 1]
  	mux2.ll	t2, t2, t3;lw	t4, 8(s1)
  	addr2.s t1, t1, t2;sub	t5, s5, 4
  	sw		t1, (2*18)(s4);sll	t5, t5, 16//t1=exp_min[2 3]
  	addr2.s	t4, t4, t5
  	sw		t4, (2*20)(s4)		//t4=exp_min[4 x]
  	or		t2, t4, 0x00007fff  //t2=exp_min[4 0x7fff]
  	
  	min2	t5, t0, t1
  	min2	t5, t5, t2
  	sra		t6, t5, 16	;sll	t7, t5, 16
  	sra		t7, t7, 16
  	min		t5, t6, t7	//t5=e_min  	
  	/* align coeff[] and save in special 32 bit double precision */
  	.align	3
  	la		t0, 1f  	
  	la		t1, 2f-4
  	li		t2, 5-1
  	mtru	t0, lps0
  	mtru	t1, lpe0	;addu	a0, s4, (2*16)//a0->exp_min
  	mtru	t2, lpc0	;lhp	t0, (a0)+2
  	move	a1, s0		;move	a2, s4//a2->coeff
  	lhp		t1, (a1)+2	;addu	a3, s4, (2*8)//a1->g_coeff
1:
	sub		t4, t0, t5	;lhp	t2, (a0)+2//t4=j
	sll		t1, t1, 16	;lhp	t3, (a1)+2//t1=l_tmp
	sgt		t6, t4, zero;absr	t7, t4//t7=abs(j)
	sra		v0, t1, t7	;sll	v1, t1, t7
	cmveqz	v0, v1, t6
	sra		t8, v0, 16	
	sll		t4, t8, 14+1;sra	t9, v0, 1
	subr.s	t9, t9, t4	;shp	t8, (a2)+2//coeff[i]
	shp		t9, (a3)+2	;nop			//coeff_lsf[i]
	move	t0, t2		;move	t1, t3
2:
  	/* Codebook search */
  	li		t9, MAX_32	//t9=L_dist_min  	  	
  	lw		t8, (2*28)(s4)//t8=[index1 index2]=[cand1 cand2]
  	lw		t0, 64(sp)	//t0=tameflag
  	move	s0, t8		//s0=[cand1 cand2]  	
  	.extern gbk1
  	.extern gbk2
  	la		s2, gbk1	//s2->gbk1
  	la		s3, gbk2	//s3->gbk2
  	sra		t4, t8, 16	;sll	t5, t8, 16
  	sll		t4, t4, 1+1	;sra	t5, t5, (16-(1+1))
  	addu	s2, s2, t4	;addu	s3, s3, t5//s2->gbk1[cand1][0]
  						//s3->gbk2[cand2][0]
  	// if(tameflag == 1) {
  	beqz	t0, 6f  	
  	li		s5, 0	//s5=i
  	la		t0, 1f
  	la		t1, 2f-4
  	mtru	t0, lps0
  	mtru	t1, lpe0
3:	//for(i=0; i<NCAN1; i++)  	
	li		s6, 0	//s6=j
	li		t0, NCAN2-1
	mtru	t0, lpc0
	lhp		t4, (s2)+2//t4=gbk1[cand1][0]
	lhp		t6, (s2)+2//t6=gbk1[cand1][1]
	// for(j=0; j<NCA2; j++)
	.align	3
1:	
	lhp		t5, (s3)+2//t5=gbk2[cand2][0]	
	lhp		t7, (s3)+2//t7=gbk2[cand2][1]
	add		t5, t4, t5//t5=g_pitch
	sub		t0, t5, GP0999
	bgez	t0, 2f-4
	nop
	//if(g_pitch <GP0999)
	lh		t2, (2*24)(s4)	;addr.s	t1, t6, t7//t1=L_tmp
	multa2	m1l, t5, t5		;sra	t1, t1, 1	//t1[lo]=tmp
	multa2	m0l, t1, t2//m0l=gcode m1l=g2_pitch
	mfa		t0, m0l
	sra		t0, t0, 15	;mfa	t1, m1l//t0=g_code
	multa2	m2l, t0, t0	;sra	t1, t1, 15//t1=g2_pitch
	multa2	m3l, t0, t5	;mfa	t2, m2l
	mfa		t3, m3l		;sra	t2, t2, 15//t2=g2_code
	sra		t3, t3, 15//t3=g_pit_cod
	//Mpy_32_16
	lh		a0, 0(s4)	;lh		a1, 16(s4)
	jal		Mpy_32_16
	move	a2, t1
	lh		a0, 2(s4)	;move	t7, v0//t7=L_tmp
	lh		a1, 18(s4)	;move	a2, t5
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;lh		a0, 4(s4)
	lh		a1, 20(s4)	;move	a2, t2
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;lh		a0, 6(s4)
	lh		a1, 22(s4)	;move	a2, t0
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;lh		a0, 8(s4)
	lh		a1, 24(s4)	;move	a2, t3
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;mux2.ll t1, s5, s6//t7=L_tmp
	
	subr.s	t0, t7, t9	;addr2.s t1, t1, s0//candx+i/j
	slt		t0, t0, zero;nop
	cmvnez	t9, t7, t0	;cmvnez	t8, t1, t0
	nop
	addi	s6, s6, 1	//j++
2:	//end j
	subu	s3, s3, 4*8	//offset s3 to gbk2[cand2][0]
	
	//end i	
	sub		t4, s5, NCAN1-1
	bltz	t4, 3b
	addi	s5, s5, 1	//i++
	j		9f	//exit
	nop
6:  // else {
  	la		t0, 1f
  	la		t1, 2f-4
  	mtru	t0, lps0
  	mtru	t1, lpe0
3:	//for(i=0; i<NCAN1; i++)  	
	li		s6, 0	//s6=j
	li		t0, NCAN2-1
	mtru	t0, lpc0
	lhp		t4, (s2)+2//t4=gbk1[cand1][0]
	lhp		t6, (s2)+2//t6=gbk1[cand1][1]
	.align	3
	// for(j=0; j<NCA2; j++)
1:	
	lhp		t5, (s3)+2//t5=gbk2[cand2][0]	
	lhp		t7, (s3)+2//t7=gbk2[cand2][1]
	add		t5, t4, t5//t5=g_pitch	
	lh		t2, (2*24)(s4)	;addr.s	t1, t6, t7//t1=L_tmp t2=gcode0
	multa2	m1l, t5, t5		;sra	t1, t1, 1	//t1[lo]=tmp
	multa2	m0l, t1, t2//m0l=gcode m1l=g2_pitch
	mfa		t0, m0l
	sra		t0, t0, 15	;mfa	t1, m1l//t0=g_code
	multa2	m2l, t0, t0	;sra	t1, t1, 15//t1=g2_pitch
	multa2	m3l, t0, t5	;mfa	t2, m2l
	mfa		t3, m3l		;sra	t2, t2, 15//t2=g2_code
	sra		t3, t3, 15//t3=g_pit_cod
	//Mpy_32_16
	lh		a0, 0(s4)	;lh		a1, 16(s4)
	jal		Mpy_32_16
	move	a2, t1
	lh		a0, 2(s4)	;move	t7, v0//t7=L_tmp
	lh		a1, 18(s4)	;move	a2, t5
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;lh		a0, 4(s4)
	lh		a1, 20(s4)	;move	a2, t2
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;lh		a0, 6(s4)
	lh		a1, 22(s4)	;move	a2, t0
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;lh		a0, 8(s4)
	lh		a1, 24(s4)	;move	a2, t3
	jal		Mpy_32_16
	nop
	addr.s	t7, t7, v0	;mux2.ll t1, s5, s6//t7=L_tmp	
	subr.s	t0, t7, t9	;addr2.s t1, t1, s0//candx+i/j
	slt		t0, t0, zero;nop
	cmvnez	t9, t7, t0	;cmvnez	t8, t1, t0
	nop
	addi	s6, s6, 1	//j++
2:	//end j
	subu	s3, s3, 4*8	//offset s3 to gbk2[cand2][0]
	
	//end i	
	sub		t4, s5, NCAN1-1
	bltz	t4, 3b
	addi	s5, s5, 1	//i++

9:	/* Read the quantized gain */
	.extern gbk1
	.extern gbk2
	la		s2, gbk1
	la		s3, gbk2 //t0=index1 t1=index2
	mux2.lh	t0, zero, t8;mux2.hl t1, zero, t8
	sll		t0, t0, (1+1);sll	t1, t1, (1+1)
	addu	t0, t0, s2	;addu	t1, t1, s3
	lh		t2, 0(t0)//t2=gbk1[index1][0]	
	lh		t3, 0(t1)//t3=gbk2[index2][0]
	lh		t4, 2(t0)//t4=gbk1[index1][1]
	lh		t5, 2(t1)//t5=gbk2[index2][1]
	add		v0, t2, t3	;lh		t1, (2*24)(s4)//v0=*gain_pit
	addr.s	s3, t4, t5	;lw		t6, 56(sp) //s3=L_gbk12
	sra		t0, s3, 1	;lh		t4, (2*25)(s4)//t0[lo]=tmp
	multa2	m0l, t0, t1	;nop	//t4=exp_gcode0
	addma.s m0l,m0l,m0l	;sh		v0, 0(t6)// save gain_pit
	//L_acc = L_shl(L_acc, add( ...
	sub		t4, zero, t4
	add		t4, t4, (-12-1+1+16)//t4=tmp		
	//if(tmp>=0)
	bltz	t4, 1f
	mfa		a0, m0l	//a0=L_acc
	jal		L_shl
	move	a1, t4	//v0=L_acc
	j		2f
	nop	
1:	//else	
	sub		t4, zero, t4
	li		t5, 31
	min		t4, t4, t5
	sra		v0, a0, t4//v0=L_acc	
2:	/* *gain_cod = extract_h(L_acc) */
	lw		t0, 60(sp)
	.extern p729Cod
	lw		t1, p729Cod
	sra		v0, v0, 16
	sh		v0, 0(t0)	// save *gain_cod
	move	s2, t8		//s2=[index1 index2]
	/* update table of past quantized energies */
	addu	a0, t1, 1592
	jal		Gain_update
	move	a1, s3
	mux2.lh t0, zero, s2	;mux2.hl t1, zero, s2
	sll		t0, t0, 1		;sll	t1, t1, 1
	.extern map1
	.extern map2
	la		t3, map1
	la		t4, map2
	addu	t3, t3, t0	;addu	t4, t4, t1
	lh		t3, 0(t3)
	lh		t4, 0(t4)
	sll		t3, t3, 4	//map1[index1]*NCODE2
	add		v0, t3, t4
	///////////////////
	lw		ra, 20(sp)
	lw		s0, 24(sp)
	lw		s1, 28(sp)
	lw		s2, 32(sp)
	lw		s3, 36(sp)
	lw		s4, 40(sp)
	lw		s5, 44(sp)
	lw		s6, 48(sp)
	lw		s7, 52(sp)
	jr		ra
	addu	sp, sp, 128

	.set	reorder
	.end	Qua_gains
