/*
   ITU-T G.729A Speech Coder with Annex B    ANSI-C Source Code
   Version 1.3    Last modified: August 1997

   Copyright (c) 1996,
   AT&T, France Telecom, NTT, Universite de Sherbrooke, Lucent Technologies,
   Rockwell International
   All rights reserved.
*/

/*-------------------------------------------------------------------*
 * Function  Set zero()                                              *
 *           ~~~~~~~~~~                                              *
 * Set vector x[] to zero                                            *
 *-------------------------------------------------------------------*/

#include "../basic_op/typedef.h"
#include "../basic_op/fixedpt_basic_op.h"
#include "g729_ld8a.h"

void Set_zero(
  Word16 x[],       /* (o)    : vector to clear     */
  Word16 L          /* (i)    : length of vector    */
)
{
   Word16 i;

   for (i = 0; i < L; i++)
     x[i] = 0;

   return;
}

/*-------------------------------------------------------------------*
 * Function  Copy_a4_154:                                            *
 *           ~~~~~                                                   *
 * Copy vector x[] to y[]                                            *
 *-------------------------------------------------------------------*/
#ifdef VC6
void Copy_a8_154(
	Word16 x[],	//align 8
	Word16 y[],	//align	8
	Word16 L)	//L=154
{
	Word16 i;

	for(i=0; i<154; i+=8)
	{
		y[i]  = x[i]; 
		y[i+1]= x[i+1]; 
		y[i+2]= x[i+2]; 
		y[i+3]= x[i+3];
		y[i+4]= x[i+4]; 
		y[i+5]= x[i+5]; 
		y[i+6]= x[i+6]; 
		y[i+7]= x[i+7];
	}
	y[152] = x[152];
	y[153] = x[153];
	return;
}
#endif
#ifdef VC6
/*
Copy_a8_m8():
	1)x and y align 8
	2)L can be divided by 8
*/
void Copy_a8_m8(
	Word16 x[], //align 8
	Word16 y[], //align 8
	Word16 L)
{
	Word16 i;

	for( i=0 ; i<L ; i+=8 )
	{
		y[i]  =x[i];
		y[i+1]=x[i+1];
		y[i+2]=x[i+2];
		y[i+3]=x[i+3];
		y[i+4]=x[i+4];
		y[i+5]=x[i+5];
		y[i+6]=x[i+6];
		y[i+7]=x[i+7];
	}

	return;
}
#endif

#ifdef VC6
void Copy50(
  Word16 x[],       //align 2/4/8
  Word16 y[],      	//align 8
  Word16 L         
)
{
   Word16 i;

   for (i = 0; i < L; i++)
     y[i] = x[i];

   return;
}
#endif
#ifdef VC6
void Copy_a4_154(
	Word16 x[],		//align 4
	Word16 y[],		//align 4
	Word16 L		//L=154
)
{
	int i;
	y[0] = x[0]; y[1]=x[1];
	for(i=2; i<L; i+=8)
	{
		y[i]=x[i]; y[i+1]=x[i+1]; y[i+2]=x[i+2]; y[i+3]=x[i+3];
		y[i+4]=x[i+4];y[i+5]=x[i+5];y[i+6]=x[i+6];y[i+7]=x[i+7];
	}		
	
	return ;
}
#endif
/*-------------------------------------------------------------------*
 * Function  Copy:                                                   *
 *           ~~~~~                                                   *
 * Copy vector x[] to y[]                                            *
 *-------------------------------------------------------------------*/
#ifdef VC6

void Copy(
  Word16 x[],      /* (i)   : input vector   */
  Word16 y[],      /* (o)   : output vector  */
  Word16 L         /* (i)   : vector length  */
)
{
	Word16 i;
	for (i = 0; i < L; i++) {
		y[i] = x[i];
	}
	return;
}

#endif

/* Random generator  */
Word16 Random(Word16 *seed)
{
	/* seed = seed*31821 + 13849; */
	*seed = extract_l(L_add(L_shr(L_mult(*seed, 31821), 1), 13849L));
	return(*seed);
}


