#include "../basic_op/typedef.h"
#include "const.h"

#ifndef __MYSTRUCT_H__
#define __MYSTRUCT_H__

typedef struct {
	Word16	old_speech[L_TOTAL];       /*240item*//*Total:480*/
	Word16	*speech;				      //+480
	Word16	*p_window; 				      //+484
	Word16 	old_wsp[L_FRAME+PIT_MAX+1];/*224item*///+488 (80+143+1)
	Word16	*wsp;							//+936 /*wsp:weighted speech*/
	Word16 	old_exc[L_FRAME+PIT_MAX+L_INTERPOL];//+940 (80+143+11=234)
	Word16 	*exc;							//+1408
	Word16 	lsp_old[M];						//+1412
	Word16 	lsp_old_q[M];					//+1432
	Word16  mem_w0[M];						//+1452 
	Word16  mem_w[M]; 						//+1472
	Word16  mem_zero[M];					//+1492
	Word16  sharp;							//+1512
	Word16 	pastVad;						//+1514
	Word16 	ppastVad;						//+1516
	Word16 	seed;							//+1518
} Codld8aStaticVar;

typedef struct
{	
	Word16	lspSid[M];						
	Word16	cur_gain;						//+20
	Word16	sid_gain;						//+22
	
} DecSidStaticVar;

typedef struct
{
	Word16 old_A[M+1];	
	Word16 blank0;
	Word16 old_rc[2];						//+24
	Word32 blank1;			
} LpcStaticVar;

typedef struct
{
	Word16 y2_hi;
	Word16 y2_lo;
	Word16 y1_hi;
	Word16 y1_lo;
	Word16 x0;
	Word16 x1;
	Word32 blank0;
} PreProcStaticVar;

typedef struct
{
	Word16 past_qua_en[4];
	
} QuaGainStaticVar;

typedef struct
{
	Word16 freq_prev[MA_NP][M];
	
} QuaLspStaticVar;

typedef struct
{
	Word32 L_exc_err[4];
	
} TamingStaticVar;

typedef struct
{
	Word16 MeanLSF[M];							
	Word16 Min_buffer[16];						//+20
	Word16 Prev_Min, Next_Min, Min;				//+52, 54, 56
	Word16 MeanE, MeanSE, MeanSLE, MeanSZC;		//+58, 60, 62, 64
	Word16 prev_energy;							//+66
	Word16 count_sil, count_update, count_ext;	//+68, 70, 72
	Word16 flag, v_flag, less_count;			//+74, 76, 78

} VadStaticVar;

typedef struct 
{
	Word16 lspSid_q[M] ;					
	Word16 pastCoeff[MP1];					//+20
	Word16 blank0;
	Word16 RCoeff[MP1];						//+44
	Word16 sh_RCoeff;						//+66
	Word16 Acf[SIZ_ACF];					//+68 (22)
	Word16 sh_Acf[NB_CURACF];				//+112
	Word16 sumAcf[SIZ_SUMACF];				//+116(33)
	Word16 sh_sumAcf[NB_SUMACF];			//+182
	Word16 ener[NB_GAIN];					//+188
	Word16 sh_ener[NB_GAIN];				//+192
	Word16 fr_cur;							//+196
	Word16 cur_gain;						//+198	
	Word16 nb_ener;							//+200
	Word16 sid_gain;						//+202
	Word16 flag_chang;						//+204
	Word16 prev_energy;						//+206
	Word16 count_fr0;						//+208
	Word16 blank1[3];
} DtxStaticVar;

typedef struct
{
	Word16 *new_speech;
	Word16 noise_fg[MODE][MA_NP][M];	//+4
	Word16 frame;						//+164
	
} GlobalVar;

/* all coder used memory */
typedef struct
{
	Codld8aStaticVar	CodStat;
	DecSidStaticVar 	DSidStat;		//+1520
	LpcStaticVar		LpcStat;		//+1544
	PreProcStaticVar 	PreStat;		//+1576
	QuaGainStaticVar 	QGainStat;		//+1592
	QuaLspStaticVar		QLspStat;		//+1600
	TamingStaticVar 	TamStat;		//+1680
	VadStaticVar		VadStat;		//+1696
	DtxStaticVar		DtxStat;		//+1776
	GlobalVar			GloVar;			//+1992
} g729CodMem;

/*
void StoreEncoderVar(Word16 ch);
void StoreGlobalVar(GlobalVar *ptr);
void StoreCodld8aStaticVar(Codld8aStaticVar *ptr);
void StoreDecSidStaticVar(DecSidStaticVar *ptr);
void StoreDtxStaticVar(DtxStaticVar *ptr);
void StoreLpcStaticVar(LpcStaticVar *ptr);
void StorePreProcStaticVar(PreProcStaticVar *ptr);
void StoreQuaGainStaticVar(QuaGainStaticVar *ptr);
void StoreQuaLspStaticVar(QuaLspStaticVar *ptr);
void StoreTamingStaticVar(TamingStaticVar *ptr);
void StoreVadStaticVar(VadStaticVar *ptr);

void LoadEncoderVar(Word16 ch);
void LoadGlobalVar(GlobalVar *ptr);
void LoadCodld8aStaticVar(Codld8aStaticVar *ptr);
void LoadDecSidStaticVar(DecSidStaticVar *ptr);
void LoadDtxStaticVar(DtxStaticVar *ptr);
void LoadLpcStaticVar(LpcStaticVar *ptr);
void LoadPreProcStaticVar(PreProcStaticVar *ptr);
void LoadQuaGainStaticVar(QuaGainStaticVar *ptr);
void LoadQuaLspStaticVar(QuaLspStaticVar *ptr);
void LoadTamingStaticVar(TamingStaticVar *ptr);
void LoadVadStaticVar(VadStaticVar *ptr);
*/
typedef struct
{
	Word16 old_exc[L_FRAME+PIT_MAX+L_INTERPOL];	// 80+143+11
	Word16 *exc;								// +468	
	Word16 lsp_old[M];							// +472
	Word16 mem_syn[M];							// +492
	Word16 sharp;								// +512
	Word16 old_T0;								// +514
	Word16 gain_code;							// +516
	Word16 gain_pitch;							// +518
	Word16 seed_fer;							// +520
	Word16 past_ftyp;							// +522
	Word16 seed;								// +524
	Word16 sid_sav, sh_sid_sav;					// +526 , 528
	
} Decld8aStaticVar;

typedef struct 
{
	Word16 past_qua_en[4];					
	
} DecGainStaticVar;

typedef struct
{
	Word16 freq_prev[MA_NP][M];					
	Word16 prev_ma;								// +80
	Word16 blank0;
	Word16 prev_lsp[M];							// +84

} LspDecStaticVar;


typedef struct
{
	Word16 y2_hi, y2_lo, y1_hi, y1_lo, x0, x1;
	
} PostProStaticVar;

typedef struct
{
	Word16 res2_buf[PIT_MAX+L_SUBFR+1];	
	//Word16 blank0;
	Word16 *res2;								//+368
	Word32 blank1;
	Word16 scal_res2_buf[PIT_MAX+L_SUBFR+1];		//+376
	//Word16 blank2;
	Word16 *scal_res2;							//+744
	Word16 mem_syn_pst[M];						//+748
	Word16 mem_pre;								//+768
	Word16 past_gain;							//+770
	
} PostfiltStaticVar;

typedef struct
{
	Word16 bad_lsf;				
	Word16 blank0;
	Word16 synth_buf[L_FRAME+M], *synth;		//+4, 104
	Word16 noise_fg[MODE][MA_NP][M];			//+108	
} GlobalVarD;

typedef struct
{
	Decld8aStaticVar	DecStat;
	Word32				blank0;
	DecGainStaticVar	DGnStat;			//+536
	LspDecStaticVar		DLspStat;			//+544
	PostProStaticVar	PostStat;			//+648
	Word32				blank1;
	PostfiltStaticVar	PfStat;				//+664
	Word32				blank2;
	GlobalVarD			GloVar;				//+1440
} g729DecMem;

/*
void StoreDecoderVar(Word16 ch);
void StoreGlobalVarD(GlobalVarD *ptr);
void StoreDecGainStaticVar(DecGainStaticVar *ptr);
void StoreDecld8aStaticVar(Decld8aStaticVar *ptr);
void StoreLspDecStaticVar(LspDecStaticVar *ptr);
void StorePostProStaticVar(PostProStaticVar *ptr);
void StorePostfiltStaticVar(PostfiltStaticVar *ptr);

void LoadDecoderVar(Word16 ch);
void LoadGlobalVarD(GlobalVarD *ptr);
void LoadDecGainStaticVar(DecGainStaticVar *ptr);
void LoadDecld8aStaticVar(Decld8aStaticVar *ptr);
void LoadLspDecStaticVar(LspDecStaticVar *ptr);
void LoadPostProStaticVar(PostProStaticVar *ptr);
void LoadPostfiltStaticVar(PostfiltStaticVar *ptr);
*/

/*
 * Struct : Global info for debugging in VoIP Codec
 * Abstract : 
 * Author : Brian Shao-Huang Pin (brian_bin@realtek.com.tw)
 * $Id: mystruct.h,v 1.1.1.1 2006/07/26 05:38:34 blue Exp $
 */
typedef struct
{
	Word16 SpeechFrameIndex;
}DebugInfo;


#endif

extern g729CodMem *p729Cod;
extern g729DecMem *p729Dec;
extern DebugInfo  *p729DebugInfo;



