#ifndef __PCM2_H__
#define __PCM2_H__
#define UNCACHED(x) (x| 0x20000000UL )
#define PHYSICAL(x) (x&~0xd0000000UL)
#define SETBIT(U32,bit) U32=(U32 | (1<<(bit)) )
#define CLRBIT(U32,bit) U32=(U32 & ~(1<<(bit)))

#define PCM_PAGE_SIZE 480
#define PCM_QUEU_SIZE 4096
#define PCM_BUFF_SIZE 160 /* G729 : 160, G723.1 480, */

typedef struct PCM_CHANNEL_s
{
	uint32 bEnable:1;
	uint32 bTxQFull:1;
	uint32 bRxQFull:1;
	uint32 bTxQEmpty:1;
	uint32 bRxQEmpty:1;
	uint8* pTxPage0;
	uint8* pTxPage1;
	uint8* pRxPage0;
	uint8* pRxPage1;
	uint32 dwTxPageSize;
	uint32 dwRxPageSize;
	
	uint8* pTxQStart;
	uint8* pRxQStart;
	uint32 dwTxQSize;
	uint32 dwRxQSize;
	uint32 dwTxQHead;
	uint32 dwTxQTail;
	uint32 dwRxQHead;
	uint32 dwRxQTail;
}PCM_CHANNEL_t;
extern PCM_CHANNEL_t* pcmChan;
extern uint32 voip_cntPktRx;
extern uint32 voip_cntPcmInt;
extern uint32 voip_cntPollPcmInt;
extern uint32 voip_cntTxOk0;
extern uint32 voip_cntTxOk1;
extern uint32 voip_cntTxOk2;
extern uint32 voip_cntRxOk0;
extern uint32 voip_cntRxOk1;
extern uint32 voip_cntRxOk2;
extern uint32 voip_cntRxToVoip;
extern uint32 voip_cntRxFrPage;
extern uint32 voip_cntRxQEmpty;
extern uint32 voip_cntTx;
extern uint32 voip_testVal;

int32 pcm2_enableGCR_initRegs(void);
int32 pcm2_enable_channel(uint32 channel,uint32 CMPE, uint32 RxQueueSize, uint32 TxQueueSize,uint32* PageSize,uint32 timeSlot);
int32 pcm2_disable_channel(uint32 channel);
int32 pcm2_TxFrom_voip(uint32 channel, uint8* databuf/*(In)*/, uint32 bsize/*(In)*/);
int32 pcm2_TxTo_page(uint32 channel, uint32 page);
int32 pcm2_RxFrom_page(uint32 channel, uint32 page);
int32 pcm2_RxTo_voip(uint32 channel, uint8* databuf, uint32 bufsize);
int32 voip_session_pcmInt( uint32 pcm_isr );
int32 voip_session_pktRx( uint32 chid, uint32 mid, void* packet, uint32 pktLen, uint32 flags );
int32 pcm2_initGpioB(void);
int32 voip_session_pcmInt_noQueue( uint32 pcm_isr );
int32 voip_session_pktRx_noQueue( uint32 chid, uint32 mid, void* packet, uint32 pktLen, uint32 flags );
int32 pcm2_TxfromVoIP_toPage(int32 chid, int32 page, void* packet, uint32 pktLen);
int32 pcm2_RxfromPage_toVoIP(int32 chid, int32 page);
int32 voip_session_pcmloopback(uint32 pcm_isr);
void pcm2_reset_gpio_enable_flag(void);
void pcm2_PlaySpeechData(short* data, uint32 dataLen, uint32 chid);


#define INTER_CH0CH1 0x01
#define INTER_CH0CH2 0x02
#define INTER_CH0CH3 0x03
#define INTER_CH1CH2 0x04
#define INTER_CH1CH3 0x05
#define INTER_CH2CH3 0x06
#define INTER_CH0CH1_CH2CH3 0x09
#define INTER_CH0CH2_CH1CH3 0x0A
#define INTER_CH0CH3_CH1CH2 0x0B


#endif

