/*
 * Copyright c                  Realtek Semiconductor Corporation, 2002  
 * All rights reserved.
 * 
 * Program : CLE command fo VoIP
 * Abstract : 
 * Author : Louis Yung-Chieh Lo (yjlou@realtek.com.tw)               
 * $Id: voip_cmd.c,v 1.1.1.1 2006/07/26 05:38:31 blue Exp $
 */

#include <types.h>
#include <rtl_types.h>
#include <rtl_cle.h>
#include <voip_support.h>
#include <linux/autoconf.h>
#include <asicRegs.h>
#include "rtl_errno.h"
#include "../../rtl8186/pcm.h"
#include "spi/spi_cmd.h"
#define KERNEL_SYSCALLS 
#include <asm/unistd.h>    /* for file access */
#include <asm/processor.h> /* for file access */
#include <asm/uaccess.h>   /* for file access */
#include <rtl8651_tblAsicDrv.h>
#include "g729ab/mystruct.h"
#include "g729ab/g729.h"
#include "g7231/g7231.h"
#include "pcm2.h"
#include "g726/g726.h"
#include "../cle_cmdRoot.h"

#include "../rtl865x/rtl_utils.h"
/*
 * Voip test
 *
 */
#if defined(CONFIG_RTL865X_VOIP_G729) || defined(CONFIG_RTL865X_VOIP_G7231)||defined(CONFIG_RTL865X_VOIP_G726)

int32 _voipTest(uint32 userId,  int32 argc,int8 **saved)
{
	int8 *nextToken;    /* cmdLine platform related */
	int32 size;         /* cmdLine platform related */
	
	cle_getNextCmdToken(&nextToken,&size,saved);
	if(strcmp(nextToken, "g729") == 0) 
	{
#ifdef CONFIG_RTL865X_VOIP_G729
#define L_FRAME 80                            /* Vector size.   */
		/* Test experiment related */
		int   TestCount, repeat;
		int   seqNum;          /* cmdLine input sequence number : 1, 2, 3, 4 */
		static short OutputBuf[79840];/*Fixed maximum test vector size*/

		/* Codec experiment support */
		int	  InSpIndex;
		int   bad;
		int   NbExpectedFrames;
		int   NbSamples;
		int   NbBytesEncoded;
		int   NbTotalEncoded;
		int   NbFrameCount;
		short fBadFrame  = 0;
		short vad_enable = 0;
		short PackedLengthPlusHead = 1;
		short i;    /* giving speech samples to encoder */

#ifdef __GNUC__
		/* Codec I/O data (frame) */
		__attribute__ ((aligned (8))) static short          EncodIn [L_FRAME];
		__attribute__ ((aligned (8))) static unsigned char  EncodOut[L_FRAME/8+1];/*at most 11 element in array*/
		__attribute__ ((aligned (8))) static unsigned char  DecodIn [L_FRAME/8+1];
		__attribute__ ((aligned (8))) static short          DecodOut[L_FRAME];
#else
#error
#endif
		/* Codec I/O pointer */
		unsigned char* ptstseqa_bit = NULL;
		short*         ptstseq_bin  = NULL;
		short*         ptstseqa_out = NULL;
		short*         pDecOut = NULL;
		char*          pDecTab = NULL;
		
		extern short int      tstseq1_bin[];  /* Encoder input  */
		extern unsigned char tstseq1a_bit[];  /* Encoder output */
		extern short int     tstseq1a_out[];  /* Decoder output */
		extern short int      tstseq2_bin[];  /* Encoder input  */
		extern unsigned char tstseq2a_bit[];  /* Encoder output */
		extern short int     tstseq2a_out[];  /* Decoder output */
		extern short int      tstseq3_bin[];  /* Encoder input  */
		extern unsigned char tstseq3a_bit[];  /* Encoder output */
		extern short int     tstseq3a_out[];  /* Decoder output */
		extern short int      tstseq4_bin[];  /* Encoder input  */
		extern unsigned char tstseq4a_bit[];  /* Encoder output */
		extern short int     tstseq4a_out[];  /* Decoder output */

		if(cle_getNextCmdToken(&nextToken,&size,saved) == SUCCESS)
			seqNum = U32_value(nextToken);
		else
			seqNum = 1;
		if(cle_getNextCmdToken(&nextToken,&size,saved) == SUCCESS)
			repeat = U32_value(nextToken);
		else
			repeat = 1;

		if( seqNum==1 ){
			NbSamples        = 79840;
			NbExpectedFrames = 998;
			ptstseq_bin  = tstseq1_bin;
			ptstseqa_bit = tstseq1a_bit;
			ptstseqa_out = tstseq1a_out;
		}
		else if(seqNum==2){
			NbSamples        = 21840;
			NbExpectedFrames = 273;
			ptstseq_bin  = tstseq2_bin;
			ptstseqa_bit = tstseq2a_bit;
			ptstseqa_out = tstseq2a_out;
		}
		else if(seqNum==3){
			NbSamples        = 68480;
			NbExpectedFrames = 856;
			ptstseq_bin  = tstseq3_bin;
			ptstseqa_bit = tstseq3a_bit;
			ptstseqa_out = tstseq3a_out;
		}
		else{
			NbSamples        = 64000;
			NbExpectedFrames = 800;
			ptstseq_bin  = tstseq4_bin;
			ptstseqa_bit = tstseq4a_bit;
			ptstseqa_out = tstseq4a_out;
		}

		TestCount = 0;
		while(TestCount ++ < repeat)
		{
			if(repeat > 1) {
				printk("*************\n* repeat %d\n*************\n", TestCount);
			}
			/*---------------------------------------------*/
			/*  G.729AB Encoder Testing                    */
			/*                                             */
			/*---------------------------------------------*/
			printk("eeeeeeeeeeeeeeeeeeeeeeeeeeee\n");
			printk("Verifying Encoder of g729...\n");
			bad            = 0;
			vad_enable     = 1;
			InSpIndex      = 0;
			NbFrameCount   = 0;
			NbTotalEncoded = 0;
			set_mmd(0x2);/* 32 bit MAC saturation mode, Radiax saturate at 32 bit */
			Init_G729ab_Encoder();
			Init_G729ab_Decoder();
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
			clearCOP3Counters();
#endif
			while(1)
			{
				for( i = 0 ; i < L_FRAME ; i++ ) {		// Get 80 Sp samples
					EncodIn[i] = ptstseq_bin[InSpIndex++];
				}
				NbFrameCount++;
				p729DebugInfo->SpeechFrameIndex = NbFrameCount;
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				startCOP3Counters(TRUE);
#endif
				NbBytesEncoded = G729ab_Encoder(EncodIn/*input speech*/, EncodOut/*ouput bits*/, vad_enable/*vad*/);
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				pauseCOP3Counters();
#endif
				/*CHECK : Nb:11,3,1*/
				for( i = 0 ; i < NbBytesEncoded ; i++ ) {
					if(EncodOut[i] != ptstseqa_bit[NbTotalEncoded+i]) {
						if(!bad) {
							printk("Encoding error in frame %d, Number of bytes encoded: %d\n", NbFrameCount, NbBytesEncoded);
							printk("Error at %d bytes %02x : %02x\n", i,EncodOut[i], ptstseqa_bit[NbTotalEncoded+i]);
							memDump(EncodOut, NbBytesEncoded, "++++++++encoded++++++++");
							memDump(ptstseqa_bit+(NbTotalEncoded), NbBytesEncoded, "--------answer--------");
						}
						bad++;
						break;
					}
				}
				
				/*Call decoder for verification of voice*/
				G729ab_Decoder(EncodOut, DecodOut, fBadFrame, NbFrameCount);
				for( i=0 ; i<L_FRAME ; ++i)
					OutputBuf[InSpIndex-L_FRAME+i] = DecodOut[i];
				/*COUNT frames*/
				NbTotalEncoded += NbBytesEncoded;
				if(NbFrameCount == NbExpectedFrames)
					break;
			}
			printk("Total varified bytes: %d\n",NbTotalEncoded);
			if(!bad) {	printk("PASS!\n");}
			else {		printk("FAIL! %d error frames\n", bad);}
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
			DisplayCOP3Counters();
#endif
		//	pcm_speakTest(OutputBuf, NbSamples, 0);
			printk("\n\n\n");
			if(bad)
				break;
			
			/*---------------------------------------------*/
			/*  G.729AB Decoder Testing                    */
			/*                                             */
			/*---------------------------------------------*/
			printk("dddddddddddddddddddddddddddd\n");
			printk("Verifying Decoder of g729...\n");
			pDecTab    = ptstseqa_bit;/*encoded bit stream    */
			pDecOut    = ptstseqa_out;/*decoded speech samples*/
			NbFrameCount = 0;
			bad = 0;
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
			clearCOP3Counters();
#endif
			while(1)
			{
				/* parse inoformation from pDecTab to DecodIn */
				PackedLengthPlusHead = read_frame1(pDecTab/*input contains codes*/,
												   DecodIn/*output streaming bit*/,
												   &fBadFrame);/*output : fBadFrame 0?1 */
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				startCOP3Counters(TRUE);
#endif
				/*if active frame, DecodIn has length 11 bytes*/
				G729ab_Decoder(DecodIn, DecodOut, fBadFrame/*in*/, NbFrameCount);
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				pauseCOP3Counters();
#endif
				pDecTab += PackedLengthPlusHead;
				for( i = 0 ; i < L_FRAME ; i++ ) {
					if(DecodOut[i] != pDecOut[i])
					{
						if(!bad)
						{
							printk("Decode error in frame %d\n", NbFrameCount);
							memDump(DecodOut, L_FRAME, "got");
							memDump(pDecOut,  L_FRAME, "expected");
						}
						bad++;
						break;
					}
				}
				for( i=0 ; i<L_FRAME ; ++i) {
					OutputBuf[NbFrameCount*L_FRAME+i] = DecodOut[i];
				}
				pDecOut += 80;		
				NbFrameCount++;
				if(NbFrameCount == NbExpectedFrames)
					break;
			}
			if(!bad)
				printk("PASS!\n");
			else {
				printk("FAIL! %d frames have decoded errors! ", bad);
				printk("Listen to decoder output\n");
				//pcm_speakTest(OutputBuf, NbSamples, 0);
			}
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
			DisplayCOP3Counters();
#endif
			if(bad)
				break;
		}
#else
		printk("G729 Not Installed!\n");
		return FAILED;
#endif
	}
	else if(strcmp(nextToken, "g7231") == 0) 
	{
#ifdef CONFIG_RTL865X_VOIP_G7231
#define Frame	240
		extern short *g7231_getCoderBuff(void);
		short 	i;
		int   	FrCnt = 0;
		int   	nFrames;
		int   	bad;
		char	Line[24];
		int	ind=0;  
		short *coderBuf = g7231_getCoderBuff();/*Coder buffer is 8 aligned*/
		short	*pDecOut;
		char rate53;
		char encode;
		int codeFrameLen;
		int retCodeLen;
		int count, repeat;
		unsigned short *Ifp = NULL;
		char *Ofp = NULL;
		char *Ifpd = NULL;
		unsigned short *Ofpd = NULL;

		cle_getNextCmdToken(&nextToken,&size,saved);
		if(strcmp(nextToken, "womenb") == 0)
		{
			rate53 = FALSE;
			Ifp = womenb;
			Ofp = r63vbits;
			codeFrameLen = 24;
			nFrames = 333;
			encode = TRUE;
		}
		else if(strcmp(nextToken, "INEQC53") == 0)
		{
			rate53 = TRUE;
			Ifp = INEQC53_TIN;
			Ofp = INEQC53_RCO;
			codeFrameLen = 20;
			nFrames = 63;
			encode = TRUE;
			g7231_setHighPassFilter(FALSE);
		}
		else if(strcmp(nextToken, "TAMEC63H") == 0)
		{
			rate53 = FALSE;
			Ifp = TAMEC63H_TIN;
			Ofp = TAMEC63H_RCO;
			codeFrameLen = 24;
			nFrames = 100;
			encode = TRUE;
		}
		else if(strcmp(nextToken, "CODEC63") == 0)
		{
			rate53 = FALSE;
			Ifp = CODEC63_TIN;
			Ofp = CODEC63_RCO;
			codeFrameLen = 24;
			nFrames = 313;
			encode = TRUE;
			g7231_setHighPassFilter(FALSE);
		}
		else if(strcmp(nextToken, "OVERC53H") == 0)
		{
			rate53 = TRUE;
			Ifp = OVERC53H_TIN;
			Ofp = OVERC53H_RCO;
			codeFrameLen = 20;
			nFrames = 21;
			encode = TRUE;
		}
		else if(strcmp(nextToken, "OVERC63") == 0)
		{
			rate53 = FALSE;
			Ifp = OVERC63_TIN;
			Ofp = OVERC63_RCO;
			codeFrameLen = 24;
			nFrames = 20;
			encode = TRUE;
		}
		else if(strcmp(nextToken, "PATHC63H") == 0)
		{
			rate53 = FALSE;
			Ifp = PATHC63H_TIN;
			Ofp = PATHC63H_RCO;
			codeFrameLen = 24;
			nFrames = 1019;
			encode = TRUE;
		}
		else if(strcmp(nextToken, "PATHC53") == 0)
		{
			rate53 = TRUE;
			Ifp = PATHC53_TIN;
			Ofp = PATHC53_RCO;
			codeFrameLen = 20;
			nFrames = 1028;
			encode = TRUE;
			g7231_setHighPassFilter(FALSE);
		}
		else if(strcmp(nextToken, "DTX53MIX") == 0)
		{
			rate53 = TRUE;
			Ifp = DTX53MIX_TIN;
			Ofp = DTX53_RCO;
			codeFrameLen = 20;
			nFrames = 2400;/*72 sec. speech*/
			encode = TRUE;
		}
		else if(strcmp(nextToken, "DTX63") == 0)/*VERY LONG period*/
		{
			rate53 = FALSE;
			Ifp = DTX63_TIN;
			Ofp = DTX63_RCO;
			codeFrameLen = 24;
			nFrames = 17280;/*8.64 min. speech*/
			encode = TRUE;
		}
		else if(strcmp(nextToken, "INEQD53") == 0)
		{
			rate53 = TRUE;
			Ifpd = INEQD53_TCO;
			Ofpd = INEQD53_ROU;
			codeFrameLen = 20;
			nFrames = 2;
			encode = FALSE;
			g7231_setHighPassFilter(FALSE);
		}
		else if(strcmp(nextToken, "OVERD53") == 0)
		{
			rate53 = TRUE;
			Ifpd = OVERD53_TCO;
			Ofpd = OVERD53_ROU;
			codeFrameLen = 20;
			nFrames = 26;
			encode = FALSE;
			g7231_setHighPassFilter(FALSE);
		}
		else
			return FAILED;

		if(cle_getNextCmdToken(&nextToken,&size,saved) == SUCCESS)
			repeat = U32_value(nextToken);
		else
			repeat = 1;

		count = 0;
		while(count ++ < repeat)
		{
			if(repeat > 1)
				printk("*************\n* repeat %d\n*************\n", count);

			set_mmd(0x2);		/* 32 bit saturation mode , resides in basic_op */
			Init_Coder();
			Init_Decod();
			Init_Dec_Cng();

			if(rate53 == TRUE)
				g7231_setCoderRate53();
			else
				g7231_setCoderRate63();

			if(encode == TRUE)
			{
				unsigned short *Ifp1 = Ifp;
				printk("Verifying g723.1 Encoder (rate %c.3kbps)...\n", (rate53 == TRUE)? '5': '6');
				FrCnt = 0;
				ind = 0;
				bad = 0;
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				clearCOP3Counters();
#endif
				do{
					/*
					  Encoder phase
					*/
					Ifp1 += Read_lbc(coderBuf, Frame, Ifp1) ;
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					startCOP3Counters(TRUE);
#endif
					retCodeLen = Coder(coderBuf, Line, FrCnt);
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					pauseCOP3Counters();
#endif
					for(i=0;i<codeFrameLen;i++)
						if(Line[i] != Ofp[ind++])
						{
							if(!bad)
							{
								printk("Enc error in frame %d, byte[%d]\n", FrCnt, i);
								memDump(Line, codeFrameLen, "got");
								memDump(Ofp + (codeFrameLen * (FrCnt)), codeFrameLen, "expected");
							}
							bad++;
							break;
    					}
					FrCnt ++ ;
				}while ( FrCnt < nFrames ) ;
				if(!bad)
					printk("PASS!\n");
				else
					printk("FAIL! %d/%d errors/Total\n", bad, nFrames);
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				DisplayCOP3Counters();
#endif
				if(bad)
					break;
			}
			else
			{
				char *Ifpd1 = Ifpd;
				printk("Verifying g723.1 Decoder (rate %c.3kbps)...\n", (rate53 == TRUE)? '5': '6');
				FrCnt = 0;
				ind = 0;
				bad = 0;
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				clearCOP3Counters();
#endif
				do
				{
					/*
					  Decoder phase
					*/
					if(rate53 != TRUE)
					{
						Ifpd1 += Line_Rd(Line/*(o)*/, Ifpd1/*(i)*/);
						/* Now, Line[0] contains the info and other contains the code */
					}
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					startCOP3Counters(TRUE);
#endif
					Decod( coderBuf,Line, 0/*Crc*/ );
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
					pauseCOP3Counters();
#endif
			   		for(i=0;i<Frame;i++)
						if(coderBuf[i] != Ofpd[ind])
						{
							if(!bad)
							{
								printk("Dec error in frame %d\n", FrCnt);
								memDump(coderBuf, Frame, "got");
								memDump(Ofpd, Frame, "expected");
							}
	    					bad++;
	        				break;
						}
					pDecOut += Frame;
					FrCnt ++ ;
				}while ( FrCnt < nFrames );
				if(!bad)
					printk("PASS!\n");
				else
					printk("FAIL! %d errors\n", bad);
#ifdef CONFIG_RTL865XB_EXP_PERFORMANCE_EVALUATION
				DisplayCOP3Counters();
#endif
				if(bad)
					break;
			}
		}
#else
		printk("G723 Codec Not Installed!\n");
		return FAILED;
#endif

	}
	
      else if(strcmp(nextToken, "g726") == 0) 
	{
#ifdef CONFIG_RTL865X_VOIP_G726

         int test_type;  //0:encoder   1:decoder
         int seqnum;
         int samplenum=2048;
         int out_bits=3;
         int pcm_type=0;
         unsigned char *in_sequence=NULL;
         unsigned char *rev_sequence=NULL;
#if 1	 
                     extern unsigned char NRM_A[];                    /*normal alaw PCM encoder input sequence*/
                     
			extern unsigned char NRM_A_PLUS[];         /*normal homing alaw PCM encoder input sequence*/
			
			extern unsigned char NRM_M[];                   /*normal ulaw PCM encoder input sequence*/
			
			extern unsigned char NRM_M_PLUS[];        /*normal homing ulaw PCM encoder input sequence*/
			
			extern unsigned char HI32FM_O[];                /*32kbps ulaw homing PCM decoder output sequence*/
			
			extern unsigned char HI40FA_O[];                /*40kbps alaw homing PCM decoder output sequence*/
			
			extern unsigned char HN32FM_I[];                /*32kbps ulaw homing normal ADPCM encoder output sequence*/
			
			extern unsigned char HN32FM_I_PLUS[];       /*32kbps ulaw homing normal ADPCM decoder input sequence*/
			
			extern unsigned char HN32FM_O[];               /*32kbps ulaw homing normal PCM decoder output sequence*/
			
			extern unsigned char HN40FA_I[];                /*40kbps alaw homing normal ADPCM encoder output sequence*/
			
			extern unsigned char HN40FA_I_PLUS[];       /*40kbps alaw homing normal ADPCM decoder input sequence*/
			
			extern unsigned char HN40FA_O[];               /*40kbps alaw homing normal PCM decoder output sequence*/
			
			extern unsigned char HV32FC_O[];              /*32kbps ulaw->alaw homing overload ADPCM decoder output sequence*/
			
			extern unsigned char HV32FM_I[];               /*32kbps ulaw homing overload ADPCM encoder output sequence*/
			
			extern unsigned char HV32FM_I_PLUS_A[];      /*32kbps ulaw homing overload ADPCM decoder intput sequence*/
			
			extern unsigned char HV40FA_I[];               /*40kbps alaw homing overload ADPCM encoder output sequence*/
			
			extern unsigned char HV40FA_I_PLUS_M[];      /*40kbps alaw homing overload ADPCM decoder input sequence*/
			
			extern unsigned char HV40FX_O[];              /*40kbps alaw->ulaw homing overload ADPCM decoder output sequence*/
			
			extern unsigned char I16[];                          /*16kbps ADPCM decoder input sequence*/
			
			extern unsigned char I24[];                          /*24kbps ADPCM decoder input sequence*/
						
			extern unsigned char I32_M_PLUS[];           /*32kbps homing ulaw ADPCM decoder input sequence*/
			
			extern unsigned char I40_A_PLUS[];           /*40kbps homing ulaw ADPCM decoder input sequence*/
			
                     extern unsigned char  OVR_A[];                   /*overload alaw PCM encoder input sequence*/
                     
			extern unsigned char OVR_A_PLUS[];        /*overload homging alaw PCM encoder sequence*/
			
			extern unsigned char OVR_M_PLUS[];        /*overload homging ulaw PCM encoder sequence*/
			
			extern unsigned char OVR_M[];                   /*overload alaw PCM encoder input sequence*/
			
			extern unsigned char RI16FM_O[];             /*16kbps reset ulaw PCM decoder output sequence*/
			
			extern unsigned char RI24FA_O[];             /*24kbps reset alaw PCM decoder output sequence*/
			
			extern unsigned char RN16FM_I[];             /*16kbps reset normal ulaw ADPCM encoder output sequence*/
			
			extern unsigned char RN16FM_O[];            /*16kbps reset normal ulaw PCM decoder output sequence*/
			
			extern unsigned char RN24FA_I[];             /*24kbps reset normal alaw ADPCM encoder output sequence*/
			
			extern unsigned char RN24FA_O[];            /*24kbps reset normal alaw ADPCM decoder output sequence*/
			
			extern unsigned char RV16FC_O[];             /*16kbps reset overload  ulaw->alaw ADPCM decoder output sequence*/
			
			extern unsigned char RV16FM_I[];              /*16kbps reset overload ulaw ADPCM encoder output sequence*/
			
			extern unsigned char RV24FA_I[];              /*24kbps reset overload alaw ADPCM encoder output sequence*/
			
			extern unsigned char RV24FX_O[];              /*16kbps reset overload alaw->ulaw ADPCM decoder output sequence*/

#endif


#if 0		

			extern __attribute__((weak)) unsigned char NRM_A[];                    /*normal alaw PCM encoder input sequence*/
                     
			extern __attribute__((weak)) unsigned char NRM_A_PLUS[];         /*normal homing alaw PCM encoder input sequence*/
			
			extern __attribute__((weak)) unsigned char NRM_M[];                   /*normal ulaw PCM encoder input sequence*/
			  
			extern __attribute__((weak)) unsigned char NRM_M_PLUS[];        /*normal homing ulaw PCM encoder input sequence*/
			  
			extern __attribute__((weak)) unsigned char HI32FM_O[];                /*32kbps ulaw homing PCM decoder output sequence*/
			  
			extern __attribute__((weak)) unsigned char HI40FA_O[];                /*40kbps alaw homing PCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char HN32FM_I[];                /*32kbps ulaw homing normal ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char HN32FM_I_PLUS[];       /*32kbps ulaw homing normal ADPCM decoder input sequence*/
			
			extern __attribute__((weak)) unsigned char HN32FM_O[];               /*32kbps ulaw homing normal PCM decoder output sequence*/
			  
			extern __attribute__((weak)) unsigned char HN40FA_I[];                /*40kbps alaw homing normal ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char HN40FA_I_PLUS[];       /*40kbps alaw homing normal ADPCM decoder input sequence*/
			  
			extern __attribute__((weak)) unsigned char HN40FA_O[];               /*40kbps alaw homing normal PCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char HV32FC_O[];              /*32kbps ulaw->alaw homing overload ADPCM decoder output sequence*/
			  
			extern __attribute__((weak)) unsigned char HV32FM_I[];               /*32kbps ulaw homing overload ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char HV32FM_I_PLUS_A[];      /*32kbps ulaw homing overload ADPCM decoder intput sequence*/
			
			extern __attribute__((weak)) unsigned char HV40FA_I[];               /*40kbps alaw homing overload ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char HV40FA_I_PLUS_M[];      /*40kbps alaw homing overload ADPCM decoder input sequence*/
			
			extern __attribute__((weak)) unsigned char HV40FX_O[];              /*40kbps alaw->ulaw homing overload ADPCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char I16[];                          /*16kbps ADPCM decoder input sequence*/
			
			extern __attribute__((weak)) unsigned char I24[];                          /*24kbps ADPCM decoder input sequence*/
				
			extern __attribute__((weak)) unsigned char I32_M_PLUS[];           /*32kbps homing ulaw ADPCM decoder input sequence*/
			  
			extern __attribute__((weak)) unsigned char I40_A_PLUS[];           /*40kbps homing ulaw ADPCM decoder input sequence*/
			
                    extern __attribute__((weak)) unsigned char  OVR_A[];                   /*overload alaw PCM encoder input sequence*/
                   
			extern __attribute__((weak)) unsigned char OVR_A_PLUS[];        /*overload homging alaw PCM encoder sequence*/
			
			extern __attribute__((weak)) unsigned char OVR_M_PLUS[];        /*overload homging ulaw PCM encoder sequence*/
			  
			extern __attribute__((weak)) unsigned char OVR_M[];                   /*overload alaw PCM encoder input sequence*/
			
			extern __attribute__((weak)) unsigned char RI16FM_O[];             /*16kbps reset ulaw PCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RI24FA_O[];             /*24kbps reset alaw PCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RN16FM_I[];             /*16kbps reset normal ulaw ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RN16FM_O[];            /*16kbps reset normal ulaw PCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RN24FA_I[];             /*24kbps reset normal alaw ADPCM encoder output sequence*/
			  
			extern __attribute__((weak)) unsigned char RN24FA_O[];            /*24kbps reset normal alaw ADPCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RV16FC_O[];             /*16kbps reset overload  ulaw->alaw ADPCM decoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RV16FM_I[];              /*16kbps reset overload ulaw ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RV24FA_I[];              /*24kbps reset overload alaw ADPCM encoder output sequence*/
			
			extern __attribute__((weak)) unsigned char RV24FX_O[];              /*16kbps reset overload alaw->ulaw ADPCM decoder output sequence*/
#endif


			printk("********************************\n");
		if(cle_getNextCmdToken(&nextToken,&size,saved) == SUCCESS)
			test_type = U32_value(nextToken);
		else
			test_type=0;

		
		if(cle_getNextCmdToken(&nextToken,&size,saved) == SUCCESS)
			seqnum = U32_value(nextToken);
		else
			if  (test_type==0)
				seqnum = 2;
			else
				seqnum=9;
		
           /*test_type  :    0    encoder            seqnum: 1~8
                                   1    decoder            seqnum:9~18
              seqnum    :     1      16kbps normal reset mlaw
                                    2      24kbps normal reset alaw
                                    3      16kbps overload  reset mlaw
                                    4      24kbps overload reset alaw
                                    5      32kbps normal homing mlaw 
                                    6      40kbps normal homing alaw
                                    7      32kbps overload homing mlaw
                                    8      40kbps overload homing alaw

                                    9      16kbps normal reset mlaw
                                    10    24kbps normal reset alaw
                                    11    16kbps I reset mlaw
                                    12    24kbps I reset alaw		
                                    13    16kbps overload  reset mlaw
                                    14    24kbps overload reset alaw
                                    15    32kbps normal homing mlaw
                                    16    40kbps normal homing alaw
                                    17    32kbps I homing mlaw
                                    18    40kbps I homing alaw
                                    19    32kbps overload homing mlaw
                                    20    40kbps overload homing alaw
          */

		if (seqnum==1){
			samplenum=16384;
			out_bits=2;
			pcm_type=2;
			in_sequence=NRM_M;
			rev_sequence=RN16FM_I;
			}
		if (seqnum==2){
			samplenum=16384;
			out_bits=3;
			pcm_type=1;
			in_sequence=NRM_A;
			rev_sequence=RN24FA_I;
			}
		if (seqnum==3){
			samplenum=2048;
			out_bits=2;
			pcm_type=2;
			in_sequence=OVR_M;
			rev_sequence=RV16FM_I;
			}
		if (seqnum==4){
			samplenum=2048;
			out_bits=3;
			pcm_type=1;
			in_sequence=OVR_A;
			rev_sequence=RV24FA_I;
			}
		if (seqnum==5){
			samplenum=19880;
			out_bits=4;
			pcm_type=2;
			in_sequence=NRM_M_PLUS;
			rev_sequence=HN32FM_I;
			}
		if (seqnum==6){
			samplenum=19880;
			out_bits=5;
			pcm_type=1;
			in_sequence=NRM_A_PLUS;
			rev_sequence=HN40FA_I;
			}
		if (seqnum==7){
			samplenum=5544;
			out_bits=4;
			pcm_type=2;
			in_sequence=OVR_M_PLUS;
			rev_sequence=HV32FM_I;
			}
		if (seqnum==8){
			samplenum=5544;
			out_bits=5;
			pcm_type=1;
			in_sequence=OVR_A_PLUS;
			rev_sequence=HV40FA_I;
			}
		if (seqnum==9){
			samplenum=16384;
			out_bits=2;
			pcm_type=2;
			in_sequence=RN16FM_I;
			rev_sequence=RN16FM_O;
			}

	       if (seqnum==10){
			samplenum=16384;
			out_bits=3;
			pcm_type=1;
			in_sequence=RN24FA_I;
			rev_sequence=RN24FA_O;
			}
		   
		if (seqnum==11){
			samplenum=16384;
			out_bits=2;
			pcm_type=2;
			in_sequence=I16;
			rev_sequence=RI16FM_O;
			}
		
		if (seqnum==12){
			samplenum=16384;
			out_bits=3;
			pcm_type=1;
			in_sequence=I24;
			rev_sequence=RI24FA_O;
			}	
		if (seqnum==13){
			samplenum=2048;
			out_bits=2;
			pcm_type=1;
			in_sequence=RV16FM_I;
			rev_sequence=RV16FC_O;
			}
		if (seqnum==14){
			samplenum=2048;
			out_bits=3;
			pcm_type=2;
			in_sequence=RV24FA_I;
			rev_sequence=RV24FX_O;
			}
		if (seqnum==15){
			samplenum=19880;
			out_bits=4;
			pcm_type=2;
			in_sequence=HN32FM_I_PLUS;
			rev_sequence=HN32FM_O;
			}
		if (seqnum==16){
			samplenum=19880;
			out_bits=4;
			pcm_type=2;
			in_sequence=I32_M_PLUS;
			rev_sequence=HI32FM_O;
			}            
		if (seqnum==17){
			samplenum=19880;
			out_bits=5;
			pcm_type=1;
			in_sequence=HN40FA_I_PLUS;
			rev_sequence=HN40FA_O;
			}
		if (seqnum==18){
			samplenum=19880;
			out_bits=5;
			pcm_type=1;
			in_sequence=I40_A_PLUS;
			rev_sequence=HI40FA_O;
			}
		if (seqnum==19){
			samplenum=5544;
			out_bits=4;
			pcm_type=1;
			in_sequence=HV32FM_I_PLUS_A;
			rev_sequence=HV32FC_O;
			}
		if (seqnum==20){
			samplenum=5544;
			out_bits=5;
			pcm_type=2;
			in_sequence=HV40FA_I_PLUS_M;
			rev_sequence=HV40FX_O;
			}
		
		rtlglue_printf("test_type: %d\n", test_type);

		rtlglue_printf("seqnum: %d\n", seqnum);

		rtlglue_printf("samlpenum: %d\n", samplenum);

		rtlglue_printf("out_bits: %d\n", out_bits);

		rtlglue_printf("pcm_type: %d\n", pcm_type);

		
	
		if (test_type==0)
			{

			G726_Encoder(out_bits,samplenum,pcm_type,in_sequence,rev_sequence);


			}


		else
			{	



			G726_Decoder(out_bits,samplenum,pcm_type,in_sequence,rev_sequence);

			}


#else
		printk("G726 Codec Not Installed!\n");
		return FAILED;
#endif

}

	return SUCCESS;
}
#else
int32 _voipTest(uint32 userId,  int32 argc,int8 **saved)
{
	rtlglue_printf( "\nPlease enable CONFIG_RTL865X_VOIP_G729 and CONFIG_RTL865X_VOIP_G7231 options.\n\n" );
	return FAILED;
}
#endif /* end of defined(CONFIG_RTL865X_VOIP_G729) || defined(CONFIG_RTL865X_VOIP_G7231) */


#ifdef CONFIG_RTL865X_PCM
int32 _pcmTest(uint32 userId,  int32 argc,int8 **saved)
{
	int8 *nextToken;
	int32 size;
	uint32 chan;
	uint32 value;
	uint32 seed;
	cle_getNextCmdToken(&nextToken,&size,saved);
	if(strcmp(nextToken, "randtest") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved);
		seed = U32_value(nextToken);
		cle_getNextCmdToken(&nextToken,&size,saved);
		value = U32_value(nextToken);
	//	return pcm_randTest(seed, value);
		return FAILED;
		}
	else if(strcmp(nextToken, "compendertest") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved);
		value = U32_value(nextToken);
	//	return pcm_compenderTest(value);
		return FAILED;
		}
	else if(strcmp(nextToken, "partner") == 0) {
	//	pcm_compenderTestPartner();
		return FAILED;
		}
	else if(strcmp(nextToken, "config") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved); 
		chan = U32_value(nextToken);
		cle_getNextCmdToken(&nextToken,&size,saved);
#if 0
		if(strcmp(nextToken, "status") == 0) {
			if(pcm_ioctl(chan, PCM_GET_MODE, &value) == SUCCESS){
				printk("PCM channel %d configuration: ", chan);
				printk("%s mode", (value == PCM_MODE_UNIFORM)? "Linear": 
									(value == PCM_MODE_ULAW)? "u-law": "A-law");
				pcm_ioctl(chan, PCM_GET_LOOPBACK, &value);
				if(value == TRUE)
					printk(", internal loopback");
				pcm_ioctl(chan, PCM_GET_TIMESLOT, &value);
				printk(", time slot %d\n", value);
			}else
				return FAILED;
		}else if(strcmp(nextToken, "uniform") == 0) {
			return pcm_ioctl(chan, PCM_SET_MODE, PCM_MODE_UNIFORM);
		}else if(strcmp(nextToken, "u-law") == 0) {
			return pcm_ioctl(chan, PCM_SET_MODE, PCM_MODE_ULAW);
		}else if(strcmp(nextToken, "A-law") == 0) {
			return pcm_ioctl(chan, PCM_SET_MODE, PCM_MODE_ALAW);
		}else if(strcmp(nextToken, "loopback") == 0) {
			cle_getNextCmdToken(&nextToken,&size,saved);
			if(strcmp(nextToken, "enable") == 0)
				return pcm_ioctl(chan, PCM_SET_LOOPBACK, TRUE);
			else
				return pcm_ioctl(chan, PCM_SET_LOOPBACK, FALSE);
		}else if(strcmp(nextToken, "slot") == 0) {
			cle_getNextCmdToken(&nextToken,&size,saved);
			value = U32_value(nextToken);
			pcm_ioctl(chan, PCM_SET_TIMESLOT, value);
		}
#endif
		return FAILED;
	}
	else if(strcmp(nextToken, "autotest") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved); 
		chan = U32_value(nextToken);
		cle_getNextCmdToken(&nextToken,&size,saved);
		value = U32_value(nextToken);
		cle_getNextCmdToken(&nextToken,&size,saved);
		seed = U32_value(nextToken);
	//	return pcm_autoTest(chan, value, seed);
	//	pcm_task(value, seed);
	}else if(strcmp(nextToken, "humantest") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved); 
		chan = U32_value(nextToken);
		cle_getNextCmdToken(&nextToken,&size,saved);
		value = U32_value(nextToken);
	//	return pcm_humanTest(chan, value);
	}else if(strcmp(nextToken, "reset") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved); 
		chan = U32_value(nextToken);
	//	init_pcm(chan);
	}else if(strcmp(nextToken, "run") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved);
		value = U32_value(nextToken);
	//	pcm_run(value);
	}
#ifdef CONFIG_RTL865X_VOIP_G7231
	else if(strcmp(nextToken, "go") == 0) {
		cle_getNextCmdToken(&nextToken,&size,saved);
		value = U32_value(nextToken);
	}
#endif
	return FAILED;
}
#else
int32 _pcmTest(uint32 userId,  int32 argc,int8 **saved)
{
	rtlglue_printf( "\nPlease enable CONFIG_RTL865X_PCM option.\n\n" );
	return FAILED;
}
#endif /*end of CONFIG_RTL865X_PCM*/

int32 voip_session(uint32 userId,  int32 argc,int8 **saved)
{
#ifdef CONFIG_RTL865X_PCM
	int8 *nextToken;
	uint32  PageSize = PCM_PAGE_SIZE;
	int32 size;
	int32 ret = SUCCESS;
	int32 extPort, remPort;
	ipaddr_t extIp, remIp;
	int32 chid = 0;
	int32 mid = 0;
#ifdef CONFIG_RTL865X_VOIP
	voip_callback_t cb =
	{
		fpTick: NULL,
		fpPktRx:  voip_session_pktRx, /*function defined in PCM2.c*/
		fpPcmInt: voip_session_pcmInt,/*function defined in PCM2.c*/
		chid: 0,
	};
#endif
	voip_rtp_port_t rtp =
	{
		chid: 0,
		mid: 0,
	};

	cle_getNextCmdToken(&nextToken,&size,saved);
	if (!strcmp( nextToken, "start" ) )
	{
		int32 chid = PCM_CHANNEL0;
		int32 mid  = 0;
		int32 pcm_mode = PCM_LINEAR;

		cle_getNextCmdToken(&nextToken,&size,saved);
		chid = U32_value(nextToken);		/* Channel ID */

		cle_getNextCmdToken(&nextToken,&size,saved);
		mid = U32_value(nextToken);			/* Media ID */

		cle_getNextCmdToken(&nextToken,&size,saved);
		pcm_mode = U32_value(nextToken);	/* linear, a/u-law */

		pcm2_enableGCR_initRegs();
		/* 
		   PageSize may be different then your input
		   PCM_QUEU_SIZE etc are set in PCM2.h 
		   Time slot is the same as channel no. Possible TSA:
		   0(Slic TXS|RXS=1), 1(Slic TXS|RXS=9), 2(Slic TXS|RXS=17), 3
		 */
		if(pcm2_enable_channel(chid, pcm_mode,
			PCM_QUEU_SIZE, PCM_QUEU_SIZE, &PageSize, chid/*time slot*/) != SUCCESS )
		{
			rtlglue_printf("pcm2_enable_channel %d failed!\n", chid);
			return FAILED;
		}
		rtlglue_printf("865x PCM interface channel %d initialized!\n", chid);
#ifdef CONFIG_RTL865X_VOIP_G729
		set_mmd(0x2);/* 32 bit MAC saturation mode, Radiax saturate at 32 bit */
		Init_G729ab_Encoder();
		Init_G729ab_Decoder();
#endif
	}
	else if (!strcmp( nextToken, "stop" ) )
	{
		int32 chid = PCM_CHANNEL0;
		extern PCM_CHANNEL_t* pcmChan;
		
		if ( cle_getNextCmdToken(&nextToken,&size,saved) != FAILED )
		{
			chid = U32_value(nextToken);
		}

		if(pcmChan[chid].bEnable == TRUE)
		{
			pcm2_disable_channel(chid);
		}
		else
		{
			rtlglue_printf("PCM %d is not enabled before\n",chid);
		}
	}
	else if (!strcmp( nextToken, "debug" ) )
	{
		rtlglue_printf( "PktRx: %d   PcmInt: %d   PollPcmInt:%d\n", 
					voip_cntPktRx, voip_cntPcmInt, voip_cntPollPcmInt );
		rtlglue_printf( "TxOk0: %d   TxOk1: %d TxOk2: %d\n", 
					voip_cntTxOk0, voip_cntTxOk1, voip_cntTxOk2);
		rtlglue_printf( "RxOk0: %d   RxOk1: %d   RxOk2: %d\n", 
			voip_cntRxOk0, voip_cntRxOk1, voip_cntRxOk2);
		rtlglue_printf( "RxToVoip: %d   RxQEmpty: %d   RxFromPage: %d\n",
			voip_cntRxToVoip, voip_cntRxQEmpty, voip_cntRxFrPage);
		rtlglue_printf( "Tested value: %d\n", voip_testVal);
	}
	else if (!strcmp( nextToken, "tsa" ) )
	{
		rtlglue_printf("Test!!!\n");
	}
	else if ( !strcmp( nextToken, "add" ) || !strcmp( nextToken, "del" ) )
	{
		int mode; /* 0 - for add
		             1 - for del */

		if ( !strcmp( nextToken, "add" ) ) 
			mode = 0;
		else 
			mode = 1;
		
		/* External IP address or Channel ID */
		cle_getNextCmdToken(&nextToken,&size,saved);
		extIp =*((ipaddr_t *)nextToken);
		if ( extIp >= 0 && extIp <= 3 )
		{
			/* Channel ID */
			chid = extIp;

			/* Media ID */
			cle_getNextCmdToken(&nextToken,&size,saved);
			mid = U32_value(nextToken);

			/* External IP address */
			cle_getNextCmdToken(&nextToken,&size,saved);
			extIp =*((ipaddr_t *)nextToken);
		}

		/* External Port */
		cle_getNextCmdToken(&nextToken,&size,saved);
		extPort = U32_value( nextToken );
		
		/* Remote IP address */
		cle_getNextCmdToken(&nextToken,&size,saved);
		remIp =*((ipaddr_t *)nextToken);

		/* Remote Port */
		cle_getNextCmdToken(&nextToken,&size,saved);
		remPort = U32_value( nextToken );

		if ( mode == 0 )
#ifdef CONFIG_RTL865X_VOIP
			ret = voip_register_callback( chid, &cb );  /* add */
#else
			rtlglue_printf("Please define CONFIG_RTL865X_VOIP first\n");
#endif
		else
#ifdef CONFIG_RTL865X_VOIP
			ret = voip_register_callback( chid, NULL ); /* del */
#else
			rtlglue_printf("Please define CONFIG_RTL865X_VOIP first\n");
#endif
		if ( ret != SUCCESS )
		{
			rtlglue_printf( "voip_register_callback() return not success: %d\n", ret );
			return ret;
		}
		
		rtp.isTcp = FALSE;
		rtp.extIp = extIp;
		rtp.extPort = extPort;
		rtp.remIp = remIp;
		rtp.remPort = remPort;
		if ( mode == 0 )
#ifdef CONFIG_RTL865X_VOIP
			ret = voip_register_RTPport( chid, mid, &rtp ); /* add */
#else
			rtlglue_printf("Please define CONFIG_RTL865X_VOIP first\n");
#endif
		else
#ifdef CONFIG_RTL865X_VOIP
			ret = voip_register_RTPport( chid, mid, NULL ); /* del */
#else
			rtlglue_printf("Please define CONFIG_RTL865X_VOIP first\n");
#endif
		if ( ret != SUCCESS )
		{
			rtlglue_printf( "voip_register_RTPport() return not success: %d\n", ret );
			return ret;
		}

		if( mode == 0 )
		{
			rtlglue_printf( "A new session is established: "NIPQUAD2STR":%d <==> "NIPQUAD2STR":%d.\n",
		                NIPQUAD2(extIp), extPort, NIPQUAD2(remIp), remPort );
		}
		else
		{
			rtlglue_printf( "A session is deleted: "NIPQUAD2STR":%d <==> "NIPQUAD2STR":%d.\n",
		                NIPQUAD2(extIp), extPort, NIPQUAD2(remIp), remPort );
		}
	}
#else
	rtlglue_printf( "voip session needs to enable compile flag \"CONFIG_RTL865X_PCM\"\n");
#endif
	return SUCCESS;
}


cle_exec_t voip_cmds[] = 
{
	{	"pcm",
		"PCM test",
		" { randtest %d 'seed' %d'Repeat times' | compendertest %d'mode' | partner | reset | config %d'Channel' { status | uniform | u-law | a-law | loopback { enable | disable } | slot %d'Time slot' } | autotest %d'Channel' %d'Repeat times' %d'Random seed' | humantest %d'Channel' %d'Seconds' | run %d'mode' | go } ",
		_pcmTest,
		CLE_USECISCOCMDPARSER,
		0,
		NULL
	},
	{	"codec",
		"Codec test",
//		" { g729 | { g7231 { womenb | INEQC53 | TAMEC63H | CODEC63 | OVERC53H | OVERC63 | PATHC63H | PATHC53 | DTX53MIX | DTX63 | INEQD53 | OVERD53 } } | { g726 { { 0 { 1 | 2 | 3 | 4 } } | { 1 { 9 | 10 | 11 | 12 | 13 | 14 } } } } } [ %d'repeat' ] ",
              " { g729 | { g7231 { womenb | INEQC53 | TAMEC63H | CODEC63 | OVERC53H | OVERC63 | PATHC63H | PATHC53 | DTX53MIX | DTX63 | INEQD53 | OVERD53 } } | g726 } [ %d'repeat' ] [ %d'test_type' ] [ %d'seqnum' ]  ",
		_voipTest,
		CLE_USECISCOCMDPARSER,
		0,
		NULL
	},
	{	"session",
		"add a voip session",
		" { { add'Add a VoIP Session' [ %d'Channel ID' %d'Media ID' ] %ip'External IP Address' %d'External UDP port' %ip'Remote IP Address' %d'Remote UDP port' } | "
		"   { del'Delete a VoIP Session' [ %d'Channel ID' %d'Media ID' ] %ip'External IP Address' %d'External UDP port' %ip'Remote IP Address' %d'Remote UDP port' } | "
		"   { debug'for debug' } | "
		"   { tsa'for check time slot assignment' } | "
		"   { start'Start PCM' %d'Channel ID' %d'Media ID' %d'PCM mode 0: linear, 1: alaw, 2:ulaw' } | "
		"   { stop'Stop PCM' %d'Channel ID' %d'Media ID' } "
		" }",
		voip_session,
		CLE_USECISCOCMDPARSER,
		0,
		NULL
	},	
};

cle_grp_t _voipCmdGrpList[] = 
{
	{
		"spi",			    				/*cmdStr*/
		"Serial Peripheral Interface",		/*cmdDesc*/
		NULL,								/*cmdPrompt*/
		spi_cmds,	  			 			/*exec array*/
		NULL,		        				/*group array*/
		CMD_SPI_CMD_NUM,					/*exec number*/
		0,		            				/*group number*/
		0,		            				/*access level*/
	},	
};

