/*
* Copyright c                  Realtek Semiconductor Corporation, 2004
* All rights reserved.
* 
* Program : Forwarding Engine test module
* Abstract : 
* Creator : Edward Jin-Ru Chen (jzchen@realtek.com.tw)
* Author :  
*
* $Id: fwdTest.c,v 1.1.1.1 2006/07/26 05:38:29 blue Exp $
*
* $Log: fwdTest.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:29  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:24  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:00  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.195  2005/09/28 08:40:55  chenyl
* *: add internal function to set the permission of each forwarding decision
* 	- if it would apply SMAC filtering?
* 	- blocking this decision
* 	=> API:
* 		int32 _rtl8651_l34AdditionalExec_setParam(srcType,dstType,para)
* 		int32 _rtl8651_l34AdditionalExec_getParam(srcType,dstType,para)
*
* *: modify return value
* 	- WAN to WAN routing
* 		- if it be blocked, original return value is FWDENG_IP_WAN2WAN_ROUTING
* 			=> Modified to "FWDENG_DECISION_BLOCK"
*
* 	- Port bouncing
* 		- if it be blocked, original return value is FWDENG_L4_PORTBOUNCING
* 			=> Modified to "FWDENG_TO_GW"
*
* Revision 1.194  2005/09/27 01:45:05  yjlou
* +: test voip_register_RTPport() for twice.
*
* Revision 1.193  2005/09/22 06:54:00  shliu
* *: test case 5210 not return SUCCESS when finishing testing
*
* Revision 1.192  2005/09/21 04:23:28  shliu
* *: add a remote management test case
*
* Revision 1.191  2005/09/20 14:40:39  shliu
* *: add remote management test cases
*
* Revision 1.190  2005/09/15 16:03:42  chenyl
* +: ARP testing code
*
* Revision 1.189  2005/09/09 06:09:05  shliu
* *: modification of remote management test case
*
* Revision 1.188  2005/09/02 02:55:13  tony
* *: bug fixed: for pptp passthrough in multiple pppoe.
*
* Revision 1.187  2005/08/25 06:26:13  shliu
* *: modify test cases related to pppoe pkt from protocol stack
*
* Revision 1.186  2005/08/22 03:05:28  tony
* *: add a pptp re-init function call.
*
* Revision 1.185  2005/08/16 05:19:15  yjlou
* *: fixed testing code for random IP ID.
*
* Revision 1.184  2005/08/15 10:53:28  chenyl
* +: new TRIGGER PORT mechanism
* 	- sip check when activate Trigger Port.
* 	- age timer for Triggered Port Mapping.
*
* Revision 1.183  2005/08/12 08:49:12  shliu
* *: change protocol stack action registration with ip range instead of subnet mask.
*
* Revision 1.182  2005/07/19 05:05:01  chenyl
* *: for Protocol-Stack TX, unknown unicast and multicast DMAC would be L2-broadcasted to all member-ports of destination vlan.
* *: In l3fastActRouting(), system would check arp cache's integrity before using it.
* *: bug fix, NAPTed UDP fragmentation forwarding typing error.
*
* Revision 1.181  2005/07/11 07:25:53  shliu
* *: pptp/l2tp-related API has been modified.
*
* Revision 1.180  2005/07/11 05:53:01  tony
* *: bug fixed: for ALG battlenet
*
* Revision 1.179  2005/07/08 02:38:01  chenyl
* *: modify ip when doning RSVP NAPT in/out H.323 related process.
* *: Let RSVP callback function returning value to indicate RSVP process was been ignored if it don't do anything.
*
* Revision 1.178  2005/06/20 13:51:19  yjlou
* *: moves common macro from 'fwdTest.c' to 'fwdTest.h' for model code to include.
*
* Revision 1.177  2005/06/19 05:38:54  yjlou
* *: fixed for the change of ipsec initial allocation.
*
* Revision 1.176  2005/06/07 15:12:53  shliu
* *: change addNaptMappingExt to addDriverNaptMapping
*
* Revision 1.175  2005/06/01 05:38:04  chenyl
* *: return SUCCESS after test-case done successfully.
*
* Revision 1.174  2005/05/23 12:53:42  yjlou
* *: rename rtl8651_timeUpdate() to rtl8651_realtimeSchedule().
* +: ROME driver supports realtime PCM and tick interrupt for VoIP.
*
* Revision 1.173  2005/05/06 12:23:16  chenyl
* *: for outbound packet which match upnp mapping, ROME Drvier would use the mapped external ip/port
* 	to contribute this connection.
*
* *: tony: fix tcp upnp qos support problem.
*
* Revision 1.172  2005/05/04 13:19:06  chenyl
* *: bug fix: when turn the "TCP/UDP static port mapping" and the source IP/Port
* 	    is in uPnP/triggerPort map and the internal Port == External Port in that map,
* 	    then in these cases, static port mapping is still work.
*
* Revision 1.171  2005/04/30 07:32:41  yjlou
* +: add VoIP supporting of ROME driver
*
* Revision 1.170  2005/04/30 04:19:49  chenyl
* +: support (L2-Packet-filling + L3-Forwarding) offload Engine
*
* Revision 1.169  2005/04/14 12:58:05  shliu
* *: Add new acl matchType testing case.
*
* Revision 1.168  2005/04/02 08:47:32  chenyl
* *: bug fix: server port overlapping check without regardless of TCP/UDP
*
* Revision 1.167  2005/04/01 10:41:57  chenyl
* *: when decision table result is 'DROP', we return it with return value 'FWDENG_DECISION_DROP'
*    and default drop it in Forwarding Engine.
*
* Revision 1.166  2005/03/28 12:17:17  chenyl
* +: Exception List for NAPT-Redirect system
*
* Revision 1.165  2005/03/28 06:01:51  chenyl
* *: NAPT redirect without DIp/Dport modification
*
* Revision 1.164  2005/03/24 09:48:21  chenyl
* *: midify code for new Protocol Stack send process (let HW do L3/L4 checksum)
*
* Revision 1.163  2005/03/14 15:33:12  chenyl
* *: modify IP fragment packet trapping mechanism for ProtocolStack cached flow
*
* Revision 1.162  2005/03/14 14:40:15  chenyl
* *: bug fix: protocol-stack flow cache, fragment packet forwarding
*
* Revision 1.161  2005/03/09 09:07:46  chenyl
* *: fix mbuf leak bug
*
* Revision 1.160  2005/03/07 16:39:28  chenyl
* *: free mbuf after test
*
* Revision 1.159  2005/02/25 07:49:06  chenyl
* *: spanning tree function patch up
* 	- update multicast spanning tree port state with unicast port state simultaneously.
* 	- trap 80211D packet instead of broadcast it.
* 	- set FWD state to non-bridge port
* 	- Don't support Extension port spanning tree management, so we set FWD state to Extension ports.
* 	- enable spanning tree process in SW ROMEDRV packet forwarding ( filter all NON-FWD-State port for
* 	  ROMEDRV packet forwarding packets and protocol stack sending packet).
*
* Revision 1.158  2005/02/16 02:15:12  chenyl
* +: Forwarding Engine Trapping Dispatch system:
* 	When one packet must to be trapped to upper-layer protocol stack,
* 	User can decide how to dispatch this packet into different "categories"
* 	according to its 'l4protocol/source IP/destination IP/source Port (TCP/UDP)/
* 	destination Port (TCP/UDP)' with wide-card allowed. The category
* 	number is decided by user and will be set into ph_category in packet header.
* 	Fragment packet's test is passed.
*
* +: Forwarding Engine QoS Send:
* 	Protocol stack packet send with high TX queue used.
*
* Revision 1.157  2005/01/11 07:49:14  chenyl
* *: bug fix : PPTP/L2TP header encap/decap's bug
* 	- packet from loopbackVlan --> outbound
* 	- packet from wanVlan --> inbound
* 	- modify m_data when decapsulating PPTP/L2TP header
*
* Revision 1.156  2005/01/11 07:41:06  yjlou
* +: add ipsecTestFrag()
*
* Revision 1.155  2005/01/11 06:57:00  tony
* *: fix ALG directX Server issue.
*
* Revision 1.154  2004/12/28 08:46:29  yjlou
* *: specify IPSEC replay window size.
*
* Revision 1.153  2004/12/17 13:15:48  yjlou
* +: add ipsecTestBasic1();
*        ipsecTestBasic2();
*        ipsecTestBasic3();
*        ipsecTestBasic4();
*        ipsecTestError();
*
* Revision 1.152  2004/12/14 09:48:10  chenyl
* +: NAPT-Connection Control system
* *: add "NAPT-AddFail" error messages into ignore case.
*
* Revision 1.151  2004/12/07 02:15:41  chenyl
* *: bug fix : Protocol Stack Flow cache
* +: hooking code for ACL-process dispatch
* +: add testing cases for Policy Route and Remote Management
*
* Revision 1.150  2004/12/02 06:17:12  chenyl
* +: add testing cases about Mutli-session fragment packet forwarding.
* *: activate New _rtl8651_l34PacketProcess and rewrite _rtl8651_l34ActExec
*
* Revision 1.149  2004/11/15 06:09:45  chenyl
* *: bug fix : multicast flow-cache update bugs
* 		- flow-cache might cause age-counting error in some cases
* 		- must filter source vlan/port when add multicast member to flow-cache
* 		- don't remove node as multicast upstream when that node send LEAVE
*
* Revision 1.148  2004/11/11 09:03:45  chenyl
* *: continue checking trigger port entry after one-entry check fail
* *: some minor-modify
*
* Revision 1.147  2004/11/05 05:28:26  chenyl
* +: add test case for fragment-multicast packet forwarding test
*
* Revision 1.146  2004/10/21 03:01:54  yjlou
* *: fixed for PPPOE_PASSTHRU_NEW_MODEL
*
* Revision 1.145  2004/10/08 03:15:05  yjlou
* +: add pkt_pppoe_passthru_without_vlan1()
*
* Revision 1.144  2004/10/07 13:16:40  chenyl
* +: uPnP entry checking for Port Bouncing
*
* Revision 1.143  2004/10/06 14:18:43  tony
* *: fix bug for CDRouter test case
*
* Revision 1.142  2004/10/06 14:04:29  tony
* *: fix H323 test case
*
* Revision 1.141  2004/10/05 16:04:30  yjlou
* *: rtl8651_timeUpdate() has renamed to _rtl8651_timeUpdate().
*
* Revision 1.140  2004/09/22 14:18:12  yjlou
* +: add pkt_pppoe_passthru_vlan_index() function
*
* Revision 1.139  2004/09/22 13:25:25  yjlou
* +: add pkt_pppoe_passthru_drop_unknown()
*
* Revision 1.138  2004/09/20 07:35:18  chenyl
* *: non-TCP/UDP/ICMP DMZ forward
* *: unicast IGMP forward
*
* Revision 1.137  2004/09/16 11:50:21  tony
* +: add PPTP pass-throught software (not change call ID) case.
*
* Revision 1.136  2004/09/16 05:43:32  chenyl
* *: multicast: remove/modify temporary APIs
* 		- rtl8651_multicastSetUpStream: remove 'port'
* 		- remove temp APIs add/del-ExternalMulticastPort();
* +: multicast: dynmaic upstream port selection
* 		- if upstream vlan (set by rtl8651_multicastSetUpStream) has multiple WAN port,
* 		  system will dynamically select one active port of it to forward.
*
* Revision 1.135  2004/09/15 16:14:28  chenyl
* +: enable multicast forward cache
*
* Revision 1.134  2004/09/10 03:30:49  tony
* *: patch for CDRouter test case
*
* Revision 1.132  2004/09/07 14:52:13  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.131  2004/09/02 13:53:12  chenyl
* *: bug fix, send periodic-query immediately when turn-on this function even in start-up phase
*
* Revision 1.130  2004/09/02 09:04:59  chenyl
* *: napt-redirect: fragment packet support
*
* Revision 1.129  2004/09/02 06:15:38  chenyl
* *: multicast :
* 	- when turning-on ip-multicast, periodic query will be sent immediately
* +: tbldrv
* 	- add options when run addNaptConnection
* 		- PURE_SW: pure software entry
* 		- DONT_CHECK_INTIP: ignore internal IP checking
* 		- TO_PROTOCOL_STACK: this napt packet must be trapped to protocol stack
* +: forwarding engine:
* 	- protocol stack TCP/UDP flow cache
* 	- napt redirect register/unregister/query
*
* Revision 1.128  2004/08/31 03:16:43  chhuang
* +: new testing code for nexthop
*
* Revision 1.127  2004/08/30 05:19:47  tony
* *: fix bug - the path of PPTP server to protocol stack is failed.
*
* Revision 1.126  2004/08/24 07:24:59  chenyl
* *: re_core. modify COMPILE_FLAG
* *: forwarding engine: bug fix, URL Filter match bug
* *: testing code for PPTP header compression
* *: PPTP testing cases re-numbering
*
* Revision 1.125  2004/08/19 11:19:05  chenyl
* +: port bouncing: add the garbage collection mechanism to port bouncing entry
* 	- recycle the TCP port bouncing flow entry for new flow if it in CLOSE state
* +: testing cases for bug fix
*
* Revision 1.124  2004/08/18 14:17:31  chenyl
* *: forwarding engine : let some code be endian free/modify some return value
* +: testing cases for bug fix
*
* Revision 1.123  2004/08/17 14:26:01  chhuang
* *: _rtl8651_l4IcmpNaptAliasOut2() should use cache route information
*
* Revision 1.122  2004/08/17 12:30:00  chenyl
* *: add port config to multicast default upstream setting API
*
* Revision 1.121  2004/08/17 05:20:57  yjlou
* *: pkt_pppoe_passthru() fixed for extPort
*
* Revision 1.120  2004/08/17 02:39:59  chhuang
* *: regular update
*
* Revision 1.119  2004/08/16 12:31:28  chenyl
* +: test case for udp blocking
*
* Revision 1.118  2004/08/12 13:20:11  chenyl
* +: testing case for remote management fragment packet support
*
* Revision 1.117  2004/08/12 11:41:36  chenyl
* *: let rtl8651_aliasProtoStackSentPkt been framgnet free...
*
* Revision 1.116  2004/08/12 08:47:41  chenyl
* *: fast path with ipQueue checking
* *: fast path routing cache checking
*
* Revision 1.115  2004/08/11 05:19:06  chenyl
* +: weak TCP napt checking
* *: modify: for TCP napt outbound packet, if packet is (SYN+ACK) and no any entry found,
* 		forwarding engine will trap this packet and return FWDENG_TCP_NAPT_OUT_NOTFOUND
* 		insteads of dropping it silently.
*
* Revision 1.114  2004/08/10 02:20:18  tony
* *: change memo.
*
* Revision 1.113  2004/08/09 12:23:19  chenyl
* *: bug fix: many minor bugs:
* 	- tcp checksum adjustment
* 	- napt flow routing cache
* 	- napt udp fast path
* 	- napt policy route
* 	- l34PacketProcess destination type recognition
* 	- forbid NAPT piggyback SYN packet
*
* Revision 1.112  2004/08/06 15:14:08  chenyl
* *: fully checked TCP/UDP static-port-translation
*
* Revision 1.111  2004/08/06 09:40:50  chenyl
* *: enable TCP/UDP NAPT static-port-translation
* *: rename from looseUDP to InexactUDP
*
* Revision 1.110  2004/08/05 06:39:11  chenyl
* +: fragment shortest path forwarding
* *: UDPBomb don't aware ignore Type Checking result
*
* Revision 1.109  2004/08/03 10:44:41  chenyl
* +: looseUDP (re-commit previous commit is failed due to DISK space's full)
*
* Revision 1.108  2004/08/03 10:21:56  chenyl
* +: loose UDP
*
* Revision 1.107  2004/07/28 10:48:20  chenyl
* *: bug fix : [re_core.c]
* 		- rtl865x_fastRx: queue-packets to Protocol Stack and failed, free Mbuf ERROR
* *: bug fix : [swNic2.c]
* 		- swNic_write: process ERROR when mbuf padding failed
* *: bug fix : [rtl8651_tblDrvFwd.c]
* 		- _rtl8651_l34ActExec: process _RTL8651_NAT_IGNORE in _RTL8651_NPT case
* *: bug fix : [rtl8651_tblDrvFwd.c]
* 		- rtl8651_fwdEngineInput: when process result is FWDENG_ACL_DROP_NOTIFY,
* 				we must either generate ICMP Error message with newly allocated packet and trap
* 				the original packet, or generate ICMP Error message using original packet and return
* 				SUCCESS.
* 				we can not send ICMP Error message with the original packet and trap it to Procotol Stack.
*
* Revision 1.106  2004/07/26 14:45:43  chenyl
* +: new logging model
* +: dos Ignore Case
* 	- ignore packets from LAN
* 	- ignore packets from WAN
*
* Revision 1.105  2004/07/26 08:49:36  tony
* +: add PPTP Server in LAN test module.
*
* Revision 1.104  2004/07/19 14:06:08  chenyl
* *: bug fix: ignore L4 checksum when comparing packets
*
* Revision 1.103  2004/07/19 12:54:43  chenyl
* *: bug fix: process udp packets withc zero-checksum
* *: bug fix: process L3/L4 packets whose ip-header length is not 20 byte
* +: add testing functions to compare/clear checksum field of mbuf/pkthdr
*
* Revision 1.102  2004/07/16 03:05:58  tony
* +: add test module for pptp_idle_timeout and l2tp_idle_timeout case.
*
* Revision 1.101  2004/07/14 14:45:35  chenyl
* *: modify www interface
* *: fix fwdTest mbuf
*
* Revision 1.100  2004/07/14 06:55:55  tony
* +: add remote management test case.(web port fowrad and icmp disable)
*
* Revision 1.99  2004/07/14 06:52:45  yjlou
* +: add pkt_ras_dialondemand() function to ensure RAS Dial-on-Demand is OK
*
* Revision 1.98  2004/07/13 13:52:06  yjlou
* +: ROME driver supports IPv6 passthru forwarding even when protocol-based VLAN is created.
*
* Revision 1.97  2004/07/13 09:46:49  yjlou
* +: support RAS idle timeout
*
* Revision 1.96  2004/07/12 04:25:36  chenyl
* *: extend existing port scan mechanism
*
* Revision 1.95  2004/07/08 04:11:05  yjlou
* +: ROME driver supports PPPoE passthru forwarding even when protocol-based VLAN is created.
* -: PPPoE passthru no more monitor the control messages.
*
* Revision 1.94  2004/07/05 11:32:47  chenyl
* +: dynamically turn-ON/OFF port bouncing
*
* Revision 1.93  2004/07/02 10:30:08  chenyl
* *: bug fix: per-source Flooding check bug (counter error)
* *: bug fix: ip-spoofing ACL add function error
* *: bug fix: ICMP ping-of-death : threshold from 65500 to 65535 (follows cisco)
* *: bug fix: item name change of DOS check: UDP Bomb -> UDP EchoChargen (follows cisco)
* +: new feature: New DoS check item, UDP Bomb
* 		- Triggered if (Length of UDP header) < (Length of IP header)
* 		- allow (Length of UDP header) > (Length of IP header)
* 		- follows cisco
*
* Revision 1.92  2004/06/30 02:53:57  chhuang
* +: add new testing case for MTU
*
* Revision 1.91  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.90  2004/06/25 13:53:11  chhuang
* +: add new testing case for MTU fragment
*
* Revision 1.89  2004/06/24 10:01:38  jzchen
* +: Modify PPTP passthrough testing code to auto-learn engine modified ID for testing code to be hashing algorithm independent
*
* Revision 1.88  2004/06/21 07:09:30  chhuang
* *: bug fixed for pkt_napt_normal1
*
* Revision 1.87  2004/06/15 05:53:22  chhuang
* +: add new testing code
*
* Revision 1.86  2004/06/14 11:04:23  yjlou
* *: replace CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU and CONFIG_RTL865XB_EXP_IPV6_PASSTHRU with CONFIG_RTL865XB_EXP_IPV6_PASSTHRU
*
* Revision 1.85  2004/06/11 14:00:37  jzchen
* +: Add forwarding engine part PPPoE session not existed termination testing item
*
* Revision 1.84  2004/06/10 03:27:17  jzchen
* +: confPppoeHSA add pppoe session ID assignment parameter
* +: Add pppoe counter tx/rx testing code into pkt_napt_policy1
*
* Revision 1.83  2004/06/09 08:16:24  yjlou
* *: commit for modified layer2.c (chenyl fixed bug).
*
* Revision 1.82  2004/06/07 13:07:03  yjlou
* +: Supporting IPv6 Passthru
* *: ACL testing code is modified with sequence template.
*
* Revision 1.81  2004/06/03 06:46:10  chenyl
* *: queue-all fragment packet only when tear-drop check enabled
* *: modify module test for auto zero bit padding
*
* Revision 1.80  2004/05/27 05:04:07  chhuang
* use new PPPoE data structure and the data structure merges PPTP/L2TP and PPPoE to a
* single data structure
*
* Revision 1.79  2004/05/25 13:31:04  yjlou
* -: remove CONFIG_RTL865XB_EXP_PROTOCOL_BASED_NAT compile flag
*
* Revision 1.78  2004/05/21 12:08:50  chenyl
* *: TCP/UDP/ICMP spoof -> check for (sip) == (dip)
* *: modify DOS prevention webpage
*
* Revision 1.77  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.76  2004/05/19 16:09:57  yjlou
* +: add rtl8651_EnablePppoePassthru() to enable/disable PPPoE passthru.
*
* Revision 1.75  2004/05/19 14:01:26  yjlou
* +: support Protocol-Based NAT
*
* Revision 1.74  2004/05/17 12:14:05  cfliu
* no message
*
* Revision 1.73  2004/05/12 07:20:15  chenyl
* +: source ip blocking
* *: modify dos mechanism
*
* Revision 1.72  2004/05/06 08:04:09  chhuang
* add testing code for MAC filtering
*
* Revision 1.71  2004/05/05 07:30:07  chenyl
* +: arp-proxy testing case
* *: bug fix in tblDrv addArp function
*
* Revision 1.70  2004/05/05 04:28:50  chenyl
* +: arp proxy
* *: bug fix (L2TP/PPTP) in layer2fwd.c
*
* Revision 1.69  2004/05/04 12:46:27  chenyl
* *: modify ipQueue/multicast system
*         +:  ipQueue:   can constraint total queued packet only
*         +:  multicast: can constraint total member only
*         *:  allocate table when ipQueue/Multicast init()
*         *:  if table size == 0 , ipQueue/Multicast system become disable
*         *:  switch to turn on/off Multicast system dynamically
*
* *: add CLE command to turn on/off ipQueue/ Multicast system
*
* *: change the init method: init ipQueue/multicast system in rtl8651_fwdEngineInit(configPara)
*    and set initial value using "configPara"
*
* Revision 1.68  2004/05/04 11:20:29  tony
* add comments for ALG
*
* Revision 1.67  2004/05/04 09:14:22  yjlou
* *: fixed the test case of PPPoE passthru
*
* Revision 1.66  2004/05/04 07:41:31  yjlou
* +: add comments
*
* Revision 1.65  2004/05/03 06:47:57  chenyl
* *: don't SYS_ID always set to 1 when we run module test
*
* Revision 1.64  2004/04/30 08:58:08  chenyl
* +: ip multicast/igmp proxy
*
* Revision 1.63  2004/04/22 10:09:19  tony
* fix bug: in case pptp_test8() and l2tp_test8()
*
* Revision 1.62  2004/04/21 11:56:58  yjlou
* *: 50B supports protocol-based VLAN PPPoE passthru.
*
* Revision 1.61  2004/04/20 14:31:28  yjlou
* +: add CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU compile flag.
*    (Warning: 5XB Protocol-Based VLAN PPPoE Passthru is still empty)
*
* Revision 1.60  2004/04/19 13:55:11  tony
* modify l2tp_test8 module.
*
* Revision 1.59  2004/04/19 09:01:16  yjlou
* +: add test code for PPPoE Passthru:
*    pkt_pppoe_passthru()
*
* Revision 1.58  2004/04/15 10:38:24  tony
* add PPTP/L2TP test module.
*
* Revision 1.57  2004/04/08 02:40:29  chenyl
* *: when PKTHDR_PPPOE_AUTOADD is set, we don't modify ethertype to 0x8864
*
* Revision 1.56  2004/04/07 11:29:33  chenyl
* *: bug fix in fwd-engine : remove "isToEthBcast"
* +: rtl8651_fwdEngineProcessIPFragment(enable) to enable/disable ipQueue system
* 	enable : fragment packets are processed by fwdeng
* 	disable: fragment packets are trapped to protocol stack
*
* Revision 1.55  2004/04/06 02:52:33  chenyl
* *: Set CSUM_L4 for routing packets with pkt type is PKTHDR_IP
*
* Revision 1.54  2004/04/06 01:53:52  chenyl
* +: new testing cases
*
* Revision 1.53  2004/04/03 08:46:36  chenyl
* +: static mode (No malloc/free) of Ip-Queue system
*
* Revision 1.52  2004/04/02 10:47:36  chenyl
* *: modify tear-drop testing case for negative list
*
* Revision 1.51  2004/04/01 08:18:58  chhuang
* remove debug message
*
* Revision 1.50  2004/03/25 08:58:22  chenyl
* *: new testing cases for fragment packet to protocol stack
*
* Revision 1.49  2004/03/24 09:50:37  chenyl
* +: Queued pkts to CPU
*
* Revision 1.48  2004/03/22 12:30:35  chenyl
* *: new testing cases
*
* Revision 1.47  2004/03/19 06:25:30  chenyl
* +: new testing cases
*
* Revision 1.46  2004/03/18 09:17:13  tony
* fix bug: ALG not reinit when test module start.
*
* Revision 1.45  2004/03/18 07:25:01  chenyl
* +: new testing cases for portbouncing
*
* Revision 1.44  2004/03/18 05:39:42  tony
* add IPSec Client ALG test module.(ESP path)
*
* Revision 1.43  2004/03/18 03:09:20  tony
* add IPSec Client ALG test module(ISAKMP path).
*
* Revision 1.42  2004/03/18 01:59:09  tony
* add PPTP Client ALG test module.
*
* Revision 1.41  2004/03/17 08:21:33  tony
* fix bug: ftp client ALG test module. (for gateway selected port range is 32768~655xx)
*
* Revision 1.40  2004/03/16 15:11:46  chenyl
* +: new testing cases for IP-Unnumbered -> DMZ Host port bouncing
* *: fix default mac bug (default mac is set to multicast mac addr)
*
* Revision 1.39  2004/03/16 12:58:16  tony
* add NetMeeting Server ALG test module.
*
* Revision 1.38  2004/03/16 09:21:24  tony
* add NetMeeting Client ALG test module.
*
* Revision 1.37  2004/03/16 07:52:12  tony
* add L2TP Client ALG test module.
*
* Revision 1.36  2004/03/16 06:46:48  chenyl
* *: testing cases modification
*
* Revision 1.35  2004/03/16 03:51:19  tony
* add CUseeMe Client ALG test module.
*
* Revision 1.34  2004/03/15 13:23:52  chenyl
* +: new testing cases for fragment packet
*
* Revision 1.33  2004/03/15 13:03:34  tony
* add Counter-Strike client ALG test module.
*
* Revision 1.32  2004/03/15 12:48:07  tony
* add Battlenet ALG test module.
*
* Revision 1.31  2004/03/15 12:08:03  tony
* add Quake Client ALG test module.
*
* Revision 1.30  2004/03/15 11:32:38  tony
* add VDOlive Client ALG test module.
* add RealAudio Client ALG test module.
*
* Revision 1.29  2004/03/15 10:03:14  tony
* add SIP Server ALG test module.
*
* Revision 1.28  2004/03/15 09:28:58  tony
* fix bug: sip test module, the packet content can't trigger ALG addUpnpMapping function.
*
* Revision 1.27  2004/03/15 09:09:41  tony
* add SIP Client ALG test module.
*
* Revision 1.26  2004/03/12 08:18:18  chenyl
* *: add rtl8651_fwdEngineIcmpRoutingMsg()
*
* Revision 1.25  2004/03/12 01:42:03  chenyl
* +: new testing cases for ICMP TIMEXCEED reply
* *: eliminate error packet's L3/4 checksum in mbuf-compare function
*
* Revision 1.24  2004/03/09 05:16:41  chenyl
* *: new testing cases
*
* Revision 1.23  2004/03/08 10:45:59  chenyl
* +: rtl8651_fwdEngineIcmpToDMZHost()
* 	set if fwdeng need to forward ICMP echo/tstamp request to DMZ host or not
*
* Revision 1.22  2004/03/08 05:34:40  tony
* add DirectX7 Server ALG test module.
*
* Revision 1.21  2004/03/08 02:46:19  tony
* add DirectX 7 Client ALG test module.
*
* Revision 1.20  2004/03/05 08:16:17  chenyl
* +: new cases dip = multicast ip, dmac = gw mac
* *: modify policy route config, only 2 session allowed
*
* Revision 1.19  2004/03/05 02:57:23  tony
* add ICUII ALG test module.
*
* Revision 1.18  2004/03/04 10:30:37  tony
* add ICQ ALG test module.(support version 2000b~2003a)
*
* Revision 1.17  2004/03/04 09:45:40  chenyl
* *: move some MACROs from fwdTest.c to drvTest.h
*
* Revision 1.16  2004/03/04 09:35:38  chenyl
* *: assert->ASSERT
*
* Revision 1.15  2004/03/04 09:19:12  chenyl
* *: remove tblDrvReinit() function call
*
* Revision 1.14  2004/03/04 02:35:07  chenyl
* *: testing cases
*
* Revision 1.13  2004/03/03 09:17:00  tony
* add Yahoo Messenger ALG test module.
*
* Revision 1.12  2004/03/03 06:22:55  tony
* add IRC ALG test module.
*
* Revision 1.11  2004/03/03 03:29:54  chenyl
* *: new testing case, fix icmp-pkt-generating-function's bug
*
* Revision 1.10  2004/03/02 12:08:12  tony
* add ALG Server test module.
*
* Revision 1.9  2004/03/02 10:40:48  chenyl
* *: uncomment vlanIdx checking, and modify testing cases
*
* Revision 1.8  2004/03/02 08:20:46  tony
* add ALG Client test module
*
*
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "mbufGen.h"
#include "rtl8651_ipQueue.h"
#include "rtl8651_ipQueue_local.h"
#include "rtl8651_multicast.h"
#include "rtl8651_multicast_local.h"
#include "rtl8651_tblDrvFwdLocal.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_dos.h"
#include "rtl8651_dos_local.h"
#include "rtl8651_alg_init.h"
#include "PktProc/pktGen.h"
#include "fwdTest.h"
#include "drvTest.h"
#include "rtl8651_ipsec.h"
#ifdef CONFIG_RTL865X_VOIP
	#include "asicRegs.h"
	#include "voip_support.h"
#endif


/*
		Data comparison macros and functions
*/ 
// less or equal
static int32 value_LE(int32 val1, int32 val2, int8 *_fun_, uint32 _line_){
	IS_LE_INT("first value is larger than the second one!", val1, val2, _fun_, _line_);
	return SUCCESS;
}
// less or equal
static int32 value_GE(int32 val1, int32 val2, int8 *_fun_, uint32 _line_){
	IS_GE_INT("first value is not larger than the second one!", val1, val2, _fun_, _line_);
	return SUCCESS;
}

static int32 value_cmp(int32 val1, int32 val2, int8 *_fun_, uint32 _line_){
	IS_EQUAL_INT("value not equal!", val1, val2, _fun_, _line_);
	return SUCCESS;
}
static int32 value_neq(int32 val1, int32 val2, int8 *_fun_, uint32 _line_){
	IS_NOT_EQUAL_INT("value is equal!", val1, val2, _fun_, _line_);
	return SUCCESS;
}

static int32 str_cmp(char *str1, char *str2, int8 *_func_, uint32 _line_){
	IS_EQUAL_STR("string not equal!!", str1, str2, _func_, _line_);
	return SUCCESS;
}

static int32 napt_cmp(rtl8651_tblDrv_naptTcpUdpFlowEntry_t* tb, ipaddr_t insideLocalAddr, uint16 insideLocalPort,
		ipaddr_t insideGlobalAddr, uint16 insideGlobalPort, ipaddr_t RemoteAddr, uint16 RemotePort, int8* _fun_, uint32 _line_){
	if (tb == NULL){
		printf("\t%s(%u): %s: null\n", _fun_, _line_, "napt entry");
		return FAILED;
	}
	if (insideLocalAddr != 0)	IS_EQUAL_IP("insideLocalAddr", insideLocalAddr, tb->insideLocalIpAddr,_fun_,_line_);
	if (insideLocalPort != 0)	IS_EQUAL_INT("insideLocalPort", insideLocalPort, tb->insideLocalPort,_fun_,_line_);
	if (insideGlobalAddr != 0)	IS_EQUAL_IP("insideGlobalAddr", insideGlobalAddr, tb->insideGlobalIpAddr,_fun_,_line_);
	if (insideGlobalPort != 0)	IS_EQUAL_INT("insideGlobalPort", insideGlobalPort, tb->insideGlobalPort,_fun_,_line_);
	if (RemoteAddr != 0)		IS_EQUAL_IP("RemoteAddr", RemoteAddr, tb->dstIpAddr,_fun_,_line_);
	if (RemotePort != 0)		IS_EQUAL_INT("RemotePort", RemotePort, tb->dstPort,_fun_,_line_);
	return SUCCESS;
}

static int32 nat_cmp(rtl8651_tblDrv_natEntry_t* tb, ipaddr_t localAddr, ipaddr_t globalAddr, int8* _fun_, uint32 _line_){
	if (tb == NULL){
		printf("\t%s(%u): %s: null\n", _fun_, _line_, "nat entry");
		return FAILED;
	}
	if (localAddr != 0) IS_EQUAL_IP("localAddr", localAddr, tb->localIp, _fun_, _line_);
	if (globalAddr != 0) IS_EQUAL_IP("globalAddr", globalAddr, tb->globalIp, _fun_,  _line_);
	return SUCCESS;
}

#define VALUE_CMP(val1, val2) 						if( value_cmp((int32)val1, (int32)val2, __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define VALUE_GE(val1, val2)	 						if( value_GE((int32)val1, (int32)val2, __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define VALUE_LE(val1, val2)	 						if( value_LE((int32)val1, (int32)val2, __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define VALUE_NEQ(val1, val2) 						if( value_neq((int32)val1, (int32)val2, __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define MBUF_CMP(mbuf1, mbuf2)						if (mbuf_cmp(mbuf1, mbuf2, __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define CKSUM_CMP(mbuf1, mbuf2, flag)				if (checksum_cmp(mbuf1, mbuf2, (flag|TEST_CSUM_1SCMODE), __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define CKSUM_CMP_SKIPUDPZERO(mbuf1, mbuf2, flag)	if (checksum_cmp(mbuf1, mbuf2, (flag|TEST_CSUM_1SCMODE|TEST_CSUM_IGNOREUDP0), __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define NAPT_CMP(tb, iLA, iLP, iGA, iGP, RA, RP)			if (napt_cmp(tb, iLA, iLP, iGA, iGP, RA, RP, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define NAT_CMP(tb, lA,gA) 							if (nat_cmp(tb, lA, gA, __FUNCTION__, __LINE__)==FAILED) return FAILED;
#define STR_CMP(s1, s2)								if (str_cmp((char*)s1, (char*)s2, __FUNCTION__, __LINE__) == FAILED) return FAILED;
#define MSG(s1)							printf("\t%s(%u): %s \n", __FUNCTION__, __LINE__, s1);
#define MBUF_CMPandFREE(m1, m2) \
	do { \
		struct rtl_mBuf *m3; \
		struct rtl_mBuf *m4; \
		m3 = m1;\
		m4 = m2;\
		if (m3 && m4)\
		{ MBUF_CMP(m3, m4); }\
		if (m3) { freeMbuf(m3); } else {printf ("MBUF_CMPandFREE: (FAIL) mbuf 1 is NULL\n");}\
		if (m4) { freeMbuf(m4); } else {printf ("MBUF_CMPandFREE: (FAIL) mbuf 2 is NULL\n");}\
	}while(0)

int32 mbuf_test1(uint32 caseNo){
	int i,j;
	rtl8651_PktConf_t conf;
	struct rtl_mBuf* buff[10];
	int8 content[512];

	START_TEST_CASE();

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;
	conf.payload.content				= content;
	conf.payload.length				= sizeof(content);

	for (i = 0 ; i < 10 ; i++){
		// Allocate mbuf
		for (j = 0 ; j < 10 ; j++)
			buff[j] = genMbufPkt(&conf);
		// Free mbuf
		for (j = 0 ; j < 10 ; j++)
			freeMbuf(buff[j]);
	}
	return 0;
}

/*****************************************************************
*****************************************************************/
#define FWDENG_INPUT(retval, hdr) \
	do { \
		if (!hdr) { printf("FWDENG_INPUT : (FAIL) hdr == NULL\n"); retval = FWDENG_DROP; break;} \
		mbufList_Reinit(); \
		log_reinit(); \
		retval = rtl8651_fwdEngineInput((void *)hdr); \
	}while (0)
#define FWDENG_L3OFFLOAD(retval, hdr, l3Len, cksumOffload, highPriority) \
	do { \
		if (!hdr) { printf("FWDENG_OFFLOAD : (FAIL) hdr == NULL\n"); retval = FWDENG_DROP; break;} \
		mbufList_Reinit(); \
		log_reinit(); \
		retval = rtl8651_offloadEngineL3Send((void *)hdr, l3Len, cksumOffload, highPriority); \
	}while (0)
/* GW_PORTMASK_OUTPUT would NOT translate port number to port mask */
#define GW_PORTMASK_OUTPUT(retval, hdr, dvid, ipOffset) \
	do { \
		mbufList_Reinit(); \
		log_reinit(); \
		retval = rtl8651_fwdEngineSend((void *)hdr, dvid, ipOffset); \
	}while (0)
#define GW_OUTPUT(retval, hdr, dvid, ipOffset) \
	do { \
		hdr->ph_portlist = 1 << hdr->ph_portlist; \
		mbufList_Reinit(); \
		log_reinit(); \
		retval = rtl8651_fwdEngineSend((void *)hdr, dvid, ipOffset); \
	}while (0)
#define GW_QOS_OUTPUT(retval, hdr, dvid, ipOffset, qualityId) \
	do { \
		hdr->ph_portlist = 1 << hdr->ph_portlist; \
		mbufList_Reinit(); \
		log_reinit(); \
		retval = rtl8651_fwdEngineQosSend((void *)hdr, dvid, ipOffset, qualityId); \
	}while (0)
#define GW_SET_DOSSTATUS(status) \
	do { \
		int i; \
		for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++) \
			rtl8651a_setDosStatus(i, status);\
	}while (0)
#define GW_SET_DOS_THRESHOLD(type,threshold,item) \
	do { \
		int i; \
		for (i = 0 ; i < RTL8651_MAX_DIALSESSION ; i ++) \
		{ \
			if (item == 0) /* whole system */ \
				rtl8651a_setDosThreshold(i, type, threshold); \
			else /* per source */ \
				rtl8651a_setPerSrcDosThreshold(i, type, threshold); \
		} \
	}while (0)
/*****************************************************************
		functions for fragment packets
*****************************************************************/
#define FRAG_DEQUEUE(mbuf, mbufq) \
	do { \
		mbuf = mbufq; \
		if (mbufq->m_pkthdr->ph_nextHdr) {\
			mbufq = mbufq->m_pkthdr->ph_nextHdr->ph_mbuf; \
		}\
		mbuf->m_pkthdr->ph_nextHdr = NULL; \
	}while (0)
static int32 frag_pktChainCnt(struct rtl_pktHdr *pkt)
{
	struct rtl_pktHdr *ppkt = pkt;
	int32 cnt = 0;

	while (ppkt)
	{
		ppkt = ppkt->ph_nextHdr;
		cnt ++;
	}

	return cnt;
}

/*****************************************************************
		functions to generate Host
*****************************************************************/
#define ADD_HOSTS(arrIp,arrMac,num,startIp,startMac) \
		ipaddr_t arrIp[num]; \
		ether_addr_t arrMac[num]; \
		{ \
			int i; \
			ipaddr_t tmpIp = (startIp); \
			unsigned long tmpMac; \
			ASSERT(sizeof(tmpMac) == 4); \
			memcpy(&tmpMac, &((startMac).octet[2]), 4); \
			for ( i = 0 ; i < num ; i ++ ) \
			{ \
				arrIp[i] = tmpIp ++; \
				arrMac[i].octet[0] = (startMac).octet[0]; \
				arrMac[i].octet[1] = (startMac).octet[1]; \
				memcpy((&(arrMac[i].octet[2])), (uint8*)(&tmpMac), 4); \
				tmpMac ++; \
			} \
		}

#define SET_HOSTS_ARP(arrIp,arrMac,num,ifName,port) \
		do { \
			int i; \
			for ( i = 0 ; i < num ; i ++ ) \
			{ \
				ASSERT(rtl8651_addArp(arrIp[i], &(arrMac[i]), ifName, port) == SUCCESS); \
			} \
		} while (0);

/*****************************************************************
		functions to fill pkt config. structure
*****************************************************************/
/*
	Default Value of pkt generation
*/
/* ID */
static uint16 DEFAULT_IP_ID	= 0xa;

/* TTL */
static uint8 TTL_HSB = 128;
#define TTL_HSA	(TTL_HSB - 1)

/*****************************************************************************************/
static struct rtl_mBuf *confArpHSB(rtl8651_PktConf_t *config, uint16 rx_port, uint8 vlanIdx,
	ether_addr_t smac, ether_addr_t dmac, ipaddr_t sip, ipaddr_t dip, uint16 op)
{
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;
	
	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	conf->pktType = _PKT_TYPE_ARP;
	conf->l2Flag = 0;
	conf->ErrFlag = 0;
	conf->conf_Flags = 0;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	/***********************
		Configurable Value
	***********************/
	SET_RX_PORT(conf->conf_portlist, rx_port);
	conf->conf_vlanIdx = vlanIdx;


	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->arp.ip_src = sip;
	conf->arp.ip_dst = dip;
	conf->arp.op = op;
	return genMbufPkt(conf);
}
/*
  *	conf_err : must be set before entering confVlanHSB, for generate ICMP error message
  *
  *
  */
static struct rtl_mBuf *confVlanHSB(rtl8651_PktConf_t *config, rtl8651_PktConf_t*conf_err, uint32 pktType,
	uint16 rx_port, uint8 vlanIdx, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint16 sport, uint16 dport,
	uint8 TCP_flag, uint16 mss,
	uint8 ICMP_type, uint16 ICMP_id, int8* data_ptr, uint32 data_len)
{
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	conf->l2Flag = 0;
	conf->ErrFlag = 0;
	if (pktType >= _PKT_TYPE_IP)
		conf->conf_Flags |= (CSUM_IP|CSUM_L4);

	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	conf->pktType = pktType;
	SET_RX_PORT(conf->conf_portlist, rx_port);
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;
	conf->conf_sport = sport;
	conf->conf_dport = dport;
	conf->conf_tcp_flag = TCP_flag;
	conf->conf_tcp_mss = mss;
	conf->icmp.type = ICMP_type;
	conf->icmp.id = ICMP_id;
	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	if (conf_err)
		return genIcmpErrMbufPkt(conf_err, conf);
	else
		return genMbufPkt(conf);
}

static struct rtl_mBuf *confPppoeHSB(rtl8651_PktConf_t *config, rtl8651_PktConf_t *conf_err, uint32 pktType,
	uint16 rx_port, uint8 vlanIdx, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac, uint16 sessionId,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint16 sport, uint16 dport,
	uint8 TCP_flag, uint16 mss,
	uint8 ICMP_type, uint16 ICMP_id, int8* data_ptr, uint32 data_len)
{
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	conf->l2Flag |= L2_PPPoE;
	conf->ErrFlag = 0;
	conf->pppoe.type = 0x8864;
	conf->pppoe.session = sessionId;
	if (pktType >= _PKT_TYPE_IP)
		conf->conf_Flags |= (CSUM_IP|CSUM_L4);

	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	conf->pktType = pktType;
	SET_RX_PORT(conf->conf_portlist, rx_port);
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;
	conf->conf_sport = sport;
	conf->conf_dport = dport;
	conf->conf_tcp_flag = TCP_flag;
	conf->conf_tcp_mss = mss;
	conf->icmp.type = ICMP_type;
	conf->icmp.id = ICMP_id;
	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	if (conf_err)
		return genIcmpErrMbufPkt(conf_err, conf);
	else
		return genMbufPkt(conf);
}

static struct rtl_mBuf *confIgmpHSB(rtl8651_PktConf_t *config,
	uint16 rx_port, uint8 vlanIdx, uint8 FromPppoeIntf, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac, uint16 sessionId,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint8 ig_version, uint8 ig_type, uint8 ig_respTime, ipaddr_t ig_gaddr,
	uint8 ig_qrsq, uint8 ig_qqic, uint16 ig_qnofs, uint32 *ig_qslist,
	uint16 ig_rnofg, rtl8651_IgmpGrConf_t *ig_grConf,
	int8* data_ptr, uint32 data_len)
{
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	if (FromPppoeIntf)
	{
		conf->l2Flag |= L2_PPPoE;
		conf->ErrFlag = 0;
		conf->pppoe.type = 0x8864;
		conf->pppoe.session = sessionId;
	}else
	{
		// L2
		conf->l2Flag = 0;
		conf->ErrFlag = 0;
	}
	conf->conf_Flags |= (CSUM_IP|CSUM_L4);

	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	// check input
	if (ig_version == IGMPV3)
	{
		if (ig_type == IGMP_V3_REPORT && ig_rnofg && !ig_grConf)
		{
			MSG("V3 Report : Group Record is null\n");
			return NULL;
		}
		if (ig_type == IGMP_QUERY && ig_qnofs && !ig_qslist)
		{
			MSG("V3 Query: source list is null\n");
			return NULL;
		}
	}
	// assign
	conf->pktType = _PKT_TYPE_IGMP;
	SET_RX_PORT(conf->conf_portlist, rx_port);
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;

	conf->igmp.ver = ig_version;
	conf->igmp.type = ig_type;
	conf->igmp.respTime = ig_respTime;
	conf->igmp.gaddr = ig_gaddr;
	conf->igmp.qrsq = ig_qrsq;
	conf->igmp.qqic = ig_qqic;
	conf->igmp.qnofs = ig_qnofs;
	conf->igmp.qslist = ig_qslist;
	conf->igmp.rnofg = ig_rnofg;
	conf->igmp.grCfg = ig_grConf;

	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	return genMbufPkt(conf);
}

static struct rtl_mBuf *confArpHSA(rtl8651_PktConf_t *config, uint16 *tx_port, uint8 vlanIdx,
	ether_addr_t smac, ether_addr_t dmac, ipaddr_t sip, ipaddr_t dip, uint16 op
	
)
{
	uint16 *tx = tx_port;
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	conf->pktType = _PKT_TYPE_ARP;
	conf->ErrFlag = 0;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->arp.ip_src = sip;
	conf->arp.ip_dst = dip;
	conf->arp.op = op;
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;
	if (tx != NULL)
		while (*tx != 0xffff)
		{
			ADD_TX_PORT(conf->conf_portlist, *tx);
			tx ++;
		}
	return genMbufPkt(conf);
}
static struct rtl_mBuf *confVlanHSA(rtl8651_PktConf_t *config, rtl8651_PktConf_t *conf_err, uint32 pktType,
	uint16* tx_port, uint8 vlanIdx, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint16 sport, uint16 dport,
	uint8 TCP_flag, uint16 mss,
	uint8 ICMP_type, uint16 ICMP_id, int8* data_ptr, uint32 data_len)
{
	uint16 *tx = tx_port;
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	conf->l2Flag = 0;
	conf->ErrFlag = 0;
	if (pktType >= _PKT_TYPE_IP)
		conf->conf_Flags |= (CSUM_IP_OK|CSUM_L4_OK);
	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	conf->pktType = pktType;
	if (tx != NULL)
		while (*tx != 0xffff)	// last one
		{
			ADD_TX_PORT(conf->conf_portlist, *tx);
			tx ++;
		}
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;
	conf->conf_sport = sport;
	conf->conf_dport = dport;
	conf->conf_tcp_flag = TCP_flag;
	conf->conf_tcp_mss = mss;
	conf->icmp.type = ICMP_type;
	conf->icmp.id = ICMP_id;
	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	if (conf_err)
		return genIcmpErrMbufPkt(conf_err, conf);
	else
		return genMbufPkt(conf);
}
static struct rtl_mBuf *confPppoeHSA(rtl8651_PktConf_t *config, rtl8651_PktConf_t *conf_err, uint32 pktType,
	uint16* tx_port, uint8 vlanIdx, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint16 sport, uint16 dport,
	uint8 TCP_flag, uint16 mss,
	uint8 ICMP_type, uint16 ICMP_id, int8* data_ptr, uint32 data_len)
{
	uint16 *tx = tx_port;
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	conf->l2Flag = 0;
	conf->ErrFlag = 0;
	conf->conf_Flags |= (PKTHDR_PPPOE_AUTOADD);
	if (pktType >= _PKT_TYPE_IP)
		conf->conf_Flags |= (CSUM_IP_OK|CSUM_L4_OK);
	
	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	conf->pktType = pktType;
	if (tx != NULL)
		while (*tx != 0xffff)	// last one
		{
			ADD_TX_PORT(conf->conf_portlist, *tx);
			tx ++;
		}
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;
	conf->conf_sport = sport;
	conf->conf_dport = dport;
	conf->conf_tcp_flag = TCP_flag;
	conf->conf_tcp_mss = mss;
	conf->icmp.type = ICMP_type;
	conf->icmp.id = ICMP_id;
	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

 	if (conf_err)
		return genIcmpErrMbufPkt(conf_err, conf);
	else
		return genMbufPkt(conf);
}
/*
	Generate PppoeHSA packet with pppoeTagged and without PKTHDR_PPPOE_AUTOADD
	ex. ICMP reply
*/
static struct rtl_mBuf *confPppoeHSA_Tagged(rtl8651_PktConf_t *config, rtl8651_PktConf_t *conf_err, uint32 pktType,
	uint16* tx_port, uint8 vlanIdx, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint16 sport, uint16 dport,
	uint8 TCP_flag, uint16 mss,
	uint8 ICMP_type, uint16 ICMP_id, int8* data_ptr, uint32 data_len)
{
	uint16 *tx = tx_port;
	rtl8651_PktConf_t pktConf, *conf = &pktConf;
	rtl865x_tblAsicDrv_pppoeParam_t asic_pppoe;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	conf->l2Flag |= L2_PPPoE;
	conf->ErrFlag = 0;
	conf->pppoe.type = 0x8864;
	rtl8651_getAsicPppoe(pppoeIdx, &asic_pppoe);
	conf->pppoe.session = asic_pppoe.sessionId;
	if (pktType >= _PKT_TYPE_IP)
		conf->conf_Flags |= (CSUM_IP|CSUM_L4);

	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	conf->pktType = pktType;
	if (tx != NULL)
		while (*tx != 0xffff)	// last one
		{
			ADD_TX_PORT(conf->conf_portlist, *tx);
			tx ++;
		}
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;
	conf->conf_sport = sport;
	conf->conf_dport = dport;
	conf->conf_tcp_flag = TCP_flag;
	conf->conf_tcp_mss = mss;
	conf->icmp.type = ICMP_type;
	conf->icmp.id = ICMP_id;
	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	if (conf_err)
		return genIcmpErrMbufPkt(conf_err, conf);
	else
		return genMbufPkt(conf);
}

static struct rtl_mBuf *confIgmpHSA(rtl8651_PktConf_t *config,
	uint16* tx_port, uint8 vlanIdx, uint8 ToPppoeIntf, uint8 pppoeIdx, ether_addr_t smac, ether_addr_t dmac, uint16 sessionId,
	ipaddr_t sip, ipaddr_t dip, uint8 ttl, uint8 mf, uint16 offset,
	uint8 ig_version, uint8 ig_type, uint8 ig_respTime, ipaddr_t ig_gaddr,
	uint8 ig_qrsq, uint8 ig_qqic, uint16 ig_qnofs, uint32 *ig_qslist,
	uint16 ig_rnofg, rtl8651_IgmpGrConf_t *ig_grConf,
	int8* data_ptr, uint32 data_len)
{
	uint16 *tx = tx_port;
	rtl8651_PktConf_t pktConf, *conf = &pktConf;

	if (config)
		conf = config;

	RESET_CONF(conf);
	/***********************
		Default Value
	***********************/
	// L2
	if (ToPppoeIntf == TRUE)
	{
		conf->l2Flag = 0;
		conf->ErrFlag = 0;
		conf->conf_Flags |= (PKTHDR_PPPOE_AUTOADD);
	}else
	{
		conf->l2Flag = 0;
		conf->ErrFlag = 0;
	}

	conf->conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
	
	// L3
	conf->ip.id = DEFAULT_IP_ID;
	// L4
		// TCP
		conf->conf_tcp_seq = 0xb;
		conf->conf_tcp_ack = 0xc;
		conf->conf_tcp_win = 0xfffe;
		// ICMP
		conf->icmp.code = 0;
		conf->icmp.seq = 0x0;

	/***********************
		Configurable Value
	***********************/
	// check input
	if (ig_version == IGMPV3)
	{
		if (ig_type == IGMP_V3_REPORT && ig_rnofg && !ig_grConf)
		{
			MSG("V3 Report : Group Record is null\n");
			return NULL;
		}
		if (ig_type == IGMP_QUERY && ig_qnofs && !ig_qslist)
		{
			MSG("V3 Query: source list is null\n");
			return NULL;
		}
	}
	// assign
	conf->pktType = _PKT_TYPE_IGMP;
	if (tx != NULL)
		while (*tx != 0xffff)	// last one
		{
			ADD_TX_PORT(conf->conf_portlist, *tx);
			tx ++;
		}
	conf->conf_vlanIdx = vlanIdx;
	conf->conf_pppoeIdx = pppoeIdx;

	CP_MAC (smac, conf->conf_smac);
	CP_MAC (dmac, conf->conf_dmac);
	conf->conf_sip = (uint32)sip;
	conf->conf_dip = (uint32)dip;
	conf->ip.ttl = ttl;
	conf->ip.mf = mf;
	conf->ip.offset = offset;

	conf->igmp.ver = ig_version;
	conf->igmp.type = ig_type;
	conf->igmp.respTime = ig_respTime;
	conf->igmp.gaddr = ig_gaddr;
	conf->igmp.qrsq = ig_qrsq;
	conf->igmp.qqic = ig_qqic;
	conf->igmp.qnofs = ig_qnofs;
	conf->igmp.qslist = ig_qslist;
	conf->igmp.rnofg = ig_rnofg;
	conf->igmp.grCfg = ig_grConf;

	conf->payload.content = data_ptr;
	conf->payload.length = data_len;
	conf->conf_category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	return genMbufPkt(conf);

}


/*****************************************************************
		Logging releated functions
*****************************************************************/
#ifdef _RTL_NEW_LOGGING_MODEL
typedef struct _rtl8651_mylog_s{
	unsigned long moduleId;
	unsigned long logNo;
	rtl8651_logInfo_t info;
}_rtl8651_mylog_t;
#else
typedef struct _rtl8651_mylog_s{
	unsigned long  dsid;
	unsigned long  moduleId;
	unsigned char  proto;
	char			 direction;
	unsigned long  sip;
	unsigned long  dip;
	unsigned short sport;
	unsigned short dport;
	unsigned char  type;
	unsigned char  action;
	char			* msg;
}_rtl8651_mylog_t;
#endif
#define MAX_MYLOG_POOL_SIZE		10

static int32 Log_count;
static _rtl8651_mylog_t *Log_Current;
static _rtl8651_mylog_t Log_pool[MAX_MYLOG_POOL_SIZE];

#ifdef _RTL_NEW_LOGGING_MODEL
int32 LogFunc
(
	unsigned long	moduleId,
	unsigned long	logNo,
	rtl8651_logInfo_t	*info
)
{
	if (Log_count == MAX_MYLOG_POOL_SIZE)
	{
		printf("Log system full !!\n");
		return FAILED;
	}

	// log
	Log_pool[Log_count].moduleId = moduleId;
	Log_pool[Log_count].logNo = logNo;
	memcpy(&(Log_pool[Log_count].info), info, sizeof(Log_pool[Log_count].info));

	Log_count ++;

	return SUCCESS;
}
#else
int32 LogFunc
(
unsigned long  dsid,
unsigned long  moduleId,
unsigned char  proto,
char           	direction,
unsigned long  sip,
unsigned long  dip,
unsigned short sport,
unsigned short dport,
unsigned char  type,
unsigned char  action,
char			* msg
)
{
	// check pool is full or not
	if (Log_count == MAX_MYLOG_POOL_SIZE)
	{
		printf("Log system full !!\n");
		return FAILED;
	}

	// log
	Log_pool[Log_count].dsid		= dsid;
	Log_pool[Log_count].moduleId	= moduleId;
	Log_pool[Log_count].proto		= proto;
	Log_pool[Log_count].direction	= direction;
	Log_pool[Log_count].sip		= sip;
	Log_pool[Log_count].dip		= dip;
	Log_pool[Log_count].sport		= sport;
	Log_pool[Log_count].dport		= dport;
	Log_pool[Log_count].type		= type;
	Log_pool[Log_count].action	= action;
	Log_pool[Log_count].msg		= (char*)malloc(strlen(msg) + 1);
	strncpy(Log_pool[Log_count].msg, msg, strlen(msg));
	Log_pool[Log_count].msg[strlen(msg)] = 0;

	Log_count ++;

	return SUCCESS;
}
#endif
/*
	Compare Log
*/
#ifdef _RTL_NEW_LOGGING_MODEL
/*
			- compare logNo only
*/
static int32 log_cmp
(
	unsigned long	moduleId,
	unsigned long	logNo,
	rtl8651_logInfo_t *info
)
{
	int32 retval = SUCCESS;

	if (Log_Current->logNo != logNo)
	{
		// msg not equal
		printf("\t%s(%u): %s:\n\t%s\n\t%s\n", __FUNCTION__, __LINE__, "Log No Not equal!!",
							Log_Current-logNo, logNo);
		retval = FAILED;
		goto out;
	}
out:
	Log_Current++;
	return retval;
}

static int32 log_reinit(void)
{
	// flush data in Log pool
	_rtl8651_mylog_t *ptr = Log_pool;

	while (Log_count > 0)
	{
		memset(Log_pool, 0, sizeof(_rtl8651_mylog_t));
		ptr ++;
		Log_count --;
	}

	Log_Current = Log_pool;
	return SUCCESS;
}
#else
/*
			- compare msg only
*/
static int32 log_cmp
(
unsigned long  dsid,
unsigned long  moduleId,
unsigned char  proto,
char           	direction,
unsigned long  sip,
unsigned long  dip,
unsigned short sport,
unsigned short dport,
unsigned char  type,
unsigned char  action,
char			* msg
)
{
	int32 retval = SUCCESS;

	if (strncmp(Log_Current->msg, msg, strlen(msg)))
	{
		// msg not equal
		printf("\t%s(%u): %s:\n\t%s\n\t%s\n", __FUNCTION__, __LINE__, "Message Not equal!!",
							Log_Current->msg, msg);
		retval = FAILED;
		goto out;
	}
out:
	Log_Current++;
	return retval;
}

static int32 log_reinit(void)
{
	// flush data in Log pool
	_rtl8651_mylog_t *ptr = Log_pool;

	while (Log_count > 0)
	{
		free(ptr->msg);
		memset(Log_pool, 0, sizeof(_rtl8651_mylog_t));

		ptr ++;
		Log_count --;
	}

	Log_Current = Log_pool;
	return SUCCESS;
}
#endif	/* _RTL_NEW_LOGGING_MODEL */

static int32 log_cnt(void)
{
	return Log_count;
}

static int32 log_enableLogging(uint32 dsid, uint32 moduleId, int8 enable)
{
	return rtl8651a_enableLogging(dsid, moduleId, enable);
}

static int32 log_init(uint32 dsid, uint32 moduleId){
	int32 ret;

	// reinit rtl8651 log system
	rtl8651_log_init();

	if ((ret = rtl8651_installLoggingFunction(&LogFunc)) != SUCCESS)
		return ret;

	if ((ret = rtl8651a_enableLogging(dsid, moduleId, 1)) != SUCCESS)
		return ret;

	return log_reinit();
}
/****************************************************************
		Mulitcast
*****************************************************************/
// multicast system definition
#define RTL8651_IGMP_QRI_TEST								10
#define RTL8651_IGMP_QI_TEST								1000
#define RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST		10
#define RTL8651_IGMP_GMI_TEST								1010
#define RTL8651_IGMP_LMQI_TEST							5
#define RTL8651_IGMP_LMQC_TEST							3
#define RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST			100
#define RTL8651_IGMP_SQI_TEST								10
#define RTL8651_IGMP_SQC_TEST								10
// host related definition
#define MAX_SLISTCNT		100
#define MAX_HOST			3	// you can NOT modify this value!!!
#define MAX_TOTALSLIST		(MAX_SLISTCNT * MAX_HOST)

typedef struct host_SourceList_s {
	ipaddr_t addr;
	struct host_SourceList_s *prev;
	struct host_SourceList_s *next;
} host_SourceList_t;

host_SourceList_t *slist_infree = NULL;
host_SourceList_t *slistPool_ptr = NULL;

int32 slistPool_reinit(void)
{
	int i;
	host_SourceList_t *ptr;

	if (!slistPool_ptr)
		return slistPool_init();

	ptr = slistPool_ptr;
	for (i = 0 ; i < MAX_TOTALSLIST ; i ++, ptr ++)
	{
		if (i == 0)
			ptr->prev = NULL;
		else
			ptr->prev = ptr - 1;

		if (i == (MAX_TOTALSLIST - 1))
			ptr->next = NULL;
		else
			ptr->next = ptr + 1;
	}
	slist_infree = slistPool_ptr;

	return SUCCESS;
}

int32 slistPool_init(void)
{
	if (slistPool_ptr)
	{	// slist has benn init, just reinit it
		return slistPool_reinit();
	}
	slistPool_ptr = (host_SourceList_t *)malloc(sizeof(host_SourceList_t) * MAX_TOTALSLIST);
	if (!slistPool_ptr)
		return FAILED;
	return slistPool_reinit();
}

int32 slist_link(host_SourceList_t** slist, host_SourceList_t *entry)
{
	if (!entry || !slist)
		return FAILED;

	entry->next = *slist;
	if (*slist)
		(*slist)->prev = entry;

	*slist = entry;
	return SUCCESS;
}
int32 slist_unlink(host_SourceList_t *entry)
{
	host_SourceList_t *next;

	if (!entry)
		return FAILED;

	next = entry->next;

	if (entry->next)
		entry->next->prev = entry->prev;
	if (entry->prev)
		entry->prev->next = next;

	entry->prev = NULL;
	entry->next = NULL;
}

void slist_free(host_SourceList_t *entry)
{
	if (!entry)
		return;

	if (!slistPool_ptr && (slistPool_init() == FAILED))
		return;
		

	slist_unlink(entry);
	slist_link(&slist_infree, entry);
}

host_SourceList_t *slist_malloc(void)
{
	host_SourceList_t *ret;

	if (!slistPool_ptr && (slistPool_init() == FAILED))
	{
		MSG("Init source list Pool failed");
		return NULL;
	}

	if (!slist_infree)
	{
		MSG("No free slist to be allocated");
		return NULL;
	}
	ret = slist_infree;
	slist_infree = slist_infree->next;
	bzero(ret, sizeof(host_SourceList_t));
	return ret;
}

int32 host_find_src(host_SourceList_t *slist, ipaddr_t addr)
{
	host_SourceList_t *ptr = slist;

	if (!slist)
		return 0;

	while (ptr)
	{
		if (ptr->addr == addr)
			return addr;
		ptr = ptr->next;
	}
	return 0;
}

int32 host_add_src(host_SourceList_t **slist, ipaddr_t addr)
{
	host_SourceList_t *n;

	if (!slist)
		return FAILED;

	if (host_find_src((*slist), addr))
		return SUCCESS;

	n = slist_malloc();

	if (!n)
		return FAILED;

	n->addr = addr;
	if (slist_link(slist, n) == FAILED)
	{
		slist_free(n);
		return FAILED;
	}
	return SUCCESS;
}

int32 host_del_src(host_SourceList_t **slist, ipaddr_t addr)
{
	host_SourceList_t *ptr;
	if (!slist)
		return FAILED;

	ptr = *slist;

	while (ptr)
	{
		if (ptr->addr == addr)
			break;
		ptr = ptr->next;
	}
	if (ptr)
	{
		slist_unlink(ptr);
		slist_free(ptr);
	}
	return SUCCESS;
}

int32 host_del_all(host_SourceList_t **slist)
{
	host_SourceList_t *ptr, *next;

	if ((!slist) || (!*slist))
		return FAILED;

	ptr = *slist;

	while (ptr)
	{
		next = ptr->next;
		slist_free(ptr);
		ptr = next;
	}

	*slist = NULL;
}
/****************************************************************
		Configuration functions
*****************************************************************/
static int32 fwdeng_env_configuration_1(void){
	/******************************
		vlan 1: pppoe/WAN
				IP/mask		:	10.113.1.1 / 32
				session id	:	11111

		vlan 2: vlan/LAN
				IP/mask		:	192.168.1.254 / 24

		vlan 3: vlan/LAN
				IP/mask		:	192.168.2.254 / 24

		vlan 4: vlan/WAN
				IP/mask		:	10.113.2.1 / 24

	******************************/
	ether_addr_t mac = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ipaddr_t ipaddr_ext, ipaddr_int, ipaddr_next, mask;

	/* VLAN 1: subnet 1 */
	/* member port 0, pppoe, pppoeid 1000, session id 11111, mtu 1492 */
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("pppoe") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("pppoe", RTL8651_LL_PPPOE, 1) == SUCCESS);
	ASSERT(rtl8651_addPppoeSession(1000, 1) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("pppoe") == SUCCESS);
	ASSERT(rtl8651_addExternalMulticastPort(0) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.1.1"));
	mask = ntohl(inet_addr("255.255.255.255"));
	mac.octet[5] = 0x02;
	ASSERT(rtl8651_addIpIntf("pppoe", ipaddr_ext, mask) == SUCCESS);
	ASSERT(rtl8651_bindPppoeSession(ipaddr_ext, 1000) == SUCCESS);
	ASSERT(rtl8651_setPppoeSessionProperty(1000, 11111, &mac, 0x00) == SUCCESS);
	ASSERT(rtl8651_setNetMtu("pppoe", 1492) == SUCCESS);

	/* VLAN 2: subnet 2 */
	/* member port 1,2,3, vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 3) == SUCCESS);
	mac.octet[5] = 0x03;
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_int, mask) == SUCCESS);

	/* VLAN 3: subnet 3 */
	/* member port 4, vlan */
	ASSERT(rtl8651_addVlan(3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 4) == SUCCESS);
	mac.octet[5] = 0x04;
	ASSERT(rtl8651_assignVlanMacAddress(3, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan2") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan2", RTL8651_LL_VLAN, 3) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.2.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan2", ipaddr_int, mask) == SUCCESS);

	/* VLAN 4: subnet 4 */
	/* member port 5, vlan */
	ASSERT(rtl8651_addVlan(4) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 5) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(4, 5) == SUCCESS);
	mac.octet[5] = 0x05;
	ASSERT(rtl8651_assignVlanMacAddress(4, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("wan2") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("wan2", RTL8651_LL_VLAN, 4) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("wan2") == SUCCESS);
	ASSERT(rtl8651_addExternalMulticastPort(5) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.2.1"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("wan2", ipaddr_ext, mask) == SUCCESS);

	/* add default route on pppoe interface */
	ASSERT(rtl8651_addRoute(0, 0, "pppoe", 0) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("140.115.0.0"));
	mask = ntohl(inet_addr("255.255.0.0"));
	ipaddr_next = ntohl(inet_addr("10.113.2.254"));
	ASSERT(rtl8651_addRoute(ipaddr_ext, mask, "wan2", ipaddr_next) == SUCCESS);

	/* flush all DoS setting and turn-on dos check for session 0 */
	rtl8651_dosOneSecondTimer();
	rtl8651a_setDosStatus(0, 0xffffffff);
	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging
	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}
	return SUCCESS;
}

#ifdef RTL_FWDENG_POLICYRT_TEST
static int32 fwdeng_env_configuration_2(void){
	/******************************

	FOR policy route
	
		vlan 1: pppoe/WAN (0)
				IP/mask		:	10.113.1.1 / 32
				session id	:	11111 (Object ID 1000)
				IP/mask		:	10.113.2.1 / 32
				session id	:	22222 (Object ID 1001)

		vlan 2: vlan/LAN (1,2)
				IP/mask		:	192.168.1.254 / 24

		vlan 3: vlan/LAN (3,4)
				IP/mask		:	192.168.2.254 / 24

		vlan 4: vlan/WAN (5)
				IP/mask		:	10.113.4.1 / 24

	******************************/
	ether_addr_t mac = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ipaddr_t ipaddr_ext, ipaddr_int, mask;
	rtl8651_tblDrvPolicyRoute_t policyRt_add, *prt_p = &policyRt_add;

//	ASSERT(rtl8651_tblDrvReinit() == SUCCESS);

	/* VLAN 1: subnet 1 */
	/* member port 0, pppoe, pppoeid 1000, session id 11111 */
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("pppoe") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("pppoe", RTL8651_LL_PPPOE, 1) == SUCCESS);
	ASSERT(rtl8651_addPppoeSession(1000, 1) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("pppoe") == SUCCESS);
	ASSERT(rtl8651_addExternalMulticastPort(0) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.1.1"));
	mask = ntohl(inet_addr("255.255.255.255"));
	mac.octet[5] = 0x02;
	ASSERT(rtl8651_addIpIntf("pppoe", ipaddr_ext, mask) == SUCCESS);
	ASSERT(rtl8651_bindPppoeSession(ipaddr_ext, 1000) == SUCCESS);
	ASSERT(rtl8651_setPppoeSessionProperty(1000, 11111, &mac, 0x00) == SUCCESS);

	/* member port 0, pppoe, pppoeid 1001, session id 22222 */
	ASSERT(rtl8651_addPppoeSession(1001, 1) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.2.1"));
	mask = ntohl(inet_addr("255.255.255.255"));
	mac.octet[5] = 0x06;
	ASSERT(rtl8651_addIpIntf("pppoe", ipaddr_ext, mask) == SUCCESS);
	ASSERT(rtl8651_bindPppoeSession(ipaddr_ext, 1001) == SUCCESS);
	ASSERT(rtl8651_setPppoeSessionProperty(1001, 22222, &mac, 0x00) == SUCCESS);

	/* VLAN 2: subnet 2 */
	/* member port 1,2 vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	mac.octet[5] = 0x03;
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_int, mask) == SUCCESS);

	/* VLAN 3: subnet 3 */
	/* member port 3,4 vlan */
	ASSERT(rtl8651_addVlan(3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 4) == SUCCESS);
	mac.octet[5] = 0x04;
	ASSERT(rtl8651_assignVlanMacAddress(3, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan2") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan2", RTL8651_LL_VLAN, 3) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.2.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan2", ipaddr_int, mask) == SUCCESS);

	/* VLAN 4: subnet 4 */
	/* member port 6, vlan */
	ASSERT(rtl8651_addVlan(4) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 5) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(4, 5) == SUCCESS);
	mac.octet[5] = 0x05;
	ASSERT(rtl8651_assignVlanMacAddress(4, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("wan2") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("wan2", RTL8651_LL_VLAN, 4) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("wan2") == SUCCESS);
	ASSERT(rtl8651_addExternalMulticastPort(5) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("10.113.4.1"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("wan2", ipaddr_int, mask) == SUCCESS);


	/* add default route on pppoe interface */
	ASSERT(rtl8651_addRoute(0, 0, "pppoe", 0) == SUCCESS);

	/* policy route */
	bzero((void*)prt_p, sizeof(rtl8651_tblDrvPolicyRoute_t));
	prt_p->type = TRIGGER_DSTIP;
	prt_p->ip_start = ntohl(inet_addr("140.115.1.1"));
	prt_p->ip_end = ntohl(inet_addr("140.115.1.253"));
	prt_p->ip_alias = ntohl(inet_addr("10.113.2.1"));
	ASSERT(rtl8651_addPolicyRoute(prt_p) == SUCCESS);
	bzero((void*)prt_p, sizeof(rtl8651_tblDrvPolicyRoute_t));
	prt_p->type = TRIGGER_SRCIP;
	prt_p->ip_start = ntohl(inet_addr("192.168.1.200"));
	prt_p->ip_end = ntohl(inet_addr("192.168.1.210"));
	prt_p->ip_alias = ntohl(inet_addr("10.113.2.1"));
	ASSERT(rtl8651_addPolicyRoute(prt_p) == SUCCESS);
//	bzero((void*)prt_p, sizeof(rtl8651_tblDrvPolicyRoute_t));
//	prt_p->type = TRIGGER_SRCGLOBALIP;
//	ASSERT(rtl8651_addPolicyRoute(prt_p), SUCCESS);
	bzero((void*)prt_p, sizeof(rtl8651_tblDrvPolicyRoute_t));
	prt_p->type = TRIGGER_DSTTCPPORT;
	prt_p->trigger.dport.start = 0x1111;
	prt_p->trigger.dport.end = 0x2222;
	prt_p->ip_alias = ntohl(inet_addr("10.113.2.1"));
	ASSERT(rtl8651_addPolicyRoute(prt_p) == SUCCESS);
	bzero((void*)prt_p, sizeof(rtl8651_tblDrvPolicyRoute_t));
	prt_p->type = TRIGGER_DSTUDPPORT;
	prt_p->trigger.dport.start = 0x1111;
	prt_p->trigger.dport.end = 0x2222;
	prt_p->ip_alias = ntohl(inet_addr("10.113.2.1"));
	ASSERT(rtl8651_addPolicyRoute(prt_p) == SUCCESS);

	/* flush all DoS setting and turn-on dos check for session 0 */
	rtl8651_dosOneSecondTimer();
	rtl8651a_setDosStatus(0, 0xffffffff);
	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging

	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	return SUCCESS;
}
#endif /* RTL_FWDENG_POLICYRT_TEST */

/*
	IP-unnumbered setting
*/
static int32 fwdeng_env_configuration_3(void){
	/******************************
		vlan 1: pppoe/WAN
				IP/mask		:	192.168.1.248 / 29
				session id	:	11111

		vlan 2: vlan/LAN
				IP/mask		:	192.168.1.254 / 24

	******************************/
	ether_addr_t mac = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ipaddr_t ipaddr_int, ipaddr_unnumber, mask;

	/* VLAN 1: subnet 1 */
	/* member port 0, pppoe, pppoeid 1000, session id 11111 */
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("pppoe") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("pppoe", RTL8651_LL_PPPOE, 1) == SUCCESS);
	ASSERT(rtl8651_addPppoeSession(1000, 1) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("pppoe") == SUCCESS);
	ASSERT(rtl8651_addExternalMulticastPort(0) == SUCCESS);
	mac.octet[5] = 0x02;
	ASSERT(rtl8651_setPppoeSessionProperty(1000, 11111, &mac, 0x00) == SUCCESS);

	/* VLAN 2: subnet 2 */
	/* member port 1 vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	mac.octet[5] = 0x03;
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_int, mask) == SUCCESS);

	// Add unnumbered IP
	mask = ntohl(inet_addr("255.255.255.240"));		// b' 11111000
	ipaddr_unnumber = ntohl(inet_addr("10.113.1.1"));
	ASSERT(rtl8651_addIpUnnumbered("pppoe", "lan", mask) == SUCCESS);
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_unnumber, mask) == SUCCESS);
	ASSERT(rtl8651_bindSession(ipaddr_unnumber, 1000) == SUCCESS);
	ASSERT(rtl8651_setLanSideExternalIpInterface("lan", ipaddr_unnumber, mask, 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ipaddr_unnumber) == SUCCESS);

	/* VLAN 3: subnet 3 */
	/* member port 2 vlan */
	ASSERT(rtl8651_addVlan(3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 2) == SUCCESS);
	mac.octet[5] = 0x04;
	ASSERT(rtl8651_assignVlanMacAddress(3, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan2") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan2", RTL8651_LL_VLAN, 3) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.2.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan2", ipaddr_int, mask) == SUCCESS);

	/* add default route on pppoe interface */
	ASSERT(rtl8651_addRoute(0, 0, "pppoe", 0) == SUCCESS);

	/* flush all DoS setting and turn-on dos check for session 0 */
	rtl8651_dosOneSecondTimer();
	rtl8651a_setDosStatus(0, 0xffffffff);
	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging
	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	return SUCCESS;
}

/*
	PPTP setting
*/
static int32 fwdeng_env_configuration_4(void){
	/******************************

		PPTP 
		
		vlan 9: vlan/LAN
				IP/mask		:	192.168.1.254 / 24

		vlan 8: vlan/LAN
				IP/mask		:	192.168.154.254 / 24

		vlan 2050: loopback

	******************************/
	ether_addr_t mac = { { 0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88} };
	ipaddr_t ipaddr_ext, ipaddr_int, ipaddr_next, mask;


	/* VLAN 2 */
	/* member port 0 vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 0) == SUCCESS);	
	ASSERT(rtl8651_addVlanPortMember(2, 0) == SUCCESS);		
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("eth0") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("eth0", RTL8651_LL_PPTP, 2) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("192.168.154.119"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("eth0", ipaddr_ext, mask) == SUCCESS);
	rtl8651_addExtNetworkInterface("eth0");
	ASSERT(rtl8651_addExternalMulticastPort(0) == SUCCESS);


	/* VLAN 3 */
	/* member port 1,2,3 vlan */	
	ASSERT(rtl8651_addVlan(3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 1) == SUCCESS);	 
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);	 
	ASSERT(rtl8651_addVlanPortMember(3, 2) == SUCCESS);	 
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);	 
	ASSERT(rtl8651_addVlanPortMember(3, 3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);	
	//ASSERT(rtl8651_addVlanPortMember(3, 4) == SUCCESS);
	
	mac.octet[5] = 0x8a;
	ASSERT(rtl8651_assignVlanMacAddress(3, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("eth1") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("eth1", RTL8651_LL_VLAN, 3) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("eth1", ipaddr_int, mask) == SUCCESS);

	ASSERT(rtl8651_setLoopbackPortPHY(4, TRUE) == SUCCESS); 
 	ASSERT(rtl8651_addSession(RTL8651_PPTP, 1, "eth0", 2)== SUCCESS); 
	ASSERT(rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0)== SUCCESS); //default route


	//ip up
	ipaddr_next = ntohl(inet_addr("192.168.154.240"));
	ipaddr_ext = ntohl(inet_addr("192.170.240.1"));
	mask = ntohl(inet_addr("255.255.255.255"));
	mac.octet[5]=0x8c;
	ASSERT(rtl8651_addIpIntf("eth0", ipaddr_ext, mask)== SUCCESS); 
	rtl8651_addArp(ipaddr_next, (ether_addr_t *)(mac.octet), "eth0", 0);	
	ASSERT(rtl8651_setPptpProperty(1, 0, 0, ipaddr_next, 0)== SUCCESS); 
	ASSERT(rtl8651_bindSession(ipaddr_ext, 1)== SUCCESS); 
	ASSERT(rtl8651_addNaptMapping(ipaddr_ext)== SUCCESS);

	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging
	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}


	return SUCCESS;
}


/*
	L2TP setting
*/
static int32 fwdeng_env_configuration_5(void){
	/******************************

		L2TP
		
		vlan 9: vlan/LAN
				IP/mask		:	192.168.1.254 / 24

		vlan 8: vlan/LAN
				IP/mask		:	192.168.154.254 / 24

		vlan 2050: loopback

	******************************/
	ether_addr_t mac = { { 0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88} };
	ipaddr_t ipaddr_ext, ipaddr_int, ipaddr_next, mask;


	/* VLAN 2 */
	/* member port 0 vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 0) == SUCCESS);	
	ASSERT(rtl8651_addVlanPortMember(2, 0) == SUCCESS);		
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("eth0") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("eth0", RTL8651_LL_L2TP, 2) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("192.168.154.119"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("eth0", ipaddr_ext, mask) == SUCCESS);
	rtl8651_addExtNetworkInterface("eth0");
	ASSERT(rtl8651_addExternalMulticastPort(0) == SUCCESS);


	/* VLAN 3 */
	/* member port 1,2,3 vlan */	
	ASSERT(rtl8651_addVlan(3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 1) == SUCCESS);	 
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);	 
	ASSERT(rtl8651_addVlanPortMember(3, 2) == SUCCESS);	 
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);	 
	ASSERT(rtl8651_addVlanPortMember(3, 3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);	
	ASSERT(rtl8651_addVlanPortMember(3, 4) == SUCCESS);
	
	mac.octet[5] = 0x8a;
	ASSERT(rtl8651_assignVlanMacAddress(3, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("eth1") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("eth1", RTL8651_LL_VLAN, 3) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("eth1", ipaddr_int, mask) == SUCCESS);

	ASSERT(rtl8651_setLoopbackPortPHY(5, TRUE) == SUCCESS); 
 	ASSERT(rtl8651_addSession(RTL8651_L2TP, 1, "eth0", 2)== SUCCESS); 
	ASSERT(rtl8651_addRoute((ipaddr_t)0,(ipaddr_t)0,(int8*)"eth0",0)== SUCCESS); //default route


	//ip up
	ipaddr_next = ntohl(inet_addr("192.168.154.240"));
	ipaddr_ext = ntohl(inet_addr("192.170.240.1"));
	mask = ntohl(inet_addr("255.255.255.255"));
	mac.octet[5]=0x8c;
	ASSERT(rtl8651_addIpIntf("eth0", ipaddr_ext, mask)== SUCCESS); 
	rtl8651_addArp(ipaddr_next, (ether_addr_t *)(mac.octet), "eth0", 0);	
	ASSERT(rtl8651_setL2tpProperty(1, 0, 0, ipaddr_next, 0)== SUCCESS); 
	ASSERT(rtl8651_bindSession(ipaddr_ext, 1)== SUCCESS); 
	ASSERT(rtl8651_addNaptMapping(ipaddr_ext)== SUCCESS);

	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	return SUCCESS;
}

static int32 fwdeng_function_configuration1(void){

	rtl8651_fwdEngineArp(1);	
	rtl8651_fwdEngineIcmp(1);
	rtl8651_fwdEngineIcmpRoutingMsg(1);
	rtl8651_fwdEngineDMZHostIcmpPassThrough(1);
	rtl8651_fwdEngineProcessL34(1);
	rtl8651_fwdEngineProcessIPFragment(1);
	rtl8651_fwdEngineProcessIPMulticast(1);
	rtl8651_fwdEngineArpProxy(1);
	rtl8651_dosProc_blockSip_enable(0, 0);		// turn-OFF sip block
	rtl8651_fwdEngineProcessPortBouncing(1);	// turn-ON port bouncing
	return SUCCESS;
}

/*
@func Testing		| route-1	| route fucntion test 1
@rvalue SUCCESS	| 	test OK
@comm
Test the routing function
 */
int32 pkt_route_normal1(uint32 caseNo){

	/**********************************************
		2 lan

		TCP
		NPI1	->	NPI2		ALL combinations of flags, including DOS attack cases

		UDP
		NPI1	->	NPI2

		ICMP
		NPI1	->	NPI2		ALL Types

		IP packet
	**********************************************/
	int8 pkt_content[1460];
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	/***************
		TCP test
	***************/
	{
		int8 *content_ptr;
		uint32 content_size;
		uint8 TCP_flag;

		for (TCP_flag = 0 ; TCP_flag < 64 ; TCP_flag ++)
		{
			if (TCP_flag == TH_SYN)
			{
				content_ptr = NULL;
				content_size = 0;
			}
			else
			{
				content_ptr = pkt_content;
				content_size = sizeof(pkt_content);

				if (TCP_flag & TH_SYN)
					content_size -= 4;	// mss option
			}
		
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_npi2, 123, 0, 0,
				port_npi, port_npi2, TCP_flag, 1460, 0, 0, content_ptr, content_size);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);

			// check output
			switch (TCP_flag)
			{
				// DOS Cases:
				//	0: - NULL scan
				//	 3: SYN,FIN - SYN/FIN scan
				//	 8: PUSH	-Vecna
				//	 9: PUSH, FIN -Vecna
				//	 32: URG	-Vecna
				//	 33: URG, FIN -Vecna	
				//	 40: URG,PUSH -Vecna
				//	 41: URG,PUSH,FIN: - nmap xmas scan
				//	 58: SYN,ACK,URG,PUSH - full Sapu scan
				//	 63: SYN,RST,FIN,URG,PUSH,ACK - full Xmas scan
				case 0:
				case 3:
				case 8:
				case 9:
				case 32:
				case 33:
				case 40:
				case 41:
				case 58:
				case 63:
					// dos attack
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS ,RTL8651_LOG_DOS_TcpScan, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Scan"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
					break;
				default:
					// l3 routing
					{
						uint16 tx_list[2] = {4, 0xffff};
						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 3, 0,
							mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 122, 0, 0,
							port_npi, port_npi2, TCP_flag, 1460, 0, 0, content_ptr, content_size);
					}
					VALUE_CMP(mbufList_nmbuf(), 1);
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	/***************
		UDP test
	***************/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_UDP, 1, 2, 0, 
			mac_npi, mac_gw_int, ip_npi, ip_npi2, 234, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_list[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_UDP, tx_list, 3, 0,
				mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 233, 0, 0,
				port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/***************
		ICMP test
	***************/
	{
		uint16 icmp_type;
		for (icmp_type = 0 ; icmp_type < 256 ; icmp_type ++)
		{
			rtl8651_dosOneSecondTimer();	// assume 1 icmp packet per-second

			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_npi2, 222, 0, 0,
				port_npi, port_npi2, 0, 0, (uint8)icmp_type, 1, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			{
				uint16 tx_list[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_ICMP, tx_list, 3, 0,
					mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 221, 0, 0,
					port_npi, port_npi2, 0, 0, (uint8)icmp_type, 1, pkt_content, sizeof(pkt_content));
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/***************
		Other test
	***************/
	{
		uint16 ip_proto;

		for (ip_proto = 0 ; ip_proto < 256 ; ip_proto ++)
		{
			switch (ip_proto)
			{
				case IPPROTO_UDP:
				case IPPROTO_TCP:
				case IPPROTO_ICMP:
					// skip tcp/udp/icmp
					continue;
				default:
					break;
			}
			/* input */
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IP;
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP);
			CP_MAC (mac_npi, conf.conf_smac);
			CP_MAC (mac_gw_int, conf.conf_dmac);
			conf.conf_sip						= ip_npi;
			conf.conf_dip						= ip_npi2;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 234;
			conf.ip.protocol					= (uint8)ip_proto;
			conf.payload.content				= pkt_content;
			conf.payload.length				= sizeof(pkt_content);
			conf.conf_vlanIdx					= 2;
			SET_RX_PORT(conf.conf_portlist, 1);

			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);

			/* output */
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IP;
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP);
			CP_MAC (mac_gw_int2, conf.conf_smac);
			CP_MAC (mac_npi2, conf.conf_dmac);
			conf.conf_sip						= ip_npi;
			conf.conf_dip						= ip_npi2;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 233;
			conf.ip.protocol					= (uint8)ip_proto;
			conf.payload.content				= pkt_content;
			conf.payload.length				= sizeof(pkt_content);
			conf.conf_vlanIdx					= 3;
			ADD_TX_PORT(conf.conf_portlist, 4);

			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	return SUCCESS;
}

/*
@func Testing		| route-frag-1	| fragment packet route fucntion test 1
@rvalue SUCCESS	| 	test OK
@comm
Test the routing function for in-order fragment packets
 */
int32 pkt_route_frag1(uint32 caseNo){
	/**********************************************
		2 lan

		Fragment

		UDP
		NPI1	->	NPI2

		ICMP
		NPI1	->	NPI2		ALL Types

		IP packet
	**********************************************/
	int8 pkt_content[1456];
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	int pkt_no;
	const int last_pkt_no = 5;	// for 1 kind of TCP packet, we generate 5 packet for it
	uint16 icmp_type;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	// only check Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/***************
		UDP test
	***************/
	{
		for (pkt_no = 1 ; pkt_no <= last_pkt_no; pkt_no ++)
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_UDP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_npi2, 234, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
				port_npi, port_npi2, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):sizeof(pkt_content)));	

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		VALUE_CMP(mbufList_nmbuf(), last_pkt_no);
		for (pkt_no = 1 ; pkt_no <= last_pkt_no; pkt_no ++)
		{
			{
				uint16 tx_list[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_UDP, tx_list, 3, 0,
					mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 233, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
					port_npi, port_npi2, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(1456-sizeof(struct udphdr)):1456));	

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/***************
		ICMP test
	***************/
	for (icmp_type = 0 ; icmp_type < 256 ; icmp_type ++)
	{
		for (pkt_no = 1; pkt_no <= last_pkt_no; pkt_no ++)
		{
			rtl8651_dosOneSecondTimer();	// assume 1 icmp packet per-second

			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_npi2, 222, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
				port_npi, port_npi2, 0, 0, (uint8)icmp_type, 1, pkt_content, (pkt_no == 1?(1456-8):1456));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		VALUE_CMP(mbufList_nmbuf(), last_pkt_no);
		for (pkt_no = 1 ; pkt_no <= last_pkt_no ; pkt_no ++)
		{
			{
				uint16 tx_list[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_ICMP, tx_list, 3, 0,
					mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 221, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
					port_npi, port_npi2, 0, 0, (uint8)icmp_type, 1, pkt_content, (pkt_no == 1?(1456-8):1456));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/***************
		Other test
	***************/
	{
		uint16 ip_proto;

		for (ip_proto = 0 ; ip_proto < 256 ; ip_proto ++)
		{
			switch (ip_proto)
			{
				case IPPROTO_UDP:
				case IPPROTO_TCP:
				case IPPROTO_ICMP:
					// skip tcp/udp/icmp
					continue;
				default:
					break;
			}
			for (pkt_no = 1 ; pkt_no <= last_pkt_no ; pkt_no ++)
			{
				/* input */
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IP;
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP);
				CP_MAC (mac_npi, conf.conf_smac);
				CP_MAC (mac_gw_int, conf.conf_dmac);
				conf.conf_sip						= ip_npi;
				conf.conf_dip						= ip_npi2;
				conf.ip.id							= 0xa;
				conf.ip.mf						= (pkt_no == last_pkt_no)? 0 : 1;
				conf.ip.offset						= (1456 * (pkt_no - 1));
				conf.ip.ttl							= 234;
				conf.ip.protocol					= (uint8)ip_proto;
				conf.payload.content				= pkt_content;
				conf.payload.length				= 1456;
				conf.conf_vlanIdx					= 2;
				SET_RX_PORT(conf.conf_portlist, 1);

				mbuf_in = genMbufPkt(&conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
			}
			VALUE_CMP(mbufList_nmbuf(), last_pkt_no);
			for (pkt_no = 1 ; pkt_no <= last_pkt_no ; pkt_no ++)
			{
				/* output */	
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IP;
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP);
				CP_MAC (mac_gw_int2, conf.conf_smac);
				CP_MAC (mac_npi2, conf.conf_dmac);
				conf.conf_sip						= ip_npi;
				conf.conf_dip						= ip_npi2;
				conf.ip.id							= 0xa;
				conf.ip.mf						= (pkt_no == last_pkt_no?0:1);
				conf.ip.offset						= (1456 * (pkt_no - 1));
				conf.ip.ttl							= 233;
				conf.ip.protocol					= (uint8)ip_proto;
				conf.payload.content				= pkt_content;
				conf.payload.length				= 1456;
				conf.conf_vlanIdx					= 3;
				ADD_TX_PORT(conf.conf_portlist, 4);
	
				mbuf_comp = genMbufPkt(&conf);
				mbuf_comp->m_pkthdr->ph_flags &= (~CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	return SUCCESS;
}

/*
@func Testing		| route-frag-2	| fragment packet route fucntion test 2
@rvalue SUCCESS	| 	test OK
@comm
Test the routing function for out-of-order fragment packets
 */
int32 pkt_route_frag2(uint32 caseNo){
	/**********************************************
		2 lan

		Fragment, out of order

		UDP
		NPI1	->	NPI2

		ICMP
		NPI1	->	NPI2		ALL Types

		IP packet
	**********************************************/
	int8 pkt_content[1456];
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	int pkt_no;
	const int last_pkt_no = 5;	// for 1 kind of TCP packet, we generate 5 packet for it
	uint16 icmp_type;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/***************
		UDP test
	***************/
	{
		for (pkt_no = last_pkt_no ; pkt_no >= 1; pkt_no --)
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_UDP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_npi2, 234, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
				port_npi, port_npi2, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):sizeof(pkt_content)));	

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		VALUE_CMP(mbufList_nmbuf(), last_pkt_no);
		for (pkt_no = 1 ; pkt_no <= last_pkt_no; pkt_no ++)
		{
			{
				uint16 tx_list[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_UDP, tx_list, 3, 0,
					mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 233, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
					port_npi, port_npi2, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(1456-sizeof(struct udphdr)):1456));	

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/***************
		ICMP test
	***************/
	for (icmp_type = 0 ; icmp_type < 256 ; icmp_type ++)
	{
		for (pkt_no = last_pkt_no ; pkt_no >= 1; pkt_no --)
		{
			rtl8651_dosOneSecondTimer();	// assume 1 icmp packet per-second

			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_npi2, 222, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
				port_npi, port_npi2, 0, 0, (uint8)icmp_type, 1, pkt_content, (pkt_no == 1?(1456-8):1456));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		VALUE_CMP(mbufList_nmbuf(), last_pkt_no);
		for (pkt_no = 1; pkt_no <= last_pkt_no; pkt_no ++)
		{
			{
				uint16 tx_list[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_ICMP, tx_list, 3, 0,
					mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 221, (pkt_no == last_pkt_no?0:1), (1456 * (pkt_no - 1)),
					port_npi, port_npi2, 0, 0, (uint8)icmp_type, 1, pkt_content, (pkt_no == 1?(1456-8):1456));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/***************
		Other test
	***************/
	{
		uint16 ip_proto;

		for (ip_proto = 0 ; ip_proto < 256 ; ip_proto ++)
		{
			switch (ip_proto)
			{
				case IPPROTO_UDP:
				case IPPROTO_TCP:
				case IPPROTO_ICMP:
					// skip tcp/udp/icmp
					continue;
				default:
					break;
			}
			for (pkt_no = last_pkt_no ; pkt_no >= 1; pkt_no --)
			{
				/* input */
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IP;
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP);
				CP_MAC (mac_npi, conf.conf_smac);
				CP_MAC (mac_gw_int, conf.conf_dmac);
				conf.conf_sip						= ip_npi;
				conf.conf_dip						= ip_npi2;
				conf.ip.id							= 0xa;
				conf.ip.mf						= (pkt_no == last_pkt_no)? 0 : 1;
				conf.ip.offset						= (1456 * (pkt_no - 1));
				conf.ip.ttl							= 234;
				conf.ip.protocol					= (uint8)ip_proto;
				conf.payload.content				= pkt_content;
				conf.payload.length				= 1456;
				conf.conf_vlanIdx					= 2;
				SET_RX_PORT(conf.conf_portlist, 1);

				mbuf_in = genMbufPkt(&conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
			}
			VALUE_CMP(mbufList_nmbuf(), last_pkt_no);
			for (pkt_no = 1 ; pkt_no <= last_pkt_no ; pkt_no ++)
			{
				/* output */	
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IP;
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP);
				CP_MAC (mac_gw_int2, conf.conf_smac);
				CP_MAC (mac_npi2, conf.conf_dmac);
				conf.conf_sip						= ip_npi;
				conf.conf_dip						= ip_npi2;
				conf.ip.id							= 0xa;
				conf.ip.mf						= (pkt_no == last_pkt_no?0:1);
				conf.ip.offset						= (1456 * (pkt_no - 1));
				conf.ip.ttl							= 233;
				conf.ip.protocol					= (uint8)ip_proto;
				conf.payload.content				= pkt_content;
				conf.payload.length				= 1456;
				conf.conf_vlanIdx					= 3;
				ADD_TX_PORT(conf.conf_portlist, 4);
	
				mbuf_comp = genMbufPkt(&conf);
				mbuf_comp->m_pkthdr->ph_flags &= (~CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	return SUCCESS;
}


/*
	napt
	normal host
	No ARP entry
*/
/*
@func Testing		| napt-1	| NAPT fucntion test 1
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for TCP/UDP packets
 */
int32 pkt_napt_normal1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP
		NPI	->	RP, SYN
		RP	->	NPI, SYN,ACK
		NPI	->	RP, ACK
		NPI	->	RP, long packet		(fast path)
		RP	->	NPI, normal packet		(fast path)
		NPI	->	RP, FIN
		RP	->	NPI, FIN, ACK
		NPI	->	RP, ACK

		UDP
		NPI	->	RP					(slow path)
		RP	->	NPI					(fast path)
		NPI 	->	RP					(fast path)
		RP	->	NPI					(fast path)

		test for:
				1. napt slow path
				2. napt fast path
				3. l3ActRouting's fragment
				4. PPPoE
				5. ARP auto generate
				6. queue packet for ARP
				7. arp-receive and dequeue packet
		
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

/*************

	TCP test

*************/
	/*
		NPI	->	RP :
					Slow path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
					ip_npi, ip_rp, 255, 0, 0,
					port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
	/* packet input */
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* NPI->RP (after NAPT) */
	{
		uint16 tx_list[2] = {0, 0xffff};	
		mbuf_comp = confPppoeHSA(&conf, NULL,
						_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, 254, 0, 0,
						port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
	}
	MBUF_CMPandFREE(mbuf_out, mbuf_comp);
}
	/*
		RP	->	NPI :
					Slow path
					Output: 	ARP request
					Input: 	ARP reply
					Output:	NAPT-R translate packet
	*/
{
	/* RP->NPI */
	mbuf_in = confPppoeHSB(&conf, NULL,
				_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 255, 0, 0,
				port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, pkt_content, 10);

	/* packet input */
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	{
		uint16 tx_port[4] = {1,2,3,0xffff};
		mbuf_comp = confArpHSA( &conf, tx_port, 2,
			mac_gw_int, mac_bcast, ip_gw_int, ip_npi, ARPOP_REQUEST);
	}
	VALUE_CMP(mbufList_nmbuf(), 1);
	MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

	/* config */
	/* arp reply */
	mbuf_in = confArpHSB(&conf, 1, 2, mac_npi, mac_gw_int, ip_npi, ip_gw_int, ARPOP_REPLY);
	/* packet input */
	mbufList_Reinit();
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	{
		uint16 tx_port[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, pkt_content, 10);
	}
	VALUE_CMP(mbufList_nmbuf(), 1);
	MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
}
	/*
		NPI	->	RP
					Slow path
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP
					Fast path
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1500;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);	
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);


	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	VALUE_CMP(mbufList_nmbuf(), 2);
	// First packet
	mbuf_out = mbufList_dequeue();
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 1;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452; /* TCP payload only, PPPoE header not taken into consideration */
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	// second packet
	mbuf_out = mbufList_dequeue();
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 1472;//64;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 48;	/* decrease added TCP header length(20bytes) */
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);
	mbuf_comp = genMbufPkt(&conf);
	mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		RP	->	NPI :
					Fast path
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= TH_ACK;
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1000;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP
					Fast path
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	VALUE_CMP(mbufList_nmbuf(), 1);

	mbuf_out = mbufList_dequeue();
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);
	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP (FIN)
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_FIN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	VALUE_CMP(mbufList_nmbuf(), 1);

	mbuf_out = mbufList_dequeue();
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_FIN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);
	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI (FIN, ACK)
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_FIN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_FIN|TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1000;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP (ACK)
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	VALUE_CMP(mbufList_nmbuf(), 1);

	mbuf_out = mbufList_dequeue();
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);
	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


/*************

	UDP test

*************/
	/*
		NPI	->	RP :
					Slow path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		RP	->	NPI :
					Fast Path
					Output:	NAPT-R translate packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP :
					Fast Path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}

/*
@func Testing		| napt-2	| NAPT fucntion test 2
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP outbound packets
 */
int32 pkt_napt_normal2(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP
		NPI	->	RP,  ICMP_ECHO
		RP	->	NPI, ICMP_ECHOREPLY
		NPI	->	RP,	ICMP_TSTAMP	
		RP	->	NPI, ICMP_TSTAMPREPLY
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id_int = 1;
	uint16 id_ext = 2;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/********************
	ICMP message
********************/
/*
	NPI	->	RP	ECHO
*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_int;
	conf.icmp.seq						= 0;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	/* get external ip/id */
	ASSERT(get_mbuf_IpId(mbuf_out, &ip_gw_ext, NULL, &id_ext)==SUCCESS);	

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 0;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
/*
	RP	->	NPI	ECHO_REPLY
*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= ICMP_ECHOREPLY;
	conf.icmp.code						= 0;
	conf.icmp.id							= id_int;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
	NPI	->	RP	TSTAMP
*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= ICMP_TSTAMP;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_int;
	conf.icmp.seq						= 0;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	/* get external ip/id */
	ASSERT(get_mbuf_IpId(mbuf_out, &ip_gw_ext, NULL, &id_ext)==SUCCESS);	

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.icmp.type					= ICMP_TSTAMP;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 0;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
/*
	RP	->	NPI	TSTAMPREPLY
*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= ICMP_TSTAMPREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= ICMP_TSTAMPREPLY;
	conf.icmp.code						= 0;
	conf.icmp.id							= id_int;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
return SUCCESS;
}

/*
@func Testing		| napt-3	| NAPT fucntion test 3
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP error messages from Remote-Host to Internal-Host (error packet is TCP)
 */
int32 pkt_napt_normal3(uint32 caseNo){
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP Error Message
		NPI	->	RP, SYN (TCP)
		RP	->	NPI, ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id = 1;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*
	Error flow setup
		NPI	->	RP :
*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_TCP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf_err_int.conf_smac);
	CP_MAC (mac_gw_int, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_npi;
	conf_err_int.conf_dip						= ip_rp;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 255;
	conf_err_int.conf_sport						= port_npi;
	conf_err_int.conf_dport						= port_rp;
	conf_err_int.conf_tcp_seq					= 0xb;
	conf_err_int.conf_tcp_ack					= 0xc;
	conf_err_int.conf_tcp_flag					= TH_SYN;
	conf_err_int.conf_tcp_win					= 0xfffe;
	conf_err_int.conf_tcp_mss					= 1460;
	conf_err_int.payload.content					= NULL;
	conf_err_int.payload.length					= 0;

	conf_err_int.conf_vlanIdx					= 2;
	SET_RX_PORT(conf_err_int.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_int);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_TCP;
	conf_err_ext.l2Flag							= 0;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_smac);
	CP_MAC(mac_pppoe, conf_err_ext.conf_dmac);
	conf_err_ext.conf_sip						= ip_gw_ext;
	conf_err_ext.conf_dip						= ip_rp;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 254;
	conf_err_ext.conf_sport						= port_gw;
	conf_err_ext.conf_dport						= port_rp;
	conf_err_ext.conf_tcp_seq					= 0xb;
	conf_err_ext.conf_tcp_ack					= 0xc;
	conf_err_ext.conf_tcp_flag					= TH_SYN;
	conf_err_ext.conf_tcp_win					= 0xfffe;
	conf_err_ext.conf_tcp_mss					= 1452;
	conf_err_ext.payload.content				= NULL;
	conf_err_ext.payload.length					= 0;
	conf_err_ext.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf_err_ext.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf_err_ext);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/********************
	ICMP message
********************/
/*
		RP	->	NPI	ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB
*/
for(nCount = 0; nCount < 4; nCount++)
{
	// when comparing mbuf, must modify conf_err_int's ttl and conf_err_ext's mss
	conf_err_int.ip.ttl = conf_err_ext.ip.ttl;
	conf_err_int.conf_tcp_mss = conf_err_ext.conf_tcp_mss = 1452;

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)(msg_arr[nCount]);
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genIcmpErrMbufPkt(&conf_err_ext, &conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	// icmp packet
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= (uint8)(msg_arr[nCount]);
	conf.icmp.code						= 0;
	conf.icmp.id							= id;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genIcmpErrMbufPkt(&conf_err_int, &conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

return SUCCESS;
}
/*
@func Testing		| napt-4	| NAPT fucntion test 4
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP error messages from Internal-Host to Remote-Host (error packet is TCP)
 */
int32 pkt_napt_normal4(uint32 caseNo){
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP Error Message
		RP	->	NPI, SYN (TCP)
		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id = 1;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*
	Error flow setup
		NPI	->	RP,
		RP	->	NPI:
*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_TCP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf_err_int.conf_smac);
	CP_MAC (mac_gw_int, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_npi;
	conf_err_int.conf_dip						= ip_rp;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 255;
	conf_err_int.conf_sport						= port_npi;
	conf_err_int.conf_dport						= port_rp;
	conf_err_int.conf_tcp_seq					= 0xb;
	conf_err_int.conf_tcp_ack					= 0xc;
	conf_err_int.conf_tcp_flag					= TH_SYN;
	conf_err_int.conf_tcp_win					= 0xfffe;
	conf_err_int.conf_tcp_mss					= 1460;
	conf_err_int.payload.content					= NULL;
	conf_err_int.payload.length					= 0;

	conf_err_int.conf_vlanIdx					= 2;
	SET_RX_PORT(conf_err_int.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_int);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_TCP;
	conf_err_ext.l2Flag							= 0;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_smac);
	CP_MAC(mac_pppoe, conf_err_ext.conf_dmac);
	conf_err_ext.conf_sip						= ip_gw_ext;
	conf_err_ext.conf_dip						= ip_rp;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 254;
	conf_err_ext.conf_sport						= port_gw;
	conf_err_ext.conf_dport						= port_rp;
	conf_err_ext.conf_tcp_seq					= 0xb;
	conf_err_ext.conf_tcp_ack					= 0xc;
	conf_err_ext.conf_tcp_flag					= TH_SYN;
	conf_err_ext.conf_tcp_win					= 0xfffe;
	conf_err_ext.conf_tcp_mss					= 1452;
	conf_err_ext.payload.content				= NULL;
	conf_err_ext.payload.length					= 0;
	conf_err_ext.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf_err_ext.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf_err_ext);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* RP->NPI */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_TCP;
	conf_err_ext.l2Flag							= L2_PPPoE;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_pppoe, conf_err_ext.conf_smac);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_dmac);
	conf_err_ext.pppoe.type					= 0x8864;
	conf_err_ext.conf_sip						= ip_rp;
	conf_err_ext.conf_dip						= ip_gw_ext;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 123;
	conf_err_ext.conf_sport						= port_rp;
	conf_err_ext.conf_dport						= port_gw;
	conf_err_ext.conf_tcp_seq					= 0xb;
	conf_err_ext.conf_tcp_ack					= 0xc;
	conf_err_ext.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf_err_ext.conf_tcp_win					= 0xfffe;
	conf_err_ext.conf_tcp_mss					= 1460;
	conf_err_ext.payload.content				= NULL;
	conf_err_ext.payload.length					= 0;
	conf_err_ext.conf_vlanIdx					= 1;
	conf_err_ext.conf_pppoeIdx					= 0;
	SET_RX_PORT(conf_err_ext.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_ext);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_TCP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_int, conf_err_int.conf_smac);
	CP_MAC(mac_npi, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_rp;
	conf_err_int.conf_dip						= ip_npi;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 122;
	conf_err_int.conf_sport						= port_rp;
	conf_err_int.conf_dport						= port_npi;
	conf_err_int.conf_tcp_seq					= 0xb;
	conf_err_int.conf_tcp_ack					= 0xc;
	conf_err_int.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf_err_int.conf_tcp_win					= 0xfffe;
	conf_err_int.conf_tcp_mss					= 1452;
	conf_err_int.payload.content					= NULL;
	conf_err_int.payload.length					= 0;
	conf_err_int.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf_err_int.conf_portlist, 1);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	mbuf_comp = genMbufPkt(&conf_err_int);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	
}
/********************
	ICMP message
********************/
/*
		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB
*/
for(nCount = 0; nCount < 4; nCount++)
{
	// when comparing mbuf, must modify conf_err_int's ttl and conf_err_ext's mss
	conf_err_ext.ip.ttl = conf_err_int.ip.ttl;
	conf_err_ext.conf_tcp_mss = conf_err_int.conf_tcp_mss = 1452;

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)(msg_arr[nCount]);
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genIcmpErrMbufPkt(&conf_err_int, &conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	// icmp packet
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip							= ip_gw_ext;
	conf.conf_dip							= ip_rp;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= (uint8)(msg_arr[nCount]);
	conf.icmp.code						= 0;
	conf.icmp.id							= id;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;
	conf.conf_pppoeIdx					= 0;

	mbuf_comp = genIcmpErrMbufPkt(&conf_err_ext, &conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

return SUCCESS;
}
/*
@func Testing		| napt-5	| NAPT fucntion test 5
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP error messages from Remote-Host to Internal-Host (error packet is UDP)
 */
int32 pkt_napt_normal5(uint32 caseNo){
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP Error Message
		NPI	->	RP, (UDP)
		RP	->	NPI, ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id = 1;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;
	
	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*
	Error flow setup
		NPI	->	RP :
*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_UDP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf_err_int.conf_smac);
	CP_MAC (mac_gw_int, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_npi;
	conf_err_int.conf_dip						= ip_rp;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 255;
	conf_err_int.conf_sport						= port_npi;
	conf_err_int.conf_dport						= port_rp;
	conf_err_int.payload.content					= pkt_content;
	conf_err_int.payload.length					= sizeof(pkt_content);

	conf_err_int.conf_vlanIdx					= 2;
	SET_RX_PORT(conf_err_int.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_int);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_UDP;
	conf_err_ext.l2Flag							= 0;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_smac);
	CP_MAC(mac_pppoe, conf_err_ext.conf_dmac);
	conf_err_ext.conf_sip						= ip_gw_ext;
	conf_err_ext.conf_dip						= ip_rp;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 254;
	conf_err_ext.conf_sport						= port_gw;
	conf_err_ext.conf_dport						= port_rp;
	conf_err_ext.payload.content				= pkt_content;
	conf_err_ext.payload.length					= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf_err_ext.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf_err_ext);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/********************
	ICMP message
********************/
/*
		RP	->	NPI	ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB
*/
for(nCount = 0; nCount < 4; nCount++)
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)(msg_arr[nCount]);
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genIcmpErrMbufPkt(&conf_err_ext, &conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	// icmp packet
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= (uint8)(msg_arr[nCount]);
	conf.icmp.code						= 0;
	conf.icmp.id							= id;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	// when comparing mbuf, must modify conf_err_int's ttl
	conf_err_int.ip.ttl = conf_err_ext.ip.ttl;

	mbuf_comp = genIcmpErrMbufPkt(&conf_err_int, &conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
return SUCCESS;
}
/*
@func Testing		| napt-6	| NAPT fucntion test 6
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP error messages from Internal-Host to Remote-Host (error packet is UDP)
 */
int32 pkt_napt_normal6(uint32 caseNo){
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP Error Message
		RP	->	NPI, (UDP)
		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id = 1;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*
	Error flow setup
		NPI	->	RP,
		RP	->	NPI:
*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_UDP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf_err_int.conf_smac);
	CP_MAC (mac_gw_int, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_npi;
	conf_err_int.conf_dip						= ip_rp;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 255;
	conf_err_int.conf_sport						= port_npi;
	conf_err_int.conf_dport						= port_rp;
	conf_err_int.payload.content					= pkt_content;
	conf_err_int.payload.length					= sizeof(pkt_content);

	conf_err_int.conf_vlanIdx					= 2;
	SET_RX_PORT(conf_err_int.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_int);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_UDP;
	conf_err_ext.l2Flag							= 0;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_smac);
	CP_MAC(mac_pppoe, conf_err_ext.conf_dmac);
	conf_err_ext.conf_sip						= ip_gw_ext;
	conf_err_ext.conf_dip						= ip_rp;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 254;
	conf_err_ext.conf_sport						= port_gw;
	conf_err_ext.conf_dport						= port_rp;
	conf_err_ext.payload.content				= pkt_content;
	conf_err_ext.payload.length					= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf_err_ext.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf_err_ext);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* RP->NPI */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_UDP;
	conf_err_ext.l2Flag							= L2_PPPoE;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_pppoe, conf_err_ext.conf_smac);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_dmac);
	conf_err_ext.pppoe.type					= 0x8864;
	conf_err_ext.conf_sip						= ip_rp;
	conf_err_ext.conf_dip						= ip_gw_ext;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 123;
	conf_err_ext.conf_sport						= port_rp;
	conf_err_ext.conf_dport						= port_gw;
	conf_err_ext.payload.content				= pkt_content;
	conf_err_ext.payload.length					= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx					= 1;
	conf_err_ext.conf_pppoeIdx					= 0;
	SET_RX_PORT(conf_err_ext.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_ext);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_UDP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_int, conf_err_int.conf_smac);
	CP_MAC(mac_npi, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_rp;
	conf_err_int.conf_dip						= ip_npi;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 122;
	conf_err_int.conf_sport						= port_rp;
	conf_err_int.conf_dport						= port_npi;
	conf_err_int.payload.content					= pkt_content;
	conf_err_int.payload.length					= sizeof(pkt_content);
	conf_err_int.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf_err_int.conf_portlist, 1);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	mbuf_comp = genMbufPkt(&conf_err_int);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	
}
/********************
	ICMP message
********************/
/*
		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB
*/
for(nCount = 0; nCount < 4; nCount++)
{
	// when comparing mbuf, must modify conf_err_int's ttl
	conf_err_ext.ip.ttl = conf_err_int.ip.ttl;

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)(msg_arr[nCount]);
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genIcmpErrMbufPkt(&conf_err_int, &conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	// icmp packet
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip							= ip_gw_ext;
	conf.conf_dip							= ip_rp;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= (uint8)(msg_arr[nCount]);
	conf.icmp.code						= 0;
	conf.icmp.id							= id;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;
	conf.conf_pppoeIdx					= 0;

	mbuf_comp = genIcmpErrMbufPkt(&conf_err_ext, &conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

return SUCCESS;
}
/*
@func Testing		| napt-7	| NAPT fucntion test 7
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP error messages from Remote-Host to Internal-Host (error packet is ICMP)
 */
int32 pkt_napt_normal7(uint32 caseNo){
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP Error Message
		NPI	->	RP, (ICMP)
		RP	->	NPI, ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id = 1;
	uint16 id_err = 0xa;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;
	
	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*
	Error flow setup
		NPI	->	RP :
*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_ICMP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf_err_int.conf_smac);
	CP_MAC (mac_gw_int, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_npi;
	conf_err_int.conf_dip						= ip_rp;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 255;
	conf_err_int.icmp.type						= ICMP_ECHO;
	conf_err_int.icmp.code						= 0;
	conf_err_int.icmp.id						= id_err;
	conf_err_int.icmp.seq						= 0;
	conf_err_int.payload.content					= pkt_content;
	conf_err_int.payload.length					= sizeof(pkt_content);

	conf_err_int.conf_vlanIdx					= 2;
	SET_RX_PORT(conf_err_int.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_int);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &id_err)==SUCCESS);

	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_ICMP;
	conf_err_ext.l2Flag							= 0;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_smac);
	CP_MAC(mac_pppoe, conf_err_ext.conf_dmac);
	conf_err_ext.conf_sip						= ip_gw_ext;
	conf_err_ext.conf_dip						= ip_rp;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 254;
	conf_err_ext.icmp.type						= ICMP_ECHO;
	conf_err_ext.icmp.code						= 0;
	conf_err_ext.icmp.id						= id_err;
	conf_err_ext.icmp.seq						= 0;
	conf_err_ext.payload.content				= pkt_content;
	conf_err_ext.payload.length					= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf_err_ext.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf_err_ext);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/********************
	ICMP message
********************/
/*
		RP	->	NPI	ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB
*/
for(nCount = 0; nCount < 4; nCount++)
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)(msg_arr[nCount]);
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genIcmpErrMbufPkt(&conf_err_ext, &conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	// icmp packet
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= (uint8)(msg_arr[nCount]);
	conf.icmp.code						= 0;
	conf.icmp.id							= id;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	// when comparing mbuf, must modify conf_err_int's ttl
	conf_err_int.ip.ttl = conf_err_ext.ip.ttl;

	mbuf_comp = genIcmpErrMbufPkt(&conf_err_int, &conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

return SUCCESS;
}
/*
@func Testing		| napt-8	| NAPT fucntion test 8
@rvalue SUCCESS	| 	test OK
@comm
Test the NAPT function for ICMP error messages from Internal-Host to Remote-Host (error packet is ICMP)
 */
int32 pkt_napt_normal8(uint32 caseNo){
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP Error Message
		RP	->	NPI, (ICMP ECHO REQUEST)	=> Must Add DMZhost: NPI
		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id = 1;
	uint16 id_err = 2;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

/*
	Error flow setup
		RP	->	NPI:
*/
{
	/* RP->NPI */
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType						= _PKT_TYPE_ICMP;
	conf_err_ext.l2Flag							= L2_PPPoE;
	conf_err_ext.ErrFlag						= 0;
	conf_err_ext.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_pppoe, conf_err_ext.conf_smac);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_dmac);
	conf_err_ext.pppoe.type					= 0x8864;
	conf_err_ext.conf_sip						= ip_rp;
	conf_err_ext.conf_dip						= ip_gw_ext;
	conf_err_ext.ip.id							= 0xa;
	conf_err_ext.ip.mf							= 0;
	conf_err_ext.ip.offset						= 0;
	conf_err_ext.ip.ttl							= 123;
	conf_err_ext.icmp.type						= ICMP_ECHO;
	conf_err_ext.icmp.code						= 0;
	conf_err_ext.icmp.id						= id_err;
	conf_err_ext.icmp.seq						= 1;
	conf_err_ext.payload.content				= pkt_content;
	conf_err_ext.payload.length					= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx					= 1;
	conf_err_ext.conf_pppoeIdx					= 0;
	SET_RX_PORT(conf_err_ext.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf_err_ext);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf_err_int);
	conf_err_int.pktType						= _PKT_TYPE_ICMP;
	conf_err_int.l2Flag							= 0;
	conf_err_int.ErrFlag						= 0;
	conf_err_int.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_int, conf_err_int.conf_smac);
	CP_MAC(mac_npi, conf_err_int.conf_dmac);
	conf_err_int.conf_sip						= ip_rp;
	conf_err_int.conf_dip						= ip_npi;
	conf_err_int.ip.id							= 0xa;
	conf_err_int.ip.mf							= 0;
	conf_err_int.ip.offset						= 0;
	conf_err_int.ip.ttl							= 122;
	conf_err_int.icmp.type						= ICMP_ECHO;
	conf_err_int.icmp.code						= 0;
	conf_err_int.icmp.id						= id_err;
	conf_err_int.icmp.seq						= 1;
	conf_err_int.payload.content					= pkt_content;
	conf_err_int.payload.length					= sizeof(pkt_content);
	conf_err_int.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf_err_int.conf_portlist, 1);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	mbuf_comp = genMbufPkt(&conf_err_int);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
/********************
	ICMP message
********************/
/*
		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB
*/
for(nCount = 0; nCount < 4; nCount++)
{
	// when comparing mbuf, must modify conf_err_int's ttl
	conf_err_ext.ip.ttl = conf_err_int.ip.ttl;

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)(msg_arr[nCount]);
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 0;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genIcmpErrMbufPkt(&conf_err_int, &conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	// icmp packet
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ICMP;
	conf.l2Flag							= 0;
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip							= ip_gw_ext;
	conf.conf_dip							= ip_rp;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.icmp.type						= (uint8)(msg_arr[nCount]);
	conf.icmp.code						= 0;
	conf.icmp.id							= id;
	conf.icmp.seq							= 0;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;
	conf.conf_pppoeIdx					= 0;

	mbuf_comp = genIcmpErrMbufPkt(&conf_err_ext, &conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

return SUCCESS;
}

int32 pkt_newflow_acl1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP
		NPI	->	RP, SYN

		UDP
		NPI	->	RP

		test for:
				1. napt-out slow path with "L4NEWFLOW"-ACL rule. 
		
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

/*************

	TCP test

*************/
{
	/* config */
	/* =================================== NPI --> RP ========================= */
	mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
					ip_npi, ip_rp, 255, 0, 0,
					port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
	// (1)
	/* Add an ACL rule of L4NEWFLOW matchType to block 1st SYN pkt. */
	rtl8651_tblDrvAclRule_t testAcl;

	memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
	testAcl.ruleType_ = RTL8651_ACL_IP;
	testAcl.actionType_ = RTL8651_ACL_DROP;
	testAcl.srcIpAddr_ = ntohl(inet_addr("192.168.1.1"));
	testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
	testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
	ASSERT(rtl8651a_addAclRule(0, "lan", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);

	/* packet input */
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 0);	// number of mbuf should be 0.
	ASSERT(mbufList_dequeue() == NULL);

	// (2)
	mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
					ip_npi, ip_rp, 255, 0, 0,
					port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);

	/* Delete that ACL rule. */
	ASSERT(rtl8651_delAclRule("lan", TRUE, &testAcl) == SUCCESS);

	/* packet input */
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* =========================== End of NPI --> RP  ============================ */
}

/*************

	UDP test

*************/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	// (1)
	/* Add an ACL rule of L4NEWFLOW matchType to block 1st UDP pkt. */
	rtl8651_tblDrvAclRule_t testAcl;

	memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
	testAcl.ruleType_ = RTL8651_ACL_IP;
	testAcl.actionType_ = RTL8651_ACL_DROP;
	testAcl.srcIpAddr_ = ntohl(inet_addr("192.168.1.1"));
	testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
	testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
	ASSERT(rtl8651a_addAclRule(0, "lan", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);
	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 0);	// number of mbuf should be 0.
	ASSERT(mbufList_dequeue() == NULL);

	// (2)
	/* Delete that ACL rule. */
        ASSERT(rtl8651_delAclRule("lan", TRUE, &testAcl) == SUCCESS);
	
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
}
	return SUCCESS;
}

int32 pkt_newflow_acl2(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		ICMP
		NPI	->	RP,  ICMP_ECHO with "L4NEWFLOW"-ACL rule.
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 id_int = 1;
	uint16 id_ext = 2;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/********************
	ICMP message
********************/
/*
	NPI	->	RP	ECHO
*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_int;
	conf.icmp.seq						= 0;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	// (1)
	/* Add an ACL rule of L4NEWFLOW matchType to block 1st ICMP pkt. */
	rtl8651_tblDrvAclRule_t testAcl;

	memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
	testAcl.ruleType_ = RTL8651_ACL_IP;
	testAcl.actionType_ = RTL8651_ACL_DROP;
	testAcl.srcIpAddr_ = ntohl(inet_addr("192.168.1.1"));
	testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
	testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
	ASSERT(rtl8651a_addAclRule(0, "lan", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 0);	// number of mbuf should be 0.
	ASSERT(mbufList_dequeue()== NULL);

	// (2)
	/* Delete that ACL rule. */
	ASSERT(rtl8651_delAclRule("lan", TRUE, &testAcl) == SUCCESS);

        mbuf_in = genMbufPkt(&conf);
        retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

        /* check result */
        VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	/* get external ip/id */
	ASSERT(get_mbuf_IpId(mbuf_out, &ip_gw_ext, NULL, &id_ext)==SUCCESS);	

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 0;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
return SUCCESS;
}


int32 pkt_newflow_acl3(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DmzHost test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NPI, SYN
		NPI	->	RP	SYN,ACK
		RP	->	NPI	ACK
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*************

	TCP test

*************/
	//add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);


	/*
		RP	->	NPI :
					Output: 	ARP request
					Input: 	ARP reply
					Output:	DMZ translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	// (1)
        /* Add an ACL rule of L4NEWFLOW matchType to block 1st ICMP pkt. */
        rtl8651_tblDrvAclRule_t testAcl;

        memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
        testAcl.ruleType_ = RTL8651_ACL_IP;
        testAcl.actionType_ = RTL8651_ACL_DROP;
        testAcl.srcIpAddr_ = ntohl(inet_addr("140.113.1.1"));
        testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
        testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
        ASSERT(rtl8651a_addAclRule(0, "pppoe", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 0);
	ASSERT(mbufList_dequeue()== NULL);

	// (2) delete that ACL rule
	ASSERT(rtl8651_delAclRule("pppoe", TRUE, &testAcl) == SUCCESS);

	/* packet input */
        mbuf_in = genMbufPkt(&conf);
        retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

        /* check result */
        VALUE_CMP(retval, SUCCESS);
        VALUE_CMP(mbufList_nmbuf(), 1);
}
	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	return SUCCESS;
}

int32 pkt_newflow_acl4(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DmzHost test

		1 wan(pppoe), 1 lan

		UDP
		RP	->	NPI
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
//	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
//	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();


	// add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/*
		RP	->	NPI :
					Output:	Dmz Host translate packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);


        // (1)
        /* Add an ACL rule of L4NEWFLOW matchType to block 1st ICMP pkt. */
        rtl8651_tblDrvAclRule_t testAcl;

        memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
        testAcl.ruleType_ = RTL8651_ACL_IP;
        testAcl.actionType_ = RTL8651_ACL_DROP;
        testAcl.srcIpAddr_ = ntohl(inet_addr("140.113.1.1"));
        testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
        testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
        ASSERT(rtl8651a_addAclRule(0, "pppoe", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
 	VALUE_CMP(mbufList_nmbuf(), 0);
        ASSERT(mbufList_dequeue()== NULL);
        
        // (2) delete that ACL rule
        ASSERT(rtl8651_delAclRule("pppoe", TRUE, &testAcl) == SUCCESS);

	/* packet input */
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
 	VALUE_CMP(mbufList_nmbuf(), 1);

}
	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	return SUCCESS;
}


int32 pkt_newflow_acl5(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DmzHost test

		1 wan(pppoe), 1 lan

		== Add dmzhost, rrtl8651_fwdEngineDMZHostIcmpPassThrough(1) ==
		RP	->	GW	ECHO
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	uint16 id_ext = 0x01;
	uint16 id_int = 0x02;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	// add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/*
		RP	->	GW: ECHO
					After adding dmz host, forward to dmz host
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

        // (1)
        /* Add an ACL rule of L4NEWFLOW matchType to block 1st ICMP pkt. */
        rtl8651_tblDrvAclRule_t testAcl;

        memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
        testAcl.ruleType_ = RTL8651_ACL_IP;
        testAcl.actionType_ = RTL8651_ACL_DROP;
        testAcl.srcIpAddr_ = ntohl(inet_addr("140.113.1.1"));
        testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
        testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
        ASSERT(rtl8651a_addAclRule(0, "pppoe", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);


	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
        VALUE_CMP(mbufList_nmbuf(), 0);
        ASSERT(mbufList_dequeue()== NULL);

        // (2) delete that ACL rule
        ASSERT(rtl8651_delAclRule("pppoe", TRUE, &testAcl) == SUCCESS);

	/* packet input */
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
        VALUE_CMP(mbufList_nmbuf(), 1);
}

	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	return SUCCESS;
}


int32 pkt_newflow_acl6(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

{
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	/*
		NPI	->	ServerPort, SYN
			Server port OK : Port bouncing!
	*/
	{
	       	// (1)
	        /* Add an ACL rule of L4NEWFLOW matchType to block 1st ICMP pkt. */
	        rtl8651_tblDrvAclRule_t testAcl;
	
	        memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
	        testAcl.ruleType_ = RTL8651_ACL_IP;
	        testAcl.actionType_ = RTL8651_ACL_DROP;
	        testAcl.srcIpAddr_ = ntohl(inet_addr("192.168.1.1"));
	        testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
	        testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
	        ASSERT(rtl8651a_addAclRule(0, "lan", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);

		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		ASSERT(mbufList_dequeue()== NULL);

	        // (2) delete that ACL rule
	        ASSERT(rtl8651_delAclRule("lan", TRUE, &testAcl) == SUCCESS);

		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_SYN, 1460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
}
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	return SUCCESS;
}


int32 pkt_newflow_acl7(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

{
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	/*
		NPI	->	ServerPort
	*/
	{
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_npi, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 123;
		conf.conf_sport					= port_npi;
		conf.conf_dport					= port_gw;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;

		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 1);

	}

	/*
		NPI	->	ServerPort
			Server port OK : Port bouncing!
	*/
	{
                // (1)
                /* Add an ACL rule of L4NEWFLOW matchType to block 1st ICMP pkt. */
                rtl8651_tblDrvAclRule_t testAcl;

                memset((void*) &testAcl, 0, sizeof(rtl8651_tblDrvAclRule_t));
                testAcl.ruleType_ = RTL8651_ACL_IP;
                testAcl.actionType_ = RTL8651_ACL_DROP;
                testAcl.srcIpAddr_ = ntohl(inet_addr("192.168.1.1"));
                testAcl.srcIpAddrMask_  = ntohl(inet_addr("255.255.255.255"));
                testAcl.matchType_ = RTL8651_ACL_L4NEWFLOW;
                ASSERT(rtl8651a_addAclRule(0, "lan", 1, (rtl8651_tblDrvAclRule_t* )&testAcl) == SUCCESS);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genMbufPkt(&conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
                VALUE_CMP(mbufList_nmbuf(), 0);
                ASSERT(mbufList_dequeue()== NULL);

 		// (2) delete that ACL rule
                ASSERT(rtl8651_delAclRule("lan", TRUE, &testAcl) == SUCCESS);

		/* packet input */
		mbuf_in = genMbufPkt(&conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_serv, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_serv;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 122;
		conf.conf_sport					= port_npi;
		conf.conf_dport					= port_serv;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;
		ADD_TX_PORT(conf.conf_portlist, 4);
		conf.conf_vlanIdx					= 3;

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMP(mbuf_out, mbuf_comp);
		
		freeMbuf(mbuf_comp);
		freeMbuf(mbuf_out);
	}
}
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	return SUCCESS;
}



/*
@func int32		| Napt_UdpStaticPortTranslation1	| static port translation for UDP NAPT flow testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the UDP NAPT function with keeping port number (internal host's port == external port)
 */
int32 Napt_UdpStaticPortTranslation1(uint32 caseNo)
{
	int8 pkt_content[1400];
	struct rtl_mBuf *mbuf_in, *mbuf_out, *mbuf_comp;
	int32 retval;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		UDP

		NPI	->	RP	Disable Static Translation
		NPI	->	RP	Enable Static Translation, port will not be translated
		NPI	->	RP	Conflict with existing flow, so port will be translated
		NPI	->	RP	Conflict with protocol stack registered port, so port will be translated
		NPI	->	RP	Conflict with server port, so port will be translated
		NPI	->	RP	Conflict with trigger port, so port will be translated
		NPI	->	RP	Conflict with upnp mapping, so port will be translated
		NPI	->	RP	Disable Static Translation

		test for:
			check (translated source port) == (original source port)

		NOTE:
			The original source port can NOT be sent in the range that NAPT engine reserved,
			or the port assigned by NAP engine "might" equal to original port.
			It exceeds our expections.

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x10;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.113.1.2"));
	uint16 port_rp2 = 0x6789;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_rp3 = ntohl(inet_addr("140.113.1.3"));
	uint16 port_rp3 = 0x7890;
	uint16 port_gw;
	uint16 port_tmp;
	uint16 port_trigger;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn off DOS */
	rtl8651a_setDosStatus(0, 0);

	/*************************************************************
		(1)
			Before turning-ON UDP static mapping, external sport will be
			assigned by NAPT engine instead of original sport
	**************************************************************/
	/* disable UDP static port translation mode */
	ASSERT(rtl8651_fwdEngineUdpStaticNaptPortTranslation(FALSE) == SUCCESS);
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*************************************************************
		(2)
			We turn-ON UDP static mapping, external sport will equal to
			original sport if forwarding engine can do it.
	**************************************************************/
	/* enable UDP static port translation mode */
	ASSERT(rtl8651_fwdEngineUdpStaticNaptPortTranslation(TRUE) == SUCCESS);
	/*
		1. new connection from internal host to remote host, source port will not be translated.
	*/
	port_npi ++;	// change port for new connection
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		2. same internal ip/port as case 1, send to another dip/dport.
			=> because the flow is created by Hash2, so this connection will be treat as the
				same flow to the previous connection in 1
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp2, 123, 0, 0,
			port_npi, port_rp2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp2, 122, 0, 0,
				port_gw, port_rp2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp2, ip_gw_ext, 123, 0, 0,
			port_rp2, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp2, ip_npi, 122, 0, 0,
				port_rp2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		3. same port from another internal ip, port has been used and will be translated
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_npi2,
				ip_rp, ip_npi2, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		4. Register the port to forwarding engine.
			If the packet's sport is registered by protocol stack, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	// set as server
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_UDP, port_npi, 0x1234) == SUCCESS);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	port_npi ++;	// change port for new connection
	// set as client
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_CLIENT, IPPROTO_UDP, port_npi, 0x1234) == SUCCESS);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	rtl8651_flushProtoStackActions();
	/*
		5. Set the server port to forwarding engine.
			If the packet's sport is used by server port, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_npi, ip_npi2, 0xffff)== SUCCESS);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_npi, ip_npi2, 0xffff) == SUCCESS);
	/*
		6. Set the trigger port to forwarding engine.
			If the packet's sport is triggered by trigger port flow, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	port_tmp = port_npi + 500;
	port_trigger = 12345;
	ASSERT(rtl8651_addTriggerPortRule( 1, (port_tmp - 10), (port_tmp + 10), 1, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/*
		send trigger flow, port will not be translated
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_trigger, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_trigger, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_trigger, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_trigger, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		send packet with triggered port (port_tmp) for the triggered internal IP,
		port will be NOT translated
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_tmp, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_tmp, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_tmp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		send packet with triggered port (port_tmp + 1) for the other internal IP (not triggered internal IP),
		port will be translated.
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_rp, 123, 0, 0,
			port_tmp+1, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_NEQ(port_tmp+1, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_npi2,
				ip_rp, ip_npi2, 122, 0, 0,
				port_rp, port_tmp+1, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	rtl8651_flushTriggerPortRules();
	/*
		7. Set the uPnP mapping to forwarding engine.
			If the packet's sport is mapped by uPnP, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	rtl8651_addUpnpMap(UPNP_ONESHOT , ip_rp, port_rp, ip_gw_ext, port_npi, ip_npi, 0x1234);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		8.
			If the uPnP mapping entry's internal Port == external Port, and the packet's sport is mapped by uPnP,
			the sport can be keeped.
			However, if the source IP is fail, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	rtl8651_addUpnpMap(UPNP_ONESHOT , ip_rp, port_rp, ip_gw_ext, port_npi, ip_npi, port_npi);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_npi2,
				ip_rp, ip_npi2, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		9.
			If the uPnP mapping entry's internal Port == external Port,
			and the packet's sport is mapped by uPnP and source Ip is from internal Ip of uPnP mapping,
			the sport can be keeped.
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*************************************************************
		(3)
			Turn-OFF UDP static mapping again, external sport will be
			assigned by NAPT engine instead of original sport
	**************************************************************/
	/* disable UDP static port translation mode */
	ASSERT(rtl8651_fwdEngineUdpStaticNaptPortTranslation(FALSE) == SUCCESS);
	port_npi ++;	// change port for new connection
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

/*
@func int32		| Napt_TcpStaticPortTranslation1	| static port translation for TCP NAPT flow testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the TCP NAPT function with keeping port number (internal host's port == external port)
 */
int32 Napt_TcpStaticPortTranslation1(uint32 caseNo)
{
	int8 pkt_content[1400];
	struct rtl_mBuf *mbuf_in, *mbuf_out, *mbuf_comp;
	int32 retval;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP

		NPI	->	RP	(SYN)	Disable Static Translation
		NPI	->	RP	(SYN)	Enable Static Translation, port will not be translated
		NPI	->	RP	(SYN)	Conflict with existing flow, so port will be translated
		NPI	->	RP	(SYN)	Conflict with protocol stack registered port, so port will be translated
		NPI	->	RP	(SYN)	Conflict with server port, so port will be translated
		NPI	->	RP	(SYN)	Conflict with trigger port, so port will be translated
		NPI	->	RP	(SYN)	Conflict with upnp mapping, so port will be translated
		NPI	->	RP	(SYN)	Disable Static Translation

		test for:
			check (translated source port) == (original source port)

		NOTE:
			The original source port can NOT be sent in the range that NAPT engine reserved,
			or the port assigned by NAP engine "might" equal to original port.
			It exceeds our expections.

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x10;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.113.1.2"));
	uint16 port_rp2 = 0x6789;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_rp3 = ntohl(inet_addr("140.113.1.3"));
	uint16 port_rp3 = 0x7890;
	uint16 port_gw;
	uint16 port_tmp;
	uint16 port_trigger;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn off DOS */
	rtl8651a_setDosStatus(0, 0);

	/*************************************************************
		(1)
			Before turning-ON TCP static mapping, external sport will be
			assigned by NAPT engine instead of original sport
	**************************************************************/
	/* disable TCP static port translation mode */
	ASSERT(rtl8651_fwdEngineTcpStaticNaptPortTranslation(FALSE) == SUCCESS);
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*************************************************************
		(2)
			We turn-ON TCP static mapping, external sport will equal to
			original sport if forwarding engine can do it.
	**************************************************************/
	/* enable TCP static port translation mode */
	ASSERT(rtl8651_fwdEngineTcpStaticNaptPortTranslation(TRUE) == SUCCESS);
	/*
		1. new connection from internal host to remote host, source port will not be translated.
	*/
	port_npi ++;	// change port for new connection
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		2. same internal ip/port as case 1, send to another dip/dport.
			=> because the flow is created by Hash2, so this connection will be treat as the
				same flow to the previous connection in 1
	*/
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp2, 123, 0, 0,
			port_npi, port_rp2, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp2, 122, 0, 0,
				port_gw, port_rp2, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp2, ip_gw_ext, 123, 0, 0,
			port_rp2, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp2, ip_npi, 122, 0, 0,
				port_rp2, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		3. same port from another internal ip, port has been used and will be translated
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_npi2,
				ip_rp, ip_npi2, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		4. Register the port to forwarding engine.
			If the packet's sport is registered by protocol stack, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	// register as server
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_TCP, port_npi, 0x1234) == SUCCESS);
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	port_npi ++;	// change port for new connection
	// register as client
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_CLIENT, IPPROTO_TCP, port_npi, 0x1234) == SUCCESS);
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	rtl8651_flushProtoStackActions();
	/*
		5. Set the server port to forwarding engine.
			If the packet's sport is used by server port, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_npi, ip_npi2, 0xffff)== SUCCESS);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_npi, ip_npi2, 0xffff) == SUCCESS);
	/*
		6. Set the trigger port to forwarding engine.
			If the packet's sport is triggered by trigger port flow, the sport can be keeped.
	*/
	port_npi ++;	// change port for new connection
	port_tmp = port_npi + 500;
	port_trigger = 12345;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/*
		send trigger flow, port will not be translated
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_trigger, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_trigger, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		send packet with triggered port (port_tmp), port will be keeped
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_tmp, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_tmp, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_tmp, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		send packet with triggered port (port_tmp + 1), but internal IP is not the trigger Ip, port will be translated
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_rp, 123, 0, 0,
			port_tmp+1, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_tmp+1, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_npi2,
				ip_rp, ip_npi2, 122, 0, 0,
				port_rp, port_tmp+1, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	rtl8651_flushTriggerPortRules();
	/*
		7. Set the uPnP mapping to forwarding engine.
			If the packet's sport is mapped by uPnP, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP) , ip_rp, port_rp, ip_gw_ext, port_npi, ip_npi, 0x1234);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		8.
			If the uPnP mapping entry's internal Port == external Port, and the packet's sport is mapped by uPnP,
			the sport can be keeped.
			However, if the source IP is fail, the sport can NOT be keeped and
			must assigned by NAPT engine.
	*/
	port_npi ++;	// change port for new connection
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP) , ip_rp, port_rp, ip_gw_ext, port_npi, ip_npi, port_npi);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_npi2,
				ip_rp, ip_npi2, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		9.
			If the uPnP mapping entry's internal Port == external Port,
			and the packet's sport is mapped by uPnP and source Ip is from internal Ip of uPnP mapping,
			the sport can be keeped.
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port == original source port
		***********************************/
		VALUE_CMP(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*************************************************************
		(3)
			Turn-OFF TCP static mapping again, external sport will be
			assigned by NAPT engine instead of original sport
	**************************************************************/
	/* disable TCP static port translation mode */
	ASSERT(rtl8651_fwdEngineTcpStaticNaptPortTranslation(FALSE) == SUCCESS);
	port_npi ++;	// change port for new connection
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/***********************************
			External port != original source port
		***********************************/
		VALUE_NEQ(port_npi, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}


/*
@func int32		| Napt-fragment-udp-1	| napt with fragment packet UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT function for UDP fragment packet from Internal-Host to Remote-Host
 */
int32 pkt_napt_frag1(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		UDP
		NPI	->	RP
		RP	->	NPI
		NPI 	->	RP
		RP	->	NPI
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no;
	const int total_pkt = 5;
	uint16 udp_payload = 1448;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// only check Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
		NPI	->	RP
	*/
	{
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?5:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}
	/*
		NPI	->	RP, out-of-order
	*/
	// turn off dos
	rtl8651a_setDosStatus(0, 0);
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?5:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}
	// turn on dos
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);
	{
		/*
			NPI	->	RP, out-of-order 2
		*/
		{
			int i;
			int list[5] = {1, 3, 5, 2, 4};
			DEFAULT_IP_ID ++;
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				pkt_no = list[i - 1];
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?5:0);
			}
			// Output
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				// get external port
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				// for next packet
				}
			}
		}
	}
	/*
		RP	->	NPI
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?5:0);
		}
		// Output
		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_rp, ip_npi, 122, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	/*
		RP	->	NPI, out-of-order
	*/
	// turn off dos
	rtl8651a_setDosStatus(0, 0);
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?5:0);
		}
		// Output
		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_rp, ip_npi, 122, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	// turn on dos
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);
	{
		/*
			RP	->	NPI, out-of-order 2
		*/
		{
			int i;
			int list[5] = {2, 4, 5, 1, 3};
			DEFAULT_IP_ID ++;
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				pkt_no = list[i - 1];
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 15, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?5:0);
			}
			// Output
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						ip_rp, ip_npi, 14, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
	}
	return SUCCESS;
}
/*
	tcp
	serverport
	No ARP entry
*/
/*
@func int32		| Napt-serverport-tcp-1	| napt serverport TCP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT ServerPort function for normal TCP flow
 */
int32 pkt_napt_serverport_tcp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ServerPort test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NPI, ACK
		NPI	->	RP , ACK
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
					Output: 	ARP request
					Input: 	ARP reply
					Output:	Server Port translate packet
	*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_SYN;
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);

	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);

	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= TH_SYN;
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP :
	*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI :
					Output:	Server Port translate packet
	*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= TH_ACK;
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= TH_ACK;
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1000;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	// delete server port mapping
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	
	return SUCCESS;
}

/*
	tcp
	serverport
	Have ARP entry
*/
/*
@func int32		| Napt-serverport-tcp-2	| napt serverport TCP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT ServerPort function for TCP packets (with random TCP-flag)
 */
int32 pkt_napt_serverport_tcp_2(uint32 caseNo){
	/**********************************************
		ServerPort test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NPI	Any Flags
		NPI	->	RP	Any Flags
	**********************************************/
	int8 pkt_content[1452];
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	fwdeng_function_configuration1();

	/***************
		TCP test
	***************/
	{
		int8 *content_ptr;
		uint32 content_size;
		uint8 TCP_flag;

		for (TCP_flag = 0 ; TCP_flag < 64 ; TCP_flag ++)
		{
			port_rp ++;	/* modify source port for new flow */
			if (TCP_flag == TH_SYN)
			{
				content_ptr = NULL;
				content_size = 0;
			}
			else
			{
				content_ptr = pkt_content;
				content_size = sizeof(pkt_content);

				if (TCP_flag & TH_SYN)
					content_size -= 4;	// mss option
			}
			/*
				RP -> NPI
			*/
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, port_gw, TCP_flag, 1460, 0, 0, content_ptr, content_size);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);

			// check output
			switch (TCP_flag)
			{
				// DOS Cases:
				//	0: - NULL scan
				//	 3: SYN,FIN - SYN/FIN scan
				//	 8: PUSH	-Vecna
				//	 9: PUSH, FIN -Vecna
				//	 32: URG	-Vecna
				//	 33: URG, FIN -Vecna	
				//	 40: URG,PUSH -Vecna
				//	 41: URG,PUSH,FIN: - nmap xmas scan
				//	 58: SYN,ACK,URG,PUSH - full Sapu scan
				//	 63: SYN,RST,FIN,URG,PUSH,ACK - full Xmas scan
				case 0:
				case 3:
				case 8:
				case 9:
				case 32:
				case 33:
				case 40:
				case 41:
				case 58:
				case 63:
					// dos attack
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS ,RTL8651_LOG_DOS_TcpScan, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Scan"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
					break;
				default:
					{
						uint16 tx_list[2] = {1, 0xffff};
						mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0,
							mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_npi, TCP_flag, 1452, 0, 0, content_ptr, content_size);
					}
					VALUE_CMP(mbufList_nmbuf(), 1);
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	return SUCCESS;
}
/*
	tcp
	serverport
	Have ARP entry
*/
/*
@func int32		| Napt-serverport-tcp-3	| napt serverport TCP testing 3
@rvalue SUCCESS	| 	test OK
@comm
Test the function of the "Serverport Internal" set-up the connection to Remote-Host (with random TCP-flag)
, the first packet is not the SYN packet
(Serverport Internal IP/Port will be changed to Serverport External IP/Port)
 */
int32 pkt_napt_serverport_tcp_3(uint32 caseNo){
	/**********************************************
		ServerPort test	=> outbound packet sent first

		1 wan(pppoe), 1 lan

		TCP
		NPI	->	RP	any TCP_Flag
		RP	->	NPI	any TCP_Flag
	**********************************************/
	int8 pkt_content[1452];
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	fwdeng_function_configuration1();

	/***************
		TCP test
	***************/
	{
		int8 *content_ptr;
		uint32 content_size;
		uint8 TCP_flag;

		for (TCP_flag = 0 ; TCP_flag < 64 ; TCP_flag ++)
		{
			if (TCP_flag == TH_SYN)
			{
				content_ptr = NULL;
				content_size = 0;
			}
			else
			{
				content_ptr = pkt_content;
				content_size = sizeof(pkt_content);

				if (TCP_flag & TH_SYN)
					content_size -= 4;	// mss option
			}
			/*
				NPI -> RP
			*/
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_TCP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
				port_npi, port_rp, TCP_flag, 1460, 0, 0, content_ptr, content_size);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);

			// check output
			switch (TCP_flag)
			{
				// DOS Cases:
				//	0: - NULL scan
				//	 3: SYN,FIN - SYN/FIN scan
				//	 8: PUSH	-Vecna
				//	 9: PUSH, FIN -Vecna
				//	 32: URG	-Vecna
				//	 33: URG, FIN -Vecna	
				//	 40: URG,PUSH -Vecna
				//	 41: URG,PUSH,FIN: - nmap xmas scan
				//	 58: SYN,ACK,URG,PUSH - full Sapu scan
				//	 63: SYN,RST,FIN,URG,PUSH,ACK - full Xmas scan
				case 0:
				case 3:
				case 8:
				case 9:
				case 32:
				case 33:
				case 40:
				case 41:
				case 58:
				case 63:
					// dos attack
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS ,RTL8651_LOG_DOS_TcpScan, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Scan"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
					break;
				default:
					{
						uint16 tx_list[2] = {0, 0xffff};
						mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_rp, TCP_flag, 1452, 0, 0, content_ptr, content_size);
					}
					VALUE_CMP(mbufList_nmbuf(), 1);
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	return SUCCESS;
}
/*
	tcp
	serverport
	Have ARP entry
*/
/*
@func int32		| Napt-serverport-tcp-4	| napt serverport TCP testing 4
@rvalue SUCCESS	| 	test OK
@comm
Test the function of the "Serverport Internal" Host set-up the connection to Remote-Host, the first packet is the SYN packet.
For these flows, policy route might be applied and we can NOT use the "Serverport External IP/Port" as their external ip/port. (used in some ALGs)
 */
int32 pkt_napt_serverport_tcp_4(uint32 caseNo){
	/**********************************************
		ServerPort test	=> outbound packet sent first

		=> Tony: for some historic reasons, for outbound serverport SYN packet, policy route must applied and
				we cannot use serverport external ip/port here

		1 wan(pppoe), 1 lan

		TCP
		NPI	->	RP	SYN
		RP	->	NPI	SYN|ACK
	**********************************************/
	int8 pkt_content[1452];
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	uint16 port_gw_tmp;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	fwdeng_function_configuration1();

	/***************
		TCP test
	***************/
	{
		/*
			NPI -> RP	SYN
		*/
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, 
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tmp, NULL, NULL);
//		ASSERT(port_gw == port_gw_tmp);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_list, 1, 0,
				mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	{
		/*
			RP -> NPI	SYN|ACK
		*/
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_list, 2, 0,
				mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}

/*
	udp
	serverport
	Have ARP entry
*/
/*
@func int32		| Napt-serverport-udp-1	| napt serverport UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT ServerPort function for normal UDP flow
 */
int32 pkt_napt_serverport_udp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ServerPort test

		1 wan(pppoe), 1 lan

		UDP
		RP	->	NPI
		NPI 	->	RP		
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
					Output:	Server Port translate packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);	// Not Add ServerPort Entry yet
	freeMbuf(mbuf_in);

	// Re-config ServerPort Setting
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi)==SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi)==SUCCESS);

	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP :
					Output:	ServerPort translate with setting PPPoE auto-added
	*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);
	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	// delete server port mapping
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	return SUCCESS;
}
/*
@func int32		| Napt-serverport-udp-2	| napt serverport UDP testing 2
@rvalue SUCCESS	| 	test OK
@comm
Test the function of the "Serverport Internal" set-up the connection to Remote-Host
, Serverport Internal IP/Port will be changed to Serverport External IP/Port
 */
int32 pkt_napt_serverport_udp_2(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		ServerPort test

		1 wan(pppoe), 1 lan

		UDP
		NPI 	->	RP
		RP	->	NPI
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		add UDP Server port mapping
	*/
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi)==SUCCESS);

	/*
		NPI -> RP
	*/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* output */
		{
			uint16 tx_port[2] = {0, 0xffff};

			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}

	/*
		RP -> NPI
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* output */
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}

	/* delete server port mapping */
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	return SUCCESS;
}



/*
@func int32		| Napt-serverport-tcpudp-1	| napt serverport TCP/UDP hybrid testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT ServerPort function for TCP/UDP flow
Add TCP / UDP same port to different internal port, test for it correctness
 */
int32 pkt_napt_serverport_hybrid_1(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ServerPort test

		1 wan(pppoe), 1 lan

		TCP/UDP

		same external port  -- TCP ---> NPI1, port 1
						 -- UDP ----> NPI2, port 2

		RP	->	NPI
		NPI 	->	RP		
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x1235;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 2) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		1. Test port mapping

			TCP	: To NPI 1
			UDP : To NPI 2
	*/
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2) == SUCCESS);

	/*
		TCP

		RP	->	NPI :	To NPI 1
	*/
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 255, 0, 0, port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {1, 0xffff};	
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}


	/*
		UDP

		RP	->	NPI :	To NPI 2
	*/
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 255, 0, 0, port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {2, 0xffff};	
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 2, 0, mac_gw_int, mac_npi2,
							ip_rp, ip_npi2, 254, 0, 0,
							port_rp, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}

	/*
		TCP
		NPI	->	RP :	From NPI 1
	*/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 255, 0, 0,
			port_npi, port_rp,
			TH_SYN|TH_ACK, 1460,
			0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp, TH_SYN|TH_ACK, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}

	/*
		UDP
		NPI	->	RP :	From NPI 2
	*/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 2, 2, 0, mac_npi2, mac_gw_int,
			ip_npi2, ip_rp, 255, 0, 0,
			port_npi2, port_rp,
			0, 0,
			0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp,
							0, 0,
							0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}


	// delete server port mapping
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2) == SUCCESS);
	return SUCCESS;
}

/*
@func int32		| Napt-serverport-tcpudp-2	| napt serverport TCP/UDP hybrid testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT ServerPort function for TCP/UDP flow
Add TCP / UDP same port to different internal port, test for it correctness
test for port range server port.
 */
int32 pkt_napt_serverport_hybrid_2(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ServerPort test

		1 wan(pppoe), 1 lan

		TCP/UDP

		same external port range -- TCP ---> NPI1, port range 1
						 	   -- UDP ----> NPI2, port range 2

		RP	->	NPI
		NPI 	->	RP		
	***********************************************/
	/*
		Config Environments
	*/
	const uint16 port_range = 100;
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x1235;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x3456;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	int i;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);


	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 2) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		1. Test port mapping

			TCP	: To NPI 1
			UDP : To NPI 2
	*/
	ASSERT(rtl8651_addNaptServerPortRange(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi, port_range) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortRange(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2, port_range) == SUCCESS);

	/*
		TCP

		RP	->	NPI :	To NPI 1
	*/
	for (i=0;i<port_range;i++)
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 255, 0, 0, port_rp, port_gw+i, TH_SYN, 1460, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {1, 0xffff};	
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi+i, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}


	/*
		UDP

		RP	->	NPI :	To NPI 2
	*/
	for (i=0;i<port_range;i++)
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 255, 0, 0, port_rp, port_gw+i, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {2, 0xffff};	
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 2, 0, mac_gw_int, mac_npi2,
							ip_rp, ip_npi2, 254, 0, 0,
							port_rp, port_npi2+i, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}

	/*
		TCP
		NPI	->	RP :	From NPI 1
	*/
	for (i=0;i<port_range;i++)
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 255, 0, 0,
			port_npi+i, port_rp,
			TH_SYN|TH_ACK, 1460,
			0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw+i, port_rp, TH_SYN|TH_ACK, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}

	/*
		UDP
		NPI	->	RP :	From NPI 2
	*/
	for (i=0;i<port_range;i++)
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 2, 2, 0, mac_npi2, mac_gw_int,
			ip_npi2, ip_rp, 255, 0, 0,
			port_npi2+i, port_rp,
			0, 0,
			0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw+i, port_rp,
							0, 0,
							0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}


	// delete server port mapping
	ASSERT(rtl8651_delNaptServerPortRange(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi, port_range) == SUCCESS);
	ASSERT(rtl8651_delNaptServerPortRange(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2, port_range) == SUCCESS);
	return SUCCESS;
}



/*
	tcp
	dmzhost
	No ARP entry
*/
/*
@func int32		| Napt-dmzHost-tcp-1	| napt dmzHost TCP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT DMZ Host function for normal TCP flow
 */
int32 pkt_napt_dmzHost_tcp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DmzHost test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NPI, SYN
		NPI	->	RP	SYN,ACK
		RP	->	NPI	ACK
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

/*************

	TCP test

*************/
	/*
		RP	->	NPI :	Before add DMZ host : FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	//add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);


	/*
		RP	->	NPI :
					Output: 	ARP request
					Input: 	ARP reply
					Output:	DMZ translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_gw;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP :
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}
	/*
		RP	->	NPI :
					Output:	Napt translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* RP->NPI (through Napt) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_gw;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	return SUCCESS;
}

/*
	udp
	dmzhost
	Have ARP entry
*/
/*
@func int32		| Napt-dmzHost-udp-1	| napt dmzHost UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT DMZ Host function for normal UDP flow
 */
int32 pkt_napt_dmzHost_udp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DmzHost test

		1 wan(pppoe), 1 lan

		UDP
		RP	->	NPI
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
//	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
//	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
					Before adding dmz host, FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	// add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/*
		RP	->	NPI :
					Output:	Dmz Host translate packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_gw;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	return SUCCESS;
}

/*
	icmp
	dmzhost
	Have ARP entry
*/
/*
@func int32		| Napt-dmzHost-icmp-1	| napt dmzHost ICMP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT DMZ Host function for normal ICMP flow
 */
int32 pkt_napt_dmzHost_icmp_1(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DmzHost test

		1 wan(pppoe), 1 lan

		RP	->	GW	ECHO
		GW	->	RP	ECHO_REPLY
		== Add dmzhost, rrtl8651_fwdEngineDMZHostIcmpPassThrough(1) ==
		RP	->	GW	ECHO
		DMZ	->	RP	ECHO_REPLY
		RP	->	GW	TSTAMP
		DMZ	->	RP	TSTAMP_REPLY
		== rtl8651_fwdEngineDMZHostIcmpPassThrough(0) <<Reply icmp packet by gateway itself>> ==
		RP	->	GW	ECHO
		GW 	->	RP	ECHO_REPLY
		RP	->	GW	TSTAMP
		GW	->	RP	TSTAMP_REPLY
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	uint16 id_ext = 0x01;
	uint16 id_int = 0x02;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();
	/*
		RP	->	GW:
					Before adding dmz host, reply by fwdeng
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= IP_DEFAULT_TTL;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	// add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/*
		RP	->	GW: ECHO
					After adding dmz host, forward to dmz host
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_npi;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP:	ECHO REPLY
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	GW: TSTAMP
					After adding dmz host, forward to dmz host
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_TSTAMP;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_npi;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_TSTAMP;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP:	TSTAMP REPLY
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_TSTAMPREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_TSTAMPREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/***********
	Diable rtl8651_fwdEngineDMZHostIcmpPassThrough,
	forwarding engine need reply ICMP echo request and put ICMP tstamp
	request to protocol stack
	************/
	ASSERT(rtl8651_fwdEngineDMZHostIcmpPassThrough(0) == SUCCESS);
	/*
		RP	->	GW	(ECHO)	==>		GW	->	RP	(ECHO_REPLY)
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111, ip_rp, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0,
			ICMP_ECHO, 0xa, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA_Tagged(NULL, NULL,
				_PKT_TYPE_ICMP, tx_list, 1, 0,
				mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, IP_DEFAULT_TTL, 0, 0, 0, 0, 0, 0,
				ICMP_ECHOREPLY, 0xa, NULL, 0);
		}
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		RP	->	GW	(TSTAMP)	==>		Protocol Stack
	*/
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0, 0, 0, 0, 0,
			ICMP_TSTAMP, 0xa, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
		mbuf_out = genMbufPkt(&conf);		// fwdeng must forward original packet to protocol stack
		MBUF_CMPandFREE(mbuf_in, mbuf_out);
	}
	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	return SUCCESS;
}

/*
@func int32		| DMZ Host test - Unicast IGMP	| Test DMZ Host forwarding for Unicast IGMP packet
@rvalue SUCCESS	| 	test OK
@comm 
If user turn-on Unicast IGMP forwarding, IGMP packet will be forwarded regardless of IGMP proxy process.
Test the packet forwarding for unicast IGMP packet if we turn on it.
 */
int32 pkt_napt_dmzHost_UnicastIgmp_1(uint32 caseNo) {
	int8 pkt_content[1024];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	rtl8651_IgmpGrConf_t grCfgArr[10];
	ipaddr_t slistArr[10][10];

	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);

	// add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	// We forward ALL - non TCP/UDP/ICMP packet to DMZ
	ASSERT(rtl8651_fwdEngineFwdGeneralL4ToDMZ(TRUE) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	/*
		before turning on Unicast IGMP forwarding, IGMP packet will be processed by IGMP proxy
	*/
	{	// V3
		{	// group report
			slistArr[0][0] = ip_rp;
			grCfgArr[0].type = IGMP_MODE_ISIN;
			grCfgArr[0].gaddr = mcast_1;
			grCfgArr[0].auxlen = 0;
			grCfgArr[0].nofs = 1;
			grCfgArr[0].slist = slistArr[0];
			grCfgArr[0].auxdata = NULL;

			slistArr[1][0] = ip_rp;
			grCfgArr[1].type = IGMP_MODE_ISEX;
			grCfgArr[1].gaddr = mcast_2;
			grCfgArr[1].auxlen = 0;
			grCfgArr[1].nofs = 1;
			grCfgArr[1].slist = slistArr[1];
			grCfgArr[1].auxdata = NULL;
		}
		mbuf_in = confIgmpHSB(NULL,
				0, 1, TRUE, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 2, 0, 0,
				IGMPV3, IGMP_V3_REPORT, 0, 0,
				0, 0, 0, 0,
				2, grCfgArr, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	{	// V2
		mbuf_in = confIgmpHSB(NULL,
				0, 1, TRUE, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 2, 0, 0,
				IGMPV2, IGMP_V2_REPORT, 0, 0,
				0, 0, 0, 0,
				0, NULL, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	{	// V1
		mbuf_in = confIgmpHSB(NULL,
				0, 1, TRUE, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 2, 0, 0,
				IGMPV1, IGMP_V1_REPORT, 0, 0,
				0, 0, 0, 0,
				0, NULL, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	/*
		Turn ON Unicast IGMP forward
	*/
	ASSERT(rtl8651_fwdEngineFwdUnicastIGMPPkt(TRUE) == SUCCESS);
	/*
		Forward IGMP packet to DMZ
	*/
	{	// V3
		{	// group report
			slistArr[0][0] = ip_rp;
			grCfgArr[0].type = IGMP_MODE_ISIN;
			grCfgArr[0].gaddr = mcast_1;
			grCfgArr[0].auxlen = 0;
			grCfgArr[0].nofs = 1;
			grCfgArr[0].slist = slistArr[0];
			grCfgArr[0].auxdata = NULL;

			slistArr[1][0] = ip_rp;
			grCfgArr[1].type = IGMP_MODE_ISEX;
			grCfgArr[1].gaddr = mcast_2;
			grCfgArr[1].auxlen = 0;
			grCfgArr[1].nofs = 1;
			grCfgArr[1].slist = slistArr[1];
			grCfgArr[1].auxdata = NULL;
		}
		mbuf_in = confIgmpHSB(NULL,
				0, 1, TRUE, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 2, 0, 0,
				IGMPV3, IGMP_V3_REPORT, 0, 0,
				0, 0, 0, 0,
				2, grCfgArr, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confIgmpHSA(NULL,
				tx_port, 2, FALSE, 0, mac_gw_int, mac_npi, 0,
				ip_rp, ip_npi, 1, 0, 0,
				IGMPV3, IGMP_V3_REPORT, 0, 0,
				0, 0, 0, 0,
				2, grCfgArr, NULL, 0);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	{	// V2
		mbuf_in = confIgmpHSB(NULL,
				0, 1, TRUE, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 2, 0, 0,
				IGMPV2, IGMP_V2_REPORT, 0, 0,
				0, 0, 0, 0,
				0, NULL, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confIgmpHSA(NULL,
				tx_port, 2, FALSE, 0, mac_gw_int, mac_npi, 0,
				ip_rp, ip_npi, 1, 0, 0,
				IGMPV2, IGMP_V2_REPORT, 0, 0,
				0, 0, 0, 0,
				0, NULL, NULL, 0);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	{	// V1
		mbuf_in = confIgmpHSB(NULL,
				0, 1, TRUE, 0, mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 2, 0, 0,
				IGMPV1, IGMP_V1_REPORT, 0, 0,
				0, 0, 0, 0,
				0, NULL, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confIgmpHSA(NULL,
				tx_port, 2, FALSE, 0, mac_gw_int, mac_npi, 0,
				ip_rp, ip_npi, 1, 0, 0,
				IGMPV1, IGMP_V1_REPORT, 0, 0,
				0, 0, 0, 0,
				0, NULL, NULL, 0);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}
/*
@func int32		| DMZ Host test - Other Protocol	| Test DMZ Host forwarding for Other L4 protocol types
@rvalue SUCCESS	| 	test OK
@comm 
If user turn-on General L4 protocol packet forwarding, forwarding engine will forward all
general L4 packets (not TCP/UDP/ICMP) to DMZ Host
This case test that function
 */
int32 pkt_napt_dmzHost_GeneralPktForward_1(uint32 caseNo) {
	int8 pkt_content[1024];
	int32 retval;
	rtl8651_PktConf_t	conf;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	rtl8651_IgmpGrConf_t grCfgArr[10];
	ipaddr_t slistArr[10][10];
	ipaddr_t iplists[32]={0};

	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int i;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);

	// add dmz host
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/*
		Turn ON Unicast IGMP forward
	*/
	ASSERT(rtl8651_fwdEngineFwdUnicastIGMPPkt(TRUE) == SUCCESS);

	rtl8651_setAlgStatus(0xffffffff,iplists);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	/**************
		Inbound
	**************/

	/* before : trapped to CPU */
	for (i = 0 ; i < 255 ; i ++)
	{
		if ((i==IPPROTO_TCP) || (i==IPPROTO_UDP) || (i==IPPROTO_ICMP))
			continue;
		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag						|= L2_PPPoE;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_pppoe, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);
		conf.pppoe.type					= 0x8864;
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.ip.protocol					= i;
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);

		conf.conf_vlanIdx					= 1;
		conf.l2Flag 						|= L2_PPPoE;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 0);

		mbuf_in = genMbufPkt(&conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		if (i==IPPROTO_GRE)
		{
			VALUE_CMP(retval, FWDENG_GRE_IGNORE);
		}else if (i==IPPROTO_ESP)
		{
			VALUE_CMP(retval, FWDENG_ESP_IGNORE);
		}else if (i==IPPROTO_RSVP)
		{
			VALUE_CMP(retval, FWDENG_RSVP_IGNORE);
		}else
		{
			VALUE_CMP(retval, FWDENG_L4_UNKNOWNPROTO);
		}

		freeMbuf(mbuf_in);
	}


	// We forward ALL - non TCP/UDP/ICMP packet to DMZ
	ASSERT(rtl8651_fwdEngineFwdGeneralL4ToDMZ(TRUE) == SUCCESS);

	/* after : forward to DMZ */
	for (i = 0 ; i < 255 ; i ++)
	{
		if ((i==IPPROTO_TCP) || (i==IPPROTO_UDP) || (i==IPPROTO_ICMP))
			continue;
		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag						|= L2_PPPoE;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_pppoe, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);
		conf.pppoe.type					= 0x8864;
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.ip.protocol					= i;
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);

		conf.conf_vlanIdx					= 1;
		conf.l2Flag 						|= L2_PPPoE;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 0);

		mbuf_in = genMbufPkt(&conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP);
		CP_MAC (mac_gw_int, conf.conf_smac);
		CP_MAC (mac_npi, conf.conf_dmac);
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_npi;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 254;
		conf.ip.protocol					= i;
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);

		conf.conf_vlanIdx					= 2;
		conf.conf_pppoeIdx				= 0;
		ADD_TX_PORT(conf.conf_portlist, 1);

		mbuf_comp = genMbufPkt(&conf);

		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	// We stop forward ALL - non TCP/UDP/ICMP packet to DMZ
	ASSERT(rtl8651_fwdEngineFwdGeneralL4ToDMZ(FALSE) == SUCCESS);

	/**************
		Outbound
	**************/

	/* before : trapped to CPU */
	for (i = 0 ; i < 255 ; i ++)
	{
		if ((i==IPPROTO_TCP) || (i==IPPROTO_UDP) || (i==IPPROTO_ICMP))
			continue;

		if((i==IPPROTO_GRE) || (i==IPPROTO_ESP))	/* outbound GRE/ESP always pass */
			continue;
		
		/* NPI->RP */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.pppoe.type					= 0;
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.ip.protocol					= i;
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);

		conf.conf_vlanIdx					= 2;
		conf.l2Flag 						= 0;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		if (i==IPPROTO_RSVP)
		{
			/* RSVP is triggered by H.225 signaling yet, so it would be not processed and be ignored here. */
			VALUE_CMP(retval, FWDENG_RSVP_IGNORE);
		}else
		{
			VALUE_CMP(retval, FWDENG_L4_UNKNOWNPROTO);
		}

		freeMbuf(mbuf_in);
	}


	// We forward ALL - non TCP/UDP/ICMP packet to DMZ
	ASSERT(rtl8651_fwdEngineFwdGeneralL4ToDMZ(TRUE) == SUCCESS);

	/* after : forward to DMZ */
	for (i = 0 ; i < 255 ; i ++)
	{
		if ((i==IPPROTO_TCP) || (i==IPPROTO_UDP) || (i==IPPROTO_ICMP))
			continue;

		/* NPI->RP */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.pppoe.type					= 0;
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.ip.protocol					= i;
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);

		conf.conf_vlanIdx					= 2;
		conf.l2Flag 						= 0;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
		CP_MAC(mac_gw_ext, conf.conf_smac);
		CP_MAC(mac_pppoe, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 254;
		conf.ip.protocol					= i;
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= 1;
		conf.conf_pppoeIdx				= 0;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);

		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}


/*
	tcp
	ipnp
	No ARP entry
*/
/*
@func int32		| Napt-uPnP-tcp-1	| napt uPnP TCP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT uPnP function for normal TCP flow
 */
int32 pkt_napt_uPnP_tcp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		uPnP test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NPI, SYN
		NPI	->	RP	SYN,ACK
		RP	->	NPI	ACK
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
					Before adding Upnp, FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	// add Upnp mapping
	rtl8651_addUpnpMap(UPNP_ONESHOT|UPNP_TCP, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);

	/*
		RP	->	NPI :
					Output: 	ARP request
					Input: 	ARP reply
					Output:	NAPT translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through uPnP port change) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP :
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}
	/*
		RP	->	NPI :
					Output:	Napt translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* RP->NPI (through Napt) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}


/*
@func int32		| Napt-uPnP-tcp-2	| napt uPnP TCP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT uPnP function:
	First packet is from internal
 */
int32 pkt_napt_uPnP_tcp_2(uint32 caseNo)
{
	int8 pkt_content[1400];
	struct rtl_mBuf *mbuf_in, *mbuf_out, *mbuf_comp;
	int32 retval;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP

		NPI	->	RP	(SYN)	uPnP mapped
		RP	->	NPI	(SYN+ACK)

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x10;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.113.1.2"));
	uint16 port_rp2 = 0x6789;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_rp3 = ntohl(inet_addr("140.113.1.3"));
	uint16 port_rp3 = 0x7890;
	uint16 port_gw;
	uint16 port_gw_real;
	uint16 port_tmp;
	uint16 port_trigger;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn off DOS */
	rtl8651a_setDosStatus(0, 0);

	/* set long timeout */
	rtl8651_setNaptTcpLongTimeout(1000);

	/*************************************************************
		(1)	Add one_shot entry:
			upnp map matched: extIP/extPort would be translated
			as upnp setting an the upnp entry would be removed
			because it is ONE-Shot entry
	**************************************************************/

	// add Upnp mapping	-> age timer set to 10000 to prevent age timeout
	rtl8651_addUpnpMapLeaseTime(UPNP_ONESHOT|UPNP_TCP, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi, 10000);

	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	_rtl8651_timeUpdate(3000);

	// we would make sure the connection is removed
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		freeMbuf(mbuf_in);
	}

	// we would make sure the upnp entry is removed
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_real, NULL, NULL)==SUCCESS);

		/***************************************
			Real External port != upnp external port
		***************************************/
		VALUE_NEQ(port_gw_real, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw_real, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw_real, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*************************************************************
		(2) 	Add one_shot entry:
			upnp map matched: extIP/extPort would be translated
			as upnp setting an the upnp entry would not be removed
			because it is persistent entry
	**************************************************************/
	port_npi ++;
	// add Upnp mapping	-> age timer set to 100001 to prevent age timeout
	rtl8651_addUpnpMapLeaseTime(UPNP_PERSIST|UPNP_TCP, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi, 100001);

	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	_rtl8651_timeUpdate(3000);

	// we would make sure the connection is removed
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		freeMbuf(mbuf_in);
	}

	// we would make sure the upnp entry is still work
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

/*
	udp
	ipnp
	Have ARP entry
*/
/*
@func int32		| Napt-uPnP-udp-1	| napt uPnP UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT uPnP function for normal UDP flow
 */
int32 pkt_napt_uPnP_udp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		uPnP test

		1 wan(pppoe), 1 lan

		UDP
		RP	->	NPI
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
//	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
//	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
					Output:	return error first, re-add UpnpMap for UDP flow, then return SUCCESS
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);

	rtl8651_delUpnpMap(TRUE, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	rtl8651_addUpnpMap(UPNP_ONESHOT, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);

	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_npi;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func int32		| Napt-uPnP-udp-2	| napt uPnP UDP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT uPnP function:
	First packet is from internal
 */
int32 pkt_napt_uPnP_udp_2(uint32 caseNo)
{
	int8 pkt_content[1400];
	struct rtl_mBuf *mbuf_in, *mbuf_out, *mbuf_comp;
	int32 retval;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		UDP

		NPI	->	RP	(SYN)	uPnP mapped
		RP	->	NPI	(SYN+ACK)

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x10;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.113.1.2"));
	uint16 port_rp2 = 0x6789;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_rp3 = ntohl(inet_addr("140.113.1.3"));
	uint16 port_rp3 = 0x7890;
	uint16 port_gw;
	uint16 port_gw_real;
	uint16 port_tmp;
	uint16 port_trigger;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn off DOS */
	rtl8651a_setDosStatus(0, 0);

	/* set long timeout */
	rtl8651_setNaptUdpTimeout(1000);

	/*************************************************************
		(1)	Add one_shot entry:
			upnp map matched: extIP/extPort would be translated
			as upnp setting an the upnp entry would be removed
			because it is ONE-Shot entry
	**************************************************************/

	// add Upnp mapping	-> age timer set to 10000 to prevent age timeout
	rtl8651_addUpnpMapLeaseTime(UPNP_ONESHOT, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi, 10000);

	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	_rtl8651_timeUpdate(3000);

	// we would make sure the connection is removed
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		freeMbuf(mbuf_in);
	}

	// we would make sure the upnp entry is removed
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_real, NULL, NULL)==SUCCESS);

		/***************************************
			Real External port != upnp external port
		***************************************/
		VALUE_NEQ(port_gw_real, port_gw);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw_real, port_rp, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw_real, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*************************************************************
		(2) 	Add one_shot entry:
			upnp map matched: extIP/extPort would be translated
			as upnp setting an the upnp entry would not be removed
			because it is persistent entry
	**************************************************************/
	port_npi ++;
	// add Upnp mapping	-> age timer set to 100001 to prevent age timeout
	rtl8651_addUpnpMapLeaseTime(UPNP_PERSIST, ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi, 100001);

	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	_rtl8651_timeUpdate(3000);

	// we would make sure the upnp entry is still work
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}


/*
	tcp
	trigger port
	No ARP entry
*/
/*
@func int32		| Napt-TriggerPort-tcp-1	| napt TriggerPort TCP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT TriggerPort function for normal TCP flow
 */
int32 pkt_napt_triggerport_tcp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_trigger = 0xabcd;
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	ASSERT(rtl8651_addTriggerPortRule( 0, (port_gw-10), (port_gw+10), 0, (port_trigger-10), (port_trigger+10), 0) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :	Before triggering trigger-port : FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}
	/*
		triggering triggered-port
	*/
	/*
		NPI	->	RP :
		UDP Flow: Can not trigger !
	*/
{
	uint16 port_gw_udp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_trigger;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= port_gw_udp;
	conf.conf_dport					= port_trigger;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMPandFREE(mbuf_out, mbuf_comp);
}

	/*
		RP	->	NPI :	Don't trigger triggered-port yet : FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}
	
	/*
		NPI	->	RP :
		TCP Flow: CAN trigger !
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_trigger;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= port_trigger;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		RP	->	NPI :
					Output: 	ARP request
					Input: 	ARP reply
					Output:	trigger-port translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_gw;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP :
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		RP	->	NPI :
					Output:	Napt translated packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* RP->NPI (through Napt) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_gw;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}

/*
@func int32		| Napt-TriggerPort-tcp-2	| napt TriggerPort TCP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test for new API and age-timer, source IP check.
 */
int32 pkt_napt_triggerport_tcp_2(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};

	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x1234;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};

	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_triggered = 0xabcd;
	uint16 port_triggering = 0xdcba;
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	_rtl8651_triggerPort_param_t mappingInfo;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	mappingInfo.isStaticMapping = FALSE;
	mappingInfo.age = 100;
	mappingInfo.tp_outType = 0;
	mappingInfo.tp_outPortStart = port_triggering-10;
	mappingInfo.tp_outPortEnd = port_triggering+10;
	mappingInfo.tp_triggeringInsideLocalIpAddrStart = ip_npi;
	mappingInfo.tp_triggeringInsideLocalIpAddrEnd = ip_npi+100;
	ASSERT(rtl8651_addTriggerPortMappingRule(	0,				/* dsid == 0 */
												0,				/* TCP */
												port_triggered-10,
												port_triggered+10,
												&mappingInfo) == SUCCESS);

	fwdeng_function_configuration1();

	/* ================================================================================
										Trigger test
	    ================================================================================ */

	/*
		RP	->	NPI :

		Before triggering trigger-port : FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		NPI -> RP:

		UDP Flow: Can not trigger !
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/*
		RP	->	NPI :

		UDP flow don't trigger mapping, FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		NPI -> RP:

		Source Port check not match: don't trigger entry. 
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_npi2, mac_gw_int2,
						ip_npi2, ip_rp, 123, 0, 0,
						port_npi, port_triggering, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/*
		RP	->	NPI :

		TCP flow with different SIP don't trigger mapping, FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		NPI -> RP:

		ALL entry fileds are match: trigger rule. 
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/*
		RP	->	NPI :

		MAP is triggered: Flow can be passed.
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/* ================================================================================
											AGE test
	    ================================================================================ */

	/*
		Before timed out, mapping is still avaliable
	*/
	_rtl8651_timeUpdate(99);

	/*
		RP	->	NPI :

		MAP is triggered and not time out: Flow can be passed.
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+1, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered+1, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/*
		NPI -> RP:

		ALL entry fileds are match, we trigger SAME entry again: trigger cache refresh.
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering+1, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering+1, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}
	_rtl8651_timeUpdate(99);
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+2, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered+2, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		Time out mapping, it would not be avaliable.
	*/
	_rtl8651_timeUpdate(100);

	/*
		RP	->	NPI :

		mapping is timed out, FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+3, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	return SUCCESS;
}

/*
@func int32		| Napt-TriggerPort-tcp-3	| napt TriggerPort TCP testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test for non-timed-out entry
 */
int32 pkt_napt_triggerport_tcp_3(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};

	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x1234;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};

	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_triggered = 0xabcd;
	uint16 port_triggering = 0xdcba;
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	_rtl8651_triggerPort_param_t mappingInfo;
	int32 loop;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	mappingInfo.isStaticMapping = FALSE;
	mappingInfo.age = 0;
	mappingInfo.tp_outType = 0;
	mappingInfo.tp_outPortStart = port_triggering-10;
	mappingInfo.tp_outPortEnd = port_triggering+10;
	mappingInfo.tp_triggeringInsideLocalIpAddrStart = ip_npi;
	mappingInfo.tp_triggeringInsideLocalIpAddrEnd = ip_npi+100;
	ASSERT(rtl8651_addTriggerPortMappingRule(	0,				/* dsid == 0 */
												0,				/* TCP */
												port_triggered-10,
												port_triggered+10,
												&mappingInfo) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		NPI -> RP:

		ALL entry fileds are match: trigger rule. 
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/* ================================================================================
											AGE test
	    ================================================================================ */

	/*
		RP	->	NPI :

		MAP is triggered: Flow can be passed.
	*/
	for (loop = port_triggered-10 ; loop <= port_triggered-1 ; loop++)
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	_rtl8651_timeUpdate(100000);

	/*
		RP	->	NPI :

		MAP is still avaliable.
	*/
	for (loop = port_triggered ; loop <= port_triggered+10 ; loop++)
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	return SUCCESS;
}


/*
@func int32		| Napt-TriggerPort-tcp-4	| napt TriggerPort TCP testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Add STATIC entry
 */
int32 pkt_napt_triggerport_tcp_4(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};

	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x1234;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};

	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_triggered = 0xabcd;
	uint16 port_triggering = 0xdcba;
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	_rtl8651_triggerPort_param_t mappingInfo;
	int32 loop;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	mappingInfo.isStaticMapping = TRUE;
	mappingInfo.age = 0;
	mappingInfo.tp_mappedInsideLocalIpAddr = ip_npi;
	mappingInfo.tp_isStatic = FALSE;
	ASSERT(rtl8651_addTriggerPortMappingRule(	0,				/* dsid == 0 */
												0,				/* TCP */
												port_triggered-10,
												port_triggered+10,
												&mappingInfo) == SUCCESS);

	fwdeng_function_configuration1();

	/* ================================================================================
											AGE test
	    ================================================================================ */

	/*
		RP	->	NPI :

		MAP is avaliable
	*/
	for ( loop = port_triggered-10 ; loop <= port_triggered-1 ; loop ++ )
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	_rtl8651_timeUpdate(1000000);

	/*
		RP	->	NPI :

		MAP is still avaliable
	*/
	for ( loop = port_triggered ; loop <= port_triggered+10 ; loop ++ )
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	return SUCCESS;
}



/*
	udp
	trigger port
	No ARP entry
*/
/*
@func int32		| Napt-TriggerPort-udp-1	| napt TriggerPort UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAPT TriggerPort function for normal UDP flow
 */
int32 pkt_napt_triggerport_udp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		UDP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_trigger = 0xabcd;
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	// triggering type : udp
	// triggering port : (port_trigger-10)~(port_trigger+10)
	// triggering type : udp
	// triggering port : (port_gw-10)~(port_gw+10)
	ASSERT(rtl8651_addTriggerPortRule( 1, (port_gw-10), (port_gw+10), 1, (port_trigger-10), (port_trigger+10), 0) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
					Before triggering port, FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	/*
		triggering triggered-port
	*/

	/*
		NPI	->	RP :
		TCP Flow: CAN NOT trigger !
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_trigger;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= port_trigger;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
					don't triggering port yet, FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}
	/*
		NPI	->	RP :
		UDP Flow: CAN trigger !
	*/
{
	uint16 port_gw_udp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= port_trigger;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();

	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= port_gw_udp;
	conf.conf_dport					= port_trigger;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		RP	->	NPI :
					Trigger port OK, SUCCESS
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_gw;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}

/*
@func int32		| Napt-TriggerPort-udp-2	| napt TriggerPort UDP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test for new API and age-timer, source IP check.
 */
int32 pkt_napt_triggerport_udp_2(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		UDP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};

	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x1234;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};

	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_triggered = 0xabcd;
	uint16 port_triggering = 0xdcba;
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	_rtl8651_triggerPort_param_t mappingInfo;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	// triggering type : tcp
	// triggering port : (port_trigger-10)~(port_trigger+10)
	// triggering type : tcp
	// triggering port : (port_gw-10)~(port_gw+10)
	mappingInfo.isStaticMapping = FALSE;
	mappingInfo.age = 100;
	mappingInfo.tp_outType = 1;									/* UDP */
	mappingInfo.tp_outPortStart = port_triggering-10;
	mappingInfo.tp_outPortEnd = port_triggering+10;
	mappingInfo.tp_triggeringInsideLocalIpAddrStart = ip_npi;
	mappingInfo.tp_triggeringInsideLocalIpAddrEnd = ip_npi+100;
	ASSERT(rtl8651_addTriggerPortMappingRule(	0,				/* dsid == 0 */
												2,				/* BOTH */
												port_triggered-10,
												port_triggered+10,
												&mappingInfo) == SUCCESS);

	fwdeng_function_configuration1();

	/* ================================================================================
										Trigger test
	    ================================================================================ */

	/*
		RP	->	NPI :

		Before triggering trigger-port : FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		NPI -> RP:

		TCP Flow: Can not trigger !
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/*
		RP	->	NPI :

		TCP flow don't trigger mapping, FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		NPI -> RP:

		Source Port check not match: don't trigger entry. 
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 4, 3, 0,
						mac_npi2, mac_gw_int2,
						ip_npi2, ip_rp, 123, 0, 0,
						port_npi, port_triggering, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/*
		RP	->	NPI :

		UDP flow with different SIP don't trigger mapping, FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		NPI -> RP:

		ALL entry fileds are match: trigger rule. 
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/*
		RP	->	NPI :

		MAP is triggered: Flow can be passed.	-- trigger both of TCP and UDP

		TCP
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/*
		RP	->	NPI :

		MAP is triggered: Flow can be passed.	-- trigger both of TCP and UDP

		UDP
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/* ================================================================================
											AGE test
	    ================================================================================ */

	/*
		Before timed out, mapping is still avaliable
	*/
	_rtl8651_timeUpdate(99);

	/*
		RP	->	NPI :

		MAP is triggered and not time out: Flow can be passed.

		TCP
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+1, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered+1, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/*
		RP	->	NPI :

		MAP is triggered and not time out: Flow can be passed.

		UDP
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+1, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered+1, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/*
		NPI -> RP:

		ALL entry fileds are match, we trigger SAME entry again: trigger cache refresh.
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering+1, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering+1, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}
	_rtl8651_timeUpdate(99);
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+2, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered+2, (TH_SYN), 1452, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+2, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_triggered+2, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		Time out mapping, it would not be avaliable.
	*/
	_rtl8651_timeUpdate(100);

	/*
		RP	->	NPI :

		mapping is timed out, FAILED
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+3, (TH_SYN), 1460, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_triggered+3, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}


	return SUCCESS;
}

/*
@func int32		| Napt-TriggerPort-udp-3	| napt TriggerPort UDP testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test for non-timed-out entry
 */
int32 pkt_napt_triggerport_udp_3(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		UDP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};

	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x1234;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};

	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_triggered = 0xabcd;
	uint16 port_triggering = 0xdcba;
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	_rtl8651_triggerPort_param_t mappingInfo;
	int32 loop;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	mappingInfo.isStaticMapping = FALSE;
	mappingInfo.age = 0;
	mappingInfo.tp_outType = 1;
	mappingInfo.tp_outPortStart = port_triggering-10;
	mappingInfo.tp_outPortEnd = port_triggering+10;
	mappingInfo.tp_triggeringInsideLocalIpAddrStart = ip_npi;
	mappingInfo.tp_triggeringInsideLocalIpAddrEnd = ip_npi+100;
	ASSERT(rtl8651_addTriggerPortMappingRule(	0,				/* dsid == 0 */
												1,				/* UDP */
												port_triggered-10,
												port_triggered+10,
												&mappingInfo) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		NPI -> RP:

		ALL entry fileds are match: trigger rule. 
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_triggering, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0 , 0xffff};
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 122, 0, 0,
							port_gw, port_triggering, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbuf_out);
		}
	}

	/* ================================================================================
											AGE test
	    ================================================================================ */

	/*
		RP	->	NPI :

		MAP is triggered: Flow can be passed.
	*/
	for (loop = port_triggered-10 ; loop <= port_triggered-1 ; loop++)
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	_rtl8651_timeUpdate(100000);

	/*
		RP	->	NPI :

		MAP is still avaliable.
	*/
	for (loop = port_triggered ; loop <= port_triggered+10 ; loop++)
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	return SUCCESS;
}


/*
@func int32		| Napt-TriggerPort-udp-4	| napt TriggerPort UDP testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Add STATIC entry
 */
int32 pkt_napt_triggerport_udp_4(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		trigger port

		1 wan(pppoe), 1 lan

		UDP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};

	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi2 = 0x1234;
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};

	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_triggered = 0xabcd;
	uint16 port_triggering = 0xdcba;
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	_rtl8651_triggerPort_param_t mappingInfo;
	int32 loop;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	rtl8651_flushTriggerPortRules();							// flush trigger port rules
	// add trigger port entry:
	mappingInfo.isStaticMapping = TRUE;
	mappingInfo.age = 0;
	mappingInfo.tp_mappedInsideLocalIpAddr = ip_npi;
	mappingInfo.tp_isStatic = FALSE;
	ASSERT(rtl8651_addTriggerPortMappingRule(	0,				/* dsid == 0 */
												1,				/* UDP */
												port_triggered-10,
												port_triggered+10,
												&mappingInfo) == SUCCESS);

	fwdeng_function_configuration1();

	/* ================================================================================
											AGE test
	    ================================================================================ */

	/*
		RP	->	NPI :

		MAP is avaliable
	*/
	for ( loop = port_triggered-10 ; loop <= port_triggered-1 ; loop ++ )
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	_rtl8651_timeUpdate(1000000);

	/*
		RP	->	NPI :

		MAP is still avaliable
	*/
	for ( loop = port_triggered ; loop <= port_triggered+10 ; loop ++ )
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, loop, 0, 0, 0, 0, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1 , 0xffff};
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, loop, 0, 0, 0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	return SUCCESS;
}


/*
	tcp
	nat
	No ARP entry
*/
/*
@func int32		| Nat-tcp-1	| nat TCP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAT function for normal TCP flow
 */
int32 pkt_nat_tcp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAT test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NI, SYN
		NI	->	RP, SYN|ACK
		RP	->	NI, ACK
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.1.1"));
	uint16 port_ni = 0x1234;
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();
	START_TEST_CASE();

	/*
		RP	->	NI :
			Before NAT Mapping: FAILED
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	// Add mapping
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping

	/*
		RP	->	NI :
					Output: 	ARP request
					Input: 	ARP reply
					Output:	NAT-R translate packet
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_ni;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_ni;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NI	->	RP :
					Output:	NAT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_ni, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_ni;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_ni;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NI->RP (after NAT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_ni;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN|TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NI :
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_ni;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_ni;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1000;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	ASSERT(rtl8651_delNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	// delete mapping

	/*
		RP	->	NI :
			After delete NAT Mapping: FAILED
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	return SUCCESS;
}
/*
	tcp
	nat
	ARP entry set
*/
/*
@func int32		| Nat-tcp-2	| nat TCP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAT function for random TCP flow
 */
int32 pkt_nat_tcp_2(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAT test

		1 wan(pppoe), 1 lan

		TCP
		RP	->	NI, ACK
		NI	->	RP, ACK
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.1.1"));
	uint16 port_ni = 0x1234;
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};


	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();


	/*
		RP	->	NI :
			Before NAT Mapping: FAILED
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}

	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping

	/*
		RP	->	NI :
					Output:	NAT-R translate packet
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_ni;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_ni;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1000;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NI	->	RP :
					Output:	NAT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_ni, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_ni;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_ni;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* NI->RP (after NAT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_ni;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NI :
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1000;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_ni;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_ni;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1000;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	ASSERT(rtl8651_delNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	// delete mapping

	/*
		RP	->	NI :
			After delete NAT Mapping: FAILED
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}
	return SUCCESS;
}
/*
@func int32		| Nat-udp-1	| nat UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAT function for UDP flow
 */
int32 pkt_nat_udp_1(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAT test

		1 wan(pppoe), 1 lan

		UDP
		RP	->	NI
		NI	->	RP		
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.1.1"));
	uint16 port_ni = 0x1234;
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
//	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
//	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};


	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan", 1) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		RP	->	NI :
			Before NAP mapping : FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping

	/*
		RP	->	NI :
					Output:	NAT-R translate packet
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NI (after NATR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_ni;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= port_ni;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NI	->	RP :
					Output:	NAT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_ni, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_ni;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_ni;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check output packet */
	/* NI->RP (after NAT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= port_ni;
	conf.conf_dport					= port_rp;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 10;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	ASSERT(rtl8651_delNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//delete nat mapping

	/*
		RP	->	NI :
			After delete NAP mapping : FAILED
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_ni;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	freeMbuf(mbuf_in);
}
	return SUCCESS;

}
/*
@func int32		| Nat-icmp-1	| nat ICMP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAT function for ICMP flow
 */
int32 pkt_nat_icmp_1(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAT test

		1 wan(pppoe), 1 lan

		ICMP
		RP	->	NI	ECHO
		NI	->	RP	ECHOREPLY
		NI	->	RP	ECHO
		RP	->	NI	ECHOREPLY
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 id = 0xabcd;
//	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
//	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping

	/*
		RP	->	NI : ECHO
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet*/
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_ni;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx					= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NI	->	RP : ECHOREPLY
	*/
{
	/* config */
	/* NI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_ni, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_ni;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet*/
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 232;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx					= 1;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NI	->	RP : ECHO
	*/
{
	/* config */
	/* NI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_ni, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_ni;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet*/
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 232;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx					= 1;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		RP	->	NI : ECHOREPLY
	*/
{
	/* config */
	/* RP->NI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet*/
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_ni, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_ni;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 233;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx					= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	ASSERT(rtl8651_delNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//delete nat mapping
	return SUCCESS;

}
/*
@func int32		| Nat-icmp-2	| nat ICMP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the NAT function for ICMP error message
 */
int32 pkt_nat_icmp_2(uint32 caseNo){
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf, conf_err_int, conf_err_ext;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAT test

		1 wan(pppoe), 1 lan

		ICMP

		for TCP/UDP/ICMP error packet
		{
			Error packet :
				sip: RP dip: NI
			NI	->	RP, ICMP_UNREACH
			NI	->	RP, ICMP_SOURCEQUENCH
			NI	->	RP, ICMP_TIMXCEED
			NI	->	RP, ICMP_PARAMPROB

			Error packet :
				sip: NI dip: RP
			RP	->	NI, ICMP_UNREACH
			RP	->	NI, ICMP_SOURCEQUENCH
			RP	->	NI, ICMP_TIMXCEED
			RP	->	NI, ICMP_PARAMPROB
		}
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.1.1"));
	uint16 port_ni = 0x1234;
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 id = 0xabcd;
	uint16 id_err = 0x7654;

	int32 ERR_PKT_TYPE[3] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP, _PKT_TYPE_ICMP};
	int32 ERR_ICMP_TYPE[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 pkt_type, icmp_type;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping

	/*
		Error Pkt:	NI -> RP
		ICMP:		RP -> NI
	*/
for (pkt_type = 0 ; pkt_type < 3 ; pkt_type++)
{
	// ERROR PKT: Before NAT
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType					= ERR_PKT_TYPE[pkt_type];
	conf_err_int.l2Flag						= 0;
	conf_err_int.ErrFlag					= 0;
	conf_err_int.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_ni, conf_err_int.conf_smac);
	CP_MAC (mac_gw_int, conf_err_int.conf_dmac);
	conf_err_int.conf_sip					= ip_ni;
	conf_err_int.conf_dip					= ip_rp;
	conf_err_int.ip.id						= 0xa;
	conf_err_int.ip.mf						= 0;
	conf_err_int.ip.offset					= 0;
	conf_err_int.ip.ttl						= 255;
	conf_err_int.conf_sport					= port_ni;
	conf_err_int.conf_dport					= port_rp;
	conf_err_int.conf_tcp_seq				= 0xb;
	conf_err_int.conf_tcp_ack				= 0xc;
	conf_err_int.conf_tcp_flag				= (TH_ACK);
	conf_err_int.conf_tcp_win				= 0xfffe;
	conf_err_int.icmp.type					= ICMP_ECHO;
	conf_err_int.icmp.code					= 0;
	conf_err_int.icmp.id					= id_err;
	conf_err_int.icmp.seq					= 1;
	conf_err_int.payload.content				= pkt_content;
	conf_err_int.payload.length				= sizeof(pkt_content);
	conf_err_int.conf_vlanIdx				= 2;
	SET_RX_PORT(conf_err_int.conf_portlist, 1);
	// ERROR PKT: After NAT
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType					= ERR_PKT_TYPE[pkt_type];
	conf_err_ext.l2Flag						= 0;
	conf_err_ext.ErrFlag					= 0;
	conf_err_ext.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf_err_ext.conf_smac);
	CP_MAC(mac_pppoe, conf_err_ext.conf_dmac);
	conf_err_ext.conf_sip					= ip_gw_ext;
	conf_err_ext.conf_dip					= ip_rp;
	conf_err_ext.ip.id						= 0xa;
	conf_err_ext.ip.mf						= 0;
	conf_err_ext.ip.offset					= 0;
	conf_err_ext.ip.ttl						= 255;		// for comparison, I don't decrease ttl
	conf_err_ext.conf_sport					= port_ni;
	conf_err_ext.conf_dport					= port_rp;
	conf_err_ext.conf_tcp_seq				= 0xb;
	conf_err_ext.conf_tcp_ack				= 0xc;
	conf_err_ext.conf_tcp_flag				= (TH_ACK);
	conf_err_ext.conf_tcp_win				= 0xfffe;
	conf_err_ext.icmp.type					= ICMP_ECHO;
	conf_err_ext.icmp.code					= 0;
	conf_err_ext.icmp.id					= id_err;
	conf_err_ext.icmp.seq					= 1;
	conf_err_ext.payload.content			= pkt_content;
	conf_err_ext.payload.length				= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx				= 1;
	ADD_TX_PORT(conf_err_ext.conf_portlist, 0);

	// ICMP error message : RP->NI
	for (icmp_type = 0 ; icmp_type < 4 ; icmp_type++)
	{
		RESET_CONF(&conf);
		conf.pktType					= _PKT_TYPE_ICMP;
		conf.l2Flag					|= L2_PPPoE;
		conf.ErrFlag					= 0;
		conf.conf_Flags				|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_pppoe, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);
		conf.pppoe.type				= 0x8864;
		conf.conf_sip					= ip_rp;
		conf.conf_dip					= ip_gw_ext;
		conf.ip.id						= 0xa;
		conf.ip.mf					= 0;
		conf.ip.offset					= 0;
		conf.ip.ttl						= 234;
		conf.icmp.type				= ERR_ICMP_TYPE[icmp_type];
		conf.icmp.code				= 0;
		conf.icmp.id					= id;
		conf.icmp.seq					= 1;
		conf.payload.content			= NULL;
		conf.payload.length			= 0;

		conf.conf_vlanIdx				= 1;
		conf.conf_pppoeIdx			= 0;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genIcmpErrMbufPkt(&conf_err_ext, &conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check output packet*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ICMP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int, conf.conf_smac);
		CP_MAC (mac_ni, conf.conf_dmac);
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_ni;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 233;
		conf.icmp.type					= ERR_ICMP_TYPE[icmp_type];
		conf.icmp.code					= 0;
		conf.icmp.id						= id;
		conf.icmp.seq						= 1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		ADD_TX_PORT(conf.conf_portlist, 1);
		conf.conf_vlanIdx					= 2;

		mbuf_comp = genIcmpErrMbufPkt(&conf_err_int, &conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMP(mbuf_out, mbuf_comp);

		freeMbuf(mbuf_out);
		freeMbuf(mbuf_comp);
	}
}

	/*
		Error Pkt:	RP -> NI
		ICMP:		NI -> RP
	*/
for (pkt_type = 0 ; pkt_type < 3 ; pkt_type++)
{
	// ERROR PKT: Before NATR
	RESET_CONF(&conf_err_ext);
	conf_err_ext.pktType					= ERR_PKT_TYPE[pkt_type];
	conf_err_ext.l2Flag						|= L2_PPPoE;
	conf_err_ext.ErrFlag					= 0;
	conf_err_ext.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_pppoe, conf_err_ext.conf_smac);
	CP_MAC (mac_gw_ext, conf_err_ext.conf_dmac);
	conf_err_ext.pppoe.type				= 0x8864;
	conf_err_ext.conf_sip					= ip_rp;
	conf_err_ext.conf_dip					= ip_gw_ext;
	conf_err_ext.ip.id						= 0xa;
	conf_err_ext.ip.mf						= 0;
	conf_err_ext.ip.offset					= 0;
	conf_err_ext.ip.ttl						= 255;
	conf_err_ext.conf_sport					= port_rp;
	conf_err_ext.conf_dport					= port_ni;
	conf_err_ext.conf_tcp_seq				= 0xb;
	conf_err_ext.conf_tcp_ack				= 0xc;
	conf_err_ext.conf_tcp_flag				= (TH_ACK);
	conf_err_ext.conf_tcp_win				= 0xfffe;
	conf_err_ext.icmp.type					= ICMP_ECHO;
	conf_err_ext.icmp.code					= 0;
	conf_err_ext.icmp.id					= id_err;
	conf_err_ext.icmp.seq					= 1;
	conf_err_ext.payload.content			= pkt_content;
	conf_err_ext.payload.length				= sizeof(pkt_content);
	conf_err_ext.conf_vlanIdx				= 1;
	SET_RX_PORT(conf_err_int.conf_portlist, 0);
	// ERROR PKT: After NATR
	RESET_CONF(&conf_err_int);
	conf_err_int.pktType					= ERR_PKT_TYPE[pkt_type];
	conf_err_int.l2Flag						= 0;
	conf_err_int.ErrFlag					= 0;
	conf_err_int.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_int, conf_err_int.conf_smac);
	CP_MAC(mac_ni, conf_err_int.conf_dmac);
	conf_err_int.conf_sip					= ip_rp;
	conf_err_int.conf_dip					= ip_ni;
	conf_err_int.ip.id						= 0xa;
	conf_err_int.ip.mf						= 0;
	conf_err_int.ip.offset					= 0;
	conf_err_int.ip.ttl						= 255;		// for comparison, I don't decrease ttl
	conf_err_int.conf_sport					= port_rp;
	conf_err_int.conf_dport					= port_ni;
	conf_err_int.conf_tcp_seq				= 0xb;
	conf_err_int.conf_tcp_ack				= 0xc;
	conf_err_int.conf_tcp_flag				= (TH_ACK);
	conf_err_int.conf_tcp_win				= 0xfffe;
	conf_err_int.icmp.type					= ICMP_ECHO;
	conf_err_int.icmp.code					= 0;
	conf_err_int.icmp.id					= id_err;
	conf_err_int.icmp.seq					= 1;
	conf_err_int.payload.content				= pkt_content;
	conf_err_int.payload.length				= sizeof(pkt_content);
	conf_err_int.conf_vlanIdx				= 2;
	ADD_TX_PORT(conf_err_int.conf_portlist, 1);

	// ICMP error message : NI->RP
	for (icmp_type = 0 ; icmp_type < 4 ; icmp_type++)
	{
		RESET_CONF(&conf);
		conf.pktType					= _PKT_TYPE_ICMP;
		conf.l2Flag					= 0;
		conf.ErrFlag					= 0;
		conf.conf_Flags				|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_ni, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.conf_sip					= ip_ni;
		conf.conf_dip					= ip_rp;
		conf.ip.id						= 0xa;
		conf.ip.mf					= 0;
		conf.ip.offset					= 0;
		conf.ip.ttl						= 234;
		conf.icmp.type				= ERR_ICMP_TYPE[icmp_type];
		conf.icmp.code				= 0;
		conf.icmp.id					= id;
		conf.icmp.seq					= 1;
		conf.payload.content			= NULL;
		conf.payload.length			= 0;

		conf.conf_vlanIdx				= 2;
		SET_RX_PORT(conf.conf_portlist, 1);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genIcmpErrMbufPkt(&conf_err_int, &conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check output packet*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ICMP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		CP_MAC (mac_pppoe, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 233;
		conf.icmp.type					= ERR_ICMP_TYPE[icmp_type];
		conf.icmp.code					= 0;
		conf.icmp.id						= id;
		conf.icmp.seq						= 1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		conf.conf_vlanIdx					= 1;

		mbuf_comp = genIcmpErrMbufPkt(&conf_err_ext, &conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMP(mbuf_out, mbuf_comp);

		freeMbuf(mbuf_out);
		freeMbuf(mbuf_comp);
	}
}
	ASSERT(rtl8651_delNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//delete nat mapping
	return SUCCESS;

}
/*
@func int32		| portBouncing_tcp_1	| portBouncing TCP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host set up TCP flow to ServerPort External IP/Port
 */
int32 pkt_portBouncing_tcp_1(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

{
	// Add UDP Server port
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort, SYN
			Server port error : FAILED
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FAILED);	// can not found entry
		freeMbuf(mbuf_in);
	}

	// Remove UDP Server port / Add TCP Server port
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort, SYN
			Server port OK : Port bouncing!
	*/
	{
		mbuf_in = genMbufPkt(&conf);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_SYN, 1460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		ServerPort  -> NPI, SYN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_gw, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/*
		NPI	->	ServerPort, ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

	}

	/*
		NPI	->	ServerPort, Data
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		ServerPort  -> NPI, DATA
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_gw, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		NPI	->	ServerPort, FIN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		ServerPort  -> NPI, FIN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_gw, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		NPI	->	ServerPort, ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
}
	// Turn-off port bouncing, all packet are trapped
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	ASSERT(rtl8651_fwdEngineProcessPortBouncing(FALSE) == SUCCESS);
{
	// Add UDP Server port
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort, SYN
			Server port error : FWDENG_DECISION_BLOCK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);	// can not found entry
		freeMbuf(mbuf_in);
	}

	// Remove UDP Server port / Add TCP Server port
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort, SYN
			trap
	*/
	{
		mbuf_in = genMbufPkt(&conf);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*
		ServerPort  -> NPI, SYN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	/*
		NPI	->	ServerPort, ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	/*
		NPI	->	ServerPort, Data
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*
		ServerPort  -> NPI, DATA
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*
		NPI	->	ServerPort, FIN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*
		ServerPort  -> NPI, FIN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*
		NPI	->	ServerPort, ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);	// trap
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
}

	// Turn-on port bouncing again
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	ASSERT(rtl8651_fwdEngineProcessPortBouncing(TRUE) == SUCCESS);
{
	// Add UDP Server port
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort, SYN
			Server port error : FAILED
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FAILED);	// can not found entry
		freeMbuf(mbuf_in);
	}

	// Remove UDP Server port / Add TCP Server port
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort, SYN
			Server port OK : Port bouncing!
	*/
	{
		mbuf_in = genMbufPkt(&conf);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_SYN, 1460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		ServerPort  -> NPI, SYN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_gw, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/*
		NPI	->	ServerPort, ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

	}

	/*
		NPI	->	ServerPort, Data
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		ServerPort  -> NPI, DATA
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_gw, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		NPI	->	ServerPort, FIN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		ServerPort  -> NPI, FIN|ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_serv, mac_gw_int2,
			ip_serv, ip_gw_ext, 123, 0, 0,
			port_serv, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_gw, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		NPI	->	ServerPort, ACK
	*/
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};

			mbuf_comp = confVlanHSA(&conf, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
}
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	return SUCCESS;
}

/*
	For Ip-unnumber -> DmzHost
	tcp packet
*/
/*
@func int32		| portBouncing_tcp_2	| portBouncing TCP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Ip-Unnumber Host set up TCP flow to NAPT External IP and gateway forwards it to dmz host
 */
int32 pkt_portBouncing_tcp_2(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_unnum = ntohl(inet_addr("10.113.1.2"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 port_unnum = 0x1234;
	uint16 port_dmz = 0x2345;
	ether_addr_t mac_unnum = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_3();
	ASSERT(rtl8651_addArp(ip_unnum, &mac_unnum, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 2) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		UNNUM	->	GW
			before DMZ host, trap it to protocol stack
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FAILED);					// Routing to gateway, return FAILED
		freeMbuf(mbuf_in);
	}

	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);
	/*
		UNNUM	->	GW
			after DMZ host, port bouncing is triggered
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, TH_SYN, 1460, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_unnum,(TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				port_dmz, port_unnum, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		UNNUM	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_unnum,TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				port_dmz, port_unnum, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		UNNUM	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_unnum,(TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				port_dmz, port_unnum, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		UNNUM	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}

/*
	For NPI -> DMZ Host
	tcp packet
*/
/*
@func int32		| portBouncing_tcp_3	| portBouncing TCP testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host set up TCP flow to NAPT External IP and gateway forwards it to dmz host
 */
int32 pkt_portBouncing_tcp_3(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_dmz = 0x2345;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);

	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, TH_SYN, 1460, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_npi,(TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_dmz, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_npi,TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_dmz, port_npi, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_npi,(TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_dmz, port_npi, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}


/*
	For NPI -> NAT
	tcp packet
*/
/*
@func int32		| portBouncing_tcp_4	| portBouncing TCP testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host set up TCP flow to NAT External IP and gateway forwards it to NAT Internal Host
 */
int32 pkt_portBouncing_tcp_4(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_ni = 0x2345;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan2", 4) == SUCCESS);

	// Add nat mapping here
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, TH_SYN, 1460, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			port_ni, port_npi,(TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_ni, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			port_ni, port_npi,TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_ni, port_npi, TH_ACK, 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			port_ni, port_npi,(TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_ni, port_npi, (TH_FIN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}

/*
@func int32		| portBouncing_tcp_5	| portBouncing TCP testing 5
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host set up TCP flow to uPnP External IP/Port
 */
int32 pkt_portBouncing_tcp_5(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	uint16 port_rp = 0x3456;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	// turn off dos
	rtl8651a_setDosStatus(0, FALSE);

	/* turn off uPnP Port Bouncing */
	ASSERT(rtl8651_fwdEngineProcessUpnpPortBouncing(FALSE) == SUCCESS);

	/* upnp is trapped */
	{
		/* add upnp entry */
		rtl8651_addUpnpMap(UPNP_ONESHOT|UPNP_TCP, 0, 0, ip_gw_ext, port_gw, ip_serv, port_serv);

		/*
			NPI	->	external Ip, SYN
				error : FAILED
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, FAILED);	// can not found entry
			freeMbuf(mbuf_in);
		}

		/* remove upnp entry */
		rtl8651_delUpnpMap(TRUE, 0, 0, ip_gw_ext, port_gw, ip_serv, port_serv);
	}

	/* turn on uPnP Port Bouncing */
	ASSERT(rtl8651_fwdEngineProcessUpnpPortBouncing(TRUE) == SUCCESS);

	{
		/* Add uPnP - remote IP/Port is assigned */
		rtl8651_addUpnpMap(UPNP_ONESHOT|UPNP_TCP, ip_rp, port_rp, ip_gw_ext, port_gw, ip_serv, port_serv);

		/*
			NPI	->	external Ip, SYN
				error : FAILED
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, FAILED);	// can not found entry
			freeMbuf(mbuf_in);
		}

		// Remove uPnP / Add this uPnP again without External IP/Port Setting
		rtl8651_delUpnpMap(TRUE, ip_rp, port_rp, ip_gw_ext, port_gw, ip_serv, port_serv);
		rtl8651_addUpnpMap(UPNP_ONESHOT|UPNP_TCP, 0, 0, ip_gw_ext, port_gw, ip_serv, port_serv);

		/*
			NPI	->	external Ip, SYN
				Server port OK : Port bouncing!
		*/
		{
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					port_npi, port_serv, TH_SYN, 1460, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			external Ip  -> NPI, SYN|ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 122, 0, 0,
					port_gw, port_npi, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}

		/*
			NPI	->	external Ip, ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					port_npi, port_serv, TH_ACK, 0, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

		}

		/*
			NPI	->	external Ip, Data
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					port_npi, port_serv, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			external Ip  -> NPI, DATA
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 122, 0, 0,
					port_gw, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			NPI	->	external Ip, FIN|ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					port_npi, port_serv, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			external Ip  -> NPI, FIN|ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 122, 0, 0,
					port_gw, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			NPI	->	external Ip, ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_ACK, 0, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					port_npi, port_serv, TH_ACK, 0, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	return SUCCESS;
}


/*
@func int32		| portBouncing_tcp_6	| portBouncing TCP testing 6
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host set up TCP flow to ServerPort External IP/Port
-- Heavy load Test --
 */
int32 pkt_portBouncing_tcp_6(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	#define TESTLOOP 50
	int testLoop;
	int32 sportList[PORT_BOUNCING_ITEM];
	int idx;
	#define MAXDATACNT	10
	#define DATALOOP (PORT_BOUNCING_ITEM * 10)
	

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		set random seed
	*/
	srandom(time(NULL));

	/*
		enable TCP Server Port mapping for port bouncing
	*/
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/* turn off dos checking */
	rtl8651a_setDosStatus(0, 0);

	/*
		Initial variables for testing
	*/
	{
		for (idx = 0 ; idx < PORT_BOUNCING_ITEM ; idx ++)
			sportList[idx] = -1;	/* initial value */
	}

	for (testLoop = 0 ; testLoop < TESTLOOP ; testLoop ++)
	{
		/*****************************************************
			First phase:
				random generate new flows
		******************************************************/
		for (idx = 0 ; idx < PORT_BOUNCING_ITEM ; idx ++)
		{
			int i;
			/* flow exist */
			if (sportList[idx] >= 0)
				continue;

			/*
				1. decide if this empty entry need to create new flow or not

					9/10 -> add new flow
					1/10 -> don't add new flow
			*/
			if (((random() % 100) + 1) < 10)
				continue;

			/*
				2. randomly decide this new flow's source port, but the source port can NOT same as exist flows
			*/
		decide_sport:
			sportList[idx] = (random() % 65535) + 1;
			for (i = 0 ; i < PORT_BOUNCING_ITEM ; i ++)
			{
				if ((idx != i) && (sportList[idx] == sportList[i]))
					goto decide_sport;
			}

			/*
				3. actually send packet to generate this new flow
			*/
			/********************************************************************************/
			/*
				NPI	->	ServerPort, SYN
			*/
			{
				mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 123, 0, 0,
					sportList[idx], port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
				{
					uint16 tx_port[2] = {4, 0xffff};

					mbuf_comp = confVlanHSA(&conf, NULL,
						_PKT_TYPE_TCP, tx_port, 3, 0,
						mac_gw_int2, mac_serv,
						ip_gw_ext, ip_serv, 122, 0, 0,
						sportList[idx], port_serv, TH_SYN, 1460, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
			/*
				ServerPort  -> NPI, SYN|ACK
			*/
			{
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 4, 3, 0,
					mac_serv, mac_gw_int2,
					ip_serv, ip_gw_ext, 123, 0, 0,
					port_serv, sportList[idx], (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
				{
					uint16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA(&conf, NULL,
						_PKT_TYPE_TCP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						ip_gw_ext, ip_npi, 122, 0, 0,
						port_gw, sportList[idx], (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
			/*
				NPI	->	ServerPort, ACK
			*/
			{
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 123, 0, 0,
					sportList[idx], port_gw, TH_ACK, 0, 0, 0, NULL, 0);

				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
				{
					uint16 tx_port[2] = {4, 0xffff};

					mbuf_comp = confVlanHSA(&conf, NULL,
						_PKT_TYPE_TCP, tx_port, 3, 0,
						mac_gw_int2, mac_serv,
						ip_gw_ext, ip_serv, 122, 0, 0,
						sportList[idx], port_serv, TH_ACK, 0, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
			/********************************************************************************/
		}

		/*****************************************************
			Second phase:
				random send data for each flow
		******************************************************/
		{
			int i, j;
			for (i = 0 ; i < DATALOOP ; i ++)
			{
				/*
					1. randomly decide flow to send data
				*/
			decide_flow:
				idx = (random() % PORT_BOUNCING_ITEM);
				if (sportList[idx] < 0)
					goto decide_flow;

				/*
					2. randomly decide how many data need to be sent for the selected flow
				*/
				j = random() % MAXDATACNT;

				/*
					3. send data
				*/
				while (j)
				{
					j --;

					if (random() % 2)
					{	/* client to server */
						mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_TCP, 1, 2, 0,
							mac_npi, mac_gw_int,
							ip_npi, ip_gw_ext, 123, 0, 0,
							sportList[idx], port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

						/* packet input */
						FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

						VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

						/* check output packet */
						VALUE_CMP(mbufList_nmbuf(), 1);
						{
							uint16 tx_port[2] = {4, 0xffff};

							mbuf_comp = confVlanHSA(&conf, NULL,
								_PKT_TYPE_TCP, tx_port, 3, 0,
								mac_gw_int2, mac_serv,
								ip_gw_ext, ip_serv, 122, 0, 0,
								sportList[idx], port_serv, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
						}
						MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
					}else
					{	/* server to client */
						mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_TCP, 4, 3, 0,
							mac_serv, mac_gw_int2,
							ip_serv, ip_gw_ext, 123, 0, 0,
							port_serv, sportList[idx], TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

						/* packet input */
						FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
						VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

						/* check output packet */
						VALUE_CMP(mbufList_nmbuf(), 1);
						{
							uint16 tx_port[2] = {1, 0xffff};

							mbuf_comp = confVlanHSA(&conf, NULL,
								_PKT_TYPE_TCP, tx_port, 2, 0,
								mac_gw_int, mac_npi,
								ip_gw_ext, ip_npi, 122, 0, 0,
								port_gw, sportList[idx], TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
						}
						MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
					}
				}
			}
		}
		/*****************************************************
			Third phase:
				random close flow
		******************************************************/
		for (idx = 0 ; idx < PORT_BOUNCING_ITEM ; idx ++)
		{
			/* empty entry */
			if (sportList[idx] < 0)
				continue;

			/*
				1. decide if this flow need to be deleted or not

					1/2 -> delete this flow
					1/2 -> keep this flow
			*/
			if (random() % 2)
				continue;

			/*
				2. terminate this flow
			*/
			if (random() % 2)
			{	/* client terminate */
				/*
					NPI	->	ServerPort, FIN|ACK
				*/
				{
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_gw_ext, 123, 0, 0,
						sportList[idx], port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

					/* packet input */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

					/* check output packet */
					VALUE_CMP(mbufList_nmbuf(), 1);
					{
						uint16 tx_port[2] = {4, 0xffff};

						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 3, 0,
							mac_gw_int2, mac_serv,
							ip_gw_ext, ip_serv, 122, 0, 0,
							sportList[idx], port_serv, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
					}
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
				/*
					ServerPort  -> NPI, FIN|ACK
				*/
				{
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_serv, mac_gw_int2,
						ip_serv, ip_gw_ext, 123, 0, 0,
						port_serv, sportList[idx], (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

					/* packet input */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

					/* check output packet */
					VALUE_CMP(mbufList_nmbuf(), 1);
					{
						uint16 tx_port[2] = {1, 0xffff};

						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_gw_ext, ip_npi, 122, 0, 0,
							port_gw, sportList[idx], (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
					}
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
				/*
					NPI	->	ServerPort, ACK
				*/
				{
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_gw_ext, 123, 0, 0,
						sportList[idx], port_gw, TH_ACK, 0, 0, 0, NULL, 0);

					/* packet input */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

					/* check output packet */
					VALUE_CMP(mbufList_nmbuf(), 1);
					{
						uint16 tx_port[2] = {4, 0xffff};

						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 3, 0,
							mac_gw_int2, mac_serv,
							ip_gw_ext, ip_serv, 122, 0, 0,
							sportList[idx], port_serv, TH_ACK, 0, 0, 0, NULL, 0);
					}
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
			}else
			{	/* server terminate */
				/*
					ServerPort  -> NPI, FIN|ACK
				*/
				{
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_serv, mac_gw_int2,
						ip_serv, ip_gw_ext, 123, 0, 0,
						port_serv, sportList[idx], (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

					/* packet input */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

					/* check output packet */
					VALUE_CMP(mbufList_nmbuf(), 1);
					{
						uint16 tx_port[2] = {1, 0xffff};

						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_gw_ext, ip_npi, 122, 0, 0,
							port_gw, sportList[idx], (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
					}
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
				/*
					NPI	->	ServerPort, FIN|ACK
				*/
				{
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_gw_ext, 123, 0, 0,
						sportList[idx], port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

					/* packet input */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

					/* check output packet */
					VALUE_CMP(mbufList_nmbuf(), 1);
					{
						uint16 tx_port[2] = {4, 0xffff};

						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 3, 0,
							mac_gw_int2, mac_serv,
							ip_gw_ext, ip_serv, 122, 0, 0,
							sportList[idx], port_serv, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
					}
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
				/*
					ServerPort  -> NPI, ACK
				*/
				{
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_serv, mac_gw_int2,
						ip_serv, ip_gw_ext, 123, 0, 0,
						port_serv, sportList[idx], TH_ACK, 0, 0, 0, NULL, 0);

					/* packet input */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

					/* check output packet */
					VALUE_CMP(mbufList_nmbuf(), 1);
					{
						uint16 tx_port[2] = {1, 0xffff};

						mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_gw_ext, ip_npi, 122, 0, 0,
							port_gw, sportList[idx], TH_ACK, 0, 0, 0, NULL, 0);
					}
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
			}
			/*
				3. delete this entry
			*/
			sportList[idx] = -1;
		}
	}

	/*****************************************************
		Test Complete:
			close all existing flows
	******************************************************/
	for (idx = 0 ; idx < PORT_BOUNCING_ITEM ; idx ++)
	{
		/* empty entry */
		if (sportList[idx] < 0)
			continue;

		/*
			NPI	->	ServerPort, FIN|ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				sportList[idx], port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					sportList[idx], port_serv, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			ServerPort  -> NPI, FIN|ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, sportList[idx], (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 122, 0, 0,
					port_gw, sportList[idx], (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			NPI	->	ServerPort, ACK
		*/
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				sportList[idx], port_gw, TH_ACK, 0, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};

				mbuf_comp = confVlanHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					sportList[idx], port_serv, TH_ACK, 0, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		disable TCP Server Port mapping used by port bouncing
	*/
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	return SUCCESS;
}

/*
@func int32		| portBouncing_udp_1	| portBouncing UDP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send UDP packet to ServerPort External IP/Port
 */
int32 pkt_portBouncing_udp_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

{
	// Add UDP Server port
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort
			Server port error : FAILED
	*/
	{
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_npi, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 123;
		conf.conf_sport					= port_npi;
		conf.conf_dport					= port_gw;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;

		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 1);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FAILED);	// can not found entry
		freeMbuf(mbuf_in);
	}

	// Remove TCP Server port / Add UDP Server port
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);

	/*
		NPI	->	ServerPort
			Server port OK : Port bouncing!
	*/
	{
		mbuf_in = genMbufPkt(&conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_serv, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_serv;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 122;
		conf.conf_sport					= port_npi;
		conf.conf_dport					= port_serv;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;
		ADD_TX_PORT(conf.conf_portlist, 4);
		conf.conf_vlanIdx					= 3;

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMP(mbuf_out, mbuf_comp);
		
		freeMbuf(mbuf_comp);
		freeMbuf(mbuf_out);
	}
	/*
		ServerPotr  -> NPI
	*/
	{

		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_serv, conf.conf_smac);
		CP_MAC (mac_gw_int2, conf.conf_dmac);
		conf.conf_sip						= ip_serv;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 123;
		conf.conf_sport					= port_serv;
		conf.conf_dport					= port_npi;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;

		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 4);

		mbuf_in = genMbufPkt(&conf);
		mbufList_Reinit();
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_gw_int, conf.conf_smac);
		CP_MAC (mac_npi, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_npi;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 122;
		conf.conf_sport					= port_gw;
		conf.conf_dport					= port_npi;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;
		ADD_TX_PORT(conf.conf_portlist, 1);
		conf.conf_vlanIdx					= 2;

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMP(mbuf_out, mbuf_comp);

		freeMbuf(mbuf_comp);
		freeMbuf(mbuf_out);
	}

	/*
		NPI	->	ServerPort
	*/
	{
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_npi, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 123;
		conf.conf_sport					= port_npi;
		conf.conf_dport					= port_gw;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;

		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);
		mbufList_Reinit();
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);	// Port-bouncing OK

		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_UDP;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_serv, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_serv;
		conf.ip.id							= 0xab;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 122;
		conf.conf_sport					= port_npi;
		conf.conf_dport					= port_serv;
		conf.payload.content				= pkt_content;
		conf.payload.length				= 1024;
		ADD_TX_PORT(conf.conf_portlist, 4);
		conf.conf_vlanIdx					= 3;

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMP(mbuf_out, mbuf_comp);
		
		freeMbuf(mbuf_comp);
		freeMbuf(mbuf_out);
	}
}
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	return SUCCESS;
}
/*
	For Ip-unnumber -> DmzHost
	udp packet
*/
/*
@func int32		| portBouncing_udp_2	| portBouncing UDP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Ip-Unnumber Host send UDP packet to NAPT External IP and gateway forwards it to dmz host
 */
int32 pkt_portBouncing_udp_2(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_unnum = ntohl(inet_addr("10.113.1.2"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 port_unnum = 0x1234;
	uint16 port_dmz = 0x2345;
	ether_addr_t mac_unnum = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_3();
	ASSERT(rtl8651_addArp(ip_unnum, &mac_unnum, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 2) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		UNNUM	->	GW
			before DMZ host, trap it to protocol stack
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FAILED);					// Routing to gateway, return FAILED
		freeMbuf(mbuf_in);
	}

	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);
	/*
		UNNUM	->	GW
			after DMZ host, port bouncing is triggered
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		GW		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_unnum, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				port_dmz, port_unnum, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		UNNUM	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		GW		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_unnum, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				port_dmz, port_unnum, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

/*
	For NPI -> DMZ Host
	udp packet
*/
 /*
@func int32		| portBouncing_udp_3	| portBouncing UDP testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send UDP packet to NAPT External IP and gateway forwards it to dmz host
 */
int32 pkt_portBouncing_udp_3(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_dmz = 0x2345;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 4) == SUCCESS);

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_dmz, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			port_dmz, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_dmz, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}

/*
	For NPI -> NAT
	udp packet
*/
 /*
@func int32		| portBouncing_udp_4	| portBouncing UDP testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send UDP packet to NAT External IP and gateway forwards it to NAT Internal Host
 */
int32 pkt_portBouncing_udp_4(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_ni = 0x2345;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan2", 4) == SUCCESS);

	// Add nat mapping here
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			port_ni, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_ni, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZ		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			port_ni, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				port_ni, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}

/*
@func int32		| portBouncing_udp_5	| portBouncing UDP testing 5
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send UDP packet to uPnP External IP/Port
 */
int32 pkt_portBouncing_udp_5(uint32 caseNo){
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_npi = 0x1234;
	uint16 port_serv = 0x2345;
	uint16 port_rp = 0x3456;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	uint16 port_gw = 0x3456;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	int cnt;

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	// turn off dos
	rtl8651a_setDosStatus(0, FALSE);

	/* turn off uPnP Port Bouncing */
	ASSERT(rtl8651_fwdEngineProcessUpnpPortBouncing(FALSE) == SUCCESS);

	/* dont process upnp port bouncing */
	{
		/* add upnp entry */
		rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, ip_gw_ext, port_gw, ip_serv, port_serv);

		/*
			NPI -> upnp External
				Error : FAILED
		*/
		{
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw,
				0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			freeMbuf(mbuf_in);
		}

		/* delete upnp entry */
		rtl8651_delUpnpMap(FALSE, 0, 0, ip_gw_ext, port_gw, ip_serv, port_serv);
	}

	/* turn on uPnP Port Bouncing */
	ASSERT(rtl8651_fwdEngineProcessUpnpPortBouncing(TRUE) == SUCCESS);

	{
		/* add upnp entry with remote IP/Port is set -> this can NOT apply to port bouncing */
		rtl8651_addUpnpMap(UPNP_ONESHOT, ip_rp, port_rp, ip_gw_ext, port_gw, ip_serv, port_serv);

		/*
			NPI -> upnp External
				Error : FAILED
		*/
		{
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw,
				0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			freeMbuf(mbuf_in);
		}

		/* delete upnp entry and add another upnp entry without remote IP/Port */
		rtl8651_delUpnpMap(FALSE, ip_rp, port_rp, ip_gw_ext, port_gw, ip_serv, port_serv);
		rtl8651_addUpnpMap(UPNP_ONESHOT, 0, 0, ip_gw_ext, port_gw, ip_serv, port_serv);

		/*
			NPI -> upnp External
				Bounce to internal host
		*/
		for (cnt = 0 ; cnt < 1000 ; cnt ++)
		{
			{
				mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int, ip_npi, ip_gw_ext, 123, 0, 0,
					port_npi, port_gw,
					0, 0, 0, 0, pkt_content, sizeof(pkt_content));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);

				{
					uint16 tx_port[2] = {4, 0xffff};
					mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 122, 0, 0,
					port_npi, port_serv,
					0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
			/*
				upnp internal -> NPI
					Bounce
			*/
			{
				mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_UDP, 4, 3, 0,
					mac_serv, mac_gw_int2, ip_serv, ip_gw_ext, 123, 0, 0,
					port_serv, port_npi,
					0, 0, 0, 0, pkt_content, sizeof(pkt_content));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);

				{
					uint16 tx_port[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 122, 0, 0,
					port_gw, port_npi,
					0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}
	}

	return SUCCESS;
}


/*
	For Ip-unnumber -> DmzHost
	icmp packet
*/
/*
@func int32		| portBouncing_icmp_1	| portBouncing ICMP testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Ip-Unnumber Host send ICMP packet to NAPT External IP and gateway forwards it to dmz host
 */
int32 pkt_portBouncing_icmp_1(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_unnum = ntohl(inet_addr("10.113.1.2"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 id = 0x1234;
	ether_addr_t mac_unnum = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType;

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_3();
	ASSERT(rtl8651_addArp(ip_unnum, &mac_unnum, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 2) == SUCCESS);
	fwdeng_function_configuration1();

	// turn-off dos
	rtl8651a_setDosStatus(0, 0);

	/*
		UNNUM	->	GW
			before DMZ host, trap it to protocol stack
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);					// Route to gateway, return ICMP ECHO reply packet
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 128, 0, 0,
				0, 0, 0, 0, ICMP_ECHOREPLY, id, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);

for (icmpType = 0 ; icmpType < 0xff; icmpType ++)
{
	_rtl8651_flushPortBouncingEntry();
	id ++;
	switch (icmpType)
	{
		// it must be trapped to CPU and can't be forwarded
		case ICMP_ECHOREPLY:
		case ICMP_TSTAMPREPLY:
		case ICMP_UNREACH:
		case ICMP_TIMXCEED:
		case ICMP_SOURCEQUENCH:
		case ICMP_PARAMPROB:
			continue;
		default:
			break;
	}
	/*
		UNNUM	->	GW
			after DMZ host, port bouncing is triggered
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}	
	/*
		GW		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		UNNUM	->	GW
			after DMZ host, port bouncing is triggered
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		GW		->	UNNUM
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				0, 0, 0, 0, icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

}
	return SUCCESS;
}
 /*
@func int32		| portBouncing_icmp_2	| portBouncing ICMP testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Ip-Unnumber Host send ICMP packet to NAPT External IP and gateway forwards it to dmz host
Dynamic turn ON/OFF "icmp-dmz-fwd" switch
 */
int32 pkt_portBouncing_icmp_2(uint32 caseNo)
{
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_unnum = ntohl(inet_addr("10.113.1.2"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 id = 0x1234;
	ether_addr_t mac_unnum = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();

	fwdeng_env_configuration_3();
	ASSERT(rtl8651_addArp(ip_unnum, &mac_unnum, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 2) == SUCCESS);
	fwdeng_function_configuration1();
	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);

	// Turn OFF fwdeng ICMP reply
	ASSERT(rtl8651_fwdEngineIcmp(FALSE) == SUCCESS);

	// Turn OFF DMZ host icmp Pass-through
	ASSERT(rtl8651_fwdEngineDMZHostIcmpPassThrough(FALSE) == SUCCESS);

	/*
		UNNUM	->	GW, ECHO	=> trap to CPU
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FAILED);
		freeMbuf(mbuf_in);
	}

	/*
		UNNUM	->	GW, TSTAMP	=> trap to CPU
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMP, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FAILED);
		freeMbuf(mbuf_in);
	}

	// Turn ON DMZ host icmp Pass-through
	ASSERT(rtl8651_fwdEngineDMZHostIcmpPassThrough(TRUE) == SUCCESS);
	/*
		UNNUM	->	GW, ECHO
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				0, 0, 0, 0, ICMP_ECHO, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		GW		->	UNNUM, ECHO REPLY
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHOREPLY, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				0, 0, 0, 0, ICMP_ECHOREPLY, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		UNNUM	->	GW, TSTAMP
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMP, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				0, 0, 0, 0, ICMP_TSTAMP, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		GW		->	UNNUM, TSTAMP REPLY
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMPREPLY, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				0, 0, 0, 0, ICMP_TSTAMPREPLY, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// Turn OFF DMZ host icmp Pass-through
	ASSERT(rtl8651_fwdEngineDMZHostIcmpPassThrough(FALSE) == SUCCESS);

	/*
		UNNUM	->	GW, ECHO	=> trap to CPU
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FAILED);
		freeMbuf(mbuf_in);
	}

	/*
		UNNUM	->	GW, TSTAMP	=> trap to CPU
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMP, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FAILED);
		freeMbuf(mbuf_in);
	}

	/*
		Still Accept remaining ECHO-REPLY from GW(DMZ host)
	*/
	/*
		GW		->	UNNUM, ECHO REPLY
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHOREPLY, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				0, 0, 0, 0, ICMP_ECHOREPLY, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		GW		->	UNNUM, TSTAMP REPLY
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 2, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMPREPLY, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_unnum,
				ip_gw_ext, ip_unnum, 122, 0, 0,
				0, 0, 0, 0, ICMP_TSTAMPREPLY, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}
 /*
@func int32		| portBouncing_icmp_3	| portBouncing ICMP testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send ICMP packet to NAPT External IP and gateway forwards it to dmz host
 */
int32 pkt_portBouncing_icmp_3(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 id = 0x1234;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 4) == SUCCESS);

	// Add nat mapping here
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_dmz) == SUCCESS);	//add nat mapping


for (icmpType = 0 ; icmpType < 0xff ; icmpType ++)
{
	rtl8651_dosOneSecondTimer();
	_rtl8651_flushPortBouncingEntry();
	id ++;

	switch (icmpType)
	{
		case ICMP_UNREACH:
		case ICMP_TIMXCEED:
		case ICMP_SOURCEQUENCH:
		case ICMP_PARAMPROB:
			continue;
	}

	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZHOST		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		DMZHOST		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 4, 3, 0,
			mac_dmz, mac_gw_int2,
			ip_dmz, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

}
	return SUCCESS;
}
  /*
@func int32		| portBouncing_icmp_4	| portBouncing ICMP testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send ICMP packet to NAT External IP and gateway forwards it to NAT Internal Host
 */
int32 pkt_portBouncing_icmp_4(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.2.1"));
	uint16 id = 0x1234;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan2", 4) == SUCCESS);

	// Add nat mapping here
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping


for (icmpType = 0 ; icmpType < 0xff ; icmpType ++)
{
	rtl8651_dosOneSecondTimer();
	_rtl8651_flushPortBouncingEntry();
	id ++;

	switch (icmpType)
	{
		case ICMP_UNREACH:
		case ICMP_TIMXCEED:
		case ICMP_SOURCEQUENCH:
		case ICMP_PARAMPROB:
			continue;
	}

	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NI		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	GW
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NI		->	NPI
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 4, 3, 0,
			mac_ni, mac_gw_int2,
			ip_ni, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_ICMP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_ext, ip_npi, 122, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

}
	return SUCCESS;
}

 /*
@func int32		| portBouncing_icmp_5	| portBouncing ICMP testing 5
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send ICMP packet to ServerPort External IP/Port
 */
int32 pkt_portBouncing_icmp_5(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	rtl8651_PktConf_t conf_err_hsb, conf_err_hsa;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_serv = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x2345;
	uint16 port_serv = 0x3456;
	uint16 port_gw = 0x1111;
	uint16 id = 0x1234;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_serv = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType, ErrorFlowType;
	uint16 errIcmpType = ICMP_ECHO;	// flood ping :p
	int32 ic_type, err_type;
	uint16 err_id = 0xabcd;
	uint8 ic_type_arr[4] = {ICMP_UNREACH, ICMP_TIMXCEED, ICMP_PARAMPROB, ICMP_SOURCEQUENCH};
	uint8 ErrorFlowType_arr[2] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP};


	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_serv, &mac_serv, "lan2", 4) == SUCCESS);
	// Add nat mapping here
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

 
for (err_type = 0; err_type < 2; err_type ++)
{
	ErrorFlowType = ErrorFlowType_arr[err_type];

	/*
		Create TCP/UDP Server Port Here
	*/
	if (ErrorFlowType == _PKT_TYPE_TCP)
	{
		// Create TCP Server Port First
		ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	}else
	{	// Create UDP Server Port First
		ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_serv, port_serv) == SUCCESS);
	}

	/*
		Before flow starting, ICMP error message must be dropped silently
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	/>	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_gw, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			GW	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 123, 0, 0,
					port_npi, port_serv, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
	/*
		Create Error Flow
	*/
	{
		/*
			NPI	->	GW 
			( For TCP first packet, we send it with TH_ACK instead of TH_SYN ....
				for port bouncing, we do route only and don't trace packet)
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			ErrorFlowType, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				ErrorFlowType, tx_port, 3, 0,
				mac_gw_int2, mac_serv,
				ip_gw_ext, ip_serv, 122, 0, 0,
				port_npi, port_serv, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		ICMP error message is accepted now
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_gw, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 3, 0,
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/*
			GW	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 123, 0, 0,
					port_npi, port_serv, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/*
		Clear Port Bouncing Entry here, ICMP error message is dropped silently again
	*/
	_rtl8651_flushPortBouncingEntry();
	/*
		ICMP error message is rejested again
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 123, 0, 0,
				port_serv, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_gw, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			GW	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_gw, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_serv,
					ip_gw_ext, ip_serv, 123, 0, 0,
					port_npi, port_serv, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_serv, mac_gw_int2,
				ip_serv, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}

}	// TCP/UDP/ICMP Error Flow
	return SUCCESS;
}

 /*
@func int32		| portBouncing_icmp_6	| portBouncing ICMP testing 6
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send packet to NAPT External IP and gateway forwards it to dmz host.
Dmz host return the ICMP error message back to the Internal Host
 */
int32 pkt_portBouncing_icmp_6(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	rtl8651_PktConf_t conf_err_hsb, conf_err_hsa;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x2345;
	uint16 port_dmz = 0x3456;
	uint16 id = 0x1234;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType, ErrorFlowType;
	uint16 errIcmpType = ICMP_ECHO;	// flood ping :p
	int32 ic_type, err_type;
	uint16 err_id = 0xabcd;
	uint8 ic_type_arr[4] = {ICMP_UNREACH, ICMP_TIMXCEED, ICMP_PARAMPROB, ICMP_SOURCEQUENCH};
	uint8 ErrorFlowType_arr[3] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP, _PKT_TYPE_ICMP};


	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);

	// disable dos check
	rtl8651a_setDosStatus(0, 0);

for (err_type = 0; err_type < 3 ; err_type ++)
{
	ErrorFlowType = ErrorFlowType_arr[err_type];

	/*
		Before flow starting, ICMP error message must be dropped silently
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 123, 0, 0,
				port_dmz, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_dmz, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 123, 0, 0,
					port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
	/*
		Create Error Flow
	*/
	{
		/*
			NPI	->	GW 
			( For TCP first packet, we send it with TH_ACK instead of TH_SYN ....
				for port bouncing, we do route only and don't trace packet)
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			ErrorFlowType, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				ErrorFlowType, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		ICMP error message is accepted now
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 123, 0, 0,
				port_dmz, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_dmz, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 3, 0,
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 123, 0, 0,
					port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/*
		Clear Port Bouncing Entry here, ICMP error message is dropped silently again
	*/
	_rtl8651_flushPortBouncingEntry();
	/*
		ICMP error message is rejested again
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 123, 0, 0,
				port_dmz, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_dmz, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 123, 0, 0,
					port_npi, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
}	// TCP/UDP/ICMP Error Flow
	return SUCCESS;
}
/*
@func int32		| portBouncing_icmp_7	| portBouncing ICMP testing 7
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Ip-Unnumbered Host send packet to NAPT External IP and gateway forwards it to dmz host.
Dmz host return the ICMP error message back to the Ip-Unnumbered Host
 */
int32 pkt_portBouncing_icmp_7(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	rtl8651_PktConf_t conf_err_hsb, conf_err_hsa;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_unnum = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_dmz = ntohl(inet_addr("192.168.2.1"));
	uint16 port_unnum = 0x2345;
	uint16 port_dmz = 0x3456;
	uint16 id = 0x1234;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_unnum = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_dmz = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType, ErrorFlowType;
	uint16 errIcmpType = ICMP_ECHO;	// flood ping :p
	int32 ic_type, err_type;
	uint16 err_id = 0xabcd;
	uint8 ic_type_arr[4] = {ICMP_UNREACH, ICMP_TIMXCEED, ICMP_PARAMPROB, ICMP_SOURCEQUENCH};
	uint8 ErrorFlowType_arr[3] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP, _PKT_TYPE_ICMP};


	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_3();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_unnum, &mac_unnum, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_dmz, &mac_dmz, "lan2", 2) == SUCCESS);

	// Add dmz host here
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_dmz) == SUCCESS);

	// disable dos check
	rtl8651a_setDosStatus(0, 0);

for (err_type = 0; err_type < 3 ; err_type ++)
{
	ErrorFlowType = ErrorFlowType_arr[err_type];

	/*
		Before flow starting, ICMP error message must be dropped silently
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			UNNUM	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 2, 3, 0, 
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 123, 0, 0,
				port_dmz, port_unnum, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_unnum,
					ip_gw_ext, ip_unnum, 123, 0, 0,
					port_dmz, port_unnum, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_unnum, mac_gw_int,
				ip_unnum, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			DMZ	->	UNNUM	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_unnum, mac_gw_int,
				ip_unnum, ip_gw_ext, 123, 0, 0,
				port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {2, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 3, 0, 
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 123, 0, 0,
					port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 2, 3, 0,
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
	/*
		Create Error Flow
	*/
	{
		/*
			UNNUM	->	GW 
			( For TCP first packet, we send it with TH_ACK instead of TH_SYN ....
				for port bouncing, we do route only and don't trace packet)
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			ErrorFlowType, 1, 2, 0,
			mac_unnum, mac_gw_int,
			ip_unnum, ip_gw_ext, 123, 0, 0,
			port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {2, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				ErrorFlowType, tx_port, 3, 0,
				mac_gw_int2, mac_dmz,
				ip_gw_ext, ip_dmz, 122, 0, 0,
				port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		ICMP error message is accepted now
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			UNNUM	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 2, 3, 0, 
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 123, 0, 0,
				port_dmz, port_unnum, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_unnum,
					ip_gw_ext, ip_unnum, 123, 0, 0,
					port_dmz, port_unnum, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_unnum, mac_gw_int,
				ip_unnum, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {2, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 3, 0,
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/*
			DMZ	->	UNNUM	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_unnum, mac_gw_int,
				ip_unnum, ip_gw_ext, 123, 0, 0,
				port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {3, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 4, 0, 
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 123, 0, 0,
					port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 2, 3, 0,
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 2, 0,
					mac_gw_int, mac_unnum,
					ip_gw_ext, ip_unnum, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/*
		Clear Port Bouncing Entry here, ICMP error message is dropped silently again
	*/
	_rtl8651_flushPortBouncingEntry();
	/*
		ICMP error message is rejested again
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 2, 3, 0, 
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 123, 0, 0,
				port_dmz, port_unnum, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_unnum,
					ip_gw_ext, ip_unnum, 123, 0, 0,
					port_dmz, port_unnum, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_unnum, mac_gw_int,
				ip_unnum, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_unnum, mac_gw_int,
				ip_unnum, ip_gw_ext, 123, 0, 0,
				port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {2, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 3, 0, 
					mac_gw_int2, mac_dmz,
					ip_gw_ext, ip_dmz, 123, 0, 0,
					port_unnum, port_dmz, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 2, 3, 0,
				mac_dmz, mac_gw_int2,
				ip_dmz, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
}	// TCP/UDP/ICMP Error Flow
	return SUCCESS;
}
/*
@func int32		| portBouncing_icmp_8	| portBouncing ICMP testing 8
@rvalue SUCCESS	| 	test OK
@comm 
Test the PortBouncing function : One Internal Host send packet to NAT External IP and gateway forwards it to NAT internal host.
NAT Internal host return the ICMP error message back to that Internal Host
 */
int32 pkt_portBouncing_icmp_8(uint32 caseNo){
	int8 pkt_content[1460];
	int32 retval;
	rtl8651_PktConf_t conf_err_hsb, conf_err_hsa;
	struct rtl_mBuf *mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_ni = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x2345;
	uint16 port_ni = 0x3456;
	uint16 id = 0x1234;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_ni = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 icmpType, ErrorFlowType;
	uint16 errIcmpType = ICMP_ECHO;	// flood ping :p
	int32 ic_type, err_type;
	uint16 err_id = 0xabcd;
	uint8 ic_type_arr[4] = {ICMP_UNREACH, ICMP_TIMXCEED, ICMP_PARAMPROB, ICMP_SOURCEQUENCH};
	uint8 ErrorFlowType_arr[3] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP, _PKT_TYPE_ICMP};


	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_ni, &mac_ni, "lan2", 4) == SUCCESS);

	// Add nat mapping here
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_ni) == SUCCESS);	//add nat mapping

	// disable dos check
	rtl8651a_setDosStatus(0, 0);

for (err_type = 0; err_type < 3 ; err_type ++)
{
	ErrorFlowType = ErrorFlowType_arr[err_type];

	/*
		Before flow starting, ICMP error message must be dropped silently
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_ni, mac_gw_int2,
				ip_ni, ip_gw_ext, 123, 0, 0,
				port_ni, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_ni, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {4, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 3, 0, 
					mac_gw_int2, mac_ni,
					ip_gw_ext, ip_ni, 123, 0, 0,
					port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_ni, mac_gw_int2,
				ip_ni, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
	/*
		Create Error Flow
	*/
	{
		/*
			NPI	->	GW 
			( For TCP first packet, we send it with TH_ACK instead of TH_SYN ....
				for port bouncing, we do route only and don't trace packet)
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			ErrorFlowType, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				ErrorFlowType, tx_port, 3, 0,
				mac_gw_int2, mac_ni,
				ip_gw_ext, ip_ni, 122, 0, 0,
				port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		ICMP error message is accepted now
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_ni, mac_gw_int2,
				ip_ni, ip_gw_ext, 123, 0, 0,
				port_ni, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_ni, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {4, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 3, 0,
					mac_gw_int2, mac_ni,
					ip_gw_ext, ip_ni, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {4, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 3, 0, 
					mac_gw_int2, mac_ni,
					ip_gw_ext, ip_ni, 123, 0, 0,
					port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_ni, mac_gw_int2,
				ip_ni, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, &conf_err_hsb,
					_PKT_TYPE_ICMP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 124, 0, 0,
					0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/*
		Clear Port Bouncing Entry here, ICMP error message is trapped to cpu again
	*/
	_rtl8651_flushPortBouncingEntry();
	/*
		ICMP error message is rejested again
	*/
	for (ic_type = 0 ; ic_type < 4 ; ic_type ++)
	{
		icmpType = ic_type_arr[ic_type];
		/*
			NPI	->	GW	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 4, 3, 0, 
				mac_ni, mac_gw_int2,
				ip_ni, ip_gw_ext, 123, 0, 0,
				port_ni, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 2, 0, 
					mac_gw_int, mac_npi,
					ip_gw_ext, ip_npi, 123, 0, 0,
					port_ni, port_npi, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
		/*
			NI	->	NPI	ICMP error msg
		*/
		/*
			Generate Error Flow here
		*/
		{
			struct rtl_mBuf *mbuf_err;
	
			mbuf_err = confVlanHSB( &conf_err_hsb, NULL,
				ErrorFlowType, 1, 2, 0, 
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 123, 0, 0,
				port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
			freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			{
				uint16 tx_port[2] = {4, 0xffff};
				mbuf_err = confVlanHSA( &conf_err_hsa, NULL,
					ErrorFlowType, tx_port, 3, 0, 
					mac_gw_int2, mac_ni,
					ip_gw_ext, ip_ni, 123, 0, 0,
					port_npi, port_ni, TH_ACK, 1460, errIcmpType, err_id, pkt_content, sizeof(pkt_content));
				freeMbuf(mbuf_err);	// we only need "conf_err_in", release mbuf_err directly
			}
		}
		/*
			ICMP error msg
		*/
		{
			mbuf_in = confVlanHSB( NULL, &conf_err_hsa,
				_PKT_TYPE_ICMP, 4, 3, 0,
				mac_ni, mac_gw_int2,
				ip_ni, ip_gw_ext, 125, 0, 0,
				0, 0, 0, 0, (uint16)icmpType, id, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}
	}
}	// TCP/UDP/ICMP Error Flow
	return SUCCESS;
}
/*
@func int32		| feature_icmpReply_1	| ICMP reply future testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the forwarding engine ICMP echo-reply function
 */
int32 pkt_feature_icmpReply_1(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP reply test
		1 wan(pppoe), 1 lan

		RP	->	GW	ICMP_ECHO
		GW 	->	RP	ICMP_ECHOREPLY
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_gw_next = ntohl(inet_addr("10.113.2.254"));
	uint16 id = 0x01;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_vlan_next = {{0x00, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_gw_next, &mac_vlan_next, "wan2", 5) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	/*
		through pppoe type
		RP	->	GW
		GW	->	RP
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	/* GW->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= IP_DEFAULT_TTL;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		through vlan type
		RP	->	GW
		GW	->	RP
	*/
{
	/* config */
	/* RP->GW */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_vlan_next, conf.conf_smac);
	CP_MAC (mac_gw_ext2, conf.conf_dmac);
	conf.conf_sip						= ip_rp2;
	conf.conf_dip						= ip_gw_ext2;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.icmp.type					= ICMP_ECHO;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 4;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 5);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	/* GW->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext2, conf.conf_smac);
	CP_MAC (mac_vlan_next, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext2;
	conf.conf_dip						= ip_rp2;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= IP_DEFAULT_TTL;
	conf.icmp.type					= ICMP_ECHOREPLY;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 4;
	conf.conf_pppoeIdx				= 0;
	ADD_TX_PORT(conf.conf_portlist, 5);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}

/*
@func int32		| feature_icmpReply_2	| ICMP reply future testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the forwarding engine ICMP echo-reply function for fragment packets
 */
int32 pkt_feature_icmpReply_2(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP reply test
		1 wan(pppoe), 1 lan

		RP	->	GW	ICMP_ECHO
		GW 	->	RP	ICMP_ECHOREPLY
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_gw_next = ntohl(inet_addr("10.113.2.254"));
	uint16 id = 0x01;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_vlan_next = {{0x00, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	int total_pkt = 5;
	uint16 icmp_payload = sizeof(pkt_content);
	int pa[5], p;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addArp(ip_gw_next, &mac_vlan_next, "wan2", 5) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);

	fwdeng_function_configuration1();

	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
			through pppoe interface
	*/
	{
		/*
			RP	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop1;
					}
			}

			DEFAULT_IP_ID ++;

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, ICMP_ECHO, 123, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				if (p < total_pkt)
				{
					VALUE_CMP(mbufList_nmbuf(), 0);
				}else
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
				}
			}		
			// reply will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};

				mbuf_comp = confPppoeHSA_Tagged(NULL, NULL,
					_PKT_TYPE_ICMP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, IP_DEFAULT_TTL, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, ICMP_ECHOREPLY, 123, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;

				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
	nextLoop1:
		}
	}

	/*
			through vlan interface
	*/
	{
		/*
			RP	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop2;
					}
			}

			DEFAULT_IP_ID ++;

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 5, 4, 0,
					mac_vlan_next, mac_gw_ext2,
					ip_rp2, ip_gw_ext2, 11, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, ICMP_ECHO, 123, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				if (p < total_pkt)
				{
					VALUE_CMP(mbufList_nmbuf(), 0);
				}else
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
				}
			}		
			// reply will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {5, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_ICMP, tx_port, 4, 0,
					mac_gw_ext2, mac_vlan_next,
					ip_gw_ext2, ip_rp2, IP_DEFAULT_TTL, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, ICMP_ECHOREPLY, 123, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;

				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
	nextLoop2:
		}
	}
	return SUCCESS;
}

/*
@func int32		| feature_icmpTexceedReply_1	| ICMP time exceed reply future testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the forwarding engine ICMP time exceed reply function for packet whose TTL <= 1
 */
int32 pkt_feature_icmpTexceedReply_1(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;

	/**********************************************
		ICMP reply test
		1 wan(pppoe), 1 lan

		NPI	->	RP	IP_PACKET
		GW	->	NPI	ICMP_TIMEXCEED

		RP	->	GW	IP_PACKET
		GW 	->	RP	ICMP_TIMEXCEED
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	int8 pkt_content[1452];

	START_TEST_CASE();
	bzero(pkt_content, sizeof(pkt_content));
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	{
		/*
			NPI	->	RP	IP_PACKET , TTL == 1
		*/
		mbuf_in = confVlanHSB( &conf, NULL,
			_PKT_TYPE_IP, 1, 2, 0, 
			mac_npi, mac_gw_int, ip_npi, ip_rp, 1, 0, 0,
			0, 0, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, &conf,
				_PKT_TYPE_ICMP, tx_list, 2, 0,
				mac_gw_int, mac_npi, ip_gw_int, ip_npi, 128, 0, 0, 0, 0,
				0, 0, ICMP_TIMXCEED, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}
/*
@func int32		| feature_logNewFlow_1	| Log new NAPT flow future testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the forwarding engine Log function when system setup new napt flow
 */
int32 pkt_feature_logNewFlow_1(uint32 caseNo)
{
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out;
	int8 pkt_content[1400];
	/*
		log for new tcp/udp napt flow
		TCP outbound,
		TCP inbound,
		UDP outbound,
		UDP inbound
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));
	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	ASSERT(log_enableLogging(0, RTL8651_LOGMODULE_NEWFLOW, 1) == SUCCESS);
	/*
		TCP outbound
	*/
	{
		/*
			NPI	->	RP:	SYN => log
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL) == SUCCESS);
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_NEWFLOW,RTL8651_LOG_NEWFLOW_NewTcpNaptOutbound, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"New TCP Outbound Flow"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			RP	->	NPI:	SYN|ACK => Don't log
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0, port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			NPI	->	RP:	ACK => Don't log
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			NPI	->	RP:	ACK => Don't log
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			RP	->	NPI:	ACK => Don't log
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0, port_rp, port_gw, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	/*
		TCP inbound, with server port
	*/
	// modify ports to avoid Napt table hash-collision and mis-understanding
	port_gw ++;
	port_rp ++;
	port_npi++;
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	{
		/*
			RP	->	NPI:	SYN => log
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0, port_rp, port_gw, (TH_SYN), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_NEWFLOW,RTL8651_LOG_NEWFLOW_NewTcpNaptInbound, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"New TCP Inbound Flow"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			NPI	->	RP:	SYN|ACK => Don't log
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			RP	->	NPI:	ACK => Don't log
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0, port_rp, port_gw, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	{
		/*
			NPI	->	RP:	ACK => Don't log
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
		VALUE_CMP(log_cnt(), 0);
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	/*
		UDP outbound
	*/
	{
		int nCount;
		for (nCount = 1; nCount < 10 ; nCount ++)
		{
			{
				/*
					NPI	->	RP: first => log, other => don't log
				*/
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				mbuf_out = mbufList_dequeue();
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL) == SUCCESS);
				freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
				if (nCount == 1)
				{
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_NEWFLOW,RTL8651_LOG_NEWFLOW_NewUdpNaptOutbound, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"New UDP Outbound Flow"), SUCCESS);
					#endif
				}else
				{
					VALUE_CMP(log_cnt(), 0);
				}
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			{
				/*
					RP	->	NPI: second => don't log
				*/
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0, port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				mbuf_out = mbufList_dequeue();
				freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
		}
	}
	/*
		UDP inbound, with server port
	*/
	port_gw ++;
	port_rp ++;
	port_npi++;
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	{
		int nCount;
		for (nCount = 1; nCount < 10 ; nCount ++)
		{
			{
				/*
					RP	->	NPI: first => log, other => don't log
				*/
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0, port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				mbuf_out = mbufList_dequeue();
				freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
				if (nCount == 1)
				{
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_NEWFLOW,RTL8651_LOG_NEWFLOW_NewUdpNaptInbound, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"New UDP Inbound Flow"), SUCCESS);
					#endif
				}else
				{
					VALUE_CMP(log_cnt(), 0);
				}
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			{
				/*
					NPI	->	RP: second => don't log
				*/
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0, port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				mbuf_out = mbufList_dequeue();
				freeMbuf(mbuf_out); // release output packet directly, because we don't care it in this testing case
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
		}
	}
	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi, port_npi) == SUCCESS);
	// disable NewFlow Logging
	ASSERT(log_enableLogging(0, RTL8651_LOGMODULE_NEWFLOW, 0) == SUCCESS);
	return SUCCESS;
}

/*
@func int32		| pkt_feature_arp_1	| arp function testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test arp function:
	In some cases, Lan host would ask Gateway with its destination IP beeing Gateway's WAN IP address.
	For these packet, ROMEDRV need to recognize it as legal ARP request and set the corresponding return value to protocol stack.
	If ARP reply is turned ON, ROMEDRV need to reply this request with the MAC beeing the address which assigned in the vlan where
	the ARP request incoming.
 */
int32 pkt_feature_arp_1(uint32 caseNo) {
	/*
		For arp requests from internal host:

		reply arp request: dip is in other VLAN
				-> reply arp with gateway mac
	*/
 	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("10.113.2.2"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_rp2 = {{0x00, 0x0a, 0x0a, 0x0a, 0x0a, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* <----------- LAN to LAN interface & WAN to WAN interface would be ok -------------> */

	/* Turn ON ARP reply */
	ASSERT(rtl8651_fwdEngineArp(TRUE) == SUCCESS);

	{
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_int, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_gw_int, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	{
		mbuf_in = confArpHSB(NULL, 5, 4, mac_rp2, mac_bcast, ip_rp2, ip_gw_ext2, ARPOP_REQUEST);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {5,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 4,
				mac_gw_ext2, mac_rp2, ip_gw_ext2, ip_rp2, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/* Turn OFF ARP reply */
	ASSERT(rtl8651_fwdEngineArp(FALSE) == SUCCESS);
	{	/*trap "FWDENG_ARP_REQUEST" to procotol stack */
		int32 flag = 0;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_ARP_REQUEST, &flag) == SUCCESS);
	}

	{	/* => trap to procotol stack */
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_int, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_REQUEST);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	{	/* => trap to procotol stack */
		mbuf_in = confArpHSB(NULL, 5, 4, mac_rp2, mac_bcast, ip_rp2, ip_gw_ext, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_REQUEST);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}


	/* Turn ON ARP reply */
	ASSERT(rtl8651_fwdEngineArp(TRUE) == SUCCESS);

	{
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_int, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_gw_int, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	{
		mbuf_in = confArpHSB(NULL, 5, 4, mac_rp2, mac_bcast, ip_rp2, ip_gw_ext2, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {5,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 4,
				mac_gw_ext2, mac_rp2, ip_gw_ext2, ip_rp2, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	/* <-------------- LAN to GW-WAN IP is ok -------------> */

	/* Turn ON ARP reply */
	ASSERT(rtl8651_fwdEngineArp(TRUE) == SUCCESS);

	/* for WAN 1 */
	{
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_ext, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_gw_ext, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/* for WAN 2 */
	{
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_ext2, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_gw_ext2, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/* turn OFF ARP reply */
	ASSERT(rtl8651_fwdEngineArp(FALSE) == SUCCESS);
	{	/*trap "FWDENG_ARP_REQUEST" to procotol stack */
		int32 flag = 0;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_ARP_REQUEST, &flag) == SUCCESS);
	}

	/* for WAN 1 */
	{	/* => trap to procotol stack */
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_ext, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_REQUEST);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/* for WAN 2 */
	{	/* => trap to procotol stack */
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_ext2, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_REQUEST);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/* Turn ON ARP reply */
	ASSERT(rtl8651_fwdEngineArp(TRUE) == SUCCESS);

	/* for WAN 1 */
	{
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_ext, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_gw_ext, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/* for WAN 2 */
	{
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_gw_ext2, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_gw_ext2, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/* <------------- WAN access LAN IP's mac would be forbidded ---------------> */

	/* Turn ON ARP reply */
	ASSERT(rtl8651_fwdEngineArp(TRUE) == SUCCESS);

	{	/*trap "FWDENG_ARP_OTHERS" to procotol stack */
		int32 flag = 0;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_ARP_OTHERS, &flag) == SUCCESS);
	}
	{	/* => trap to procotol stack */
		mbuf_in = confArpHSB(NULL, 5, 4, mac_rp2, mac_bcast, ip_rp2, ip_gw_int, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_OTHERS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/* Turn OFF ARP reply */
	ASSERT(rtl8651_fwdEngineArp(FALSE) == SUCCESS);

	{	/*trap "FWDENG_ARP_OTHERS" to procotol stack */
		int32 flag = 0;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_ARP_OTHERS, &flag) == SUCCESS);
	}
	{	/* => trap to procotol stack */
		mbuf_in = confArpHSB(NULL, 5, 4, mac_rp2, mac_bcast, ip_rp2, ip_gw_int, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_OTHERS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	return SUCCESS;
}


/*
@func int32		| feature_arp_proxy_1	| arp proxy function testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the arp proxy function for internal Hosts when arp request packet's (incoming vlan) != (vlan of dip)
 */
int32 pkt_feature_arp_proxy_1(uint32 caseNo) {
	/*
		For arp requests from internal host:

		reply arp request: dip is in other VLAN
				-> reply arp with gateway mac
	*/
 	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	// turn on arp-proxy
	ASSERT(rtl8651_fwdEngineArpProxy(1) == SUCCESS);

	{	// arp proxy
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_rp, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_rp, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	// turn off arp-proxy
	ASSERT(rtl8651_fwdEngineArpProxy(0) == SUCCESS);
	{	// trap "FWDENG_ARP_OTHERS" to procotol stack
		int32 flag = 0;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_ARP_OTHERS, &flag) == SUCCESS);
	}

	{	// => trap to procotol stack
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_rp, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_ARP_OTHERS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	// turn on arp-proxy
	ASSERT(rtl8651_fwdEngineArpProxy(1) == SUCCESS);

	{	// arp proxy
		mbuf_in = confArpHSB(NULL, 1, 2, mac_npi, mac_bcast, ip_npi, ip_rp, ARPOP_REQUEST);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[4] = {1,0xffff};
			mbuf_comp = confArpHSA( NULL, tx_port, 2,
				mac_gw_int, mac_npi, ip_rp, ip_npi, ARPOP_REPLY);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	return SUCCESS;
}
/*
@func int32		| pkt_feature_InexactUDPNapt_1	| Udp Remote-Host-Regardless(Inexact UDP) napt test 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the function of Remote-Host-Regardless UDP (Inexact UDP) Napt flow establish
 */
int32 pkt_feature_InexactUDPNapt_1(uint32 caseNo)
{
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		UDP
		NPI	->	RP
		RP	->	NPI
		RP2	->	NPI
		RP3	->	NPI

		test for:
			UDP Hash2-only mode

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.113.1.2"));
	uint16 port_rp2 = 0x6789;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_rp3 = ntohl(inet_addr("140.113.1.3"));
	uint16 port_rp3 = 0x7890;
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	/**************************************
		Before enabling Hash2-Only-mode
	**************************************/
	/* disable hash2 only mode */
	ASSERT(rtl8651_fwdEngineInexactUdpFlow(FALSE) == SUCCESS);
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP2 -> NPI	: Not Allow
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp2, ip_gw_ext, 123, 0, 0,
			port_rp2, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	/**************************************
		Enable Hash2-Only-mode
	**************************************/
	/* change port for new established flow */
	port_npi ++;

	/* enable hash2 only mode */
	ASSERT(rtl8651_fwdEngineInexactUdpFlow(TRUE) == SUCCESS);
	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP2 -> NPI	: Allow
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp2, ip_gw_ext, 123, 0, 0,
			port_rp2, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp2, ip_npi, 122, 0, 0,
				port_rp2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/**************************************
		Disable Hash2-Only-mode again
	**************************************/
	/* disable hash2 only mode again */
	ASSERT(rtl8651_fwdEngineInexactUdpFlow(FALSE) == SUCCESS);

	/* old flow still can work */
	// RP2 -> NPI, old flow	: Allow
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp3, ip_gw_ext, 123, 0, 0,
			port_rp3, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp3, ip_npi, 122, 0, 0,
				port_rp3, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/* new flow established after Hash2-only mode disable, hash2 function is not allowed */

	/* change port for new established flow */
	port_npi ++;

	// NPI -> RP
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		// get external port
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// RP -> NPI
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	// RP2 -> NPI	: Not Allow
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp2, ip_gw_ext, 123, 0, 0,
			port_rp2, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	return SUCCESS;
}

#ifdef RTL_WEAK_NAPT_CTRL_TEST
/*
@func int32		| pkt_feature_weakTcpNaptCheck_1	| Forwarding engine TCP Napt stateless entry creation (weak NAPT) test 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the feature:
	For an unknown outbound TCP packet, forwarding engine create an established flow for it instead of
	trap it to procotol stack.
 */
int32 pkt_feature_weakTcpNaptCheck_1(uint32 caseNo)
{
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP
		NPI	->	RP, ACK
		NPI	->	RP, SYN+ACK
		NPI	->	RP, FIN+ACK
		NPI	->	RP, FIN

		test for:
			tcp stateless connection creation
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	/***************************************************************************
		Before turning on weak TCP control, so SPI must be checked
	***************************************************************************/
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN|TH_ACK), 1500, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	/***************************************************************************
		Turn on weak TCP control, and SPI will be ignored
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(TRUE) == SUCCESS);
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_npi ++;	/* add port number for new flow */

	/***************************************************************************
		Turn off weak TCP control again, and SPI will be checked
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(FALSE) == SUCCESS);
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN|TH_ACK), 1500, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_npi ++;	/* add port number for new flow */

	return SUCCESS;
}

/*
@func int32		| pkt_feature_weakTcpNaptCheck_2	| Forwarding engine TCP Napt stateless entry creation (weak NAPT) test 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the feature:
	For an unknown inbound TCP packet,
	if trigger port/upnp/dmz host is set
	forwarding engine create an established flow for it instead of
	trap it to procotol stack.
	(for server port, TCP state is useless and forwarding engine don't care it.)
 */
int32 pkt_feature_weakTcpNaptCheck_2(uint32 caseNo)
{
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP	- for DMZ/uPNP/trigger port, we send 4 different flows to test function:
			NPI	->	RP, ACK
			NPI	->	RP, SYN+ACK
			NPI	->	RP, FIN+ACK
			NPI	->	RP, FIN

		test for:
			tcp stateless connection creation
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	uint16 port_trigger, port_tmp;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	/*************************
		dmz host
	**************************/
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);
	/***************************************************************************
		Before turning on weak TCP control, so SPI must be checked
	***************************************************************************/
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	/***************************************************************************
		Turn on weak TCP control, and SPI will be ignored
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(TRUE) == SUCCESS);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */

	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	/***************************************************************************
		Turn off weak TCP control again, and SPI will be checked
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(FALSE) == SUCCESS);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	ASSERT(rtl8651_delDmzHost(ip_gw_ext) == SUCCESS);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	port_gw ++; port_npi ++;	/* add port number for new flow */
	/*************************
		upnp
	**************************/
	/***************************************************************************
		Before turning on weak TCP control, so SPI must be checked
	***************************************************************************/
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	/***************************************************************************
		Turn on weak TCP control, and SPI will be ignored
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(TRUE) == SUCCESS);
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_npi, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	/***************************************************************************
		Turn off weak TCP control again, and SPI will be checked
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(FALSE) == SUCCESS);
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	rtl8651_addUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_gw, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_delUpnpMap((UPNP_ONESHOT|UPNP_TCP), ip_rp, port_rp, ip_gw_ext, port_gw, ip_npi, port_npi);
	port_gw ++; port_npi ++;	/* add port number for new flow */
	/*************************
		trigger port
	**************************/
	/***************************************************************************
		Before turning on weak TCP control, so SPI must be checked
	***************************************************************************/
	port_tmp = port_npi + 500;
	port_trigger = 12345;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();

	/***************************************************************************
		Turn on weak TCP control, and SPI will be ignored
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(TRUE) == SUCCESS);
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_tmp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_tmp, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_tmp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* RP->NPI (after NAPT) */
		{
			uint16 tx_list[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
							ip_rp, ip_npi, 254, 0, 0,
							port_rp, port_tmp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	rtl8651_flushTriggerPortRules();
	/***************************************************************************
		Turn off weak TCP control again, and SPI will be checked
	***************************************************************************/
	ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(FALSE) == SUCCESS);
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();
	port_tmp += 100;
	port_trigger += 100;
	ASSERT(rtl8651_addTriggerPortRule(0, (port_tmp - 10), (port_tmp + 10), 0, (port_trigger - 10), (port_trigger + 10), 0) == SUCCESS);
	/* out bound packet to trigger the trigger port */
	{	/* NPI->RP */
		mbuf_in = confVlanHSB(NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_trigger, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_trigger, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);	
	}
	/* in bound packet to match trigger the trigger port */
	{	/* RP->NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 255, 0, 0,
						port_rp, port_tmp, (TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}
	rtl8651_flushTriggerPortRules();

	return SUCCESS;
}

/*
@func int32		| pkt_feature_weakTcpNaptCheckRandomTest_1	| Forwarding engine TCP Napt stateless entry creation (weak NAPT) random test 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the feature:
	For an unknown outbound TCP packet, forwarding engine create an established flow for it instead of
	trap it to procotol stack.
	-- Random generate packet and test napt function
 */
int32 pkt_feature_weakTcpNaptCheckRandomTest_1(uint32 caseNo)
{
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP
		NPI	->	RP, Random source

		test for:
			tcp stateless connection creation
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 1024;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	uint32 cnt;
	uint32 loop;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn off DOS */
	rtl8651a_setDosStatus(0, 0);

	srandom(time(NULL));

	for (loop = 1 ; loop < 10 ; loop ++)
	{
		/*************************************************************
			before enabling weak TCP, only SYN packt can pass NAPT checking
		*************************************************************/
		for (cnt = 1 ; cnt < 4096 ; cnt ++)
		{
			uint8 flag = random() % 128;		/* random generate */
			uint16 mss;
			uint16 mssout;
			int8 *data;
			uint32 dataLen;

			/* add port number for new flow */
			port_npi ++;
			if (!port_npi)
				port_npi = 1;

			if (flag & TH_SYN)
			{
				mss = (random() % 5000) + 1;
				mssout = MIN(1452, mss);
				data = NULL;
				dataLen = 0;
			}else
			{
				mss = 0;
				mssout = 0;
				data = pkt_content;
				dataLen = sizeof(pkt_content);
			}

			/* NPI -> RP */
			mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_rp, 255, 0, 0,
							port_npi, port_rp, flag, mss, 0, 0, data, dataLen);
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/*****************************
				only SYN packet is allowed
			*****************************/
			if (flag == TH_SYN)
			{
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
			}else
			{
				/* check result */
				VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 0);
				freeMbuf(mbuf_in);
				continue;
			}

			/**************** check output packet ****************/
			{
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
				/* NPI->RP (after NAPT) */
				{
					uint16 tx_list[2] = {0, 0xffff};	
					mbuf_comp = confPppoeHSA(NULL, NULL,
									_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
									ip_gw_ext, ip_rp, 254, 0, 0,
									port_gw, port_rp, flag, mssout, 0, 0, data, dataLen);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
			/**************** check if flow is create or not, send packet from RP ****************/
			{	/* RP->NPI */
				mbuf_in = confPppoeHSB(NULL, NULL,
								_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
								ip_rp, ip_gw_ext, 255, 0, 0,
								port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
				/* RP->NPI (after NAPT) */
				{
					uint16 tx_list[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA(NULL, NULL,
									_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
									ip_rp, ip_npi, 254, 0, 0,
									port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}

		/*
			all entries will time out
		*/
		_rtl8651_timeUpdate(defaultNaptLongTimeout);

		/*************************************************************
			enable weak TCP, all packts can pass NAPT checking
		*************************************************************/
		ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(TRUE) == SUCCESS);

		for (cnt = 1 ; cnt < 4096 ; cnt ++)
		{
			uint8 flag = random() % 128;		/* random generate */
			uint16 mss;
			uint16 mssout;
			int8 *data;
			uint32 dataLen;

			/* add port number for new flow */
			port_npi ++;
			if (!port_npi)
				port_npi = 1;

			if (flag & TH_SYN)
			{
				mss = (random() % 5000) + 1;
				mssout = MIN(1452, mss);
				data = NULL;
				dataLen = 0;
			}else
			{
				mss = 0;
				mssout = 0;
				data = pkt_content;
				dataLen = sizeof(pkt_content);
			}

			/* NPI -> RP */
			mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_rp, 255, 0, 0,
							port_npi, port_rp, flag, mss, 0, 0, data, dataLen);
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/*****************************
				all packets are allowed
			*****************************/
			/* check result */
			VALUE_CMP(retval, SUCCESS);
			/* check output packet */
			VALUE_CMP(mbufList_nmbuf(), 1);

			/**************** check output packet ****************/
			{
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
				/* NPI->RP (after NAPT) */
				{
					uint16 tx_list[2] = {0, 0xffff};	
					mbuf_comp = confPppoeHSA(NULL, NULL,
									_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
									ip_gw_ext, ip_rp, 254, 0, 0,
									port_gw, port_rp, flag, mssout, 0, 0, data, dataLen);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
			/**************** check if flow is create or not, send packet from RP ****************/
			{	/* RP->NPI */
				mbuf_in = confPppoeHSB(NULL, NULL,
								_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
								ip_rp, ip_gw_ext, 255, 0, 0,
								port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
				/* RP->NPI (after NAPT) */
				{
					uint16 tx_list[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA(NULL, NULL,
									_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
									ip_rp, ip_npi, 254, 0, 0,
									port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}

		/*
			all entries will time out
		*/
		_rtl8651_timeUpdate(defaultNaptLongTimeout);

		/*************************************************************
			disable weak TCP, only SYN packt can pass NAPT checking
		*************************************************************/
		ASSERT(rtl8651_fwdEngineWeakTcpNaptProcess(FALSE) == SUCCESS);
		for (cnt = 1 ; cnt < 4096 ; cnt ++)
		{
			uint8 flag = random() % 128;		/* random generate */
			uint16 mss;
			uint16 mssout;
			int8 *data;
			uint32 dataLen;

			/* add port number for new flow */
			port_npi ++;
			if (!port_npi)
				port_npi = 1;

			if (flag & TH_SYN)
			{
				mss = (random() % 5000) + 1;
				mssout = MIN(1452, mss);
				data = NULL;
				dataLen = 0;
			}else
			{
				mss = 0;
				mssout = 0;
				data = pkt_content;
				dataLen = sizeof(pkt_content);
			}

			/* NPI -> RP */
			mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_rp, 255, 0, 0,
							port_npi, port_rp, flag, mss, 0, 0, data, dataLen);
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/*****************************
				only SYN packet is allowed
			*****************************/
			if (flag == TH_SYN)
			{
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
			}else
			{
				/* check result */
				VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 0);
				freeMbuf(mbuf_in);
				continue;
			}

			/**************** check output packet ****************/
			{
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
				/* NPI->RP (after NAPT) */
				{
					uint16 tx_list[2] = {0, 0xffff};	
					mbuf_comp = confPppoeHSA(NULL, NULL,
									_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
									ip_gw_ext, ip_rp, 254, 0, 0,
									port_gw, port_rp, flag, mssout, 0, 0, data, dataLen);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
			/**************** check if flow is create or not, send packet from RP ****************/
			{	/* RP->NPI */
				mbuf_in = confPppoeHSB(NULL, NULL,
								_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
								ip_rp, ip_gw_ext, 255, 0, 0,
								port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				/* check output packet */
				VALUE_CMP(mbufList_nmbuf(), 1);
				/* RP->NPI (after NAPT) */
				{
					uint16 tx_list[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA(NULL, NULL,
									_PKT_TYPE_TCP, tx_list, 2, 0, mac_gw_int, mac_npi,
									ip_rp, ip_npi, 254, 0, 0,
									port_rp, port_npi, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}

		/*
			all entries will time out
		*/
		_rtl8651_timeUpdate(defaultNaptLongTimeout);
	}

	return SUCCESS;
}

#endif /* RTL_WEAK_NAPT_CTRL_TEST */

/*
@func int32		| blacklist_sip_1	| SIP blacking testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the blocking function when packet's (dmac==gateway mac) and (SIP is multicast IP)
 */
int32 pkt_BlackList_sip1(uint32 caseNo){
	/*
		dmac = gw mac
		sip in class D (multicast: 224.0.0.0)

		return FWDENG_IP_INVALID
	*/
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in;

	ipaddr_t ip_npi = ntohl(inet_addr("224.1.2.3"));
	ipaddr_t ip_rp = ntohl(inet_addr("224.2.3.4"));
	ipaddr_t ip_classD = ntohl(inet_addr("224.0.0.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();

	/***************
		TCP packet
	***************/
	{
			/*
				From RP
			*/
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0, ip_rp, ip_classD, 123, 0, 0,
				0x1234, 0x2345, TH_SYN, 1460, 0, 0, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
			/*
				From NPI
			*/
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_TCP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_classD, 123, 0, 0,
				0x1234, 0x2345, TH_SYN, 1460, 0, 0, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
	}
	/***************
		UDP packet
	***************/
	{
			/*
				From RP
			*/
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0, ip_rp, ip_classD, 123, 0, 0,
				0x1234, 0x2345, 0, 0, 0, 0, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
			/*
				From NPI
			*/
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_classD, 123, 0, 0,
				0x1234, 0x2345, 0, 0, 0, 0, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
	}
	/***************
		ICMP packet
	***************/
	{
			/*
				From RP
			*/
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_ICMP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0, ip_rp, ip_classD, 123, 0, 0,
				0, 0, 0, 0, ICMP_ECHO, 0xa, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
			/*
				From NPI
			*/
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_ICMP, 1, 2, 0, 
				mac_npi, mac_gw_int, ip_npi, ip_classD, 123, 0, 0,
				0, 0, 0, 0, ICMP_ECHO, 0xa, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
	}
	/***************
		IP packet
	***************/
	{
		uint16 ip_proto;
		/*
			From RP
		*/
		for (ip_proto = 0 ; ip_proto < 256 ; ip_proto ++)
		{
			/* input */
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IP;
			conf.l2Flag						= L2_PPPoE;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP);
			CP_MAC (mac_pppoe, conf.conf_smac);
			CP_MAC (mac_gw_ext, conf.conf_dmac);
			conf.pppoe.type					= 0x8864;
			conf.conf_sip						= ip_rp;
			conf.conf_dip						= ip_classD;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 234;
			conf.ip.protocol					= (uint8)ip_proto;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			SET_RX_PORT(conf.conf_portlist, 0);

			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
		}

		/*
			From NPI
		*/
		for (ip_proto = 0 ; ip_proto < 256 ; ip_proto ++)
		{
			/* input */
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IP;
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP);
			CP_MAC (mac_npi, conf.conf_smac);
			CP_MAC (mac_gw_int, conf.conf_dmac);
			conf.conf_sip						= ip_npi;
			conf.conf_dip						= ip_classD;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 234;
			conf.ip.protocol					= (uint8)ip_proto;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 2;
			SET_RX_PORT(conf.conf_portlist, 1);

			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_INVALID);
			freeMbuf(mbuf_in);
		}
	}
	return SUCCESS;
}

/*
@func Testing		| Acl-To CPU-1	| ACL-to-CPU testing 1
@rvalue SUCCESS	| 	test OK
@comm
Match ACL Rule and it's action is "to CPU", forwarding engine must trap this packet to protocol stack
 */
int32 pkt_acl_2cpu1(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in;
	rtl8651_tblDrvAclRule_t rule;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		From NPI
	*/
	{	// set ACL rule				------	TCP dst port
		bzero(&rule, sizeof(rtl8651_tblDrvAclRule_t));
		rule.ruleType_					= RTL8651_ACL_TCP;
		rule.srcIpAddr_				= 0;
		rule.srcIpAddrMask_			= 0;
		rule.dstIpAddr_				= 0;
		rule.dstIpAddrMask_			= 0;
		rule.tcpFlag_					= 0;
		rule.tcpFlagMask_				= 0;
		rule.tcpSrcPortLB_				= 0;
		rule.tcpSrcPortUB_				= 0xffff;
		rule.tcpDstPortLB_				= port_rp;
		rule.tcpDstPortUB_				= port_rp;
		rule.actionType_				= RTL8651_ACL_CPU;
	}
	ASSERT(rtl8651_addAclRule("lan", TRUE, &rule) == SUCCESS);
	{
		mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 123, 0, 0,
						port_npi, port_rp,
						TH_SYN, 1460,
						ICMP_ECHO, 1, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_ACL_IN_USERTRAP);
		freeMbuf(mbuf_in);
	}

	return SUCCESS;
}

/*
@func Testing		| Fragment Pkt-To CPU-1	| Fragment Pkt-to-CPU testing 1
@rvalue SUCCESS	| 	test OK
@comm
Fragment packet from Internal Host
When trapping fragment packet to CPU, pkts must be assembled in forwarding engine and split, sent in sequence to protocol stack, we test for functionality
 */
int32 pkt_frag_2cpu1(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		NPI	->	GW	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int sa[5], s;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
nextLoop:
	}

	// turn-off all dos check
	rtl8651a_setDosStatus(0, 0);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;
		int firstArrive;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop2;
				}
		}

		DEFAULT_IP_ID ++;
		firstArrive = FALSE;

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (firstArrive == FALSE)
			{
				if (pkt_no == 1)	// first packet
				{	// dequeue
					int min, m, idx;
					int cmp_no;

					firstArrive = TRUE;
					VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
					VALUE_CMP(mbufList_nmbuf(), 0);
					// check output
					VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
					// sort arrived packets number
					min = 0;
					for (s = 0 ; s < p ; s ++)
					{
						m = total_pkt + 1;
						for (idx = 0 ; idx < p ; idx ++)
						{
							if ((min < pa[idx]) && (pa[idx] < m))
								m = pa[idx];
								
						}
						min = m;
						sa[s] = min;
					}
					// compare packet
					for (idx = 0 ; idx < p ; idx ++)
					{
						int16 tx_port[2] = {1, 0xffff};
					
						cmp_no = sa[idx];

						FRAG_DEQUEUE(mbuf_out, mbuf_in);

						mbuf_comp = confVlanHSB( NULL, NULL,
							_PKT_TYPE_UDP, 1, 2, 0,
							mac_npi, mac_gw_int,
							ip_npi, ip_gw_int, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
							port_npi, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					}
				}else
				{	// queued
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 0);
				}
			}else
			{	// first packet arrived, pass-through it
				int16 tx_port[2] = {1, 0xffff};

				VALUE_CMP(retval, FAILED);
				VALUE_CMP(mbufList_nmbuf(), 0);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}

nextLoop2:
	}

	return SUCCESS;
}

/*
@func Testing		| Fragment Pkt-To CPU-2	| Fragment Pkt-to-CPU testing 2
@rvalue SUCCESS	| 	test OK
@comm
Fragment packet from Remote Host
When trapping fragment packet to CPU, pkts must be assembled in forwarding engine and split, sent in sequence to protocol stack, we test for functionality
 */
int32 pkt_frag_2cpu2(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		RP	->	GW	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int sa[5], s;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
		RP	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
nextLoop:
	}

	// turn-off all dos check
	rtl8651a_setDosStatus(0, 0);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;
		int firstArrive;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop2;
				}
		}

		DEFAULT_IP_ID ++;
		firstArrive = FALSE;

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (firstArrive == FALSE)
			{
				if (pkt_no == 1)	// first packet
				{	// dequeue
					int min, m, idx;
					int cmp_no;

					firstArrive = TRUE;
					VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
					VALUE_CMP(mbufList_nmbuf(), 0);
					// check output
					VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
					// sort arrived packets number
					min = 0;
					for (s = 0 ; s < p ; s ++)
					{
						m = total_pkt + 1;
						for (idx = 0 ; idx < p ; idx ++)
						{
							if ((min < pa[idx]) && (pa[idx] < m))
								m = pa[idx];
								
						}
						min = m;
						sa[s] = min;
					}
					// compare packet
					for (idx = 0 ; idx < p ; idx ++)
					{
						int16 tx_port[2] = {1, 0xffff};
					
						cmp_no = sa[idx];

						FRAG_DEQUEUE(mbuf_out, mbuf_in);

						mbuf_comp = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_UDP, 0, 1, 0,
							mac_pppoe, mac_gw_ext, 0,
							ip_rp, ip_gw_ext, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					}
				}else
				{	// queued
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 0);
				}
			}else
			{	// first packet arrived, pass-through it
				int16 tx_port[2] = {1, 0xffff};

				VALUE_CMP(retval, FWDENG_IP_CANTFRAG);
				VALUE_CMP(mbufList_nmbuf(), 0);

				mbuf_comp = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}

nextLoop2:
	}

	
	return SUCCESS;
}


/*
@func Testing		| Fragment Stress-1	| Fragment system stress testing 1
@rvalue SUCCESS	| 	test OK
@comm
Fragment system stress test : drop a packet and deny it when that packet is too long then system setting
 */
int32 ipFrag_stress_1(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan

		UDP
		NPI	->	GW	in-order
		NPI	->	GW	out-of-order
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int flow_no, total_flow;
	int pkt_no, total_pkt = 5;
	uint16 udp_payload = 1448;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// Turn off dos check
	rtl8651a_setDosStatus(0, FALSE);


	total_flow = RTL8651_DefaultDrvMaxFragPktCnt + RTL8651_DefaultDrvMaxNegativeListCnt;

	// for all flows , they put no.1 ~ no. (total -1) packets into system
	for (flow_no = 1 ; flow_no <= total_flow ; flow_no ++)
	{

		DEFAULT_IP_ID = flow_no;

		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(mbufList_nmbuf(), 0);
			if (pkt_no == 1)
			{
				VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
				VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), 1);
				FRAG_DEQUEUE(mbuf_out, mbuf_in);
			}else
			{
				VALUE_CMP(retval, FAILED);
				mbuf_out = mbuf_in;
			}

			// out put will be in-order
			{
				int16 tx_port[2] = {1, 0xffff};
		
				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
		}
	}

	/*
		NPI	->	GW

		Out-of-order
		Let ipQueue System overflow, so the last 10 flows are dropped
	*/
	// for all flows , they put no.2 ~ no. (total) packets into system
	for (flow_no = 1 ; flow_no <= total_flow ; flow_no ++)
	{

		DEFAULT_IP_ID = flow_no | 0xf000;

		for (pkt_no = 2 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}

	for (flow_no = 1 ; flow_no <= total_flow; flow_no ++)
	{
		pkt_no = 1;

		DEFAULT_IP_ID = flow_no | 0xf000;
		
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
			port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(mbufList_nmbuf(), 0);

		if (flow_no <= RTL8651_DefaultDrvMaxFragPktCnt)
		{
			VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);

			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);
				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
		}else
		{	// all packet is dropped in fwdengine
			VALUE_CMP(retval, SUCCESS);
		}
	}
	return SUCCESS;
}

/*
@func Testing		| Fragment Stress-2	| Fragment system stress testing 2
@rvalue SUCCESS	| 	test OK
@comm
Fragment system stress test : enable/disable fragment system dynamically
 */
int32 ipFrag_stress_2(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan

		UDP
		NPI	->	GW	in-order
		NPI	->	GW	out-of-order
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no, total_pkt = RTL8651_DefaultDrvMaxFragSubPktCnt;
	uint16 udp_payload = 1448;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();


	// Only turn on teardrop test for fragment packet queue
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	// Enable IP Fragment packet
	rtl8651_fwdEngineProcessIPFragment(TRUE);

	/*
		NPI	->	RP
		First flow: Fragment packet process OK
	*/
	{
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?RTL8651_DefaultDrvMaxFragSubPktCnt:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
			ASSERT(mbuf_out == NULL);
		}
	}

	DEFAULT_IP_ID ++;
	
	/*
		Second flow: send first packet, success
	*/
	{
		pkt_no = total_pkt;
		mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	// Enable IP Fragment packet again, queued packet is still available
	rtl8651_fwdEngineProcessIPFragment(TRUE);
	/*
		Second flow: send remaining packets, success
	*/
	{
		for (pkt_no = (total_pkt-1) ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?RTL8651_DefaultDrvMaxFragSubPktCnt:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}

	DEFAULT_IP_ID ++;
	
	/*
		Third flow: send first packet, success
	*/
	{
		pkt_no = total_pkt;
		mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	// disable IP Fragment packet, IP-Queue system is reset and queued packet is dropped
	rtl8651_fwdEngineProcessIPFragment(FALSE);
	/*
		Third flow: send remaining packets, all packets will be drop (drop case is set) and trapped to protocol stack
	*/
	{
		int32 flag = TRUE;

		// drop
		rtl8651_fwdEngineDropPktCase(FWDENG_IP_CANTFRAG, &flag);

		for (pkt_no = (total_pkt-1) ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}

		// trap to protocol stack
		flag = FALSE;
		rtl8651_fwdEngineDropPktCase(FWDENG_IP_CANTFRAG, &flag);

		for (pkt_no = (total_pkt-1) ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, FWDENG_IP_CANTFRAG);
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}
	}
	// enable IP Fragment packet, IP-Queue system is reset
	rtl8651_fwdEngineProcessIPFragment(TRUE);
	/*
		Third flow: send remaining packets, after re-enable IP-Queue system, these packets will be queued
	*/
	{
		for (pkt_no = (total_pkt) ; pkt_no > 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	/*
		Third flow: re-send first packet, this flow is de-queued and sent now
	*/
	{
		pkt_no = 1;
		mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), RTL8651_DefaultDrvMaxFragSubPktCnt);
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}
	return SUCCESS;
}

/*
@func Testing		| Udp blocking test1	| Test function of NAPT large fragment packets block
@rvalue SUCCESS	| 	test OK
@comm
For UDP NAPT outbound/inbound fragment packet, if it total size is larger than user desire, forwarding engine can block it.
 */
int32 pkt_udp_blocking1(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		UDP
		NPI	->	RP
		RP	->	NPI

		fast path and slow path
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no;
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	uint32 totalAllowPkt = 3;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		Must disable DOS - disable UDP Bomb check
	*/
	rtl8651a_setDosStatus(0, 0);

	/*
		turn on udp blocking check,
		but allow ip payload size > {per arrival packet size},
		all packets can pass
	*/
	rtl8651a_setUdpSizeThreshValue(0, (udp_payload + 20) * (MAX(totalAllowPkt, total_pkt) + 1));

	/*
		NPI	->	RP
	*/
	{
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}
	/*
		NPI	->	RP, out-of-order
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}
	{
		/*
			NPI	->	RP, out-of-order 2
		*/
		{
			int i;
			int list[5] = {1, 3, 5, 2, 4};
			DEFAULT_IP_ID ++;
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				pkt_no = list[i - 1];
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
			}
			// Output
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				// get external port
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				// for next packet
				}
			}
		}
	}
	/*
		RP	->	NPI
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
		}
		// Output
		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_rp, ip_npi, 122, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	/*
		RP	->	NPI, out-of-order
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
		}
		// Output
		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_rp, ip_npi, 122, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
	}
	{
		/*
			RP	->	NPI, out-of-order 2
		*/
		{
			int i;
			int list[5] = {2, 4, 5, 1, 3};
			DEFAULT_IP_ID ++;
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				pkt_no = list[i - 1];
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 15, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
			}
			// Output
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						ip_rp, ip_npi, 14, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
	}

	/*
		turn on udp blocking check,
		and the allow ip payload size > {per arrival packets' size},
		all are blocked
	*/
	totalAllowPkt = total_pkt - 1;
	rtl8651a_setUdpSizeThreshValue(0, (udp_payload + 20) * totalAllowPkt);

	/*
		NPI	->	RP	: blocked
	*/
	{
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	/*
		NPI	->	RP, out-of-order	: blocked
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	{
		/*
			NPI	->	RP, out-of-order 2	: blocked
		*/
		{
			int i;
			int list[5] = {1, 3, 5, 2, 4};
			DEFAULT_IP_ID ++;
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				pkt_no = list[i - 1];
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
		}
	}
	/*
		RP	->	NPI	: blocked
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	/*
		RP	->	NPI, out-of-order	: blocked
	*/
	{
		DEFAULT_IP_ID ++;
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	{
		/*
			RP	->	NPI, out-of-order 2	: blocked
		*/
		{
			int i;
			int list[5] = {2, 4, 5, 1, 3};
			DEFAULT_IP_ID ++;
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				pkt_no = list[i - 1];
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 15, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
		}
	}
	/*
		Start mass tests,
		dynamically adjust packet size (adjust total_pkt) and block size (adjust totalAllowPkt)
		and test function
	*/
	for (total_pkt = 2 ; total_pkt <= 10 ; total_pkt ++)
	{
		int32 max_totalAllowPkt = (0xffff /(udp_payload + 20));
	
		for (totalAllowPkt = 0; totalAllowPkt < max_totalAllowPkt ; totalAllowPkt ++)
		{
			rtl8651a_setUdpSizeThreshValue(0, (udp_payload + 20) * totalAllowPkt);
			/*
				NPI	->	RP
			*/
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					if (totalAllowPkt >= total_pkt)
					{	// pass
						VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
					}else
					{	// blocked
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}
				// for packet passed, check it output
				if (totalAllowPkt >= total_pkt)
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
					mbuf_out = mbufList_dequeue();
					// get external port
					ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {0, 0xffff};
						mbuf_comp = confPppoeHSA( NULL, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						mbuf_out = mbufList_dequeue();				// for next packet
					}
				}
			}
			/*
				NPI	->	RP, out-of-order
			*/
			{
				DEFAULT_IP_ID ++;
				for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
				{
					mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					if (totalAllowPkt >= total_pkt)
					{	// pass
						VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
					}else
					{	// blocked
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}
				// for packet passed, check it output
				if (totalAllowPkt >= total_pkt)
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
					mbuf_out = mbufList_dequeue();
					// get external port
					ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {0, 0xffff};
						mbuf_comp = confPppoeHSA( NULL, NULL,
							_PKT_TYPE_UDP, tx_port, 1, 0,
							mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							port_gw, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						mbuf_out = mbufList_dequeue();				// for next packet
					}
				}
			}
			/*
				RP	->	NPI
			*/
			{
				DEFAULT_IP_ID ++;
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					if (totalAllowPkt >= total_pkt)
					{	// pass
						VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
					}else
					{	// blocked
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}
				// for packet passed, check it output
				if (totalAllowPkt >= total_pkt)
				{
					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {1, 0xffff};

						mbuf_comp = confVlanHSA( NULL, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
					}
				}
			}
			/*
				RP	->	NPI, out-of-order
			*/
			{
				DEFAULT_IP_ID ++;
				for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
				{
					mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 0,
						ip_rp, ip_gw_ext, 123, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					if (totalAllowPkt >= total_pkt)
					{	// pass
						VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
					}else
					{	// blocked
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}
				// Output
				// for packet passed, check it output
				if (totalAllowPkt >= total_pkt)
				{
					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {1, 0xffff};

						mbuf_comp = confVlanHSA( NULL, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							port_rp, port_npi, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
					}
				}
			}
		}
	}
	return SUCCESS;
}

/*
@func Testing		| Udp blocking test2	| Test function of large fragment packets to CPU block
@rvalue SUCCESS	| 	test OK
@comm
For UDP fragment packet to CPU, if it total size is larger than user desire, forwarding engine can block it.
 */
int32 pkt_udp_blocking2(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		NPI	->	GW	out-of-order (indiscriminate)
		RP	->	GW	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int totalAllowPkt;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		Must disable DOS - disable UDP Bomb check
	*/
	rtl8651a_setDosStatus(0, 0);

	/*
		NPI	->	GW
	*/
	for (totalAllowPkt = 0; totalAllowPkt < (0xffff /(udp_payload + 20)) ; totalAllowPkt ++)
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop1;
				}
		}
		/*
			turn on udp blocking check,
		*/
		rtl8651a_setUdpSizeThreshValue(0, (udp_payload + 20) * totalAllowPkt);

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(mbufList_nmbuf(), 0);
			if (totalAllowPkt >= total_pkt)
			{	// trap
				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			}else
			{	// block
				VALUE_CMP(retval, SUCCESS);
			}
		}
		// check output for trapped packets
		if (totalAllowPkt >= total_pkt)
		{
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
		}
nextLoop1:
	}

	/*
		RP	->	GW
	*/
	for (totalAllowPkt = 0; totalAllowPkt < (0xffff /(udp_payload + 20)) ; totalAllowPkt ++)	
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop2;
				}
		}
		/*
			turn on udp blocking check,
		*/
		rtl8651a_setUdpSizeThreshValue(0, (udp_payload + 20) * totalAllowPkt);

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(mbufList_nmbuf(), 0);
			if (totalAllowPkt >= total_pkt)
			{	// trap
				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			}else
			{	// block
				VALUE_CMP(retval, SUCCESS);
			}
		}
		// check output for trapped packets
		if (totalAllowPkt >= total_pkt)
		{
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
		}
nextLoop2:
	}
	
	return SUCCESS;
}

/*
@func Testing		| Udp zero Checksum	| Special case: udp with zero checksum, we must ignore checksum issue
@rvalue SUCCESS	| 	test OK
@comm
Udp packet switching test : check the checksum process for udp packets with zero checksum
 */
int32 pkt_udp_zeroCksum(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp, *mbuf_out;
	/**********************************************
		1 wan(pppoe), 2 lan

		UDP
		NPI	->	NPI2		routing
		NPI	->	NPI2		routing, frag
		NPI	->	RP		napt
		NPI	->	RP		napt, frag
		RP	->	NPI		napt-r
		RP	->	NPI		napt-r, frag
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	uint16 port_rp = 0x5678;
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no, total_pkt = RTL8651_DefaultDrvMaxFragSubPktCnt;
	uint16 udp_payload = 1448;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// Turn off dos check
	rtl8651a_setDosStatus(0, FALSE);

	/*
		NPI	->	NPI2
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
			_PKT_TYPE_UDP, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 122, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	mbuf_out = mbufList_dequeue();
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	NPI2, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
			_PKT_TYPE_UDP, tx_list, 3, 0,
			mac_gw_int2, mac_npi2,
			ip_npi, ip_npi2, 122, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	mbuf_out = mbufList_dequeue();
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	RP
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	RP, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 1, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 1, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 1, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 1, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);


	/*
		Port bouncing test
	*/
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2) == SUCCESS);
	/*
		NPI	->	ServerPort
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);
	/*
		NPI	->	ServerPort, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 1, 0,
			port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);
	/*
		ServerPort	->	NPI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 0, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 0, 0,
			port_gw, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);
	/*
		ServerPort	->	NPI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 1, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 1, 0,
			port_gw, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2) == SUCCESS);


	ASSERT(rtl8651_delNaptMapping(ip_gw_ext) == SUCCESS);
	/****************************************
		NAT
	*****************************************/
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_npi) == SUCCESS);	//add nat mapping
	/*
		NI	->	RP
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	RP, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 1, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 1, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 1, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 1, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/****************************************
		NAT Portbouncing
	*****************************************/
	_rtl8651_flushPortBouncingEntry();
	/*
		NPI2		->	NI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 0, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 0, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI2	->	NI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 1, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 1, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NI	->	NPI2
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NI	->	NPI2, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		/*
			set udp checksum to zero
		*/
		VALUE_CMP(clr_checksum(mbuf_in, TEST_CSUM_L4), SUCCESS);
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		VALUE_CMP(clr_checksum(mbuf_comp, TEST_CSUM_L4), SUCCESS);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	return SUCCESS;
}


/*
@func Testing		| Udp Checksum calculation	| check udp checksum calculation
@rvalue SUCCESS	| 	test OK
@comm
Udp checksum  : check the checksum process for udp packets
 */
int32 pkt_udp_cksum(uint32 caseNo){
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp, *mbuf_out;
	/**********************************************
		1 wan(pppoe), 2 lan

		calculate udp checksum if ip-option is added and ip header length is not 20 byte

		UDP
		NPI	->	NPI2		routing
		NPI	->	NPI2		routing, frag
		NPI	->	RP		napt
		NPI	->	RP		napt, frag
		RP	->	NPI		napt-r
		RP	->	NPI		napt-r, frag
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	uint16 port_rp = 0x5678;
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no, total_pkt = RTL8651_DefaultDrvMaxFragSubPktCnt;
	uint16 udp_payload = 1448;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// Turn off dos check
	rtl8651a_setDosStatus(0, FALSE);

	/*
		NPI	->	NPI2
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 122, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	mbuf_out = mbufList_dequeue();
	CKSUM_CMP(mbuf_comp, mbuf_out, (TEST_CSUM_L4|TEST_CSUM_IP));
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	NPI2, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 3, 0,
			mac_gw_int2, mac_npi2,
			ip_npi, ip_npi2, 122, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	mbuf_out = mbufList_dequeue();
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	RP
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	RP, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 1, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 1, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 1, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
 	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 1, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		Port bouncing test
	*/
	ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2) == SUCCESS);
	/*
		NPI	->	ServerPort
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);
	/*
		NPI	->	ServerPort, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 1, 0,
			port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);
	/*
		ServerPort	->	NPI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 0, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 0, 0,
			port_gw, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);
	/*
		ServerPort	->	NPI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 1, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 1, 0,
			port_gw, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, port_gw, ip_npi2, port_npi2) == SUCCESS);

	ASSERT(rtl8651_delNaptMapping(ip_gw_ext) == SUCCESS);
	/****************************************
		NAT
	*****************************************/
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_npi) == SUCCESS);	//add nat mapping
	/*
		NI	->	RP
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI	->	RP, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 1, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 1, 0,
			mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 122, 1, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		RP	->	NPI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 1, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 1, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/****************************************
		NAT Portbouncing
	*****************************************/
	_rtl8651_flushPortBouncingEntry();
	/*
		NPI2		->	NI
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 0, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 0, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NPI2	->	NI, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_gw_ext, 123, 1, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 2, 0,
			mac_gw_int, mac_npi, ip_gw_ext, ip_npi, 122, 1, 0,
			port_npi2, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NI	->	NPI2
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	/*
		NI	->	NPI2, fragment
	*/
	{
		/*
			generate pkt
		*/
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP_OPTION, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_gw_ext, 123, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_list[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
			_PKT_TYPE_UDP_OPTION, tx_list, 3, 0,
			mac_gw_int2, mac_npi2, ip_gw_ext, ip_npi2, 122, 1, 0,
			port_npi, port_npi2, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4|CSUM_IP);
		mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
	}
	CKSUM_CMP(mbuf_comp, mbuf_out, TEST_CSUM_L4|TEST_CSUM_IP);
	MBUF_CMPandFREE(mbuf_comp, mbuf_out);

	return SUCCESS;
}

/*
@func Testing		| dos ICMP Fragment test 1	| Test DOS system correctness when processing ICMP fragment packets
@rvalue SUCCESS	| 	test OK
@comm
Test if DOS system can process ICMP fragment packet correctly or not.
 */
int32 pkt_dos_IcmpFragment1(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		RP	-> GW
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint32 nCount;
	uint16 id = 1;
	uint16 id_ext;
	uint32 pkt_no;
	uint32 total_pkt = 5;
	uint32 icmp_payload = sizeof(pkt_content);

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	/*
		Turn-on all DOS check
	*/
	rtl8651a_setDosStatus(0, 0xffffffff);


	{
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_ICMP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
				0, 0, 0, 0, ICMP_ECHO, id, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
		}
		// Output
		{
			VALUE_CMP(mbufList_nmbuf(), total_pkt);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &id_ext)==SUCCESS);

			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
					_PKT_TYPE_ICMP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 10, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, ICMP_ECHO, id_ext, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				mbuf_out = mbufList_dequeue();				// for next packet
			}
		}
	}
	return SUCCESS;
}

/*
@func Testing		| pkt_PacketBouncing_1	| Packet bouncing test
@rvalue SUCCESS	| 	test OK
@comm
Test and make sure packets which don't need to do layer2 broadcast will not be sent by forwarding engine
 */
int32 pkt_PacketBouncing_1(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		NAPT test

		1 wan(vlan), 1 lan

		UDP Multicast

		RP	->	GW	: drop

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_multicast = ntohl(inet_addr("234.1.2.3"));
	uint16 port_multicast = 0x1111;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ether_addr_t mac_multicast = {{0x01, 0x00, 0x5e, 0x01, 0x02, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	ether_addr_t mac_rp2 = {{0x01, 0x01, 0x01, 0x01, 0x01, 0x01}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		turn Multicast process OFF, multicast packet will be layer2-broadcasted and trapped to protocol stack
	*/
	ASSERT(rtl8651_fwdEngineProcessIPMulticast(FALSE) == SUCCESS);

	/*
		UDP Multicast
			RP -> GW
	*/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 5, 4, 0,
			mac_rp2, mac_multicast,
			ip_rp2, ip_multicast, 123, 0, 0,
			port_rp, port_multicast, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_IP_MULTICAST);	// packet still been trapped to protocol stack
			VALUE_CMP(mbufList_nmbuf(), 0);			// but it don't do any layer2 forwarding
			freeMbuf(mbuf_in);
	}

	return SUCCESS;
}

/*
@func Testing		| SPI test-1	| test SPI function
@rvalue SUCCESS	| 	test OK
@comm
Packet from Remote Host with Destination IP is internal IP will be blocked by SPI system
 */
int32 pkt_SPI_1(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		RP	->	NPI	: trapped and don't send it

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		turn-OFF dos to purify the testing environment
	*/
	rtl8651a_setDosStatus(0, 0);

	/*
		RP -> NPI	UDP
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_npi, 123, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_DECISION_DROP);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		RP -> NPI	TCP
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_npi, 123, 0, 0,
			port_rp, port_npi, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_DECISION_DROP);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	/*
		RP -> NPI	ICMP
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_npi, 123, 0, 0,
			port_rp, port_npi, 0, 0, ICMP_ECHO, 123, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_DECISION_DROP);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	return SUCCESS;
}

/*
@func Testing		| SPI test-2	| test SPI function
@rvalue SUCCESS	| 	test OK
@comm
SPI system must forbid the TCP piggyback SYN packet
 */
int32 pkt_SPI_2(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		NPI -> RP, SYN		: forward
		RP -> NPI, SYN		: forbid
		RP -> NPI, SYN+ACK	: forward
		NPI -> RP, ACK		: forward
		RP -> NPI, SYN		: forbid

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*
		NPI -> RP, SYN		: forward
	*/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 1);
		/* get external port */
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL) == SUCCESS);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	/*
		RP -> NPI, SYN		: forbid
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);		
	}
	/*
		RP -> NPI, SYN+ACK	: forward
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};

			mbuf_comp = confVlanHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI -> RP, ACK		: forward
	*/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		RP -> NPI, SYN		: forbid
	*/
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);		
	}

	return SUCCESS;
}

/*
@func Testing		| SPI test-2	| test SPI function
@rvalue SUCCESS	| 	test OK
@comm
SPI system must forbid the TCP piggyback SYN packet
 */
int32 pkt_ttlCheck1(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		NAPT test

		1 wan(pppoe), 1 lan

		TCP
			NPI -> RP	(SYN)	ttl = 1
			NPI -> RP	(SYN)	ttl = 0
			NPI -> RP	(SYN)
			RP -> NPI	(SYN|ACK)	ttl = 1
			RP -> NPI	(SYN|ACK)	ttl = 0
			RP -> NPI	(SYN|ACK)
			NPI -> RP	(ACK)	ttl = 1
			NPI -> RP	(ACK)	ttl = 0
			NPI -> RP	(ACK)
			RP -> NPI	(ACK)	ttl = 1
			RP -> NPI	(ACK)	ttl = 0
			RP -> NPI	(ACK)

		UDP
			NPI -> RP
			RP -> NPI
			NPI -> RP	ttl = 1
			RP -> NPI	ttl = 0
			NPI -> RP	ttl = 1
			RP -> NPI	ttl = 0

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	uint32 idx;
	uint32 testCnt = 3;
	uint8 ttl[3] = {123, 1, 123};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// disable icmp-ttl exceed message sending
	ASSERT(rtl8651_fwdEngineIcmpRoutingMsg(FALSE) == SUCCESS);

	/*
		TCP test
	*/
	/*
		NPI -> RP, SYN
	*/
	for (idx = 0 ; idx < testCnt ; idx ++)
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, ttl[idx], 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		if (ttl[idx] < 2)
		{
			VALUE_CMP(retval, FWDENG_IP_TTLEXCEED);
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else
		{
			VALUE_CMP(retval, SUCCESS);

			/* check output */
			VALUE_CMP(mbufList_nmbuf(), 1);
			/* get external port */
			mbuf_out = mbufList_dequeue();
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL) == SUCCESS);
			{
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(NULL, NULL,
					_PKT_TYPE_TCP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, (ttl[idx] - 1), 0, 0,
					port_gw, port_rp, TH_SYN, 1452, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
	}
	/*
		RP -> NPI, SYN+ACK
	*/
	for (idx = 0 ; idx < testCnt ; idx ++)
	{
		mbuf_in = confPppoeHSB(NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, ttl[idx], 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		if (ttl[idx] < 2)
		{
			VALUE_CMP(retval, FWDENG_IP_TTLEXCEED);
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else
		{
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};

				mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_TCP, tx_port, 2, 0,
					mac_gw_int, mac_npi,
					ip_rp, ip_npi, (ttl[idx] - 1), 0, 0,
					port_rp, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	/*
		NPI -> RP, ACK		: forward
	*/
	for (idx = 0 ; idx < testCnt ; idx ++)
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, ttl[idx], 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		if (ttl[idx] < 2)
		{
			VALUE_CMP(retval, FWDENG_IP_TTLEXCEED);
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else
		{
			VALUE_CMP(retval, SUCCESS);

			/* check output */
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(NULL, NULL,
					_PKT_TYPE_TCP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, (ttl[idx] - 1), 0, 0,
					port_gw, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}

	/*
		UDP test
	*/
	for (idx = 0 ; idx < testCnt ; idx ++)
	{
		/*
			NPI -> RP
		*/
		{
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, ttl[idx], 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (ttl[idx] < 2)
			{
				VALUE_CMP(retval, FWDENG_IP_TTLEXCEED);
				VALUE_CMP(mbufList_nmbuf(), 0);
				freeMbuf(mbuf_in);
			}else
			{
				VALUE_CMP(retval, SUCCESS);

				/* check output */
				VALUE_CMP(mbufList_nmbuf(), 1);
				/* get external port */
				mbuf_out = mbufList_dequeue();
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL) == SUCCESS);
				{
					uint16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA(NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, (ttl[idx] - 1), 0, 0,
						port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
		}
		/*
			RP -> NPI
		*/
		for (idx = 0 ; idx < testCnt ; idx ++)
		{
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, ttl[idx], 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (ttl[idx] < 2)
			{
				VALUE_CMP(retval, FWDENG_IP_TTLEXCEED);
				VALUE_CMP(mbufList_nmbuf(), 0);
				freeMbuf(mbuf_in);
			}else
			{
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				{
					uint16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA(NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						ip_rp, ip_npi, (ttl[idx] - 1), 0, 0,
						port_rp, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}	
	}

	return SUCCESS;
}

/*
@func Testing		| Protocol Stack QoS Send-1	| Protocol Stack packet TX with QoS test 1
@rvalue SUCCESS	| 	test OK
@comm
if If high priority is chosen when upper-protocol-stack TX,
the HW High priority queue must be used.
 */
int32 pkt_protocolStackFlow_QosSend_1(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		1 wan(pppoe), 1 lan

		TCP	- call rtl8651_fwdEngineSend
		TCP	- call rtl8651_fwdEngineQosSend with low priority selection
		TCP	- call rtl8651_fwdEngineQosSend with high priority selection
		UDP	- call rtl8651_fwdEngineSend
		UDP	- call rtl8651_fwdEngineQosSend with low priority selection
		UDP	- call rtl8651_fwdEngineQosSend with high priority selection

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint32 loop;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);
	/*add dmz host */
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/***********************************************
		TCP test
	***********************************************/

	/*
		1. call rtl8651_fwdEngineSend()

			- low priority
	*/
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*
		2. call rtl8651_fwdEngineQosSend() with Low priority queue selection

			- low priority
	*/
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), FALSE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), FALSE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), FALSE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), FALSE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*
		3. call rtl8651_fwdEngineQosSend() with High priority queue selection

			- high priority
	*/
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), TRUE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= PKTHDR_HPRIORITY;
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), TRUE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= PKTHDR_HPRIORITY;
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), TRUE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= PKTHDR_HPRIORITY;
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), TRUE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= PKTHDR_HPRIORITY;
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/***********************************************
		UDP test
	***********************************************/
	/*
		1. call rtl8651_fwdEngineSend()

			- low priority
	*/
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	/*
		2. call rtl8651_fwdEngineQosSend() with Low priority queue selection

			- low priority
	*/
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), FALSE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	/*
		3. call rtl8651_fwdEngineQosSend() with High priority queue selection

			- high priority
	*/
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_QOS_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8), TRUE);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= PKTHDR_HPRIORITY;
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	return SUCCESS;
}

/*
@func Testing		| Protocol Stack PortList determination-1	| Protocol Stack packet TX, test for port list determination.
@rvalue SUCCESS	| 	test OK
@comm
Forwarding engine need to determine the port list of TX packets.
Check its correctness for UNICAST packet forwarding. (including unknown unicast broadcasting)
 */
int32 pkt_protocolStackFlow_portListDetermination_1(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		1 wan(pppoe), 1 lan

		L2 unicast packet	- call rtl8651_fwdEngineSend
						- learnt by ROMEDRV before, so L2 lookup OK and would forward to dport

		L2 unicast packet	- call rtl8651_fwdEngineSend
						- never learnt by ROMEDRV before, so L2 lookup falied and do L2 broadcasting.

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint32 loop;
	ether_addr_t mac_smac = mac_gw_int;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);

	/* ==============================================
		1. Known UNICAST, send to TX Port
	     ============================================== */
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(mac_smac.octet[6], 1, 1, 254);
	
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_smac,				conf.conf_smac);		/* we don't check source MAC, it would be changed corresponding to loop count */
		CP_MAC (mac_npi,				conf.conf_dmac);
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= -1;				/* this would be assigned by FWDENG because MAC need to use it */
		mbuf_in							= genMbufPkt(&conf);

		/* Let FWDENG to determine the TX port list */
		mbuf_in->m_pkthdr->ph_portlist		= 0;

		GW_PORTMASK_OUTPUT(retval, mbuf_in->m_pkthdr, 2, -1);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_vlanIdx = 2;
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 1);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/* ==============================================
		2. UnKnown UNICAST, Broadcasting
	     ============================================== */
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(mac_smac.octet[6], 1, 1, 254);
	
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_smac,				conf.conf_smac);		/* we don't check source MAC, it would be changed corresponding to loop count */
		CP_MAC (mac_npi2,				conf.conf_dmac);
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= -1;				/* this would be assigned by FWDENG because MAC need to use it */
		mbuf_in							= genMbufPkt(&conf);

		/* Let FWDENG to determine the TX port list */
		mbuf_in->m_pkthdr->ph_portlist		= 0;

		GW_PORTMASK_OUTPUT(retval, mbuf_in->m_pkthdr, 2, -1);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_vlanIdx = 2;
		/* all member ports of VLAN 2: 1, 2, 3 */
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}


	/* ==============================================
		3. the UnKnown UNICAST learnt by ARP addition, start unicast
	     ============================================== */

	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 2) == SUCCESS);

	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(mac_smac.octet[6], 1, 1, 254);
	
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_smac,				conf.conf_smac);		/* we don't check source MAC, it would be changed corresponding to loop count */
		CP_MAC (mac_npi2,				conf.conf_dmac);
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= -1;				/* this would be assigned by FWDENG because MAC need to use it */
		mbuf_in							= genMbufPkt(&conf);

		/* Let FWDENG to determine the TX port list */
		mbuf_in->m_pkthdr->ph_portlist		= 0;

		GW_PORTMASK_OUTPUT(retval, mbuf_in->m_pkthdr, 2, -1);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_vlanIdx = 2;
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 2);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/* ==============================================
		4. L2 entry of DMAC is removed, Protocol Stack Tx becomes
		   broadcast back.
	     ============================================== */

	ASSERT(rtl8651_delArp(ip_npi2) == SUCCESS);

	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(mac_smac.octet[6], 1, 1, 254);
	
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_smac,				conf.conf_smac);		/* we don't check source MAC, it would be changed corresponding to loop count */
		CP_MAC (mac_npi2,				conf.conf_dmac);
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= -1;				/* this would be assigned by FWDENG because MAC need to use it */
		mbuf_in							= genMbufPkt(&conf);

		/* Let FWDENG to determine the TX port list */
		mbuf_in->m_pkthdr->ph_portlist		= 0;

		GW_PORTMASK_OUTPUT(retval, mbuf_in->m_pkthdr, 2, -1);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_vlanIdx = 2;
		/* all member ports of VLAN 2: 1, 2, 3 */
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

/*
@func Testing		| Protocol Stack PortList determination-2	| Protocol Stack packet TX, test for port list determination.
@rvalue SUCCESS	| 	test OK
@comm
Forwarding engine need to determine the port list of TX packets.
Check its correctness for BROADCAST packet forwarding. (including MULTICAST L2 broadcasting)
 */
int32 pkt_protocolStackFlow_portListDetermination_2(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		1 wan(pppoe), 1 lan

		L2 unicast packet	- call rtl8651_fwdEngineSend
						- learnt by ROMEDRV before, so L2 lookup OK and would forward to dport

		L2 unicast packet	- call rtl8651_fwdEngineSend
						- never learnt by ROMEDRV before, so L2 lookup falied and do L2 broadcasting.

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	ether_addr_t mac_mcast = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x01}};

	uint32 loop;
	ether_addr_t mac_smac = mac_gw_int;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);

	/* ==============================================
		1. Broadcast DMAC, do L2 broadcasting
	     ============================================== */
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(mac_smac.octet[6], 1, 1, 254);
	
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_smac,				conf.conf_smac);		/* we don't check source MAC, it would be changed corresponding to loop count */
		CP_MAC (mac_bcast,				conf.conf_dmac);
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= -1;				/* this would be assigned by FWDENG because MAC need to use it */
		mbuf_in							= genMbufPkt(&conf);

		/* Let FWDENG to determine the TX port list */
		mbuf_in->m_pkthdr->ph_portlist		= 0;

		GW_PORTMASK_OUTPUT(retval, mbuf_in->m_pkthdr, 2, -1);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_vlanIdx = 2;
		/* all member ports of VLAN 2: 1, 2, 3 */
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}


	/* ==============================================
		2. Multicast DMAC, do L2 broadcasting
	     ============================================== */
	for (loop = 0 ; loop < 100 ; loop ++)
	{
		BOUND_INCREASE(mac_smac.octet[6], 1, 1, 254);
		BOUND_INCREASE(mac_mcast.octet[6], 1, 1, 254);
	
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_smac,				conf.conf_smac);		/* we don't check source MAC, it would be changed corresponding to loop count */
		CP_MAC (mac_mcast,				conf.conf_dmac);
		conf.payload.content				= pkt_content;
		conf.payload.length				= sizeof(pkt_content);
		conf.conf_vlanIdx					= -1;				/* this would be assigned by FWDENG because MAC need to use it */
		mbuf_in							= genMbufPkt(&conf);

		/* Let FWDENG to determine the TX port list */
		mbuf_in->m_pkthdr->ph_portlist		= 0;

		GW_PORTMASK_OUTPUT(retval, mbuf_in->m_pkthdr, 2, -1);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_vlanIdx = 2;
		/* all member ports of VLAN 2: 1, 2, 3 */
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

 
#ifdef CONFIG_RTL865X_MULTICAST
/*
@func Testing		| Multicast IGMP-1	| Multicast system testing for IGMP basic functions
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : basic function, test for IGMPv2 join/leave/timeout and data forwarding
 */
int32 pkt_multicast_igmp1(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/**********************************************
		Set upstream to wan

		test for:
			Receiving Leave message: send Query and Expire
			Receiving Report message: send Query and receive Query

			Group1			Group2
			Upstream1		Upstream2
			(vlan1 port0)		(vlan4 port5)
		---------------------------------
		H1(1)	H2(1)	|	             H3(4)
			vlan2					vlan3
	  	G1	      G1				      G1 G2		<= join group
		1            2					3    4		<= join sequence
		1		1					2    3		<= leave sequence
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.2.254"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_upstream1 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x01}}; 
	ether_addr_t mac_upstream2 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x02}}; 
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	int32 cnt;
	const int32 LoopCnt = 100;
	int32 CurrentTime;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);

	ASSERT(rtl8651_addArp(ip_npi1, &mac_npi1, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi3, &mac_npi3, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addArp(upstream2, &mac_upstream2, "wan2", 5) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	/*
		IGMP V2 Leave from npi1 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi1, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi1;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_LEAVE;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 2;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		/*
			Query
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 2;
		ADD_TX_PORT(conf.conf_portlist, 1);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	// after RTL8651_IGMP_LMQI, gateway send Query
	for (cnt = 0 ; cnt < (RTL8651_IGMP_LMQC_TEST - 1) ; cnt ++)
	{
		mbufList_Reinit();
		_rtl8651_timeUpdate(RTL8651_IGMP_LMQI_TEST);
		{	// query
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 2;
			ADD_TX_PORT(conf.conf_portlist, 1);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	mbufList_Reinit();
	_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);
	
	{	// report TO_IN to upstream
		{	// group report
			grCfg.type = IGMP_MODE_TOIN;
			grCfg.gaddr = mcast_1;
			grCfg.auxlen = 0;
			grCfg.nofs = 0;
			grCfg.slist = NULL;
			grCfg.auxdata = NULL;
		}

		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		CP_MAC (mac_pppoe, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= mcast_V3rpt;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 3;
		conf.igmp.type					= IGMP_V3_REPORT;
		conf.igmp.rnofg					= 1;
		conf.igmp.grCfg					= &grCfg;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);

		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	mbufList_Reinit();
	{
		// Entry is expired : Don't send any message anymore
		_rtl8651_timeUpdate(2000);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}

	/*
			Join
	*/

	/*
		IGMP V2 Report from npi1 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi1, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi1;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_REPORT;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 2;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		/*
			Report to upstream
		*/
		// Report
		{
			{	// group report
				grCfg.type = IGMP_MODE_ISEX;
				grCfg.gaddr = mcast_1;
				grCfg.auxlen = 0;
				grCfg.nofs = 0;
				grCfg.slist = NULL;
				grCfg.auxdata = NULL;
			}

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_ext, conf.conf_smac);
			CP_MAC (mac_pppoe, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext;
			conf.conf_dip						= mcast_V3rpt;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 3;
			conf.igmp.type					= IGMP_V3_REPORT;
			conf.igmp.rnofg					= 1;
			conf.igmp.grCfg					= &grCfg;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	// Delay for 1 sec
	_rtl8651_timeUpdate(1);

	/*
		IGMP V2 Report from npi2 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi2, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi2;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_REPORT;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 2;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);

		/*
			Report to upstream: IGMPv3 (allow{} and block{} -> don't send it)
		*/
		// Report
		if (0)
		{
			{	// group report
				grCfg.type = IGMP_MODE_ISEX;
				grCfg.gaddr = mcast_1;
				grCfg.auxlen = 0;
				grCfg.nofs = 0;
				grCfg.slist = NULL;
				grCfg.auxdata = NULL;
			}

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_ext, conf.conf_smac);
			CP_MAC (mac_pppoe, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext;
			conf.conf_dip						= mcast_V3rpt;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 3;
			conf.igmp.type					= IGMP_V3_REPORT;
			conf.igmp.rnofg					= 1;
			conf.igmp.grCfg					= &grCfg;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	// Delay for 1 sec
	mbufList_Reinit();
	_rtl8651_timeUpdate(1);

	/*
		IGMP V2 Report from npi3 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi3, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi3;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0x11;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_REPORT;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 3;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 4);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);

		/*
			Report to upstream: IGMPv3 (allow{} and block{} -> don't send it)
		*/
		// Report
		if (0)
		{
			{	// group report
				grCfg.type = IGMP_MODE_ISEX;
				grCfg.gaddr = mcast_1;
				grCfg.auxlen = 0;
				grCfg.nofs = 0;
				grCfg.slist = NULL;
				grCfg.auxdata = NULL;
			}

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_ext, conf.conf_smac);
			CP_MAC (mac_pppoe, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext;
			conf.conf_dip						= mcast_V3rpt;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 3;
			conf.igmp.type					= IGMP_V3_REPORT;
			conf.igmp.rnofg					= 1;
			conf.igmp.grCfg					= &grCfg;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	// Delay for 1 sec
	mbufList_Reinit();
	_rtl8651_timeUpdate(1);

	/*
		IGMP V2 Report from npi3 for multicast group 2
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi3, conf.conf_smac);
		CP_MAC (mac_mcast_2, conf.conf_dmac);
		conf.conf_sip						= ip_npi3;
		conf.conf_dip						= mcast_2;
		conf.ip.id							= 0x11;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_REPORT;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_2;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 3;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 4);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		/*
			Report to upstream
		*/
		// Report
		{
			{	// group report
				grCfg.type = IGMP_MODE_ISEX;
				grCfg.gaddr = mcast_2;
				grCfg.auxlen = 0;
				grCfg.nofs = 0;
				grCfg.slist = NULL;
				grCfg.auxdata = NULL;
			}

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_ext, conf.conf_smac);
			CP_MAC (mac_pppoe, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext;
			conf.conf_dip						= mcast_V3rpt;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 3;
			conf.igmp.type					= IGMP_V3_REPORT;
			conf.igmp.rnofg					= 1;
			conf.igmp.grCfg					= &grCfg;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	// each RTL8651_IGMP_QI, gateway send Query and want to receive Report
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbufList_Reinit();
		_rtl8651_timeUpdate(RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST - 2);
		{	// query
			// Query of (Group 1) for (port 1)
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 2;
			ADD_TX_PORT(conf.conf_portlist, 1);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			// Send Report back
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_npi1, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_npi1;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= 1;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 2;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 1);
			mbuf_in = genMbufPkt(&conf);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);

			VALUE_CMP(mbufList_nmbuf(), 0);	// Report to upstream: ALLOW/BLOCK {NONE} -> don't send it
			//freeMbuf(mbufList_dequeue());	retval = SID; //increase SID
		}
			mbufList_Reinit();
			_rtl8651_timeUpdate(1);
		{	// query
			// Query of (Group 1) for (port 4)
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int2, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int2;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			ADD_TX_PORT(conf.conf_portlist, 4);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			// Send Report back
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_npi3, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_npi3;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= 1;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 4);
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);	// Report to upstream: ALLOW/BLOCK {NONE} -> don't send it
			//freeMbuf(mbufList_dequeue());	retval = SID; //increase SID
		}
			mbufList_Reinit();
			_rtl8651_timeUpdate(1);
		{	// query
			// Query of (Group 2) for (port 4)
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int2, conf.conf_smac);
			CP_MAC (mac_mcast_2, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int2;
			conf.conf_dip						= mcast_2;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			ADD_TX_PORT(conf.conf_portlist, 4);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			// Send Report back
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_npi3, conf.conf_smac);
			CP_MAC (mac_mcast_2, conf.conf_dmac);
			conf.conf_sip						= ip_npi3;
			conf.conf_dip						= mcast_2;
			conf.ip.id							= 1;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 4);
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);	// Report to upstream: ALLOW/BLOCK {NONE} -> don't send it
			//freeMbuf(mbufList_dequeue());	retval = SID; //increase SID
		}
	}
	// Upstream Response
	/*
		Group 1 upstream	=> default upstream : vlan1 port 0 (pppoe)
		Group 2 upstream	=> vlan 4 port 5
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		/*
			Group 1 upstream send Query
		*/
		{
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;
			conf.l2Flag						|= L2_PPPoE;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_pppoe, conf.conf_smac);
			CP_MAC (mac_gw_ext, conf.conf_dmac);
			conf.pppoe.type					= 0x8864;
			conf.conf_sip						= upstream1;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 10;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 0);
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			// Gateway Send Report
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					= (PKTHDR_PPPOE_AUTOADD);
			CP_MAC (mac_gw_ext, conf.conf_smac);
			CP_MAC (mac_pppoe, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			Group 2 upstream send Query
		*/
		{
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_upstream2, conf.conf_smac);
			CP_MAC (mac_mcast_2, conf.conf_dmac);
			conf.conf_sip						= upstream2;
			conf.conf_dip						= mcast_2;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 10;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 4;
			SET_RX_PORT(conf.conf_portlist, 5);
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			// Gateway Send Report
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					= 0;
			CP_MAC (mac_gw_ext2, conf.conf_smac);
			CP_MAC (mac_mcast_2, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext2;
			conf.conf_dip						= mcast_2;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 4;
			ADD_TX_PORT(conf.conf_portlist, 5);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}


		// each RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, gateway send Query and want to receive Report
		// because Upstream is set, Gateway Will not generate Report when receiving downstream Report
		{
			mbufList_Reinit();
			_rtl8651_timeUpdate(RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST - 2);
			{	// query
				// Query of (Group 1) for (port 1)
				VALUE_CMP(mbufList_nmbuf(), 1);

				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
				CP_MAC (mac_gw_int, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_gw_int;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= SID;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_QUERY;
				conf.igmp.respTime				= 100;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 2;
				ADD_TX_PORT(conf.conf_portlist, 1);
				mbuf_comp = genMbufPkt(&conf);
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				// Send Report back
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
				CP_MAC (mac_npi1, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_npi1;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= 1;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_V2_REPORT;
				conf.igmp.respTime				= 0;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 2;
				conf.conf_pppoeIdx				= 0;
				SET_RX_PORT(conf.conf_portlist, 1);
				mbuf_in = genMbufPkt(&conf);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
				mbufList_Reinit();
				_rtl8651_timeUpdate(1);
			{	// query
				// Query of (Group 1) for (port 4)
				VALUE_CMP(mbufList_nmbuf(), 1);

				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
				CP_MAC (mac_gw_int2, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_gw_int2;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= SID;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_QUERY;
				conf.igmp.respTime				= 100;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 3;
				ADD_TX_PORT(conf.conf_portlist, 4);
				mbuf_comp = genMbufPkt(&conf);
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				// Send Report back
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
				CP_MAC (mac_npi3, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_npi3;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= 1;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_V2_REPORT;
				conf.igmp.respTime				= 0;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 3;
				conf.conf_pppoeIdx				= 0;
				SET_RX_PORT(conf.conf_portlist, 4);
				mbuf_in = genMbufPkt(&conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
				mbufList_Reinit();
				_rtl8651_timeUpdate(1);
			{	// query
				// Query of (Group 2) for (port 4)
				VALUE_CMP(mbufList_nmbuf(), 1);

				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
				CP_MAC (mac_gw_int2, conf.conf_smac);
				CP_MAC (mac_mcast_2, conf.conf_dmac);
				conf.conf_sip						= ip_gw_int2;
				conf.conf_dip						= mcast_2;
				conf.ip.id							= SID;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_QUERY;
				conf.igmp.respTime				= 100;
				conf.igmp.gaddr					= mcast_2;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 3;
				ADD_TX_PORT(conf.conf_portlist, 4);
				mbuf_comp = genMbufPkt(&conf);
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				// Send Report back
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
				CP_MAC (mac_npi3, conf.conf_smac);
				CP_MAC (mac_mcast_2, conf.conf_dmac);
				conf.conf_sip						= ip_npi3;
				conf.conf_dip						= mcast_2;
				conf.ip.id							= 1;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_V2_REPORT;
				conf.igmp.respTime				= 0;
				conf.igmp.gaddr					= mcast_2;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 3;
				conf.conf_pppoeIdx				= 0;
				SET_RX_PORT(conf.conf_portlist, 4);
				mbuf_in = genMbufPkt(&conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
		}
	}

	/*
			Send udp multicast packet
	*/
	/*
		Group 1: Sent from Upstream1 -> to (vlan 2, port 1) (vlan 3, port 4)
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_mcast_1,
				upstream1, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_mcast_1,
				upstream1, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 1: Sent from Upstream2 -> to (vlan 2, port 1) (vlan 3, port 4)
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 5, 4, 0, mac_upstream2, mac_gw_ext2,
					upstream2, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_mcast_1,
				upstream2, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_mcast_1,
				upstream2, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/*
		Group 2: Sent from Upstream2 -> to (vlan 3, port 4)
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 5, 4, 0, mac_upstream2, mac_mcast_2,
					upstream2, mcast_2, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_mcast_2,
				upstream2, mcast_2, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 1: Sent from npi1 -> to (vlan 3, port 4)
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi1, mac_mcast_1,
					ip_npi1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_mcast_1,
				ip_npi1, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 2: Sent from npi3 -> sent to Upstream2
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 4, 3, 0, mac_npi3, mac_mcast_2,
					ip_npi3, mcast_2, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {5, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 4, 0,
				mac_gw_ext2, mac_mcast_2,
				ip_gw_ext2, mcast_2, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 3: Sent from npi1 -> sent to default upstream
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi1, mac_mcast_3,
					ip_npi1, mcast_3, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, mcast_3, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
			Leave
	*/
	// each RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, gateway send Query and want to receive Report (because Port 1 leave, port1 don't send report)
	{
		mbufList_Reinit();
		_rtl8651_timeUpdate(RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST - 2);
		{	// query
			// Query of (Group 1) for (port 1)	==> we don't response
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 2;
			ADD_TX_PORT(conf.conf_portlist, 1);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
			mbufList_Reinit();
			_rtl8651_timeUpdate(1);
		{	// query
			// Query of (Group 1) for (port 4)	=> response
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int2, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int2;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			ADD_TX_PORT(conf.conf_portlist, 4);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			// Send Report back
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_npi3, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_npi3;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= 1;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 4);
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
			mbufList_Reinit();
			_rtl8651_timeUpdate(1);
		{	// query
			// Query of (Group 2) for (port 4)	=> response
			CurrentTime = _sysUpSeconds;			// store Current Time for expire
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int2, conf.conf_smac);
			CP_MAC (mac_mcast_2, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int2;
			conf.conf_dip						= mcast_2;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			ADD_TX_PORT(conf.conf_portlist, 4);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			// Send Report back
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_npi3, conf.conf_smac);
			CP_MAC (mac_mcast_2, conf.conf_dmac);
			conf.conf_sip						= ip_npi3;
			conf.conf_dip						= mcast_2;
			conf.ip.id							= 1;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_REPORT;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_2;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 4);
			mbuf_in = genMbufPkt(&conf);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST - 1);
	for (cnt = 0 ; cnt < RTL8651_IGMP_LMQC_TEST ; cnt ++)
	{
		VALUE_CMP(mbufList_nmbuf(), 1);
		/*
			Query
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= RTL8651_IGMP_QRI_TEST*10;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 2;
		ADD_TX_PORT(conf.conf_portlist, 1);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

		mbufList_Reinit();
		if (cnt < (RTL8651_IGMP_LMQC_TEST - 1))
		_rtl8651_timeUpdate(RTL8651_IGMP_LMQI_TEST);
	}

	mbufList_Reinit();
	_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);

	// Port 1 of Group 1 is removed

	/*
		Group 1: Sent from Upstream1 -> to (vlan 3, port 4)
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 3, 0,
				mac_gw_int2, mac_mcast_1,
				upstream1, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		IGMP V2 Leave from npi3 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi3, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi3;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_LEAVE;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 3;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 4);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		/*
			Query
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int2;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 3;
		ADD_TX_PORT(conf.conf_portlist, 4);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	// after RTL8651_IGMP_LMQI, gateway send Query
	for (cnt = 0 ; cnt < (RTL8651_IGMP_LMQC_TEST - 1) ; cnt ++)
	{
		mbufList_Reinit();
		_rtl8651_timeUpdate(RTL8651_IGMP_LMQI_TEST);
		{	// query
			VALUE_CMP(mbufList_nmbuf(), 1);

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_int2, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_gw_int2;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_QUERY;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 3;
			ADD_TX_PORT(conf.conf_portlist, 4);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());			
		}
	}
	mbufList_Reinit();
	_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);

	// send Group 1 Leave to Upstream
	{
		VALUE_CMP(mbufList_nmbuf(), 1);
		// Leave
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= (PKTHDR_PPPOE_AUTOADD);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		CP_MAC (mac_pppoe, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= IGMP_ALL_ROUTER;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_LEAVE;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 1: Sent from npi1 -> sent to default upstream
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi1, mac_mcast_1,
					ip_npi1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	{
		// Query of (Group 2) for (port 4)
		mbufList_Reinit();
		_rtl8651_timeUpdate(CurrentTime + RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST - _sysUpSeconds);

		VALUE_CMP(mbufList_nmbuf(), 1);

		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_mcast_2, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int2;
		conf.conf_dip						= mcast_2;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= mcast_2;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 3;
		ADD_TX_PORT(conf.conf_portlist, 4);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 2 expire
	*/
	mbufList_Reinit();
	_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);
	for (cnt = 0 ; cnt < RTL8651_IGMP_LMQC_TEST ; cnt ++)
	{
		VALUE_CMP(mbufList_nmbuf(), 1);
		/*
			Query
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_mcast_2, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int2;
		conf.conf_dip						= mcast_2;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= RTL8651_IGMP_QRI_TEST*10;
		conf.igmp.gaddr					= mcast_2;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 3;
		ADD_TX_PORT(conf.conf_portlist, 4);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

		mbufList_Reinit();
		if (cnt < (RTL8651_IGMP_LMQC_TEST - 1))
		_rtl8651_timeUpdate(RTL8651_IGMP_LMQI_TEST);
	}
	_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST+RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);
	/*
		Group Destroyed
	*/
	// send Group 2 Leave to Upstream
	{
		VALUE_CMP(mbufList_nmbuf(), 1);
		// Leave
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					= 0;
		CP_MAC (mac_gw_ext2, conf.conf_smac);
		CP_MAC (mac_mcast_2, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext2;
		conf.conf_dip						= IGMP_ALL_ROUTER;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_LEAVE;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_2;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 4;
		ADD_TX_PORT(conf.conf_portlist, 5);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	
	/*
		Group 1: Sent from npi3 -> sent to default upstream
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 4, 3, 0, mac_npi3, mac_mcast_1,
					ip_npi3, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, mcast_1, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	/*
		Group 2: Sent from npi1 -> sent to default upstream
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi1, mac_mcast_2,
					ip_npi1, mcast_2, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, mcast_2, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}
	/*
		Group 3: Sent from npi1 -> sent to default upstream
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi1, mac_mcast_3,
					ip_npi1, mcast_3, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, mcast_3, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	mbufList_Reinit();
	{
		// Entry is expired : Don't send any message anymore
		_rtl8651_timeUpdate(2000);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}

	return SUCCESS;
}

static int32 inline pkt_env1_multicast_igmp2_broadcast(uint16* current_id)
{
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	
	/*
		Config Environments
	*/
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_all_hosts = IGMP_ALL_HOSTS;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_all_hosts = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x01}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	uint16 system_id = *current_id;
	#define SID system_id
	bzero(pkt_content, sizeof(pkt_content));

	{
		/*
			General Query
		*/
		#if 0
		VALUE_CMP(mbufList_nmbuf(), 3);
		#else
		VALUE_CMP(mbufList_nmbuf(), 2);
		#endif
		/*
			Vlan 2
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int, conf.conf_smac);
		CP_MAC (mac_all_hosts, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int;
		conf.conf_dip						= ip_all_hosts;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 3;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= 0;
		conf.igmp.qrsq					= 0x01;
		conf.igmp.qqic						= RTL8651_IGMP_QI_TEST;
		conf.igmp.qnofs					= 0;
		conf.igmp.qslist					= NULL;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 2;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		/*
			Vlan 3
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_int2, conf.conf_smac);
		CP_MAC (mac_all_hosts, conf.conf_dmac);
		conf.conf_sip						= ip_gw_int2;
		conf.conf_dip						= ip_all_hosts;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 3;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= 0;
		conf.igmp.qrsq					= 0x01;
		conf.igmp.qqic						= RTL8651_IGMP_QI_TEST;
		conf.igmp.qnofs					= 0;
		conf.igmp.qslist					= NULL;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 3;
		ADD_TX_PORT(conf.conf_portlist, 4);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		#if 0	// don't broadcast to external vlan
		/*
			Vlan 4
		*/
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_ext2, conf.conf_smac);
		CP_MAC (mac_all_hosts, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext2;
		conf.conf_dip						= ip_all_hosts;
		conf.ip.id							= SID;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 3;
		conf.igmp.type					= IGMP_QUERY;
		conf.igmp.respTime				= 100;
		conf.igmp.gaddr					= 0;
		conf.igmp.qrsq					= 0x01;
		conf.igmp.qqic						= RTL8651_IGMP_QI_TEST;
		conf.igmp.qnofs					= 0;
		conf.igmp.qslist					= NULL;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;
		conf.conf_vlanIdx					= 4;
		ADD_TX_PORT(conf.conf_portlist, 5);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		#endif
	}
	mbufList_Reinit();

	*current_id = system_id;
	return SUCCESS;
}
/*
@func Testing		| Multicast IGMP-2	| Multicast system testing for IGMP basic functions
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : basic function, test for periodic general-query broadcast
 */
int32 pkt_multicast_igmp2(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;

	/**********************************************
		NAPT test

		1 wan(pppoe), 2 lans

		Set upstream to wan

		test for:
			Receiving Leave message: send Query and Expire
			Receiving Report message: send Query and receive Query
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_all_hosts = IGMP_ALL_HOSTS;
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_all_hosts = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x01}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	int32 cnt;
	const int32 LoopCnt = 1000;
	uint16 system_id = 1;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);
	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI_TEST;
		para.igmp_sqc				= RTL8651_IGMP_SQC_TEST;
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(TRUE);
		mbufList_Reinit();	// when we call rtl8651_multicastPeriodicQuery(TRUE), system query all internal ports immediately
		rtl8651_multicastReinit();
	}

	// Startup delay
	_rtl8651_timeUpdate(RTL8651_IGMP_STARTUP_QUERY_DELAY);
	for (cnt = 0 ; cnt < RTL8651_IGMP_SQC_TEST; cnt ++)
	{
		// Startup Broadcast
		VALUE_CMP(pkt_env1_multicast_igmp2_broadcast(&system_id), SUCCESS);
		if (cnt < (RTL8651_IGMP_SQC_TEST))
			_rtl8651_timeUpdate(RTL8651_IGMP_SQI_TEST);
	}

	// Perioidc delay
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		_rtl8651_timeUpdate(RTL8651_IGMP_QI_TEST);
		VALUE_CMP(pkt_env1_multicast_igmp2_broadcast(&system_id), SUCCESS);
	}
	// We turn off Periodic Query
	_rtl8651_timeUpdate(RTL8651_IGMP_QI_TEST - 1);	// before next periodic Query
	rtl8651_multicastPeriodicQuery(FALSE);

	_rtl8651_timeUpdate(2000);
	VALUE_CMP(mbufList_nmbuf(), 0);

	// turn on Periodic Query
	rtl8651_multicastPeriodicQuery(TRUE);
	mbufList_Reinit();	// when we call rtl8651_multicastPeriodicQuery(TRUE), system query all internal ports immediately

	// Periodic Query
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		_rtl8651_timeUpdate(RTL8651_IGMP_QI_TEST);
		VALUE_CMP(pkt_env1_multicast_igmp2_broadcast(&system_id), SUCCESS);
	}

	// Periodic Query, when reset Query switch, we reinit timer
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		_rtl8651_timeUpdate(min(RTL8651_IGMP_QI_TEST, cnt));
		rtl8651_multicastPeriodicQuery(TRUE);
		if (min(RTL8651_IGMP_QI_TEST, cnt) < RTL8651_IGMP_QI_TEST)
		{
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		_rtl8651_timeUpdate(RTL8651_IGMP_QI_TEST - min(RTL8651_IGMP_QI_TEST, cnt));
		VALUE_CMP(pkt_env1_multicast_igmp2_broadcast(&system_id), SUCCESS);
	}
	
	return SUCCESS;
}

struct multicast_host
{
	ipaddr_t			addr;
	ether_addr_t		mac;
	uint16			port;
	uint8			vlanIdx;
	uint8			vers;
	uint8			filterMode;
	host_SourceList_t *slist;
	uint32			slistCnt;
};
/*
	Input : Current slist, all source can be choosed

		this function choose new source list and remove old source list randomly, set new source list to "slist"
		allocate Memory and fill the value of Grouptype/sendSlist/sendSlistCnt for host to generate report
*/
int32 pkt_genNewSlist(uint8 forceInClude, host_SourceList_t **slist, uint32 *slistCnt, uint8 * filterMode, ipaddr_t *sPoolp, int32 sPoolCnt,
	uint8* Grouptype1, ipaddr_t **sendSlist1, uint32 * sendSlistCnt1,
	uint8* Grouptype2, ipaddr_t **sendSlist2, uint32 * sendSlistCnt2)
{
	int i, die, a, b;
	ipaddr_t ip[MAX_SLISTCNT];
	uint8 map[MAX_SLISTCNT];
	uint8 newFilterMode;
	int ipCnt;
	ipaddr_t *ipp;
	host_SourceList_t *sp;

	if (!slist || !slistCnt || !filterMode || !sPoolp || !sPoolCnt || !Grouptype1 || !sendSlist1 || !sendSlistCnt1 ||
		!Grouptype2 || !sendSlist2 || !sendSlistCnt2)
		return FAILED;

	// init
	for (i = 0 ; i < MAX_SLISTCNT ; i ++)
	{
		ip[i] = 0;
		map[i] = 0;
	}
	newFilterMode = IGMP_FILTER_NONE;
	ipCnt = 0;

	// decide new ipCnt
	ipCnt = (random() % ((sPoolCnt > MAX_SLISTCNT)?MAX_SLISTCNT:sPoolCnt));

	// get new ip list
	for (i = 0 ; i < ipCnt ; i ++)
	{
		do {
			die = (random() % sPoolCnt);
		} while (map[die] != 0);
		map[die] = 1;
		ip[i] = sPoolp[die];
	}

	// decide new filterMode
	if (forceInClude == TRUE)
		newFilterMode = IGMP_FILTER_INCLUDE;
	else
	{
		if (random() % 2)
			newFilterMode = IGMP_FILTER_EXCLUDE;
		else
			newFilterMode = IGMP_FILTER_INCLUDE;
	}

	if (*filterMode == IGMP_FILTER_NONE)
	{
		*Grouptype1 = (newFilterMode == IGMP_FILTER_EXCLUDE)?IGMP_MODE_ISEX:IGMP_MODE_ISIN;
		*sendSlist1 = (ipaddr_t*)malloc(sizeof(ipaddr_t)*ipCnt);
		ipp = *sendSlist1;
		for (i = 0 ; i < ipCnt ; i ++, ipp ++)
			*ipp = ip[i];
		*sendSlistCnt1 = ipCnt;
		*Grouptype2 = 0;
		*sendSlist2 = NULL;
		*sendSlistCnt2 = 0;
	}else if (*filterMode != newFilterMode)
	{
TO:
		*Grouptype1 = (newFilterMode == IGMP_FILTER_EXCLUDE)?IGMP_MODE_TOEX:IGMP_MODE_TOIN;
		*sendSlist1 = (ipaddr_t*)malloc(sizeof(ipaddr_t)*ipCnt);
		ipp = *sendSlist1;
		for (i = 0 ; i < ipCnt ; i ++, ipp ++)
			*ipp = ip[i];
		*sendSlistCnt1 = ipCnt;
		*Grouptype2 = 0;
		*sendSlist2 = NULL;
		*sendSlistCnt2 = 0;
	}else
	{
		// calculate how many ip in Current List
		a = 0;
		for (i = 0 ; i < ipCnt ; i ++)
		{
			if (host_find_src(*slist, ip[i]))
				a ++;
		}
		
		if (a == 0 || a == ipCnt)
			goto TO;
		// block / allow
		*Grouptype1 = (newFilterMode == IGMP_FILTER_EXCLUDE)?IGMP_MODE_ALLOW:IGMP_MODE_BLOCK;
		// old list - {a}
		*sendSlist1 = (ipaddr_t*)malloc(sizeof(ipaddr_t)*(*slistCnt - a));
		ipp = *sendSlist1;
		sp = *slist;
		while (sp)
		{
			for (i = 0 ; i < ipCnt ; i ++)
			{
				if (sp->addr == ip[i])
					goto next_sp;
			}
			*ipp = sp->addr;
			ipp ++;
		next_sp:
			sp = sp->next;
		}
		*sendSlistCnt1 = (*slistCnt - a);
		// new list - {a}
		*Grouptype2 = (newFilterMode == IGMP_FILTER_EXCLUDE)?IGMP_MODE_BLOCK:IGMP_MODE_ALLOW;
		*sendSlist2 = (ipaddr_t*)malloc(sizeof(ipaddr_t)*(ipCnt - a));
		ipp = *sendSlist2;
		for (i = 0 ; i < ipCnt ; i ++)
		{
			if (!host_find_src(*slist, ip[i]))
			{
				*ipp = ip[i];
				ipp ++;
			}
		}
		*sendSlistCnt2 = (ipCnt - a);
	}

	// update source list and filter mode
	host_del_all(slist);
	for (i = 0 ; i < ipCnt ; i ++)
	{
		host_add_src(slist, ip[i]);
	}
	*slistCnt = ipCnt;
	*filterMode = newFilterMode;

	return SUCCESS;
}
/*
	Function pkt_multicast_igmp3 test util

		send Multicast packet from upstream and check downstream
*/
int32 pkt_sendMulticastAndCheckRscv(struct multicast_host* host, int32 hostCnt, ipaddr_t* upStream, int32 upStreamCnt)
{
	rtl8651_PktConf_t conf;
	struct rtl_mBuf *mbuf_in, *mbuf_comp, *mbuf_out[RTL8651_VLAN_NUMBER];
	int8 pkt_content[1000];
	int32 retval;
	int32 pktCnt;
	int i, j, k, cnt;
	int dataLen, ttl;
	uint16 sp, dp;
	uint16 vlanPortIdx[RTL8651_VLAN_NUMBER] = {0};

	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));

	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};

//	MCast_DumpMCast();

	// We generate multicast packet with sip is each upStream, and expect what port will recv this packet
	for (cnt = 0 ; cnt < upStreamCnt ; cnt ++)
	{
		dataLen = (random() % sizeof(pkt_content)) + 1;
		ttl = (random() % 128) + 2;
		sp = (random() % 65535) + 1;
		dp = (random() % 65535) + 1;
	
		// generate multicast packet
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
						upStream[cnt], mcast_1, ttl, 0, 0,
						sp, dp, 0, 0, 0, 0, pkt_content, dataLen);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
		}

		// init
		bzero(vlanPortIdx, sizeof(vlanPortIdx));
		bzero(mbuf_out, sizeof(mbuf_out));

		// get output information
		pktCnt = mbufList_nmbuf();
		for (i = 0 ; i < pktCnt ; i ++)
		{
			mbuf_out[i] = mbufList_dequeue();
		}

		// for each hosts which want to recv packet from this upstream, gateway MUST forward it to them
		for (i = 0 ; i < hostCnt ; i ++)
		{
			if (((host[i].filterMode == IGMP_FILTER_INCLUDE) && (host_find_src(host[i].slist, upStream[cnt]))) ||
				((host[i].filterMode == IGMP_FILTER_EXCLUDE) && (!host_find_src(host[i].slist, upStream[cnt]))))	// this host want to receive this packet
			{
				// set vlan Port Idx
				vlanPortIdx[host[i].vlanIdx] |= (1 << host[i].port);
				// check all mbufs, check if there is any packet sent to itself
				k = 0;
				for (j = 0 ; j < pktCnt ; j ++)
				{
					if ((mbuf_out[j]->m_pkthdr->ph_vlanIdx == host[i].vlanIdx) &&
						(mbuf_out[j]->m_pkthdr->ph_portlist & (1<<host[i].port)))
						k ++;
				}
				if (k != 1)	// no packet sent to that port OR too many packet sent to that port
				{
					MCast_DumpMCast();
					printf("ERROR: host[%d][port %d] want to get packet from %s and %d pkts sent to it!!\n", i, host[i].port, inet_ntoa(upStream[cnt]), k);
					return FAILED;
				}
			}
		}

		if (pktCnt == 0)
		{	// check if there is no any host want to receive this packet
			for (i = 0 ; i < RTL8651_VLAN_NUMBER ; i ++)
			{
				if (vlanPortIdx[i])
				{
					MCast_DumpMCast();
					printf("for %s, some hosts in Vlan [%d] want to get pkt from this, but gateway don't forward it!\n", inet_ntoa(upStream[cnt]), i);
					return FAILED;
				}
			}
		}

		// don't care port / vlan of each packet, check the content of them
		for (i = 0 ; i < pktCnt ; i ++)
		{
			uint16 ptr;
			uint16 tx_port[17];
			uint16 portList = mbuf_out[i]->m_pkthdr->ph_portlist;
			uint16 vlanIdx = mbuf_out[i]->m_pkthdr->ph_vlanIdx;

			for (j = 0 ; j < 17 ; j ++)
				tx_port[j] = 0xffff;

			// trace all ports to get port list
			ptr = 0;
			for (j = 0 ; j < 16 ; j ++)
			{
				if (portList & (1<<j))
				{
					tx_port[ptr] = j;
					ptr ++;
				}
			}

			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, vlanIdx, 0,
				mac_gw_int, mac_mcast_1,
				upStream[cnt], mcast_1, ttl-1, 0, 0,
				sp, dp, 0, 0, 0, 0, pkt_content, dataLen);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);

			MBUF_CMPandFREE(mbuf_comp, mbuf_out[i]);
		}
	}
	return SUCCESS;
}

/*
	Function pkt_multicast_igmp3 test util

		update each host's source list and send corresponding report to gateway
*/
int32 pkt_updateHostAndSendReport(uint8 forceInClude, struct multicast_host* host, ipaddr_t *sPool, int32 sPoolCnt)
{
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfgArr[2];
	struct rtl_mBuf *mbuf_in, mbuf_comp;
	int32 retval;
	
	uint8 gr1, gr2;
	ipaddr_t *s1, *s2;
	uint32 sc1, sc2;
	void *aux1, *aux2;
	uint32 auxLen1, auxLen2;
	int i;
	uint16 system_id = 1;
	#define SID system_id

	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));

	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};


	// update source list, filter mode and generate report source list
	if (pkt_genNewSlist(forceInClude, &host->slist, &host->slistCnt, &host->filterMode, sPool, sPoolCnt,
		&gr1, &s1, &sc1, &gr2, &s2, &sc2) != SUCCESS)
		return FAILED;

	//printf("port[%d]<%d> %d:%d %d:%d\n", host->port, host->filterMode, gr1, sc1, gr2, sc2);

	// get aux data
	auxLen1 = random() % 100;
	if (auxLen1)
		aux1 = malloc(auxLen1);
	else
		aux1 = NULL;

	auxLen2 = random() % 100;
	if (auxLen2)
		aux2 = malloc(auxLen2);
	else
		aux2 = NULL;

	/* send report to gateway */
	if ((host->vers == IGMPV1) || (host->vers == IGMPV2))
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (host->mac, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= host->addr;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= random() % 65535;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 1;
		conf.igmp.type					= ((host->vers == IGMPV1)?IGMP_V1_REPORT:IGMP_V2_REPORT);
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= host->vlanIdx;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, host->port);
	}else if (host->vers == IGMPV3)
	{
		{	// group report
			grCfgArr[0].type = gr1;
			grCfgArr[0].gaddr = mcast_1;
			grCfgArr[0].auxlen = auxLen1;
			grCfgArr[0].nofs = sc1;
			grCfgArr[0].slist = s1;
			grCfgArr[0].auxdata = aux1;

			if (gr2 != 0)
			{
				grCfgArr[1].type = gr2;
				grCfgArr[1].gaddr = mcast_1;
				grCfgArr[1].auxlen = auxLen2;
				grCfgArr[1].nofs = sc2;
				grCfgArr[1].slist = s2;
				grCfgArr[1].auxdata = aux2;
			}
		}
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (host->mac, conf.conf_smac);
		CP_MAC (mac_mcast_V3rpt, conf.conf_dmac);
		conf.conf_sip						= host->addr;
		conf.conf_dip						= mcast_V3rpt;
		conf.ip.id							= random() % 65535;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 3;
		conf.igmp.type					= IGMP_V3_REPORT;
		conf.igmp.rnofg					= ((gr2 == 0)?1:2);
		conf.igmp.grCfg					= grCfgArr;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= host->vlanIdx;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, host->port);

	}
	mbuf_in = genMbufPkt(&conf);

	/* packet input */
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	/* check responds */
	VALUE_CMP(retval, SUCCESS);
	mbufList_Reinit();
	
	if (gr1 != 0)
		free(s1);
	if (gr2 != 0)
		free(s2);
	if (aux1)
		free(aux1);
	if (aux2)
		free(aux2);
	return SUCCESS;
}

/*
@func Testing		| Multicast IGMP-3	| Multicast system testing for IGMP basic functions (forwarding)
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : basic function, test for IGMPv3 report and data forwarding
 */
int32 pkt_multicast_igmp3(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/************************************************************
		test for:

			100 host's in different port dynamically choose source list and
			check pkt forwarding
	************************************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	const int32 LoopCnt = 100;
	int32 CurrentTime;

	////////////////////////////////////////////////////////////////
	struct multicast_host host[3];
	ipaddr_t host_var = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_host_var = {0x00, 0x00, 0x0f, 0x01, 0x01, 0x01};
	ipaddr_t upstream[MAX_SLISTCNT];
	ether_addr_t mac_upstream[MAX_SLISTCNT];
	int i, j, cnt;
	ipaddr_t upstream_var = ntohl(inet_addr("10.113.1.1"));
	ether_addr_t mac_upstream_var = {0x00, 0x00, 0x00, 0x01, 0x01, 0x01};
	////////////////////////////////////////////////////////////////

	// set random seed
	srandom(time(NULL));
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();	// we can NOT change this config!
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, FALSE);


	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	// init all hosts
	for (i = 0 ; i < 3 ; i ++)
	{
		host[i].addr = (host_var ++);
		host[i].mac = mac_host_var; mac_host_var.octet[5] ++;
		host[i].port = i+1;
		host[i].vlanIdx = 2;
		host[i].vers = 3;
		host[i].filterMode = IGMP_MODE_NONE;
		host[i].slist = NULL;
		host[i].slistCnt = 0;

		ASSERT(rtl8651_addArp(host[i].addr, &host[i].mac, "lan", host[i].port) == SUCCESS);
	}

	// init all upstreams
	for (i = 0 ; i < MAX_SLISTCNT ; i ++)
	{
		upstream[i]		= (upstream_var ++);
		mac_upstream[i]	= mac_upstream_var;
		mac_upstream_var.octet[5] ++;
	}

	// init source list Pool
	slistPool_reinit();

	// first : we must timeupdate(1), some condition is compare with _sysUpSecond, so it must larger than 0
	_rtl8651_timeUpdate((random() % 100) + 1);
	//////////////////////////////////////////////////////////////////////////////////////////////
	for (cnt = 0; cnt < 10 ; cnt ++)
	{
		for (i = 0 ; i < 3 ; i ++)
		{
			j = random();
			switch (j % 3)
			{
				case 0:
					host[i].filterMode = IGMP_FILTER_NONE;
					break;
				case 1:
					host[i].filterMode = IGMP_FILTER_INCLUDE;
					break;
				case 2:
					host[i].filterMode = IGMP_FILTER_EXCLUDE;
					break;
			}
			host_del_all(&(host[i].slist));
			host[i].slistCnt = 0;
		}

		for (j = 0 ; j < 200 ; j ++)
		{
			for (i = 0 ; i < 3 ; i ++)
				VALUE_CMP(pkt_updateHostAndSendReport(FALSE, &host[i], upstream, MAX_SLISTCNT), SUCCESS);
			VALUE_CMP(pkt_sendMulticastAndCheckRscv(host, i, upstream, MAX_SLISTCNT), SUCCESS);
		}

		for (j = 0 ; j < 200 ; j ++)
		{
			for (i = 0 ; i < 3 ; i ++)
				VALUE_CMP(pkt_updateHostAndSendReport(TRUE, &host[i], upstream, MAX_SLISTCNT), SUCCESS);
			VALUE_CMP(pkt_sendMulticastAndCheckRscv(host, i, upstream, MAX_SLISTCNT), SUCCESS);
		}

		mbufList_Reinit();
		for (j = 0 ; j < (RTL8651_IGMP_GMI_TEST + RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST) ; j ++)
		{
			_rtl8651_timeUpdate(1);
			mbufList_Reinit();
		}
	}

	for (j = 0 ; j < 2000 ; j ++)
	{
		_rtl8651_timeUpdate(1);
		mbufList_Reinit();
	}
	
	return SUCCESS;
}

/*
@func Testing		| Multicast IGMP-4	| Multicast system testing for IGMP basic functions (timing)
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : basic function, test for IGMPv3 report/query
 */
int32 pkt_multicast_igmp4(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfgArr[10];
	ipaddr_t slistArr[10][10];
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/************************************************************
		test for:

	************************************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.1.253"));
	ipaddr_t upstream3 = ntohl(inet_addr("10.113.1.252"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	uint16 port_rp = 0x5678;
	uint16 port_gw = 0x2345;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	const int32 LoopCnt = 100;
	int32 i;

	// set random seed
	srandom(time(NULL));
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();	// we can NOT change this config!
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi1, &mac_npi1, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi3, &mac_npi3, "lan2", 4) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	// set DEFAULT ID to system id
	DEFAULT_IP_ID = SID;

	/*
		In the beginning, gateway don't forward packet to all ports
	*/
	{
		// multicast packet: from upstream1
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
						upstream1, mcast_1, 5, 0, 0,
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		}
		// check output
		VALUE_CMP(retval, SUCCESS);
		// no packet output
		VALUE_CMP(mbufList_nmbuf(), 0);


		// multicast packet: from upstream2
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
						upstream2, mcast_1, 5, 0, 0,
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		}
		// check output
		VALUE_CMP(retval, SUCCESS);
		// no packet output
		VALUE_CMP(mbufList_nmbuf(), 0);
	}

	/*
		npi1 report:
					mcast1 : Include {upstream1}
					mcast2 : Exclude {upstream1}

		gateway send 2 report to upstream for mcast1 and mcast2
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream1;
				grCfgArr[0].type = IGMP_MODE_ISIN;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 1;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream1;
				grCfgArr[1].type = IGMP_MODE_ISEX;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 1;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0);
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 2);

		/* report 1 : for mcast 1 */
		{
			{
				{	// group report
					slistArr[0][0] = upstream1;
					grCfgArr[0].type = IGMP_MODE_ISIN;
					grCfgArr[0].gaddr = mcast_1;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/* report 2 : for mcast 2 */
		{
			{
				{	// group report
					slistArr[0][0] = upstream1;
					grCfgArr[0].type = IGMP_MODE_ISEX;
					grCfgArr[0].gaddr = mcast_2;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		send multicast packet from upstream1, upstream2
					mcast1 : upstream1 is allowed, upstream2 is dropped
					mcast2 : both of upstream1/upstream2 are allowed
							-> $6.4.1
								EXCLUDE{X, Y} -> IS_EX{A} : EXCLUDE{A-Y, Y*A}, so gateway only block A if Y has been blocked
	*/
	
	{
		// mcast1 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream1, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream1, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream1, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast1 multicast packet: from upstream2: don't forward
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream2, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// no packet output
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// mcast2 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream2, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream2, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	// upstream query: gateway return for mcast1 and mcast2
	{
		mbufList_Reinit();
		{
			// query for mcast1: gateway report
			{
				mbuf_in = confIgmpHSB(&conf,
						0, 1, TRUE, 0, mac_pppoe, mac_mcast_1, 0,
						ip_rp, mcast_1, 1, 0, 0,
						IGMPV3, IGMP_QUERY, 100, mcast_1,
						1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
						0, 0, NULL, 0);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			// gateway report
			{
				{	// group report
					slistArr[0][0] = upstream1;
					grCfgArr[0].type = IGMP_MODE_ISIN;
					grCfgArr[0].gaddr = mcast_1;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		{
			// query for mcast2: gateway report
			{
				mbuf_in = confIgmpHSB(&conf,
						0, 1, TRUE, 0, mac_pppoe, mac_mcast_2, 0,
						ip_rp, mcast_2, 1, 0, 0,
						IGMPV3, IGMP_QUERY, 100, mcast_2,
						1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
						0, 0, NULL, 0);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			// gateway report
			{
				{	// group report
					slistArr[0][0] = upstream1;
					grCfgArr[0].type = IGMP_MODE_ISEX;
					grCfgArr[0].gaddr = mcast_2;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	// gateway periodically send query to npi1 for mcast1 and mcast2
	{
		mbufList_Reinit();
		_rtl8651_timeUpdate(RTL8651_IGMP_QI_TEST);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// query for mcast1
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_1, 0,
					ip_gw_int, mcast_1, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_1,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// query for mcast2
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_2, 0,
					ip_gw_int, mcast_2, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_2,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		npi1 generate report for mcast1 and mcast2
					mcast1 : To EX {upstream1}	-> EXCLUDE {upstream1}
						- Gateway send Q(mcast1, {upstream1 * upstream1})
					mcast2 : To IN {upstream1}	-> EXCLUDE {upstream1}
						- Gateway send Q(mcast2, {upstream1 - upstream1}) (don't send)
						- Gateway send Q(mcast2)
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream1;
				grCfgArr[0].type = IGMP_MODE_TOEX;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 1;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream1;
				grCfgArr[1].type = IGMP_MODE_TOIN;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 1;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0);
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 2);

		// query for mcast1 {upstream1}
		{
			uint16 tx_port[2] = {1, 0xffff};

			slistArr[0][0] = upstream1;
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_1, 0,
					ip_gw_int, mcast_1, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_1,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 1, slistArr[0],
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// query for mcast2
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_2, 0,
					ip_gw_int, mcast_2, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_2,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		npi1 generate report for mcast1 and mcast2
					mcast1 : ALLOW {upstream1, upstream2}	-> EXCLUDE {upstream1, upstream2}
					mcast2 : BLOCK {upstream1, upstream2}	-> EXCLUDE {upstream1, upstream2}
						- Gateway send Q(mcast2, {upstream1, upstream2})
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream2;
				slistArr[0][1] = upstream1;
				grCfgArr[0].type = IGMP_MODE_ALLOW;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 2;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream1;
				slistArr[1][1] = upstream2;
				grCfgArr[1].type = IGMP_MODE_BLOCK;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 2;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0);
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 1);

		// query for mcast2 {upstream1, upstream2}
		{
			uint16 tx_port[2] = {1, 0xffff};

			slistArr[0][0] = upstream1;
			slistArr[0][1] = upstream2;
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_2, 0,
					ip_gw_int, mcast_2, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_2,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 2, slistArr[0],
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	// go to timeout state
	for (i = 0 ; i < 100000 ; i ++)
	{
		_rtl8651_timeUpdate(1);
		if (mbufList_nmbuf())
			mbufList_Reinit();
	}
	// packet cannot be forwarded now
	{
		// multicast packet: from upstream1
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
						upstream1, mcast_1, 5, 0, 0,
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		}
		// check output
		VALUE_CMP(retval, SUCCESS);
		// no packet output
		VALUE_CMP(mbufList_nmbuf(), 0);


		// multicast packet: from upstream2
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
						upstream2, mcast_1, 5, 0, 0,
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		}
		// check output
		VALUE_CMP(retval, SUCCESS);
		// no packet output
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	/*
		npi1 report:
					mcast1 : Include {upstream1}
					mcast2 : Include {upstream2}

		gateway send 2 report to upstream for mcast1 and mcast2
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream1;
				grCfgArr[0].type = IGMP_MODE_ISIN;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 1;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream2;
				grCfgArr[1].type = IGMP_MODE_ISIN;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 1;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0);
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 2);

		/* report 1 : for mcast 1 */
		{
			{
				{	// group report
					slistArr[0][0] = upstream1;
					grCfgArr[0].type = IGMP_MODE_ISIN;
					grCfgArr[0].gaddr = mcast_1;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/* report 2 : for mcast 2 */
		{
			{
				{	// group report
					slistArr[0][0] = upstream2;
					grCfgArr[0].type = IGMP_MODE_ISIN;
					grCfgArr[0].gaddr = mcast_2;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		send multicast packet from upstream1, upstream2
					mcast1 : upstream1 is allowed, upstream2 is dropped
					mcast2 : upstream2 is allowed, upstream1 is dropped
	*/
	
	{
		// mcast1 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream1, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream1: don't forward
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream1, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// no packet output
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// mcast1 multicast packet: from upstream2: don't forward
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream2, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// no packet output
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// mcast2 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream2, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream2, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	// upstream query: gateway return for mcast1 and mcast2
	{
		mbufList_Reinit();
		{
			// query for mcast1: gateway report
			{
				mbuf_in = confIgmpHSB(&conf,
						0, 1, TRUE, 0, mac_pppoe, mac_mcast_1, 0,
						ip_rp, mcast_1, 1, 0, 0,
						IGMPV3, IGMP_QUERY, 100, mcast_1,
						1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
						0, 0, NULL, 0);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			// gateway report
			{
				{	// group report
					slistArr[0][0] = upstream1;
					grCfgArr[0].type = IGMP_MODE_ISIN;
					grCfgArr[0].gaddr = mcast_1;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		{
			// query for mcast2: gateway report
			{
				mbuf_in = confIgmpHSB(&conf,
						0, 1, TRUE, 0, mac_pppoe, mac_mcast_2, 0,
						ip_rp, mcast_2, 1, 0, 0,
						IGMPV3, IGMP_QUERY, 100, mcast_2,
						1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 0, 0,
						0, 0, NULL, 0);

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			// gateway report
			{
				{	// group report
					slistArr[0][0] = upstream2;
					grCfgArr[0].type = IGMP_MODE_ISIN;
					grCfgArr[0].gaddr = mcast_2;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 1;
					grCfgArr[0].slist = slistArr[0];
					grCfgArr[0].auxdata = NULL;
				}
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confIgmpHSA(&conf,
						tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
						ip_gw_ext, mcast_V3rpt, 1, 0, 0,
						IGMPV3, IGMP_V3_REPORT, 0, 0,
						0, 0, 0, 0,
						1, grCfgArr, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		npi1 generate report for mcast1 and mcast2
					mcast1 : ALLOW {upstream2}			-> INCLUDE {upstream1, upstream2}
					mcast2 : TO_IN {upstream1}			-> INCLUDE {upstream1, upstream2}
						- Gateway send Q(mcast2, {upstream2})
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream2;
				grCfgArr[0].type = IGMP_MODE_ALLOW;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 1;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream1;
				grCfgArr[1].type = IGMP_MODE_TOIN;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 1;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0); 
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 1);

		// query for mcast2 {upstream2}
		{
			uint16 tx_port[2] = {1, 0xffff};

			slistArr[0][1] = upstream2;
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_2, 0,
					ip_gw_int, mcast_2, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_2,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 1, slistArr[0],
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		send multicast packet from upstream1, upstream2
					mcast1 : both upstream1/upstream2 are allowed
					mcast2 : both upstream1/upstream2 are allowed
	*/
	
	{
		// mcast1 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream1, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream1, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream1, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast1 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream2, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream2, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream2, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream2, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		npi1 generate report for mcast1 and mcast2
					mcast1 : IS_EX {upstream3}			-> EXCLUDE {{}, {upstream3}}	block upstream3
					mcast2 : BLOCK {upstream1, upstream3}	-> INCLUDE {upstream1, upstream2}
						- Gateway send Q(mcast2, {upstream1})
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream3;
				grCfgArr[0].type = IGMP_MODE_ISEX;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 1;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream1;
				slistArr[1][1] = upstream3;
				grCfgArr[1].type = IGMP_MODE_BLOCK;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 2;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0); 
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 1);

		// query for mcast2 {upstream1}
		{
			uint16 tx_port[2] = {1, 0xffff};

			slistArr[0][0] = upstream1;
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_2, 0,
					ip_gw_int, mcast_2, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_2,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 1, slistArr[0],
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		send multicast packet from upstream1, upstream2
					mcast1 : both upstream1/upstream2 are allowed, upstream3 is dropped
					mcast2 : both upstream1/upstream2 are allowed, upstream3 is drooped
	*/
	
	{
		// mcast1 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream1, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream1, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream1, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast1 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream2, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream2, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream2, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream2, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast1 multicast packet: from upstream3: don't forward
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream3, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// no packet output
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// mcast2 multicast packet: from upstream3: don't forward
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream3, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// no packet output
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
	}
	/*
		npi1 generate report for mcast1 and mcast2
					mcast2 : IS_EX {upstream1}			-> EXCLUDE {upstream1}
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream1;
				grCfgArr[0].type = IGMP_MODE_ISEX;
				grCfgArr[0].gaddr = mcast_2;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 1;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					1, grCfgArr, NULL, 0); 
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	/*
		npi1 generate report for mcast1 and mcast2
					mcast1 : TO_EX {upstream1, upstream3}	-> EXCLUDE {{upstream1}, {upstream3}}	block upstream3
						- Gateway send Q(mcast1, {upstream1})
					mcast2 : IS_IN {upstream1, upstream2}	-> EXCLUDE {upstream1, upstream2}
	*/
	{
		{
			{	// group report
				slistArr[0][0] = upstream1;
				slistArr[0][1] = upstream3;
				grCfgArr[0].type = IGMP_MODE_TOEX;
				grCfgArr[0].gaddr = mcast_1;
				grCfgArr[0].auxlen = 0;
				grCfgArr[0].nofs = 2;
				grCfgArr[0].slist = slistArr[0];
				grCfgArr[0].auxdata = NULL;

				slistArr[1][0] = upstream1;
				slistArr[1][1] = upstream2;
				grCfgArr[1].type = IGMP_MODE_ISIN;
				grCfgArr[1].gaddr = mcast_2;
				grCfgArr[1].auxlen = 0;
				grCfgArr[1].nofs = 2;
				grCfgArr[1].slist = slistArr[1];
				grCfgArr[1].auxdata = NULL;
			}
			mbuf_in = confIgmpHSB(&conf,
					1, 2, FALSE, 0, mac_npi1, mac_gw_int, 0,
					ip_npi1, mcast_V3rpt, 1, 0, 0,
					IGMPV3, IGMP_V3_REPORT, 0, 0,
					0, 0, 0, 0,
					2, grCfgArr, NULL, 0); 
		}
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		/* check output */
		VALUE_CMP(mbufList_nmbuf(), 1);

		// query for mcast1 {upstream1}
		{
			uint16 tx_port[2] = {1, 0xffff};

			slistArr[0][0] = upstream1;
			mbuf_comp = confIgmpHSA(&conf,
					tx_port, 2, FALSE, 0, mac_gw_int, mac_mcast_1, 0,
					ip_gw_int, mcast_1, 1, 0, 0,
					IGMPV3, IGMP_QUERY, 100, mcast_1,
					1, RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST, 1, slistArr[0],
					0, 0, NULL, 0);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}
	/*
		send multicast packet from upstream1, upstream2
					mcast1 : both upstream1/upstream2 are allowed, upstream3 is dropped
					mcast2 : all of upstream1/upstream2/upstream3 are allowed
	*/
	
	{
		// mcast1 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream1, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream1: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream1, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream1, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast1 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream2, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_1,
					upstream2, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast2 multicast packet: from upstream2: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream2, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream2, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		// mcast1 multicast packet: from upstream3: don't forward
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
							upstream3, mcast_1, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// no packet output
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// mcast2 multicast packet: from upstream3: allow
		{
			{
				mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_2, 0,
							upstream3, mcast_2, 5, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			}
			// check output
			VALUE_CMP(retval, SUCCESS);
			// one packet output
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0, mac_gw_int, mac_mcast_2,
					upstream3, mcast_2, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	return SUCCESS;
}

/*
@func Testing		| Multicast IGMP-5	| Multicast system testing for IGMP-Expire-stop-forwarding functions
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : stop forward packet to specific member if this member is under expire state
 */
int32 pkt_multicast_igmp5(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/**********************************************
		Set upstream to wan

		test for:

			join		-> multicast forward
			leave	-> stop forward
			join		-> forward resume

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.2.254"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_upstream1 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x01}}; 
	ether_addr_t mac_upstream2 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x02}}; 
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	int32 cnt;
	const int32 LoopCnt = 1000;
	int32 CurrentTime;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);

	ASSERT(rtl8651_addArp(ip_npi1, &mac_npi1, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi3, &mac_npi3, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addArp(upstream2, &mac_upstream2, "wan2", 5) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	_rtl8651_setMcastProcessOptions(MCAST_PROC_EXPIRE_STATE_DONT_FWD);

	// set DEFAULT ID to system id
	DEFAULT_IP_ID = SID;

	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		/*
			IGMP V2 Report from npi1 for multicast group 1
		*/
		{
			mbuf_in = confIgmpHSB(NULL,
						1, 2, FALSE, 0,
						mac_npi1, mac_mcast_1, 0,
						ip_npi1, mcast_1, 1, 0, 0,
						IGMPV2, IGMP_V2_REPORT, 100, mcast_1,
						0, 0, 0, NULL, 0, NULL, NULL, 0);	

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);

			/*
				Report to upstream
			*/
			{
				{	// group report
					grCfg.type = IGMP_MODE_ISEX;
					grCfg.gaddr = mcast_1;
					grCfg.auxlen = 0;
					grCfg.nofs = 0;
					grCfg.slist = NULL;
					grCfg.auxdata = NULL;
				}

				{
					uint16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confIgmpHSA(&conf,
							tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
							ip_gw_ext, mcast_V3rpt, 1, 0, 0,
							IGMPV3, IGMP_V3_REPORT, 0, 0,
							0, 0, 0, 0,
							1, &grCfg, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}
		/*
			send mcast1 packet, we forward it
		*/
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			IGMP V2 Leave from npi1 for multicast group 1
		*/
		{
			mbuf_in = confIgmpHSB(NULL,
						1, 2, FALSE, 0,
						mac_npi1, mac_mcast_1, 0,
						ip_npi1, mcast_1, 1, 0, 0,
						IGMPV2, IGMP_V2_LEAVE, 100, mcast_1,
						0, 0, 0, NULL, 0, NULL, NULL, 0);	

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);

			/*
				Query
			*/
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confIgmpHSA(NULL,
					tx_port, 2, FALSE, 0,
					mac_gw_int, mac_mcast_1, 0,
					ip_gw_int, mcast_1, 1, 0, 0,
					IGMPV2, IGMP_QUERY, 100, mcast_1,
					0, 0, 0, NULL, 0, NULL, NULL, 0);
			}	

			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			send mcast1 packet, we don't forward it
		*/
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}

		/*
			wait 10000 sec for entry expire
		*/
		_rtl8651_timeUpdate(10000);
		mbufList_Reinit();	/* free all gateway's query and report */
	}

	return SUCCESS;
}

/*
@func Testing		| Multicast IGMP-6	| Multicast system testing for Fragment multicast packets
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : forward fragment multicast packet
 */
int32 pkt_multicast_igmp6(uint32 caseNo) {
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/**********************************************
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.2.254"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_upstream1 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x01}}; 
	ether_addr_t mac_upstream2 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x02}}; 
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	int32 cnt;
	const int32 LoopCnt = 100;
	int32 CurrentTime;
	uint16 udp_payload = 1448;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);

	ASSERT(rtl8651_addArp(ip_npi1, &mac_npi1, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi3, &mac_npi3, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addArp(upstream2, &mac_upstream2, "wan2", 5) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}
	

	/******************************************************
			Join
	******************************************************/

	/*
		IGMP V2 Report from npi1 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi1, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi1;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_REPORT;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 2;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 1);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		/*
			Report to upstream
		*/
		{
			{	// group report
				grCfg.type = IGMP_MODE_ISEX;
				grCfg.gaddr = mcast_1;
				grCfg.auxlen = 0;
				grCfg.nofs = 0;
				grCfg.slist = NULL;
				grCfg.auxdata = NULL;
			}

			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
			conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
			CP_MAC (mac_gw_ext, conf.conf_smac);
			CP_MAC (mac_pppoe, conf.conf_dmac);
			conf.conf_sip						= ip_gw_ext;
			conf.conf_dip						= mcast_V3rpt;
			conf.ip.id							= SID;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 3;
			conf.igmp.type					= IGMP_V3_REPORT;
			conf.igmp.rnofg					= 1;
			conf.igmp.grCfg					= &grCfg;
			conf.igmp.respTime				= 100;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;
			conf.conf_vlanIdx					= 1;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);

			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
	}

	/*
		IGMP V2 Report from npi3 for multicast group 1
	*/
	{
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
		conf.l2Flag						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi3, conf.conf_smac);
		CP_MAC (mac_mcast_1, conf.conf_dmac);
		conf.conf_sip						= ip_npi3;
		conf.conf_dip						= mcast_1;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 1;		/* igmp ttl */
		conf.igmp.ver						= 2;
		conf.igmp.type					= IGMP_V2_REPORT;
		conf.igmp.respTime				= 0;
		conf.igmp.gaddr					= mcast_1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 3;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 4);

		mbuf_in = genMbufPkt(&conf);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}

	/*
		Group 1: Sent from upstream -> to (npi1, npi3)
	*/
	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		int total_pkt;
		int pa[5];
		int sa[5];

		/* only allow Tear drop */
		rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j,p;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop;
					}
			}

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, mcast_1, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?(total_pkt*2):0));
			}

			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				/* to npi1 */
				{
					uint16 tx_port[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_mcast_1,
						ip_rp, mcast_1, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

				/* to npi3 */
				{
					uint16 tx_port[2] = {4, 0xffff};
					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 3, 0,
						mac_gw_int2, mac_mcast_1,
						ip_rp, mcast_1, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
	nextLoop:
		}

		// turn-off all dos check
		rtl8651a_setDosStatus(0, 0);

		/*
			NPI	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j,p,s;
			int firstArrive;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop2;
					}
			}

			DEFAULT_IP_ID ++;
			firstArrive = FALSE;

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, mcast_1, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				if (firstArrive == FALSE)
				{
					if (pkt_no == 1)	// first packet
					{	// dequeue
						int min, m, idx;
						int cmp_no;

						firstArrive = TRUE;
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), (p*2));
						// sort arrived packets number
						min = 0;
						for (s = 0 ; s < p ; s ++)
						{
							m = total_pkt + 1;
							for (idx = 0 ; idx < p ; idx ++)
							{
								if ((min < pa[idx]) && (pa[idx] < m))
									m = pa[idx];
									
							}
							min = m;
							sa[s] = min;
						}
						// compare packet
						for (idx = 0 ; idx < p ; idx ++)
						{
							int16 tx_port[2] = {1, 0xffff};
						
							cmp_no = sa[idx];

							/* to npi1 */
							{
								uint16 tx_port[2] = {1, 0xffff};
								mbuf_comp = confVlanHSA( NULL, NULL,
									_PKT_TYPE_UDP, tx_port, 2, 0,
									mac_gw_int, mac_mcast_1,
									ip_rp, mcast_1, 10, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
									port_rp, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
								mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
							}
							MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

							/* to npi3 */
							{
								uint16 tx_port[2] = {4, 0xffff};
								mbuf_comp = confVlanHSA( NULL, NULL,
									_PKT_TYPE_UDP, tx_port, 3, 0,
									mac_gw_int2, mac_mcast_1,
									ip_rp, mcast_1, 10, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
									port_rp, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
								mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
							}
							MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

						}
					}else
					{	// queued
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}else
				{	// first packet arrived, pass-through it
					int16 tx_port[2] = {1, 0xffff};

					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 2);

							/* to npi1 */
							{
								uint16 tx_port[2] = {1, 0xffff};
								mbuf_comp = confVlanHSA( NULL, NULL,
									_PKT_TYPE_UDP, tx_port, 2, 0,
									mac_gw_int, mac_mcast_1,
									ip_rp, mcast_1, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
									port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
								mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
							}
							MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

							/* to npi3 */
							{
								uint16 tx_port[2] = {4, 0xffff};
								mbuf_comp = confVlanHSA( NULL, NULL,
									_PKT_TYPE_UDP, tx_port, 3, 0,
									mac_gw_int2, mac_mcast_1,
									ip_rp, mcast_1, 10, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
									port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
								mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
							}
							MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
			}

	nextLoop2:
		}

	}

	return SUCCESS;

}



/*
	pkt_multicast_igmp_Filter1 utility
*/
int32 pkt_multicast_igmp_Filter1_Flow(uint8 Mirror, uint8 NoProc)
{
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfgArr[10];
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_general = ntohl(inet_addr("224.0.0.1"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.2.254"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_general = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x01}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_upstream1 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x01}}; 
	ether_addr_t mac_upstream2 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x02}}; 
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	int32 cnt;
	const int32 LoopCnt = 100;
	int32 CurrentTime;
	bzero(pkt_content, sizeof(pkt_content));

	{
		/*
			IGMP V1 Report from npi1 for multicast group 1
		*/
		{
			{
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
				CP_MAC (mac_npi1, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_npi1;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= 0xa;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 1;
				conf.igmp.type					= IGMP_V1_REPORT;
				conf.igmp.respTime				= 0;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;

				conf.conf_vlanIdx					= 2;
				conf.conf_pppoeIdx				= 0;
				SET_RX_PORT(conf.conf_portlist, 1);

				mbuf_in = genMbufPkt(&conf);
				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				if (Mirror)
				{
					VALUE_CMP(retval, FWDENG_IGMPPKT);
					mbuf_comp = genMbufPkt(&conf);
					MBUF_CMPandFREE(mbuf_in, mbuf_comp);
				}else
				{
					VALUE_CMP(retval, SUCCESS);
				}
				if (NoProc)
				{
					VALUE_CMP(mbufList_nmbuf(), 0);
				}else
				{
					VALUE_CMP(mbufList_nmbuf(), 1);
				}

				/*
					Report to upstream
				*/
				// Report
				if (!NoProc)
				{
					{	// group report
						grCfg.type = IGMP_MODE_ISEX;
						grCfg.gaddr = mcast_1;
						grCfg.auxlen = 0;
						grCfg.nofs = 0;
						grCfg.slist = NULL;
						grCfg.auxdata = NULL;
					}

					RESET_CONF(&conf);
					conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
					conf.l2Flag						= 0;
					conf.ErrFlag						= 0;
					conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
					conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
					CP_MAC (mac_gw_ext, conf.conf_smac);
					CP_MAC (mac_pppoe, conf.conf_dmac);
					conf.conf_sip						= ip_gw_ext;
					conf.conf_dip						= mcast_V3rpt;
					conf.ip.id							= SID;
					conf.ip.mf						= 0;
					conf.ip.offset						= 0;
					conf.ip.ttl							= 1;		/* igmp ttl */
					conf.igmp.ver						= 3;
					conf.igmp.type					= IGMP_V3_REPORT;
					conf.igmp.rnofg					= 1;
					conf.igmp.grCfg					= &grCfg;
					conf.igmp.respTime				= 100;
					conf.igmp.gaddr					= mcast_1;
					conf.payload.content				= NULL;
					conf.payload.length				= 0;
					conf.conf_vlanIdx					= 1;
					ADD_TX_PORT(conf.conf_portlist, 0);
					mbuf_comp = genMbufPkt(&conf);

					VALUE_CMP(mbufList_nmbuf(), 1);
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
				}
			}

			if (NoProc)
			{
				mbufList_Reinit();
				_rtl8651_timeUpdate(2000);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}else
			{
				// fwd engine will query client using general query(because this member is under V1 setting)
				mbufList_Reinit();
				while (mbufList_nmbuf() == 0)
					_rtl8651_timeUpdate(1);
				{
					RESET_CONF(&conf);
					conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
					conf.l2Flag						= 0;
					conf.ErrFlag						= 0;
					conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
					CP_MAC (mac_gw_int, conf.conf_smac);
					CP_MAC (mac_mcast_general, conf.conf_dmac);
					conf.conf_sip						= ip_gw_int;
					conf.conf_dip						= mcast_general;
					conf.ip.id							= SID;
					conf.ip.mf						= 0;
					conf.ip.offset						= 0;
					conf.ip.ttl							= 1;		/* igmp ttl */
					conf.igmp.ver						= 1;
					conf.igmp.type					= IGMP_QUERY;
					conf.igmp.respTime				= 0;
					conf.igmp.gaddr					= 0;
					conf.payload.content				= NULL;
					conf.payload.length				= 0;

					conf.conf_vlanIdx					= 2;
					conf.conf_pppoeIdx				= 0;
					ADD_TX_PORT(conf.conf_portlist, 1);

					mbuf_comp = genMbufPkt(&conf);
					
					/* compare query */
					VALUE_CMP(mbufList_nmbuf(), 1);
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
					/*
						Report to gateway
					*/
					{
						RESET_CONF(&conf);
						conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
						conf.l2Flag						= 0;
						conf.ErrFlag						= 0;
						conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
						CP_MAC (mac_npi1, conf.conf_smac);
						CP_MAC (mac_mcast_1, conf.conf_dmac);
						conf.conf_sip						= ip_npi1;
						conf.conf_dip						= mcast_1;
						conf.ip.id							= 0xa;
						conf.ip.mf						= 0;
						conf.ip.offset						= 0;
						conf.ip.ttl							= 1;		/* igmp ttl */
						conf.igmp.ver						= 1;
						conf.igmp.type					= IGMP_V1_REPORT;
						conf.igmp.respTime				= 0;
						conf.igmp.gaddr					= mcast_1;
						conf.payload.content				= NULL;
						conf.payload.length				= 0;

						conf.conf_vlanIdx					= 2;
						conf.conf_pppoeIdx				= 0;
						SET_RX_PORT(conf.conf_portlist, 1);

						mbuf_in = genMbufPkt(&conf);
						/* packet input */
						FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

						if (Mirror)
						{
							VALUE_CMP(retval, FWDENG_IGMPPKT);
							mbuf_comp = genMbufPkt(&conf);
							MBUF_CMPandFREE(mbuf_in, mbuf_comp);
						}else
						{
							VALUE_CMP(retval, SUCCESS);
						}
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}
			}
		}		
		/*
			IGMP V2 Leave from npi1 for multicast group 1
		*/
		{
			RESET_CONF(&conf);
			conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
			conf.l2Flag						= 0;
			conf.ErrFlag						= 0;
			conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
			CP_MAC (mac_npi1, conf.conf_smac);
			CP_MAC (mac_mcast_1, conf.conf_dmac);
			conf.conf_sip						= ip_npi1;
			conf.conf_dip						= mcast_1;
			conf.ip.id							= 0xa;
			conf.ip.mf						= 0;
			conf.ip.offset						= 0;
			conf.ip.ttl							= 1;		/* igmp ttl */
			conf.igmp.ver						= 2;
			conf.igmp.type					= IGMP_V2_LEAVE;
			conf.igmp.respTime				= 0;
			conf.igmp.gaddr					= mcast_1;
			conf.payload.content				= NULL;
			conf.payload.length				= 0;

			conf.conf_vlanIdx					= 2;
			conf.conf_pppoeIdx				= 0;
			SET_RX_PORT(conf.conf_portlist, 1);

			mbuf_in = genMbufPkt(&conf);
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (Mirror)
			{
				VALUE_CMP(retval, FWDENG_IGMPPKT);
				mbuf_comp = genMbufPkt(&conf);
				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}else
			{
				VALUE_CMP(retval, SUCCESS);
			}
			if (NoProc)
			{
				VALUE_CMP(mbufList_nmbuf(), 0);
			}else
			{
				VALUE_CMP(mbufList_nmbuf(), 1);
			}

			/*
				Query
			*/
			if (!NoProc)
			{
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
				CP_MAC (mac_gw_int, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_gw_int;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= SID;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_QUERY;
				conf.igmp.respTime				= 100;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;
				conf.conf_vlanIdx					= 2;
				ADD_TX_PORT(conf.conf_portlist, 1);
				mbuf_comp = genMbufPkt(&conf);
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}
		/*
			IGMP V2 Report from npi1 for multicast group 1
		*/
		{
			{
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
				CP_MAC (mac_npi1, conf.conf_smac);
				CP_MAC (mac_mcast_1, conf.conf_dmac);
				conf.conf_sip						= ip_npi1;
				conf.conf_dip						= mcast_1;
				conf.ip.id							= 0xa;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 2;
				conf.igmp.type					= IGMP_V2_REPORT;
				conf.igmp.respTime				= 0;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;

				conf.conf_vlanIdx					= 2;
				conf.conf_pppoeIdx				= 0;
				SET_RX_PORT(conf.conf_portlist, 1);

				mbuf_in = genMbufPkt(&conf);
				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				if (Mirror)
				{
					VALUE_CMP(retval, FWDENG_IGMPPKT);
					mbuf_comp = genMbufPkt(&conf);
					MBUF_CMPandFREE(mbuf_in, mbuf_comp);
				}else
				{
					VALUE_CMP(retval, SUCCESS);
				}
				VALUE_CMP(mbufList_nmbuf(), 0);

				/*
					When (NoProc = FALSE):
						Report to upstream: send ALLOW{NONE} and BLOCK{NONE}: don't send it!
				*/
			}

			if (NoProc)
			{
				mbufList_Reinit();
				_rtl8651_timeUpdate(2000);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}else
			{
				// fwd engine will query client using group-specific query(because this member is under V2 setting)
				mbufList_Reinit();
				while (mbufList_nmbuf() == 0)
					_rtl8651_timeUpdate(1);
				{
					RESET_CONF(&conf);
					conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
					conf.l2Flag						= 0;
					conf.ErrFlag						= 0;
					conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
					CP_MAC (mac_gw_int, conf.conf_smac);
					CP_MAC (mac_mcast_1, conf.conf_dmac);
					conf.conf_sip						= ip_gw_int;
					conf.conf_dip						= mcast_1;
					conf.ip.id							= SID;
					conf.ip.mf						= 0;
					conf.ip.offset						= 0;
					conf.ip.ttl							= 1;		/* igmp ttl */
					conf.igmp.ver						= 2;
					conf.igmp.type					= IGMP_QUERY;
					conf.igmp.respTime				= 100;
					conf.igmp.gaddr					= mcast_1;
					conf.payload.content				= NULL;
					conf.payload.length				= 0;

					conf.conf_vlanIdx					= 2;
					conf.conf_pppoeIdx				= 0;
					ADD_TX_PORT(conf.conf_portlist, 1);

					mbuf_comp = genMbufPkt(&conf);
					
					/* compare query */
					VALUE_CMP(mbufList_nmbuf(), 1);
					MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
					/*
						Report to gateway
					*/
					{
						RESET_CONF(&conf);
						conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
						conf.l2Flag						= 0;
						conf.ErrFlag						= 0;
						conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
						CP_MAC (mac_npi1, conf.conf_smac);
						CP_MAC (mac_mcast_1, conf.conf_dmac);
						conf.conf_sip						= ip_npi1;
						conf.conf_dip						= mcast_1;
						conf.ip.id							= 0xa;
						conf.ip.mf						= 0;
						conf.ip.offset						= 0;
						conf.ip.ttl							= 1;		/* igmp ttl */
						conf.igmp.ver						= 2;
						conf.igmp.type					= IGMP_V2_REPORT;
						conf.igmp.respTime				= 0;
						conf.igmp.gaddr					= mcast_1;
						conf.payload.content				= NULL;
						conf.payload.length				= 0;

						conf.conf_vlanIdx					= 2;
						conf.conf_pppoeIdx				= 0;
						SET_RX_PORT(conf.conf_portlist, 1);

						mbuf_in = genMbufPkt(&conf);
						/* packet input */
						FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

						if (Mirror)
						{
							VALUE_CMP(retval, FWDENG_IGMPPKT);
							mbuf_comp = genMbufPkt(&conf);
							MBUF_CMPandFREE(mbuf_in, mbuf_comp);
						}else
						{
							VALUE_CMP(retval, SUCCESS);
						}
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}
			}
		}
		/*
			IGMP V3 Report from npi1 for multicast group 1
		*/
		{
			{
				{	// group report
					grCfgArr[0].type = IGMP_MODE_ISEX;
					grCfgArr[0].gaddr = mcast_2;
					grCfgArr[0].auxlen = 0;
					grCfgArr[0].nofs = 0;
					grCfgArr[0].slist = NULL;
					grCfgArr[0].auxdata = NULL;

					grCfgArr[1].type = IGMP_MODE_ISEX;
					grCfgArr[1].gaddr = mcast_1;
					grCfgArr[1].auxlen = 0;
					grCfgArr[1].nofs = 0;
					grCfgArr[1].slist = NULL;
					grCfgArr[1].auxdata = NULL;
				}
				RESET_CONF(&conf);
				conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
				conf.l2Flag						= 0;
				conf.ErrFlag						= 0;
				conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
				CP_MAC (mac_npi1, conf.conf_smac);
				CP_MAC (mac_mcast_V3rpt, conf.conf_dmac);
				conf.conf_sip						= ip_npi1;
				conf.conf_dip						= mcast_V3rpt;
				conf.ip.id							= 0xa;
				conf.ip.mf						= 0;
				conf.ip.offset						= 0;
				conf.ip.ttl							= 1;		/* igmp ttl */
				conf.igmp.ver						= 3;
				conf.igmp.type					= IGMP_V3_REPORT;
				conf.igmp.rnofg					= 2;
				conf.igmp.grCfg					= grCfgArr;
				conf.igmp.respTime				= 100;
				conf.igmp.gaddr					= mcast_1;
				conf.payload.content				= NULL;
				conf.payload.length				= 0;

				conf.conf_vlanIdx					= 2;
				conf.conf_pppoeIdx				= 0;
				SET_RX_PORT(conf.conf_portlist, 1);

				mbuf_in = genMbufPkt(&conf);
				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				if (Mirror)
				{
					VALUE_CMP(retval, FWDENG_IGMPPKT);
					mbuf_comp = genMbufPkt(&conf);
					MBUF_CMPandFREE(mbuf_in, mbuf_comp);
				}else
				{
					VALUE_CMP(retval, SUCCESS);
				}

				// if NoProc == TRUE -> system must process mcast_2
				VALUE_CMP(mbufList_nmbuf(), 1);	// for mcast_2

				/*
					Report to upstream: for mcast_2
				*/
				// Report
				{
					{
						{	// group report
							grCfg.type = IGMP_MODE_ISEX;
							grCfg.gaddr = mcast_2;
							grCfg.auxlen = 0;
							grCfg.nofs = 0;
							grCfg.slist = NULL;
							grCfg.auxdata = NULL;
						}

						RESET_CONF(&conf);
						conf.pktType						= _PKT_TYPE_IGMP;					/* igmp packet */
						conf.l2Flag						= 0;
						conf.ErrFlag						= 0;
						conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD);
						conf.conf_Flags					&= ~(CSUM_IP|CSUM_L4);
						CP_MAC (mac_gw_ext, conf.conf_smac);
						CP_MAC (mac_pppoe, conf.conf_dmac);
						conf.conf_sip						= ip_gw_ext;
						conf.conf_dip						= mcast_V3rpt;
						conf.ip.id							= SID;
						conf.ip.mf						= 0;
						conf.ip.offset						= 0;
						conf.ip.ttl							= 1;		/* igmp ttl */
						conf.igmp.ver						= 3;
						conf.igmp.type					= IGMP_V3_REPORT;
						conf.igmp.rnofg					= 1;
						conf.igmp.grCfg					= &grCfg;
						conf.igmp.respTime				= 100;
						conf.igmp.gaddr					= mcast_2;
						conf.payload.content				= NULL;
						conf.payload.length				= 0;
						conf.conf_vlanIdx					= 1;
						ADD_TX_PORT(conf.conf_portlist, 0);
						mbuf_comp = genMbufPkt(&conf);

						MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
					}
				}
			}
		}

		// send packet : mcast_1
		mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		if (Mirror)
		{
			VALUE_CMP(retval, FWDENG_IP_MULTICAST);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}else
		{
			VALUE_CMP(retval, SUCCESS);
		}
		if (NoProc)
		{
			VALUE_CMP(mbufList_nmbuf(), 0);
		}else
		{
			VALUE_CMP(mbufList_nmbuf(), 1);
		}

		if (!NoProc)
		{
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}

		// send packet : mcast_2
		mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
					upstream1, mcast_2, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA( NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_mcast_2,
				upstream1, mcast_2, 4, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

		
		// finally: we update time instead of reply any report, then fwdeng will goto timeout and report v3 TO_IN{} to upstream
		// for NoProc == TRUE, only 1 packet is sent each time for mcast_2
		{
			uint32 i;

			// query and wait timeout
			mbufList_Reinit();
			_rtl8651_timeUpdate(RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST);
			if (NoProc)
			{
				VALUE_CMP(mbufList_nmbuf(), 1);
			}else
			{
				VALUE_CMP(mbufList_nmbuf(), 2);
			}
			// timeout: start LMQC query
			mbufList_Reinit();
			_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);
			if (NoProc)
			{
				VALUE_CMP(mbufList_nmbuf(), 1);
			}else
			{
				VALUE_CMP(mbufList_nmbuf(), 2);
			}
			// expire state
			for (i = 0 ; i < (RTL8651_IGMP_LMQC_TEST-1) ; i ++)
			{
				mbufList_Reinit();
				_rtl8651_timeUpdate(RTL8651_IGMP_LMQI_TEST);
				if (NoProc)
				{
					VALUE_CMP(mbufList_nmbuf(), 1);
				}else
				{
					VALUE_CMP(mbufList_nmbuf(), 2);
				}
			}
			// after QRI + RESPONSE_TOLERANCE_DELAY -> timeout and send report to upstream
			mbufList_Reinit();
			_rtl8651_timeUpdate(RTL8651_IGMP_QRI_TEST + RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST);
			if (NoProc)
			{
				VALUE_CMP(mbufList_nmbuf(), 1);
			}else
			{
				VALUE_CMP(mbufList_nmbuf(), 2);
			}
			
			mbufList_Reinit();
		}
	}
	return SUCCESS;
}


/*
@func Testing		| Multicast IGMP-Filter1	| Multicast system packet filter testing
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : packet filter, test for packet {mirror}/{ignore}/{to-protocol stack} setting by upstream
 */
int32 pkt_multicast_igmp_Filter1(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfgArr[10];
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/**********************************************
		for a specific group address:
		set the action
					1. mirror and process multicast packet
						- V1/V2/V3 : process this packet (IGMP and multicast) and trap it
					2. silently igore this packet
						- V1/V2	: drop this packet (IGMP and multicast) silently
						- V3		: for IGMP query and multicast packet for this group, drop it
								  for IGMP report packet, if all of group records need to drop, we ignore it,
								  if some of group records need process, than we process those group records only.
					3. don't process packet and trap to protocol stack
						- V1/V2	: trap this packet directly
						- V3		: for IGMP query and multicast packet for this group, trap it directly
								  for IGMP report packet, if one of group records needs to drop, then we must trap it up,
								  and for the group records which need to trap, we don't process then

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_general = ntohl(inet_addr("224.0.0.1"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.2.254"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_general = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x01}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_upstream1 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x01}}; 
	ether_addr_t mac_upstream2 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x02}}; 
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	int32 cnt;
	const int32 LoopCnt = 100;
	int32 CurrentTime;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);

	ASSERT(rtl8651_addArp(ip_npi1, &mac_npi1, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi3, &mac_npi3, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addArp(upstream2, &mac_upstream2, "wan2", 5) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	/*******************************************************
		Test (1)
			* set MIRROR only
			* process this group and trap this pkt to protocol stack
	********************************************************/
	// stage 1: before set MIRROR, any version/packet are processed normally
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);
	// stage 2: set MIRROR to mcast1, any version/packet are processed normally and the original packet is trapped
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, FALSE), SUCCESS);
	// stage 3: remove NOPROC from mcast1, system still trap mcast1 packets
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, FALSE), SUCCESS);
	// stage 4: set MIRROR to mcast1 again, system is same as (2)
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, FALSE), SUCCESS);
	// stage 5: remove MIRROR from mcast1, any version/packet are processed normally and the original packet isn't trapped
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);
	/*******************************************************
		Test (2)
			* set NOPROC only
			* ignore this group silently
	********************************************************/
	// stage 1: before set NOPROC, any version/packet are processed normally
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);
	// stage 2: set NOPROC to mcast1, any version/packet are processed normally but process for mcast1 is ignored
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 3: remove MIRROR from mcast1, system still ignore mcast1 process
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 4: set NOPROC to mcast1 again, system is ame as (2)
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 5: remove NOPROC from mcast1, any version/packet are processed normally again
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);

	/*******************************************************
		Test (3)
			* set MIRROR and NOPROC
			* ignore this group and trap this pkt to protocol stack
	********************************************************/
	// stage 1: before set, any version/packet are processed normally
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);
	// stage 2: set NOPROC to mcast1, any version/packet are processed normally but process for mcast1 is ignored
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 3: set MIRROR to mcast1, system trap and ignore all packet about mcast1
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, TRUE), SUCCESS);
	// stage 4: remove NOPROC from mcast1, now, system setting is MIRROR only, system trap and process all packet for mcast1
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, FALSE), SUCCESS);
	// stage 5: set MIRROR to mcast1 again, system is same as (stage 4)
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, FALSE), SUCCESS);
	// stage 6: remove NOPROC from mcast1 again, system is same as (stage 4)
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, FALSE), SUCCESS);
	// stage 7: set NOPROC to mcast1, system trap and ignore all packet about mcast1
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, TRUE), SUCCESS);
	// stage 8: remove MIRROR from mcast1, now, system setting is NOPROC only, ignore all packet for mcast1
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 9: set NOPROC to mcast1 again, system is same as (stage 8)
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_NOPROC) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 10: remove MIRROR from mcast1 again, system is same as (stage 8)
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, TRUE), SUCCESS);
	// stage 11: set MIRROR to mcast1, system trap and ignore all packet about mcast1
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, MCAST_FILTER_ACT_MIRROR) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, TRUE), SUCCESS);
	// stage 12: set MIRROR and NOPROC to mcast1, system is same as (stage 11)
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, (MCAST_FILTER_ACT_MIRROR|MCAST_FILTER_ACT_NOPROC)) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, TRUE), SUCCESS);
	// stage 13: remove MIRROR and NOPROC from mcast1, system is back to initial state
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, (MCAST_FILTER_ACT_MIRROR|MCAST_FILTER_ACT_NOPROC)) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);
	// stage 14: set MIRROR and NOPROC to mcast1, system trap and ignore processing for mcast1 again
	ASSERT(rtl8651_multicast_AddFilter(mcast_1, (MCAST_FILTER_ACT_MIRROR|MCAST_FILTER_ACT_NOPROC)) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(TRUE, TRUE), SUCCESS);
	// stage 15: finally, remove MIRROR and NOPROC from mcast1, system is back to initial state
	ASSERT(rtl8651_multicast_RemoveFilter(mcast_1, (MCAST_FILTER_ACT_MIRROR|MCAST_FILTER_ACT_NOPROC)) == SUCCESS);
	VALUE_CMP(pkt_multicast_igmp_Filter1_Flow(FALSE, FALSE), SUCCESS);

	return SUCCESS;
}


/*
@func Testing		| Multicast IGMP-Flow Cache 1	| Multicast system testing for Multicast flow cache
@rvalue SUCCESS	| 	test OK
@comm
Multicast system function test : test the forwarding cache correctness
 */
int32 pkt_multicast_flowCache1(uint32 caseNo) {
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	rtl8651_IgmpGrConf_t grCfg;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/**********************************************
		Set upstream to wan

		test for:

			join		-> multicast forward
			leave	-> stop forward
			join		-> forward resume

	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi1 = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.2"));
	ipaddr_t ip_npi3 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t mcast_V3rpt = ntohl(inet_addr("224.0.0.22"));
	ipaddr_t mcast_1 = ntohl(inet_addr("234.1.1.1"));
	ipaddr_t mcast_2 = ntohl(inet_addr("234.1.1.2"));
	ipaddr_t mcast_3 = ntohl(inet_addr("234.1.1.3"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi1 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ether_addr_t mac_npi3 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t upstream1 = ntohl(inet_addr("10.113.1.254"));
	ipaddr_t upstream2 = ntohl(inet_addr("10.113.2.254"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw = 0x1234;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_mcast_V3rpt = {{0x01, 0x00, 0x5e, 0x00, 0x00, 0x22}};
	ether_addr_t mac_mcast_1 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x01}};
	ether_addr_t mac_mcast_2 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x02}};
	ether_addr_t mac_mcast_3 = {{0x01, 0x00, 0x5e, 0x01, 0x01, 0x03}};
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_upstream1 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x01}}; 
	ether_addr_t mac_upstream2 = {{0x00, 0x01, 0x01, 0x01, 0x01, 0x02}}; 
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 system_id = 1;
	#define SID system_id
	int32 cnt;
	const int32 LoopCnt = 100;
	int32 CurrentTime;
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
 	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	/* set default igmp upstream */
	ASSERT(rtl8651_multicastSetUpStream("pppoe", 0) == SUCCESS);

	ASSERT(rtl8651_addArp(ip_npi1, &mac_npi1, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi3, &mac_npi3, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addArp(upstream2, &mac_upstream2, "wan2", 5) == SUCCESS);

	// turn off dos
	rtl8651a_setDosStatus(0, 0);

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= (RTL8651_IGMP_QI_TEST * 2);
		para.igmp_sqi					= RTL8651_IGMP_SQI;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= RTL8651_IGMP_RESPONSE_TOLERANCE_DELAY_TEST;
		para.igmp_qri					= RTL8651_IGMP_QRI_TEST;
		para.igmp_qi					= RTL8651_IGMP_QI_TEST;
		para.igmp_oqpi				= RTL8651_IGMP_OQPI;
		para.igmp_gmi				= RTL8651_IGMP_GMI_TEST;
		para.igmp_lmqi				= RTL8651_IGMP_LMQI_TEST;
		para.igmp_lmqc				= RTL8651_IGMP_LMQC_TEST;
		para.igmp_group_query_interval= RTL8651_IGMP_GROUP_QUERY_INTERVAL_TEST;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}

	_rtl8651_setMcastProcessOptions(MCAST_PROC_EXPIRE_STATE_DONT_FWD);

	// set DEFAULT ID to system id
	DEFAULT_IP_ID = SID;

	for (cnt = 0 ; cnt < LoopCnt ; cnt ++)
	{
		/*
			IGMP V2 Report from npi1 for multicast group 1
		*/
		{
			mbuf_in = confIgmpHSB(NULL,
						1, 2, FALSE, 0,
						mac_npi1, mac_mcast_1, 0,
						ip_npi1, mcast_1, 1, 0, 0,
						IGMPV2, IGMP_V2_REPORT, 100, mcast_1,
						0, 0, 0, NULL, 0, NULL, NULL, 0);	

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);

			/*
				Report to upstream
			*/
			{
				{	// group report
					grCfg.type = IGMP_MODE_ISEX;
					grCfg.gaddr = mcast_1;
					grCfg.auxlen = 0;
					grCfg.nofs = 0;
					grCfg.slist = NULL;
					grCfg.auxdata = NULL;
				}

				{
					uint16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confIgmpHSA(&conf,
							tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
							ip_gw_ext, mcast_V3rpt, 1, 0, 0,
							IGMPV3, IGMP_V3_REPORT, 0, 0,
							0, 0, 0, 0,
							1, &grCfg, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}
		}
		/*
			send mcast1 packet, we forward it
		*/
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 2, 0,
					mac_gw_int, mac_mcast_1,
					upstream1, mcast_1, 4, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}

		/* we can get the forwarding cache here !*/
		{
			rtl8651_tblDrv_mCast_t *m_data;

			m_data = _rtl8651_findMCast(mcast_1, upstream1, 1, 0);
			ASSERT(m_data);

			VALUE_CMP(m_data->mbr, 1<<1);
			VALUE_CMP(m_data->vlanMask, 1<<2);
			VALUE_CMP(m_data->flag, 0);
		}

		
		/*
			IGMP V2 Leave from npi1 for multicast group 1
		*/
		{
			mbuf_in = confIgmpHSB(NULL,
						1, 2, FALSE, 0,
						mac_npi1, mac_mcast_1, 0,
						ip_npi1, mcast_1, 1, 0, 0,
						IGMPV2, IGMP_V2_LEAVE, 100, mcast_1,
						0, 0, 0, NULL, 0, NULL, NULL, 0);	

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);

			/*
				Query
			*/
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confIgmpHSA(NULL,
					tx_port, 2, FALSE, 0,
					mac_gw_int, mac_mcast_1, 0,
					ip_gw_int, mcast_1, 1, 0, 0,
					IGMPV2, IGMP_QUERY, 100, mcast_1,
					0, 0, 0, NULL, 0, NULL, NULL, 0);
			}	

			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		}
		/*
			send mcast1 packet, we don't forward it
		*/
		{
			mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_mcast_1, 0,
					upstream1, mcast_1, 5, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}

		/* we can NOT get the forwarding cache noew !*/
		{
			rtl8651_tblDrv_mCast_t *m_data;

			m_data = _rtl8651_findMCast(mcast_1, upstream1, 1, 0);
			ASSERT(m_data == NULL);
		}

		/*
			wait 10000 sec for entry expire
		*/
		_rtl8651_timeUpdate(10000);
		mbufList_Reinit();	/* free all gateway's query and report */


		/************************************************************************************
			Test Upload
		************************************************************************************/
		{
			/* upload : this packet is dropped due to TTL is decreased to 1 */
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi1, mac_mcast_2,
				ip_npi1, mcast_2, 1, 0, 0,
				port_npi, port_rp,
				0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);

			/* we still can get forwarding cache here !*/
			{
				rtl8651_tblDrv_mCast_t *m_data;

				m_data = _rtl8651_findMCast(mcast_2, ip_npi1, 2, 1);
				ASSERT(m_data);

				VALUE_CMP(m_data->mbr, 1<<0);
				VALUE_CMP(m_data->vlanMask, 1<<1);
				VALUE_CMP(m_data->flag, RTL865X_MULTICAST_UPLOADONLY|RTL865X_MULTICAST_EXTIP_SET|RTL865X_MULTICAST_PPPOEPATCH_CPUBIT);
			}			

			/* upload : this packet can be forwarded to upstream */
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi1, mac_mcast_2,
				ip_npi1, mcast_2, 2, 0, 0,
				port_npi, port_rp,
				0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(NULL, NULL,
					_PKT_TYPE_UDP, tx_port, 1, 0,
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, mcast_2, 1, 0, 0,
					port_npi, port_rp,
					0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
			}
			MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

			/*
				IGMP V2 Report from npi3 for multicast group 2
			*/
			{
				mbuf_in = confIgmpHSB(NULL,
							4, 3, FALSE, 0,
							mac_npi3, mac_mcast_2, 0,
							ip_npi3, mcast_2, 1, 0, 0,
							IGMPV2, IGMP_V2_REPORT, 100, mcast_2,
							0, 0, 0, NULL, 0, NULL, NULL, 0);	

				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);

				/*
					Report to upstream
				*/
				{
					{	// group report
						grCfg.type = IGMP_MODE_ISEX;
						grCfg.gaddr = mcast_2;
						grCfg.auxlen = 0;
						grCfg.nofs = 0;
						grCfg.slist = NULL;
						grCfg.auxdata = NULL;
					}

					{
						uint16 tx_port[2] = {0, 0xffff};
						mbuf_comp = confIgmpHSA(&conf,
								tx_port, 1, TRUE, 0, mac_gw_ext, mac_pppoe, 0,
								ip_gw_ext, mcast_V3rpt, 1, 0, 0,
								IGMPV3, IGMP_V3_REPORT, 0, 0,
								0, 0, 0, 0,
								1, &grCfg, NULL, 0);
					}
				}
				MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
			}

			/* forwarding cache must be modified here !*/
			{
				rtl8651_tblDrv_mCast_t *m_data;

				m_data = _rtl8651_findMCast(mcast_2, ip_npi1, 2, 1);
				ASSERT(m_data);

				VALUE_CMP(m_data->mbr, 1<<4);
				VALUE_CMP(m_data->vlanMask, 1<<3);
				VALUE_CMP(m_data->flag, 0);
			}			

			
			/*
				wait 10000 sec for entry expire
			*/
			mbufList_Reinit();	/* free all gateway's query and report */
			_rtl8651_timeUpdate(10000);
			mbufList_Reinit();	/* free all gateway's query and report */
		}

		
	}

	return SUCCESS;
}


#endif /* CONFIG_RTL865X_MULTICAST */

static uint32 pppoeRxPkts[2], pppoeRxBytes[2], pppoeTxPkts[2], pppoeTxBytes[2];

int32 pktPppoeCntrCmp(uint8 pppIdx, uint32 objectId) {
	rtl865x_tblDrv_basicCounterParam_t pppoeCntr;
	static uint32 idx;
	
	if(rtl8651_getPppoeCounter(objectId, &pppoeCntr)!=SUCCESS)
		return FAILED;
	if(pppoeCntr.txPackets != pppoeTxPkts[pppIdx])
		return FAILED;
	if(pppoeCntr.txBytes != pppoeTxBytes[pppIdx])
		return FAILED;
	if(pppoeCntr.rxPackets != pppoeRxPkts[pppIdx])
		return FAILED;
	if(pppoeCntr.rxBytes != pppoeRxBytes[pppIdx])
		return FAILED;
	return SUCCESS;
}

#ifdef RTL_FWDENG_POLICYRT_TEST
/*
@func int32		| napt_policy_1	| napt Policy testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function for TCP/UDP NAPT packets
 */
int32 pkt_napt_policy1(uint32 caseNo){
	/**********************************************
		NAPT test

		2 wan(pppoe), 1 lan

		for tcp/udp SIP/DIP/DPORT policy route

		TCP
		NPI	->	RP, SYN
		RP	->	NPI, SYN,ACK
		NPI	->	RP, ACK
		NPI	->	RP, long packet		(fast path)
		RP	->	NPI, normal packet		(fast path)
		NPI	->	RP, FIN
		RP	->	NPI, FIN, ACK
		NPI	->	RP, ACK

		UDP
		NPI	->	RP					(slow path)
		RP	->	NPI					(fast path)
		NPI 	->	RP					(fast path)
		RP	->	NPI					(fast path)

		test for:
				1. napt slow path
				2. napt fast path
				3. l3ActRouting's fragment
				4. PPPoE
				5. ARP auto generate
				6. queue packet for ARP
				7. arp-receive and dequeue packet
		
	***********************************************/
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 nCount;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	uint16 port_npi = 0x9876;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x1112;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	//		3) dport
	//
	int32 loop_cnt = 4;
	ipaddr_t npi_addr[4]	= {ip_npi		, ip_npi2		, ip_npi		, ip_npi};
	ipaddr_t rp_addr[4]	= {ip_rp		, ip_rp		, ip_rp2		, ip_rp};
	uint16 npi_port[4]		= {port_npi	, port_npi		, port_npi		, port_npi};
	uint16 rp_port[4]		= {port_rp	, port_rp		, port_rp		, port_rp2};
	ipaddr_t gw_addr[4]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	, ip_gw_ext2};
	ether_addr_t mac_s[4] = {mac_pppoe, mac_pppoe2, mac_pppoe2, mac_pppoe2};
	uint8 pppoe_idx[4]	= {0			,1			, 1			, 1};
	uint16 pppoeSessionId[4] = {11111, 22222, 22222, 22222};//This value depend on pppoe_idx and fwdeng_env_configuration_2 setting
	uint32 pppoeObjectId[4] = { 1000, 1001, 1001, 1001};//This value depend on pppoe_idx and fwdeng_env_configuration_2 setting
	
	ipaddr_t lip, wip, gip;
	uint32 objectId;
	uint16 lport, wport, sessionId;
	uint8 pppIdx;
	ether_addr_t macPppoe;

	bzero(pkt_content, sizeof(pkt_content));
	for(pppIdx=0; pppIdx<2; pppIdx++) {
		pppoeRxPkts[pppIdx] = 0;
		pppoeRxBytes[pppIdx] = 0;
		pppoeTxPkts[pppIdx] = 0;
		pppoeTxBytes[pppIdx] = 0;
	}
	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

/*************

	TCP test

*************/
for (loop_cnt = 0 ; loop_cnt < 4 ; loop_cnt ++)
{
	lip = npi_addr[loop_cnt];
	wip = rp_addr[loop_cnt];
	gip = gw_addr[loop_cnt];
	lport = npi_port[loop_cnt];
	wport = rp_port[loop_cnt];
	pppIdx = pppoe_idx[loop_cnt];
	sessionId = pppoeSessionId[loop_cnt];
	objectId = pppoeObjectId[loop_cnt];
	macPppoe = mac_s[loop_cnt];

	/*
		NPI	->	RP :
					Slow path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
	{
		/* config */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
						lip, wip, 255, 0, 0,
						lport, wport, (TH_SYN), 1460, 0, 0, NULL, 0);
		pppoeTxPkts[pppIdx] ++;
		pppoeTxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		pktPppoeCntrCmp(pppIdx, objectId);
	
		/* check result */
		VALUE_CMP(retval, SUCCESS);	
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		// get external port
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
							gip, wip, 254, 0, 0,
							port_gw, wport, (TH_SYN), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}

	/*
		RP	->	NPI :
					Slow path (SYN, ACK)
					Output:	NAPT reverse translate
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, pppIdx, macPppoe, mac_gw_ext, sessionId,
						wip, gip, 123, 0, 0,
						wport, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
	
		pppoeRxPkts[pppIdx] ++;
		pppoeRxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		ASSERT(pktPppoeCntrCmp(pppIdx, objectId)==SUCCESS);

		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_list[2] = {1, 0xffff};	
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
							wip, lip, 122, 0, 0,
							wport, lport, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	RP :
					Slow path (ACK)
					Output:	NAPT revse translate
	*/
	{
		/* config */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
						lip, wip, 255, 0, 0,
						lport, wport, (TH_ACK), 0, 0, 0, NULL, 0);
		pppoeTxPkts[pppIdx] ++;
		pppoeTxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		ASSERT(pktPppoeCntrCmp(pppIdx, objectId)==SUCCESS);
	
		VALUE_CMP(retval, SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
							gip, wip, 254, 0, 0,
							port_gw, wport, (TH_ACK), 0, 0, 0, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	// fast path
	for (nCount = 0; nCount < 10 ; nCount ++)
	{
			/*
				NPI	->	RP :
							Fast path
							Output:	NAPT reverse translate with setting PPPoE auto-added
			*/
		{
			/* config */
			mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
							lip, wip, 255, 0, 0,
							lport, wport, (TH_ACK), 0, 0, 0, pkt_content, 1452);
			pppoeTxPkts[pppIdx] ++;
			pppoeTxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			pktPppoeCntrCmp(pppIdx, objectId);
			VALUE_CMP(retval, SUCCESS);

			{
				uint16 tx_list[2] = {0, 0xffff};	
				mbuf_comp = confPppoeHSA(&conf, NULL,
								_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
								gip, wip, 254, 0, 0,
								port_gw, wport, (TH_ACK), 0, 0, 0, pkt_content, 1452);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
			/*
				RP	->	NPI :
							Fast path
							Output:	NAPT translate with setting PPPoE auto-added
			*/
		{
			/* config */
			mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_TCP, 0, 1, pppIdx, macPppoe, mac_gw_ext, sessionId,
							wip, gip, 123, 0, 0,
							wport, port_gw, TH_ACK, 0, 0, 0, pkt_content, 1452);
			pppoeRxPkts[pppIdx] ++;
			pppoeRxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			pktPppoeCntrCmp(pppIdx, objectId);
			VALUE_CMP(retval, SUCCESS);

			{
					uint16 tx_list[2] = {1, 0xffff};	
				mbuf_comp = confVlanHSA(&conf, NULL,
								_PKT_TYPE_TCP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
								wip, lip, 122, 0, 0,
								wport, lport, TH_ACK, 1452, 0, 0, pkt_content, 1452);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}// fast path
	/*
		NPI	->	RP :
					Fast path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
	{
		/* config */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
						lip, wip, 255, 0, 0,
						lport, wport, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, 1452);
		pppoeTxPkts[pppIdx] ++;
		pppoeTxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		pktPppoeCntrCmp(pppIdx, objectId);
		VALUE_CMP(retval, SUCCESS);
	
		/* check output packet */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
							gip, wip, 254, 0, 0,
							port_gw, wport, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, 1452);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		RP	->	NPI :
					Fast path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, pppIdx, macPppoe, mac_gw_ext, sessionId,
						wip, gip, 123, 0, 0,
						wport, port_gw, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, 1452);

		pppoeRxPkts[pppIdx] ++;
		pppoeRxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		pktPppoeCntrCmp(pppIdx, objectId);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_list[2] = {1, 0xffff};	
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
							wip, lip, 122, 0, 0,
							wport, lport, (TH_FIN|TH_ACK), 0, 0, 0, pkt_content, 1452);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/*
		NPI	->	RP :
					Fast path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
	{
		/* config */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
						lip, wip, 255, 0, 0,
						lport, wport, (TH_ACK), 0, 0, 0, pkt_content, 1452);
		pppoeTxPkts[pppIdx] ++;
		pppoeTxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		pktPppoeCntrCmp(pppIdx, objectId);

		/* check result */
		VALUE_CMP(retval, SUCCESS);

		/* check output packet */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
							gip, wip, 254, 0, 0,
							port_gw, wport, (TH_ACK), 0, 0, 0, pkt_content, 1452);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
}// TCP Test

/*************

	UDP test

*************/
for (loop_cnt = 0 ; loop_cnt < 4 ; loop_cnt ++)
{
	lip = npi_addr[loop_cnt];
	wip = rp_addr[loop_cnt];
	gip = gw_addr[loop_cnt];
	lport = npi_port[loop_cnt];
	wport = rp_port[loop_cnt];
	pppIdx = pppoe_idx[loop_cnt];
	sessionId = pppoeSessionId[loop_cnt];
	objectId = pppoeObjectId[loop_cnt];
	macPppoe = mac_s[loop_cnt];

	for (nCount = 0 ; nCount < 10 ; nCount ++)
	{
		/*
			NPI	->	RP :
						Slow path
						Output:	NAPT translate with setting PPPoE auto-added
		*/
		{
			/* config */
			mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_UDP, 1, 2, pppIdx, mac_npi, mac_gw_int,
							lip, wip, 255, 0, 0,
							lport, wport, 0, 0, 0, 0, pkt_content, 1452);
			pppoeTxPkts[pppIdx] ++;
			pppoeTxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			pktPppoeCntrCmp(pppIdx, objectId);
			VALUE_CMP(retval, SUCCESS);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

			{
				uint16 tx_list[2] = {0, 0xffff};	
				mbuf_comp = confPppoeHSA(&conf, NULL,
								_PKT_TYPE_UDP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
								gip, wip, 254, 0, 0,
								port_gw, wport, 0, 0, 0, 0, pkt_content, 1452);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
		/*
			RP	->	NPI :
						Output:	NAPT translate with setting PPPoE auto-added
		*/
		{
			/* config */
			mbuf_in = confPppoeHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, pppIdx, macPppoe, mac_gw_ext, sessionId,
							wip, gip, 123, 0, 0,
							wport, port_gw, 0, 0, 0, 0, pkt_content, 1452);
	
			pppoeRxPkts[pppIdx] ++;
			pppoeRxBytes[pppIdx] += mbuf_in->m_pkthdr->ph_len;
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			pktPppoeCntrCmp(pppIdx, objectId);
			VALUE_CMP(retval, SUCCESS);
	
			{
				uint16 tx_list[2] = {1, 0xffff};	
				mbuf_comp = confVlanHSA(&conf, NULL,
								_PKT_TYPE_UDP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
								wip, lip, 122, 0, 0,
								wport, lport, 0, 0, 0, 0, pkt_content, 1452);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
}

	return SUCCESS;
}
/*
@func int32		| napt_policy_2	| napt Policy testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function for ICMP NAPT packets
 */
int32 pkt_napt_policy2(uint32 caseNo){
	/**********************************************
		ICMP test

		3 wan(pppoe), 1 lan

		for icmp SIP/DIP policy route

		ICMP
		NPI	->	RP	ECHO
		RP	->	NPI	ECHO_REPLY
		NPI	->	RP	TSTAMP
		RP	->	NPI	TSTAMP_REPLY
	***********************************************/
	int8 pkt_content[1024];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 id_int = 0x1, id_ext;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	int32 loop_cnt = 3;
	ipaddr_t npi_addr[3]	= {ip_npi		, ip_npi2		, ip_npi		};
	ipaddr_t rp_addr[3]	= {ip_rp		, ip_rp		, ip_rp2		};
	ipaddr_t gw_addr[3]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	};
	uint8 pppoe_idx[3]	= {0			,1			, 1			};
	ether_addr_t mac_s[3]  = {mac_pppoe, mac_pppoe2, mac_pppoe2};

	int32 nCount;
	uint8 icmp_request[2]	= {ICMP_ECHO, ICMP_TSTAMP};
	uint8 icmp_reply[2]	= {ICMP_ECHOREPLY, ICMP_TSTAMPREPLY};
	
	ipaddr_t lip, wip, gip; 
	uint8 icmp_req, icmp_rep;
	uint8 pppIdx;
	ether_addr_t macPppoe;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

for (nCount = 0 ; nCount < 2 ; nCount ++)
for (loop_cnt = 0 ; loop_cnt < 3 ; loop_cnt ++)
{
	icmp_req = icmp_request[nCount];
	icmp_rep = icmp_reply[nCount];
	
	lip = npi_addr[loop_cnt];
	wip = rp_addr[loop_cnt];
	gip = gw_addr[loop_cnt];
 	pppIdx = pppoe_idx[loop_cnt];
	macPppoe = mac_s[loop_cnt];
	/*
		NPI	->	RP :
					Output:	NAPT translate with setting PPPoE auto-added
	*/
	{
		/* config */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_ICMP, 1, 2, pppIdx, mac_npi, mac_gw_int,
						lip, wip, 234, 0, 0,
						0, 0, 0, 0, icmp_req, id_int, NULL, 0);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
		/* check result */
		VALUE_CMP(retval, SUCCESS);	
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		// get external port
		ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &id_ext)==SUCCESS);

		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
							gip, wip, 233, 0, 0,
							0, 0, 0, 0, icmp_req, id_ext, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	
	/*
		RP	->	NPI :
					Output:	NAPT translate with setting PPPoE auto-added
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_ICMP, 0, 1, pppIdx, macPppoe, mac_gw_ext, 0,
						wip, gip, 123, 0, 0,
						0, 0, 0, 0, icmp_rep, id_ext, NULL, 0);
	
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		{
			uint16 tx_list[2] = {1, 0xffff};	
			mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_ICMP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
							wip, lip, 122, 0, 0,
							0, 0, 0, 0, icmp_rep, id_int, NULL, 0);
		}
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
}// ICMP Test
	return SUCCESS;
}
/*
@func int32		| napt_policy_3	| napt Policy testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function: An error message (TCP or UDP) from Internal-Host to Remote-Host through policy route,
and ICMP error messages from Remote-Host to Internal-Host must through policy route, too.
 */
int32 pkt_napt_policy3(uint32 caseNo){
	/**********************************************
		ICMP test

		3 wan(pppoe), 1 lan
		for icmp SIP/DIP policy route

		NPI	->	RP	(TCP<SYN> or UDP)	(error flow)
		RP	->	NPI, ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB
	***********************************************/
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	uint16 port_npi = 0x9876;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x1112;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	//		3) dport
	//
	int32 err_cnt = 2;
	int32 icmp_cnt = 4;
	int32 loop_cnt = 4;
	ipaddr_t npi_addr[4]	= {ip_npi		, ip_npi2		, ip_npi		, ip_npi};
	ipaddr_t rp_addr[4]	= {ip_rp		, ip_rp		, ip_rp2		, ip_rp};
	uint16 rp_port[4]		= {port_rp	, port_rp		, port_rp		, port_rp2};
	ipaddr_t gw_addr[4]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	, ip_gw_ext2};
	uint8 pppoe_idx[4]	= {0			,1			, 1			, 1};
	uint8 ic_type[4]		= {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	ether_addr_t mac_s[4]	= {mac_pppoe, mac_pppoe2, mac_pppoe2, mac_pppoe2};

	ipaddr_t lip, wip, gip;
	uint16  wport;
	uint8 pppIdx;
	uint8 icmp_type;
	ether_addr_t macPppoe;
	uint16 id = 0xa;

	START_TEST_CASE();
	bzero(pkt_content, sizeof(pkt_content));
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

	for (err_cnt = 0 ; err_cnt < 2 ; err_cnt ++)
	for (loop_cnt = 0 ; loop_cnt < 4 ; loop_cnt ++)
	{	
		lip = npi_addr[loop_cnt];
		wip = rp_addr[loop_cnt];
		gip = gw_addr[loop_cnt];
		wport = rp_port[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		macPppoe = mac_s[loop_cnt];

		/*
			NPI	->	RP:	TCP, SYN (Error Flow)
		*/
		if (err_cnt == 0)
		{
			mbuf_in = confVlanHSB(&conf_err_int, NULL,
							_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
							lip, wip, 123, 0, 0,
							port_npi, wport, (TH_SYN), 1460, 0, 0, NULL, 0);
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			/* check result */
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
			{
				uint16 tx_list[2] = {0, 0xffff};	
				mbuf_comp = confPppoeHSA(&conf_err_ext, NULL,
								_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
								gip, wip, 122, 0, 0,
								port_gw, wport, (TH_SYN), 1452, 0, 0, NULL, 0);
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
		/*
			NPI	->	RP:	UDP (Error Flow)
		*/
		if (err_cnt == 1)
		{
			mbuf_in = confVlanHSB(&conf_err_int, NULL,
							_PKT_TYPE_UDP, 1, 2, pppIdx, mac_npi, mac_gw_int,
							lip, wip, 121, 0, 0,
							port_npi, wport, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			/* check result */
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
			{
				uint16 tx_list[2] = {0, 0xffff};	
				mbuf_comp = confPppoeHSA(&conf_err_ext, NULL,
								_PKT_TYPE_UDP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
								gip, wip, 120, 0, 0,
								port_gw, wport, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
		/*
			RP	->	NPI:	ICMP ERROR Message
		*/
		for (icmp_cnt = 0 ; icmp_cnt < 4 ; icmp_cnt ++)
		{
			icmp_type = ic_type[icmp_cnt];
			// must set mss/ttl to be the same (for comparison issue)
			conf_err_int.conf_tcp_mss = conf_err_ext.conf_tcp_mss;
			conf_err_int.ip.ttl = conf_err_ext.ip.ttl;
		
			mbuf_in = confPppoeHSB(&conf, &conf_err_ext,
								_PKT_TYPE_ICMP, 0, 1, pppIdx, macPppoe, mac_gw_ext, 0,
								wip, gip, 98, 0, 0,
								0, 0, 0, 0, icmp_type, id, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			/* check result */
			VALUE_CMP(retval, SUCCESS);

			{
				uint16 tx_list[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA(&conf, &conf_err_int,
								_PKT_TYPE_ICMP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
								wip, lip, 97, 0, 0,
								0, 0, 0, 0, icmp_type, id, NULL, 0);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	return SUCCESS;
}
/*
@func int32		| napt_policy_4	| napt Policy testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function: An error message (ICMP) from Internal-Host to Remote-Host through policy route,
and ICMP error messages from Remote-Host to Internal-Host must through policy route, too.
 */
int32 pkt_napt_policy4(uint32 caseNo){
	/**********************************************
		ICMP test

		3 wan(pppoe), 1 lan
		for icmp SIP/DIP policy route

		NPI	->	RP	ICMP	(error flow)
		RP	->	NPI, ICMP_UNREACH
		RP	->	NPI, ICMP_SOURCEQUENCH
		RP	->	NPI, ICMP_TIMXCEED
		RP	->	NPI, ICMP_PARAMPROB
	***********************************************/
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_gw_ext3 = ntohl(inet_addr("10.113.3.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	//		3) dport
	//
	int32 err_cnt = 2;
	int32 icmp_cnt = 4;
	int32 loop_cnt = 3;
	ipaddr_t npi_addr[3]	= {ip_npi		, ip_npi2		, ip_npi		};
	ipaddr_t rp_addr[3]	= {ip_rp		, ip_rp		, ip_rp2		};
	ipaddr_t gw_addr[3]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	};
	uint8 pppoe_idx[3]	= {0			,1			, 1			};
	uint8 ic_type[4]		= {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	uint8 err_type[2]		= {ICMP_ECHO, ICMP_TSTAMP};
	ether_addr_t mac_s[3]  = {mac_pppoe, mac_pppoe2, mac_pppoe2};

	ipaddr_t lip, wip, gip;
	uint8 pppIdx;
	uint8 error_type;
	uint8 icmp_type;
	ether_addr_t macPppoe;
	uint16 id = 0xa;

	START_TEST_CASE();
	bzero(pkt_content, sizeof(pkt_content));
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

	for (err_cnt = 0 ; err_cnt < 2 ; err_cnt ++)
	for (loop_cnt = 0 ; loop_cnt < 3 ; loop_cnt ++)
	{
		lip = npi_addr[loop_cnt];
		wip = rp_addr[loop_cnt];
		gip = gw_addr[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		macPppoe = mac_s[loop_cnt];
		error_type = err_type[err_cnt];

		/*
			NPI	->	RP:	ICMP (Error Flow)
		*/
		{
			uint16 id_ext;
		
			mbuf_in = confVlanHSB(&conf_err_int, NULL,
							_PKT_TYPE_ICMP, 1, 2, pppIdx, mac_npi, mac_gw_int,
							lip, wip, 121, 0, 0,
							0, 0, 0, 0, error_type, 10, pkt_content, sizeof(pkt_content));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			/* check result */
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			// get external port
			ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &id_ext)==SUCCESS);
			{
				uint16 tx_list[2] = {0, 0xffff};	
				mbuf_comp = confPppoeHSA(&conf_err_ext, NULL,
								_PKT_TYPE_ICMP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
								gip, wip, 120, 0, 0,
								0, 0, 0, 0, error_type, id_ext, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
		
		/*
			RP	->	NPI:	ICMP ERROR Message
		*/
		for (icmp_cnt = 0 ; icmp_cnt < 4 ; icmp_cnt ++)
		{
			icmp_type = ic_type[icmp_cnt];
			// must set ttl to be the same (for comparison issue)
			conf_err_int.ip.ttl = conf_err_ext.ip.ttl;
		
			mbuf_in = confPppoeHSB(&conf, &conf_err_ext,
								_PKT_TYPE_ICMP, 0, 1, pppIdx, macPppoe, mac_gw_ext, 0,
								wip, gip, 98, 0, 0,
								0, 0, 0, 0, icmp_type, id, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			/* check result */
			VALUE_CMP(retval, SUCCESS);

			{
				uint16 tx_list[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA(&conf, &conf_err_int,
								_PKT_TYPE_ICMP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
								wip, lip, 97, 0, 0,
								0, 0, 0, 0, icmp_type, id, NULL, 0);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	return SUCCESS;
}
/*
@func int32		| napt_policy_5	| napt Policy testing 5
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function: An error message (TCP or UDP) from Remote-Host to Internal-Host through policy route,
and ICMP error messages from Internal-Host to Remote-Host must through policy route, too.
 */
int32 pkt_napt_policy5(uint32 caseNo){
	/**********************************************
		ICMP test

		3 wan(pppoe), 1 lan
		for icmp SIP/DIP policy route

		NPI	->	RP	(TCP<SYN> or UDP)		(error flow)
		RP	->	NPI	(TCP<SYN|ACK> or UDP)	(error flow)

		NPI	->	RP, ICMP_UNREACH
		NPI	->	RP, ICMP_SOURCEQUENCH
		NPI	->	RP, ICMP_TIMXCEED
		NPI	->	RP, ICMP_PARAMPROB
	***********************************************/
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf, conf_err_ext, conf_err_int;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	uint16 port_npi = 0x9876;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x1112;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	//		3) dport
	//
	int32 err_cnt = 2;
	int32 icmp_cnt = 4;
	int32 loop_cnt = 4;
	ipaddr_t npi_addr[4]	= {ip_npi		, ip_npi2		, ip_npi		, ip_npi};
	ipaddr_t rp_addr[4]	= {ip_rp		, ip_rp		, ip_rp2		, ip_rp};
	uint16 rp_port[4]		= {port_rp	, port_rp		, port_rp		, port_rp2};
	ipaddr_t gw_addr[4]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	, ip_gw_ext2};
	uint8 pppoe_idx[4]	= {0			,1			, 1			, 1};
	uint8 ic_type[4]		= {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	ether_addr_t mac_s[4]	= {mac_pppoe, mac_pppoe2, mac_pppoe2, mac_pppoe2};

	ipaddr_t lip, wip, gip;
	uint16  wport;
	uint8 pppIdx;
	uint8 icmp_type;
	ether_addr_t macPppoe;
	uint16 id = 0xa;

	START_TEST_CASE();
	bzero(pkt_content, sizeof(pkt_content));
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

	for (err_cnt = 0 ; err_cnt < 2 ; err_cnt ++)
	for (loop_cnt = 0 ; loop_cnt < 4 ; loop_cnt ++)
	{	
		lip = npi_addr[loop_cnt];
		wip = rp_addr[loop_cnt];
		gip = gw_addr[loop_cnt];
		wport = rp_port[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		macPppoe = mac_s[loop_cnt];

		if (err_cnt == 0)
		{
			/*
				NPI	->	RP:	TCP, SYN (Error Flow)
			*/
			{
				mbuf_in = confVlanHSB(&conf_err_int, NULL,
							_PKT_TYPE_TCP, 1, 2, pppIdx, mac_npi, mac_gw_int,
							lip, wip, 123, 0, 0,
							port_npi, wport, (TH_SYN), 1460, 0, 0, NULL, 0);
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				mbuf_out = mbufList_dequeue();
				// get external port
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
				{
					uint16 tx_list[2] = {0, 0xffff};	
					mbuf_comp = confPppoeHSA(&conf_err_ext, NULL,
									_PKT_TYPE_TCP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
									gip, wip, 122, 0, 0,
									port_gw, wport, (TH_SYN), 1452, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
			/*
				RP	->	NPI:	TCP, (SYN|ACK) (Error Flow)
			*/
			{
				mbuf_in = confPppoeHSB(&conf_err_ext, NULL,
								_PKT_TYPE_TCP, 0 ,1 , pppIdx, macPppoe, mac_gw_ext, 0,
								wip, gip, 121, 0, 0,
								wport, port_gw, (TH_SYN|TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
	
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				/* check result */
				VALUE_CMP(retval, SUCCESS);
				{
					uint16 tx_list[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA(&conf_err_int, NULL,
									_PKT_TYPE_TCP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
									wip, lip, 120, 0, 0,
									wport, port_npi, (TH_SYN|TH_ACK), 1452, 0, 0, pkt_content, sizeof(pkt_content));
				}
				VALUE_CMP(mbufList_nmbuf(), 1);
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
		if (err_cnt == 1)
		{
			/*
				NPI	->	RP:	UDP (Error Flow)
			*/
				{
				mbuf_in = confVlanHSB(&conf_err_int, NULL,
								_PKT_TYPE_UDP, 1, 2, pppIdx, mac_npi, mac_gw_int,
								lip, wip, 121, 0, 0,
								port_npi, wport, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				mbuf_out = mbufList_dequeue();
				// get external port
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
				{
					uint16 tx_list[2] = {0, 0xffff};	
					mbuf_comp = confPppoeHSA(&conf_err_ext, NULL,
									_PKT_TYPE_UDP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
									gip, wip, 120, 0, 0,
									port_gw, wport, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
			/*
				RP	->	NPI:	UDP (Error Flow)
			*/
				{
				mbuf_in = confPppoeHSB(&conf_err_ext, NULL,
								_PKT_TYPE_UDP, 0, 1, pppIdx, macPppoe, mac_gw_ext, 0,
								wip, gip, 2, 0, 0,
								wport, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				/* check result */
				VALUE_CMP(retval, SUCCESS);
				{
					uint16 tx_list[2] = {1, 0xffff};	
					mbuf_comp = confVlanHSA(&conf_err_int, NULL,
									_PKT_TYPE_UDP, tx_list, 2, pppIdx, mac_gw_int, mac_npi,
									wip, lip, 1, 0, 0,
									wport, port_npi, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
				}
				VALUE_CMP(mbufList_nmbuf(), 1);
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}

		}
		/*
			NPI	->	RP:	ICMP ERROR Message
		*/

		for (icmp_cnt = 0 ; icmp_cnt < 4 ; icmp_cnt ++)
		{
			icmp_type = ic_type[icmp_cnt];
			// must set mss/ttl to be the same (for comparison issue)
			conf_err_ext.conf_tcp_mss = conf_err_int.conf_tcp_mss;
			conf_err_ext.ip.ttl = conf_err_int.ip.ttl;
		
			mbuf_in = confVlanHSB(&conf, &conf_err_int,
								_PKT_TYPE_ICMP, 1, 2, pppIdx, mac_npi, mac_gw_int,
								lip, wip, 93, 0, 0,
								0, 0, 0, 0, icmp_type, id, NULL, 0);

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			/* check result */
			VALUE_CMP(retval, SUCCESS);

			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(&conf, &conf_err_ext,
								_PKT_TYPE_ICMP, tx_list, 1, pppIdx, mac_gw_ext, macPppoe,
								gip, wip, 92, 0, 0,
								0, 0, 0, 0, icmp_type, id, NULL, 0);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}
	return SUCCESS;
}

/*
@func int32		| napt_policy_6	| napt Policy testing 6
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function: TCP/UDP Fragment packets policy-forward
Fragment packets stress test
 */
 int32 pkt_napt_policy6 (uint32 caseNo) {
	/**********************************************
		NAPT test

		2 wan(pppoe), 1 lan

		for tcp/udp SIP/DIP/DPORT policy route

		TCP
		NPI	->	RP, SYN
		RP	->	NPI, SYN,ACK
		NPI	->	RP, ACK
		NPI	->	RP, fragment packet
		RP	->	NPI, fragment packet
		NPI	->	RP, FIN
		RP	->	NPI, FIN, ACK
		NPI	->	RP, ACK

		UDP
		NPI	->	RP, fragment packet
		RP	->	NPI, fragment packet

	***********************************************/
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 nCount;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	uint16 port_npi = 0x9876;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x1112;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	//		3) dport
	//
	int32 loop_cnt = 4;
	ipaddr_t npi_addr[4]	= {ip_npi		, ip_npi2		, ip_npi		, ip_npi};
	ipaddr_t rp_addr[4]	= {ip_rp		, ip_rp		, ip_rp2		, ip_rp};
	uint16 npi_port[4]		= {port_npi	, port_npi		, port_npi		, port_npi};
	uint16 rp_port[4]		= {port_rp	, port_rp		, port_rp		, port_rp2};
	ipaddr_t gw_addr[4]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	, ip_gw_ext2};
	uint8 pppoe_idx[4]	= {0			,1			, 1			, 1};
	ether_addr_t mac_s[4]	= {mac_pppoe, mac_pppoe2, mac_pppoe2, mac_pppoe2};
	uint16 pppoeSessionId[4] = {11111, 22222, 22222, 22222};//This value depend on pppoe_idx and fwdeng_env_configuration_2 setting
	uint32 pppoeObjectId[4] = { 1000, 1001, 1001, 1001};//This value depend on pppoe_idx and fwdeng_env_configuration_2 setting
	
	ipaddr_t lip, wip, gip;
	uint32 objectId;
	uint16 lport, wport, sessionId;
	uint8 pppIdx;
	ether_addr_t macPppoe;

	int pkt_no;
	const int total_pkt = 5;
	uint16 tcp_payload = 1448;
	uint16 udp_payload = 1448;

	bzero(pkt_content, sizeof(pkt_content));
	for(pppIdx=0; pppIdx<2; pppIdx++) {
		pppoeRxPkts[pppIdx] = 0;
		pppoeRxBytes[pppIdx] = 0;
		pppoeTxPkts[pppIdx] = 0;
		pppoeTxBytes[pppIdx] = 0;
	}
	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();


	/*******************************************
		TCP Test
	********************************************/
	for (loop_cnt = 0 ; loop_cnt < 4 ; loop_cnt ++)
	{
		lip = npi_addr[loop_cnt];
		wip = rp_addr[loop_cnt];
		gip = gw_addr[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		lport = npi_port[loop_cnt];
		wport = rp_port[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		sessionId = pppoeSessionId[loop_cnt];
		objectId = pppoeObjectId[loop_cnt];
		macPppoe = mac_s[loop_cnt];

		/* SYN: 3 way hand-shaking */
		/* NPI -> RP (SYN) */
		mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, 0, 0,
					lport, wport,
					TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		mbuf_out = mbufList_dequeue();
		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, pppIdx,
				mac_gw_ext, macPppoe,
				gip, wip, 63, 0, 0,
				port_gw, wport,
				TH_SYN, 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);

		/* RP -> NPI (SYN, ACK) */
		mbuf_in = confPppoeHSB(NULL, NULL,
					_PKT_TYPE_TCP, 0, 1, pppIdx,
					macPppoe, mac_gw_ext, sessionId,
					wip, gip, 64, 0, 0,
					wport, port_gw,
					(TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_TCP, tx_port, 2, pppIdx,
					mac_gw_int, mac_npi,
					wip, lip, 63, 0, 0,
					wport, lport,
					(TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

		/* NPI -> RP (ACK) */
		mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, 0, 0,
					lport, wport,
					TH_ACK, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		mbuf_out = mbufList_dequeue();
		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, pppIdx,
				mac_gw_ext, macPppoe,
				gip, wip, 63, 0, 0,
				port_gw, wport,
				TH_ACK, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);

		/*************************************************************************************************/
		/*************************************************************************************************/
		/*
			NPI	->	RP
		*/
		
		/* only check Tear drop */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);

		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
					lport, wport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
			}
			/* Output */
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_TCP, tx_port, 1, pppIdx,
						mac_gw_ext, macPppoe,
						gip, wip, 63, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
						port_gw, wport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				/* for next packet */
				}
			}
		}
		/*
			NPI	->	RP, out-of-order
		*/
		/* turn off dos */
		GW_SET_DOSSTATUS(0);
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
			{
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
					lport, wport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?5:0);
			}
			/* Output */
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_TCP, tx_port, 1, pppIdx,
						mac_gw_ext, macPppoe,
						gip, wip, 63, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
						port_gw, wport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(udp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				/* for next packet */
				}
			}
		}
		/* turn on dos */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);
		{
			/*
				NPI	->	RP, out-of-order 2
			*/
			{
				int i;
				int list[5] = {1, 3, 5, 2, 4};
				DEFAULT_IP_ID ++;
				for (i = 1 ; i <= total_pkt ; i ++)
				{
					pkt_no = list[i - 1];
					mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						lip, wip, 64, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
						lport, wport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
				}
				/* Output */
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
					mbuf_out = mbufList_dequeue();
					/* get external port */
					ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {0, 0xffff};
						mbuf_comp = confPppoeHSA( NULL, NULL,
							_PKT_TYPE_TCP, tx_port, 1, pppIdx,
							mac_gw_ext, macPppoe,
							gip, wip, 63, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
							port_gw, wport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						mbuf_out = mbufList_dequeue();				/* for next packet */
					}
				}
			}
		}
		/*
			RP	->	NPI
		*/
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					macPppoe, mac_gw_ext, 0,
					wip, gip, 64, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
					wport, port_gw, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
			}
			/* Output */
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_TCP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						wip, lip, 63, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
						wport, lport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
		/*
			RP	->	NPI, out-of-order
		*/
		/* turn off dos */
		GW_SET_DOSSTATUS(0);
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
			{
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					macPppoe, mac_gw_ext, 0,
					wip, gip, 64, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
					wport, port_gw, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
			}
			/* Output */
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_TCP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						wip, lip, 63, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
						wport, lport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
		/* turn on dos */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);
		{
			/*
				RP	->	NPI, out-of-order 2
			*/
			{
				int i;
				int list[5] = {2, 4, 5, 1, 3};
				DEFAULT_IP_ID ++;
				for (i = 1 ; i <= total_pkt ; i ++)
				{
					pkt_no = list[i - 1];
					mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						macPppoe, mac_gw_ext, 0,
						wip, gip, 64, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
						wport, port_gw, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
				}
				/* Output */
				{
					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {1, 0xffff};
						mbuf_comp = confVlanHSA( NULL, NULL,
							_PKT_TYPE_TCP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							wip, lip, 63, (pkt_no == total_pkt?0:1), (tcp_payload * (pkt_no - 1)),
							wport, lport, TH_ACK, 0, 0, 0, pkt_content, (pkt_no == 1?(tcp_payload-sizeof(struct tcphdr)):(tcp_payload)));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
					}
				}
			}
		}
		/*************************************************************************************************/
		/*************************************************************************************************/
		
		/* FIN: 3 way hand-shaking */
		/* NPI -> RP (FIN, ACK) */
		mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, 0, 0,
					lport, wport,
					(TH_FIN|TH_ACK), 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		mbuf_out = mbufList_dequeue();
		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, pppIdx,
				mac_gw_ext, macPppoe,
				gip, wip, 63, 0, 0,
				port_gw, wport,
				(TH_FIN|TH_ACK), 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);

		/* RP -> NPI (SYN, ACK) */
		mbuf_in = confPppoeHSB(NULL, NULL,
					_PKT_TYPE_TCP, 0, 1, pppIdx,
					macPppoe, mac_gw_ext, sessionId,
					wip, gip, 64, 0, 0,
					wport, port_gw,
					(TH_FIN|TH_ACK), 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
					_PKT_TYPE_TCP, tx_port, 2, pppIdx,
					mac_gw_int, mac_npi,
					wip, lip, 63, 0, 0,
					wport, lport,
					(TH_FIN|TH_ACK), 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());

		/* NPI -> RP (ACK) */
		mbuf_in = confVlanHSB(NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, 0, 0,
					lport, wport,
					TH_ACK, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		mbuf_out = mbufList_dequeue();
		/* get external port */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
				_PKT_TYPE_TCP, tx_port, 1, pppIdx,
				mac_gw_ext, macPppoe,
				gip, wip, 63, 0, 0,
				port_gw, wport,
				TH_ACK, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
	/*******************************************
		UDP Test
	********************************************/
	for (loop_cnt = 0 ; loop_cnt < 4 ; loop_cnt ++)
	{
		lip = npi_addr[loop_cnt];
		wip = rp_addr[loop_cnt];
		gip = gw_addr[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		lport = npi_port[loop_cnt];
		wport = rp_port[loop_cnt];
		pppIdx = pppoe_idx[loop_cnt];
		sessionId = pppoeSessionId[loop_cnt];
		objectId = pppoeObjectId[loop_cnt];
		macPppoe = mac_s[loop_cnt];

		/* only check Tear drop */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);

		/*
			NPI	->	RP
		*/
		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					lport, wport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
			}
			/* Output */
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 1, pppIdx,
						mac_gw_ext, macPppoe,
						gip, wip, 63, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_gw, wport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				// for next packet
				}
			}
		}
		/*
			NPI	->	RP, out-of-order
		*/
		/* turn off dos */
		GW_SET_DOSSTATUS(0);

		{
			DEFAULT_IP_ID ++;
			for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
			{
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					lport, wport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
			}
			/* Output */
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 1, pppIdx,
						mac_gw_ext, macPppoe,
						gip, wip, 63, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_gw, wport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				/* for next packet */
				}
			}
		}
		/* turn on dos */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);
		{
			/*
				NPI	->	RP, out-of-order 2
			*/
			{
				int i;
				int list[5] = {1, 3, 5, 2, 4};
				DEFAULT_IP_ID ++;
				for (i = 1 ; i <= total_pkt ; i ++)
				{
					pkt_no = list[i - 1];
					mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						lip, wip, 64, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						lport, wport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
				}
				/* Output */
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
					mbuf_out = mbufList_dequeue();
					/* get external port */
					ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {0, 0xffff};
						mbuf_comp = confPppoeHSA( NULL, NULL,
							_PKT_TYPE_UDP, tx_port, 1, pppIdx,
							mac_gw_ext, macPppoe,
							gip, wip, 63, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							port_gw, wport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						mbuf_out = mbufList_dequeue();				/* for next packet */
					}
				}
			}
		}
		/*
			RP	->	NPI
		*/
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					macPppoe, mac_gw_ext, 0,
					wip, gip, 64, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					wport, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
			}
			/* Output */
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						wip, lip, 63, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						wport, lport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
		/*
			RP	->	NPI, out-of-order
		*/
		/* turn off dos */
		GW_SET_DOSSTATUS(0);
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
			{
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					macPppoe, mac_gw_ext, 0,
					wip, gip, 64, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					wport, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
			}
			/* Output */
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						wip, lip, 63, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						wport, lport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
		/* turn on dos */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);
		{
			/*
				RP	->	NPI, out-of-order 2
			*/
			{
				int i;
				int list[5] = {2, 4, 5, 1, 3};
				DEFAULT_IP_ID ++;
				for (i = 1 ; i <= total_pkt ; i ++)
				{
					pkt_no = list[i - 1];
					mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						macPppoe, mac_gw_ext, 0,
						wip, gip, 64, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						wport, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
				}
				/* Output */
				{
					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {1, 0xffff};
						mbuf_comp = confVlanHSA( NULL, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							wip, lip, 63, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							wport, lport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(udp_payload-sizeof(struct udphdr)):(udp_payload)));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
					}
				}
			}
		}
	}

 	return SUCCESS;
 }

/*
@func int32		| napt_policy_7	| napt Policy testing 7
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function: ICMP Fragment packets policy-forward
Fragment packets stress test
 */
 int32 pkt_napt_policy7 (uint32 caseNo) {
	/**********************************************
		NAPT test

		2 wan(pppoe), 1 lan

		for icmp SIP/DIP policy route

	***********************************************/
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 nCount;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	int32 loop_cnt = 3;
	ipaddr_t npi_addr[3]	= {ip_npi		, ip_npi2		, ip_npi		};
	ipaddr_t rp_addr[3]	= {ip_rp		, ip_rp		, ip_rp2		};
	ipaddr_t gw_addr[3]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	};
	uint8 pppoe_idx[3]	= {0			,1			, 1			};
	ether_addr_t mac_s[3]  = {mac_pppoe, mac_pppoe2, mac_pppoe2};

	uint8 icmp_request[2]	= {ICMP_ECHO, ICMP_TSTAMP};
	uint8 icmp_reply[2]	= {ICMP_ECHOREPLY, ICMP_TSTAMPREPLY};
	
	ipaddr_t lip, wip, gip; 
	uint8 icmp_req, icmp_rep;
	uint8 pppIdx;
	uint16 id[3];
	uint16 gw_id[3];
	ether_addr_t macPppoe;

	int pkt_no;
	const int total_pkt = 5;
	uint16 icmp_payload = 1448;

	const uint16 normal_icmp_size = 8;	/* 8 bytes, sizeof(icmp) include some other fields */

	bzero(pkt_content, sizeof(pkt_content));
	for(pppIdx=0; pppIdx<2; pppIdx++) {
		pppoeRxPkts[pppIdx] = 0;
		pppoeRxBytes[pppIdx] = 0;
		pppoeTxPkts[pppIdx] = 0;
		pppoeTxBytes[pppIdx] = 0;
	}
	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();



	for (nCount = 0 ; nCount < 2 ; nCount ++)
	for (loop_cnt = 0 ; loop_cnt < 3 ; loop_cnt ++)
	{
		icmp_req = icmp_request[nCount];
		icmp_rep = icmp_reply[nCount];
		
		lip = npi_addr[loop_cnt];
		wip = rp_addr[loop_cnt];
		gip = gw_addr[loop_cnt];
	 	pppIdx = pppoe_idx[loop_cnt];
		macPppoe = mac_s[loop_cnt];
		id[0] += 10;
		id[1] = id[0] + 1;
		id[2] = id[1] + 1;

		/* only check Tear drop */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);

		/*
			NPI	->	RP
		*/
		{
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, icmp_req, id[0], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
			}
			/* Output */
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &gw_id[0])==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_ICMP, tx_port, 1, pppIdx,
						mac_gw_ext, macPppoe,
						gip, wip, 63, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
						0, 0, 0, 0, icmp_req, gw_id[0], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				// for next packet
				}
			}
		}
		/*
			NPI	->	RP, out-of-order
		*/
		/* turn off dos */
		GW_SET_DOSSTATUS(0);

		{
			DEFAULT_IP_ID ++;
			for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
			{
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 1, 2, 0,
					mac_npi, mac_gw_int,
					lip, wip, 64, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, icmp_req, id[1], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
			}
			/* Output */
			{
				VALUE_CMP(mbufList_nmbuf(), total_pkt);
				mbuf_out = mbufList_dequeue();
				/* get external port */
				ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &gw_id[1])==SUCCESS);

				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_ICMP, tx_port, 1, pppIdx,
						mac_gw_ext, macPppoe,
						gip, wip, 63, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
						0, 0, 0, 0, icmp_req, gw_id[1], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					mbuf_out = mbufList_dequeue();				/* for next packet */
				}
			}
		}
		/* turn on dos */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);
		{
			/*
				NPI	->	RP, out-of-order 2
			*/
			{
				int i;
				int list[5] = {1, 3, 5, 2, 4};
				DEFAULT_IP_ID ++;
				for (i = 1 ; i <= total_pkt ; i ++)
				{
					pkt_no = list[i - 1];
					mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_ICMP, 1, 2, 0,
						mac_npi, mac_gw_int,
						lip, wip, 64, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
						0, 0, 0, 0, icmp_req, id[2], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
				}
				/* Output */
				{
					VALUE_CMP(mbufList_nmbuf(), total_pkt);
					mbuf_out = mbufList_dequeue();
					/* get external port */
					ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &gw_id[2])==SUCCESS);

					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {0, 0xffff};
						mbuf_comp = confPppoeHSA( NULL, NULL,
							_PKT_TYPE_ICMP, tx_port, 1, pppIdx,
							mac_gw_ext, macPppoe,
							gip, wip, 63, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
							0, 0, 0, 0, icmp_req, gw_id[2], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						mbuf_out = mbufList_dequeue();				/* for next packet */
					}
				}
			}
		}
		/*
			RP	->	NPI
		*/
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 0, 1, 0,
					macPppoe, mac_gw_ext, 0,
					wip, gip, 64, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, icmp_rep, gw_id[0], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?total_pkt:0);
			}
			/* Output */
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_ICMP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						wip, lip, 63, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
						0, 0, 0, 0, icmp_rep, id[0], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
		/*
			RP	->	NPI, out-of-order
		*/
		/* turn off dos */
		GW_SET_DOSSTATUS(0);
		{
			DEFAULT_IP_ID ++;
			for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
			{
				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 0, 1, 0,
					macPppoe, mac_gw_ext, 0,
					wip, gip, 64, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
					0, 0, 0, 0, icmp_rep, gw_id[1], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (pkt_no == 1)?total_pkt:0);
			}
			/* Output */
			{
				for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				{
					int16 tx_port[2] = {1, 0xffff};

					mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_ICMP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						wip, lip, 63, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
						0, 0, 0, 0, icmp_rep, id[1], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

					mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
					mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
					MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				}
			}
		}
		/* turn on dos */
		GW_SET_DOSSTATUS(RTL8651_DOS_TEARDROP);
		{
			/*
				RP	->	NPI, out-of-order 2
			*/
			{
				int i;
				int list[5] = {2, 4, 5, 1, 3};
				DEFAULT_IP_ID ++;
				for (i = 1 ; i <= total_pkt ; i ++)
				{
					pkt_no = list[i - 1];
					mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_ICMP, 0, 1, 0,
						macPppoe, mac_gw_ext, 0,
						wip, gip, 64, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
						0, 0, 0, 0, icmp_rep, gw_id[2], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));
			
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), (i == total_pkt)?total_pkt:0);
				}
				/* Output */
				{
					for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
					{
						int16 tx_port[2] = {1, 0xffff};
						mbuf_comp = confVlanHSA( NULL, NULL,
							_PKT_TYPE_ICMP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							wip, lip, 63, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
							0, 0, 0, 0, icmp_rep, id[2], pkt_content, (pkt_no == 1?(icmp_payload-normal_icmp_size):(icmp_payload)));

						mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
						mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
						MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
					}
				}
			}
		}

	}/* ICMP Test */

	return SUCCESS;
}

/*
@func int32		| future_icmpReply_policy_1	| icmpReply future through policy route testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the policy route function: When icmp echo message to gateway is through policy route,
icmp echo-reply message must through policy route, too.
 */
int32 pkt_future_icmpReply_policy1(uint32 caseNo){
	/**********************************************
		ICMP test

		3 wan(pppoe), 1 lan

		for icmp SIP/DIP policy route

	***********************************************/
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 id = 0x1;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	//	Policy route:
	//		1) sip
	//		2) dip
	int32 loop_cnt = 3;
	ipaddr_t npi_addr[3]	= {ip_npi		, ip_npi2		, ip_npi		};
	ipaddr_t rp_addr[3]	= {ip_rp		, ip_rp		, ip_rp2		};
	ipaddr_t gw_addr[3]	= {ip_gw_ext	, ip_gw_ext2	, ip_gw_ext2	};
	uint8 pppoe_idx[3]	= {0			,1			, 1			};

	ipaddr_t lip, wip, gip; 
	uint8 pppIdx;

	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

for (loop_cnt = 0 ; loop_cnt < 3 ; loop_cnt ++)
{	
	lip = npi_addr[loop_cnt];
	wip = rp_addr[loop_cnt];
	gip = gw_addr[loop_cnt];
 	pppIdx = pppoe_idx[loop_cnt];
	/*
		RP	->	GW : ECHO
		GW	->	RP : ECHO-REPLY
	*/
	{
		/* config */
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_ICMP, 0, 1, pppIdx, mac_pppoe, mac_gw_ext, loop_cnt==0?11111:22222,
						wip, gip, 124, 0, 0,
						0, 0, 0, 0, ICMP_ECHO, id, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
		/* check result */
		VALUE_CMP(retval, SUCCESS);	
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA_Tagged(&conf, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, pppIdx, mac_gw_ext, mac_pppoe,
							gip, wip, IP_DEFAULT_TTL, 0, 0,
							0, 0, 0, 0, ICMP_ECHOREPLY, id, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	}
}// ICMP Test
	return SUCCESS;
}


#endif

#ifdef RTL_FWDENG_DOS_TEST
/*
@func int32		| DOS_synflood_1	| DOS synflood attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: synflood from Remote Host
 */
int32 dosSynFlood_1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		RP	->	NPI	SYN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (nCount = 0 ; nCount < RTL8651_DOS_SYN_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of sip/sport
	(uint32)ip_rp = (((uint32)(ip_rp&0x0000000f)+1)|((uint32)(ip_rp&0xfffffff0)));
	port_rp = ((port_rp++)|0x1000);

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_SYN_THRESHOLD_DEFAULT)
	{
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		freeMbuf(mbuf_in);
	}else
	{
		//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		if (nCount == RTL8651_DOS_SYN_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_SynFlood, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP SYN Flood"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_synflood_2	| DOS synflood attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: synflood from Internal Host
 */
int32 dosSynFlood_2(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		NPI	->	GW_INT	SYN
		NPI	->	GW_EXT	SYN
		NPI	->	RP		SYN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	uint16 dport_arr[3] = {port_gw, port_gw, port_rp};
	int32 result_arr[3] = {FAILED, FAILED, SUCCESS};
	ipaddr_t dip;
	uint16 dport;
	uint16 nCount, d_type;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0; d_type < 3 ; d_type ++, rtl8651_dosOneSecondTimer())
for (nCount = 0 ; nCount < RTL8651_DOS_SYN_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of dip/dport
	dip = dip_arr[d_type];
	dport = dport_arr[d_type];

	// change value of sip/sport
	(uint32)ip_npi = (((uint32)(ip_npi&0x0000000f)+1)|((uint32)(ip_npi&0xfffffff0)));
	port_npi = ((port_npi++)|0x1000);
 
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= dport;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	conf.l2Flag 						= 0;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_SYN_THRESHOLD_DEFAULT)
	{
		VALUE_CMP(retval, result_arr[d_type]);
		if (result_arr[d_type] == SUCCESS)
		{
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			freeMbuf(mbuf_out);
		}
		else
		{
			freeMbuf(mbuf_in);
		}
	}else
	{
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		if (nCount == RTL8651_DOS_SYN_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_SynFlood, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP SYN Flood"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}

	}
}
	return SUCCESS;
}

/*
@func int32		| DOS_synflood_3	| DOS synflood attack testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: synflood from One Remote Host, system will track packet count of this host and notify
the flood attack of the host
 */
int32 dosSynFlood_3(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		RP	->	NPI	SYN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp;
	ipaddr_t ip_rp_base = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x0001;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_SYN_TRACKCNT], idx;
	uint16 LoopPerSec;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system syn threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_SYN_THRESHOLD, ((RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_SYN_TRACKCNT))+1);

	for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
	{
		// increase system time
		_rtl8651_timeUpdate(1);

		for (idx=0;idx<RTL8651_DOS_SYN_TRACKCNT;idx++)
		{
			pktCnt[idx] = 0;
		}

		port_rp = 0x1234;

		for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_SYN_TRACKCNT)); nCount ++)
		{
			// change value of sip/sport
			(uint32)ip_rp = ip_rp_base + IP_LOOP(RTL8651_DOS_SYN_TRACKCNT);
			pktCnt[(ip_rp%RTL8651_DOS_SYN_TRACKCNT)] ++;
			port_rp = ((port_rp++)|0x1000);
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/* check result */
			if (pktCnt[(ip_rp%RTL8651_DOS_SYN_TRACKCNT)] < RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT)
			{
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				freeMbuf(mbuf_in);
			}else
			{
				//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
				VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
				// compare DoS Type
				if (pktCnt[(ip_rp%RTL8651_DOS_SYN_TRACKCNT)] == RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostSynFlood, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: TCP SYN Flood"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
				}
			}
		}
	}
	// restore whole-system syn threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_SYN_THRESHOLD, RTL8651_DOS_SYN_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_synflood_4	| DOS synflood attack testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: synflood from One Internal Host, system will track packet count of this host and notify
the flood attack of the host
 */
int32 dosSynFlood_4(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		NPI	->	GW_INT	SYN
		NPI	->	GW_EXT	SYN
		NPI	->	RP		SYN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi;
	ipaddr_t ip_npi_base = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x0001;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_SYN_TRACKCNT], idx;
	uint16 LoopPerSec, dst_cnt;
	const uint16 tx_dst=3;
	ipaddr_t dst_ip[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	int32 ret_val[3] = {FAILED, FAILED, SUCCESS};
	ipaddr_t dip;
	uint16 dport = 0x1234;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system syn threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_SYN_THRESHOLD, ((RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_SYN_TRACKCNT))+1);

	for (dst_cnt = 0 ; dst_cnt < tx_dst ; dst_cnt ++)
	{
		dip = dst_ip[dst_cnt];
		dport = (dport ++)|(0x1000);
		for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
		{
			// increase system time
			_rtl8651_timeUpdate(1);

			for (idx=0;idx<RTL8651_DOS_SYN_TRACKCNT;idx++)
			{
				pktCnt[idx] = 0;
			}

			port_npi = 0x1234;

			for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_SYN_TRACKCNT)); nCount ++)
			{
				// change value of sip/sport
				(uint32)ip_npi = ip_npi_base + IP_LOOP(RTL8651_DOS_SYN_TRACKCNT);
				port_npi = (port_npi ++)|(0x1000);
				pktCnt[(ip_npi%RTL8651_DOS_SYN_TRACKCNT)] ++;
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int, ip_npi, dip, 123, 0, 0,
					port_npi, dport, TH_SYN, 1460, 0, 0, NULL, 0);

				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				/* check result */
				if (pktCnt[(ip_npi%RTL8651_DOS_SYN_TRACKCNT)] < RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(retval, ret_val[dst_cnt]);
					if (retval == SUCCESS)
					{
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						freeMbuf(mbuf_out);
					}
					else
					{
						freeMbuf(mbuf_in);
					}
				}else
				{
					//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
					VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
					// compare DoS Type
					if (pktCnt[(ip_npi%RTL8651_DOS_SYN_TRACKCNT)] == RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT)
					{
						VALUE_CMP(log_cnt(), 1);
						#ifdef _RTL_NEW_LOGGING_MODEL
						VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostSynFlood, NULL), SUCCESS);
						#else
						VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: TCP SYN Flood"), SUCCESS);
						#endif
						VALUE_CMP(log_reinit(), SUCCESS);
					}
				}
			}
		}
	}
	// restore whole-system syn threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_SYN_THRESHOLD, RTL8651_DOS_SYN_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_stealthFin_1	| DOS stealthFin attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: stealthFin from Remote Host
 */
int32 dosStealthFin_1(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		RP	->	NPI
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (nCount = 0 ; nCount < RTL8651_DOS_FIN_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of sip/sport
	(uint32)ip_rp = (((uint32)(ip_rp&0x0000000f)+1)|((uint32)(ip_rp&0xfffffff0)));
	port_rp = ((port_rp++)|0x1000);

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_FIN);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_FIN_THRESHOLD_DEFAULT)
	{
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		freeMbuf(mbuf_in);
	}else
	{
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success

		if (nCount == RTL8651_DOS_FIN_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_StealthFin, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Stealth FIN Port Scan"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_stealthFin_2	| DOS stealthFin attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: stealthFin from Internal Host
 */
int32 dosStealthFin_2(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	uint16 dport_arr[3] = {port_gw, port_gw, port_rp};
	int32 result_arr[3] = {FAILED, FAILED, FWDENG_TCP_NAPT_OUT_NOTFOUND};
	ipaddr_t dip;
	uint16 dport;
	uint16 nCount, d_type;
	

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 3 ; d_type ++, rtl8651_dosOneSecondTimer())
for (nCount = 0 ; nCount < RTL8651_DOS_FIN_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of dip/dport
	dip = dip_arr[d_type];
	dport = dport_arr[d_type];

	// change value of sip/sport
	(uint32)ip_npi = (((uint32)(ip_npi&0x0000000f)+1)|((uint32)(ip_npi&0xfffffff0)));
	port_npi = ((port_npi++)|0x1000);

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= dport;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_FIN);
	conf.conf_tcp_win					= 0xfffe;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	conf.l2Flag 						= 0;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 3);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_FIN_THRESHOLD_DEFAULT)
	{
		VALUE_CMP(retval, result_arr[d_type]);
		if (result_arr[d_type] == SUCCESS)
		{
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			freeMbuf(mbuf_out);
		}else
		{
			freeMbuf(mbuf_in);
		}
	}else
	{
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		if (nCount == RTL8651_DOS_FIN_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_StealthFin, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Stealth FIN Port Scan"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_stealthFin_3	| DOS stealthFin attack testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: stealthFin from One Remote Host, system will track packet count of this host and notify
the stealthFin attack of the host
 */
int32 dosStealthFin_3(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		RP	->	NPI	FIN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp;
	ipaddr_t ip_rp_base = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x0001;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_FIN_TRACKCNT], idx;
	uint16 LoopPerSec;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system fin threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_FIN_THRESHOLD, ((RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_FIN_TRACKCNT))+1);

	for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
	{
		// increase system time
		_rtl8651_timeUpdate(1);

		for (idx=0;idx<RTL8651_DOS_FIN_TRACKCNT;idx++)
		{
			pktCnt[idx] = 0;
		}

		port_rp = 0x1234;

		for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_FIN_TRACKCNT)); nCount ++)
		{
			// change value of sip/sport
			(uint32)ip_rp = ip_rp_base + IP_LOOP(RTL8651_DOS_FIN_TRACKCNT);
			pktCnt[(ip_rp%RTL8651_DOS_FIN_TRACKCNT)] ++;
			port_rp = ((port_rp++)|0x1000);
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, port_gw, TH_FIN, 1460, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/* check result */
			if (pktCnt[(ip_rp%RTL8651_DOS_FIN_TRACKCNT)] < RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT)
			{
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				freeMbuf(mbuf_in);
			}else
			{
				//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
				VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
				// compare DoS Type
				if (pktCnt[(ip_rp%RTL8651_DOS_FIN_TRACKCNT)] == RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostStealthFin, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: TCP Stealth FIN Port Scan"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
				}
			}
		}
	}
	// restore whole-system fin threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_FIN_THRESHOLD, RTL8651_DOS_FIN_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_stealthFin_4	| DOS stealthFin attack testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: stealthFin from One Internal Host, system will track packet count of this host and notify
the stealthFin attack of the host
 */
int32 dosStealthFin_4(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		NPI	->	GW_INT	FIN
		NPI	->	GW_EXT	FIN
		NPI	->	RP		FIN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi;
	ipaddr_t ip_npi_base = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x0001;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_FIN_TRACKCNT], idx;
	uint16 LoopPerSec, dst_cnt;
	const uint16 tx_dst=3;
	ipaddr_t dst_ip[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	int32 ret_val[3] = {FAILED, FAILED, FWDENG_TCP_NAPT_OUT_NOTFOUND};
	ipaddr_t dip;
	uint16 dport = 0x1234;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system fin threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_FIN_THRESHOLD, ((RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_FIN_TRACKCNT))+1);

	for (dst_cnt = 0 ; dst_cnt < tx_dst ; dst_cnt ++)
	{
		dip = dst_ip[dst_cnt];
		dport = (dport ++)|(0x1000);
		for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
		{
			// increase system time
			_rtl8651_timeUpdate(1);

			for (idx=0;idx<RTL8651_DOS_FIN_TRACKCNT;idx++)
			{
				pktCnt[idx] = 0;
			}

			port_npi = 0x1234;

			for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_FIN_TRACKCNT)); nCount ++)
			{
				// change value of sip/sport
				(uint32)ip_npi = ip_npi_base + IP_LOOP(RTL8651_DOS_FIN_TRACKCNT);
				port_npi = (port_npi ++)|(0x1000);
				pktCnt[(ip_npi%RTL8651_DOS_FIN_TRACKCNT)] ++;
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int, ip_npi, dip, 123, 0, 0,
					port_npi, dport, TH_FIN, 1460, 0, 0, NULL, 0);

				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				/* check result */
				if (pktCnt[(ip_npi%RTL8651_DOS_FIN_TRACKCNT)] < RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(retval, ret_val[dst_cnt]);
					if (retval == SUCCESS)
					{
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						freeMbuf(mbuf_out);
					}
					else
					{
						freeMbuf(mbuf_in);
					}
				}else
				{
					//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
					VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
					// compare DoS Type
					if (pktCnt[(ip_npi%RTL8651_DOS_FIN_TRACKCNT)] == RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT)
					{
						VALUE_CMP(log_cnt(), 1);
						#ifdef _RTL_NEW_LOGGING_MODEL
						VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostStealthFin, NULL), SUCCESS);
						#else
						VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: TCP Stealth FIN Port Scan"), SUCCESS);
						#endif
						VALUE_CMP(log_reinit(), SUCCESS);
					}
				}
			}
		}
	}
	// restore whole-system fin threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_FIN_THRESHOLD, RTL8651_DOS_FIN_THRESHOLD_DEFAULT);

	return SUCCESS;
}


/*
@func int32		| DOS_udpflood_1	| DOS udpflood attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udpflood from Remote Host
 */
int32 dosUdpFlood_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		UDP
		RP	->	NPI
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint32 nCount;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (nCount = 0 ; nCount < RTL8651_DOS_UDP_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of sip/sport
	(uint32)ip_rp = (((uint32)(ip_rp&0x0000000f)+1)|((uint32)(ip_rp&0xfffffff0)));
	port_rp = ((port_rp++)|0x1000);

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* Udp packet */
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_UDP_THRESHOLD_DEFAULT)
	{
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		freeMbuf(mbuf_in);
	}else
	{
		//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success

		if (nCount == RTL8651_DOS_UDP_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpFlood, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Flood"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_udpflood_2	| DOS udpflood attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udpflood from Internal Host
 */
int32 dosUdpFlood_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		UDP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	uint16 dport_arr[3] = {port_gw, port_gw, port_rp};
	int32 result_arr[3] = {FAILED, FAILED, SUCCESS};
	ipaddr_t dip;
	uint16 dport;
	uint16 nCount, d_type;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 3 ; d_type ++, rtl8651_dosOneSecondTimer())
for (nCount = 0 ; nCount < RTL8651_DOS_UDP_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of dip/dport
	dip = dip_arr[d_type];
	dport = dport_arr[d_type];

	// change value of sip/sport
	(uint32)ip_npi = (((uint32)(ip_npi&0x000000ff)+1)|((uint32)(ip_npi&0xffffff00)));
	port_npi = ((port_npi++)|0x1000);
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 123;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= dport;
	conf.payload.content				= pkt_content;
	conf.payload.length				= sizeof(pkt_content);

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 3);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_UDP_THRESHOLD_DEFAULT)
	{
		VALUE_CMP(retval, result_arr[d_type]);
		if (result_arr[d_type] == SUCCESS)
		{
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			freeMbuf(mbuf_out);
		}else
		{
			freeMbuf(mbuf_in);
		}
	}else
	{
		//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success

		if (nCount == RTL8651_DOS_UDP_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpFlood, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Flood"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}

}
	return SUCCESS;
}

/*
@func int32		| DOS_UdpFlood_3	| DOS UdpFlood attack testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: UdpFlood from One Remote Host, system will track packet count of this host and notify
the UdpFlood attack of the host
 */
int32 dosUdpFlood_3(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		RP	->	NPI	UDP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp;
	ipaddr_t ip_rp_base = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x0001;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_UDP_TRACKCNT], idx;
	uint16 LoopPerSec;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system udp threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_UDP_THRESHOLD, ((RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_UDP_TRACKCNT))+1);

	for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
	{
		// increase system time
		_rtl8651_timeUpdate(1);

		for (idx=0;idx<RTL8651_DOS_UDP_TRACKCNT;idx++)
		{
			pktCnt[idx] = 0;
		}

		port_rp = 0x1234;

		for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_UDP_TRACKCNT)); nCount ++)
		{
			// change value of sip/sport
			(uint32)ip_rp = ip_rp_base + IP_LOOP(RTL8651_DOS_UDP_TRACKCNT);
			pktCnt[(ip_rp%RTL8651_DOS_UDP_TRACKCNT)] ++;
			port_rp = ((port_rp++)|0x1000);
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/* check result */
			if (pktCnt[(ip_rp%RTL8651_DOS_UDP_TRACKCNT)] < RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT)
			{
				VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
				freeMbuf(mbuf_in);
			}else
			{
				//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
				VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
				// compare DoS Type
				if (pktCnt[(ip_rp%RTL8651_DOS_UDP_TRACKCNT)] == RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostUdpFlood, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: UDP Flood"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
				}
			}
		}
	}
	// restore whole-system udp threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_UDP_THRESHOLD, RTL8651_DOS_UDP_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_UdpFlood_4	| DOS UdpFlood attack testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: UdpFlood from One Internal Host, system will track packet count of this host and notify
the UdpFlood attack of the host
 */
int32 dosUdpFlood_4(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		NPI	->	GW_INT	UDP
		NPI	->	GW_EXT	UDP
		NPI	->	RP		UDP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi;
	ipaddr_t ip_npi_base = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x0001;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_UDP_TRACKCNT], idx;
	uint16 LoopPerSec, dst_cnt;
	const uint16 tx_dst=3;
	ipaddr_t dst_ip[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	int32 ret_val[3] = {FAILED, FAILED, SUCCESS};
	ipaddr_t dip;
	uint16 dport = 0x1234;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system udp threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_UDP_THRESHOLD, ((RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_UDP_TRACKCNT))+1);

	for (dst_cnt = 0 ; dst_cnt < tx_dst ; dst_cnt ++)
	{
		dip = dst_ip[dst_cnt];
		dport = (dport ++)|(0x1000);
		for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
		{
			// increase system time
			_rtl8651_timeUpdate(1);

			for (idx=0;idx<RTL8651_DOS_UDP_TRACKCNT;idx++)
			{
				pktCnt[idx] = 0;
			}

			port_npi = 0x1234;

			for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_UDP_TRACKCNT)); nCount ++)
			{
				// change value of sip/sport
				(uint32)ip_npi = ip_npi_base + IP_LOOP(RTL8651_DOS_UDP_TRACKCNT);
				port_npi = (port_npi ++)|(0x1000);
				pktCnt[(ip_npi%RTL8651_DOS_UDP_TRACKCNT)] ++;
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int, ip_npi, dip, 123, 0, 0,
					port_npi, dport, 0, 0, 0, 0, NULL, 0);

				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				/* check result */
				if (pktCnt[(ip_npi%RTL8651_DOS_UDP_TRACKCNT)] < RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(retval, ret_val[dst_cnt]);
					if (retval == SUCCESS)
					{
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						freeMbuf(mbuf_out);
					}
					else
					{
						freeMbuf(mbuf_in);
					}
				}else
				{
					//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
					VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
					// compare DoS Type
					if (pktCnt[(ip_npi%RTL8651_DOS_UDP_TRACKCNT)] == RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT)
					{
						VALUE_CMP(log_cnt(), 1);
						#ifdef _RTL_NEW_LOGGING_MODEL
						VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostUdpFlood, NULL), SUCCESS);
						#else
						VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: UDP Flood"), SUCCESS);
						#endif
						VALUE_CMP(log_reinit(), SUCCESS);
					}
				}
			}
		}
	}
	// restore whole-system udp threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_UDP_THRESHOLD, RTL8651_DOS_UDP_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_icmpflood_1	| DOS icmpflood attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmpflood from Remote Host
 */
int32 dosIcmpFlood_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		RP	-> GW
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint32 nCount;
	uint16 id = 1;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (nCount = 0 ; nCount < (RTL8651_DOS_ICMP_THRESHOLD_DEFAULT + 10); nCount ++)
{
	// change value of sip/id
	(uint32)ip_rp = (((uint32)(ip_rp&0x0000000f)+1)|((uint32)(ip_rp&0xfffffff0)));
	id ++;

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;

	if (nCount%2)
	{
		conf.icmp.type				= ICMP_ECHO;
	}
	else
	{
		conf.icmp.type				= ICMP_ECHOREPLY;
	}

	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_ICMP_THRESHOLD_DEFAULT)
	{
		if (conf.icmp.type == ICMP_ECHOREPLY)
		{
			VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
			freeMbuf(mbuf_in);
		}
		else
		{	// echo
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			freeMbuf(mbuf_out);
		}
	}else
	{
		//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success

		if (nCount == RTL8651_DOS_ICMP_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpFlood, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Flood"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_icmpflood_2	| DOS icmpflood attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmpflood from Internal Host
 */
int32 dosIcmpFlood_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint32 nCount, d_type;

	ipaddr_t dip_arr[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	ipaddr_t dip;
	uint16 id = 1;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 3 ; d_type ++, rtl8651_dosOneSecondTimer())
for (nCount = 0 ; nCount < RTL8651_DOS_ICMP_THRESHOLD_DEFAULT + 10; nCount ++)
{
	// change value of dip/id
	dip = dip_arr[d_type];
	id ++;
	// change value of sip
	(uint32)ip_npi = (((uint32)(ip_npi&0x0000000f)+1)|((uint32)(ip_npi&0xfffffff0)));

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;

	if (nCount%2)
		conf.icmp.type				= ICMP_ECHO;
	else
		conf.icmp.type				= ICMP_ECHOREPLY;

	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 3);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	if (nCount < RTL8651_DOS_ICMP_THRESHOLD_DEFAULT)
	{
		if (conf.icmp.type == ICMP_ECHOREPLY)	// fwdeng must return FWDENG_ICMP_OUT_INVALIDIPID : echo reply without echo request
		{
			if (d_type < 2)
			{
				VALUE_CMP(retval, FAILED);
			}else
			{
				VALUE_CMP(retval, FWDENG_ICMP_OUT_INVALIDIPID);
			}
			freeMbuf(mbuf_in);
		}
		else
		{
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			mbuf_out = mbufList_dequeue();
			freeMbuf(mbuf_out);
		}
	}else
	{
		//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success

		if (nCount == RTL8651_DOS_ICMP_THRESHOLD_DEFAULT)
		{
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpFlood, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Flood"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}else
		{
			VALUE_CMP(log_cnt(), 0);	// don't log anymore
			VALUE_CMP(log_reinit(), SUCCESS);
		}
	}

}
	return SUCCESS;
}

/*
@func int32		| DOS_IcmpFlood_3	| DOS IcmpFlood attack testing 3
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: IcmpFlood from One Remote Host, system will track packet count of this host and notify
the IcmpFlood attack of the host
 */
int32 dosIcmpFlood_3(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		RP	->	NPI	ICMP_ECHOREPLY
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp;
	ipaddr_t ip_rp_base = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	uint16 id;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_UDP_TRACKCNT], idx;
	uint16 LoopPerSec;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system icmp threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_ICMP_THRESHOLD, ((RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_ICMP_TRACKCNT))+1);

	for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
	{
		// increase system time
		_rtl8651_timeUpdate(1);

		for (idx=0;idx<RTL8651_DOS_ICMP_TRACKCNT;idx++)
		{
			pktCnt[idx] = 0;
		}

		id = 0x1;

		for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_ICMP_TRACKCNT)); nCount ++)
		{
			// change value of sip/sport
			(uint32)ip_rp = ip_rp_base + IP_LOOP(RTL8651_DOS_ICMP_TRACKCNT);
			pktCnt[(ip_rp%RTL8651_DOS_ICMP_TRACKCNT)] ++;
			(id++);
			id |= 0x01;
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_ICMP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
				0, 0, 0, 0, ICMP_ECHOREPLY, id, NULL, 0);

			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			/* check result */
			if (pktCnt[(ip_rp%RTL8651_DOS_ICMP_TRACKCNT)] < RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT)
			{
				VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
				freeMbuf(mbuf_in);
			}else
			{
				//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
				VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
				// compare DoS Type
				if (pktCnt[(ip_rp%RTL8651_DOS_ICMP_TRACKCNT)] == RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT)
				{
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostIcmpFlood, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: ICMP Flood"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
				}
			}
		}
	}
	// restore whole-system udp threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_ICMP_THRESHOLD, RTL8651_DOS_ICMP_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_IcmpFlood_4	| DOS IcmpFlood attack testing 4
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: IcmpFlood from One Internal Host, system will track packet count of this host and notify
the IcmpFlood attack of the host
 */
int32 dosIcmpFlood_4(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	uint16 nCount;

	/**********************************************
		TCP
		NPI	->	GW_INT	ICMP_ECHOREPLY
		NPI	->	GW_EXT	ICMP_ECHOREPLY
		NPI	->	RP		ICMP_ECHOREPLY
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi;
	ipaddr_t ip_npi_base = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 loop = 1;
	#define IP_LOOP(loopCnt) ((loop++)%(loopCnt))
	uint16 pktCnt[RTL8651_DOS_ICMP_TRACKCNT], idx;
	uint16 LoopPerSec, dst_cnt;
	const uint16 tx_dst=3;
	ipaddr_t dst_ip[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	int32 ret_val[3] = {FAILED, FAILED, SUCCESS};
	ipaddr_t dip;
	uint16 id;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// turn-off sip blocking
	rtl8651_dosProc_blockSip_enable(0, FALSE);

	// increase whole-system icmp threshold to prevent this DOS attack
	rtl8651a_setDosThreshold(0, RTL8651_DOS_ICMP_THRESHOLD, ((RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_ICMP_TRACKCNT))+1);

	for (dst_cnt = 0 ; dst_cnt < tx_dst ; dst_cnt ++)
	{
		dip = dst_ip[dst_cnt];
		for (LoopPerSec = 1 ; LoopPerSec < 10 ; LoopPerSec ++)
		{
			// increase system time
			_rtl8651_timeUpdate(1);

			for (idx=0;idx<RTL8651_DOS_ICMP_TRACKCNT;idx++)
			{
				pktCnt[idx] = 0;
			}

			id = 0x01;

			for (nCount = 0 ; nCount < ((RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_ICMP_TRACKCNT)); nCount ++)
			{
				// change value of sip/sport
				(uint32)ip_npi = ip_npi_base + IP_LOOP(RTL8651_DOS_ICMP_TRACKCNT);
				id ++;
				id |= 0x01;
				pktCnt[(ip_npi%RTL8651_DOS_ICMP_TRACKCNT)] ++;
				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int, ip_npi, dip, 123, 0, 0,
					0, 0, 0, 0, ICMP_ECHOREPLY, id, NULL, 0);

				/* packet input */
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				/* check result */
				if (pktCnt[(ip_npi%RTL8651_DOS_ICMP_TRACKCNT)] < RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT)
				{
					if (dst_cnt < 2)
					{
						VALUE_CMP(retval, FAILED);
					}else
					{
						VALUE_CMP(retval, FWDENG_ICMP_OUT_INVALIDIPID);
					}
					freeMbuf(mbuf_in);
				}else
				{
					//VALUE_CMP(FWDENG_USER_IDSCHECKDROP);
					VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
					// compare DoS Type
					if (pktCnt[(ip_npi%RTL8651_DOS_ICMP_TRACKCNT)] == RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT)
					{
						VALUE_CMP(log_cnt(), 1);
						#ifdef _RTL_NEW_LOGGING_MODEL
						VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostIcmpFlood, NULL), SUCCESS);
						#else
						VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: ICMP Flood"), SUCCESS);
						#endif
						VALUE_CMP(log_reinit(), SUCCESS);
					}
				}
			}
		}
	}
	// restore whole-system icmp threshold
	rtl8651a_setDosThreshold(0, RTL8651_DOS_ICMP_THRESHOLD, RTL8651_DOS_ICMP_THRESHOLD_DEFAULT);

	return SUCCESS;
}

/*
@func int32		| DOS_SynWithData_1	| DOS SynWithData attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: SynWithData from Remote Host
 */
int32 dosSynWithData_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		RP	->	NPI	SYN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();
	/*
		RP	->	NPI :
	*/
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpSynWithData, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP SYN with Data"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);

}
	return SUCCESS;
}
/*
@func int32		| DOS_SynWithData_2	| DOS SynWithData attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: SynWithData from Internal Host
 */
int32 dosSynWithData_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
		NPI	->	NPI2
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	uint16 dport_arr[4] = {port_gw, port_gw, port_rp, port_npi2};
	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 4 ; d_type ++)
{

	dip = dip_arr[d_type];
	dport = dport_arr[d_type]; 

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= dport;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 2);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpSynWithData, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP SYN with Data"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);
}
	return SUCCESS;
}
/*
@func int32		| DOS_teardrop_1	| DOS teardrop attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: teardrop from Remote Host
 */
int32 dosTearDrop_1(uint32 caseNo){
	int8 pkt_content[1448];
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x4321;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0x4324;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no;
	const int total_pkt = 5;
	uint16 udp_payload = 1448;
	uint32 pktType, hdrsize, pi;
	uint32 pktTypeArr[3] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP, _PKT_TYPE_ICMP};
	uint32 hdrsizeArr[3] = {sizeof(struct tcphdr), sizeof(struct udphdr), 8};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

for (pi = 0; pi < 3 ; pi++)
{
	pktType = pktTypeArr[pi];
	hdrsize = hdrsizeArr[pi];

	/*
		NPI	->	RP
	*/
	{
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt

		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			uint16 offset = (udp_payload * (pkt_no - 1));

			if (pkt_no == total_pkt)
			{
				offset -= (1 * 8);
			}
			
			mbuf_in = confPppoeHSB( NULL, NULL,
				pktType, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), offset,
				port_rp, port_gw, 0, 0, ICMP_ECHO, 1, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-hdrsize):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);

			if (pkt_no == total_pkt)
			{
				// compare DoS Type
				VALUE_CMP(log_cnt(), 1);
				#ifdef _RTL_NEW_LOGGING_MODEL
				VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TearDrop, NULL), SUCCESS);
				#else
				VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP TearDrop"), SUCCESS);
				#endif
				VALUE_CMP(log_reinit(), SUCCESS);
			}
		}
	}
	/*
		NPI	->	RP, out-of-order
	*/
	{
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt
		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			uint16 offset = (udp_payload * (pkt_no - 1));
			uint32 datalen = (pkt_no == 1?(sizeof(pkt_content)-hdrsize):(sizeof(pkt_content)));
		
			if (pkt_no == 1)
			{
				datalen += (1*8);
			}
		
			mbuf_in = confPppoeHSB( NULL, NULL,
				pktType, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), offset,
				port_rp, port_gw, 0, 0, ICMP_ECHO, 1, pkt_content, datalen);
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);

			if (pkt_no == 1)
			{
				// compare DoS Type
				VALUE_CMP(log_cnt(), 1);
				#ifdef _RTL_NEW_LOGGING_MODEL
				VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TearDrop, NULL), SUCCESS);
				#else
				VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP TearDrop"), SUCCESS);
				#endif
				VALUE_CMP(log_reinit(), SUCCESS);
			}
		}
	}
	{
		/*
			NPI	->	RP, out-of-order 2
		*/
		{
			int i;
			int list[5] = {1, 3, 5, 2, 4};
			
			DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt
			
			for (i = 1 ; i <= total_pkt ; i ++)
			{
				uint16 offset;
				pkt_no = list[i - 1];
				offset = (udp_payload * (pkt_no - 1));

				if (pkt_no == total_pkt)
				{
					offset -= (1*8);
				}
				mbuf_in = confPppoeHSB( NULL, NULL,
					pktType, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), offset,
					port_rp, port_gw, 0, 0, ICMP_ECHO, 1, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-hdrsize):(sizeof(pkt_content))));
		
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);

				if (i  == total_pkt)
				{
					// compare DoS Type
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TearDrop, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP TearDrop"), SUCCESS);
					#endif
					VALUE_CMP(log_reinit(), SUCCESS);
				}

			}
		}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_teardrop_2	| DOS teardrop attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: teardrop from Internal Host
 */
int32 dosTearDrop_2(uint32 caseNo){
	int8 pkt_content[1448];
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int pkt_no;
	const int total_pkt = 5;
	uint16 udp_payload = 1448;
	uint32 pktType, hdrsize, pi;
	uint32 pktTypeArr[3] = {_PKT_TYPE_TCP, _PKT_TYPE_UDP, _PKT_TYPE_ICMP};
	uint32 hdrsizeArr[3] = {sizeof(struct tcphdr), sizeof(struct udphdr), 8};
	ipaddr_t dip, dipArr[3] = {ip_gw_int, ip_gw_ext, ip_rp};
	uint16 dport = 0x1234;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

for (pi = 0; pi < 3 ; pi++)
{
	pktType = pktTypeArr[pi];
	hdrsize = hdrsizeArr[pi];
	dip = dipArr[pi];

	/*
		NPI	->	RP
	*/
	{
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt

		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			uint16 offset = (udp_payload * (pkt_no - 1));

			if (pkt_no == total_pkt)
			{
				offset -= (1 * 8);
			}
			
			mbuf_in = confVlanHSB( NULL, NULL,
				pktType, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, dip, 11, (pkt_no == total_pkt?0:1), offset,
				port_npi, dport, 0, 0, ICMP_ECHO, 1, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-hdrsize):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);

			if (pkt_no == total_pkt)
			{
				// compare DoS Type
				VALUE_CMP(log_cnt(), 1);
				#ifdef _RTL_NEW_LOGGING_MODEL
				VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TearDrop, NULL), SUCCESS);
				#else
				VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP TearDrop"), SUCCESS);
				#endif
				VALUE_CMP(log_reinit(), SUCCESS);
			}
		}
	}
	/*
		NPI	->	RP, out-of-order
	*/
	{
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt

		for (pkt_no = total_pkt ; pkt_no >= 1 ; pkt_no --)
		{
			uint16 offset = (udp_payload * (pkt_no - 1));
			uint32 datalen = (pkt_no == 1?(sizeof(pkt_content)-hdrsize):(sizeof(pkt_content)));
		
			if (pkt_no == 1)
			{
				datalen += (1*8);
			}
		
			mbuf_in = confVlanHSB( NULL, NULL,
				pktType, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, dip, 11, (pkt_no == total_pkt?0:1), offset,
				port_npi, dport, 0, 0, ICMP_ECHO, 1, pkt_content, datalen);
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);

			if (pkt_no == 1)
			{
				// compare DoS Type
				VALUE_CMP(log_cnt(), 1);
				#ifdef _RTL_NEW_LOGGING_MODEL
				VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TearDrop, NULL), SUCCESS);
				#else
				VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP TearDrop"), SUCCESS);
				#endif
				VALUE_CMP(log_reinit(), SUCCESS);
			}
		}
	}
	{
	/*
		NPI	->	RP, out-of-order 2
	*/
	{
		int i;
		int list[5] = {1, 3, 5, 2, 4};

		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt

		for (i = 1 ; i <= total_pkt ; i ++)
		{
			uint16 offset;
			pkt_no = list[i - 1];
			offset = (udp_payload * (pkt_no - 1));

			if (pkt_no == total_pkt)
			{
				offset -= (1*8);
			}
			mbuf_in = confVlanHSB( NULL, NULL,
				pktType, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, dip, 11, (pkt_no == total_pkt?0:1), offset,
				port_npi, dport, 0, 0, ICMP_ECHO, 1, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-hdrsize):(sizeof(pkt_content))));
	
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);

			if (i  == total_pkt)
			{
				// compare DoS Type
				VALUE_CMP(log_cnt(), 1);
				#ifdef _RTL_NEW_LOGGING_MODEL
				VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TearDrop, NULL), SUCCESS);
				#else
				VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP TearDrop"), SUCCESS);
				#endif
				VALUE_CMP(log_reinit(), SUCCESS);
			}

		}
	}
	}
}
	return SUCCESS;
}
/*
@func int32		| DOS_tcpland_1	| DOS tcpland attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: tcpland attack from Remote Host
 */
int32 dosTcpLand_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		RP	->	NPI	SYN
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);

}
	return SUCCESS;
}
/*
@func int32		| DOS_tcpland_2	| DOS tcpland attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: tcpland attack from Internal Host
 */
int32 dosTcpLand_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	uint16 dport_arr[4] = {port_gw, port_gw, port_rp, port_npi2};
	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 4 ; d_type ++)
{
	dip = dip_arr[d_type];
	dport = dport_arr[d_type];
	
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= dip;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= dport;
	conf.conf_dport					= dport;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 3);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_GE(log_cnt(), 1);
	VALUE_LE(log_cnt(), 2);
	if (dip != ip_gw_int)
	{
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		#endif
	}else
	{
		VALUE_CMP(log_cnt(), 1);
	}
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);
}
	return SUCCESS;
}
/*
@func int32		| DOS_udpland_1	| DOS udpland attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udpland attack from Remote Host
 */
int32 dosUdpLand_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		UDP
		RP	->	NPI
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* Udp packet */
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_gw;
	conf.conf_dport					= port_gw;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);

}
	return SUCCESS;
}
/*
@func int32		| DOS_udpland_2	| DOS udpland attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udpland attack from Internal Host
 */
int32 dosUdpLand_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		UDP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
		ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	uint16 dport_arr[4] = {port_gw, port_gw, port_rp, port_npi2};
	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 4 ; d_type ++)
{
	dip = dip_arr[d_type];
	dport = dport_arr[d_type];

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= dip;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= dport;
	conf.conf_dport					= dport;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 3);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_GE(log_cnt(), 1);
	VALUE_LE(log_cnt(), 2);
	if (dip != ip_gw_int)
	{
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		#endif
	}else
	{
		VALUE_CMP(log_cnt(), 1);
	}
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);
}
	return SUCCESS;
}
/*
@func int32		| DOS_icmpland_1	| DOS icmpland attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmpland attack from Remote Host
 */
int32 dosIcmpLand_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		RP	->	GW
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1")); 
	uint16 id_int = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 id_ext = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 icmpType;	

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	rtl8651a_setDosStatus(0, RTL8651_DOS_ICMPLAND);

for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)icmpType;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
 	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);
}
	return SUCCESS;
}
/*
@func int32		| DOS_icmpland_2	| DOS icmpland attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmpland attack from Internal Host
 */
int32 dosIcmpLand_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1")); 
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 id_int = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 id_ext = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	ipaddr_t dip;
	uint16 d_type;
	uint16 id = 0;
	uint16 icmpType;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
for (d_type = 0 ; d_type < 4 ; d_type ++, id++)
{
	rtl8651_dosOneSecondTimer();
	dip = dip_arr[d_type];

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= dip;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)icmpType;
	conf.icmp.code					= 0;
	conf.icmp.id						= id;
	conf.icmp.seq						= 1;
 	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 2);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_GE(log_cnt(), 1);
	VALUE_LE(log_cnt(), 3);
	if (dip != ip_gw_int)
	{
		VALUE_GE(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		#endif
	}
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
	#endif
	if (icmpType == ICMP_ECHO)
	{
		if (dip != ip_gw_int)
		{
			VALUE_GE(log_cnt(), 2);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpSmurf, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Smurf"), SUCCESS);
			#endif
		}
	}
	VALUE_CMP(log_reinit(), SUCCESS);
}
	return SUCCESS;
}
/*
@func int32		| DOS_smurf_1	| DOS smurf attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmp smurf attack from Remote/Internal Host
 */
int32 dosSmurf_1(uint32 caseNo){
	/**********************************************
		ICMP
		RP	->	GW
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
		NPI	->	NPI2
 	***********************************************/
	int32 retval;
	struct rtl_mBuf *mbuf_in;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi_err = ntohl(inet_addr("192.168.2.1")); 
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.2"));
	uint16 id = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp_err = ntohl(inet_addr("140.115.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	/*
		RP	->	GW
	*/
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0,
			ip_rp_err, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpSmurf, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Smurf"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	/*
		NPI	->	GW_INT
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi_err, ip_gw_int, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpSmurf, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Smurf"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	/*
		NPI	->	GW_EXT
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi_err, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpSmurf, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Smurf"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	/*
		NPI	->	RP
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi_err, ip_rp_err, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpSmurf, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Smurf"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	/*
		NPI	->	NPI2
	*/
	{
		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
			ip_npi_err, ip_npi2, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(log_cnt(), 2);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpSmurf, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Smurf"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	return SUCCESS;
}
/*
@func int32		| DOS_PingOfDeath_1	| DOS PingOfDeath attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmp PingOfDeath attack from Remote Host
 */
int32 dosPingOfDeath_1(uint32 caseNo){
	int8 pkt_content[0xf];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		RP	->	GW
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1")); 
	uint16 id_int = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 id_ext = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 icmpType;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
{
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// if dos is detected, this ip will be put into blacklist and be dropped before next DOS detect

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_ICMP;
	conf.l2Flag						|= L2_PPPoE;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0xfff0;
	conf.ip.ttl							= 255;
	conf.icmp.type					= (uint8)icmpType;
	conf.icmp.code					= 0;
	conf.icmp.id						= id_ext;
	conf.icmp.seq						= 1;
 	conf.payload.content				= pkt_content;
	conf.payload.length				= 0x10;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);
}
	return SUCCESS;
}
/*
@func int32		| DOS_PingOfDeath_2	| DOS PingOfDeath attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: icmp PingOfDeath attack from Internal Host
 */
int32 dosPingOfDeath_2(uint32 caseNo){
	int8 pkt_content[0xf];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		ICMP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1")); 
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1")); 
	uint16 id_int = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 id_ext = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	ipaddr_t dip;
	uint16 d_type;
	uint16 id = 0;
	uint16 icmpType;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		id ++;
		_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// if dos is detected, this ip will be put into blacklist and be dropped before next DOS detect

		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ICMP;
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_npi, conf.conf_smac);
		CP_MAC (mac_gw_int, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= dip;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0xfff0;
		conf.ip.ttl							= 255;
		conf.icmp.type					= (uint8)icmpType;
		conf.icmp.code					= 0;
		conf.icmp.id						= id;
		conf.icmp.seq						= 1;
	 	conf.payload.content				= pkt_content;
		conf.payload.length				= 0x10;

		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genMbufPkt(&conf);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	return SUCCESS;
}
/*
@func int32		| DOS_udpBomb_1	| DOS udp bomb attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udp bomb attack (udp length specified is less than ip length specified) from Remote Host
 */
 int32 dosUdpBomb_1(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		RP	->	GW	single packet
		RP	->	GW	in-order
		RP	->	GW	out-of-order
		RP	->	GW	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// only allow UDPBOMB test
	rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

	/*****************************************************************************************/
	/*							single packet test												  */
	/*****************************************************************************************/
	// udp Bomb check is turned ON, so illegal packet is detected
	// legal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	// L4 > L3 : legal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	// L4 < L3 : illegal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	// turn UDPBOMB test OFF
	rtl8651a_setDosStatus(0, 0);
	// udp Bomb check is turned OFF, so illegal packet is allowed
	// legal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	// L4 > L3 : legal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	// L4 < L3 : illegal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}

	// only allow UDPBOMB test
	rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

	// udp Bomb check is turned ON again, so illegal packet is detected
	// legal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	// L4 > L3 : legal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	// L4 < L3 : illegal
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 11, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		{
			struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
			u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
		}
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}

	/*****************************************************************************************/
	/*							Fragment test													  */
	/*****************************************************************************************/
	// udp Bomb check is turned ON, so illegal packet is detected

	// only allow UDPBOMB test
	rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

	// legal
	/*
		RP	->	GW

		udp header length == total ip payload length -> legal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n1;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n1:
		rtl8651_dosOneSecondTimer();
	}

	/*
		NPI	->	GW

		udp header length > total ip payload length -> legal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n2;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n2:
		rtl8651_dosOneSecondTimer();
	}

	/*
		NPI	->	GW

		udp header length < total ip payload length -> illegal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n3;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
n3:
		rtl8651_dosOneSecondTimer();
	}

	// udp Bomb check is turned OFF, so illegal packet is allowed (TEAR_DROP is Opened to prevent Queueing System stop)
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	// legal
	/*
		NPI	->	GW

		udp header length == total ip payload length -> legal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n4;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n4:
		rtl8651_dosOneSecondTimer();
	}
	/*
		NPI	->	GW

		udp header length > total ip payload length -> legal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n5;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n5:
		rtl8651_dosOneSecondTimer();
	}

	/*
		NPI	->	GW

		udp header length < total ip payload length -> illegal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n6;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
			}

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n6:
		rtl8651_dosOneSecondTimer();
	}

	// enable UDP bomb again, illegal packet will be detected again

	// allow UDPBOMB test again
	rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

	// legal
	/*
		RP	->	GW

		udp header length == total ip payload length -> legal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n7;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n7:
		rtl8651_dosOneSecondTimer();
	}

	/*
		NPI	->	GW

		udp header length > total ip payload length -> legal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n8;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
n8:
		rtl8651_dosOneSecondTimer();
	}

	/*
		NPI	->	GW

		udp header length < total ip payload length -> illegal
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
					goto n9;
		}

		// reset dos counter to prevent DOS udp packet count
		rtl8651_dosOneSecondTimer();

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 0,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			if (pkt_no == 1)
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (uint32)14 + (uint32)8);
				u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
			}
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
n9:
		rtl8651_dosOneSecondTimer();
	}
	return SUCCESS;
 }

/*
@func int32		| DOS_udpBomb_2	| DOS udp bomb attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udp bomb attack from npi
 */
 int32 dosUdpBomb_2(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		NPI	->	GW INT	single packet
		NPI	->	GW INT	out-of-order (legal)
		NPI	->	GW INT	out-of-order (illegal1)
		NPI	->	GW INT	out-of-order (illegal2)

		NPI	->	GW EXT	single packet
		NPI	->	GW EXT	out-of-order (legal)
		NPI	->	GW EXT	out-of-order (illegal1)
		NPI	->	GW EXT	out-of-order (illegal2)

		NPI	->	RP	single packet
		NPI	->	RP	out-of-order (legal)
		NPI	->	RP	out-of-order (illegal1)
		NPI	->	RP	out-of-order (illegal2)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();


	/*************************************************************************************************/
	/*************************************************************************************************/
	/*									to GW INT													  */
	/*************************************************************************************************/
	/*************************************************************************************************/
	{

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		/*****************************************************************************************/
		/*							single packet test												  */
		/*****************************************************************************************/
		// udp Bomb check is turned ON, so illegal packet is detected
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 < L3 : illegal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// turn UDPBOMB test OFF
		rtl8651a_setDosStatus(0, 0);
		// udp Bomb check is turned OFF, so illegal packet is allowed
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 < L3 : illegal	
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// udp Bomb check is turned ON again, so illegal packet is detected
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 < L3 : illegal	
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}

		/*****************************************************************************************/
		/*							Fragment test													  */
		/*****************************************************************************************/
		// udp Bomb check is turned ON, so illegal packet is detected

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// legal
		/*
			RP	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n11;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n11:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n12;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n12:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n13;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
	n13:
			rtl8651_dosOneSecondTimer();
		}

		// udp Bomb check is turned OFF, so illegal packet is allowed (TEAR_DROP is Opened to prevent Queueing System stop)
		rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

		// legal
		/*
			NPI	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n14;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n14:
			rtl8651_dosOneSecondTimer();
		}
		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n15;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n15:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n16;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n16:
			rtl8651_dosOneSecondTimer();
		}

		// enable UDP bomb again, illegal packet will be detected again

		// allow UDPBOMB test again
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// legal
		/*
			RP	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n17;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n17:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n18;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n18:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n19;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
	n19:
			rtl8651_dosOneSecondTimer();
		}
	}

	/*************************************************************************************************/
	/*************************************************************************************************/
	/*									to GW EXT													  */
	/*************************************************************************************************/
	/*************************************************************************************************/
	{

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		/*****************************************************************************************/
		/*							single packet test												  */
		/*****************************************************************************************/
		// udp Bomb check is turned ON, so illegal packet is detected
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 < L3 : illegal	
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// turn UDPBOMB test OFF
		rtl8651a_setDosStatus(0, 0);
		// udp Bomb check is turned OFF, so illegal packet is allowed
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 < L3 : illegal	
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// udp Bomb check is turned ON again, so illegal packet is detected
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 > L3 : llegal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FAILED);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
			freeMbuf(mbuf_in);
		}
		// L4 < L3 : illegal	
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext, 11, 0, 0,
				port_npi, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}

		/*****************************************************************************************/
		/*							Fragment test													  */
		/*****************************************************************************************/
		// udp Bomb check is turned ON, so illegal packet is detected

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// legal
		/*
			RP	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n21;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n21:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n22;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n22:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n23;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
	n23:
			rtl8651_dosOneSecondTimer();
		}

		// udp Bomb check is turned OFF, so illegal packet is allowed (TEAR_DROP is Opened to prevent Queueing System stop)
		rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

		// legal
		/*
			NPI	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n24;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n24:
			rtl8651_dosOneSecondTimer();
		}
		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n25;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n25:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n26;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n26:
			rtl8651_dosOneSecondTimer();
		}

		// enable UDP bomb again, illegal packet will be detected again

		// allow UDPBOMB test again
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// legal
		/*
			RP	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n27;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n27:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n28;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_comp->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	n28:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n29;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
	n29:
			rtl8651_dosOneSecondTimer();
		}
	}

	/*************************************************************************************************/
	/*************************************************************************************************/
	/*									to RP														  */
	/*************************************************************************************************/
	/*************************************************************************************************/
	{

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		/*****************************************************************************************/
		/*							single packet test												  */
		/*****************************************************************************************/
		// udp Bomb check is turned ON, so illegal packet is detected
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}
		// L4 < L3 : illegal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}
		// turn UDPBOMB test OFF
		rtl8651a_setDosStatus(0, 0);
		// udp Bomb check is turned OFF, so illegal packet is allowed
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}
		// L4 < L3 : illegal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// udp Bomb check is turned ON again, so illegal packet is detected
		// legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content));
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}
		// L4 > L3 : legal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) + 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
			// compare DoS Type
			VALUE_CMP(log_cnt(), 0);
		}
		// L4 < L3 : illegal
		{
			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, 0, 0,
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			{
				struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
				u->uh_ulen = htons(sizeof(struct udphdr) + sizeof(pkt_content) - 1);
			}
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
		}

		/*****************************************************************************************/
		/*							Fragment test													  */
		/*****************************************************************************************/
		// udp Bomb check is turned ON, so illegal packet is detected

		// only allow UDPBOMB test
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// legal
		/*
			RP	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n31;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output		
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				freeMbuf(mbufList_dequeue());
	n31:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n32;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output		
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				freeMbuf(mbufList_dequeue());
	n32:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n33;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
	n33:
			rtl8651_dosOneSecondTimer();
		}

		// udp Bomb check is turned OFF, so illegal packet is allowed (TEAR_DROP is Opened to prevent Queueing System stop)
		rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

		// legal
		/*
			NPI	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n34;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			freeMbuf(mbufList_dequeue());
	n34:
			rtl8651_dosOneSecondTimer();
		}
		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n35;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				freeMbuf(mbufList_dequeue());
	n35:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n36;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				freeMbuf(mbufList_dequeue());
	n36:
			rtl8651_dosOneSecondTimer();
		}

		// enable UDP bomb again, illegal packet will be detected again

		// allow UDPBOMB test again
		rtl8651a_setDosStatus(0, RTL8651_DOS_UDPBOMB);

		// legal
		/*
			RP	->	GW

			udp header length == total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n37;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content));
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output		
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				freeMbuf(mbufList_dequeue());
	n37:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length > total ip payload length -> legal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n38;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) + 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), (p == total_pkt?total_pkt:0));
				// compare DoS Type
				VALUE_CMP(log_cnt(), 0);
				VALUE_CMP(log_reinit(), SUCCESS);
			}
			// Output		
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
				freeMbuf(mbufList_dequeue());
	n38:
			rtl8651_dosOneSecondTimer();
		}

		/*
			NPI	->	GW

			udp header length < total ip payload length -> illegal
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
						goto n39;
			}

			// reset dos counter to prevent DOS udp packet count
			rtl8651_dosOneSecondTimer();

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				if (pkt_no == 1)
				{
					struct udphdr *u = (struct udphdr*)((uint32)(mbuf_in->m_data) + (uint32)20 + (int32)14);
					u->uh_ulen = htons(total_pkt * sizeof(pkt_content) - 1);
				}
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// compare DoS Type
			VALUE_CMP(log_cnt(), 1);
			#ifdef _RTL_NEW_LOGGING_MODEL
			VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpBomb, NULL), SUCCESS);
			#else
			VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Bomb"), SUCCESS);
			#endif
			VALUE_CMP(log_reinit(), SUCCESS);
	n39:
			rtl8651_dosOneSecondTimer();
		}
	}

	return SUCCESS;
 }


/*
@func int32		| DOS_ipspoof_1	| DOS ip spoof attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: ip spoof attack from Remote Host
 */
int32 dosIpSpoof_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		RP	->	NPI
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("10.113.2.123"));
	uint16 port_rp2 = 0x3456;
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_gw_ext2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x05}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_rp2 = {{0x00, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_rp2, conf.conf_smac);
	CP_MAC (mac_gw_ext2, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 4;
	SET_RX_PORT(conf.conf_portlist, 5);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);

}
	return SUCCESS;
}
/*
@func int32		| DOS_ipspoof_2	| DOS ip spoof attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: ip spoof attack from Internal Host
 */
int32 dosIpSpoof_2(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		TCP
		NPI	->	GW_INT
		NPI	->	GW_EXT
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1")); 
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	uint16 dport_arr[4] = {port_gw, port_gw, port_rp, port_npi2};
	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

for (d_type = 0 ; d_type < 4 ; d_type ++)
{
	dip = dip_arr[d_type];
	dport = dport_arr[d_type];

	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int2, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= dip;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= dport;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 3;
	SET_RX_PORT(conf.conf_portlist, 4);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IpSpoof, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"IP Spoofing"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);

}
	return SUCCESS;
}
/*
@func int32		| DOS_udpEchoChargen_1	| DOS udp echo chargen attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: udp echo loop from Internal Host
 */
int32 dosUdpEchoChargen_1(uint32 caseNo){
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		1 wan(pppoe), 2 lan

		TCP
		NPI	->	RP
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint16 bomb_port_list[3] = {7, 17, 19};
	uint16 bomb_port = bomb_port_list[0];
	int32 nCount, test_sport;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
	*/
for (test_sport = 0 ; test_sport < 2; test_sport ++)
for (nCount = 0; ((nCount < 3)&&(bomb_port = bomb_port_list[nCount])); nCount ++)
{
	/* config */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;
	conf.l2Flag						= 0;
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_gw_int;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	if (test_sport)
	{
		conf.conf_sport				= bomb_port;
		conf.conf_dport				= port_gw;
	}
	else
	{
		conf.conf_sport				= port_npi;
		conf.conf_dport				= bomb_port;
	}
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 2);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
	VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
	// compare DoS Type
	VALUE_CMP(log_cnt(), 1);
	#ifdef _RTL_NEW_LOGGING_MODEL
	VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpEchoChargen, NULL), SUCCESS);
	#else
	VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Echo Chargen"), SUCCESS);
	#endif
	VALUE_CMP(log_reinit(), SUCCESS);

}
	return SUCCESS;
}
/*
@func int32		| DOS_tcpScan_1	| DOS tcp scan attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: tcp scan attack from Internal Host to Remote Host or another Internal Host
 */
int32 dosTcpScan_1(uint32 caseNo){
	/**********************************************
		1 wan(pppoe), 2 lan

		TCP
		NPI	->	RP
		NPI	->	NPI2
 	***********************************************/
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_test;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	// DOS Cases:
	//	0: - NULL scan
	//	 3: SYN,FIN - SYN/FIN scan
	//	 8: PUSH	-Vecna
	//	 9: PUSH, FIN -Vecna
	//	 32: URG	-Vecna
	//	 33: URG, FIN -Vecna	
	//	 40: URG,PUSH -Vecna
	//	 41: URG,PUSH,FIN: - nmap xmas scan
	//	 58: SYN,ACK,URG,PUSH - full Sapu scan
	//	 63: SYN,RST,FIN,URG,PUSH,ACK - full Xmas scan
	uint32 cnt;
	uint8 scan_case[10] = {0,3,8,9,32,33,40,41,58,63};
	uint8 tcp_flags;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
	*/
	for (cnt = 0 ; cnt < 10 ; cnt ++)
	{
		tcp_flags = scan_case[cnt];
	
		mbuf_test = confVlanHSB( &conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_npi2, 111, 0, 0,
			port_npi, port_npi2, tcp_flags, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_test->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpScan, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Scan"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	/*
		NPI	->	RP :
	*/
	for (cnt = 0 ; cnt < 10 ; cnt ++)
	{
		tcp_flags = scan_case[cnt];
	
		mbuf_test = confVlanHSB( &conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 111, 0, 0,
			port_npi, port_rp, tcp_flags, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_test->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);

		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpScan, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"TCP Scan"), SUCCESS);
		#endif
		VALUE_CMP(log_reinit(), SUCCESS);
	}
	return SUCCESS;
}

/*
@func int32		| DOS_TcpUdpPortScan_1	| DOS tcp/udp scan attack testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: tcp syn/fin/ack scan and udp scan from Internal Host to Remote Host or another Internal Host
 */
int32 dosTcpUdpPortScan_1(uint32 caseNo)
{
	/**********************************************
		1 wan(pppoe), 2 lan

		SYN/FIN/ACK/UDP

		NPI	->	RP
		NPI	->	NPI2
 	***********************************************/
	rtl8651_PktConf_t	conf, conf_err;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	int32 i, j, k, l;
	const uint32 window = 10;
	const uint32 threshold = 10;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	srandom(time(NULL));

	/* Turn ON port scan */
	rtl8651a_setDosStatus(0, RTL8651_DOS_PORTSCAN);

	/* set threshold and window */
	rtl8651_dosScanTrackingSetPara(0, window, threshold);

	_rtl8651_timeUpdate(1);

	/******************
		NPI	->	RP
	*******************/
	/*<--------------------------- SYN --------------------------->*/
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_rp, 123, 0, 0,
		port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	// get external port
	mbuf_out = mbufList_dequeue();
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	freeMbuf(mbuf_out);
	/* rst */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0,
					port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				VALUE_CMP(log_cnt(), 0);
				// get external port
				mbuf_out = mbufList_dequeue();
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
				freeMbuf(mbuf_out);
				/* rst */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_SYN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"SYN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		// get external port
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		freeMbuf(mbuf_out);
		/* rst */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- FIN --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_rp, 123, 0, 0,
		port_npi, port_rp, TH_FIN, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* generate error flow */
	i = (threshold - 1);	/* for error egress flow, we can recognize this scan if threshold is reached (no error flow needed) */
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0,
					port_npi, port_rp, TH_FIN, 0, 0, 0, NULL, 0);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
					VALUE_CMP(mbufList_nmbuf(), 0);
					freeMbuf(mbuf_in);
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_FIN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"FIN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
					VALUE_CMP(mbufList_nmbuf(), 0);
					freeMbuf(mbuf_in);
					VALUE_CMP(log_cnt(), 0);
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_FIN, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- ACK --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_rp, 123, 0, 0,
		port_npi, port_rp, TH_ACK, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* generate error flow */
	i = (threshold - 1);	/* for error egress flow, we can recognize this scan if threshold is reached (no error flow needed) */
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0,
					port_npi, port_rp, TH_ACK, 0, 0, 0, NULL, 0);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
					VALUE_CMP(mbufList_nmbuf(), 0);
					freeMbuf(mbuf_in);
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_ACK, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ACK Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
					VALUE_CMP(mbufList_nmbuf(), 0);
					freeMbuf(mbuf_in);
					VALUE_CMP(log_cnt(), 0);
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- UDP --------------------------->*/
	port_npi ++;
	port_rp ++;
	/* attack flow */
	mbuf_in = confVlanHSB(&conf_err, NULL,
		_PKT_TYPE_UDP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_rp, 123, 0, 0,
		port_npi, port_rp, 0, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	// get external port
	mbuf_out = mbufList_dequeue();
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
	{
		uint16 tx_port[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA(&conf_err, NULL,
						_PKT_TYPE_UDP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, 122, 0, 0,
						port_gw, port_rp, 0, 0, 0, 0, NULL, 0);
	}
	MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	/* icmp unreach */
	/* get conf */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_ICMP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, 0, 0, ICMP_UNREACH, 0, NULL, 0);
	/* modify conf and free unused mbuf_in */
	freeMbuf(mbuf_in);
	conf.icmp.code = ICMP_UNREACH_PORT;
	mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confVlanHSB(&conf_err, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0,
					port_npi, port_rp, 0, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				VALUE_CMP(log_cnt(), 0);
				// get external port
				mbuf_out = mbufList_dequeue();
				ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
				{
					uint16 tx_port[2] = {0, 0xffff};
					mbuf_comp = confPppoeHSA(&conf_err, NULL,
						_PKT_TYPE_UDP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, 122, 0, 0,
						port_gw, port_rp, 0, 0, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				/* icmp unreach */
				/* get conf */
				mbuf_in = confPppoeHSB(&conf, &conf_err,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, 0, 0, ICMP_UNREACH, 0, NULL, 0);
				/* modify conf and free unused mbuf_in */
				freeMbuf(mbuf_in);
				conf.icmp.code = ICMP_UNREACH_PORT;
				mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_UDP, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf_err, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		// get external port
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
		{
			uint16 tx_port[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(&conf_err, NULL,
				_PKT_TYPE_UDP, tx_port, 1, 0,
				mac_gw_ext, mac_pppoe,
				ip_gw_ext, ip_rp, 122, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		/* icmp unreach */
		/* get conf */
		mbuf_in = confPppoeHSB(&conf, &conf_err,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, ICMP_UNREACH, 0, NULL, 0);
		/* modify conf and free unused mbuf_in */
		freeMbuf(mbuf_in);
		conf.icmp.code = ICMP_UNREACH_PORT;
		mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);

	/******************
		NPI	->	NPI2
	*******************/
	/*<--------------------------- SYN --------------------------->*/
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_npi2, 123, 0, 0,
		port_npi, port_npi2, TH_SYN, 1460, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* rst */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 4, 3, 0,
		mac_npi2, mac_gw_int2,
		ip_npi2, ip_npi, 123, 0, 0,
		port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_npi2, 123, 0, 0,
						port_npi, port_npi2, TH_SYN, 1460, 0, 0, NULL, 0);
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
					/* rst */
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_npi2, mac_gw_int2,
						ip_npi2, ip_npi, 123, 0, 0,
						port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_SYN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"SYN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 0, 0,
			port_npi, port_npi2, TH_SYN, 1460, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
		/* rst */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_npi, 123, 0, 0,
			port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- FIN --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_npi2, 123, 0, 0,
		port_npi, port_npi2, TH_FIN, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* rst */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 4, 3, 0,
		mac_npi2, mac_gw_int2,
		ip_npi2, ip_npi, 123, 0, 0,
		port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_npi2, 123, 0, 0,
						port_npi, port_npi2, TH_FIN, 0, 0, 0, NULL, 0);
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
					/* rst */
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_npi2, mac_gw_int2,
						ip_npi2, ip_npi, 123, 0, 0,
						port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_FIN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"FIN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 0, 0,
			port_npi, port_npi2, TH_FIN, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
		/* rst */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_npi, 123, 0, 0,
			port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- ACK --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_npi2, 123, 0, 0,
		port_npi, port_npi2, TH_ACK, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* rst */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 4, 3, 0,
		mac_npi2, mac_gw_int2,
		ip_npi2, ip_npi, 123, 0, 0,
		port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_npi2, 123, 0, 0,
						port_npi, port_npi2, TH_ACK, 0, 0, 0, NULL, 0);
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
					/* rst */
					mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 3, 0,
						mac_npi2, mac_gw_int2,
						ip_npi2, ip_npi, 123, 0, 0,
						port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_ACK, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ACK Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 0, 0,
			port_npi, port_npi2, TH_ACK, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
		/* rst */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_npi, 123, 0, 0,
			port_npi2, port_npi, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- UDP --------------------------->*/
	port_npi ++;
	port_rp ++;
	/* attack flow */
	mbuf_in = confVlanHSB(&conf_err, NULL,
		_PKT_TYPE_UDP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_npi2, 123, 0, 0,
		port_npi, port_npi2, 0, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	// get external port
	mbuf_out = mbufList_dequeue();
	{
		uint16 tx_port[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf_err, NULL,
						_PKT_TYPE_UDP, tx_port, 3, 0,
						mac_gw_int2, mac_npi2,
						ip_npi, ip_npi2, 122, 0, 0,
						port_npi, port_npi2, 0, 0, 0, 0, NULL, 0);
	}
	MBUF_CMPandFREE(mbuf_out, mbuf_comp);
	/* icmp unreach */
	/* get conf */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_ICMP, 4, 3, 0,
		mac_npi2, mac_gw_int2,
		ip_npi2, ip_npi, 123, 0, 0,
		0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
	/* modify conf and free unused mbuf_in */
	freeMbuf(mbuf_in);
	conf.icmp.code = ICMP_UNREACH_PORT;
	mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confVlanHSB(&conf_err, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_npi2, 123, 0, 0,
					port_npi, port_npi2, 0, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				VALUE_CMP(log_cnt(), 0);
				// get external port
				mbuf_out = mbufList_dequeue();
				{
					uint16 tx_port[2] = {4, 0xffff};
					mbuf_comp = confVlanHSA(&conf_err, NULL,
									_PKT_TYPE_UDP, tx_port, 3, 0,
									mac_gw_int2, mac_npi2,
									ip_npi, ip_npi2, 122, 0, 0,
									port_npi, port_npi2, 0, 0, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
				/* icmp unreach */
				/* get conf */
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_ICMP, 4, 3, 0,
					mac_npi2, mac_gw_int2,
					ip_npi2, ip_npi, 123, 0, 0,
					0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
				/* modify conf and free unused mbuf_in */
				freeMbuf(mbuf_in);
				conf.icmp.code = ICMP_UNREACH_PORT;
				mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_UDP, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confVlanHSB(&conf_err, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_npi2, 123, 0, 0,
			port_npi, port_npi2, 0, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		// get external port
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_port[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(&conf_err, NULL,
							_PKT_TYPE_UDP, tx_port, 3, 0,
							mac_gw_int2, mac_npi2,
							ip_npi, ip_npi2, 122, 0, 0,
							port_npi, port_npi2, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		/* icmp unreach */
		/* get conf */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 4, 3, 0,
			mac_npi2, mac_gw_int2,
			ip_npi2, ip_npi, 123, 0, 0,
			0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
		/* modify conf and free unused mbuf_in */
		freeMbuf(mbuf_in);
		conf.icmp.code = ICMP_UNREACH_PORT;
		mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);

	return SUCCESS;
}

/*
@func int32		| DOS_TcpUdpPortScan_2	| DOS tcp/udp scan attack testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS function: tcp syn/fin/ack scan and udp scan from Remote Host to Gateway/dmz host
 */
int32 dosTcpUdpPortScan_2(uint32 caseNo)
{
	/**********************************************
		1 wan(pppoe), 2 lan

		SYN/FIN/ACK/UDP

		RP	->	GW
		RP	->	DMZ Host
 	***********************************************/
	rtl8651_PktConf_t	conf, conf_err;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	int32 i, j, k, l;
	const uint32 window = 10;
	const uint32 threshold = 10;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	srandom(time(NULL));

	/* Turn ON port scan */
	rtl8651a_setDosStatus(0, RTL8651_DOS_PORTSCAN);

	/* set threshold and window */
	rtl8651_dosScanTrackingSetPara(0, window, threshold);

	_rtl8651_timeUpdate(1);

	/******************
		RP	->	GW
	*******************/
	/*<--------------------------- SYN --------------------------->*/
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* rst */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_gw_ext, mac_pppoe, 0,
		ip_gw_ext, ip_rp, 123, 0, 0,
		port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbuf_in);
				/* rst */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 0,
					ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
				VALUE_CMP(retval, SUCCESS);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_SYN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"SYN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
		/* rst */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 0,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- FIN --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, TH_FIN, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* rst */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_gw_ext, mac_pppoe, 0,
		ip_gw_ext, ip_rp, 123, 0, 0,
		port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, TH_FIN, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbuf_in);
				/* rst */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 0,
					ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
				VALUE_CMP(retval, SUCCESS);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_FIN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"FIN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_FIN, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
		/* rst */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 0,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- ACK --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, TH_ACK, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* rst */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_gw_ext, mac_pppoe, 0,
		ip_gw_ext, ip_rp, 123, 0, 0,
		port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, TH_ACK, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbuf_in);
				/* rst */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 0,
					ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
				VALUE_CMP(retval, SUCCESS);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_ACK, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ACK Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_ACK, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
		/* rst */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 0,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- UDP --------------------------->*/
	port_npi ++;
	port_rp ++;
	/* attack flow */
	mbuf_in = confPppoeHSB(&conf_err, NULL,
		_PKT_TYPE_UDP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, 0, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* icmp unreach */
	/* get conf */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_ICMP, 0, 1, 0,
		mac_gw_ext, mac_pppoe, 0,
		ip_gw_ext, ip_rp, 123, 0, 0,
		0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
	/* modify conf and free unused mbuf_in */
	freeMbuf(mbuf_in);
	conf.icmp.code = ICMP_UNREACH_PORT;
	mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf_err, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, 0, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbuf_in);
				/* icmp unreach */
				/* get conf */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 0,
					ip_gw_ext, ip_rp, 123, 0, 0,
					0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
				/* modify conf and free unused mbuf_in */
				freeMbuf(mbuf_in);
				conf.icmp.code = ICMP_UNREACH_PORT;
				mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);
				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));

				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_UDP, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf_err, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
		/* icmp unreach */
		/* get conf */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 0,
			ip_gw_ext, ip_rp, 123, 0, 0,
			0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
		/* modify conf and free unused mbuf_in */
		freeMbuf(mbuf_in);
		conf.icmp.code = ICMP_UNREACH_PORT;
		mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);

	/******************
		RP	->	DMZ
	*******************/
	/* add dmz host */
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);
	/*<--------------------------- SYN --------------------------->*/
	port_npi ++;
	port_rp ++;
	/* attack flow */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_npi, TH_SYN, 1460, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* rst */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_rp, 123, 0, 0,
		port_npi, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_npi, TH_SYN, 1460, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbufList_dequeue());
				/* rst */
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0,
					port_npi, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_SYN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"SYN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_npi, TH_SYN, 1460, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
		/* rst */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- FIN --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, TH_FIN, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* rst */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_gw_ext, mac_pppoe, 0,
		ip_gw_ext, ip_rp, 123, 0, 0,
		port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, TH_FIN, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbuf_in);
				/* rst */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 0,
					ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
				VALUE_CMP(retval, SUCCESS);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_FIN, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"FIN Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_FIN, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
		/* rst */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 0,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- ACK --------------------------->*/
	port_npi ++;
	port_rp ++;
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_gw, TH_ACK, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
	VALUE_CMP(mbufList_nmbuf(), 0);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbuf_in);
	/* rst */
	mbuf_in = confPppoeHSB(&conf, NULL,
		_PKT_TYPE_TCP, 0, 1, 0,
		mac_gw_ext, mac_pppoe, 0,
		ip_gw_ext, ip_rp, 123, 0, 0,
		port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_gw, TH_ACK, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				VALUE_CMP(log_cnt(), 0);
				freeMbuf(mbuf_in);
				/* rst */
				mbuf_in = confPppoeHSB(&conf, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 0,
					ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
				VALUE_CMP(retval, SUCCESS);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_ACK, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ACK Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, TH_ACK, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbuf_in);
		/* rst */
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 0,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_RST|TH_ACK), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	/*<--------------------------- UDP --------------------------->*/
	port_npi ++;
	port_rp ++;
	/* attack flow */
	mbuf_in = confPppoeHSB(&conf_err, NULL,
		_PKT_TYPE_UDP, 0, 1, 0,
		mac_pppoe, mac_gw_ext, 0,
		ip_rp, ip_gw_ext, 123, 0, 0,
		port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	{
		uint16 tx_port[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(&conf_err, NULL,
						_PKT_TYPE_UDP, tx_port, 2, 0,
						mac_gw_int, mac_npi,
						ip_rp, ip_npi, 122, 0, 0,
						port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
	}
	MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	/* icmp unreach */
	/* get conf */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_ICMP, 1, 2, 0,
		mac_npi, mac_gw_int,
		ip_npi, ip_rp, 123, 0, 0,
		0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
	/* modify conf and free unused mbuf_in */
	freeMbuf(mbuf_in);
	conf.icmp.code = ICMP_UNREACH_PORT;
	mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	VALUE_CMP(log_cnt(), 0);
	freeMbuf(mbufList_dequeue());
	/* generate flow and rst */
	i = threshold;
	for (j = 0 ; j < (window - 1) ; j ++)
	{
		_rtl8651_timeUpdate(1);
		if (i)
		{
			if (j == (window - 2))	/* last second, we sent remaining scan/rst */
				k = i;
			else
				k = random() % i;
			i = i - k;

			for (l = 0 ; l < k ; l ++)
			{
				port_npi ++;
				port_rp ++;
				/* attack flow */
				mbuf_in = confPppoeHSB(&conf_err, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 0,
					ip_rp, ip_gw_ext, 123, 0, 0,
					port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				VALUE_CMP(retval, SUCCESS);
				VALUE_CMP(mbufList_nmbuf(), 1);
				VALUE_CMP(log_cnt(), 0);
				{
					uint16 tx_port[2] = {1, 0xffff};
					mbuf_comp = confVlanHSA(&conf_err, NULL,
									_PKT_TYPE_UDP, tx_port, 2, 0,
									mac_gw_int, mac_npi,
									ip_rp, ip_npi, 122, 0, 0,
									port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
				}
				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
				/* icmp unreach */
				/* get conf */
				mbuf_in = confVlanHSB(&conf, NULL,
					_PKT_TYPE_ICMP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 123, 0, 0,
					0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
				/* modify conf and free unused mbuf_in */
				freeMbuf(mbuf_in);
				conf.icmp.code = ICMP_UNREACH_PORT;
				mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				if ((i == 0) && (l == (k-1)))	/* complain reach threshold */
				{
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					freeMbuf(mbufList_dequeue());
					VALUE_CMP(log_cnt(), 1);
					#ifdef _RTL_NEW_LOGGING_MODEL
					VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpUdpScan_UDP, NULL), SUCCESS);
					#else
					VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Scan"), SUCCESS);
					#endif
				}else
				{	/* complain not reach threshold, don't log */
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 1);
					VALUE_CMP(log_cnt(), 0);
					freeMbuf(mbufList_dequeue());
				}
			}
		}
	}
	/* more attack flow & rst, we don't log it */
	for (l = 0 ; l < 100 ; l ++)
	{
		port_npi ++;
		port_rp ++;
		/* attack flow */
		mbuf_in = confPppoeHSB(&conf_err, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(&conf_err, NULL,
							_PKT_TYPE_UDP, tx_port, 2, 0,
							mac_gw_int, mac_npi,
							ip_rp, ip_npi, 122, 0, 0,
							port_rp, port_npi, 0, 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/* icmp unreach */
		/* get conf */
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, ip_rp, 123, 0, 0,
			0, 0, 0, 0, ICMP_UNREACH, 0, NULL, 0);
		/* modify conf and free unused mbuf_in */
		freeMbuf(mbuf_in);
		conf.icmp.code = ICMP_UNREACH_PORT;
		mbuf_in = genIcmpErrMbufPkt(&conf_err, &conf);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		VALUE_CMP(log_cnt(), 0);
		freeMbuf(mbufList_dequeue());
	}
	/* expire entry */
	_rtl8651_timeUpdate(window);
	return SUCCESS;
}

/*
@func int32		| DOS_ignoreCase_1	| DOS ignore case testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS ignore function: ignore attack from LAN
 */
int32 dosIgnoreCase_1(uint32 caseNo)
{
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*******************************************************
		1. TCP
		2. UDP
		3. ICMP
		4. fragment
	*******************************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	uint16 dport_arr[4] = {port_gw, port_gw, port_rp, port_npi2};
	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 
	uint16 icmpType;
	uint16 id = 0;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	fwdeng_function_configuration1();

	/************************************
		TCP	- use TCP Land Attack
	************************************/
	/* Turn ON TCP Land */
	rtl8651a_setDosStatus(0, RTL8651_DOS_TCPLAND);
	
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
		#endif
	}

	/* Ignore packet from LAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* TCP Land Attack will not been detected */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		if ((dip == ip_gw_int) || (dip == ip_gw_ext))
		{
			VALUE_CMP(retval, FAILED);	// fwdeng find the dip is gateway ip, so it return FAILED
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else if (dip == ip_rp)
		{	/* silently ignore */
			VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_ADDFAIL);
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else
		{	// routing
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
		}
		// compare DoS Type
		VALUE_GE(log_cnt(), 0);
	}

	/* TCP Land Attack from WAN is detected */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
		#endif
	}

	/* Process packet from LAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* TCP Land Attack is detected again */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
		#endif
	}

	/************************************
		UDP	- use UDP Land Attack
	************************************/
	/* Turn ON UDP Land */
	rtl8651a_setDosStatus(0, RTL8651_DOS_UDPLAND);
	
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, 0, 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
		#endif
	}

	/* Ignore packet from LAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* UDP Land Attack will not been detected */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, 0, 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		if ((dip == ip_gw_int) || (dip == ip_gw_ext))
		{
			VALUE_CMP(retval, FAILED);	// fwdeng find the dip is gateway ip, so it return FAILED
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else if (dip == ip_rp)
		{	/* silently ignore */
			VALUE_CMP(retval, FWDENG_UDP_NAPT_OUT_ADDFAIL);
			VALUE_CMP(mbufList_nmbuf(), 0);
			freeMbuf(mbuf_in);
		}else
		{	// routing
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			freeMbuf(mbufList_dequeue());
		}
		// compare DoS Type
		VALUE_GE(log_cnt(), 0);
	}

	/* UDP Land Attack from WAN is detected */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
		#endif
	}

	/* Process packet from LAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* UDP Land Attack is detected again */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, 0, 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
		#endif
	}
	/************************************
		ICMP	- use ICMP Land Attack
	************************************/
	/* Turn ON ICMP Land */
	rtl8651a_setDosStatus(0, RTL8651_DOS_ICMPLAND);
	
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
		#endif
	}

	/* Ignore packet from LAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* ICMP Land Attack will not been detected */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
		// compare DoS Type
		VALUE_GE(log_cnt(), 0);
	}

	/* ICMP Land Attack from WAN is detected */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
		#endif
	}

	/* Process packet from LAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* ICMP Land Attack is detected again */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
		#endif
	}
	/************************************
		Fragment	- use ICMP Ping of Death
	************************************/
	/* Turn ON ICMP Ping of death */
	rtl8651a_setDosStatus(0, RTL8651_DOS_PINGOFDEATH);

	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		id ++;
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt (because when dos is detected, the ip/id pair will put into Fragment BlackList and dropped)

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, dip, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
	}
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList

	/* Ignore packet from LAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		id ++;
		DEFAULT_IP_ID ++;

		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, dip, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fragment packet is queued
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		// wait expire time and get the icmp-time-exceed message
		_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxFragTimeOut);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
		_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList
	}

	/* ICMP Ping of Death from WAN is detected */
	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	{
		id ++;
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt (because when dos is detected, the ip/id pair will put into Fragment BlackList and dropped)

		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
	}
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList

	/* Process packet from LAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_LAN);

	/* ICMP Ping of Death is detected again */
	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		id ++;
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt (because when dos is detected, the ip/id pair will put into Fragment BlackList and dropped)

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, dip, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
	}
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList

	return SUCCESS;
}

/*
@func int32		| DOS_ignoreCase_2	| DOS ignore case testing 2
@rvalue SUCCESS	| 	test OK
@comm 
Test the DOS ignore function: ignore attack from WAN
 */
int32 dosIgnoreCase_2(uint32 caseNo)
{
	int8 pkt_content[100];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*******************************************************
		1. TCP
		2. UDP
		3. ICMP
		4. fragment
	*******************************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip_arr[4] = {ip_gw_int, ip_gw_ext, ip_rp, ip_npi2};
	uint16 dport_arr[4] = {port_gw, port_gw, port_rp, port_npi2};
	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 
	uint16 icmpType;
	uint16 id = 0;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	fwdeng_function_configuration1();

	/************************************
		TCP	- use TCP Land Attack
	************************************/
	/* Turn ON TCP Land */
	rtl8651a_setDosStatus(0, RTL8651_DOS_TCPLAND);

	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
		#endif
	}

	/* Ignore packet from WAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* TCP Land Attack will not been detected */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
	}

	/* TCP Land Attack from LAN is detected */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, TH_SYN, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
		#endif
	}

	/* Process packet from WAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* TCP Land Attack is detected again */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_TcpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"Land"), SUCCESS);
		#endif
	}

	/************************************
		UDP	- use UDP Land Attack
	************************************/
	/* Turn ON UDP Land */
	rtl8651a_setDosStatus(0, RTL8651_DOS_UDPLAND);

	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
		#endif
	}

	/* Ignore packet from WAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* UDP Land Attack will not been detected */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
	}

	/* UDP Land Attack from LAN is detected */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		dport = dport_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			dport, dport, 0, 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		//VALUE_CMP(retval, FWDENG_USER_IDSCHECKDROP);
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
		#endif
	}

	/* Process packet from WAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* UDP Land Attack is detected again */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			port_gw, port_gw, 0, 0, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_UdpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"UDP Land"), SUCCESS);
		#endif
	}

	/************************************
		ICMP	- use ICMP Land Attack
	************************************/
	/* Turn ON ICMP Land */
	rtl8651a_setDosStatus(0, RTL8651_DOS_ICMPLAND);

	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
		#endif
	}

	/* Ignore packet from WAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* ICMP Land Attack will not been detected */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);	/* replied by icmp replay engine */
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
	}

	/* ICMP Land Attack from LAN is detected */
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			dip, dip, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_GE(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
		#endif
	}

	/* Process packet from WAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* ICMP Land Attack is detected again */
	{
		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_gw_ext, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, (id++), NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpLand, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Land"), SUCCESS);
		#endif
	}
	/************************************
		Fragment	- use ICMP Ping of Death
	************************************/
	/* Turn ON ICMP Ping of death */
	rtl8651a_setDosStatus(0, RTL8651_DOS_PINGOFDEATH);

	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	{
		id ++;
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt (because when dos is detected, the ip/id pair will put into Fragment BlackList and dropped)

		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
	}
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList

	/* Ignore packet from WAN */
	_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* ICMP Ping of Death will not been detected */
	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	{
		dip = dip_arr[d_type];
		id ++;
		DEFAULT_IP_ID ++;

		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fragment packet is queued
		VALUE_CMP(mbufList_nmbuf(), 0);
		// compare DoS Type
		VALUE_CMP(log_cnt(), 0);
		// wait expire time and get the icmp-time-exceed message
		_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxFragTimeOut);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
		_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList
	}

	/* ICMP Ping of Death from LAN is detected */
	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	for (d_type = 0 ; d_type < 4 ; d_type ++)
	{
		dip = dip_arr[d_type];
		id ++;
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt (because when dos is detected, the ip/id pair will put into Fragment BlackList and dropped)

		mbuf_in = confVlanHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 1, 2, 0,
			mac_npi, mac_gw_int,
			ip_npi, dip, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
	}
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList

	/* Process packet from WAN again */
	_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_WAN);

	/* ICMP Ping of Death is detected again */
	for (icmpType = 0 ; icmpType <= 0xff ; icmpType ++)
	{
		id ++;
		DEFAULT_IP_ID ++;		// modify id field of IP hdr when generate pkt (because when dos is detected, the ip/id pair will put into Fragment BlackList and dropped)

		mbuf_in = confPppoeHSB( NULL, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0xfff0,
			0, 0, 0, 0, (uint8)icmpType, id, pkt_content, 0x10);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);	// fwdeng drop and return success
		// compare DoS Type
		VALUE_CMP(log_cnt(), 1);
		#ifdef _RTL_NEW_LOGGING_MODEL
		VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_IcmpPingOfDeath, NULL), SUCCESS);
		#else
		VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"ICMP Ping Of Death"), SUCCESS);
		#endif
	}
	_rtl8651_timeUpdate(RTL8651_DefaultDrvMaxNegativeListTimeOut);	// clear blackList

	return SUCCESS;
}

/*
@func int32		| SourceIpBlocking_1	| Source IP Blocking testing 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the function: block source IP if attacks are detected
 */
int32 SipBlocking_1(uint32 caseNo){
	/*******************************************************
		1 wan(pppoe), 2 lan

		TCP
		RP	->	GW-EXT		SynFlood		--> block source IP
		RP	->	GW-EXT		StealFin		--> block source IP
		RP	->	GW-EXT		UdpFlood		-->	block source IP
		RP	->	GW-EXT		IcmpFlood	--> block source IP
 	********************************************************/
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in;
	/*
		Config Environments
	*/
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp;
	ipaddr_t ip_rp_base = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x01;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	uint16 id = 0;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 nCount, flow, pCount, loopCnt;
	ipaddr_t ip_rp_list[4];
	static uint16 Max_pCount = 10, Max_loopCount = 256;
	int32 pktCnt[4];
	enum en{SYN, FIN, UDP, ICMP};

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	fwdeng_function_configuration1();

	// increase whole-system threshold to prevent these DOS attacks
	rtl8651a_setDosThreshold(0, RTL8651_DOS_SYN_THRESHOLD, ((RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_SYN_TRACKCNT))+1);
	rtl8651a_setDosThreshold(0, RTL8651_DOS_FIN_THRESHOLD, ((RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_FIN_TRACKCNT))+1);
	rtl8651a_setDosThreshold(0, RTL8651_DOS_UDP_THRESHOLD, ((RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_UDP_TRACKCNT))+1);
	rtl8651a_setDosThreshold(0, RTL8651_DOS_ICMP_THRESHOLD, ((RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT + 10)*(RTL8651_DOS_ICMP_TRACKCNT))+1);

	#define DOS_PERSRC_LARGE_THRESHOLD	(RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT+ \
											RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT+ \
											RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT+ \
											RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT + 100)

	// turn-ON source IP blocking
	rtl8651_dosProc_blockSip_enable(0, TRUE);

	srandom( time(NULL) );

	/**********************************************************************************************/
	for (loopCnt = 0 ; loopCnt < Max_loopCount ; loopCnt ++)
	{
	re_rand:
		for (flow = 0 ; flow < 4 ; flow ++)
		{
			ip_rp_list[flow] = ip_rp_base + (random()%65536);
		}
		for (flow = 0 ; flow < 4 ; flow ++)
		{
			int idx;
			for (idx = 0 ; idx < 4 ; idx ++)
			{
				if (idx == flow)	continue;
				if (ip_rp_list[flow] == ip_rp_list[idx])	goto re_rand;
			}
		}
	
		_rtl8651_timeUpdate(1);	// update timer
		for (flow = 0 ; flow < 4 ; flow ++)
		{
			pktCnt[flow] = 0;
		}
		/*
				Attack detect phase
		*/
		for (nCount = 0; nCount < DOS_PERSRC_LARGE_THRESHOLD ; nCount ++)
		{
			for (flow = 0 ; flow < 4 ; flow ++)
			{
				ip_rp = ip_rp_list[flow];
				port_rp = ((random()%3000) + 1024);
				id ++;
				pktCnt[flow] ++;
				
				switch (flow)
				{
					case SYN:
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);
						break;
					case FIN:
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							port_rp, port_gw, TH_FIN, 1460, 0, 0, NULL, 0);
						break;
					case UDP:
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, NULL, 0);
						break;
					case ICMP:
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_ICMP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							0, 0, 0, 0, ICMP_ECHOREPLY, id, NULL, 0);
						break;
					default:
						assert(0);
						break;
				}

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				switch(flow)
				{
					case SYN:
						if (pktCnt[flow] < RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT)
						{
							VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
							freeMbuf(mbuf_in);
						}else
						{
							VALUE_CMP(retval, SUCCESS);
							if (pktCnt[flow] == RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT)
							{
								// compare DoS Type
								VALUE_CMP(log_cnt(), 1);
								#ifdef _RTL_NEW_LOGGING_MODEL
								VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostSynFlood, NULL), SUCCESS);
								#else
								VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: TCP SYN Flood"), SUCCESS);
								#endif
								VALUE_CMP(log_reinit(), SUCCESS);
							}
							if (pktCnt[flow] > RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT) // pkt dropped by sip blocking system
							{
								VALUE_CMP(log_cnt(), 0);
							}
						}
						break;
					case FIN:
						if (pktCnt[flow] < RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT)
						{
							VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
							freeMbuf(mbuf_in);
						}else
						{
							VALUE_CMP(retval, SUCCESS);
							if (pktCnt[flow] == RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT)
							{
								// compare DoS Type
								VALUE_CMP(log_cnt(), 1);
								#ifdef _RTL_NEW_LOGGING_MODEL
								VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostStealthFin, NULL), SUCCESS);
								#else
								VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: TCP Stealth FIN Port Scan"), SUCCESS);
								#endif
								VALUE_CMP(log_reinit(), SUCCESS);
							}
							if (pktCnt[flow] > RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT) // pkt dropped by sip blocking system
							{
								VALUE_CMP(log_cnt(), 0);
							}
						}
						break;
					case UDP:
						if (pktCnt[flow] < RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT)
						{
							VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
							freeMbuf(mbuf_in);
						}else
						{
							VALUE_CMP(retval, SUCCESS);
							if (pktCnt[flow] == RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT)
							{
								// compare DoS Type
								VALUE_CMP(log_cnt(), 1);
								#ifdef _RTL_NEW_LOGGING_MODEL
								VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostUdpFlood, NULL), SUCCESS);
								#else
								VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: UDP Flood"), SUCCESS);
								#endif
								VALUE_CMP(log_reinit(), SUCCESS);
							}
							if (pktCnt[flow] > RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT) // pkt dropped by sip blocking system
							{
								VALUE_CMP(log_cnt(), 0);
							}
						}
						break;
					case ICMP:
						if (pktCnt[flow] < RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT)
						{
							VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
							freeMbuf(mbuf_in);
						}else
						{
							VALUE_CMP(retval, SUCCESS);
							if (pktCnt[flow] == RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT)
							{
								// compare DoS Type
								VALUE_CMP(log_cnt(), 1);
								#ifdef _RTL_NEW_LOGGING_MODEL
								VALUE_CMP(log_cmp(RTL8651_LOGMODULE_DOS,RTL8651_LOG_DOS_HostIcmpFlood, NULL), SUCCESS);
								#else
								VALUE_CMP(log_cmp(0,0,0,0,0,0,0,0,0,0,"HOST Attack: ICMP Flood"), SUCCESS);
								#endif
								VALUE_CMP(log_reinit(), SUCCESS);
							}
							if (pktCnt[flow] > RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT) // pkt dropped by sip blocking system
							{
								VALUE_CMP(log_cnt(), 0);
							}
						}
						break;
				}
			}
		}
		/*
				Source ip block phase
		*/
		for (nCount = 0 ; nCount <= RTL8651_DOSPROC_SIPBLOCK_TIMEOUT ; nCount ++)
		{
			for (pCount = 0 ; pCount < Max_pCount ; pCount ++)
			{
				for (flow = 0 ; flow < 4 ; flow ++)
				{
					ip_rp = ip_rp_list[flow];
					port_rp ++; if (!port_rp){port_rp = 1;}
					id ++;
					
					switch (flow)
					{
						case SYN:
							mbuf_in = confPppoeHSB( NULL, NULL,
								_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
								port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);
							break;
						case FIN:
							mbuf_in = confPppoeHSB( NULL, NULL,
								_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
								port_rp, port_gw, TH_FIN, 1460, 0, 0, NULL, 0);
							break;
						case UDP:
							mbuf_in = confPppoeHSB( NULL, NULL,
								_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
								port_rp, port_gw, 0, 0, 0, 0, NULL, 0);
							break;
						case ICMP:
							mbuf_in = confPppoeHSB( NULL, NULL,
								_PKT_TYPE_ICMP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
								0, 0, 0, 0, ICMP_ECHOREPLY, id, NULL, 0);
							break;
						default:
							assert(0);
							break;
					}

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

					VALUE_CMP(retval, SUCCESS);	// all packet are dropped
					VALUE_CMP(log_cnt(), 0);
				}
			}
			_rtl8651_timeUpdate(1);
		}

		/*
				Source ip discharge phase
		*/
		for (flow = 0 ; flow < 4 ; flow ++)
		{
			pktCnt[flow] = 0;
		}
		for (nCount = 0; nCount < DOS_PERSRC_LARGE_THRESHOLD ; nCount ++)
		{
			for (flow = 0 ; flow < 4 ; flow ++)
			{
				ip_rp = ip_rp_list[flow];
				port_rp ++; if (!port_rp){port_rp = 1;}
				id ++;
				pktCnt[flow] ++;
				
				switch (flow)
				{
					case SYN:
						if (pktCnt[flow] >= RTL8651_DOS_PERSRC_SYN_THRESHOLD_DEFAULT) goto nextFlow;
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							port_rp, port_gw, TH_SYN, 1460, 0, 0, NULL, 0);
						break;
					case FIN:
						if (pktCnt[flow] >= RTL8651_DOS_PERSRC_FIN_THRESHOLD_DEFAULT) goto nextFlow;
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							port_rp, port_gw, TH_FIN, 1460, 0, 0, NULL, 0);
						break;
					case UDP:
						if (pktCnt[flow] >= RTL8651_DOS_PERSRC_UDP_THRESHOLD_DEFAULT) goto nextFlow;
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							port_rp, port_gw, 0, 0, 0, 0, NULL, 0);
						break;
					case ICMP:
						if (pktCnt[flow] >= RTL8651_DOS_PERSRC_ICMP_THRESHOLD_DEFAULT) goto nextFlow;
						mbuf_in = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_ICMP, 0, 1, 0, mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
							0, 0, 0, 0, ICMP_ECHOREPLY, id, NULL, 0);
						break;
					default:
						assert(0);
						break;
				}

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				freeMbuf(mbuf_in);

				switch(flow)
				{
					case SYN:
						VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
						break;
					case FIN:
						VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);
						break;
					case UDP:
						VALUE_CMP(retval, FWDENG_UDP_NAPT_IN_NOTFOUND);
						break;
					case ICMP:
						VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
						break;
				}
		nextFlow:
			}
		}
	}
	/**********************************************************************************************/
	return SUCCESS;
}


/*
@func int32		| pkt_connectionControl_wholeSystem_1	| Gateway NAPT Connection Control System Whole System test 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the function: Set the global TCP connection count threshold and test its functionality
Also test the ignore function for LAN traffic
 */
int32 pkt_connectionControl_wholeSystem_1(uint32 caseNo)
{
	int8 pkt_content[1450];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*******************************************************
	*******************************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 
	uint16 icmpType;
	uint16 id = 0;

	int config;
	int tcpFlow, udpFlow, bothFlow, tcpThreshold, udpThreshold, bothThreshold;
	int testCnt, loopCnt, testPerConfig;

	ether_addr_t mac_start = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ether_addr_t mac_dontCare;
	ADD_HOSTS(ip_lan, mac_lan, 100, ip_npi+1, mac_start);
	ADD_HOSTS(ip_wan, mac_wan, 100, ip_rp+1, mac_dontCare);

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	SET_HOSTS_ARP(ip_lan, mac_lan, 100, "lan", 1);

	fwdeng_function_configuration1();

	/*****************************************************************
		Test for:

				1. TCP Whole System NAPT connection
				2. UDP Whole System NAPT connection
				3. Both TCP/UDP Whole System NAPT connection

				- Also test the ignore case
	******************************************************************/

	srandom( time(NULL) );

	for (config = 0 ; config < 16 ; config ++)
	{
		/*****************************************************************************/
			uint32 dosStatus = 0;

			if (config & 1)
				dosStatus |= RTL8651_DOS_TCPCONNOVERFLOW;
			if (config & 2)
				dosStatus |= RTL8651_DOS_UDPCONNOVERFLOW;
			if (config & 4)
				dosStatus |= RTL8651_DOS_TCPUDPCONNOVERFLOW;

			/* ignore LAN */
			if (config & 8)
				_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_LAN);
			else
				_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_LAN);

			GW_SET_DOSSTATUS(dosStatus);

		/*****************************************************************************/
		for (testPerConfig = 0 ; testPerConfig < 10 ; testPerConfig ++)
		{
			tcpThreshold = (random() % 1000) + 1000;
			udpThreshold = (random() % 1000) + 1000;
			bothThreshold = (random() % 1000) + 1000;
			GW_SET_DOS_THRESHOLD(RTL8651_DOS_TCPCONN_THRESHOLD, tcpThreshold, 0);
			GW_SET_DOS_THRESHOLD(RTL8651_DOS_UDPCONN_THRESHOLD, udpThreshold, 0);
			GW_SET_DOS_THRESHOLD(RTL8651_DOS_TCPUDPCONN_THRESHOLD, bothThreshold, 0);

			port_npi = 0x1111;
			tcpFlow = 0;
			udpFlow = 0;
			bothFlow = 0;

			/* 100 Host * 50 flows */
			for ( loopCnt = 0 ; loopCnt < 25 ; loopCnt ++ )
			{
				for (testCnt = 0 ; testCnt < 100 ; testCnt ++ )
				{
					if (bothFlow >= 4096)	/* don't remove Any flow entry */
					{
						continue;
					}
					/* TCP */
					mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_TCP, 1, 2, 0,
							mac_lan[testCnt], mac_gw_int,
							ip_lan[testCnt], ip_wan[testCnt],
							TTL_HSB, 0, 0,
							port_npi++, port_rp,
							TH_SYN, 1460, 0, 0, NULL, 0);

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

					if ( (config & 8) ||
						(((!(config & 1)) || (tcpFlow < tcpThreshold)) &&
						((!(config & 4)) || (bothFlow < bothThreshold))) )
					{
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						// get external port
						ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
						{
							uint16 tx_port[2] = {0, 0xffff};
							mbuf_comp = confPppoeHSA(NULL, NULL,
								_PKT_TYPE_TCP, tx_port, 1, 0,
								mac_gw_ext, mac_pppoe,
								ip_gw_ext, ip_wan[testCnt], TTL_HSA, 0, 0,
								port_gw, port_rp,
								TH_SYN, 1452, 0, 0, NULL, 0);
							MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						}
						tcpFlow ++;
						bothFlow ++;
					} else
					{	/* Error */
						VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_ADDFAIL);
						VALUE_CMP(mbufList_nmbuf(), 0);
						freeMbuf(mbuf_in);
					}

					/* UDP */
					mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_UDP, 1, 2, 0,
							mac_lan[testCnt], mac_gw_int,
							ip_lan[testCnt], ip_wan[testCnt],
							TTL_HSB, 0, 0,
							port_npi++, port_rp,
							0, 0, 0, 0, pkt_content, sizeof(pkt_content));

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

					if ( (config & 8) ||
						(((!(config & 2)) || (udpFlow < udpThreshold)) &&
						((!(config & 4)) || (bothFlow < bothThreshold))) )
					{
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						// get external port
						ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
						{
							uint16 tx_port[2] = {0, 0xffff};
							mbuf_comp = confPppoeHSA(NULL, NULL,
								_PKT_TYPE_UDP, tx_port, 1, 0,
								mac_gw_ext, mac_pppoe,
								ip_gw_ext, ip_wan[testCnt], TTL_HSA, 0, 0,
								port_gw, port_rp,
								0, 0, 0, 0, pkt_content, sizeof(pkt_content));
							MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						}
						udpFlow ++;
						bothFlow ++;
					} else
					{	/* Error */
						VALUE_CMP(retval, FWDENG_UDP_NAPT_OUT_ADDFAIL);
						VALUE_CMP(mbufList_nmbuf(), 0);
						freeMbuf(mbuf_in);
					}
				}
			}
			/* timeout ALL flows */
			_rtl8651_timeUpdate(100000);
		}
	}

	return SUCCESS;
}

/*
@func int32		| pkt_connectionControl_perSrc_1	| Gateway NAPT Connection Control System Per-Soruce test 1
@rvalue SUCCESS	| 	test OK
@comm 
Test the function: Set the per-source TCP connection count threshold and test its functionality
Also test the ignore function for LAN traffic
 */
 int32 pkt_connectionControl_perSrc_1(uint32 caseNo)
{
	int8 pkt_content[1450];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*******************************************************
	*******************************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw = 0xabcd;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	ipaddr_t dip;
	uint16 dport;
	uint16 d_type; 
	uint16 icmpType;
	uint16 id = 0;

	int config;
	int tcpFlow[100], udpFlow[100], bothFlow[100], tcpThreshold, udpThreshold, bothThreshold;
	int testCnt, loopCnt, testPerConfig;
	int totalFlow;

	ether_addr_t mac_start = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x05}};
	ether_addr_t mac_dontCare;
	ADD_HOSTS(ip_lan, mac_lan, 100, ip_npi+1, mac_start);
	ADD_HOSTS(ip_wan, mac_wan, 100, ip_rp+1, mac_dontCare);

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	//add napt mapping
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);

	SET_HOSTS_ARP(ip_lan, mac_lan, 100, "lan", 1);

	fwdeng_function_configuration1();

	/*****************************************************************
		Test for:

				1. TCP Per-Source NAPT connection
				2. UDP Per-Source NAPT connection
				3. Both TCP/UDP Per-Source NAPT connection

				- Also test the ignore case
	******************************************************************/

	srandom( time(NULL) );

	for (config = 0 ; config < 16 ; config ++)
	{
		/*****************************************************************************/
			uint32 dosStatus = 0;

			if (config & 1)
				dosStatus |= RTL8651_DOS_SRC_TCPCONNOVERFLOW;
			if (config & 2)
				dosStatus |= RTL8651_DOS_SRC_UDPCONNOVERFLOW;
			if (config & 4)
				dosStatus |= RTL8651_DOS_SRC_TCPUDPCONNOVERFLOW;

			/* ignore LAN */
			if (config & 8)
				_rtl8651_dosIgnoreTypeAdd(RTL8651_DOS_IGNORETYPE_FROM_LAN);
			else
				_rtl8651_dosIgnoreTypeDel(RTL8651_DOS_IGNORETYPE_FROM_LAN);

			GW_SET_DOSSTATUS(dosStatus);

		/*****************************************************************************/
		for (testPerConfig = 0 ; testPerConfig < 5 ; testPerConfig ++)
		{
			tcpThreshold = (random() % 20) + 5;
			udpThreshold = (random() % 20) + 5;
			bothThreshold = (random() % 20) + 5;
			GW_SET_DOS_THRESHOLD(RTL8651_DOS_TCPCONN_THRESHOLD, tcpThreshold, 1);
			GW_SET_DOS_THRESHOLD(RTL8651_DOS_UDPCONN_THRESHOLD, udpThreshold, 1);
			GW_SET_DOS_THRESHOLD(RTL8651_DOS_TCPUDPCONN_THRESHOLD, bothThreshold, 1);

			port_npi = 0x1111;
			totalFlow = 0;
			memset(tcpFlow, 0, sizeof(tcpFlow));
			memset(udpFlow, 0, sizeof(udpFlow));
			memset(bothFlow, 0, sizeof(bothFlow));

			/* 100 Host * 50 flows */
			for ( loopCnt = 0 ; loopCnt < 25 ; loopCnt ++ )
			{
				for (testCnt = 0 ; testCnt < 100 ; testCnt ++ )
				{
					if ( totalFlow >= 4096 )
						continue;
				
					/* TCP */
					mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_TCP, 1, 2, 0,
							mac_lan[testCnt], mac_gw_int,
							ip_lan[testCnt], ip_wan[testCnt],
							TTL_HSB, 0, 0,
							port_npi++, port_rp,
							TH_SYN, 1460, 0, 0, NULL, 0);

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

					if ( (config & 8) ||
						(((!(config & 1)) || (tcpFlow[testCnt] < tcpThreshold)) &&
						((!(config & 4)) || (bothFlow[testCnt] < bothThreshold))) )
					{
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						// get external port
						ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
						{
							uint16 tx_port[2] = {0, 0xffff};
							mbuf_comp = confPppoeHSA(NULL, NULL,
								_PKT_TYPE_TCP, tx_port, 1, 0,
								mac_gw_ext, mac_pppoe,
								ip_gw_ext, ip_wan[testCnt], TTL_HSA, 0, 0,
								port_gw, port_rp,
								TH_SYN, 1452, 0, 0, NULL, 0);
							MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						}
						tcpFlow[testCnt] ++;
						bothFlow[testCnt] ++;
						totalFlow ++;
					} else
					{	/* Error */
						VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_ADDFAIL);
						VALUE_CMP(mbufList_nmbuf(), 0);
						freeMbuf(mbuf_in);
					}

					/* UDP */
					mbuf_in = confVlanHSB(NULL, NULL,
							_PKT_TYPE_UDP, 1, 2, 0,
							mac_lan[testCnt], mac_gw_int,
							ip_lan[testCnt], ip_wan[testCnt],
							TTL_HSB, 0, 0,
							port_npi++, port_rp,
							0, 0, 0, 0, pkt_content, sizeof(pkt_content));

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

					if ( (config & 8) ||
						(((!(config & 2)) || (udpFlow[testCnt] < udpThreshold)) &&
						((!(config & 4)) || (bothFlow[testCnt] < bothThreshold))) )
					{
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 1);
						mbuf_out = mbufList_dequeue();
						// get external port
						ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);
						{
							uint16 tx_port[2] = {0, 0xffff};
							mbuf_comp = confPppoeHSA(NULL, NULL,
								_PKT_TYPE_UDP, tx_port, 1, 0,
								mac_gw_ext, mac_pppoe,
								ip_gw_ext, ip_wan[testCnt], TTL_HSA, 0, 0,
								port_gw, port_rp,
								0, 0, 0, 0, pkt_content, sizeof(pkt_content));
							MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						}
						udpFlow[testCnt] ++;
						bothFlow[testCnt] ++;
						totalFlow ++;
					} else
					{	/* Error */
						VALUE_CMP(retval, FWDENG_UDP_NAPT_OUT_ADDFAIL);
						VALUE_CMP(mbufList_nmbuf(), 0);
						freeMbuf(mbuf_in);
					}
				}
			}
			/* timeout ALL flows */
			_rtl8651_timeUpdate(100000);
		}
	}

	return SUCCESS;
}

#endif	/* RTL_FWDENG_DOS_TEST */

#ifdef RTL_NAPT_REDIRECT_TEST
/*
@func int32		| pkt_naptRedirect_1	| Test napt redirect register/unregister functions
@rvalue SUCCESS	| 	test OK
@comm
Test the function: redirect napt flow entry register/unregister procedure.
 */
int32 pkt_naptRedirect_1(uint32 caseNo){
	/**********************************************
		1 wan(pppoe), 2 lan

		Test register/unregister accuracy

		- register test
		- conflict test
		- unregister test

			1. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	OK
			2. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	OK
			3. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp2)	-	OK
			4. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp2)	-	OK
			5. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	Conflict, FAILED
			6. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	Conflict, FAILED
			7. unregister
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	return value = 1
			8. unregister
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	return value = 1
			9. unregister
				(TCP, 0, 0, 0, 0)								-	return value = 1
			10. unregister
				(UDP, 0, 0, 0, 0)								-	return value = 1
			11. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	OK
					-> add subset of each register item			-	Conflict, FAILED
			    unregister										-	return value = 1
			12. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	OK
					-> add subset of each register item			-	Conflict, FAILED
			    unregister										-	return value = 1
 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x5679;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*****************************************************************************
			1. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, ip_npi, port_npi, ip_rp, port_rp, 0, 1234) == SUCCESS);
	}
	/*****************************************************************************
			2. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, ip_npi, port_npi, ip_rp, port_rp, 0, 1234) == SUCCESS);
	}
	/*****************************************************************************
			3. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp2)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, ip_npi, port_npi, ip_rp, port_rp2, 0, 1234) == SUCCESS);
	}
	/*****************************************************************************
			4. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp2)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, ip_npi, port_npi, ip_rp, port_rp2, 0, 1234) == SUCCESS);
	}
	/*****************************************************************************
			5. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	Conflict, FAILED
	*****************************************************************************/
	{
		int i1, i2, i3, i4;

		for (i1 = 0 ; i1 < 2 ; i1 ++)
		for (i2 = 0 ; i2 < 2 ; i2 ++)
		for (i3 = 0 ; i3 < 2 ; i3 ++)
		for (i4 = 0 ; i4 < 2 ; i4 ++)
		{
			ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, i1?0:ip_npi, i2?0:port_npi, i3?0:ip_rp, i4?0:port_rp, 0, 1234) == FAILED);
		}
	}
	/*****************************************************************************
			6. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	Conflict, FAILED
	*****************************************************************************/
	{
		int i1, i2, i3, i4;

		for (i1 = 0 ; i1 < 2 ; i1 ++)
		for (i2 = 0 ; i2 < 2 ; i2 ++)
		for (i3 = 0 ; i3 < 2 ; i3 ++)
		for (i4 = 0 ; i4 < 2 ; i4 ++)
		{
			ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, i1?0:ip_npi, i2?0:port_npi, i3?0:ip_rp, i4?0:port_rp, 0, 1234) == FAILED);
		}
	}
	/*****************************************************************************
			7. unregister
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, ip_npi, port_npi, ip_rp, port_rp, 0, 1234) == 1);
	}
	/*****************************************************************************
			8. unregister
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp)	-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, ip_npi, port_npi, ip_rp, port_rp, 0, 1234) == 1);
	}
	/*****************************************************************************
			9. unregister
				(TCP, 0, 0, 0, 0)								-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, 0, 0, 0, 0, 0, 1234) == 1);
	}
	/*****************************************************************************
			10. unregister
				(UDP, 0, 0, 0, 0)								-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, 0, 0, 0, 0, 0, 1234) == 1);
	}
	/*****************************************************************************
			11. register
				(TCP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	OK
					-> add subset of each register item			-	Conflict, FAILED
			    unregister										-	return value = 1
	*****************************************************************************/
	{
		/* register */
		int i1, i2, i3, i4;

		for (i1 = 0 ; i1 < 2 ; i1 ++)
		for (i2 = 0 ; i2 < 2 ; i2 ++)
		for (i3 = 0 ; i3 < 2 ; i3 ++)
		for (i4 = 0 ; i4 < 2 ; i4 ++)
		{
			ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, i1?0:ip_npi, i2?0:port_npi, i3?0:ip_rp, i4?0:port_rp, 0, 1234) == SUCCESS);

			/* other related register items are denied */
			{
				ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, ip_npi, port_npi, ip_rp, port_rp, 0, 1234) == FAILED);
			}

			ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, i1?0:ip_npi, i2?0:port_npi, i3?0:ip_rp, i4?0:port_rp, 0, 1234) == 1);
		}
	}
	/*****************************************************************************
			12. register
				(UDP, 192.168.1.1, port_npi, 140.113.1.1, port_rp),
				0,1,2,3,4 of last 4-tuple are zero					-	OK
					-> add subset of each register item			-	Conflict, FAILED
			    unregister										-	return value = 1
	*****************************************************************************/
	{
		/* register */
		int i1, i2, i3, i4;

		for (i1 = 0 ; i1 < 2 ; i1 ++)
		for (i2 = 0 ; i2 < 2 ; i2 ++)
		for (i3 = 0 ; i3 < 2 ; i3 ++)
		for (i4 = 0 ; i4 < 2 ; i4 ++)
		{
			ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, i1?0:ip_npi, i2?0:port_npi, i3?0:ip_rp, i4?0:port_rp, 0, 1234) == SUCCESS);

			/* other related register items are denied */
			{
				ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, ip_npi, port_npi, ip_rp, port_rp, 0, 1234) == FAILED);
			}

			ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, i1?0:ip_npi, i2?0:port_npi, i3?0:ip_rp, i4?0:port_rp, 0, 1234) == 1);
		}
	}

	return SUCCESS;
}

/*
@func int32		| pkt_naptRedirect_2	| Test napt redirect basic functions
@rvalue SUCCESS	| 	test OK
@comm
Test the function: redirect napt flow to protocol stack if we need.
 */
int32 pkt_naptRedirect_2(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	int8 pkt_content[1024];

	/*********************************************************************************

		From GlobalSum's spec:

		Trend THPD process
		-----------------------------------------------------------------

		Typical Flow in details:

		1. LAN host to Gateway
		   src port: 1234
		   src IP:   192.168.1.1
		   dst port: 80
		   dst IP:   140.113.1.1

		2. Gateway trap dst port 80 and translate dst port to 10080
		   THPD received packet is:
		   src port: 1234
		   src IP:   192.168.1.1
		   dst port: 10080
		   dst IP:   192.168.1.254

		3. THPD generate new session to Rome driver
		   THPD will query Rome Driver with API call:
		   int32 rtl8651_queryRedirectOutboundNaptFlow(
				192.168.1.1,
				1234,
				&originalDip,
				&originalDport,
				192.168.1.254,
				10080
			);

			With the help of above API, original dst IP
			140.113.1.1 and original dst port 80 are obtained.
			This information will be included in the propritatry
			http request to treand_ASP.
			src port: 2345 (arbitrarily selected by socket)
			src IP:   10.113.1.1
			dst port: 80
			dst IP:   trend_ASP

		4. Rome driver to WAN ASP
		   src port: 2345
		   src IP:   10.113.1.1
		   dst port: 80
		   dst IP:   trend_ASP

		5. WAN ASP reply to Rome driver
		   src port: 80
		   src IP:   trend_ASP
		   dst port: 2345
		   dst IP:   10.113.1.1

		6. Rome driver to THPD
		   src port: 80
		   src IP:   trend_ASP
		   dst port: 2345
		   dst IP:   10.113.1.1

		7. THPD generate new session to Rome driver
		   src port: 3456 (arbitrarily selected by socket)
		   src IP:   10.113.1.1
		   dst port: 80
		   dsp IP:   140.113.1.1

		8. Rome driver to WAN Web Server
		   src port: 3456
		   src IP:   10.113.1.1
		   dst port: 80
		   dst IP:   140.113.1.1

		9. WAN Web Server reply to Rome Driver
		   src port: 80
		   src IP:   140.113.1.1
		   dst port: 3456
		   dst IP:   10.113.1.1

		10. Rome Driver to THPD
		   src port: 80
		   src IP:   140.113.1.1
		   dst port: 3456
		   dst ip:   10.113.1.1

		11. THPD to Rome Driver
		   src port: 10080
		   src IP:   192.168.1.254
		   dst port: 1234
		   dst IP:   192.168.1.1

		12. Rome Driver to LAN Host
		   src port: 80
		   src IP:   140.113.1.1
		   dst port: 1234
		   dst IP:   192.168.1.1

	*********************************************************************************/	
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 80;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint16 port_THPDListen = 10080;		/* listen port of THPD process in protocol stack */
	uint16 port_THPDtoRP = 0x4567;		/* flow generated from THPD process to Remote Host */
	uint16 port_THPDtoTrendASP = 0x5678;	/* flow generated from THPD process to Trend ASP */
	ipaddr_t ip_Trend_ASP = ntohl(inet_addr("123.123.123.123"));	/* trend ASP's IP addr */
	uint16 port_Trend_ASP = 80;			/* trend ASP's listen port */


	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/*******************************************************************************
		Register NAPT redirect entry
	*******************************************************************************/
	ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, 0, 0, 0, port_rp, 0, port_THPDListen) == SUCCESS);

	/*******************************************************************************
		1. LAN host to Gateway
		   src port: 1234
		   src IP:   192.168.1.1
		   dst port: 80
		   dst IP:   140.113.1.1

		2. Gateway trap dst port 80 and translate dst port to 10080
		   THPD received packet is:
		   src port: 1234
		   src IP:   192.168.1.1
		   dst port: 10080
		   dst IP:   192.168.1.254
	*******************************************************************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, port_THPDListen, TH_SYN, 1460, 0, 0, NULL, 0);

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, port_THPDListen, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	/*******************************************************************************
		3. THPD generate new session to Rome driver
		   THPD will query Rome Driver with API call:
		   int32 rtl8651_queryRedirectOutboundNaptFlow(
				192.168.1.1,
				1234,
				&originalDip,
				&originalDport,
				192.168.1.254,
				10080
			);

			With the help of above API, original dst IP
			140.113.1.1 and original dst port 80 are obtained.
			This information will be included in the propritatry
			http request to treand_ASP.
			src port: 2345 (arbitrarily selected by socket)
			src IP:   10.113.1.1
			dst port: 80
			dst IP:   trend_ASP
	*******************************************************************************/
	{
		ipaddr_t originalIp;
		uint16 originalPort;

		ASSERT(rtl8651_queryRedirectOutboundNaptFlow(TRUE, ip_npi, port_npi, &originalIp, &originalPort, ip_gw_int, port_THPDListen) == SUCCESS);
		VALUE_CMP(originalIp, ip_rp);
		VALUE_CMP(originalPort, port_rp);
	}
	/*******************************************************************************
		4. Rome driver to WAN ASP							(direct TX, ignore it)
		   src port: 2345
		   src IP:   10.113.1.1
		   dst port: 80
		   dst IP:   trend_ASP

		5. WAN ASP reply to Rome driver
		   src port: 80
		   src IP:   trend_ASP
		   dst port: 2345
		   dst IP:   10.113.1.1

		6. Rome driver to THPD
		   src port: 80
		   src IP:   trend_ASP
		   dst port: 2345
		   dst IP:   10.113.1.1
	*******************************************************************************/
	/* SYN packet */
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_Trend_ASP, ip_gw_ext, 123, 0, 0,
			port_Trend_ASP, port_THPDtoTrendASP,
			TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/* Other packets */
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_Trend_ASP, ip_gw_ext, 123, 0, 0,
			port_Trend_ASP, port_THPDtoTrendASP,
			TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*******************************************************************************
		7. THPD generate new session to Rome driver				(direct TX, ignore it)
		   src port: 3456 (arbitrarily selected by socket)
		   src IP:   10.113.1.1
		   dst port: 80
		   dsp IP:   140.113.1.1

		8. Rome driver to WAN Web Server						(direct TX, ignore it)
		   src port: 3456
		   src IP:   10.113.1.1
		   dst port: 80
		   dst IP:   140.113.1.1

		9. WAN Web Server reply to Rome Driver
		   src port: 80
		   src IP:   140.113.1.1
		   dst port: 3456
		   dst IP:   10.113.1.1

		10. Rome Driver to THPD
		   src port: 80
		   src IP:   140.113.1.1
		   dst port: 3456
		   dst ip:   10.113.1.1
	*******************************************************************************/
	/* SYN packet */
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_THPDtoRP,
			TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/* Other packets */
	{
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_THPDtoRP,
			TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*******************************************************************************
		11. THPD to Rome Driver
		   src port: 10080
		   src IP:   192.168.1.254
		   dst port: 1234
		   dst IP:   192.168.1.1

		12. Rome Driver to LAN Host
		   src port: 80
		   src IP:   140.113.1.1
		   dst port: 1234
		   dst IP:   192.168.1.1
	*******************************************************************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_gw_int, mac_npi,
			ip_gw_int, ip_npi, 123, 0, 0,
			port_THPDListen, port_npi, (TH_SYN), 1460, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 2, 14);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			mbuf_comp = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 123, 0, 0,
				port_Trend_ASP, port_npi, (TH_SYN), 1460, 0, 0, NULL, 0);
#ifdef SW_CHECKSUM
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
			mbuf_comp->m_pkthdr->ph_portlist = 0x02;/* port 1*/
			mbuf_out = mbufList_dequeue();
			CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(&conf, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_gw_int, mac_npi,
			ip_gw_int, ip_npi, 123, 0, 0,
			port_THPDListen, port_npi, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 2, 14);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			mbuf_comp = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 123, 0, 0,
				port_Trend_ASP, port_npi, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

#ifdef SW_CHECKSUM
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
			mbuf_comp->m_pkthdr->ph_portlist = 0x02;/* port 1*/
			mbuf_out = mbufList_dequeue();
			CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
	}
	/* try fragment */
	{
		uint16 offset = 1024;
		int i;
		for (i = 0 ; i < 100 ; i ++)
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_gw_int, mac_npi,
				ip_gw_int, ip_npi, 123, 0, offset,
				port_THPDListen, port_npi, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 2, 14);
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				mbuf_comp = confVlanHSB(&conf, NULL,
					_PKT_TYPE_TCP, 1, 2, 0,
					mac_gw_int, mac_npi,
					ip_rp, ip_npi, 123, 0, offset++,
					port_Trend_ASP, port_npi, (TH_ACK), 1460, 0, 0, pkt_content, sizeof(pkt_content));

#ifdef SW_CHECKSUM
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
				mbuf_comp->m_pkthdr->ph_portlist = 0x02;/* port 1*/
				mbuf_out = mbufList_dequeue();
				CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
		}
	}

	return SUCCESS;
}

/*
@func int32		| pkt_naptRedirect_3	| Stresss Test napt redirect basic functions
@rvalue SUCCESS	| 	test OK
@comm
Test the function: redirect napt flow to protocol stack if we need.
This is stress random test.
 */
int32 pkt_naptRedirect_3(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	int8 pkt_content[1024];

	/*********************************************************************************
		Random register
		Random unregister
		Random flow arrival
		Random flow query
	*********************************************************************************/	
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 80;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	/* entry */
	ipaddr_t	sip = ntohl(inet_addr("192.168.1.1"));
	uint16	sport = 1111;
	ipaddr_t	dip = ntohl(inet_addr("140.113.1.1"));
	uint16	dport = 2222;
	ipaddr_t	newDip = ntohl(inet_addr("127.0.0.1"));
	uint16	newDport = 1;

/*
	time out of napt redirect cache
	must same as definition in rtl8651_tblDrvFwd.c
*/
#define RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE			16
#define RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE		32

	uint8	e_valid[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint8	e_isTcp[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	ipaddr_t	e_sip[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint16	e_sport[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	ipaddr_t	e_dip[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint16	e_dport[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	ipaddr_t	e_newDip[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint16	e_newDport[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint8	e_used[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	/* flow */
	/* 20 flows can NOT be queried (failed), but forwarding engine alway trap all packets to protocol stack */
	#define PKT_NAPT_REDIRECT_TOTALFLOW	(RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE + 20)
	uint8	f_isTcp[PKT_NAPT_REDIRECT_TOTALFLOW];
	ipaddr_t	f_sip[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint16	f_sport[PKT_NAPT_REDIRECT_TOTALFLOW];
	ipaddr_t	f_dip[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint16	f_dport[PKT_NAPT_REDIRECT_TOTALFLOW];
	ipaddr_t	f_newDip[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint16	f_newDport[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint32	f_sendCnt[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint32	f_correspEntry[PKT_NAPT_REDIRECT_TOTALFLOW];
	
	const uint32 MaxLoop = 10;
	uint32 loop;
	const uint32 MaxFlowLoop = 5;
	uint32 flowLoop;
	const uint32 MaxPktLoop = 2;
	uint32 pktLoop;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);

	srandom( time(NULL) );

	/*******************************************************************************
		Initiate all items before testing
	*******************************************************************************/
	/* napt redirect entry */
	memset(e_valid, 0, sizeof(e_valid));
	memset(e_isTcp, 0, sizeof(e_isTcp));
	memset(e_sip, 0, sizeof(e_sip));
	memset(e_sport, 0, sizeof(e_sport));
	memset(e_dip, 0, sizeof(e_dip));
	memset(e_dport, 0, sizeof(e_dport));
	memset(e_newDip, 0, sizeof(e_newDip));
	memset(e_newDport, 0, sizeof(e_newDport));
	memset(e_used, 0, sizeof(e_used));
	/* napt redirect flow cache */
	memset(f_isTcp, 0, sizeof(f_isTcp));
	memset(f_sip, 0, sizeof(f_sip));
	memset(f_sport, 0, sizeof(f_sport));
	memset(f_dip, 0, sizeof(f_dip));
	memset(f_dport, 0, sizeof(f_dport));
	memset(f_newDip, 0, sizeof(f_newDip));
	memset(f_newDport, 0, sizeof(f_newDport));
	memset(f_sendCnt, 0, sizeof(f_sendCnt));
	memset(f_correspEntry, 0, sizeof(f_correspEntry));
	

	/*******************************************************************************
		Main loop
	*******************************************************************************/
	for (loop = 0 ; loop < MaxLoop ; loop ++)
	{
		/*******************************************************************************
			1. Randomly decide napt redirect entry and register

				when we register rules, we try add it in two ways:
			
					1) add new register respectively.
					2) flush all exist entries and add all entries at one time

				to stress the napt redirect system
		*******************************************************************************/
		{
			int i , j;
			/*
				for empty entries, we decide to create a new one or not.
			*/
genRule:
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if (e_valid[i] == TRUE)
					continue;

				/*
					9/10	->	create
					1/10	->	don't create
				*/
				if (DICING(10) == 0)
					continue;
				
				/*
					create new rules: there are 1/2 probability to set item to 0
				*/
				e_isTcp[i]	= DICING(2)?TRUE:FALSE;
				e_sip[i]		= DICING(2)?sip:0;
				e_sport[i]	= DICING(2)?sport:0;
				e_dip[i]		= DICING(2)?dip:0;
				e_dport[i]	= DICING(2)?dport:0;
				e_newDip[i]	= DICING(2)?newDip:0;
				assert(newDport);
				e_newDport[i]	= newDport;
				e_used[i]		= FALSE;

				/************** update item base **************/
				MASK_INCREASE(sip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(sport, 2, 1);
				MASK_INCREASE(dip, 1, ntohl(inet_addr("255.255.0.0")));
				LOWERBOUND_INCREASE(dport, 1, 1);
				MASK_INCREASE(newDip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(newDport, 1, 1);

				/*
					Register item.
						if return SUCCES	: ok
						else				: ignore this new rule (maybe cause collision)
				*/
				if (rtl8651_registerRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], e_newDport[i]) == SUCCESS)
				{
					e_valid[i] = TRUE;
				}
			}

			/*
				1. If there are no any entry in rule table, retry it.
				2. System must has last 1 valid entry with wildcard sip or wildcard sport
			*/
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if ((e_valid[i] == TRUE) && ((e_sip[i] == 0) || (e_sport[i] == 0)))
					goto refillRuleEntry;
			}
			/* no entry: re-gen */
			goto genRule;

refillRuleEntry:
			/*
				flush and fill all entries
			*/
			rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, 0, 0, 0, 0, 0, 0);
			rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, 0, 0, 0, 0, 0, 0);
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if (e_valid[i] == TRUE)
				{
					ASSERT(rtl8651_registerRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], e_newDport[i]) == SUCCESS);
				}
			}
		}

		for (flowLoop = 0 ; flowLoop < MaxFlowLoop ; flowLoop ++)
		{
			uint32 idx;
			int i, j;

			/*******************************************************************************
				2. Randomly generate flows
			*******************************************************************************/
			/* before generate flow, we reset all rules' used bit */
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				e_used[i] = FALSE;
			}

			
			for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
			{
				/*
					1) randomly choose a entry to match
				*/
				idx = (random() % RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE);
				/* ignore invalid and used entry */
				while ((e_valid[idx] == FALSE) || (e_used[idx] == TRUE))
				{
					UPPERBOUND_INCREASE(idx, 1, (RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE - 1));
				}
				/*
					2) set items
				*/
				assert(e_valid[idx] == TRUE);

				f_isTcp[i]			= e_isTcp[idx];
				f_sip[i]			= e_sip[idx]?e_sip[idx]:sip;
				f_sport[i]			= e_sport[idx]?e_sport[idx]:sport;
				f_dip[i]			= e_dip[idx]?e_dip[idx]:dip;
				f_dport[i]			= e_dport[idx]?e_dport[idx]:dport;
				f_newDip[i]		= e_newDip[idx]?e_newDip[idx]:ip_gw_int;
				f_newDport[i]		= e_newDport[idx];
				f_sendCnt[i]		= 0;
				f_correspEntry[i]	= idx;

				/*
					for rule with sip/sport specified, we must prevent other flow use this entry and avoid napt confuse
				*/
				if (e_sip[idx] && e_sport[idx])
				{
					e_used[idx] = TRUE;
				}

				/************** update item base **************/
				MASK_INCREASE(sip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(sport, 3, 1);
				MASK_INCREASE(dip, 1, ntohl(inet_addr("255.255.0.0")));
				LOWERBOUND_INCREASE(dport, 1, 1);
				MASK_INCREASE(newDip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(newDport, 1, 1);				
			}

			/*******************************************************************************
				3. Randomly redirect them (all of flows must be redirected)
			*******************************************************************************/
			for (pktLoop = 0 ; pktLoop < MaxPktLoop ; pktLoop ++)
			{
				/*
					we reset sendCnt for each loop
				*/
				for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
				{
					f_sendCnt[i] = 0;
				}
			
				for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
				{
					/*
						Randomly choose unsent flow
					*/
					idx = (random() % PKT_NAPT_REDIRECT_TOTALFLOW);
					while (f_sendCnt[idx] > 0)
					{
						UPPERBOUND_INCREASE(idx, 1, (PKT_NAPT_REDIRECT_TOTALFLOW - 1));
					}
					/*
						randomly decide how many packet of this flow to be sent at this time
					*/
					if (f_isTcp[idx] == TRUE)
					{	/* tcp */
						j = DICING(2) + 1;
						f_sendCnt[idx] += (j * 64);	/* all flags are tested */
					}else
					{	/* udp */
						j = DICING(10) + 1;
						f_sendCnt[idx] += j;
					}
					while (j > 0)
					{	/* send packet to forwarding engine */
						int8 *data;
						uint32 dataLen;
						/*******************************************************************************/
						/*******************************************************************************/
						if (f_isTcp[idx] == TRUE)
						{	/* tcp */
							uint8 tcpFlag;

							for (tcpFlag = 0 ; tcpFlag < 64 ; tcpFlag ++)
							{
								/* send tcp packet */
								if (tcpFlag == TH_SYN)
								{
									data = NULL;
									dataLen = 0;
								}else
								{
									data = pkt_content;
									dataLen = DICING(sizeof(pkt_content));
								}
								/* generate input packet */
								mbuf_in = confVlanHSB(NULL, NULL,
									_PKT_TYPE_TCP, 1, 2, 0,
									mac_npi, mac_gw_int,
									f_sip[idx], f_dip[idx], 123, 0, 0,
									f_sport[idx], f_dport[idx], tcpFlag, 1460, 0, 0, data, dataLen);

								FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

								VALUE_CMP(retval, FWDENG_TO_GW);
								/* check trapped packet */
								mbuf_comp = confVlanHSB(NULL, NULL,
									_PKT_TYPE_TCP, 1, 2, 0,
									mac_npi, mac_gw_int,
									f_sip[idx], f_newDip[idx], 123, 0, 0,
									f_sport[idx], f_newDport[idx], tcpFlag, 1460, 0, 0, data, dataLen);

								CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
								MBUF_CMPandFREE(mbuf_in, mbuf_comp);
							}
						}else
						{	/* udp */
							data = pkt_content;
							dataLen = DICING(sizeof(pkt_content));

							/* generate input packet */
							mbuf_in = confVlanHSB(NULL, NULL,
								_PKT_TYPE_UDP, 1, 2, 0,
								mac_npi, mac_gw_int,
								f_sip[idx], f_dip[idx], 123, 0, 0,
								f_sport[idx], f_dport[idx], 0, 0, 0, 0, data, dataLen);

							FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

							VALUE_CMP(retval, FWDENG_TO_GW);
							/* check trapped packet */
							mbuf_comp = confVlanHSB(NULL, NULL,
								_PKT_TYPE_UDP, 1, 2, 0,
								mac_npi, mac_gw_int,
								f_sip[idx], f_newDip[idx], 123, 0, 0,
								f_sport[idx], f_newDport[idx], 0, 0, 0, 0, data, dataLen);		

							CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
							MBUF_CMPandFREE(mbuf_in, mbuf_comp);
						}
						/*******************************************************************************/
						/*******************************************************************************/
						j --;
					}
				}
			}
			/*******************************************************************************
				4. Query all flows,
					only RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE flows return SUCCESS
			*******************************************************************************/
			j = 0;	/* store the success count */
			for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
			{
				ipaddr_t odip;
				uint16 odport;
				if (rtl8651_queryRedirectOutboundNaptFlow(f_isTcp[i], f_sip[i], f_sport[i], &odip, &odport, f_newDip[i], f_newDport[i]) == SUCCESS)
				{
					j ++;	/* add match count */
					/* check original dip/dport matching rule */
					VALUE_CMP(odip, f_dip[i]);
					VALUE_CMP(odport, f_dport[i]);
				}
			}

			VALUE_CMP(j , RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE);
		}

		/*******************************************************************************
			5. Randomly decide what napt redirect entry must to be removed
					- 2/3 probability to remove entry
		*******************************************************************************/
		{
			int i;
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if (e_valid[i] == FALSE)
					continue;
				/* 1/3 -> don't remove entry */
				if (DICING(3) == 0)
					continue;

				/* remove this entry */
				ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], e_newDport[i]) == 1);

				/* invalid this entry */
				e_valid[i] = FALSE;
				e_used[i] = 0;
			}
		}
	}

	/*
		Finally, we remove all rules
	*/
	{
		int i;
		for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
		{
			if (e_valid[i] == FALSE)
				continue;

			/* remove this entry */
			ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], e_newDport[i]) == 1);

			/* invalid this entry */
			e_valid[i] = FALSE;
			e_used[i] = 0;
		}
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, 0, 0, 0, 0, 0, 0) == 0);
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, 0, 0, 0, 0, 0, 0) == 0);
	}

	return SUCCESS;
}

/*
@func int32		| pkt_naptRedirect_4	| Test napt redirect basic functions for fragment packets
@rvalue SUCCESS	| 	test OK
@comm
Test the function: redirect napt fragment flow to protocol stack if we need.
 */
int32 pkt_naptRedirect_4(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		RP	->	RP	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int sa[5], s;

	uint16 newDport = 10080;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* register redirect rule */
	ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, 0, 0, 0, port_rp, 0, newDport) == SUCCESS);

	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, newDport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (pkt_no == 1)?(TEST_CSUM_L4|TEST_CSUM_IP):(TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
nextLoop:
	}

	// turn-off all dos check
	rtl8651a_setDosStatus(0, 0);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;
		int firstArrive;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop2;
				}
		}

		DEFAULT_IP_ID ++;
		firstArrive = FALSE;

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (firstArrive == FALSE)
			{
				if (pkt_no == 1)	// first packet
				{	// dequeue
					int min, m, idx;
					int cmp_no;

					firstArrive = TRUE;
					VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
					VALUE_CMP(mbufList_nmbuf(), 0);
					// check output
					VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
					// sort arrived packets number
					min = 0;
					for (s = 0 ; s < p ; s ++)
					{
						m = total_pkt + 1;
						for (idx = 0 ; idx < p ; idx ++)
						{
							if ((min < pa[idx]) && (pa[idx] < m))
								m = pa[idx];
								
						}
						min = m;
						sa[s] = min;
					}
					// compare packet
					for (idx = 0 ; idx < p ; idx ++)
					{
						int16 tx_port[2] = {1, 0xffff};
					
						cmp_no = sa[idx];

						FRAG_DEQUEUE(mbuf_out, mbuf_in);

						mbuf_comp = confVlanHSB( NULL, NULL,
							_PKT_TYPE_UDP, 1, 2, 0,
							mac_npi, mac_gw_int,
							ip_npi, ip_gw_int, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
							port_npi, newDport, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (cmp_no == 1)?(TEST_CSUM_L4|TEST_CSUM_IP):(TEST_CSUM_IP));
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					}
				}else
				{	// queued
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 0);
				}
			}else
			{	// first packet arrived, pass-through it
				int16 tx_port[2] = {1, 0xffff};

				VALUE_CMP(retval, FWDENG_TO_GW);
				VALUE_CMP(mbufList_nmbuf(), 0);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, newDport, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (pkt_no == 1)?(TEST_CSUM_L4|TEST_CSUM_IP):(TEST_CSUM_IP));
				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}
nextLoop2:
	}
	return SUCCESS;
}

/*
@func int32		| pkt_naptRedirect_5	| Stresss Test napt redirect basic functions
@rvalue SUCCESS	| 	test OK
@comm
Test the function: redirect napt flow to protocol stack if we need.
We don't change dip/dport when trapping packet to protocol stack. (register this entry with newdport < 0)
This is stress random test.
 */
int32 pkt_naptRedirect_5(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	int8 pkt_content[1024];

	/*********************************************************************************
		Random register
		Random unregister
		Random flow arrival
		Random flow query
	*********************************************************************************/	
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 80;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	/* entry */
	ipaddr_t	sip = ntohl(inet_addr("192.168.1.1"));
	uint16	sport = 1111;
	ipaddr_t	dip = ntohl(inet_addr("140.113.1.1"));
	uint16	dport = 2222;
	ipaddr_t	newDip = ntohl(inet_addr("127.0.0.1"));
	uint16	newDport = 1;

/*
	time out of napt redirect cache
	must same as definition in rtl8651_tblDrvFwd.c
*/
#define RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE			16
#define RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE		32

	uint8	e_valid[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint8	e_isTcp[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	ipaddr_t	e_sip[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint16	e_sport[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	ipaddr_t	e_dip[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint16	e_dport[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	ipaddr_t	e_newDip[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint16	e_newDport[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	uint8	e_used[RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE];
	/* flow */
	/* 20 flows can NOT be queried (failed), but forwarding engine alway trap all packets to protocol stack */
	#define PKT_NAPT_REDIRECT_TOTALFLOW	(RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE + 20)
	uint8	f_isTcp[PKT_NAPT_REDIRECT_TOTALFLOW];
	ipaddr_t	f_sip[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint16	f_sport[PKT_NAPT_REDIRECT_TOTALFLOW];
	ipaddr_t	f_dip[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint16	f_dport[PKT_NAPT_REDIRECT_TOTALFLOW];
	ipaddr_t	f_newDip[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint16	f_newDport[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint32	f_sendCnt[PKT_NAPT_REDIRECT_TOTALFLOW];
	uint32	f_correspEntry[PKT_NAPT_REDIRECT_TOTALFLOW];
	
	const uint32 MaxLoop = 10;
	uint32 loop;
	const uint32 MaxFlowLoop = 5;
	uint32 flowLoop;
	const uint32 MaxPktLoop = 2;
	uint32 pktLoop;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);

	srandom( time(NULL) );

	/*******************************************************************************
		Initiate all items before testing
	*******************************************************************************/
	/* napt redirect entry */
	memset(e_valid, 0, sizeof(e_valid));
	memset(e_isTcp, 0, sizeof(e_isTcp));
	memset(e_sip, 0, sizeof(e_sip));
	memset(e_sport, 0, sizeof(e_sport));
	memset(e_dip, 0, sizeof(e_dip));
	memset(e_dport, 0, sizeof(e_dport));
	memset(e_newDip, 0, sizeof(e_newDip));
	memset(e_newDport, 0, sizeof(e_newDport));
	memset(e_used, 0, sizeof(e_used));
	/* napt redirect flow cache */
	memset(f_isTcp, 0, sizeof(f_isTcp));
	memset(f_sip, 0, sizeof(f_sip));
	memset(f_sport, 0, sizeof(f_sport));
	memset(f_dip, 0, sizeof(f_dip));
	memset(f_dport, 0, sizeof(f_dport));
	memset(f_newDip, 0, sizeof(f_newDip));
	memset(f_newDport, 0, sizeof(f_newDport));
	memset(f_sendCnt, 0, sizeof(f_sendCnt));
	memset(f_correspEntry, 0, sizeof(f_correspEntry));
	

	/*******************************************************************************
		Main loop
	*******************************************************************************/
	for (loop = 0 ; loop < MaxLoop ; loop ++)
	{
		/*******************************************************************************
			1. Randomly decide napt redirect entry and register

				when we register rules, we try add it in two ways:
			
					1) add new register respectively.
					2) flush all exist entries and add all entries at one time

				to stress the napt redirect system
		*******************************************************************************/
		{
			int i , j;
			/*
				for empty entries, we decide to create a new one or not.
			*/
genRule:
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if (e_valid[i] == TRUE)
					continue;

				/*
					9/10	->	create
					1/10	->	don't create
				*/
				if (DICING(10) == 0)
					continue;
				
				/*
					create new rules: there are 1/2 probability to set item to 0
				*/
				e_isTcp[i]	= DICING(2)?TRUE:FALSE;
				e_sip[i]		= DICING(2)?sip:0;
				e_sport[i]	= DICING(2)?sport:0;
				e_dip[i]		= DICING(2)?dip:0;
				e_dport[i]	= DICING(2)?dport:0;
				e_newDip[i]	= DICING(2)?newDip:0;
				e_newDport[i]	= DICING(2)?newDport:0;		/* if new dport == 0, we don't change dip/dport when trapping packet (when register, we set it to -1) */
				e_used[i]		= FALSE;

				/************** update item base **************/
				MASK_INCREASE(sip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(sport, 2, 1);
				MASK_INCREASE(dip, 1, ntohl(inet_addr("255.255.0.0")));
				LOWERBOUND_INCREASE(dport, 1, 1);
				MASK_INCREASE(newDip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(newDport, 1, 1);

				/*
					Register item.
						if return SUCCES	: ok
						else				: ignore this new rule (maybe cause collision)
				*/
				if (rtl8651_registerRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], (e_newDport[i])?e_newDport[i]:-1) == SUCCESS)
				{
					e_valid[i] = TRUE;
				}
			}

			/*
				1. If there are no any entry in rule table, retry it.
				2. System must has last 1 valid entry with wildcard sip or wildcard sport
			*/
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if ((e_valid[i] == TRUE) && ((e_sip[i] == 0) || (e_sport[i] == 0)))
					goto refillRuleEntry;
			}
			/* no entry: re-gen */
			goto genRule;

refillRuleEntry:
			/*
				flush and fill all entries
			*/
			rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, 0, 0, 0, 0, 0, 0);
			rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, 0, 0, 0, 0, 0, 0);
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if (e_valid[i] == TRUE)
				{
					ASSERT(rtl8651_registerRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], (e_newDport[i])?e_newDport[i]:-1) == SUCCESS);
				}
			}
		}

		for (flowLoop = 0 ; flowLoop < MaxFlowLoop ; flowLoop ++)
		{
			uint32 idx;
			int i, j;

			/*******************************************************************************
				2. Randomly generate flows
			*******************************************************************************/
			/* before generate flow, we reset all rules' used bit */
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				e_used[i] = FALSE;
			}

			
			for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
			{
				/*
					1) randomly choose a entry to match
				*/
				idx = (random() % RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE);
				/* ignore invalid and used entry */
				while ((e_valid[idx] == FALSE) || (e_used[idx] == TRUE))
				{
					UPPERBOUND_INCREASE(idx, 1, (RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE - 1));
				}
				/*
					2) set items
				*/
				assert(e_valid[idx] == TRUE);

				f_isTcp[i]			= e_isTcp[idx];
				f_sip[i]			= e_sip[idx]?e_sip[idx]:sip;
				f_sport[i]			= e_sport[idx]?e_sport[idx]:sport;
				f_dip[i]			= e_dip[idx]?e_dip[idx]:dip;
				f_dport[i]			= e_dport[idx]?e_dport[idx]:dport;
				f_newDip[i]		= (e_newDport[idx])?(e_newDip[idx]?e_newDip[idx]:ip_gw_int):f_dip[i];
				f_newDport[i]		= (e_newDport[idx])?(e_newDport[idx]):f_dport[i];
				f_sendCnt[i]		= 0;
				f_correspEntry[i]	= idx;

				/*
					for rule with sip/sport specified, we must prevent other flow use this entry and avoid napt confuse
				*/
				if (e_sip[idx] && e_sport[idx])
				{
					e_used[idx] = TRUE;
				}

				/************** update item base **************/
				MASK_INCREASE(sip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(sport, 3, 1);
				MASK_INCREASE(dip, 1, ntohl(inet_addr("255.255.0.0")));
				LOWERBOUND_INCREASE(dport, 1, 1);
				MASK_INCREASE(newDip, 1, ntohl(inet_addr("255.255.255.0")));
				LOWERBOUND_INCREASE(newDport, 1, 1);				
			}

			/*******************************************************************************
				3. Randomly redirect them (all of flows must be redirected)
			*******************************************************************************/
			for (pktLoop = 0 ; pktLoop < MaxPktLoop ; pktLoop ++)
			{
				/*
					we reset sendCnt for each loop
				*/
				for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
				{
					f_sendCnt[i] = 0;
				}
			
				for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
				{
					/*
						Randomly choose unsent flow
					*/
					idx = (random() % PKT_NAPT_REDIRECT_TOTALFLOW);
					while (f_sendCnt[idx] > 0)
					{
						UPPERBOUND_INCREASE(idx, 1, (PKT_NAPT_REDIRECT_TOTALFLOW - 1));
					}
					/*
						randomly decide how many packet of this flow to be sent at this time
					*/
					if (f_isTcp[idx] == TRUE)
					{	/* tcp */
						j = DICING(2) + 1;
						f_sendCnt[idx] += (j * 64);	/* all flags are tested */
					}else
					{	/* udp */
						j = DICING(10) + 1;
						f_sendCnt[idx] += j;
					}
					while (j > 0)
					{	/* send packet to forwarding engine */
						int8 *data;
						uint32 dataLen;
						/*******************************************************************************/
						/*******************************************************************************/
						if (f_isTcp[idx] == TRUE)
						{	/* tcp */
							uint8 tcpFlag;

							for (tcpFlag = 0 ; tcpFlag < 64 ; tcpFlag ++)
							{
								/* send tcp packet */
								if (tcpFlag == TH_SYN)
								{
									data = NULL;
									dataLen = 0;
								}else
								{
									data = pkt_content;
									dataLen = DICING(sizeof(pkt_content));
								}
								/* generate input packet */
								mbuf_in = confVlanHSB(NULL, NULL,
									_PKT_TYPE_TCP, 1, 2, 0,
									mac_npi, mac_gw_int,
									f_sip[idx], f_dip[idx], 123, 0, 0,
									f_sport[idx], f_dport[idx], tcpFlag, 1460, 0, 0, data, dataLen);

								FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

								VALUE_CMP(retval, FWDENG_TO_GW);
								/* check trapped packet */
								mbuf_comp = confVlanHSB(NULL, NULL,
									_PKT_TYPE_TCP, 1, 2, 0,
									mac_npi, mac_gw_int,
									f_sip[idx], f_newDip[idx], 123, 0, 0,
									f_sport[idx], f_newDport[idx], tcpFlag, 1460, 0, 0, data, dataLen);
								CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
								MBUF_CMPandFREE(mbuf_in, mbuf_comp);
							}
						}else
						{	/* udp */
							data = pkt_content;
							dataLen = DICING(sizeof(pkt_content));

							/* generate input packet */
							mbuf_in = confVlanHSB(NULL, NULL,
								_PKT_TYPE_UDP, 1, 2, 0,
								mac_npi, mac_gw_int,
								f_sip[idx], f_dip[idx], 123, 0, 0,
								f_sport[idx], f_dport[idx], 0, 0, 0, 0, data, dataLen);

							FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

							VALUE_CMP(retval, FWDENG_TO_GW);
							/* check trapped packet */
							mbuf_comp = confVlanHSB(NULL, NULL,
								_PKT_TYPE_UDP, 1, 2, 0,
								mac_npi, mac_gw_int,
								f_sip[idx], f_newDip[idx], 123, 0, 0,
								f_sport[idx], f_newDport[idx], 0, 0, 0, 0, data, dataLen);		
							CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
							MBUF_CMPandFREE(mbuf_in, mbuf_comp);
						}
						/*******************************************************************************/
						/*******************************************************************************/
						j --;
					}
				}
			}
			/*******************************************************************************
				4. Query all flows,
					only RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE flows return SUCCESS
			*******************************************************************************/
			j = 0;	/* store the success count */
			for (i = 0 ; i < PKT_NAPT_REDIRECT_TOTALFLOW ; i ++)
			{
				ipaddr_t odip;
				uint16 odport;
				if (rtl8651_queryRedirectOutboundNaptFlow(f_isTcp[i], f_sip[i], f_sport[i], &odip, &odport, f_newDip[i], f_newDport[i]) == SUCCESS)
				{
					j ++;	/* add match count */
					/* check original dip/dport matching rule */
					VALUE_CMP(odip, f_dip[i]);
					VALUE_CMP(odport, f_dport[i]);
				}
			}

			VALUE_CMP(j , RTL8651_NAPTREDIRECT_DEFAULT_FLOWCACHESIZE);
		}

		/*******************************************************************************
			5. Randomly decide what napt redirect entry must to be removed
					- 2/3 probability to remove entry
		*******************************************************************************/
		{
			int i;
			for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
			{
				if (e_valid[i] == FALSE)
					continue;
				/* 1/3 -> don't remove entry */
				if (DICING(3) == 0)
					continue;

				/* remove this entry */
				ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], e_newDport[i]?e_newDport[i]:-1) == 1);

				/* invalid this entry */
				e_valid[i] = FALSE;
				e_used[i] = 0;
			}
		}
	}

	/*
		Finally, we remove all rules
	*/
	{
		int i;
		for (i = 0 ; i < RTL8651_NAPTREDIRECT_DEFAULT_TABLESIZE ; i ++)
		{
			if (e_valid[i] == FALSE)
				continue;

			/* remove this entry */
			ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(e_isTcp[i], e_sip[i], e_sport[i], e_dip[i], e_dport[i], e_newDip[i], e_newDport[i]?e_newDport[i]:-1) == 1);

			/* invalid this entry */
			e_valid[i] = FALSE;
			e_used[i] = 0;
		}
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, 0, 0, 0, 0, 0, 0) == 0);
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, 0, 0, 0, 0, 0, 0) == 0);
	}

	return SUCCESS;
}


/*
@func int32		| pkt_naptRedirect_6	| Test napt redirect basic functions for fragment packets
@rvalue SUCCESS	| 	test OK
@comm
We don't change dip/dport when trapping packet to protocol stack. (register this entry with newdport < 0)
Test the function: redirect napt fragment flow to protocol stack if we need.
 */
int32 pkt_naptRedirect_6(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		RP	->	RP	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int sa[5], s;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* register redirect rule */
	ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, 0, 0, 0, port_rp, 0, -1) == SUCCESS);

	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (pkt_no == 1)?(TEST_CSUM_L4|TEST_CSUM_IP):(TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
nextLoop:
	}

	// turn-off all dos check
	rtl8651a_setDosStatus(0, 0);

	/*
		NPI	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;
		int firstArrive;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop2;
				}
		}

		DEFAULT_IP_ID ++;
		firstArrive = FALSE;

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];

			mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			if (firstArrive == FALSE)
			{
				if (pkt_no == 1)	// first packet
				{	// dequeue
					int min, m, idx;
					int cmp_no;

					firstArrive = TRUE;
					VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
					VALUE_CMP(mbufList_nmbuf(), 0);
					// check output
					VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
					// sort arrived packets number
					min = 0;
					for (s = 0 ; s < p ; s ++)
					{
						m = total_pkt + 1;
						for (idx = 0 ; idx < p ; idx ++)
						{
							if ((min < pa[idx]) && (pa[idx] < m))
								m = pa[idx];
								
						}
						min = m;
						sa[s] = min;
					}
					// compare packet
					for (idx = 0 ; idx < p ; idx ++)
					{
						int16 tx_port[2] = {1, 0xffff};
					
						cmp_no = sa[idx];

						FRAG_DEQUEUE(mbuf_out, mbuf_in);

						mbuf_comp = confVlanHSB( NULL, NULL,
							_PKT_TYPE_UDP, 1, 2, 0,
							mac_npi, mac_gw_int,
							ip_npi, ip_rp, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
							port_npi, port_rp, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						CKSUM_CMP_SKIPUDPZERO(mbuf_out, mbuf_comp, (cmp_no == 1)?(TEST_CSUM_L4|TEST_CSUM_IP):(TEST_CSUM_IP));
						MBUF_CMPandFREE(mbuf_out, mbuf_comp);
					}
				}else
				{	// queued
					VALUE_CMP(retval, SUCCESS);
					VALUE_CMP(mbufList_nmbuf(), 0);
				}
			}else
			{	// first packet arrived, pass-through it
				int16 tx_port[2] = {1, 0xffff};

				VALUE_CMP(retval, FWDENG_TO_GW);
				VALUE_CMP(mbufList_nmbuf(), 0);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (pkt_no == 1)?(TEST_CSUM_L4|TEST_CSUM_IP):(TEST_CSUM_IP));
				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}
nextLoop2:
	}
	return SUCCESS;
}

/*
@func int32		| pkt_naptRedirect_7	| Stresss Test napt redirect Exception List
@rvalue SUCCESS	| 	test OK
@comm
Test the function: Exception List of NAPT redirect.
 */
int32 pkt_naptRedirect_7(uint32 caseNo){
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	int8 pkt_content[1024];

	/**********************************************
		1 wan(pppoe), 2 lan

		Test register/unregister accuracy

		- register test
		- conflict test
		- unregister test

			TCP test

			1. register
				(TCP, 0, port_npi, 0, port_rp)			-	OK
			2. register exception list
				(TCP, 192.168.1.1, port_npi, 0, port_rp)	-	OK
			3. register exception list
				(TCP, 192.168.1.1, port_npi, 0, port_rp)	-	Conflict, FAILED
			4. unregister exception list
				(TCP, 192.168.1.1, port_npi, 0, port_rp)	-	return value = 1
			5. unregister
				(TCP, 0, 0, 0, 0)						-	return value = 1


			UDP test

			6. register
				(UDP, 0, port_npi, 0, port_rp)			-	OK
			7. register exception list
				(UDP, 192.168.1.1, port_npi, 0, port_rp)	-	OK
			8. register exception list
				(UDP, 192.168.1.1, port_npi, 0, port_rp)	-	Conflict, FAILED
			9. unregister exception list
				(UDP, 192.168.1.1, port_npi, 0, port_rp)	-	return value = 1
			10. unregister
				(UDP, 0, 0, 0, 0)						-	return value = 1

 	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x5679;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ipaddr_t ip_gw_int2 = ntohl(inet_addr("192.168.2.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 4) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();


	/*************************
		Test flow trapping
	*************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			1. register
				(TCP, 0, port_npi, 0, port_rp)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptFlow(TRUE, 0, port_npi, 0, port_rp, 0, 1234) == SUCCESS);
	}
	/*************************
		Test flow trapping
	*************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, 1234, TH_SYN, 1460, 0, 0, NULL, 0);

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, 1234, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			2. register exception list
				(TCP, 192.168.1.1, port_npi, 0, port_rp)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptExceptionList(TRUE, ip_npi, port_npi, 0, port_rp) == SUCCESS);
	}
	/*************************
		Test flow trapping
	*************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			3. register exception list
				(TCP, 192.168.1.1, port_npi, 0, port_rp)	-	Conflict
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptExceptionList(TRUE, ip_npi, port_npi, 0, port_rp) == FAILED);
	}
	/*************************
		Test flow trapping
	*************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			4. unregister exception list
				(TCP, 192.168.1.1, port_npi, 0, port_rp)	-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptExceptionList(TRUE, ip_npi, port_npi, 0, port_rp) == 1);
	}
	/*************************
		Test flow trapping
	*************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, 1234, TH_SYN, 1460, 0, 0, NULL, 0);

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, 1234, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			5. unregister
				(TCP, 0, 0, 0, 0)						-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(TRUE, 0, 0, 0, 0, 0, 0) == 1);
	}
	/*************************
		Test flow trapping
	*************************/
	/* SYN packet */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_SYN, 1460, 0, 0, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}
	/* Other packets */
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_TCP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));


	/*****************************************************************************
			6. register
				(UDP, 0, port_npi, 0, port_rp)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptFlow(FALSE, 0, port_npi, 0, port_rp, 0, 1234) == SUCCESS);
	}
	/*************************
		Test flow trapping
	*************************/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, 1234, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			2. register exception list
				(UDP, 192.168.1.1, port_npi, 0, port_rp)	-	OK
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptExceptionList(FALSE, ip_npi, port_npi, 0, port_rp) == SUCCESS);
	}
	/*************************
		Test flow trapping
	*************************/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			3. register exception list
				(UDP, 192.168.1.1, port_npi, 0, port_rp)	-	Conflict
	*****************************************************************************/
	{
		ASSERT(rtl8651_registerRedirectOutboundNaptExceptionList(FALSE, ip_npi, port_npi, 0, port_rp) == FAILED);
	}
	/*************************
		Test flow trapping
	*************************/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			4. unregister exception list
				(UDP, 192.168.1.1, port_npi, 0, port_rp)	-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptExceptionList(FALSE, ip_npi, port_npi, 0, port_rp) == 1);
	}
	/*************************
		Test flow trapping
	*************************/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_TO_GW);

		mbuf_comp = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_gw_int, 123, 0, 0,
			port_npi, 1234, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));

	/*****************************************************************************
			5. unregister
				(UDP, 0, 0, 0, 0)						-	return value = 1
	*****************************************************************************/
	{
		ASSERT(rtl8651_unregisterRedirectOutboundNaptFlow(FALSE, 0, 0, 0, 0, 0, 0) == 1);
	}
	/*************************
		Test flow trapping
	*************************/
	{
		mbuf_in = confVlanHSB(NULL, NULL,
			_PKT_TYPE_UDP, 1, 2, 0,
			mac_npi, mac_gw_int, ip_npi, ip_rp, 123, 0, 0,
			port_npi, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
	}

	MASK_INCREASE(ip_rp, 1, ntohl(inet_addr("255.0.0.0")));


	return SUCCESS;
}


#endif /* RTL_NAPT_REDIRECT_TEST */

#ifdef RTL_TRAPPING_DISPATCH_TEST
/*
@func int32		| pkt_trapping_dispatch_1	| test trapping dispatch system correctness
@rvalue SUCCESS	| 	test OK
@comm
	For IP packets with DMAC == Gateway MAC, test the trapping dispatch system which can
	distinguish different packets into different categories.

	Test for TCP/UDP non-fragmented packet.
 */
int32 pkt_trapping_dispatch_1(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/**********************************************
		1 wan(pppoe), 1 lan

		TCP
		---------------------------
		GW	->	RP	:	SYN
		RP	->	GW	:	SYN+ACK
		GW	->	RP	:	ACK
		RP	->	GW	:	ACK
		GW	->	RP	:	ACK+FIN
		RP	->	GW	:	ACK+FIN
		GW	->	RP	:	ACK

		UDP
		---------------------------
		GW	->	RP
		RP	->	GW

	***********************************************/

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	uint16 port_gw_start;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint32 loop, loop2;

	uint16 tcpCategory, udpCategory;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);

	/***********************************************************************************
								TCP test
	***********************************************************************************/

	/* record the start port number of geteway */
	port_gw_start = port_gw;

	/*	before registering:
		any trapping dispatch entry, all categories are RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY */

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}


	/*	register entry:

		all ICMP entries have category : 2	-> TCP is still 0
	*/
	ASSERT(rtl8651_registerTrappingDispatchEntry(	IPPROTO_ICMP,
													0,
													0,
													1234,	/* will be ignored */
													1234,	/* will be ignored */
													2) == SUCCESS);

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*	register entry:

		all TCP entries have category : 3	-> TCP is set to 3
	*/
	ASSERT(rtl8651_registerTrappingDispatchEntry(	IPPROTO_TCP,
													0,
													0,
													-1,
													-1,
													3) == SUCCESS);

	tcpCategory = 3;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*	update entry:

		all TCP entries have category : 4	-> TCP is set to 4
	*/
	ASSERT(rtl8651_registerTrappingDispatchEntry(	IPPROTO_TCP,
													0,
													0,
													-1,
													-1,
													4) == SUCCESS);

	tcpCategory = 4;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*	register entry:

		all TCP entries with dstPort == {port_gw_start + {1~100}}
			have category : dstPort	-> other TCP is 4
	*/
	for (loop2 = 0 ; loop2 < 100 ; loop2 ++)
	{
		ASSERT(rtl8651_registerTrappingDispatchEntry(	IPPROTO_TCP,
														0,
														0,
														-1,
														port_gw_start + loop2 + 1,
														port_gw_start + loop2 + 1) == SUCCESS);
	}

	tcpCategory = 4;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=(port_gw_start + 1)&&port_gw<=(port_gw_start+100))?port_gw:tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=(port_gw_start + 1)&&port_gw<=(port_gw_start+100))?port_gw:tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=(port_gw_start + 1)&&port_gw<=(port_gw_start+100))?port_gw:tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}


	/*	unregister entry:

		all TCP entries  have category 4 --> remove!

			TCP packets witch dstPort = {port_gw_start + 1 ~ 100}	-> category = dstPort
			other TCP packets									-> category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY
	*/
	ASSERT(rtl8651_unregisterTrappingDispatchEntry(	IPPROTO_TCP,
													0,
													0,
													-10,	/* note: different from -1(used in registering), both of this two values mean the same */
													-10	/* note: different from -1(used in registering), both of this two values mean the same */
													) == 1 /* 1 entry is removed */);

	tcpCategory = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=(port_gw_start + 1)&&port_gw<=(port_gw_start+100))?port_gw:tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=(port_gw_start + 1)&&port_gw<=(port_gw_start+100))?port_gw:tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=(port_gw_start + 1)&&port_gw<=(port_gw_start+100))?port_gw:tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/*	unregister entry:

		all TCP entries  witch dstPort = {port_gw_start + 1 ~ 100} --> remove!

			all TCP packets	-> category = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY
	*/
	for (loop2 = 0 ; loop2 < 100 ; loop2 ++)
	{
		ASSERT(rtl8651_unregisterTrappingDispatchEntry(	IPPROTO_TCP,
														0,
														0,
														-1,
														port_gw_start + loop2 + 1) == 1);
	}


	tcpCategory = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = tcpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/***********************************************************************************
								UDP test
	***********************************************************************************/

	/* re-init port_gw_start */
	BOUND_INCREASE(port_gw_start, 10000, 1, 65535);

	/*	register entry:

		all UDP entries with dstPort == {port_gw_start + {1~100}} category : dstPort
	*/
	for (loop2 = 0 ; loop2 < 100 ; loop2 ++)
	{
		ASSERT(rtl8651_registerTrappingDispatchEntry(	IPPROTO_UDP,
														0,
														0,
														-1,
														port_gw_start + loop2 + 1,
														port_gw_start + loop2 + 1) == SUCCESS);
	}

	udpCategory = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_NEQ(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=port_gw_start+1 && port_gw<=port_gw_start+100)?port_gw:udpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);

		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

	}

	/*	update entry:

		all UDP entries with dstPort == {port_gw_start + {1~100}} category : dstPort + 1
	*/
	for (loop2 = 0 ; loop2 < 100 ; loop2 ++)
	{
		ASSERT(rtl8651_registerTrappingDispatchEntry(	IPPROTO_UDP,
														0,
														0,
														-1,
														port_gw_start + loop2 + 1,
														port_gw_start + loop2 + 1 + 1) == SUCCESS);
	}

	udpCategory = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_NEQ(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = (port_gw>=port_gw_start+1 && port_gw<=port_gw_start+100)?(port_gw+1):udpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);

		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

	}

	/*	unregister entry:

		all UDP entries's category : RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY
	*/
	for (loop2 = 0 ; loop2 < 100 ; loop2 ++)
	{
		ASSERT(rtl8651_unregisterTrappingDispatchEntry(	IPPROTO_UDP,
														0,
														0,
														-1,
														port_gw_start + loop2 + 1) == 1);
	}

	udpCategory = RTL8651_DEFAULT_TRAPPING_DISPATCH_CATEGORY;

	/* init port_gw */
	port_gw = port_gw_start;

	for (loop = 0 ; loop < 300 ; loop ++)
	{
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_NEQ(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_category = udpCategory;
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);

		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

	}

	return SUCCESS;
}

/*
@func int32		| pkt_trapping_dispatch_2	| test trapping dispatch system correctness 2
@rvalue SUCCESS	| 	test OK
@comm
	For IP packets with DMAC == Gateway MAC, test the trapping dispatch system which can
	distinguish different packets into different categories.

	Test for fragmented packet.
 */
int32 pkt_trapping_dispatch_2(uint32 caseNo){
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		NPI	->	GW	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int sa[5], s;

	int loop;

	uint16 udpCategory = 10;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();


	for (loop = 0 ; loop < 10 ; loop ++)
	{
		/*
			register category for ip_npi/port_npi/{widecard(ip_gw)}/port_gw

			category = udpCategory
		*/
		ASSERT(rtl8651_registerTrappingDispatchEntry(IPPROTO_UDP,
													ip_npi,
													0,
													port_npi,
													port_gw,
													udpCategory) == SUCCESS);


		// only allow Tear drop
		rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

		/*
			NPI	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop;
					}
			}

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				mbuf_comp->m_pkthdr->ph_category = udpCategory;

				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	nextLoop:
		}

		// turn-off all dos check
		rtl8651a_setDosStatus(0, 0);

		/*
			NPI	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;
			int firstArrive;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop2;
					}
			}

			DEFAULT_IP_ID ++;
			firstArrive = FALSE;

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confVlanHSB( NULL, NULL,
					_PKT_TYPE_UDP, 1, 2, 0,
					mac_npi, mac_gw_int,
					ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				if (firstArrive == FALSE)
				{
					if (pkt_no == 1)	// first packet
					{	// dequeue
						int min, m, idx;
						int cmp_no;

						firstArrive = TRUE;
						VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
						VALUE_CMP(mbufList_nmbuf(), 0);
						// check output
						VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
						// sort arrived packets number
						min = 0;
						for (s = 0 ; s < p ; s ++)
						{
							m = total_pkt + 1;
							for (idx = 0 ; idx < p ; idx ++)
							{
								if ((min < pa[idx]) && (pa[idx] < m))
									m = pa[idx];
									
							}
							min = m;
							sa[s] = min;
						}
						// compare packet
						for (idx = 0 ; idx < p ; idx ++)
						{
							int16 tx_port[2] = {1, 0xffff};
						
							cmp_no = sa[idx];

							FRAG_DEQUEUE(mbuf_out, mbuf_in);

							mbuf_comp = confVlanHSB( NULL, NULL,
								_PKT_TYPE_UDP, 1, 2, 0,
								mac_npi, mac_gw_int,
								ip_npi, ip_gw_int, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
								port_npi, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

							mbuf_comp->m_pkthdr->ph_category = udpCategory;

							MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						}
					}else
					{	// queued
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}else
				{	// first packet arrived, pass-through it
					int16 tx_port[2] = {1, 0xffff};

					VALUE_CMP(retval, FAILED);
					VALUE_CMP(mbufList_nmbuf(), 0);

					mbuf_comp = confVlanHSB( NULL, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int,
						ip_npi, ip_gw_int, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_npi, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					mbuf_comp->m_pkthdr->ph_category = udpCategory;

					MBUF_CMPandFREE(mbuf_in, mbuf_comp);
				}
			}

	nextLoop2:
		}

		/* for next loop */

		/* unregister first */
		ASSERT(rtl8651_unregisterTrappingDispatchEntry(IPPROTO_UDP,
														ip_npi,
														0,
														port_npi,
														port_gw) == 1);
		port_gw ++;
		udpCategory ++;
	}

	for (loop = 0 ; loop < 10 ; loop ++)
	{
		/*
			register category for ip_npi/port_npi/{widecard(ip_gw)}/port_gw

			category = udpCategory
		*/
		ASSERT(rtl8651_registerTrappingDispatchEntry(IPPROTO_UDP,
													0,
													ip_gw_ext,
													0,
													port_gw,
													udpCategory) == SUCCESS);
		// only allow Tear drop
		rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

		/*
			RP	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoo3;
					}
			}

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
			
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
				VALUE_CMP(mbufList_nmbuf(), 0);
			}
			// Output
			VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
		
			// out put will be in-order
			for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
			{
				int16 tx_port[2] = {1, 0xffff};
		
				FRAG_DEQUEUE(mbuf_out, mbuf_in);

				mbuf_comp = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				MBUF_CMPandFREE(mbuf_out, mbuf_comp);
			}
	nextLoo3:
		}

		// turn-off all dos check
		rtl8651a_setDosStatus(0, 0);

		/*
			NPI	->	GW
		*/
		for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
		for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
		for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
		for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
		for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
		for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
		{
			int pkt_no;
			int i,j;
			int firstArrive;

			for (i = 0 ; i < total_pkt ; i ++)
			for (j = 0 ; j < total_pkt ; j ++)
			{
				if ((i != j) &&
				    (pa[i] == pa[j]))
					{
						goto nextLoop4;
					}
			}

			DEFAULT_IP_ID ++;
			firstArrive = FALSE;

			for (p = 1 ; p <= total_pkt ; p ++)
			{
				// set pkt sequence
				pkt_no = pa[p - 1];

				mbuf_in = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

				if (firstArrive == FALSE)
				{
					if (pkt_no == 1)	// first packet
					{	// dequeue
						int min, m, idx;
						int cmp_no;

						firstArrive = TRUE;
						VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
						VALUE_CMP(mbufList_nmbuf(), 0);
						// check output
						VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
						// sort arrived packets number
						min = 0;
						for (s = 0 ; s < p ; s ++)
						{
							m = total_pkt + 1;
							for (idx = 0 ; idx < p ; idx ++)
							{
								if ((min < pa[idx]) && (pa[idx] < m))
									m = pa[idx];
									
							}
							min = m;
							sa[s] = min;
						}
						// compare packet
						for (idx = 0 ; idx < p ; idx ++)
						{
							int16 tx_port[2] = {1, 0xffff};
						
							cmp_no = sa[idx];

							FRAG_DEQUEUE(mbuf_out, mbuf_in);

							mbuf_comp = confPppoeHSB( NULL, NULL,
								_PKT_TYPE_UDP, 0, 1, 0,
								mac_pppoe, mac_gw_ext, 11111,
								ip_rp, ip_gw_ext, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
								port_rp, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

							MBUF_CMPandFREE(mbuf_out, mbuf_comp);
						}
					}else
					{	// queued
						VALUE_CMP(retval, SUCCESS);
						VALUE_CMP(mbufList_nmbuf(), 0);
					}
				}else
				{	// first packet arrived, pass-through it
					int16 tx_port[2] = {1, 0xffff};

					VALUE_CMP(retval, FWDENG_IP_CANTFRAG);
					VALUE_CMP(mbufList_nmbuf(), 0);

					mbuf_comp = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 11111,
						ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					MBUF_CMPandFREE(mbuf_in, mbuf_comp);
				}
			}

	nextLoop4:
		}

		/* for next loop */
		ASSERT(rtl8651_unregisterTrappingDispatchEntry(IPPROTO_UDP,
														0,
														ip_gw_ext,
														0,
														port_gw) == 1);

		port_gw ++;
		udpCategory ++;
	}

	return SUCCESS;
}

#endif /* RTL_TRAPPING_DISPATCH_TEST */


#ifdef RTL_OFFLOAD_ENGINE_TEST
/*
@func int32		| pkt_L3_offload_engine_1	| test L3 offload engine forwarding
@rvalue SUCCESS	| 	test OK
@comm
	This case tests the correctness of IP packets forwarding.
 */
int32 pkt_L3_offload_engine_1(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/**********************************************
		1 wan(pppoe), 1 lan
		UDP
		NPI	->	GW	out-of-order (indiscriminate)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xabcd;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	uint32 l3len;
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;
	int sa[5], s;

	int loop;

	uint16 udpCategory = 10;

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/***************
		TCP test
	***************/
	{
		int8 *content_ptr;
		uint32 content_size;
		uint8 TCP_flag;

		for (TCP_flag = 0 ; TCP_flag < 64 ; TCP_flag ++)
		{
			if (TCP_flag == TH_SYN)
			{
				content_ptr = NULL;
				content_size = 0;
			}
			else
			{
				content_ptr = pkt_content;
				content_size = sizeof(pkt_content);

				if (TCP_flag & TH_SYN)
					content_size -= 4;	// mss option
			}
		
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_TCP, 0, 0, 0, 
				mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 123, 0, 0,
				port_gw, port_rp, TCP_flag, 1460, 0, 0, content_ptr, content_size);

			{
				struct rtl_pktHdr *pPkt = mbuf_in->m_pkthdr;

				l3len = mbuf_in->m_len - 14;

				pPkt->ph_len = mbuf_in->m_len = l3len;
				memset(mbuf_in->m_data, 0, 14);

				mbuf_in->m_data += 14;
			}
			
			FWDENG_L3OFFLOAD(retval, mbuf_in->m_pkthdr, l3len, OFFLOAD_IP_CKSUM|OFFLOAD_L4_CKSUM, 0);
			VALUE_CMP(retval, SUCCESS);

			// check output
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(&conf, NULL,
					_PKT_TYPE_TCP, tx_list, 1, 0,
					mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, TCP_flag, 1460, 0, 0, content_ptr, content_size);
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}

	/***************
		UDP test
	***************/
	{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_UDP, 0, 0, 0, 
				mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 123, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			{
				struct rtl_pktHdr *pPkt = mbuf_in->m_pkthdr;

				l3len = mbuf_in->m_len - 14;

				pPkt->ph_len = mbuf_in->m_len = l3len;
				memset(mbuf_in->m_data, 0, 14);

				mbuf_in->m_data += 14;
			}
			
			FWDENG_L3OFFLOAD(retval, mbuf_in->m_pkthdr, l3len, OFFLOAD_IP_CKSUM|OFFLOAD_L4_CKSUM, 0);
			VALUE_CMP(retval, SUCCESS);

			// check output
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(&conf, NULL,
					_PKT_TYPE_UDP, tx_list, 1, 0,
					mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	/***************
		ICMP test
	***************/
	{
		uint16 icmp_type;
		for (icmp_type = 0 ; icmp_type < 256 ; icmp_type ++)
		{
			mbuf_in = confVlanHSB(&conf, NULL,
				_PKT_TYPE_ICMP, 0, 0, 0, 
				mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 123, 0, 0,
				port_gw, port_rp, 0, 0, (uint8)icmp_type, 1, pkt_content, sizeof(pkt_content));

			{
				struct rtl_pktHdr *pPkt = mbuf_in->m_pkthdr;

				l3len = mbuf_in->m_len - 14;

				pPkt->ph_len = mbuf_in->m_len = l3len;
				memset(mbuf_in->m_data, 0, 14);

				mbuf_in->m_data += 14;
			}
			
			FWDENG_L3OFFLOAD(retval, mbuf_in->m_pkthdr, l3len, OFFLOAD_IP_CKSUM|OFFLOAD_L4_CKSUM, 0);
			VALUE_CMP(retval, SUCCESS);

			// check output
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA(&conf, NULL,
					_PKT_TYPE_ICMP, tx_list, 1, 0,
					mac_gw_ext, mac_pppoe, ip_gw_ext, ip_rp, 123, 0, 0,
					port_gw, port_rp, 0, 0, (uint8)icmp_type, 1, pkt_content, sizeof(pkt_content));
			}
			VALUE_CMP(mbufList_nmbuf(), 1);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
	}

	return SUCCESS;
}
#endif /* RTL_OFFLOAD_ENGINE_TEST */

#ifdef RTL_PROTOCOLSTACK_FLOWCACHE_TEST
/*
@func int32		| pkt_napt_ProtocolStackFlow_trap_1	| test protocol stack flow sending correctness
@rvalue SUCCESS	| 	test OK
@comm
For gateway with DMZ Host is set:
	When protocol stack create connections with remote host,
	The traffic of these connections can NOT be forwarded to DMZ host and must be trapped to protocol stack.

	This case tests the correctness of TCP/UDP packets forwarding.
 */
int32 pkt_napt_ProtocolStackFlow_trap_1(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		1 wan(pppoe), 1 lan

		-->	set DMZ Host first

		TCP
		---------------------------
		GW	->	RP	:	SYN
		RP	->	GW	:	SYN+ACK
		GW	->	RP	:	ACK
		RP	->	GW	:	ACK
		GW	->	RP	:	ACK+FIN
		RP	->	GW	:	ACK+FIN
		GW	->	RP	:	ACK

		UDP
		---------------------------
		GW	->	RP
		RP	->	GW
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint32 loop;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);
	/*add dmz host */
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/***********************************************
		TCP test
	***********************************************/
	for (loop = 0 ; loop < 1000 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP : SYN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : SYN+ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ACK+FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 0,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, (TH_ACK|TH_FIN), 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : FIN
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_TCP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, (TH_FIN), 0, 0, 0, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	/***********************************************
		UDP test
	***********************************************/
	for (loop = 0 ; loop < 1000 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111, 
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}

	/*
		UDP packet without registered to napt entry will be forwarded to DMZ host
	*/
	for (loop = 0 ; loop < 1000 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			RP -> GW
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		{
			uint16 tx_port[2] = {1, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
				_PKT_TYPE_UDP, tx_port, 2, 0,
				mac_gw_int, mac_npi,
				ip_rp, ip_npi, 122, 0, 0,
				port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		}
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

/*
@func int32		| pkt_napt_ProtocolStackFlow_trap_2	| test protocol stack flow sending correctness
@rvalue SUCCESS	| 	test OK
@comm
For gateway with DMZ Host is set:
	When protocol stack create connections with remote host,
	The traffic of these connections can NOT be forwarded to DMZ host and must be trapped to protocol stack.

	This case tests the correctness of ICMP packets forwarding.
 */
int32 pkt_napt_ProtocolStackFlow_trap_2(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf, conf_comp;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		1 wan(pppoe), 1 lan

		-->	set DMZ Host first

		ICMP
		-------------------------------------------
		GW	->	RP	:	ECHO
		RP	->	GW	:	ECHO_REPLY
		GW	->	RP	:	TIMESTAMP
		RP	->	GW	:	TIMESTAMP_REPLY

		ICMP_ERROR
		-------------------------------------------
		TCP
		---------------------------
		GW	->	RP	:	SYN
		RP	->	GW	:	ICMP_ERROR

		UDP
		---------------------------
		GW	->	RP
		RP	->	GW	:	ICMP_ERROR

		ICMP
		---------------------------
		GW	->	RP	:	TIMESTAMP
		RP	->	GW	:	ICMP_ERROR
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 icmp_id1 = 1234;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint32 loop;

	const uint8 err_cnt = 4;
	uint8 err_type[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);
	/* add dmz host */
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);
	/* turn-on icmp forwarding */
	ASSERT(rtl8651_fwdEngineDMZHostIcmpPassThrough(TRUE) == SUCCESS);

	/*********************************************
		ICMP
	*********************************************/
	for (loop = 0 ; loop < 1000 ; loop ++)
	{
		BOUND_INCREASE(icmp_id1, 1, 0, 65535);
		/*
			GW -> RP : ECHO
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHO, icmp_id1, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : ECHO_REPLY
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_ECHOREPLY, icmp_id1, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* packet will be trapped due to icmp flow can not be found */
		VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		/*
			GW -> RP : TIMESTAMP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMP, icmp_id1, NULL, 0);
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW : TIMESTAMP_REPLY
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_ICMP, 0, 1, 0,
			mac_pppoe, mac_gw_ext, 11111,
			ip_rp, ip_gw_ext, 123, 0, 0,
			0, 0, 0, 0, ICMP_TSTAMPREPLY, icmp_id1, NULL, 0);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* packet will be trapped due to icmp flow can not be found */
		VALUE_CMP(retval, FWDENG_ICMP_IN_NOTFOUND);
		VALUE_CMP(mbufList_nmbuf(), 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	/*********************************************
		ICMP Error message
	*********************************************/
	for (loop = 0 ; loop < 1000 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/****************************
			For TCP error
		****************************/
		{
			/*
				GW -> RP : SYN
			*/
			mbuf_in = confPppoeHSB(&conf, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, 123, 0, 0,
				port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
			conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
			conf.conf_portlist = 0;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			/*
				RP -> GW : SYN+ACK
			*/
			mbuf_in = confPppoeHSB(&conf, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TO_GW);
			VALUE_CMP(mbufList_nmbuf(), 0);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			/*
				GW -> RP : ACK
			*/
			mbuf_in = confPppoeHSB(&conf, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, 123, 0, 0,
				port_gw, port_rp, (TH_ACK), 0, 0, 0, pkt_content, sizeof(pkt_content));
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
			conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
			conf.conf_portlist = 0;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/******** ICMP Error message ********/
		{
			int i;
			for (i = 0 ; i < err_cnt ; i ++)
			{
				BOUND_INCREASE(icmp_id1, 1, 0, 65535);
				/*
					RP -> GW : ICMP ERROR
				*/
				mbuf_in = confPppoeHSB(&conf_comp, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 123, 0, 0,
					0, 0, 0, 0, err_type[i], icmp_id1, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				/* packet will be trapped due to corresponding flow is trapped to protocol stack */
				VALUE_CMP(retval, FWDENG_TO_GW);
				VALUE_CMP(mbufList_nmbuf(), 0);
				mbuf_comp = genIcmpErrMbufPkt(&conf, &conf_comp);
				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}
		/****************************
			For UDP error
		****************************/
		{
			BOUND_INCREASE(port_gw, 1, 1, 65535);
			/*
				GW -> RP
			*/
			mbuf_in = confPppoeHSB(&conf, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, 123, 0, 0,
				port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
			conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
			conf.conf_portlist = 0;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/******** ICMP Error message ********/
		{
			int i;
			for (i = 0 ; i < err_cnt ; i ++)
			{
				BOUND_INCREASE(icmp_id1, 1, 0, 65535);
				/*
					RP -> GW : ICMP ERROR
				*/
				mbuf_in = confPppoeHSB(&conf_comp, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 123, 0, 0,
					0, 0, 0, 0, err_type[i], icmp_id1, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				/* packet will be trapped due to corresponding flow is trapped to protocol stack */
				VALUE_CMP(retval, FWDENG_TO_GW);
				VALUE_CMP(mbufList_nmbuf(), 0);
				mbuf_comp = genIcmpErrMbufPkt(&conf, &conf_comp);
				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}
		/****************************
			For ICMP error
		****************************/
		{
			BOUND_INCREASE(icmp_id1, 1, 0, 65535);
			/*
				GW -> RP, ICMP whatever
			*/
			mbuf_in = confPppoeHSB(&conf, NULL,
				_PKT_TYPE_ICMP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, 123, 0, 0,
				0, 0, 0, 0, (icmp_id1 & 0xff), icmp_id1, pkt_content, sizeof(pkt_content));
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
			conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
			conf.conf_portlist = 0;
			ADD_TX_PORT(conf.conf_portlist, 0);
			mbuf_comp = genMbufPkt(&conf);
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/******** ICMP Error message ********/
		{
			int i;
			for (i = 0 ; i < err_cnt ; i ++)
			{
				BOUND_INCREASE(icmp_id1, 1, 0, 65535);
				/*
					RP -> GW : ICMP ERROR
				*/
				mbuf_in = confPppoeHSB(&conf_comp, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, 123, 0, 0,
					0, 0, 0, 0, err_type[i], icmp_id1, NULL, 0);
				FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
				/* packet will be trapped due to corresponding error flow can not be found */
				VALUE_CMP(retval, FWDENG_ICMP_IN_ERRFLOWNOTFOUND);
				VALUE_CMP(mbufList_nmbuf(), 0);
				mbuf_comp = genIcmpErrMbufPkt(&conf, &conf_comp);
				MBUF_CMPandFREE(mbuf_in, mbuf_comp);
			}
		}
	}
	return SUCCESS;
}

/*
@func int32		| pkt_napt_ProtocolStackFlow_trap_3	| test protocol stack flow sending correctness
@rvalue SUCCESS	| 	test OK
@comm
For gateway with DMZ Host is set:
	When protocol stack create connections with remote host,
	The traffic of these connections can NOT be forwarded to DMZ host and must be trapped to protocol stack.

	This case tests the correctness of UDP fragment packets forwarding.
 */
int32 pkt_napt_ProtocolStackFlow_trap_3(uint32 caseNo){
	int8 pkt_content[1452];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		1 wan(pppoe), 1 lan

		-->	set DMZ Host first

		UDP
		---------------------------
		GW	->	RP
		RP	->	GW	(fragment packet)
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
//	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	uint32 loop;
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Turn OFF dos scan */
	rtl8651a_setDosStatus(0, 0);
	/*add dmz host */
	ASSERT(rtl8651_addDmzHost(ip_gw_ext, ip_npi) == SUCCESS);

	/***********************************************
		UDP test
	***********************************************/
	for (loop = 0 ; loop < 10 ; loop ++)
	{
		BOUND_INCREASE(port_gw, 1, 1, 65535);
		/*
			GW -> RP
		*/
		mbuf_in = confPppoeHSB(&conf, NULL,
			_PKT_TYPE_UDP, 0, 1, 0,
			mac_gw_ext, mac_pppoe, 11111,
			ip_gw_ext, ip_rp, 123, 0, 0,
			port_gw, port_rp, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
#ifdef SW_CHECKSUM
		conf.conf_Flags &= ~(CSUM_IP_OK|CSUM_L4_OK);
#endif
		conf.conf_portlist = 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		mbuf_comp = genMbufPkt(&conf);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		/*
			RP -> GW
		*/
		{
			int total_pkt, p;
			int pa[5], sa[5];
			int udp_payload = 1480;
			// turn-off all dos check
			rtl8651a_setDosStatus(0, 0);

			/*
				NPI	->	GW
			*/
			for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
			for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
			for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
			for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
			for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
			for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
			{
				int pkt_no;
				int i,j;
				int firstArrive;

				for (i = 0 ; i < total_pkt ; i ++)
				for (j = 0 ; j < total_pkt ; j ++)
				{
					if ((i != j) &&
					    (pa[i] == pa[j]))
						{
							goto nextLoop1;
						}
				}
				DEFAULT_IP_ID ++;
				firstArrive = FALSE;

				for (p = 1 ; p <= total_pkt ; p ++)
				{
					// set pkt sequence
					pkt_no = pa[p - 1];

					mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 11111,
						ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

					FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

					if (firstArrive == FALSE)
					{
						if (pkt_no == 1)	// first packet
						{	// dequeue
							int min, m, idx;
							int cmp_no;
							int s;

							firstArrive = TRUE;
							VALUE_CMP(retval, FWDENG_QUEUED_TO_GW);
							VALUE_CMP(mbufList_nmbuf(), 0);
							// check output
							VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), p);
							// sort arrived packets number
							min = 0;
							for (s = 0 ; s < p ; s ++)
							{
								m = total_pkt + 1;
								for (idx = 0 ; idx < p ; idx ++)
								{
									if ((min < pa[idx]) && (pa[idx] < m))
										m = pa[idx];
										
								}
								min = m;
								sa[s] = min;
							}
							// compare packet
							for (idx = 0 ; idx < p ; idx ++)
							{
								int16 tx_port[2] = {1, 0xffff};
							
								cmp_no = sa[idx];

								FRAG_DEQUEUE(mbuf_out, mbuf_in);

								mbuf_comp = confPppoeHSB( NULL, NULL,
									_PKT_TYPE_UDP, 0, 1, 0,
									mac_pppoe, mac_gw_ext, 11111,
									ip_rp, ip_gw_ext, 11, (cmp_no == total_pkt?0:1), (udp_payload * (cmp_no - 1)),
									port_rp, port_gw, 0, 0, 0, 0, pkt_content, (cmp_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

								MBUF_CMPandFREE(mbuf_out, mbuf_comp);
							}
						}else
						{	// queued
							VALUE_CMP(retval, SUCCESS);
							VALUE_CMP(mbufList_nmbuf(), 0);
						}
					}else
					{	// first packet arrived, pass-through it
						int16 tx_port[2] = {1, 0xffff};

						VALUE_CMP(retval, FWDENG_IP_CANTFRAG);
						VALUE_CMP(mbufList_nmbuf(), 0);

						mbuf_comp = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_UDP, 0, 1, 0,
							mac_pppoe, mac_gw_ext, 11111,
							ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
							port_rp, port_gw, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

						MBUF_CMPandFREE(mbuf_in, mbuf_comp);
					}
				}

		nextLoop1:
			}
		}
	}

	return SUCCESS;
}


#endif	/* RTL_PROTOCOLSTACK_FLOWCACHE_TEST */

#ifdef RTL_FWDENG_ALG_TEST
/*
@func void		| algFtpClient	| test FTP-ALG LAN to WAN path.
@comm 
a FTP control packet 'PORT' from LAN pass-through FTP-ALG to WAN
will be modified to gateway's IP address and a assigned port.
Remote FTP Server is able to create this data channel.
*/
int32 algFtpClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG FTP Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
		TCP Flow: make a ALG connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		NPI	->	RP :
		TCP Flow: send a USER command
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0;
	uint8 src_content[2048]={0};
	src_content_len=sprintf(src_content,"USER test\r\n");

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}	

	/*
		NPI	->	RP :
		TCP Flow: send a FTP PORT command
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={0};
	uint8 dst_content[2048]={0};
	ipaddr_t tmpip;
	tmpip=htonl(ip_npi);
	src_content_len=sprintf(src_content,"PORT %u,%u,%u,%u,%u,%u\r\n",NIPQUAD(tmpip),0xdd,0xee);
	tmpip=htonl(ip_gw_ext);
	dst_content_len=sprintf(dst_content,"PORT %u,%u,%u,%u,129,1\r\n",NIPQUAD(tmpip));
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	//dumpMbufPkt(mbuf_comp);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a FTP data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5375; // hardware data channel 
	conf.conf_dport					= 0x8101; //for ftp data channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 5375; // hardware data channel 
	conf.conf_dport						= 0xddee; //data channel internal port
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}

/*
@func void		| algFtpServer	| test FTP-ALG WAN to LAN path.
@comm
Remote FTP Client is able to create a ctrl channel(port 21) to LAN.
a FTP control packet 'PASV' from WAN pass-through FTP-ALG to LAN
will be modified to LAN's IP address.
*/
int32 algFtpServer(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG FTP Server
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	iplists[RTL8651_ALG_FTP_IDX]=ip_npi;
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
		Input:	create a FTP control channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp; 
	conf.conf_dport					= 21;  // ftp ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp; //remote port
	conf.conf_dport						= 21; //ftp ctrl channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP -> NPI :
		TCP Flow: send a PASV command
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0;
	uint8 src_content[2048]={0};
	src_content_len=sprintf(src_content,"PASV\r\n");

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);	
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	
	conf.l2Flag						= L2_PPPoE;	
	conf.pppoe.type					= 0x8864;
	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);	
	VALUE_CMP(retval, SUCCESS);
	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_npi;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= 21; // ALG Port: for FTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);	

}	


	/*
		NPI	->	RP :
		TCP Flow: response a FTP 227 message
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={0};
	src_content_len=sprintf(src_content,"230 User logged in, proceed.\r\n");
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 21; // ALG Port: for FTP Server 
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 21; // ALG Port: for FTP Server
	conf.conf_dport					= port_rp; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;

	mbuf_comp = genMbufPkt(&conf);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		NPI	->	RP :
		TCP Flow: response a FTP 227 message
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={0};
	uint8 dst_content[2048]={0};
	ipaddr_t tmpip;
	tmpip=htonl(ip_npi);
	src_content_len=sprintf(src_content,"227 Entering Passive Mode (%u,%u,%u,%u,%u,%u)\r\n",NIPQUAD(tmpip),0xdd,0xee);
	tmpip=htonl(ip_gw_ext);
	dst_content_len=sprintf(dst_content,"227 Entering Passive Mode (%u,%u,%u,%u,%u,%u)\r\n",NIPQUAD(tmpip),0xdd,0xee);
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 21; // ALG Port: for FTP Server 
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 21; // ALG Port: for FTP Server
	conf.conf_dport					= port_rp; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;

	mbuf_comp = genMbufPkt(&conf);
//	dumpMbufPkt(mbuf_out);
//	dumpMbufPkt(mbuf_comp);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a FTP data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp; // from a random port
	conf.conf_dport					= 0xddee; //to ftp data channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp; // from a random port
	conf.conf_dport						= 0xddee; //to ftp server data channel 
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}



/*
@func void		| algIrcClient	| test IRC-ALG LAN to WAN path.
@comm 
a IRC control packet 'PRIVMSG DCCSEND' from LAN pass-through IRC-ALG to WAN
will be recorded the port information.
Remote user is able to create this data channel by this port information.
*/
int32 algIrcClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG IRC Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a IRC connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 6667; // ALG Port: for IRC Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 6667; // ALG Port: for IRC Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		NPI	->	RP :
		TCP Flow: send a IRC DCC command
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={0};
	uint8 dst_content[2048]={0};
	src_content_len=sprintf(src_content,"PRIVMSG ttt :%cDCC SEND realdme.txt %lu 3333 1104%c%c",1,1,ip_gw_ext,10);

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 6667; // ALG Port: for IRC Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 6667; // ALG Port: for IRC Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a IRC DCC data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; //from a random port
	conf.conf_dport					= 3333; //to IRC DCC data channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; // from a random port
	conf.conf_dport						= 3333; //to IRC DCC data channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}



/*
@func void		| algYmsgClient	| test YMSG-ALG LAN to WAN path.
@comm 
a Yahoo Messenger control packet(YMSG_P2PFILEXFER) from LAN pass-through YMSG-ALG to WAN
will be modified to port 5002.
Remote user is able to create this connection by port 5002.
gateway will forward this connection to port 80.
*/
int32 algYmsgClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG YMSG Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs

	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a Yahoo Messenger connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 5050; // ALG Port: for Ymsg Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 5050; // ALG Port: for Ymsg Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		NPI	->	RP :
		TCP Flow: send a YMSG P2PFILEXFER command
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[300]={'Y','M','S','G',0,0x0b,0,0,1,0x13,0,0x4d,0,0,0,0,0xb4,0x74,
		0x07,0x95,0x35,0xc0,0x80,'0','9','3','1','8','8','8','6','8','8',0xc0,0x80,'4','9',0xc0,0x80,
		'F','I','L','E','X','F','E','R',0xc0,0x80,'1',0xc0,0x80,'t','y','s','u','_','t','w',0xc0,0x80,
		'1','3',0xc0,0x80,'1',0xc0,0x80,'2','7',0xc0,0x80,'s','o','n','g','.','t','x','t',0xc0,0x80,
		'2','8',0xc0,0x80,'1','0','4','5',0xc0,0x80,'2','0',0xc0,0x80,'h','t','t','p',':','/','/','1','9','2',
		'.','1','6','8','.','1','.','1','0','1','/','M','e','s','s','e','n','g','e','r','.','0','9','3','1','8','8','8','6','8','8','8',
		'.','1','0','7','8','2','9','7','1','9','8','5','4','0','s','o','n','g','.','t','x','t','?','A','p','p','I','D','=','M','e','s',
		's','e','n','g','e','r','&','U','s','e','r','I','D','=','0','9','3','1','8','8','8','6','8','8','&','K','=','l','c','9','l','q',
		'p','m','x','z','1','z','w','q','f','n','l','g','b','m','h','8',
		0xc0,0x80,'1','4',0xc0,0x80,'d','d','d',0xc0,0x80,'1','1',0xc0,0x80,'1',0xc0,0x80,'5','4',0xc0,0x80,
		0xc0,0x80,'M','S','G','1','.','0',0xc0,0x80};

	uint8 dst_content[300]={'Y','M','S','G',0,0x0b,0,0,1,0x13,0,0x4d,0,0,0,0,0xb4,0x74,
		0x07,0x95,0x35,0xc0,0x80,'0','9','3','1','8','8','8','6','8','8',0xc0,0x80,'4','9',0xc0,0x80,
		'F','I','L','E','X','F','E','R',0xc0,0x80,'1',0xc0,0x80,'t','y','s','u','_','t','w',0xc0,0x80,
		'1','3',0xc0,0x80,'1',0xc0,0x80,'2','7',0xc0,0x80,'s','o','n','g','.','t','x','t',0xc0,0x80,
		'2','8',0xc0,0x80,'1','0','4','5',0xc0,0x80,'2','0',0xc0,0x80,'h','t','t','p',':','/','/','1','0',
		'.','1','1','3','.','1','.','1',':','5','0','0','2','/','M','e','s','s','e','n','g','e','r','.','0','9','3','1','8','8','8','6','8','8','8',
		'.','1','0','7','8','2','9','7','1','9','8','5','4','0','s','o','n','g','.','t','x','t','?','A','p','p','I','D','=','M','e','s',
		's','e','n','g','e','r','&','U','s','e','r','I','D','=','0','9','3','1','8','8','8','6','8','8','&','K','=','l','c','9','l','q',
		'p','m','x','z','1','z','w','q','f','n','l','g','b','m','h','8',
		0xc0,0x80,'1','4',0xc0,0x80,'d','d','d',0xc0,0x80,'1','1',0xc0,0x80,'1',0xc0,0x80,'5','4',0xc0,0x80,
		0xc0,0x80,'M','S','G','1','.','0',0xc0,0x80};

		src_content_len=295;
		dst_content_len=297;
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 5050; // ALG Port: for YMSG Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 5050; // ALG Port: for YMSG Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

/*
		RP	->	NPI :
		Input:	create a Ymsg media data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; //from a random port
	conf.conf_dport					= 5001; //to YMSG media data channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);	
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */

	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; // from a random port
	conf.conf_dport						= 5001; //to IRC DCC data channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI :
		Input:	create a YMSG file transfer data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 2222; //from a random port
	conf.conf_dport					= 5002; //to YMSG file transfer data channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 2222; // from a random port
	conf.conf_dport						= 80; //to internal YMSG data transfer data channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}	

	return SUCCESS;
}

/*
@func void		| algIcqClient	| test ICQ-ALG LAN to WAN path.
@comm 
a ICQ control packet 'FILE XFER(id=0x2a,ch=2,snac1=1,snac2=0x1e)' 
from LAN pass-through ICQ-ALG to WAN will be recorded and be modified to port 24500.
Remote user is able to connect this ctrl connection by port 24500.
gateway will forward this connection to original port.
this connection will send a port_info packet from LAN to WAN for peer-to-peer file transfer.
A remote host is able to create a data channel by this port_info.
In order to support ICQ 2003b, a special control packet 'id=0x2a,ch=2,snac1=4,snac2=6' 
is be handled. This ctrl packet have port infomation for remote hosts to connect.
If successfully, a remote host is able to create this connection.
*/
int32 algIcqClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG ICQ Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a ICQ connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 5190; // ALG Port: for ICQ Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 5190; // ALG Port: for Icq Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		NPI	->	RP :
		TCP Flow: send a ICQ FILEXFER ctrl packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={
		//section1: fake data(unknow ctrl)
		0x2a,0x02,0x2a,0xa5,0x00,0x1a,0x00,0x04,
		0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x02,
		0x00,0x00,0x00,0x00,0x00,0x03,0x1f,0x40,
		0x03,0xe7,0x03,0xe7,0x00,0x00,0x00,0x00,
		//section2: data transfer control packet
		0x2a,0x02,0x2a,0xa6,0x00,0x41,
		0x00,0x01,0x00,0x1e,0x00,0x00,0x00,0x00,
		0x00,0x1e,0x00,0x06,0x00,0x04,0x20,0x03,
		0x00,0x00,0x00,0x08,0x00,0x02,0x00,0x00,
		0x00,0x0c,0x00,0x25,0xc0,0xa8,0x01,0x65, //192.168.1.101
		0x00,0x00,0xab,0xcd,0x04,0x00,0x08,0xc7, //0xabcd port
		0xbb,0x9a,0x8a,0x00,0x00,0x00,0x50,0x00,
		0x00,0x00,0x03,0x3f,0xc5,0x3d,0xff,0x3f,
		0xc5,0x3d,0xf7,0x3f,0xc5,0x3d,0xf8,0x00,0x00};
		
	src_content_len=103;

uint8 dst_content[2048]={
		//section1: fake data(unknow ctrl)
		0x2a,0x02,0x2a,0xa5,0x00,0x1a,0x00,0x04,
		0x00,0x02,0x00,0x00,0x00,0x00,0x00,0x02,
		0x00,0x00,0x00,0x00,0x00,0x03,0x1f,0x40,
		0x03,0xe7,0x03,0xe7,0x00,0x00,0x00,0x00,
		//section2: data transfer control packet
		0x2a,0x02,0x2a,0xa6,0x00,0x41,
		0x00,0x01,0x00,0x1e,0x00,0x00,0x00,0x00,
		0x00,0x1e,0x00,0x06,0x00,0x04,0x20,0x03,
		0x00,0x00,0x00,0x08,0x00,0x02,0x00,0x00,
		0x00,0x0c,0x00,0x25,0xc0,0xa8,0x01,0x65, //192.168.1.101
		0x00,0x00,0x5f,0xb4,0x04,0x00,0x08,0xc7, //0x5fb4(24500) port
		0xbb,0x9a,0x8a,0x00,0x00,0x00,0x50,0x00,
		0x00,0x00,0x03,0x3f,0xc5,0x3d,0xff,0x3f,
		0xc5,0x3d,0xf7,0x3f,0xc5,0x3d,0xf8,0x00,0x00};
		
	dst_content_len=103;	

	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 5190; //for ICQ ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 5190; //for icq ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :
		Input:	create a file transfer ctrl channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; //from a random port
	conf.conf_dport					= 24500; //to ICQ file transfer ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; // from a random port
	conf.conf_dport						= 0xabcd; // to internal file transfer ctrl channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP :
		TCP Flow: send a ICQ old version file transfer ctrl command
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={ 0x02 ,0x94 
	,0x65 ,0xf1 ,0xc8 ,0xe7 ,0x1b ,0x2d ,0xcf ,0x87
	,0xe3 ,0x23 ,0xcf ,0x44 ,0x1c ,0x23 ,0xcf ,0x4f  
	,0x1c ,0x23 ,0xcf ,0x53 ,0x1c ,0x39 ,0xcf ,0xfc
	,0x1b ,0x23 ,0xcf ,0x01 ,0x00 ,0x00 ,0x20 ,0x00
	,0xf0 ,0x2d ,0x12 ,0xd9 ,0x30 ,0x91 ,0xd3 ,0x11
	,0x8d ,0xd7 ,0x00 ,0x10 ,0x4b ,0x06 ,0x46 ,0x2e
	,0x00 ,0x00 ,0x04 ,0x00 ,0x00 ,0x00 ,0x46 ,0x69
	,0x6c ,0x65 ,0x00 ,0x00 ,0x01 ,0x00 ,0x00 ,0x01
	,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00
	,0x00 ,0x1f ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00
	,0x00 ,0x58 ,0xc0 ,0x00 ,0x00 ,0x0d ,0x00 ,0x6e
	,0x74 ,0x70 ,0x63 ,0x6c ,0x6f ,0x63 ,0x6b ,0x2e
	,0x65 ,0x78 ,0x65 ,0x00 ,0x00 ,0xf0 ,0x03 ,0x00
	,0xde ,0xbc ,0x00 ,0x00}; //data channel port 0xbcde
		
	src_content_len=110;


	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0xabcd;
	conf.conf_dport					= 1111; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 24500;
	conf.conf_dport					= 1111;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}



	/*
		RP	->	NPI :
		Input:	create a ICQ file transfer data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 2222; //from a random port
	conf.conf_dport					= 0xbcde; //to YMSG file transfer data channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 2222; // from a random port
	conf.conf_dport						= 0xbcde; //to internal YMSG data transfer data channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}	


//for ICQ 2003b support

	/*
		NPI	->	RP :
		TCP Flow: send a new version ICQ FILEXFER ctrl packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={
		//header
		0x2a,0x02,0x11,0x22,0x33,0x44,0x00,0x04,
		0x00,0x06,0x55,0x66,
		//some random data
		0x00,0x01,0x00,0x1e,0x00,0x00,0x00,0x00,
		0x00,0x1e,0x00,0x06,0x00,0x04,0x20,0x03,
		0x00,0x00,0x00,0x08,0x00,0x02,0x00,0x00,
		// port info
		0xef,0xcd,0x00,0x00}; //data port 0xcdef 
		
	src_content_len=40;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 5190; //for ICQ ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 5190; //for icq ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :
		Input:	test the data channel is ok?
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 4444; //from a random port
	conf.conf_dport					= 0xcdef; //to ICQ file transfer ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 4444; // from a random port
	conf.conf_dport						= 0xcdef; // to internal file transfer ctrl channel
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}


/*
@func void		| algIcuiiServer	| test ICUII-ALG WAN to LAN path.
@comm
Remote ICUII user is able to create connections
(TCP:2000,2001 UDP:2002) to gateway, 
gateway will forward those connections to the ICUII server in LAN.
*/
int32 algIcuiiServer(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ICUII Server
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	iplists[RTL8651_ALG_ICUII_IDX]=ip_npi;
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
		Input:	create a ICUII media channel, port 2000
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; 
	conf.conf_dport					= 2000;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; // hardware data channel 
	conf.conf_dport						= 2000; //data channel internal port
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI :
		Input:	create a ICUII media channel, port 2001
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 2222; 
	conf.conf_dport					= 2001;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 2222; 
	conf.conf_dport						= 2001; 
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}	

	/*
		RP	->	NPI :
		ICUII media channel test, port 2002 UDP
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= 3333;
	conf.conf_dport					= 2002;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= 3333;
	conf.conf_dport						= 2002;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algDx7Client	| test DX7-ALG LAN to WAN path.
@comm 
a DirectX7 control packets(52bytes or 134bytes) from LAN pass-through DX7-ALG to WAN
will be recorded the port information.
Remote DirectX7 Server is able to connect to those connection which 
to create by control packets.
*/
int32 algDx7Client(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG DirectX Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a ICQ connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 47624; // ALG Port: for DirectX7 Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 47624; // ALG Port: for dx7 Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		NPI	->	RP :
		TCP Flow: send a DirectX7 ctrl packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={
		0x34 ,0x00 ,0xb0 ,0xfa ,0x02 ,0x00 ,0x08 ,0xfc ,0x00 ,0x00
		,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00  ,0x00 ,0x00 ,0x70 ,0x6c ,0x61 ,0x79 ,0x02 ,0x00
		,0x0e ,0x00 ,0x60 ,0xa2 ,0x69 ,0xfb ,0x31 ,0x50  ,0xd3 ,0x11 ,0xa2 ,0xd4 ,0x00 ,0x60 ,0x97 ,0xba
		,0x65 ,0x50 ,0x00 ,0x00 ,0x00 ,0x00 ,0x01 ,0x00  ,0x00 ,0x00};		
	src_content_len=52;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 47624; //for DirectX7 ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 47624; //for directX7 ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :
		Input:	create a inbound connection from the port of dx7 ctrl channel 
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; //from a random port
	conf.conf_dport					= 2300; //to DirectX7 inbound connection
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; //
	conf.conf_dport						= 2300; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: make a DX7 connection 2
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 2300; // ALG Port: for DirectX7 Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 2300; // ALG Port: for Dx7 Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}



	/*
		NPI	->	RP :
		TCP Flow: send a DX7 ctrl command 2
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={ 

	0x86 ,0x0 ,0xb0 ,0xfa ,0x02 ,0x0 ,0x8 ,0xfc ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x70 ,0x6c ,0x61 ,0x79 ,0x13 ,0x0
	,0x0e ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30 ,0x90 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x1c ,0x0 
	,0x0 ,0x0 ,0x6c ,0x0 ,0x0 ,0x0 ,0x50 ,0x0 ,0x0 ,0x0 ,0x9 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30
	,0x90 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x20 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30 ,0x90 ,0x0 ,0x30 ,0x0 ,0x0 ,0x0 ,0xe ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x2 ,0x0 ,0x8 ,0xfc ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x2 ,0x0 ,0x9 ,0x2e ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3f ,0x30 ,0x91 ,0x0 }; //ctrl packet : raw data 		
	src_content_len=134;


	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 2300; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 2300;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI :
		DX7 media channel test, port 2350 UDP
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= 2350; //
	conf.conf_dport					= 2350; //
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= 2350;
	conf.conf_dport						= 2350;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	return SUCCESS;
}


/*
@func void		| algDx7Server	| test DX7-ALG WAN to LAN path.
@comm 
a DirectX7 control packets(52bytes or 134bytes) from WAN to WAN
will be recorded the port information.
Remote DirectX7 Clinet is able to connect to those connection which 
to create by control packets.
*/
int32 algDx7Server(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		DX7 Server
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs and DirectX 7 Server
	iplists[RTL8651_ALG_DX7_IDX]=ip_npi;
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
		Input:	create a DX7 connection
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; 
	conf.conf_dport					= 47624;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; // hardware data channel 
	conf.conf_dport						= 47624; //data channel internal port
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI :
		Input:	send a ctrl packet 1
	*/
{
	uint16 src_content_len=0;
	uint8 src_content[2048]={
		0x34 ,0x00 ,0xb0 ,0xfa ,0x02 ,0x00 ,0x08 ,0xfc ,0x00 ,0x00
		,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00 ,0x00  ,0x00 ,0x00 ,0x70 ,0x6c ,0x61 ,0x79 ,0x02 ,0x00
		,0x0e ,0x00 ,0x60 ,0xa2 ,0x69 ,0xfb ,0x31 ,0x50  ,0xd3 ,0x11 ,0xa2 ,0xd4 ,0x00 ,0x60 ,0x97 ,0xba
		,0x65 ,0x50 ,0x00 ,0x00 ,0x00 ,0x00 ,0x01 ,0x00  ,0x00 ,0x00};		
	src_content_len=52;

	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; 
	conf.conf_dport					= 47624;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; 
	conf.conf_dport						= 47624; 
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}	


	/*
		NPI	->	RP :
		TCP Flow: send a DX7 syn packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;


	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 2300; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 2300;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: send a DX7 ctrl command 2
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={ 

	0x86 ,0x0 ,0xb0 ,0xfa ,0x02 ,0x0 ,0x8 ,0xfc ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x70 ,0x6c ,0x61 ,0x79 ,0x13 ,0x0
	,0x0e ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30 ,0x90 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x1c ,0x0 
	,0x0 ,0x0 ,0x6c ,0x0 ,0x0 ,0x0 ,0x50 ,0x0 ,0x0 ,0x0 ,0x9 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30
	,0x90 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x20 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30 ,0x90 ,0x0 ,0x30 ,0x0 ,0x0 ,0x0 ,0xe ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x2 ,0x0 ,0x8 ,0xfd ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x2 ,0x0 ,0x9 ,0x2e ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3f ,0x30 ,0x91 ,0x0 }; //ctrl packet : raw data 		
	src_content_len=134;

	src_content[114]=0x08;
	src_content[115]=0xfd;	


	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 2300; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 2300;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}



	/*
		RP	->	NPI :
		Input:	create a DX7 dynamic connection 
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; 
	conf.conf_dport					= 2301;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; // hardware data channel 
	conf.conf_dport						= 2301; //data channel internal port
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}



	/*
		NPI	->	RP :
		TCP Flow: send a DX7 ctrl command 2
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]={ 

	0x86 ,0x0 ,0xb0 ,0xfa ,0x02 ,0x0 ,0x8 ,0xfc ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x70 ,0x6c ,0x61 ,0x79 ,0x13 ,0x0
	,0x0e ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30 ,0x90 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x1c ,0x0 
	,0x0 ,0x0 ,0x6c ,0x0 ,0x0 ,0x0 ,0x50 ,0x0 ,0x0 ,0x0 ,0x9 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30
	,0x90 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x20 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3d ,0x30 ,0x90 ,0x0 ,0x30 ,0x0 ,0x0 ,0x0 ,0xe ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x2 ,0x0 ,0x8 ,0xfd ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x2 ,0x0 ,0x9 ,0x2e ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0
	,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x0 ,0x3f ,0x30 ,0x91 ,0x0 }; //ctrl packet : raw data 		
	src_content_len=134;

	src_content[114]=0x09;
	src_content[115]=0x2e;	


	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 2300; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 2300;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);
	//dumpMbufPkt(mbuf_out);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		RP	->	NPI :
		DX7 media channel test, port 2350 UDP
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= 2350; //
	conf.conf_dport					= 2350; //
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1452;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 233;
	conf.conf_sport						= 2350;
	conf.conf_dport						= 2350;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 1452;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	return SUCCESS;
}



/*
@func void		| algSipClient	| test SIP-ALG LAN to WAN path.
@comm 
SIP ALG will modify all the LAN's IP of payload to Gateway's WAN IP.
A SIP control packet which contain '\r\nm=' will open a port make remote
hosts is able to connect to client.
*/
int32 algSipClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG SIP Client , local port=global port=dst port
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_udp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a SIP connection
	*/
{

	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5060;
	conf.conf_dport					= 5060; // ALG Port: for SIP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 5060; // for hash1 algorithm
	conf.conf_dport					= 5060; // ALG Port: for SIP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :

*/
{
	/* config */
	/* RP->NPI */
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]="IP:10.113.1.1\r\nm=audio 12345 123\r\n";
	uint8 dst_content[2048]="IP:192.168.1.101\r\nm=audio 12345 123\r\n";
	src_content_len=34;
	dst_content_len=37;
	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5060; 
	conf.conf_dport					= 5060; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 5060; //
	conf.conf_dport						= 5060; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		UDP Flow: send a SIP packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]="IP:192.168.1.101\r\nm=audio 54321 123\r\n";
	uint8 dst_content[2048]="IP:10.113.1.1\r\nm=audio 54321 123\r\n";	
	src_content_len=37;
	dst_content_len=34;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5060;
	conf.conf_dport					= 5060; //for DirectX7 ctrl channel
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;				
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 5060;
	conf.conf_dport					= 5060; // sip protocol
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);


	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :

*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 12345; 
	conf.conf_dport					= 54321; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 12345; //
	conf.conf_dport						= 54321; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algSipServer	| test SIP-ALG WAN to LAN path.
@comm
SIP ALG will modify all the Gateway's WAN IP of payload to a assigned LAN IP.
A SIP control packet which contain '\r\nm=' will open a port make remote
client is able to connect to LAN's SIP server.
*/
int32 algSipServer(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG SIP Client , local port=global port=dst port
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_udp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	iplists[RTL8651_ALG_SIP_IDX]=ip_npi;
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();


/*
		RP	->	NPI : make a SIP connection

*/
{
	/* config */
	/* RP->NPI */
	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5060; 
	conf.conf_dport					= 5060; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 5060; //
	conf.conf_dport						= 5060; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


/*
	NPI	->	RP :
	send server out info
*/
{

	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]="IP:192.168.1.101\r\nm=audio 12345 123\r\n";
	uint8 dst_content[2048]="IP:10.113.1.1\r\nm=audio 12345 123\r\n";
	src_content_len=37;
	dst_content_len=34;
	
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5060;
	conf.conf_dport					= 5060; // ALG Port: for SIP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 5060; // for hash1 algorithm
	conf.conf_dport					= 5060; // ALG Port: for SIP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}



/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint16 src_content_len=0,dst_content_len=0;
	uint8 src_content[2048]="IP:10.113.1.1\r\nm=audio 12345 123\r\n";
	uint8 dst_content[2048]="IP:192.168.1.101\r\nm=audio 12345 123\r\n";
	src_content_len=34;	
	dst_content_len=37;


	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5060; 
	conf.conf_dport					= 5060; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 5060; //
	conf.conf_dport						= 5060; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}

/*
@func void		| algVDOliveClient	| test VDOLive-ALG LAN to WAN path.
@comm 
a VDOLive control packet from LAN pass-through VDOLive-ALG to WAN
will be recorded the port information, make remote VDOLive Server 
is able to connect to VDOLive Client by this port.
*/
int32 algVDOliveClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG VDOlive Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
		TCP Flow: make a ALG connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 7000; // vdo live
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 7000; // vdo live
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		NPI	->	RP :
		TCP Flow: send a ctrl packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=24;
	uint8 src_content[2048]={0,0,0,0,0,0,0,1,'V','D','O',' ','L','i','v','e',0,0,0xab,0xcd,0,0,0,0};

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 7000;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 7000;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a VDO live data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1234;
	conf.conf_dport					= 0xabcd;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1234;
	conf.conf_dport						= 0xabcd; //data channel internal port
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algRealAudioClient	| test RealAudio-ALG LAN to WAN path.
@comm 
a RealAudio control packet from LAN pass-through RealAudio-ALG to WAN
will be recorded the port information, make remote RealAudio Server 
is able to connect to RealAudio Client by this port.
*/
int32 algRealAudioClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG Real Audio Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
		TCP Flow: make a Real Audio ALG connection
	*/
{

	uint16 port_gw_tcp;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 7070; // vdo live
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 7070; // vdo live
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		NPI	->	RP :
		TCP Flow: send a ctrl packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=20;
	uint8 src_content[2048]={'P','N','A',0,1,0,1,0,7,0xbc,0xde,0,0,0,0,0,0,0,0,0};

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 7070;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 7070;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a VDO live data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1234;
	conf.conf_dport					= 0xbcde;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1234;
	conf.conf_dport						= 0xbcde;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algQuakeClient	| test Quake-ALG LAN to WAN path.
@comm 
a Quake control packet from LAN pass-through Quake-ALG to WAN
will be recorded the port information, make remote Quake Server 
is able to connect to Quake Client by this port.
*/                                               
int32 algQuakeClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG Quake Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_tcp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
		TCP Flow: make a Quake ALG connection
	*/
{

	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 27910; // vdo live
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 27910; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :

*/
{
	/* config */
	/* RP->NPI */
	uint16 src_content_len=16;
	uint8 src_content[2048]={0, 0x80, 0 , 11, 0x81 , 0xde , 0xf0 ,0 , 0 ,0 ,0, 0 ,0 ,0 ,0 ,0};
	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 27910; 
	conf.conf_dport					= port_gw_tcp; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 27910; //
	conf.conf_dport						= port_npi; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_PUSH|TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: send a ctrl packet
	*/
{

	uint16 port_gw_tcp;
	uint16 src_content_len=16;
	uint8 src_content[2048]={0, 0x80, 0 , 11, 0x81 , 0xcd , 0xef ,0 , 0 ,0 ,0, 0 ,0 ,0 ,0 ,0};

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 27910;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 27910;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a Quake data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0xdef0;
	conf.conf_dport					= 0xcdef;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 0xdef0;
	conf.conf_dport						= 0xcdef;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algBattlenetClient	| test Battlenet-ALG LAN to WAN path.
@comm
Remote Battlenet Server is able to create connections
(TCP:6112 UDP:6112,4000) to gateway, 
gateway will forward those connections to the Battlenet users in LAN.
*/
int32 algBattlenetClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG Battlenet Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_tcp=0;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
		TCP Flow: make a ALG connection
	*/
{



	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 6112;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 6112;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		NPI	->	RP :
		TCP Flow: send a NULL packet
	*/
{

	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 6112;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 6112;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}	






	/*
		RP -> NPI :
		TCP Flow: send a control packet
	*/
{

	uint16 src_content_len=24;
	uint8 src_content[2048]={0xff,0x09,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};


	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 6112;
	conf.conf_dport					= port_gw_tcp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	


	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 6112;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}	

	

	/*
		RP	->	NPI :
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 4444;
	conf.conf_dport					= 6112;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 4444;
	conf.conf_dport						= 6112;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}




	return SUCCESS;
}


/*
@func void		| algCsClient	| test Counter-Strike-ALG LAN to WAN path.
@comm
Remote Counter-Strike Server is able to create connections
(UDP:6003,7002,27005,27010,27011,27012,27015) to gateway, 
gateway will forward those connections to the Counter-Strike users in LAN.
*/
int32 algCsClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG CS Client , local port=global port=dst port
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_udp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a CS connection
	*/
{

	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 27015; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_udp;
	conf.conf_dport					= 27015;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :

*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1111; 
	conf.conf_dport					= 6003; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1111; //
	conf.conf_dport						= 6003; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 2222; 
	conf.conf_dport					= 7002; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 2222; //
	conf.conf_dport						= 7002; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 3333; 
	conf.conf_dport					= 27005; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 3333; //
	conf.conf_dport						= 27005; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 4444; 
	conf.conf_dport					= 27010; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 4444; //
	conf.conf_dport						= 27010; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 5555; 
	conf.conf_dport					= 27011; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 5555; //
	conf.conf_dport						= 27011; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 6666; 
	conf.conf_dport					= 27012; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 6666; //
	conf.conf_dport						= 27012; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 7777; 
	conf.conf_dport					= 27015; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 7777; //
	conf.conf_dport						= 27015; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}



/*
@func void		| algCUseeMeClient	| test CUseeMe-ALG LAN to WAN path.
@comm 
a CUseeMe control packet from LAN pass-through CUseeMe-ALG to WAN
will be modified to gateway's IP address and a assigned WAN port.
a CUseeMe control packet from WAN pass-through CUseeMe-ALG to LAN
will be modified to LAN's IP address and the original port.
*/
int32 algCUseeMeClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG CUseeMe Client , local port=global port=dst port
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_udp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a CUseeMe connection
	*/
{
	uint8 src_content[2048]={0,0,(7648>>8)&0xff,7648&0xff,(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,
		0,0,(port_npi>>8)&0xff,port_npi&0xff,(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,
		0,0,0,0,0,0,0,101,0,0};
	uint16 src_content_len=26;
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 7648; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	{
	uint8 dst_content[2048]={0,0,(7648>>8)&0xff,7648&0xff,(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,
		0,0,(port_gw_udp>>8)&0xff,port_gw_udp&0xff,(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,
		0,0,0,0,0,0,0,101,0,0};
	uint16 dst_content_len=26;
	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_udp;
	conf.conf_dport					= 7648;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	}

}



/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0,0,(port_gw_udp>>8)&0xff,port_gw_udp&0xff,(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,
		0,0,(7648>>8)&0xff,7648&0xff,(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,
		0,0,0,0,0,0,0,101,
		0,0,0,42,0,0,0,0,'n','a','m','e',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ,0,0,0,0,
		(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,
		0,0,0,0,0,0,0,0};
	uint16 src_content_len=68;

	uint8 dst_content[2048]={0,0,(port_npi>>8)&0xff,port_npi&0xff,(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,
		0,0,(7648>>8)&0xff,7648&0xff,(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,
		0,0,0,0,0,0,0,101,
		0,0,0,42,0,0,0,0,'n','a','m','e',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ,0,0,0,0,
		(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,
		0,0,0,0,0,0,0,0};
	uint16 dst_content_len=68;
	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 7648; 
	conf.conf_dport					= port_gw_udp; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 7648; //
	conf.conf_dport						= port_npi; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algL2tpClient	| test L2TP-ALG LAN to WAN path.
@comm 
a L2TP first control packet 'tunnel_id=0' from LAN to WAN will be recorded the last LAN's IP.
After L2TP server send a response packet, ALG will bind the LAN's IP address and tunnel's ID.
so, any L2TP packet from WAN will redirect to it's mapping LAN's IP by tunnel's ID of packet.
*/
int32 algL2tpClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG L2TP Client , local port=global port=dst port
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.102"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_gw_udp;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a L2TP connection
	*/
{
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x00,0x00,0x00};
	uint16 src_content_len=8;
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701;
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	
	if(port_gw_udp!=1701) { printf("Gateway port not equal 1701!\n"); return FAILED; }
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */

	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 1701;
	conf.conf_dport					= 1701;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	

}



/*
		RP	->	NPI :

*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x01,0x00,0x00};
	uint16 src_content_len=8;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701; 
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;  // NPI 1 IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1701; //
	conf.conf_dport						= 1701; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: make a L2TP connection
	*/
{
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x00,0x00,0x00};
	uint16 src_content_len=8;
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi2, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi2;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701;
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	
	if(port_gw_udp!=1701) { printf("Gateway port not equal 1701!\n"); return FAILED; }
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */

	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 1701;
	conf.conf_dport					= 1701;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	

}


/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x02,0x00,0x00};
	uint16 src_content_len=8;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701; 
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi2;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi2, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi2;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi2, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi2;  // NPI 2 IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1701; //
	conf.conf_dport						= 1701; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: make a L2TP connection
	*/
{
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x00,0x00,0x00};
	uint16 src_content_len=8;
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi2, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi2;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701;
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	
	if(port_gw_udp!=1701) { printf("Gateway port not equal 1701!\n"); return FAILED; }
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */

	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 1701;
	conf.conf_dport					= 1701;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	
}


/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x03,0x00,0x00};
	uint16 src_content_len=8;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701; 
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi2, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi2;  // NPI 2 IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1701; //
	conf.conf_dport						= 1701; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x01,0x00,0x00};
	uint16 src_content_len=8;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701; 
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;  // NPI IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1701; //
	conf.conf_dport						= 1701; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0xc8,0x02,0x00,0x08,0x00,0x03,0x00,0x00};
	uint16 src_content_len=8;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1701; 
	conf.conf_dport					= 1701; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	//conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi2, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi2;  // NPI 2 IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1701; //
	conf.conf_dport						= 1701; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}


/*
@func void		| algNetMeetingClient	| test NetMeeting-ALG LAN to WAN path.
@comm 
a WAN->LAN H225 packet contain the remote IP and Port, client create a H245 connection
to the port which H225 has gotten. The LAN->WAN H245 packet contain the local IP and port.
NetMeeting-ALG will modify the local IP to Gateway's WAN IP and open the port for 
NetMeeting Server establishing connection.
*/
int32 algNetMeetingClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG NetMeeting Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_tcp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		NPI	->	RP :
		TCP Flow: make a Netmeeting ALG connection
	*/
{

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 1720;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 1720; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI : H225

*/
{
	/* config */
	/* RP->NPI */
	
	uint8 src_content[2048]={0,0,0,
	(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,0xaa,0xbb, //port 0xaabb for h245
	0,0,0};
	uint16 src_content_len=12;
	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1720; 
	conf.conf_dport					= port_gw_tcp; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1720; //
	conf.conf_dport						= port_npi; //
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_PUSH|TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: send a h245 syn packet
	*/
{

	uint16 port_gw_tcp;
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi+1;
	conf.conf_dport					= 0xaabb;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_npi+1;
	conf.conf_dport					= 0xaabb;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI : H245

*/
{
	/* config */
	/* RP->NPI */
	
	uint8 src_content[2048]={0,0,0,
	(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,0x22,0x22, //port 0xaabb for h245
	0,0,0};
	uint16 src_content_len=12;

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0xaabb; 
	conf.conf_dport					= port_npi+1;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	
	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 0xaabb; 
	conf.conf_dport						= port_npi+1;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_PUSH|TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI : H245

*/
{
	/* config */
	/* RP->NPI */
	
	uint8 src_content[2048]={0,0,0,
	(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,0x22,0x22, //port 0xaabb for h245
	0,0,0};
	uint16 src_content_len=12;

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0xaabb; 
	conf.conf_dport					= port_npi+1;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	
	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 0xaabb; 
	conf.conf_dport						= port_npi+1;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_PUSH|TH_ACK);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP :
		TCP Flow: send a h245 ctrl packet , to open a port.
	*/
{

	uint16 port_gw_tcp;
	uint8 src_content[2048]={0, 0, 0,
		(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,0xbb,0xcc, //port: 0xbbcc for UDP connect in.
		0,0,0};
	uint16 src_content_len=12;

	uint8 dst_content[2048]={0, 0, 0,
		(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,0xbb,0xcc, //port: 0xbbcc for UDP connect in.
		0,0,0};
	uint16 dst_content_len=12;
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi+1;
	conf.conf_dport					= 0xaabb; //h245
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_npi+1;
	conf.conf_dport					= 0xaabb;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a Netmeeting data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0x2222;
	conf.conf_dport					= 0xbbcc;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 0x2222;
	conf.conf_dport						= 0xbbcc;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}


/*
@func void		| algNetMeetingServer	| test NetMeeting-ALG WAN to LAN path.
@comm 
a LAN->WAN H225 packet contain the local IP and local Port,
gateway will modify local IP to gateway's WAN IP, and local Port to 17200.
a NetMeeting Client will establish a H245 connection to NetMeeting Server with port 17200.
gateway redirect the port to original port.
NetMeeting Server response a ctrl packet contain a local ip and a random port.
gateway change the local ip to gateway's WAN IP.
remote NetMeeting Client is able to establish a data channel by the random port.
*/
int32 algNetMeetingServer(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG NetMeeting Server
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	iplists[RTL8651_ALG_NETMEETING_IDX]=ip_npi;
	
	rtl8651_setAlgStatus(0xffffffff,iplists);

	fwdeng_function_configuration1();

	/*
		RP	->	NPI :
		Input:	create a H225 ctrl channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp; 
	conf.conf_dport					= 1720;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp; //remote port
	conf.conf_dport						= 1720;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	/*
		NPI	->	RP :
		TCP Flow: send a h225 server out ctrl packet
	*/
{

	uint16 port_gw_tcp;

	uint8 src_content[2048]={0,0,0,(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,0xdd,0xee,0,0,0};
	uint8 dst_content[2048]={0,0,0,(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,(17200>>8)&0xff,17200&0xff,0,0,0};
	uint16 src_content_len=12,dst_content_len=12;
	
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1720;
	conf.conf_dport					= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 1720;
	conf.conf_dport					= port_rp; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;

	mbuf_comp = genMbufPkt(&conf);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		RP	->	NPI :
		Input:	H225 Server In
	*/
{

	uint8 src_content[2048]={0,0,0,(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,(1720>>8)&0xff,1720&0xff,0,0,0};
	uint8 dst_content[2048]={0,0,0,(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,(1720>>8)&0xff,1720&0xff,0,0,0};	
	uint16 src_content_len=12,dst_content_len=12;
	
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp; 
	conf.conf_dport					= 1720; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(retval, SUCCESS);

	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= 1720;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		RP	->	NPI :
		Input:	H245 SYN
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp+1; 
	conf.conf_dport					= 17200;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp+1; 
	conf.conf_dport						= 0xddee;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		RP	->	NPI :
		Input:	H245 control data
	*/
{

	uint8 src_content[2048]={0,0,0,(ip_rp>>24)&0xff,(ip_rp>>16)&0xff,(ip_rp>>8)&0xff,ip_rp&0xff,0x33,0x44,0,0,0};
	uint16 src_content_len=12;

	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_rp+1; 
	conf.conf_dport					= 17200;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= port_rp+1; 
	conf.conf_dport						= 0xddee;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	
	/*
		NPI	->	RP :
		TCP Flow: send a h245 server out ctrl packet
	*/
{

	uint16 port_gw_tcp;

	uint8 src_content[2048]={0,0,0,(ip_npi>>24)&0xff,(ip_npi>>16)&0xff,(ip_npi>>8)&0xff,ip_npi&0xff,0xee,0xff,0,0,0};
	uint8 dst_content[2048]={0,0,0,(ip_gw_ext>>24)&0xff,(ip_gw_ext>>16)&0xff,(ip_gw_ext>>8)&0xff,ip_gw_ext&0xff,0xee,0xff,0,0,0};
	uint16 src_content_len=12,dst_content_len=12;
	
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0xddee;
	conf.conf_dport					= port_rp+1;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 17200;
	conf.conf_dport					= port_rp+1; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;

	mbuf_comp = genMbufPkt(&conf);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


	/*
		RP	->	NPI :
		Input:	create a Netmeeting data channel
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 0x3344;
	conf.conf_dport					= 0xeeff;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
//	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 0x3344;
	conf.conf_dport						= 0xeeff;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
//	conf.conf_tcp_flag						= (TH_SYN);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= NULL;
	conf.payload.length					= 0;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}

/*
@func void		| algPptpClient	| test PPTP-ALG LAN to WAN path.
@comm 
modify the Call ID of PPTP ctrl packet Outgoing-Request(LAN->WAN) to global port.
modify the Peer's Call of PPTP ctrl packet Outgoing-Reply(WAN->LAN) to original ID.
modify the source IP of IP header of GRE outgoing packet to gateway's WAN IP.
modfiy the destination IP of IP header of GRE incoming packet to original IP and 
modify the Call ID of GRE header to original Call ID.
*/
int32 algPptpClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG PPTP Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_tcp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 inboundGlobalId, inboundLocalId, outboundGlobalId, outboundLocalId;
	uint8 * pktBuffer;
	uint32 pktLen;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0x7fffffff,iplists);
	
	fwdeng_function_configuration1();

	rtl8651_l4AliasPptpReInit();

//rtl8651_l4AliasPptpDump();
	/*
		NPI	->	RP :
		TCP Flow: make a PPTP connection
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		NPI	->	RP :
		TCP Flow: send a Outgoing-Call-Request packet
	*/
{

	
	uint16 src_content_len=20,dst_content_len=20;
	uint8 src_content[2048]={
		0x00 ,0xa8 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x07 ,//Outgoing-call-request
		0x00 ,0x00,
		0x00 ,0x00 ,0x08 ,0x1b, 
		0x00 ,0x00 ,0x01 ,0x2c};
	uint8 dst_content[2048]={
		0x00 ,0xa8 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x07 ,
		0x00 ,0x00,
		0x81 ,0xcb ,0x08 ,0x1b, 
		0x00 ,0x00 ,0x01 ,0x2c};
		
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 1723;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	inboundLocalId = *(uint16 *)&src_content[12];
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
	pktBuffer = _mBuf2pkt(mbuf_out, &pktLen);
	inboundGlobalId = *(uint16 *)(pktBuffer+66);
	free(pktBuffer);
	*(uint16 *)&dst_content[12] = *(uint16 *)(pktBuffer+66);
	
	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 1723; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);

	//dumpMbufPkt(mbuf_out);
	//dumpMbufPkt(mbuf_comp);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
//	printf("Inbound GID:%x LID:%x\n", inboundGlobalId, inboundLocalId);
}

	/*
		RP	->	NPI :
		Input:	create a PPTP Outgoing-call-reply pkt
	*/
{


	uint16 src_content_len=20,dst_content_len=20;
	uint8 src_content[2048]={
		0x00 ,0x20 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x08 ,0x00 ,0x00,
		0x03 ,0x00 ,0x81 ,0xcb, 
		0x01 ,0x00 ,0x00 ,0x00};
	uint8 dst_content[2048]={
		0x00 ,0x20 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x08 ,0x00 ,0x00,
		0x03 ,0x00 ,0x00 ,0x00, 
		0x01 ,0x00 ,0x00 ,0x00};
		
		
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1723;
	conf.conf_dport					= port_gw_tcp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	outboundGlobalId = *(uint16 *)&src_content[12];
	*(uint16 *)&src_content[14] = inboundGlobalId;
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1723;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_out = mbufList_dequeue();
	pktBuffer = _mBuf2pkt(mbuf_out, &pktLen);
	outboundLocalId = *(uint16 *)(pktBuffer+66);
	free(pktBuffer);
	*(uint16 *)&dst_content[12] = outboundLocalId;
//	printf("Outbound GID:%x LID:%x\n", outboundGlobalId, outboundLocalId);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: send a GRE packet
	*/
{

	
	uint16 src_content_len=12,dst_content_len=12;
	uint8 src_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x0f};
	uint8 dst_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x0f};	

	*(uint16 *)&src_content[6] = outboundLocalId;
	*(uint16 *)&dst_content[6] = outboundGlobalId;
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);

	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


	// get external port
	//ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	send a GRE packet
	*/
{

	uint16 src_content_len=12,dst_content_len=12;
	uint8 src_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x81,0xcb,0x00,0x00,0x00,0x16};
	uint8 dst_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x16};			
		
	*(uint16 *)&src_content[6] = inboundGlobalId;
	*(uint16 *)&dst_content[6] = inboundLocalId;
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.ip.protocol						= 0x2f; //GRE	
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}



/*
@func void		| algPptpSoftwareClient	| test PPTP-ALG LAN to WAN path.
@comm 
modify the source IP of IP header of GRE outgoing packet to gateway's WAN IP.
modfiy the destination IP of IP header of GRE incoming packet to original IP.
In pptp software case, Call ID and Peer's Call ID will not be changed!
*/
int32 algPptpSoftwareClient(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG PPTP Software Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_tcp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 inboundGlobalId, inboundLocalId, outboundGlobalId, outboundLocalId;
	uint8 * pktBuffer;
	uint32 pktLen;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a PPTP connection
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp; // for hash1 algorithm
	conf.conf_dport					= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		NPI	->	RP :
		TCP Flow: send a Outgoing-Call-Request packet
	*/
{

	
	uint16 src_content_len=20,dst_content_len=20;
	uint8 src_content[2048]={
		0x00 ,0xa8 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x07 ,//Outgoing-call-request
		0x00 ,0x00,
		0xab ,0xcd ,0x08 ,0x1b, 
		0x00 ,0x00 ,0x01 ,0x2c};
	uint8 dst_content[2048]={
		0x00 ,0xa8 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x07 ,
		0x00 ,0x00,
		0xab ,0xcd ,0x08 ,0x1b, 
		0x00 ,0x00 ,0x01 ,0x2c};
		
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= port_npi;
	conf.conf_dport					= 1723;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	inboundLocalId = *(uint16 *)&src_content[12];
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
	pktBuffer = _mBuf2pkt(mbuf_out, &pktLen);
	inboundGlobalId = *(uint16 *)(pktBuffer+66);
	free(pktBuffer);
	*(uint16 *)&dst_content[12] = *(uint16 *)(pktBuffer+66);
	
	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_gw_tcp;
	conf.conf_dport					= 1723; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);

	//dumpMbufPkt(mbuf_out);
	//dumpMbufPkt(mbuf_comp);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
//	printf("Inbound GID:%x LID:%x\n", inboundGlobalId, inboundLocalId);
}

	/*
		RP	->	NPI :
		Input:	create a PPTP Outgoing-call-reply pkt
	*/
{


	uint16 src_content_len=20,dst_content_len=20;
	uint8 src_content[2048]={
		0x00 ,0x20 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x08 ,0x00 ,0x00,
		0xde ,0xf0 ,0xab ,0xcd, 
		0x01 ,0x00 ,0x00 ,0x00};
	uint8 dst_content[2048]={
		0x00 ,0x20 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x08 ,0x00 ,0x00,
		0xde ,0xf0 ,0xab,0xcd, 
		0x01 ,0x00 ,0x00 ,0x00};
		
		
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 1723;
	conf.conf_dport					= port_gw_tcp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	outboundGlobalId = *(uint16 *)&src_content[12];
	
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1723;
	conf.conf_dport						= port_npi;
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_out = mbufList_dequeue();
	pktBuffer = _mBuf2pkt(mbuf_out, &pktLen);
	outboundLocalId = *(uint16 *)(pktBuffer+66);
	free(pktBuffer);
//	*(uint16 *)&dst_content[12] = outboundLocalId;
//	printf("Outbound GID:%x LID:%x\n", outboundGlobalId, outboundLocalId);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: send a GRE packet
	*/
{

	
	uint16 src_content_len=12,dst_content_len=12;
	uint8 src_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x0f};
	uint8 dst_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x0f};	

	*(uint16 *)&src_content[6] = outboundLocalId;
	*(uint16 *)&dst_content[6] = outboundGlobalId;
	
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);

	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


	// get external port
	//ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	send a GRE packet
	*/
{

	uint16 src_content_len=12,dst_content_len=12;
	uint8 src_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0xab,0xcd,0x00,0x00,0x00,0x16};
	uint8 dst_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0xab,0xcd,0x00,0x00,0x00,0x16};			
		
	*(uint16 *)&src_content[6] = inboundGlobalId;
	*(uint16 *)&dst_content[6] = inboundLocalId;
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.ip.protocol						= 0x2f; //GRE	
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}






/*
@func void		| algPptpServer	| test PPTP-ALG WAN to LAN path.
@comm 
modify the Call ID of PPTP ctrl packet Outgoing-Request(WAN->LAN) to local ID.
modify the Peer's Call of PPTP ctrl packet Outgoing-Reply(LAN->WAN) to global ID.
modify the source IP of IP header of GRE outgoing packet to gateway's WAN IP.
modfiy the destination IP of IP header of GRE incoming packet to original IP and 
modify the Call ID of GRE header to original Call ID.
*/
int32 algPptpServer(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG PPTP Client
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	uint16 port_gw_tcp;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	uint16 inboundGlobalId, inboundLocalId, outboundGlobalId, outboundLocalId;
	uint8 * pktBuffer;
	uint32 pktLen;

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs

	//turn on all the ALGs
	iplists[RTL8651_ALG_PPTP_IDX]=ip_npi;
	
	rtl8651_setAlgStatus(0x7fffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		RP -> NPI :
		TCP Flow: make a PPTP connection
	*/
{
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= L2_PPPoE;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags						= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type						= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= NULL;
	conf.payload.length					= 0;
	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx					= 0;
	SET_RX_PORT(conf.conf_portlist,0);


	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);

	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(retval, SUCCESS);
	//VALUE_CMP(mbufList_nmbuf(), 1);
    //mbuf_out = mbufList_dequeue();	

	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);



	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_int, conf.conf_smac);
	CP_MAC(mac_npi, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_npi;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= port_rp; 
	conf.conf_dport					= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.payload.content				= NULL;
	conf.payload.length				= 0;
	conf.conf_vlanIdx					= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}



	/*
		RP	->	NPI :
		TCP Flow: send a Outgoing-Call-Request packet
	*/
{

	
	uint16 src_content_len=20,dst_content_len=20;
	uint8 src_content[2048]={
		0x00 ,0xa8 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x07 ,//Outgoing-call-request
		0x00 ,0x00,
		0x00 ,0x00 ,0x08 ,0x1b, 
		0x00 ,0x00 ,0x01 ,0x2c};
	uint8 dst_content[2048]={
		0x00 ,0xa8 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x07 ,
		0x00 ,0x00,
		0x81 ,0xcb ,0x08 ,0x1b, 
		0x00 ,0x00 ,0x01 ,0x2c};
		
	/* config */

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= L2_PPPoE;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags						= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type						= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport						= port_rp;
	conf.conf_dport						= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_PUSH+TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length					= src_content_len;
	conf.conf_vlanIdx					= 1;
	conf.conf_pppoeIdx					= 0;
	SET_RX_PORT(conf.conf_portlist,0);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	outboundGlobalId = *(uint16 *)&src_content[12];
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
	pktBuffer = _mBuf2pkt(mbuf_out, &pktLen);
	outboundLocalId = *(uint16 *)(pktBuffer+66);
	free(pktBuffer);
	*(uint16 *)&dst_content[12] = *(uint16 *)(pktBuffer+66);
	
	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_int, conf.conf_smac);
	CP_MAC(mac_npi, conf.conf_dmac);
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_npi;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport						= port_rp; 
	conf.conf_dport						= 1723; // ALG Port: for PPTP Server 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_PUSH+TH_ACK);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1452;
	conf.conf_vlanIdx					= 2;
	conf.payload.content				= dst_content;
	conf.payload.length					= dst_content_len;	
	ADD_TX_PORT(conf.conf_portlist, 1);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);

//	dumpMbufPkt(mbuf_out);	

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
//	printf("Inbound GID:%x LID:%x\n", inboundGlobalId, inboundLocalId);
}


	/*
		NPI	->	RP :
		Input:	create a PPTP Outgoing-call-reply pkt
	*/
{


	uint16 src_content_len=20,dst_content_len=20;
	uint8 src_content[2048]={
		0x00 ,0x20 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x08 ,0x00 ,0x00,
		0x03 ,0x00 ,0x81 ,0xcb, 
		0x01 ,0x00 ,0x00 ,0x00};
	uint8 dst_content[2048]={
		0x00 ,0x20 ,0x00 ,0x01,
		0x1a ,0x2b ,0x3c ,0x4d,
		0x00 ,0x08 ,0x00 ,0x00,
		0x03 ,0x00 ,0x00 ,0x00, 
		0x01 ,0x00 ,0x00 ,0x00};
		
		
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;	
	conf.ErrFlag						= 0;
	conf.conf_Flags						= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_npi,  conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport						= 1723;
	conf.conf_dport						= port_rp;
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1460;
	conf.payload.content				= src_content;
	conf.payload.length					= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();
	inboundLocalId = *(uint16 *)&src_content[12];
	*(uint16 *)&src_content[14] = outboundLocalId;
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip							= ip_gw_ext;
	conf.conf_dip							= ip_rp;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 1723;
	conf.conf_dport						= port_rp; 
	conf.conf_tcp_seq						= 0xb;
	conf.conf_tcp_ack						= 0xc;
	conf.conf_tcp_flag						= (TH_ACK|TH_PUSH);
	conf.conf_tcp_win						= 0xfffe;
	conf.conf_tcp_mss						= 1452;
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;

	mbuf_out = mbufList_dequeue();
	pktBuffer = _mBuf2pkt(mbuf_out, &pktLen);
	inboundGlobalId = *(uint16 *)(pktBuffer+66);
	free(pktBuffer);
	*(uint16 *)&dst_content[12] = inboundGlobalId;
//	printf("Outbound GID:%x LID:%x\n", outboundGlobalId, outboundLocalId);

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);

	//dumpMbufPkt(mbuf_out);
	
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: send a GRE packet
	*/
{

	
	uint16 src_content_len=12,dst_content_len=12;
	uint8 src_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x0f};
	uint8 dst_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x03,0x00,0x00,0x00,0x00,0x0f};	

	*(uint16 *)&src_content[6] = outboundLocalId;
	*(uint16 *)&dst_content[6] = outboundGlobalId;
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);

	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


	// get external port
	//ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= dst_content;
	conf.payload.length				= dst_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}




	/*
		RP	->	NPI :
		Input:	send a GRE packet
	*/
{

	uint16 src_content_len=12,dst_content_len=12;
	uint8 src_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x81,0xcb,0x00,0x00,0x00,0x16};
	uint8 dst_content[2048]={0x20,0x81,0x88,0x0b,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x16};			
		
	*(uint16 *)&src_content[6] = inboundGlobalId;
	*(uint16 *)&dst_content[6] = inboundLocalId;
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 0x2f; //GRE
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */	
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf								= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.ip.protocol						= 0x2f; //GRE	
	conf.payload.content					= dst_content;
	conf.payload.length					= dst_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	return SUCCESS;
}




/*
@func void		| algIpsecClient	| test IPSec-ALG LAN to WAN path.
@comm 
a IPSec packet from LAN to WAN will record the initiator cookie and responder cookie,
a ISAKMP or ESP packet from WAN to LAN will redirct to original LAN's IP address by
initiator cookie and responder cookie.
*/
int32 algIpsecClient(uint32 caseNo)
{

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	/**********************************************
		ALG IPSec Client , local port=global port=dst port
		1 wan(pppoe), 1 lan
		TCP
	***********************************************/
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.101"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.102"));
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x02, 0x03, 0x04}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_gw_udp;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	//turn on all the ALGs
	
	rtl8651_setAlgStatus(0xffffffff,iplists);
	
	fwdeng_function_configuration1();
	

	/*
		NPI	->	RP :
		TCP Flow: make a IPSec connection
	*/
{
	uint8 src_content[2048]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
	uint16 src_content_len=16;	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 500;
	conf.conf_dport					= 500; 
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	
	if(port_gw_udp!=500) { printf("Gateway port not equal 500!\n"); return FAILED; }
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */

	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 500;
	conf.conf_dport					= 500;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
	

}



/*
		RP	->	NPI :

*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
	uint16 src_content_len=16;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 500; 
	conf.conf_dport					= 500; 
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */
	/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet

	/* check output packet */
	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;  // NPI 1 IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 500; //
	conf.conf_dport						= 500; //
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_out);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}


	/*
		NPI	->	RP :
		TCP Flow: make a L2TP connection
	*/
{
	uint8 src_content[2048]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	uint16 src_content_len=16;	
	

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi2, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi2;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 500;
	conf.conf_dport					= 500; 
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	// get external port
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_udp, NULL, NULL)==SUCCESS);
	
	if(port_gw_udp!=500) { printf("Gateway port not equal 500!\n"); return FAILED; }
	//dumpMbufPkt(mbuf_out);

	/* check output packet */
	/* NPI->RP (after NAPT) */

	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport					= 500;
	conf.conf_dport					= 500;
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}


/*
		RP	->	NPI :
*/
{
	/* config */
	/* RP->NPI */
	uint8 src_content[2048]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	uint16 src_content_len=16;	

	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.conf_sport					= 500; 
	conf.conf_dport					= 500; 
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */


/* arp */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_bcast, conf.conf_dmac);
	conf.arp.ip_src						= ip_gw_int;
	conf.arp.ip_dst						= ip_npi2;
	conf.arp.op							= ARPOP_REQUEST;
	conf.conf_vlanIdx						= 2;
	ADD_TX_PORT(conf.conf_portlist, 1);
	ADD_TX_PORT(conf.conf_portlist, 2);
	ADD_TX_PORT(conf.conf_portlist, 3);

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

	/* config */
	/* arp reply */
	RESET_CONF(&conf);	
	conf.pktType							= _PKT_TYPE_ARP;
	conf.ErrFlag							= 0;
	CP_MAC (mac_npi2, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.arp.ip_src						= ip_npi2;
	conf.arp.ip_dst						= ip_gw_int;
	conf.arp.op							= ARPOP_REPLY;
	SET_RX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, FWDENG_ARP_NOTREQ);
	freeMbuf(mbuf_in);					// free arp-reply packet


	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi2, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi2;  // NPI 2 IP address
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.conf_sport						= 500; //
	conf.conf_dport						= 500; //
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	/*
		NPI	->	RP :
		TCP Flow: send a Outgoing-Call-Request packet
	*/
	
{

	
	uint16 src_content_len=8;
	uint8 src_content[2048]={0x22,0x33,0x44,0x55,0x66,0x77,0x88,0x99};
		
	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC (mac_npi, conf.conf_smac);
	CP_MAC (mac_gw_int, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 50; //ESP
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 2;
	SET_RX_PORT(conf.conf_portlist, 1);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);

	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


	// get external port
	//ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);

	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.ip.protocol					= 50; //ESP
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);

}

	/*
		RP	->	NPI :
		Input:	create a ESP pkt
	*/
{

	uint16 src_content_len=8;
	uint8 src_content[2048]={0x11,0x22,0x33,0x44,0x55,0x66,0x77,0x88};
		
	/* config */
	/* RP->NPI */	
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;
	conf.ip.protocol					= 50; //ESP
	conf.payload.content				= src_content;
	conf.payload.length				= src_content_len;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP(retval, SUCCESS);
	/* check output packet */

	/* RP->NPI (through ServerPort) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP);
	CP_MAC (mac_gw_int, conf.conf_smac);
	CP_MAC (mac_npi, conf.conf_dmac);
	conf.conf_sip							= ip_rp;
	conf.conf_dip							= ip_npi;
	conf.ip.id								= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 254;
	conf.ip.protocol						= 50; //GRE	
	conf.payload.content					= src_content;
	conf.payload.length					= src_content_len;
	ADD_TX_PORT(conf.conf_portlist, 1);
	conf.conf_vlanIdx						= 2;

	mbuf_comp = genMbufPkt(&conf);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}

	return SUCCESS;
}

#endif
extern rtl8651_tblDrv_miiTunneling_t tunnel;
/*
@func void		| pptp_test10	| test GRE encapsulating/decapsulating.
@comm 
test GRE encapsulating and decapsulating - Non-compress header
*/
int32 pptp_test10(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_org, *mbuf_out, *mbuf_comp;


	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("192.168.240.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("192.170.240.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88}};	
	ether_addr_t mac_gw_int = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8a}};
	ether_addr_t mac_gw_sv = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8c}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	rtl8651_tblDrv_routeTable_t *rt_t=NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t=NULL;	
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_4();

	/*
		disable PPTP Compress header
	*/
	rtl8651_pptpPppCompress(FALSE);

	//printf("loopback VLAN_ID=%d WAN_VID=%d\n",tunnel.loopBackVid,tunnel.wanVid);

	rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
	if (rt_t->valid != 0 && rt_t->ifrt_flag==0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP))
		{
			//pppEntry_t=rt_t->rt_nhSession_t;
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
			pppEntry_t->initiated=1;
			if(pppEntry_t->greBuf1_==NULL)
			{	
				pppEntry_t->greBuf1_=(uint8*)rtlglue_malloc(1500);
				assert(pppEntry_t->greBuf1_);						
			}
			//make gre header
			pppEntry_t->greBuf1_[0]=0x45;
			pppEntry_t->greBuf1_[1]=0;
			pppEntry_t->greBuf1_[4]=0x12; //id
			pppEntry_t->greBuf1_[5]=0x34; //id
			pppEntry_t->greBuf1_[6]=0;
			pppEntry_t->greBuf1_[7]=0;
			pppEntry_t->greBuf1_[8]=0x80; //TTL
			pppEntry_t->greBuf1_[9]=0x2f; //GRE
			pppEntry_t->greBuf1_[12]=(ip_gw_ext>>24)&0xff;
			pppEntry_t->greBuf1_[13]=(ip_gw_ext>>16)&0xff;
			pppEntry_t->greBuf1_[14]=(ip_gw_ext>>8)&0xff;
			pppEntry_t->greBuf1_[15]=(ip_gw_ext)&0xff;
			pppEntry_t->greBuf1_[16]=(ip_rp>>24)&0xff;
			pppEntry_t->greBuf1_[17]=(ip_rp>>16)&0xff;
			pppEntry_t->greBuf1_[18]=(ip_rp>>8)&0xff;
			pppEntry_t->greBuf1_[19]=(ip_rp)&0xff;
		}
	}	

	ASSERT(pppEntry_t);
	
	/*
		NPI	->	RP : GRE encapsulating...		
	*/
	{

		uint16 port_gw_tcp;
		int i;

		/* config */
		/* NPI->RP */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
		conf.l2Flag							= 0;								/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC(mac_gw_ext, conf.conf_smac);
		CP_MAC(mac_gw_sv, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 254;
		conf.conf_sport						= port_gw_tcp;
		conf.conf_dport						= 1000; 
		conf.conf_tcp_seq					= 0xb;
		conf.conf_tcp_ack					= 0xc;
		conf.conf_tcp_flag					= (TH_SYN);
		conf.conf_tcp_win					= 0xfffe;
		conf.conf_tcp_mss					= 1412;
		conf.payload.content				= NULL;
		conf.payload.length					= 0;
		conf.conf_vlanIdx					= (tunnel.loopBackVid)&7;
		SET_RX_PORT(conf.conf_portlist, tunnel.loopbackPort);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		mbuf_org = genMbufPkt(&conf);


		mbuf_in->m_pkthdr->ph_rxdesc=0;
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		//dumpMbufPkt(mbuf_out);

		//compare ether header
		for(i=0;i<14;i++)
		{
			VALUE_CMP(mbuf_out->m_data[i], mbuf_org->m_data[i]);
		}

		//compare ip & gre & ppp header
		for(i=0;i<36;i++)
		{
			VALUE_CMP(mbuf_out->m_data[i+14], pppEntry_t->greBuf1_[i]);
		}

		//compare payload
		for(i=0;i<mbuf_org->m_len-14;i++)
		{	
			VALUE_CMP(mbuf_out->m_data[i+54], mbuf_org->m_data[i+14]);
		}

		freeMbuf(mbuf_out);	
		freeMbuf(mbuf_org);	

	}

	/*
		RP	->	NPI : GRE decapsulating...	
	*/
	{
		int i;
		uint8 content[1500]={0x30,0x01,0x88,0x0b,0x00,0x5d,0x03,0x80,0,0,0,0x35,0xff,0x03,0x00,0x21 //GRE,PPP
		,0x45,0x00,0x00,0x28,0,0x0a,0x40,0,0xfe,0x06,0x5b,0x6b,192,170,240,2,192,170,240,1 //IP
		,0,0x50,0x04,0x1b,0,0,0,1,0,0,0,2,0x50,0x02,0xff,0x23,0xc6,0x75,0,0}; //TCP
		
		/* config */
		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
		conf.l2Flag							= 0;							/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag						= 0;
		conf.conf_Flags						= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_sv, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);	
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.protocol					= 0x2f;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;	
		conf.payload.content				= content;
		conf.payload.length					= 53;
		conf.conf_vlanIdx					= tunnel.wanVid;	
		SET_RX_PORT(conf.conf_portlist, tunnel.wanPort);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genMbufPkt(&conf);
		mbuf_org = genMbufPkt(&conf);

		
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);


		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		//dumpMbufPkt(mbuf_org);	
		//dumpMbufPkt(mbuf_out);	

		//compare ether header
		for(i=0;i<14;i++)
		{
			VALUE_CMP(mbuf_out->m_data[i], mbuf_org->m_data[i]);
		}

		//compare payload
		for(i=0;i<mbuf_out->m_len-14;i++)
		{
			//printf("%d[%02x][%02x]\n",i,content[i+16],mbuf_out->m_data[i+14]);
			VALUE_CMP(content[i+16], mbuf_out->m_data[i+14]);
		}

		freeMbuf(mbuf_out);
		freeMbuf(mbuf_org);	
	 }

	return SUCCESS;
}

/*
@func void		| pptp_test11	| test GRE encapsulating/decapsulating.
@comm 
test GRE encapsulating and decapsulating - Compress Header
*/
int32 pptp_test11(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_org, *mbuf_out, *mbuf_comp;


	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("192.168.240.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("192.170.240.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88}};	
	ether_addr_t mac_gw_int = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8a}};
	ether_addr_t mac_gw_sv = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8c}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	rtl8651_tblDrv_routeTable_t *rt_t=NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t=NULL;	
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_4();

	/*
		Enable PPTP Compress header
	*/
	rtl8651_pptpPppCompress(TRUE);

	//printf("loopback VLAN_ID=%d WAN_VID=%d\n",tunnel.loopBackVid,tunnel.wanVid);

	rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
	if (rt_t->valid != 0 && rt_t->ifrt_flag==0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP))
		{
			//pppEntry_t=rt_t->rt_nhSession_t;
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
			pppEntry_t->initiated=1;
			if(pppEntry_t->greBuf1_==NULL)
			{	
				pppEntry_t->greBuf1_=(uint8*)rtlglue_malloc(1500);
				assert(pppEntry_t->greBuf1_);						
			}
			//make gre header
			pppEntry_t->greBuf1_[0]=0x45;
			pppEntry_t->greBuf1_[1]=0;
			pppEntry_t->greBuf1_[4]=0x12; //id
			pppEntry_t->greBuf1_[5]=0x34; //id
			pppEntry_t->greBuf1_[6]=0;
			pppEntry_t->greBuf1_[7]=0;
			pppEntry_t->greBuf1_[8]=0x80; //TTL
			pppEntry_t->greBuf1_[9]=0x2f; //GRE
			pppEntry_t->greBuf1_[12]=(ip_gw_ext>>24)&0xff;
			pppEntry_t->greBuf1_[13]=(ip_gw_ext>>16)&0xff;
			pppEntry_t->greBuf1_[14]=(ip_gw_ext>>8)&0xff;
			pppEntry_t->greBuf1_[15]=(ip_gw_ext)&0xff;
			pppEntry_t->greBuf1_[16]=(ip_rp>>24)&0xff;
			pppEntry_t->greBuf1_[17]=(ip_rp>>16)&0xff;
			pppEntry_t->greBuf1_[18]=(ip_rp>>8)&0xff;
			pppEntry_t->greBuf1_[19]=(ip_rp)&0xff;
		}
	}	

	ASSERT(pppEntry_t);
	
	/*
		NPI	->	RP : GRE encapsulating...		
	*/
	{

		uint16 port_gw_tcp;
		int i;

		/* config */
		/* NPI->RP */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
		conf.l2Flag							= 0;								/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag						= 0;
		conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
		CP_MAC(mac_gw_ext, conf.conf_smac);
		CP_MAC(mac_gw_sv, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 254;
		conf.conf_sport						= port_gw_tcp;
		conf.conf_dport						= 1000; 
		conf.conf_tcp_seq					= 0xb;
		conf.conf_tcp_ack					= 0xc;
		conf.conf_tcp_flag					= (TH_SYN);
		conf.conf_tcp_win					= 0xfffe;
		conf.conf_tcp_mss					= 1412;
		conf.payload.content				= NULL;
		conf.payload.length					= 0;
		conf.conf_vlanIdx					= (tunnel.loopBackVid)&7;
		SET_RX_PORT(conf.conf_portlist, tunnel.loopbackPort);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		mbuf_org = genMbufPkt(&conf);


		mbuf_in->m_pkthdr->ph_rxdesc=0;
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		//dumpMbufPkt(mbuf_out);

		//compare ether header
		for(i=0;i<14;i++)
		{
			VALUE_CMP(mbuf_out->m_data[i], mbuf_org->m_data[i]);
		}

		//compare ip & gre & ppp header
		for(i=0;i<37;i++)
		{
			VALUE_CMP(mbuf_out->m_data[i+14], pppEntry_t->greBuf1_[i]);
		}

		//compare payload
		for(i=0;i<mbuf_org->m_len-14;i++)
		{	
			VALUE_CMP(mbuf_out->m_data[i+51], mbuf_org->m_data[i+14]);
		}

		freeMbuf(mbuf_out);	
		freeMbuf(mbuf_org);	

	}

	/*
		RP	->	NPI : GRE decapsulating...	
	*/
	{
		int i;
		uint8 content[1500]={0x30,0x01,0x88,0x0b,0x00,0x5d,0x03,0x80,0,0,0,0x35,0x21 //GRE,PPP
		,0x45,0x00,0x00,0x28,0,0x0a,0x40,0,0xfe,0x06,0x5b,0x6b,192,170,240,2,192,170,240,1 //IP
		,0,0x50,0x04,0x1b,0,0,0,1,0,0,0,2,0x50,0x02,0xff,0x23,0xc6,0x75,0,0}; //TCP
		
		/* config */
		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
		conf.l2Flag							= 0;							/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag						= 0;
		conf.conf_Flags						= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_sv, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);	
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.protocol					= 0x2f;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;	
		conf.payload.content				= content;
		conf.payload.length					= 53;
		conf.conf_vlanIdx					= tunnel.wanVid;	
		SET_RX_PORT(conf.conf_portlist, tunnel.wanPort);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genMbufPkt(&conf);
		mbuf_org = genMbufPkt(&conf);

		
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);


		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();
		//dumpMbufPkt(mbuf_org);	
		//dumpMbufPkt(mbuf_out);	

		//compare ether header
		for(i=0;i<14;i++)
		{
			VALUE_CMP(mbuf_out->m_data[i], mbuf_org->m_data[i]);
		}

		//compare payload
		for(i=0;i<mbuf_out->m_len-14;i++)
		{
			//printf("%d[%02x][%02x]\n",i,content[i+13],mbuf_out->m_data[i+14]);
			VALUE_CMP(content[i+13], mbuf_out->m_data[i+14]);
		}

		freeMbuf(mbuf_out);
		freeMbuf(mbuf_org);	
	}
	return SUCCESS;
}


extern rtl8651_tblDrv_miiTunneling_t tunnel;
/*
@func void		| pptp_test12	| test GRE encapsulating/decapsulating.
@comm 
test GRE LCP packet in
*/
int32 pptp_test12(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_org, *mbuf_out, *mbuf_comp;


	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("192.168.240.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("192.170.240.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88}};	
	ether_addr_t mac_gw_int = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8a}};
	ether_addr_t mac_gw_sv = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8c}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	rtl8651_tblDrv_routeTable_t *rt_t=NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t=NULL;	

	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_4();

	rtl8651_setAlgStatus(0xffffffff,iplists);

	/*
		disable PPTP Compress header
	*/
	rtl8651_pptpPppCompress(FALSE);

	//printf("loopback VLAN_ID=%d WAN_VID=%d\n",tunnel.loopBackVid,tunnel.wanVid);

	rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
	if (rt_t->valid != 0 && rt_t->ifrt_flag==0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP))
		{
			//pppEntry_t=rt_t->rt_nhSession_t;
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
			pppEntry_t->initiated=1;
			if(pppEntry_t->greBuf1_==NULL)
			{	
				pppEntry_t->greBuf1_=(uint8*)rtlglue_malloc(1500);
				assert(pppEntry_t->greBuf1_);						
			}
			//make gre header
			pppEntry_t->greBuf1_[0]=0x45;
			pppEntry_t->greBuf1_[1]=0;
			pppEntry_t->greBuf1_[4]=0x12; //id
			pppEntry_t->greBuf1_[5]=0x34; //id
			pppEntry_t->greBuf1_[6]=0;
			pppEntry_t->greBuf1_[7]=0;
			pppEntry_t->greBuf1_[8]=0x80; //TTL
			pppEntry_t->greBuf1_[9]=0x2f; //GRE
			pppEntry_t->greBuf1_[12]=(ip_gw_ext>>24)&0xff;
			pppEntry_t->greBuf1_[13]=(ip_gw_ext>>16)&0xff;
			pppEntry_t->greBuf1_[14]=(ip_gw_ext>>8)&0xff;
			pppEntry_t->greBuf1_[15]=(ip_gw_ext)&0xff;
			pppEntry_t->greBuf1_[16]=(ip_rp>>24)&0xff;
			pppEntry_t->greBuf1_[17]=(ip_rp>>16)&0xff;
			pppEntry_t->greBuf1_[18]=(ip_rp>>8)&0xff;
			pppEntry_t->greBuf1_[19]=(ip_rp)&0xff;
		}
	}	

	ASSERT(pppEntry_t);

	{
		int i;
		uint8 content[1500]={0x30,0x01,0x88,0x0b,0x00,0x08,0x00,0x00,0x00,0x00,0x00,0x11,0xff,0x03,0xc0,0x21,0x05,0x02,0x00,0x04};
		
		/* config */
		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType							= _PKT_TYPE_IP;					/* tcp packet */
		conf.l2Flag							= 0;							/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag							= 0;
		conf.conf_Flags						= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_gw_sv, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);	
		conf.conf_sip							= ip_rp;
		conf.conf_dip							= ip_gw_ext;
		conf.ip.protocol						= 0x2f;
		conf.ip.id								= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset							= 0;
		conf.ip.ttl								= 255;	
		conf.payload.content					= content;
		conf.payload.length					= 20;
		conf.conf_vlanIdx						= tunnel.wanVid;	
		SET_RX_PORT(conf.conf_portlist, tunnel.wanPort);

		/* packet input */
		mbuf_in = genMbufPkt(&conf);
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_GRE_IGNORE);
		freeMbuf(mbuf_in);
	}
	return SUCCESS;
}



/*
@func void		| l2tp_test8	| test L2TP encapsulating/decapsulating.
@comm 
test L2TP encapsulating and decapsulating
*/
int32 l2tp_test8(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_org, *mbuf_out, *mbuf_comp;


	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("192.168.240.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("192.170.240.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88}};	
	ether_addr_t mac_gw_int = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8a}};
	ether_addr_t mac_gw_sv = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8c}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	rtl8651_tblDrv_routeTable_t *rt_t=NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t=NULL;	
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_5();

	//printf("loopback VLAN_ID=%d WAN_VID=%d\n",tunnel.loopBackVid,tunnel.wanVid);

	rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
	if (rt_t->valid != 0 && rt_t->ifrt_flag==0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP))
		{
			//pppEntry_t=rt_t->rt_nhSession_t;
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
			pppEntry_t->initiated=1;
			if(pppEntry_t->l2tpBuf1_==NULL)
			{	
				pppEntry_t->l2tpBuf1_=(uint8*)rtlglue_malloc(1500);
				assert(pppEntry_t->l2tpBuf1_);
			}
			//make l2tp header
			pppEntry_t->l2tpBuf1_[0]=0x45;
			pppEntry_t->l2tpBuf1_[1]=0;
			pppEntry_t->l2tpBuf1_[4]=0x12; //id
			pppEntry_t->l2tpBuf1_[5]=0x34; //id
			pppEntry_t->l2tpBuf1_[6]=0;
			pppEntry_t->l2tpBuf1_[7]=0;
			pppEntry_t->l2tpBuf1_[8]=0x80; //TTL
			pppEntry_t->l2tpBuf1_[9]=0x11; //UDP
			pppEntry_t->l2tpBuf1_[12]=(ip_gw_ext>>24)&0xff;
			pppEntry_t->l2tpBuf1_[13]=(ip_gw_ext>>16)&0xff;
			pppEntry_t->l2tpBuf1_[14]=(ip_gw_ext>>8)&0xff;
			pppEntry_t->l2tpBuf1_[15]=(ip_gw_ext)&0xff;
			pppEntry_t->l2tpBuf1_[16]=(ip_rp>>24)&0xff;
			pppEntry_t->l2tpBuf1_[17]=(ip_rp>>16)&0xff;
			pppEntry_t->l2tpBuf1_[18]=(ip_rp>>8)&0xff;
			pppEntry_t->l2tpBuf1_[19]=(ip_rp)&0xff;			
			pppEntry_t->l2tpBuf1_[20]=0x06;
			pppEntry_t->l2tpBuf1_[21]=0xa5;
			pppEntry_t->l2tpBuf1_[22]=0x06;
			pppEntry_t->l2tpBuf1_[23]=0xa5;
			// 24,25 udp_length 26,27 checksum
			pppEntry_t->l2tpBuf1_[28]=0x40;
			pppEntry_t->l2tpBuf1_[29]=0x02;
			// 30,31 l2tp_length
			pppEntry_t->l2tpBuf1_[32]=0x00;	//tunnel id		
			pppEntry_t->l2tpBuf1_[33]=0x01;	
			pppEntry_t->l2tpBuf1_[34]=0x00;	//session id		
			pppEntry_t->l2tpBuf1_[35]=0x02;	

			pppEntry_t->l2tpBuf1_[36]=0x21;
			pppEntry_t->l2tpOffset_=37;
			
			pppEntry_t->l2tpLengthBit_=1;
		}
	}	

	ASSERT(pppEntry_t);
	
	/*
		NPI	->	RP : L2TP encapsulating...		
	*/
{

	uint16 port_gw_tcp;
	int i;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;								/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_gw_sv, conf.conf_dmac);
	conf.conf_sip						= ip_gw_ext;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport						= port_gw_tcp;
	conf.conf_dport						= 1000; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1412;
	conf.payload.content				= NULL;
	conf.payload.length					= 0;
	conf.conf_vlanIdx					= (tunnel.loopBackVid)&7;
	SET_RX_PORT(conf.conf_portlist, tunnel.loopbackPort);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	mbuf_org = genMbufPkt(&conf);

	mbuf_in->m_pkthdr->ph_rxdesc=0;	
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


	//compare ether header
	for(i=0;i<14;i++)
	{
		VALUE_CMP(mbuf_out->m_data[i], mbuf_org->m_data[i]);
	}

	//compare ip & udp & l2tp & ppp header
	//dumpMbufPkt(mbuf_out);
	for(i=0;i<pppEntry_t->l2tpOffset_;i++)
	{		
		VALUE_CMP(mbuf_out->m_data[i+14], pppEntry_t->l2tpBuf1_[i]);
	}


	//compare payload
	for(i=0;i<mbuf_org->m_len-14;i++)
	{	
		VALUE_CMP(mbuf_out->m_data[i+14+pppEntry_t->l2tpOffset_], mbuf_org->m_data[i+14]);
	}

	freeMbuf(mbuf_out);	
	freeMbuf(mbuf_org);	
}

	/*
		RP	->	NPI : L2TP decapsulating...	
	*/
{
	int i;
	uint8 content[1500]={0x06,0xa5,0x06,0xa5,0,0x39,0,0,0x40,0x02,0x00,0x31,0,1,0,2,0x21 //UDP,L2TP,PPP
	,0x45,0x00,0x00,0x28,0,0x0a,0x40,0,0xfe,0x06,0x5b,0x6b,192,170,240,2,192,170,240,1 //IP
	,0,0x50,0x04,0x1b,0,0,0,1,0,0,0,2,0x50,0x02,0xff,0x23,0xc6,0x75,0,0}; //TCP
	
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_IP;					/* tcp packet */
	conf.l2Flag							= 0;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags						= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_gw_sv, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);	
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.protocol					= 0x11;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 255;	
	conf.payload.content				= content;
	conf.payload.length					= 53;
	conf.conf_vlanIdx					= tunnel.wanVid;	
	SET_RX_PORT(conf.conf_portlist, tunnel.wanPort);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	mbuf_org = genMbufPkt(&conf);

	
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
	/* check result */
	VALUE_CMP(retval, SUCCESS);


	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	//dumpMbufPkt(mbuf_org);	
	//dumpMbufPkt(mbuf_out);	

	//compare ether header
	for(i=0;i<14;i++)
	{
		VALUE_CMP(mbuf_out->m_data[i], mbuf_org->m_data[i]);
	}

	//compare payload
	for(i=0;i<mbuf_out->m_len-14;i++)
	{
		//printf("%d[%02x][%02x]\n",i,content[i+17],mbuf_out->m_data[i+14]);
		VALUE_CMP(content[i+17], mbuf_out->m_data[i+14]);
	}

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_org);	
 }

	return SUCCESS;
}



static int32 fwdeng_env_configuration_pppoe(void){
	/******************************
		vlan 2: pppoe/WAN
				IP/mask		:	10.113.1.1 / 32

		vlan 3: vlan/LAN
				IP/mask		:	192.168.1.254 / 24

	******************************/
	ether_addr_t mac = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ipaddr_t ipaddr_ext, ipaddr_int, ipaddr_next, mask;

	/* VLAN 1: subnet 1 */
	/* member port 0, pppoe, pppoeid 1000, session id 11111 */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("pppoe") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("pppoe", RTL8651_LL_PPPOE, 2) == SUCCESS);
	ASSERT(rtl8651_addPppoeSession(1000, 2) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("pppoe") == SUCCESS);
	ASSERT(rtl8651_addExternalMulticastPort(0) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 0) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.1.1"));
	mask = ntohl(inet_addr("255.255.255.255"));
	mac.octet[5] = 0x02;
	ASSERT(rtl8651_addIpIntf("pppoe", ipaddr_ext, mask) == SUCCESS);
	ASSERT(rtl8651_bindPppoeSession(ipaddr_ext, 1000) == SUCCESS);
	ASSERT(rtl8651_setPppoeSessionProperty(1000, 11111, &mac, 0x00) == SUCCESS);

	/* VLAN 2: subnet 2 */
	/* member port 1,2,3, 4 */
	ASSERT(rtl8651_addVlan(3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(3, 4) == SUCCESS);
	mac.octet[5] = 0x03;
	ASSERT(rtl8651_assignVlanMacAddress(3, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 3) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_int, mask) == SUCCESS);


	/* add default route on pppoe interface */
	ASSERT(rtl8651_addRoute(0, 0, "pppoe", 0) == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("140.115.0.0"));
	mask = ntohl(inet_addr("255.255.0.0"));
	ipaddr_next = ntohl(inet_addr("10.113.2.254"));

	/* flush all DoS setting and turn-on dos check for session 0 */
	rtl8651_dosOneSecondTimer();
	rtl8651a_setDosStatus(0, 0xffffffff);
	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging
	mbufList_Reinit();

	return SUCCESS;
}


/*******************************************************************
 *  PPPoE Passthru
 *******************************************************************/
#if 1//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU

/*
@func int32		| pkt_pppoe_passthru_PBV	| PPPoE Passthru (with hardware accelerated)
@rvalue SUCCESS	| test OK
@comm 
This test case expects the protocol-based VLAN is configured while environment setup.
Then, try to change link status to see whether VLAN member is properly set.
 */
int32 pkt_pppoe_passthru_PBV(uint32 caseNo)
{
	int i;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	ether_addr_t mac_gateway = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( TRUE );
	rtl8651_EnableIpv6Passthru( FALSE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* VLAN Table */
	rtl865x_tblAsicDrv_vlanParam_t vlan, vlanExpected;

	vlanExpected.broadcastToCpu = FALSE;
	vlanExpected.DMZFlag = FALSE;
	vlanExpected.enableRoute = TRUE;
	vlanExpected.inAclEnd = DrvTbl.vlan[2].inAclEnd;
	vlanExpected.inAclStart = DrvTbl.vlan[2].inAclStart;
	vlanExpected.internal = FALSE;
	vlanExpected.macAddr = mac_gateway;
	vlanExpected.macAddrNumber = 1;
	vlanExpected.memberPortMask = 0x1f;
	vlanExpected.mtu = 1500;
	vlanExpected.outAclEnd = DrvTbl.vlan[2].outAclEnd;
	vlanExpected.outAclStart = DrvTbl.vlan[2].outAclEnd;
	for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum;i++) vlanExpected.portState[i] = RTL8651_PORTSTA_FORWARDING;
	vlanExpected.promiscuous = FALSE;
	vlanExpected.untagPortMask = 0x1f;
	vlanExpected.valid = TRUE;
	vlanExpected.vid = 8;
	
	ASSERT( SUCCESS == rtl8651_getAsicVlan( rtl8651_gPPPoEPassthruVlanID, &vlan ) );
	ASSERT( SUCCESS == vlan_entry_cmp( &vlan, &vlanExpected ) );

	/* Protocol-based VLAN table */
	uint8 valid, vlanIdx;
	for( i = 0; i < RTL8651_PORT_NUMBER; i++ )
	{
		//printf("i=%d\n",i);
		// Link Up
		rtl8651_setAsicEthernetLinkStatus( i, TRUE );
		ASSERT( SUCCESS == rtl8651_getProtocolBasedVLAN( 
								RTL8651_PBV_RULE_PPPOE_CONTROL, 
								i, &valid, &vlanIdx ) );
		ASSERT( valid == TRUE );
		ASSERT( vlanIdx == 0 );

		// Link Down
		rtl8651_setAsicEthernetLinkStatus( i, FALSE );
		ASSERT( SUCCESS == rtl8651_getProtocolBasedVLAN( 
								RTL8651_PBV_RULE_PPPOE_CONTROL, 
								i, &valid, &vlanIdx ) );
		ASSERT( valid == FALSE );

	}

	return SUCCESS;
}

#else//CONFIG_RTL865XB
#endif//CONFIG_RTL865XB

/*
@func int32		| pkt_pppoe_passthru	| PPPoE Passthru
@rvalue SUCCESS	| test OK
@comm 
Control Message: PADI, PADO, PADR, PADS, PADT
Data Message: 10000 packets from client to server, and 10000 packets from server to client.
 */
int32 pkt_pppoe_passthru(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 i;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( TRUE );
	rtl8651_EnableIpv6Passthru( FALSE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// force to add ACL rule to trap 0x8863 to CPU.
	for_pppoe_passthru_testcode_rtl8651_arrangeAllACL();

#ifdef CONFIG_RTL865XB
#else//CONFIG_RTL865XB
	int32 b8863added = FALSE;
	for( i = 0; i < RTL8651_ACLTBL_SIZE; i++ )
	{
		_rtl8651_tblDrvAclRule_t rule;
		if ( rtl8651_getAsicAclRule( i, &rule ) == SUCCESS )
		{
			if ( rule.un_ty.MAC._typeLen == 0x8863 && rule.un_ty.MAC._typeLenMask == 0xffff &&
			     !memcmp( &rule.un_ty.MAC._dstMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._dstMacMask,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMacMask,  &mac_zero, sizeof(mac_zero)) )
			{
				b8863added = TRUE;
			}
		}
	}
	if ( rtl8651_drvDropUnknownPppoePADT ) ASSERT( b8863added == TRUE );
#endif//CONFIG_RTL865XB

	// PPPoE PADI
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x09; /* PADI */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );
		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x09; /* PADI */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// PPPoE PADO
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}

	
	// PPPoE PADR
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x19; /* PADR */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x19; /* PADR */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	
	// PPPoE PADS
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	
	}
	

	// PPPoE 0x8864 (Client to Server)
	for( i = 0; i < 10000; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// PPPoE 0x8864 (Server to Client)
	for( i = 0; i < 10000; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 3 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	

	// PPPoE PADT (Server to Client)
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	

	/* Since PPPoE passthru does not monitor 0x8863 control message,
	 *   the following tests should not do.
	 */
#if 0	
	// PPPoE 0x8864 (Client to Server) -- should be left for upper stack!
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0); /* left for upper stack! */
		freeMbuf(mbuf_in);
	}
	

	// PPPoE 0x8864 (Server to Client) -- should be left for upper stack!
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0); /* left for upper stack! */
		freeMbuf(mbuf_in);
	}
#endif//0

	return SUCCESS;
}


/*
@func int32		| pkt_pppoe_passthru	| PPPoE Passthru
@rvalue SUCCESS	| test OK
@comm 
Control Message: PADI, PADO, PADR, PADS, PADT
Data Message: 10000 packets from client to server, and 10000 packets from server to client.
 */
int32 pkt_pppoe_passthru_without_vlan1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 i;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( TRUE );
	rtl8651_EnableIpv6Passthru( FALSE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* Remove default VLAN: vlan1 */
	retval = _rtl8651_delVlan( 1 );
	ASSERT( retval==SUCCESS );

	// force to add ACL rule to trap 0x8863 to CPU.
	for_pppoe_passthru_testcode_rtl8651_arrangeAllACL();

#ifdef CONFIG_RTL865XB
#else//CONFIG_RTL865XB
	int32 b8863added = FALSE;
	for( i = 0; i < RTL8651_ACLTBL_SIZE; i++ )
	{
		_rtl8651_tblDrvAclRule_t rule;
		if ( rtl8651_getAsicAclRule( i, &rule ) == SUCCESS )
		{
			if ( rule.un_ty.MAC._typeLen == 0x8863 && rule.un_ty.MAC._typeLenMask == 0xffff &&
			     !memcmp( &rule.un_ty.MAC._dstMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._dstMacMask,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMacMask,  &mac_zero, sizeof(mac_zero)) )
			{
				b8863added = TRUE;
			}
		}
	}
	if ( rtl8651_drvDropUnknownPppoePADT ) ASSERT( b8863added == TRUE );
#endif//CONFIG_RTL865XB

	// PPPoE PADI
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x09; /* PADI */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );
		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x09; /* PADI */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 2;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// PPPoE PADO
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 3;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}

	
	// PPPoE PADR
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x19; /* PADR */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x19; /* PADR */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 2;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	
	// PPPoE PADS
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 3;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	
	}
	

	// PPPoE 0x8864 (Client to Server)
	for( i = 0; i < 10000; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 2;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// PPPoE 0x8864 (Server to Client)
	for( i = 0; i < 10000; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 3 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 3;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	

	// PPPoE PADT (Server to Client)
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 3;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	

	/* Since PPPoE passthru does not monitor 0x8863 control message,
	 *   the following tests should not do.
	 */
#if 0	
	// PPPoE 0x8864 (Client to Server) -- should be left for upper stack!
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0); /* left for upper stack! */
		freeMbuf(mbuf_in);
	}
	

	// PPPoE 0x8864 (Server to Client) -- should be left for upper stack!
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0); /* left for upper stack! */
		freeMbuf(mbuf_in);
	}
#endif//0

	return SUCCESS;
}


/*
@func int32		| pkt_pppoe_passthru_drop_unknown	| PPPoE Passthru
@rvalue SUCCESS	| test OK
@comm 
Control Message: PADI, PADO, PADR, PADS, PADT
Data Message: 1 packets from client to server, and 1 packets from server to client.
Control Message with unknown DMAC address from WAN: PADT
 */
int32 pkt_pppoe_passthru_drop_unknown(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 i;
	ether_addr_t unknown = {0x77,0x88,0x88,0x88,0x88,0x88};
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( TRUE );
	rtl8651_EnableIpv6Passthru( FALSE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/**************************************************
	 *   Drop Unknown                                 *
	 **************************************************/
	rtl8651_enableDropUnknownPppoePADT( TRUE );

	// force to add ACL rule to trap 0x8863 to CPU.
	for_pppoe_passthru_testcode_rtl8651_arrangeAllACL();

#ifdef CONFIG_RTL865XB
#else//CONFIG_RTL865XB
	int32 b8863added = FALSE;
	for( i = 0; i < RTL8651_ACLTBL_SIZE; i++ )
	{
		_rtl8651_tblDrvAclRule_t rule;
		if ( rtl8651_getAsicAclRule( i, &rule ) == SUCCESS )
		{
			if ( rule.un_ty.MAC._typeLen == 0x8863 && rule.un_ty.MAC._typeLenMask == 0xffff &&
			     !memcmp( &rule.un_ty.MAC._dstMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._dstMacMask,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMacMask,  &mac_zero, sizeof(mac_zero)) )
			{
				b8863added = TRUE;
			}
		}
	}
	ASSERT( b8863added == TRUE );
#endif//CONFIG_RTL865XB

	// PPPoE PADI
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x09; /* PADI */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );
		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x09; /* PADI */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// PPPoE PADO
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}

	
	// PPPoE PADR
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x19; /* PADR */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x19; /* PADR */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	
	// PPPoE PADS
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	
	}
	

	// PPPoE 0x8864 (Client to Server)
	for( i = 0; i < 1; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// PPPoE 0x8864 (Server to Client)
	for( i = 0; i < 1; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 3 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	

	// PPPoE PADT (Server to Client)
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 1 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		ADD_TX_PORT(conf.conf_portlist, 5);
		ADD_TX_PORT(conf.conf_portlist, 6);
		ADD_TX_PORT(conf.conf_portlist, 7);
		ADD_TX_PORT(conf.conf_portlist, 8);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#if PPPOE_PASSTHRU_NEW_MODEL//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 1;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	
	// PPPoE PADT (Server to unknown DMAC)
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (unknown, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result (should be trapped to PS and will be dropped. */
		VALUE_CMP(retval, FWDENG_PPPOE8863);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	rtl8651_enableDropUnknownPppoePADT( FALSE );
	return SUCCESS;
}


/*
@func int32		| pkt_pppoe_passthru_vlan_index	| PPPoE Passthru
@rvalue SUCCESS	| test OK
@comm 
DMAC is gateway MAC, the packet will be send to Protocol Stack, 
and VLAN index is changed to WAN index (eg. eth0).
Control Message: PADO
Data Message: 1 packets from server to GW.
 */
int32 pkt_pppoe_passthru_vlan_index(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 i;
	ether_addr_t unknown = {0x77,0x88,0x88,0x88,0x88,0x88};
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_gw = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( TRUE );
	rtl8651_EnableIpv6Passthru( FALSE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// force to add ACL rule to trap 0x8863 to CPU.
	for_pppoe_passthru_testcode_rtl8651_arrangeAllACL();

#ifdef CONFIG_RTL865XB
#else//CONFIG_RTL865XB
	int32 b8863added = FALSE;
	for( i = 0; i < RTL8651_ACLTBL_SIZE; i++ )
	{
		_rtl8651_tblDrvAclRule_t rule;
		if ( rtl8651_getAsicAclRule( i, &rule ) == SUCCESS )
		{
			if ( rule.un_ty.MAC._typeLen == 0x8863 && rule.un_ty.MAC._typeLenMask == 0xffff &&
			     !memcmp( &rule.un_ty.MAC._dstMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._dstMacMask,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMacMask,  &mac_zero, sizeof(mac_zero)) )
			{
				b8863added = TRUE;
			}
		}
	}
	if ( rtl8651_drvDropUnknownPppoePADT ) ASSERT( b8863added == TRUE );
#endif//CONFIG_RTL865XB

	// PPPoE PADO
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x07; /* PADO */
		pkt_content[2]				= 0x00; /* seesio id */
		pkt_content[3]				= 0x00;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8863;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_gw, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result (should be trapped to PS and will be dropped. */
		VALUE_CMP(retval, FWDENG_PPPOE8863);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(mbuf_in->m_pkthdr->ph_vlanIdx, 2);
		freeMbuf(mbuf_in);
	}

	
	// PPPoE 0x8864 (Server to GW)
	for( i = 0; i < 1; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= L2_PPPoE;
		conf.pppoe.type						= 0x8864;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_gw, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result (should be trapped to PS and will be dropped. */
		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0);
		VALUE_CMP(mbuf_in->m_pkthdr->ph_vlanIdx, 2);
		freeMbuf(mbuf_in);
	}
	return SUCCESS;
}




/*
@func int32		| naptpkt_mac_filtering_test1	| MAC Filtering.
@comm
Generate TCP/UDP/ICMP packets from LAN to WAN. If packets match the MAC Filtering rule, packets will be dropped.
The external IP is used as NAPT.
 */
int32 pkt_mac_filtering_test1(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

 	//add MAC Filter
 	ASSERT(rtl8651_enableMacAccessControl(TRUE) == SUCCESS);
 	ASSERT(rtl8651_addMacAccessControl(&mac_npi, &mac_bcast, FALSE) == SUCCESS);

	{	// trap FWDENG_MACBLOCK up to protocol stack
		int32 flag = FALSE;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_MACBLOCK,&flag) == SUCCESS);
	}

	{
		/*=======================================================
		  * Test: TCP packet
		  *=======================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);
	}


	{
		/*=======================================================
		  * Test: UDP packet
		  *=======================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_rp, 255, 0, 0,
							port_npi, port_rp, 0, 0, 0, 0, NULL, 0);
		
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);		
	}
	
	{
		/*=======================================================
		  * Test: ICMP packet
		  *=======================================================*/
		mbuf_in = confVlanHSB( &conf, NULL,
						_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);		
	}
	return SUCCESS;
}


/*
@func int32		| naptpkt_mac_filtering_test12	| MAC Filtering.
@comm
Generate TCP/UDP/ICMP packets from LAN to LAN. The MAC Filtering mechanism will not apply such packets.
 */
int32 pkt_mac_filtering_test2(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x03, 0x04, 0x05, 0x11, 0xff}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	ether_addr_t mac_gw_int2 = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x04 } };
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.2.1"));
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

 	//add MAC Filter
 	ASSERT(rtl8651_enableMacAccessControl(TRUE) == SUCCESS);
 	ASSERT(rtl8651_addMacAccessControl(&mac_npi, &mac_bcast, FALSE) == SUCCESS);

	{	// trap FWDENG_MACBLOCK up to protocol stack
		int32 flag = FALSE;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_MACBLOCK,&flag) == SUCCESS);
	}

	/* add arp */
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 0x01) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi2, &mac_npi2, "lan2", 0x04) == SUCCESS);

	{
		/*=======================================================
		  * Test: TCP packet
		  *=======================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_npi2, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);

		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
						_PKT_TYPE_TCP, tx_list, 3, 0,
						mac_gw_int2, mac_npi2, ip_npi, ip_npi2, 254, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	{
		/*=======================================================
		  * Test: UDP packet
		  *=======================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_npi2, 255, 0, 0,
							port_npi, port_rp, 0, 1460, 0, 0, NULL, 0);
		
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);

		uint16 tx_list[2] = {4, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_UDP, tx_list, 3, 0,	mac_gw_int2, mac_npi2, 
							ip_npi, ip_npi2, 254, 0, 0,
							port_npi, port_rp, 0, 1460, 0, 0, NULL, 0);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	{
		/*=======================================================
		  * Test: ICMP packet
		  *=======================================================*/
		mbuf_in = confVlanHSB( &conf, NULL,
							_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_npi2, 255, 0, 0,
							0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);

		uint16 tx_list[2] = {4, 0xffff};	
		mbuf_comp = confVlanHSA(&conf, NULL,
							_PKT_TYPE_ICMP, tx_list, 3, 0, mac_gw_int2, mac_npi2,
							ip_npi, ip_npi2, 254, 0, 0,
							0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	return SUCCESS;
}



/*
@func int32		| naptpkt_mac_filtering_test3	| MAC Filtering.
@comm
Generate TCP/UDP/ICMP packets from LAN to WAN. If packets match the MAC Filtering rule, packets will be dropped.
The external IP is used as NAT.
 */
int32 pkt_mac_filtering_test3(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 1000;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNatMapping(ip_gw_ext, ip_npi) == SUCCESS);
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);

 	//add MAC Filter
 	ASSERT(rtl8651_enableMacAccessControl(TRUE) == SUCCESS);
 	ASSERT(rtl8651_addMacAccessControl(&mac_npi, &mac_bcast, FALSE) == SUCCESS);

	{	// trap FWDENG_MACBLOCK up to protocol stack
		int32 flag = FALSE;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_MACBLOCK,&flag) == SUCCESS);
	}

	{
		/*=======================================================
		  * Test: TCP packet
		  *=======================================================*/
		/* NPI -> RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);


		/* RP -> NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_gw, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);

		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
						_PKT_TYPE_TCP, tx_list, 2, 0,
						mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
						port_rp, port_gw, (TH_SYN), 1452, 0, 0, NULL, 0);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		
	}

	{
		/*=======================================================
		  * Test: UDP packet
		  *=======================================================*/	
		/* NPI -> RP */
		mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_rp, 255, 0, 0,
							port_npi, port_rp, 0, 0, 0, 0, NULL, 0);
		
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);		

		/* RP -> NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_gw, 0, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);

		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(&conf, NULL,
						_PKT_TYPE_UDP, tx_list, 2, 0,
						mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
						port_rp, port_gw, 0, 1460, 0, 0, NULL, 0);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		
	}
	
	{
		/*=======================================================
		  * Test: ICMP packet
		  *=======================================================*/
		/* NPI -> RP */
		mbuf_in = confVlanHSB( &conf, NULL,
						_PKT_TYPE_ICMP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);		

		/* RP -> NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_ICMP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
						0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);

		uint16 tx_list[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA(NULL, NULL,
						_PKT_TYPE_ICMP, tx_list, 2, 0,
						mac_gw_int, mac_npi, ip_rp, ip_npi, 122, 0, 0,
						0, 0, 0, 0, ICMP_ECHO, 0, NULL, 0);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		
	}
	return SUCCESS;
}




/*
@func int32		| naptpkt_mac_filtering_test4	| MAC Filtering.
@comm
Generate TCP/UDP/ICMP packets from LAN to WAN. If packets match the MAC Filtering rule, packets will be dropped.
Test for Server Port Case.
*/
int32 pkt_mac_filtering_test4(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	fwdeng_function_configuration1();

 	//add MAC Filter
 	ASSERT(rtl8651_enableMacAccessControl(TRUE) == SUCCESS);
 	ASSERT(rtl8651_addMacAccessControl(&mac_npi, &mac_bcast, FALSE) == SUCCESS);

	{	// trap FWDENG_MACBLOCK up to protocol stack
		int32 flag = FALSE;
		ASSERT(rtl8651_fwdEngineDropPktCase(FWDENG_MACBLOCK,&flag) == SUCCESS);
	}
	port_rp = 9000;
	port_gw = 1000;
	port_npi = 2000;
	
	/*
	  * For Server Port case, the first inbound packet which matches the server port and the server port's internal host's
	  * MAC address matches MAC filtering will be dropped.
	  */

	{
		/*=======================================================
		  * Test: TCP packet
		  *=======================================================*/
		ASSERT(rtl8651_addNaptServerPortMapping(TRUE, ip_gw_ext, 1000, ip_npi, 2000) == SUCCESS);
		/* RP -> NPI */
		mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 0, ip_rp, ip_gw_ext, 123, 0, 0,
						port_rp, port_gw, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);


		/* NPI -> RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);
		ASSERT(rtl8651_delNaptServerPortMapping(TRUE, ip_gw_ext, 1000, ip_npi, 2000) == SUCCESS);
	}


	{
		/*=======================================================
		  * Test: UDP packet
		  *=======================================================*/
		/* RP -> NPI */
		ASSERT(rtl8651_addNaptServerPortMapping(FALSE, ip_gw_ext, 1000, ip_npi, 2000) == SUCCESS);
		mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext,
							ip_rp, ip_gw_ext, 255, 0, 0,
							port_rp, port_gw, 0, 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);	

		/* NPI -> RP */
		mbuf_in = confVlanHSB(&conf, NULL,
							_PKT_TYPE_UDP, 1, 2, 0, mac_npi, mac_gw_int,
							ip_npi, ip_rp, 255, 0, 0,
							port_npi, port_rp, 0, 0, 0, 0, NULL, 0);
		
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, FWDENG_MACBLOCK);
		freeMbuf(mbuf_in);	
		ASSERT(rtl8651_delNaptServerPortMapping(FALSE, ip_gw_ext, 1000, ip_npi, 2000) == SUCCESS);
	}
	return SUCCESS;
}


/*******************************************************************
 *  Protocol-Based NAT
 *******************************************************************/
/*
@func int32		| pkt_protocol_based_nat	| protocol-based NAT
@rvalue SUCCESS	| test OK
@comm 
This function will configure protocol based NAT, and then send packet to test.
 */
int32 pkt_protocol_based_nat(uint32 caseNo)
{
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 i;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_client = ntohl(inet_addr("192.168.1.1"));
	ether_addr_t mac_npe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_xxx = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_npi = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// protocol-based NAT
	retval = rtl8651_addProtocolBasedNAT( IPPROTO_HELLO, ip_gw_ext, ip_client );
	ASSERT( retval == SUCCESS );
	rtl8651_EnableProtocolBasedNAT( TRUE );

	// outbound packet
	for( i = 0; i < 10000; i++ )
	{
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag							= 0;
		conf.pppoe.type						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_npi, conf.conf_dmac);
		conf.conf_sip						= ip_client;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.ip.protocol					= IPPROTO_HELLO;
		conf.icmp.type						= 0;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 3);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		//dumpMbufPkt(mbuf_in);
		mbuf_in->m_pkthdr->ph_flags |= CSUM_IP_OK;
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag							= 0;
		conf.pppoe.type						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_npe, conf.conf_smac);
		CP_MAC (mac_xxx, conf.conf_dmac);
		conf.conf_sip						= ip_gw_ext;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 254;
		conf.ip.protocol					= IPPROTO_HELLO;
		conf.icmp.type						= 0;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= PKTHDR_PPPOE_AUTOADD | CSUM_IP;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// add ARP for client
	retval = rtl8651_addArp( ip_client, &mac_pppoe_client, "lan", 3 );
	ASSERT( retval == SUCCESS );

	// inbound packet
	for( i = 0; i < 10000; i++ )
	{
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag							= 0;
		conf.pppoe.type						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_npe, conf.conf_dmac);
		CP_MAC (mac_xxx, conf.conf_smac);
		conf.conf_dip						= ip_gw_ext;
		conf.conf_sip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.ip.protocol					= IPPROTO_HELLO;
		conf.icmp.type						= 0;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 1;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		//dumpMbufPkt(mbuf_in);
		mbuf_in->m_pkthdr->ph_flags |= CSUM_IP_OK;
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_IP;
		conf.l2Flag							= 0;
		conf.pppoe.type						= 0;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_npi, conf.conf_smac);
		conf.conf_dip						= ip_client;
		conf.conf_sip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 254;
		conf.ip.protocol					= IPPROTO_HELLO;
		conf.icmp.type						= 0;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		ADD_TX_PORT(conf.conf_portlist, 3);

		mbuf_comp = genMbufPkt(&conf);
		mbuf_comp->m_pkthdr->ph_flags |= CSUM_IP;

		
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}

	
	return SUCCESS;
}



/*******************************************************************
 *  IPv6 Passthru
 *******************************************************************/
#if 1//CONFIG_RTL865XB_EXP_IPV6_PASSTHRU

/*
@func int32		| pkt_ipv6_passthru_PBV	| IPv6 Passthru (with hardware accelerated)
@rvalue SUCCESS	| test OK
@comm 
This test case expects the protocol-based VLAN is configured while environment setup.
Then, try to change link status to see whether VLAN member is properly set.
 */
int32 pkt_ipv6_passthru_PBV(uint32 caseNo)
{
	int i,port;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	ether_addr_t mac_gateway = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( FALSE );
	rtl8651_EnableIpv6Passthru( TRUE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	/* VLAN Table */
	rtl865x_tblAsicDrv_vlanParam_t vlan, vlanExpected;

	vlanExpected.broadcastToCpu = FALSE;
	vlanExpected.DMZFlag = FALSE;
	vlanExpected.enableRoute = FALSE;
	vlanExpected.inAclEnd = RTL8651_ACLTBL_PERMIT_ALL;
	vlanExpected.inAclStart = RTL8651_ACLTBL_PERMIT_ALL;
	vlanExpected.internal = FALSE;
	vlanExpected.macAddr = mac_gateway;
	vlanExpected.macAddrNumber = 1;
	vlanExpected.memberPortMask = 0x1f;
	vlanExpected.mtu = 1500;
	vlanExpected.outAclEnd = RTL8651_ACLTBL_PERMIT_ALL;
	vlanExpected.outAclStart = RTL8651_ACLTBL_PERMIT_ALL;
	for(i=0;i<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum;i++) vlanExpected.portState[i] = RTL8651_PORTSTA_FORWARDING;
	vlanExpected.promiscuous = FALSE;
	vlanExpected.untagPortMask = 0x1f;
	vlanExpected.valid = TRUE;
	vlanExpected.vid = 8;
	
	ASSERT( SUCCESS == rtl8651_getAsicVlan( rtl8651_gIPv6PassthruVlanID, &vlan ) );
	ASSERT( SUCCESS == vlan_entry_cmp( &vlan, &vlanExpected ) );

	/* Protocol-based VLAN table */
	uint8 valid, vlanIdx;
	for( i = 0; i < RTL8651_PORT_NUMBER; i++ )
	{
		//printf("i=%d\n",i);
		// Link Up
		rtl8651_setAsicEthernetLinkStatus( i, TRUE );
		ASSERT( SUCCESS == rtl8651_getProtocolBasedVLAN( 
								rtl8651_pbv_ipv6passthru, 
								i, &valid, &vlanIdx ) );
		ASSERT( valid == TRUE );
		ASSERT( vlanIdx == 0 );

		// Link Down
		rtl8651_setAsicEthernetLinkStatus( i, FALSE );
		ASSERT( SUCCESS == rtl8651_getProtocolBasedVLAN( 
								rtl8651_pbv_ipv6passthru, 
								i, &valid, &vlanIdx ) );
		ASSERT( valid == FALSE );

	}

	return SUCCESS;
}

#else//CONFIG_RTL865XB
#endif//CONFIG_RTL865XB

/*
@func int32		| pkt_ipv6_passthru	| IPv6 Passthru
@rvalue SUCCESS	| test OK
@comm 
10000 packets from internal to external, and 10000 packets from external to internal.
 */
int32 pkt_ipv6_passthru(uint32 caseNo){
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 i, port;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_zero = {{0x00, 0x00, 0x00, 0x00, 0x00, 0x00}};
	ether_addr_t mac_pppoe_client = {{0x00, 0x11, 0x22, 0x33, 0x44, 0x00}};
	ether_addr_t mac_pppoe_server = {{0x00, 0xaa, 0xbb, 0xcc, 0xdd, 0x00}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	rtl8651_EnablePppoePassthru( FALSE );
	rtl8651_EnableIpv6Passthru( TRUE );
	fwdeng_env_configuration_pppoe();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	// delete VLAN 1
	for(port=0; port<RTL8651_PORT_NUMBER+rtl8651_totalExtPortNum; port++) {
		retval = rtl8651_delVlanPortMember(1, port);	assert(retval == SUCCESS);
		//retval = rtl8651_setPvid(port, 1);				assert(retval == SUCCESS);
	}
	retval = _rtl8651_delVlan( 1 );

	// force to add ACL rule to trap 0x86DD to CPU.
	for_ipv6_passthru_testcode_rtl8651_arrangeAllACL();

#if 1//CONFIG_RTL865XB_EXP_IPV6_PASSTHRU
#else //CONFIG_RTL865XB
	int32 b86DDadded = FALSE;
	for( i = 0; i < RTL8651_ACLTBL_SIZE; i++ )
	{
		_rtl8651_tblDrvAclRule_t rule;
		if ( rtl8651_getAsicAclRule( i, &rule ) == SUCCESS )
		{
			if ( rule.un_ty.MAC._typeLen == 0x86DD && rule.un_ty.MAC._typeLenMask == 0xffff &&
			     !memcmp( &rule.un_ty.MAC._dstMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._dstMacMask,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMac,  &mac_zero, sizeof(mac_zero)) &&
			     !memcmp( &rule.un_ty.MAC._srcMacMask,  &mac_zero, sizeof(mac_zero)) )
			{
				b86DDadded = TRUE;
			}
		}
	}
	ASSERT( b86DDadded == TRUE );
#endif//CONFIG_RTL865XB

	// IPv6 0x86DD (Internal to External)
	for( i = 0; i < 10000; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= 0x0000;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_ethtype					= 0x86DD;
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 3;
		SET_RX_PORT(conf.conf_portlist, 2);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 2 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= 0x0000;
		conf.pppoe.type						= 0x0000;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_smac);
		CP_MAC (mac_pppoe_server, conf.conf_dmac);
		conf.conf_ethtype					= 0x86DD;
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;

#if 1//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
		ADD_TX_PORT(conf.conf_portlist, 0);
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		//ADD_TX_PORT(conf.conf_portlist, 5);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 2;
		ADD_TX_PORT(conf.conf_portlist, 0);
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
	}


	// IPv6 0x86DD (External to Internal)
	for( i = 0; i < 10000; i++ ) 
	{
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* config */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= 0x0000;
		conf.pppoe.type						= 0x0000;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_ethtype					= 0x86DD;
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		conf.conf_vlanIdx					= 2;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();	// re-init mbufList
		mbuf_in = genMbufPkt(&conf);
		memcpy(&mbuf_in->m_data[14], conf.payload.content, 6 );

		//dumpMbufPkt(mbuf_in);
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1); /* VLAN 3 */

		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x00; /* must be 0x00 */
		pkt_content[2]				= 0x77; /* seesio id */
		pkt_content[3]				= 0x88;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[5]				= 0x22;
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		conf.l2Flag							= 0x0000;
		conf.pppoe.type						= 0x0000;
		conf.ErrFlag						= 0;
		conf.conf_Flags						= 0;
		CP_MAC (mac_pppoe_client, conf.conf_dmac);
		CP_MAC (mac_pppoe_server, conf.conf_smac);
		conf.conf_ethtype					= 0x86DD;
		conf.conf_sip						= ip_npi;
		conf.conf_dip						= ip_rp;
		conf.ip.id							= 0xa;
		conf.ip.mf							= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type						= ICMP_ECHO;
		conf.icmp.code						= 0;
		conf.icmp.id						= 0;
		conf.icmp.seq						= 0;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 46;
		ADD_TX_PORT(conf.conf_portlist, 1);
		ADD_TX_PORT(conf.conf_portlist, 2);
		ADD_TX_PORT(conf.conf_portlist, 3);
		ADD_TX_PORT(conf.conf_portlist, 4);

#if 1//CONFIG_RTL865XB_EXP_PPPOE_PASSTHRU
		// In 5xB, PPPoE Passthru VLAN will be created.
		// Therefore, the packet is forwarded to VLAN 8.
		conf.conf_vlanIdx					= 0;
#if PPPOE_PASSTHRU_NEW_MODEL == 1
#else/*PPPOE_PASSTHRU_NEW_MODEL == 1*/
		//ADD_TX_PORT(conf.conf_portlist, 5);
#endif/*PPPOE_PASSTHRU_NEW_MODEL == 1*/

#else//CONFIG_RTL865XB
		// In 50/51, the packet is forwarded to VLAN 2.
		conf.conf_vlanIdx					= 3;
#endif//CONFIG_RTL865XB

		mbuf_comp = genMbufPkt(&conf);
		memcpy(&mbuf_comp->m_data[14], conf.payload.content, 6 );
		mbuf_comp->m_pkthdr->ph_pppeTagged = FALSE;
		MBUF_CMPandFREE(mbuf_comp, mbufList_dequeue());
		
	}
	return SUCCESS;
}


/*
@func int32		| pkt_pppoeNotExistedSessionTermination_test	| Testing whether PPPoE Not Existed Session Termination can operation successfully
@rvalue SUCCESS	| operation as expected
@rvalue FAILED	| operation FAILED
@comm 
	The expected operation is either PPPoE session found or PADR make session ID exist, PPPoE data channel (0x8864) becomes valid. Otherwise,
when pppoeNotExistedSessionTermination is enabled, forwarding engine will generate corresponding PADT to terminate this session. This feature
is provided the gateway with shorter connection waiting time when ISP constrains each client can create PPPoE session once at any time.
1. Received LCP will trigger PADT packet
2. Receive PADR packet
3. Received LCP packet can send to protocol stack
4. Configure session ID into Rome driver
5. Received LCP packet can send to protocol stack
6. Receive PADT packet
7. Received LCP packet can send to protocol stack
8. Remove session ID from Rome driver
9. Received LCP packet will trigger PADT

 */

int32 pkt_pppoeNotExistedSessionTermination_test2(uint32 caseNo) {
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 nCount;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};

	START_TEST_CASE();
	rtl8651_fwdEnginePppoeNotExistedSessionTermination(TRUE);
	/* VLAN 1: subnet 1 */
	/* member port 0, pppoe, pppoeid 1000 */
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac_gw_ext, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("pppoe") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("pppoe", RTL8651_LL_PPPOE, 1) == SUCCESS);
	ASSERT(rtl8651_addPppoeSession(1000, 1) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("pppoe") == SUCCESS);

	//Received session ID 0x1122 trigger PADT for session ID 0x1122
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1122,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x11; /* seesio id */
		pkt_content[3]				= 0x22;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	//Received session ID 0x1234 trigger PADT for session ID 0x1234
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1234,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x12; /* seesio id */
		pkt_content[3]				= 0x34;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	//Received session ID 0x1122 PADS
	{
		/* config */
		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0x65; /* PADS */
		pkt_content[2]				= 0x11; /* seesio id */
		pkt_content[3]				= 0x22;
		pkt_content[4]				= 0x00; /* len */
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_gw_ext, conf.conf_dmac);
		CP_MAC (mac_pppoe, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		SET_RX_PORT(conf.conf_portlist, 0);
		mbuf_in = genMbufPkt(&conf);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_PPPOE8863);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	//Received session ID 0x1122 LCP and send to protocol stack
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1122,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	//Received session ID 0x1234 trigger PADT for session ID 0x1234
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1234,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x12; /* seesio id */
		pkt_content[3]				= 0x34;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}
	
	ASSERT(rtl8651_setPppoeSessionProperty(1000, 0x1122, &mac_pppoe, 0x00) == SUCCESS);

	//Received session ID 0x1122 LCP and send to protocol stack
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1122,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	//Received session ID 0x1234 trigger PADT for session ID 0x1234
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1234,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x12; /* seesio id */
		pkt_content[3]				= 0x34;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	//Received session ID 0x1122 PADT
	{
		/* config */
		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x11; /* seesio id */
		pkt_content[3]				= 0x22;
		pkt_content[4]				= 0x00; /* len */
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_gw_ext, conf.conf_dmac);
		CP_MAC (mac_pppoe, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		SET_RX_PORT(conf.conf_portlist, 0);
		mbuf_in = genMbufPkt(&conf);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_PPPOE8863);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	//Received session ID 0x1122 LCP and send to protocol stack
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1122,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, FWDENG_PPPOE8864);
		VALUE_CMP(mbufList_nmbuf(), 0);
		freeMbuf(mbuf_in);
	}

	//Received session ID 0x1234 trigger PADT for session ID 0x1234
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1234,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x12; /* seesio id */
		pkt_content[3]				= 0x34;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	ASSERT(rtl8651_resetPppoeSessionProperty(1000) == SUCCESS);

	//Received session ID 0x1122 trigger PADT for session ID 0x1122
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1122,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x11; /* seesio id */
		pkt_content[3]				= 0x22;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	//Received session ID 0x1234 trigger PADT for session ID 0x1234
	{
		/* config */
		pkt_content[0]				= 0xc0; 
		pkt_content[1]				= 0x21; 
		mbuf_in = confPppoeHSB(&conf, NULL, _PKT_TYPE_ETHER, 0, 1, 0, mac_pppoe, mac_gw_ext, 0x1234,
						0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, pkt_content, 2);

		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		VALUE_CMP(retval, SUCCESS);
		memset(pkt_content, 0, 60);
		pkt_content[0]				= 0x11; /* ver */
		pkt_content[1]				= 0xa7; /* PADT */
		pkt_content[2]				= 0x12; /* seesio id */
		pkt_content[3]				= 0x34;
		pkt_content[4]				= 0x00; /* len */
		pkt_content[8]				= 0xc0; /* LCP code*/
		pkt_content[9]				= 0x21; /* LCP code*/
		
		/* check output packet */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ETHER;
		CP_MAC (mac_pppoe, conf.conf_dmac);
		CP_MAC (mac_gw_ext, conf.conf_smac);
		conf.conf_ethtype						= 0x8863;
		conf.payload.content				= pkt_content;
		conf.payload.length					= 38;
		conf.conf_vlanIdx					= 1;
		ADD_TX_PORT(conf.conf_portlist, 0);

		mbuf_comp = genMbufPkt(&conf);
		VALUE_CMP(mbufList_nmbuf(), 1);
		MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	}

	return SUCCESS;
}

/*
@func int32		| pkt_serverPort_syn_ack_drop	| Non-exist tcp server port flow SYN-ACK Drop test
@rvalue SUCCESS	| test OK
@comm 
For non-existing TCP napt flow (including server port), if (SYN+ACK) packet sent from internal host,
we forbid it.
 */
int32 pkt_serverPort_syn_ack_drop(uint32 caseNo){

	/**********************************************
		2 lan

		TCP
		NPI1	->	NPI2		ALL combinations of flags, including DOS attack cases

		UDP
		NPI1	->	NPI2

		ICMP
		NPI1	->	NPI2		ALL Types

		IP packet
	**********************************************/
	int8 pkt_content[1460];
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t wan_ip = ntohl(inet_addr("10.113.2.1"));
	ipaddr_t npe_ip = ntohl(inet_addr("1.1.1.1"));
	uint16 port_npi = 0x1234;
	uint16 port_npi2 = 0x2345;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ether_addr_t mac_npi2 = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_gw_int2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x04}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	fwdeng_function_configuration1();
	ASSERT(rtl8651_addNaptMapping(wan_ip) == SUCCESS);
	ASSERT(rtl8651_addNaptServerPortMapping(TRUE, wan_ip, 10000, ip_npi, 20000) == SUCCESS);

		
	/*(1) LAN: SYN+ACK paket: should be dropped */
	mbuf_in = confVlanHSB(&conf, NULL,
		_PKT_TYPE_TCP, 1, 2, 0, 
		mac_npi, mac_gw_int, ip_npi, npe_ip, 123, 0, 0,
		20000, 12345, (TH_SYN|TH_ACK), 1460, 0, 0, 0, 0);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TCP_NAPT_OUT_NOTFOUND);
	freeMbuf(mbuf_in);
	
	
	return SUCCESS;
}

/*
@func int32		| pkt_mtu_fragment_static_ip	| packet fragment test for static ip wan type
@rvalue SUCCESS	| test OK
@comm 
test packet fragment functions according to different MTU setting for static ip wan type
 */
int32 pkt_mtu_fragment_static_ip(uint32 caseNo)
{
	ether_addr_t mac_wan 	= { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ether_addr_t mac_lan 	= { { 0x00, 0x00, 0x00, 0x01, 0x02, 0x03 } };
	ether_addr_t mac_npi	= { { 0x00, 0x00, 0x01, 0x02, 0x04, 0x06 } };
	ether_addr_t mac_nh	= { { 0x00, 0x00, 0x02, 0x01, 0x02, 0x03 } };
	ipaddr_t ip_rp		= ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_npi 	= ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_wan	= ntohl(inet_addr("192.168.154.169"));
	uint16 port_rp	 = 10000;
	uint16 port_npi = 20000;
	uint16 port_gw_tcp;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	rtl8651_PktConf_t conf;
	ipaddr_t ipaddr, mask, nexthop;
	int8 pkt_content[2048] = {0};
	int32 retval;
	uint16 icmpId;

	START_TEST_CASE();
	
	/* WAN: subnet 1: 192.168.154.169/24*/	
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac_wan, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("wan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("wan", RTL8651_LL_VLAN, 1) == SUCCESS);
	ipaddr = ntohl(inet_addr("192.168.154.169"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("wan", ipaddr, mask) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("wan") == SUCCESS);

	/* LAN: subnet 2: 192.168.1.254/24 */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac_lan, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr, mask) == SUCCESS);

	/* Member Port setting */
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 4) == SUCCESS);

	/* Add arp */
	nexthop = ntohl(inet_addr("192.168.154.254"));
	ASSERT(rtl8651_addArp(nexthop, &mac_nh, "wan", 0x00) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 0x04) == SUCCESS);
	
	/* Set NAPT IP address */
	ipaddr = ntohl(inet_addr("192.168.154.169"));
	ASSERT(rtl8651_addNaptMapping(ipaddr) == SUCCESS);
	ASSERT(rtl8651_addRoute(0, 0, "wan", nexthop) == SUCCESS);
	
	
	/* Forwarding Engine Configuration */
	fwdeng_function_configuration1();
	
	/* (1) set MTU for wan */
	ASSERT(rtl8651_setNetMtu("wan", 1000) == SUCCESS);


	/* (2) outbound packet with total packet length(include ether header)  =  1500 */
	{
		/*=================================================
		  * TCP packet: SYN packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();
		/* check output */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 0,
							port_gw_tcp , port_rp, (TH_SYN), 960, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 


		/*=================================================
		  * TCP packet: SYN+ACK packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_nh , mac_wan,
						ip_rp, ip_wan, 255, 0, 0,
						port_rp, port_gw_tcp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();

		/* check output */
		{
			uint16 tx_list[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0,
							mac_lan, mac_npi, ip_rp, ip_npi ,254, 0, 0,
							port_rp , port_npi, (TH_SYN|TH_ACK), 960, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 


		/*=================================================
		  * TCP packet: ACK packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_ACK), 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();
		/* check output */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 0,
							port_gw_tcp , port_rp, (TH_ACK), 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 


		/*=================================================
		  * TCP packet: with 1500 payload packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, 1460);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		/* check output */ 
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 0,
							port_gw_tcp , port_rp, 0,  0, 0, 0, pkt_content, 956);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_IP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x06;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
	}

	{
		/*===============================================
		  * UDP packet with 1500 payload
		  *===============================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, 1472);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		/* check output */ 
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 0,
							port_gw_tcp , port_rp, 0,  0, 0, 0, pkt_content, 968);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[38] = 0x05;
			mbuf_comp->m_data[39] = 0xc8;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_IP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x11;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
 
	}

	{
		/*===============================================
		  * ICMP packet with 1500 payload
		  *===============================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_ICMP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, ICMP_ECHO, 100, pkt_content, 1472);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &icmpId) == SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 0,
							0 , 0, 0,  0, ICMP_ECHO, 100, pkt_content, 968);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[38] = icmpId>>8;
			mbuf_comp->m_data[39] = icmpId&0xff;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x01;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
 
	}

	return SUCCESS;
}

/*
@func int32		| pkt_mtu_fragment_pppoe	| packet fragment test for pppoe wan type
@rvalue SUCCESS	| test OK
@comm 
test packet fragment functions according to different MTU setting for pppoe wan type
 */
int32 pkt_mtu_fragment_pppoe(uint32 caseNo)
{
	ether_addr_t mac_wan 	= { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ether_addr_t mac_lan 	= { { 0x00, 0x00, 0x00, 0x01, 0x02, 0x03 } };
	ether_addr_t mac_npi	= { { 0x00, 0x00, 0x01, 0x02, 0x04, 0x06 } };
	ether_addr_t mac_nh	= { { 0x00, 0x00, 0x02, 0x01, 0x02, 0x03 } };
	ether_addr_t pppoe_srv_mac = { { 0x00, 0x00, 0x03, 0x01, 0x02, 0x03 } };
	ipaddr_t ip_rp		= ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_npi 	= ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_wan	= ntohl(inet_addr("192.168.154.169"));
	uint16 port_rp	 = 10000;
	uint16 port_npi = 20000;
	uint16 port_gw_tcp;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	rtl8651_PktConf_t conf;
	ipaddr_t ipaddr, mask;
	int8 pkt_content[2048] = {0};
	int32 retval;
	uint16 icmpId;

	START_TEST_CASE();
	
	/* WAN: subnet 1: 192.168.154.169/24*/	
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac_wan, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("pppoe") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("pppoe", RTL8651_LL_PPPOE, 1) == SUCCESS);
	ASSERT(rtl8651_addPppoeSession(1000, 1) == SUCCESS);

	ipaddr = ntohl(inet_addr("192.168.154.169"));
	mask = ntohl(inet_addr("255.255.255.255"));
	ASSERT(rtl8651_addIpIntf("pppoe", ipaddr, mask) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("pppoe") == SUCCESS);
	ASSERT(rtl8651_setPppoeSessionProperty(1000, 12345, &pppoe_srv_mac, 0x00) == SUCCESS);
	ASSERT(rtl8651_bindPppoeSession(ipaddr, 1000) == SUCCESS);

	/* LAN: subnet 2: 192.168.1.254/24 */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac_lan, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr, mask) == SUCCESS);

	/* Member Port setting */
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 4) == SUCCESS);

	/* Add arp */
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 0x04) == SUCCESS);
	
	/* Set NAPT IP address */
	ipaddr = ntohl(inet_addr("192.168.154.169"));
	ASSERT(rtl8651_addNaptMapping(ipaddr) == SUCCESS);
	ASSERT(rtl8651_addRoute(0, 0, "pppoe", 0) == SUCCESS);
	
	
	/* Forwarding Engine Configuration */
	fwdeng_function_configuration1();
	
	/* (1) set MTU for wan */
	ASSERT(rtl8651_setNetMtu("pppoe", 1000) == SUCCESS);


	/* (2) outbound packet with total packet length(include ether header)  =  1500 */
	{
		/*=================================================
		  * TCP packet: SYN packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();
		/* check output */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 0, 0,
							port_gw_tcp , port_rp, (TH_SYN), 960, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/*=================================================
		  * TCP packet: SYN+ACK packet
		  *=================================================*/
		mbuf_in = confPppoeHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, pppoe_srv_mac , mac_wan, 12345, 
						ip_rp, ip_wan, 255, 0, 0,
						port_rp, port_gw_tcp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();

		/* check output */
		{
			uint16 tx_list[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0,
							mac_lan, mac_npi, ip_rp, ip_npi ,254, 0, 0,
							port_rp , port_npi, (TH_SYN|TH_ACK), 960, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/*=================================================
		  * TCP packet: ACK packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_ACK), 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();
		/* check output */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 0, 0,
							port_gw_tcp , port_rp, (TH_ACK), 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/*=================================================
		  * TCP packet: with 1500 payload packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, 1460);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		/* check output */ 
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 1, 0,
							port_gw_tcp , port_rp, 0,  0, 0, 0, pkt_content, 956); 
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);					    
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();		
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_IP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x06;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
	}

	{
		/*===============================================
		  * UDP packet with 1500 payload
		  *===============================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, 1472);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		/* check output */ 
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 1, 0,
							port_gw_tcp , port_rp, 0,  0, 0, 0, pkt_content, 968);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[38] = 0x05;
			mbuf_comp->m_data[39] = 0xc8;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_IP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x11;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
 
	}


	{
		/*===============================================
		  * ICMP packet with 1500 payload
		  *===============================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_ICMP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, ICMP_ECHO, 100, pkt_content, 1472);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &icmpId) == SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 1, 0,
							0 , 0, 0,  0, ICMP_ECHO, 100, pkt_content, 968);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[38] = icmpId>>8;
			mbuf_comp->m_data[39] = icmpId&0xff;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confPppoeHSA(NULL, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, 0,
							mac_wan, pppoe_srv_mac, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x01;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
 	}
 	return SUCCESS;
}


#if 0 //not complete, chhuang
int32 pkt_mtu_fragment_pptp(uint32 caseNo)
{



}


int32 pkt_mtu_fragment_l2tp(uint32 caseNo)
{



}


int32 pkt_mtu_fragment_static_ip_fragment(uint32 caseNo)
{
	ether_addr_t mac_wan 	= { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ether_addr_t mac_lan 	= { { 0x00, 0x00, 0x00, 0x01, 0x02, 0x03 } };
	ether_addr_t mac_npi	= { { 0x00, 0x00, 0x01, 0x02, 0x04, 0x06 } };
	ether_addr_t mac_nh	= { { 0x00, 0x00, 0x02, 0x01, 0x02, 0x03 } };
	ipaddr_t ip_rp		= ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_npi 	= ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_wan	= ntohl(inet_addr("192.168.154.169"));
	uint16 port_rp	 = 10000;
	uint16 port_npi = 20000;
	uint16 port_gw_tcp;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	rtl8651_PktConf_t conf;
	ipaddr_t ipaddr, mask, nexthop;
	int8 pkt_content[2048] = {0};
	int32 retval;
	uint16 icmpId, offset;

	START_TEST_CASE();
	
	/* WAN: subnet 1: 192.168.154.169/24*/	
	ASSERT(rtl8651_assignVlanMacAddress(1, &mac_wan, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("wan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("wan", RTL8651_LL_VLAN, 1) == SUCCESS);
	ipaddr = ntohl(inet_addr("192.168.154.169"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("wan", ipaddr, mask) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("wan") == SUCCESS);

	/* LAN: subnet 2: 192.168.1.254/24 */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac_lan, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr, mask) == SUCCESS);

	/* Member Port setting */
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 3) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 4) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 4) == SUCCESS);

	/* Add arp */
	nexthop = ntohl(inet_addr("192.168.154.254"));
	ASSERT(rtl8651_addArp(nexthop, &mac_nh, "wan", 0x00) == SUCCESS);
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 0x04) == SUCCESS);
	
	/* Set NAPT IP address */
	ipaddr = ntohl(inet_addr("192.168.154.169"));
	ASSERT(rtl8651_addNaptMapping(ipaddr) == SUCCESS);
	ASSERT(rtl8651_addRoute(0, 0, "wan", nexthop) == SUCCESS);
	
	
	/* Forwarding Engine Configuration */
	fwdeng_function_configuration1();
	
	/* (1) set MTU for wan */
	ASSERT(rtl8651_setNetMtu("wan", 500) == SUCCESS);


	/* (2) outbound packet with total packet length(include ether header)  =  1500 */
	{
		/*=================================================
		  * TCP packet: SYN packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();
		/* check output */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 0,
							port_gw_tcp , port_rp, (TH_SYN), 460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/*=================================================
		  * TCP packet: SYN+ACK packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_nh , mac_wan,
						ip_rp, ip_wan, 255, 0, 0,
						port_rp, port_gw_tcp, (TH_SYN|TH_ACK), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();

		/* check output */
		{
			uint16 tx_list[2] = {4, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 2, 0,
							mac_lan, mac_npi, ip_rp, ip_npi ,254, 0, 0,
							port_rp , port_npi, (TH_SYN|TH_ACK), 460, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 


		/*=================================================
		  * TCP packet: ACK packet
		  *=================================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_ACK), 0, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 1);
		// get external port
		mbuf_out = mbufList_dequeue();
		/* check output */
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 0,
							port_gw_tcp , port_rp, (TH_ACK), 0, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/*=================================================
		  * TCP packet: with fragment packet
		  *=================================================*/
		for(offset=0; offset<10; offset++) {

		  	if (offset == 0) {
				mbuf_in = confVlanHSB(&conf, NULL,
								_PKT_TYPE_TCP, 4, 2, 0, mac_npi, mac_lan,
								ip_npi, ip_rp, 255, 1, 0,
								port_npi, port_rp, 0, 0, 0, 0, pkt_content, 1460);
			} else if (offset == 9) {
				mbuf_in = confVlanHSB(&conf, NULL,
								_PKT_TYPE_IP, 4, 2, 0, mac_npi, mac_lan,
								ip_npi, ip_rp, 255, 0, (offset>>3),
								0, 0, 0, 0, 0, 0, pkt_content, 1480);

			} else {
				mbuf_in = confVlanHSB(&conf, NULL,
								_PKT_TYPE_IP, 4, 2, 0, mac_npi, mac_lan,
								ip_npi, ip_rp, 255, 1, (offset*1480),
								0, 0, 0, 0, 0, 0, pkt_content, 1480);
			}
			
			/* packet input */
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			
			/* check result */
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 4);
			// get external port 
			mbuf_out = mbufList_dequeue();
			/* check output */ 
			ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
								_PKT_TYPE_TCP, tx_list, 1, 0,
								mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 0,
								port_gw_tcp , port_rp, 0,  0, 0, 0, pkt_content, 460);
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp); 


			/* Verify second packet */
			mbuf_out = mbufList_dequeue();
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
								_PKT_TYPE_IP, tx_list, 1, 0,
								mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 480,
								0 , 0, 0,  0, 0, 0, pkt_content, 480);
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				mbuf_comp->m_data[23] = 0x06;
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

			/* Verify 3th packet */
			mbuf_out = mbufList_dequeue();
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
								_PKT_TYPE_IP, tx_list, 1, 0,
								mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 960,
								0 , 0, 0,  0, 0, 0, pkt_content, 480);
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				mbuf_comp->m_data[23] = 0x06;
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

			/* Verify 4th packet */
			mbuf_out = mbufList_dequeue();
			{
				uint16 tx_list[2] = {0, 0xffff};
				mbuf_comp = confVlanHSA(NULL, NULL,
								_PKT_TYPE_IP, tx_list, 1, 0,
								mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 1440,
								0 , 0, 0,  0, 0, 0, pkt_content, 40);
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
				mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
				mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
				mbuf_comp->m_data[23] = 0x06;
			}
			MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
return;			
		}		
	}
 
return;
	{
		/*===============================================
		  * UDP packet with 1500 payload
		  *===============================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_UDP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, 0, 0, pkt_content, 1472);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		/* check output */ 
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw_tcp, NULL, NULL)==SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_UDP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 0,
							port_gw_tcp , port_rp, 0,  0, 0, 0, pkt_content, 968);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[38] = 0x05;
			mbuf_comp->m_data[39] = 0xc8;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_IP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x11;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
 
	}

	{
		/*===============================================
		  * ICMP packet with 1500 payload
		  *===============================================*/
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_ICMP, 4, 2, 0, mac_npi, mac_lan,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, 0, 0, ICMP_ECHO, 100, pkt_content, 1472);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		/* check result */
		VALUE_CMP(retval, SUCCESS);
		VALUE_CMP(mbufList_nmbuf(), 2);
		// get external port 
		mbuf_out = mbufList_dequeue();
		ASSERT(get_mbuf_IpId(mbuf_out, NULL, NULL, &icmpId) == SUCCESS);
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 1, 0,
							0 , 0, 0,  0, ICMP_ECHO, 100, pkt_content, 968);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[38] = icmpId>>8;
			mbuf_comp->m_data[39] = icmpId&0xff;
			
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 

		/* Verify second packet */
		mbuf_out = mbufList_dequeue();
		{
			uint16 tx_list[2] = {0, 0xffff};
			mbuf_comp = confVlanHSA(NULL, NULL,
							_PKT_TYPE_ICMP, tx_list, 1, 0,
							mac_wan, mac_nh, ip_wan, ip_rp, 254, 0, 976,
							0 , 0, 0,  0, 0, 0, pkt_content, 504);
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_L4);
			mbuf_comp->m_pkthdr->ph_flags |= (CSUM_IP);
			mbuf_comp->m_pkthdr->ph_proto = PKTHDR_IP;
			mbuf_comp->m_data[23] = 0x01;
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp); 
 
	}

	return SUCCESS;


}


int32 pkt_mtu_fragment_pppoe_fragment(uint32 caseNo)
{


}


int32 pkt_mtu_fragment_pptp_fragment(uint32 caseNo)
{


}


int32 pkt_mtu_fragment_l2tp_fragment(uint32 caseNo)
{


}

#endif




static int32 myRasCallbackIsFired;
int32 myRasCallback( uint32 nothing )
{
	myRasCallbackIsFired = TRUE;
	//printf("myRasCallback fired!!!\n");
}

/*
@func int32 | pkt_ras_idletimeout | test if RAS idle timeout works ?
@rvalue SUCCESS	| 	test OK
@comm
1.Configure environment
2.Set idle timeout(10), including callback function
3.increase _sysUpSeconds to 5
4.send a TCP packet
5.increase _sysUpSeconds to 10
6.confirm the callback function is NOT fired
7.increase _sysUpSeconds to 20
8.confirm the callback function is fired.
 */
int32 pkt_ras_idletimeout(uint32 caseNo)
{
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	START_TEST_CASE();
 	/******************************************************************
 	 * 1.Config Environments 
	 *	vlan 2: vlan/LAN
	 *			IP/mask		:	192.168.1.254 / 24
	 *
	 *	vlan 4: vlan/WAN
	 *			IP/mask		:	10.113.2.1 / 24
 	 ******************************************************************/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	ether_addr_t mac = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ipaddr_t ipaddr_ext, ipaddr_int, ipaddr_next, mask;

	/* VLAN 2: subnet 2 */
	/* member port 1,2,3, vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 3) == SUCCESS);
	mac.octet[5] = 0x03;
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_int, mask) == SUCCESS);

	/* VLAN 4: subnet 4 */
	/* member port 6, vlan */
	ASSERT(rtl8651_addVlan(4) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 5) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(4, 5) == SUCCESS);
	mac.octet[5] = 0x05;
	ASSERT(rtl8651_assignVlanMacAddress(4, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("wan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("wan", RTL8651_LL_VLAN, 4) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("wan") == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.1.1"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("wan", ipaddr_ext, mask) == SUCCESS);

	/* add default route on wan interface */
	ASSERT(rtl8651_addRoute(0, 0, "wan", ntohl(inet_addr("10.113.1.254"))) == SUCCESS);

	/* flush all DoS setting and turn-on dos check for session 0 */
	rtl8651_dosOneSecondTimer();
	rtl8651a_setDosStatus(0, 0xffffffff);
	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging
	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

	int T = 10; // timeout value

 	/******************************************************************
 	 * 2.set idle timeout
 	 ******************************************************************/
	myRasCallbackIsFired = FALSE;
	retval = rtl8651_setPppoeSessionHangUp( 0, TRUE, T, myRasCallback );
	ASSERT( retval == SUCCESS );

 	/******************************************************************
	 * 3.increase _sysUpSeconds to 5
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == FALSE );

 	/******************************************************************
	 * 4.send a TCP packet
 	 ******************************************************************/
	{
		/* config */
		/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* check result */
		VALUE_CMP(retval, SUCCESS);
#if 0
		/* check output packet */
		VALUE_CMP(mbufList_nmbuf(), 1);
		mbuf_out = mbufList_dequeue();

		// get external port
		ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

		/* NPI->RP (after NAPT) */
		{
			uint16 tx_list[2] = {0, 0xffff};	
			mbuf_comp = confPppoeHSA(&conf, NULL,
							_PKT_TYPE_TCP, tx_list, 1, 0, mac_gw_ext, mac_pppoe,
							ip_gw_ext, ip_rp, 254, 0, 0,
							port_gw, port_rp, (TH_SYN), 1452, 0, 0, NULL, 0);
		}
		MBUF_CMPandFREE(mbuf_out, mbuf_comp);
#else
		VALUE_CMP(mbufList_nmbuf(), 1);
		freeMbuf(mbufList_dequeue());
#endif//0
	}
	
 	/******************************************************************
	 * 5.increase _sysUpSeconds to 10
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
 	// 6.confirm the callback function is NOT fired
	ASSERT( myRasCallbackIsFired == FALSE );

 	/******************************************************************
	 * 7.increase _sysUpSeconds to 20
 	 ******************************************************************/
	_rtl8651_timeUpdate( T );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
 	// 8.confirm the callback function is fired
	ASSERT( myRasCallbackIsFired == TRUE );

	return SUCCESS;
}


static int32 myRasDoDCallbackIsFired;
int32 myRasDoDCallback( uint32 nothing )
{
	myRasDoDCallbackIsFired = TRUE;
	//printf("myRasDoDCallback fired!!!\n");
}

/*
@func int32 | pkt_ras_dialondemand | test if RAS idle timeout works ?
@rvalue SUCCESS	| 	test OK
@comm
1.Configure environment
2.Register callback function for demand route
3.Assert callback function is not fired.
4.Send a packet to demand route
5.Confirm the callback function is fired.
 */
int32 pkt_ras_dialondemand(uint32 caseNo)
{
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;


	START_TEST_CASE();
 	/******************************************************************
 	 * 1.Config Environments 
	 *	vlan 2: vlan/LAN
	 *			IP/mask		:	192.168.1.254 / 24
	 *
	 *	vlan 4: vlan/WAN
	 *			IP/mask		:	10.113.2.1 / 24
 	 ******************************************************************/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	ether_addr_t mac = { { 0x00, 0x03, 0x04, 0x05, 0x06, 0x01 } };
	ipaddr_t ipaddr_ext, ipaddr_int, ipaddr_next, mask;

	/* VLAN 2: subnet 2 */
	/* member port 1,2,3, vlan */
	ASSERT(rtl8651_addVlan(2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 1) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 1) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 2) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 2) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 3) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(2, 3) == SUCCESS);
	mac.octet[5] = 0x03;
	ASSERT(rtl8651_assignVlanMacAddress(2, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("lan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("lan", RTL8651_LL_VLAN, 2) == SUCCESS);
	ipaddr_int = ntohl(inet_addr("192.168.1.254"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("lan", ipaddr_int, mask) == SUCCESS);

	/* VLAN 4: subnet 4 */
	/* member port 6, vlan */
	ASSERT(rtl8651_addVlan(4) == SUCCESS);
	ASSERT(rtl8651_delVlanPortMember(1, 5) == SUCCESS);
	ASSERT(rtl8651_addVlanPortMember(4, 5) == SUCCESS);
	mac.octet[5] = 0x05;
	ASSERT(rtl8651_assignVlanMacAddress(4, &mac, 1) == SUCCESS);
	ASSERT(rtl8651_addNetworkIntf("wan") == SUCCESS);
	ASSERT(rtl8651_specifyNetworkIntfLinkLayerType("wan", RTL8651_LL_VLAN, 4) == SUCCESS);
	ASSERT(rtl8651_addExtNetworkInterface("wan") == SUCCESS);
	ipaddr_ext = ntohl(inet_addr("10.113.1.1"));
	mask = ntohl(inet_addr("255.255.255.0"));
	ASSERT(rtl8651_addIpIntf("wan", ipaddr_ext, mask) == SUCCESS);

	/* add default route on wan interface */
	ASSERT(rtl8651_addRoute(0, 0, "wan", ntohl(inet_addr("10.113.1.254"))) == SUCCESS);

	/* flush all DoS setting and turn-on dos check for session 0 */
	rtl8651_dosOneSecondTimer();
	rtl8651a_setDosStatus(0, 0xffffffff);
	log_init(0, RTL8651_LOGMODULE_DOS);	// enable DOS logging
	mbufList_Reinit();

	// disable multicast Query broadcasting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();

 	/******************************************************************
 	 * 2.Register callback function for demand route
 	 ******************************************************************/
	myRasDoDCallbackIsFired = FALSE;
	rtl8651_tblDrvDemandRoute_t dr;
	dr.type = TRIGGER_DSTIP;
	dr.ip_start = 0;
	dr.ip_end = 0xffffffff;
	retval = rtl8651_addDemandRoute( &dr, 0, myRasDoDCallback );
	ASSERT( retval == SUCCESS );

  	/******************************************************************
	 * 3.Assert callback function is not fired.
 	 ******************************************************************/
 	 ASSERT( myRasDoDCallbackIsFired == FALSE );
 	 
	/******************************************************************
	 * 4.send a TCP packet
 	 ******************************************************************/
	{
		/* config */
		/* NPI->RP */
		mbuf_in = confVlanHSB(&conf, NULL,
						_PKT_TYPE_TCP, 1, 2, 0, mac_npi, mac_gw_int,
						ip_npi, ip_rp, 255, 0, 0,
						port_npi, port_rp, (TH_SYN), 1460, 0, 0, NULL, 0);
		/* packet input */
		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

		/* expected FAILED because default route is NOT set. */
		VALUE_CMP(retval, FAILED);

		/* free mbuf */
		freeMbuf(mbuf_in);
	}
	
  	/******************************************************************
	 * 5.Confirm the callback function is fired.
 	 ******************************************************************/
 	 ASSERT( myRasDoDCallbackIsFired == TRUE );

  	/******************************************************************
	 * 6.Unregister callback function
 	 ******************************************************************/
 	retval = rtl8651_flushDemandRoute( 0 );
	ASSERT( retval == SUCCESS );
	
	return SUCCESS;
}

/*
@func int32		| pkt_remote_management1	| remote management test 1
@comm
Test for normal TCP trapping and port translation (received to gateway)
 */
int32 pkt_remote_management1(uint32 caseNo)
{
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	fwdeng_function_configuration1();

	/* turn-off DOS check */
	rtl8651a_setDosStatus(0, 0);
	/* add protocol stack action */
	/* 
		2005.08.12
		Originally, protocol stack action entry is matched with "ip subnet". 
		Now, we change it to "ip range".
	*/
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff,PS_ACTION_TO_PS,PS_ACTION_SERVER,IPPROTO_TCP, 8080,80) == SUCCESS);

	/*
		RP	->	GW
	*/
	{
		uint8 flag = 0;

		for (flag = 0 ; flag < 64 ; flag ++)
		{
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, 8080,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

			mbuf_comp = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, 80,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}
	}
	return SUCCESS;
}
/*
@func int32		| pkt_remote_management2	| remote management test 2
@comm
Test for normal TCP port translation (sent from gateway)
 */
int32 pkt_remote_management2(uint32 caseNo)
{
	int8 pkt_content[1400];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int i;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();

	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt

	fwdeng_function_configuration1();

	rtl8651a_setDosStatus(0, 0);

	retval = rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER,IPPROTO_TCP, 8080,80);
	{
		uint8 flag = 0;

		for (flag = 0 ; flag < 64 ; flag ++)
		{

			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, 123, 0, 0,
				80, port_rp,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

				GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, 22);
				VALUE_CMP(retval, SUCCESS);
			{
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA_Tagged(NULL, NULL,
					_PKT_TYPE_TCP, tx_port, 1, PPPOE_TABLE_INDEX(_rtl8651_getPppoeSessionByPppoeSessionId(11111)),
					mac_gw_ext, mac_pppoe,
					ip_gw_ext, ip_rp, 123, 0, 0,
					8080, port_rp,
					flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

#ifdef SW_CHECKSUM
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
#endif
			}

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

		}
	}
	return SUCCESS;
}

/*
@func int32		| pkt_remote_management3	| remote management test 3
@comm
Test for ICMP packet blocking
 */
int32 pkt_remote_management3(uint32 caseNo)
{
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	fwdeng_function_configuration1();

	ASSERT(rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DROP,0,IPPROTO_ICMP,0,0) == SUCCESS);

	/*
		RP	->	NPI :		
	*/
	{
		/* config */
		/* RP->NPI */
		RESET_CONF(&conf);
		conf.pktType						= _PKT_TYPE_ICMP;					/* tcp packet */
		conf.l2Flag						= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
		conf.ErrFlag						= 0;
		conf.conf_Flags					= (CSUM_IP|CSUM_L4);
		CP_MAC (mac_pppoe, conf.conf_smac);
		CP_MAC (mac_gw_ext, conf.conf_dmac);
		conf.pppoe.type					= 0x8864;
		conf.conf_sip						= ip_rp;
		conf.conf_dip						= ip_gw_ext;
		conf.ip.id							= 0xa;
		conf.ip.mf						= 0;
		conf.ip.offset						= 0;
		conf.ip.ttl							= 255;
		conf.icmp.type					= ICMP_ECHO;
		conf.icmp.code					= 0;
		conf.icmp.id						= 0x1234;
		conf.icmp.seq						= 1;
		conf.payload.content				= NULL;
		conf.payload.length				= 0;

		conf.conf_vlanIdx					= 1;
		conf.conf_pppoeIdx				= 0;
		SET_RX_PORT(conf.conf_portlist, 0);

		/* packet input */
		mbufList_Reinit();
		mbuf_in = genMbufPkt(&conf);
		
		retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);
		VALUE_CMP(mbufList_nmbuf(), 0);
	}
	return SUCCESS;
}

/*
@func int32		| pkt_remote_management4	| remote management test 4
@comm
Test for normal TCP port translation for fragment packets (received to gateway)
 */
int32 pkt_remote_management4(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_beforeTran = 0x1234;
	uint16 port_afterTran = 0x2345;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	fwdeng_function_configuration1();

	/* add protocol stack action */
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_UDP, port_beforeTran, port_afterTran) == SUCCESS);

	/* send fragment packet to protocol stack */
	// only allow Tear drop
	rtl8651a_setDosStatus(0, RTL8651_DOS_TEARDROP);

	/*
		RP	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_beforeTran, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, (p == total_pkt?FWDENG_QUEUED_TO_GW:SUCCESS));
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
		// Output
		VALUE_CMP(frag_pktChainCnt(mbuf_in->m_pkthdr), total_pkt);
	
		// out put will be in-order
		for (pkt_no = 1 ; pkt_no <= total_pkt ; pkt_no ++)
		{
			int16 tx_port[2] = {1, 0xffff};
	
			FRAG_DEQUEUE(mbuf_out, mbuf_in);

			mbuf_comp = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_rp, port_afterTran, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			MBUF_CMPandFREE(mbuf_out, mbuf_comp);
		}
nextLoop:
	}

	return SUCCESS;
}


/*
@func int32		| pkt_remote_management5	| remote management test 5
@comm
Test for normal TCP port translation for fragment packets (sent from gateway)
 */
int32 pkt_remote_management5(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_beforeTran = 0x1234;
	uint16 port_afterTran = 0x2345;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 udp_payload = 1448;
	int pa[5], p;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	fwdeng_function_configuration1();

	/* add protocol stack action */
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_UDP, port_beforeTran, port_afterTran) == SUCCESS);

	/*
		RP	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
				port_afterTran, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14 + 8));
			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				mbuf_comp = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 11111,
					ip_gw_ext, ip_rp, 11, (pkt_no == total_pkt?0:1), (udp_payload * (pkt_no - 1)),
					port_beforeTran, port_rp, 0, 0, 0, 0, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));

#ifdef SW_CHECKSUM
				mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
#endif
				mbuf_comp->m_pkthdr->ph_portlist = 0x01;

				MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
			}
		}
nextLoop:
	}

	return SUCCESS;
}

/*
@func int32		| pkt_remote_management6	| remote management test 6
@comm
Test for normal ICMP blocking for fragment packets
 */
int32 pkt_remote_management6(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_beforeTran = 0x1234;
	uint16 port_afterTran = 0x2345;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int total_pkt = 5;
	uint16 icmp_payload = 1448;
	int pa[5], p;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	// add napt
	fwdeng_function_configuration1();

	/* add protocol stack action */
	ASSERT(rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DROP,0,IPPROTO_ICMP,0,0) == SUCCESS);

	/*
		RP	->	GW
	*/
	for (total_pkt = 2 ; total_pkt <= 5 ; total_pkt ++)
	for (pa[0] = 1; pa[0] <= total_pkt ; pa[0] ++)
	for (pa[1] = 1; pa[1] <= total_pkt ; pa[1] ++)
	for (pa[2] = 1; pa[2] <= total_pkt ; pa[2] ++)
	for (pa[3] = 1; pa[3] <= total_pkt ; pa[3] ++)
	for (pa[4] = 1; pa[4] <= total_pkt ; pa[4] ++)
	{
		int pkt_no;
		int i,j;

		for (i = 0 ; i < total_pkt ; i ++)
		for (j = 0 ; j < total_pkt ; j ++)
		{
			if ((i != j) &&
			    (pa[i] == pa[j]))
				{
					goto nextLoop;
				}
		}

		for (p = 1 ; p <= total_pkt ; p ++)
		{
			// set pkt sequence
			pkt_no = pa[p - 1];
			mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_ICMP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 11, (pkt_no == total_pkt?0:1), (icmp_payload * (pkt_no - 1)),
				0, 0, 0, 0, ICMP_ECHO, 123, pkt_content, (pkt_no == 1?(sizeof(pkt_content)-sizeof(struct udphdr)):(sizeof(pkt_content))));
		
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 0);
		}
nextLoop:
	}

	return SUCCESS;
}

/*
@func int32		| pkt_remote_management7	| remote management test 7
@comm
Test for ICMP Error message for TCP error packets sent by protocol stack which is modified by remote-management engine
 */
int32 pkt_remote_management7(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp, *mbuf_err;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw_protocol = 0x9012;
	uint16 port_gw_send;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int count;

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	GW_SET_DOSSTATUS(0);

	/***********************************************************************************

                                                                                   Protocol Stack
                                                                                          /
                                                                     (Remote management Engine)
                                                                                       /
                                                                                     /
	Remote IP/Port <------------------> Gateway External IP/Port <-----------> Internal IP/Port


	Test for:
				Flow 1 : Remote IP/Port <---> Internal IP/Port
				Flow 2 : Remote IP/Port <---> Protocol Stack with Remote Managment Port Translation issue

	Flow 1 come first, then flow2 come and will need to change source port.
	-> We must make sure:
		1. Flow 1 and flow 2 are both OK.
		2. ICMP Error message is changed correctly.

	************************************************************************************/

	/****************************
		TCP flow
	*****************************/

	/* 1. enable TCP static port translation */
	rtl8651_fwdEngineTcpStaticNaptPortTranslation(TRUE);

	/* 2. flow 1 come */
	/*******************************************************************/
	mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_rp, TTL_HSB, 0, 0,
				port_npi, port_rp,
				TH_SYN, 1460, 0, 0, NULL, 0);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_port[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_TCP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_npi, port_rp,
						TH_SYN, 1452, 0, 0, NULL, 0);
	}
	MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

	mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
				port_rp, port_npi,
				(TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_port[2] = {1, 0xffff};
		mbuf_comp = confVlanHSA( NULL, NULL,
						_PKT_TYPE_TCP, tx_port, 2, 0,
						mac_gw_int, mac_npi, ip_rp, ip_npi, TTL_HSA, 0, 0,
						port_rp, port_npi,
						(TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);
	}
	MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
	/*******************************************************************/
	/* 3. protocol stack action ADD */
	port_gw_send = port_npi;
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_TCP, port_gw_send, port_gw_protocol) == SUCCESS);

	/* 4. flow 2 come */
	mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
				port_gw_protocol, port_rp,
				TH_SYN, 1452, 0, 0, NULL, 0);
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14+8));
	VALUE_CMP(retval, SUCCESS);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* make sure the original port is collision with exist port and it is changed by forwarding engine */
	VALUE_CMP(port_gw_send, port_npi);
	VALUE_NEQ(port_gw, port_gw_send);
	VALUE_NEQ(port_gw, port_npi);

	mbuf_comp = confPppoeHSB(NULL, NULL,
					_PKT_TYPE_TCP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 11111,
					ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
					port_gw, port_rp,
					TH_SYN, 1452, 0, 0, NULL, 0);

#ifdef SW_CHECKSUM
	mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
#endif
	mbuf_comp->m_pkthdr->ph_portlist = 0x01;
	MBUF_CMPandFREE(mbuf_out, mbuf_comp);

	mbuf_in = confPppoeHSB( NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
				port_rp, port_gw, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
	VALUE_CMP(retval, FWDENG_TO_GW);

	mbuf_comp = confPppoeHSB( NULL, NULL,
					_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
					port_rp, port_gw_protocol, (TH_SYN|TH_ACK), 1452, 0, 0, NULL, 0);

	CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
	MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	/*******************************************************************/
	/* 5. make sure this two flows are both OK. */
	for (count = 0 ; count < 1000 ; count ++)
	{
		/* Flow 1 */
		DEFAULT_IP_ID ++;
		{
			mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_TCP, 1, 2, 0,
						mac_npi, mac_gw_int, ip_npi, ip_rp, TTL_HSB, 0, 0,
						port_npi, port_rp,
						TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
								_PKT_TYPE_TCP, tx_port, 1, 0,
								mac_gw_ext, mac_pppoe,
								ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
								port_npi, port_rp,
								TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

			mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 11111,
						ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
						port_rp, port_npi,
						TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
								_PKT_TYPE_TCP, tx_port, 2, 0,
								mac_gw_int, mac_npi, ip_rp, ip_npi, TTL_HSA, 0, 0,
								port_rp, port_npi,
								TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/* Flow 2 */
		DEFAULT_IP_ID ++;
		{
			mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						mac_gw_ext, mac_pppoe, 11111,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_gw_protocol, port_rp,
						TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14+8));
			VALUE_CMP(retval, SUCCESS);

			VALUE_CMP(mbufList_nmbuf(), 1);

			mbuf_comp = confPppoeHSB(NULL, NULL,
							_PKT_TYPE_TCP, 0, 1, 0,
							mac_gw_ext, mac_pppoe, 11111,
							ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
							port_gw, port_rp,
							TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

#ifdef SW_CHECKSUM
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
#endif
			mbuf_comp->m_pkthdr->ph_portlist = 0x01;
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

			mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 11111,
						ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
						port_rp, port_gw, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TO_GW);

			mbuf_comp = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_TCP, 0, 1, 0, mac_pppoe, mac_gw_ext, 11111,
							ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
							port_rp, port_gw_protocol, TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}
	}
	/*******************************************************************/
	/* 5. make sure ICMP Error message for flow 2 is OK. */
	DEFAULT_IP_ID ++;

	for ( nCount = 0 ; nCount < 4 ; nCount ++ )
	{
		/* generate Error message */
		mbuf_err = confPppoeHSB( &conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						mac_gw_ext, mac_pppoe, 11111,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_gw, port_rp,
						TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		freeMbuf(mbuf_err);
		/* generate ICMP Error message */
		mbuf_in = confPppoeHSB( NULL, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
					0, 0, 0, 0, msg_arr[nCount], 123, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		/* generate Packet to compare */
		mbuf_err = confPppoeHSB( &conf, NULL,
						_PKT_TYPE_TCP, 0, 1, 0,
						mac_gw_ext, mac_pppoe, 11111,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_gw_protocol, port_rp,
						TH_ACK, 0, 0, 0, pkt_content, sizeof(pkt_content));
		freeMbuf(mbuf_err);
		mbuf_comp = confPppoeHSB( NULL, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
					0, 0, 0, 0, msg_arr[nCount], 123, NULL, 0);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	
	return SUCCESS;
}

/*
@func int32		| pkt_remote_management8	| remote management test 8
@comm
Test for ICMP Error message for UDP error packets sent by protocol stack which is modified by remote-management engine
 */
int32 pkt_remote_management8(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp, *mbuf_err;
	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	uint16 port_gw_protocol = 0x9012;
	uint16 port_gw_send;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	int count;

	uint8 msg_arr[4] = {ICMP_UNREACH, ICMP_SOURCEQUENCH, ICMP_TIMXCEED, ICMP_PARAMPROB};
	int32 nCount;

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	GW_SET_DOSSTATUS(0);

	/***********************************************************************************

                                                                                   Protocol Stack
                                                                                          /
                                                                     (Remote management Engine)
                                                                                       /
                                                                                     /
	Remote IP/Port <------------------> Gateway External IP/Port <-----------> Internal IP/Port


	Test for:
				Flow 1 : Remote IP/Port <---> Internal IP/Port
				Flow 2 : Remote IP/Port <---> Protocol Stack with Remote Managment Port Translation issue

	Flow 1 come first, then flow2 come and will need to change source port.
	-> We must make sure:
		1. Flow 1 and flow 2 are both OK.
		2. ICMP Error message is changed correctly.

	************************************************************************************/

	/****************************
		TCP flow
	*****************************/

	/* 1. enable UDP static port translation */
	rtl8651_fwdEngineUdpStaticNaptPortTranslation(TRUE);

	/* 2. flow 1 come */
	/*******************************************************************/
	mbuf_in = confVlanHSB( NULL, NULL,
				_PKT_TYPE_UDP, 1, 2, 0,
				mac_npi, mac_gw_int, ip_npi, ip_rp, TTL_HSB, 0, 0,
				port_npi, port_rp,
				0, 0, 0, 0, pkt_content, sizeof(pkt_content));

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	VALUE_CMP(retval, SUCCESS);
	VALUE_CMP(mbufList_nmbuf(), 1);
	{
		uint16 tx_port[2] = {0, 0xffff};
		mbuf_comp = confPppoeHSA( NULL, NULL,
						_PKT_TYPE_UDP, tx_port, 1, 0,
						mac_gw_ext, mac_pppoe,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_npi, port_rp,
						0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	}
	MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

	/*******************************************************************/
	/* 3. protocol stack action ADD */
	port_gw_send = port_npi;
	ASSERT(rtl8651_addProtoStackActions(0, 0xffffffff, PS_ACTION_TO_PS, PS_ACTION_SERVER, IPPROTO_UDP, port_gw_send, port_gw_protocol) == SUCCESS);

	/* 4. flow 2 come */
	mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_UDP, 0, 1, 0,
				mac_gw_ext, mac_pppoe, 11111,
				ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
				port_gw_protocol, port_rp,
				0, 0, 0, 0, pkt_content, sizeof(pkt_content));
	GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14+8));
	VALUE_CMP(retval, SUCCESS);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	ASSERT(get_mbuf_IpPort(mbuf_out, NULL, &port_gw, NULL, NULL)==SUCCESS);

	/* make sure the original port is collision with exist port and it is changed by forwarding engine */
	VALUE_CMP(port_gw_send, port_npi);
	VALUE_NEQ(port_gw, port_gw_send);
	VALUE_NEQ(port_gw, port_npi);

	mbuf_comp = confPppoeHSB(NULL, NULL,
					_PKT_TYPE_UDP, 0, 1, 0,
					mac_gw_ext, mac_pppoe, 11111,
					ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
					port_gw, port_rp,
					0, 0, 0, 0, pkt_content, sizeof(pkt_content));

#ifdef SW_CHECKSUM
	mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
#endif
	mbuf_comp->m_pkthdr->ph_portlist = 0x01;
	MBUF_CMPandFREE(mbuf_out, mbuf_comp);

	/*******************************************************************/
	/* 5. make sure this two flows are both OK. */
	for (count = 0 ; count < 1000 ; count ++)
	{
		/* Flow 1 */
		DEFAULT_IP_ID ++;
		{
			mbuf_in = confVlanHSB( NULL, NULL,
						_PKT_TYPE_UDP, 1, 2, 0,
						mac_npi, mac_gw_int, ip_npi, ip_rp, TTL_HSB, 0, 0,
						port_npi, port_rp,
						0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {0, 0xffff};
				mbuf_comp = confPppoeHSA( NULL, NULL,
								_PKT_TYPE_UDP, tx_port, 1, 0,
								mac_gw_ext, mac_pppoe,
								ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
								port_npi, port_rp,
								0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

			mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_pppoe, mac_gw_ext, 11111,
						ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
						port_rp, port_npi,
						0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			
			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

			VALUE_CMP(retval, SUCCESS);
			VALUE_CMP(mbufList_nmbuf(), 1);
			{
				uint16 tx_port[2] = {1, 0xffff};
				mbuf_comp = confVlanHSA( NULL, NULL,
								_PKT_TYPE_UDP, tx_port, 2, 0,
								mac_gw_int, mac_npi, ip_rp, ip_npi, TTL_HSA, 0, 0,
								port_rp, port_npi,
								0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			}
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);
		}
		/* Flow 2 */
		DEFAULT_IP_ID ++;
		{
			mbuf_in = confPppoeHSB(NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_gw_ext, mac_pppoe, 11111,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_gw_protocol, port_rp,
						0, 0, 0, 0, pkt_content, sizeof(pkt_content));
			GW_OUTPUT(retval, mbuf_in->m_pkthdr, 1, (14+8));
			VALUE_CMP(retval, SUCCESS);

			VALUE_CMP(mbufList_nmbuf(), 1);

			mbuf_comp = confPppoeHSB(NULL, NULL,
							_PKT_TYPE_UDP, 0, 1, 0,
							mac_gw_ext, mac_pppoe, 11111,
							ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
							port_gw, port_rp,
							0, 0, 0, 0, pkt_content, sizeof(pkt_content));

#ifdef SW_CHECKSUM
			mbuf_comp->m_pkthdr->ph_flags &= ~(CSUM_IP|CSUM_L4);
#endif
			mbuf_comp->m_pkthdr->ph_portlist = 0x01;
			MBUF_CMPandFREE(mbufList_dequeue(), mbuf_comp);

			mbuf_in = confPppoeHSB( NULL, NULL,
						_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 11111,
						ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
						port_rp, port_gw, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TO_GW);

			mbuf_comp = confPppoeHSB( NULL, NULL,
							_PKT_TYPE_UDP, 0, 1, 0, mac_pppoe, mac_gw_ext, 11111,
							ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
							port_rp, port_gw_protocol, 0, 0, 0, 0, pkt_content, sizeof(pkt_content));

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}
	}
	/*******************************************************************/
	/* 5. make sure ICMP Error message for flow 2 is OK. */
	DEFAULT_IP_ID ++;

	for ( nCount = 0 ; nCount < 4 ; nCount ++ )
	{
		/* generate Error message */
		mbuf_err = confPppoeHSB( &conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_gw_ext, mac_pppoe, 11111,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_gw, port_rp,
						0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		freeMbuf(mbuf_err);
		/* generate ICMP Error message */
		mbuf_in = confPppoeHSB( NULL, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
					0, 0, 0, 0, msg_arr[nCount], 123, NULL, 0);

		FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
		VALUE_CMP(retval, FWDENG_TO_GW);
		VALUE_CMP(mbufList_nmbuf(), 0);
		/* generate Packet to compare */
		mbuf_err = confPppoeHSB( &conf, NULL,
						_PKT_TYPE_UDP, 0, 1, 0,
						mac_gw_ext, mac_pppoe, 11111,
						ip_gw_ext, ip_rp, TTL_HSA, 0, 0,
						port_gw_protocol, port_rp,
						0, 0, 0, 0, pkt_content, sizeof(pkt_content));
		freeMbuf(mbuf_err);
		mbuf_comp = confPppoeHSB( NULL, &conf,
					_PKT_TYPE_ICMP, 0, 1, 0,
					mac_pppoe, mac_gw_ext, 11111,
					ip_rp, ip_gw_ext, TTL_HSB, 0, 0,
					0, 0, 0, 0, msg_arr[nCount], 123, NULL, 0);
		MBUF_CMPandFREE(mbuf_in, mbuf_comp);
	}
	
	return SUCCESS;
}

/*
@func int32             | pkt_remote_management9        | remote management test 9
@comm
Test for normal TCP trapping and port translation (received to gateway)
1) when sip is in the range of PSA rule
2) when sip is not in the range of PSA rule
 */
int32 pkt_remote_management9(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t conf;
	int32 retval;
	struct rtl_mBuf *mbuf_in, *mbuf_out, *mbuf_comp;
	/*
		Config Environments
	*/
	ipaddr_t iplists[32] = {0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);	/* add napt */
	fwdeng_function_configuration1();

	/* turn-off DOS check */
	rtl8651a_setDosStatus(0, 0);

	/* add protocol stack action */
	{
		rtl8651_PS_Action_Entry_t tempPSAction;
		ipaddr_t temp_ip;
		
		memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
		memcpy(&(tempPSAction.dstIp), &ip_gw_ext, sizeof(ipaddr_t));
		temp_ip = ntohl(inet_addr("140.113.1.0"));
		memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
		temp_ip = ntohl(inet_addr("140.113.1.255"));
		memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
		tempPSAction.orgPort = 8080;
		tempPSAction.orgPortEnd = 8080;
		tempPSAction.fwdPort = 80;
		tempPSAction.protocol = IPPROTO_TCP;
		tempPSAction.action = PS_ACTION_TO_PS;
		tempPSAction.role = PS_ACTION_SERVER;
		ASSERT(rtl8651_addGenericProtoStackActions(&tempPSAction) == SUCCESS);
	}
	/* RP -> GW : packet with source ip in the range of PSA. */
	{
		uint8 flag = 0;

		for (flag = 0 ; flag < 64 ; flag ++)
		{
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, 8080,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

			mbuf_comp = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, 80,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}
	}
	/* RP -> GW: packet with source ip not in the range of PSA rule. */
	{
                uint8 flag = 0;
		ipaddr_t temp_ip = ntohl(inet_addr("140.113.2.1"));

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 11111,
                                temp_ip /* sip not in the range */, ip_gw_ext, 123, 0, 0,
                                port_rp, 8080,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, SUCCESS);	/* this packet has been dropped */
			VALUE_CMP(mbufList_nmbuf(), 0);
                }

	}
	return SUCCESS;
}

/*
@func int32             | pkt_remote_management10        | remote management test 10
@comm
Test for normal TCP trapping and port translation (received to gateway) for multiple session.
1) session 1 should use remote management port 8080
2) session 2 should use remote management port 9090
 */
int32 pkt_remote_management10(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int32 nCount;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	uint16 port_npi = 0x9876;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x1112;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

	/* turn-off DOS check */
	rtl8651a_setDosStatus(0, 0);

	/* add protocol stack action */
	{
		rtl8651_PS_Action_Entry_t tempPSAction;
		ipaddr_t temp_ip;
		
		memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
		memcpy(&(tempPSAction.dstIp), &ip_gw_ext, sizeof(ipaddr_t));
		temp_ip = ntohl(inet_addr("0.0.0.0"));
		memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
		temp_ip = ntohl(inet_addr("255.255.255.255"));
		memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
		tempPSAction.orgPort = 8080;
		tempPSAction.orgPortEnd = 8080;
		tempPSAction.fwdPort = 80;
		tempPSAction.protocol = IPPROTO_TCP;
		tempPSAction.action = PS_ACTION_TO_PS;
		tempPSAction.role = PS_ACTION_SERVER;
		ASSERT(rtl8651_addGenericProtoStackActions(&tempPSAction) == SUCCESS);

                memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
                memcpy(&(tempPSAction.dstIp), &ip_gw_ext2, sizeof(ipaddr_t));
                temp_ip = ntohl(inet_addr("0.0.0.0"));
                memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
                temp_ip = ntohl(inet_addr("255.255.255.255"));
                memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
                tempPSAction.orgPort = 9090;
                tempPSAction.orgPortEnd = 9090;
                tempPSAction.fwdPort = 80;
                tempPSAction.protocol = IPPROTO_TCP;
                tempPSAction.action = PS_ACTION_TO_PS;
                tempPSAction.role = PS_ACTION_SERVER;
                ASSERT(rtl8651_addGenericProtoStackActions(&tempPSAction) == SUCCESS);
	}
	/* RP -> GW-session1-wanip: use port 8080 => port translation!  */
	{
		uint8 flag = 0;

		for (flag = 0 ; flag < 64 ; flag ++)
		{
			mbuf_in = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext /* session 1 wanip */, 123, 0, 0,
				port_rp, 8080,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

			mbuf_comp = confPppoeHSB(NULL, NULL,
				_PKT_TYPE_TCP, 0, 1, 0,
				mac_pppoe, mac_gw_ext, 11111,
				ip_rp, ip_gw_ext, 123, 0, 0,
				port_rp, 80 /* port translation */,
				flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}
	}
        /* RP -> GW-session1-wanip: use port 9090 => don't change port  */
        {
                uint8 flag = 0;

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 11111,
                                ip_rp, ip_gw_ext /* session 1 wanip */, 123, 0, 0,
                                port_rp, 9090,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

                        mbuf_comp = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 11111,
                                ip_rp, ip_gw_ext, 123, 0, 0,
                                port_rp, 9090 /* won't change port due to not matching any PSA. */,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
                        MBUF_CMPandFREE(mbuf_in, mbuf_comp);
                }
        }
        /* RP -> GW-session2-wanip: use port 8080 => don't change port  */
        {
                uint8 flag = 0;

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 22222,
                                ip_rp, ip_gw_ext2 /* session 2 wanip */, 123, 0, 0,
                                port_rp, 8080,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

                        mbuf_comp = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 22222,
                                ip_rp, ip_gw_ext2, 123, 0, 0,
                                port_rp, 8080 /* won't change port due to not matching any PSA. */,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
                        MBUF_CMPandFREE(mbuf_in, mbuf_comp);
                }
        }
        /* RP -> GW-session2-wanip: use port 9090 => port translation!  */
        {
                uint8 flag = 0;

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 22222,
                                ip_rp, ip_gw_ext2 /* session 2 wanip */, 123, 0, 0,
                                port_rp, 9090,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, FWDENG_TCP_NAPT_IN_NOTFOUND);

                        mbuf_comp = confPppoeHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 0, 1, 0,
                                mac_pppoe, mac_gw_ext, 22222,
                                ip_rp, ip_gw_ext2, 123, 0, 0,
                                port_rp, 80 /* port translation */,
                                flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));
                        CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
                        MBUF_CMPandFREE(mbuf_in, mbuf_comp);
                }
        }
	return SUCCESS;
}

/*
@func int32             | pkt_remote_management11        | remote management test 11
@comm
Test for normal TCP trapping and port translation (received to gateway) for lan side host.
1) session 1 should use Web Access port 8080
2) session 2 should use Web Access port 9090
 */
int32 pkt_remote_management11(uint32 caseNo)
{
	int8 pkt_content[1448];
	rtl8651_PktConf_t conf;
	int32 retval;
	int32 nCount;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/

	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	ipaddr_t ip_npi2 = ntohl(inet_addr("192.168.1.201"));
	uint16 port_npi = 0x9876;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	ipaddr_t ip_rp2 = ntohl(inet_addr("140.115.1.1"));
	uint16 port_rp = 0x5678;
	uint16 port_rp2 = 0x1112;
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	ipaddr_t ip_gw_ext2 = ntohl(inet_addr("10.113.2.1"));
	uint16 port_gw;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_pppoe2 = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x06}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};

	START_TEST_CASE();
	fwdeng_env_configuration_2();
	ASSERT(rtl8651_addArp(ip_npi, &mac_npi, "lan", 1) == SUCCESS);
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	ASSERT(rtl8651_addDriverNaptMapping(ip_gw_ext2) == SUCCESS);
	fwdeng_function_configuration1();

	/* turn-off DOS check */
	rtl8651a_setDosStatus(0, 0);

	/* add protocol stack action */
	{
		rtl8651_PS_Action_Entry_t tempPSAction;
		ipaddr_t temp_ip;
		
		memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
		memcpy(&(tempPSAction.dstIp), &ip_gw_ext, sizeof(ipaddr_t));
		temp_ip = ntohl(inet_addr("0.0.0.0"));
		memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
		temp_ip = ntohl(inet_addr("255.255.255.255"));
		memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
		tempPSAction.orgPort = 8080;
		tempPSAction.orgPortEnd = 8080;
		tempPSAction.fwdPort = 80;
		tempPSAction.protocol = IPPROTO_TCP;
		tempPSAction.action = PS_ACTION_TO_PS;
		tempPSAction.role = PS_ACTION_SERVER;
		ASSERT(rtl8651_addGenericProtoStackActions(&tempPSAction) == SUCCESS);

                memset(&tempPSAction, 0, sizeof(rtl8651_PS_Action_Entry_t));
                memcpy(&(tempPSAction.dstIp), &ip_gw_ext2, sizeof(ipaddr_t));
                temp_ip = ntohl(inet_addr("0.0.0.0"));
                memcpy(&(tempPSAction.lowerIp), &temp_ip, sizeof(ipaddr_t));
                temp_ip = ntohl(inet_addr("255.255.255.255"));
                memcpy(&tempPSAction.upperIp, &temp_ip, sizeof(ipaddr_t));
                tempPSAction.orgPort = 9090;
                tempPSAction.orgPortEnd = 9090;
                tempPSAction.fwdPort = 80;
                tempPSAction.protocol = IPPROTO_TCP;
                tempPSAction.action = PS_ACTION_TO_PS;
                tempPSAction.role = PS_ACTION_SERVER;
                ASSERT(rtl8651_addGenericProtoStackActions(&tempPSAction) == SUCCESS);
	}
	/* NPI -> NPE(GW-session1-wanip): use port 8080 => port translation!  */
	{
		uint8 flag = 0;

		for (flag = 0 ; flag < 64 ; flag ++)
		{
			mbuf_in = confVlanHSB(NULL, NULL,
				_PKT_TYPE_TCP, 1, 2, 0,
				mac_npi, mac_gw_int,
				ip_npi, ip_gw_ext /* session 1 wanip */, 123, 0, 0,
				port_npi, 8080, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

			FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
			VALUE_CMP(retval, FWDENG_TO_GW);

			mbuf_comp = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext /* session 1 wanip */, 123, 0, 0,
                                port_npi, 80, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));
 

			CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
			MBUF_CMPandFREE(mbuf_in, mbuf_comp);
		}
	}
        /* NPI -> NPE(GW-session1-wanip): use port 9090 => no port translation!  */
        {
                uint8 flag = 0;

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext /* session 1 wanip */, 123, 0, 0,
                                port_npi, 9090, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, FAILED);

                        mbuf_comp = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext /* session 1 wanip */, 123, 0, 0,
                                port_npi, 9090, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));


                        CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
                        MBUF_CMPandFREE(mbuf_in, mbuf_comp);
                }
        }
        /* NPI -> NPE(GW-session2-wanip): use port 8080 => no port translation!  */
        {
                uint8 flag = 0;

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext2 /* session 2 wanip */, 123, 0, 0,
                                port_npi, 8080, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, FAILED);

                        mbuf_comp = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext2 /* session 2 wanip */, 123, 0, 0,
                                port_npi, 8080, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));


                        CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
                        MBUF_CMPandFREE(mbuf_in, mbuf_comp);
                }
        }
        /* NPI -> NPE(GW-session2-wanip): use port 9090 => port translation!  */
        {
                uint8 flag = 0;

                for (flag = 0 ; flag < 64 ; flag ++)
                {
                        mbuf_in = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext2 /* session 2 wanip */, 123, 0, 0,
                                port_npi, 9090, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));

                        FWDENG_INPUT(retval, mbuf_in->m_pkthdr);
                        VALUE_CMP(retval, FWDENG_TO_GW);

                        mbuf_comp = confVlanHSB(NULL, NULL,
                                _PKT_TYPE_TCP, 1, 2, 0,
                                mac_npi, mac_gw_int,
                                ip_npi, ip_gw_ext2 /* session 2 wanip */, 123, 0, 0,
                                port_npi, 80, flag, 1460, 0, 0, pkt_content, sizeof(pkt_content));


                        CKSUM_CMP_SKIPUDPZERO(mbuf_in, mbuf_comp, (TEST_CSUM_L4|TEST_CSUM_IP));
                        MBUF_CMPandFREE(mbuf_in, mbuf_comp);
                }
        }
      
	return SUCCESS;
}


/*
@func void		| pptp_test_idletimeout	| test GRE silent timeout.
@comm 
test GRE silent timeout.
*/
int32 pptp_test_idletimeout(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int T=10;
	struct rtl_mBuf* mbuf_in, *mbuf_org, *mbuf_out, *mbuf_comp;

 	/******************************************************************
 	 * 1.Config Environments 
 	 ******************************************************************/

	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("192.168.240.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("192.170.240.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88}};	
	ether_addr_t mac_gw_int = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8a}};
	ether_addr_t mac_gw_sv = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8c}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	rtl8651_tblDrv_routeTable_t *rt_t=NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t=NULL;	
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_4();

	rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_TCP,1723,1723);	

	//printf("loopback VLAN_ID=%d WAN_VID=%d\n",tunnel.loopBackVid,tunnel.wanVid);

	rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
	if (rt_t->valid != 0 && rt_t->ifrt_flag==0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_PPTP))
		{
			//pppEntry_t=rt_t->rt_nhSession_t;
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
			pppEntry_t->initiated=1;
			if(pppEntry_t->greBuf1_==NULL)
			{	
				pppEntry_t->greBuf1_=(uint8*)rtlglue_malloc(1500);
				assert(pppEntry_t->greBuf1_);						
			}
			//make gre header
			pppEntry_t->greBuf1_[0]=0x45;
			pppEntry_t->greBuf1_[1]=0;
			pppEntry_t->greBuf1_[4]=0x12; //id
			pppEntry_t->greBuf1_[5]=0x34; //id
			pppEntry_t->greBuf1_[6]=0;
			pppEntry_t->greBuf1_[7]=0;
			pppEntry_t->greBuf1_[8]=0x80; //TTL
			pppEntry_t->greBuf1_[9]=0x2f; //GRE
			pppEntry_t->greBuf1_[12]=(ip_gw_ext>>24)&0xff;
			pppEntry_t->greBuf1_[13]=(ip_gw_ext>>16)&0xff;
			pppEntry_t->greBuf1_[14]=(ip_gw_ext>>8)&0xff;
			pppEntry_t->greBuf1_[15]=(ip_gw_ext)&0xff;
			pppEntry_t->greBuf1_[16]=(ip_rp>>24)&0xff;
			pppEntry_t->greBuf1_[17]=(ip_rp>>16)&0xff;
			pppEntry_t->greBuf1_[18]=(ip_rp>>8)&0xff;
			pppEntry_t->greBuf1_[19]=(ip_rp)&0xff;
		}
	}	

	ASSERT(pppEntry_t);


	/******************************************************************
 	 * 2.set idle timeout
 	 ******************************************************************/
	myRasCallbackIsFired = FALSE;
	retval = rtl8651_setPppoeSessionHangUp( 0, TRUE, T, myRasCallback );
	ASSERT( retval == SUCCESS );

 	/******************************************************************
	 * 3.increase _sysUpSeconds to 7
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == FALSE );

 	/******************************************************************
	 * 4.send a pptp packet
 	 ******************************************************************/

	
	
	/*
		NPI	->	RP : 
	*/
{

	uint16 port_gw_tcp;
	int i;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_TCP;					/* tcp packet */
	conf.l2Flag							= 0;								/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_gw_sv, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport						= port_gw_tcp;
	conf.conf_dport						= 1723; 
	conf.conf_tcp_seq					= 0xb;
	conf.conf_tcp_ack					= 0xc;
	conf.conf_tcp_flag					= (TH_SYN);
	conf.conf_tcp_win					= 0xfffe;
	conf.conf_tcp_mss					= 1412;
	conf.payload.content				= NULL;
	conf.payload.length					= 0;
	conf.conf_vlanIdx					= (tunnel.loopBackVid)&7;
	
	SET_RX_PORT(conf.conf_portlist, tunnel.loopbackPort);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	mbuf_org = genMbufPkt(&conf);


	mbuf_in->m_pkthdr->ph_rxdesc=0;
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


 	/******************************************************************
	 * 5.increase _sysUpSeconds to 14 , update last_received to 7
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == FALSE );


	conf.conf_vlanIdx= (tunnel.wanVid)&7;	
	SET_RX_PORT(conf.conf_portlist, tunnel.wanPort);	
	mbuf_in = genMbufPkt(&conf);	
	GW_OUTPUT(retval, mbuf_in->m_pkthdr,conf.conf_vlanIdx, 14);
	if(mbufList_nmbuf()==1)
	{
		mbuf_in= mbufList_dequeue();
		freeMbuf(mbuf_in);
		printk("free");
	}
	

 	/******************************************************************
	 * 6.increase _sysUpSeconds to 21 , (21-7=14)>10 timeout
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == TRUE );

	
	freeMbuf(mbuf_out);	
	freeMbuf(mbuf_org);	

}


	return SUCCESS;
}




/*
@func void		| l2tp_test_idletimeout	| test L2TP silent timeout.
@comm 
test L2TP silent timeout
*/
int32 l2tp_test_idletimeout(uint32 caseNo){

	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	int T=10;
	struct rtl_mBuf* mbuf_in, *mbuf_org, *mbuf_out, *mbuf_comp;


	/*
		Config Environments
	*/
	ipaddr_t iplists[32]={0};
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("192.168.240.1"));		
	uint16 port_rp = 0x5678;

	ipaddr_t ip_gw_ext = ntohl(inet_addr("192.170.240.1"));
	uint16 port_gw = 0xf456;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x88}};	
	ether_addr_t mac_gw_int = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8a}};
	ether_addr_t mac_gw_sv = {{0x00, 0x00, 0x1a, 0x2b, 0x3c, 0x8c}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	rtl8651_tblDrv_routeTable_t *rt_t=NULL;
	rtl8651_tblDrv_pppTable_t *pppEntry_t=NULL;	
	
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();

	fwdeng_env_configuration_5();

	rtl8651_addProtoStackActions(0,0xffffffff,PS_ACTION_DONT_TIMEOUT,PS_ACTION_CLIENT,IPPROTO_UDP,1701,1701);	

	//printf("loopback VLAN_ID=%d WAN_VID=%d\n",tunnel.loopBackVid,tunnel.wanVid);

	rt_t = DrvTbl.route+(rtl8651_tblDrvPara.routingTableSize-1);
	if (rt_t->valid != 0 && rt_t->ifrt_flag==0)
	{
		if ((rt_t->netif_t->linkLayerType == RTL8651_LL_L2TP))
		{
			//pppEntry_t=rt_t->rt_nhSession_t;
			pppEntry_t = (rtl8651_tblDrv_pppTable_t *)rt_t->rt_nhstart_t->nexthop_t;
			pppEntry_t->initiated=1;
			if(pppEntry_t->l2tpBuf1_==NULL)
			{	
				pppEntry_t->l2tpBuf1_=(uint8*)rtlglue_malloc(1500);
				assert(pppEntry_t->l2tpBuf1_);
			}
			//make l2tp header
			pppEntry_t->l2tpBuf1_[0]=0x45;
			pppEntry_t->l2tpBuf1_[1]=0;
			pppEntry_t->l2tpBuf1_[4]=0x12; //id
			pppEntry_t->l2tpBuf1_[5]=0x34; //id
			pppEntry_t->l2tpBuf1_[6]=0;
			pppEntry_t->l2tpBuf1_[7]=0;
			pppEntry_t->l2tpBuf1_[8]=0x80; //TTL
			pppEntry_t->l2tpBuf1_[9]=0x11; //UDP
			pppEntry_t->l2tpBuf1_[12]=(ip_gw_ext>>24)&0xff;
			pppEntry_t->l2tpBuf1_[13]=(ip_gw_ext>>16)&0xff;
			pppEntry_t->l2tpBuf1_[14]=(ip_gw_ext>>8)&0xff;
			pppEntry_t->l2tpBuf1_[15]=(ip_gw_ext)&0xff;
			pppEntry_t->l2tpBuf1_[16]=(ip_rp>>24)&0xff;
			pppEntry_t->l2tpBuf1_[17]=(ip_rp>>16)&0xff;
			pppEntry_t->l2tpBuf1_[18]=(ip_rp>>8)&0xff;
			pppEntry_t->l2tpBuf1_[19]=(ip_rp)&0xff;			
			pppEntry_t->l2tpBuf1_[20]=0x06;
			pppEntry_t->l2tpBuf1_[21]=0xa5;
			pppEntry_t->l2tpBuf1_[22]=0x06;
			pppEntry_t->l2tpBuf1_[23]=0xa5;
			// 24,25 udp_length 26,27 checksum
			pppEntry_t->l2tpBuf1_[28]=0x40;
			pppEntry_t->l2tpBuf1_[29]=0x02;
			// 30,31 l2tp_length
			pppEntry_t->l2tpBuf1_[32]=0x00;	//tunnel id		
			pppEntry_t->l2tpBuf1_[33]=0x01;	
			pppEntry_t->l2tpBuf1_[34]=0x00;	//session id		
			pppEntry_t->l2tpBuf1_[35]=0x02;	

			pppEntry_t->l2tpBuf1_[36]=0x21;
			pppEntry_t->l2tpOffset_=37;
			
			pppEntry_t->l2tpLengthBit_=1;
		}
	}	

	ASSERT(pppEntry_t);


	/******************************************************************
 	 * 2.set idle timeout
 	 ******************************************************************/
	myRasCallbackIsFired = FALSE;
	retval = rtl8651_setPppoeSessionHangUp( 0, TRUE, T, myRasCallback );
	ASSERT( retval == SUCCESS );

 	/******************************************************************
	 * 3.increase _sysUpSeconds to 7
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == FALSE );

 	/******************************************************************
	 * 4.send a GRE packet
 	 ******************************************************************/	
	
	/*
		NPI	->	RP 
	*/
{

	uint16 port_gw_tcp;
	int i;

	/* config */
	/* NPI->RP */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;								/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP_OK|CSUM_L4_OK);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_gw_sv, conf.conf_dmac);
	conf.conf_sip						= ip_npi;
	conf.conf_dip						= ip_rp;
	conf.ip.id							= 0xa;
	conf.ip.mf							= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 254;
	conf.conf_sport						= port_gw_tcp;
	conf.conf_dport						= 1701; 	
	conf.payload.content				= NULL;
	conf.payload.length					= 0;
	conf.conf_vlanIdx					= (tunnel.loopBackVid)&7;
	SET_RX_PORT(conf.conf_portlist, tunnel.loopbackPort);

	/* packet input */
	mbufList_Reinit();	// re-init mbufList
	mbuf_in = genMbufPkt(&conf);
	mbuf_org = genMbufPkt(&conf);


	mbuf_in->m_pkthdr->ph_rxdesc=0;
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();


 	/******************************************************************
	 * 5.increase _sysUpSeconds to 14 , update last_received to 7
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == FALSE );


	conf.conf_vlanIdx= (tunnel.wanVid)&7;	
	SET_RX_PORT(conf.conf_portlist, tunnel.wanPort);	
	mbuf_in = genMbufPkt(&conf);	
	GW_OUTPUT(retval, mbuf_in->m_pkthdr,conf.conf_vlanIdx, 14);
	if(mbufList_nmbuf()==1)
	{
		mbuf_in= mbufList_dequeue();
		freeMbuf(mbuf_in);
		printk("free");
	}
	

 	/******************************************************************
	 * 6.increase _sysUpSeconds to 21 , (21-7=14)>10 timeout
 	 ******************************************************************/
	_rtl8651_timeUpdate( T/2 );
	_rtl8651_timeUpdate( 1 );
	_rtl8651_timeUpdate( 1 );
	ASSERT( myRasCallbackIsFired == TRUE );


	freeMbuf(mbuf_out);	
	freeMbuf(mbuf_org);	
}
	return SUCCESS;
}


//////////////////////////////////////////////////////////////////////////////////////////
/////		For forwarding engine <---> ACL co-operate
//////////////////////////////////////////////////////////////////////////////////////////
int32 acl_Syn2CpuForExternalVlan(uint32 caseNo)
{
	rtl865x_tblAsicDrv_vlanParam_t asic_vlan;
	_rtl8651_tblDrvAclRule_t rule1, rule2;
	int32 curr;
	int vlan[2] = {1, 4};
	int i;

	START_TEST_CASE();	

	fwdeng_env_configuration_1();

	memset(&rule1, 0, sizeof(_rtl8651_tblDrvAclRule_t));
 	rule1.actionType_		= RTL8651_ACL_CPU;
 	rule1.tcpSYN_			= 0x01;
 	rule1.tcpFlagMask_		= rule1.tcpFlag_; /* SYN bit set */
 	rule1.tcpSrcPortUB_	= 0xffff;
 	rule1.tcpSrcPortLB_	= 0x00;
 	rule1.tcpDstPortUB_	= 0xffff;
 	rule1.tcpDstPortLB_	= 0x00;

	/* verify wan's (vlan1 and vlan4) acl rule for SYN trapping */

	for (i = 0 ; i < 2 ; i ++)
	{
		ASSERT(rtl8651_getAsicVlan(vlan[i], &asic_vlan) == SUCCESS);

		for (curr = 0 ; curr < RTL8651_ACLTBL_SIZE ; curr ++ )
		{
			memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
			ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

			/* found */
			if (		(rule1.tcpSrcPortUB_ == rule2.tcpSrcPortUB_) &&
					(rule1.tcpSrcPortLB_ == rule2.tcpSrcPortLB_) &&
					(rule1.tcpDstPortUB_ == rule2.tcpDstPortUB_) &&
					(rule1.tcpDstPortLB_ == rule2.tcpDstPortLB_) &&
					(rule1.tcpFlagMask_ == rule2.tcpFlagMask_) &&
					(rule1.tcpFlag_ == rule2.tcpFlag_) &&
					(rule1.srcIpAddr_ == rule2.srcIpAddr_) &&
					(rule1.srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
					(rule1.dstIpAddr_ == rule2.dstIpAddr_) &&
					(rule1.dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
					(rule1.tos_ == rule2.tos_) &&
					(rule1.tosMask_ == rule2.tosMask_))
				return SUCCESS;
		}
	}
	return FAILED;
}

int32 acl_DoS2Cpu(uint32 caseNo)
{
	rtl865x_tblAsicDrv_vlanParam_t asic_vlan;
	_rtl8651_tblDrvAclRule_t rule1, rule2;
	int32 curr;
	int i, j, k;
	int aclCnt;

	START_TEST_CASE();	

	fwdeng_env_configuration_1();

	/*
		test for (RTL8651_DOS_SYNFLOOD|RTL8651_DOS_SRC_SYNFLOOD|RTL8651_DOS_SYNWITHDATA|RTL8651_DOS_TCPLAND)
	*/
	for (i = 0 ; i < 4 ; i ++)
	{
		uint32 dosType[4] = {RTL8651_DOS_SYNFLOOD, RTL8651_DOS_SRC_SYNFLOOD, RTL8651_DOS_SYNWITHDATA, RTL8651_DOS_TCPLAND};

		rtl8651a_setDosStatus(0, dosType[i]);

		/* verify */
		memset(&rule1, 0, sizeof(_rtl8651_tblDrvAclRule_t));
		rule1.actionType_   = RTL8651_ACL_CPU;
		rule1.tcpSYN_       = 0x01;
		rule1.tcpFlagMask_  = rule1.tcpFlag_; /* SYN bit set */
		rule1.tcpSrcPortUB_ = 0xffff;
		rule1.tcpSrcPortLB_ = 0x00;
		rule1.tcpDstPortUB_ = 0xffff;
		rule1.tcpDstPortLB_ = 0x00;

		for (j = 1 ; j <= 4 ; j ++)
		{
			ASSERT(rtl8651_getAsicVlan(j, &asic_vlan) == SUCCESS);

			aclCnt = 0;
			for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
			{
				memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
				ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

				/* found */
				if (		(rule1.tcpSrcPortUB_ == rule2.tcpSrcPortUB_) &&
						(rule1.tcpSrcPortLB_ == rule2.tcpSrcPortLB_) &&
						(rule1.tcpDstPortUB_ == rule2.tcpDstPortUB_) &&
						(rule1.tcpDstPortLB_ == rule2.tcpDstPortLB_) &&
						(rule1.tcpFlagMask_ == rule2.tcpFlagMask_) &&
						(rule1.tcpFlag_ == rule2.tcpFlag_) &&
						(rule1.srcIpAddr_ == rule2.srcIpAddr_) &&
						(rule1.srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
						(rule1.dstIpAddr_ == rule2.dstIpAddr_) &&
						(rule1.dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
						(rule1.tos_ == rule2.tos_) &&
						(rule1.tosMask_ == rule2.tosMask_))
					aclCnt ++;
			}
			// aclCnt must > 0
			VALUE_NEQ(aclCnt, 0);
		}
	}

	/*
		test for (RTL8651_DOS_STEALTHFIN|RTL8651_DOS_SRC_STEALTHFIN)
	*/
	for (i = 0 ; i < 2 ; i ++)
	{
		uint32 dosType[2] = {RTL8651_DOS_STEALTHFIN, RTL8651_DOS_SRC_STEALTHFIN};

		rtl8651a_setDosStatus(0, dosType[i]);

		/* verify */
		memset(&rule1, 0, sizeof(_rtl8651_tblDrvAclRule_t));
		rule1.actionType_   = RTL8651_ACL_CPU;
		rule1.tcpFIN_       = 0x01;
		rule1.tcpFlagMask_  = rule1.tcpFlag_; /* FIN bit set */
		rule1.tcpSrcPortUB_ = 0xffff;
		rule1.tcpSrcPortLB_ = 0x00;
		rule1.tcpDstPortUB_ = 0xffff;
		rule1.tcpDstPortLB_ = 0x00;

		for (j = 1 ; j <= 4 ; j ++)
		{
			ASSERT(rtl8651_getAsicVlan(j, &asic_vlan) == SUCCESS);

			aclCnt = 0;
			for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
			{
				memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
				ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

				/* found */
				if (		(rule1.tcpSrcPortUB_ == rule2.tcpSrcPortUB_) &&
						(rule1.tcpSrcPortLB_ == rule2.tcpSrcPortLB_) &&
						(rule1.tcpDstPortUB_ == rule2.tcpDstPortUB_) &&
						(rule1.tcpDstPortLB_ == rule2.tcpDstPortLB_) &&
						(rule1.tcpFlagMask_ == rule2.tcpFlagMask_) &&
						(rule1.tcpFlag_ == rule2.tcpFlag_) &&
						(rule1.srcIpAddr_ == rule2.srcIpAddr_) &&
						(rule1.srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
						(rule1.dstIpAddr_ == rule2.dstIpAddr_) &&
						(rule1.dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
						(rule1.tos_ == rule2.tos_) &&
						(rule1.tosMask_ == rule2.tosMask_))
					aclCnt ++;
			}
			// aclCnt must > 0
			VALUE_NEQ(aclCnt, 0);
		}
	}

	/*
		test for RTL8651_DOS_SCAN
	*/
	{
		_rtl8651_tblDrvAclRule_t rule[11];

		rtl8651a_setDosStatus(0, RTL8651_DOS_SCAN);

		/* verify */
		memset(rule, 0, sizeof(rule));
		{	// RTL8651_TCP_FULLXMASSCAN
			rule[0].actionType_   = RTL8651_ACL_CPU;
			rule[0].tcpSrcPortUB_ = 0xffff;
			rule[0].tcpSrcPortLB_ = 0x00;
			rule[0].tcpDstPortUB_ = 0xffff;
			rule[0].tcpDstPortLB_ = 0x00;
			rule[0].tcpFlagMask_  = 0xff;
			rule[0].tcpFlag_      = 0xff;
		}
		{	// RTL8651_TCP_FULLSAPUSCAN
			rule[1].actionType_   = RTL8651_ACL_CPU;
			rule[1].tcpSrcPortUB_ = 0xffff;
			rule[1].tcpSrcPortLB_ = 0x00;
			rule[1].tcpDstPortUB_ = 0xffff;
			rule[1].tcpDstPortLB_ = 0x00;
			rule[1].tcpFlagMask_  = 0xff;
			rule[1].tcpURG_       = 0x01;
			rule[1].tcpACK_	   = 0x01;
			rule[1].tcpPSH_	   = 0x01;
			rule[1].tcpSYN_	   = 0x01;
		}
		{	// RTL8651_TCP_FINSCAN
			rule[2].actionType_   = RTL8651_ACL_CPU;
			rule[2].tcpFIN_       = 0x01;
			rule[2].tcpFlagMask_  = 0xff; /* only FIN bit set */
			rule[2].tcpSrcPortUB_ = 0xffff;
			rule[2].tcpSrcPortLB_ = 0x00;
			rule[2].tcpDstPortUB_ = 0xffff;
			rule[2].tcpDstPortLB_ = 0x00;
		}
		{	// RTL8651_TCP_SYNFINSCAN
		 	rule[3].actionType_   = RTL8651_ACL_CPU;
		 	rule[3].tcpFIN_       = 0x01;
		 	rule[3].tcpSYN_	   = 0x01;
		 	rule[3].tcpFlagMask_  = 0xff; /* only FIN & SYN bits set */
		 	rule[3].tcpSrcPortUB_ = 0xffff;
		 	rule[3].tcpSrcPortLB_ = 0x00;
		 	rule[3].tcpDstPortUB_ = 0xffff;
		 	rule[3].tcpDstPortLB_ = 0x00;
		}
		{	// RTL8651_TCP_NULLSCAN
		 	rule[4].actionType_   = RTL8651_ACL_CPU;
		 	rule[4].tcpFlag_	   = 0x00;
		 	rule[4].tcpFlagMask_  = 0xff; 
		 	rule[4].tcpSrcPortUB_ = 0xffff;
		 	rule[4].tcpSrcPortLB_ = 0x00;
		 	rule[4].tcpDstPortUB_ = 0xffff;
		 	rule[4].tcpDstPortLB_ = 0x00;
		}
		{	// RTL8651_TCP_NMAPXMASSCAN
		 	rule[5].actionType_   = RTL8651_ACL_CPU;
		 	rule[5].tcpFIN_	   = 0x01;
		 	rule[5].tcpPSH_	   = 0x01;
		 	rule[5].tcpURG_	   = 0x01;
		 	rule[5].tcpFlagMask_  = 0xff; 
		 	rule[5].tcpSrcPortUB_ = 0xffff;
		 	rule[5].tcpSrcPortLB_ = 0x00;
		 	rule[5].tcpDstPortUB_ = 0xffff;
		 	rule[5].tcpDstPortLB_ = 0x00;
		}
		{	// RTL8651_TCP_VECNASCAN - 1
		 	rule[6].actionType_   = RTL8651_ACL_CPU;
		 	rule[6].tcpFlagMask_  = 0xff; 
		 	rule[6].tcpSrcPortUB_ = 0xffff;
		 	rule[6].tcpSrcPortLB_ = 0x00;
		 	rule[6].tcpDstPortUB_ = 0xffff;
		 	rule[6].tcpDstPortLB_ = 0x00;
			rule[6].tcpURG_ = 0x01;
		}
		{	// RTL8651_TCP_VECNASCAN - 2
		 	rule[7].actionType_   = RTL8651_ACL_CPU;
		 	rule[7].tcpFlagMask_  = 0xff; 
		 	rule[7].tcpSrcPortUB_ = 0xffff;
		 	rule[7].tcpSrcPortLB_ = 0x00;
		 	rule[7].tcpDstPortUB_ = 0xffff;
		 	rule[7].tcpDstPortLB_ = 0x00;
			rule[7].tcpPSH_ = 0x01;
		}
		{	// RTL8651_TCP_VECNASCAN - 3
		 	rule[8].actionType_   = RTL8651_ACL_CPU;
		 	rule[8].tcpFlagMask_  = 0xff; 
		 	rule[8].tcpSrcPortUB_ = 0xffff;
		 	rule[8].tcpSrcPortLB_ = 0x00;
		 	rule[8].tcpDstPortUB_ = 0xffff;
		 	rule[8].tcpDstPortLB_ = 0x00;
			rule[8].tcpURG_ = 0x01;
			rule[8].tcpFIN_ = 0x01;
		}
		{	// RTL8651_TCP_VECNASCAN - 4
		 	rule[9].actionType_   = RTL8651_ACL_CPU;
		 	rule[9].tcpFlagMask_  = 0xff; 
		 	rule[9].tcpSrcPortUB_ = 0xffff;
		 	rule[9].tcpSrcPortLB_ = 0x00;
		 	rule[9].tcpDstPortUB_ = 0xffff;
		 	rule[9].tcpDstPortLB_ = 0x00;
			rule[9].tcpPSH_ = 0x01;
			rule[9].tcpFIN_ = 0x01;
		}
		{	// RTL8651_TCP_VECNASCAN -5
		 	rule[10].actionType_   = RTL8651_ACL_CPU;
		 	rule[10].tcpFlagMask_  = 0xff; 
		 	rule[10].tcpSrcPortUB_ = 0xffff;
		 	rule[10].tcpSrcPortLB_ = 0x00;
		 	rule[10].tcpDstPortUB_ = 0xffff;
		 	rule[10].tcpDstPortLB_ = 0x00;
			rule[10].tcpURG_ = 0x01;
			rule[10].tcpPSH_ = 0x01;
		}

		for (i = 0 ; i < 11 ; i ++)
		for (j = 1 ; j <= 4 ; j ++)
		{
			ASSERT(rtl8651_getAsicVlan(j, &asic_vlan) == SUCCESS);

			aclCnt = 0;
			for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
			{
				memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
				ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

				/* found */
				if (		(rule[i].tcpSrcPortUB_ == rule2.tcpSrcPortUB_) &&
						(rule[i].tcpSrcPortLB_ == rule2.tcpSrcPortLB_) &&
						(rule[i].tcpDstPortUB_ == rule2.tcpDstPortUB_) &&
						(rule[i].tcpDstPortLB_ == rule2.tcpDstPortLB_) &&
						(rule[i].tcpFlagMask_ == rule2.tcpFlagMask_) &&
						(rule[i].tcpFlag_ == rule2.tcpFlag_) &&
						(rule[i].srcIpAddr_ == rule2.srcIpAddr_) &&
						(rule[i].srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
						(rule[i].dstIpAddr_ == rule2.dstIpAddr_) &&
						(rule[i].dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
						(rule[i].tos_ == rule2.tos_) &&
						(rule[i].tosMask_ == rule2.tosMask_))
					aclCnt ++;
			}
			// aclCnt must > 0
			VALUE_NEQ(aclCnt, 0);
		}
	}

	/*
		test for (RTL8651_DOS_IPSPOOF)
	*/
	{
		_rtl8651_tblDrvAclRule_t rule[2];

		rtl8651a_setDosStatus(0, RTL8651_DOS_IPSPOOF);

		/* verify */
		memset(rule, 0, sizeof(rule));
		{
			rule[0].srcIpAddr_ = ntohl(inet_addr("192.168.1.0"));
			rule[0].srcIpAddrMask_ = ntohl(inet_addr("255.255.255.0"));
			rule[0].dstIpAddr_ = 0;
			rule[0].dstIpAddrMask_ = 0;
			rule[0].tos_ = 0;
			rule[0].tosMask_ = 0;
			rule[0].ipProto_ = 0;
			rule[0].ipProtoMask_ = 0;
			rule[0].ipFlag_ = 0;
			rule[0].ipFlagMask_ = 0;
			rule[0].ruleType_ = RTL8651_ACL_IP;
			rule[0].actionType_ = RTL8651_ACL_CPU;
		}
		{
			rule[1].srcIpAddr_ = ntohl(inet_addr("192.168.2.0"));
			rule[1].srcIpAddrMask_ = ntohl(inet_addr("255.255.255.0"));
			rule[1].dstIpAddr_ = 0;
			rule[1].dstIpAddrMask_ = 0;
			rule[1].tos_ = 0;
			rule[1].tosMask_ = 0;
			rule[1].ipProto_ = 0;
			rule[1].ipProtoMask_ = 0;
			rule[1].ipFlag_ = 0;
			rule[1].ipFlagMask_ = 0;
			rule[1].ruleType_ = RTL8651_ACL_IP;
			rule[1].actionType_ = RTL8651_ACL_CPU;
		}

		for (k = 0 ; k < 2 ; k ++)
		{
			int vlan[2] = {1, 4};
		
			ASSERT(rtl8651_getAsicVlan(vlan[k], &asic_vlan) == SUCCESS);

			for (j = 0 ; j < 2 ; j ++)
			{
				aclCnt = 0;
				for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
				{
					memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
					ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

					/* found */
					if (		(rule[j].ipProto_ == rule2.ipProto_) &&
							(rule[j].ipProtoMask_ == rule2.ipProtoMask_) &&
							(rule[j].ipFlagMask_ == rule2.ipFlagMask_) &&
							(rule[j].ipFlag_ == rule2.ipFlag_) &&
							(rule[j].ipFOP_ == rule2.ipFOP_) &&
							(rule[j].ipFOM_ == rule2.ipFOM_) &&
							(rule[j].ipHttpFilter_ == rule2.ipHttpFilter_) &&
							(rule[j].ipHttpFilterM_ == rule2.ipHttpFilterM_) &&
							(rule[j].ipIdentSrcDstIp_ == rule2.ipIdentSrcDstIp_) &&
							(rule[j].ipIdentSrcDstIpM_ == rule2.ipIdentSrcDstIpM_) &&
							(rule[j].srcIpAddr_ == rule2.srcIpAddr_) &&
							(rule[j].srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
							(rule[j].dstIpAddr_ == rule2.dstIpAddr_) &&
							(rule[j].dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
							(rule[j].tos_ == rule2.tos_) &&
							(rule[j].tosMask_ == rule2.tosMask_))
						aclCnt ++;
				}
				// aclCnt must > 0
				VALUE_NEQ(aclCnt, 0);
			}
		}
	}

	/*
		test for RTL8651_DOS_ECHOCHARGEN
	*/
	{
		_rtl8651_tblDrvAclRule_t rule[3];

		rtl8651a_setDosStatus(0, RTL8651_DOS_ECHOCHARGEN);

		/* verify */
		memset(rule, 0, sizeof(rule));
		{	// port 7
			rule[0].actionType_ = RTL8651_ACL_CPU;
			rule[0].ruleType_ = RTL8651_ACL_UDP;
			rule[0].dstIpAddr_ = 0;
			rule[0].dstIpAddrMask_ = 0;
			rule[0].srcIpAddr_ = 0;
			rule[0].srcIpAddrMask_ = 0;
			rule[0].tos_ = 0;
			rule[0].tosMask_ = 0;
			rule[0].udpSrcPortUB_ = 0xffff;
			rule[0].udpSrcPortLB_ = 0x00;
			rule[0].udpDstPortUB_ = 7;
			rule[0].udpDstPortLB_ = 7;
		}
		{	// port 17
			rule[1].actionType_ = RTL8651_ACL_CPU;
			rule[1].ruleType_ = RTL8651_ACL_UDP;
			rule[1].dstIpAddr_ = 0;
			rule[1].dstIpAddrMask_ = 0;
			rule[1].srcIpAddr_ = 0;
			rule[1].srcIpAddrMask_ = 0;
			rule[1].tos_ = 0;
			rule[1].tosMask_ = 0;
			rule[1].udpSrcPortUB_ = 0xffff;
			rule[1].udpSrcPortLB_ = 0x00;
			rule[1].udpDstPortUB_ = 17;
			rule[1].udpDstPortLB_ = 17;
		}
		{	// port 19
			rule[2].actionType_ = RTL8651_ACL_CPU;
			rule[2].ruleType_ = RTL8651_ACL_UDP;
			rule[2].dstIpAddr_ = 0;
			rule[2].dstIpAddrMask_ = 0;
			rule[2].srcIpAddr_ = 0;
			rule[2].srcIpAddrMask_ = 0;
			rule[2].tos_ = 0;
			rule[2].tosMask_ = 0;
			rule[2].udpSrcPortUB_ = 0xffff;
			rule[2].udpSrcPortLB_ = 0x00;
			rule[2].udpDstPortUB_ = 19;
			rule[2].udpDstPortLB_ = 19;
		}
 
		for (i = 0 ; i < 3 ; i ++)
		for (j = 1 ; j <= 4 ; j ++)
		{
			ASSERT(rtl8651_getAsicVlan(j, &asic_vlan) == SUCCESS);

			aclCnt = 0;
			for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
			{
				memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
				ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

 				/* found */
				if (		(rule[i].udpSrcPortUB_ == rule2.udpSrcPortUB_) &&
						(rule[i].udpSrcPortLB_ == rule2.udpSrcPortLB_) &&
						(rule[i].udpDstPortUB_ == rule2.udpDstPortUB_) &&
						(rule[i].udpDstPortLB_ == rule2.udpDstPortLB_) &&
 						(rule[i].srcIpAddr_ == rule2.srcIpAddr_) &&
						(rule[i].srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
						(rule[i].dstIpAddr_ == rule2.dstIpAddr_) &&
						(rule[i].dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
						(rule[i].tos_ == rule2.tos_) &&
						(rule[i].tosMask_ == rule2.tosMask_))
					aclCnt ++;
			}
			// aclCnt must > 0
			VALUE_NEQ(aclCnt, 0);
		}
	}

	/*
		test for (RTL8651_DOS_UDPFLOOD|RTL8651_DOS_SRC_UDPFLOOD|RTL8651_DOS_UDPBOMB|RTL8651_DOS_UDPLAND)
	*/
	for (i = 0 ; i < 4 ; i ++)
	{
		uint32 dosType[4] = {RTL8651_DOS_UDPFLOOD, RTL8651_DOS_SRC_UDPFLOOD, RTL8651_DOS_UDPBOMB, RTL8651_DOS_UDPLAND};
		_rtl8651_tblDrvAclRule_t rule[3];

		rtl8651a_setDosStatus(0, dosType[i]);

		/* verify */
		memset(&rule1, 0, sizeof(_rtl8651_tblDrvAclRule_t));
		rule1.ruleType_    = RTL8651_ACL_IP;
		rule1.actionType_  = RTL8651_ACL_CPU;
		rule1.ipProto_     = IPPROTO_UDP;
		rule1.ipProtoMask_ = 0xff;
 
		for (j = 1 ; j <= 4 ; j ++)
		{
			ASSERT(rtl8651_getAsicVlan(j, &asic_vlan) == SUCCESS);

			aclCnt = 0;
			for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
			{
				memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
				ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

 				/* found */
				if (		(rule1.udpSrcPortUB_ == rule2.udpSrcPortUB_) &&
						(rule1.udpSrcPortLB_ == rule2.udpSrcPortLB_) &&
						(rule1.udpDstPortUB_ == rule2.udpDstPortUB_) &&
						(rule1.udpDstPortLB_ == rule2.udpDstPortLB_) &&
 						(rule1.srcIpAddr_ == rule2.srcIpAddr_) &&
						(rule1.srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
						(rule1.dstIpAddr_ == rule2.dstIpAddr_) &&
						(rule1.dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
						(rule1.tos_ == rule2.tos_) &&
						(rule1.tosMask_ == rule2.tosMask_))
					aclCnt ++;
			}
			// aclCnt must > 0
			VALUE_NEQ(aclCnt, 0);
		}
	}

	/*
		test for RTL8651_DOS_PORTSCAN
	*/
	{
		rtl8651a_setDosStatus(0, RTL8651_DOS_PORTSCAN);

		/* verify */
		memset(&rule1, 0, sizeof(_rtl8651_tblDrvAclRule_t));
		rule1.ruleType_		= RTL8651_ACL_TCP;
	 	rule1.actionType_	= RTL8651_ACL_CPU;
	 	rule1.tcpRST_		= 0x01;
	 	rule1.tcpFlagMask_	= rule1.tcpFlag_; /* RST bit set */
	 	rule1.tcpSrcPortUB_	= 0xffff;
	 	rule1.tcpSrcPortLB_	= 0x00;
	 	rule1.tcpDstPortUB_	= 0xffff;
	 	rule1.tcpDstPortLB_	= 0x00;

		for (j = 1 ; j <= 4 ; j ++)
		{
			ASSERT(rtl8651_getAsicVlan(j, &asic_vlan) == SUCCESS);

			aclCnt = 0;
			for (curr = 0 ; curr < MIN(RTL8651_ACLTBL_SIZE, (RTL8651_ACLTBL_SIZE+RTL8651_ACLTBL_RESERV_SIZE - asic_vlan.inAclStart)) ; curr ++ )
			{
				memset(&rule2, 0, sizeof(_rtl8651_tblDrvAclRule_t));
				ASSERT(rtl8651_getAsicAclRule((asic_vlan.inAclStart+curr), &rule2) == SUCCESS);

				/* found */
				if (		(rule1.tcpSrcPortUB_ == rule2.tcpSrcPortUB_) &&
						(rule1.tcpSrcPortLB_ == rule2.tcpSrcPortLB_) &&
						(rule1.tcpDstPortUB_ == rule2.tcpDstPortUB_) &&
						(rule1.tcpDstPortLB_ == rule2.tcpDstPortLB_) &&
						(rule1.tcpFlagMask_ == rule2.tcpFlagMask_) &&
						(rule1.tcpFlag_ == rule2.tcpFlag_) &&
						(rule1.srcIpAddr_ == rule2.srcIpAddr_) &&
						(rule1.srcIpAddrMask_ == rule2.srcIpAddrMask_) &&
						(rule1.dstIpAddr_ == rule2.dstIpAddr_) &&
						(rule1.dstIpAddrMask_ == rule2.dstIpAddrMask_) &&
						(rule1.tos_ == rule2.tos_) &&
						(rule1.tosMask_ == rule2.tosMask_))
					aclCnt ++;
			}
			// aclCnt must > 0
			VALUE_NEQ(aclCnt, 0);
		}
	}

	return SUCCESS;
}


/*
 *  Basic test for IPSEC
 *
 *  Add an IPSEC SPI and delete it.
 */
int32 ipsecTestBasic1(uint32 caseNo)
{
	int32 retval;
	uint32 encKey[] = {0x40ee9860,0xd890027c,0xa8b32072,0x3cbb0855,0x8ee22f98,0x11adca08};
	uint32 authKey[] = {0xac56a5c2,0xbe6188cd,0x078c290b,0x89b3498c};
	
	START_TEST_CASE();	

	fwdeng_env_configuration_1();

	/* ADD */
	retval = rtl8651_addIpsecSpi( ntohl(inet_addr("192.168.154.240")), 0x1005, IPSEC_ESP, 
	                              ntohl(inet_addr("192.168.154.143")), IPSEC_CBC_3DES, encKey, IPSEC_HMAC_MD5, authKey,
	                              ntohl(inet_addr("0.0.0.0")), 60 , 64, IPSEC_AUTH_DATA_PRESENT );
	ASSERT( retval == SUCCESS );

	/* DELETE */
	retval = rtl8651_delIpsecSpi( ntohl(inet_addr("192.168.154.240")), 0x1005, IPSEC_ESP );
	ASSERT( retval == SUCCESS );
	
	return SUCCESS;
}


/*
 *  Basic test2 for IPSEC
 *
 *  Add an IPSEC SPI GRP and delete it.
 */
int32 ipsecTestBasic2(uint32 caseNo)
{
	int32 retval;
	
	START_TEST_CASE();	

	fwdeng_env_configuration_1();

	/* ADD */
	retval = rtl8651_addIpsecSpiGrp( ntohl(inet_addr("192.168.154.240")), 0x1005, IPSEC_ESP, 
								     ntohl(inet_addr("192.168.154.240")), 0x1004, IPSEC_IPIP, 
								     ntohl(inet_addr("192.168.154.240")), 0x1003, IPSEC_IPIP, 
								     ntohl(inet_addr("192.168.154.240")), 0x1002, IPSEC_IPIP, 
	                                 0 );
	ASSERT( retval == SUCCESS );

	/* DELETE */
	retval = rtl8651_delIpsecSpiGrp( ntohl(inet_addr("192.168.154.240")), 0x1005, IPSEC_ESP );
	ASSERT( retval == SUCCESS );
	
	return SUCCESS;
}


/*
 *  Basic test3 for IPSEC
 *
 *  Add an IPSEC SPI GRP and delete it.
 */
int32 ipsecTestBasic3(uint32 caseNo)
{
	int32 retval;
	
	START_TEST_CASE();	

	fwdeng_env_configuration_1();

	/* ADD */
	retval = rtl8651_addIpsecERoute( ntohl(inet_addr("192.168.143.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.154.240")), 0x1005, IPSEC_IPIP, 
	                                 0 );
	ASSERT( retval == SUCCESS );

	/* DELETE */
	retval = rtl8651_delIpsecERoute( ntohl(inet_addr("192.168.143.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0")), ntohl(inet_addr("255.255.255.0")) );
	ASSERT( retval == SUCCESS );
	
	return SUCCESS;
}


/*
 *  Basic test4 for IPSEC
 *
 *  A typical case -- outbound encryption.
 */
int32 ipsecTestBasic4(uint32 caseNo)
{
	int32 retval;
	uint32 encKey[] = {0x40ee9860,0xd890027c,0xa8b32072,0x3cbb0855,0x8ee22f98,0x11adca08};
	uint32 authKey[] = {0xac56a5c2,0xbe6188cd,0x078c290b,0x89b3498c};
	ipaddr_t extIp = ntohl(inet_addr("192.168.154.143"));
	ipaddr_t remIp = ntohl(inet_addr("192.168.154.240"));

	START_TEST_CASE();	

	fwdeng_env_configuration_3();

	/* ADD EROUTE */
	retval = rtl8651_addIpsecERoute( ntohl(inet_addr("192.168.143.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0")), ntohl(inet_addr("255.255.255.0")),
	                                 remIp, 0x1004, IPSEC_IPIP, 
	                                 0 );
	ASSERT( retval == SUCCESS );
	
	/* ADD IPIP */
	retval = rtl8651_addIpsecSpi( remIp, 0x1004, IPSEC_IPIP, 
	                              extIp, 0, NULL, 0, NULL,
	                              extIp, 15 , 64, 0 );
	ASSERT( retval == SUCCESS );
	/* ADD ESP */
	retval = rtl8651_addIpsecSpi( remIp, 0x1005, IPSEC_ESP, 
	                              extIp, IPSEC_CBC_3DES, encKey, IPSEC_HMAC_MD5, authKey,
	                              ntohl(inet_addr("0.0.0.0")), 15 , 64, IPSEC_AUTH_DATA_PRESENT );
	ASSERT( retval == SUCCESS );

	/* ADD SPI GRP */
	retval = rtl8651_addIpsecSpiGrp( remIp, 0x1004, IPSEC_IPIP, 
								     remIp, 0x1005, IPSEC_ESP, 
								     0, 0, 0, 
								     0, 0, 0, 
	                                 0 );
	ASSERT( retval == SUCCESS );



	/* DELETE EROUTE */
	retval = rtl8651_delIpsecERoute( ntohl(inet_addr("192.168.143.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0")), ntohl(inet_addr("255.255.255.0")) );
	ASSERT( retval == SUCCESS );
	
	/* DELETE SPI GRP */
	retval = rtl8651_delIpsecSpiGrp( remIp, 0x1004, IPSEC_IPIP );
	ASSERT( retval == SUCCESS );
	
	/* DELETE ESP */
	retval = rtl8651_delIpsecSpi( remIp, 0x1005, IPSEC_ESP );
	ASSERT( retval == SUCCESS );

	/* DELETE IPIP */
	retval = rtl8651_delIpsecSpi( remIp, 0x1004, IPSEC_IPIP );
	ASSERT( retval == SUCCESS );

	

	return SUCCESS;
}


/*
 *  test case for IPSEC fragment
 *
 */
int32 ipsecTestFrag(uint32 caseNo)
{
	int32 retval;
	uint32 encKey[] = {0x40ee9860,0xd890027c,0xa8b32072,0x3cbb0855,0x8ee22f98,0x11adca08};
	uint32 authKey[] = {0xac56a5c2,0xbe6188cd,0x078c290b,0x89b3498c};
	ipaddr_t extIp = ntohl(inet_addr("10.113.1.1"));/* maybe wrong */
	ipaddr_t remIp = ntohl(inet_addr("10.113.1.2"));/* maybe wrong */

	/* variables for UDP */
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;
	ipaddr_t intIp = ntohl(inet_addr("192.168.143.6"));
	uint16 intPort = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t oppIp = ntohl(inet_addr("192.168.240.1"));
	uint16 oppPort = 0x5678;
	uint16 extPort;
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	bzero(pkt_content, sizeof(pkt_content));
	int i;

	START_TEST_CASE();	

	fwdeng_env_configuration_1();

	/* ADD EROUTE */
	retval = rtl8651_addIpsecERoute( ntohl(inet_addr("192.168.143.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0")), ntohl(inet_addr("255.255.255.0")),
	                                 remIp, 0x1004, IPSEC_IPIP, 
	                                 0 );
	ASSERT( retval == SUCCESS );
	
	/* ADD IPIP */
	retval = rtl8651_addIpsecSpi( remIp, 0x1004, IPSEC_IPIP, 
	                              extIp, 0, NULL, 0, NULL,
	                              extIp, 15 , 64, 0 );
	ASSERT( retval == SUCCESS );
	/* ADD ESP */
	retval = rtl8651_addIpsecSpi( remIp, 0x1005, IPSEC_ESP, 
	                              extIp, IPSEC_CBC_3DES, encKey, IPSEC_HMAC_MD5, authKey,
	                              ntohl(inet_addr("0.0.0.0")), 15 , 64, IPSEC_AUTH_DATA_PRESENT );
	ASSERT( retval == SUCCESS );

	/* ADD SPI GRP */
	retval = rtl8651_addIpsecSpiGrp( remIp, 0x1004, IPSEC_IPIP, 
								     remIp, 0x1005, IPSEC_ESP, 
								     0, 0, 0, 
								     0, 0, 0, 
	                                 0 );
	ASSERT( retval == SUCCESS );


	
/*************

	UDP test

*************/
	/*
		NPI	->	RP :
					Slow path
					Output:	NAPT translate with setting PPPoE auto-added
	*/
{
	/* config */
	/* NPI->RP */
	//_rtl8651_dumpIpsec();
	
	mbuf_in = confVlanHSB( NULL, NULL,
		_PKT_TYPE_UDP, 1, 2, 0,
		mac_npi, mac_gw_int,
		intIp, oppIp, 11, 1, 1500,
		intPort, oppPort, 0, 0, 0, 0, pkt_content, 1500);

	FWDENG_INPUT(retval, mbuf_in->m_pkthdr);

	//VALUE_CMP(retval, SUCCESS);
	//VALUE_CMP(mbufList_nmbuf(), (pkt_no == total_pkt)?5:0);
			
	/* check result */
	VALUE_CMP(retval, SUCCESS);
	printf("mbufList_nmbuf()=%d\n",mbufList_nmbuf());
//	mbuf_out = mbufList_dequeue();
//	dumpMbufPkt( mbuf_out );
//	printf("========================================================\n");
//	mbuf_out = mbufList_dequeue();
//	dumpMbufPkt( mbuf_out );
	
	VALUE_CMP(mbufList_nmbuf(), 2);

	for (i=0; i < mbufList_nmbuf() ; i ++ )
	{
		freeMbuf(mbufList_dequeue());
	}

#if 0
	/* check output packet */
	/* NPI->RP (after NAPT) */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (PKTHDR_PPPOE_AUTOADD|CSUM_IP|CSUM_L4);
	CP_MAC(mac_gw_ext, conf.conf_smac);
	CP_MAC(mac_pppoe, conf.conf_dmac);
	conf.conf_sip						= extIp;
	conf.conf_dip						= remIp;
	conf.ip.id							= 0xab;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 122;
	conf.conf_sport					= extPort;
	conf.conf_dport					= oppPort;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 1492;
	conf.conf_vlanIdx					= 1;
	ADD_TX_PORT(conf.conf_portlist, 0);

	mbuf_comp = genMbufPkt(&conf);
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
#endif
}

	/* DELETE EROUTE */
	retval = rtl8651_delIpsecERoute( ntohl(inet_addr("192.168.143.0")), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0")), ntohl(inet_addr("255.255.255.0")) );
	ASSERT( retval == SUCCESS );
	
	/* DELETE SPI GRP */
	retval = rtl8651_delIpsecSpiGrp( remIp, 0x1004, IPSEC_IPIP );
	ASSERT( retval == SUCCESS );
	
	/* DELETE ESP */
	retval = rtl8651_delIpsecSpi( remIp, 0x1005, IPSEC_ESP );
	ASSERT( retval == SUCCESS );

	/* DELETE IPIP */
	retval = rtl8651_delIpsecSpi( remIp, 0x1004, IPSEC_IPIP );
	ASSERT( retval == SUCCESS );

	

	return SUCCESS;
}


/*
 *  test for Error of IPSEC
 */
int32 ipsecTestError(uint32 caseNo)
{
	int32 retval;
	uint32 encKey[] = {0x40ee9860,0xd890027c,0xa8b32072,0x3cbb0855,0x8ee22f98,0x11adca08};
	uint32 authKey[] = {0xac56a5c2,0xbe6188cd,0x078c290b,0x89b3498c};
	int32 i;
	
	START_TEST_CASE();	

	fwdeng_env_configuration_1();

/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
 * -=  SPI Function
 * -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
#undef MAX_CONN
#define MAX_CONN 48
	/* Add SPI until full */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* ADD */
		retval = rtl8651_addIpsecSpi( ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_ESP, 
		                              ntohl(inet_addr("192.168.154.143"))+i, IPSEC_CBC_3DES, encKey, IPSEC_HMAC_MD5, authKey,
		                              ntohl(inet_addr("0.0.0.0")), 60 , 64, IPSEC_AUTH_DATA_PRESENT );
		ASSERT( retval == SUCCESS );
	}

	/* We expect it is full. */
	retval = rtl8651_addIpsecSpi( ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_ESP, 
	                              ntohl(inet_addr("192.168.154.143"))+i, IPSEC_CBC_3DES, encKey, IPSEC_HMAC_MD5, authKey,
	                              ntohl(inet_addr("0.0.0.0")), 60 , 64, IPSEC_AUTH_DATA_PRESENT );
	ASSERT( retval == TBLDRV_EIPSEC_NO_MORE_SPI );

	/* Delete non-exist SPI */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* DELETE */
		retval = rtl8651_delIpsecSpi( ntohl(inet_addr("192.168.154.240"))-i-1, 0x1005, IPSEC_ESP );
		ASSERT( retval == TBLDRV_EIPSEC_SPI_NOT_FOUNT );
	}

	/* Delete non-exist SPI (proto not matched) */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* DELETE */
		retval = rtl8651_delIpsecSpi( ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_IPIP );
		ASSERT( retval == TBLDRV_EIPSEC_SPI_NOT_FOUNT );
	}

/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
 * -=  SPIGRP Function
 * -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
#undef MAX_CONN
#define MAX_CONN 24
	/* Add SPIGRP until full */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* ADD */
		retval = rtl8651_addIpsecSpiGrp( ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_ESP, 
									     ntohl(inet_addr("192.168.154.240"))+i, 0x1004, IPSEC_IPIP, 
									     ntohl(inet_addr("192.168.154.240"))+i, 0x1003, IPSEC_IPIP, 
									     ntohl(inet_addr("192.168.154.240"))+i, 0x1002, IPSEC_IPIP, 
		                                 0 );
		ASSERT( retval == SUCCESS );
	}

	/* We expect it is full. */
	retval = rtl8651_addIpsecSpiGrp( ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_ESP, 
								     ntohl(inet_addr("192.168.154.240"))+i, 0x1004, IPSEC_IPIP, 
								     ntohl(inet_addr("192.168.154.240"))+i, 0x1003, IPSEC_IPIP, 
								     ntohl(inet_addr("192.168.154.240"))+i, 0x1002, IPSEC_IPIP, 
	                                 0 );
	ASSERT( retval == TBLDRV_EIPSEC_NO_MORE_SPIGRP );

	/* Delete non-exist SPIGRP */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* DELETE */
		retval = rtl8651_delIpsecSpiGrp( ntohl(inet_addr("192.168.154.240"))-i-1, 0x1005, IPSEC_ESP );
		ASSERT( retval == TBLDRV_EIPSEC_SPIGRP_NOT_FOUNT );
	}

	/* Delete non-exist SPIGRP (proto not matched) */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* DELETE */
		retval = rtl8651_delIpsecSpiGrp( ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_IPIP );
		ASSERT( retval == TBLDRV_EIPSEC_SPIGRP_NOT_FOUNT );
	}

/* -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
 * -=  EROUTE Function
 * -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=- */
#undef MAX_CONN
#define MAX_CONN 24
	/* Add EROUTE until full */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* ADD */
		retval = rtl8651_addIpsecERoute( ntohl(inet_addr("192.168.143.0"))+(i<<8), ntohl(inet_addr("255.255.255.0")),
		                                 ntohl(inet_addr("192.168.240.0"))+(i<<8), ntohl(inet_addr("255.255.255.0")),
		                                 ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_IPIP, 
		                                 0 );
		ASSERT( retval == SUCCESS );
	}

	/* We expect it is full. */
	retval = rtl8651_addIpsecERoute( ntohl(inet_addr("192.168.143.0"))+(i<<8), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.240.0"))+(i<<8), ntohl(inet_addr("255.255.255.0")),
	                                 ntohl(inet_addr("192.168.154.240"))+i, 0x1005, IPSEC_IPIP, 
	                                 0 );
	ASSERT( retval == TBLDRV_EIPSEC_NO_MORE_EROUTE );

	/* Delete non-exist EROUTE */
	for( i = 0; i < MAX_CONN; i++ )
	{
		/* DELETE */
		retval = rtl8651_delIpsecERoute( ntohl(inet_addr("192.168.143.0"))-(i<<8)-1, ntohl(inet_addr("255.255.255.0")),
		                                 ntohl(inet_addr("192.168.240.0"))-(i<<8)-1, ntohl(inet_addr("255.255.255.0")) );
		ASSERT( retval == TBLDRV_EIPSEC_EROUTE_NOT_FOUNT );
	}

	return SUCCESS;
}


#ifdef CONFIG_RTL865X_VOIP
/**********************************************************************************************************
 *
 *  Test code for VoIP Supporting
 *
 * In the test, we will register callback functions and RTP information to ROME driver.
 * Then, rtpTest1() will simulate a RTP packer arrives, and expect pktRx() callback function will be called.
 * rtpTest2() will simulate a voice packet is ready to send, and expect a RTP packet will be send out.
 * rtpTest3() will test the PCM interrupt callback function.
 * rtpTest4() will test the tick callback function.
 *
 **********************************************************************************************************/
/*
 *  Callback function for VoIP
 */
int32 bTestTick0;
int32 testTick0( uint32 chid, int32 msPassed )
{
	bTestTick0 = TRUE;
	return SUCCESS;
}
int32 bTestTick1;
int32 testTick1( uint32 chid, int32 msPassed )
{
	bTestTick1 = TRUE;
	return SUCCESS;
}
int32 bTestTick2;
int32 testTick2( uint32 chid, int32 msPassed )
{
	bTestTick2 = TRUE;
	return SUCCESS;
}
int32 bTestTick3;
int32 testTick3( uint32 chid, int32 msPassed )
{
	bTestTick3 = TRUE;
	return SUCCESS;
}

/*
 *  Callback function for VoIP
 */
int32 bTestPktRx;
int32 testPktRx( uint32 chid, uint32 mid, void* packet, uint32 pktLen, uint32 flags )
{
	//rtlglue_printf( "%s():%d\n", __FUNCTION__, __LINE__ );
	bTestPktRx = TRUE;
	return SUCCESS;
}

/*
 *  Callback function for VoIP
 */
int32 bTestPcmInt0;
int32 testPcmInt0( void )
{
	bTestPcmInt0 = TRUE;
	return SUCCESS;
}

int32 bTestPcmInt1;
int32 testPcmInt1( void )
{
	bTestPcmInt1 = TRUE;
	return SUCCESS;
}

int32 bTestPcmInt2;
int32 testPcmInt2( void )
{
	bTestPcmInt2 = TRUE;
	return SUCCESS;
}

int32 bTestPcmInt3;
int32 testPcmInt3( void )
{
	bTestPcmInt3 = TRUE;
	return SUCCESS;
}

int32 rtpTest1(uint32 caseNo)
{
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 9000;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	mbufList_Reinit();

/*************

	VoIP Register

*************/
	voip_callback_t callback =
	{
		fpTick: testTick0,
		msTick: 50,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt0,
	};
	voip_rtp_port_t rtpInbound;
	voip_rtp_port_t rtpOutbound;

	retval = voip_register_callback( 0, &callback );
	ASSERT( retval == SUCCESS );

	rtpInbound.isTcp = FALSE;
	rtpInbound.remIp = ip_rp;
	rtpInbound.remPort = port_rp;
	rtpInbound.extIp = ip_gw_ext;
	rtpInbound.extPort = port_gw;
	retval = voip_register_RTPport( 0, 0, &rtpInbound );
	ASSERT( retval == SUCCESS );
	
	rtpOutbound.isTcp = FALSE;
	rtpOutbound.remIp = ip_rp;
	rtpOutbound.remPort = port_rp;
	rtpOutbound.extIp = ip_gw_ext;
	rtpOutbound.extPort = port_gw;
	retval = voip_register_RTPport( 0, 1, &rtpOutbound );
	ASSERT( retval == SUCCESS );

	/* Unregister, and register again */
	retval = voip_register_RTPport( 0, 0, NULL );
	ASSERT( retval == SUCCESS );
	retval = voip_register_RTPport( 0, 0, NULL );
	ASSERT( retval == SUCCESS );

	rtpInbound.isTcp = FALSE;
	rtpInbound.remIp = ip_rp;
	rtpInbound.remPort = port_rp;
	rtpInbound.extIp = ip_gw_ext;
	rtpInbound.extPort = port_gw;
	retval = voip_register_RTPport( 0, 0, &rtpInbound );
	ASSERT( retval == SUCCESS );
	
	rtpOutbound.isTcp = FALSE;
	rtpOutbound.remIp = ip_rp;
	rtpOutbound.remPort = port_rp;
	rtpOutbound.extIp = ip_gw_ext;
	rtpOutbound.extPort = port_gw;
	retval = voip_register_RTPport( 0, 1, &rtpOutbound );
	ASSERT( retval == SUCCESS );
	
/*************

	UDP test

*************/
	/*
		RP	->	NPE :
	*/
{
	/* config */
	/* RP->NPI */
	RESET_CONF(&conf);
	conf.pktType						= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag						|= L2_PPPoE;							/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag						= 0;
	conf.conf_Flags					|= (CSUM_IP|CSUM_L4);
	CP_MAC (mac_pppoe, conf.conf_smac);
	CP_MAC (mac_gw_ext, conf.conf_dmac);
	conf.pppoe.type					= 0x8864;
	conf.conf_sip						= ip_rp;
	conf.conf_dip						= ip_gw_ext;
	conf.ip.id							= 0xa;
	conf.ip.mf						= 0;
	conf.ip.offset						= 0;
	conf.ip.ttl							= 234;
	conf.conf_sport					= port_rp;
	conf.conf_dport					= port_gw;
	conf.payload.content				= pkt_content;
	conf.payload.length				= 160;

	conf.conf_vlanIdx					= 1;
	conf.l2Flag 						|= L2_PPPoE;
	conf.conf_pppoeIdx				= 0;
	SET_RX_PORT(conf.conf_portlist, 0);

	/* packet input */
	mbufList_Reinit();
	mbuf_in = genMbufPkt(&conf);
	retval = rtl8651_fwdEngineInput((void*)mbuf_in->m_pkthdr);

	/* check result */
	VALUE_CMP( retval, FWDENG_ACL_IN_USERTRAP );
	ASSERT( VOIP_CATEGORY_VALID( mbuf_in->m_pkthdr->ph_category ) );

	/* test callback function */
	bTestPktRx = FALSE;
	voip_pktRx( mbuf_in->m_pkthdr );
	ASSERT( bTestPktRx == TRUE );

	/* The packet should be free */
	VALUE_CMP(mbufList_nmbuf(), 0);
}
	return SUCCESS;
}


int32 rtpTest2(uint32 caseNo)
{
	int8 pkt_content[2048];
	rtl8651_PktConf_t	conf;
	int32 retval;
	struct rtl_mBuf* mbuf_in, *mbuf_out, *mbuf_comp;

	/*
		Config Environments
	*/
	ipaddr_t ip_npi = ntohl(inet_addr("192.168.1.1"));
	uint16 port_npi = 0x1234;
	ether_addr_t mac_npi = {{0x00, 0x00, 0x00, 0x01, 0x02, 0x03}};
	ipaddr_t ip_rp = ntohl(inet_addr("140.113.1.1"));
	uint16 port_rp = 0x5678;
//	ether_addr_t mac_rp = {{0x00, 0x00, 0x00, 0x0a, 0x0b, 0x0c}};
	ipaddr_t ip_gw_ext = ntohl(inet_addr("10.113.1.1"));
	uint16 port_gw = 9000;
	ipaddr_t ip_gw_int = ntohl(inet_addr("192.168.1.254"));
	ether_addr_t mac_gw_ext = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x01}};
	ether_addr_t mac_pppoe = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x02}};
	ether_addr_t mac_gw_int = {{0x00, 0x03, 0x04, 0x05, 0x06, 0x03}};
	ether_addr_t mac_bcast = {{0xff, 0xff, 0xff, 0xff, 0xff, 0xff}};
	bzero(pkt_content, sizeof(pkt_content));
	sprintf( pkt_content, "This is RTP Payload, blahblah ...." );

	START_TEST_CASE();
	fwdeng_env_configuration_1();
	ASSERT(rtl8651_addNaptMapping(ip_gw_ext) == SUCCESS);
	fwdeng_function_configuration1();
	mbufList_Reinit();

/*************

	VoIP Register

*************/
	voip_callback_t callback =
	{
		fpTick: testTick0,
		msTick: 50,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt0,
	};
	voip_rtp_port_t rtpInbound;
	voip_rtp_port_t rtpOutbound;

	retval = voip_register_callback( 0, &callback );
	ASSERT( retval == SUCCESS );

	rtpInbound.isTcp = FALSE;
	rtpInbound.remIp = ip_rp;
	rtpInbound.remPort = port_rp;
	rtpInbound.extIp = ip_gw_ext;
	rtpInbound.extPort = port_gw;
	retval = voip_register_RTPport( 0, 0, &rtpInbound );
	ASSERT( retval == SUCCESS );
	
	rtpOutbound.isTcp = FALSE;
	rtpOutbound.remIp = ip_rp;
	rtpOutbound.remPort = port_rp;
	rtpOutbound.extIp = ip_gw_ext;
	rtpOutbound.extPort = port_gw;
	retval = voip_register_RTPport( 0, 1, &rtpOutbound );
	ASSERT( retval == SUCCESS );

	retval = voip_TxRtpPkt( 0, 1, pkt_content, 160, TYPE_NONE );
	ASSERT( retval == SUCCESS );
	
/*************

	UDP test

*************/
	/*
		NPE	->	RP :
	*/
{

	/* check output packet */
	/* RP->NPI (after NAPTR) */
	RESET_CONF(&conf);
	conf.pktType							= _PKT_TYPE_UDP;					/* udp packet */
	conf.l2Flag							= 0;									/* no VLAN/PPPoE/SNAP */
	conf.ErrFlag							= 0;
	conf.conf_Flags						|= (CSUM_IP|CSUM_L4|PKTHDR_PPPOE_AUTOADD);
	CP_MAC (mac_gw_ext, conf.conf_smac);
	CP_MAC (mac_pppoe, conf.conf_dmac);
	conf.conf_sip							= ip_gw_ext;
	conf.conf_dip							= ip_rp;
	conf.ip.id								= 0x7788;
	conf.ip.mf							= 0;
	conf.ip.offset							= 0;
	conf.ip.ttl								= 147;
	conf.conf_dport						= port_rp;
	conf.conf_sport						= port_gw;
	conf.payload.content					= pkt_content;
	conf.payload.length					= 160;
	ADD_TX_PORT(conf.conf_portlist, 0);
	conf.conf_vlanIdx						= 1;

	mbuf_comp = genMbufPkt(&conf);
	VALUE_CMP(mbufList_nmbuf(), 1);
	mbuf_out = mbufList_dequeue();
	/*dumpMbufPkt( mbuf_out );*/
	MBUF_CMP(mbuf_out, mbuf_comp);

	freeMbuf(mbuf_out);
	freeMbuf(mbuf_comp);
}
	return SUCCESS;
}


int32 rtpTest3(uint32 caseNo)
{
	int32 retval;
	
	START_TEST_CASE();

/*************

	VoIP Register

*************/
	voip_callback_t callback0 =
	{
		fpTick: testTick0,
		msTick: 50,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt0,
	};
	voip_callback_t callback1 =
	{
		fpTick: testTick1,
		msTick: 50,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt1,
	};
	voip_callback_t callback2 =
	{
		fpTick: testTick2,
		msTick: 50,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt2,
	};
	voip_callback_t callback3 =
	{
		fpTick: testTick3,
		msTick: 50,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt3,
	};

	retval = voip_register_callback( 0, &callback0 );
	ASSERT( retval == SUCCESS );
	retval = voip_register_callback( 1, &callback1 );
	ASSERT( retval == SUCCESS );
	retval = voip_register_callback( 2, &callback2 );
	ASSERT( retval == SUCCESS );
	retval = voip_register_callback( 3, &callback3 );
	ASSERT( retval == SUCCESS );

	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/********************* CH0 *********************/
	/* ch0 tx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x80000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 tx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x40000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 rx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x20000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 rx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x10000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 tx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x08000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 tx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x04000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 rx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x02000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch0 rx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x01000000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==TRUE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/********************* CH1 *********************/
	/* ch1 tx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x00800000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 tx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x00400000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 rx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x00200000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 rx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x00100000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 tx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00080000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 tx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00040000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 rx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00020000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch1 rx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00010000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==TRUE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==FALSE );

	/********************* CH2 *********************/
	/* ch2 tx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x00008000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 tx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x00004000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 rx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x00002000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 rx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x00001000 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 tx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000800 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 tx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000400 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 rx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000200 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/* ch2 rx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000100 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==TRUE );
	ASSERT( bTestPcmInt3==FALSE );

	/********************* CH3 *********************/
	/* ch3 tx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x00000080 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 tx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x00000040 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 rx p0 OK */
	WRITE_MEM32( PCM_ISR, 0x00000020 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 rx p1 OK */
	WRITE_MEM32( PCM_ISR, 0x00000010 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 tx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000008 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 tx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000004 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 rx p0 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000002 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	/* ch3 rx p1 buffer unavailable */
	WRITE_MEM32( PCM_ISR, 0x00000001 );
	bTestPcmInt0 = bTestPcmInt1 = bTestPcmInt2 = bTestPcmInt3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestPcmInt0==FALSE );
	ASSERT( bTestPcmInt1==FALSE );
	ASSERT( bTestPcmInt2==FALSE );
	ASSERT( bTestPcmInt3==TRUE );

	return SUCCESS;
}


int32 rtpTest4(uint32 caseNo)
{
	int32 retval;
	
	START_TEST_CASE();

/*************

	VoIP Register

Time     0 10 20 30 40 50 60 70 80 90
Ch0( 7)  -  * **  *  * **  * **  * **
Ch1(11)  -  -  *  *  *  *  *  *  *  *
Ch2(13)  -  -  *  *  *  -  *  *  *  -
Ch3(23)  -  -  -  *  -  *  -  *  -  -

*************/
	voip_callback_t callback0 =
	{
		fpTick: testTick0,
		msTick: 7,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt0,
	};
	voip_callback_t callback1 =
	{
		fpTick: testTick1,
		msTick: 11,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt1,
	};
	voip_callback_t callback2 =
	{
		fpTick: testTick2,
		msTick: 13,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt2,
	};
	voip_callback_t callback3 =
	{
		fpTick: testTick3,
		msTick: 23,
		msRemain: 500,
		fpPktRx: testPktRx,
		fpPcmInt: testPcmInt3,
	};

	retval = voip_register_callback( 0, &callback0 );
	ASSERT( retval == SUCCESS );
	retval = voip_register_callback( 1, &callback1 );
	ASSERT( retval == SUCCESS );
	retval = voip_register_callback( 2, &callback2 );
	ASSERT( retval == SUCCESS );
	retval = voip_register_callback( 3, &callback3 );
	ASSERT( retval == SUCCESS );

	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==FALSE );
	ASSERT( bTestTick1==FALSE );
	ASSERT( bTestTick2==FALSE );
	ASSERT( bTestTick3==FALSE );

	/* 10 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==FALSE );
	ASSERT( bTestTick2==FALSE );
	ASSERT( bTestTick3==FALSE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 20 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==TRUE );
	ASSERT( bTestTick3==FALSE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 30 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==TRUE );
	ASSERT( bTestTick3==TRUE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 40 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==TRUE );
	ASSERT( bTestTick3==FALSE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 50 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==FALSE );
	ASSERT( bTestTick3==TRUE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 60 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==TRUE );
	ASSERT( bTestTick3==FALSE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 70 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==TRUE );
	ASSERT( bTestTick3==TRUE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 80 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==TRUE );
	ASSERT( bTestTick3==FALSE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	/* 90 ms passed */
	WRITE_MEM32( TC1CNT, READ_MEM32(TC1CNT) - READ_MEM32(TC0DATA)*1 );
	rtl8651_realtimeSchedule();
	ASSERT( bTestTick0==TRUE );
	ASSERT( bTestTick1==TRUE );
	ASSERT( bTestTick2==FALSE );
	ASSERT( bTestTick3==FALSE );
	bTestTick0 = bTestTick1 = bTestTick2 = bTestTick3 = FALSE;

	return SUCCESS;
}

#endif/*CONFIG_RTL865X_VOIP*/

