/*
* Copyright c                  Realtek Semiconductor Corporation, 2002  
* All rights reserved.
* 
* Program : Test code for NAPT
* Abstract : 
* Creator : Yung-Chieh Lo (yjlou@realtek.com.tw)
* Author :
* $Id: naptTest.c,v 1.1.1.1 2006/07/26 05:38:29 blue Exp $
* $Log: naptTest.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:29  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:25  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:00  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.2  2005/11/23 05:17:00  chenyl
* *: module test for WPNT834 case.
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.41  2005/09/28 01:56:00  shliu
* *: solve multiple definition problem
*
* Revision 1.40  2005/08/01 13:28:53  yjlou
* +: add Hash2_Outbound_Ambigious() and Hash2_2pairs().
*
* Revision 1.39  2005/07/08 13:30:09  yjlou
* +: support _rtl8651_changeNaptIpAndPort().
* +: add testChangeNaptIpAndPort().
*
* Revision 1.38  2005/06/07 15:14:16  shliu
* *: change addNaptMappingExt to addDriverNaptMapping
*
* Revision 1.37  2005/06/07 08:34:50  yjlou
* *: fixed the bug of IP Interface cannot be deleted.
*   *: fixed the bug of changeNaptFlowListType(): Symmetric Hash2 connection should not call setNaptEntry() twice. Just call once, and setNaptEntry() will call addHash2ToNexthop() twice.
*   *: fixed the bug of delNaptConnection(): derefHash2NexthopCount() should be called twice (for inbound entry and outbound entry).
*
* Revision 1.36  2005/05/27 13:23:01  yjlou
* +: add NaptTestMoreThan4096Connections() function.
*
* Revision 1.35  2004/12/15 02:46:24  yjlou
* +: add NaptTestAddNaptConnectiondBug()
* +: add DONT_BIRD_CDROUTER
*
* Revision 1.34  2004/11/19 04:30:24  yjlou
* *: fixed the bug of refilling Timer1. Config to timer mode, let ASIC refill it!
*    +: add NEVER_REFILL_TIMER1
* +: add DONT_BIRD_CDROUTER for test code
*
* Revision 1.33  2004/10/20 09:44:13  yjlou
* *: fixed for SERVERPORT_PARK_TCPUDP and ADD_FINITE_HASH2_SP.
*
* Revision 1.32  2004/10/20 02:10:56  yjlou
* *: fixed for setting default external interface.
*
* Revision 1.31  2004/10/19 11:08:58  yjlou
* *: addNaptMappingExt() must be called when adding second external interface.
*
* Revision 1.30  2004/10/15 11:49:39  yjlou
* +: add testAgeOfHash2PortReused()
*
* Revision 1.29  2004/10/15 03:13:54  yjlou
* +: add testNapt4WayHash()
*
* Revision 1.28  2004/10/13 07:06:59  yjlou
* +: add NaptInterfaceRoute2() to check interface route in ASIC accelerated.
*
* Revision 1.27  2004/10/12 11:39:13  yjlou
* +: ServerPortAndNewHash1()
* *: fixed for ALLOW_SP
*
* Revision 1.26  2004/10/12 08:53:53  yjlou
* *: fixed for CDRouter: HASH1 UDP will not write to ASIC when add.
*
* Revision 1.25  2004/10/12 05:17:50  chhuang
* *: disable time of date API when in CYGWIN platform
*
* Revision 1.24  2004/10/05 16:04:31  yjlou
* *: rtl8651_timeUpdate() has renamed to _rtl8651_timeUpdate().
*
* Revision 1.23  2004/10/04 14:41:16  yjlou
* +: add AddConnPerSec_Hash1() and AddConnPerSec_Hash2()
*
* Revision 1.22  2004/10/04 03:29:43  yjlou
* +: add testGetOutboundNaptFlow()
*
* Revision 1.21  2004/09/27 13:22:31  yjlou
* *: fixed for HASH2 UDP inbound entry also stays in software.
*
* Revision 1.20  2004/09/24 07:20:37  yjlou
* +: add testNewlyAddedHash2Udp() function
* *: fixed SelEIdx field
*
* Revision 1.19  2004/09/20 06:04:02  yjlou
* *: commit for test case 356 and 359.
*    *: fixed for NaptTest4096Connections and NaptInterfaceRoute.
*
* Revision 1.18  2004/09/07 14:52:14  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.17  2004/08/12 12:59:21  yjlou
* +: add NaptInterfaceRoute()
* +: tcpudp_entry_cmp() supports to compare selExtIPIdx,selEIdx,isCollision2,isDedicated.
*
* Revision 1.16  2004/07/28 14:09:17  yjlou
* +: BIG BANG! ROME Driver supports HASH2 ASIC-accelerated now!
*
* Revision 1.15  2004/07/06 05:16:27  yjlou
* *: fixed function NaptTypicalCaseRandomTest(): ensure (isTcp,IntIp,IntPort) is NOT duplicated.
*
* Revision 1.14  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.13  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.12  2004/05/19 14:01:27  yjlou
* +: support Protocol-Based NAT
*
* Revision 1.11  2004/05/04 07:41:31  yjlou
* +: add comments
*
* Revision 1.10  2004/04/30 08:58:08  chenyl
* +: ip multicast/igmp proxy
*
* $Id: naptTest.c,v 1.1.1.1 2006/07/26 05:38:29 blue Exp $
* $Log: naptTest.c,v $
* Revision 1.1.1.1  2006/07/26 05:38:29  blue
*
*
* Revision 1.1.1.1  2006/02/14 03:09:25  jason
* backup the source code from v1036
*
* Revision 1.1.1.1  2006/01/16 02:40:00  jason
* backup source,because now we directly use romedriver source code, i open a new directory;
*
* Revision 1.2  2005/11/23 05:17:00  chenyl
* *: module test for WPNT834 case.
*
* Revision 1.1.1.1  2005/11/21 05:20:04  chenyl
* +: WPNT834
* 	- System provider	: Sercomm
* 	- Brand Name		: Netgear
* 	- 3rt Party		: Airgo Gen 3
* 	- SDK			: 066-3
* 	- ROMEDRV		: 3.6-3
*
*
* Revision 1.41  2005/09/28 01:56:00  shliu
* *: solve multiple definition problem
*
* Revision 1.40  2005/08/01 13:28:53  yjlou
* +: add Hash2_Outbound_Ambigious() and Hash2_2pairs().
*
* Revision 1.39  2005/07/08 13:30:09  yjlou
* +: support _rtl8651_changeNaptIpAndPort().
* +: add testChangeNaptIpAndPort().
*
* Revision 1.38  2005/06/07 15:14:16  shliu
* *: change addNaptMappingExt to addDriverNaptMapping
*
* Revision 1.37  2005/06/07 08:34:50  yjlou
* *: fixed the bug of IP Interface cannot be deleted.
*   *: fixed the bug of changeNaptFlowListType(): Symmetric Hash2 connection should not call setNaptEntry() twice. Just call once, and setNaptEntry() will call addHash2ToNexthop() twice.
*   *: fixed the bug of delNaptConnection(): derefHash2NexthopCount() should be called twice (for inbound entry and outbound entry).
*
* Revision 1.36  2005/05/27 13:23:01  yjlou
* +: add NaptTestMoreThan4096Connections() function.
*
* Revision 1.35  2004/12/15 02:46:24  yjlou
* +: add NaptTestAddNaptConnectiondBug()
* +: add DONT_BIRD_CDROUTER
*
* Revision 1.34  2004/11/19 04:30:24  yjlou
* *: fixed the bug of refilling Timer1. Config to timer mode, let ASIC refill it!
*    +: add NEVER_REFILL_TIMER1
* +: add DONT_BIRD_CDROUTER for test code
*
* Revision 1.33  2004/10/20 09:44:13  yjlou
* *: fixed for SERVERPORT_PARK_TCPUDP and ADD_FINITE_HASH2_SP.
*
* Revision 1.32  2004/10/20 02:10:56  yjlou
* *: fixed for setting default external interface.
*
* Revision 1.31  2004/10/19 11:08:58  yjlou
* *: addNaptMappingExt() must be called when adding second external interface.
*
* Revision 1.30  2004/10/15 11:49:39  yjlou
* +: add testAgeOfHash2PortReused()
*
* Revision 1.29  2004/10/15 03:13:54  yjlou
* +: add testNapt4WayHash()
*
* Revision 1.28  2004/10/13 07:06:59  yjlou
* +: add NaptInterfaceRoute2() to check interface route in ASIC accelerated.
*
* Revision 1.27  2004/10/12 11:39:13  yjlou
* +: ServerPortAndNewHash1()
* *: fixed for ALLOW_SP
*
* Revision 1.26  2004/10/12 08:53:53  yjlou
* *: fixed for CDRouter: HASH1 UDP will not write to ASIC when add.
*
* Revision 1.25  2004/10/12 05:17:50  chhuang
* *: disable time of date API when in CYGWIN platform
*
* Revision 1.24  2004/10/05 16:04:31  yjlou
* *: rtl8651_timeUpdate() has renamed to _rtl8651_timeUpdate().
*
* Revision 1.23  2004/10/04 14:41:16  yjlou
* +: add AddConnPerSec_Hash1() and AddConnPerSec_Hash2()
*
* Revision 1.22  2004/10/04 03:29:43  yjlou
* +: add testGetOutboundNaptFlow()
*
* Revision 1.21  2004/09/27 13:22:31  yjlou
* *: fixed for HASH2 UDP inbound entry also stays in software.
*
* Revision 1.20  2004/09/24 07:20:37  yjlou
* +: add testNewlyAddedHash2Udp() function
* *: fixed SelEIdx field
*
* Revision 1.19  2004/09/20 06:04:02  yjlou
* *: commit for test case 356 and 359.
*    *: fixed for NaptTest4096Connections and NaptInterfaceRoute.
*
* Revision 1.18  2004/09/07 14:52:14  chenyl
* *: bug fix: napt-redirect fragment packet checksum-recalculate
* *: bug fix: conflict between protocol stack flow cache and protocol stack action
* *: bug fix: protocol stack action mis-process to UDP-zero-checksum packet
* *: separate the header file:
*         - internal : rtl8651_tblDrvFwdLocal.h
*         - external : rtl8651_tblDrvFwd.h
*
* Revision 1.17  2004/08/12 12:59:21  yjlou
* +: add NaptInterfaceRoute()
* +: tcpudp_entry_cmp() supports to compare selExtIPIdx,selEIdx,isCollision2,isDedicated.
*
* Revision 1.16  2004/07/28 14:09:17  yjlou
* +: BIG BANG! ROME Driver supports HASH2 ASIC-accelerated now!
*
* Revision 1.15  2004/07/06 05:16:27  yjlou
* *: fixed function NaptTypicalCaseRandomTest(): ensure (isTcp,IntIp,IntPort) is NOT duplicated.
*
* Revision 1.14  2004/06/29 07:34:23  chenyl
* +: IGMPv3
* +: igmp proxy filter :
* 		protocol stack can let igmp-proxy
* 			1: trap specific multicast group
* 			2: ignore specific multicast group
*
* Revision 1.13  2004/05/20 06:41:33  chenyl
* *: fragment system : if (DOS)/(UDP blocking) is disabled, don't queue in-the-order packets
* *: check all dos attacks for each packet
* *: bug fix in port bouncing
* *: apply TCP state tracking in port bouncing
* *: bug fix in multicast system
*
* Revision 1.12  2004/05/19 14:01:27  yjlou
* +: support Protocol-Based NAT
*
* Revision 1.11  2004/05/04 07:41:31  yjlou
* +: add comments
*
* Revision 1.9  2004/04/20 05:17:20  chhuang
* bug fixed
*
* Revision 1.8  2004/03/17 06:21:49  yjlou
* +: NaptPortRangeBug()
*
* Revision 1.7  2004/03/17 06:14:00  yjlou
* *: fixed a bug of _rtl8651_selectNaptPortOffset()
*    forget initial candidate value.
* -: remove collision bit related code
*
* Revision 1.6  2004/03/04 05:17:04  yjlou
* *: avoid function call in assert() as less as possible.
*
* Revision 1.5  2004/03/03 10:40:38  yjlou
* *: commit for mergence the difference in rtl86xx_tbl/ since 2004/02/26.
*
* Revision 1.4  2004/03/02 05:25:45  yjlou
* +: NaptHash1Hash2RandomTest()
*
* Revision 1.3  2004/02/27 08:20:36  yjlou
* +: add int32 AddDelIcmpError() and AddDelIcmpRandomTest()
*
* Revision 1.2  2004/02/26 08:54:51  yjlou
* +: add AddDelALGError(), AddDelALGBug(), and AddDelALGRandomTest()
*
* Revision 1.1  2004/02/25 14:26:59  chhuang
* *** empty log message ***
*
* Revision 1.11  2004/02/25 03:57:23  yjlou
* *: change the nextHop parameter of rtl8651_addRoute() at PPPoE connection.
*
* Revision 1.10  2004/02/24 12:59:26  yjlou
* +: add NaptAddDMZHostRandomTest()
*
* Revision 1.9  2004/02/24 12:44:40  yjlou
* +: add NaptFlushNaptServerPortbyExtIpRandomTest()
* +: enhance NaptAddDMZHost2()
*
* Revision 1.8  2004/02/24 08:39:46  yjlou
* +: enhance NaptAddDelServerPortRandomTest2() to test _rtl8651_getOutsideNaptServerPortMapping() and _rtl8651_getOutsideNaptServerPortMapping()
*
* Revision 1.7  2004/02/24 07:38:19  yjlou
* +: DMZ-related test code
* +: add ConfigNaptTestEnvironment2()
*
* Revision 1.6  2004/02/23 09:04:40  yjlou
* +: add NaptAddAlgCtrlConnectionError()
*
* Revision 1.5  2004/02/23 07:38:34  yjlou
* +: add NaptAddAlgCtrlConnectionRandomTest()
* +: enhance NaptTypicalCaseRandomTest()
*
*/

#include <stdlib.h>
#include <time.h>
#include "drvTest.h"
#include "rtl8651_tblDrvProto.h"
#include "rtl8651_tblAsicDrv.h"
#include "rtl8651_tblDrv.h"
#include "rtl8651_tblDrvLocal.h"
#include "rtl8651_tblDrvFwdLocal.h"



#define Hash1(a,b,c,d,e) rtl8651_naptTcpUdpTableIndex(a,b,c,d,e)  // short name for Hash1
#define Hash2(a,b,c)     rtl8651_naptTcpUdpTableIndex(a,b,c,0,0)  // short name for Hash2


/* just for debug */
void _dump_naptTcpUdpParam( uint32 idx, rtl865x_tblAsicDrv_naptTcpUdpParam_t* pe )
{
	printf("[%4d] Offset:%2d isTcp:%d  Int:%d.%d.%d.%d:%d\n",
	       idx,
	       pe->offset,
	       pe->isTcp,
	       pe->insideLocalIpAddr>>24, (pe->insideLocalIpAddr&0x00ff0000) >> 16,
	       (pe->insideLocalIpAddr&0x0000ff00)>>8, pe->insideLocalIpAddr&0x000000ff,
	       pe->insideLocalPort );	       
	printf("       C1(%d) age(%d) tcpflag(%d) S(%d) V(%d)\n",
	       pe->isCollision,
	       pe->ageSec,
	       pe->tcpFlag,
	       pe->isStatic,
	       pe->isValid );
}


//
// This is the routine to setup testing environment for NAPT table.
// Including:
//   2 network interfaces ( internal VLAN, 192.168.1.254/24,
//                          external VLAN, 140.113.214.102/24,
//                                         140.113.214.117 <-- For Local Public
//                          external VLAN, 140.113.131.53/24 )
//   3 VLANs
//
#define NAPT_INTF_RTK0 (ntohl(inet_addr("192.168.1.254"))) // IP address of network interface rtk0
#define NAPT_INTF_RTK1 (ntohl(inet_addr("140.113.214.102"))) // IP address of network interface rtk1
#define NAPT_INTF_RTK1_2 (ntohl(inet_addr("140.113.214.117"))) // IP address of network interface rtk1 (Local Public)
#define NAPT_INTF_RTK2 (ntohl(inet_addr("140.113.131.53"))) // IP address of network interface rtk2
int8
ConfigNaptTestEnvironment()
{
	uint32 ret;

	// internal interface
	ret = rtl8651_addNetworkIntf( "rtk0" );
	IS_EQUAL_INT( "addNetworkIntf(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ether_addr_t ether0 = { { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05 } };
	ret = rtl8651_assignVlanMacAddress( 1, &ether0, 1 );
	IS_EQUAL_INT( "assignVlanMacAddress(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk0", RTL8651_LL_VLAN, 1 );
	IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addIpIntf( "rtk0", NAPT_INTF_RTK0, ntohl( inet_addr("255.255.255.0") ) );
	IS_EQUAL_INT( "addIpIntf(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// external interface 1
	ret = rtl8651_addVlan( 2 );
	IS_EQUAL_INT( "addVlan(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNetworkIntf( "rtk1" );
	IS_EQUAL_INT( "addNetworkIntf(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ether_addr_t ether1 = { { 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f } };
	ret = rtl8651_assignVlanMacAddress( 2, &ether1, 1 );
	IS_EQUAL_INT( "assignVlanMacAddress(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk1", RTL8651_LL_VLAN, 2 );
	IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addExtNetworkInterface( "rtk1" );
	IS_EQUAL_INT( "addExtNetworkInterface(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addIpIntf( "rtk1", NAPT_INTF_RTK1, ntohl( inet_addr("255.255.255.0") ) );
	IS_EQUAL_INT( "addIpIntf(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptMapping( NAPT_INTF_RTK1 );
	IS_EQUAL_INT( "addNaptMappingExt(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// external interface 2
	ret = rtl8651_addVlan( 3 );
	IS_EQUAL_INT( "addVlan(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addNetworkIntf( "rtk2" );
	IS_EQUAL_INT( "addNetworkIntf(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ether_addr_t ether2 = { { 0x1a, 0x1b, 0x1c, 0x1d, 0x1e, 0x1f } };
	ret = rtl8651_assignVlanMacAddress( 3, &ether2, 1 );
	IS_EQUAL_INT( "assignVlanMacAddress(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk2", RTL8651_LL_VLAN, 3 );
	IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addExtNetworkInterface( "rtk2" );
	IS_EQUAL_INT( "addExtNetworkInterface(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addIpIntf( "rtk2", NAPT_INTF_RTK2, ntohl( inet_addr("255.255.255.0") ) );
	IS_EQUAL_INT( "addIpIntf(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addDriverNaptMapping( NAPT_INTF_RTK2 );
	IS_EQUAL_INT( "addNaptMappingExt(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// add default route
	ret = rtl8651_addRoute( ntohl( inet_addr( "0.0.0.0" ) ), ntohl( inet_addr( "0.0.0.0" ) ),
	                        "rtk1", ntohl( inet_addr( "140.113.214.254" ) ) );
	IS_EQUAL_INT( "addRoute(DefaultRoute) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// set port range
	ret = rtl8651_setNaptTcpUdpPortRange( 1024, 20480-1 );
	IS_EQUAL_INT( "rtl8651_setNaptTcpUdpPortRange() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// add local public
	ret = rtl8651_addLocalServer( NAPT_INTF_RTK1_2 );
	IS_EQUAL_INT( "rtl8651_addLocalServer() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}
	
	return FAILED;
}


//
// This is the routine to setup testing environment for NAPT table.
// Including:
//   2 network interfaces ( internal VLAN, 192.168.1.254/24,
//                          external VLAN, 140.113.214.102/24 <-- NAPT PPPOE Session )
//   2 VLANs
//
#define PPPOE_SESSION_ID1  1234
#define PPPOE_SESSION_ID2  4567
int8
ConfigNaptTestEnvironment2()
{
	uint32 ret;

	///////////////////////////////////////////////////////////////////////
	// internal interface
	
	ret = rtl8651_addNetworkIntf( "rtk0" );
	IS_EQUAL_INT( "addNetworkIntf(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ether_addr_t ether0 = { { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05 } };
	ret = rtl8651_assignVlanMacAddress( 1, &ether0, 1 );
	IS_EQUAL_INT( "assignVlanMacAddress(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk0", RTL8651_LL_VLAN, 1 );
	IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addIpIntf( "rtk0", NAPT_INTF_RTK0, ntohl( inet_addr("255.255.255.0") ) );
	IS_EQUAL_INT( "addIpIntf(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );


	///////////////////////////////////////////////////////////////////////
	// Add NAPT PPPoE session 1
	// See linux-2.4.x/drivers/net/re865x/re_core.c, re865x_ioctl(): case PPPOEUP_CFG.
	// lanType == PPPOECFGPARAM_LANTYPE_NAPT
	
	ret = rtl8651_addVlan( 2 );
	IS_EQUAL_INT( "addVlan(2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ether_addr_t ether1 = { { 0x00, 0x55, 0x66, 0x66, 0x55, 0x00 } };
	ret = rtl8651_assignVlanMacAddress( 2, &ether1, 1 );
	IS_EQUAL_INT( "assignVlanMacAddress(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNetworkIntf( "rtk1" );
	IS_EQUAL_INT( "addNetworkIntf(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk1", RTL8651_LL_PPPOE, 2 );
	IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addPppoeSession( PPPOE_SESSION_ID1, 2 );
	IS_EQUAL_INT( "rtl8651_addPppoeSession() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addIpIntf( "rtk1", NAPT_INTF_RTK1, (ipaddr_t)0xffffffff );
	IS_EQUAL_INT( "rtl8651_addIpIntf() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ether_addr_t serverMac = { { 00,11,22,33,44,00 } };
	ret = rtl8651_setPppoeSessionProperty( PPPOE_SESSION_ID1, 5566, &serverMac, 0 );
	IS_EQUAL_INT( "rtl8651_setPppoeSessionProperty() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_bindPppoeSession( NAPT_INTF_RTK1, PPPOE_SESSION_ID1 );
	IS_EQUAL_INT( "rtl8651_bindPppoeSession() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addExtNetworkInterface( "rtk1" );
	IS_EQUAL_INT( "addExtNetworkInterface(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	
	///////////////////////////////////////////////////////////////////////
	// Add NAPT PPPoE session 2
	// See linux-2.4.x/drivers/net/re865x/re_core.c, re865x_ioctl(): case PPPOEUP_CFG.
	// lanType == PPPOECFGPARAM_LANTYPE_NAPT

	ret = rtl8651_addVlan( 3 );
	IS_EQUAL_INT( "addVlan(3) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ether_addr_t ether2 = { { 0x00, 0x22, 0x66, 0x66, 0x22, 0x00 } };
	ret = rtl8651_assignVlanMacAddress( 3, &ether2, 1 );
	IS_EQUAL_INT( "assignVlanMacAddress(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNetworkIntf( "rtk2" );
	IS_EQUAL_INT( "addNetworkIntf(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk2", RTL8651_LL_PPPOE, 3 );
	IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addPppoeSession( PPPOE_SESSION_ID2, 3 );
	IS_EQUAL_INT( "rtl8651_addPppoeSession() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addIpIntf( "rtk2", NAPT_INTF_RTK2, (ipaddr_t)0xffffffff );
	IS_EQUAL_INT( "rtl8651_addIpIntf(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ether_addr_t serverMac2 = { { 00,22,66,66,22,00 } };
	ret = rtl8651_setPppoeSessionProperty( PPPOE_SESSION_ID2, 2266, &serverMac2, 0 );
	IS_EQUAL_INT( "rtl8651_setPppoeSessionProperty() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_bindPppoeSession( NAPT_INTF_RTK2, PPPOE_SESSION_ID2 );
	IS_EQUAL_INT( "rtl8651_bindPppoeSession() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addExtNetworkInterface( "rtk2" );
	IS_EQUAL_INT( "addExtNetworkInterface(rtk2) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	
	///////////////////////////////////////////////////////////////////////
	// add default route
	ret = rtl8651_addRoute( ntohl( inet_addr( "0.0.0.0" ) ), ntohl( inet_addr( "0.0.0.0" ) ),
	                        "rtk1", 0 );
	IS_EQUAL_INT( "addRoute(DefaultRoute) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// add napt mapping
	ret = rtl8651_addNaptMapping( NAPT_INTF_RTK1 );
	IS_EQUAL_INT( "addNaptMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// set port range
	ret = rtl8651_setNaptTcpUdpPortRange( 1024, 20480-1 );
	IS_EQUAL_INT( "rtl8651_setNaptTcpUdpPortRange() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// multicast related setting
	{
		rtl8651_tblDrvMCastPara_t para;

		para.MCastUpstream_Timeout	= 0xffffffff;
		para.MCastMember_ExpireTime	= 0xffffffff;
		para.igmp_sqi					= 0xffffffff;
		para.igmp_sqc				= 0;	// disable startup query
		para.igmp_response_tolerance_delay	= 0xffffffff;
		para.igmp_qri					= 0xffffffff;
		para.igmp_qi					= 0xffffffff;
		para.igmp_oqpi				= 0xffffffff;
		para.igmp_lmqi				= 0xffffffff;
		para.igmp_lmqc				= 0;
		para.igmp_group_query_interval	= 0xffffffff;
		ASSERT(rtl8651_multicastSetPara(&para) == SUCCESS);
		rtl8651_multicastPeriodicQuery(FALSE);		// disable periodically query
	}
	
	return FAILED;
}


/*
@func int32		| NaptAddConnectionError	| NAPT error exception handle
@rvalue SUCCESS	| test OK
@comm 
This function is used to test if _rtl8651_addNaptConnection() can detect the error.
*/
int32 NaptAddConnectionError(uint32 caseNo) 
{
	uint32 IntIp;
	uint16 IntPort;
	uint32 RemIp;
	uint16 RemPort;
	uint32 ExtIp;
	uint16 ExtPort;
	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	///////////////////////////////////////////////////////////////
	// Case 1: IntIp is not a LAN IP.
	//
	IntIp = ntohl( inet_addr("10.113.3.107") );
	IntPort = 1025;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_ENOTINTIP, __FUNCTION__, __LINE__ );


	///////////////////////////////////////////////////////////////
	// Case 2: RemIp is a Local Public Ip.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	RemIp= NAPT_INTF_RTK1_2;
	RemPort= 80;
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EDSTIPISLS, __FUNCTION__, __LINE__ );


	///////////////////////////////////////////////////////////////
	// Case 3: ExtIp is not a WAN IP.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	ExtIp = ntohl( inet_addr("140.113.214.254") );
	ExtPort = 1234;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EINVEXTIP, __FUNCTION__, __LINE__ );


	///////////////////////////////////////////////////////////////
	// Case 4: ExtPort is 0.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 0;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EINVL4PORTNUM, __FUNCTION__, __LINE__ );


	///////////////////////////////////////////////////////////////
	// Case 5: Duplicate Connection.
	//
	// Case 5.1: first L1, then L1
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EDRVNAPTEXIST, __FUNCTION__, __LINE__ );
	
	// Case 5.2: first L1, then L2
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1027;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1027;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 1027;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EDRVNAPTEXIST, __FUNCTION__, __LINE__ );
	
	// Case 5.3: first L2, then L1
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1029;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 1029;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1029;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EDRVNAPTEXIST, __FUNCTION__, __LINE__ );

	// Case 5.4: first L2, then L2
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1031;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 1031;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1031;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 1031;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EDRVNAPTEXIST, __FUNCTION__, __LINE__ );


	///////////////////////////////////////////////////////////////
	// Case 6: Duplicate ExtPort
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1111;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 1033;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 2132;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 1033;
	RemIp= ntohl( inet_addr("140.113.1.1") );
	RemPort= 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EINVALIDEXTPORT, __FUNCTION__, __LINE__ );


	return SUCCESS;
}


#ifdef CONFIG_RTL865XB_EXP_HASH2
#else//CONFIG_RTL865XB_EXP_HASH2
/*
@func int32		| NaptTypicalCase	| NAPT typical case
@rvalue SUCCESS	| test OK
@comm 
This is the typical case of 8651: Hash 1 hardware accelerated.
Only one entry would be write to ASIC.
*/
int32 NaptTypicalCase(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1025;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	uint32 ExtIp;
	uint16 ExtPort;
	int32 ret;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
	                                               RemIp, RemPort );
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort >> RTL8651_TCPUDPTBL_BITS, rtl8651GlobalControl.l4PortRangeStart, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry */
	Entry1.insideLocalIpAddr	= IntIp;
	Entry1.insideLocalPort		= IntPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= TRUE; // always true. FALSE;
	Entry1.isStatic				= TRUE;
	Entry1.isValid				= TRUE;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );

	return SUCCESS;
}


/*
@func int32		| NaptTypicalCaseRandomTest	| NAPT random test
@rvalue SUCCESS	| test OK
@comm 
Random test for addNaptConnection().
*/
int32 NaptTypicalCaseRandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 4096

	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 isTcp[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	uint32 RemIp[MAX_CONN];
	uint16 RemPort[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	uint32 ASIC[RTL8651_TCPUDPTBL_SIZE];	// -1: this line is empty; other: the index of the using connection.
	int32 ret, i, j, loopCount;
	uint16 idx1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		// initial ASIC
		for( i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++ )
			ASIC[i] = -1;

		//
		// Add Connections
		//
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]%d\n", loopCount, i );
			// give the random values
regen:
			isTcp[i] = random() & 1;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			IntPort[i] = random() % 9216 + 1024;
			ExtIp[i] = ntohl( inet_addr("140.113.214.102") );
			ExtPort[i] = random() % 9216 + 1024;
			do
			{
				RemIp[i] = random();
			} while( ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("192.168.1.0") ) ) ||
			         ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("140.113.214.0") ) ) );
			RemPort[i] = random() % 9216 + 1024;

			// is (isTcp,IntIp,IntPort) duplicated?
			for( j = 0; j < i; j++ )
				if ( isTcp[i] == isTcp[j] &&
				     IntIp[i] == IntIp[j] && 
				     IntPort[i] == IntPort[j] ) goto regen;

			idx1 = rtl8651_naptTcpUdpTableIndex( isTcp[i], IntIp[i], IntPort[i], 
			                                               RemIp[i], RemPort[i] );
			                                               
			ret = rtl8651_addNaptConnection( FALSE, isTcp[i]?TCP_ESTABLISHED_FLOW:UDP_FLOW,
			                                 IntIp[i], IntPort[i], 
			                                 &ExtIp[i], &ExtPort[i],
			                                 RemIp[i], RemPort[i] );
			IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp[i], NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort[i] & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );


			///////////////////////////////////////////////////////////////
			// Once we added the connection successfully, 
			//   we should be able to get the information of the connection.
			// Test _rtl8651_findNaptConnectionByExtPort()
			rtl8651_tblDrv_naptTcpUdpFlowEntry_t E, *entry;
			entry = _rtl8651_findNaptConnectionByExtPort( isTcp[i], ExtPort[i] );
			assert( entry );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_findNaptConnectionByTuple()
			entry = _rtl8651_findNaptConnectionByTuple( isTcp[i], ExtPort[i], RemIp[i], RemPort[i] );
			assert( entry );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_getOutboundNaptFlow()
			entry = &E;
			ret = _rtl8651_getOutboundNaptFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_getInboundNaptFlow()
			entry = &E;
			ret = _rtl8651_getInboundNaptFlow( isTcp[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );


			///////////////////////////////////////////////////////////////
			// We expect the connection is ASIC accelerated if the ASIC entry is free.
			memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
			if ( ASIC[idx1] == -1 )
			{
				// ASIC should be empty, we expect it can be hardware accelerated.
				/* Expected TCPUDP Entry */
				//printf( "[%4d] ASIC should be empty\n", i );
				Entry1.insideLocalIpAddr	= IntIp[i];
				Entry1.insideLocalPort		= IntPort[i];
				Entry1.ageSec				= isTcp[i] ?_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) :_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
				Entry1.tcpFlag				= isTcp[i] ?(TCP_ESTABLISHED_FLOW - 1) :0;
				Entry1.offset				= ExtPort[i] >> RTL8651_TCPUDPTBL_BITS;
				Entry1.isTcp				= isTcp[i];
				Entry1.isCollision			= TRUE; // always true. FALSE;
				Entry1.isStatic				= TRUE;
				Entry1.isValid				= TRUE;

				ASIC[idx1] = i;
			}
			else
			{
				// ASIC should be in-used, we expect the ASIC is the origin one.
				/* Expected TCPUDP Entry */
				//printf( "[%4d] ASIC should be in-used\n", i );
				Entry1.insideLocalIpAddr	= IntIp[ASIC[idx1]];
				Entry1.insideLocalPort		= IntPort[ASIC[idx1]];
				Entry1.ageSec				= isTcp[ASIC[idx1]] ?_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) :_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
				Entry1.tcpFlag				= isTcp[ASIC[idx1]] ?(TCP_ESTABLISHED_FLOW - 1) :0;
				Entry1.offset				= ExtPort[ASIC[idx1]] >> RTL8651_TCPUDPTBL_BITS;
				Entry1.isTcp				= isTcp[ASIC[idx1]];
				Entry1.isCollision			= TRUE;
				Entry1.isStatic				= TRUE;
				Entry1.isValid				= TRUE;
			}

			/* Read TCPUDP Entry */
			memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
			ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
			TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );

		}

		//
		// Del Connections
		//
		for( i = 0; i < MAX_CONN; i++ )
		{
			idx1 = rtl8651_naptTcpUdpTableIndex( isTcp[i], IntIp[i], IntPort[i], 
			                                               RemIp[i], RemPort[i] );
			ret = rtl8651_delNaptConnection( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i] );
			IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			// Look if the collision bit should be set to TRUE ?
			uint32 ColBit = FALSE;
			for( j = i + 1; j < MAX_CONN; j++ )
			{
				if ( ( ExtPort[j] & (RTL8651_TCPUDPTBL_SIZE-1) ) == idx1 )
				{
					ColBit = TRUE;
					break;
				}
			}

			// only TCP connection will be deleted soon
			if ( ASIC[idx1] == i ) ASIC[idx1] = -1;
				
			// if the ASIC is hold by this connection, clear it, and the Collision bit should be refreshed.
			memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
			if ( ASIC[idx1] == -1 )
			{
				/* Expected TCPUDP Entry */
				Entry1.insideLocalIpAddr	= 0;
				Entry1.insideLocalPort		= 0;
				Entry1.ageSec				= 0;
				Entry1.tcpFlag				= 0;
				Entry1.offset				= 0;
				Entry1.isTcp				= 0;
				Entry1.isCollision			= TRUE; // always true. ColBit;
				Entry1.isStatic				= FALSE;
				Entry1.isValid				= FALSE;
			}
			else
			{
				/* Expected TCPUDP Entry */
				Entry1.insideLocalIpAddr	= IntIp[ASIC[idx1]];
				Entry1.insideLocalPort		= IntPort[ASIC[idx1]];
				Entry1.ageSec				= isTcp[ASIC[idx1]] ?_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) :_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
				Entry1.tcpFlag				= isTcp[ASIC[idx1]] ?(TCP_ESTABLISHED_FLOW - 1) :0;
				Entry1.offset				= ExtPort[ASIC[idx1]] >> RTL8651_TCPUDPTBL_BITS;
				Entry1.isTcp				= isTcp[ASIC[idx1]];
				Entry1.isCollision			= TRUE; // always true. ColBit;
				Entry1.isStatic				= TRUE;
				Entry1.isValid				= TRUE;
			}

			/* Read TCPUDP Entry */
			memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
			ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
			TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );
			
		}
	}

	return SUCCESS;
}


/*
@func int32		| NaptHash1Hash2RandomTest	| NAPT random test (with hash2)
@rvalue SUCCESS	| test OK
@comm 
Random test for addNaptConnection() with hybrid hash1 and hash2 connections.
*/
int32 NaptHash1Hash2RandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 4096

	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 assigned[MAX_CONN];
	uint32 isTcp[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	uint32 RemIp[MAX_CONN];
	uint16 RemPort[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	uint32 ASIC[RTL8651_TCPUDPTBL_SIZE];	// -1: this line is empty; other: the index of the using connection.
	int32 ret, i, j, loopCount;
	uint16 idx1, idx2, idxCol;
	uint32 ColBit;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 10; loopCount++ )
	{
		// initial ASIC
		for( i = 0; i < RTL8651_TCPUDPTBL_SIZE; i++ )
			ASIC[i] = -1;

		//
		// Add Connections
		//
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]%d\n", loopCount, i );
			// give the random values
			regen:
			assigned[i] = random() & 1;
			isTcp[i] = random() & 1;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			IntPort[i] = random() % 9216 + 1024;
			ExtIp[i] = ntohl( inet_addr("140.113.214.102") );
			ExtPort[i] = random() % 9216 + 1024;
			do
			{
				RemIp[i] = random();
			} while( ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("192.168.1.0") ) ) ||
			         ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("140.113.214.0") ) ) );
			RemPort[i] = random() % 9216 + 1024;

			for( j = 0; j < i; j++ )
			{
				// Port overlapped, skip.
				if ( ( IntIp[j] == IntIp[i] && IntPort[j] == IntPort[i] ) ||
				     ( ExtIp[j] == ExtIp[i] && ExtPort[j] == ExtPort[i] ) )
				{
					goto regen;
				}
			}
			
			// printf("i:[%d]%d assigned:%d isTcp:%d Int(%x:%d) Ext(%x:%d) Rem(%x:%d)\n", loopCount, i, assigned[i], isTcp[i], IntIp[i], IntPort[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i] );

			idx1 = rtl8651_naptTcpUdpTableIndex( isTcp[i], IntIp[i], IntPort[i], 
			                                               RemIp[i], RemPort[i] );

			idx2 = rtl8651_naptTcpUdpTableIndex( isTcp[i], IntIp[i], IntPort[i], 
			                                               0, 0 );

			ret = rtl8651_addNaptConnection( assigned[i], isTcp[i]?TCP_ESTABLISHED_FLOW:UDP_FLOW,
			                                 IntIp[i], IntPort[i], 
			                                 &ExtIp[i], &ExtPort[i],
			                                 RemIp[i], RemPort[i] );
			IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
			if ( assigned[i] == FALSE )
			{
				// If the user does NOT assign ExtIp and ExtPort, addNaptConnection() should assign.
				IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp[i], NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
				IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort[i] & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );
			}


			///////////////////////////////////////////////////////////////
			// Once we added the connection successfully, 
			//   we should be able to get the information of the connection.
			// Test _rtl8651_findNaptConnectionByExtPort()
			rtl8651_tblDrv_naptTcpUdpFlowEntry_t E, *entry;
			entry = _rtl8651_findNaptConnectionByExtPort( isTcp[i], ExtPort[i] );
			assert( entry );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_findNaptConnectionByTuple()
			entry = _rtl8651_findNaptConnectionByTuple( isTcp[i], ExtPort[i], RemIp[i], RemPort[i] );
			assert( entry );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_getOutboundNaptFlow()
			entry = &E;
			ret = _rtl8651_getOutboundNaptFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_getInboundNaptFlow()
			entry = &E;
			ret = _rtl8651_getInboundNaptFlow( isTcp[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );


			///////////////////////////////////////////////////////////////
			// We expect the connection is ASIC-accelerated in following situation:
			//   The ASIC entry is free if
			//     1.the entry is added by hash1 algorithm.
			//     2.the entry is added by hash2 algorithm and the idx1 is equal to ExtPort.
			memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
			if ( assigned[i] == FALSE || 
			     ( assigned[i] == TRUE && idx1 == (ExtPort[i]&(RTL8651_TCPUDPTBL_SIZE-1)) ) )
			{
				//
				//  This connection can be ASIC-accelerated.
				//
				
				// Look if the collision bit should be set to TRUE ?
				ColBit = FALSE;
				for( j = 0; j < i; j++ )
				{
					// out-bound
					idxCol = rtl8651_naptTcpUdpTableIndex( isTcp[j], IntIp[j], IntPort[j], 
					                                                 RemIp[j], RemPort[j] );
					if ( idxCol == idx1 )
					{
						//printf("j:[%d]%d assigned:%d isTcp:%d Int(%x:%d) Ext(%x:%d) Rem(%x:%d)\n", loopCount, j, assigned[j], isTcp[j], IntIp[j], IntPort[j], ExtIp[j], ExtPort[j], RemIp[j], RemPort[j] );
						ColBit = TRUE;
						break;
					}
					
					// in-bound
					if ( ( ExtPort[j] & (RTL8651_TCPUDPTBL_SIZE-1) ) == idx1 )
					{
						//printf("j:[%d]%d assigned:%d isTcp:%d Int(%x:%d) Ext(%x:%d) Rem(%x:%d)\n", loopCount, j, assigned[j], isTcp[j], IntIp[j], IntPort[j], ExtIp[j], ExtPort[j], RemIp[j], RemPort[j] );
						ColBit = TRUE;
						break;
					}
				}

				if ( ASIC[idx1] == -1 )
				{
					// ASIC should be empty, we expect it can be hardware accelerated.
					//The ASIC is free, and connection can be ASIC-accelerated.
					//printf("The ASIC is free, and connection can be ASIC-accelerated.\n");
					Entry1.insideLocalIpAddr	= IntIp[i];
					Entry1.insideLocalPort		= IntPort[i];
					Entry1.ageSec				= isTcp[i] ?_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) :_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
					Entry1.tcpFlag				= isTcp[i] ?(TCP_ESTABLISHED_FLOW - 1) :0;
					Entry1.offset				= ExtPort[i] >> RTL8651_TCPUDPTBL_BITS;
					Entry1.isTcp				= isTcp[i];
					Entry1.isCollision			= TRUE; // always true. ColBit;
					Entry1.isStatic				= TRUE;
					Entry1.isValid				= TRUE;

					ASIC[idx1] = i;
				}
				else
				{
					// ASIC should be in-used, and we expect the ASIC is the origin one.
					//printf("ASIC should be in-used, and we expect the ASIC is the origin one.\n");
					Entry1.insideLocalIpAddr	= IntIp[ASIC[idx1]];
					Entry1.insideLocalPort		= IntPort[ASIC[idx1]];
					Entry1.ageSec				= isTcp[ASIC[idx1]] ?_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) :_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
					Entry1.tcpFlag				= isTcp[ASIC[idx1]] ?(TCP_ESTABLISHED_FLOW - 1) :0;
					Entry1.offset				= ExtPort[ASIC[idx1]] >> RTL8651_TCPUDPTBL_BITS;
					Entry1.isTcp				= isTcp[ASIC[idx1]];
					Entry1.isCollision			= TRUE; // always true. ColBit;
					Entry1.isStatic				= TRUE;
					Entry1.isValid				= TRUE;
				}
				
				/* Read TCPUDP Entry */
				memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
				ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
				//_dump_naptTcpUdpParam( idx1, &Entry0 );
				TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );
			}
			else
			{
				//
				//	This connection CANNOT be ASIC-accelerated.
				//  So we do not check ASIC entry.
				//
			}
		}

		//
		// Del Connections
		//
		for( i = 0; i < MAX_CONN; i++ )
		{
			// printf("i:[%d]%d assigned:%d isTcp:%d Int(%x:%d) Ext(%x:%d) Rem(%x:%d)\n", loopCount, i, assigned[i], isTcp[i], IntIp[i], IntPort[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i] );
			idx1 = rtl8651_naptTcpUdpTableIndex( isTcp[i], IntIp[i], IntPort[i], 
			                                               RemIp[i], RemPort[i] );
			ret = rtl8651_delNaptConnection( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i] );
			IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			// Look if the collision bit should be set to TRUE ?
			ColBit = FALSE;
			for( j = i + 1; j < MAX_CONN; j++ )
			{
				// out-bound
				idxCol = rtl8651_naptTcpUdpTableIndex( isTcp[j], IntIp[j], IntPort[j], 
				                                                 RemIp[j], RemPort[j] );
				if ( idxCol == idx1 )
				{
					//printf("j:[%d]%d assigned:%d isTcp:%d Int(%x:%d) Ext(%x:%d) Rem(%x:%d)\n", loopCount, j, assigned[j], isTcp[j], IntIp[j], IntPort[j], ExtIp[j], ExtPort[j], RemIp[j], RemPort[j] );
					ColBit = TRUE;
					break;
				}
				
				// in-bound
				if ( ( ExtPort[j] & (RTL8651_TCPUDPTBL_SIZE-1) ) == idx1 )
				{
					ColBit = TRUE;
					break;
				}
			}

			if ( assigned[i] == FALSE ||
			     ( assigned[i] == TRUE && idx1 == (ExtPort[i]&(RTL8651_TCPUDPTBL_SIZE-1)) ) )
			{
				// This connection can be ASIC-accelerated.
				
				// If this connection is ASIC-accelerated, the ASIC-entry should be cleared.
				if ( ASIC[idx1] == i ) ASIC[idx1] = -1;
					
				memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
				if ( ASIC[idx1] == -1 )
				{
					// The ASIC entry is expected to be cleared.
					/* Expected TCPUDP Entry */
					Entry1.insideLocalIpAddr	= 0;
					Entry1.insideLocalPort		= 0;
					Entry1.ageSec				= 0;
					Entry1.tcpFlag				= 0;
					Entry1.offset				= 0;
					Entry1.isTcp				= 0;
					Entry1.isCollision			= TRUE; // always true. ColBit;
					Entry1.isStatic				= FALSE;
					Entry1.isValid				= FALSE;
				}
				else
				{
					// The ASIC entry is expected as origin one.
					/* Expected TCPUDP Entry */
					Entry1.insideLocalIpAddr	= IntIp[ASIC[idx1]];
					Entry1.insideLocalPort		= IntPort[ASIC[idx1]];
					Entry1.ageSec				= isTcp[ASIC[idx1]] ?_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) :_rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
					Entry1.tcpFlag				= isTcp[ASIC[idx1]] ?(TCP_ESTABLISHED_FLOW - 1) :0;
					Entry1.offset				= ExtPort[ASIC[idx1]] >> RTL8651_TCPUDPTBL_BITS;
					Entry1.isTcp				= isTcp[ASIC[idx1]];
					Entry1.isCollision			= TRUE; // always true. ColBit;
					Entry1.isStatic				= TRUE;
					Entry1.isValid				= TRUE;
				}

				/* Read TCPUDP Entry */
				memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
				ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
				TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );
			}
		}
	}

	return SUCCESS;
}


/*
@func int32		| NaptAddAlgCtrlConnectionRandomTest	| NAPT ALG control connection random test
@rvalue SUCCESS	| test OK
@comm 
Random test for addAlgCtrlConnection().
*/
int32 NaptAddAlgCtrlConnectionRandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 4096

	uint32 isTcp[MAX_CONN];
	uint32 forced[MAX_CONN];
	uint32 flowtype[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	uint32 RemIp[MAX_CONN];
	uint16 RemPort[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t E, *entry;
	int32 i, loopCount, ret;
	uint16 idx2;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		//
		// Add Connections
		//
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[loop=%d,i=%d]\n", loopCount, i );
			// give the random values
			forced[i] = FALSE;
			flowtype[i] = random() % 5;
			isTcp[i] = flowtype[i] ?TRUE :FALSE;
			if ( flowtype[i] == 4 ) flowtype[i] = TCP_ESTABLISHED_FLOW;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			IntPort[i] = random() % 9216 + 1024;
			ExtIp[i] = ntohl( inet_addr("140.113.214.102") );
			ExtPort[i] = random() % 9216 + 1024;
			do
			{
				RemIp[i] = random();
			} while( ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("192.168.1.0") ) ) ||
			         ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("140.113.214.0") ) ) );
			RemPort[i] = random() % 9216 + 1024;

			idx2 = rtl8651_naptTcpUdpTableIndex( isTcp[i], IntIp[i], IntPort[i], 
			                                               0, 0 );
			entry = _rtl8651_addAlgCtrlConnection( forced[i], flowtype[i],
			                                       IntIp[i], IntPort[i], 
			                                       &ExtIp[i], &ExtPort[i],
			                                       RemIp[i], RemPort[i] );
			IS_NOT_EQUAL_POINTER( "_rtl8651_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp[i], NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
			if ( forced[i] == FALSE ) IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort[i] & (RTL8651_TCPUDPTBL_SIZE-1), idx2, __FUNCTION__, __LINE__ );


			///////////////////////////////////////////////////////////////
			// Once we added the connection successfully, 
			//   we should be able to get the information of the connection.
			// Test _rtl8651_findNaptConnectionByExtPort()
			assert( NULL == _rtl8651_findNaptConnectionByExtPort( isTcp[i], ExtPort[i] ) );

			// Test _rtl8651_findNaptConnectionByTuple()
			assert( NULL == _rtl8651_findNaptConnectionByTuple( isTcp[i], ExtPort[i], RemIp[i], RemPort[i] ) );

			// Test _rtl8651_getOutboundAlgCtrlFlow()
			entry = &E;
			ret = _rtl8651_getOutboundAlgCtrlFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "hashing is different.", entry->hashing, NAPT_LIBERAL_HASHING, __FUNCTION__, __LINE__ );

			// Test _rtl8651_getInboundAlgCtrlFlow()
			entry = &E;
			ret = _rtl8651_getInboundAlgCtrlFlow( isTcp[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_getOutboundNaptFlow()
			entry = &E;
			ret = _rtl8651_getOutboundNaptFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );

			// Test _rtl8651_getInboundNaptFlow()
			entry = &E;
			ret = _rtl8651_getInboundNaptFlow( isTcp[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i], &entry );
			assert( SUCCESS == ret );
			IS_EQUAL_INT( "isTcp is different.", entry->tcp , isTcp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", entry->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntPort is different.", entry->insideLocalPort, IntPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", entry->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtPort is different.", entry->insideGlobalPort, ExtPort[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different.", entry->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemPort is different.", entry->dstPort, RemPort[i], __FUNCTION__, __LINE__ );


		}

		// delete all
		_rtl8651_timeUpdate( rtl8651GlobalControl.tcpLongTimeout * 2 );

		int count = 0;
		for( i = 0; i < MAX_CONN; i++ )
		{
			entry = &E;
			if ( SUCCESS == _rtl8651_getOutboundAlgCtrlFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry ) )
				count++;

			entry = &E;
			if ( SUCCESS == _rtl8651_getInboundAlgCtrlFlow( isTcp[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i], &entry ) )
				count++;
				
			entry = &E;
			if ( SUCCESS == _rtl8651_getOutboundNaptFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry ) )
				count++;
				
			entry = &E;
			if ( SUCCESS == _rtl8651_getInboundNaptFlow( isTcp[i], ExtIp[i], ExtPort[i], RemIp[i], RemPort[i], &entry ) )
				count++;
		}
		IS_EQUAL_INT( "All connections should be deleted.", 0, count, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "inuseList should be zero.", 0, CTAILQ_TOTAL(&DrvTbl.inuseList.tcpudp), __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "freeList should be 4096.", MAX_CONN, CTAILQ_TOTAL(&DrvTbl.freeList.tcpudp), __FUNCTION__, __LINE__ );
		//break;
	}

	return SUCCESS;
}
#endif//CONFIG_RTL865XB_EXP_HASH2


/*
@func int32		| NaptTypicalCaseRandomTest	| NAPT ALG control connection error handle
@rvalue SUCCESS	| test OK
@comm 
This is used to test if _rtl8651_addAlgCtrlConnection() can detect the errors.
*/
int32 NaptAddAlgCtrlConnectionError(uint32 caseNo) 
{
	uint32 IntIp;
	uint16 IntPort;
	uint32 ExtIp;
	uint16 ExtPort;
	uint32 RemIp;
	uint16 RemPort;
 	int32 i;
 	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *entry;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();


	/////////////////////////////////////////////////////////////////////////////
	//  Case 1: RemIp is a Local Public IP address.
	//
	IntIp = ntohl( inet_addr("192.168.254.254") );
	IntPort = 1025;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 80;
	RemIp = ntohl( inet_addr("140.113.214.117") );
	RemPort = 80;
	
	entry = _rtl8651_addAlgCtrlConnection( FALSE, UDP_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 2: Adding a duplicate connection (outbound).
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 80;
	RemIp = ntohl( inet_addr("140.113.53.80") );
	RemPort = 80;
	
	entry = _rtl8651_addAlgCtrlConnection( FALSE, UDP_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_NOT_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );
	entry = _rtl8651_addAlgCtrlConnection( FALSE, UDP_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 3: _rtl8651_selectNaptPortOffset() failed.
	//
	IntIp = ntohl( inet_addr("192.168.1.13") );
	IntPort = 1024;

	for( i = 0;
	     i < rtl8651GlobalControl.l4PortRangeEnd - rtl8651GlobalControl.l4PortRangeStart + 1;
	     i++ )
	{
		RemIp = ntohl( inet_addr("144.40.3.0") ) + i;
		RemPort = i + 1111;

		entry = _rtl8651_addAlgCtrlConnection( FALSE, TCP_ESTABLISHED_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
		IS_NOT_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );
	}

	// The last one	
	RemIp = ntohl( inet_addr("144.40.3.0") ) + i;
	RemPort = i + 1111;
	entry = _rtl8651_addAlgCtrlConnection( FALSE, TCP_ESTABLISHED_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 4: Adding a duplicate connection (inbound).
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1027;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 80;
	RemIp = ntohl( inet_addr("140.113.53.80") );
	RemPort = 1199;
	
	entry = _rtl8651_addAlgCtrlConnection( TRUE, TCP_ESTABLISHED_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_NOT_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );
	entry = _rtl8651_addAlgCtrlConnection( TRUE, TCP_ESTABLISHED_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );
	

	/////////////////////////////////////////////////////////////////////////////
	//  Case 5: ExtIp or ExtPort is zero.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1027;
	ExtIp = ntohl( inet_addr("0.0.0.0") );
	ExtPort = 80;
	entry = _rtl8651_addAlgCtrlConnection( TRUE, UDP_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );

	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1027;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 0;
	entry = _rtl8651_addAlgCtrlConnection( TRUE, TCP_ESTABLISHED_FLOW, IntIp, IntPort, &ExtIp, &ExtPort, RemIp, RemPort );
	IS_EQUAL_POINTER( "_addAlgCtrlConnection() failed", entry, NULL, __FUNCTION__, __LINE__ );
	

	return SUCCESS;
}

/*
@func int32		| NaptPortRangeBug	| For Napt port range bug
@rvalue SUCCESS	| test OK
@comm 
This is the test case to confirm the selecting port range bug has been solved.
*/
int32 NaptPortRangeBug(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1025;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	uint32 ExtIp;
	uint16 ExtPort;
	int32 ret;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
	                                               RemIp, RemPort );
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	// set port range
	ret = rtl8651_setNaptTcpUdpPortRange( 32768, 65536 - 1 );
	IS_EQUAL_INT( "rtl8651_setNaptTcpUdpPortRange() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort >> RTL8651_TCPUDPTBL_BITS, rtl8651GlobalControl.l4PortRangeStart, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort >> RTL8651_TCPUDPTBL_BITS, 32, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry */
	Entry1.insideLocalIpAddr	= IntIp;
	Entry1.insideLocalPort		= IntPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= TRUE; // always true. FALSE;
	Entry1.isStatic				= TRUE;
	Entry1.isValid				= TRUE;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );

	return SUCCESS;
}


/*
@func int32		| NaptAddServerPortError	| Server Port error handle
@rvalue SUCCESS	| test OK
@comm 
This is used to test if rtl8651_addNaptServerPort* can detect errors.
*/
int32 NaptAddServerPortError(uint32 caseNo) 
{
	uint32 IntIp;
	uint16 IntPort;
	uint32 ExtIp;
	uint16 ExtPort;
 	int32 ret, i;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();


	/////////////////////////////////////////////////////////////////////////////
	//  Case 1: IntIp is not a LAN IP.
	//
	IntIp = ntohl( inet_addr("192.168.254.254") );
	IntPort = 1025;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 80;
	
	ret = rtl8651_addNaptServerPortMapping( FALSE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_ENOTINTIP, __FUNCTION__, __LINE__ );

 
	/////////////////////////////////////////////////////////////////////////////
	//  Case 2: ExtIp is not a WAn IP.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 1025;
	ExtIp = ntohl( inet_addr("140.113.254.254") );
	ExtPort = 80;
	
	ret = rtl8651_addNaptServerPortMapping( FALSE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_ENOTEXTIP, __FUNCTION__, __LINE__ );

 
	/////////////////////////////////////////////////////////////////////////////
	//  Case 3: ExtPort Range is overlapped.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 9999;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 9999;
	
	ret = rtl8651_addNaptServerPortRange( FALSE, ExtIp, ExtPort, IntIp, IntPort, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addNaptServerPortRange( FALSE, ExtIp, ExtPort + 9, IntIp, IntPort + 1000, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_ERANGEOVERLAP, __FUNCTION__, __LINE__ );

 
	/////////////////////////////////////////////////////////////////////////////
	//  Case 4: IntPort Range is overlapped.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 2049;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 2049;
	
	ret = rtl8651_addNaptServerPortRange( FALSE, ExtIp, ExtPort, IntIp, IntPort, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addNaptServerPortRange( FALSE, ExtIp, ExtPort + 1000, IntIp, IntPort + 9, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_ERANGEOVERLAP, __FUNCTION__, __LINE__ );

 
	/////////////////////////////////////////////////////////////////////////////
	//  Case 5: The overlapping port range, but different protocol.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 3333;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 4444;
	
	ret = rtl8651_addNaptServerPortRange( FALSE, ExtIp, ExtPort, IntIp, IntPort, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addNaptServerPortRange( TRUE, ExtIp, ExtPort, IntIp, IntPort, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptServerPortRange( FALSE, ExtIp, ExtPort, IntIp, IntPort, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_EENTRYALREADYEXIST, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_addNaptServerPortRange( TRUE, ExtIp, ExtPort, IntIp, IntPort, 10 );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_EENTRYALREADYEXIST, __FUNCTION__, __LINE__ );

 
	/////////////////////////////////////////////////////////////////////////////
	//  Case 6: Server Port is running out.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	IntPort = 5555;
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ExtPort = 6666;

	// We assume total 64 entries are allocated, and 3 of them are in-used.
	for( i = 0; i < 61; i++ )
	{
		ret = rtl8651_addNaptServerPortMapping( TRUE, ExtIp, ExtPort + i, IntIp, IntPort + i );
		IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}

	// No more one server port
	ret = rtl8651_addNaptServerPortMapping( TRUE, ExtIp, ExtPort + i, IntIp, IntPort + i );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, TBLDRV_ENOFREEBUFFER, __FUNCTION__, __LINE__ );
	
	return SUCCESS;
}


/*
@func int32		| NaptAddDelServerPort	| Server Port (test one entry)
@rvalue SUCCESS	| test OK
@comm 
Test for add/del Server Port.
*/
int32 NaptAddDelServerPort(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_serverPortParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1025;
	uint32 ExtIp = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort = 1025;
	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	/*************************************************************************************
	 *  Add
	 *************************************************************************************/
	ret = rtl8651_addNaptServerPortMapping( TRUE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

#ifdef SERVERPORT_PARK_TCPUDP
	/* In this mode, Server Port will be handled by software. */
	ASSERT(rtl8651_getAsicServerPortTable(0, &Entry0) != SUCCESS);
#else/*SERVERPORT_PARK_TCPUDP*/
	/* Expected Server Port Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	Entry1.extIpAddr = ExtIp;
	Entry1.extPort = ExtPort;
	Entry1.intIpAddr = IntIp;
	Entry1.intPort = IntPort;
	Entry1.valid = TRUE;
	/* Read Server Port Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	ASSERT(rtl8651_getAsicServerPortTable( 0, &Entry0 ) == SUCCESS);
	SP_ENTRY_CMP( &Entry0, &Entry1 );
#endif/*SERVERPORT_PARK_TCPUDP*/

	/*************************************************************************************
	 *  Delete
	 *************************************************************************************/
	ret = rtl8651_delNaptServerPortMapping( TRUE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "delNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	/* Read Server Port Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	ASSERT(rtl8651_getAsicServerPortTable( 0, &Entry0 ) == FAILED);
	
	return SUCCESS;
}


/*
@func int32		| NaptAddDelServerPortRandomTest	| Server Port random test (test ASIC)
@rvalue SUCCESS	| test OK
@comm 
Random Test for add/del Server Port (verify ASIC entry).
*/
int32 NaptAddDelServerPortRandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN RTL8651_SERVERPORTTBL_SIZE
	rtl865x_tblAsicDrv_serverPortParam_t Entry0, Entry1;
	uint32 isTcp[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	int32 ret, i, j, loopCount;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		for( i = 0; i < MAX_CONN; i++ )
		{
			// give the random values
			regen:
			isTcp[i] = random() & 1;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			IntPort[i] = random() % 9216 + 1024;
			ExtIp[i] = ntohl( inet_addr("140.113.214.102") );
			ExtPort[i] = random() % 9216 + 1024;

			for( j = 0; j < i; j++ )
			{
				if ( ExtIp[i] == ExtIp[j] &&
				     ExtPort[i] == ExtPort[j] )
				{
					goto regen;
				}
			}
		
			ret = rtl8651_addNaptServerPortMapping( TRUE, ExtIp[i], ExtPort[i], IntIp[i], IntPort[i] );
			IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

#ifdef SERVERPORT_PARK_TCPUDP
			/* In this mode, Server Port will be handled by software. */
			ASSERT(rtl8651_getAsicServerPortTable(0, &Entry0) != SUCCESS);
#else/*SERVERPORT_PARK_TCPUDP*/
			/* Expected TCPUDP Entry */
			memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
			Entry1.extIpAddr = ExtIp[i];
			Entry1.extPort = ExtPort[i];
			Entry1.intIpAddr = IntIp[i];
			Entry1.intPort = IntPort[i];
			Entry1.valid = TRUE;

			/* Read TCPUDP Entry */
			memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
			ASSERT(rtl8651_getAsicServerPortTable( i, &Entry0 ) == SUCCESS);
			SP_ENTRY_CMP( &Entry0, &Entry1 );
#endif/*SERVERPORT_PARK_TCPUDP*/
		}

		for( i = 0; i < MAX_CONN; i++ )
		{
			ret = rtl8651_delNaptServerPortMapping( TRUE, ExtIp[i], ExtPort[i], IntIp[i], IntPort[i] );
			IS_EQUAL_INT( "delNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			/* Expected TCPUDP Entry */
			memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));

			/* Read TCPUDP Entry */
			memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
			ASSERT(rtl8651_getAsicServerPortTable( i, &Entry0 ) == FAILED);
			SP_ENTRY_CMP( &Entry0, &Entry1 );
		}
	}
	
	return SUCCESS;
}


/*
@func int32		| NaptAddDelServerPortRandomTest	| Server Port random test (test software)
@rvalue SUCCESS	| test OK
@comm 
Random Test for add/del Server Port (verify software entry).
*/
int32 NaptAddDelServerPortRandomTest2(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 64
	uint32 isTcp[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	uint32 nCount[MAX_CONN];
	int32 ret, i, j, loopCount;
	rtl8651_tblDrv_naptServerPortEntry_t *sp;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		for( i = 0; i < MAX_CONN; i++ )
		{
			// give the random values
			regen:
			isTcp[i] = random() & 1;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			IntPort[i] = random() % 9216 + 1024;
			ExtIp[i] = ntohl( inet_addr("140.113.214.102") );
			ExtPort[i] = random() % 9216 + 1024;
			nCount[i] = random() % 2 + 1;

			uint32 bOverlap = FALSE;
			for( j = 0; j < i; j++ )
			{
				if ( ( IntIp[j] == IntIp[i] &&
				       ( ( IntPort[j] >= IntPort[i] && IntPort[j] <= IntPort[i]+nCount[i]-1 ) ||
				         ( IntPort[j]+nCount[j]-1 >= IntPort[i] && IntPort[j]+nCount[j]-1 <= IntPort[i]+nCount[i]-1 ) ||
				         ( IntPort[j] >= IntPort[i] && IntPort[j]+nCount[j]-1 <= IntPort[i]+nCount[i]-1 ) ||
				         ( IntPort[j] <= IntPort[i] && IntPort[j]+nCount[j]-1 >= IntPort[i]+nCount[i]-1 ) ) ) ||
				     ( ExtIp[j] == ExtIp[i] &&
				       ( ( ExtPort[j] >= ExtPort[i] && ExtPort[j] <= ExtPort[i]+nCount[i]-1 ) ||
				         ( ExtPort[j]+nCount[j]-1 >= ExtPort[i] && ExtPort[j]+nCount[j]-1 <= ExtPort[i]+nCount[i]-1 ) ||
				         ( ExtPort[j] >= ExtPort[i] && ExtPort[j]+nCount[j]-1 <= ExtPort[i]+nCount[i]-1 ) ||
				         ( ExtPort[j] <= ExtPort[i] && ExtPort[j]+nCount[j]-1 >= ExtPort[i]+nCount[i]-1 ) ) ) )
				{
					// Port overlapped, skip.
					bOverlap = TRUE;
					break;
				}
			}
			if ( bOverlap ) goto regen;
			
			//printf("[%d]: isTcp[%d], ExtIp[%x], ExtPort[%d], IntIp[%x], IntPort[%d], nCount[%d]\n", i, isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			
			if ( nCount[i] == 1 )		
				ret = rtl8651_addNaptServerPortMapping( isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i] );
			else
				ret = rtl8651_addNaptServerPortRange( isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			/* Query in Software (Outside) */
			sp = _rtl8651_getOutsideNaptServerPortMapping( isTcp[i], ExtIp[i], ExtPort[i] );
			IS_NOT_EQUAL_POINTER( "getOutsideNaptServerPortMapping() failed", NULL, sp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "isTcp is different.", isTcp[i], sp->tcp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", ExtIp[i], sp->globalIp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "lowerExtPort is different.", ExtPort[i], sp->globalPort, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "upperExtPort is different.", ExtPort[i]+nCount[i]-1, sp->endGlobalPort, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", IntIp[i], sp->localIp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "lowerIntPort is different.", IntPort[i], sp->localPort, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "upperIntPort is different.", IntPort[i]+nCount[i]-1, sp->endLocalPort, __FUNCTION__, __LINE__ );

			/* Query in Software (Inside) */
			sp = _rtl8651_getInsideNaptServerPortMapping( isTcp[i], IntIp[i], IntPort[i] );
			IS_NOT_EQUAL_POINTER( "getOutsideNaptServerPortMapping() failed", NULL, sp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "isTcp is different.", isTcp[i], sp->tcp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different.", ExtIp[i], sp->globalIp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "lowerExtPort is different.", ExtPort[i], sp->globalPort, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "upperExtPort is different.", ExtPort[i]+nCount[i]-1, sp->endGlobalPort, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", IntIp[i], sp->localIp, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "lowerIntPort is different.", IntPort[i], sp->localPort, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "upperIntPort is different.", IntPort[i]+nCount[i]-1, sp->endLocalPort, __FUNCTION__, __LINE__ );

		}

			//printf("==================================\n");

		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]: isTcp[%d], ExtIp[%x], ExtPort[%d], IntIp[%x], IntPort[%d], nCount[%d]\n", i, isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			
			if ( nCount[i] == 1 )		
				ret = rtl8651_delNaptServerPortMapping( isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i] );
			else
				ret = rtl8651_delNaptServerPortRange( isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			IS_EQUAL_INT( "delNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}
	}
	
	return SUCCESS;
}


/*
@func int32		| NaptFlushNaptServerPortbyExtIpRandomTest	| random test for rtl8651_flushNaptServerPortbyExtIp()
@rvalue SUCCESS	| test OK
@comm 
Random Test for rtl8651_flushNaptServerPortbyExtIp().
*/
int32 NaptFlushNaptServerPortbyExtIpRandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 64
	uint32 isTcp[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	uint32 nCount[MAX_CONN];
	uint32 sessId[MAX_CONN];
	int32 ret, i, j, loopCount;

	START_TEST_CASE();
	ConfigNaptTestEnvironment2();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]%d\n", loopCount, i );
			// give the random values
			regen:
			isTcp[i] = random() & 1;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			IntPort[i] = random() % 9216 + 1024;
			if ( ( random() & 1 ) == 1 )
			{
				ExtIp[i] = ntohl(inet_addr("140.113.214.102"));
				sessId[i] = PPPOE_SESSION_ID1;
			}
			else
			{
				ExtIp[i] = ntohl(inet_addr("140.113.131.53"));
				sessId[i] = PPPOE_SESSION_ID2;
			}
			ExtPort[i] = random() % 9216 + 1024;
			nCount[i] = random() % 2 + 1;

			uint32 bOverlap = FALSE;
			for( j = 0; j < i; j++ )
			{
				if ( ( IntIp[j] == IntIp[i] &&
				       ( ( IntPort[j] >= IntPort[i] && IntPort[j] <= IntPort[i]+nCount[i]-1 ) ||
				         ( IntPort[j]+nCount[j]-1 >= IntPort[i] && IntPort[j]+nCount[j]-1 <= IntPort[i]+nCount[i]-1 ) ||
				         ( IntPort[j] >= IntPort[i] && IntPort[j]+nCount[j]-1 <= IntPort[i]+nCount[i]-1 ) || 
				         ( IntPort[j] <= IntPort[i] && IntPort[j]+nCount[j]-1 >= IntPort[i]+nCount[i]-1 ) ) ) ||
				     ( ExtIp[j] == ExtIp[i] &&
				       ( ( ExtPort[j] >= ExtPort[i] && ExtPort[j] <= ExtPort[i]+nCount[i]-1 ) ||
				         ( ExtPort[j]+nCount[j]-1 >= ExtPort[i] && ExtPort[j]+nCount[j]-1 <= ExtPort[i]+nCount[i]-1 ) ||
				         ( ExtPort[j] >= ExtPort[i] && ExtPort[j]+nCount[j]-1 <= ExtPort[i]+nCount[i]-1 ) ||
				         ( ExtPort[j] <= ExtPort[i] && ExtPort[j]+nCount[j]-1 >= ExtPort[i]+nCount[i]-1 ) ) ) )
				{
					// Port overlapped, skip.
					bOverlap = TRUE;
					break;
				}
			}
			if ( bOverlap ) goto regen;
			
			//printf("[%d]: isTcp[%d], ExtIp[%x], ExtPort[%d], IntIp[%x], IntPort[%d], nCount[%d]\n", i, isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			
			if ( nCount[i] == 1 )		
				ret = rtl8651a_addNaptServerPortMapping( sessId[i], isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i] );
			else
				ret = rtl8651a_addNaptServerPortRange( sessId[i], isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}

		///////////////////////////////////////////////////////////////
		// call rtl8651_flushNaptServerPortbyExtIp() in random order
		//
		if ( ( random() & 1 ) == 1 )
		{
			// Flush RTK1, first
			ret = rtl8651_flushNaptServerPortbyExtIp( ntohl(inet_addr("140.113.214.102")) );
			IS_EQUAL_INT( "flushNaptServerPortbyExtIp() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
			// Then, flush RTK2
			ret = rtl8651_flushNaptServerPortbyExtIp( ntohl(inet_addr("140.113.131.53")) );
			IS_EQUAL_INT( "flushNaptServerPortbyExtIp() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}
		else
		{
			// Flush RTK2, first
			ret = rtl8651_flushNaptServerPortbyExtIp( ntohl(inet_addr("140.113.131.53")) );
			IS_EQUAL_INT( "flushNaptServerPortbyExtIp() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
			// Then, flush RTK1
			ret = rtl8651_flushNaptServerPortbyExtIp( ntohl(inet_addr("140.113.214.102")) );
			IS_EQUAL_INT( "flushNaptServerPortbyExtIp() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}

		// Expect the server port has been deleted.
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]: isTcp[%d], ExtIp[%x], ExtPort[%d], IntIp[%x], IntPort[%d], nCount[%d]\n", i, isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			
			if ( nCount[i] == 1 )		
				ret = rtl8651a_delNaptServerPortMapping( sessId[i], isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i] );
			else
				ret = rtl8651a_delNaptServerPortRange( sessId[i], isTcp[i], ExtIp[i], ExtPort[i], IntIp[i], IntPort[i], nCount[i] );
			IS_EQUAL_INT( "delNaptServerPortMapping() should fail", ret, TBLDRV_EENTRYNOTFOUND, __FUNCTION__, __LINE__ );
		}
	}

	return SUCCESS;
}


/*
@func int32		| testServerPortParkTcpUdp	| SERVERPORT_PARK_TCPUDP decides what policy we want for Server Port.
@rvalue SUCCESS	| test OK
@comm 
If defined SERVERPORT_PARK_TCPUDP, neither TCP nor UDP connection can use ASIC Server Port Table.
   Only both TCP and UDP connection can use ASIC Server Port Table to accelerate.
If not defined, any of TCP and UDP can use ASIC Server Port Table to accelerate.
   However, in this mode security hole will be raised.
*/
int32 testServerPortParkTcpUdp(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_serverPortParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1025;
	uint32 ExtIp = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort = 1025;
	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	/*************************************************************************************
	 *  Add TCP
	 *************************************************************************************/
	ret = rtl8651_addNaptServerPortMapping( TRUE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

#ifdef SERVERPORT_PARK_TCPUDP
	/* In this mode, Server Port will be handled by software. */
	ASSERT(rtl8651_getAsicServerPortTable(0, &Entry0) != SUCCESS);
#else/*SERVERPORT_PARK_TCPUDP*/
	/* Expected Server Port Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	Entry1.extIpAddr = ExtIp;
	Entry1.extPort = ExtPort;
	Entry1.intIpAddr = IntIp;
	Entry1.intPort = IntPort;
	Entry1.valid = TRUE;
	/* Read Server Port Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	ASSERT(rtl8651_getAsicServerPortTable( 0, &Entry0 ) == SUCCESS);
	SP_ENTRY_CMP( &Entry0, &Entry1 );
#endif/*SERVERPORT_PARK_TCPUDP*/


	/*************************************************************************************
	 *  Add UDP (We expect ASIC-Accelerated)
	 *************************************************************************************/
	ret = rtl8651_addNaptServerPortMapping( FALSE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "addNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	/* Expected Server Port Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	Entry1.extIpAddr = ExtIp;
	Entry1.extPort = ExtPort;
	Entry1.intIpAddr = IntIp;
	Entry1.intPort = IntPort;
	Entry1.valid = TRUE;
	/* Read Server Port Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	ASSERT(rtl8651_getAsicServerPortTable( 0, &Entry0 ) == SUCCESS);
	SP_ENTRY_CMP( &Entry0, &Entry1 );


	/*************************************************************************************
	 *  Delete TCP (UDP is still alive)
	 *************************************************************************************/
	ret = rtl8651_delNaptServerPortMapping( TRUE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "delNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

#ifdef SERVERPORT_PARK_TCPUDP
	/* In this mode, Server Port will be handled by software. */
	ASSERT(rtl8651_getAsicServerPortTable(0, &Entry0) != SUCCESS);
#else/*SERVERPORT_PARK_TCPUDP*/
	/* Expected Server Port Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	Entry1.extIpAddr = ExtIp;
	Entry1.extPort = ExtPort;
	Entry1.intIpAddr = IntIp;
	Entry1.intPort = IntPort;
	Entry1.valid = TRUE;
	/* Read Server Port Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	ASSERT(rtl8651_getAsicServerPortTable( 0, &Entry0 ) == SUCCESS);
	SP_ENTRY_CMP( &Entry0, &Entry1 );
#endif/*SERVERPORT_PARK_TCPUDP*/


	/*************************************************************************************
	 *  Delete UDP (We expect ASIC server port is cleared)
	 *************************************************************************************/
	ret = rtl8651_delNaptServerPortMapping( FALSE, ExtIp, ExtPort, IntIp, IntPort );
	IS_EQUAL_INT( "delNaptServerPortMapping() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	/* Read Server Port Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_serverPortParam_t));
	ASSERT(rtl8651_getAsicServerPortTable( 0, &Entry0 ) == FAILED);
	
	return SUCCESS;
}

/*
@func int32		| NaptDMZHostError	| DMZ related error handling
@rvalue SUCCESS	| test OK
@comm 
This is used to test if rtl8651_addDmzHost() can detect errors.
*/
int32 NaptDMZHostError(uint32 caseNo) 
{
	uint32 IntIp;
	uint32 ExtIp;
 	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();


	/////////////////////////////////////////////////////////////////////////////
	//  Case 1: ExtIp is not a NAPT IP.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	ExtIp = ntohl( inet_addr("140.113.214.103") );
	
	ret = rtl8651_addDmzHost( ExtIp, IntIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() should fail", ret, TBLDRV_EDMZHOSTNEEDNAPTIP, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 2: IntIp is not a LAN IP.
	//
	IntIp = ntohl( inet_addr("192.168.254.254") );
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	
	ret = rtl8651_addDmzHost( ExtIp, IntIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() should fail", ret, TBLDRV_EDMZHOSTSHOULDBEINTIP, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 3: IntIp cannot be gateway IP.
	//
	IntIp = ntohl( inet_addr("192.168.1.254") );
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	
	ret = rtl8651_addDmzHost( ExtIp, IntIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() should fail", ret, TBLDRV_EDMZHOSTCANNOTBEGWIP, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 4: Already exist.
	//
	IntIp = ntohl( inet_addr("192.168.1.1") );
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	
	ret = rtl8651_addDmzHost( ExtIp, IntIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	ret = rtl8651_addDmzHost( ExtIp, IntIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() should fail", ret, TBLDRV_EENTRYALREADYEXIST, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 5: Remove successfully.
	//
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ret = rtl8651_delDmzHost( ExtIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 6: Host not found.
	//
	ExtIp = ntohl( inet_addr("140.113.214.102") );
	ret = rtl8651_delDmzHost( ExtIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() should fail", ret, TBLDRV_EDMZHOSTNOTFOUND, __FUNCTION__, __LINE__ );


	return SUCCESS;
 }


/*
@func int32		| NaptAddDMZHost	| test case for add DMZ host
@rvalue SUCCESS	| test OK
@comm 
This is used to test add/query/del DMZ Host.
*/
int32 NaptAddDMZHost(uint32 caseNo) 
{
	uint32 IntIp;
	uint32 _IntIp;
	uint32 ExtIp;
 	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	IntIp = ntohl( inet_addr("192.168.1.1") );
	ExtIp = ntohl( inet_addr("140.113.214.102") );

	// Add	
	ret = rtl8651_addDmzHost( ExtIp, IntIp );
	IS_EQUAL_INT( "rtl8651_addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// Query
	ret = _rtl8651_getDmzHost( 0, ExtIp, &_IntIp );
	IS_EQUAL_INT( "_rtl8651_getDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "IntIp is different.", _IntIp, IntIp, __FUNCTION__, __LINE__ );

	// Delete
	ret = rtl8651_delDmzHost( ExtIp );
	IS_EQUAL_INT( "rtl8651_delDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	return SUCCESS;
}


/*
@func int32		| NaptAddDMZHost2	| test case for add DMZ host(with sessionId)
@rvalue SUCCESS	| test OK
@comm 
This is used to test add/query/del DMZ Host with sessionId.
*/
int32 NaptAddDMZHost2(uint32 caseNo) 
{
	uint32 IntIp1;
	uint32 _IntIp1;
	uint32 ExtIp1;
	uint32 IntIp2;
	uint32 _IntIp2;
	uint32 ExtIp2;
	uint32 dsid;
	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment2();

	IntIp1 = ntohl( inet_addr("192.168.1.1") );
	ExtIp1 = ntohl( inet_addr("140.113.214.102") );
	IntIp2 = ntohl( inet_addr("192.168.1.1") );
	ExtIp2 = ntohl( inet_addr("140.113.131.53") );

	// Add DMZ Host 1
	ret = rtl8651a_addDmzHost( PPPOE_SESSION_ID1, ExtIp1, IntIp1 );
	IS_EQUAL_INT( "rtl8651_addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// Add DMZ Host 2
	ret = rtl8651a_addDmzHost( PPPOE_SESSION_ID2, ExtIp2, IntIp2 );
	IS_EQUAL_INT( "rtl8651_addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// Query DMZ Host 1
	dsid = _rtl8651_SessionIDToDSID( PPPOE_SESSION_ID1 );
	ret = _rtl8651_getDmzHost( dsid, ExtIp1, &_IntIp1 );
	IS_EQUAL_INT( "_rtl8651_getDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "IntIp is different.", _IntIp1, IntIp1, __FUNCTION__, __LINE__ );

	// Query DMZ Host 2
	dsid = _rtl8651_SessionIDToDSID( PPPOE_SESSION_ID2 );
	ret = _rtl8651_getDmzHost( dsid, ExtIp2, &_IntIp2 );
	IS_EQUAL_INT( "_rtl8651_getDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "IntIp is different.", _IntIp2, IntIp2, __FUNCTION__, __LINE__ );

	// Delete DMZ Host 1
	ret = rtl8651a_delDmzHost( PPPOE_SESSION_ID1, ExtIp1 );
	IS_EQUAL_INT( "rtl8651_delDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// Delete DMZ Host 2
	ret = rtl8651a_delDmzHost( PPPOE_SESSION_ID2, ExtIp2 );
	IS_EQUAL_INT( "rtl8651_delDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );


	return SUCCESS;
}


/*
@func int32		| NaptAddDMZHostRandomTest	| random test for add DMZ host(with sessionId)
@rvalue SUCCESS	| test OK
@comm 
This is used to random test add/query/del DMZ Host with sessionId.
*/
int32 NaptAddDMZHostRandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 2
	uint32 isTcp[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint32 _IntIp;
	uint32 sessId[MAX_CONN];
	int32 ret, i, j, loopCount, dsid;

	START_TEST_CASE();
	ConfigNaptTestEnvironment2();

	srandom( caseNo );
	
	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]%d\n", loopCount, i );
			// give the random values
			regen:
			isTcp[i] = random() & 1;
			IntIp[i] = ntohl( inet_addr("192.168.1.1") ) + ( random() % 253 );
			if ( ( random() & 1 ) == 1 )
			{
				ExtIp[i] = ntohl(inet_addr("140.113.214.102"));
				sessId[i] = PPPOE_SESSION_ID1;
			}
			else
			{
				ExtIp[i] = ntohl(inet_addr("140.113.131.53"));
				sessId[i] = PPPOE_SESSION_ID2;
			}

			uint32 bOverlap = FALSE;
			for( j = 0; j < i; j++ )
			{
				if ( IntIp[j] == IntIp[i] ||
				     ExtIp[j] == ExtIp[i] )
				{
					// Port overlapped, skip.
					bOverlap = TRUE;
					break;
				}
			}
			if ( bOverlap ) goto regen;
			
			//printf("[%d]: ExtIp[%x], IntIp[%x]\n", i, ExtIp[i], IntIp[i] );
			
			// Add DMZ Host
			ret = rtl8651a_addDmzHost( sessId[i], ExtIp[i], IntIp[i] );
			IS_EQUAL_INT( "rtl8651_addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}


		// Query DMZ Host
		for( i = 0; i < MAX_CONN; i++ )
		{
			dsid = _rtl8651_SessionIDToDSID( sessId[i] );
			ret = _rtl8651_getDmzHost( dsid, ExtIp[i], &_IntIp );
			IS_EQUAL_INT( "_rtl8651_getDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different.", _IntIp, IntIp[i], __FUNCTION__, __LINE__ );
		}

		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d]: ExtIp[%x], IntIp[%x]\n", i, ExtIp[i], IntIp[i] );
			
			// Delete DMZ Host
			ret = rtl8651a_delDmzHost( sessId[i], ExtIp[i] );
			IS_EQUAL_INT( "rtl8651_delDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}
	}


	return SUCCESS;
}


/*
@func int32		| AddDelALGError	| add ALG table error handling
@rvalue SUCCESS	| test OK
@comm 
This is used to test if rtl8651_addALGRule() can detect errors.
*/
int32 AddDelALGError(uint32 caseNo)
{
	uint32 isTcp;
	uint32 isServer;
	uint32 isClient;
	uint16 StartPort;
	uint16 EndPort;
 	int32 ret, i;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();


	/////////////////////////////////////////////////////////////////////////////
	//  Case 1: Invalid ALG attribute.
	//
	isTcp = TRUE;
	isServer = FALSE;
	isClient = FALSE;
	StartPort = 1024;
	EndPort = 1024;
	
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, TBLDRV_EINVALALGATTR, __FUNCTION__, __LINE__ );

	/////////////////////////////////////////////////////////////////////////////
	//  Case 2: Invalid Port Range.
	//
	isTcp = TRUE;
	isServer = TRUE;
	isClient = FALSE;
	StartPort = 6677;
	EndPort = 1122;
	
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, TBLDRV_EINVALPORTRANGE, __FUNCTION__, __LINE__ );

	/////////////////////////////////////////////////////////////////////////////
	//  Case 3: Port Range Overlapped.
	//
	isTcp = TRUE;
	isServer = TRUE;
	isClient = FALSE;
	StartPort = 1122;
	EndPort = 1123;
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, SUCCESS, __FUNCTION__, __LINE__ );
	StartPort = 1123;
	EndPort = 1124;
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, TBLDRV_EALGPORTRANGEOVERLAP, __FUNCTION__, __LINE__ );

	/////////////////////////////////////////////////////////////////////////////
	//  Case 4: Already exist.
	//
	isTcp = TRUE;
	isServer = TRUE;
	isClient = FALSE;
	StartPort = 2233;
	EndPort = 2244;
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, SUCCESS, __FUNCTION__, __LINE__ );
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, TBLDRV_EENTRYALREADYEXIST, __FUNCTION__, __LINE__ );

	/////////////////////////////////////////////////////////////////////////////
	//  Case 5: run out of freeList.
	//
	for( i = 0; i < configPara.algSize - 2; i++ )
	{
		isTcp = TRUE;
		isServer = TRUE;
		isClient = FALSE;
		StartPort = 5566 + i;
		EndPort = 5566 + i;
		ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
		IS_EQUAL_INT( "rtl8651_addALGRule() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}
	isTcp = TRUE;
	isServer = TRUE;
	isClient = FALSE;
	StartPort = 5566 + i;
	EndPort = 5566 + i;
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() should fail", ret, TBLDRV_ENOFREEBUFFER, __FUNCTION__, __LINE__ );


	return SUCCESS;
}


/*
@func int32		| AddDelALGBug	| For the bug of rtl8651_addALGRule()
@rvalue SUCCESS	| test OK
@comm 
This is used to test the bug of rtl8651_addALGRule().
rtl8651_addALGRule() does NOT release trackAlgPtr when TBLDRV_EENTRYALREADYEXIST happends.
*/
int32 AddDelALGBug(uint32 caseNo)
{
	uint32 isTcp;
	uint32 isServer;
	uint32 isClient;
	uint16 StartPort;
	uint16 EndPort;
 	int32 ret, i;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	isTcp = TRUE;
	isServer = TRUE;
	isClient = FALSE;
	StartPort = 5566;
	EndPort = 5566;

	// We expect the first one is SUCCESS.
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// The reminders return fail, and trackAlgPtr should be released.
	for( i = 0; i < configPara.algSize; i++ )
	{
		ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
		IS_EQUAL_INT( "rtl8651_addALGRule() failed", ret, TBLDRV_EENTRYALREADYEXIST, __FUNCTION__, __LINE__ );
	}

	// Since the above function calls would release trackAlgPtr,
	//   we should be able to add another ALG Rule.
	// Note: the bug is out of freeList.alg.
	StartPort = 7788;
	EndPort = 7788;
	ret = rtl8651_addALGRule( StartPort, EndPort, isTcp, isServer, isClient );
	IS_EQUAL_INT( "rtl8651_addALGRule() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	
	return SUCCESS;
}


/*
@func int32		| AddDelALGRandomTest	| random test for add/del ALG rules
@rvalue SUCCESS	| test OK
@comm 
Random Test for add/del ALG (verify ASIC entry).
*/
int32 AddDelALGRandomTest(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN RTL8651_ALGTBL_SIZE
	rtl865x_tblAsicDrv_algParam_t Entry0, Entry1;
	uint16 StartPort[MAX_CONN];
	uint16 nCount[MAX_CONN];
	uint32 isTcp[MAX_CONN];
	uint32 isServer[MAX_CONN];
	uint32 isClient[MAX_CONN];
	int32 ret, i, j, loopCount;
	uint32 NextUse; // the ASIC index will be used that we expect.
	uint32 TotalNumOfRule; // Total numbers of rules have been added successfully.

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 100; loopCount++ )
	{
		// reset statistic variables
		NextUse = TotalNumOfRule = 0;
	
		for( i = 0; NextUse < MAX_CONN; i++ )
		{
			//printf("[%d] i=%d, NextUse:%d\n", loopCount, i, NextUse );
			// give the random values
			regen:
			StartPort[i] = random() % 9216 + 1024;
			nCount[i] = random() % 10 + 1;
			isTcp[i] = random() & 1;
			isServer[i] = random() & 1;
			isClient[i] = random() & 1;

			if ( isServer[i] == FALSE && isClient[i] == FALSE ) goto regen; //TBLDRV_EINVALALGATTR
			if ( NextUse + nCount[i] - 1 >= RTL8651_ALGTBL_SIZE ) goto regen; // ASIC entry will run out.
		
			uint32 bOverlap = FALSE;
			for( j = 0; j < i; j++ )
			{
				if ( ( StartPort[j] >= StartPort[i] && StartPort[j] <= StartPort[i]+nCount[i]-1 ) ||
				     ( StartPort[j]+nCount[j]-1 >= StartPort[i] && StartPort[j]+nCount[j]-1 <= StartPort[i]+nCount[i]-1 ) ||
				     ( StartPort[j] >= StartPort[i] && StartPort[j]+nCount[j]-1 <= StartPort[i]+nCount[i]-1 ) ||
				     ( StartPort[j] <= StartPort[i] && StartPort[j]+nCount[j]-1 >= StartPort[i]+nCount[i]-1 ) )
				{
					// Port overlapped, skip.
					bOverlap = TRUE;
					break;
				}
			}
			if ( bOverlap ) goto regen;
			
			//printf("  StartPort:%d  nCount:%d  isTcp:%d  isServer:%d  isClient:%d\n", StartPort[i], nCount[i], isTcp[i], isServer[i], isClient[i] );

			ret = rtl8651_addALGRule( StartPort[i], StartPort[i]+nCount[i]-1, isTcp[i], isServer[i], isClient[i] );
			IS_EQUAL_INT( "addALGRule() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			for( j = 0; j < nCount[i]; j++ )
			{
				/* Expected TCPUDP Entry */
				memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_algParam_t));
				Entry1.port = StartPort[i] + j;

				/* Read TCPUDP Entry */
				memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_algParam_t));
				ASSERT(rtl8651_getAsicAlg( NextUse + j, &Entry0 ) == SUCCESS);
				ALG_ENTRY_CMP( &Entry0, &Entry1 );
			}

			// move pointer to 
			NextUse += nCount[i];
			TotalNumOfRule++;
		}

		///////////////////////////////////////////////////////////////
		// Query !!
		for( i = 0; i < TotalNumOfRule; i++ )
		{
			//printf("[%d]%d\n", loopCount, i );
			rtl8651_tblDrv_algEntry_t *alg;
			uint8 _isServer, _isClient;
			alg = _rtl8651_getAlgEntry( isTcp[i], &_isServer, &_isClient, StartPort[i], StartPort[i]+nCount[i]-1 );
			IS_NOT_EQUAL_POINTER( "_rtl8651_getAlgEntry() failed", alg, NULL, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "isServer is different", _isServer, isServer[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "isClient is different", _isClient, isClient[i], __FUNCTION__, __LINE__ );
		}

		///////////////////////////////////////////////////////////////
		// Delete !!
		// printf("TotalNumOfRule:%d\n", TotalNumOfRule );
		for( i = 0; i < TotalNumOfRule; i++ )
		{
			ret = rtl8651_delALGRule( StartPort[i], StartPort[i]+nCount[i]-1, isTcp[i], isServer[i], isClient[i] );
			IS_EQUAL_INT( "delALGRule() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			/* Expected TCPUDP Entry */
			memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_algParam_t));

			/* Read TCPUDP Entry */
			memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_algParam_t));
			ASSERT(rtl8651_getAsicAlg( NextUse + j, &Entry0 ) == FAILED);
			ALG_ENTRY_CMP( &Entry0, &Entry1 );
		}
	}
	
	return SUCCESS;
}


/*
@func int32		| AddDelIcmpError	| test case for add/del Icmp
@rvalue SUCCESS	| test OK
@comm 
This is used to test if ICMP Candidate related functions can detect errors.
*/
int32 AddDelIcmpError(uint32 caseNo)
{
#undef MAX_CONN
#define MAX_CONN configPara.naptIcmpFlowSize
	uint32 assigned;
	uint32 IntIp;
	uint16 IntId;
	uint32 ExtIp;
	uint16 ExtId;
	uint32 RemIp;
 	int32 ret, i;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();


	/////////////////////////////////////////////////////////////////////////////
	//  Case 1: Neither ExtIp nor ExtId is given.
	//
	assigned = TRUE;
	IntIp = ntohl(inet_addr("192.168.1.1"));
	IntId = 5;
	RemIp = ntohl(inet_addr("140.113.1.1"));
	
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, NULL, NULL, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EINVALIDINPUT, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, NULL, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EINVALIDINPUT, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, NULL, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EINVALIDINPUT, __FUNCTION__, __LINE__ );


	/////////////////////////////////////////////////////////////////////////////
	//  Case 2: IntIp is not a LAN IP address.
	//
	assigned = FALSE;
	IntIp = ntohl(inet_addr("192.168.254.254"));
	IntId = 5;
	RemIp = ntohl(inet_addr("140.113.1.1"));
	
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, NULL, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EINVALIDINPUT, __FUNCTION__, __LINE__ );

	
	/////////////////////////////////////////////////////////////////////////////
	//  Case 3: ExtIp is not a WAN IP address.
	//
	assigned = TRUE;
	IntIp = ntohl(inet_addr("192.168.1.1"));
	IntId = 5;
	RemIp = ntohl(inet_addr("140.113.1.1"));
	
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_ENOTEXTIP, __FUNCTION__, __LINE__ );
	

	/////////////////////////////////////////////////////////////////////////////
	//  Case 4: RemIp is local server.
	//
	assigned = FALSE;
	IntIp = ntohl(inet_addr("192.168.1.1"));
	IntId = 5;
	RemIp = ntohl(inet_addr("140.113.214.117"));
	
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EDSTIPISLS, __FUNCTION__, __LINE__ );
	

	/////////////////////////////////////////////////////////////////////////////
	//  Case 5: Offset has been run out.
	//
	for( i = 0; i < 63; i++ )
	{
		//printf("%d\n",i);
		assigned = FALSE;
		IntIp = ntohl(inet_addr("192.168.1.12"));
		IntId = ( i % 32 ) * 8 + ( ( i / 32 ) << 13 );
		RemIp = ntohl(inet_addr("144.40.3.1"));

		//rtl8651_naptIcmpTableIndex( IntIp, IntId, RemIp, &ret );		
		//printf("IntIp:%x IntId:%5d RemIp:%x index:%d\n", IntIp, IntId, RemIp, ret);
		
		ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
		IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, SUCCESS, __FUNCTION__, __LINE__ );

		//printf("ExtId:%d\n", ExtId );
	}
	IntId = ( i % 32 ) * 8 + ( ( i / 32 ) << 13 );
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EDSTIPISLS, __FUNCTION__, __LINE__ );

	
	/////////////////////////////////////////////////////////////////////////////
	//  Case 6: Insert duplicate entry
	//
	assigned = TRUE;
	IntIp = ntohl(inet_addr("192.168.1.2"));
	IntId = 5566;
	ExtIp = ntohl(inet_addr("140.113.214.102"));
	ExtId = 5566;
	RemIp = ntohl(inet_addr("144.40.3.1"));

	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EENTRYALREADYEXIST, __FUNCTION__, __LINE__ );

	
	/////////////////////////////////////////////////////////////////////////////
	//  Case 7: ExtID has been in-used. (_rtl8651_addNaptIcmpNonCandidateFlow())
	//
	assigned = TRUE;
	IntIp = ntohl(inet_addr("192.168.1.2"));
	IntId = 7788;
	ExtIp = ntohl(inet_addr("140.113.214.102"));
	ExtId = 7788;
	RemIp = ntohl(inet_addr("144.40.3.1"));
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	assigned = TRUE;
	IntIp = ntohl(inet_addr("192.168.1.1"));
	IntId = 1234;
	ExtIp = ntohl(inet_addr("140.113.214.102"));
	ExtId = 7788;
	RemIp = ntohl(inet_addr("144.40.3.1"));
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_EEXTIDINUSE, __FUNCTION__, __LINE__ );

	
	/////////////////////////////////////////////////////////////////////////////
	//  Case 8: Run out of flow entry
	//  We assume there are 65 flows added successfully above.
	//
	for( i = 0; i < 63; i++ )
	{
		//printf("%d\n",i);
		assigned = FALSE;
		IntIp = ntohl(inet_addr("192.168.1.110"));
		IntId = i * 7 + 19;
		RemIp = ntohl(inet_addr("144.40.3.1"));

		//rtl8651_naptIcmpTableIndex( IntIp, IntId, RemIp, &ret );		
		//printf("IntIp:%x IntId:%5d RemIp:%x index:%d\n", IntIp, IntId, RemIp, ret);
		
		ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
		IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, SUCCESS, __FUNCTION__, __LINE__ );

		//printf("ExtId:%d\n", ExtId );
	}
	IntId = i * 7 + 19;
	ret = rtl8651_addNaptIcmpFlow( assigned, IntIp, IntId, &ExtIp, &ExtId, RemIp );
	IS_EQUAL_INT( "addNaptIcmpFlow() should fail", ret, TBLDRV_ENOFREEBUFFER, __FUNCTION__, __LINE__ );

	
	return SUCCESS;
}


/*
@func int32		| AddDelIcmpRandomTest	| random test for add/del Icmp
@rvalue SUCCESS	| test OK
@comm 
Random Test for add/del ICMP (verify software entry).
*/
int32 AddDelIcmpRandomTest(uint32 caseNo)
{
#undef MAX_CONN
#define MAX_CONN configPara.naptIcmpFlowSize
	rtl865x_tblAsicDrv_naptIcmpParam_t Entry0, Entry1;
	rtl8651_tblDrv_naptIcmpFlowEntry_t *icmp;
	uint32 assigned[MAX_CONN];
	uint32 IntIp[MAX_CONN];
	uint16 IntId[MAX_CONN];
	uint32 ExtIp[MAX_CONN];
	uint16 ExtId[MAX_CONN];
	uint32 RemIp[MAX_CONN];
	int32 ret, i, j, loopCount, isRefresh;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	srandom( caseNo );

	for( loopCount = 0; loopCount < 1000; loopCount++ )
	{
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d] i=%d\n", loopCount, i );
			// give the random values
			regen:
			assigned[i] = random() & 1;
			IntIp[i] = ntohl(inet_addr("192.168.1.1")) + random() % 253;
			IntId[i] = random() % 65535 + 1;
			if ( ( random() & 1 ) == 1 )
				ExtIp[i] = ntohl(inet_addr("140.113.214.102"));
			else
				ExtIp[i] = ntohl(inet_addr("140.113.131.53"));
			ExtId[i] = random() % 65535 + 1;
			do
			{
				RemIp[i] = random();
			} while( ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("192.168.1.0") ) ) ||
			         ( ( RemIp[i] & 0xffffff00 ) == ntohl( inet_addr("140.113.214.0") ) ) );

			for( j = 0; j < i; j++ )
			{
				// ID overlapped, skip.
				if ( ( IntIp[j] == IntIp[i] && IntId[j] == IntId[i] ) ||
				     ( ExtIp[j] == ExtIp[i] && ExtId[j] == ExtId[i] ) )
				{
					goto regen;
				}
			}

			//printf("[%d] assigned:%d IntIp:%x IntId:%d &ExtIp:%x &ExtId:%d RemIp:%x\n", i, assigned[i], IntIp[i], IntId[i], ExtIp[i], ExtId[i], RemIp[i] );
			
			ret = rtl8651_addNaptIcmpFlow( assigned[i], IntIp[i], IntId[i], &ExtIp[i], &ExtId[i], RemIp[i] );
			IS_EQUAL_INT( "addNaptIcmpFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		}

		///////////////////////////////////////////////////////////////
		// Query !!
		for( i = 0; i < MAX_CONN; i++ )
		{
			isRefresh = random() & 1;
			//printf("[%d] isRefresh:%d assigned:%d IntIp:%x IntId:%d &ExtIp:%x &ExtId:%d RemIp:%x\n", i, isRefresh, assigned[i], IntIp[i], IntId[i], ExtIp[i], ExtId[i], RemIp[i] );

			// test getOutsideNaptIcmpEntry
			icmp = _rtl8651_getOutsideNaptIcmpEntry( ExtIp[i], ExtId[i], RemIp[i], isRefresh, 0 );
			IS_NOT_EQUAL_POINTER( "getOutsideNaptIcmpEntry() failed", icmp, NULL, __FUNCTION__, __LINE__ );
			
			if ( isRefresh == TRUE )
				IS_EQUAL_INT( "age is different", icmp->age, rtl8651GlobalControl.icmpTimeout, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "alive is different", icmp->alive, TRUE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "canAsic is different", icmp->canAsic, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "count is different", icmp->count, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different", icmp->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "fromAsic is different", icmp->fromAsic, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "fromDrv is different", icmp->fromDrv, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtId is different", icmp->insideGlobalId, ExtId[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different", icmp->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntId is different", icmp->insideLocalId, IntId[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different", icmp->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "protoDel is different", icmp->protoDel, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "staticEntry is different", icmp->staticEntry, TRUE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "toAsic is different", icmp->toAsic, FALSE, __FUNCTION__, __LINE__ );

			// test getInsideNaptIcmpEntry
			icmp = _rtl8651_getInsideNaptIcmpEntry( IntIp[i], IntId[i], RemIp[i], isRefresh, 0 );
			IS_NOT_EQUAL_POINTER( "getInsideNaptIcmpEntry() failed", icmp, NULL, __FUNCTION__, __LINE__ );
			
			if ( isRefresh == TRUE )
				IS_EQUAL_INT( "age is different", icmp->age, rtl8651GlobalControl.icmpTimeout, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "alive is different", icmp->alive, TRUE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "canAsic is different", icmp->canAsic, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "count is different", icmp->count, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "RemIp is different", icmp->dstIpAddr, RemIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "fromAsic is different", icmp->fromAsic, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "fromDrv is different", icmp->fromDrv, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtId is different", icmp->insideGlobalId, ExtId[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "ExtIp is different", icmp->insideGlobalIpAddr, ExtIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntId is different", icmp->insideLocalId, IntId[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "IntIp is different", icmp->insideLocalIpAddr, IntIp[i], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "protoDel is different", icmp->protoDel, FALSE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "staticEntry is different", icmp->staticEntry, TRUE, __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "toAsic is different", icmp->toAsic, FALSE, __FUNCTION__, __LINE__ );

			// force age out
			icmp->age = 0;
		}

		///////////////////////////////////////////////////////////////
		// Delete !!
		// printf("TotalNumOfRule:%d\n", TotalNumOfRule );
		for( i = 0; i < MAX_CONN; i++ )
		{
			//printf("[%d] assigned:%d IntIp:%x IntId:%d &ExtIp:%x &ExtId:%d RemIp:%x\n", i, assigned[i], IntIp[i], IntId[i], ExtIp[i], ExtId[i], RemIp[i] );

			ret = rtl8651_delNaptIcmpFlow( IntIp[i], IntId[i], RemIp[i] );
			IS_EQUAL_INT( "delNaptIcmpFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

			// the flow should be deleted.
			icmp = _rtl8651_getOutsideNaptIcmpEntry( ExtIp[i], ExtId[i], RemIp[i], isRefresh, 0 );
			IS_EQUAL_POINTER( "_rtl8651_getAlgEntry() failed", icmp, NULL, __FUNCTION__, __LINE__ );
		}
	}
	
	return SUCCESS;
}


#ifdef CONFIG_RTL865XB_EXP_HASH2
//
// These cases are used to test if the addNaptConnection() can detect the error.
//
int32 AddNaptConnectionErrors(uint32 caseNo) 
{
	int32 ret;
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.222.222") );
	uint16 insideLocalPort = 80;
	ipaddr_t insideGlobalIpAddr = ntohl( inet_addr("140.113.222.222") );
	uint16 insideGlobalPort = 80;
	ipaddr_t remotePublicIpAddr = ntohl( inet_addr("140.113.222.222") );
	uint16 remotePublicPort = 1234;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	// Not Internal IP
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() should fail", ret, TBLDRV_ENOTINTIP, __FUNCTION__, __LINE__ );

	// Not External IP
	insideLocalIpAddr = ntohl( inet_addr("192.168.1.1") );
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() should fail", ret, TBLDRV_EINVEXTIP, __FUNCTION__, __LINE__ );

	// invalid port number
	insideGlobalIpAddr = ntohl( inet_addr("140.113.214.102") );
	remotePublicPort = 0;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() should fail", ret, TBLDRV_EINVL4PORTNUM, __FUNCTION__, __LINE__ );

	remotePublicPort = 1234;
	// insert correct connection (Hash1)
	insideGlobalIpAddr = ntohl( inet_addr("140.113.214.102") );
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// insert duplicate connection
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() should fail", ret, TBLDRV_EDRVNAPTEXIST, __FUNCTION__, __LINE__ );
	
	// insert duplicate connection, but different internal IP:port.
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW, ntohl( inet_addr("192.168.1.100") ), 2543, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() fail", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	// insert duplicate intIp/intPort, but remoteIp:remotePort is 0.0.0.0:0.
	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// remove it for Hash2 testing
	ret = rtl8651_delNaptConnection( TRUE, insideLocalIpAddr, insideLocalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// remove it for Hash2 testing
	ret = rtl8651_delNaptConnection( TRUE, insideLocalIpAddr, insideLocalPort, 
	                                 0, 0 );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// remove it for Hash2 testing
	ret = rtl8651_delNaptConnection( TRUE, ntohl( inet_addr("192.168.1.100") ), 2543,
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// insert correct connection (Hash2)
	insideGlobalPort = 80;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// insert duplicate connection
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() should fail", ret, TBLDRV_EDRVNAPTEXIST, __FUNCTION__, __LINE__ );
	
	// insert duplicate connection, but different internal IP:Port.
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, ntohl( inet_addr( "192.168.1.200" ) ), 3678, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() should fail", ret, TBLDRV_EINVALIDEXTPORT, __FUNCTION__, __LINE__ );
	
	// insert duplicate connection, but remoteIp:remotePort is NOT 0.0.0.0:0.
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// insert duplicate gport, but different internal IP:Port ( remote is the same as above ).
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, ntohl( inet_addr("192.168.1.1") ), 9999, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EINVALIDEXTPORT, __FUNCTION__, __LINE__ );

	// insert duplicate gport, but different internal IP:Port ( remote is the same as above ).
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW, ntohl( inet_addr("192.168.1.1") ), 9999, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 
	                                 ntohl( inet_addr("140.113.17.5") ), 53 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// remove it
	ret = rtl8651_delNaptConnection( TRUE, insideLocalIpAddr, insideLocalPort, 
	                                 0, 0 );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// remove it
	ret = rtl8651_delNaptConnection( TRUE, insideLocalIpAddr, insideLocalPort, 
	                                 remotePublicIpAddr, remotePublicPort );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	// remove it
	ret = rtl8651_delNaptConnection( TRUE, ntohl( inet_addr("192.168.1.1") ), 9999, 
	                                 ntohl( inet_addr("140.113.17.5") ), 53 );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	return SUCCESS;
}


//
// This is old code.
//
// Like NaptTypicalCase(), but the 2nd connection is Hash2 Accelerated. (L03)
//
//	idx1 is the index of 1st connection.
//	idx2 is the index of 2nd connection, and equal to idx1 (we force it to use Hash 2 !!).
//	idx22 is the Hash2 index of 2nd connection.
//
// If the remoteGlobalIpAddr is an interface route, the HASH2 outbound flow cannot be ASIC-accelerated.
// After Holly chhuang supports nexthop table, this issue should be solved.
//
int32 NaptInterfaceRoute(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 insideLocalIpAddr1 = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort1 = 1026;
	uint32 remoteGlobalIpAddr1 = ntohl( inet_addr("140.113.214.102") );
	uint16 remoteGlobalPort1 = 80;
	ipaddr_t insideGlobalIpAddr1; // out
	uint16 insideGlobalPort1;     // out
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr1, insideLocalPort1, 
	                                               remoteGlobalIpAddr1, remoteGlobalPort1 );

	uint32 insideLocalIpAddr2 = ntohl( inet_addr("192.168.1.2") );
	uint16 insideLocalPort2 = 1027;
	uint32 remoteGlobalIpAddr2 = ntohl( inet_addr("140.113.214.102") );
	uint16 remoteGlobalPort2 = 1872;  // this will collide to above connection
	ipaddr_t insideGlobalIpAddr2; // out
	uint16 insideGlobalPort2;     // out
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                               remoteGlobalIpAddr2, remoteGlobalPort2 );
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                                0, 0 );

	IS_EQUAL_INT( "Two connection should be collided in the same index.", idx1, idx2, __FUNCTION__, __LINE__ );
	                                               
	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	rtl8651_enable4WayHash( FALSE );

	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr1, insideLocalPort1, 
	                                 &insideGlobalIpAddr1, &insideGlobalPort1, remoteGlobalIpAddr1, remoteGlobalPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort1 & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW, insideLocalIpAddr2, insideLocalPort2, 
	                                 &insideGlobalIpAddr2, &insideGlobalPort2, remoteGlobalIpAddr2, remoteGlobalPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr2, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort is assigned properly.", insideGlobalPort2 & (RTL8651_TCPUDPTBL_SIZE-1), idx22, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry of Connection 1  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr1;
	Entry1.insideLocalPort		= insideLocalPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= insideGlobalPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry of Connection 1  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	/* Expected TCPUDP Entry of Connection 2, interface-routed outbound entry CANNOT be ASIC-accelerated ! */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr2;
	Entry1.insideLocalPort		= insideLocalPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= insideGlobalPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= insideGlobalPort2 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read TCPUDP Entry of Connection 2  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	
	return SUCCESS;
}


/*
 * This case is used to test Nexthop table.
 * For HASH2 with interface route, HASH2 connection should bind with a nexthop entry.
 */
int32 NaptInterfaceRoute2(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 intIp = ntohl( inet_addr("192.168.1.1") );
	uint16 intPort = 1026;
	ipaddr_t extIp = ntohl( inet_addr("140.113.214.102") );
	uint16 extPort = 1026;
	uint32 remIp = ntohl( inet_addr("140.113.214.107") );
	uint16 remPort = 80;
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, intIp, intPort, 
	                                                0, 0 );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	rtl8651_enable4WayHash( FALSE );

	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, intIp, intPort, 
	                                 &extIp, &extPort, remIp, remPort );

	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );

	/* Expected HASH2 outbound entry  */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= extPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= _rtl8651_findHash2ToNexthop( remIp, extIp );
	Entry1.selEIdx				= extPort & ( RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read outbound entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected HASH2 outbound entry  */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= extPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= _rtl8651_findHash2ToNexthop( remIp, extIp );
	Entry1.selEIdx				= extPort & ( RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read outbound entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort & ( RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	return SUCCESS;
}


//
// This is the typical case from 8651: Hash 1 hardware accelerated.
// Only one entry would be write to ASIC.
//
int32 NaptTypicalCase(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort = 1025;
	uint32 remoteGlobalIpAddr = ntohl( inet_addr("140.113.1.1") );
	uint16 remoteGlobalPort = 80;
	ipaddr_t insideGlobalIpAddr; // out
	uint16 insideGlobalPort;     // out
	int32 ret;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               remoteGlobalIpAddr, remoteGlobalPort );
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW,
	                                 insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort,
	                                 remoteGlobalIpAddr, remoteGlobalPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr;
	Entry1.insideLocalPort		= insideLocalPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= insideGlobalPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );

	return SUCCESS;
}

//
// Like NaptTypicalCase(), but the 2nd connection is Hash2 Accelerated. (L03)
//
//	idx1 is the index of 1st connection.
//	idx2 is the index of 2nd connection, and equal to idx1 (we force it to use Hash 2 !!).
//	idx22 is the Hash2 index of 2nd connection.
//
int32 NaptTypicalCaseButHash2Accelerated(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 insideLocalIpAddr1 = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort1 = 1026;
	uint32 remoteGlobalIpAddr1 = ntohl( inet_addr("140.113.17.5") );
	uint16 remoteGlobalPort1 = 80;
	ipaddr_t insideGlobalIpAddr1; // out
	uint16 insideGlobalPort1;     // out
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr1, insideLocalPort1, 
	                                               remoteGlobalIpAddr1, remoteGlobalPort1 );

	uint32 insideLocalIpAddr2 = ntohl( inet_addr("192.168.1.2") );
	uint16 insideLocalPort2 = 1027;
	uint32 remoteGlobalIpAddr2 = ntohl( inet_addr("140.113.17.5") );
	uint16 remoteGlobalPort2 = 1872;  // this will collide to above connection
	ipaddr_t insideGlobalIpAddr2; // out
	uint16 insideGlobalPort2;     // out
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                               remoteGlobalIpAddr2, remoteGlobalPort2 );
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                                0, 0 );

	IS_EQUAL_INT( "Two connection should be collided in the same index.", idx1, idx2, __FUNCTION__, __LINE__ );
	                                               
	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	rtl8651_enable4WayHash( FALSE );

	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr1, insideLocalPort1, 
	                                 &insideGlobalIpAddr1, &insideGlobalPort1, remoteGlobalIpAddr1, remoteGlobalPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort1 & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr2, insideLocalPort2, 
	                                 &insideGlobalIpAddr2, &insideGlobalPort2, remoteGlobalIpAddr2, remoteGlobalPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr2, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort is assigned properly.", insideGlobalPort2 & (RTL8651_TCPUDPTBL_SIZE-1), idx22, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry of Connection 1  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr1;
	Entry1.insideLocalPort		= insideLocalPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= insideGlobalPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry of Connection 1  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	/* Expected TCPUDP Entry of Connection 2  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr2;
	Entry1.insideLocalPort		= insideLocalPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0; // quiet=0; dir=0; outbound=0;
	Entry1.offset				= insideGlobalPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= idx22;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read TCPUDP Entry of Connection 2  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	
	return SUCCESS;
}

//
// Like NaptTypicalCase(), but the 3rd connection is Half-Hardware Accelerated. (L04)
//
//	idx1 is the index of 1st connection.
//	idx2 is the index of 2nd connection, and equal to idx1 (we force it to use Hash 2 !!).
//	idx22 is the Hash2 index of 2nd connection.
//
// Expect: [270] is Hash2 (Conn2)
//         [259] is Hash2 (Conn4)
//         [914] is Hash1 (Conn1)
//         [917] is Hash1 (Conn3)
//
int32 NaptTypicalCaseButHalfAccelerated(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;

	// Connection 1
	uint32 insideLocalIpAddr1 = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort1 = 1026;
	uint32 remoteGlobalIpAddr1 = ntohl( inet_addr("140.113.17.5") );
	uint16 remoteGlobalPort1 = 80;
	ipaddr_t insideGlobalIpAddr1; // out
	uint16 insideGlobalPort1;     // out
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr1, insideLocalPort1, 
	                                               remoteGlobalIpAddr1, remoteGlobalPort1 );
	// Connection 2
	uint32 insideLocalIpAddr2 = ntohl( inet_addr("192.168.1.2") );
	uint16 insideLocalPort2 = 1027;
	uint32 remoteGlobalIpAddr2 = ntohl( inet_addr("140.113.17.5") );
	uint16 remoteGlobalPort2 = 1872;  // this will collide to above connection
	ipaddr_t insideGlobalIpAddr2; // out
	uint16 insideGlobalPort2;     // out
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                               remoteGlobalIpAddr2, remoteGlobalPort2 );
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                                0, 0 );
	IS_EQUAL_INT( "Two connection should be collided in the same index.", idx2, idx1, __FUNCTION__, __LINE__ );

	// Connection 3 : to collide Conn4 in Hash 1 entry.
	uint32 insideLocalIpAddr3 = ntohl( inet_addr("192.168.1.2") );
	uint16 insideLocalPort3 = 3076;
	uint32 remoteGlobalIpAddr3 = ntohl( inet_addr("140.113.17.5") );
	uint16 remoteGlobalPort3 = 80;  // this will collide to above connection
	ipaddr_t insideGlobalIpAddr3; // out
	uint16 insideGlobalPort3;     // out
	uint16 idx3 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr3, insideLocalPort3, 
	                                               remoteGlobalIpAddr3, remoteGlobalPort3 );

	// in expection, this connection collides with Conn3(by Hash1) and Conn2(by Hash2).
	uint32 insideLocalIpAddr4 = ntohl( inet_addr("192.168.1.2") );
	uint16 insideLocalPort4 = 2053;
	uint32 remoteGlobalIpAddr4 = ntohl( inet_addr("140.113.17.5") );
	uint16 remoteGlobalPort4 = 80;  // this will collide to above connection
	ipaddr_t insideGlobalIpAddr4; // out
	uint16 insideGlobalPort4;     // out
	uint16 idx41 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr4, insideLocalPort4, 
	                                                remoteGlobalIpAddr4, remoteGlobalPort4 );
	uint16 idx42 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr4, insideLocalPort4, 
	                                                0, 0 );
	IS_EQUAL_INT( "Two connection should be collided in the same index.", idx42, idx22, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Two connection should be collided in the same index.", idx41, idx3, __FUNCTION__, __LINE__ );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	rtl8651_enable4WayHash( FALSE );

	// Add Connection 1 (Hash1)
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr1, insideLocalPort1, 
	                                 &insideGlobalIpAddr1, &insideGlobalPort1, remoteGlobalIpAddr1, remoteGlobalPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort1 & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	// Add Connection 2
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr2, insideLocalPort2, 
	                                 &insideGlobalIpAddr2, &insideGlobalPort2, remoteGlobalIpAddr2, remoteGlobalPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr2, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort is assigned properly.", insideGlobalPort2 & (RTL8651_TCPUDPTBL_SIZE-1), idx22, __FUNCTION__, __LINE__ );

	// Add Connection 3
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr3, insideLocalPort3, 
	                                 &insideGlobalIpAddr3, &insideGlobalPort3, remoteGlobalIpAddr3, remoteGlobalPort3 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr3, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort is assigned properly.", insideGlobalPort3 & (RTL8651_TCPUDPTBL_SIZE-1), idx3, __FUNCTION__, __LINE__ );

	// Add Connection 4
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr4, insideLocalPort4, 
	                                 &insideGlobalIpAddr4, &insideGlobalPort4, remoteGlobalIpAddr4, remoteGlobalPort4 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr4, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort is assigned properly.", insideGlobalPort4 & (RTL8651_TCPUDPTBL_SIZE-1), idx42 + 1, __FUNCTION__, __LINE__ );


	/* Expected TCPUDP Entry of Connection 1  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr1;
	Entry1.insideLocalPort		= insideLocalPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= insideGlobalPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0; // FIXME: should point to NextHop, DO NOT support yet.
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry of Connection 1  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	/* Expected TCPUDP Entry of Connection 2  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr2;
	Entry1.insideLocalPort		= insideLocalPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0; // quiet=0; dir=0; outbound=0;
	Entry1.offset				= insideGlobalPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= idx22;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read TCPUDP Entry of Connection 2  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	
	/* Expected TCPUDP Entry of Connection 3  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr3;
	Entry1.insideLocalPort		= insideLocalPort3;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 4; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= insideGlobalPort3 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr3, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0; // FIXME: should point to NextHop, DO NOT support yet.
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry of Connection 3  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx3, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected TCPUDP Entry of Connection 4  */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr4;
	Entry1.insideLocalPort		= insideLocalPort4;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= insideGlobalPort4 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr4, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= insideGlobalPort4 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read TCPUDP Entry of Connection 4  */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx42 + 1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	return SUCCESS;
}


//
// This is the typical case : Hash 1 hardware accelerated.
// Additionally, we enable 4-way hash for Hash 1.
// Expect: 4 connections that conllide to the same index will group together.
//         [69] Conn1
//         [70] Conn2
//         [71] Conn3
//         [68] Conn4
//
int32 NaptTypicalCaseWith4Way(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.1.4") );
	uint16 insideLocalPort = 1058;
	uint32 remoteGlobalIpAddr = ntohl( inet_addr("140.113.1.1") );
	uint16 remoteGlobalPort = 80;
	ipaddr_t insideGlobalIpAddr; // out
	uint16 insideGlobalPort;     // out
	int32 ret, i;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               remoteGlobalIpAddr, remoteGlobalPort );
	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	rtl8651_enable4WayHash( TRUE );

	// Add 4 connections
	int Ports[4] = { 1058, 2081, 3104, 4135 }; // Their idx1 is 69.
	for( i = 0; i < 4; i++ )
	{
		insideLocalPort = Ports[i];
		ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW,
		                                 insideLocalIpAddr, insideLocalPort, 
		                                 &insideGlobalIpAddr, &insideGlobalPort,
		                                 remoteGlobalIpAddr, remoteGlobalPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1), WRAPIN_4WAY( idx1, i ), __FUNCTION__, __LINE__ );
	}

	// Expected connections.
	for( i = 0; i < 4; i++ )
	{
		insideLocalPort = Ports[i];
		
		/* Expected TCPUDP Entry */
		Entry1.insideLocalIpAddr	= insideLocalIpAddr;
		Entry1.insideLocalPort		= insideLocalPort;
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
		Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
		Entry1.offset				= insideGlobalPort >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr, 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= 0;
		Entry1.isTcp				= TRUE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 0;

		/* Read TCPUDP Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
		TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );
		
		idx1 = WRAPIN_4WAY( idx1, 1 );
	}

	// test getOutboundNaptFlow()
	for( i = 0; i < 4; i++ )
	{
		insideLocalPort = Ports[i];
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s Entry;
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry = &Entry;
		ret = _rtl8651_getOutboundNaptFlow( TRUE, insideLocalIpAddr, insideLocalPort,
		                                          remoteGlobalIpAddr, remoteGlobalPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideLocalPort should be the same.", insideLocalPort, pEntry->insideLocalPort, __FUNCTION__, __LINE__ );
	}
	
	// test rtl8651_delNaptConnection()
	for( i = 0; i < 4; i++ )
	{
		insideLocalPort = Ports[i];
		ret = rtl8651_delNaptConnection( TRUE, insideLocalIpAddr, insideLocalPort,
		                                       remoteGlobalIpAddr, remoteGlobalPort );
		IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}

	// disable 4-way hash
	rtl8651_enable4WayHash( FALSE );
	
	return SUCCESS;
}


//
// This is function is used to test the L04 branch of addNaptConnection() function.
// At first, this function add l4NaptFindEmptyAsicRetry + 1 connections.
//
int32 NaptTestL04(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1028;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	ipaddr_t ExtIp; // out
	uint16 ExtPort;     // out
	int32 ret, i;
	uint16 idx1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	// we assume the 1024 connections will occupy the whole 1024 ASIC entries.
	for( i = 0; i < rtl8651GlobalControl.l4NaptFindEmptyAsicRetry; i++, IntPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( TRUE, IntIp, IntPort, 
		                                            RemIp, RemPort );

		ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW,
		                                 IntIp, IntPort, 
		                                 &ExtIp, &ExtPort,
		                                 RemIp, RemPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort& (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

		/* Expected TCPUDP Entry */
		Entry1.insideLocalIpAddr	= IntIp;
		Entry1.insideLocalPort		= IntPort;
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout) );
		Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
		Entry1.offset				= ExtPort >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp, 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= 0;
		Entry1.isTcp				= TRUE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 0;

		/* Read TCPUDP Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
		TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );
	}

	// Since all ASIC entries are full, the last line will be appended to candidate list.
	idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
	                                        RemIp, RemPort );

	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort& (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	return SUCCESS;
}


//
// This is function is used to test the L04 branch of addNaptConnection() function.
// For CDRouter, we dont write HASH1 and HASH2 UDP connection tp ASIC.
// This case is designed for this prupose.
// At first, this function add l4NaptFindEmptyAsicRetry + 1 connections.
//
int32 NaptTestL04UdpForCDRouter(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1028;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	ipaddr_t ExtIp; // out
	uint16 ExtPort;     // out
	int32 ret, i;
	uint16 idx1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	// we assume the 1024 connections will occupy the whole 1024 ASIC entries.
	for( i = 0; i < rtl8651GlobalControl.l4NaptFindEmptyAsicRetry; i++, IntPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( FALSE, IntIp, IntPort, 
		                                            RemIp, RemPort );

		ret = rtl8651_addNaptConnection( FALSE, UDP_FLOW,
		                                 IntIp, IntPort, 
		                                 &ExtIp, &ExtPort,
		                                 RemIp, RemPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort& (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

		/* Expected TCPUDP Entry */
		memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;

		/* Read TCPUDP Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
		TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );
	}

	// Since all ASIC entries are full, the last line will be appended to candidate list.
	idx1 = rtl8651_naptTcpUdpTableIndex( FALSE, IntIp, IntPort, 
	                                            RemIp, RemPort );

	ret = rtl8651_addNaptConnection( FALSE, UDP_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort& (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	return SUCCESS;
}


//
// This is function is used to test the L04 branch of addNaptConnection() function.
// At first, this function add l4NaptFindEmptyAsicRetry + 1 connections.
//
int32 NaptTest4096Connections(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1024;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	ipaddr_t ExtIp; // out
	uint16 ExtPort;     // out
	int32 ret, i;
	uint16 idx1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	// we assume the 4096 connections will occupy the whole 1024 ASIC entries.
	for( i = 0; i < rtl8651_tblDrvPara.naptTcpUdpFlowSize; i++, IntPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
		                                        RemIp, RemPort );

		ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
		                                 IntIp, IntPort, 
		                                 &ExtIp, &ExtPort,
		                                 RemIp, RemPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort&(RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );
	}

	// We expect adding one more connection will cause error.
	idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
	                                        RemIp, RemPort );

	ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );

#if 1
	/* Since _rtl8651_flushNaptOldestConnection() is implemented, more than 4096 connections can be supprted. */
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
#else
	IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_ENOFREEBUFFER, __FUNCTION__, __LINE__ );
#endif/*1*/

	// delete all connections we just added.
	IntPort = 1024;
	for( i = 0; i < rtl8651_tblDrvPara.naptTcpUdpFlowSize; i++, IntPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
		                                        RemIp, RemPort );

		ret = rtl8651_delNaptConnection( TRUE,
		                                 IntIp, IntPort, 
		                                 RemIp, RemPort );
#if 1
		/* Since _rtl8651_flushNaptOldestConnection() is implemented, one connection will be flushed. */
#else
		IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
#endif/*1*/
	}
		
	return SUCCESS;
}


//
// This is the case that user specified the gport, and fortunely the gport is equal to idx1. (L01)
// Therefore, we can use ASIC to accelerate.
// Expect: [204] is a Hash1 conneciton.
//
int32 DMZHostUsingHash1(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort = 1025;
	uint32 remoteGlobalIpAddr = ntohl( inet_addr("140.113.1.1") );
	uint16 remoteGlobalPort = 80;
	ipaddr_t insideGlobalIpAddr; // out
	uint16 insideGlobalPort;     // out
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               remoteGlobalIpAddr, remoteGlobalPort );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	insideGlobalIpAddr = ntohl( inet_addr("140.113.214.102") );
	insideGlobalPort = 204;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr;
	Entry1.insideLocalPort		= insideLocalPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= insideGlobalPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0; // FIXME: should point to NextHop, DO NOT support yet.
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used
	uint32 remoteIpAddr = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 remotePort = 1177;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, remoteIpAddr, remotePort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	return SUCCESS;
}

//
// This is the case that user specified the gport. 
// But, unfortunely the gport is NOT equal to idx1. (L07)
// Therefore, we must seperate in-entry and out-entry in two different index.
// Expect: 
//         [ 35] is a Hash2 (tcpFlag:3) connection (Conn4).
//         [264] is a Hash2 (tcpFlag:4) connection (Conn5)
//               (We note that Conn1, Conn2, Conn3 and Conn4 also share ExtPort 264 too)
//         [265] is a Hash2 (tcpFlag:3) connection (Conn1).
//
//                     in  out   IntPort  ExtPort  RemPort
//         Conn1: H2( 264, 265)     1025      264       80
//         Conn2: H2( 264, 265)     1025      264     1177
//         Conn3: H1( 264, 264)     1025      264     1056
//         Conn4: H2( 264, 264)     1611      264     5566
//         Conn5: H1( 264, 264)     1611      264     7788
//
int32 DMZHostUsingHash2(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 1025;
	uint32 ExtIp1 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort1 = 264;
	uint32 RemIp1 = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort1 = 80;
	uint16 idx12 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1,
	                                                0, 0 );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	//// Conn1 ///////////////////////////////////////////////////////////////////////////////////////////
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1,
	                                 &ExtIp1, &ExtPort1, RemIp1, RemPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	/* Expected In-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	/* Expected Out-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx12, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	//// Conn2 ///////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used (The same IntIp/Port with Conn1, so the ASIC entry is still hold by Conn1.)
	uint32 IntIp2 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort2 = 1025;
	uint32 ExtIp2 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort2 = 264;
	uint32 RemIp2 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort2 = 1177;
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, IntIp2, IntPort2, 
	                                                0, 0 );
	                                                
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp2, IntPort2, 
	                                 &ExtIp2, &ExtPort2, RemIp2, RemPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	/* Expected In-Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected Out-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	//// Conn3 ///////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used (using L01, it is a Hash1 conncection. )
	// (The same IntIp/Port with Conn1, so the ASIC entry is still hold by Conn1.)
	uint32 IntIp3 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort3 = 1025;
	uint32 ExtIp3 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort3 = 264;
	uint32 RemIp3 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort3 = 1056;
	uint16 idx31 = rtl8651_naptTcpUdpTableIndex( 1, IntIp3, IntPort3, 
	                                                RemIp3, RemPort3 );

	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp3, IntPort3,
	                                 &ExtIp3, &ExtPort3, RemIp3, RemPort3 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	/* Expected Hash1 Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Hash1 Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx31 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	
	//// Conn4 ///////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used (this is a Hash2 conncection. )
	// (The different IntIp/Port with Conn1, so the ASIC entry is still hold by Conn1.)
	uint32 IntIp4 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort4 = 1611;
	uint32 ExtIp4 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort4 = 264;
	uint32 RemIp4 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort4 = 5566;
	uint16 idx42 = rtl8651_naptTcpUdpTableIndex( 1, IntIp4, IntPort4, 
	                                                0, 0 );

	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp4, IntPort4,
	                                 &ExtIp4, &ExtPort4, RemIp4, RemPort4 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
#if 1
	/* Since we DO NOT choose the best connection into ASIC after addConnection when ambiguous,
	 * the Conn3 will not win thios entry. It should be empty. 
	 */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 0;
	Entry1.isValid				= 0;
	Entry1.isDedicated			= 0;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#else
	/* Expected Inbound Entry (it should be Conn3, which is a Hash1 connection) */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp3;
	Entry1.insideLocalPort		= IntPort3;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort3 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp3, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#endif
	
	/* Expected Out-Entry */
	Entry1.insideLocalIpAddr	= IntIp4;
	Entry1.insideLocalPort		= IntPort4;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort4 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp4, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx42, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	
	//// Remove Conn3 ////////////////////////////////////////////////////////////////////////////////////
	// As the Conn3(Hash1) is removed, the remaining connections (Conn1,Conn2,Conn4) ALL are Hash2.
	// Therefore, the ASIC entry should be empty to avoid ambiguous.
	ret = rtl8651_delNaptConnection( TRUE, IntIp3, IntPort3, RemIp3, RemPort3 );
	IS_EQUAL_INT( "delNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	/* Expected Hash1 Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx31 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	
	//// Conn5 ///////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used (using L01, it is a Hash1 conncection. )
	// (This is the only Hash1 entry, it will be swap to ASIC entry for Hardware-accelerated)
	uint32 IntIp5 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort5 = 1611;
	uint32 ExtIp5 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort5 = 264;
	uint32 RemIp5 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort5 = 7788;
	uint16 idx51 = rtl8651_naptTcpUdpTableIndex( 1, IntIp5, IntPort5, 
	                                                RemIp5, RemPort5 );

	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp5, IntPort5,
	                                 &ExtIp5, &ExtPort5, RemIp5, RemPort5 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
#if 1
	/* Since we DO NOT choose the best connection into ASIC after addConnection when ambiguous,
	 * the Conn3 will not win thios entry. It should be empty. 
	 */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 0;
	Entry1.isValid				= 0;
	Entry1.isDedicated			= 0;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx51 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#else
	/* Expected Hash1 Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp5;
	Entry1.insideLocalPort		= IntPort5;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
	Entry1.offset				= ExtPort5 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp5, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx51 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#endif
	
	return SUCCESS;
}

//
// This is the best case of Hash 2.
// The user only specified the (isTCP,intIP,intPort), and fortunely the idx2 is empty.
// Therefore, we can use ASIC to accelerate. (L03)
//
int32 Hash2BestCase(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort = 1025;
	ipaddr_t insideGlobalIpAddr; // out
	uint16 insideGlobalPort;     // out
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               0, 0 );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	insideGlobalIpAddr = 0;
	insideGlobalPort = 0;
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1), idx2, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr;
	Entry1.insideLocalPort		= insideLocalPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0; // quiet=0; dir=0; outbound=0;
	Entry1.offset				= insideGlobalPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= idx2;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	return SUCCESS;
}

//
// This is the worst case of Hash 2.
// The user only specified the (isTCP,intIP,intPort), but unfortunely the idx2 is in use.
// Therefore, we must append to candidate list. (L06)
//
//                     in  out   IntPort  ExtPort  RemPort
//         Conn1: H1( 261, 261)     1959      261       80
//         Conn2: H2( 261, 261)     1025      261     ----
//
Hash2WorstCase(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 insideLocalIpAddr1 = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort1 = 1959;
	uint32 remoteGlobalIpAddr1 = ntohl( inet_addr("140.113.214.102") );
	uint16 remoteGlobalPort1 = 80;
	ipaddr_t insideGlobalIpAddr1; // out
	uint16 insideGlobalPort1;     // out
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr1, insideLocalPort1, 
	                                               remoteGlobalIpAddr1, remoteGlobalPort1 );

	uint32 insideLocalIpAddr2 = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort2 = 1025;
	ipaddr_t insideGlobalIpAddr2; // out
	uint16 insideGlobalPort2;     // out
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                                0, 0 );
	IS_EQUAL_INT( "Two connection should be collided in the same index.", idx22, idx1, __FUNCTION__, __LINE__ );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	insideGlobalIpAddr1 = 0;
	insideGlobalPort1 = 0;
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr1, insideLocalPort1, 
	                                 &insideGlobalIpAddr1, &insideGlobalPort1, remoteGlobalIpAddr1, remoteGlobalPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort1 & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	insideGlobalIpAddr2 = 0;
	insideGlobalPort2 = 0;
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr2, insideLocalPort2, 
	                                 &insideGlobalIpAddr2, &insideGlobalPort2, 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort1 & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	/* Expected Conn1 */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr1;
	Entry1.insideLocalPort		= insideLocalPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= insideGlobalPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0; // FIXME: point to Nexthop table, DO NOT support yet.
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read Conn1 */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected Conn2 */
	Entry1.insideLocalIpAddr	= insideLocalIpAddr2;
	Entry1.insideLocalPort		= insideLocalPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= insideGlobalPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( insideGlobalIpAddr2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= insideGlobalPort2 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read Conn2 */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22 + 1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	return SUCCESS;
}

//
// This is the case of Server Port.
// The user specified the (isTCP,intIP,intPort,gPort), and fortunely the idx2 is equal to gport;
// Therefore, we can use ASIC to accelerate. (L05)
// Expect: [45] is a Hash2 connection, shared by Conn1 and Conn2 (the same internal IP and port).
//
int32 ServerPortUsingOneHash2Entry(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 2048+77;
	uint32 ExtIp1 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort1 = 2048+45;
	uint16 idx12 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1,
	                                               0, 0 );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	//// Conn1 ///////////////////////////////////////////////////////////////////////////////////////////
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1, 
	                                 &ExtIp1, &ExtPort1, 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	/* Expected In-bound Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 0 | 0; // quiet=@; dir=0; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 0 | 0; // quiet=1; dir=0; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= idx12;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx12, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	//// Conn2 ///////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used
	uint32 IntIp2 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort2 = 2048+77;
	uint32 ExtIp2 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort2 = 2048+45;
	uint32 RemIp2 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort2 = 1177;
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1,
	                                                0, 0 );
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp2, IntPort2, 
	                                 &ExtIp2, &ExtPort2, RemIp2, RemPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	/* Expected In-Entry ( still is Conn1 ) */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 0 | 0; // quiet=@; dir=0; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 0 | 0; // quiet=1; dir=0; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= idx12;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	
	/* Expected Out-Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp2;
	Entry1.insideLocalPort		= IntPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 0 | 0; // quiet=@; dir=0; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 0 | 0; // quiet=1; dir=0; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	
	return SUCCESS;
}

//
// This is the case of Server Port.
// The user specified the (isTCP,intIP,intPort,gPort), but inIdx!=outIdx.
// Therefore we must place in/out entry in different entries.
// Therefore, we can use ASIC to accelerate. (L07)
// Expect: 
//         [ 73] is a Hash2 (tcpFlag:7) connection (Conn1). In Final, this entry is empty.
//         [ 80] is a Hash2 (tcpFlag:6) conenction (Conn3).
//         [987] is a Hash2 (tcpFlag:3) conenction (Conn4).
//
//                     in  out   intPort  ExtPort  RemPort
//         Conn1: H2(  80,  73)       80       80      ---
//         Conn2: H2(  80,  73)       80       80     1177
//         Conn3: H2(  80,  73)       80     1104     3344  -- This makes outbound ASIC entry swap to software.
//         Conn4: H2(  80, 987)     5566       80     7788  -- This makes inbound ASIC entry swap to software.
//                                                             Then, Conn3 holds the inbound ASIC entry.
//
int32 ServerPortUsingTwoHash2Entries(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	//// Conn1 ///////////////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 80;
	ipaddr_t ExtIp1 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort1 = 80;
	uint16 idx12 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1, 
	                                                0, 0 );
	                                               
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1, 
	                                 &ExtIp1, &ExtPort1, 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	/* Expected In-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=@; dir=1; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 0; // quiet=1; dir=1; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected Out-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=@; dir=1; outbound=1;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 1; // quiet=1; dir=1; outbound=1;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx12, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	//// Conn2 ///////////////////////////////////////////////////////////////////////////////////////////
	// test for port re-used
	uint32 IntIp2 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort2 = 80;
	ipaddr_t ExtIp2 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort2 = 80;
	uint32 RemIp2 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort2 = 1177;
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, IntIp2, IntPort2, 
	                                                0, 0 );
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp2, IntPort2,
	                                 &ExtIp2, &ExtPort2, RemIp2, RemPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	/* Expected In-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=@; dir=1; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 0; // quiet=1; dir=1; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	
	/* Expected Out-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=@; dir=1; outbound=1;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 1; // quiet=1; dir=1; outbound=1;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	

	//// Conn3 ///////////////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp3 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort3 = 80;
	ipaddr_t ExtIp3 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort3 = 1104;
	uint32 RemIp3 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort3 = 3344;
	uint16 idx32 = rtl8651_naptTcpUdpTableIndex( 1, IntIp3, IntPort3, 
	                                                0, 0 );
	
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp3, IntPort3,
	                                 &ExtIp3, &ExtPort3, RemIp3, RemPort3 );

	/* Expected In-Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=@; dir=1; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 0; // quiet=1; dir=1; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort3 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	
	/* Expected Out-Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx32, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	

	//// Conn4 ///////////////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp4 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort4 = 5566;
	ipaddr_t ExtIp4 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort4 = 80;
	uint32 RemIp4 = ntohl( inet_addr( "140.113.17.5" ) );
	uint16 RemPort4 = 7788;
	uint16 idx42 = rtl8651_naptTcpUdpTableIndex( 1, IntIp4, IntPort4, 
	                                                0, 0 );
	
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp4, IntPort4,
	                                 &ExtIp4, &ExtPort4, RemIp4, RemPort4 );

#if 1
	/* Since we DO NOT choose the best connection into ASIC after addConnection when ambiguous,
	 * the Conn3 will not win thios entry. It should be empty. 
	 */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 0;
	Entry1.isValid				= 0;
	Entry1.isDedicated			= 0;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#else
	/* Expected In-Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp3;
	Entry1.insideLocalPort		= IntPort3;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= ExtPort3 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp3, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#endif
	
	/* Expected Out-Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.insideLocalIpAddr	= IntIp4;
	Entry1.insideLocalPort		= IntPort4;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort4 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp4, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx42, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	

	return SUCCESS;
}


//
//  This function is used to test ALG-related function.
//
int32 TestNaptAlgConnection(uint32 caseNo) 
{
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort = 1025;
	uint32 remoteGlobalIpAddr = ntohl( inet_addr("140.113.1.1") );
	uint16 remoteGlobalPort = 80;
	ipaddr_t insideGlobalIpAddr; // out
	uint16 insideGlobalPort;     // out
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *alg, *successAlg;
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               0, 0 );
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// add an ALG control connection
	alg = _rtl8651_addNaptAlgConnection( FALSE, TCP_ESTABLISHED_FLOW, 
	                                     insideLocalIpAddr, insideLocalPort, 
	                                     &insideGlobalIpAddr, &insideGlobalPort,
	                                     remoteGlobalIpAddr, remoteGlobalPort );
	IS_NOT_EQUAL_POINTER( "addNaptAlgConnection() should fail, but success.", alg, NULL, __FUNCTION__, __LINE__ );
	successAlg = alg;

	IS_EQUAL_INT( "insideGlobalPort is not proper.", insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1), idx2, __FUNCTION__, __LINE__ );

	// add an existing ALG control connection
	alg = _rtl8651_addNaptAlgConnection( FALSE, TCP_ESTABLISHED_FLOW, 
	                                     insideLocalIpAddr, insideLocalPort, 
	                                     &insideGlobalIpAddr, &insideGlobalPort,
	                                     remoteGlobalIpAddr, remoteGlobalPort );
	IS_EQUAL_POINTER( "addNaptAlgConnection() should fail, but success.", alg, NULL, __FUNCTION__, __LINE__ );

	// there should be one connection in DrvTbl
	IS_NOT_EQUAL_POINTER( "should have entry in alg_outbound.", 
	                      SLIST_FIRST( &DrvTbl.tcpudp[idx2].list[NAPT_ALG_OUT] ), NULL,
	                      __FUNCTION__, __LINE__ );
	IS_NOT_EQUAL_POINTER( "should have entry in alg_outbound.", 
	                      SLIST_FIRST( &DrvTbl.tcpudp[idx2].list[NAPT_ALG_IN] ), NULL,
	                      __FUNCTION__, __LINE__ );

	// delete it
	IS_EQUAL_INT( "delNaptAlgConnection() failed", _rtl8651_delNaptAlgConnection( successAlg ), SUCCESS, __FUNCTION__, __LINE__ );
	
	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// add an ALG control connection with assigned port
	uint32 insideLocalIpAddr2 = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort2 = 1027;
	uint32 remoteGlobalIpAddr2 = ntohl( inet_addr("140.113.1.1") );
	uint16 remoteGlobalPort2 = 80;
	ipaddr_t insideGlobalIpAddr2 = ntohl( inet_addr("140.113.214.102") ); // out
	uint16 insideGlobalPort2 = 1030;     // out
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr2, insideLocalPort2, 
	                                                0, 0 );
	                                               
	alg = _rtl8651_addNaptAlgConnection( TRUE, TCP_ESTABLISHED_FLOW, 
	                                     insideLocalIpAddr2, insideLocalPort2, 
	                                     &insideGlobalIpAddr2, &insideGlobalPort2,
	                                     remoteGlobalIpAddr2, remoteGlobalPort2 );
	IS_NOT_EQUAL_POINTER( "addNaptAlgConnection() should fail, but success.", alg, NULL, __FUNCTION__, __LINE__ );
	successAlg = alg;

	// add an existing ALG control connection
	alg = _rtl8651_addNaptAlgConnection( FALSE, TCP_ESTABLISHED_FLOW, 
	                                     insideLocalIpAddr2, insideLocalPort2, 
	                                     &insideGlobalIpAddr2, &insideGlobalPort2,
	                                     remoteGlobalIpAddr2, remoteGlobalPort2 );
	IS_EQUAL_POINTER( "addNaptAlgConnection() should fail, but success.", alg, NULL, __FUNCTION__, __LINE__ );

	// add an existing ALG control connection with assigned external port
	alg = _rtl8651_addNaptAlgConnection( TRUE, TCP_ESTABLISHED_FLOW, 
	                                     insideLocalIpAddr2, insideLocalPort2, 
	                                     &insideGlobalIpAddr2, &insideGlobalPort2,
	                                     remoteGlobalIpAddr2, remoteGlobalPort2 );
	IS_EQUAL_POINTER( "addNaptAlgConnection() should fail, but success.", alg, NULL, __FUNCTION__, __LINE__ );

	// there should be one connection in DrvTbl
	IS_NOT_EQUAL_POINTER( "expect an entry in alg_outbound.", 
	                      SLIST_FIRST( &DrvTbl.tcpudp[idx22].list[NAPT_ALG_OUT] ), NULL,
	                      __FUNCTION__, __LINE__ );
	IS_NOT_EQUAL_POINTER( "expect an entry in alg_inbound.", 
	                      SLIST_FIRST( &DrvTbl.tcpudp[insideGlobalPort2&(RTL8651_TCPUDPTBL_SIZE-1)].list[NAPT_ALG_IN] ), NULL,
	                      __FUNCTION__, __LINE__ );
	
	// delete it
	IS_EQUAL_INT( "delNaptAlgConnection() failed", _rtl8651_delNaptAlgConnection( successAlg ), SUCCESS, __FUNCTION__, __LINE__ );
	
	return SUCCESS;
}


//
//  This function is used to test _rtl8651_updateNaptConnection() function.
//  We first add four Hash1 connections into NAPT table, then increase PPS value.
//
//  Expect:
//          [ 344] Hash 1 Connection
//
int32 TestUpdateNaptConnection1Way(uint32 caseNo) 
{
#define NUM_CONN	6
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret, i, j;
	uint32 IntIp[NUM_CONN];
	uint16 IntPort[NUM_CONN] = { 1025, 2055, 3077, 4107, 5129, 6159 };
	uint32 RemIp[NUM_CONN];
	uint16 RemPort[NUM_CONN] = {   53, 1073, 2097, 3129, 4157, 5177 };
	uint32 ExtIp[NUM_CONN];
	uint16 ExtPort[NUM_CONN];
	uint16 idx1[NUM_CONN];
	uint16 idx2[NUM_CONN];

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	_rtl8651_setl4NaptFindEmptyAsicRetry( 0 ); // just for testing ALL hash1 connections collided to the same entry.
	rtl8651_enable4WayHash( FALSE );

	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// initial value
	for( i = 0; i < NUM_CONN; i++ )
	{
		IntIp[i] = ntohl( inet_addr("192.168.1.1") );
		RemIp[i] = ntohl( inet_addr("140.113.17.5") );
		idx1[i] = rtl8651_naptTcpUdpTableIndex( 1, IntIp[i], IntPort[i], 
	                                               RemIp[i], RemPort[i] );
		idx2[i] = rtl8651_naptTcpUdpTableIndex( 1, IntIp[i], IntPort[i], 
	                                               0, 0 );

		if ( i != 0 )
		{
			// ALL hash1 index must be the same, and so hash2 does.
			IS_EQUAL_INT( "hash1 index is NOT the same with previos one", idx1[i], idx1[i-1], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "hash2 index is NOT the same with previos one", idx2[i], idx2[i-1], __FUNCTION__, __LINE__ );
		}

		ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp[i], IntPort[i],
		                                 &ExtIp[i], &ExtPort[i], 
		                                 RemIp[i], RemPort[i] );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}

	// PPS threshold
	_rtl8651_naptSmartFlowSwapByPPS( TRUE, 10 );

	/* Expected Initial status */
	Entry1.insideLocalIpAddr	= IntIp[0];
	Entry1.insideLocalPort		= IntPort[0];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort[0] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[0], 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;
	/* Read In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1[0] & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	///// 1-Way ////////////////////////////////////////////////////////////////////////////////////////////
	// Conn[1] is Hash2 and skipped (because Conn[1] is expected as Hash2, and others are Hash1).
	for( i = NUM_CONN - 1; i >= 0; i-- )
	{
		if ( i == 1 ) continue;

		int32 winner = i; // the who holds the ASIC entry.
		
		rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pEntry;
		pEntry = _rtl8651_findNaptConnection( idx1[winner], TRUE, IntIp[winner], IntPort[winner], RemIp[winner], RemPort[winner] );
		IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
		
		for( j = 0; j < 21; j++ )
		{
			_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
			                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );
		}

		/* Expected status */
		Entry1.insideLocalIpAddr	= IntIp[winner];
		Entry1.insideLocalPort		= IntPort[winner];
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
		Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
		Entry1.offset				= ExtPort[winner] >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[winner], 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= 0;
		Entry1.isTcp				= TRUE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 0;
		/* Read In-Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1[winner] & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	}	

	return SUCCESS;
}

//
//  This function is used to test _rtl8651_updateNaptConnection() function.
//  We first add four Hash1 connections into NAPT table, then increase PPS value.
//
//  Expect:
//	        [ 264] Hash 2 Connection (ConnXXX, disable typical case to use hash2 to accelerate)
//	        [ 265] Hash 2 Connection (ConnXXX, disable typical case to use hash2 to accelerate)
//          [ 344] Hash 1 Connection (Conn[0],Conn[4])
//          [ 345] Hash 1 Connection (Conn[1],Conn[5])
//          [ 346] Hash 1 Connection (Conn[2])
//          [ 347] Hash 1 Connection (Conn[3])
//
int32 TestUpdateNaptConnection4Way(uint32 caseNo) 
{
#define NUM_CONN	6
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret, i, j;
	uint32 IntIp[NUM_CONN];
	uint16 IntPort[NUM_CONN] = { 1025, 2055, 3077, 4107, 5129, 6159 };
	uint32 RemIp[NUM_CONN];
	uint16 RemPort[NUM_CONN] = {   53, 1073, 2097, 3129, 4157, 5177 };
	uint32 ExtIp[NUM_CONN];
	uint16 ExtPort[NUM_CONN];
	uint16 idx1[NUM_CONN];
	uint16 idx2[NUM_CONN];

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	_rtl8651_setl4NaptFindEmptyAsicRetry( 0 ); // just for testing ALL hash1 connection collided to the same entry.

	//// 4-Way /////////////////////////////////////////////////////////////////////////////////////////////
	rtl8651_enable4WayHash( TRUE );

	//// ConnXXX /////////////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 1025;
	uint32 ExtIp1 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort1 = 264;
	uint32 RemIp1 = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort1 = 80;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1,
	                                 &ExtIp1, &ExtPort1, RemIp1, RemPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );



	//////////////////////////////////////////////////////////////////////////////////////////////////////
	// initial value
	for( i = 0; i < NUM_CONN; i++ )
	{
		IntIp[i] = ntohl( inet_addr("192.168.1.1") );
		RemIp[i] = ntohl( inet_addr("140.113.17.5") );
		idx1[i] = rtl8651_naptTcpUdpTableIndex( 1, IntIp[i], IntPort[i], 
	                                               RemIp[i], RemPort[i] );
		idx2[i] = rtl8651_naptTcpUdpTableIndex( 1, IntIp[i], IntPort[i], 
	                                               0, 0 );

		if ( i != 0 )
		{
			// ALL hash1 index must be the same, and so hash2 does.
			IS_EQUAL_INT( "hash1 index is NOT the same with previos one", idx1[i], idx1[i-1], __FUNCTION__, __LINE__ );
			IS_EQUAL_INT( "hash2 index is NOT the same with previos one", idx2[i], idx2[i-1], __FUNCTION__, __LINE__ );
		}

		ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp[i], IntPort[i],
		                                 &ExtIp[i], &ExtPort[i], 
		                                 RemIp[i], RemPort[i] );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}

	// PPS threshold
	_rtl8651_naptSmartFlowSwapByPPS( TRUE, 10 );

	/* Expected Initial status */
	Entry1.insideLocalIpAddr	= IntIp[0];
	Entry1.insideLocalPort		= IntPort[0];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort[0] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[0], 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;
	/* Read In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1[0] & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	// Conn[4] is Hash2 and skipped.
	for( i = NUM_CONN - 1; i >= 0; i-- )
	{
		int32 winner = i; // the who holds the ASIC entry.
		
		rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pEntry;
		pEntry = _rtl8651_findNaptConnection( i < 4 ? WRAPIN_4WAY( idx1[winner], i ) : idx1[winner], TRUE, IntIp[winner], IntPort[winner], RemIp[winner], RemPort[winner] );
		IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
		
		for( j = 0; j < 21; j++ )
		{
			_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
			                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );
		}

		/* Expected status */
		Entry1.insideLocalIpAddr	= IntIp[winner];
		Entry1.insideLocalPort		= IntPort[winner];
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
		Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
		Entry1.offset				= ExtPort[winner] >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[winner], 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= 0;
		Entry1.isTcp				= TRUE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 0;
		/* Read In-Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( i < 4 ? WRAPIN_4WAY( idx1[winner], i ) : idx1[winner], &Entry0 ) == SUCCESS);
		if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	}	

	rtl8651_enable4WayHash( FALSE );

	return SUCCESS;
}


//
//	This case is used to test the hybrid connections.
//	We will add four connections: Hash1, UPnP, Server Port, and DMZ Host.
//  They are designed to be overwriten one-by-one.
//
//	Expect:
//			[ 269] Conn1 Hash1
//                       UPnP (outbound, in candidate)
//			[ 270] Conn2 UPnP (inbound)
//			             Server Port (outbound, in candidate)
//          [ 271] Conn3 Server Port (inbound)
//                       DMZ Host (outbound, in candidate)
//          [ 272] Conn4 DMZ Host (inbound)
//
//
//                 IntPort  ExtPort  RemPort
//          Conn1     1025    o:269      571
//                            i:269
//          Conn2     1024    o:269        0
//                            i:270
//          Conn3      257    o:270        0
//                            i:271
//          Conn4     1536    o:271       80
//                            i:272
//
int32 TestUpdateNaptConnectionHybrid1(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pEntry;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	_rtl8651_naptSmartFlowSwapByPPS( TRUE, 1 );
	rtl8651_enable4WayHash( TRUE );

	//// Conn 1, Hash 1 //////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 1025;
	uint32 ExtIp1;
	uint16 ExtPort1;
	uint32 RemIp1 = ntohl( inet_addr("140.113.209.90") );
	uint16 RemPort1 = 571;
	uint16 idx11 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1,
	                                                RemIp1, RemPort1 );
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1,
	                                 &ExtIp1, &ExtPort1, RemIp1, RemPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx1 should be equal to 269", idx11, 269, __FUNCTION__, __LINE__ );

	//// Conn 2, UPnP ////////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp2 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort2 = 1027;
	uint32 ExtIp2;
	uint16 ExtPort2;
	uint32 RemIp2 = ntohl( inet_addr("0.0.0.0") );
	uint16 RemPort2 = 0;
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, IntIp2, IntPort2,
	                                                0, 0 );
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp2, IntPort2,
	                                 &ExtIp2, &ExtPort2, RemIp2, RemPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx22 should be equal to idx11", idx22, idx11, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "ExtPort2 should be next to idx22", ExtPort2&(RTL8651_TCPUDPTBL_SIZE-1), idx22+1, __FUNCTION__, __LINE__ );

	//// Conn 3, Server Port /////////////////////////////////////////////////////////////////////////////
	uint32 IntIp3 = ntohl( inet_addr("192.168.1.2") );
	uint16 IntPort3 = 512;
	uint32 ExtIp3 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort3 = 271;
	uint32 RemIp3 = ntohl( inet_addr("0.0.0.0") );
	uint16 RemPort3 = 0;
	uint16 idx32 = rtl8651_naptTcpUdpTableIndex( 1, IntIp3, IntPort3,
	                                                0, 0 );
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp3, IntPort3,
	                                 &ExtIp3, &ExtPort3, RemIp3, RemPort3 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx32 should be equal to Extport2", idx32, ExtPort2&(RTL8651_TCPUDPTBL_SIZE-1), __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "ExtPort3 should be next to idx32", ExtPort3&(RTL8651_TCPUDPTBL_SIZE-1), idx32+1, __FUNCTION__, __LINE__ );

	//// Conn 4, DMZ Host ////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp4 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort4 = 1794;
	uint32 ExtIp4 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort4 = 272;
	uint32 RemIp4 = ntohl( inet_addr("140.113.209.90") );
	uint16 RemPort4 = 80;
	uint16 idx42 = rtl8651_naptTcpUdpTableIndex( 1, IntIp4, IntPort4,
	                                                0, 0 );
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp4, IntPort4,
	                                 &ExtIp4, &ExtPort4, RemIp4, RemPort4 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx42 should be equal to ExtPort3", idx42, ExtPort3&(RTL8651_TCPUDPTBL_SIZE-1), __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "ExtPort4 should be next to idx42", ExtPort4&(RTL8651_TCPUDPTBL_SIZE-1), idx42+1, __FUNCTION__, __LINE__ );

 	//// Conn 4 will win ASIC[271] ///////////////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx42, TRUE, IntIp4, IntPort4, RemIp4, RemPort4 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn4 will hold the ASIC entry [271] */
	Entry1.insideLocalIpAddr	= IntIp4;
	Entry1.insideLocalPort		= IntPort4;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort4 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp4, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn4 Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx42 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


 	//// Conn 3 will win ASIC[270] and [271] ////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx32, TRUE, IntIp3, IntPort3, RemIp3, RemPort3 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn3 will hold the outbound ASIC entry [270] */
	Entry1.insideLocalIpAddr	= IntIp3;
	Entry1.insideLocalPort		= IntPort3;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=@; dir=1; outbound=1;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 1; // quiet=1; dir=1; outbound=1;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort3 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp3, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort3 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn3 Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx32 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expect Conn3 will hold the inbound ASIC entry [271] */
	Entry1.insideLocalIpAddr	= IntIp3;
	Entry1.insideLocalPort		= IntPort3;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=@; dir=1; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 0; // quiet=1; dir=1; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort3 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp3, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort3 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn3 In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort3 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


 	//// Conn 2 will win ASIC[269] and [270] ////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx22, TRUE, IntIp2, IntPort2, RemIp2, RemPort2 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn2 will hold the outbound ASIC entry [269] */
	Entry1.insideLocalIpAddr	= IntIp2;
	Entry1.insideLocalPort		= IntPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn2 Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expect Conn2 will hold the inbound ASIC entry [270] */
	Entry1.insideLocalIpAddr	= IntIp2;
	Entry1.insideLocalPort		= IntPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn2 In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


 	//// Conn 1 will win ASIC[269] ////////////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx11, TRUE, IntIp1, IntPort1, RemIp1, RemPort1 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn1 will hold the ASIC entry [269] */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;
	/* Read Conn1 Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx11 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	rtl8651_enable4WayHash( FALSE );
	return SUCCESS;
}


//
//	This case is used to test the hybrid connections for ambiguous Hash2 connections.
//	We will add four connections: Hash1, UPnP, Server Port, and DMZ Host.
//  They are designed to be overwriten in the same port (269).
//  We expect only Hash 1 connection and inbound flow of Conn2 can be ASIC-accelerated.
//
//	Expect:
//			[ 269] Conn1 Hash1 <--- ASIC accelerated
//                 Conn3 Server Port (inbound, in candidate)
//			             Server Port (outbound, in candidate)
//                 Conn4 DMZ Host (inbound, in candidate)
//                       DMZ Host (outbound, in candidate)
//                       UPnP (outbound, in candidate)
//			[ 270] Conn2 UPnP (inbound) <--- ASIC accelerated
//
//
//                 IntPort  ExtPort  RemPort
//          Conn1     1025    o:269      571  <--- ASIC accelerated
//                            i:269
//          Conn2     1027    o:269        0  <--- ASIC accelearted
//                            i:270           <--- ASIC accelearted
//          Conn3      512    o:269        0
//                            i:269
//          Conn4     1538    o:269       80
//                            i:269
//
int32 TestUpdateNaptConnectionHybrid2(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pEntry;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	_rtl8651_naptSmartFlowSwapByPPS( TRUE, 1 );
	rtl8651_enable4WayHash( TRUE );

	//// Conn 1, Hash 1 //////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 1025;
	uint32 ExtIp1;
	uint16 ExtPort1;
	uint32 RemIp1 = ntohl( inet_addr("140.113.209.90") );
	uint16 RemPort1 = 571;
	uint16 idx11 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1,
	                                                RemIp1, RemPort1 );
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1,
	                                 &ExtIp1, &ExtPort1, RemIp1, RemPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx11 should be equal to 269", idx11, 269, __FUNCTION__, __LINE__ );

	//// Conn 2, UPnP ////////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp2 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort2 = 1027;
	uint32 ExtIp2;
	uint16 ExtPort2;
	uint32 RemIp2 = ntohl( inet_addr("0.0.0.0") );
	uint16 RemPort2 = 0;
	uint16 idx22 = rtl8651_naptTcpUdpTableIndex( 1, IntIp2, IntPort2,
	                                                0, 0 );
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp2, IntPort2,
	                                 &ExtIp2, &ExtPort2, RemIp2, RemPort2 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx22 should be equal to idx11", idx22, idx11, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "ExtPort2 should be next to idx42", ExtPort2&(RTL8651_TCPUDPTBL_SIZE-1), idx22+1, __FUNCTION__, __LINE__ );

	//// Conn 3, Server Port /////////////////////////////////////////////////////////////////////////////
	uint32 IntIp3 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort3 = 512;
	uint32 ExtIp3 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort3 = 269;
	uint32 RemIp3 = ntohl( inet_addr("0.0.0.0") );
	uint16 RemPort3 = 0;
	uint16 idx32 = rtl8651_naptTcpUdpTableIndex( 1, IntIp3, IntPort3,
	                                                0, 0 );
	IS_EQUAL_INT( "ExtPort3 is different with idx32", idx32, ExtPort3 & (RTL8651_TCPUDPTBL_SIZE-1), __FUNCTION__, __LINE__ );
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp3, IntPort3,
	                                 &ExtIp3, &ExtPort3, RemIp3, RemPort3 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx32 should be equal to idx22", idx32, idx22, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "ExtPort3 should be next to idx32", ExtPort3&(RTL8651_TCPUDPTBL_SIZE-1), idx32, __FUNCTION__, __LINE__ );

	//// Conn 4, DMZ Host ////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp4 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort4 = 1538;
	uint32 ExtIp4 = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort4 = 269;
	uint32 RemIp4 = ntohl( inet_addr("140.113.209.90") );
	uint16 RemPort4 = 80;
	uint16 idx42 = rtl8651_naptTcpUdpTableIndex( 1, IntIp4, IntPort4,
	                                                0, 0 );
	IS_EQUAL_INT( "ExtPort3 is different with idx32", idx42, ExtPort4 & (RTL8651_TCPUDPTBL_SIZE-1), __FUNCTION__, __LINE__ );
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp4, IntPort4,
	                                 &ExtIp4, &ExtPort4, RemIp4, RemPort4 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "idx42 should be equal to idx32", idx42, idx32, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "ExtPort4 should be next to idx42", ExtPort4&(RTL8651_TCPUDPTBL_SIZE-1), idx42, __FUNCTION__, __LINE__ );


 	//// Conn 4 should win //////////////////////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx42, TRUE, IntIp4, IntPort4, RemIp4, RemPort4 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn4's outbount entry holds the ASIC entry [269] */
	Entry1.insideLocalIpAddr	= IntIp4;
	Entry1.insideLocalPort		= IntPort4;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort4 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp4, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= idx42;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn1 Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx42 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


 	//// Conn 3 should win //////////////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx32, TRUE, IntIp3, IntPort3, RemIp3, RemPort3 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn3 still holds the ASIC entry [269] */
	Entry1.insideLocalIpAddr	= IntIp3;
	Entry1.insideLocalPort		= IntPort3;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=@; dir=1; outbound=1;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 1; // quiet=1; dir=1; outbound=1;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= ExtPort3 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp3, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort3 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn1 Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx32 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

 	//// Conn 2 should win ASIC[269] and [270] ////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx22, TRUE, IntIp2, IntPort2, RemIp2, RemPort2 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn2 has hold the outbound ASIC entry [269] */
	Entry1.insideLocalIpAddr	= IntIp2;
	Entry1.insideLocalPort		= IntPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn2 Out-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx22 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expect Conn2 will hold the inbound ASIC entry [270] */
	Entry1.insideLocalIpAddr	= IntIp2;
	Entry1.insideLocalPort		= IntPort2;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort2 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp2, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read Conn2 In-Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort2 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


 	//// Conn 1 wins ASIC[269] //////////////////////////////////////////////////////////////////////
	pEntry = _rtl8651_findNaptConnection( idx11, TRUE, IntIp1, IntPort1, RemIp1, RemPort1 );
	IS_NOT_EQUAL_POINTER( "findNaptConnection() failed", pEntry, NULL, __FUNCTION__, __LINE__ );
	_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW,
	                               _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) ) );

	/* Expect Conn1 still holds the ASIC entry [269] */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW - 1;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp1, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;
	/* Read Conn1 Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx11 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	rtl8651_enable4WayHash( FALSE );
	return SUCCESS;
}


#else//CONFIG_RTL865XB_EXP_HASH2
#endif//CONFIG_RTL865XB_EXP_HASH2


//
//	This case is used to test functionality of keeping newly-added HASH2 UDP from ASIC (for CDRouter case 89 and 90).
//
//	We will set DMZ Host to force using HASH2, and add 1024 UDP connections from WAN to LAN.
//  We expect all inbound entry is in ASIC, and outbound entry is in software.
//  Then, we will repeat sending UDP packets to trap the connections to ASIC for n times
//    ( n is bigger than _smartNaptSwappingThresholdUdp).
// 
//	Expect:
//			[   0] Conn0 Hash2
//              :
//			[1023] Conn1023 Hash2
//
//
#define NEWLY_ADDED_MIN 1
#define NEWLY_ADDED_MAX 1024
int32 testNewlyAddedHash2Udp(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pEntry;
	int i;
	int idx2;
	ipaddr_t _IntIp = ntohl(inet_addr("192.168.1.253"));
	ipaddr_t _ExtIp = ntohl(inet_addr("140.113.214.102"));
	ipaddr_t _RemIp = ntohl(inet_addr("3.3.3.3"));

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	//_rtl8651_naptSmartFlowSwapByPPS( TRUE, 1 );
	rtl8651_enable4WayHash( TRUE );;
	ret = rtl8651_addDmzHost( _ExtIp, _IntIp );
	IS_EQUAL_INT( "addDmzHost() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	//// Add Connection //////////////////////////////////////////////////////////////////////////////////
	uint32 IntIp[NEWLY_ADDED_MAX];
	uint16 IntPort[NEWLY_ADDED_MAX];
	uint32 ExtIp[NEWLY_ADDED_MAX];
	uint16 ExtPort[NEWLY_ADDED_MAX];
	uint32 RemIp[NEWLY_ADDED_MAX];
	uint16 RemPort[NEWLY_ADDED_MAX];

	for( i = NEWLY_ADDED_MIN; i < NEWLY_ADDED_MAX; i++ )
	{
		IntIp[i] = _IntIp;
		IntPort[i] = i;
		ExtIp[i] = _ExtIp;
		ExtPort[i] = i;
		RemIp[i] = _RemIp;
		RemPort[i] = 80;
		idx2 = rtl8651_naptTcpUdpTableIndex( 0, IntIp[i], IntPort[i],
		                                     0, 0 );
		                                               
		ret = rtl8651_addNaptConnection( TRUE, UDP_FLOW, IntIp[i], IntPort[i],
		                                 &ExtIp[i], &ExtPort[i], RemIp[i], RemPort[i] );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "ExtPort should be equal to Idx2", ExtPort[i], i, __FUNCTION__, __LINE__ );
	}

#if 1 /* Louis note: inbound entry is in software also. */
	//// Expect NO inbound entry is using ASIC //////////////////////////////////////////////////////////////////////////////////
	for( i = NEWLY_ADDED_MIN; i < NEWLY_ADDED_MAX; i++ )
	{
		idx2 = rtl8651_naptTcpUdpTableIndex( 0, IntIp[i], IntPort[i],
		                                     0, 0 );
		/* Expect Conn's outbount entry holds the ASIC entry */
		memset( &Entry1, 0, sizeof(Entry1) );
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		/* Read Conn1 Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort[i] & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	}
#else/*1*/
	//// Expect only inbound entry is using ASIC //////////////////////////////////////////////////////////////////////////////////
	for( i = NEWLY_ADDED_MIN; i < NEWLY_ADDED_MAX; i++ )
	{
		idx2 = rtl8651_naptTcpUdpTableIndex( 0, IntIp[i], IntPort[i],
		                                     0, 0 );
		/* Expect Conn's outbount entry holds the ASIC entry */
		memset( &Entry1, 0, sizeof(Entry1) );
		Entry1.insideLocalIpAddr	= IntIp[i];
		Entry1.insideLocalPort		= IntPort[i];
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
		Entry1.tcpFlag				= 0 | 2 | 0; // quiet=0; dir=1; outbound=0;
		Entry1.offset				= ExtPort[i] >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[i], 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= ExtPort[i] & ((1<<RTL8651_TCPUDPTBL_BITS)-1);
		Entry1.isTcp				= FALSE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 1;
		/* Read Conn1 Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort[i] & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	}
#endif/*1*/

	//// call updateNaptConnection() serveral times to //////////////////////////////////////////////////////////////////////////////////
	//// Expect inbound and outbound entries are using ASIC //////////////////////////////////////////////////////////////////////////////////
	for( i = NEWLY_ADDED_MIN; i < NEWLY_ADDED_MAX; i++ )
	{
		int j;
		rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pe;

		//printf("[%d]\n", i );		
		idx2 = rtl8651_naptTcpUdpTableIndex( 0, IntIp[i], IntPort[i],
		                                     0, 0 );

		pe = _rtl8651_findNaptConnectionByExtIpPort( FALSE, ExtIp[i], ExtPort[i], RemIp[i], RemPort[i] );
		IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", pe, NULL, __FUNCTION__, __LINE__ );

		for( j = 0; j < 10/*_smartNaptSwappingThresholdUdp*/; j++ )
			_rtl8651_updateNaptConnection( pe, 0, rtl8651GlobalControl.udpTimeout );

		/* Expect Conn's inbount entry holds the ASIC entry */
		memset( &Entry1, 0, sizeof(Entry1) );
		Entry1.insideLocalIpAddr	= IntIp[i];
		Entry1.insideLocalPort		= IntPort[i];
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
		Entry1.tcpFlag				= 0 | 2 | 0; // quiet=0; dir=1; outbound=0;
		Entry1.offset				= ExtPort[i] >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[i], 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= ExtPort[i] & ((1<<RTL8651_TCPUDPTBL_BITS)-1);
		Entry1.isTcp				= FALSE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 1;
		/* Read Conn1 Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort[i] & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
		
		/* Expect Conn's outbount entry holds the ASIC entry */
		memset( &Entry1, 0, sizeof(Entry1) );
		Entry1.insideLocalIpAddr	= IntIp[i];
		Entry1.insideLocalPort		= IntPort[i];
		Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.udpTimeout ) );
		Entry1.tcpFlag				= 0 | 2 | 1; // quiet=0; dir=1; outbound=1;
		Entry1.offset				= ExtPort[i] >> RTL8651_TCPUDPTBL_BITS;
		Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( ExtIp[i], 0, IP_ATTR_NAPT ) );
		Entry1.selEIdx				= ExtPort[i] & ((1<<RTL8651_TCPUDPTBL_BITS)-1);
		Entry1.isTcp				= FALSE;
		Entry1.isCollision			= 1;
		Entry1.isCollision2			= 1;
		Entry1.isStatic				= 1;
		Entry1.isValid				= 1;
		Entry1.isDedicated			= 1;
		/* Read Conn1 Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
	}

	rtl8651_enable4WayHash( FALSE );
	return SUCCESS;
}


//
// This is a simple test for _rtl8651_getOutboundNaptFlow() whose pEntry==NULL.
// Only one entry would be write to ASIC.
// [ 866] S1 TCP From 192.168.1.2:49504 Use 33634 EIDX:0 HwAge:961
//               Dest:192.168.154.110:49578 SwAge:884 
//
int32 testGetOutboundNaptFlow(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 intIp = ntohl( inet_addr("192.168.1.2") );
	uint16 intPort = 49504;
	uint32 remIp = ntohl( inet_addr("192.168.154.110") );
	uint16 remPort = 49578;
	ipaddr_t extIp; // out
	uint16 extPort; // out
	int32 ret;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry = NULL;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( TRUE, intIp, intPort, 
	                                                  remIp, remPort );
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW,
	                                 intIp, intPort, 
	                                 &extIp, &extPort,
	                                 remIp, remPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", extPort & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
	Entry1.offset				= extPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0;

	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	TCPUDP_ENTRY_CMP( &Entry0, &Entry1 );

	/* try get outbound napt flow */
	ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
	                                          remIp, remPort,
	                                          &pEntry );
	IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideLocalPort should be the same.", intPort, pEntry->insideLocalPort, __FUNCTION__, __LINE__ );

	return SUCCESS;
}


//
// This function emulates the performance of new-arrival connecitons (Hash1).
//
// The procedure includes:
//   1. getOutboundNaptConnection() misses -- fast path
//   2. getOutboundNaptConnection() misses -- slow path
//   3. getOutboundNaptConnection() misses -- in addNaptConnection()
//   4. getOutboundNaptConnection() success -- after addNaptConnection()
//
//
#define TOTAL_CONN_HASH1 20000
int32 AddConnPerSec_Hash1(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 intIp = ntohl( inet_addr("192.168.1.1") );
	uint16 intPort = 1024;
	uint32 remIp = ntohl( inet_addr("192.168.154.110") );
	uint16 remPort = 80;
	ipaddr_t extIp = ntohl( inet_addr("140.113.214.102") ); // out
	uint16 extPort = 80; // out
	int32 ret;
	int32 i;
#ifndef CYGWIN
	struct timeval tvStart, tvEnd;
#endif
	float passedSec;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry = NULL;
	uint16 idx1;
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

#ifndef CYGWIN
	gettimeofday( &tvStart );
#endif
	for( i = 0; i < TOTAL_CONN_HASH1; i++ )
	{
		intPort++;
		if ( ( intPort & 0xffff ) == 0x0000 ) intIp++;
		idx1 = rtl8651_naptTcpUdpTableIndex( 0, intIp, intPort, 
	                                            remIp, remPort );
		
		/* get outbound napt flow in fast path */
		ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
		                                          remIp, remPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, TBLDRV_EENTRYNOTFOUND, __FUNCTION__, __LINE__ );

		/* get outbound napt flow in slow path */
		ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
		                                          remIp, remPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, TBLDRV_EENTRYNOTFOUND, __FUNCTION__, __LINE__ );

		/* insert the connection */
		ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
		                                 intIp, intPort, 
		                                 &extIp, &extPort,
		                                 remIp, remPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );

		/* try get outbound napt flow */
		ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
		                                          remIp, remPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideLocalPort should be the same.", intPort, pEntry->insideLocalPort, __FUNCTION__, __LINE__ );

		_rtl8651_timeUpdate( 1 );
	}

#ifndef CYGWIN
	gettimeofday( &tvEnd );

	passedSec = (tvEnd.tv_sec-tvStart.tv_sec)+(((float)(tvEnd.tv_usec-tvStart.tv_usec))/1000000);

	printf("Total:%d  passed second:%f  avarage=%f\n", TOTAL_CONN_HASH1, passedSec, TOTAL_CONN_HASH1/passedSec );
#endif

	return SUCCESS;
}


//
// This function emulates the performance of new-arrival connecitons (Hash2).
//
// The procedure includes:
//   1. getOutboundNaptConnection() misses -- fast path
//   2. getOutboundNaptConnection() misses -- slow path
//   3. getOutboundNaptConnection() misses -- in addNaptConnection()
//   4. getOutboundNaptConnection() success -- after addNaptConnection()
//
//
#define TOTAL_CONN_HASH2 20000
int32 AddConnPerSec_Hash2(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 intIp = ntohl( inet_addr("192.168.1.1") );
	uint16 intPort = 1024;
	uint32 remIp = ntohl( inet_addr("192.168.154.110") );
	uint16 remPort = 80;
	ipaddr_t extIp = ntohl( inet_addr("140.113.214.102") ); // out
	uint16 extPort = 80; // out
	int32 ret;
	int32 i;
#ifndef CYGWIN
	struct timeval tvStart, tvEnd;
#endif
	float passedSec;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry = NULL;
	uint16 idx1;
	START_TEST_CASE();
	ConfigNaptTestEnvironment();

#ifndef CYGWIN
	gettimeofday( &tvStart );
#endif
	for( i = 0; i < TOTAL_CONN_HASH2; i++ )
	{
		remPort++;
		if ( ( intPort & 0xffff ) == 0x0000 ) intIp++;
		idx1 = rtl8651_naptTcpUdpTableIndex( 0, intIp, intPort, 
	                                            remIp, remPort );
		
		/* get outbound napt flow in fast path */
		ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
		                                          remIp, remPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, TBLDRV_EENTRYNOTFOUND, __FUNCTION__, __LINE__ );

		/* get outbound napt flow in slow path */
		ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
		                                          remIp, remPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, TBLDRV_EENTRYNOTFOUND, __FUNCTION__, __LINE__ );

		/* insert the connection */
		ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
		                                 intIp, intPort, 
		                                 &extIp, &extPort,
		                                 remIp, remPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );

		/* try get outbound napt flow */
		ret = _rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort,
		                                          remIp, remPort,
		                                          &pEntry );
		IS_EQUAL_INT( "getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideLocalPort should be the same.", intPort, pEntry->insideLocalPort, __FUNCTION__, __LINE__ );

		_rtl8651_timeUpdate( 1 );
	}

#ifndef CYGWIN

	gettimeofday( &tvEnd );

	passedSec = (tvEnd.tv_sec-tvStart.tv_sec)+(((float)(tvEnd.tv_usec-tvStart.tv_usec))/1000000);

	printf("Total:%d  passed second:%f  avarage=%f\n", TOTAL_CONN_HASH2, passedSec, TOTAL_CONN_HASH2/passedSec );
#endif
	
	return SUCCESS;
}


//
// This is the case for Netmeeting ALG.
// Since server port connection is added, newly-outbound packet should match the existed server port conneciton.
// Therefore, the extIp/extPort will be the same with the server port, not HASH1 connction.
//
int32 ServerPortAndNewHash1(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 intIp = ntohl( inet_addr("192.168.1.1") );
	uint16 intPort = 1025;
	ipaddr_t extIp;
	uint16 extPort;
	ipaddr_t remIp = ntohl( inet_addr("140.113.1.1") );
	uint16 remPort = 80;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry;
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, intIp, intPort, 
	                                               0, 0 );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	extIp = ntohl( inet_addr("140.113.214.102") );
	extPort = 1025;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, intIp, intPort, 
	                                 &extIp, &extPort, 0, 0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry (Outbound) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 1; // quiet=@; dir=1; outbound=1;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 1; // quiet=1; dir=1; outbound=1;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= extPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= extPort&(RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected TCPUDP Entry (Inbound) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
#ifdef ADD_FINITE_HASH2_SP
	Entry1.tcpFlag				= 0 | 2 | 0; // quiet=@; dir=1; outbound=0;
#else/*ADD_FINITE_HASH2_SP*/
	Entry1.tcpFlag				= 4 | 2 | 0; // quiet=1; dir=1; outbound=0;
#endif/*ADD_FINITE_HASH2_SP*/
	Entry1.offset				= extPort >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= extPort&(RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	ASSERT(_rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort, remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, 0, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, 0, __FUNCTION__, __LINE__ )

	ASSERT(_rtl8651_getInboundNaptFlow( TRUE, extIp, extPort, remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, 0, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, 0, __FUNCTION__, __LINE__ )

	return SUCCESS;
}


//
// This is the case for 4-way hash1.
// Louis wonder if the 4-way hash1 is OK.
// We expect these 4 connections use the same group of ASIC entry. 
//
int32 testNapt4WayHash(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	uint32 intIp = ntohl( inet_addr("192.168.1.1") );
	uint16 intPort[4] = { 1025, 2050, 3075, 4100 };
	ipaddr_t extIp;
	uint16 extPort[4];
	ipaddr_t remIp = ntohl( inet_addr("140.113.1.1") );
	uint16 remPort = 80;
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, intIp, intPort[0], 
	                                               remIp, remPort );

	START_TEST_CASE();
	ConfigNaptTestEnvironment();
	rtl8651_enable4WayHash( TRUE );

	//
	// Conn1
	//
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, intIp, intPort[0], 
	                                 &extIp, &extPort[0], remIp, remPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extIp should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extPort should be assigned properly.", extPort[0]&(RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry (Conn1) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[0];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
	Entry1.offset				= extPort[0] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0; /* HASH1 */
	/* Read TCPUDP Entry (Conn1) */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	ASSERT(_rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort[0], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[0], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[0], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )

	ASSERT(_rtl8651_getInboundNaptFlow( TRUE, extIp, extPort[0], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[0], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[0], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )


	//
	// Conn12
	//
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, intIp, intPort[1], 
	                                 &extIp, &extPort[1], remIp, remPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extIp should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extPort should be assigned properly.", extPort[1]&(RTL8651_TCPUDPTBL_SIZE-1), idx1+1, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry (Conn1) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[1];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
	Entry1.offset				= extPort[1] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0; /* HASH1 */
	/* Read TCPUDP Entry (Conn1) */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1+1, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	ASSERT(_rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort[1], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[1], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[1], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )

	ASSERT(_rtl8651_getInboundNaptFlow( TRUE, extIp, extPort[1], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[1], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[1], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )


	//
	// Conn13
	//
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, intIp, intPort[2], 
	                                 &extIp, &extPort[2], remIp, remPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extIp should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extPort should be assigned properly.", extPort[2]&(RTL8651_TCPUDPTBL_SIZE-1), idx1+2, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry (Conn1) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[2];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
	Entry1.offset				= extPort[2] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0; /* HASH1 */
	/* Read TCPUDP Entry (Conn1) */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1+2, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	ASSERT(_rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort[2], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[2], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[2], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )

	ASSERT(_rtl8651_getInboundNaptFlow( TRUE, extIp, extPort[2], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[2], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[2], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )


	//
	// Conn14
	//
	ret = rtl8651_addNaptConnection( FALSE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, intIp, intPort[3], 
	                                 &extIp, &extPort[3], remIp, remPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extIp should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "extPort should be assigned properly.", extPort[3]&(RTL8651_TCPUDPTBL_SIZE-1), idx1+3, __FUNCTION__, __LINE__ );

	/* Expected TCPUDP Entry (Conn1) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[3];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= TCP_ESTABLISHED_FLOW-1;
	Entry1.offset				= extPort[3] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= 0;
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 0; /* HASH1 */
	/* Read TCPUDP Entry (Conn1) */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx1+3, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	ASSERT(_rtl8651_getOutboundNaptFlow( TRUE, intIp, intPort[3], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[3], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[3], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )

	ASSERT(_rtl8651_getInboundNaptFlow( TRUE, extIp, extPort[3], remIp, remPort, &pEntry )==SUCCESS);
	IS_EQUAL_INT( "intIp is not the same", pEntry->insideLocalIpAddr, intIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "intPort is not the same", pEntry->insideLocalPort, intPort[3], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extIp is not the same", pEntry->insideGlobalIpAddr, extIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "extPort is not the same", pEntry->insideGlobalPort, extPort[3], __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remIp is not the 0", pEntry->dstIpAddr, remIp, __FUNCTION__, __LINE__ )
	IS_EQUAL_INT( "remPort is not the 0", pEntry->dstPort, remPort, __FUNCTION__, __LINE__ )

	rtl8651_enable4WayHash( FALSE );

	return SUCCESS;
}


#ifdef LEGACY_AGING_CODE
#else/*LEGACY_AGING_CODE*/
/*
 * This is the case for HASH2 port-reused age when LEGACY_AGING_CODE is disabled.
 * When reused HASH2 port is ASIC accelerated, software must update age value from ASIC age.
 * However, we expect only port-reused connections' age will be updated.
 *
 *        IntPort   ExtPort   RemPort
 *  A TCP 1025      1025      80
 *  B TCP 1025      1025      5566
 *  C UDP 1025      1025      5566
 *  D TCP 2055      1025      7788
 *  E TCP 3077      2050      80
 *
 * We expect Conn A will be ASIC-accelerated. Conn B's age will be updated with Conn A's ASIC age.
 * Conn C, D, E's age should not be modified.
 *
 */
#define NUM_HASH2_REUSE_PORT 5
int32 testAgeOfHash2PortReused(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	int8 tcpState[NUM_HASH2_REUSE_PORT] = { TCP_ESTABLISHED_FLOW, TCP_ESTABLISHED_FLOW, UDP_FLOW, TCP_ESTABLISHED_FLOW, TCP_ESTABLISHED_FLOW };
	uint32 intIp = ntohl( inet_addr("192.168.1.1") );
	uint16 intPort[NUM_HASH2_REUSE_PORT] = { 1025, 1025, 1025, 2055, 3077 };
	ipaddr_t extIp = ntohl( inet_addr("140.113.214.102") );
	uint16 extPort[NUM_HASH2_REUSE_PORT] = { 1025, 1025, 1025, 1025, 2050 };
	ipaddr_t remIp = ntohl( inet_addr("140.113.1.1") );
	uint16 remPort[NUM_HASH2_REUSE_PORT] = { 80, 5566, 5566, 7788, 80 };
	uint32 OrgAge[NUM_HASH2_REUSE_PORT];
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry[NUM_HASH2_REUSE_PORT];
	uint16 idx2;
	int i;

	uint32 sameAge = 641; /* To simply procedure, all timeout use this value. */
	rtl8651_setNaptTcpFastTimeout( sameAge );
	rtl8651_setNaptTcpMediumTimeout( sameAge );
	rtl8651_setNaptTcpLongTimeout( sameAge );
	rtl8651_setNaptUdpTimeout( sameAge );
	rtl8651_setNaptTcpFinTimeout( sameAge );

	/* We assist all hash2 index is the same. */
	idx2 = rtl8651_naptTcpUdpTableIndex( tcpState[0]?1:0, intIp, intPort[0], 0, 0 );
	for( i=1; i<NUM_HASH2_REUSE_PORT; i++ )
	{
		uint16 tmp = rtl8651_naptTcpUdpTableIndex( tcpState[i]?1:0, intIp, intPort[i], 0, 0 );
		//printf("i=%d  idx2=%d  tmp=%d\n",i,idx2,tmp);
		if ( i != 2 )
			ASSERT( tmp == idx2 );
	}

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	/* Conn A */
	i = 0;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, tcpState[i], intIp, intPort[i], 
	                                 &extIp, &extPort[i], remIp, remPort[i] );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==SUCCESS);
	OrgAge[i] = pEntry[i]->age;

	/* Expected TCPUDP Entry (Conn A) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[i];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= extPort[i] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= extPort[i]&(RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected TCPUDP Entry (Inbound) */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[i];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= extPort[i] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= extPort[i]&(RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort[i]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Conn B */
	i = 1;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, tcpState[i], intIp, intPort[i], 
	                                 &extIp, &extPort[i], remIp, remPort[i] );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==SUCCESS);
	OrgAge[i] = pEntry[i]->age;

	/* Conn C */
	i = 2;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, tcpState[i], intIp, intPort[i], 
	                                 &extIp, &extPort[i], remIp, remPort[i] );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==SUCCESS);
	OrgAge[i] = pEntry[i]->age;

	/* Conn D */
	i = 3;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, tcpState[i], intIp, intPort[i], 
	                                 &extIp, &extPort[i], remIp, remPort[i] );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==SUCCESS);
	OrgAge[i] = pEntry[i]->age;

	/* Conn E */
	i = 4;
	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, tcpState[i], intIp, intPort[i], 
	                                 &extIp, &extPort[i], remIp, remPort[i] );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", extIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==SUCCESS);
	OrgAge[i] = pEntry[i]->age;

	/* Expected TCPUDP Entry (Inbound)
	 * Conn A/B/C/D cause ambigious in inbound direction.
	 */
	Entry1.insideLocalIpAddr	= intIp;
	Entry1.insideLocalPort		= intPort[i];
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= extPort[i] >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= IP_TABLE_INDEX( _rtl8651_getIPTableEntry( extIp, 0, IP_ATTR_NAPT ) );
	Entry1.selEIdx				= extPort[i]&(RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= TRUE;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;
	/* Read TCPUDP Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort[i]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;


	/************* All connections are added ******************/

	/*---------------------------------------------------------
	 * We expect only Conn B will be refilled as Conn a.
	 */

	/*---------------------------------------------------------
	 * Defined event trigger, timeUpdate() will trigger _rtl8651_softwareNaptAging().
	 * Then, _rtl8651_softwareNaptAging() will trigger _rtl8651_updateAsicNaptTable()
	 *
	 * Seconds passed, every connection is almost died.
	 * We assume all aging value is correct.
	 *
	 * Conn A    refilled by ASIC
	 * Conn B    refilled by Conn A
	 * Conn C    10
	 * Conn D    10
	 * Conn E    refilled by ASIC
	 *
	 */
	uint32 secPassed = sameAge - 10;
	for( i=0; i<secPassed; i++ ) _rtl8651_timeUpdate( 1 );
	//for( i=0; i<NUM_HASH2_REUSE_PORT; i++ ) printf("[%d] age=%d\n",i,pEntry[i]->age);
	IS_EQUAL_INT( "Conn A's age is not the same with expected.", pEntry[0]->age, OrgAge[0], __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Conn B's age is not the same with expected.", pEntry[1]->age, OrgAge[1]-1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Conn C's age is not the same with expected.", pEntry[2]->age, 10, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Conn D's age is not the same with expected.", pEntry[3]->age, 10, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Conn E's age is not the same with expected.", pEntry[4]->age, OrgAge[4], __FUNCTION__, __LINE__ );
	for( i=0; i<NUM_HASH2_REUSE_PORT; i++ ) OrgAge[i] = pEntry[i]->age;

	/*---------------------------------------------------------
	 * 15 seconds passed, Conn C and D are died.
	 */
	secPassed = 15;
	for( i=0; i<secPassed; i++ ) _rtl8651_timeUpdate( 1 );

	/* Conn C (expect died) */
	i = 2;
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==TBLDRV_EENTRYNOTFOUND);

	/* Conn D (expect died) */
	i = 3;
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==TBLDRV_EENTRYNOTFOUND);


	secPassed = sameAge - 2;
	/*---------------------------------------------------------
	 * Simulate several seconds had passed until 3 seconds.
	 */
	pEntry[0]->age -= secPassed;
	pEntry[1]->age -= secPassed;
	pEntry[4]->age -= secPassed;

	/* decrease age of Conn A outbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	Entry0.ageSec -= secPassed;
	ASSERT(rtl8651_setAsicNaptTcpUdpTable( TRUE, idx2, &Entry0 ) == SUCCESS);

	/* decrease age of Conn E inbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	Entry0.ageSec -= secPassed;
	ASSERT(rtl8651_setAsicNaptTcpUdpTable( TRUE, extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);

	/*---------------------------------------------------------
	 * One more second, age is still low.
	 */
	_rtl8651_timeUpdate( 1 );
	IS_EQUAL_INT( "Conn A's ASIC age should be refilled.", pEntry[0]->age, 2-1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Conn B's ASIC age should be refilled.", pEntry[1]->age, 2-2, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Conn E's ASIC age should be refilled.", pEntry[4]->age, 2-1, __FUNCTION__, __LINE__ );

	/*---------------------------------------------------------
	 * But now, a Conn A packet passes through software, age is refilled.
	 */
	pEntry[0]->age = sameAge;
	_rtl8651_timeUpdate( 1 );
	ASSERT(	pEntry[0]->age == sameAge-1 );
	IS_EQUAL_INT( "Conn A's SW age should be refilled.", pEntry[0]->age, sameAge-1, __FUNCTION__, __LINE__ );
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	IS_EQUAL_INT( "Conn A's ASIC age should be refilled.", Entry0.ageSec, sameAge, __FUNCTION__, __LINE__ );
	
	/*---------------------------------------------------------
	 * A Conn E packet passes through software, age is refilled.
	 */
	pEntry[4]->age = sameAge;
	_rtl8651_timeUpdate( 1 );
	ASSERT(	pEntry[4]->age == sameAge-1 );
	IS_EQUAL_INT( "Conn E's SW age should be refilled.", pEntry[4]->age, sameAge-1, __FUNCTION__, __LINE__ );
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	IS_EQUAL_INT( "Conn E's ASIC age should be refilled.", Entry0.ageSec, sameAge, __FUNCTION__, __LINE__ );
	
	/*---------------------------------------------------------
	 * At final, all connection will be aged out.
	 */
	/* decrease age of Conn A outbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
	Entry0.ageSec = 3;
	ASSERT(rtl8651_setAsicNaptTcpUdpTable( TRUE, idx2, &Entry0 ) == SUCCESS);

	/* decrease age of Conn E inbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	Entry0.ageSec = 3;
	ASSERT(rtl8651_setAsicNaptTcpUdpTable( TRUE, extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);

	/* sync */
	pEntry[0]->age = 3;
	pEntry[1]->age = 3;
	pEntry[4]->age = 3;
	for( i=0; i<sameAge; i++ )
	{
		_rtl8651_timeUpdate( 1 );

			/* decrease age of Conn A outbound Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( idx2, &Entry0 ) == SUCCESS);
		Entry0.ageSec--;
		ASSERT(rtl8651_setAsicNaptTcpUdpTable( TRUE, idx2, &Entry0 ) == SUCCESS);

		/* decrease age of Conn E inbound Entry */
		memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
		ASSERT(rtl8651_getAsicNaptTcpUdpTable( extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		Entry0.ageSec--;
		ASSERT(rtl8651_setAsicNaptTcpUdpTable( TRUE, extPort[4]&(RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
		

	}

	//for( i=0; i<NUM_HASH2_REUSE_PORT; i++ ) if ( pEntry[i])printf("[%d] age=%d\n",i,pEntry[i]->age);
	i= 0; /* Conn A */
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==TBLDRV_EENTRYNOTFOUND);
	i= 1; /* Conn B */
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==TBLDRV_EENTRYNOTFOUND);
	i= 4; /* Conn E */
	ASSERT(_rtl8651_getOutboundNaptFlow( tcpState[i]?1:0, intIp, intPort[i], remIp, remPort[i], &pEntry[i] )==TBLDRV_EENTRYNOTFOUND);

	return SUCCESS;
}
#endif/*LEGACY_AGING_CODE*/


/*
@func int32		| NaptTestAddNaptConnectiondBug	| test NAPT outbound bug
@rvalue SUCCESS	| test OK
@comm
Older addNaptConnection() use _rtl8651_findNaptConnection() to check duplicate connection.
However, it is buggy when addNaptConnection() supports intIp=extIp.
Therefore, we must use _rtl8651_findNaptConnectionByExtIpPort() to ensure the connection is not duplicate.
*/
int32 NaptTestAddNaptConnectiondBug(uint32 caseNo) 
{
#undef MAX_CONN
#define MAX_CONN 2

	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 isTcp[MAX_CONN];
	ipaddr_t IntIp[MAX_CONN];
	uint16 IntPort[MAX_CONN];
	ipaddr_t RemIp[MAX_CONN];
	uint16 RemPort[MAX_CONN];
	ipaddr_t ExtIp[MAX_CONN];
	uint16 ExtPort[MAX_CONN];
	uint32 ASIC[RTL8651_TCPUDPTBL_SIZE];	// -1: this line is empty; other: the index of the using connection.
	int32 ret, i, j, loopCount;
	uint16 idx1;
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t E, *entry;

	START_TEST_CASE();
	/* Set Environment */
	{
		// internal interface
		ret = rtl8651_addNetworkIntf( "rtk0" );
		IS_EQUAL_INT( "addNetworkIntf(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ether_addr_t ether0 = { { 0x00, 0x01, 0x02, 0x03, 0x04, 0x05 } };
		ret = rtl8651_assignVlanMacAddress( 1, &ether0, 1 );
		IS_EQUAL_INT( "assignVlanMacAddress(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk0", RTL8651_LL_VLAN, 1 );
		IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		
		ret = rtl8651_addIpIntf( "rtk0", ntohl( inet_addr("192.168.58.254") ), ntohl( inet_addr("255.255.255.0") ) );
		IS_EQUAL_INT( "addIpIntf(rtk0) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		// external interface 1
		ret = rtl8651_addVlan( 2 );
		IS_EQUAL_INT( "addVlan(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ret = rtl8651_addNetworkIntf( "rtk1" );
		IS_EQUAL_INT( "addNetworkIntf(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ether_addr_t ether1 = { { 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f } };
		ret = rtl8651_assignVlanMacAddress( 2, &ether1, 1 );
		IS_EQUAL_INT( "assignVlanMacAddress(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ret = rtl8651_specifyNetworkIntfLinkLayerType( "rtk1", RTL8651_LL_VLAN, 2 );
		IS_EQUAL_INT( "specifyNetworkIntfLinkLayerType(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ret = rtl8651_addExtNetworkInterface( "rtk1" );
		IS_EQUAL_INT( "addExtNetworkInterface(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		
		ret = rtl8651_addIpIntf( "rtk1", ntohl( inet_addr("210.241.238.90") ), ntohl( inet_addr("255.255.255.0") ) );
		IS_EQUAL_INT( "addIpIntf(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		ret = rtl8651_addNaptMapping( ntohl( inet_addr("210.241.238.90") ) );
		IS_EQUAL_INT( "addNaptMappingExt(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		// add default route
		ret = rtl8651_addRoute( ntohl( inet_addr( "0.0.0.0" ) ), ntohl( inet_addr( "0.0.0.0" ) ),
		                        "rtk1", ntohl( inet_addr( "210.241.238.254" ) ) );
		IS_EQUAL_INT( "addRoute(DefaultRoute) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		// set port range
		ret = rtl8651_setNaptTcpUdpPortRange( 1024, 20480-1 );
		IS_EQUAL_INT( "rtl8651_setNaptTcpUdpPortRange() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	}

	srandom( caseNo );

	i = 0;
	isTcp[i] = TRUE;
	IntIp[i] = ntohl( inet_addr("192.168.58.19") );
	IntPort[i] = 4662;
	ExtIp[i] = ntohl( inet_addr("210.241.238.90") );
	ExtPort[i] = 4662;
	RemIp[i] = ntohl( inet_addr("203.218.17.178") );
	RemPort[i] = 1723;
	
	i = 1;
	isTcp[i] = TRUE;
	IntIp[i] = ntohl( inet_addr("210.241.238.90") );
	IntPort[i] = 4662;
	ExtIp[i] = ntohl( inet_addr("210.241.238.90") );
	ExtPort[i] = 4662;
	RemIp[i] = ntohl( inet_addr("203.218.17.178") );
	RemPort[i] = 1723;
	
	//
	// Add Connections
	//
	{
		i = 0;
		//printf("[i=%d]\n",i);
		                                               
		entry = _rtl8651_addNaptAlgConnection( TRUE | (IntIp[i]==ExtIp[i]?DONT_CHECK_INTIP:0),
		                                       isTcp[i]?TCP_ESTABLISHED_FLOW:UDP_FLOW,
		                                       IntIp[i], IntPort[i], 
		                                       &ExtIp[i], &ExtPort[i],
		                                       RemIp[i], RemPort[i] );
		IS_NOT_EQUAL_INT( "addNaptConnection() failed", entry, SUCCESS, __FUNCTION__, __LINE__ );
	}
	{
		i = 1;
		//printf("[i=%d]\n",i);
		                                               
		entry = &E;
		ret = _rtl8651_getOutboundNaptFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry );
		IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow()", ret, TBLDRV_EENTRYNOTFOUND, __FUNCTION__, __LINE__ );

		entry = &E;
		ret = _rtl8651_getInboundNaptFlow( isTcp[i], IntIp[i], IntPort[i], RemIp[i], RemPort[i], &entry );
		IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow()", ret, SUCCESS, __FUNCTION__, __LINE__ );
		
		ret = rtl8651_addNaptConnection( TRUE | (IntIp[i]==ExtIp[i]?DONT_CHECK_INTIP:0),
		                                 isTcp[i]?TCP_ESTABLISHED_FLOW:UDP_FLOW,
		                                 IntIp[i], IntPort[i], 
		                                 &ExtIp[i], &ExtPort[i],
		                                 RemIp[i], RemPort[i] );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, TBLDRV_EINVALIDEXTPORT, __FUNCTION__, __LINE__ );


	}

	return SUCCESS;
}


/*
 * This is function is used to test addNaptConnection when NAPT connections are more than 4096.
 * At first, this function add naptTcpUdpFlowSize connections.
 * Then, add another naptTcpUdpFlowSize connections. 
 * We assume the newer connections can be added successfully.
 */
int32 NaptTestMoreThan4096Connections(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1024;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	ipaddr_t ExtIp; // out
	uint16 ExtPort;     // out
	int32 ret, i;
	uint16 idx1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	// we first add 4096 connections to fill the whole NAPT table.
	for( i = 0; i < rtl8651_tblDrvPara.naptTcpUdpFlowSize; i++, IntPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
		                                        RemIp, RemPort );

		ret = rtl8651_addNaptConnection( FALSE, TCP_ESTABLISHED_FLOW,
		                                 IntIp, IntPort, 
		                                 &ExtIp, &ExtPort,
		                                 RemIp, RemPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort&(RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );
	}

	// we expect we can add another 4096 connections.
	for( i = 0; i < rtl8651_tblDrvPara.naptTcpUdpFlowSize; i++, IntPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
		                                        RemIp, RemPort );

		ret = rtl8651_addNaptConnection( FALSE, TCP_OUTBOUND_SYN_RCVD_FLOW,
		                                 IntIp, IntPort, 
		                                 &ExtIp, &ExtPort,
		                                 RemIp, RemPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
		IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort&(RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );
	}

#if 0 /* set 1 to show more debug information. */
	for( idx1 = 0; idx1 < RTL8651_TCPUDPTBL_SIZE; idx1++ )
	{
		_rtl8651_dumpNaptTableEntry( idx1, 0 );
	}
	rtl8651_getTblDrvNaptInfo( 20, 3 );
#endif
	
	return SUCCESS;
}


/*
 * This is function is used to test _rtl8651_changeNaptFlowListType().
 * Bug happens when Hash2 connection is
 */
int32 NaptTestIpEntryReferenceCount(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	uint32 IntIp = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort = 1024;
	uint32 RemIp = ntohl( inet_addr("140.113.1.1") );
	uint16 RemPort = 80;
	uint32 ExtIp = ntohl( inet_addr("140.113.214.102") );
	uint16 ExtPort = 32768;     // out
	int32 ret, i;
	uint16 idx1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

#if 1
	IntPort += 85;
	ExtPort += 85;
	ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
	                                 IntIp, IntPort, 
	                                 &ExtIp, &ExtPort,
	                                 RemIp, RemPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
#else
	// we expect we can add another 4096 connections.
	ExtPort += rtl8651_tblDrvPara.naptTcpUdpFlowSize;
	for( i = 0; i < rtl8651_tblDrvPara.naptTcpUdpFlowSize; i++, IntPort++, ExtPort++ )
	{
		idx1 = rtl8651_naptTcpUdpTableIndex( 1, IntIp, IntPort, 
		                                        RemIp, RemPort );

		ret = rtl8651_addNaptConnection( TRUE, TCP_ESTABLISHED_FLOW,
		                                 IntIp, IntPort, 
		                                 &ExtIp, &ExtPort,
		                                 RemIp, RemPort );
		IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}
#endif

#if 0 /* set 1 to show more debug information. */
	for( idx1 = 0; idx1 < RTL8651_TCPUDPTBL_SIZE; idx1++ )
	{
		_rtl8651_dumpNaptTableEntry( idx1, 0 );
	}
	rtl8651_getTblDrvNaptInfo( 20, 3 );
#endif

	/* to trigger _rtl8651_changeNaptFlowListType() */
#if 1
	{
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry;
		int j;
		
		ret = _rtl8651_getOutboundNaptFlow( TRUE, IntIp, IntPort,
		                                    RemIp, RemPort, &pEntry );
		IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		for( j = 0; j < 20 /* must be lager than _smartNaptSwappingThresholdCdrouter */; j++ )
		{
			_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW, 86400 );
			IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}
	}
#else
	IntPort = IntPort - rtl8651_tblDrvPara.naptTcpUdpFlowSize + 85;
	for( i = 0; i < 1/*rtl8651_tblDrvPara.naptTcpUdpFlowSize*/; i++, IntPort++ )
	{
		struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *pEntry;
		int j;
		
		ret = _rtl8651_getOutboundNaptFlow( TRUE, IntIp, IntPort,
		                                    RemIp, RemPort, &pEntry );
		IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

		if ( pEntry->hashing == NAPT_HASH2 )
		for( j = 0; j < 20 /* must be lager than _smartNaptSwappingThresholdCdrouter */; j++ )
		{
			_rtl8651_updateNaptConnection( pEntry, TCP_ESTABLISHED_FLOW, 86400 );
			IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
		}
	}
#endif

	// del local public
	ret = rtl8651_delLocalServer( NAPT_INTF_RTK1_2 );
	IS_EQUAL_INT( "rtl8651_delLocalServer() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	// del default route
	ret = rtl8651_delRoute( ntohl( inet_addr( "0.0.0.0" ) ), ntohl( inet_addr( "0.0.0.0" ) ) );
	IS_EQUAL_INT( "rtl8651_delRoute(DefaultRoute) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	
	ret = rtl8651_delNaptMapping( NAPT_INTF_RTK1 );
	IS_EQUAL_INT( "rtl8651_delNaptMapping(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	ret = rtl8651_delIpIntf( "rtk1", NAPT_INTF_RTK1, ntohl( inet_addr("255.255.255.0") ) );
	IS_EQUAL_INT( "rtl8651_delIpIntf(rtk1) failed", ret, SUCCESS, __FUNCTION__, __LINE__ );

	
	return SUCCESS;
}


/*
* This is the case will test if _rtl8651_changeNaptIpAndPort() function works.
* First, we will insert a hash1 connection, then change extPort to meet hash1 and hash2.
* Expect: [204] is a Hash1 conneciton.
*/
int32 testChangeNaptIpAndPort(uint32 caseNo) 
{
	rtl8651_tblDrv_naptTcpUdpFlowEntry_t *pe;
	int32 ret;
	uint32 insideLocalIpAddr = ntohl( inet_addr("192.168.1.1") );
	uint16 insideLocalPort = 1025;
	uint32 remoteGlobalIpAddr = ntohl( inet_addr("140.113.1.1") );
	uint16 remoteGlobalPort = 80;
	ipaddr_t insideGlobalIpAddr = ntohl( inet_addr("140.113.214.102") );
	uint16 insideGlobalPort = 204;
	int inType, outType;
	uint16 idx1 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               remoteGlobalIpAddr, remoteGlobalPort );
	uint16 idx2 = rtl8651_naptTcpUdpTableIndex( 1, insideLocalIpAddr, insideLocalPort, 
	                                               0, 0 );
	uint16 newExtPort = 203;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	ret = rtl8651_addNaptConnection( TRUE|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, insideLocalIpAddr, insideLocalPort, 
	                                 &insideGlobalIpAddr, &insideGlobalPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", insideGlobalIpAddr, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", insideGlobalPort & (RTL8651_TCPUDPTBL_SIZE-1), idx1, __FUNCTION__, __LINE__ );

	pe = _rtl8651_findNaptConnectionByExtIpPort( TRUE, insideGlobalIpAddr, insideGlobalPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", pe, NULL, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect HASH1", pe->hashing, NAPT_HASH1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect outbound index is idx1", pe->outboundTblIdx, idx1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect inbound index is idx1", pe->inboundTblIdx, idx1, __FUNCTION__, __LINE__ );

	/* Let's change extPort to newExtPort. We expect it become HASH2. */
	ret = _rtl8651_changeNaptIpAndPort( pe, pe->insideLocalIpAddr, pe->insideLocalPort, 
	                                        pe->insideGlobalIpAddr, newExtPort,
	                                        pe->dstIpAddr, pe->dstPort );
	IS_EQUAL_INT( "_rtl8651_changeNaptIpAndPort() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	pe = _rtl8651_findNaptConnectionByExtIpPort( TRUE, insideGlobalIpAddr, insideGlobalPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", pe, NULL, __FUNCTION__, __LINE__ );
	pe = _rtl8651_findNaptConnectionByExtIpPort( TRUE, insideGlobalIpAddr, newExtPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", pe, NULL, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect become HASH2", pe->hashing, NAPT_HASH2, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect outbound index is idx2", pe->outboundTblIdx, idx2, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect extPort index is newExtPort", pe->insideGlobalPort, newExtPort, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect inbound index is newExtPort", pe->inboundTblIdx, newExtPort&(RTL8651_TCPUDPTBL_SIZE-1), __FUNCTION__, __LINE__ );

	/* Let's change extPort to insideGlobalPort. We expect it become HASH1. */
	ret = _rtl8651_changeNaptIpAndPort( pe, pe->insideLocalIpAddr, pe->insideLocalPort, 
	                                        pe->insideGlobalIpAddr, insideGlobalPort,
	                                        pe->dstIpAddr, pe->dstPort );
	IS_EQUAL_INT( "_rtl8651_changeNaptIpAndPort() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	pe = _rtl8651_findNaptConnectionByExtIpPort( TRUE, insideGlobalIpAddr, newExtPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", pe, NULL, __FUNCTION__, __LINE__ );
	pe = _rtl8651_findNaptConnectionByExtIpPort( TRUE, insideGlobalIpAddr, insideGlobalPort, remoteGlobalIpAddr, remoteGlobalPort );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", pe, NULL, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect HASH1", pe->hashing, NAPT_HASH1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect outbound index is idx1", pe->outboundTblIdx, idx1, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "Expect inbound index is idx1", pe->inboundTblIdx, idx1, __FUNCTION__, __LINE__ );

	return SUCCESS;
}


/*
 * This is for the two pairs of Hash2.
 * The user add two connections, one for Int0-Ext0-Rem0, another for Int1-Ext1-Rem1.
 * Rem0 and Rem1 are interface route. We expect ASIC tables are filled properly.
 */
int32 Hash2_2pairs(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	int32 i;
	int usingIpIdx[2]; /* to record which IP index the flow is using... */
	int32 isTcp0 = TRUE;
	uint32 IntIp0 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort0 = 22000;
	uint32 ExtIp0 = NAPT_INTF_RTK1;
	uint16 ExtPort0 = 22001;
	uint32 RemIp0 = ntohl( inet_addr("140.113.214.1") );
	uint16 RemPort0 = 1819;
	uint16 Idx20 = rtl8651_naptTcpUdpTableIndex( 1, IntIp0, IntPort0, 0, 0 );
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *flow0;
	
	int32 isTcp1 = TRUE;
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.44") );
	uint16 IntPort1 = 22000;
	uint32 ExtIp1 = NAPT_INTF_RTK1;
	uint16 ExtPort1 = 22002;
	uint32 RemIp1 = ntohl( inet_addr("140.113.214.44") );
	uint16 RemPort1 = 1820;
	uint16 Idx21 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1, 0, 0 );
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *flow1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	/*****************************************************************
	 *** Conn 0 ******************************************************
	 *****************************************************************/
	ret = rtl8651_addNaptConnection( EXTIPPORT_ASSIGNED|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp0, IntPort0, 
	                                 &ExtIp0, &ExtPort0, RemIp0, RemPort0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp0, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	/* IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort0 & (RTL8651_TCPUDPTBL_SIZE-1), Idx20, __FUNCTION__, __LINE__ ); */

	/* Expected Outbound Entry */
	Entry1.insideLocalIpAddr	= IntIp0;
	Entry1.insideLocalPort		= IntPort0;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort0 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= 1; /* IP index for Nexthop 1 */
	Entry1.selEIdx				= ExtPort0 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= isTcp0;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read Outbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( Idx20, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected Inbound Entry */
	Entry1.insideLocalIpAddr	= IntIp0;
	Entry1.insideLocalPort		= IntPort0;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= ExtPort0 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= 1; /* IP index for Nexthop 1 */
	Entry1.selEIdx				= ExtPort0 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= isTcp0;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read Inbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort0 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	
	/*****************************************************************
	 *** Conn 1 ******************************************************
	 *****************************************************************/
	ret = rtl8651_addNaptConnection( EXTIPPORT_ASSIGNED|DONT_BIRD_CDROUTER, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1, 
	                                 &ExtIp1, &ExtPort1, RemIp1, RemPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	/* IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), Idx21, __FUNCTION__, __LINE__ ); */

	/* Expected Outbound Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 3; // quiet=0; dir=1; outbound=1;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= 3; /* IP index for Nexthop 1 */
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= isTcp1;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read Outbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( Idx21, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/* Expected Inbound Entry */
	Entry1.insideLocalIpAddr	= IntIp1;
	Entry1.insideLocalPort		= IntPort1;
	Entry1.ageSec				= _rtl8651_NaptAgingToSec( _rtl8651_NaptAgingToUnit( rtl8651GlobalControl.tcpLongTimeout ) );
	Entry1.tcpFlag				= 2; // quiet=0; dir=1; outbound=0;
	Entry1.offset				= ExtPort1 >> RTL8651_TCPUDPTBL_BITS;
	Entry1.selExtIPIdx			= 3; /* IP index for Nexthop 1 */
	Entry1.selEIdx				= ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1);
	Entry1.isTcp				= isTcp1;
	Entry1.isCollision			= 1;
	Entry1.isCollision2			= 1;
	Entry1.isStatic				= 1;
	Entry1.isValid				= 1;
	Entry1.isDedicated			= 1;

	/* Read Inbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

	/*****************************************************************
	 *** Get flow ****************************************************
	 *****************************************************************/
	flow0 = _rtl8651_findNaptConnectionByExtIpPort( isTcp0, ExtIp0, ExtPort0, RemIp0, RemPort0 );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", flow0, NULL, __FUNCTION__, __LINE__ );
	flow1 = _rtl8651_findNaptConnectionByExtIpPort( isTcp1, ExtIp1, ExtPort1, RemIp1, RemPort1 );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", flow1, NULL, __FUNCTION__, __LINE__ );

	/* At first, we trap all connections to CPU. */
	ret = _rtl8651_changeNaptFlowListType( flow0, NAPT_CANDIDATE_IN, NAPT_CANDIDATE_OUT );
	ASSERT( ret == SUCCESS );
	ret = _rtl8651_changeNaptFlowListType( flow1, NAPT_CANDIDATE_IN, NAPT_CANDIDATE_OUT );
	ASSERT( ret == SUCCESS );
	usingIpIdx[0] = -1;
	usingIpIdx[1] = -1;
	for( i = 0; i < 100000; i++ )
	{
		switch( random() & 3 )
		{
			case 0: /* flow0 ASIC */
				ret = _rtl8651_changeNaptFlowListType( flow0, NAPT_ASIC_CACHED_IN, NAPT_ASIC_CACHED_OUT );
				ASSERT( ret == SUCCESS );
				ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort0 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
				usingIpIdx[0] = Entry0.selExtIPIdx;
				break;
			case 1: /* flow0 SW */
				ret = _rtl8651_changeNaptFlowListType( flow0, NAPT_CANDIDATE_IN, NAPT_CANDIDATE_OUT );
				ASSERT( ret == SUCCESS );
				usingIpIdx[0] = -1;
				break;
			case 2: /* flow1 ASIC */
				ret = _rtl8651_changeNaptFlowListType( flow1, NAPT_ASIC_CACHED_IN, NAPT_ASIC_CACHED_OUT );
				ASSERT( ret == SUCCESS );
				ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
				usingIpIdx[1] = Entry0.selExtIPIdx;
				break;
			case 3: /* flow1 SW */
				ret = _rtl8651_changeNaptFlowListType( flow1, NAPT_CANDIDATE_IN, NAPT_CANDIDATE_OUT );
				ASSERT( ret == SUCCESS );
				usingIpIdx[1] = -1;
				break;
		}

		/* compare if two connection use the same IP index. */
		if ( usingIpIdx[0] != -1 )
		{
			ASSERT( usingIpIdx[0] != usingIpIdx[1] );
		}
	}


	return SUCCESS;
}


/*
 * This is for the bug of Hash Outbound Ambigious (see note 2004/08/09).
 * The user add two connections. Thier IntIp/IntPort/ExtIp/ExtPort are the same, but RemIp is different (RemPort is don't care).
 * We expect ROME driver keep these two connections in software.
 */
int32 Hash2_Outbound_Ambigious(uint32 caseNo) 
{
	rtl865x_tblAsicDrv_naptTcpUdpParam_t Entry0, Entry1;
	int32 ret;
	int32 i;
	int32 isTcp0 = TRUE;
	uint32 IntIp0 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort0 = 22000;
	uint32 ExtIp0 = NAPT_INTF_RTK1;
	uint16 ExtPort0 = 22000;
	uint32 RemIp0 = ntohl( inet_addr("140.113.214.1") );
	uint16 RemPort0 = 1819;
	uint16 Idx20 = rtl8651_naptTcpUdpTableIndex( 1, IntIp0, IntPort0, 0, 0 );
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *flow0;
	
	int32 isTcp1 = TRUE;
	uint32 IntIp1 = ntohl( inet_addr("192.168.1.1") );
	uint16 IntPort1 = 22000;
	uint32 ExtIp1 = NAPT_INTF_RTK1;
	uint16 ExtPort1 = 22000;
	uint32 RemIp1 = ntohl( inet_addr("140.113.214.44") );
	uint16 RemPort1 = 1820;
	uint16 Idx21 = rtl8651_naptTcpUdpTableIndex( 1, IntIp1, IntPort1, 0, 0 );
	struct rtl8651_tblDrv_naptTcpUdpFlowEntry_s *flow1;

	START_TEST_CASE();
	ConfigNaptTestEnvironment();

	/*****************************************************************
	 *** Conn 0 ******************************************************
	 *****************************************************************/
	ret = rtl8651_addNaptConnection( EXTIPPORT_ASSIGNED|0, TCP_ESTABLISHED_FLOW, IntIp0, IntPort0, 
	                                 &ExtIp0, &ExtPort0, RemIp0, RemPort0 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp0, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	/* IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort0 & (RTL8651_TCPUDPTBL_SIZE-1), Idx20, __FUNCTION__, __LINE__ ); */

	/*****************************************************************
	 *** Conn 1 ******************************************************
	 *****************************************************************/
	ret = rtl8651_addNaptConnection( EXTIPPORT_ASSIGNED|0, TCP_ESTABLISHED_FLOW, IntIp1, IntPort1, 
	                                 &ExtIp1, &ExtPort1, RemIp1, RemPort1 );
	IS_EQUAL_INT( "addNaptConnection() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	IS_EQUAL_INT( "insideGlobalIpAddr should be assigned properly.", ExtIp1, NAPT_INTF_RTK1, __FUNCTION__, __LINE__ );
	/* IS_EQUAL_INT( "insideGlobalPort should be assigned properly.", ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), Idx21, __FUNCTION__, __LINE__ ); */

	/*****************************************************************
	 *** Get flow ****************************************************
	 *****************************************************************/
	flow0 = _rtl8651_findNaptConnectionByExtIpPort( isTcp0, ExtIp0, ExtPort0, RemIp0, RemPort0 );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", flow0, NULL, __FUNCTION__, __LINE__ );
	flow1 = _rtl8651_findNaptConnectionByExtIpPort( isTcp1, ExtIp1, ExtPort1, RemIp1, RemPort1 );
	IS_NOT_EQUAL_POINTER( "_rtl8651_findNaptConnectionByExtIpPort() failed", flow1, NULL, __FUNCTION__, __LINE__ );

	for( i = 0; i < 20 /* must be lager than _smartNaptSwappingThresholdCdrouter */; i++ )
	{
		_rtl8651_updateNaptConnection( flow1, TCP_ESTABLISHED_FLOW, 86400 );
		IS_EQUAL_INT( "_rtl8651_getOutboundNaptFlow() failed", ret, SUCCESS, __FUNCTION__, __LINE__ );
	}

	/* Expected Outbound Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision = 1;
	Entry1.isCollision2 = 1;

	/* Read Outbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( Idx21, &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;

#if 0 /* Inbound Entry is OK. */
	/* Expected Inbound Entry */
	memset((int8 *)&Entry1, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	Entry1.isCollision = 1;
	Entry1.isCollision2 = 1;

	/* Read Inbound Entry */
	memset((int8 *)&Entry0, 0, sizeof(rtl865x_tblAsicDrv_naptTcpUdpParam_t));
	ASSERT(rtl8651_getAsicNaptTcpUdpTable( ExtPort1 & (RTL8651_TCPUDPTBL_SIZE-1), &Entry0 ) == SUCCESS);
	if ( tcpudp_entry_cmp( &Entry0, &Entry1, __FUNCTION__, __LINE__ ) == FAILED ) return FAILED;
#endif

	/*****************************************************************
	 *** Assume in Software ******************************************
	 *****************************************************************/
#if 0 /* Inbound Entry is OK. */
	ASSERT( flow0->inListType == NAPT_CANDIDATE_IN );
	ASSERT( flow1->inListType == NAPT_CANDIDATE_IN );
#endif
	ASSERT( flow0->outListType == NAPT_CANDIDATE_OUT );
	ASSERT( flow1->outListType == NAPT_CANDIDATE_OUT );

	return SUCCESS;
}


